<?php
// (c) Copyright by authors of the Tiki Wiki CMS Groupware Project
// 
// All Rights Reserved. See copyright.txt for details and a complete list of authors.
// Licensed under the GNU LESSER GENERAL PUBLIC LICENSE. See license.txt for details.

// The original strings (English) are case-sensitive.

/* Note for translators about translation of text ending with punctuation
 *
 * The current list of concerned punctuation can be found in 'lib/init/tra.php'
 * On 2009-03-02, it is: (':', '!', ';', '.', ',', '?')
 * For clarity, we explain here only for colons: ':' but it is the same for the rest
 *
 * Short version: it is not a problem that string "Login:" has no translation. Only "Login" needs to be translated.
 *
 * Technical justification:
 * If a string ending with colon needs translating (like "{tr}Login:{/tr}")
 * then Tiki tries to translate 'Login' and ':' separately.
 * This allows to have only one translation for "{tr}Login{/tr}" and "{tr}Login:{/tr}"
 * and it still allows to translate ":" as " :" for languages that
 * need it (like French)
 * Note: the difference is invisible but " :" has an UTF-8 non-breaking-space, not a regular space, but the UTF-8 equivalent of the HTML &nbsp;.
 * This allows correctly displaying emails and JavaScript messages, not only web pages as would happen with &nbsp;.
 */
$lang = array(
// "Welsh" => "Welsh",
// "Slovene" => "Slovene",
// "Arabic" => "Arabic",
// "Bulgarian" => "Bulgarian",
// "Catalan" => "Catalan",
// "Simplified Chinese" => "Simplified Chinese",
// "Czech" => "Czech",
// "Danish" => "Danish",
// "German" => "German",
// "English" => "English",
// "English British" => "English British",
// "Spanish" => "Spanish",
// "Greek" => "Greek",
// "Farsi" => "Farsi",
// "Finnish" => "Finnish",
// "Fijian" => "Fijian",
// "French" => "French",
// "Frisian Netherlands" => "Frisian Netherlands",
// "Galician" => "Galician",
// "Hebrew" => "Hebrew",
// "Croatian" => "Croatian",
// "Indonesian" => "Indonesian",
// "Icelandic" => "Icelandic",
// "Italian" => "Italian",
// "Inuktitut" => "Inuktitut",
// "Inuktitut (Roman)" => "Inuktitut (Roman)",
// "Iniunnaqtun" => "Iniunnaqtun",
// "Japanese" => "Japanese",
// "Korean" => "Korean",
// "Hungarian" => "Hungarian",
// "Lithuanian" => "Lithuanian",
// "Low German" => "Low German",
// "Dutch" => "Dutch",
// "Norwegian" => "Norwegian",
// "Polish" => "Polish",
// "Portuguese" => "Portuguese",
// "Brazilian Portuguese" => "Brazilian Portuguese",
// "Romanian" => "Romanian",
// "Romansh" => "Romansh",
// "Russian" => "Russian",
// "Pijin Solomon" => "Pijin Solomon",
// "Sinhala" => "Sinhala",
// "Slovak" => "Slovak",
// "Albanian" => "Albanian",
// "Serbian Latin" => "Serbian Latin",
// "Swedish" => "Swedish",
// "Swahili" => "Swahili",
// "Thai" => "Thai",
// "Tuvaluan" => "Tuvaluan",
// "Turkish" => "Turkish",
// "Traditional Chinese" => "Traditional Chinese",
// "Ukrainian" => "Ukrainian",
// "Urdu" => "Urdu",
// "Vietnamese" => "Vietnamese",
// "Afghanistan" => "Afghanistan",
// "Aland Islands" => "Aland Islands",
// "Aland_Islands" => "Aland_Islands",
// "Albania" => "Albania",
// "Algeria" => "Algeria",
// "American Samoa" => "American Samoa",
// "American_Samoa" => "American_Samoa",
// "Andorra" => "Andorra",
// "Angola" => "Angola",
// "Anguilla" => "Anguilla",
// "Antigua" => "Antigua",
// "Argentina" => "Argentina",
// "Armenia" => "Armenia",
// "Aruba" => "Aruba",
// "Australia" => "Australia",
// "Austria" => "Austria",
// "Azerbaijan" => "Azerbaijan",
// "Bahamas" => "Bahamas",
// "Bahrain" => "Bahrain",
// "Bangladesh" => "Bangladesh",
// "Barbados" => "Barbados",
// "Belarus" => "Belarus",
// "Belgium" => "Belgium",
// "Belize" => "Belize",
// "Benin" => "Benin",
// "Bermuda" => "Bermuda",
// "Bhutan" => "Bhutan",
// "Bolivia" => "Bolivia",
// "Bosnia and Herzegovina" => "Bosnia and Herzegovina",
// "Bosnia_and_Herzegovina" => "Bosnia_and_Herzegovina",
// "Botswana" => "Botswana",
// "Bouvet Island" => "Bouvet Island",
// "Bouvet_Island" => "Bouvet_Island",
// "Brazil" => "Brazil",
// "British Indian Ocean Territory" => "British Indian Ocean Territory",
// "British Virgin Islands" => "British Virgin Islands",
// "British_Indian_Ocean_Territory" => "British_Indian_Ocean_Territory",
// "British_Virgin_Islands" => "British_Virgin_Islands",
// "Brunei" => "Brunei",
// "Bulgaria" => "Bulgaria",
// "Burkina Faso" => "Burkina Faso",
// "Burkina_Faso" => "Burkina_Faso",
// "Burundi" => "Burundi",
// "Cambodia" => "Cambodia",
// "Cameroon" => "Cameroon",
// "Canada" => "Canada",
// "Cape Verde" => "Cape Verde",
// "Cape_Verde" => "Cape_Verde",
// "Catalan Countries" => "Catalan Countries",
// "Catalan_Countries" => "Catalan_Countries",
// "Cayman Islands" => "Cayman Islands",
// "Cayman_Islands" => "Cayman_Islands",
// "Central African Republic" => "Central African Republic",
// "Central_African_Republic" => "Central_African_Republic",
// "Chad" => "Chad",
// "Chile" => "Chile",
// "China" => "China",
// "Christmas Island" => "Christmas Island",
// "Christmas_Island" => "Christmas_Island",
// "Cocos Islands" => "Cocos Islands",
// "Cocos_Islands" => "Cocos_Islands",
// "Colombia" => "Colombia",
// "Comoros" => "Comoros",
// "Democratic Republic of the Congo" => "Democratic Republic of the Congo",
// "Democratic_Republic_of_the_Congo" => "Democratic_Republic_of_the_Congo",
// "Congo" => "Congo",
// "Cook Islands" => "Cook Islands",
// "Cook_Islands" => "Cook_Islands",
// "Costa Rica" => "Costa Rica",
// "Costa_Rica" => "Costa_Rica",
// "Croatia" => "Croatia",
// "Cuba" => "Cuba",
// "Cyprus" => "Cyprus",
// "Czech Republic" => "Czech Republic",
// "Czech_Republic" => "Czech_Republic",
// "Denmark" => "Denmark",
// "Djibouti" => "Djibouti",
// "Dominica" => "Dominica",
// "Dominican Republic" => "Dominican Republic",
// "Dominican_Republic" => "Dominican_Republic",
// "Ecuador" => "Ecuador",
// "Egypt" => "Egypt",
// "El Salvador" => "El Salvador",
// "El_Salvador" => "El_Salvador",
// "England" => "England",
// "Equatorial Guinea" => "Equatorial Guinea",
// "Equatorial_Guinea" => "Equatorial_Guinea",
// "Eritrea" => "Eritrea",
// "Estonia" => "Estonia",
// "Ethiopia" => "Ethiopia",
// "Europe" => "Europe",
// "Falkland Islands" => "Falkland Islands",
// "Falkland_Islands" => "Falkland_Islands",
// "Faroe Islands" => "Faroe Islands",
// "Faroe_Islands" => "Faroe_Islands",
// "Federated States of Micronesia" => "Federated States of Micronesia",
// "Federated_States_of_Micronesia" => "Federated_States_of_Micronesia",
// "Fiji" => "Fiji",
// "Finland" => "Finland",
// "France" => "France",
// "French Guiana" => "French Guiana",
// "French Polynesia" => "French Polynesia",
// "French Southern Territories" => "French Southern Territories",
// "French_Guiana" => "French_Guiana",
// "French_Polynesia" => "French_Polynesia",
// "French_Southern_Territories" => "French_Southern_Territories",
// "Gabon" => "Gabon",
// "Gambia" => "Gambia",
// "Georgia" => "Georgia",
// "Germany" => "Germany",
// "Ghana" => "Ghana",
// "Gibraltar" => "Gibraltar",
// "Greece" => "Greece",
// "Greenland" => "Greenland",
// "Grenada" => "Grenada",
// "Guadeloupe" => "Guadeloupe",
// "Guam" => "Guam",
// "Guatemala" => "Guatemala",
// "Guernsey" => "Guernsey",
// "Guinea Bissau" => "Guinea Bissau",
// "Guinea" => "Guinea",
// "Guinea_Bissau" => "Guinea_Bissau",
// "Guyana" => "Guyana",
// "Haiti" => "Haiti",
// "Heard Island and McDonald Islands" => "Heard Island and McDonald Islands",
// "Heard_Island_and_McDonald_Islands" => "Heard_Island_and_McDonald_Islands",
// "Honduras" => "Honduras",
// "Hong Kong" => "Hong Kong",
// "Hong_Kong" => "Hong_Kong",
// "Hungary" => "Hungary",
// "Iceland" => "Iceland",
// "India" => "India",
// "Indonesia" => "Indonesia",
// "Iran" => "Iran",
// "Iraq" => "Iraq",
// "Ireland" => "Ireland",
// "Isle of Man" => "Isle of Man",
// "Israel" => "Israel",
// "Italy" => "Italy",
// "Ivory Coast" => "Ivory Coast",
// "Ivory_Coast" => "Ivory_Coast",
// "Jamaica" => "Jamaica",
// "Japan" => "Japan",
// "Jersey" => "Jersey",
// "Jordan" => "Jordan",
// "Kazakstan" => "Kazakstan",
// "Kenya" => "Kenya",
// "Kiribati" => "Kiribati",
// "Kuwait" => "Kuwait",
// "Kyrgyzstan" => "Kyrgyzstan",
// "Laos" => "Laos",
// "Latvia" => "Latvia",
// "Lebanon" => "Lebanon",
// "Lesotho" => "Lesotho",
// "Liberia" => "Liberia",
// "Libya" => "Libya",
// "Liechtenstein" => "Liechtenstein",
// "Lithuania" => "Lithuania",
// "Luxemburg" => "Luxemburg",
// "Macao" => "Macao",
// "Macedonia" => "Macedonia",
// "Madagascar" => "Madagascar",
// "Malawi" => "Malawi",
// "Malaysia" => "Malaysia",
// "Maldives" => "Maldives",
// "Mali" => "Mali",
// "Malta" => "Malta",
// "Marshall Islands" => "Marshall Islands",
// "Marshall_Islands" => "Marshall_Islands",
// "Martinique" => "Martinique",
// "Mauritania" => "Mauritania",
// "Mauritius" => "Mauritius",
// "Mayotte" => "Mayotte",
// "Mexico" => "Mexico",
// "Moldova" => "Moldova",
// "Monaco" => "Monaco",
// "Mongolia" => "Mongolia",
// "Montenegro" => "Montenegro",
// "Montserrat" => "Montserrat",
// "Morocco" => "Morocco",
// "Mozambique" => "Mozambique",
// "Myanmar" => "Myanmar",
// "Namibia" => "Namibia",
// "Nauru" => "Nauru",
// "Nepal" => "Nepal",
// "Netherlands Antilles" => "Netherlands Antilles",
// "Netherlands" => "Netherlands",
// "Netherlands_Antilles" => "Netherlands_Antilles",
// "New Caledonia" => "New Caledonia",
// "New Zealand" => "New Zealand",
// "New_Caledonia" => "New_Caledonia",
// "New_Zealand" => "New_Zealand",
// "Nicaragua" => "Nicaragua",
// "Niger" => "Niger",
// "Nigeria" => "Nigeria",
// "Niue" => "Niue",
"None" => "無",
// "Norfolk Island" => "Norfolk Island",
// "Norfolk_Island" => "Norfolk_Island",
// "North Korea" => "North Korea",
// "North_Korea" => "North_Korea",
// "Northern Mariana Islands" => "Northern Mariana Islands",
// "Northern_Mariana_Islands" => "Northern_Mariana_Islands",
// "Norway" => "Norway",
// "Oman" => "Oman",
// "Other" => "Other",
// "Pakistan" => "Pakistan",
// "Palau" => "Palau",
// "Palestine" => "Palestine",
// "Panama" => "Panama",
// "Papua New Guinea" => "Papua New Guinea",
// "Papua_New_Guinea" => "Papua_New_Guinea",
// "Paraguay" => "Paraguay",
// "Peru" => "Peru",
// "Philippines" => "Philippines",
// "Pitcairn" => "Pitcairn",
// "Poland" => "Poland",
// "Portugal" => "Portugal",
// "Puerto Rico" => "Puerto Rico",
// "Puerto_Rico" => "Puerto_Rico",
// "Quatar" => "Quatar",
// "Republic of Macedonia" => "Republic of Macedonia",
// "Republic_of_Macedonia" => "Republic_of_Macedonia",
// "Reunion" => "Reunion",
// "Romania" => "Romania",
// "Russia" => "Russia",
// "Russian Federation" => "Russian Federation",
// "Russian_Federation" => "Russian_Federation",
// "Rwanda" => "Rwanda",
// "Saint Helena" => "Saint Helena",
// "Saint Kitts and Nevis" => "Saint Kitts and Nevis",
// "Saint Lucia" => "Saint Lucia",
// "Saint Pierre and Miquelon" => "Saint Pierre and Miquelon",
// "Saint_Helena" => "Saint_Helena",
// "Saint_Kitts_and_Nevis" => "Saint_Kitts_and_Nevis",
// "Saint_Lucia" => "Saint_Lucia",
// "Saint_Pierre_and_Miquelon" => "Saint_Pierre_and_Miquelon",
// "Samoa" => "Samoa",
// "San Marino" => "San Marino",
// "San_Marino" => "San_Marino",
// "Sao Tome and Principe" => "Sao Tome and Principe",
// "Sao_Tome_and_Principe" => "Sao_Tome_and_Principe",
// "Saudi Arabia" => "Saudi Arabia",
// "Saudi_Arabia" => "Saudi_Arabia",
// "Senegal" => "Senegal",
// "Serbia" => "Serbia",
// "Seychelles" => "Seychelles",
// "Sierra Leone" => "Sierra Leone",
// "Sierra_Leone" => "Sierra_Leone",
// "Singapore" => "Singapore",
// "Slovakia" => "Slovakia",
// "Slovenia" => "Slovenia",
// "Solomon Islands" => "Solomon Islands",
// "Solomon_Islands" => "Solomon_Islands",
// "Somalia" => "Somalia",
// "South Africa" => "South Africa",
// "South Georgia and South Sandwich Islands" => "South Georgia and South Sandwich Islands",
// "South Korea" => "South Korea",
// "South_Africa" => "South_Africa",
// "South_Georgia_and_South_Sandwich_Islands" => "South_Georgia_and_South_Sandwich_Islands",
// "South_Korea" => "South_Korea",
// "Spain" => "Spain",
// "Sri Lanka" => "Sri Lanka",
// "Sri_Lanka" => "Sri_Lanka",
// "St Vincent Grenadines" => "St Vincent Grenadines",
// "St_Vincent_Grenadines" => "St_Vincent_Grenadines",
// "Sudan" => "Sudan",
// "Surinam" => "Surinam",
// "Svalbard and Jan Mayen" => "Svalbard and Jan Mayen",
// "Svalbard_and_Jan_Mayen" => "Svalbard_and_Jan_Mayen",
// "Swaziland" => "Swaziland",
// "Sweden" => "Sweden",
// "Switzerland" => "Switzerland",
// "Syria" => "Syria",
// "Taiwan" => "Taiwan",
// "Tajikistan" => "Tajikistan",
// "Tanzania" => "Tanzania",
// "Thailand" => "Thailand",
// "Timor-Leste" => "Timor-Leste",
// "Togo" => "Togo",
// "Tokelau" => "Tokelau",
// "Tonga" => "Tonga",
// "Trinidad Tobago" => "Trinidad Tobago",
// "Trinidad_Tobago" => "Trinidad_Tobago",
// "Tunisia" => "Tunisia",
// "Turkey" => "Turkey",
// "Turkmenistan" => "Turkmenistan",
// "Turks and Caicos Islands" => "Turks and Caicos Islands",
// "Turks_and_Caicos_Islands" => "Turks_and_Caicos_Islands",
// "Tuvalu" => "Tuvalu",
// "US Virgin Islands" => "US Virgin Islands",
// "US_Virgin_Islands" => "US_Virgin_Islands",
// "Uganda" => "Uganda",
// "Ukraine" => "Ukraine",
// "United Arab Emirates" => "United Arab Emirates",
// "United Kingdom" => "United Kingdom",
// "United Nations Organization" => "United Nations Organization",
// "United States Minor Outlying Islands" => "United States Minor Outlying Islands",
// "United States" => "United States",
// "United_Arab_Emirates" => "United_Arab_Emirates",
// "United_Kingdom" => "United_Kingdom",
// "United_Kingdom_-_England_and_Wales" => "United_Kingdom_-_England_and_Wales",
// "United_Kingdom_-_Northern_Ireland" => "United_Kingdom_-_Northern_Ireland",
// "United_Kingdom_-_Scotland" => "United_Kingdom_-_Scotland",
// "United_Nations_Organization" => "United_Nations_Organization",
// "United_States" => "United_States",
// "United_States_Minor_Outlying_Islands" => "United_States_Minor_Outlying_Islands",
// "Uruguay" => "Uruguay",
// "Uzbekistan" => "Uzbekistan",
// "Vanuatu" => "Vanuatu",
// "Vatican" => "Vatican",
// "Venezuela" => "Venezuela",
// "Viet Nam" => "Viet Nam",
// "Viet_Nam" => "Viet_Nam",
// "Wales" => "Wales",
// "Wallis and Futuna" => "Wallis and Futuna",
// "Wallis_and_Futuna" => "Wallis_and_Futuna",
// "Western Sahara" => "Western Sahara",
// "Western_Sahara" => "Western_Sahara",
// "World" => "World",
// "Yemen" => "Yemen",
// "Yugoslavia" => "Yugoslavia",
// "Zambia" => "Zambia",
// "Zimbabwe" => "Zimbabwe",
// "the former Yugoslav Republic of Macedonia" => "the former Yugoslav Republic of Macedonia",
// "the_former_Yugoslav_Republic_of_Macedonia" => "the_former_Yugoslav_Republic_of_Macedonia",
// "File %0 succesfully imported" => "File %0 succesfully imported",
// "category defaults" => "category defaults",
// "You must specify a directory" => "You must specify a directory",
// "ViewerJS URI not set" => "ViewerJS URI not set",
// "ViewerJS URI not found (local file not readable)" => "ViewerJS URI not found (local file not readable)",
// "ViewerJS URI not found (%0)" => "ViewerJS URI not found (%0)",
// "Tags successfully cleaned up" => "Tags successfully cleaned up",
// "Tag cleanup failed" => "Tag cleanup failed",
// "Remove orphan images" => "Remove orphan images",
// "Orphan images successfully removed" => "Orphan images successfully removed",
// "moved %d images, %d errors occurred" => "moved %d images, %d errors occurred",
// "a timeout occurred. Hit the reload button to move the rest" => "a timeout occurred. Hit the reload button to move the rest",
// "Tiki Email Test" => "Tiki Email Test",
// "Tiki Test email from" => "Tiki Test email from",
// "Unable to send mail" => "Unable to send mail",
// "Test mail sent to" => "Test mail sent to",
// "Remove this server" => "Remove this server",
// "Remove this host" => "Remove this host",
// "registration choices" => "registration choices",
// "Assign users to groups based on email patterns" => "Assign users to groups based on email patterns",
// "This method of captcha is not supported by your server, please select another or upgrade" => "This method of captcha is not supported by your server, please select another or upgrade",
// "You need to select a file to upload" => "You need to select a file to upload",
// "File Upload Error: ' . \$_FILES['passwordlist']['error']));\n\t}else{  // if file has been uploaded, and there are no errors, then index the file in the database.\n\t\t\$blackL->deletePassIndex();\n\t\t\$blackL->createPassIndex();\n\t\t\$blackL->loadPassIndex(\$_FILES['passwordlist']['tmp_name'],\$_POST['loaddata']);\n\t\tFeedback::success(tra('Uploaded file has been populated into database and indexed. Ready to generate password lists" => "File Upload Error: ' . \$_FILES['passwordlist']['error']));\n\t}else{  // if file has been uploaded, and there are no errors, then index the file in the database.\n\t\t\$blackL->deletePassIndex();\n\t\t\$blackL->createPassIndex();\n\t\t\$blackL->loadPassIndex(\$_FILES['passwordlist']['tmp_name'],\$_POST['loaddata']);\n\t\tFeedback::success(tra('Uploaded file has been populated into database and indexed. Ready to generate password lists",
// "Unable to Write Password File to Disk" => "Unable to Write Password File to Disk",
// "Delete temporary index" => "Delete temporary index",
// "%d users were assigned to groups based on user emails matching the patterns defined for the groups" => "%d users were assigned to groups based on user emails matching the patterns defined for the groups",
// "No user emails matched the group pattern definitions, or the matching users were already assigned, or email patterns have not been set for any groups" => "No user emails matched the group pattern definitions, or the matching users were already assigned, or email patterns have not been set for any groups",
// "composer.lock file was removed" => "composer.lock file was removed",
// "composer.lock file is not writable, so it can not be removed" => "composer.lock file is not writable, so it can not be removed",
// "composer.lock file do not exists" => "composer.lock file do not exists",
// "Vendor folder contents was removed" => "Vendor folder contents was removed",
// "Vendor folder is not writable" => "Vendor folder is not writable",
// "Vendor folder do not exists" => "Vendor folder do not exists",
// "Used" => "Used",
// "Available" => "Available",
// "Hit" => "Hit",
// "Miss" => "Miss",
// "An error occurred: " => "An error occurred: ",
// "profile applied" => "profile applied",
// "The following list of changes has been applied" => "The following list of changes has been applied",
// "Profile forgotten" => "Profile forgotten",
// "New rating configuration %0 created" => "New rating configuration %0 created",
// "Rating configuration updated for %0" => "Rating configuration updated for %0",
// "Scoring events replaced with form data" => "Scoring events replaced with form data",
// "Unable to get info from log file" => "Unable to get info from log file",
// "You must set a home file gallery" => "You must set a home file gallery",
"Tag already exists" => "標籤已經存在",
// "Tag %0 created" => "Tag %0 created",
// "Tag %0 not found" => "Tag %0 not found",
// "Tag %0 restored" => "Tag %0 restored",
// "Tag %0 not restored" => "Tag %0 not restored",
// "Tag %0 removed" => "Tag %0 removed",
// "Tag %0 not removed" => "Tag %0 not removed",
// "Process to remove pictures has completed" => "Process to remove pictures has completed",
// "Dump created at %0" => "Dump created at %0",
// "Dump was not created. Please check permissions for the storage/ directory" => "Dump was not created. Please check permissions for the storage/ directory",
// "Dump file %0 removed" => "Dump file %0 removed",
// "Dump file %0 was not removed" => "Dump file %0 was not removed",
// "No update was made" => "No update was made",
// "Areas were updated" => "Areas were updated",
// "Are you sure you want to remove that post" => "Are you sure you want to remove that post",
"Re:" => "Re:",
// "This forum is flat and doesn't allow replies to other replies" => "This forum is flat and doesn't allow replies to other replies",
// "Copyright management" => "Copyright management",
"No page indicated" => "沒有指定頁面",
"You must supply all the information, including title and year." => "你必須提供所有資訊, 包含標題與年份.",
// "Sorry, that mail has been taken by another operator" => "Sorry, that mail has been taken by another operator",
// "Wiki Page" => "Wiki Page",
// "Tracker item not found" => "Tracker item not found",
// "Put this item back" => "Put this item back",
// "Taken by %0" => "Taken by %0",
// "Take this email" => "Take this email",
// "TAKE" => "TAKE",
// "View contact" => "View contact",
"ID" => "ID",
"Type" => "類型",
"Name" => "名稱",
"Description" => "描述",
"Size" => "大小",
"Created" => "產生",
// "Uploaded" => "Uploaded",
"Last modified" => "最近改變",
// "Uploaded by" => "Uploaded by",
"Creator" => "建立者",
// "Last modified by" => "Last modified by",
"Comment" => "評論",
"Files" => "檔案",
"Hits" => "點擊數",
// "Last download" => "Last download",
"Locked by" => "由鎖定",
"Backlinks" => "反向連結",
// "Delete after" => "Delete after",
// "Share" => "Share",
"Source" => "來源",
// "Explorer" => "Explorer",
"Path" => "路徑",
// "Slideshow" => "Slideshow",
// "Gallery icon" => "Gallery icon",
"Register" => "註冊",
"Group" => "群組",
// "Tiki Installer" => "Tiki Installer",
// "MySQL Improved (mysqli)" => "MySQL Improved (mysqli)",
// "MySQL classic (mysql)" => "MySQL classic (mysql)",
// "Invalid database user" => "Invalid database user",
// "No database name specified" => "No database name specified",
// "Automatic" => "Automatic",
// "Make a symlink" => "Make a symlink",
// "Make a copy" => "Make a copy",
// "Do nothing" => "Do nothing",
// "symlink created" => "symlink created",
// "copy created" => "copy created",
// "Email address not valid, test mail not sent" => "Email address not valid, test mail not sent",
// "Email address empty and \"copy\" checkbox not set, test mail not sent" => "Email address empty and \"copy\" checkbox not set, test mail not sent",
// "Test mail from Tiki installer %0" => "Test mail from Tiki installer %0",
// "Tiki version" => "Tiki version",
// "PHP version" => "PHP version",
// "Server" => "Server",
// "Sent" => "Sent",
// "Some invalid characters were detected in database name. Please use alphanumeric characters or _ or -" => "Some invalid characters were detected in database name. Please use alphanumeric characters or _ or -",
// "Database `%0` was created" => "Database `%0` was created",
// "Database `%0` creation failed. You need to create the database" => "Database `%0` creation failed. You need to create the database",
// "Database `%0`. Unable to connect to database" => "Database `%0`. Unable to connect to database",
// "User `%0` was created" => "User `%0` was created",
// "User `%0` creation failed" => "User `%0` creation failed",
// "Congratulations!\n\nYour server can send emails.\n\n" => "Congratulations!\n\nYour server can send emails.\n\n",
// "To use AlchemyLib Tiki needs the media-alchemyst/media-alchemyst package. If you do not have permission to install this package, ask the site administrator" => "To use AlchemyLib Tiki needs the media-alchemyst/media-alchemyst package. If you do not have permission to install this package, ask the site administrator",
// "Failed to convert document into image" => "Failed to convert document into image",
// "Please check Tiki Action Log for more information" => "Please check Tiki Action Log for more information",
// "No automated tax" => "No automated tax",
// "Account name must not be empty" => "Account name must not be empty",
// "Budget is not a valid amount: " => "Budget is not a valid amount: ",
// "Locked must be either 0 or 1" => "Locked must be either 0 or 1",
// "Error creating account" => "Error creating account",
// "AccountId %0 is already in use and must not be changed. Please disable it if it is no longer needed" => "AccountId %0 is already in use and must not be changed. Please disable it if it is no longer needed",
// "Error updating account" => "Error updating account",
// "Account is already in use and must not be deleted. Please disable it, if it is no longer needed" => "Account is already in use and must not be deleted. Please disable it, if it is no longer needed",
// "Rollback failed, inconsistent database: Cleanup needed for journalId %0 in book %1" => "Rollback failed, inconsistent database: Cleanup needed for journalId %0 in book %1",
// "successfully rolled back #" => "successfully rolled back #",
// "Booking error creating journal entry" => "Booking error creating journal entry",
// "Booking error creating debit entry" => "Booking error creating debit entry",
// "Booking error creating credit entry" => "Booking error creating credit entry",
// "The number of debit entries differs: " => "The number of debit entries differs: ",
// "The number of credit entries differs: " => "The number of credit entries differs: ",
// "Splitting is only allowed on one side" => "Splitting is only allowed on one side",
// "Invalid debit amount " => "Invalid debit amount ",
// "Invalid debit account number " => "Invalid debit account number ",
// "Invalid credit amount " => "Invalid credit amount ",
// "Invalid credit account number " => "Invalid credit account number ",
// "Difference between debit and credit amounts " => "Difference between debit and credit amounts ",
// "Rollback failed, inconsistent database: Cleanup needed for stackId %0 in book %1" => "Rollback failed, inconsistent database: Cleanup needed for stackId %0 in book %1",
// "Booking error creating stack entry" => "Booking error creating stack entry",
// "Booking error creating stack debit entry" => "Booking error creating stack debit entry",
// "Booking error creating stack credit entry" => "Booking error creating stack credit entry",
// "Error deleting entry from stack" => "Error deleting entry from stack",
// "Booking error confirming stack entry" => "Booking error confirming stack entry",
// "Error while updating statement" => "Error while updating statement",
// "is not a number" => "is not a number",
// "must be greater than 0" => "must be greater than 0",
// "Invalid transaction - please contact administrator" => "Invalid transaction - please contact administrator",
// "Error checking" => "Error checking",
// "does not exist" => "does not exist",
// "already exists" => "already exists",
// "This book has been closed. You can't create new accounts" => "This book has been closed. You can't create new accounts",
// "This book has been closed. You can't modify the account" => "This book has been closed. You can't modify the account",
// "This book has been closed. You can't delete the account" => "This book has been closed. You can't delete the account",
// "The date of the transaction is before the start date of this book" => "The date of the transaction is before the start date of this book",
// "The date of the transaction is after the end date of this book" => "The date of the transaction is after the end date of this book",
// "This book has been closed. Bookings can no longer be made in it" => "This book has been closed. Bookings can no longer be made in it",
// "Invalid booking date" => "Invalid booking date",
// "This book has been closed. Transactions can no longer be cancelled in it" => "This book has been closed. Transactions can no longer be cancelled in it",
// "APC system, user and opcode caches cleared" => "APC system, user and opcode caches cleared",
// "APC %0 cache cleared" => "APC %0 cache cleared",
// "APC %0 cache not cleared" => "APC %0 cache not cleared",
// "New article post" => "New article post",
// "Edited article post" => "Edited article post",
// "Deleted article post" => "Deleted article post",
"The file has incorrect syntax or is not a CSV file" => "檔案不是 CSV 檔, 或是語法錯誤",
// "Error line: %d" => "Error line: %d",
// "Import failed due to data format. Make sure the file has Unix-style line breaks" => "Import failed due to data format. Make sure the file has Unix-style line breaks",
// "Spam is not welcome here" => "Spam is not welcome here",
// "anonymous" => "anonymous",
// "Blog cannot be found" => "Blog cannot be found",
// "Locked by %0" => "Locked by %0",
"refresh" => "更新",
// "go back to this crumb" => "go back to this crumb",
"Administration" => "系統管理",
// "Cache file %0 is not writable" => "Cache file %0 is not writable",
// "All day" => "All day",
// "First day of week: Sunday (its ID is 0) - Translators, you need to localize this string" => "First day of week: Sunday (its ID is 0) - Translators, you need to localize this string",
"Sunday" => "星期日",
// "Su" => "Su",
"Monday" => "星期一",
"Tuesday" => "星期二",
"Wednesday" => "星期三",
"Thursday" => "星期四",
"Friday" => "星期五",
"Saturday" => "星期六",
// "Mo" => "Mo",
// "Tu" => "Tu",
// "We" => "We",
// "Th" => "Th",
// "Fr" => "Fr",
// "Sa" => "Sa",
"in" => "於",
"continued" => "待續",
"New Image Uploaded by" => "新影像上傳自",
"New Subscriptions" => "新訂閱",
"New Item in Tracker" => "追蹤系統中有新項目",
// "tracker" => "tracker",
"by" => "由",
"Wiki" => "Wiki",
"Image Gallery" => "影像圖庫",
"Articles" => "文章",
"Blogs" => "Blogs",
"Forums" => "論壇",
"Directory" => "目錄",
"File Gallery" => "檔案庫",
"FAQs" => "FAQs",
"Quizzes" => "測驗",
"Trackers" => "追蹤系統",
"Survey" => "調查",
"Newsletter" => "電子報",
// "Please type this word backwards" => "Please type this word backwards",
// "Empty CAPTCHA value" => "Empty CAPTCHA value",
// "You have mistyped the anti-bot verification code. Please try again" => "You have mistyped the anti-bot verification code. Please try again",
// "Failed to validate CAPTCHA" => "Failed to validate CAPTCHA",
// "CAPTCHA ID field is missing" => "CAPTCHA ID field is missing",
// "Get a visual challenge" => "Get a visual challenge",
// "Get an audio challenge" => "Get an audio challenge",
// "Get a new challenge" => "Get a new challenge",
// "Type the two words" => "Type the two words",
// "Type what you hear" => "Type what you hear",
"Help" => "說明",
// "Play sound again" => "Play sound again",
// "Download audio as an MP3 file" => "Download audio as an MP3 file",
// "Incorrect. Try again" => "Incorrect. Try again",
// "Invalid category identifier: \"%0\"" => "Invalid category identifier: \"%0\"",
"Top" => "Top",
// "A category named %0 already exists in %1" => "A category named %0 already exists in %1",
"article" => "文章",
"blog" => "blog",
"directory" => "目錄",
"faq" => "faq",
"FAQ" => "FAQ",
// "file gallery" => "file gallery",
"forum" => "論壇",
// "image gallery" => "image gallery",
// "newsletter" => "newsletter",
"poll" => "投票",
"quiz" => "測驗",
// "survey" => "survey",
// "wiki page" => "wiki page",
"image" => "影像",
"calendar" => "行事曆",
"template" => "模板",
"Permission denied" => "權限不足",
"Invalid filename (using filters for filenames)" => "不合法檔名 (使用檔名過濾器)",
"Cannot upload this file - maximum upload size exceeded" => "無法上傳檔案, 超過最大檔案大小限制",
"Cannot write to this file" => "無法寫入此檔案",
// "(not registered)" => "(not registered)",
"Anonymous" => "Anonymous",
// "Your comment was rejected" => "Your comment was rejected",
// "Cannot perform spam check: %0" => "Cannot perform spam check: %0",
// "Please wait %0 seconds between posts" => "Please wait %0 seconds between posts",
"Wrong password. Cannot post comment" => "密碼錯誤. 無法發表評論",
// "A contribution is mandatory" => "A contribution is mandatory",
// "Please enter a Title and Message for your new forum topic" => "Please enter a Title and Message for your new forum topic",
// "Please enter a Title and Message for your forum reply" => "Please enter a Title and Message for your forum reply",
// "Please enter a Message for your forum reply" => "Please enter a Message for your forum reply",
// "Invalid Email" => "Invalid Email",
// "Your message has been queued for approval and will be posted after a moderator approves it" => "Your message has been queued for approval and will be posted after a moderator approves it",
// "Use this thread to discuss the %s page" => "Use this thread to discuss the %s page",
// "This forum is locked" => "This forum is locked",
// "This thread is locked" => "This thread is locked",
// "An error occurred; please contact the administrator" => "An error occurred; please contact the administrator",
// "Route was updated" => "Route was updated",
// "Route was created" => "Route was created",
"Page cannot be found" => "找不到頁面",
// "From is required" => "From is required",
// "There is a route with the same From path already defined" => "There is a route with the same From path already defined",
// "Type is required" => "Type is required",
// "Selected type is not supported" => "Selected type is not supported",
"To" => "至",
"Article" => "文章",
"Blog" => "Blog",
"Forum" => "論壇",
"Object" => "物件",
"Tracker" => "追蹤",
// "Field" => "Field",
// "Tracker Item Id" => "Tracker Item Id",
// "%s is required" => "%s is required",
"Error" => "錯誤",
// "Note" => "Note",
// "Success" => "Success",
"Warning" => "Warning",
// "Feedback class called with no feedback provided" => "Feedback class called with no feedback provided",
// "PDF.js feature is disabled. If you do not have permission to enable, ask the site administrator" => "PDF.js feature is disabled. If you do not have permission to enable, ask the site administrator",
// "To view office document files Tiki needs the media-alchemyst/media-alchemyst package. If you do not have permission to install this package, ask the site administrator" => "To view office document files Tiki needs the media-alchemyst/media-alchemyst package. If you do not have permission to install this package, ask the site administrator",
// "Invalid request" => "Invalid request",
// "Failed to convert document %0 to pdf" => "Failed to convert document %0 to pdf",
// "Please check Action Log for more information" => "Please check Action Log for more information",
// "Please contact the administrator" => "Please contact the administrator",
// "H5P requires the CURL extension to be installed in PHP" => "H5P requires the CURL extension to be installed in PHP",
// "Failed to write to temp file %0" => "Failed to write to temp file %0",
// " (code=%0)" => " (code=%0)",
// "Exporting H5P content %0 failed" => "Exporting H5P content %0 failed",
// "Saving H5P content %0 (fileId %1) failed" => "Saving H5P content %0 (fileId %1) failed",
// "H5P directory is not writable: %0" => "H5P directory is not writable: %0",
// "Too many arguments on ceil" => "Too many arguments on ceil",
// "Too many arguments on date" => "Too many arguments on date",
// "Divide by zero on \"%0\"" => "Divide by zero on \"%0\"",
// "Too many arguments on floor" => "Too many arguments on floor",
// "Unexpected values: %0" => "Unexpected values: %0",
// "Field must be provided and contain one argument: list" => "Field must be provided and contain one argument: list",
// "Field must be provided and contain a function" => "Field must be provided and contain a function",
// "Too many arguments on less than" => "Too many arguments on less than",
// "Too many arguments on more than" => "Too many arguments on more than",
// "string \$input , int \$pad_length [, string \$pad_string = \" \" [, string \$pad_type = right|left|both ]]" => "string \$input , int \$pad_length [, string \$pad_string = \" \" [, string \$pad_type = right|left|both ]]",
// "Too many arguments for pad" => "Too many arguments for pad",
// "Too few arguments for pad" => "Too few arguments for pad",
// "Too many arguments on round" => "Too many arguments on round",
// "Content required" => "Content required",
// "Field must be provided and contain one argument: separator" => "Field must be provided and contain one argument: separator",
// "Field must be provided and contain one or more values: key or keys" => "Field must be provided and contain one or more values: key or keys",
// "Str-replace needs exactly 3 arguments: search, replace and subject" => "Str-replace needs exactly 3 arguments: search, replace and subject",
// "Too many arguments on strtotime" => "Too many arguments on strtotime",
// "Too few arguments on strtotime" => "Too few arguments on strtotime",
// "Field must be provided and contain one argument: group" => "Field must be provided and contain one argument: group",
// "Field must be provided and contain at least one argument: aggregate" => "Field must be provided and contain at least one argument: aggregate",
// "%0 near \"%1\"" => "%0 near \"%1\"",
// "Expecting \"(\"" => "Expecting \"(\"",
// "Unexpected \"%0\"" => "Unexpected \"%0\"",
// "Expecting \")\"" => "Expecting \")\"",
// "No formula provided" => "No formula provided",
// "Variable not found \"%0\"" => "Variable not found \"%0\"",
// "Unknown operation \"%0\"" => "Unknown operation \"%0\"",
// "Articles deleted" => "Articles deleted",
// "removed the article" => "removed the article",
// "Edited articles" => "Edited articles",
// "edited the article" => "edited the article",
// "New articles submitted" => "New articles submitted",
// "created the article" => "created the article",
// "New blog posts" => "New blog posts",
// "replied to the blog" => "replied to the blog",
// "New calendar events" => "New calendar events",
// "%0 added or updated event %1" => "%0 added or updated event %1",
// "Changes in categories" => "Changes in categories",
// "added the %0 %1 to the category %2" => "added the %0 %1 to the category %2",
// "created the subcategory" => "created the subcategory",
// "removed the subcategory" => "removed the subcategory",
"from" => "由",
// "edited the category" => "edited the category",
// "removed the %0 %1 from the category %2" => "removed the %0 %1 from the category %2",
// "File galleries changed" => "File galleries changed",
// "%0 edited the file gallery %1" => "%0 edited the file gallery %1",
// "%0 uploaded the file %1" => "%0 uploaded the file %1",
// "onto" => "onto",
// "%0 removed the file %1 from %2" => "%0 removed the file %1 from %2",
// "New replies in forum topics" => "New replies in forum topics",
// "%0 <a href=%1>replied</a> to the topic %2" => "%0 <a href=%1>replied</a> to the topic %2",
// "New posts in forums" => "New posts in forums",
// "%0 created the topic %1 at forum %2" => "%0 created the topic %1 at forum %2",
// "Image galleries changed" => "Image galleries changed",
// "changed the picture gallery" => "changed the picture gallery",
// "uploaded the picture" => "uploaded the picture",
// "removed the picture" => "removed the picture",
// "Wiki pages added to a structure" => "Wiki pages added to a structure",
// "%0 added %1 wiki page to a structure" => "%0 added %1 wiki page to a structure",
// "Wiki pages moved down in a structure tree" => "Wiki pages moved down in a structure tree",
// "%0 moved a wiki page down in a structure tree" => "%0 moved a wiki page down in a structure tree",
// "Wiki pages moved up in a structure tree" => "Wiki pages moved up in a structure tree",
// "%0 moved a wiki page up in a structure tree" => "%0 moved a wiki page up in a structure tree",
// "Wiki pages removed from structure" => "Wiki pages removed from structure",
// "%0 removed %1 wiki page from a structure" => "%0 removed %1 wiki page from a structure",
// "File attached to tracker" => "File attached to tracker",
// "%0 attached a file (%1) to tracker item %2" => "%0 attached a file (%1) to tracker item %2",
// "Comments in tracker items" => "Comments in tracker items",
// "%0 added a new comment to %1 on tracker %2" => "%0 added a new comment to %1 on tracker %2",
// "%0 added a new comment to item id %1 on tracker %2" => "%0 added a new comment to item id %1 on tracker %2",
// "Tracker items modified" => "Tracker items modified",
// "%0 added or updated tracker item %1 on tracker %2" => "%0 added or updated tracker item %1 on tracker %2",
// "%0 added or updated tracker item id %1 on tracker %2" => "%0 added or updated tracker item id %1 on tracker %2",
// "New attachments in wiki pages" => "New attachments in wiki pages",
// "%0 uploaded the file %1 onto %2" => "%0 uploaded the file %1 onto %2",
// "Wiki pages updated" => "Wiki pages updated",
// "%0 edited the wikipage %1 (<a href=%2>this history</a>, <a href=%3>all history</a>)" => "%0 edited the wikipage %1 (<a href=%2>this history</a>, <a href=%3>all history</a>)",
// "Wiki pages created" => "Wiki pages created",
// "%0 created the wikipage %1" => "%0 created the wikipage %1",
// "Wiki pages deleted" => "Wiki pages deleted",
// "%0 deleted the wikipage %1" => "%0 deleted the wikipage %1",
// "and %0 more changes of the same type" => "and %0 more changes of the same type",
// "Nothing has happened" => "Nothing has happened",
// "Report on %0 from %1 " => "Report on %0 from %1 ",
// "(no changes)" => "(no changes)",
// "(1 change)" => "(1 change)",
// "(%0 changes)" => "(%0 changes)",
// "Scheduler task is stalled" => "Scheduler task is stalled",
// "Scheduler task is already running" => "Scheduler task is already running",
// "Unable to decode task params" => "Unable to decode task params",
// "***** Running scheduler %s *****" => "***** Running scheduler %s *****",
// "Scheduler %0 (id: %1) is stalled" => "Scheduler %0 (id: %1) is stalled",
// "Skip scheduler %s - %s" => "Skip scheduler %s - %s",
// "***** Scheduler %s - FAILED *****\n%s" => "***** Scheduler %s - FAILED *****\n%s",
// "***** Scheduler %s - OK *****" => "***** Scheduler %s - OK *****",
// "Scheduler with id %0 does not exist or is not active" => "Scheduler with id %0 does not exist or is not active",
// "Scheduler `%0` (id: %1) is stalled" => "Scheduler `%0` (id: %1) is stalled",
// "Scheduler `%0` (id: %1) was healed" => "Scheduler `%0` (id: %1) was healed",
// "Scheduler `%0` (id: %1) was not healed" => "Scheduler `%0` (id: %1) was not healed",
// "Scheduler %0 (id: %1) is not stalled, no need to heal" => "Scheduler %0 (id: %1) is not stalled, no need to heal",
// "Missing parameters to run the command" => "Missing parameters to run the command",
// "Executing console command: %s" => "Executing console command: %s",
// "Console command" => "Console command",
// "Missing the URL to call" => "Missing the URL to call",
// "Missing the file path to where the output should be saved" => "Missing the file path to where the output should be saved",
// "URL to invoke: %s" => "URL to invoke: %s",
// "Save output to: %s" => "Save output to: %s",
// "Using basic authentication" => "Using basic authentication",
// "Including additional headers" => "Including additional headers",
// "Sending request" => "Sending request",
// "Request was successful" => "Request was successful",
// "Failed to open file %s to write" => "Failed to open file %s to write",
// "Request failed" => "Request failed",
"URL" => "URL",
// "Output File" => "Output File",
// "File path to save the output" => "File path to save the output",
// "Additional HTTP Headers" => "Additional HTTP Headers",
// "One HTTP Header per line" => "One HTTP Header per line",
// "Auth Username" => "Auth Username",
// "Auth Password" => "Auth Password",
// "Missing shell command to execute" => "Missing shell command to execute",
// "Executing shell command: %s" => "Executing shell command: %s",
// "Shell command" => "Shell command",
// "Run timeout" => "Run timeout",
// "in seconds" => "in seconds",
// "Checking tiki version" => "Checking tiki version",
// "Sending emails" => "Sending emails",
// "Tiki version email sent to" => "Tiki version email sent to",
// "Tiki Version Updated" => "Tiki Version Updated",
// "Tiki Updates: " => "Tiki Updates: ",
// "Tiki Updates" => "Tiki Updates",
// "Invalid cron time format" => "Invalid cron time format",
// "Found invalid user(s)/email(s) to send notification on preference %0. Invalid users/emails: %1" => "Found invalid user(s)/email(s) to send notification on preference %0. Invalid users/emails: %1",
// "Missing required action parameter or value: %0" => "Missing required action parameter or value: %0",
// "Cannot apply change_status action to an object type %0" => "Cannot apply change_status action to an object type %0",
// "Invalid \"from\" status specified for change_status action: %0. Should be one of \"o\", \"p\" or \"c\"" => "Invalid \"from\" status specified for change_status action: %0. Should be one of \"o\", \"p\" or \"c\"",
// "Invalid \"to\" status specified for change_status action: %0. Should be one of \"o\", \"p\" or \"c\"" => "Invalid \"to\" status specified for change_status action: %0. Should be one of \"o\", \"p\" or \"c\"",
// "Tracker item %0 not found" => "Tracker item %0 not found",
// "Tracker item %0 status %1 is different than the \"from\" status %2" => "Tracker item %0 status %1 is different than the \"from\" status %2",
// "Cannot apply delete action to an aggregation type %0" => "Cannot apply delete action to an aggregation type %0",
// "Cannot apply delete action to an object type %0" => "Cannot apply delete action to an object type %0",
// "Tracker field %0 not found" => "Tracker field %0 not found",
// "Cannot find file to delete: %0" => "Cannot find file to delete: %0",
// "Are you sure you want to permanently delete this object" => "Are you sure you want to permanently delete this object",
// "EmailAction - send to %0, subject - %1" => "EmailAction - send to %0, subject - %1",
// "Error sending email: %0" => "Error sending email: %0",
// "Page %s cannot be found" => "Page %s cannot be found",
// "EmailAction - can't send new message" => "EmailAction - can't send new message",
// "Cannot apply filegal_change_filename action to an object type %0" => "Cannot apply filegal_change_filename action to an object type %0",
// "Tracker field %0 not found for tracker %1" => "Tracker field %0 not found for tracker %1",
// "Tracker field %0 is not a Files field type" => "Tracker field %0 is not a Files field type",
// "filegal_change_filename action missing value parameter" => "filegal_change_filename action missing value parameter",
// "Cannot apply filegal_image_overlay action to an object type %0" => "Cannot apply filegal_image_overlay action to an object type %0",
// "filegal_image_overlay action missing value parameter" => "filegal_image_overlay action missing value parameter",
// "filegal_image_overlay: Problem processing image \"%0\", the following values form the template are empty: %1" => "filegal_image_overlay: Problem processing image \"%0\", the following values form the template are empty: %1",
// "Cannot apply tracker_item_modify action to an aggregation type %0" => "Cannot apply tracker_item_modify action to an aggregation type %0",
// "Cannot apply tracker_item_modify action to an object type %0" => "Cannot apply tracker_item_modify action to an object type %0",
// "tracker_item_modify action missing value, calc, add or remove parameter" => "tracker_item_modify action missing value, calc, add or remove parameter",
// "Field %0 not found on Action TrackerItemModify" => "Field %0 not found on Action TrackerItemModify",
// "Error applying tracker_item_modify calc formula to item %0: %1" => "Error applying tracker_item_modify calc formula to item %0: %1",
// "Unknown search action step: %0" => "Unknown search action step: %0",
// "Cannot apply wiki_approval action to an object type %0" => "Cannot apply wiki_approval action to an object type %0",
// "Wiki page %0 is not in pending state" => "Wiki page %0 is not in pending state",
// "Wiki page %0 does not require approval" => "Wiki page %0 does not require approval",
"Tentative" => "暫定",
"Confirmed" => "已確認",
"Cancelled" => "取消",
"unknown" => "不明",
// "Unknown" => "Unknown",
// "Tracker Status" => "Tracker Status",
// "Webservice %0 field \"%1\" not found" => "Webservice %0 field \"%1\" not found",
// "%0 (latest)" => "%0 (latest)",
// "Elasticsearch does not support optimize" => "Elasticsearch does not support optimize",
// "Federated index %0 not found" => "Federated index %0 not found",
// "Unknown mapping type \"%0\" for field \"%1\"" => "Unknown mapping type \"%0\" for field \"%1\"",
// "Document not found in index %1 (%0)" => "Document not found in index %1 (%0)",
// "String \"%0\" cannot be formatted as a number for field \"%1\"" => "String \"%0\" cannot be formatted as a number for field \"%1\"",
// "Field %0 does not exist in the current index. Please check field permanent name and if you have any items in that tracker" => "Field %0 does not exist in the current index. Please check field permanent name and if you have any items in that tracker",
// "Field %0 does not exist in the current index. If this is a tracker field, the proper syntax is tracker_field_%0" => "Field %0 does not exist in the current index. If this is a tracker field, the proper syntax is tracker_field_%0",
// "Feature not supported" => "Feature not supported",
// "Parsing search query failed: \"%0\"" => "Parsing search query failed: \"%0\"",
// "Sort field %0 not found in index" => "Sort field %0 not found in index",
// "No results for query" => "No results for query",
// "Missing template \"%0\"" => "Missing template \"%0\"",
// "Template tplwiki page \"%0\" not found" => "Template tplwiki page \"%0\" not found",
// "Template wiki page \"%0\" not found" => "Template wiki page \"%0\" not found",
// "Error evaluating formula %0: %1" => "Error evaluating formula %0: %1",
// "No value for '%0'" => "No value for '%0'",
// "Unknown formatting rule '%0' for '%1'" => "Unknown formatting rule '%0' for '%1'",
// "Category Tree" => "Category Tree",
"Categories" => "分類",
// "%0 (Tree)" => "%0 (Tree)",
// "Tags" => "Tags",
// "Letter" => "Letter",
// "First word" => "First word",
// "Indexing failed while processing \"%0\" (type %1) with the error \"%2\"" => "Indexing failed while processing \"%0\" (type %1) with the error \"%2\"",
// "Object %0 type %1 returned null from getDocument function" => "Object %0 type %1 returned null from getDocument function",
// "Could not perform index modification: %0" => "Could not perform index modification: %0",
// "Feature not supported: %0" => "Feature not supported: %0",
// "Missing objectype or qualifier for relation filter" => "Missing objectype or qualifier for relation filter",
// "Range filter \"from\" parameter not valid: \"%0\"" => "Range filter \"from\" parameter not valid: \"%0\"",
// "Range filter \"to\" parameter not valid: \"%0\"" => "Range filter \"to\" parameter not valid: \"%0\"",
// "Range filter \"gap\" parameter not valid: \"%0\"" => "Range filter \"gap\" parameter not valid: \"%0\"",
// "The range filter is missing \\\"from\\\" or \\\"to\\\"" => "The range filter is missing \\\"from\\\" or \\\"to\\\"",
// "The distance filter is missing \\\"distance\\\", \\\"lat\\\" or \\\"lon\\\"" => "The distance filter is missing \\\"distance\\\", \\\"lat\\\" or \\\"lon\\\"",
// "Distance sort: Missing lat or lon arguments" => "Distance sort: Missing lat or lon arguments",
// "Script sort: Missing source argument" => "Script sort: Missing source argument",
// "List plugin: Feature \"jQuery Sortable Tables\" (tablesorter) is not enabled" => "List plugin: Feature \"jQuery Sortable Tables\" (tablesorter) is not enabled",
// "filterRange: \"from\" value not parsed" => "filterRange: \"from\" value not parsed",
// "filterRange: \"to\" value not parsed" => "filterRange: \"to\" value not parsed",
// "Malformed search query" => "Malformed search query",
// "%0 (%1)" => "%0 (%1)",
// "Please confirm" => "Please confirm",
"OK" => "ok",
// "Are you sure you want to %0 the following %1" => "Are you sure you want to %0 the following %1",
// "Please confirm your action for the following item" => "Please confirm your action for the following item",
// "Please confirm your action for the following items" => "Please confirm your action for the following items",
// "Activity stream currently unavailable" => "Activity stream currently unavailable",
// "Permission Denied" => "Permission Denied",
// "Activity rule deleted" => "Activity rule deleted",
// "%0 activity rules deleted" => "%0 activity rules deleted",
// "No activity rules deleted" => "No activity rules deleted",
// "Delete Rule" => "Delete Rule",
// "Activity (id:' . (string) \$id . " => "Activity (id:' . (string) \$id . ",
// "No activities deleted" => "No activities deleted",
// "Delete Activity" => "Delete Activity",
// "Sample activity rule %0 updated" => "Sample activity rule %0 updated",
// "Sample activity rule %0 created" => "Sample activity rule %0 created",
// "Sample activity rule %0 unchanged" => "Sample activity rule %0 unchanged",
// "Edit Rule %0" => "Edit Rule %0",
// "Create Sample Rule" => "Create Sample Rule",
// "Basic activity rule %0 updated" => "Basic activity rule %0 updated",
// "Basic activity rule %0 created" => "Basic activity rule %0 created",
// "Basic activity rule %0 unchanged" => "Basic activity rule %0 unchanged",
// "Create Record Rule" => "Create Record Rule",
// "Tracker activity rule %0 updated" => "Tracker activity rule %0 updated",
// "Tracker activity rule %0 created" => "Tracker activity rule %0 created",
// "Tracker activity rule %0 unchanged" => "Tracker activity rule %0 unchanged",
// "Create Tracker Rule" => "Create Tracker Rule",
// "Advanced activity rule %0 updated" => "Advanced activity rule %0 updated",
// "Advanced activity rule %0 created" => "Advanced activity rule %0 created",
// "Advanced activity rule %0 unchanged" => "Advanced activity rule %0 unchanged",
// "Create Advanced Rule" => "Create Advanced Rule",
// "Sample" => "Sample",
// "Basic" => "Basic",
// "Advanced" => "Advanced",
// "Invalid rule type" => "Invalid rule type",
// "Type changed for activity rule %0" => "Type changed for activity rule %0",
// "Change Rule Type" => "Change Rule Type",
// "Status changed for activity rule %0" => "Status changed for activity rule %0",
// "Change Rule Status" => "Change Rule Status",
// "Content could not be loaded" => "Content could not be loaded",
// "Create article from URL" => "Create article from URL",
// "Invalid input" => "Invalid input",
// "Invalid data" => "Invalid data",
// "Authentication added or modified" => "Authentication added or modified",
// "Authentication not added or modified" => "Authentication not added or modified",
// "Authentication deleted" => "Authentication deleted",
// "Authentication not deleted" => "Authentication not deleted",
// "Oops" => "Oops",
// "Action not found (%0 in %1)" => "Action not found (%0 in %1)",
// "Controller not found (%0)" => "Controller not found (%0)",
// "No change made for one object already in the category" => "No change made for one object already in the category",
// "No change made for %0 objects already in the category" => "No change made for %0 objects already in the category",
// "One object added to category" => "One object added to category",
// "%0 objects added to category" => "%0 objects added to category",
// "No objects added to category" => "No objects added to category",
// "No change made for one object not in the category" => "No change made for one object not in the category",
// "No change made for %0 objects not in the category" => "No change made for %0 objects not in the category",
// "One object removed from category" => "One object removed from category",
// "%0 objects removed from category" => "%0 objects removed from category",
// "No objects removed from category" => "No objects removed from category",
// "Invalid %0 ID: %1" => "Invalid %0 ID: %1",
// "Comments not allowed on this page" => "Comments not allowed on this page",
// "Loading.." => "Loading..",
"Comments" => "評論",
// "Parent is locked" => "Parent is locked",
// "Pseudonym must be specified" => "Pseudonym must be specified",
// "Email must be specified" => "Email must be specified",
// "Title is empty" => "Title is empty",
// "Content is empty" => "Content is empty",
// "Duplicated comment, there is already another comment with the same text" => "Duplicated comment, there is already another comment with the same text",
// "Your comment was posted" => "Your comment was posted",
// "Permissions denied" => "Permissions denied",
// "Lock comments" => "Lock comments",
// "Unlock comments" => "Unlock comments",
// "Comment not found" => "Comment not found",
// "Comment already approved" => "Comment already approved",
// "Invalid argument" => "Invalid argument",
// "Thread not specified" => "Thread not specified",
// "Comment permissions: %0 object %1 not found" => "Comment permissions: %0 object %1 not found",
"Feature disabled" => "功能已關閉",
// "Reserved for administrators during development" => "Reserved for administrators during development",
// "Tiki not connected. Please click \"Send Info\" to join in" => "Tiki not connected. Please click \"Send Info\" to join in",
// "There was an error (Tiki Connect is still experimental). Please try again" => "There was an error (Tiki Connect is still experimental). Please try again",
// "registration" => "registration",
// "confirmation" => "confirmation",
// "Connect Feature disabled" => "Connect Feature disabled",
// "Connect server mode disabled" => "Connect server mode disabled",
// "Please confirm that you want to participate in Tiki Connect" => "Please confirm that you want to participate in Tiki Connect",
// "Welcome to Tiki Connect, please click \"Send Info\" when you want to make a connection" => "Welcome to Tiki Connect, please click \"Send Info\" when you want to make a connection",
// "There was a problem at the server (Tiki Connect is still experimental)" => "There was a problem at the server (Tiki Connect is still experimental)",
// "CAPTCHA code problem" => "CAPTCHA code problem",
// "Connect data received, thanks" => "Connect data received, thanks",
// "Your Tiki site is not registered here yet. Please try again" => "Your Tiki site is not registered here yet. Please try again",
// "Remove custom route" => "Remove custom route",
// "Inline editor update" => "Inline editor update",
"Preview" => "預覽",
// "Syntax Help" => "Syntax Help",
// "WYSIWYG Help" => "WYSIWYG Help",
// "Plugin Help" => "Plugin Help",
// "Spreadsheet Help" => "Spreadsheet Help",
// "Edit Help" => "Edit Help",
"Edit" => "編輯",
// "Tracker %0 not found" => "Tracker %0 not found",
// "The following parameters could not be converted to plugin list at this stage:\n" => "The following parameters could not be converted to plugin list at this stage:\n",
// "Plugins found containing: %0" => "Plugins found containing: %0",
// "No plugins found containing: %0" => "No plugins found containing: %0",
// "You do not have permission to edit \"%0\"" => "You do not have permission to edit \"%0\"",
// "Undefined parameter" => "Undefined parameter",
// "Missing parameters" => "Missing parameters",
// "%0 Plugin modified by editor" => "%0 Plugin modified by editor",
// "Page \"%0\" not found" => "Page \"%0\" not found",
// "%0 Plugin converted to list" => "%0 Plugin converted to list",
// "Plugin %0 on page %1 converted" => "Plugin %0 on page %1 converted",
// "Authentication required" => "Authentication required",
// "Feature disabled: %0" => "Feature disabled: %0",
// "Edit conflict" => "Edit conflict",
// "Edit conflict: %0 \"%1\" is being edited already by %2" => "Edit conflict: %0 \"%1\" is being edited already by %2",
// "Field Required" => "Field Required",
// "Not found" => "Not found",
// "File Upload" => "File Upload",
// "File could not be uploaded" => "File could not be uploaded",
// "No file arrived" => "No file arrived",
// "File too large" => "File too large",
// "Unknown errors" => "Unknown errors",
// "File empty" => "File empty",
// "Batch file processed: \"%0\"" => "Batch file processed: \"%0\"",
"You don't have permission to upload zipped file packages" => "沒有權限上傳 zip 壓縮的檔案包",
"Browse" => "瀏覽",
// "Gallery List" => "Gallery List",
// "Upload from source disabled" => "Upload from source disabled",
// "Unable to retrieve file from remote site. Please try a different URL" => "Unable to retrieve file from remote site. Please try a different URL",
// "File could not be uploaded. Restrictions apply" => "File could not be uploaded. Restrictions apply",
// "Manual refresh disabled" => "Manual refresh disabled",
// "Gallery ID %0 not found" => "Gallery ID %0 not found",
// "Potential cross-site request forgery (CSRF) detected. Operation blocked. Reloading the page may help" => "Potential cross-site request forgery (CSRF) detected. Operation blocked. Reloading the page may help",
// "Requested gallery does not exist" => "Requested gallery does not exist",
// "Vimeo not authenticated" => "Vimeo not authenticated",
// "Upload Video" => "Upload Video",
// "Unknown error" => "Unknown error",
// "No action was selected. Please select an action before clicking OK" => "No action was selected. Please select an action before clicking OK",
// "Merge selected posts with another topic" => "Merge selected posts with another topic",
// "Merge this post" => "Merge this post",
// "Merge these posts" => "Merge these posts",
// "Merge selected topics with another topic" => "Merge selected topics with another topic",
// "Merge this topic" => "Merge this topic",
// "Merge these topics" => "Merge these topics",
"Merge" => "合併",
// "With this topic" => "With this topic",
// "All topics or posts were selected, leaving none to merge with. Please make your selection again" => "All topics or posts were selected, leaving none to merge with. Please make your selection again",
// "No topics were selected. Please select the topics you wish to merge before clicking the merge button" => "No topics were selected. Please select the topics you wish to merge before clicking the merge button",
// "The following post has been merged with the %0 topic" => "The following post has been merged with the %0 topic",
// "The following posts have been merged with the %0 topic" => "The following posts have been merged with the %0 topic",
// "Move this topic" => "Move this topic",
// "Move these topics" => "Move these topics",
// "From the %0 forum to the below forum" => "From the %0 forum to the below forum",
// "Move selected topics to another forum" => "Move selected topics to another forum",
"Move" => "移動",
// "No topics were selected. Please select the topics you wish to move before clicking the move button" => "No topics were selected. Please select the topics you wish to move before clicking the move button",
// "The following topic has been moved to the %0 forum" => "The following topic has been moved to the %0 forum",
// "The following topics have been moved to the %0 forum" => "The following topics have been moved to the %0 forum",
// "Delete the following forum %0" => "Delete the following forum %0",
"Delete" => "刪除",
// "No topics were selected. Please select the topics you wish to delete before clicking the delete button" => "No topics were selected. Please select the topics you wish to delete before clicking the delete button",
// "The following topic has been deleted" => "The following topic has been deleted",
// "The following topics have been deleted" => "The following topics have been deleted",
// "Delete the following attachment" => "Delete the following attachment",
// "No attachments were selected. Please select an attachment to delete" => "No attachments were selected. Please select an attachment to delete",
// "The following attachment has been deleted" => "The following attachment has been deleted",
// "The following attachments have been deleted" => "The following attachments have been deleted",
// "Reserved for forum administrators" => "Reserved for forum administrators",
// "Delete the following forum" => "Delete the following forum",
// "Delete the following forums" => "Delete the following forums",
// "No forums were selected. Please select a forum to delete" => "No forums were selected. Please select a forum to delete",
// "The following forum has been deleted" => "The following forum has been deleted",
// "The following forums have been deleted" => "The following forums have been deleted",
// "Reserved for forum administrators and moderators" => "Reserved for forum administrators and moderators",
// "%0 the following topic" => "%0 the following topic",
// "%0 the following topics" => "%0 the following topics",
// "No topics were selected. Please select the topics you wish to %0 before clicking the %0 button" => "No topics were selected. Please select the topics you wish to %0 before clicking the %0 button",
"locked" => "鎖定",
"unlocked" => "解鎖",
// "The following topic has been %0" => "The following topic has been %0",
// "The following topics have been %0" => "The following topics have been %0",
// "%0 the following thread" => "%0 the following thread",
// "thread" => "thread",
// "No threads were selected. Please select the threads you wish to %0" => "No threads were selected. Please select the threads you wish to %0",
// "archived" => "archived",
// "unarchived" => "unarchived",
// "The following thread has been %0" => "The following thread has been %0",
// "The following thread have been %0" => "The following thread have been %0",
// "The goal is currently disabled" => "The goal is currently disabled",
// "This goal is not enabled" => "This goal is not enabled",
// "Not eligible for this goal" => "Not eligible for this goal",
// "The goal has not been evaluated, administrator view" => "The goal has not been evaluated, administrator view",
// "Reserved for administrators" => "Reserved for administrators",
// "Manage Goals" => "Manage Goals",
// "Create Goal" => "Create Goal",
// "Edit Goal" => "Edit Goal",
// "Remove Goal" => "Remove Goal",
// "Conditions" => "Conditions",
// "Pages created" => "Pages created",
// "Condition" => "Condition",
// "Rewards" => "Rewards",
// "No available rewards" => "No available rewards",
// "Reward" => "Reward",
// "Restricted access" => "Restricted access",
// "Modify Eligibility for %0" => "Modify Eligibility for %0",
// "Delete the following group" => "Delete the following group",
// "Delete the following groups" => "Delete the following groups",
// "No groups were selected. Please select one or more groups" => "No groups were selected. Please select one or more groups",
// "The following group cannot be deleted" => "The following group cannot be deleted",
// "The following groups cannot be deleted" => "The following groups cannot be deleted",
// "The following group has been deleted" => "The following group has been deleted",
// "The following groups have been deleted" => "The following groups have been deleted",
"Group already exists" => "群組已經存在",
// "Create the group %0" => "Create the group %0",
"Create" => "建立",
// "Group name cannot be empty" => "Group name cannot be empty",
// "Group %0 (ID %1) successfully created" => "Group %0 (ID %1) successfully created",
// "Group %0 not created" => "Group %0 not created",
// "Modify the group %0" => "Modify the group %0",
// "Modify" => "Modify",
// "Group %0 successfully modified" => "Group %0 successfully modified",
// "Group %0 not modified" => "Group %0 not modified",
// "Add the following user to group %0" => "Add the following user to group %0",
// "Add the following users to group %0" => "Add the following users to group %0",
"Add" => "加入",
// "One or more users must be selected" => "One or more users must be selected",
// "The following user was added to group %0" => "The following user was added to group %0",
// "The following users were added to group %0" => "The following users were added to group %0",
// "Ban the following user from group %0" => "Ban the following user from group %0",
// "Ban the following users from group %0" => "Ban the following users from group %0",
// "Ban" => "Ban",
// "The following user was banned from group %0" => "The following user was banned from group %0",
// "The following users were banned from group %0" => "The following users were banned from group %0",
// "Unban the following user from group %0" => "Unban the following user from group %0",
// "Unban the following users from group %0" => "Unban the following users from group %0",
// "Unban" => "Unban",
// "The following user was unbanned from group %0" => "The following user was unbanned from group %0",
// "The following users were unbanned from group %0" => "The following users were unbanned from group %0",
// "h5p_enabled" => "h5p_enabled",
// "Create H5P Content" => "Create H5P Content",
// "Create H5P content" => "Create H5P content",
// "H5P Embed" => "H5P Embed",
// "No fileID provided" => "No fileID provided",
// "H5P Plugin" => "H5P Plugin",
// "Cannot find H5P content with fileId: %0" => "Cannot find H5P content with fileId: %0",
// "Edit H5P Content" => "Edit H5P Content",
// "H5P Edit" => "H5P Edit",
// "Waiting for javascript.." => "Waiting for javascript..",
// "H5P Content Libraries" => "H5P Content Libraries",
// "File not found on server. Check file upload settings" => "File not found on server. Check file upload settings",
// "H5P Results" => "H5P Results",
// "No contentId provided" => "No contentId provided",
// "H5P User Data" => "H5P User Data",
// "H5P User Results" => "H5P User Results",
// "You have successfully added %0 new media items" => "You have successfully added %0 new media items",
// "You have successfully added one new media item" => "You have successfully added one new media item",
// "No language provided" => "No language provided",
// "lang/\$language directory is not writable" => "lang/\$language directory is not writable",
// "Wrote %d new strings and updated %d to lang/%s/language.php" => "Wrote %d new strings and updated %d to lang/%s/language.php",
// "Write to language.php" => "Write to language.php",
// "Custom Translations" => "Custom Translations",
// "Invalid file type" => "Invalid file type",
// "File does not exist" => "File does not exist",
// "Invalid file type: php not allowed" => "Invalid file type: php not allowed",
// "Upload Translations" => "Upload Translations",
// "Feature Disabled" => "Feature Disabled",
// "Invalid file parameter supplied" => "Invalid file parameter supplied",
// "Translation not supported for the specified object type" => "Translation not supported for the specified object type",
// "No source provided" => "No source provided",
// "Manage translations" => "Manage translations",
// "No source or target provided" => "No source or target provided",
// "You do not have permission to attach the selected translations" => "You do not have permission to attach the selected translations",
// "Could not attach the translations" => "Could not attach the translations",
// "You do not have permission to detach the selected translations" => "You do not have permission to detach the selected translations",
// "The object has no language indicated and cannot be translated" => "The object has no language indicated and cannot be translated",
// "The language directory is not readable" => "The language directory is not readable",
// "The language directory is not writeable" => "The language directory is not writeable",
// "String translation set is not an array" => "String translation set is not an array",
// "Can not fopen custom.php" => "Can not fopen custom.php",
// "Can not fwrite custom.php" => "Can not fwrite custom.php",
// "Source string translation set is not an array" => "Source string translation set is not an array",
// "Target string translation set is not an array" => "Target string translation set is not an array",
// "Invalid process type" => "Invalid process type",
// "Add new and update existing" => "Add new and update existing",
// "Add new only" => "Add new only",
// "Update existing only" => "Update existing only",
// "Replace all" => "Replace all",
// "Failed to connect or authenticate with remote host" => "Failed to connect or authenticate with remote host",
// "Account created or modified" => "Account created or modified",
// "Account not created or modified" => "Account not created or modified",
// "Modify Account" => "Modify Account",
// "Create Account" => "Create Account",
// "Account removed" => "Account removed",
// "Account not removed" => "Account not removed",
// "Remove Account" => "Remove Account",
// "Menu %0 not found" => "Menu %0 not found",
// "The %0 menu has been edited" => "The %0 menu has been edited",
// "The %0 menu has been created" => "The %0 menu has been created",
// "An error occurred - the %0 menu may not have been edited" => "An error occurred - the %0 menu may not have been edited",
// "An error occurred - the %0 menu may not have been created" => "An error occurred - the %0 menu may not have been created",
// "Edit Menu" => "Edit Menu",
// "Create Menu" => "Create Menu",
// "Menu %0 cloned as menu %1" => "Menu %0 cloned as menu %1",
// "Clone this menu and its options" => "Clone this menu and its options",
// "Menu option %0 not found" => "Menu option %0 not found",
// "Menu Option %0" => "Menu Option %0",
// "Create Menu Option" => "Create Menu Option",
// "Your menu options have been imported" => "Your menu options have been imported",
// "Import Menu Options" => "Import Menu Options",
// "Menu Preview" => "Menu Preview",
// "The %0 menu has been removed" => "The %0 menu has been removed",
// "The %0 menu has not been removed" => "The %0 menu has not been removed",
// "Delete the %0 menu" => "Delete the %0 menu",
// "You don't have permission to edit menus (tiki_p_edit_menu)" => "You don't have permission to edit menus (tiki_p_edit_menu)",
// "You don't have permission to edit menu options (tiki_p_edit_menu_option)" => "You don't have permission to edit menu options (tiki_p_edit_menu_option)",
// "You don't have permission to edit menu options (edit_menu_option)" => "You don't have permission to edit menu options (edit_menu_option)",
// "Must Read" => "Must Read",
// "Invalid request method" => "Invalid request method",
// "Cannot circulate" => "Cannot circulate",
// "Circulate" => "Circulate",
// "Group does not exist" => "Group does not exist",
// "Misconfigured feature" => "Misconfigured feature",
// "Target field not found" => "Target field not found",
// "Object not found" => "Object not found",
// "Must Read for %0" => "Must Read for %0",
// "Must Read Item not found" => "Must Read Item not found",
"Read" => "閱讀",
// "Respond Privately" => "Respond Privately",
"Completed" => "完成",
// "Missing %0 parameter" => "Missing %0 parameter",
// "Not Found" => "Not Found",
// "No box available for %0" => "No box available for %0",
// "Invalid attribute name \"%0\"" => "Invalid attribute name \"%0\"",
// "Cannot lock \"%0\"" => "Cannot lock \"%0\"",
// "Reserved for payment administrators" => "Reserved for payment administrators",
// "Recommendations for %0" => "Recommendations for %0",
// "Remote service inaccessible (%0)" => "Remote service inaccessible (%0)",
// "Execution output" => "Execution output",
// "Scheduler %0 - FAILED" => "Scheduler %0 - FAILED",
// "Scheduler %0 - OK" => "Scheduler %0 - OK",
// "Running %0" => "Running %0",
// "Reset scheduler run" => "Reset scheduler run",
// "Rebuild Index" => "Rebuild Index",
// "Process Update Queue" => "Process Update Queue",
// "empty" => "empty",
// "Lookup Result" => "Lookup Result",
// "ManifoldCF Configuration Check" => "ManifoldCF Configuration Check",
// "Create ManifoldCF Index" => "Create ManifoldCF Index",
// "A query could not be created because the name is already in use" => "A query could not be created because the name is already in use",
// "Could not obtain the query" => "Could not obtain the query",
// "Save Search" => "Save Search",
// "Saved Searches" => "Saved Searches",
// "Delete Saved Search" => "Delete Saved Search",
// "Edit Saved Search" => "Edit Saved Search",
// "Search functionality currently unavailable" => "Search functionality currently unavailable",
// "Theme Customizer" => "Theme Customizer",
// "Item not found" => "Item not found",
// "Reserved for tracker administrators" => "Reserved for tracker administrators",
// "Type does not exist" => "Type does not exist",
// "Add Field" => "Add Field",
// "Warning: There is a conflict in permanent names, which can cause indexing errors" => "Warning: There is a conflict in permanent names, which can cause indexing errors",
// "Field #%0 \"%1\" of type \"%2\" also found in tracker #%3 with perm name %4" => "Field #%0 \"%1\" of type \"%2\" also found in tracker #%3 with perm name %4",
// "You are using the image field type, which is deprecated. It is recommended to activate 'Use legacy tracker insertion screen' found on the <a href=\"%0\">trackers admin configuration</a> screen" => "You are using the image field type, which is deprecated. It is recommended to activate 'Use legacy tracker insertion screen' found on the <a href=\"%0\">trackers admin configuration</a> screen",
// "Warning: Required field types not enabled: %0" => "Warning: Required field types not enabled: %0",
// "Tracker contains no listed field, no meaningful information will be provided in the default list" => "Tracker contains no listed field, no meaningful information will be provided in the default list",
// "The tracker contains no field in the title, so no link will be generated" => "The tracker contains no field in the title, so no link will be generated",
// "Field handler not found" => "Field handler not found",
// "%0" => "%0",
// "CAPTCHA" => "CAPTCHA",
// "Distinct" => "Distinct",
// "Page Name" => "Page Name",
"Password" => "密碼",
// "Regular Expression (Pattern)" => "Regular Expression (Pattern)",
"Username" => "使用者名稱",
// "Export Fields" => "Export Fields",
// "Invalid data provided" => "Invalid data provided",
// "Import Tracker Fields" => "Import Tracker Fields",
// "No item to clone" => "No item to clone",
// "Duplicate Item" => "Duplicate Item",
// "Item could not be created. Only one item per user is allowed" => "Item could not be created. Only one item per user is allowed",
// "Item created" => "Item created",
// "New \"%0\" item successfully created" => "New \"%0\" item successfully created",
// "New tracker item %0 successfully created" => "New tracker item %0 successfully created",
// "Tracker item could not be created" => "Tracker item could not be created",
// "Create Item" => "Create Item",
// "Tracker item %0 has been updated" => "Tracker item %0 has been updated",
// "%0: Updated \"%1\"" => "%0: Updated \"%1\"",
// "Comment for edit #%0" => "Comment for edit #%0",
// "Update Item" => "Update Item",
// "Are you sure you would like to update this item" => "Are you sure you would like to update this item",
"Save" => "儲存",
// "The requested element cannot be displayed. One of the view/edit templates is missing or has errors: %0" => "The requested element cannot be displayed. One of the view/edit templates is missing or has errors: %0",
// "Tracker item %0 has been successfully deleted" => "Tracker item %0 has been successfully deleted",
"Remove" => "移除",
// "Validation error" => "Validation error",
// "Create Tracker" => "Create Tracker",
// "Duplicate Tracker" => "Duplicate Tracker",
// "Export Items" => "Export Items",
// "Import Tracker Structure" => "Import Tracker Structure",
// "File upload failed" => "File upload failed",
// "Uploaded file could not be read" => "Uploaded file could not be read",
// "Import Items" => "Import Items",
// "Import Tracker From Profile/YAML" => "Import Tracker From Profile/YAML",
"Last Modification" => "最後修改",
// "Creation Date" => "Creation Date",
// "Item ID" => "Item ID",
"Filename" => "檔案",
// "Creation date" => "Creation date",
// "Views" => "Views",
// "File size" => "File size",
"Version" => "版本",
// "File type" => "File type",
// "Long description" => "Long description",
"User" => "使用者",
// "Select Tracker" => "Select Tracker",
// "You don't have permission to view the tracker" => "You don't have permission to view the tracker",
// "The item to clone isn't visible" => "The item to clone isn't visible",
// "You don't have permission to create new items" => "You don't have permission to create new items",
// "Cannot remove item %0 from this tracker" => "Cannot remove item %0 from this tracker",
// "You don't have permission to export" => "You don't have permission to export",
// "Remote Source" => "Remote Source",
// "Automatically generated field for synchronized trackers. Contains the itemId of the remote item" => "Automatically generated field for synchronized trackers. Contains the itemId of the remote item",
// "Clone Remote Tracker" => "Clone Remote Tracker",
// "Tracker does not exist" => "Tracker does not exist",
// "Tracker is not synchronized with a remote source" => "Tracker is not synchronized with a remote source",
// "Tabular Formats" => "Tabular Formats",
// "Remove Format" => "Remove Format",
// "Create Tabular Format" => "Create Tabular Format",
// "Edit Format: %0" => "Edit Format: %0",
// "Format %0 not found" => "Format %0 not found",
// "Duplicate Format: %0" => "Duplicate Format: %0",
// "%0 copy" => "%0 copy",
// "Fields in %0" => "Fields in %0",
// "No formats available" => "No formats available",
// "Select Format" => "Select Format",
// "Primary Key required" => "Primary Key required",
// "Your import was completed successfully" => "Your import was completed successfully",
"Import" => "匯入",
// "Filter %0" => "Filter %0",
"Filter" => "過濾器",
// "Export %0" => "Export %0",
"Export" => "匯出",
// "Create tabular format and tracker from file" => "Create tabular format and tracker from file",
// "Operation reserved for tracker administrators" => "Operation reserved for tracker administrators",
// "Events" => "Events",
// "The following mandatory fields are missing: %0" => "The following mandatory fields are missing: %0",
// "Invalid value in %0: %1" => "Invalid value in %0: %1",
// "Invalid value in %0" => "Invalid value in %0",
// "Field %0 does not exist in tracker" => "Field %0 does not exist in tracker",
// "The terms and conditions were modified while you were reading them" => "The terms and conditions were modified while you were reading them",
// "You are required to approve the terms of use to continue" => "You are required to approve the terms of use to continue",
// "Terms and Conditions" => "Terms and Conditions",
// "You must enter your date of birth to continue" => "You must enter your date of birth to continue",
// "Age Validation" => "Age Validation",
// "We were unable to create your account because this email is already in use" => "We were unable to create your account because this email is already in use",
// "Friend" => "Friend",
// "Remove Friend" => "Remove Friend",
// "Add Friend" => "Add Friend",
// "Following you" => "Following you",
// "Remove Follower" => "Remove Follower",
// "You are following" => "You are following",
// "Stop Following" => "Stop Following",
// "Follow" => "Follow",
// "Awaiting your approval" => "Awaiting your approval",
// "Refuse Request" => "Refuse Request",
// "Accept &amp; Add" => "Accept &amp; Add",
// "Accept Request" => "Accept Request",
// "Waiting for approval" => "Waiting for approval",
// "Cancel Request" => "Cancel Request",
// "Hidden" => "Hidden",
// "km" => "km",
// "You need to set \"Show my information on mouseover\"" => "You need to set \"Show my information on mouseover\"",
// "Click here" => "Click here",
// "You need to log in" => "You need to log in",
// "Delete the following user" => "Delete the following user",
// "Delete the following users" => "Delete the following users",
// "No users were selected. Please select one or more users" => "No users were selected. Please select one or more users",
// "The following user has been deleted" => "The following user has been deleted",
// "Submit form below to ban this user" => "Submit form below to ban this user",
// "The following users have been deleted" => "The following users have been deleted",
// "Submit form below to ban these users" => "Submit form below to ban these users",
// "Ban the following user's IP" => "Ban the following user's IP",
// "Clicking Ban will redirect you to a form where this user's is preselected for IP banning" => "Clicking Ban will redirect you to a form where this user's is preselected for IP banning",
// "Ban the following users' IPs" => "Ban the following users' IPs",
// "Clicking Ban will redirect you to a form where these users' are preselected for IP banning" => "Clicking Ban will redirect you to a form where these users' are preselected for IP banning",
// "See highlighted section in the form below for users you have selected for banning" => "See highlighted section in the form below for users you have selected for banning",
// "Remove the following user from group %0" => "Remove the following user from group %0",
// "For this user" => "For this user",
// "For these selected users" => "For these selected users",
// "Change group assignments for selected users" => "Change group assignments for selected users",
// "%s %s assigned to %s %s" => "%s %s assigned to %s %s",
"user" => "使用者",
"group" => "群組",
// "An error occurred. The group assignment failed" => "An error occurred. The group assignment failed",
// "%s %s removed from %s %s" => "%s %s removed from %s %s",
// "The following user" => "The following user",
// "The following users" => "The following users",
// "%0 had the following group set as default" => "%0 had the following group set as default",
// "%0 been %1 the following %2" => "%0 been %1 the following %2",
// "Set default group for selected users" => "Set default group for selected users",
// "Make this the default group" => "Make this the default group",
// "group %s set as the default group for user %s" => "group %s set as the default group for user %s",
// "For the following user" => "For the following user",
// "For the following users" => "For the following users",
// "The following group has been set as the default group" => "The following group has been set as the default group",
// "Send wiki page content by email to selected users" => "Send wiki page content by email to selected users",
// "Page not found" => "Page not found",
// "The page does not have a description, which is mandatory to perform this action" => "The page does not have a description, which is mandatory to perform this action",
// "Invalid bcc email address" => "Invalid bcc email address",
// "and blind copied (bcc) to %0" => "and blind copied (bcc) to %0",
// "The template page has no text or the text cannot be extracted" => "The template page has no text or the text cannot be extracted",
// "Mail sent to user %s" => "Mail sent to user %s",
// "The page %0 has been emailed to the following user" => "The page %0 has been emailed to the following user",
// "The page %0 has been emailed to the following users" => "The page %0 has been emailed to the following users",
// "And blind copied to %0" => "And blind copied to %0",
// "No user was selected" => "No user was selected",
// "Message not sent - no subject or body" => "Message not sent - no subject or body",
// "Your message was successfully sent to %0" => "Your message was successfully sent to %0",
// "An error occurred, please check your mail settings and try again" => "An error occurred, please check your mail settings and try again",
// "Please specify validity period" => "Please specify validity period",
// "The group %0 does not exist" => "The group %0 does not exist",
// "Your invite has been sent" => "Your invite has been sent",
// "You must set a user for whom to set an avatar" => "You must set a user for whom to set an avatar",
// "You do not have the permission to change the avatar" => "You do not have the permission to change the avatar",
// "You must select an avatar to upload" => "You must select an avatar to upload",
// "An error occurred. User page for %0 could not be deleted" => "An error occurred. User page for %0 could not be deleted",
// "Deleted account %s" => "Deleted account %s",
// "An error occurred. User %0 could not be deleted" => "An error occurred. User %0 could not be deleted",
// "secure connection required" => "secure connection required",
// "You cannot see this user's data" => "You cannot see this user's data",
// "Send Me a Message" => "Send Me a Message",
// "Upload Avatar" => "Upload Avatar",
// "Must be authenticated" => "Must be authenticated",
// "Notifications for %0" => "Notifications for %0",
// "No notifications" => "No notifications",
"Notifications" => "提醒",
// "Unread Notifications" => "Unread Notifications",
// "Mark all notifications as read" => "Mark all notifications as read",
// "Must be registered" => "Must be registered",
// "Friend List" => "Friend List",
// "User not found" => "User not found",
// "Approve Friend" => "Approve Friend",
// "Regenerate Wiki URLs" => "Regenerate Wiki URLs",
// "the only version of" => "the only version of",
// "all versions of" => "all versions of",
// "the last version of" => "the last version of",
// "Delete %0 the following %1" => "Delete %0 the following %1",
// "You do not have permission to remove the selected page(s)" => "You do not have permission to remove the selected page(s)",
// "No pages were selected. Please select one or more pages" => "No pages were selected. Please select one or more pages",
// "An error occurred. %0%1 could not be deleted" => "An error occurred. %0%1 could not be deleted",
// "All versions" => "All versions",
// "The last version" => "The last version",
// "Version %0" => "Version %0",
// "%0 of the following page %1 been deleted" => "%0 of the following page %1 been deleted",
// "%0 of the following pages %1 been deleted" => "%0 of the following pages %1 been deleted",
// "Redirection page not specified. 301 redirect not created" => "Redirection page not specified. 301 redirect not created",
// "Semantic aliases (301 Redirects) to this page were created when other pages were deleted" => "Semantic aliases (301 Redirects) to this page were created when other pages were deleted",
// "A semantic alias (301 Redirect) to this page was created when page %0 was deleted" => "A semantic alias (301 Redirect) to this page was created when page %0 was deleted",
// "301 Redirects to the following page were created" => "301 Redirects to the following page were created",
// "A 301 Redirect to the following page was created" => "A 301 Redirect to the following page was created",
// "The following page and 301 Redirects to it were created" => "The following page and 301 Redirects to it were created",
// "The following page and a 301 Redirect to it were created" => "The following page and a 301 Redirect to it were created",
// "Delete the following %0 of %1" => "Delete the following %0 of %1",
// "No version were selected. Please select one or more versions" => "No version were selected. Please select one or more versions",
// "An error occurred. Version %0 could not be deleted" => "An error occurred. Version %0 could not be deleted",
// "The following version of %0 has been deleted" => "The following version of %0 has been deleted",
// "The following versions of %0 have been deleted" => "The following versions of %0 have been deleted",
// "Print the following page" => "Print the following page",
// "Print the following pages" => "Print the following pages",
"Print" => "列印",
// "No page specified" => "No page specified",
// "Export the following page to PDF" => "Export the following page to PDF",
// "Export the following pages to PDF" => "Export the following pages to PDF",
// "PDF" => "PDF",
// "Lock the following page" => "Lock the following page",
// "Lock the following pages" => "Lock the following pages",
"Lock" => "鎖定",
// "Excludes selected pages already locked or for which you lack permission to lock" => "Excludes selected pages already locked or for which you lack permission to lock",
// "You do not have permission to lock the selected pages or they have already been locked" => "You do not have permission to lock the selected pages or they have already been locked",
// "The following page was not locked due to an error" => "The following page was not locked due to an error",
// "The following pages were not locked due to an error" => "The following pages were not locked due to an error",
// "The following page has been locked" => "The following page has been locked",
// "The following pages have been locked" => "The following pages have been locked",
// "Unlock the following page" => "Unlock the following page",
// "Unlock the following pages" => "Unlock the following pages",
"Unlock" => "解除鎖定",
// "Excludes selected pages already unlocked or for which you lack permission to unlock" => "Excludes selected pages already unlocked or for which you lack permission to unlock",
// "You do not have permission to unlock the selected pages or they have already been unlocked" => "You do not have permission to unlock the selected pages or they have already been unlocked",
// "The following page was not unlocked due to an error" => "The following page was not unlocked due to an error",
// "The following pages were not unlocked due to an error" => "The following pages were not unlocked due to an error",
// "The following page has been unlocked" => "The following page has been unlocked",
// "The following pages have been unlocked" => "The following pages have been unlocked",
// "Download a zipped file of the following page" => "Download a zipped file of the following page",
// "Download a zipped file of the following pages" => "Download a zipped file of the following pages",
// "Zip" => "Zip",
// "Add page name as header of the following page" => "Add page name as header of the following page",
// "Add page name as header of the following pages" => "Add page name as header of the following pages",
// "The following page was not found" => "The following page was not found",
// "The following pages were not found" => "The following pages were not found",
// "The page name was added as header to the following page" => "The page name was added as header to the following page",
// "The page name was added as header to the following pages" => "The page name was added as header to the following pages",
// "THIS PAGE WAS CREATED AUTOMATICALLY when other pages were removed. Please edit and write the definitive contents" => "THIS PAGE WAS CREATED AUTOMATICALLY when other pages were removed. Please edit and write the definitive contents",
// "THIS PAGE WAS CREATED AUTOMATICALLY when another page was removed. Please edit and write the definitive contents" => "THIS PAGE WAS CREATED AUTOMATICALLY when another page was removed. Please edit and write the definitive contents",
// "Create Workspace" => "Create Workspace",
// "Workspace Templates" => "Workspace Templates",
// "Create Workspace Template" => "Create Workspace Template",
// "Edit template %0" => "Edit template %0",
// "Workspaces" => "Workspaces",
// "Could not create workspace root" => "Could not create workspace root",
"Invalid user" => "不合法的使用者",
// "Invalid token" => "Invalid token",
// "Empty authorization" => "Empty authorization",
// "Wrong authorization format" => "Wrong authorization format",
// "You don't have enough privileges" => "You don't have enough privileges",
// "Select a filter" => "Select a filter",
// "n/a" => "n/a",
// "Server-side Processing" => "Server-side Processing",
// "Enter %0y%1 to have the server do the sorting and filtering through Ajax and %0n%1 to have the\n\t\t\t\t\tbrowser do it (n is the default). Set to %0y%1 (and also set the Paginate parameter\n\t\t\t\t\t(%0tspaginate%1)) if you do not want all rows fetched at once, but rather fetch rows as you\n\t\t\t\t\tpaginate, filter or sort" => "Enter %0y%1 to have the server do the sorting and filtering through Ajax and %0n%1 to have the\n\t\t\t\t\tbrowser do it (n is the default). Set to %0y%1 (and also set the Paginate parameter\n\t\t\t\t\t(%0tspaginate%1)) if you do not want all rows fetched at once, but rather fetch rows as you\n\t\t\t\t\tpaginate, filter or sort",
// "Overall Sort Settings" => "Overall Sort Settings",
// "Serves as the overall switch for turning jQuery Tablesorter on (also for filtering) as well as\n\t\t\t\t\toverall sort settings. Enter %0y%1 to allow sorting and %0n%1 to disallow (n is the default).\n\t\t\t\t\tEnter %0type:save%1 to allow sorts to be saved between page refreshes.\n\t\t\t\t\tEnter %0type:%2reset%3;text:*****%1 to allow sorting and show an unsort button with\n\t\t\t\t\tcustom text. Enter %0type:%2savereset%3;text:buttontext%1 to allow the same for saved sorts" => "Serves as the overall switch for turning jQuery Tablesorter on (also for filtering) as well as\n\t\t\t\t\toverall sort settings. Enter %0y%1 to allow sorting and %0n%1 to disallow (n is the default).\n\t\t\t\t\tEnter %0type:save%1 to allow sorts to be saved between page refreshes.\n\t\t\t\t\tEnter %0type:%2reset%3;text:*****%1 to allow sorting and show an unsort button with\n\t\t\t\t\tcustom text. Enter %0type:%2savereset%3;text:buttontext%1 to allow the same for saved sorts",
// "Pre-sorted Columns" => "Pre-sorted Columns",
// "Bracketed numbers for column number (first column = 0) and sort direction\n\t\t\t\t\t(%20%3 = ascending, %21%3 = descending, %2n%3 = no sort, %2y%3 = allow sorting but no pre-sort),\n\t\t\t\t\tfor example: %0. If the first pre-sorted or no filter column is not the first column, then you\n\t\t\t\t\tshould use the %2y%3 parameter (as in %1) to assign all previous columns" => "Bracketed numbers for column number (first column = 0) and sort direction\n\t\t\t\t\t(%20%3 = ascending, %21%3 = descending, %2n%3 = no sort, %2y%3 = allow sorting but no pre-sort),\n\t\t\t\t\tfor example: %0. If the first pre-sorted or no filter column is not the first column, then you\n\t\t\t\t\tshould use the %2y%3 parameter (as in %1) to assign all previous columns",
// "Sort Settings by Column" => "Sort Settings by Column",
// "Set %0 and %1 settings for each column, using %2 to separate columns. To show group headings upon\n\t\t\t\t\tpage load, the Pre-sorted Columns parameter (%3) will need to be set for a column with a group\n\t\t\t\t\tsetting. Group will not work in plugins where the Server Side Processing parameter (%4) is set to\n\t\t\t\t\t%5" => "Set %0 and %1 settings for each column, using %2 to separate columns. To show group headings upon\n\t\t\t\t\tpage load, the Pre-sorted Columns parameter (%3) will need to be set for a column with a group\n\t\t\t\t\tsetting. Group will not work in plugins where the Server Side Processing parameter (%4) is set to\n\t\t\t\t\t%5",
// "Set %0 to one of the following" => "Set %0 to one of the following",
// "Also handle strings in numeric columns with" => "Also handle strings in numeric columns with",
// "Handle empty cells with" => "Handle empty cells with",
// "%0 creates automatic row headings upon sort with the heading text determined by\n\t\t\t\t\tthe setting as follows: %1 (first letter), %2 (first word)" => "%0 creates automatic row headings upon sort with the heading text determined by\n\t\t\t\t\tthe setting as follows: %1 (first letter), %2 (first word)",
// "%0 and %1 can be extended, e.g., %2 shows the first 2 words.\n\t\t\t\t\t%3 will group rows in blocks of ten. Group will not work in plugins where the Server Side Processing\n\t\t\t\t\tparameter (%4) is set to %5" => "%0 and %1 can be extended, e.g., %2 shows the first 2 words.\n\t\t\t\t\t%3 will group rows in blocks of ten. Group will not work in plugins where the Server Side Processing\n\t\t\t\t\tparameter (%4) is set to %5",
// "Column Filters" => "Column Filters",
// "Enter %0 for a blank text filter on all columns, or %1 for no filters. Or set custom column\n\t\t\t\t\t\tfilters separated by %2 for each column for the following filter choices and parameters" => "Enter %0 for a blank text filter on all columns, or %1 for no filters. Or set custom column\n\t\t\t\t\t\tfilters separated by %2 for each column for the following filter choices and parameters",
// "(For PluginTrackerlist this will be an exact search, for other plugins partial values will work.)" => "(For PluginTrackerlist this will be an exact search, for other plugins partial values will work.)",
// "From Tiki 18, you can add initial:t option to allow prefix search for text filter. E.g. <code>type:text;initial:t</code>" => "From Tiki 18, you can add initial:t option to allow prefix search for text filter. E.g. <code>type:text;initial:t</code>",
// "Options generated automatically if not set and the %0server%1 parameter is not %0y%1" => "Options generated automatically if not set and the %0server%1 parameter is not %0y%1",
// "Use %0value=Display label%1 to have the option value be different than the displayed label in\n\t\t\t\t\tthe dropdown" => "Use %0value=Display label%1 to have the option value be different than the displayed label in\n\t\t\t\t\tthe dropdown",
// "Use %0empty:Display label%1 to include an option with the specified label that will filter only empty rows.\n\t\t\t\t\tOnly used if other options are not specified manually" => "Use %0empty:Display label%1 to include an option with the specified label that will filter only empty rows.\n\t\t\t\t\tOnly used if other options are not specified manually",
// "Date range - " => "Date range - ",
// "(from and to values set defaults for these fields when user clicks on the input field)" => "(from and to values set defaults for these fields when user clicks on the input field)",
// "Beware that items with empty date values will not be shown when default date range filters are applied" => "Beware that items with empty date values will not be shown when default date range filters are applied",
// "Numeric range - " => "Numeric range - ",
// "No filter - " => "No filter - ",
// "For example: %0tsfilters=\"type:dropdown;placeholder:Type to filter...\"%1 would result in a dropdown\n\t\t\t\t\t\tfilter on the first column with all unique values in that column in the dropdown list" => "For example: %0tsfilters=\"type:dropdown;placeholder:Type to filter...\"%1 would result in a dropdown\n\t\t\t\t\t\tfilter on the first column with all unique values in that column in the dropdown list",
// "Filter Options" => "Filter Options",
// "The following options are available: %0reset%1 (adds button to take off filters), and %0hide%1\n\t\t\t\t\t(Filters are revealed upon mouseover. Hide doesn't work when date and range filters are used.).\n\t\t\t\t\tTo use both, set %0tsfilteroptions=\"type:reset;text:button text;style:hide\"%1" => "The following options are available: %0reset%1 (adds button to take off filters), and %0hide%1\n\t\t\t\t\t(Filters are revealed upon mouseover. Hide doesn't work when date and range filters are used.).\n\t\t\t\t\tTo use both, set %0tsfilteroptions=\"type:reset;text:button text;style:hide\"%1",
// "Paginate" => "Paginate",
// "Enter %0y%1 to set default values based on the site setting for maximum records in listings (on the\n\t\t\t\t\t\tpagination table of the Look & Feel admin panel). Set to %0n%1 (and %0server%1 cannot be set to\n\t\t\t\t\t\t%0y%1) for no pagination. Set custom values as in the following example: " => "Enter %0y%1 to set default values based on the site setting for maximum records in listings (on the\n\t\t\t\t\t\tpagination table of the Look & Feel admin panel). Set to %0n%1 (and %0server%1 cannot be set to\n\t\t\t\t\t\t%0y%1) for no pagination. Set custom values as in the following example: ",
// "Column Select" => "Column Select",
// "Add a button for hiding and re-showing columns. Also sets priority for dropping columns when\n\t\t\t\t\t\tbrowser is too narrow. Set each column to a number between 1 and 6 (1 is highest priority and last\n\t\t\t\t\t\tto be dropped) or to %0critical%1 to never hide or drop. An example with 4 columns" => "Add a button for hiding and re-showing columns. Also sets priority for dropping columns when\n\t\t\t\t\t\tbrowser is too narrow. Set each column to a number between 1 and 6 (1 is highest priority and last\n\t\t\t\t\t\tto be dropped) or to %0critical%1 to never hide or drop. An example with 4 columns",
// "Totals" => "Totals",
// "Generate table, column or row totals and set labels, using either %0 or the following\n\t\t\t\t\t\tsyntax for each total: %1" => "Generate table, column or row totals and set labels, using either %0 or the following\n\t\t\t\t\t\tsyntax for each total: %1",
// "Setting to %0 will add one column total row set as follows: %1" => "Setting to %0 will add one column total row set as follows: %1",
// "Separate multiple total row or column settings with a pipe %0. Set %1 only to\n\t\t\t\t\tgenerate sums of visible values. In all cases, cells in columns set to be ignored in\n\t\t\t\t\tthe %2 parameter will not be included in calculations" => "Separate multiple total row or column settings with a pipe %0. Set %1 only to\n\t\t\t\t\tgenerate sums of visible values. In all cases, cells in columns set to be ignored in\n\t\t\t\t\tthe %2 parameter will not be included in calculations",
// "Instructions for each total option follows" => "Instructions for each total option follows",
// "Choices are %0, for a row of columns totals, %1, for a\n\t\t\t\t\tcolumn of row totals, and %2 to include amounts from all cells in the table body in a row total" => "Choices are %0, for a row of columns totals, %1, for a\n\t\t\t\t\tcolumn of row totals, and %2 to include amounts from all cells in the table body in a row total",
// "set what the calculation is. Choices are" => "set what the calculation is. Choices are",
// "Click %0 for a description of these options" => "Click %0 for a description of these options",
// "Determines the rows that will be included in the\n\t\t\t\t\tcalculations (so no impact if %0). Also, when %1, only visible cells are included regardless of this\n\t\t\t\t\tsetting. Choices are %2 (rows visible on the page), %3 (all rows not filtered out, even if not\n\t\t\t\t\tvisible because of pagination), %4 (all rows, even if filtered or hidden), and %5 (rows filtered out\n\t\t\t\t\tand rows hidden due to pagination)" => "Determines the rows that will be included in the\n\t\t\t\t\tcalculations (so no impact if %0). Also, when %1, only visible cells are included regardless of this\n\t\t\t\t\tsetting. Choices are %2 (rows visible on the page), %3 (all rows not filtered out, even if not\n\t\t\t\t\tvisible because of pagination), %4 (all rows, even if filtered or hidden), and %5 (rows filtered out\n\t\t\t\t\tand rows hidden due to pagination)",
// "set the label for the total, which will appear in the header\n\t\t\t\t\tfor row totals and in the first column for column totals" => "set the label for the total, which will appear in the header\n\t\t\t\t\tfor row totals and in the first column for column totals",
// "Total Format" => "Total Format",
// "Format for table totals (click %0 for patterns). Example" => "Format for table totals (click %0 for patterns). Example",
// "Total Options" => "Total Options",
// "Pipe-separated options for totals for each column which are set in the %0 parameter" => "Pipe-separated options for totals for each column which are set in the %0 parameter",
// "overrides the default number format set in %0" => "overrides the default number format set in %0",
// "column will be excluded from total calculations set in the %0\n\t\t\t\t\tparameter. Remember to include any columns that will be added for row totals set in the %0\n\t\t\t\t\tparameter" => "column will be excluded from total calculations set in the %0\n\t\t\t\t\tparameter. Remember to include any columns that will be added for row totals set in the %0\n\t\t\t\t\tparameter",
"Example" => "範例",
// "Page totals" => "Page totals",
// "Please install Faker package" => "Please install Faker package",
// "Object \"%0\" of type \"%1\" not found" => "Object \"%0\" of type \"%1\" not found",
// "The value of items is not a number" => "The value of items is not a number",
// "Tracker not found" => "Tracker not found",
// "Invalid field definition: %0" => "Invalid field definition: %0",
// "Checking for image gallery files skipped" => "Checking for image gallery files skipped",
// "The user (%0) do not have at least the \"view_image_gallery\" permission, please select other user using the \"--as-user\" parameter" => "The user (%0) do not have at least the \"view_image_gallery\" permission, please select other user using the \"--as-user\" parameter",
// "Tracker Attachments" => "Tracker Attachments",
// "Wiki Attachments" => "Wiki Attachments",
// "Forum Attachments" => "Forum Attachments",
// "Configured to stores files in Database" => "Configured to stores files in Database",
// "Configured to stores files on Disk: %0" => "Configured to stores files on Disk: %0",
// "Files are currently stored both in Disk and DB, it might mean that you changed the setting but did not migrate the files" => "Files are currently stored both in Disk and DB, it might mean that you changed the setting but did not migrate the files",
// "Files in DB: %0" => "Files in DB: %0",
// "Files on Disk: %0" => "Files on Disk: %0",
// "No Issues found" => "No Issues found",
// "Found %0 Issues, details below" => "Found %0 Issues, details below",
// "The following files are missing" => "The following files are missing",
"Id" => "Id",
// "The following files have different size that expected" => "The following files have different size that expected",
// "The following files are unknown, exists in the folder, but not in the database" => "The following files are unknown, exists in the folder, but not in the database",
// "Copy files from file galleries to a regular directory on the file system" => "Copy files from file galleries to a regular directory on the file system",
// "Feature Galleries not set up" => "Feature Galleries not set up",
// "File Copy: Gallery #%0 not found" => "File Copy: Gallery #%0 not found",
// "File Copy: Destination path required" => "File Copy: Destination path required",
// "No files to copy" => "No files to copy",
// "File Copy starting.." => "File Copy starting..",
// "File Copy complete" => "File Copy complete",
// "Move files from file galleries to a regular directory on the file system" => "Move files from file galleries to a regular directory on the file system",
// "File Move: Gallery #%0 not found" => "File Move: Gallery #%0 not found",
// "File Move: Destination path required" => "File Move: Destination path required",
// "No files to move" => "No files to move",
// "Use the --confirm option to proceed with the move operation" => "Use the --confirm option to proceed with the move operation",
// "File Move starting.." => "File Move starting..",
// "File Move complete" => "File Move complete",
// "Migrate images from the Image Gallery to the File Gallery" => "Migrate images from the Image Gallery to the File Gallery",
// "All files migrated" => "All files migrated",
// "No files migrated, default file gallery path is not writable" => "No files migrated, default file gallery path is not writable",
// "%0 reached for %1 (%2)" => "%0 reached for %1 (%2)",
// "Search index could not be updated: %0" => "Search index could not be updated: %0",
// "Clean Tiki install" => "Clean Tiki install",
// "Force installation. Overwrite any current database" => "Force installation. Overwrite any current database",
// "Use InnoDb as storage engine: 1 - InnoDb, 0 - MyISAM" => "Use InnoDb as storage engine: 1 - InnoDb, 0 - MyISAM",
// "Installation completed" => "Installation completed",
// "Queries executed successfully: %0" => "Queries executed successfully: %0",
// "Error %0 in" => "Error %0 in",
// "Database already exists" => "Database already exists",
// "Dependencies not satisfied. Exiting" => "Dependencies not satisfied. Exiting",
// "Composer could not be executed" => "Composer could not be executed",
// "Extension %0 is now disabled" => "Extension %0 is now disabled",
// "Extension %0 was not disabled" => "Extension %0 was not disabled",
// "Extension %0 was updated" => "Extension %0 was updated",
// "Extension %0 is now enabled" => "Extension %0 is now enabled",
// "Extension %0 was not enabled" => "Extension %0 was not enabled",
// "Installing package: " => "Installing package: ",
// "Invalid Package: " => "Invalid Package: ",
// "No packages available to be installed" => "No packages available to be installed",
// "No packages found in composer.json in the root of the project" => "No packages found in composer.json in the root of the project",
// "No packages installed" => "No packages installed",
// "Packages Installed" => "Packages Installed",
// "Packages Available to Install" => "Packages Available to Install",
// "No packages available to be removed" => "No packages available to be removed",
// "Removing package: " => "Removing package: ",
// "Packages that can be removed" => "Packages that can be removed",
// "No packages available to be updated" => "No packages available to be updated",
// "Updating package: " => "Updating package: ",
// "Packages that can be updated" => "Packages that can be updated",
// "Approve a list of plugin invocations/calls" => "Approve a list of plugin invocations/calls",
// "List fingerprints of the plugin invocations/calls to approve separated by commas" => "List fingerprints of the plugin invocations/calls to approve separated by commas",
// "Approve all plugin invocations/calls" => "Approve all plugin invocations/calls",
// "You must either use the option --all or provide a list of fingerprints to approve" => "You must either use the option --all or provide a list of fingerprints to approve",
// "Approving all pending plugins" => "Approving all pending plugins",
// "Approving a list of plugins" => "Approving a list of plugins",
// "Approving plugin %0" => "Approving plugin %0",
// "Plugins approved with success" => "Plugins approved with success",
// "List all plugin invocations/calls" => "List all plugin invocations/calls",
// "Shows only invocations/calls pending approval" => "Shows only invocations/calls pending approval",
// "Listing plugins in status: %0" => "Listing plugins in status: %0",
// "Found %0 plugins" => "Found %0 plugins",
// "No plugins found" => "No plugins found",
// "Parses all the pages to refresh the list of plugin invocations/calls" => "Parses all the pages to refresh the list of plugin invocations/calls",
// "Plugin list refreshed with success" => "Plugin list refreshed with success",
// "Not enough arguments (missing: \"article\" or \"--all\" options)" => "Not enough arguments (missing: \"article\" or \"--all\" options)",
// "Not enough arguments (missing: \"calendar\" or \"--all\" option)" => "Not enough arguments (missing: \"calendar\" or \"--all\" option)",
// "Not enough arguments (missing: \"category\" or \"--all\" options)" => "Not enough arguments (missing: \"category\" or \"--all\" options)",
// "Not enough arguments (missing: \"forum\" or \"--all\" option)" => "Not enough arguments (missing: \"forum\" or \"--all\" option)",
// "Not enough arguments (missing: \"menu\" or \"--all\" option)" => "Not enough arguments (missing: \"menu\" or \"--all\" option)",
// "Not enough arguments (missing: \"name\" or \"--all\" options)" => "Not enough arguments (missing: \"name\" or \"--all\" options)",
// "Not enough arguments (missing: \"tracker\" or \"--all\" option)" => "Not enough arguments (missing: \"tracker\" or \"--all\" option)",
// "No Items found to export" => "No Items found to export",
// "Tracker item %0 exported" => "Tracker item %0 exported",
// "Tracker item %0 failed to exported" => "Tracker item %0 failed to exported",
// "Tracker items for tracker %0 exported" => "Tracker items for tracker %0 exported",
// "Not enough arguments (missing: \"page\" or \"--all\" option)" => "Not enough arguments (missing: \"page\" or \"--all\" option)",
// "Profile name" => "Profile name",
// "profiles.tiki.org" => "profiles.tiki.org",
// "Re-apply profiles when already applied" => "Re-apply profiles when already applied",
// "Return to the user information about what is going to be applied" => "Return to the user information about what is going to be applied",
// "Some of the named object references in the profile are invalid" => "Some of the named object references in the profile are invalid",
// "Profile applied" => "Profile applied",
// "Installation failed" => "Installation failed",
// "Dry-run for profile: " => "Dry-run for profile: ",
// "Permission removed: " => "Permission removed: ",
// "Permission added: " => "Permission added: ",
// "User modified: " => "User modified: ",
// "User added: " => "User added: ",
// "Group modified: " => "Group modified: ",
// "Group added: " => "Group added: ",
// "Preference set: %0= %1 old value= %2" => "Preference set: %0= %1 old value= %2",
// "Installer added: " => "Installer added: ",
// "Profile was already applied. Nothing happened" => "Profile was already applied. Nothing happened",
// "SCSS Parse Error" => "SCSS Parse Error",
// "SCSS Compiler Error" => "SCSS Compiler Error",
// "SCSS Range Error" => "SCSS Range Error",
// "SCSS Server Error" => "SCSS Server Error",
// "SCSS Error" => "SCSS Error",
// "Preference \"sitemap_enable\" is not enabled" => "Preference \"sitemap_enable\" is not enabled",
// "New sitemap created" => "New sitemap created",
// "File not found" => "File not found",
// "File is not a .zip file" => "File is not a .zip file",
// "Theme installed" => "Theme installed",
// "Theme not found" => "Theme not found",
// "Theme removed successfully" => "Theme removed successfully",
// "An error occurred while deleting theme" => "An error occurred while deleting theme",
// "CSS folder not found" => "CSS folder not found",
// "Configuration file added" => "Configuration file added",
// "Preference inserted or updated" => "Preference inserted or updated",
// "Menu inserted or update" => "Menu inserted or update",
// "Module inserted or update" => "Module inserted or update",
// "Theme updated" => "Theme updated",
// "Could not open file" => "Could not open file",
// "Displays the Tiki (tiki) or PHP version (php), empty to display both" => "Displays the Tiki (tiki) or PHP version (php), empty to display both",
// "Internal error: mandatory parameter field_fetch_url is missing" => "Internal error: mandatory parameter field_fetch_url is missing",
// "Internal error: mandatory parameter object_store_url is missing" => "Internal error: mandatory parameter object_store_url is missing",
// "Problem finding the associated user. %0 is not recognized. See EventNotify.php" => "Problem finding the associated user. %0 is not recognized. See EventNotify.php",
// "Event name may be empty or invalid" => "Event name may be empty or invalid",
// "Arguments are expected to be a value map" => "Arguments are expected to be a value map",
// "New File" => "New File",
// "Unable to write to destination path: %0" => "Unable to write to destination path: %0",
// "Cannot resize the file" => "Cannot resize the file",
// "Cannot write the file" => "Cannot write the file",
// "Image was reduced: %s x %s -> %s x %s" => "Image was reduced: %s x %s -> %s x %s",
// "`%0` does not match acceptable naming patterns" => "`%0` does not match acceptable naming patterns",
// "Duplicate file found as `%0`. Upload rejected" => "Duplicate file found as `%0`. Upload rejected",
// "Mail-in auto-reply" => "Mail-in auto-reply",
// "Sorry, you can't use this feature" => "Sorry, you can't use this feature",
// "The functionality you are trying to access is currently disabled" => "The functionality you are trying to access is currently disabled",
// "No required action found" => "No required action found",
// "Rejected message, user globally denied" => "Rejected message, user globally denied",
// "Rejected message, associated action disabled (%0)" => "Rejected message, associated action disabled (%0)",
// "Performing action (%0)" => "Performing action (%0)",
// "Rejected message, user locally denied (%0)" => "Rejected message, user locally denied (%0)",
// "Rejected message, no associated action" => "Rejected message, no associated action",
// "Submit Article" => "Submit Article",
// "Unable to find suitable action" => "Unable to find suitable action",
// "Wiki Append" => "Wiki Append",
// "Wiki Get" => "Wiki Get",
// "Wiki Prepend" => "Wiki Prepend",
// "Wiki Create/Update" => "Wiki Create/Update",
// "created from mail-in" => "created from mail-in",
// "Create or update article" => "Create or update article",
// "Reply Handler" => "Reply Handler",
// "Wiki (multiple actions)" => "Wiki (multiple actions)",
// "Login failed for IMAP account on %0:%1 for user %2" => "Login failed for IMAP account on %0:%1 for user %2",
// "Login failed for POP3 account on %0:%1 for user %2" => "Login failed for POP3 account on %0:%1 for user %2",
// "= New composer.json file content" => "= New composer.json file content",
// "= Composer execution output" => "= Composer execution output",
// "Errors" => "Errors",
// "Unable to download composer installer from %0" => "Unable to download composer installer from %0",
// "Invalid composer installer signature" => "Invalid composer installer signature",
// "composer.phar installed in temp folder" => "composer.phar installed in temp folder",
// "There was a problem when installing Composer" => "There was a problem when installing Composer",
// "Tiki root directory is not writable, so file \"%0\" can not be created" => "Tiki root directory is not writable, so file \"%0\" can not be created",
// "Tiki root directory is not writable, so directory \"%0\" can not be created" => "Tiki root directory is not writable, so directory \"%0\" can not be created",
// "Tiki can not write to file \"%0\"" => "Tiki can not write to file \"%0\"",
// "Tiki can not write to directory \"%0\"" => "Tiki can not write to directory \"%0\"",
// "Warning: Unable to load profile. Profile %0 not found in profiles folder. Skipping.." => "Warning: Unable to load profile. Profile %0 not found in profiles folder. Skipping..",
// "Warning: Profile %0 already installed. Skipping.." => "Warning: Profile %0 already installed. Skipping..",
// "Profile %0 applied" => "Profile %0 applied",
// "Warning: Profile %0 is not installed. Skipping.." => "Warning: Profile %0 is not installed. Skipping..",
// "Profile %0 removed" => "Profile %0 removed",
// "%0 library not found. This may be due to a typo or caused by a recent update" => "%0 library not found. This may be due to a typo or caused by a recent update",
// "Package %0 is not a Tiki Extension" => "Package %0 is not a Tiki Extension",
// "Package %0 is already enabled" => "Package %0 is already enabled",
// "Package %0 is not enabled" => "Package %0 is not enabled",
// "Calendar does not exist" => "Calendar does not exist",
// "Calendar already exists" => "Calendar already exists",
// "File gallery does not exist" => "File gallery does not exist",
// "File gallery already exists" => "File gallery already exists",
// "Untitled - From Profile Import" => "Untitled - From Profile Import",
// "Field \"%0\" in Tracker %1 has no value for itemId %2" => "Field \"%0\" in Tracker %1 has no value for itemId %2",
// "Created by profile installer" => "Created by profile installer",
// "Page updated by profile installer" => "Page updated by profile installer",
// "Tiki (%0) is not satisfiable by profile required Tiki version (%1)" => "Tiki (%0) is not satisfiable by profile required Tiki version (%1)",
// "Nothing was changed. Please check the profile for errors" => "Nothing was changed. Please check the profile for errors",
// "Applying profile" => "Applying profile",
// "Added (or modified)" => "Added (or modified)",
// "Group changed (or modified)" => "Group changed (or modified)",
// "Installer reverted" => "Installer reverted",
// "Installer removed" => "Installer removed",
// "Group removed" => "Group removed",
// "Group modified" => "Group modified",
// "Permission removed" => "Permission removed",
// "Permission assign" => "Permission assign",
// "Preference set" => "Preference set",
// "<error>Package %0:  No folder was found. Did you forgot to install?</error>" => "<error>Package %0:  No folder was found. Did you forgot to install?</error>",
// "Package set" => "Package set",
// "Modified permission %s for %s" => "Modified permission %s for %s",
// "Modified permission %s on %s/%s for %s" => "Modified permission %s on %s/%s for %s",
// "User %0 was added to %1" => "User %0 was added to %1",
// "No name" => "No name",
// "Bad object" => "Bad object",
// "Could not parse YAML in profile: \"%0\"" => "Could not parse YAML in profile: \"%0\"",
// "Profile Path cannot be found" => "Profile Path cannot be found",
// "Syntax error: " => "Syntax error: ",
// "Circular reference" => "Circular reference",
// "Permissions' object must have a field 'type' and 'id'" => "Permissions' object must have a field 'type' and 'id'",
// "Needs a 'type' and 'data' field" => "Needs a 'type' and 'data' field",
// "Source: %0:%1 (%2)" => "Source: %0:%1 (%2)",
// "Recommendation: %0:%1 (%2)" => "Recommendation: %0:%1 (%2)",
// "The directory with path: ' . \$path_or_id . ' could not be found" => "The directory with path: ' . \$path_or_id . ' could not be found",
// "The file with path: ' . \$path_or_id . ' could not be found" => "The file with path: ' . \$path_or_id . ' could not be found",
// "The wiki page with name: ' . \$name . ' could not be found" => "The wiki page with name: ' . \$name . ' could not be found",
// "Theme already installed" => "Theme already installed",
// "Version %0 is no longer supported" => "Version %0 is no longer supported",
// "A minor upgrade to %0 is strongly recommended" => "A minor upgrade to %0 is strongly recommended",
// "A major upgrade to %0 is strongly recommended" => "A major upgrade to %0 is strongly recommended",
// "Version %0 is still supported. However, an upgrade to %1 is available" => "Version %0 is still supported. However, an upgrade to %1 is available",
// "Version %0 is still supported. However, a major upgrade to %1 is available" => "Version %0 is still supported. However, a major upgrade to %1 is available",
// "Replace spaces with dashes" => "Replace spaces with dashes",
// "Replace spaces with underscores" => "Replace spaces with underscores",
// "URL Encode (Tiki Classic)" => "URL Encode (Tiki Classic)",
// "Duplicate entry found (%0)" => "Duplicate entry found (%0)",
// "Filter error: \"%0\"" => "Filter error: \"%0\"",
"Action" => "動作",
// "Create a form to be posted somewhere, not necessarily in a tracker or even at this Tiki site" => "Create a form to be posted somewhere, not necessarily in a tracker or even at this Tiki site",
// "The title of the button" => "The title of the button",
"Post" => "發表佈告",
// "The protocol to use in the form: either get or post" => "The protocol to use in the form: either get or post",
// "Script" => "Script",
// "The URL of the destination of the form" => "The URL of the destination of the form",
"Parameters" => "參數",
// "Here page:fieldname can be repeated several times. It specifies the variable names to pass in the form as well as the value taken from the current item in the field named fieldname. \"highlight=test\" can also be repeated and is useful for fixed values as parameters to pass to the form" => "Here page:fieldname can be repeated several times. It specifies the variable names to pass in the form as well as the value taken from the current item in the field named fieldname. \"highlight=test\" can also be repeated and is useful for fixed values as parameters to pass to the form",
// "Attach articles to the tracker item" => "Attach articles to the tracker item",
"Topic" => "主題",
// "Default article topic" => "Default article topic",
// "Article Type" => "Article Type",
// "Default article type" => "Default article type",
// "Auto-Increment" => "Auto-Increment",
// "Enable an incrementing value field, or itemId field" => "Enable an incrementing value field, or itemId field",
"Start" => "開始",
// "The starting value for the field" => "The starting value for the field",
// "Prepend" => "Prepend",
// "Text that will be displayed before the field" => "Text that will be displayed before the field",
// "Append" => "Append",
// "Text that will be displayed after the field" => "Text that will be displayed after the field",
// "If set to \"itemId\", will set this field to match the value of the actual database itemId field value" => "If set to \"itemId\", will set this field to match the value of the actual database itemId field value",
// "Update Empty" => "Update Empty",
"No" => "否",
"Yes" => "是",
// "Note: %0 auto-increment item values updated" => "Note: %0 auto-increment item values updated",
// "Add auto-increment numbers to items in this tracker that don't have one one. ********** N.B. This modifies data and there is no undo **********" => "Add auto-increment numbers to items in this tracker that don't have one one. ********** N.B. This modifies data and there is no undo **********",
// "Date and Time (Calendar Item)" => "Date and Time (Calendar Item)",
// "Associate calendar items with tracker items" => "Associate calendar items with tracker items",
// "Experimental: (work in progress, use with care)" => "Experimental: (work in progress, use with care)",
// "Calendar Id" => "Calendar Id",
// "Calendar to use for associated events" => "Calendar to use for associated events",
// "Show Event Id" => "Show Event Id",
// "Show an input for the event id when editing the field, allow lost events to be reattached" => "Show an input for the event id when editing the field, allow lost events to be reattached",
// "Calendar Item %0 not found" => "Calendar Item %0 not found",
// "CalendarItem Tracker Field %0 calendar item not found %1 for itemId %2" => "CalendarItem Tracker Field %0 calendar item not found %1 for itemId %2",
"Category" => "分類",
// "Enable the tracker item to be categorized in one or more categories under the specified main category" => "Enable the tracker item to be categorized in one or more categories under the specified main category",
// "Parent Category" => "Parent Category",
// "Child categories will be provided as options for the field" => "Child categories will be provided as options for the field",
// "Input Type" => "Input Type",
// "User interface control to be used" => "User interface control to be used",
// "Dropdown" => "Dropdown",
// "Radio buttons" => "Radio buttons",
// "List box" => "List box",
// "Multiple-selection checkboxes" => "Multiple-selection checkboxes",
// "Select All" => "Select All",
// "Includes a control to select all available options for multi-selection controls" => "Includes a control to select all available options for multi-selection controls",
// "No controls" => "No controls",
// "Include controls" => "Include controls",
// "All descendants" => "All descendants",
// "Display all descendants instead of only first-level descendants" => "Display all descendants instead of only first-level descendants",
// "First level only" => "First level only",
// "All descendants and display full path" => "All descendants and display full path",
// "Displays the field description in a help tooltip" => "Displays the field description in a help tooltip",
// "No help" => "No help",
// "Tooltip" => "Tooltip",
// "Output Type" => "Output Type",
// "Plain list with items separated by line breaks (default)" => "Plain list with items separated by line breaks (default)",
// "Links separated by line breaks" => "Links separated by line breaks",
// "Unordered list of labels" => "Unordered list of labels",
// "Unordered list of links" => "Unordered list of links",
// "Do not Inherit Categories" => "Do not Inherit Categories",
// "Inherit (default)" => "Inherit (default)",
// "Do not inherit" => "Do not inherit",
// "Recategorization event" => "Recategorization event",
// "Set this to \"Indexing\" to recategorize the items during reindexing as well as when saving" => "Set this to \"Indexing\" to recategorize the items during reindexing as well as when saving",
// "Indexing" => "Indexing",
// "-Blank (no data)-" => "-Blank (no data)-",
// "%0 (any of)" => "%0 (any of)",
// "%0 (all of)" => "%0 (all of)",
// "Tracker items will inherit their tracker's categories unless this option is set" => "Tracker items will inherit their tracker's categories unless this option is set",
// "Checkbox" => "Checkbox",
// "Provide a checkbox field for yes/no, on/off input" => "Provide a checkbox field for yes/no, on/off input",
// "Computed Field" => "Computed Field",
// "Provide a computed value based on numeric field values. Consider using webservices or JavaScript to perform the task instead of using this field type" => "Provide a computed value based on numeric field values. Consider using webservices or JavaScript to perform the task instead of using this field type",
// "This feature is still in place for backward compatibility. While it has no known flaws, it could be used as a vector for a malicious attack. A webservice field or custom JavaScript is recommended instead of this field" => "This feature is still in place for backward compatibility. While it has no known flaws, it could be used as a vector for a malicious attack. A webservice field or custom JavaScript is recommended instead of this field",
// "Formula" => "Formula",
// "The formula to be computed supporting various operators (+ - * / and parenthesis), references to other field made using the field id preceeded by #" => "The formula to be computed supporting various operators (+ - * / and parenthesis), references to other field made using the field id preceeded by #",
// "Decimal Places" => "Decimal Places",
// "Number of decimal places to round to" => "Number of decimal places to round to",
// "Decimal separator when displaying data" => "Decimal separator when displaying data",
// "Single character. Use \"c\" for comma, \"d\" for dot or \"s\" for space. The valid decimal separator when inserting numbers may depend on the site language and web browser. See the documentation for more details" => "Single character. Use \"c\" for comma, \"d\" for dot or \"s\" for space. The valid decimal separator when inserting numbers may depend on the site language and web browser. See the documentation for more details",
// "Thousand separator when displaying data" => "Thousand separator when displaying data",
// "Single character: use \"c\" for comma, \"d\" for dot or \"s\" for space.  When inserting data, no thousands separator is needed" => "Single character: use \"c\" for comma, \"d\" for dot or \"s\" for space.  When inserting data, no thousands separator is needed",
// "Country Selector" => "Country Selector",
// "Enable a selection from a specified list of countries" => "Enable a selection from a specified list of countries",
"Display" => "顯示",
// "Specify the rendering type for the field" => "Specify the rendering type for the field",
// "Name and flag" => "Name and flag",
// "Name only" => "Name only",
// "Flag only" => "Flag only",
// "Sort order" => "Sort order",
// "Determines whether the ordering should be based on the translated name or the English name" => "Determines whether the ordering should be based on the translated name or the English name",
// "Translated name" => "Translated name",
// "English name" => "English name",
// "Currency Field" => "Currency Field",
// "Provide a one-line field for numeric input only. Prepended or appended values may be alphanumeric" => "Provide a one-line field for numeric input only. Prepended or appended values may be alphanumeric",
// "Same Row" => "Same Row",
// "Displays the next field on the same line" => "Displays the next field on the same line",
// "Display Size" => "Display Size",
// "Visible size of the field, in characters. Does not affect the numeric length" => "Visible size of the field, in characters. Does not affect the numeric length",
// "Text to be displayed in front of the currency amount" => "Text to be displayed in front of the currency amount",
// "Text to be displayed after the numeric value" => "Text to be displayed after the numeric value",
// "Locale" => "Locale",
// "Set locale for currency formatting, for example en_US or en_US.UTF-8 or en_US.ISO-8559-1. Default is en_US" => "Set locale for currency formatting, for example en_US or en_US.UTF-8 or en_US.ISO-8559-1. Default is en_US",
// "Currency" => "Currency",
// "A custom alphanumeric currency code. Not needed if locale is set and a standard code is desired. Default is USD" => "A custom alphanumeric currency code. Not needed if locale is set and a standard code is desired. Default is USD",
// "Symbol" => "Symbol",
// "Set whether the currency code (for example USD) or symbol (for example \$) will display. Defaults to symbol" => "Set whether the currency code (for example USD) or symbol (for example \$) will display. Defaults to symbol",
// "Currency code" => "Currency code",
// "Currency symbol" => "Currency symbol",
// "First or all" => "First or all",
// "Set whether the currency code or symbol will be displayed against all amounts or only the first amount" => "Set whether the currency code or symbol will be displayed against all amounts or only the first amount",
// "First item only" => "First item only",
"All" => "全部",
// "Currency Tracker" => "Currency Tracker",
// "Tracker containing available currencies and exchange rates" => "Tracker containing available currencies and exchange rates",
// "Date and Time" => "Date and Time",
// "Provide drop-down options to accurately select a date and/or time" => "Provide drop-down options to accurately select a date and/or time",
// "Components to be included" => "Components to be included",
// "Date only" => "Date only",
// "Start year" => "Start year",
// "Year to allow selecting from" => "Year to allow selecting from",
// "End year" => "End year",
// "Year to allow selecting to" => "Year to allow selecting to",
// "Default selection" => "Default selection",
// "Indicates if blank dates should be allowed" => "Indicates if blank dates should be allowed",
// "Current Date" => "Current Date",
// "Blank" => "Blank",
// "Time Ago" => "Time Ago",
// "Use timeago.js if the feature is enabled" => "Use timeago.js if the feature is enabled",
// "Item Date Field" => "Item Date Field",
// "Use this date as the item's global date in the search index" => "Use this date as the item's global date in the search index",
// "Allow users to select only from a specified set of options" => "Allow users to select only from a specified set of options",
"Option" => "選項",
// "If an option contains an equal sign, the part before the equal sign will be used as the value, and the second part as the label" => "If an option contains an equal sign, the part before the equal sign will be used as the value, and the second part as the label",
// "Dropdown selector with \"Other\" field" => "Dropdown selector with \"Other\" field",
// "Allow users to select from a specified set of options or to enter an alternate option" => "Allow users to select from a specified set of options or to enter an alternate option",
// "To change the label of the \"Other\" option, use \"other=Label\"" => "To change the label of the \"Other\" option, use \"other=Label\"",
// "Radio Buttons" => "Radio Buttons",
// "Multiselect" => "Multiselect",
// "Allow a user to select multiple values from a specified set of options" => "Allow a user to select multiple values from a specified set of options",
// "Dynamic Items List" => "Dynamic Items List",
// "Dynamically update a selection list based on linked data from another tracker" => "Dynamically update a selection list based on linked data from another tracker",
// "Tracker ID" => "Tracker ID",
// "Tracker to link with" => "Tracker to link with",
// "Field ID (Other tracker)" => "Field ID (Other tracker)",
// "Field ID to link with in the other tracker" => "Field ID to link with in the other tracker",
// "Field ID (This tracker)" => "Field ID (This tracker)",
// "Field ID to link with in the current tracker" => "Field ID to link with in the current tracker",
// "Listed Field" => "Listed Field",
// "Field ID to be displayed in the dropdown list" => "Field ID to be displayed in the dropdown list",
// "Status Filter" => "Status Filter",
// "Restrict listed items to specific statuses" => "Restrict listed items to specific statuses",
"all" => "全部",
"open" => "開放",
// "pending" => "pending",
"closed" => "關閉",
// "open, pending" => "open, pending",
// "pending, closed" => "pending, closed",
// "Hide blank" => "Hide blank",
// "Hide first blank option, thus preselecting the first available option" => "Hide first blank option, thus preselecting the first available option",
// "Select multiple values" => "Select multiple values",
// "Allow the user to select multiple values" => "Allow the user to select multiple values",
// "*** ERROR: Field ID (This tracker) cannot be the same: %0 ***" => "*** ERROR: Field ID (This tracker) cannot be the same: %0 ***",
// "*** ERROR: Field %0 not found ***" => "*** ERROR: Field %0 not found ***",
// "*** ERROR: No remote tracker selected for DynamicList Field %0 ***" => "*** ERROR: No remote tracker selected for DynamicList Field %0 ***",
// "DynamicList field: Field \"%0\" not found" => "DynamicList field: Field \"%0\" not found",
"Email" => "電子郵件",
// "Enable an email address to be input with the option of making it active" => "Enable an email address to be input with the option of making it active",
// "Link Type" => "Link Type",
// "How the email address will be rendered" => "How the email address will be rendered",
"Plain text" => "純文字",
// "Encoded mailto link" => "Encoded mailto link",
// "Simple mailto link" => "Simple mailto link",
// "Watch Open" => "Watch Open",
// "Notify this address every time the status changes to open" => "Notify this address every time the status changes to open",
// "Watch Pending" => "Watch Pending",
// "Notify this address every time the status changes to pending" => "Notify this address every time the status changes to pending",
// "Watch Closed" => "Watch Closed",
// "Notify this address every time the status changes to closed" => "Notify this address every time the status changes to closed",
// "Tracker Field Factory Error: Pref \"%0\" required for field type \"%1\"" => "Tracker Field Factory Error: Pref \"%0\" required for field type \"%1\"",
"Attachment" => "附件",
// "Deprecated in favor of the Files field" => "Deprecated in favor of the Files field",
// "List View" => "List View",
// "Defines how attachments will be displayed within the field" => "Defines how attachments will be displayed within the field",
"name" => "名稱",
"type" => "類型",
// "name, size" => "name, size",
// "name, type, size" => "name, type, size",
// "uploader" => "uploader",
// "mediaplayer" => "mediaplayer",
// "Download" => "Download",
// "Attached and upload files stored in the file galleries to the tracker item" => "Attached and upload files stored in the file galleries to the tracker item",
// "Gallery ID" => "Gallery ID",
// "File gallery to upload new files into" => "File gallery to upload new files into",
// "MIME Type Filter" => "MIME Type Filter",
// "Mask for accepted MIME types in the field" => "Mask for accepted MIME types in the field",
// "File Count" => "File Count",
// "Maximum number of files to be attached on the field" => "Maximum number of files to be attached on the field",
// "Display Mode" => "Display Mode",
// "Show files as object links or via a wiki plugin (img so far)" => "Show files as object links or via a wiki plugin (img so far)",
"Links" => "連結",
// "Bare Links" => "Bare Links",
// "Table" => "Table",
"Images" => "圖片",
// "Vimeo" => "Vimeo",
// "Google Viewer" => "Google Viewer",
// "Moodle Scorm Viewer" => "Moodle Scorm Viewer",
// "Display parameters" => "Display parameters",
// "URL-encoded parameters used such as in the {img} plugin, for example," => "URL-encoded parameters used such as in the {img} plugin, for example,",
// "Display parameters for lists" => "Display parameters for lists",
// "Display Order" => "Display Order",
// "Sort order for the files" => "Sort order for the files",
// "Default (order added to tracker item)" => "Default (order added to tracker item)",
// "Name (A - Z)" => "Name (A - Z)",
// "Name (Z - A)" => "Name (Z - A)",
// "Filename (A - Z)" => "Filename (A - Z)",
// "Filename (Z - A)" => "Filename (Z - A)",
// "Created date (old - new)" => "Created date (old - new)",
// "Created date (new - old)" => "Created date (new - old)",
// "Last modified date (old - new)" => "Last modified date (old - new)",
// "Last modified date (new - old)" => "Last modified date (new - old)",
// "File size (small - large)" => "File size (small - large)",
// "File size (large - small)" => "File size (large - small)",
// "Hits (low - high)" => "Hits (low - high)",
// "Hits (high - low)" => "Hits (high - low)",
// "Include Child Galleries" => "Include Child Galleries",
// "Use files from child galleries as well" => "Use files from child galleries as well",
// "Replace Existing File" => "Replace Existing File",
// "Replace the existing file, if any, instead of uploading a new one" => "Replace the existing file, if any, instead of uploading a new one",
// "Browse Gallery ID" => "Browse Gallery ID",
// "File gallery browse files. Use 0 for root file gallery. (requires elFinder feature - experimental)" => "File gallery browse files. Use 0 for root file gallery. (requires elFinder feature - experimental)",
// "Restrict permissions to view the file gallery to hide the button" => "Restrict permissions to view the file gallery to hide the button",
// "Duplicate Gallery ID" => "Duplicate Gallery ID",
// "File gallery to duplicate files into when copying the tracker item. 0 or empty means do not duplicate (default)" => "File gallery to duplicate files into when copying the tracker item. 0 or empty means do not duplicate (default)",
// "Index As Map Layer" => "Index As Map Layer",
// "Index the files in a specific format for use in map searchlayers to display trails and features" => "Index the files in a specific format for use in map searchlayers to display trails and features",
// "GeoJSON" => "GeoJSON",
// "GPX" => "GPX",
// "Upload In Modal" => "Upload In Modal",
// "Upload files in a new modal window" => "Upload files in a new modal window",
// "Maximum image width" => "Maximum image width",
// "Leave blank to use selected gallery default setting or enter value in pixels to override gallery settings" => "Leave blank to use selected gallery default setting or enter value in pixels to override gallery settings",
// "Maximum image height" => "Maximum image height",
// "Leave blank to use selected gallery default settings or enter value in pixels to override gallery settings" => "Leave blank to use selected gallery default settings or enter value in pixels to override gallery settings",
// "Add Descriptions" => "Add Descriptions",
// "Add descriptions on uploaded files" => "Add descriptions on uploaded files",
// "Show files as object links or via a wiki plugin (img, Vimeo)" => "Show files as object links or via a wiki plugin (img, Vimeo)",
// "Files field: Gallery #%0 not found" => "Files field: Gallery #%0 not found",
// "Token access needs to be enabled for Google viewer to be used" => "Token access needs to be enabled for Google viewer to be used",
// "File #%0 missing (was attached to trackerfield \"%1\" on item \"%2\")" => "File #%0 missing (was attached to trackerfield \"%1\" on item \"%2\")",
// "Problem with uploaded file: \"%0\"" => "Problem with uploaded file: \"%0\"",
// "No gallery for uploaded file, galleryId=%0" => "No gallery for uploaded file, galleryId=%0",
// "You don't have permission to upload a file to gallery \"%0\"" => "You don't have permission to upload a file to gallery \"%0\"",
// "Allow tags to be shown or added for tracker items" => "Allow tags to be shown or added for tracker items",
// "Visible size of the input field" => "Visible size of the input field",
// "Hide or show the input help" => "Hide or show the input help",
// "Show" => "Show",
// "Hide" => "Hide",
// "Suggest" => "Suggest",
// "Hide or show the tag suggestions" => "Hide or show the tag suggestions",
// "Geographic Feature" => "Geographic Feature",
// "Store a geographic feature on a map, allowing paths (LineString) and boundaries (Polygon) to be drawn on a map and saved" => "Store a geographic feature on a map, allowing paths (LineString) and boundaries (Polygon) to be drawn on a map and saved",
// "Feature cannot be set or modified through this interface" => "Feature cannot be set or modified through this interface",
// "Feature cannot be viewed" => "Feature cannot be viewed",
// "Group Selector" => "Group Selector",
// "Allow a selection from a specified list of user groups" => "Allow a selection from a specified list of user groups",
// "Auto-Assign" => "Auto-Assign",
// "Determines if any group should be automatically assigned to the field" => "Determines if any group should be automatically assigned to the field",
// "Modifier" => "Modifier",
// "Group Filter" => "Group Filter",
// "Limit listed groups to those including the specified group" => "Limit listed groups to those including the specified group",
// "User Groups" => "User Groups",
// "Show groups user belongs to instead of the ones user has permission to see" => "Show groups user belongs to instead of the ones user has permission to see",
// "Assign to the group" => "Assign to the group",
// "For no auto-assigned field, the user (user selector if it exists, or user) will be assigned to the group and it will be his or her default group. The group must have the user choice setting activated" => "For no auto-assigned field, the user (user selector if it exists, or user) will be assigned to the group and it will be his or her default group. The group must have the user choice setting activated",
"Assign" => "指定",
// "Unassign from previous selection" => "Unassign from previous selection",
// "When assign to the group is set, the user (user selector if it exists, or user) will be unassigned from the previously selected group (if any). That group must have the user choice setting activated" => "When assign to the group is set, the user (user selector if it exists, or user) will be unassigned from the previously selected group (if any). That group must have the user choice setting activated",
"Unassign" => "未指定",
// "Email Notification" => "Email Notification",
// "Add selected group to group monitor the item. Group watches feature must be enabled" => "Add selected group to group monitor the item. Group watches feature must be enabled",
// "Header" => "Header",
// "Display a heading between fields to delimit a section and allow visual folding of the fields" => "Display a heading between fields to delimit a section and allow visual folding of the fields",
// "Heading Level" => "Heading Level",
// "Level of the heading to use for complex tracker structures needing multiple heading levels" => "Level of the heading to use for complex tracker structures needing multiple heading levels",
// "Section Toggle" => "Section Toggle",
// "Default State" => "Default State",
// "No toggle" => "No toggle",
"Open" => "開放",
// "Closed" => "Closed",
// "Icon" => "Icon",
// "Provide the ability to select an image as an icon attached to the tracker item from the file galleries" => "Provide the ability to select an image as an icon attached to the tracker item from the file galleries",
// "Default image" => "Default image",
// "Path to the default icon used" => "Path to the default icon used",
// "Maximum Icons" => "Maximum Icons",
// "Number of icons to display in each gallery (default 120)" => "Number of icons to display in each gallery (default 120)",
// "Update icon event" => "Update icon event",
// "Allow update during re-indexing. Selection of indexing is useful for changing the default icon for all items" => "Allow update during re-indexing. Selection of indexing is useful for changing the default icon for all items",
"Image" => "影像",
// "List image width" => "List image width",
// "Display size in pixels" => "Display size in pixels",
// "List image height" => "List image height",
// "Detail image width" => "Detail image width",
// "Detail image height" => "Detail image height",
// "Maximum image size" => "Maximum image size",
// "Maximum image width or height in pixels" => "Maximum image width or height in pixels",
// "Shadowbox" => "Shadowbox",
// "Shadowbox usage on this field" => "Shadowbox usage on this field",
// "Do not use" => "Do not use",
// "One box per item" => "One box per item",
// "Use the same box for all images" => "Use the same box for all images",
// "Missing Icon" => "Missing Icon",
// "Icon to use when no images have been uploaded" => "Icon to use when no images have been uploaded",
"Invalid imagename (using filters for filenames)" => "影像名稱不合法 (使用檔名過濾器)",
// "In Group" => "In Group",
// "Indicate if the user associated with the item is a member of a specified group" => "Indicate if the user associated with the item is a member of a specified group",
// "Group Name" => "Group Name",
// "Name of the group to verify" => "Name of the group to verify",
// "How to display the result" => "How to display the result",
// "Yes/No" => "Yes/No",
// "Join date" => "Join date",
// "Expiration date" => "Expiration date",
// "IP Selector" => "IP Selector",
// "IP address input field" => "IP address input field",
// "Auto-assign" => "Auto-assign",
// "Automatically assign the value on creation or edit" => "Automatically assign the value on creation or edit",
// "Item Link" => "Item Link",
// "Link to another item, similar to a foreign key" => "Link to another item, similar to a foreign key",
// "Tracker to link to" => "Tracker to link to",
// "Field ID" => "Field ID",
// "Default field to display" => "Default field to display",
// "How the link to the item should be rendered" => "How the link to the item should be rendered",
"Value" => "Value",
// "Link" => "Link",
// "Multiple Fields" => "Multiple Fields",
// "Display the values from multiple fields instead of a single one" => "Display the values from multiple fields instead of a single one",
// "Format for Customising Multiple Fields" => "Format for Customising Multiple Fields",
// "Uses the translate function to replace %0 etc with the field values. E.g. \"%0 any text %1\"" => "Uses the translate function to replace %0 etc with the field values. E.g. \"%0 any text %1\"",
// "Multiple Fields display type" => "Multiple Fields display type",
// "Display multiple fields as concatenated list in a dropdown or as a table" => "Display multiple fields as concatenated list in a dropdown or as a table",
// "Plugin TrackerList options" => "Plugin TrackerList options",
// "Override one or more options of Plugin TrackerList to customize displayed table at item edit time (e.g. editable, tsfilters, etc.)" => "Override one or more options of Plugin TrackerList to customize displayed table at item edit time (e.g. editable, tsfilters, etc.)",
// "Limit the available items to a selected set" => "Limit the available items to a selected set",
// "Link Page" => "Link Page",
// "Link to a wiki page instead of directly to the item" => "Link to a wiki page instead of directly to the item",
// "Add Items" => "Add Items",
// "Display text to allow new items to be added - e.g. \"Add item...\" (requires jQuery-UI)" => "Display text to allow new items to be added - e.g. \"Add item...\" (requires jQuery-UI)",
// "Add Item Template Page" => "Add Item Template Page",
// "Wiki page to use as a Pretty Tracker template" => "Wiki page to use as a Pretty Tracker template",
// "Preselect item based on value in this field" => "Preselect item based on value in this field",
// "Preselect item based on value in specified field ID of item being edited" => "Preselect item based on value in specified field ID of item being edited",
// "Preselect based on the value in this remote field" => "Preselect based on the value in this remote field",
// "Match preselect item to this field ID in the tracker that is being linked to" => "Match preselect item to this field ID in the tracker that is being linked to",
// "Preselection matching method" => "Preselection matching method",
// "Method to use to match fields for preselection purposes" => "Method to use to match fields for preselection purposes",
// "Exact Match" => "Exact Match",
// "Field here is part of field there" => "Field here is part of field there",
// "Match domain, used for URL fields" => "Match domain, used for URL fields",
// "Cross select. Load all matching items in the remote tracker" => "Cross select. Load all matching items in the remote tracker",
// "Cross select. Load all matching items in the remote tracker plus wildcards" => "Cross select. Load all matching items in the remote tracker plus wildcards",
// "One item per value" => "One item per value",
// "Display only one item for each label (at random, needed for filtering records in a dynamic items list) or all items" => "Display only one item for each label (at random, needed for filtering records in a dynamic items list) or all items",
// "Displays all the items for a same label with a notation value (itemId)" => "Displays all the items for a same label with a notation value (itemId)",
// "Display only one item for each label" => "Display only one item for each label",
// "Index remote fields" => "Index remote fields",
// "Index one or multiple fields from the master tracker along with the child, separated by |" => "Index one or multiple fields from the master tracker along with the child, separated by |",
// "Cascade actions" => "Cascade actions",
"Status" => "狀態",
// "Categories and status" => "Categories and status",
// "Categories and delete" => "Categories and delete",
// "Delete and status" => "Delete and status",
// "ItemLink: Tracker %0 not found for field \"%1\"" => "ItemLink: Tracker %0 not found for field \"%1\"",
// "ItemLink: Field %0 not found for field \"%1\"" => "ItemLink: Field %0 not found for field \"%1\"",
// "ItemLink field \"%0\": Tracker ID #%1 not found" => "ItemLink field \"%0\": Tracker ID #%1 not found",
// "Elements to cascade when the master is updated or deleted. Categories may conflict if multiple item links are used to different items attempting to manage the same categories. Same for status" => "Elements to cascade when the master is updated or deleted. Categories may conflict if multiple item links are used to different items attempting to manage the same categories. Same for status",
// "Unsupported field conversion type: from %0 to %1" => "Unsupported field conversion type: from %0 to %1",
// "Items List" => "Items List",
// "Display a list of field values from another tracker that has a relation with this tracker" => "Display a list of field values from another tracker that has a relation with this tracker",
// "Tracker from which to list items" => "Tracker from which to list items",
// "Link Field ID" => "Link Field ID",
// "Field ID from the other tracker containing an item link pointing to the item in this tracker or some other value to be matched" => "Field ID from the other tracker containing an item link pointing to the item in this tracker or some other value to be matched",
// "Value Field ID" => "Value Field ID",
// "Field ID from this tracker matching the value in the link field ID from the other tracker if the field above is not an item link. If the field chosen here is an ItemLink, Link Field ID above can be left empty" => "Field ID from this tracker matching the value in the link field ID from the other tracker if the field above is not an item link. If the field chosen here is an ItemLink, Link Field ID above can be left empty",
// "Fields to display" => "Fields to display",
// "Display alternate fields from the other tracker instead of the item title" => "Display alternate fields from the other tracker instead of the item title",
// "Format for customising fields to display" => "Format for customising fields to display",
// "Sort Fields" => "Sort Fields",
// "Order results by one or more fields from the other tracker" => "Order results by one or more fields from the other tracker",
// "How the link to the items should be rendered" => "How the link to the items should be rendered",
// "Permission denied importing into linked tracker %0" => "Permission denied importing into linked tracker %0",
// "Errors occurred importing into linked tracker %0" => "Errors occurred importing into linked tracker %0",
// "Creating replacement linked item for itemId %0 for ItemsList field \"%1\" import failed on item #%2" => "Creating replacement linked item for itemId %0 for ItemsList field \"%1\" import failed on item #%2",
// "Updating linked item for itemId %0 for ItemsList field \"%1\" import failed on item #%2" => "Updating linked item for itemId %0 for ItemsList field \"%1\" import failed on item #%2",
// "Date and Time (Date Picker)" => "Date and Time (Date Picker)",
// "Provide a jQuery UI date picker to select a date and, optionally, a time" => "Provide a jQuery UI date picker to select a date and, optionally, a time",
// "Default value" => "Default value",
// "Default date and time for new items" => "Default date and time for new items",
// "None (undefined)" => "None (undefined)",
// "Item creation date and time" => "Item creation date and time",
// "Not before" => "Not before",
// "Field ID from this tracker to compare the value against and validate it is not before that timestamp" => "Field ID from this tracker to compare the value against and validate it is not before that timestamp",
// "Not after" => "Not after",
// "Field ID from this tracker to compare the value against and validate it is not after that timestamp" => "Field ID from this tracker to compare the value against and validate it is not after that timestamp",
// "Date Picker Field: \"%0\" is not a valid internal date value" => "Date Picker Field: \"%0\" is not a valid internal date value",
// "%0 cannot be before %1" => "%0 cannot be before %1",
// "%0 cannot be after %1" => "%0 cannot be after %1",
// "Kaltura Video" => "Kaltura Video",
// "Display a series of attached Kaltura videos" => "Display a series of attached Kaltura videos",
// "URL-encoded parameters used in the {kaltura} plugin, for example," => "URL-encoded parameters used in the {kaltura} plugin, for example,",
"Language" => "語言",
// "Assign a language to the tracker item to enable multilingual trackers" => "Assign a language to the tracker item to enable multilingual trackers",
// "Indicates if the language should be assigned as the item's language" => "Indicates if the language should be assigned as the item's language",
// "LDAP" => "LDAP",
// "Display a field value from a specific user in LDAP" => "Display a field value from a specific user in LDAP",
// "LDAP filter, can contain the %field_name% placeholder to be replaced with the current field's name" => "LDAP filter, can contain the %field_name% placeholder to be replaced with the current field's name",
// "Field name returned by LDAP" => "Field name returned by LDAP",
"DSN" => "DSN",
// "Data source name registered in Tiki" => "Data source name registered in Tiki",
"Location" => "地點",
// "Enable a geographic location to be selected for the item and displayed on a map" => "Enable a geographic location to be selected for the item and displayed on a map",
// "Use as item location" => "Use as item location",
// "List View Width" => "List View Width",
// "Width of map in pixels when tracker items are shown in list view" => "Width of map in pixels when tracker items are shown in list view",
// "List View Height" => "List View Height",
// "Height of map in pixels when tracker items are shown in list view" => "Height of map in pixels when tracker items are shown in list view",
// "Item View Width" => "Item View Width",
// "Width of map in pixels when a single tracker item is shown" => "Width of map in pixels when a single tracker item is shown",
// "Item View Height" => "Item View Height",
// "Height of map in pixels when a single tracker item is shown" => "Height of map in pixels when a single tracker item is shown",
// "Fields To Search" => "Fields To Search",
// "Fields in this tracker to use as a source to search for a location for" => "Fields in this tracker to use as a source to search for a location for",
// "When To Search" => "When To Search",
// "Event to attempt to search for a location" => "Event to attempt to search for a location",
"Never" => "從不",
// "Save (when Location is empty)" => "Save (when Location is empty)",
// "Save (always)" => "Save (always)",
// "Indexing (when Location is empty)" => "Indexing (when Location is empty)",
// "Indexing (always)" => "Indexing (always)",
// "Location: Field %0 not found for field \"%1\"" => "Location: Field %0 not found for field \"%1\"",
// "Could not find a location for \"%0\"" => "Could not find a location for \"%0\"",
// "When enabled, the field's value is recorded as the item's geolocation to be displayed on locator maps" => "When enabled, the field's value is recorded as the item's geolocation to be displayed on locator maps",
// "Mathematical Calculation" => "Mathematical Calculation",
// "Perform a calculation upon saving the item based on other fields within the same item" => "Perform a calculation upon saving the item based on other fields within the same item",
// "Calculation" => "Calculation",
// "Calculation in the Rating Language" => "Calculation in the Rating Language",
// "Re-calculation event" => "Re-calculation event",
// "Allow specifying special calculation handling. Selection of indexing is useful for dynamic score fields that will not be displayed" => "Allow specifying special calculation handling. Selection of indexing is useful for dynamic score fields that will not be displayed",
// "Value will be re-calculated on save. Current value: %0" => "Value will be re-calculated on save. Current value: %0",
// "Numeric Field" => "Numeric Field",
// "Text to be displayed in front of the numeric value" => "Text to be displayed in front of the numeric value",
// "Thousands separator when displaying data" => "Thousands separator when displaying data",
// "Page Selector" => "Page Selector",
// "Allow a selection from the list of pages" => "Allow a selection from the list of pages",
// "Will auto-assign the creator of the item" => "Will auto-assign the creator of the item",
// "Visible size of the input in characters" => "Visible size of the input in characters",
"Create Page" => "建立頁面",
// "Create missing pages using the page name in this file as the template" => "Create missing pages using the page name in this file as the template",
// "Display the value as a link to the page" => "Display the value as a link to the page",
"Rating" => "評等",
// "A rating of the tracker item. Permissions involved: %0" => "A rating of the tracker item. Permissions involved: %0",
// "The possible options (comma-separated integers) for the rating" => "The possible options (comma-separated integers) for the rating",
"Mode" => "模式",
// "Display rating options as" => "Display rating options as",
// "Stars" => "Stars",
// "Single Option: for example, Like" => "Single Option: for example, Like",
// "Labels" => "Labels",
// "The text labels (comma-separated) for the possible options" => "The text labels (comma-separated) for the possible options",
// "Stars (deprecated)" => "Stars (deprecated)",
// "Display a star rating" => "Display a star rating",
// "A possible option for the rating" => "A possible option for the rating",
// "Stars (system - deprecated)" => "Stars (system - deprecated)",
"Average" => "平均",
// "Number of votes" => "Number of votes",
// "Your rating" => "Your rating",
// "Relations" => "Relations",
// "Allow arbitrary relations to be created between the trackers and other objects in the system" => "Allow arbitrary relations to be created between the trackers and other objects in the system",
// "Relation" => "Relation",
// "Relation qualifier. Must be a three-part qualifier containing letters and separated by dots" => "Relation qualifier. Must be a three-part qualifier containing letters and separated by dots",
// "URL-encoded list of filters to be applied on object selection" => "URL-encoded list of filters to be applied on object selection",
// "Format" => "Format",
// "Customize display of search results of object selection. Default is {title} listing the object title. Note that including other fields in the format will make search look up exactly those fields intead of the title field" => "Customize display of search results of object selection. Default is {title} listing the object title. Note that including other fields in the format will make search look up exactly those fields intead of the title field",
// "Read-only" => "Read-only",
// "Only display the incoming relations instead of manipulating them" => "Only display the incoming relations instead of manipulating them",
// "Include Invert" => "Include Invert",
// "Include invert relations in the list" => "Include invert relations in the list",
// "Control how the relations are displayed in view mode" => "Control how the relations are displayed in view mode",
"List" => "列表",
// "Count" => "Count",
// "Count with toggle for list" => "Count with toggle for list",
// "Force Refresh" => "Force Refresh",
// "Re-save related tracker items" => "Re-save related tracker items",
// "On Save" => "On Save",
// "Extra Filter Field" => "Extra Filter Field",
// "Filter objects by value of another field. Use a jQuery seletor to target the element in the page" => "Filter objects by value of another field. Use a jQuery seletor to target the element in the page",
// "Extra Filter Key" => "Extra Filter Key",
// "Key to filter objects by using the value from the Extra Filter Field above" => "Key to filter objects by using the value from the Extra Filter Field above",
// "Self-related fields with Include Invert option set to Yes should not have Force Refresh option on save" => "Self-related fields with Include Invert option set to Yes should not have Force Refresh option on save",
// "and" => "and",
// "show.tiki.org" => "show.tiki.org",
// "Create, display or manage show.tiki.org instances" => "Create, display or manage show.tiki.org instances",
// "Domain name of show server" => "Domain name of show server",
// "For example, show.tikiwiki.org" => "For example, show.tikiwiki.org",
// "Supported Versions" => "Supported Versions",
// "List of Tiki versions for new instances, For example: \"18.x,15.x,12.x\" or \"trunk,19.x\"" => "List of Tiki versions for new instances, For example: \"18.x,15.x,12.x\" or \"trunk,19.x\"",
// "Shell username on remote server" => "Shell username on remote server",
// "The shell username on the show server" => "The shell username on the show server",
// "Public key file path" => "Public key file path",
// "System path to public key on local server. Only RSA keys are supported" => "System path to public key on local server. Only RSA keys are supported",
// "Private key file path" => "Private key file path",
// "System path to private key on local server. Only RSA keys are supported" => "System path to private key on local server. Only RSA keys are supported",
// "Show debugging information" => "Show debugging information",
// "Show debugging info during testing" => "Show debugging info during testing",
// "Fixed user ID" => "Fixed user ID",
// "Set fixed user ID instead of using the user ID of the creator of the tracker item" => "Set fixed user ID instead of using the user ID of the creator of the tracker item",
// "Static Text" => "Static Text",
// "Display the field description as static text to present notes or additional instructions" => "Display the field description as static text to present notes or additional instructions",
// "Wiki Parse" => "Wiki Parse",
// "Indicates if the description should be parsed as wiki syntax for formatting" => "Indicates if the description should be parsed as wiki syntax for formatting",
// "Handle line breaks as new lines only" => "Handle line breaks as new lines only",
// "Wiki Parse with Pretty Tracker replacements" => "Wiki Parse with Pretty Tracker replacements",
// "Maximum Length (List)" => "Maximum Length (List)",
// "Maximum number of characters to be displayed in list mode" => "Maximum number of characters to be displayed in list mode",
// "Text Field" => "Text Field",
// "Single-line text input" => "Single-line text input",
// "Display the field name and input on the same row" => "Display the field name and input on the same row",
// "Visible size of the field, in characters" => "Visible size of the field, in characters",
// "Text to prepend when displaying the value" => "Text to prepend when displaying the value",
// "Text to append when displaying the value" => "Text to append when displaying the value",
// "Maximum Length" => "Maximum Length",
// "Maximum amount of characters to store" => "Maximum amount of characters to store",
// "Autocomplete" => "Autocomplete",
// "Enable autocompletion while typing in the field" => "Enable autocompletion while typing in the field",
// "Index exact value" => "Index exact value",
// "In addition to indexing the content of the field, also index it as an identifier in tracker_field_{perm name}_exact. This option is not available for multilingual fields. Mostly for identifiers like product codes or ISBN numbers" => "In addition to indexing the content of the field, also index it as an identifier in tracker_field_{perm name}_exact. This option is not available for multilingual fields. Mostly for identifiers like product codes or ISBN numbers",
// "Full-text search of the content of the field" => "Full-text search of the content of the field",
// "Search for a value prefix" => "Search for a value prefix",
// "Search for a precise value" => "Search for a precise value",
// "Full-text search in the current language" => "Full-text search in the current language",
// "Full-text search in a specific language (%0)" => "Full-text search in a specific language (%0)",
// "%0 (any language)" => "%0 (any language)",
// "Full-text search in any language" => "Full-text search in any language",
// "Text Area" => "Text Area",
// "Multi-line text input" => "Multi-line text input",
// "Toolbars" => "Toolbars",
// "Enable the toolbars as syntax helpers" => "Enable the toolbars as syntax helpers",
// "Disable" => "Disable",
// "Enable" => "Enable",
// "Width" => "Width",
// "Size of the text area, in characters" => "Size of the text area, in characters",
// "Height" => "Height",
// "Size of the text area, in lines" => "Size of the text area, in lines",
// "Character Limit" => "Character Limit",
// "Maximum number of characters to be stored" => "Maximum number of characters to be stored",
// "Display Limit (List)" => "Display Limit (List)",
// "Maximum number of characters to be displayed in list mode before the value gets truncated" => "Maximum number of characters to be displayed in list mode before the value gets truncated",
// "Word Count" => "Word Count",
// "Limit the length of the text, in number of words" => "Limit the length of the text, in number of words",
// "Distinct Values" => "Distinct Values",
// "All values in the field must be different" => "All values in the field must be different",
// "Use WYSIWYG" => "Use WYSIWYG",
// "Use a rich text editor instead of inputting plain text" => "Use a rich text editor instead of inputting plain text",
// "Word Limit Exceeded" => "Word Limit Exceeded",
// "Character Limit Exceeded" => "Character Limit Exceeded",
// "Create a link to a specified URL" => "Create a link to a specified URL",
// "How the URL should be rendered" => "How the URL should be rendered",
// "URL as link" => "URL as link",
// "Site title as link" => "Site title as link",
// "URL as link plus site title" => "URL as link plus site title",
// "Text as link (see Other)" => "Text as link (see Other)",
// "Label of the link text. Requires \"Display\" to be set to \"Text as link\"" => "Label of the link text. Requires \"Display\" to be set to \"Text as link\"",
// "Display the list of groups for the user associated with the tracker items" => "Display the list of groups for the user associated with the tracker items",
// "Show direct groups memberships only" => "Show direct groups memberships only",
// "Do not show inherited/included groups" => "Do not show inherited/included groups",
// "Specify Fields" => "Specify Fields",
// "Get the groups for users from these fields, not the \"owner\" user fields" => "Get the groups for users from these fields, not the \"owner\" user fields",
// "User Preference" => "User Preference",
// "Allow user preference changes from a tracker" => "Allow user preference changes from a tracker",
// "Preference Name" => "Preference Name",
// "Name of the preference to manipulate. password and email are not preferences, but are also valid values that will modify the user's profile" => "Name of the preference to manipulate. password and email are not preferences, but are also valid values that will modify the user's profile",
// "User Selector" => "User Selector",
// "Allow the selection of a user or users from a list" => "Allow the selection of a user or users from a list",
// "Assign the value based on the creator or modifier" => "Assign the value based on the creator or modifier",
// "Item Owner" => "Item Owner",
// "Field that determines permissions of the item when \"User can see his own items\" is enabled for the tracker" => "Field that determines permissions of the item when \"User can see his own items\" is enabled for the tracker",
// "Send an email notification to the user(s) every time the item is modified" => "Send an email notification to the user(s) every time the item is modified",
// "Only when other users modify the item" => "Only when other users modify the item",
// "Notification Template" => "Notification Template",
// "The notification email template to use in templates/mail directory or in wiki:PAGE or tplwiki:PAGE format. Default: tracker_changed_notification.tpl. A corresponding subject template must also exist, e.g. tracker_changed_notification_subject.tpl (optional for wiki page templates)" => "The notification email template to use in templates/mail directory or in wiki:PAGE or tplwiki:PAGE format. Default: tracker_changed_notification.tpl. A corresponding subject template must also exist, e.g. tracker_changed_notification_subject.tpl (optional for wiki page templates)",
// "Email Format" => "Email Format",
// "Choose between values text or html, depending on the syntax in the template file that will be used" => "Choose between values text or html, depending on the syntax in the template file that will be used",
"text" => "文字",
// "html" => "html",
// "Multiple selection" => "Multiple selection",
// "Allow selection of multiple users from the list" => "Allow selection of multiple users from the list",
// "Yes (complete list)" => "Yes (complete list)",
// "Yes (filterable by group)" => "Yes (filterable by group)",
// "Group IDs" => "Group IDs",
// "Limit the list of users to members of specific groups" => "Limit the list of users to members of specific groups",
// "Groups that can modify autoassigned values" => "Groups that can modify autoassigned values",
// "List of group IDs who can change this field, even without tracker_admin permission" => "List of group IDs who can change this field, even without tracker_admin permission",
// "Show real name if possible" => "Show real name if possible",
// "User \"%0\" not found" => "User \"%0\" not found",
// "User Subscription" => "User Subscription",
// "Allow registered users to subscribe to a tracker item. Ideally, the item should only be editable by the creator or by administrators. Prepend the maximum amount of subscribers to the field value followed by # if such a limit is desired. For example, 50# means that 50 subscribers will be allowed for this item" => "Allow registered users to subscribe to a tracker item. Ideally, the item should only be editable by the creator or by administrators. Prepend the maximum amount of subscribers to the field value followed by # if such a limit is desired. For example, 50# means that 50 subscribers will be allowed for this item",
// "Webservice" => "Webservice",
// "Display the result of a registered webservice call" => "Display the result of a registered webservice call",
// "Service Name" => "Service Name",
// "Webservice name as registered in Tiki" => "Webservice name as registered in Tiki",
// "Template Name" => "Template Name",
// "Template name to use for rendering as registered with the webservice" => "Template name to use for rendering as registered with the webservice",
// "URL-encoded list of parameters to send to the webservice. %field_name% can be used in the string to be replaced with the values in the tracker item by field permName, Id or Name" => "URL-encoded list of parameters to send to the webservice. %field_name% can be used in the string to be replaced with the values in the tracker item by field permName, Id or Name",
// "Require parameters" => "Require parameters",
// "Do not execute the request if parameters are missing or empty" => "Do not execute the request if parameters are missing or empty",
// "All required" => "All required",
// "(default)" => "(default)",
// "First only required" => "First only required",
// "No parameters required" => "No parameters required",
// "Cache time" => "Cache time",
// "Time in seconds to cache the result for before trying again" => "Time in seconds to cache the result for before trying again",
// "Read only" => "Read only",
// "Webservice %0 not found" => "Webservice %0 not found",
// "Webservice template %0 not found" => "Webservice template %0 not found",
// "Unknown webservice error (code: %0)" => "Unknown webservice error (code: %0)",
// "Unknown webservice error" => "Unknown webservice error",
// "Data too long for Webservice field %0 with %1" => "Data too long for Webservice field %0 with %1",
// "Error updating Webservice field %0" => "Error updating Webservice field %0",
// "Embed an associated wiki page" => "Embed an associated wiki page",
// "Field that is used for Wiki Page Name" => "Field that is used for Wiki Page Name",
// "Field to get page name to create page name with" => "Field to get page name to create page name with",
// "Namespace for Wiki Page" => "Namespace for Wiki Page",
// "The namespace to use for the wiki page to prevent page name clashes. See namespace feature for more information" => "The namespace to use for the wiki page to prevent page name clashes. See namespace feature for more information",
// "Default (trackerfield<fieldId>)" => "Default (trackerfield<fieldId>)",
// "No namespace" => "No namespace",
// "Custom namespace" => "Custom namespace",
// "Custom Namespace" => "Custom Namespace",
// "The custom namespace to use if the custom option is selected" => "The custom namespace to use if the custom option is selected",
// "Rename Wiki Page when changed in tracker" => "Rename Wiki Page when changed in tracker",
// "Rename associated wiki page when the field that is used for Wiki Page Name is changed" => "Rename associated wiki page when the field that is used for Wiki Page Name is changed",
// "Delete Wiki Page when tracker item is deleted" => "Delete Wiki Page when tracker item is deleted",
// "Delete associated wiki page when the tracker item is deleted" => "Delete associated wiki page when the tracker item is deleted",
// "Action Buttons" => "Action Buttons",
// "Display wiki page buttons when editing the item" => "Display wiki page buttons when editing the item",
// "Remove Bad Chars" => "Remove Bad Chars",
// "Remove bad characters from the Wiki Page name" => "Remove bad characters from the Wiki Page name",
// "The page name provided already exists. Please choose another" => "The page name provided already exists. Please choose another",
// "The page name specified \"%0\" contains unallowed characters. It will not be possible to save the page until those are removed: %1" => "The page name specified \"%0\" contains unallowed characters. It will not be possible to save the page until those are removed: %1",
// "Missing Page Name field #%0 for Wiki field #%1" => "Missing Page Name field #%0 for Wiki field #%1",
// "Page \"%0\" already exists. Not overwriting" => "Page \"%0\" already exists. Not overwriting",
// "Missing Page Name field #%0 value for Wiki field #%1 (so page not created)" => "Missing Page Name field #%0 value for Wiki field #%1 (so page not created)",
// "Look up a single item by ID" => "Look up a single item by ID",
"Search" => "搜尋",
// "Full-text search across all of the content" => "Full-text search across all of the content",
// "Modification Date" => "Modification Date",
// "Unknown value" => "Unknown value",
// "Modified Date" => "Modified Date",
"Actions" => "行動",
// "Dynamic Filters" => "Dynamic Filters",
// "From %0 to %1" => "From %0 to %1",
// "Field not found: %0" => "Field not found: %0",
// "Filter mode not found: %0 for %1" => "Filter mode not found: %0 for %1",
// "Field mode not found: %0 for %1" => "Field mode not found: %0 for %1",
// "Primary Key fields cannot be read-only" => "Primary Key fields cannot be read-only",
// "Column \"%0\" cannot co-exist with \"%1\"" => "Column \"%0\" cannot co-exist with \"%1\"",
// "Column \"%0:%1\" found multiple times" => "Column \"%0:%1\" found multiple times",
// "Primary key already defined" => "Primary key already defined",
// "Not enough columns, expecting \"%0\"" => "Not enough columns, expecting \"%0\"",
// "Header \"%0\" found where \"%1\" was expected" => "Header \"%0\" found where \"%1\" was expected",
// "Header \"%0\" found where ignored column was expected" => "Header \"%0\" found where ignored column was expected",
// "new tracker(s) item(s) created" => "new tracker(s) item(s) created",
// "tracker(s) item(s) updated" => "tracker(s) item(s) updated",
// "Line %0" => "Line %0",
// "duplicate entry" => "duplicate entry",
// "duplicate entry for unique column %0" => "duplicate entry for unique column %0",
// "Import file contains errors. Please review and fix before importing" => "Import file contains errors. Please review and fix before importing",
// "Primary Key not defined" => "Primary Key not defined",
// "Create page" => "Create page",
// "Plugin execution pending approval" => "Plugin execution pending approval",
// "Edit plugin" => "Edit plugin",
// "Wiki page pagination has not been enabled" => "Wiki page pagination has not been enabled",
// "Pretty tracker reference \"%0\" could not be replaced in plugin \"%1\"" => "Pretty tracker reference \"%0\" could not be replaced in plugin \"%1\"",
// "Internal error" => "Internal error",
// "User error" => "User error",
// "Plugin argument(s) missing" => "Plugin argument(s) missing",
// "Plugin <strong>%0</strong> cannot be executed" => "Plugin <strong>%0</strong> cannot be executed",
"Set" => "設定",
// "Plugin disabled" => "Plugin disabled",
// "Edit Plugin" => "Edit Plugin",
// "Unable to locate cryptphrase" => "Unable to locate cryptphrase",
// "Single Container" => "Single Container",
// "Classic Tiki (3 containers - header, middle, footer)" => "Classic Tiki (3 containers - header, middle, footer)",
// "Classic Bootstrap (fixed top navbar)" => "Classic Bootstrap (fixed top navbar)",
// "Line" => "Line",
// "Lines" => "Lines",
"WikiDiff::apply: line count mismatch: %s != %s" => "WikiDiff::apply: 行數不符: %s != %s",
"WikiDiff::_check: failed" => "WikiDiff::_check: 失敗",
"WikiDiff::_check: edit sequence is non-optimal" => "WikiDiff::_check: 編輯序列並非最佳",
"WikiDiff Okay: LCS = %s" => "WikiDiff Okay: LCS = %s",
// "Problem setting user for \"%0\"" => "Problem setting user for \"%0\"",
// "Problem setting group for \"%0\"" => "Problem setting group for \"%0\"",
// "Problem setting mode for \"%0\"" => "Problem setting mode for \"%0\"",
// "Upload was not successful for \"%0\"" => "Upload was not successful for \"%0\"",
// "Subgallery number to galleryId error: Too many subdirs (%0)</span>" => "Subgallery number to galleryId error: Too many subdirs (%0)</span>",
// "Subgallery number to galleryId error: Not an integer (%0)</span>" => "Subgallery number to galleryId error: Not an integer (%0)</span>",
// "Subgallery number to galleryId error: Gallery with ID %0 not found</span>" => "Subgallery number to galleryId error: Gallery with ID %0 not found</span>",
// "Created by batch upload by user \"%0\" on %1" => "Created by batch upload by user \"%0\" on %1",
// "Create gallery \"%0\" failed</span>" => "Create gallery \"%0\" failed</span>",
// "No permsission to create gallery \"%0\"</span>" => "No permsission to create gallery \"%0\"</span>",
// "Gallery \"%0\" not found</span>" => "Gallery \"%0\" not found</span>",
// "Upload was successful" => "Upload was successful",
// "File %s removed from Batch directory" => "File %s removed from Batch directory",
// "Impossible to remove file %s from Batch directory" => "Impossible to remove file %s from Batch directory",
// "Invalid directory name" => "Invalid directory name",
// "Move was not successful for \"%0\"" => "Move was not successful for \"%0\"",
// "Copy was not successful for \"%0\"" => "Copy was not successful for \"%0\"",
// "Move was successful" => "Move was successful",
// "Copy was successful" => "Copy was successful",
// "Cannot write to this path: " => "Cannot write to this path: ",
// "Cannot read this file: " => "Cannot read this file: ",
// "Cannot remove file from gallery" => "Cannot remove file from gallery",
// "Migrated Image Galleries" => "Migrated Image Galleries",
// "Converted from image gallery" => "Converted from image gallery",
"My Files" => "我的檔案",
// "Files of %0" => "Files of %0",
// "Cannot open this file" => "Cannot open this file",
// " copy" => " copy",
// "Processing search text from a \"%0\" file in gallery #%1" => "Processing search text from a \"%0\" file in gallery #%1",
// "User File Galleries" => "User File Galleries",
// "Wiki Attachment File Galleries" => "Wiki Attachment File Galleries",
"File Galleries" => "檔案總覽",
// "The upload was not completed" => "The upload was not completed",
// "Reason: The global quota has been reached" => "Reason: The global quota has been reached",
// "Reason: The quota has been reached in \"%s\"" => "Reason: The quota has been reached in \"%s\"",
// "File gallery quota exceeded" => "File gallery quota exceeded",
// "Number of files transferred to the database" => "Number of files transferred to the database",
// "Number of files transferred to the file system" => "Number of files transferred to the file system",
// "Old File deleted" => "Old File deleted",
// "Incorrect param" => "Incorrect param",
"You do not have permission to remove files from this gallery" => "權限不足, 你無法移除此檔案庫中的檔案",
// "Warning: The file is used in" => "Warning: The file is used in",
// "You are trying to edit multiple files in different galleries, which is not supported yet" => "You are trying to edit multiple files in different galleries, which is not supported yet",
// "The specified file does not exist" => "The specified file does not exist",
"Upload was not successful" => "上傳失敗",
// "An exception occurred" => "An exception occurred",
// "Batch file processed" => "Batch file processed",
"Errors detected" => "偵測到錯誤",
// "Check that these paths exist and are writable by the web server" => "Check that these paths exist and are writable by the web server",
// "File added: " => "File added: ",
// "Cannot read the file" => "Cannot read the file",
// "Warning: Empty file" => "Warning: Empty file",
// "Please re-upload the file" => "Please re-upload the file",
// "The upload was not successful due to duplicate file content" => "The upload was not successful due to duplicate file content",
// "Files uploaded" => "Files uploaded",
// "File \"%0\" uploaded" => "File \"%0\" uploaded",
// "File update was successful" => "File update was successful",
// "Automatic revision from source" => "Automatic revision from source",
// "Images successfully moved to file gallery %0" => "Images successfully moved to file gallery %0",
// "Images could not be opened or uploaded" => "Images could not be opened or uploaded",
// "No changes were made since no images in wiki_up were found in Wiki pages" => "No changes were made since no images in wiki_up were found in Wiki pages",
// "No images found" => "No images found",
// "%0 on page %1 could not be opened" => "%0 on page %1 could not be opened",
// "%0 on page %1 could not be uploaded into the file gallery" => "%0 on page %1 could not be uploaded into the file gallery",
// "%0 used on page %1 was moved and given the file ID %2" => "%0 used on page %1 was moved and given the file ID %2",
// "Forcing a filetype of image/svg+xml is blocked for security reasons" => "Forcing a filetype of image/svg+xml is blocked for security reasons",
// "SVG files are not safe and cannot be uploaded" => "SVG files are not safe and cannot be uploaded",
// "PHP Zip extension not found, reqiuired for Feature H5P" => "PHP Zip extension not found, reqiuired for Feature H5P",
// "PHP Class \"ZipArchive\" not found" => "PHP Class \"ZipArchive\" not found",
// "Missing content parameters" => "Missing content parameters",
// "Invalid content parameters" => "Invalid content parameters",
// "Missing title" => "Missing title",
// "Title is too long. Must be 256 letters or shorter" => "Title is too long. Must be 256 letters or shorter",
// "Invalid content type" => "Invalid content type",
// "Created by H5P" => "Created by H5P",
// "The chosen content type isn't installed" => "The chosen content type isn't installed",
// "This is an approximation based on your server memory limit" => "This is an approximation based on your server memory limit",
// "This is the value of your server's PHP '%s' setting" => "This is the value of your server's PHP '%s' setting",
// "Not a git repository" => "Not a git repository",
// "Branch \"%s\" not found" => "Branch \"%s\" not found",
// "Can't get Git object file" => "Can't get Git object file",
// "Goal achieved" => "Goal achieved",
// "Event Count" => "Event Count",
// "Event Count (Forever)" => "Event Count (Forever)",
// "Goal Reached (Periodic)" => "Goal Reached (Periodic)",
// "Goal Reached (Forever)" => "Goal Reached (Forever)",
// "Has Badge" => "Has Badge",
// "Add One-Time Badge" => "Add One-Time Badge",
// "%0 Badge" => "%0 Badge",
// "Remove One-Time Badge" => "Remove One-Time Badge",
// "%0 Badge (Remove)" => "%0 Badge (Remove)",
// "Credits" => "Credits",
// "%0 credit(s) - %1" => "%0 credit(s) - %1",
// "Unknown credit type" => "Unknown credit type",
// "You are alerted by the server " => "You are alerted by the server ",
// "You can check the modifications at: " => "You can check the modifications at: ",
// "You are alerted of a change on " => "You are alerted of a change on ",
// "JavaScript file \"%0\" cannot be found so will not be minified" => "JavaScript file \"%0\" cannot be found so will not be minified",
"No image yet, sorry." => "尚無影像, 抱歉.",
// "unknown destination directory. Please set it up in <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a>" => "unknown destination directory. Please set it up in <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a>",
// "unlink failed" => "unlink failed",
// "The uploaded file exceeds the upload_max_filesize directive in php.ini" => "The uploaded file exceeds the upload_max_filesize directive in php.ini",
// "The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form" => "The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form",
// "The uploaded file was only partially uploaded. Please try again" => "The uploaded file was only partially uploaded. Please try again",
// "No file was uploaded" => "No file was uploaded",
// "Missing a temporary folder" => "Missing a temporary folder",
// "Failed to write file to disk" => "Failed to write file to disk",
// "File upload stopped by extension" => "File upload stopped by extension",
// "Set new blog as Tiki homepage" => "Set new blog as Tiki homepage",
// "Importation completed" => "Importation completed",
// "<a href=\"tiki-importer.php\">Click here</a> to finish the import process" => "<a href=\"tiki-importer.php\">Click here</a> to finish the import process",
// "Found %0 posts, %1 pages, %2 tags and %3 categories. Inserting them into Tiki" => "Found %0 posts, %1 pages, %2 tags and %3 categories. Inserting them into Tiki",
// "Item \"%0\" NOT imported (there was already a item with the same name)" => "Item \"%0\" NOT imported (there was already a item with the same name)",
// "Page \"%0\" sucessfully imported" => "Page \"%0\" sucessfully imported",
// "Post \"%0\" sucessfully imported" => "Post \"%0\" sucessfully imported",
// "Import images and other attachments" => "Import images and other attachments",
// "Update internal links (experimental)" => "Update internal links (experimental)",
// "Suggest .htaccess rules to redirect from old WordPress URLs to new Tiki URLs (experimental)" => "Suggest .htaccess rules to redirect from old WordPress URLs to new Tiki URLs (experimental)",
// "Class DOMDocument not available, check your PHP installation. For more information see http://php.net/manual/en/book.dom.php" => "Class DOMDocument not available, check your PHP installation. For more information see http://php.net/manual/en/book.dom.php",
// "Invalid file MIME type" => "Invalid file MIME type",
// "There was an error while loading the XML file. Probably the XML file is malformed. Some versions of WordPress generate a malformed XML file. See the Tiki Importer documentation for more information" => "There was an error while loading the XML file. Probably the XML file is malformed. Some versions of WordPress generate a malformed XML file. See the Tiki Importer documentation for more information",
// "Invalid WordPress XML file" => "Invalid WordPress XML file",
// "No attachments found to import" => "No attachments found to import",
// "Importing attachments" => "Importing attachments",
// "Attachment %0 successfully imported" => "Attachment %0 successfully imported",
// "Unable to download attachment %0. Error message was: %1 %2" => "Unable to download attachment %0. Error message was: %1 %2",
// "%0 attachments imported and %1 errors" => "%0 attachments imported and %1 errors",
// "Page \"%0\" successfully extracted" => "Page \"%0\" successfully extracted",
// "Post \"%0\" successfully extracted" => "Post \"%0\" successfully extracted",
// "Extracting data from XML file" => "Extracting data from XML file",
// "Number of page revisions to import (0 for all revisions)" => "Number of page revisions to import (0 for all revisions)",
// "What to do with page names that already exists in Tiki" => "What to do with page names that already exists in Tiki",
// "Do not import" => "Do not import",
// "Override" => "Override",
// "Prepend software name as a prefix to the page name" => "Prepend software name as a prefix to the page name",
// "Page %0 sucessfully imported" => "Page %0 sucessfully imported",
// "Page %0 NOT imported (there was already a page with the same name)" => "Page %0 NOT imported (there was already a page with the same name)",
// "%0 pages parsed. Starting to insert those pages into Tiki" => "%0 pages parsed. Starting to insert those pages into Tiki",
// "Import images and attachments (see documentation for more information)" => "Import images and attachments (see documentation for more information)",
// "Add a maketoc at the top of each page" => "Add a maketoc at the top of each page",
// "The XML file does not validate against the MediaWiki XML schema" => "The XML file does not validate against the MediaWiki XML schema",
// "Aborting: the destination directory for attachments (%0) does not exist. Correct this problem or try to import without the attachments" => "Aborting: the destination directory for attachments (%0) does not exist. Correct this problem or try to import without the attachments",
// "Aborting: the destination directory for attachments (%0) is not writable. Correct this problem or try to import without attachments" => "Aborting: the destination directory for attachments (%0) is not writable. Correct this problem or try to import without attachments",
// "File %0 is not being imported because there is already a file with the same name in the destination directory (%1)" => "File %0 is not being imported because there is already a file with the same name in the destination directory (%1)",
// "File %0 successfully imported" => "File %0 successfully imported",
// "Unable to download file %0. File not found" => "Unable to download file %0. File not found",
// "Error while parsing revision %0 of the page \"%1\". There could be a problem in the page syntax or in the Text_Wiki parser used by the importer" => "Error while parsing revision %0 of the page \"%1\". There could be a problem in the page syntax or in the Text_Wiki parser used by the importer",
// "Page \"%0\" successfully parsed with %1 revisions (from a total of %2 revisions)" => "Page \"%0\" successfully parsed with %1 revisions (from a total of %2 revisions)",
// "Page \"%0\" is NOT going to be imported. It was not possible to parse any of the page revisions" => "Page \"%0\" is NOT going to be imported. It was not possible to parse any of the page revisions",
// "MediaWiki XML file version %0 is not supported" => "MediaWiki XML file version %0 is not supported",
// "Aborting: you need to enable the PHP setting 'allow_url_fopen' to be able to import attachments. Fix the problem or try to import without the attachments" => "Aborting: you need to enable the PHP setting 'allow_url_fopen' to be able to import attachments. Fix the problem or try to import without the attachments",
// "Parsing pages" => "Parsing pages",
// "No attachments were found to import. Be sure to create the XML file with the dumpDump.php script and with the option --uploads. This is the only way to import attachments" => "No attachments were found to import. Be sure to create the XML file with the dumpDump.php script and with the option --uploads. This is the only way to import attachments",
// "Invalid template name: %0" => "Invalid template name: %0",
// "Unnamed file" => "Unnamed file",
// "string" => "string",
// "Unknown language" => "Unknown language",
// "Error: unable to write to lang/%s/language.php" => "Error: unable to write to lang/%s/language.php",
// "The file lang/%0/language.php is not correctly formatted. Run get_strings.php?lang=%0 and then try to export the translations again" => "The file lang/%0/language.php is not correctly formatted. Run get_strings.php?lang=%0 and then try to export the translations again",
// "Contributions" => "Contributions",
// "reverted" => "reverted",
// "section level 0" => "section level 0",
// "sorted section level 0" => "sorted section level 0",
// "section level 1" => "section level 1",
// "section level 2" => "section level 2",
// "section level 3" => "section level 3",
"option" => "選項",
// "separator" => "separator",
// "You can only use optionId = 0 to create a new option; or, to update a menu, use an optionId that is the same as an optionId that is already used in the menu" => "You can only use optionId = 0 to create a new option; or, to update a menu, use an optionId that is the same as an optionId that is already used in the menu",
// "menu" => "menu",
"NONE" => "無",
// "(values not interpreted)" => "(values not interpreted)",
// "Unknown Field: " => "Unknown Field: ",
// "duplicate fields do not match" => "duplicate fields do not match",
// "Description not available" => "Description not available",
// "Module Title" => "Module Title",
// "Title to display at the top of the box" => "Title to display at the top of the box",
// "No Box" => "No Box",
// "Show only the content" => "Show only the content",
// "Title, background, etcs" => "Title, background, etcs",
// "Show module decorations" => "Show module decorations",
// "No Title" => "No Title",
// "Hide module title" => "Hide module title",
// "Module displayed depending on category. Separate multiple category IDs or names by semi-colons" => "Module displayed depending on category. Separate multiple category IDs or names by semi-colons",
// "No Category" => "No Category",
// "Module is hidden depending on category. Separate multiple category IDs or names by semi-colons. This takes precedence over the category parameter above" => "Module is hidden depending on category. Separate multiple category IDs or names by semi-colons. This takes precedence over the category parameter above",
// "Category subtrees" => "Category subtrees",
// "Consider child categories of the categories listed in \"category\" and \"no category\" to be part of those categories. (0 or 1)" => "Consider child categories of the categories listed in \"category\" and \"no category\" to be part of those categories. (0 or 1)",
// "Perspective" => "Perspective",
// "Module is displayed only in the listed perspective ID(s). Separate multiple perspective IDs by semi-colons" => "Module is displayed only in the listed perspective ID(s). Separate multiple perspective IDs by semi-colons",
// "Module is displayed only when the specified language(s) in use. Designate languages by two-character language codes. Separate multiple languages by semi-colons" => "Module is displayed only when the specified language(s) in use. Designate languages by two-character language codes. Separate multiple languages by semi-colons",
"Section" => "區段",
// "Module is displayed only in the specified sections. Separate multiple sections by semi-colons. Choose from: blogs; calendar; categories; cms (for \"articles\"); contacts; directory; faqs; featured_links; file_galleries; forums; galleries (for \"image galleries\"); gmaps; html_pages; maps; mytiki; newsletters; poll; quizzes; surveys; trackers; user_messages; webmail; wiki page" => "Module is displayed only in the specified sections. Separate multiple sections by semi-colons. Choose from: blogs; calendar; categories; cms (for \"articles\"); contacts; directory; faqs; featured_links; file_galleries; forums; galleries (for \"image galleries\"); gmaps; html_pages; maps; mytiki; newsletters; poll; quizzes; surveys; trackers; user_messages; webmail; wiki page",
// "Page Filter" => "Page Filter",
// "Module is displayed only on the specified page(s). Separate multiple page names by semi-colons" => "Module is displayed only on the specified page(s). Separate multiple page names by semi-colons",
// "No Page" => "No Page",
// "Module is not displayed on the specified page(s). Separate multiple page names by semi-colons" => "Module is not displayed on the specified page(s). Separate multiple page names by semi-colons",
"Theme" => "佈景主題",
// "Module is displayed or not displayed depending on the theme. (Enter the theme's file name, for example, \"thenews.css\".) Prefix the theme name with \"!\" for the module to not display. Separate multiple theme names by semi-colons" => "Module is displayed or not displayed depending on the theme. (Enter the theme's file name, for example, \"thenews.css\".) Prefix the theme name with \"!\" for the module to not display. Separate multiple theme names by semi-colons",
// "Module only available based on the relationship of the user with the wiki page. Either only creators (y) or only non-creators (n) will see the module" => "Module only available based on the relationship of the user with the wiki page. Either only creators (y) or only non-creators (n) will see the module",
// "Contributor" => "Contributor",
// "Module only available based on the relationship of the user with the wiki page. Either only contributors (y) or only non-contributors (n) will see the module" => "Module only available based on the relationship of the user with the wiki page. Either only contributors (y) or only non-contributors (n) will see the module",
// "Flip" => "Flip",
// "Users can open and close the module" => "Users can open and close the module",
// "Style" => "Style",
// "CSS style attribute (for example, to position the module)" => "CSS style attribute (for example, to position the module)",
// "Class" => "Class",
// "Extra class (for CSS or JavaScript)" => "Extra class (for CSS or JavaScript)",
// "Containing Class" => "Containing Class",
// "Custom CSS class of div around the module" => "Custom CSS class of div around the module",
// "Cookie Consent" => "Cookie Consent",
// "Show only if consent to accept cookies has been granted" => "Show only if consent to accept cookies has been granted",
// "No Numbers" => "No Numbers",
// "If set to \"y\", the module will not number list items" => "If set to \"y\", the module will not number list items",
"Rows" => "列",
// "Number of rows, or items, to display" => "Number of rows, or items, to display",
// "Default: 10" => "Default: 10",
// "Failed to execute \"%0\" module" => "Failed to execute \"%0\" module",
// "Missing dependencies" => "Missing dependencies",
// "Contact the system administrator" => "Contact the system administrator",
// "Module file \"%0\" not found" => "Module file \"%0\" not found",
// "Newsletter subscription information at" => "Newsletter subscription information at",
// "Cannot add subscribers from a newsletter that includes this newsletter's subscribers" => "Cannot add subscribers from a newsletter that includes this newsletter's subscribers",
// " after sending to" => " after sending to",
// " after error in sending to" => " after error in sending to",
// " after failure to send to" => " after failure to send to",
// "Error - potential cross site request forgery detected" => "Error - potential cross site request forgery detected",
// "Potential cross site forgery request detected" => "Potential cross site forgery request detected",
// "Limiting the email send rate. Resuming in %0 seconds" => "Limiting the email send rate. Resuming in %0 seconds",
// "Newsletter successfully sent to %s users" => "Newsletter successfully sent to %s users",
// "Number of errors: %s" => "Number of errors: %s",
// "End of last article" => "End of last article",
// "potential CSRF" => "potential CSRF",
// "invalid email" => "invalid email",
"A user registers" => "有使用者註冊",
"A user submits an article" => "有使用者發送文章",
// "A user edits an article" => "A user edits an article",
// "A user deletes an article" => "A user deletes an article",
// "An article is submitted, edited, deleted or commented on" => "An article is submitted, edited, deleted or commented on",
// "A new blog post is published" => "A new blog post is published",
// "A blog post comment is posted or edited" => "A blog post comment is posted or edited",
// "A wiki page is created, deleted or edited, except for minor changes" => "A wiki page is created, deleted or edited, except for minor changes",
// "A wiki page is created, deleted or edited, even for minor changes" => "A wiki page is created, deleted or edited, even for minor changes",
// "A wiki page comment is posted or edited" => "A wiki page comment is posted or edited",
// "An article comment is posted or edited" => "An article comment is posted or edited",
// "Token is called" => "Token is called",
// "User joins a group" => "User joins a group",
// "User's comment is replied" => "User's comment is replied",
// "Category change in a language" => "Category change in a language",
// "A new page is created in a language" => "A new page is created in a language",
// "Cannot save invalid client" => "Cannot save invalid client",
// "Name cannot be empty" => "Name cannot be empty",
// "Redirect URI cannot be empty" => "Redirect URI cannot be empty",
// "Invalid URL for redirect URI" => "Invalid URL for redirect URI",
// "section edit" => "section edit",
// "Engine \"%0\" not found" => "Engine \"%0\" not found",
// "Output converter \"%0\" not found" => "Output converter \"%0\" not found",
// "Parsed Data" => "Parsed Data",
"Data" => "資料",
// "Mapping" => "Mapping",
// "Edit Section" => "Edit Section",
// "index" => "index",
// "Table of contents" => "Table of contents",
// "Show/Hide" => "Show/Hide",
// "Processing page: %0, is_html: %1" => "Processing page: %0, is_html: %1",
// "Payment was sent but verification is not currently available (this feature is a work in progress)" => "Payment was sent but verification is not currently available (this feature is a work in progress)",
// "Cart: Product code mismatch" => "Cart: Product code mismatch",
// "Cart: Product exchange mismatch" => "Cart: Product exchange mismatch",
// "Invalid gift certificate: %0" => "Invalid gift certificate: %0",
// "Please enter your shopper information first" => "Please enter your shopper information first",
// "No email found for gift certificate recipient" => "No email found for gift certificate recipient",
// "Gift card is not valid for products in cart" => "Gift card is not valid for products in cart",
"for" => "表示",
// "Bundled Product" => "Bundled Product",
// "Product" => "Product",
// "Quantity" => "Quantity",
// "Unit Price" => "Unit Price",
// "There is insufficient inventory to meet your request" => "There is insufficient inventory to meet your request",
// "Advanced Shopping Cart setup error: Orders profile missing" => "Advanced Shopping Cart setup error: Orders profile missing",
// "Gift Certificate: " => "Gift Certificate: ",
// "Gift Certificate Amount Used: " => "Gift Certificate Amount Used: ",
// "No registries specified in admin/payment/cclite" => "No registries specified in admin/payment/cclite",
// "Cclite payment initiated on %0" => "Cclite payment initiated on %0",
// "Connection to Cclite server %0 failed for %1<br />\"%2\"" => "Connection to Cclite server %0 failed for %1<br />\"%2\"",
// "Tiki credits payment done on %0 for %1 (using %2)" => "Tiki credits payment done on %0 for %1 (using %2)",
// "PDF webkit path \"%0\" not found" => "PDF webkit path \"%0\" not found",
// "The PDF webkit path has not been set" => "The PDF webkit path has not been set",
// "PDF WeasyPrint path \"%0\" not found" => "PDF WeasyPrint path \"%0\" not found",
// "The PDF WeasyPrint path has not been set" => "The PDF WeasyPrint path has not been set",
// "PDF webservice URL \"%0\" not found" => "PDF webservice URL \"%0\" not found",
// "The PDF webservice URL has not been set" => "The PDF webservice URL has not been set",
// "The package mPDF is not installed. You can install it using packages" => "The package mPDF is not installed. You can install it using packages",
// "PDF generation failed" => "PDF generation failed",
// "This is set by the administrator (search for \"print\" in the control panels to locate the setting)" => "This is set by the administrator (search for \"print\" in the control panels to locate the setting)",
// "Required function shell_exec is not enabled" => "Required function shell_exec is not enabled",
// "No category jail set in any perspective" => "No category jail set in any perspective",
// "Areas root category ID" => "Areas root category ID",
// "is invalid" => "is invalid",
// "Access-Control-Allow-Origin" => "Access-Control-Allow-Origin",
// "Domains allowed to make \"CORS\" (Cross-Origin Resource Sharing or Cross-Domain Ajax) requests from this server" => "Domains allowed to make \"CORS\" (Cross-Origin Resource Sharing or Cross-Domain Ajax) requests from this server",
// "One URI per line, for example, \"http://www.example.com\" or \"*\" for any site" => "One URI per line, for example, \"http://www.example.com\" or \"*\" for any site",
// "Record basic events" => "Record basic events",
// "Enable recording of basic internal Tiki events. This is primarily for entry level options. Using custom events is strongly encouraged" => "Enable recording of basic internal Tiki events. This is primarily for entry level options. Using custom events is strongly encouraged",
// "Record tracker item update" => "Record tracker item update",
// "Enable recording of basic internal Tiki events" => "Enable recording of basic internal Tiki events",
// "Record tracker item creation" => "Record tracker item creation",
// "Record user following users" => "Record user following users",
// "Record user being followed by users" => "Record user being followed by users",
// "Record user adding new friend" => "Record user adding new friend",
// "Custom activities" => "Custom activities",
// "Allow the defining of custom behaviors in addition to internal events" => "Allow the defining of custom behaviors in addition to internal events",
// "Enable notifications through activities" => "Enable notifications through activities",
// "Allow users to create notifications using activities" => "Allow users to create notifications using activities",
// "Ajax auto-save" => "Ajax auto-save",
// "Save content during editing, enabling work to be recovered after any interruption. Also enable a real-time preview. This option is required for WYSIWYG plugin processing" => "Save content during editing, enabling work to be recovered after any interruption. Also enable a real-time preview. This option is required for WYSIWYG plugin processing",
// "Inline editing" => "Inline editing",
// "Enable inline editing of certain values. Currently limited to tracker item fields" => "Enable inline editing of certain values. Currently limited to tracker item fields",
// "Tracker list inline editing" => "Tracker list inline editing",
// "Enable inline editing of all fields on the tracker list page" => "Enable inline editing of all fields on the tracker list page",
// "ffmpeg path" => "ffmpeg path",
// "Path to the location of the ffmpeg binary" => "Path to the location of the ffmpeg binary",
// "ffprobe path" => "ffprobe path",
// "Path to the location of the ffprobe binary" => "Path to the location of the ffprobe binary",
// "Alchemy Image library" => "Alchemy Image library",
// "Select either Image Magick or GD Graphics Library" => "Select either Image Magick or GD Graphics Library",
// "Imagemagick" => "Imagemagick",
// "GD" => "GD",
// "unoconv path" => "unoconv path",
// "Path to the location of the unoconv binary" => "Path to the location of the unoconv binary",
// "ghostscript path" => "ghostscript path",
// "Path to the location of the ghostscript binary" => "Path to the location of the ghostscript binary",
// " (Extension not loaded)" => " (Extension not loaded)",
// "Search index rebuild" => "Search index rebuild",
// "Tracker item export" => "Tracker item export",
// "Tracker clear" => "Tracker clear",
// "Printing to PDF" => "Printing to PDF",
// "PHP execution" => "PHP execution",
// "for example 256M, currently is %0" => "for example 256M, currently is %0",
// "for example 30 seconds, currently is %0 seconds" => "for example 30 seconds, currently is %0 seconds",
// "%0 memory limit" => "%0 memory limit",
// "Temporarily adjust the memory limit to use during %0. Depending on the volume of data, some large operations require more memory. Increasing it locally, per operation, allows to keep a lower memory limit globally. Keep in mind that memory usage is still limited to what is available on the server" => "Temporarily adjust the memory limit to use during %0. Depending on the volume of data, some large operations require more memory. Increasing it locally, per operation, allows to keep a lower memory limit globally. Keep in mind that memory usage is still limited to what is available on the server",
// "for example: 256M" => "for example: 256M",
// "%0 time limit" => "%0 time limit",
// "Temporarily adjust the time limit to use during %0. Depending on the volume of data, some requests may take longer. Increase the time limit locally to resolve the issue. Use reasonable values" => "Temporarily adjust the time limit to use during %0. Depending on the volume of data, some requests may take longer. Increase the time limit locally to resolve the issue. Use reasonable values",
"seconds" => "秒",
// "Users accept internal messages by default" => "Users accept internal messages by default",
// "Users can opt out of internal messages" => "Users can opt out of internal messages",
// "ID of category whose child categories are bound to a perspective by areas" => "ID of category whose child categories are bound to a perspective by areas",
// "Newest first" => "Newest first",
// "ascending" => "ascending",
// "descending" => "descending",
// "Article order" => "Article order",
// "Default sort mode for the articles on the list-articles page" => "Default sort mode for the articles on the list-articles page",
// "Title of articles homepage" => "Title of articles homepage",
// "Select the default title for the page that displays all articles" => "Select the default title for the page that displays all articles",
"Title" => "標題",
// "Title length" => "Title length",
// "characters" => "characters",
// "Publication date" => "Publication date",
// "Visible" => "Visible",
// "Author (owner)" => "Author (owner)",
// "Author name (as displayed)" => "Author name (as displayed)",
// "Author rating" => "Author rating",
// "Users rating" => "Users rating",
"Reads" => "閱讀",
// "Is published" => "Is published",
// "Trailer position" => "Trailer position",
// "Between heading and body" => "Between heading and body",
// "Header text position" => "Header text position",
// "Requires a smaller image for list view" => "Requires a smaller image for list view",
// "Next to image" => "Next to image",
// "Below image" => "Below image",
// "Oldest first" => "Oldest first",
"Points" => "分數",
// "Number per page" => "Number per page",
// "Set the number of comments per page" => "Set the number of comments per page",
"comments" => "評論",
// "Display order" => "Display order",
// "Set the display order of comments" => "Set the display order of comments",
// "Paginate articles" => "Paginate articles",
// "Divide articles into multiple pages with pagebreak markers" => "Divide articles into multiple pages with pagebreak markers",
// "Article creator remains article owner" => "Article creator remains article owner",
// "Last article editor does not automatically become author (owner)" => "Last article editor does not automatically become author (owner)",
// "User ratings on articles" => "User ratings on articles",
// "Allow users to rate articles" => "Allow users to rate articles",
// "Permissions involved: %0. Also, when configuring articles, \"Admin Types > Comment can rate article\" needs to be set" => "Permissions involved: %0. Also, when configuring articles, \"Admin Types > Comment can rate article\" needs to be set",
// "Article rating options" => "Article rating options",
// "List of options available for the rating of articles" => "List of options available for the rating of articles",
// "Default maximum width for custom article images" => "Default maximum width for custom article images",
// "Set the default maximum width of the article image" => "Set the default maximum width of the article image",
// "pixels" => "pixels",
// "\"0\" for no maximum" => "\"0\" for no maximum",
// "Default maximum height for custom article images" => "Default maximum height for custom article images",
// "Set the default maximum height of article images" => "Set the default maximum height of article images",
// "Default maximum width for custom article images in list mode (on View Articles)" => "Default maximum width for custom article images in list mode (on View Articles)",
// "Sets the default maximum width of custom article images in list mode (on View Articles page)" => "Sets the default maximum width of custom article images in list mode (on View Articles page)",
// "\"0\" to default to the view mode maximum" => "\"0\" to default to the view mode maximum",
// "Default maximum height of custom article images in list mode (on View Articles page)" => "Default maximum height of custom article images in list mode (on View Articles page)",
// "Set the default maximum height of custom article images in list mode (on the View Articles page)" => "Set the default maximum height of custom article images in list mode (on the View Articles page)",
// "Article image maximum file size" => "Article image maximum file size",
// "Maximum file size for an article image. Article images are stored in the database so it should remain low" => "Maximum file size for an article image. Article images are stored in the database so it should remain low",
// "kilobytes" => "kilobytes",
// "Custom attributes for article types" => "Custom attributes for article types",
// "Enable additional custom fields for article types" => "Enable additional custom fields for article types",
// "Your ShareThis publisher identifier (optional)" => "Your ShareThis publisher identifier (optional)",
// "Set to define your ShareThis publisher identifier" => "Set to define your ShareThis publisher identifier",
// "record your ShareThis publisher ID" => "record your ShareThis publisher ID",
// "Related articles" => "Related articles",
// "Display a list of related articles at the bottom of an article page" => "Display a list of related articles at the bottom of an article page",
// "Use new articles" => "Use new articles",
// "Use the new CustomSearch-based article lists rather than database information" => "Use the new CustomSearch-based article lists rather than database information",
// "Article copyright" => "Article copyright",
// "Apply copyright management preferences to this feature" => "Apply copyright management preferences to this feature",
"Authentication method" => "認證方式",
// "Tiki supports several authentication methods. The default method is to use the internal user database" => "Tiki supports several authentication methods. The default method is to use the internal user database",
// "Tiki" => "Tiki",
// "Tiki and OpenID" => "Tiki and OpenID",
// "Tiki and PAM" => "Tiki and PAM",
// "Tiki and LDAP" => "Tiki and LDAP",
// "CAS (Central Authentication Service)" => "CAS (Central Authentication Service)",
// "SAML" => "SAML",
// "Shibboleth" => "Shibboleth",
"Web Server" => "網站伺服器",
// "phpBB" => "phpBB",
// "Token access" => "Token access",
// "With the presentation of a token, allow access to the content with elevated rights. The primary use of this authentication method is to grant temporary access to content to an external service" => "With the presentation of a token, allow access to the content with elevated rights. The primary use of this authentication method is to grant temporary access to content to an external service",
// "Token access default timeout" => "Token access default timeout",
// "The default duration for which the generated tokens will be valid" => "The default duration for which the generated tokens will be valid",
// "Token access default maximum hits" => "Token access default maximum hits",
// "The default maximum number of times a token can be used before it expires" => "The default maximum number of times a token can be used before it expires",
// "hits" => "hits",
// "Share access rights with friends when using Tell a friend" => "Share access rights with friends when using Tell a friend",
// "Allow users to share their access rights for the current page with a friend when sending the link by email. The lifespan of the link is defined by the site" => "Allow users to share their access rights for the current page with a friend when sending the link by email. The lifespan of the link is defined by the site",
// "Do not delete temporary users when token is deleted/expired" => "Do not delete temporary users when token is deleted/expired",
// "Normally temporary users created (see tiki-adminusers.php) are deleted when their access token is deleted/expired. If turned on, this will keep those users around (and can be manually deleted later) but they will have no groups and therefore no perms" => "Normally temporary users created (see tiki-adminusers.php) are deleted when their access token is deleted/expired. If turned on, this will keep those users around (and can be manually deleted later) but they will have no groups and therefore no perms",
// "Share access rights with friends when using Share" => "Share access rights with friends when using Share",
// "Allow users to share their access rights for the current page with a friend when sending the link by email, Twitter, or Facebook. The lifespan of the link is defined by the site" => "Allow users to share their access rights for the current page with a friend when sending the link by email, Twitter, or Facebook. The lifespan of the link is defined by the site",
// "Create user if not registered in Tiki" => "Create user if not registered in Tiki",
// "Automatically create a new Tiki user for the PHPbb login" => "Automatically create a new Tiki user for the PHPbb login",
// "Use Tiki authentication for Admin log-in" => "Use Tiki authentication for Admin log-in",
// "The user “admin” will be authenticated by <b>only</b> using Tiki’s user database. This option has no effect on users other than “admin”" => "The user “admin” will be authenticated by <b>only</b> using Tiki’s user database. This option has no effect on users other than “admin”",
// "Disable Tiki users who don’t have a phpBB login as they could have been deleted" => "Disable Tiki users who don’t have a phpBB login as they could have been deleted",
// "phpBB Version" => "phpBB Version",
"3" => "3",
// "phpBB Database Hostname" => "phpBB Database Hostname",
// "phpBB Database Username" => "phpBB Database Username",
// "phpBB Database Password" => "phpBB Database Password",
// "phpBB Database Name" => "phpBB Database Name",
// "phpBB Table Prefix" => "phpBB Table Prefix",
// "Use Tiki authentication for users created in Tiki" => "Use Tiki authentication for users created in Tiki",
// "If this option is set, users that are created using Tiki are not authenticated via LDAP. This can be useful to let external users (ex.: partners or consultants) access Tiki, without being in your main user list in LDAP" => "If this option is set, users that are created using Tiki are not authenticated via LDAP. This can be useful to let external users (ex.: partners or consultants) access Tiki, without being in your main user list in LDAP",
// "Host" => "Host",
// "The hostnames, ip addresses or URIs of your LDAP servers. Separate multiple entries with Whitespace or ‘,’. If you use URIs, then the settings for Port number and SSL are ignored. Example: “localhost ldaps://master.ldap.example.org:63636” will try to connect to localhost unencrypted and if if fails it will try the master LDAP server at a special port with SSL" => "The hostnames, ip addresses or URIs of your LDAP servers. Separate multiple entries with Whitespace or ‘,’. If you use URIs, then the settings for Port number and SSL are ignored. Example: “localhost ldaps://master.ldap.example.org:63636” will try to connect to localhost unencrypted and if if fails it will try the master LDAP server at a special port with SSL",
"Port" => "埠",
// "The port number your LDAP server uses (389 is the default, 636 if you check SSL)" => "The port number your LDAP server uses (389 is the default, 636 if you check SSL)",
// "Write LDAP debug Information in Tiki Logs" => "Write LDAP debug Information in Tiki Logs",
// "Write debug information to Tiki logs (Admin -> Tiki Logs, Tiki Logs have to be enabled)" => "Write debug information to Tiki logs (Admin -> Tiki Logs, Tiki Logs have to be enabled)",
// "Do not enable this option for production sites" => "Do not enable this option for production sites",
// "Use SSL (ldaps)" => "Use SSL (ldaps)",
// "Use TLS" => "Use TLS",
// "LDAP Bind Type" => "LDAP Bind Type",
// "<ul><li><b>Active Directory bind</b> will build a RDN like username@example.com where your basedn is (dc=example, dc=com) and username is your username</li><li><b>Plain bind</b> will build a RDN username</li><li><b>Full bind</b> will build a RDN like userattr=username, userdn, basedn where userattr is replaced with the value you put in ‘User attribute’, userdn with the value you put in ‘User DN’, basedn with the value with the value you put in ‘base DN’</li><li><b>OpenLDAP bind</b> will build a RDN like cn=username, basedn</li><li><b>Anonymous bind</b> will build an empty RDN</li></ul>" => "<ul><li><b>Active Directory bind</b> will build a RDN like username@example.com where your basedn is (dc=example, dc=com) and username is your username</li><li><b>Plain bind</b> will build a RDN username</li><li><b>Full bind</b> will build a RDN like userattr=username, userdn, basedn where userattr is replaced with the value you put in ‘User attribute’, userdn with the value you put in ‘User DN’, basedn with the value with the value you put in ‘base DN’</li><li><b>OpenLDAP bind</b> will build a RDN like cn=username, basedn</li><li><b>Anonymous bind</b> will build an empty RDN</li></ul>",
// "Default: Anonymous Bind" => "Default: Anonymous Bind",
// "Full: userattr=username,UserDN,BaseDN" => "Full: userattr=username,UserDN,BaseDN",
// "OpenLDAP: cn=username,BaseDN" => "OpenLDAP: cn=username,BaseDN",
// "Active Directory (username@domain)" => "Active Directory (username@domain)",
// "Plain Username" => "Plain Username",
// "Search scope" => "Search scope",
// "Used after authentication for getting user and group information" => "Used after authentication for getting user and group information",
// "Subtree" => "Subtree",
// "One level" => "One level",
// "Base object" => "Base object",
// "Base DN" => "Base DN",
// "User DN" => "User DN",
// "User attribute" => "User attribute",
// "User OC" => "User OC",
// "Realname attribute" => "Realname attribute",
// "Synchronize Tiki user attributes with the LDAP values" => "Synchronize Tiki user attributes with the LDAP values",
// "Country attribute" => "Country attribute",
// "Email attribute" => "Email attribute",
// "Group DN" => "Group DN",
// "Group name attribute" => "Group name attribute",
// "Group description attribute" => "Group description attribute",
// "Group OC" => "Group OC",
// "Member attribute" => "Member attribute",
// "Member is DN" => "Member is DN",
// "Group attribute" => "Group attribute",
// "Group attribute in group entry" => "Group attribute in group entry",
// "(Leave this empty if the group name is already given in the user attribute)" => "(Leave this empty if the group name is already given in the user attribute)",
// "Admin user" => "Admin user",
// "Admin password" => "Admin password",
// "Use an external LDAP server for groups" => "Use an external LDAP server for groups",
// "Anonymous Bind" => "Anonymous Bind",
// "Corresponding user attribute in 1st directory" => "Corresponding user attribute in 1st directory",
// "If a user was externally authenticated, but not found in the Tiki user database, Tiki will create an entry in its user database" => "If a user was externally authenticated, but not found in the Tiki user database, Tiki will create an entry in its user database",
// "Disable Tiki users with no phpBB login" => "Disable Tiki users with no phpBB login",
// "Default Bootstrap" => "Default Bootstrap",
// "Available languages" => "Available languages",
// "By default, all languages supported by Tiki are available on multilingual sites. This option allows limiting the languages to a subset" => "By default, all languages supported by Tiki are available on multilingual sites. This option allows limiting the languages to a subset",
// "Available themes" => "Available themes",
// "Restrict available themes" => "Restrict available themes",
// "BigBlueButton web conferencing" => "BigBlueButton web conferencing",
// "Integration with the BigBlueButton collaboration server for web conference and screen sharing" => "Integration with the BigBlueButton collaboration server for web conference and screen sharing",
// "BigBlueButton server location" => "BigBlueButton server location",
// "Full URL to the BigBlueButton installation" => "Full URL to the BigBlueButton installation",
// "http://host.example.com/" => "http://host.example.com/",
// "BigBlueButton server salt" => "BigBlueButton server salt",
// "A salt key used to generate checksums for the BigBlueButton server to assure that requests are authentic" => "A salt key used to generate checksums for the BigBlueButton server to assure that requests are authentic",
// "BigBlueButton recording maximum duration" => "BigBlueButton recording maximum duration",
// "A maximum duration for the meetings must be submitted to BigBlueButton to prevent the recordings from being excessively long if a user leaves the conference window open" => "A maximum duration for the meetings must be submitted to BigBlueButton to prevent the recordings from being excessively long if a user leaves the conference window open",
"minutes" => "分",
// "BigBlueButton dynamic configuration" => "BigBlueButton dynamic configuration",
// "Uses the advanced options of BigBlueButton to configure the XML per room" => "Uses the advanced options of BigBlueButton to configure the XML per room",
// "Default ordering" => "Default ordering",
// "Default order" => "Default order",
"Creation Date (desc)" => "建立日期 (降冪)",
"Last modification date (desc)" => "最近修改日期 (降冪)",
"Blog title (asc)" => "Blog 標題 (升冪)",
"Number of posts (desc)" => "佈告數 (降冪)",
"Visits (desc)" => "拜訪數 (降冪)",
"Activity (desc)" => "活動力 (降冪)",
"Disabled" => "關閉",
"Link to user information" => "連結至使用者資訊",
"User profile picture" => "使用者頭像",
"Posts" => "佈告數",
"Visits" => "瀏覽數",
"Activity" => "活動力",
// "Blog post copyright" => "Blog post copyright",
// "Module (box) shadow start" => "Module (box) shadow start",
// "Module (box) shadow end" => "Module (box) shadow end",
// "Days to display in the calendar" => "Days to display in the calendar",
// "Default view mode" => "Default view mode",
// "Day" => "Day",
"Week" => "週",
"Month" => "月",
// "Quarter" => "Quarter",
// "Semester" => "Semester",
"Year" => "年",
// "View list begins" => "View list begins",
// "Focus date" => "Focus date",
// "Period beginning" => "Period beginning",
// "First day of the week" => "First day of the week",
// "Depends user language" => "Depends user language",
// "Split hours in periods of" => "Split hours in periods of",
"1" => "1",
"5" => "5",
// "10" => "10",
// "15" => "15",
// "30" => "30",
// "Minute Interval" => "Minute Interval",
// "First year in the dropdown" => "First year in the dropdown",
// "years" => "years",
// "Enter a year or use +/- N to specify a year relative to the current year. Year selection is valid when the JS Calendar __is not__ enabled" => "Enter a year or use +/- N to specify a year relative to the current year. Year selection is valid when the JS Calendar __is not__ enabled",
// "Last year in the dropdown" => "Last year in the dropdown",
// "Enter a year or use +/- N to specify a year relative to the current year" => "Enter a year or use +/- N to specify a year relative to the current year",
// "Sticky popup" => "Sticky popup",
// "Item view tab" => "Item view tab",
// "Show \"Add to Google Calendar\" icon" => "Show \"Add to Google Calendar\" icon",
// "Show \"Export Calendars\" button" => "Show \"Export Calendars\" button",
// "Show \"Export Calendar Item\" Button" => "Show \"Export Calendar Item\" Button",
// "Allow exporting a single calendar event as an iCal file" => "Allow exporting a single calendar event as an iCal file",
// "Use FullCalendar to display calendars" => "Use FullCalendar to display calendars",
// "Treat calendar item descriptions as HTML" => "Treat calendar item descriptions as HTML",
// "Use this if you use the WYSIWYG editor for calendars. This is to handle legacy data from Tiki pre 7.0" => "Use this if you use the WYSIWYG editor for calendars. This is to handle legacy data from Tiki pre 7.0",
// "Enable watch events when you are the editor" => "Enable watch events when you are the editor",
// "Check this to receive email notifications of events you changed yourself" => "Check this to receive email notifications of events you changed yourself",
// "CAPTCHA image word length" => "CAPTCHA image word length",
// "Number of characters the CAPTCHA will display" => "Number of characters the CAPTCHA will display",
// "CAPTCHA image width" => "CAPTCHA image width",
// "Width of the CAPTCHA image in pixels" => "Width of the CAPTCHA image in pixels",
// "CAPTCHA image noise" => "CAPTCHA image noise",
// "Level of noise of the CAPTCHA image" => "Level of noise of the CAPTCHA image",
// "Choose a smaller number for less noise and easier reading" => "Choose a smaller number for less noise and easier reading",
// "CAPTCHA questions" => "CAPTCHA questions",
// "Requires anonymous visitors to enter the answer to a question" => "Requires anonymous visitors to enter the answer to a question",
// "CAPTCHA questions and answers" => "CAPTCHA questions and answers",
// "Add some simple questions that only humans should be able to answer, in the format: \"Question?: Answer\" with one per line" => "Add some simple questions that only humans should be able to answer, in the format: \"Question?: Answer\" with one per line",
// "One question per line with a colon separating the question and answer" => "One question per line with a colon separating the question and answer",
// "Try automatically to connect SSO" => "Try automatically to connect SSO",
// "Force CAS log-out when the user logs out from Tiki" => "Force CAS log-out when the user logs out from Tiki",
// "Show alternate log-in method in header" => "Show alternate log-in method in header",
// "CAS server version" => "CAS server version",
"none" => "無",
// "Version 1.0" => "Version 1.0",
// "Version 2.0" => "Version 2.0",
// "Hostname" => "Hostname",
// "Hostname of the CAS server" => "Hostname of the CAS server",
// "Port of the CAS server" => "Port of the CAS server",
// "Path for the CAS server" => "Path for the CAS server",
// "CAS Extra Parameter" => "CAS Extra Parameter",
// "Extra Parameter to pass to the CAS Server" => "Extra Parameter to pass to the CAS Server",
// "CAS Authentication Verification Timeout" => "CAS Authentication Verification Timeout",
// "Verify authentication with the CAS server every N seconds. Null value means never reverify" => "Verify authentication with the CAS server every N seconds. Null value means never reverify",
"minute" => "分",
"hour" => "小時",
// "Provides the current categories to Smarty templates" => "Provides the current categories to Smarty templates",
// "When enabled, the \$objectCategoryIds variable is set to the identifiers of the categories of the object being viewed. This allows showing alternate content depending on the categories of the current object, but reduces performance" => "When enabled, the \$objectCategoryIds variable is set to the identifiers of the categories of the object being viewed. This allows showing alternate content depending on the categories of the current object, but reduces performance",
// "Categories to add as CSS classes to <body>" => "Categories to add as CSS classes to <body>",
// "Pages in selected categories will have a class with syntax like \"cat_catname\" added to the body tag" => "Pages in selected categories will have a class with syntax like \"cat_catname\" added to the body tag",
// "Clear cache upon category change" => "Clear cache upon category change",
// "A cache is used to avoid having to fetch all categories from the database every time; this clears the cache when an object is categorized to keep the count up to date" => "A cache is used to avoid having to fetch all categories from the database every time; this clears the cache when an object is categorized to keep the count up to date",
// "Can slow saving objects on sites with a lot of categories. You may need to manually clear caches to update category object counts" => "Can slow saving objects on sites with a lot of categories. You may need to manually clear caches to update category object counts",
// "Category jail" => "Category jail",
// "Limits the visibility of objects to those in these category IDs. Used mainly for creating workspaces from perspectives" => "Limits the visibility of objects to those in these category IDs. Used mainly for creating workspaces from perspectives",
// "This should only be set for perspectives, and not globally" => "This should only be set for perspectives, and not globally",
// "Category jail root" => "Category jail root",
// "Always display categories outside of the jail root, which would be for normal categorization" => "Always display categories outside of the jail root, which would be for normal categorization",
// "Category defaults" => "Category defaults",
// "Require certain categories to be present. If none of the categories in a given set is provided, assign a category by default" => "Require certain categories to be present. If none of the categories in a given set is provided, assign a category by default",
// "Use *7 to specify all the categories in the subtree of 7 + category 7" => "Use *7 to specify all the categories in the subtree of 7 + category 7",
// "Can do only this for objectname matching the regex (Example: /^RND_/ = name beginning by RND_)(Optional)" => "Can do only this for objectname matching the regex (Example: /^RND_/ = name beginning by RND_)(Optional)",
// "Can do for wiki only (optional)" => "Can do for wiki only (optional)",
// "Rename will only reassign the categories for wiki pages" => "Rename will only reassign the categories for wiki pages",
// "One per line, for example: 1,4,6,*7/4:/^RND_/:wiki page" => "One per line, for example: 1,4,6,*7/4:/^RND_/:wiki page",
// "Synchronize multilingual categories" => "Synchronize multilingual categories",
// "Make sure that the categories of the translations are synchronized when modified on any version" => "Make sure that the categories of the translations are synchronized when modified on any version",
// "Only those specified" => "Only those specified",
// "All but those specified" => "All but those specified",
// "Synchronized categories" => "Synchronized categories",
// "List of categories affected by the multilingual synchronization. Depending on the parent feature, this list will be used as a white list (the only categories allowed) or as a black list (all categories allowed except those specified)" => "List of categories affected by the multilingual synchronization. Depending on the parent feature, this list will be used as a white list (the only categories allowed) or as a black list (all categories allowed except those specified)",
// "Sort categories case insensitively" => "Sort categories case insensitively",
// "Ignore case and accents when listing categories. Disable to use the \"locale\" sort settings" => "Ignore case and accents when listing categories. Disable to use the \"locale\" sort settings",
// "Automatically geocode items with this category" => "Automatically geocode items with this category",
// "Automatically geocode items based on category name when categorized in the sub-categories of this category ID" => "Automatically geocode items based on category name when categorized in the sub-categories of this category ID",
// "Replace any existing geocode" => "Replace any existing geocode",
// "When automatically geocoding items based on category name, replace existing geocode, if any" => "When automatically geocoding items based on category name, replace existing geocode, if any",
// "Use approximate geocode location" => "Use approximate geocode location",
// "When automatically geocoding items based on category name, use randomly approximated location instead of precise location" => "When automatically geocoding items based on category name, use randomly approximated location instead of precise location",
// "\"More Like This\" algorithm for categories" => "\"More Like This\" algorithm for categories",
// "Weighted" => "Weighted",
// "Minimum number of categories in common" => "Minimum number of categories in common",
// "categories" => "categories",
"2" => "2",
"4" => "4",
// "6" => "6",
// "7" => "7",
// "8" => "8",
// "9" => "9",
// "List objects with most categories in common" => "List objects with most categories in common",
// "No minimum is applied" => "No minimum is applied",
// "Maximum number of \"more like this\" objects" => "Maximum number of \"more like this\" objects",
// "The default maximum records setting for the site is used of this is set to 0" => "The default maximum records setting for the site is used of this is set to 0",
// "objects" => "objects",
// "Generate custom facets from categories" => "Generate custom facets from categories",
// "Comma-separated list of category IDs" => "Comma-separated list of category IDs",
// "Show category object count" => "Show category object count",
// "Show object count when browsing categories, complying with search and type filters" => "Show object count when browsing categories, complying with search and type filters",
// "Can slow the loading of the categories page on large sites" => "Can slow the loading of the categories page on large sites",
// "Exclude these category IDs" => "Exclude these category IDs",
// "Category path won't appear for these category IDs" => "Category path won't appear for these category IDs",
// "Category path format" => "Category path format",
// "Alter how the category path will be rendered" => "Alter how the category path will be rendered",
// "Links to the category when the category is visible" => "Links to the category when the category is visible",
// "Text label when the category is visible" => "Text label when the category is visible",
// "Link when visible, text label otherwise" => "Link when visible, text label otherwise",
// "Always display the category path labels" => "Always display the category path labels",
// "Center shadow start" => "Center shadow start",
// "Center shadow end" => "Center shadow end",
// "Users can choose the language of their interface" => "Users can choose the language of their interface",
// "Allow users to change the language of the menus and labels" => "Allow users to change the language of the menus and labels",
"Users can change theme" => "允許註冊使用者更改佈景",
// "Users can override the theme with this setting" => "Users can override the theme with this setting",
// "Users can change their password" => "Users can change their password",
// "Registered users can change their password from their User Preferences page. If not, passwords can be changed only by the admin" => "Registered users can change their password from their User Preferences page. If not, passwords can be changed only by the admin",
// "Disable comment titles" => "Disable comment titles",
// "Don't display the title input field on comments and their replies" => "Don't display the title input field on comments and their replies",
// "Email field" => "Email field",
// "Email field for comments (only for anonymous users)" => "Email field for comments (only for anonymous users)",
// "Website field" => "Website field",
// "Website field for comments (only for anonymous users)" => "Website field for comments (only for anonymous users)",
// "Use vote system for comments" => "Use vote system for comments",
// "Allow users with permission to vote on comments" => "Allow users with permission to vote on comments",
// "Permissions involved: %0" => "Permissions involved: %0",
// "Archive comments" => "Archive comments",
// "If a comment is archived, only admins can see it" => "If a comment is archived, only admins can see it",
// "Use Akismet to filter comments" => "Use Akismet to filter comments",
// "Prevent comment spam by using the Akismet service to determine if the comment is spam. If comment moderation is enabled, Akismet will indicate if the comment is to be moderated or not. If there is no comment moderation, the comment will be rejected if considered to be spam" => "Prevent comment spam by using the Akismet service to determine if the comment is spam. If comment moderation is enabled, Akismet will indicate if the comment is to be moderated or not. If there is no comment moderation, the comment will be rejected if considered to be spam",
// "Akismet API Key" => "Akismet API Key",
// "Key required for the Akismet comment spam prevention" => "Key required for the Akismet comment spam prevention",
// "Obtain this key by registering your site at [%0]" => "Obtain this key by registering your site at [%0]",
// "Filter spam for registered users" => "Filter spam for registered users",
// "Activate spam filtering for registered users as well. Useful if your site allows anyone to register without screening" => "Activate spam filtering for registered users as well. Useful if your site allows anyone to register without screening",
// "Allow comments to be edited by their author" => "Allow comments to be edited by their author",
// "Allow a comment to be modified by its author for a 30-minute period after posting it, for clarifications, correction of errors, etc" => "Allow a comment to be modified by its author for a 30-minute period after posting it, for clarifications, correction of errors, etc",
// "Inline comments using Apache Annotator" => "Inline comments using Apache Annotator",
// "Use the Open/Apache Annotator JavaScript based library for managing inline comments as annotations" => "Use the Open/Apache Annotator JavaScript based library for managing inline comments as annotations",
// "Anchor links on headings" => "Anchor links on headings",
// "Cause a link icon to appear on hover over each heading, useful for sharing the URL to an exact location on a page" => "Cause a link icon to appear on hover over each heading, useful for sharing the URL to an exact location on a page",
// "Number of comments per page" => "Number of comments per page",
// "Sort mode for comments" => "Sort mode for comments",
// "Automatically present a terms of use page to be accepted by users accessing the site" => "Automatically present a terms of use page to be accepted by users accessing the site",
// "Terms of Use page name" => "Terms of Use page name",
// "Wiki page for Terms of Use content. The page may be translated using the multilingual feature" => "Wiki page for Terms of Use content. The page may be translated using the multilingual feature",
// "Minimum age" => "Minimum age",
// "When presenting the terms of use, request age" => "When presenting the terms of use, request age",
// "0 to ignore age validation" => "0 to ignore age validation",
// "Tiki connect" => "Tiki connect",
// "Connect your Tiki with the community by sending anonymised statistical data to tiki.org" => "Connect your Tiki with the community by sending anonymised statistical data to tiki.org",
// "This feature is still under development" => "This feature is still under development",
// "Send site information" => "Send site information",
// "Additionally send keywords, location, etc. to tiki.org so you can connect with other Tiki sites near you" => "Additionally send keywords, location, etc. to tiki.org so you can connect with other Tiki sites near you",
// "Site title" => "Site title",
// "Name of site to be listed on Tiki Connect" => "Name of site to be listed on Tiki Connect",
// "Site title is required to send site information" => "Site title is required to send site information",
// "Email contact" => "Email contact",
// "Email to register" => "Email to register",
// "URL to register" => "URL to register",
// "Key words" => "Key words",
// "Key words or tags describing your site" => "Key words or tags describing your site",
// "Site location" => "Site location",
// "Site location expressed as longitude, latitude, and zoom" => "Site location expressed as longitude, latitude, and zoom",
// "Send anonymous information" => "Send anonymous information",
// "Send anonymous usage information" => "Send anonymous usage information",
// "Connection frequency" => "Connection frequency",
// "How often to send information" => "How often to send information",
"hours" => "小時",
// "Click \"Send Info\" to connect" => "Click \"Send Info\" to connect",
// "Currently not in use" => "Currently not in use",
// "Tiki connect server URL" => "Tiki connect server URL",
// "Where to send the information" => "Where to send the information",
// "Last connection" => "Last connection",
// "Connect server mode" => "Connect server mode",
// "For use by mother.tiki.org" => "For use by mother.tiki.org",
// "Connect GUID" => "Connect GUID",
// "For use by mother.tiki.org. Do not modify" => "For use by mother.tiki.org. Do not modify",
// "Allow anonymous visitors to use the \"Contact Us\" feature" => "Allow anonymous visitors to use the \"Contact Us\" feature",
// "Display contact priority" => "Display contact priority",
// "Display contact priority option" => "Display contact priority option",
"Contact user" => "聯絡使用者",
// "User to contact" => "User to contact",
// "Cookie name" => "Cookie name",
// "Domain" => "Domain",
// "The domain that the cookie is available to" => "The domain that the cookie is available to",
// "The path on the server in which the cookie will be available on. Tiki will detect if it is installed in a subdirectory and will use that automatically" => "The path on the server in which the cookie will be available on. Tiki will detect if it is installed in a subdirectory and will use that automatically",
// "Ask permission of the user before setting any cookies, and comply with the response" => "Ask permission of the user before setting any cookies, and comply with the response",
// "Complies with EU Privacy and Electronic Communications Regulations" => "Complies with EU Privacy and Electronic Communications Regulations",
// "Cookie consent name" => "Cookie consent name",
// "Name of the cookie to record the user's consent if the user agrees" => "Name of the cookie to record the user's consent if the user agrees",
// "Cookie consent expiration" => "Cookie consent expiration",
// "Expiration date of the cookie to record consent (in days)" => "Expiration date of the cookie to record consent (in days)",
"days" => "日",
// "Cookie consent text" => "Cookie consent text",
// "Description for the dialog" => "Description for the dialog",
// "Wiki-parsed" => "Wiki-parsed",
// "This website would like to place cookies on your computer to improve the quality of your experience of the site. To find out more about the cookies, see our ((privacy notice))" => "This website would like to place cookies on your computer to improve the quality of your experience of the site. To find out more about the cookies, see our ((privacy notice))",
// "Cookie consent question" => "Cookie consent question",
// "Specific question next to the checkbox for agreement. Leave empty to not display a checkbox" => "Specific question next to the checkbox for agreement. Leave empty to not display a checkbox",
// "I accept cookies from this site" => "I accept cookies from this site",
// "Cookie consent button" => "Cookie consent button",
// "Label on the agreement button" => "Label on the agreement button",
// "Continue" => "Continue",
// "Cookie consent alert" => "Cookie consent alert",
// "Alert displayed when user tries to access or use a feature requiring cookies" => "Alert displayed when user tries to access or use a feature requiring cookies",
// "Sorry, cookie consent required" => "Sorry, cookie consent required",
// "Cookie consent mode" => "Cookie consent mode",
// "Appearance of consent dialog" => "Appearance of consent dialog",
// "Dialog style requires feature_jquery_ui" => "Dialog style requires feature_jquery_ui",
// "Plain" => "Plain",
// "Banner" => "Banner",
// "Dialog" => "Dialog",
// "Cookie consent dialog ID" => "Cookie consent dialog ID",
// "DOM id for the dialog container div" => "DOM id for the dialog container div",
// "Cookie consent disabled" => "Cookie consent disabled",
// "Do not give the option to refuse cookies but still inform the user about cookie usage" => "Do not give the option to refuse cookies but still inform the user about cookie usage",
// "Refresh the remember-me cookie expiration" => "Refresh the remember-me cookie expiration",
// "Each time a user is logged in with a cookie set in a previous session, the cookie expiration date is updated" => "Each time a user is logged in with a cookie set in a previous session, the cookie expiration date is updated",
// "Name of the cookie to remember the user's login" => "Name of the cookie to remember the user's login",
"Count admin pageviews" => "計算管理頁面瀏覽數",
// "Include pageviews by Admin when reporting stats" => "Include pageviews by Admin when reporting stats",
// "Enable daily reports for new users" => "Enable daily reports for new users",
// "Determines if daily reports will be automatically enabled for new users" => "Determines if daily reports will be automatically enabled for new users",
// "Default character set for sending mail" => "Default character set for sending mail",
// "Specify the character encoding used by Tiki when sending mail notifications" => "Specify the character encoding used by Tiki when sending mail notifications",
// "utf-8" => "utf-8",
// "iso-8859-1" => "iso-8859-1",
// "default mapfile" => "default mapfile",
// "Default diff style" => "Default diff style",
// "Only with last version" => "Only with last version",
// "HTML diff" => "HTML diff",
// "Side-by-side diff" => "Side-by-side diff",
// "Side-by-side diff by characters" => "Side-by-side diff by characters",
// "Inline diff" => "Inline diff",
// "Inline diff by characters" => "Inline diff by characters",
// "Full side-by-side diff" => "Full side-by-side diff",
// "Full side-by-side diff by characters" => "Full side-by-side diff by characters",
// "Full inline diff" => "Full inline diff",
// "Full inline diff by characters" => "Full inline diff by characters",
// "Unified diff" => "Unified diff",
// "Side-by-side view" => "Side-by-side view",
"rows" => "列",
// "Comment box" => "Comment box",
// "Size (height) of the comment text area" => "Size (height) of the comment text area",
// "Forum reply" => "Forum reply",
// "Select default calendars to display" => "Select default calendars to display",
// "Group transition sets default" => "Group transition sets default",
// "Sets the group transitioned to as the user's default group" => "Sets the group transitioned to as the user's default group",
// "Use to deactivate the autocomplete in the log-in box. The autocomplete features can be optionally set in the user’s browser to remember the form input and proposes the remember the password. If enabled, the user log-in name and password cannot be remembered. You should enable this feature for highly secure sites" => "Use to deactivate the autocomplete in the log-in box. The autocomplete features can be optionally set in the user’s browser to remember the form input and proposes the remember the password. If enabled, the user log-in name and password cannot be remembered. You should enable this feature for highly secure sites",
// "Disable browser's autocomplete feature for username and password fields" => "Disable browser's autocomplete feature for username and password fields",
"Use direct pagination links" => "使用直接頁數連結",
// "Maximum number of links around the current item" => "Maximum number of links around the current item",
// "links" => "links",
// "Maximum number of links after the first or before the last item" => "Maximum number of links after the first or before the last item",
// "Show country flag" => "Show country flag",
// "Show the country flag" => "Show the country flag",
// "Enable \"popular sites\"" => "Enable \"popular sites\"",
"Validate URLs" => "確認 URLs",
// "Should Tiki check the URL" => "Should Tiki check the URL",
// "Columns per page" => "Columns per page",
// "Number of columns per page when listing directory categories" => "Number of columns per page when listing directory categories",
// "columns" => "columns",
"Links per page" => "每頁連結數",
// "How many links should be displayed per page" => "How many links should be displayed per page",
// "Method to open Directory links" => "Method to open Directory links",
"The linked-to website can be opened in various ways" => "打開目錄連結的方法",
"Replace the current window" => "取代目前視窗",
"Open a new window" => "新的視窗",
"Open an iframe" => "行內頁框",
// "Fields display order" => "Fields display order",
// "The order date field inputs should be listed in" => "The order date field inputs should be listed in",
// "Year to show first in dropdown lists" => "Year to show first in dropdown lists",
// "For example, use \"-2\" for the current year minus two, or \"2010\" for a specific year" => "For example, use \"-2\" for the current year minus two, or \"2010\" for a specific year",
// "year(s)" => "year(s)",
// "Year to show last on dropdown lists" => "Year to show last on dropdown lists",
// "For example, use \"+2\" for the current year plus two, or \"2016\" for a specific year" => "For example, use \"+2\" for the current year plus two, or \"2016\" for a specific year",
// "Re-validate user email after" => "Re-validate user email after",
// "The number of days after which an email will be sent to the user with a link to revalidate the account. The user will not be able to login (that is, the account will be invalid), until the user clicks the link. Use this feature to verify that a user’s email is still valid" => "The number of days after which an email will be sent to the user with a link to revalidate the account. The user will not be able to login (that is, the account will be invalid), until the user clicks the link. Use this feature to verify that a user’s email is still valid",
// "Use \"-1\" for never" => "Use \"-1\" for never",
// "Email footer" => "Email footer",
// "Text appended to outgoing emails" => "Text appended to outgoing emails",
// "PHP errors visible to admin only" => "PHP errors visible to admin only",
// "During site development, it's better to display errors to all users. However, in production settings, errors should only be displayed to administrators" => "During site development, it's better to display errors to all users. However, in production settings, errors should only be displayed to administrators",
// "PHP Errors will be shown to only the Admin user" => "PHP Errors will be shown to only the Admin user",
// "PHP Error reporting level" => "PHP Error reporting level",
// "Level of errors to be reported. Errors can be seen in a collapsible box at the bottom of the page, if any exist" => "Level of errors to be reported. Errors can be seen in a collapsible box at the bottom of the page, if any exist",
// "No error reporting" => "No error reporting",
// "Report all PHP errors except strict" => "Report all PHP errors except strict",
// "Report all PHP errors" => "Report all PHP errors",
// "Report all PHP errors except notices" => "Report all PHP errors except notices",
// "According to the PHP configuration" => "According to the PHP configuration",
"Default number of comments per page" => "預設每頁評論數目",
// "Maximum number of comments to display on each page. Users may override this number" => "Maximum number of comments to display on each page. Users may override this number",
"Default order of comments" => "預設評論排序",
// "In which order to list the comments on the page" => "In which order to list the comments on the page",
// "Prefix for answers" => "Prefix for answers",
// "The prefix for that Tiki should display for each FAQ answer" => "The prefix for that Tiki should display for each FAQ answer",
// "Q and A" => "Q and A",
// "Question ID" => "Question ID",
// "FAQ copyright" => "FAQ copyright",
// "Limit blog categories to those under this category" => "Limit blog categories to those under this category",
// "If you get an error message indicating a mandatory category is required when editing a blog post, this is the option to blame. Set it to None" => "If you get an error message indicating a mandatory category is required when editing a blog post, this is the option to blame. Set it to None",
// "Areas" => "Areas",
// "Binding categories and perspectives to each other" => "Binding categories and perspectives to each other",
// "Pages and collaboratively authored documents with edit history" => "Pages and collaboratively authored documents with edit history",
// "Online diaries or journals" => "Online diaries or journals",
// "Enable directory batch loading" => "Enable directory batch loading",
// "Import large number of files by placing them them in a local directory accessible via a network share, scp, ftp, or other protocols" => "Import large number of files by placing them them in a local directory accessible via a network share, scp, ftp, or other protocols",
// "You will need to setup a web-readable directory (outside of your web space is better). Then create a way to upload images to that directory" => "You will need to setup a web-readable directory (outside of your web space is better). Then create a way to upload images to that directory",
"Rankings" => "排名",
// "Users can see several charts or rankings about the file" => "Users can see several charts or rankings about the file",
// "Image gallery" => "Image gallery",
// "Collections of images for viewing or downloading (photo albums)" => "Collections of images for viewing or downloading (photo albums)",
// "File galleries can be used instead" => "File galleries can be used instead",
// "Image Gallery Comments" => "Image Gallery Comments",
// "Users with permission may post threaded comments. The comments will appear at the bottom of the page" => "Users with permission may post threaded comments. The comments will appear at the bottom of the page",
// "Limit image gallery categories to those under this category" => "Limit image gallery categories to those under this category",
// "Machine translation" => "Machine translation",
// "Uses machine translation to translate the content of the site to other languages. Note that this feature relies on external services thay may not be free. Google Translate is a paid service" => "Uses machine translation to translate the content of the site to other languages. Note that this feature relies on external services thay may not be free. Google Translate is a paid service",
// "Database and form generator" => "Database and form generator",
// "Threaded or flat discussions" => "Threaded or flat discussions",
// "File gallery" => "File gallery",
// "Storage of files of various formats to display or download, etc. With check-in and check-out (lock) capability" => "Storage of files of various formats to display or download, etc. With check-in and check-out (lock) capability",
// "Save files as drafts" => "Save files as drafts",
// "Allow saving of files as drafts" => "Allow saving of files as drafts",
// "File gallery configuration templates" => "File gallery configuration templates",
// "Articles can be used for date-specific news and announcements. You can configure articles to automatically publish and expire at specific times or to require that submissions be approved before becoming \"live.\"" => "Articles can be used for date-specific news and announcements. You can configure articles to automatically publish and expire at specific times or to require that submissions be approved before becoming \"live.\"",
"Polls" => "測驗紀錄",
// "Presentation of a set of votable options, typically displayed in a module" => "Presentation of a set of votable options, typically displayed in a module",
"Newsletters" => "電子報",
// "Content mailed to registered users or other subscribers" => "Content mailed to registered users or other subscribers",
"Calendar" => "行事曆",
// "Events calendar with public, private and group channels" => "Events calendar with public, private and group channels",
"Banners" => "大標題",
// "Insert, track, and manage advertising banners" => "Insert, track, and manage advertising banners",
// "Site-wide content category system. Items of different types (wiki pages, articles, tracker items, etc.) can be categorized. Categories can have permissions to control content access" => "Site-wide content category system. Items of different types (wiki pages, articles, tracker items, etc.) can be categorized. Categories can have permissions to control content access",
// "Unified user details " => "Unified user details ",
// "Use User Details Page using the Unified Index" => "Use User Details Page using the Unified Index",
"Score" => "分數",
// "Score is a game to motivate participants to increase their contribution by comparing to other users" => "Score is a game to motivate participants to increase their contribution by comparing to other users",
// "Score expiry" => "Score expiry",
// "Unified search index" => "Unified search index",
// "Enables searching for content at the site using a Tiki-managed index" => "Enables searching for content at the site using a Tiki-managed index",
// "Enables tags to be set on pages and other items for freeform categorization" => "Enables tags to be set on pages and other items for freeform categorization",
// "Action log" => "Action log",
// "Provides the ability to track the actions of users and produce reports on a per-user or per-category basis" => "Provides the ability to track the actions of users and produce reports on a per-user or per-category basis",
// "Contribution" => "Contribution",
// "Enables users to specify the type of contribution they are making while editing items at the site. The contributions are then displayed color-coded in history and other reports" => "Enables users to specify the type of contribution they are making while editing items at the site. The contributions are then displayed color-coded in history and other reports",
// "Multilingual" => "Multilingual",
// "Enables internationalization features and multilingual support at the site" => "Enables internationalization features and multilingual support at the site",
// "Frequently asked questions and answers" => "Frequently asked questions and answers",
// "There has been discussion about this feature being retired, so keep in mind that normal wiki pages can be used to create and display FAQs" => "There has been discussion about this feature being retired, so keep in mind that normal wiki pages can be used to create and display FAQs",
"Surveys" => "調查",
// "Create questionnaires with multiple-choice or open-ended questions" => "Create questionnaires with multiple-choice or open-ended questions",
// "User-submitted Web links" => "User-submitted Web links",
// "Sets of questions that can be presented, with the sessions timed and the scores recorded" => "Sets of questions that can be presented, with the sessions timed and the scores recorded",
// "Featured links" => "Featured links",
// "A simple menu system to display external web pages in a new browser tab or an iframe within the site, etc" => "A simple menu system to display external web pages in a new browser tab or an iframe within the site, etc",
"Copyright" => "版權所有",
// "Use the Copyright Management System (or ©MS) to display the license of your content" => "Use the Copyright Management System (or ©MS) to display the license of your content",
"Wiki references" => "Wiki 參考",
// "Permits using references and the reference library" => "Permits using references and the reference library",
// "Library references" => "Library references",
// "Enforce library reference as master" => "Enforce library reference as master",
// "Reference style" => "Reference style",
// "Default style when using references" => "Default style when using references",
// "AMA citation style (default)" => "AMA citation style (default)",
// "MLA citation style" => "MLA citation style",
// "Display reference in a popover" => "Display reference in a popover",
// "Display the details of the reference in a popover" => "Display the details of the reference in a popover",
"Shoutbox" => "Shoutbox",
// "Quick comment (graffiti) box. Like a group chat, but not in real time" => "Quick comment (graffiti) box. Like a group chat, but not in real time",
"Live support system" => "線上支援系統",
// "One-on-one chatting with customer" => "One-on-one chatting with customer",
// "Tell a friend" => "Tell a friend",
// "Add to each page an \"Email this page\" link" => "Add to each page an \"Email this page\" link",
// "Add a \"Share\" link in all pages to send it via email, Twitter, Facebook, message or forums" => "Add a \"Share\" link in all pages to send it via email, Twitter, Facebook, message or forums",
// "Be careful when allowing anonymous users to activate the antibot feature" => "Be careful when allowing anonymous users to activate the antibot feature",
// "HTML pages" => "HTML pages",
// "Static and dynamic HTML content" => "Static and dynamic HTML content",
// "HTML can be used in wiki pages. This is a separate feature" => "HTML can be used in wiki pages. This is a separate feature",
// "Contact us" => "Contact us",
// "A basic contact form a visitor can use to contact the site admin" => "A basic contact form a visitor can use to contact the site admin",
// "Minichat" => "Minichat",
// "Real-time group text chatting enabled through a module" => "Real-time group text chatting enabled through a module",
// "Comments moderation" => "Comments moderation",
// "Enables the admin or other authorized group member to validate comments before they are visible" => "Enables the admin or other authorized group member to validate comments before they are visible",
// "Add author name in From email header" => "Add author name in From email header",
// "Add the name of the comment author in the email header \"From\", making the email look like sent from  \"John Doe <noreply@example.com>\"" => "Add the name of the comment author in the email header \"From\", making the email look like sent from  \"John Doe <noreply@example.com>\"",
// "Comments locking" => "Comments locking",
// "Comments can be closed (no comments, or no new comments)" => "Comments can be closed (no comments, or no new comments)",
// "Allow logged-in users to post comments anonymously" => "Allow logged-in users to post comments anonymously",
// "This can be used to encourage honest feedback without self-censorship, such as in a forum for brainstorming or feedback for improvement" => "This can be used to encourage honest feedback without self-censorship, such as in a forum for brainstorming or feedback for improvement",
// "Show the page description" => "Show the page description",
// "Display the wiki page description between the page title and the page content" => "Display the wiki page description between the page title and the page content",
// "Display page name as page title" => "Display page name as page title",
// "Display the page name at the top of each page as page title. If not enabled, the page content should contain an h1 heading to function as the page title, or the page description can be used as the title" => "Display the page name at the top of each page as page title. If not enabled, the page content should contain an h1 heading to function as the page title, or the page description can be used as the title",
// "Show the page ID" => "Show the page ID",
// "Each wiki page has a numeric ID and this can be displayed" => "Each wiki page has a numeric ID and this can be displayed",
// "Individual wiki cache" => "Individual wiki cache",
// "Allow users to change the duration of the cache on a per-page basis" => "Allow users to change the duration of the cache on a per-page basis",
// "Date picker for date selection" => "Date picker for date selection",
// "JavaScript popup date selector (uses jQuery UI DatePicker)" => "JavaScript popup date selector (uses jQuery UI DatePicker)",
// "Output should be HTML purified" => "Output should be HTML purified",
// "This activates HTML Purifier on wiki content and other outputs, to filter out potential security problems like XSS code. Keep in mind that HTML Purifier is not HTML5 compatible and may rewrite HTML5 syntax, producing unwanted results" => "This activates HTML Purifier on wiki content and other outputs, to filter out potential security problems like XSS code. Keep in mind that HTML Purifier is not HTML5 compatible and may rewrite HTML5 syntax, producing unwanted results",
// "If you are trying to use HTML in your pages and it gets stripped out, you should make sure your HTML is valid or de-activate this feature" => "If you are trying to use HTML in your pages and it gets stripped out, you should make sure your HTML is valid or de-activate this feature",
// "Full screen" => "Full screen",
// "Allow users to activate full-screen mode" => "Allow users to activate full-screen mode",
// "CSS menus" => "CSS menus",
// "Use CSS-styled (Suckerfish) vertical and horizontal menus" => "Use CSS-styled (Suckerfish) vertical and horizontal menus",
// "Shadowbox / ColorBox" => "Shadowbox / ColorBox",
// "Display images in a modal popup window (also referred to as shadowbox, lightbox or colorbox)" => "Display images in a modal popup window (also referred to as shadowbox, lightbox or colorbox)",
// "Quick permission assignment" => "Quick permission assignment",
// "Quickperms are an interface in addition to the normal edit-permissions page, for quick assignment of permissions for a page or other object" => "Quickperms are an interface in addition to the normal edit-permissions page, for quick assignment of permissions for a page or other object",
// "User encryption" => "User encryption",
// "Tiki user encryption enables a personal, secure storage of sensitive data, e.g. password. Only the user can see the data. No decryption passwords are stored" => "Tiki user encryption enables a personal, secure storage of sensitive data, e.g. password. Only the user can see the data. No decryption passwords are stored",
// "Enable personal, secure storage of sensitive data such as passwords" => "Enable personal, secure storage of sensitive data such as passwords",
// "This is an experimental feature. Using it may cause loss of the encrypted data" => "This is an experimental feature. Using it may cause loss of the encrypted data",
// "Password domains" => "Password domains",
// "Securely store extra user passwords and other user specific data for other \"domains\", or just for yourself" => "Securely store extra user passwords and other user specific data for other \"domains\", or just for yourself",
// "HTML purifier" => "HTML purifier",
// "If you use HTML in your wiki page and it gets stripped out or rewritten, make sure your HTML is valid, or de-activate this feature.  Keep in mind that HTML Purifier is not HTML5 compatible and may rewrite HTML5 syntax and produce unwanted results" => "If you use HTML in your wiki page and it gets stripped out or rewritten, make sure your HTML is valid, or de-activate this feature.  Keep in mind that HTML Purifier is not HTML5 compatible and may rewrite HTML5 syntax and produce unwanted results",
// "Ajax" => "Ajax",
// "Allows for efficient retrieval and display of information from the server, thus improving the user experience. This feature is required for the interface for many features to work" => "Allows for efficient retrieval and display of information from the server, thus improving the user experience. This feature is required for the interface for many features to work",
// "This feature is required for the interface for many features to work properly" => "This feature is required for the interface for many features to work properly",
"Webmail" => "Webmail",
// "Intertiki" => "Intertiki",
// "Allows several Tiki sites (slaves) to get authentication from a master Tiki site" => "Allows several Tiki sites (slaves) to get authentication from a master Tiki site",
"Mail-in" => "Mail-in",
// "Create and publish wiki pages and articles via email" => "Create and publish wiki pages and articles via email",
// "Mindmap" => "Mindmap",
// "Display in a graphical way the connection among wiki pages" => "Display in a graphical way the connection among wiki pages",
// "Print indexed" => "Print indexed",
// "Generate a printable version of the whole wiki or a subset of pages, filtered by category" => "Generate a printable version of the whole wiki or a subset of pages, filtered by category",
// "Spreadsheet" => "Spreadsheet",
// "Spreadsheets with calculations and charts" => "Spreadsheets with calculations and charts",
// "Slideshow (reveal.js)" => "Slideshow (reveal.js)",
// "Create simple presentations via Wiki Syntax" => "Create simple presentations via Wiki Syntax",
// "Slideshow (reveal.js) PDF export" => "Slideshow (reveal.js) PDF export",
// "Wiki-page-based slideshow to pdf export" => "Wiki-page-based slideshow to pdf export",
// "Invoice" => "Invoice",
// "Invoice system" => "Invoice system",
// "Full WYSIWYG editor" => "Full WYSIWYG editor",
// "WYSIWYG is an acronym for \"What You See Is What You Get\". <a href=\"https://ckeditor.com\">CKEditor</a> is used to provide a word-processor-like editing experience" => "WYSIWYG is an acronym for \"What You See Is What You Get\". <a href=\"https://ckeditor.com\">CKEditor</a> is used to provide a word-processor-like editing experience",
// "Kaltura video management" => "Kaltura video management",
// "Integration with the Kaltura video management platform" => "Integration with the Kaltura video management platform",
// "Friendship network" => "Friendship network",
// "Users can identify other users as their friends" => "Users can identify other users as their friends",
"Banning system" => "禁用系統",
// "Deny access to specific users based on username, IP, and date/time range" => "Deny access to specific users based on username, IP, and date/time range",
"Stats" => "狀態",
// "Record basic statistics about major Tiki features (number of wiki pages, size of file galleries, etc.)" => "Record basic statistics about major Tiki features (number of wiki pages, size of file galleries, etc.)",
// "Action calendar" => "Action calendar",
// "Displays a calendar of system events, such as wiki page modifications, forum posts and article publications. Days with events show links to the action calendar page" => "Displays a calendar of system events, such as wiki page modifications, forum posts and article publications. Days with events show links to the action calendar page",
"Referrer stats" => "參照頁面統計",
// "Record domain name of sites that send visitors to this Tiki" => "Record domain name of sites that send visitors to this Tiki",
// "Redirect on error" => "Redirect on error",
// "On an error, refresh to the homepage as specified on the Admin General page" => "On an error, refresh to the homepage as specified on the Admin General page",
"Communications (send/receive objects)" => "通訊 (發送/接受 物件)",
// "Send/receive wiki pages and articles between Tiki-powered sites" => "Send/receive wiki pages and articles between Tiki-powered sites",
// "Display \"My Account\" in the application menu" => "Display \"My Account\" in the application menu",
// "Mini calendar" => "Mini calendar",
// "Displays a personal calendar for each user" => "Displays a personal calendar for each user",
// "User preferences screen" => "User preferences screen",
// "User notepad" => "User notepad",
// "My bookmarks" => "My bookmarks",
// "User contacts" => "User contacts",
// "User watches" => "User watches",
// "Receive email notification of changes. Each user can choose to be notified of changes to specific items" => "Receive email notification of changes. Each user can choose to be notified of changes to specific items",
// "Group watches" => "Group watches",
// "All users in a group selected by a users admin (tiki_p_admin_users) will receive email notification of changes to specific items. Users cannot choose to stop receiving those notifications while they are members of that group" => "All users in a group selected by a users admin (tiki_p_admin_users) will receive email notification of changes to specific items. Users cannot choose to stop receiving those notifications while they are members of that group",
// "Daily reports for user watches" => "Daily reports for user watches",
// "Allows you to schedule daily reports of watches to be sent (batched) at specific times" => "Allows you to schedule daily reports of watches to be sent (batched) at specific times",
// "User watches translations" => "User watches translations",
// "User watches languages" => "User watches languages",
// "Watch language-specific changes within a category" => "Watch language-specific changes within a category",
// "User menu" => "User menu",
// "Unmaintained feature" => "Unmaintained feature",
// "User tasks" => "User tasks",
// "User messages" => "User messages",
// "Enables inter-user messages (for this to work for new users, the tiki_p_messages permission must be assigned to at least the Registered group)." => "Enables inter-user messages (for this to work for new users, the tiki_p_messages permission must be assigned to at least the Registered group).",
// "User files" => "User files",
// "Menu user levels" => "Menu user levels",
// "Enables control of the per-group visibility of menu options" => "Enables control of the per-group visibility of menu options",
// "Group alert" => "Group alert",
// "Integrator" => "Integrator",
"XMLRPC API" => "XMLRPC API",
"Debugger console" => "除錯器控制臺",
// "A popup console with a list of all PHP and Smarty variables used to render the current webpage. It can be viewed by clicking 'Quick Administration->Smarty debug window' or by appending ?show_smarty_debug=1 or &show_smarty_debug=1 to the page URL. You may also execute SQL, watch vars and perform a number of other functions" => "A popup console with a list of all PHP and Smarty variables used to render the current webpage. It can be viewed by clicking 'Quick Administration->Smarty debug window' or by appending ?show_smarty_debug=1 or &show_smarty_debug=1 to the page URL. You may also execute SQL, watch vars and perform a number of other functions",
// "Only viewable by admins" => "Only viewable by admins",
// "Not suitable for production use" => "Not suitable for production use",
// "TikiTests" => "TikiTests",
// "Permits recording and playback of functional tests" => "Permits recording and playback of functional tests",
// "Check for updates automatically" => "Check for updates automatically",
// "Tiki will automatically check for new updates each time you access the Admin Home page, based on your Check frequency selection" => "Tiki will automatically check for new updates each time you access the Admin Home page, based on your Check frequency selection",
// "Subscribe to the Tiki Newsletter to be notified of new releases. https://doc.tiki.org/Newsletters" => "Subscribe to the Tiki Newsletter to be notified of new releases. https://doc.tiki.org/Newsletters",
// "Require confirmation of an action if a possible CSRF is detected" => "Require confirmation of an action if a possible CSRF is detected",
// "Deprecated. Using may cause false errors" => "Deprecated. Using may cause false errors",
// "Detect browser language" => "Detect browser language",
// "Look up the user's preferred language through browser preferences" => "Look up the user's preferred language through browser preferences",
// "Show pages in user's preferred language" => "Show pages in user's preferred language",
// "When accessing a page which has an equivalent in the user's preferred language, favor the translated page. Based on the user’s Tiki preferences" => "When accessing a page which has an equivalent in the user's preferred language, favor the translated page. Based on the user’s Tiki preferences",
// "Synchronize page and site language" => "Synchronize page and site language",
// "Changing the page language also changes the site language" => "Changing the page language also changes the site language",
// "Translation assistant" => "Translation assistant",
// "Track translation operations between pages" => "Track translation operations between pages",
// "Urgent translation notifications" => "Urgent translation notifications",
// "Enable changes to be flagged as urgent, so translations are marked with a notice visible to all users" => "Enable changes to be flagged as urgent, so translations are marked with a notice visible to all users",
// "Incomplete translation notice" => "Incomplete translation notice",
// "When a page is translated to a new language, a notice will automatically be inserted into the page to indicate that the translation is not yet complete" => "When a page is translated to a new language, a notice will automatically be inserted into the page to indicate that the translation is not yet complete",
// "Multilingual structures" => "Multilingual structures",
// "Structures search for equivalent pages in other languages" => "Structures search for equivalent pages in other languages",
// "May cause performance problems with larger structures" => "May cause performance problems with larger structures",
// "Display all languages in a single page" => "Display all languages in a single page",
// "List all languages as options in the page-language dropdown list, to see them all at once" => "List all languages as options in the page-language dropdown list, to see them all at once",
// "GZip output" => "GZip output",
// "Compress your pages on-the-fly, if the requesting browser supports this" => "Compress your pages on-the-fly, if the requesting browser supports this",
// "Help system" => "Help system",
// "Activates links to Tiki documentation.  You can specify a Help URL that contains customized help pages. By default, the Help system uses http://doc.tiki.org/" => "Activates links to Tiki documentation.  You can specify a Help URL that contains customized help pages. By default, the Help system uses http://doc.tiki.org/",
"Smileys" => "表情符號",
// "Also known as emoticons" => "Also known as emoticons",
// "Tagging users" => "Tagging users",
// "Add support for @username mentions" => "Add support for @username mentions",
// "User mention notifications" => "User mention notifications",
// "Add support for @username mentions notifications" => "Add support for @username mentions notifications",
// "Draw (SVG edit)" => "Draw (SVG edit)",
// "Draw enables creating and editing SVG images in all wiki text areas" => "Draw enables creating and editing SVG images in all wiki text areas",
// "Draw (SVG edit) hide buttons" => "Draw (SVG edit) hide buttons",
// "Hide buttons in Draw, HTML id, comma-separated" => "Hide buttons in Draw, HTML id, comma-separated",
// "Example: \"tool_select, tool_fhpath, tools_line_show, tools_rect_show, tools_ellipse_show, tool_path, tools_shapelib_show, tool_text, tool_image, tool_zoom, tool_eyedropper\"" => "Example: \"tool_select, tool_fhpath, tools_line_show, tools_rect_show, tools_ellipse_show, tool_path, tools_shapelib_show, tool_text, tool_image, tool_zoom, tool_eyedropper\"",
// "Separate base image" => "Separate base image",
// "Leaves the initially edited image as a separate file and stores the drawing separately" => "Leaves the initially edited image as a separate file and stores the drawing separately",
// "Draw in user file gallery" => "Draw in user file gallery",
// "Docs (WebODF)" => "Docs (WebODF)",
// "Docs enables viewing and editing Open Document Format files" => "Docs enables viewing and editing Open Document Format files",
// "Dynamic content system" => "Dynamic content system",
// "Block of content which can be reused and programmed (timed)" => "Block of content which can be reused and programmed (timed)",
// "Use file galleries to store images" => "Use file galleries to store images",
// "If not enabled, images will be stored in the file system, in the /img/wiki_up directory, instead" => "If not enabled, images will be stored in the file system, in the /img/wiki_up directory, instead",
// "External link icon" => "External link icon",
// "External links will be identified with an icon. To customize the icon, change the \"link-external\" icon in the icon set" => "External links will be identified with an icon. To customize the icon, change the \"link-external\" icon in the icon set",
// "Add \"rel=nofollow\" to external links" => "Add \"rel=nofollow\" to external links",
// "Semantic links" => "Semantic links",
// "Going beyond Backlinks functionality, this allows some semantic relationships to be defined between wiki pages" => "Going beyond Backlinks functionality, this allows some semantic relationships to be defined between wiki pages",
// "Web services" => "Web services",
// "Can receive web services via JSON or YAML" => "Can receive web services via JSON or YAML",
"Use folder icons for menu section (parent) items" => "用資料夾方式顯示選單",
// "When a menu isn't set as a Bootstrap or CSS menu, use folder icons for menu section items (rather than plus/minus signs)" => "When a menu isn't set as a Bootstrap or CSS menu, use folder icons for menu section items (rather than plus/minus signs)",
// "Breadcrumbs" => "Breadcrumbs",
// "Indicates the navigation path through parent pages to the current page" => "Indicates the navigation path through parent pages to the current page",
// "Anonymous editors must enter anti-bot code (CAPTCHA)" => "Anonymous editors must enter anti-bot code (CAPTCHA)",
// "Use CAPTCHA to ensure that anonymous input is from a person" => "Use CAPTCHA to ensure that anonymous input is from a person",
// "Protect email against spam" => "Protect email against spam",
// "Protect email against spam submissions" => "Protect email against spam submissions",
// "Protect email against spam currently does not operate in pages edited in WYSIWYG mode (Tiki 6.1)" => "Protect email against spam currently does not operate in pages edited in WYSIWYG mode (Tiki 6.1)",
// "Site ads" => "Site ads",
// "Enable advertising" => "Enable advertising",
// "Activate will display content for Admin only. Select Publish to display for all users" => "Activate will display content for Admin only. Select Publish to display for all users",
// "Anonymous voting" => "Anonymous voting",
// "Allow anonymous users to participate in voting" => "Allow anonymous users to participate in voting",
// "This can be overridden by specific permissions" => "This can be overridden by specific permissions",
// "Allow re-voting" => "Allow re-voting",
// "Visitors can vote mulitiple times in a poll" => "Visitors can vote mulitiple times in a poll",
// "When logged in, Tiki tracks users by username or otherwise IP address" => "When logged in, Tiki tracks users by username or otherwise IP address",
// "Comments for polls" => "Comments for polls",
// "Comments for FAQs" => "Comments for FAQs",
// "Search engine friendly URL" => "Search engine friendly URL",
// "If the site is using Apache, you can rename _htaccess as .htaccess to use short URLs. On IIS, rename web_config as web.config" => "If the site is using Apache, you can rename _htaccess as .htaccess to use short URLs. On IIS, rename web_config as web.config",
// "SEFURL postfilter" => "SEFURL postfilter",
// "Do not enable this feature as most Tiki features output friendly URLs and this feature has high processor overhead" => "Do not enable this feature as most Tiki features output friendly URLs and this feature has high processor overhead",
// "Article title in SEFURL" => "Article title in SEFURL",
// "The article title rather than article number can be displayed in the search engine friendly URL" => "The article title rather than article number can be displayed in the search engine friendly URL",
// "Blog title in SEFURL" => "Blog title in SEFURL",
// "The blog title rather than blog number can be displayed in the search engine friendly URL" => "The blog title rather than blog number can be displayed in the search engine friendly URL",
// "Display forum thread or forum post title in the search engine friendly URL" => "Display forum thread or forum post title in the search engine friendly URL",
// "Tracker title in SEFURL" => "Tracker title in SEFURL",
// "To display the title, you should disable `Rewrite tiki-view_tracker.php?itemId=yyy to Prefixyyy page`" => "To display the title, you should disable `Rewrite tiki-view_tracker.php?itemId=yyy to Prefixyyy page`",
// "Max size of title in the search engine friendly URL (Tracker Items and Forum Threads)" => "Max size of title in the search engine friendly URL (Tracker Items and Forum Threads)",
// "Limit the number of characters in the tracker item or forum thread title" => "Limit the number of characters in the tracker item or forum thread title",
// "Rewrite tiki-view_tracker.php?itemId=yyy to Prefixyyy page" => "Rewrite tiki-view_tracker.php?itemId=yyy to Prefixyyy page",
// "This redirection uses the wiki prefix alias feature" => "This redirection uses the wiki prefix alias feature",
// "Canonical URL tag" => "Canonical URL tag",
// "Indicates to search engines which URL to use, to prevent duplicate listings" => "Indicates to search engines which URL to use, to prevent duplicate listings",
// "Canonical URL domain" => "Canonical URL domain",
// "Custom Routes" => "Custom Routes",
// "Custom routes allow the definition of URLs by the admin, that can be mapped to existing Tiki objects like pages and trackers.  \"Add BASE tag in the page HEAD\" is required when you have \"/\" as part of the URL" => "Custom routes allow the definition of URLs by the admin, that can be mapped to existing Tiki objects like pages and trackers.  \"Add BASE tag in the page HEAD\" is required when you have \"/\" as part of the URL",
// "Show module controls" => "Show module controls",
// "Enable controls in modules" => "Enable controls in modules",
// "Perspectives" => "Perspectives",
// "Permits overriding of preferences" => "Permits overriding of preferences",
// "Search and replace" => "Search and replace",
// "Enables finding and replacing of content in the edit box" => "Enables finding and replacing of content in the edit box",
"Submissions" => "提交",
// "Articles can be submitted but need to be approved before they are published" => "Articles can be submitted but need to be approved before they are published",
// "Users can see several charts or rankings about the item" => "Users can see several charts or rankings about the item",
// "Comments on articles" => "Comments on articles",
// "Users with permission can post or reply to comments. The comments will appear at the bottom of the page" => "Users with permission can post or reply to comments. The comments will appear at the bottom of the page",
// "Article content templates" => "Article content templates",
// "Predefined content for an article" => "Predefined content for an article",
// "template article news" => "template article news",
// "Print articles" => "Print articles",
// "Specify notification emails when creating articles" => "Specify notification emails when creating articles",
// "Send a notification email when creating an article. Remember that notification emails for article topics can be redefined when the topic is edited after its creation" => "Send a notification email when creating an article. Remember that notification emails for article topics can be redefined when the topic is edited after its creation",
// "ShareThis buttons" => "ShareThis buttons",
// "Enable sharing site content via ShareThis" => "Enable sharing site content via ShareThis",
// "Insert a ShareThis button from [http://www.sharethis.com]" => "Insert a ShareThis button from [http://www.sharethis.com]",
// "Category path" => "Category path",
// "Show the category tree above the wiki page" => "Show the category tree above the wiki page",
// "Show category objects" => "Show category objects",
// "Show, at the bottom of the wiki page, objects in the same category" => "Show, at the bottom of the wiki page, objects in the same category",
// "Ignore category viewing restrictions" => "Ignore category viewing restrictions",
// "Display items the user may not be entitled to view in search results" => "Display items the user may not be entitled to view in search results",
// "Will improve performance, but may show forbidden results" => "Will improve performance, but may show forbidden results",
"List pages" => "列出頁面",
// "Allow viewing the wiki page list" => "Allow viewing the wiki page list",
// "Latest changes" => "Latest changes",
// "Enable users (with permission) to see the sortable, searchable list of wiki pages (tiki-lastchanges.php) organized by last-updated date. Use the Configuration area to specify which items to display." => "Enable users (with permission) to see the sortable, searchable list of wiki pages (tiki-lastchanges.php) organized by last-updated date. Use the Configuration area to specify which items to display.",
"Orphan pages" => "孤立頁面",
// "Allow listing of \\\"orphan pages\\\" (pages not linked to from another page)" => "Allow listing of \\\"orphan pages\\\" (pages not linked to from another page)",
// "MySQL full-text search" => "MySQL full-text search",
// "Referer search highlighting" => "Referer search highlighting",
// "When a user lands on a Tiki page from a search engine, Tiki highlights the search words they used. Its similar to using Tiki’s search facility" => "When a user lands on a Tiki page from a search engine, Tiki highlights the search words they used. Its similar to using Tiki’s search facility",
"Search statistics" => "搜尋統計",
// "Enables administrators to collect and view statistics on search activity" => "Enables administrators to collect and view statistics on search activity",
// "Ignore individual object permissions" => "Ignore individual object permissions",
// "Object filter" => "Object filter",
// "Enables object type filters to be displayed above the search results to further reduce search results by object type" => "Enables object type filters to be displayed above the search results to further reduce search results by object type",
// "Search box" => "Search box",
// "Shows a search box above the search results to do additional searches" => "Shows a search box above the search results to do additional searches",
// "Include the number of visits in the search results" => "Include the number of visits in the search results",
"Relevance" => "相當",
// "Display Tiki's estimate of the relevance of search matches in the search results" => "Display Tiki's estimate of the relevance of search matches in the search results",
// "Object type" => "Object type",
// "Shows object type filters above the search results to further reduce search results by object type" => "Shows object type filters above the search results to further reduce search results by object type",
// "Last-modified date" => "Last-modified date",
// "Show the last-modified date in search results" => "Show the last-modified date in search results",
// "Users can see several charts or rankings about the page" => "Users can see several charts or rankings about the page",
// "Custom blog headings" => "Custom blog headings",
// "Using custom blog headings will use significantly more server resources. Unless you need per-blog templates, you should customize the template file instead" => "Using custom blog headings will use significantly more server resources. Unless you need per-blog templates, you should customize the template file instead",
// "Publish dates can be modified" => "Publish dates can be modified",
// "Blog post Comments" => "Blog post Comments",
// "Users can view the “top” or “most” downloaded files" => "Users can view the “top” or “most” downloaded files",
// "File gallery comments" => "File gallery comments",
// "Store user files in a file gallery" => "Store user files in a file gallery",
// "Use the file gallery admin and the individual file gallery settings to manage file storage preferences" => "Use the file gallery admin and the individual file gallery settings to manage file storage preferences",
// "userfiles" => "userfiles",
// "Use file galleries for wiki attachments" => "Use file galleries for wiki attachments",
// "Wiki attachments will be stored in the file gallery" => "Wiki attachments will be stored in the file gallery",
// "Batch uploading" => "Batch uploading",
// "Direct import of local files into a file gallery. This method can handle large files. The user can upload files via FTP to the target folder. It is highly recommended to use a file directory as the file gallery storage when using this feature" => "Direct import of local files into a file gallery. This method can handle large files. The user can upload files via FTP to the target folder. It is highly recommended to use a file directory as the file gallery storage when using this feature",
"Accept wiki syntax" => "接受 wiki 語法",
// "Topic archiving" => "Topic archiving",
// "Quick jumps" => "Quick jumps",
// "Replies are empty" => "Replies are empty",
// "If disabled, replies will quote the original post" => "If disabled, replies will quote the original post",
// "Allows quoting in flat forums" => "Allows quoting in flat forums",
// "Allows users to reply" => "Allows users to reply",
// "First post of a thread can have an empty body" => "First post of a thread can have an empty body",
// "Will be a thread title" => "Will be a thread title",
// "Forum name search" => "Forum name search",
// "When listing forums" => "When listing forums",
// "Forum content search" => "Forum content search",
// "Topic content search" => "Topic content search",
// "Tiki-indexed search" => "Tiki-indexed search",
// "Use database (full-text) search" => "Use database (full-text) search",
// "Index posts on forum section change" => "Index posts on forum section change",
// "Re-indexes forum posts to match the parent section when the section is changed" => "Re-indexes forum posts to match the parent section when the section is changed",
"Edit CSS" => "編輯 CSS",
// "Edit CSS files directly in the browser" => "Edit CSS files directly in the browser",
// "May not be functional in Tiki 14+" => "May not be functional in Tiki 14+",
"Theme Control" => "佈景主題控制",
// "Assign different themes to various sections, categories, and objects" => "Assign different themes to various sections, categories, and objects",
// "design themes" => "design themes",
// "Tiki template viewing" => "Tiki template viewing",
"Edit templates" => "編輯模板",
// "Custom HTML head content" => "Custom HTML head content",
// "Additional content such at meta or link tags can be added to the head section of HTML files. Smarty filters can be used here" => "Additional content such at meta or link tags can be added to the head section of HTML files. Smarty filters can be used here",
// "Add base tag in the HTML head section" => "Add base tag in the HTML head section",
// "The base tag specifies a default address for all links on a page" => "The base tag specifies a default address for all links on a page",
// "Site logo and title" => "Site logo and title",
// "Display a site logo image and/or title in the page header area" => "Display a site logo image and/or title in the page header area",
// "This setting is expected to be moved from here to the admin-modules page" => "This setting is expected to be moved from here to the admin-modules page",
"Left column" => "左欄",
// "Controls visibility of the left column of modules" => "Controls visibility of the left column of modules",
// "sidebar" => "sidebar",
// "Only if one or more modules are assigned" => "Only if one or more modules are assigned",
// "Always" => "Always",
// "User decides" => "User decides",
"Right column" => "右欄",
// "Controls visibility of the right column of modules" => "Controls visibility of the right column of modules",
// "Prefix breadcrumbs with \"Location : \"" => "Prefix breadcrumbs with \"Location : \"",
// "Place the term \"Location:\" in the breadcrumbs" => "Place the term \"Location:\" in the breadcrumbs",
// "Site location bar" => "Site location bar",
// "Use breadcrumbs module" => "Use breadcrumbs module",
// "Top of center column" => "Top of center column",
// "Larger font" => "Larger font",
// "Entire location" => "Entire location",
"Page name" => "頁面名稱",
"Use page description" => "使用頁面描述",
// "Extreme top of page, above the site logo, etc" => "Extreme top of page, above the site logo, etc",
// "Custom code just before the closing </body> tag" => "Custom code just before the closing </body> tag",
// "Enter lines here to be placed near the end of the HTML file" => "Enter lines here to be placed near the end of the HTML file",
// "Webmaster report" => "Webmaster report",
// "Activate the feature to report a problematic page to the webmaster." => "Activate the feature to report a problematic page to the webmaster.",
// "Webmaster email" => "Webmaster email",
// "Leave blank to use the default sender email" => "Leave blank to use the default sender email",
// "A specific email address can be set for receiving the webmaster reports" => "A specific email address can be set for receiving the webmaster reports",
// "Email this page" => "Email this page",
// "Adds a link at the bottom if set, otherwise adds a link at the top" => "Adds a link at the bottom if set, otherwise adds a link at the top",
// "This enables users to share a page with others, by emailing a short message and link to the page" => "This enables users to share a page with others, by emailing a short message and link to the page",
// "Shadow layer" => "Shadow layer",
// "Additional div elements for shadows, radiused corners or other decorative styling" => "Additional div elements for shadows, radiused corners or other decorative styling",
// "Tooltips" => "Tooltips",
// "Enable tooltips such as this to have a custom appearance, styled by CSS" => "Enable tooltips such as this to have a custom appearance, styled by CSS",
// "Provides various dropdown menus on many text input boxes for page names, user names, groups, tags, etc" => "Provides various dropdown menus on many text input boxes for page names, user names, groups, tags, etc",
// "Superfish" => "Superfish",
// "Adds animation effects to CSS \"Suckerfish\" menus" => "Adds animation effects to CSS \"Suckerfish\" menus",
// "Reflection" => "Reflection",
// "Creates a reflection under an image. Used in Plugin Img with the parameter \"class=reflect\"" => "Creates a reflection under an image. Used in Plugin Img with the parameter \"class=reflect\"",
// "JQuery UI" => "JQuery UI",
// "Include jQuery UI library. Enables a number of interface features" => "Include jQuery UI library. Enables a number of interface features",
// "jQuery UI theme" => "jQuery UI theme",
// "jQuery UI theme. Used in some modal popups and in the TikiSheet feature, etc" => "jQuery UI theme. Used in some modal popups and in the TikiSheet feature, etc",
// "Validation" => "Validation",
// "Provides various validation possibilities such as for trackers" => "Provides various validation possibilities such as for trackers",
// "jQuery infinite carousel" => "jQuery infinite carousel",
// "Create a slideshow (like an image carousel) for file galleries. Used in Plugin Carousel" => "Create a slideshow (like an image carousel) for file galleries. Used in Plugin Carousel",
// "jQuery sortable tables" => "jQuery sortable tables",
// "Provides an interactive way to sort and filter data in tables produced with Plugin FancyTable and Plugin TrackerList, as well as administrative tables" => "Provides an interactive way to sort and filter data in tables produced with Plugin FancyTable and Plugin TrackerList, as well as administrative tables",
// "jQuery media" => "jQuery media",
// "Provides a media player via Plugin MediaPlayer that can be used in wiki pages or other wiki text area to play media files including .flv, .mp3, .mp4, .swf, .avi, .wmv, .ram, .mov, .mpeg, and .pdf. A Flash-based open source media player is used" => "Provides a media player via Plugin MediaPlayer that can be used in wiki pages or other wiki text area to play media files including .flv, .mp3, .mp4, .swf, .avi, .wmv, .ram, .mov, .mpeg, and .pdf. A Flash-based open source media player is used",
// "TagCanvas" => "TagCanvas",
// "TagCanvas is a Javascript class which will draw and animate an HTML5 canvas-based tag cloud" => "TagCanvas is a Javascript class which will draw and animate an HTML5 canvas-based tag cloud",
// "jQuery zoom" => "jQuery zoom",
// "Enables zoom in images on mouseover or click. Used in Plugin Img with the parameter \\\"thumb=zoombox\\\"" => "Enables zoom in images on mouseover or click. Used in Plugin Img with the parameter \\\"thumb=zoombox\\\"",
// "Use tabs" => "Use tabs",
// "Separates page content into tabbed panels" => "Separates page content into tabbed panels",
// "Wiki content templates" => "Wiki content templates",
// "Prewritten content (probably partial content) for a wiki page" => "Prewritten content (probably partial content) for a wiki page",
// "Warn on edit conflict" => "Warn on edit conflict",
// "When a user is editing a page, the edit button will be colored red and the name of the user editing the page will be displayed as a tooltip. If the user saves or cancels his or her edit or if the indicated amount of time passes the edit button will be displayed normally. This feature is useful to prevent collisions when editing pages" => "When a user is editing a page, the edit button will be colored red and the name of the user editing the page will be displayed as a tooltip. If the user saves or cancels his or her edit or if the indicated amount of time passes the edit button will be displayed normally. This feature is useful to prevent collisions when editing pages",
"Undo" => "回復",
"Footnotes" => "註腳",
// "Logged-in users can write personal footnotes when editing a page. The footnotes display immediately below the wiki page only to the user who edited it. This is a good way for users to make personal notes about pages." => "Logged-in users can write personal footnotes when editing a page. The footnotes display immediately below the wiki page only to the user who edited it. This is a good way for users to make personal notes about pages.",
"Allow HTML" => "允許 HTML",
// "Per-page option: HTML tags are used to create elements of the wiki page, instead of being displayed as code" => "Per-page option: HTML tags are used to create elements of the wiki page, instead of being displayed as code",
// "This is potentially dangerous, as it allows raw HTML to be added. Be sure to enable this option only if trusted users can create and edit menus" => "This is potentially dangerous, as it allows raw HTML to be added. Be sure to enable this option only if trusted users can create and edit menus",
// "Log bytes changes (+/-) in action logs" => "Log bytes changes (+/-) in action logs",
// "May impact performance" => "May impact performance",
"Sandbox" => "沙池",
// "A <a href=\"/tiki-editpage.php?page=SandBox\">special page</a> to test the wiki feature that can edited, but the content is not saved" => "A <a href=\"/tiki-editpage.php?page=SandBox\">special page</a> to test the wiki feature that can edited, but the content is not saved",
// "Comments below wiki pages" => "Comments below wiki pages",
// "Allow users to upload images to a page" => "Allow users to upload images to a page",
// "Users can export individual pages and structure pages content as a file (requires tiki_p_admin_wiki permission)" => "Users can export individual pages and structure pages content as a file (requires tiki_p_admin_wiki permission)",
// "WikiWords" => "WikiWords",
// "Automatically convert \\\"CamelCase\\\" words into wiki links" => "Automatically convert \\\"CamelCase\\\" words into wiki links",
// "Link plural WikiWords to their singular forms" => "Link plural WikiWords to their singular forms",
// "Accept dashes and underscores in WikiWords" => "Accept dashes and underscores in WikiWords",
"History" => "歷史紀錄",
// "Users (with permission) can see the history of each wiki page" => "Users (with permission) can see the history of each wiki page",
// "Display IP address" => "Display IP address",
// "Wiki full history" => "Wiki full history",
// "Record all versions, rather than only when page content or description changes or when an edit comment is given" => "Record all versions, rather than only when page content or description changes or when an edit comment is given",
// "View page contributions by author" => "View page contributions by author",
// "Visualize the contributions that different authors have made to a wiki page" => "Visualize the contributions that different authors have made to a wiki page",
"Discuss pages on forums" => "在論壇上討論頁面",
// "Enabling the option will add, on each wiki page, a Discuss button that links to a forum thread dedicated to discussion of the particular page" => "Enabling the option will add, on each wiki page, a Discuss button that links to a forum thread dedicated to discussion of the particular page",
// "View source" => "View source",
// "Users (with permission) can see the wiki and/or HTML syntax of the page" => "Users (with permission) can see the wiki and/or HTML syntax of the page",
// "Enables adding a poll from the polls feature to a wiki page. The poll is unique to the page, created from a “poll template” which is created in the Polls feature: set a poll’s ‘active’ drop-down to “template”" => "Enables adding a poll from the polls feature to a wiki page. The poll is unique to the page, created from a “poll template” which is created in the Polls feature: set a poll’s ‘active’ drop-down to “template”",
// "Present a list of pages that link to the current page" => "Present a list of pages that link to the current page",
// "Similar pages" => "Similar pages",
// "Display a list of pages named similarly to the current page" => "Display a list of pages named similarly to the current page",
"Structures" => "結構",
// "Structures allow grouping any number of wiki pages in a hierarchy, with a common navigation bar and the option to print them all together as a single HTML document" => "Structures allow grouping any number of wiki pages in a hierarchy, with a common navigation bar and the option to print them all together as a single HTML document",
// "Structures drill down menu" => "Structures drill down menu",
// "Ajax-style menu in which the user moves through the page hierarchy by clicking to reveal the next level down" => "Ajax-style menu in which the user moves through the page hierarchy by clicking to reveal the next level down",
// "Open page as structure" => "Open page as structure",
// "Open a page within its structure (with structure navigation, etc.), even if no structure parameter is given in the URL" => "Open a page within its structure (with structure navigation, etc.), even if no structure parameter is given in the URL",
// "Make structure from page" => "Make structure from page",
// "Show a button below each wiki page to allow converting it from a simple wiki page into the root page of a new structure" => "Show a button below each wiki page to allow converting it from a simple wiki page into the root page of a new structure",
// "Categorize structure pages together" => "Categorize structure pages together",
// "Place new pages of a structure in the same category as the structure's root page" => "Place new pages of a structure in the same category as the structure's root page",
// "Disable inherited direct object permissions" => "Disable inherited direct object permissions",
// "Normally pages will inherit object permissions from their parent page. However, object permissions override category permissions. So, if you are relying on category permissions in structures, you may want to consider this setting, in order to disable inheritance of direct object permissions when adding pages from a structure" => "Normally pages will inherit object permissions from their parent page. However, object permissions override category permissions. So, if you are relying on category permissions in structures, you may want to consider this setting, in order to disable inheritance of direct object permissions when adding pages from a structure",
// "Create webhelp from structure" => "Create webhelp from structure",
// "If enabled, the Structure Admin page will include a new option for generating WebHelp (a self-contained, HTML “help” version of the wikii structure). Use this option to distribute wiki pages to offline users in a usable format" => "If enabled, the Structure Admin page will include a new option for generating WebHelp (a self-contained, HTML “help” version of the wikii structure). Use this option to distribute wiki pages to offline users in a usable format",
// "Import HTML" => "Import HTML",
// "Enable import of HTML pages" => "Enable import of HTML pages",
// "Use date parameter" => "Use date parameter",
// "Allow wiki page version to be selected from a parameter \"date\" on the url" => "Allow wiki page version to be selected from a parameter \"date\" on the url",
// "Report it in wiki links" => "Report it in wiki links",
// "Add the date parameter to wiki links" => "Add the date parameter to wiki links",
// "Import pages" => "Import pages",
// "A personal wiki page for each user" => "A personal wiki page for each user",
// "Userpage prefix" => "Userpage prefix",
// "All userpages share a common prefix. The page name will be a concatenation of the prefix and the username. A prefix is required" => "All userpages share a common prefix. The page name will be a concatenation of the prefix and the username. A prefix is required",
// "Users can lock pages" => "Users can lock pages",
// "Enable users to lock pages and so prevent others from editing them" => "Enable users to lock pages and so prevent others from editing them",
"MultiPrint" => "多重列印",
// "Enable printing of multiple wiki pages as well as an entire structure of wiki pages as a book in a single HTML document" => "Enable printing of multiple wiki pages as well as an entire structure of wiki pages as a book in a single HTML document",
// "Print Wiki" => "Print Wiki",
// "Provide a print icon and layout of the wiki page formatted for printing" => "Provide a print icon and layout of the wiki page formatted for printing",
// "Pages not in structure" => "Pages not in structure",
// "Users (with permission) can see the sortable, searchable list of wiki pages (tiki-listpages.php). Use the Configuration area to specify which items to display" => "Users (with permission) can see the sortable, searchable list of wiki pages (tiki-listpages.php). Use the Configuration area to specify which items to display",
"Attachments" => "附件",
// "Allow users to upload (attach) files to a page" => "Allow users to upload (attach) files to a page",
// "Limit wiki page categories to those under this category" => "Limit wiki page categories to those under this category",
// "If an error message indicates a mandatory category is required when editing a wiki page, set this option to \"None\"" => "If an error message indicates a mandatory category is required when editing a wiki page, set this option to \"None\"",
// "Show/hide icon before headings" => "Show/hide icon before headings",
// "For use with the !!- or !!+ syntax. Activating this will display the show/hide icon at the left of the heading; otherwise, it displays below" => "For use with the !!- or !!+ syntax. Activating this will display the show/hide icon at the left of the heading; otherwise, it displays below",
// "Wiki argument variables" => "Wiki argument variables",
// "Allow writing request variables in wiki content using {{paramname}} or {{paramname|default}} - special case {{page}} {{user}}" => "Allow writing request variables in wiki content using {{paramname}} or {{paramname|default}} - special case {{page}} {{user}}",
// "Users can choose to stay in SSL mode after an HTTPS login" => "Users can choose to stay in SSL mode after an HTTPS login",
// "Users can switch between secured or standard mode at login" => "Users can switch between secured or standard mode at login",
// "Wiki paragraph formatting" => "Wiki paragraph formatting",
// "Because the wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs.  Lines can be of any length, and will be wrapped together with the next line.  Paragraphs are separated by blank lines" => "Because the wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs.  Lines can be of any length, and will be wrapped together with the next line.  Paragraphs are separated by blank lines",
// "Because the Wiki paragraph formatting feature is off, each line will be presented as you write it.  This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line" => "Because the Wiki paragraph formatting feature is off, each line will be presented as you write it.  This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line",
// "Create line breaks within paragraphs" => "Create line breaks within paragraphs",
// "When Wiki paragraph formatting is enabled, this option creates line breaks within paragraphs" => "When Wiki paragraph formatting is enabled, this option creates line breaks within paragraphs",
"Automonospaced text" => "自動使用固定寬度文字",
// "Lines indented with spaces will automatically be converted to monospace font" => "Lines indented with spaces will automatically be converted to monospace font",
"Tables syntax" => "表格語法",
"|| for rows" => "|| 表示一列",
"<return> for rows" => "\n 表示一列",
// "AutoLinks" => "AutoLinks",
// "Web (http://) and email addresses will automatically be converted to links" => "Web (http://) and email addresses will automatically be converted to links",
"Hotwords" => "熱門單字",
// "Open hotwords in new window" => "Open hotwords in new window",
// "Characters that limit a hotword" => "Characters that limit a hotword",
// "Use Quote plugin rather than \">\" for quoting" => "Use Quote plugin rather than \">\" for quoting",
// "Center text using ::: instead of :" => "Center text using ::: instead of :",
// "Useful to avoid conflicts with C++ scope operators or default namespace separator" => "Useful to avoid conflicts with C++ scope operators or default namespace separator",
// "String to use to delimit simplebox" => "String to use to delimit simplebox",
// "Users can choose to show their gender" => "Users can choose to show their gender",
// "Real name" => "Real name",
// "Gender" => "Gender",
// "Profile picture (avatar)" => "Profile picture (avatar)",
"Country" => "國家",
"Last login" => "最近登入",
// "Distance" => "Distance",
// "Manual selection of time/date" => "Manual selection of time/date",
// "WebDAV access to Tiki" => "WebDAV access to Tiki",
// "Allow file gallery access with WebDAV" => "Allow file gallery access with WebDAV",
// "use tiki-webdav.php as the URI of the WebDAV repository" => "use tiki-webdav.php as the URI of the WebDAV repository",
// "Fixed width" => "Fixed width",
// "Restrict the width of the site content area, in contrast to a liquid (full-width) layout" => "Restrict the width of the site content area, in contrast to a liquid (full-width) layout",
// "Social networks" => "Social networks",
// "Integration with social applications and networks like Twitter and Facebook" => "Integration with social applications and networks like Twitter and Facebook",
// "Group transition" => "Group transition",
// "Enables transitions for users between different groups. Transitions will create a user approval workflow" => "Enables transitions for users between different groups. Transitions will create a user approval workflow",
// "Category transition" => "Category transition",
// "Enables transitions for objects between different categories. Transitions will create a document workflow" => "Enables transitions for objects between different categories. Transitions will create a document workflow",
// "Tiki user credits" => "Tiki user credits",
// "Invite users" => "Invite users",
// "Allow users to invite new users to register at this site, by sending an email" => "Allow users to invite new users to register at this site, by sending an email",
// "Alternate registration page" => "Alternate registration page",
// "Enter URL of a custom registration page. Tiki will automatically redirect default registration page (tiki-register.php) to this page" => "Enter URL of a custom registration page. Tiki will automatically redirect default registration page (tiki-register.php) to this page",
// "Load balancer" => "Load balancer",
// "Activate this only if the server is behind a load balancer (or reverse proxy). This enables logging the IP of the user rather than the IP of the proxy server" => "Activate this only if the server is behind a load balancer (or reverse proxy). This enables logging the IP of the user rather than the IP of the proxy server",
// "Tiki is behind a frontend-proxy/load-balancer that rewrites ports" => "Tiki is behind a frontend-proxy/load-balancer that rewrites ports",
// "Activate this only if the server is behind a frontend-proxy/load-balancer (or reverse proxy) that rewrites ports. This enables Tiki to use the HTTP_X_FORWARDED_PROTO parameter set by the proxy, to provide correct links" => "Activate this only if the server is behind a frontend-proxy/load-balancer (or reverse proxy) that rewrites ports. This enables Tiki to use the HTTP_X_FORWARDED_PROTO parameter set by the proxy, to provide correct links",
// "Accounting" => "Accounting",
// "Double-entry accounting system" => "Double-entry accounting system",
// "Code editor (CodeMirror)" => "Code editor (CodeMirror)",
// "CodeMirror code editor, which provides syntax highlighting" => "CodeMirror code editor, which provides syntax highlighting",
// "Syntax highlighter (CodeMirror) Theme" => "Syntax highlighter (CodeMirror) Theme",
// "CodeMirror themes (clear cache after changing)" => "CodeMirror themes (clear cache after changing)",
// "default" => "default",
// "Off (but switchable)" => "Off (but switchable)",
// "Dummy preference" => "Dummy preference",
// "This is useful for developers to learn how to create a new preference. HTML may be used" => "This is useful for developers to learn how to create a new preference. HTML may be used",
// "This is the detail" => "This is the detail",
// "This is the warning" => "This is the warning",
// "This is the hint. Wiki syntax may be used" => "This is the hint. Wiki syntax may be used",
// "This is the shorthint. Wiki syntax may be used" => "This is the shorthint. Wiki syntax may be used",
// "Time sheet" => "Time sheet",
// "A project time manager" => "A project time manager",
// "This feature will be removed after Tiki18 and before Tiki19" => "This feature will be removed after Tiki18 and before Tiki19",
// "HTML feed" => "HTML feed",
// "A way to transfer HTML content from one Tiki site to another" => "A way to transfer HTML content from one Tiki site to another",
// "Send an email notification to group leaders when a user joins" => "Send an email notification to group leaders when a user joins",
// "Send an email notification to group leaders when a user leaves" => "Send an email notification to group leaders when a user leaves",
// "Inline comments" => "Inline comments",
// "Contextual comments" => "Contextual comments",
// "Enable JavaScript plugin for equal-height rows" => "Enable JavaScript plugin for equal-height rows",
// "Enable responsive rows, the contained elements of which have the same height" => "Enable responsive rows, the contained elements of which have the same height",
// "Conditional formatting" => "Conditional formatting",
// "Use different coloring for certain system objects. Only groups are supported for now" => "Use different coloring for certain system objects. Only groups are supported for now",
// "Store session variable for current theme" => "Store session variable for current theme",
// "Store a session variable for current theme so that it can  be used for auto-selecting a category when categorizing" => "Store a session variable for current theme so that it can  be used for auto-selecting a category when categorizing",
// "Parent category of theme control categories" => "Parent category of theme control categories",
// "Choose the parent category of categories used for theme control" => "Choose the parent category of categories used for theme control",
// "Automatically select the theme-control category of the current theme when categorizing" => "Automatically select the theme-control category of the current theme when categorizing",
// "When creating or editing an object, automatically select the category that matches the theme-control category of the current theme" => "When creating or editing an object, automatically select the category that matches the theme-control category of the current theme",
// "Certain pages redirect to homepage when language is changed" => "Certain pages redirect to homepage when language is changed",
// "List of pages that redirect" => "List of pages that redirect",
// "List of names of pages that always redirect to the homepage when the language is switched" => "List of names of pages that always redirect to the homepage when the language is switched",
// "Separate page names by commas" => "Separate page names by commas",
// "User wizard" => "User wizard",
// "Wizard to help users set up their basic settings and account details" => "Wizard to help users set up their basic settings and account details",
// "Present different input fields in the User Wizard than are in the Registration form" => "Present different input fields in the User Wizard than are in the Registration form",
// "Ask a different set of fields for the User Details section in the User Wizard than the ones shown in the Registration form" => "Ask a different set of fields for the User Details section in the User Wizard than the ones shown in the Registration form",
// "Tracker fields presented in the User Wizard as User Details" => "Tracker fields presented in the User Wizard as User Details",
// "User's information tracker fields presented in the User Wizard as User Details (separate field IDs with colons)" => "User's information tracker fields presented in the User Wizard as User Details (separate field IDs with colons)",
// "Enable Typography Features" => "Enable Typography Features",
// "Features to replace normal characters with typographic equivalents" => "Features to replace normal characters with typographic equivalents",
// "Smart “curly” quotes" => "Smart “curly” quotes",
// "Convert \\\"straight\\\" quotes to “curly” ones, also convert ’ apostrophe and ‘single’ quotes" => "Convert \\\"straight\\\" quotes to “curly” ones, also convert ’ apostrophe and ‘single’ quotes",
// "Convert approximative ASCII quotes" => "Convert approximative ASCII quotes",
// "Convert plain-ASCII quote substitutes `` '\\" => "Convert plain-ASCII quote substitutes `` '\\",
// "Smart em-dash and ellipsis" => "Smart em-dash and ellipsis",
// "Convert double hyphen \\-- to em-dash — and three consecutive dots\\... to typographic ellipsis character…" => "Convert double hyphen \\-- to em-dash — and three consecutive dots\\... to typographic ellipsis character…",
// "Smart no-break space" => "Smart no-break space",
// "Prevents line breaks from occuring at unfortunate places in the text by replacing regular space character with no-break spaces where appropriate: around some punctuation, when used as thousand separator, and between a unit abbreviation and the number preceding it" => "Prevents line breaks from occuring at unfortunate places in the text by replacing regular space character with no-break spaces where appropriate: around some punctuation, when used as thousand separator, and between a unit abbreviation and the number preceding it",
// "Display only select calendars by default" => "Display only select calendars by default",
// "Master Tiki server" => "Master Tiki server",
// "Master Tiki server that this client will obtain user authorizations from" => "Master Tiki server that this client will obtain user authorizations from",
// "Overrides manually registered local users" => "Overrides manually registered local users",
// "Import user preferences" => "Import user preferences",
// "Client Tiki will copy the user preferences from the master server" => "Client Tiki will copy the user preferences from the master server",
// "This will overwrite local user preferences every time the user logs in" => "This will overwrite local user preferences every time the user logs in",
// "Import user groups" => "Import user groups",
// "Groups the user belongs to on the master server will be imported (along with their security definitions)" => "Groups the user belongs to on the master server will be imported (along with their security definitions)",
// "This will overwrite local groups every time a user logs in" => "This will overwrite local groups every time a user logs in",
// "Limit group import" => "Limit group import",
// "Comma-separated list of case-sensitive imported groups. Leave empty to avoid limitation" => "Comma-separated list of case-sensitive imported groups. Leave empty to avoid limitation",
// "This list will limit the group import feature to only those groups listed here" => "This list will limit the group import feature to only those groups listed here",
// "Intertiki shared cookie" => "Intertiki shared cookie",
// "Causes a user who logs into or out of either the slave or master site to be automatically logged into or out of all other sites" => "Causes a user who logs into or out of either the slave or master site to be automatically logged into or out of all other sites",
// "This site is a master server" => "This site is a master server",
// "Scheduler" => "Scheduler",
// "Provides the ability to run tasks at a scheduled time" => "Provides the ability to run tasks at a scheduled time",
// "Convert from absolute to relative link" => "Convert from absolute to relative link",
// "Process wiki text and convert internal links from absolute to relative links" => "Process wiki text and convert internal links from absolute to relative links",
// "It's recommended to set a cron job to periodically rebuild the search index" => "It's recommended to set a cron job to periodically rebuild the search index",
// "HTML Purifier is a standards-compliant HTML filter library written in PHP and integrated in Tiki. HTML Purifier will not only remove all malicious code (better known as XSS) with a thoroughly audited, secure yet permissive whitelist, it will also ensure that your documents are standards-compliant. Keep in mind that HTML Purifier is not HTML5 compatible and may rewrite HTML5 syntax and produce unwanted results" => "HTML Purifier is a standards-compliant HTML filter library written in PHP and integrated in Tiki. HTML Purifier will not only remove all malicious code (better known as XSS) with a thoroughly audited, secure yet permissive whitelist, it will also ensure that your documents are standards-compliant. Keep in mind that HTML Purifier is not HTML5 compatible and may rewrite HTML5 syntax and produce unwanted results",
// "Show user's contribution on the user information page" => "Show user's contribution on the user information page",
// "View user's contribution on the user information page" => "View user's contribution on the user information page",
// "Users' drawings are stored in their user files gallery" => "Users' drawings are stored in their user files gallery",
// "Nofollow is used to instruct some search engines that the link should not influence the ranking of the link's target in the search engine's index" => "Nofollow is used to instruct some search engines that the link should not influence the ranking of the link's target in the search engine's index",
// "If this is a testing site with duplicate content, you may want to put the real site domain here so search engines don't index the testing site. In complex perspective setups using multiple domains, you may want more control on which canonical domain is advertised" => "If this is a testing site with duplicate content, you may want to put the real site domain here so search engines don't index the testing site. In complex perspective setups using multiple domains, you may want more control on which canonical domain is advertised",
// "Also known as 'Basic Search'. This search uses the MySQL full-text search feature. The indexation is continuously updated" => "Also known as 'Basic Search'. This search uses the MySQL full-text search feature. The indexation is continuously updated",
// "Deprecated: This feature is unmaintained and may not be reliable. InnoDB doesn't support Full-Text Search earlier than version 5.6" => "Deprecated: This feature is unmaintained and may not be reliable. InnoDB doesn't support Full-Text Search earlier than version 5.6",
// "Require file creator's name for anonymous uploads" => "Require file creator's name for anonymous uploads",
// "Redirect to similar wiki page" => "Redirect to similar wiki page",
// "If a requested page doesn't exist, redirect to a similarly named page" => "If a requested page doesn't exist, redirect to a similarly named page",
// "Redirect to page alias, if any" => "Redirect to page alias, if any",
// "If a requested page doesn't exist, redirect to an alias page, if specified using an alias semantic link" => "If a requested page doesn't exist, redirect to an alias page, if specified using an alias semantic link",
// "User's information page" => "User's information page",
// "Display a user's gender if permitted by the user" => "Display a user's gender if permitted by the user",
// "Allow showing user's information on mouseover" => "Allow showing user's information on mouseover",
// "Show users' information on mouseover" => "Show users' information on mouseover",
// "Requires user's information to be public" => "Requires user's information to be public",
// "Show the user's real name" => "Show the user's real name",
// "Federated search" => "Federated search",
// "Search through alternate site indices" => "Search through alternate site indices",
// "Elasticsearch is required" => "Elasticsearch is required",
// "Elasticsearch tribe node URL" => "Elasticsearch tribe node URL",
// "URL of the tribe client node accessing multiple clusters" => "URL of the tribe client node accessing multiple clusters",
// "Default feed format" => "Default feed format",
// "ATOM 1.0" => "ATOM 1.0",
// "RSS 2.0" => "RSS 2.0",
// "Feed author name" => "Feed author name",
// "Default author of each item in the feed" => "Default author of each item in the feed",
// "This field is mandatory unless both feed author email and homepage are empty" => "This field is mandatory unless both feed author email and homepage are empty",
// "Feed author email" => "Feed author email",
// "Email of the author of each item in the feed" => "Email of the author of each item in the feed",
// "Feed author homepage" => "Feed author homepage",
// "Homepage URL of the author of each item in the feed" => "Homepage URL of the author of each item in the feed",
// "Feed editor email" => "Feed editor email",
// "Email address for person responsible for editorial content" => "Email address for person responsible for editorial content",
// "Feed webmaster email" => "Feed webmaster email",
// "Email address for person responsible for technical issues relating to channel" => "Email address for person responsible for technical issues relating to channel",
// "Feed image path" => "Feed image path",
// "Specifies a GIF, JPEG or PNG image that can be displayed with the feed" => "Specifies a GIF, JPEG or PNG image that can be displayed with the feed",
// "Feed language" => "Feed language",
// "The default language for this feed" => "The default language for this feed",
// "RSS basic authentication" => "RSS basic authentication",
// "Propose basic HTTP authentication if the user has no permission to see the feed" => "Propose basic HTTP authentication if the user has no permission to see the feed",
// "Feed caching time" => "Feed caching time",
// "Cache the feed for this number of seconds" => "Cache the feed for this number of seconds",
// "Use 0 for no caching" => "Use 0 for no caching",
// "Feed caching is done for anonymous users only" => "Feed caching is done for anonymous users only",
// "RSS for articles" => "RSS for articles",
// "RSS feeds for articles" => "RSS feeds for articles",
// "RSS for blogs" => "RSS for blogs",
// "RSS feeds for blogs" => "RSS feeds for blogs",
// "RSS for individual blogs" => "RSS for individual blogs",
// "RSS feeds for individual blogs" => "RSS feeds for individual blogs",
// "RSS for image galleries" => "RSS for image galleries",
// "RSS feed for image galleries" => "RSS feed for image galleries",
// "RSS for individual image galleries" => "RSS for individual image galleries",
// "RSS feeds for individual image galleries" => "RSS feeds for individual image galleries",
// "RSS for file galleries" => "RSS for file galleries",
// "RSS feed for file galleries" => "RSS feed for file galleries",
// "RSS for individual file galleries" => "RSS for individual file galleries",
// "RSS feeds for individual file galleries" => "RSS feeds for individual file galleries",
// "RSS for wiki pages" => "RSS for wiki pages",
// "RSS feed for wiki pages" => "RSS feed for wiki pages",
// "RSS for forums" => "RSS for forums",
// "RSS feed for forums" => "RSS feed for forums",
// "RSS for individual forums" => "RSS for individual forums",
// "RSS feeds for individual forums" => "RSS feeds for individual forums",
// "RSS per tracker" => "RSS per tracker",
// "RSS feed per tracker" => "RSS feed per tracker",
// "RSS for calendar events" => "RSS for calendar events",
// "RSS feed for calendar events" => "RSS feed for calendar events",
// "RSS for directories" => "RSS for directories",
// "RSS feed for directories" => "RSS feed for directories",
// "RSS for shoutbox" => "RSS for shoutbox",
// "RSS feed for shoutbox" => "RSS feed for shoutbox",
// "Maximum number of items to display" => "Maximum number of items to display",
// "items" => "items",
// "Show author" => "Show author",
// "Homepage URL" => "Homepage URL",
// "Tiki RSS feed for articles" => "Tiki RSS feed for articles",
// "Tiki RSS feed for blogs" => "Tiki RSS feed for blogs",
// "Title to be prepended to the blog title for all blogs. If this field is empty only the blog title will be used" => "Title to be prepended to the blog title for all blogs. If this field is empty only the blog title will be used",
// "Tiki RSS feed for image galleries" => "Tiki RSS feed for image galleries",
// "Tiki RSS feed for the image gallery: " => "Tiki RSS feed for the image gallery: ",
// "Tiki RSS feed for file galleries" => "Tiki RSS feed for file galleries",
// "Tiki RSS feed for the file gallery: " => "Tiki RSS feed for the file gallery: ",
// "Tiki RSS feed for the wiki pages" => "Tiki RSS feed for the wiki pages",
// "Tiki RSS feed for forums" => "Tiki RSS feed for forums",
// "Tiki RSS feed for forum: " => "Tiki RSS feed for forum: ",
// "Tiki RSS feed for individual trackers: " => "Tiki RSS feed for individual trackers: ",
// "Tiki RSS feed for calendars" => "Tiki RSS feed for calendars",
// "Tiki RSS feed for directory sites" => "Tiki RSS feed for directory sites",
// "Tiki RSS feed for shoutbox messages" => "Tiki RSS feed for shoutbox messages",
// "Article RSS description" => "Article RSS description",
// "Description to be published as part of the RSS feed for articles" => "Description to be published as part of the RSS feed for articles",
// "Last articles" => "Last articles",
// "Blogs RSS description" => "Blogs RSS description",
// "Description to be published as part of the RSS feed for blogs" => "Description to be published as part of the RSS feed for blogs",
// "Last posts to weblogs" => "Last posts to weblogs",
// "Blog RSS Description" => "Blog RSS Description",
// "Description to be prepended to the blog description and published as part of the RSS feeds for individual blogs. If this field is empty, the blog description only will be used" => "Description to be prepended to the blog description and published as part of the RSS feeds for individual blogs. If this field is empty, the blog description only will be used",
// "Image galleries RSS description" => "Image galleries RSS description",
// "Description to be published as part of the RSS feed for image galleries" => "Description to be published as part of the RSS feed for image galleries",
// "Latest images uploaded to the image galleries" => "Latest images uploaded to the image galleries",
// "Individual image galleries RSS Description" => "Individual image galleries RSS Description",
// "Description to be published as part of the RSS feeds for individual image galleries" => "Description to be published as part of the RSS feeds for individual image galleries",
// "Latest images uploaded to this image gallery" => "Latest images uploaded to this image gallery",
// "File galleries RSS description" => "File galleries RSS description",
// "Description to be published as part of the RSS feed for file galleries" => "Description to be published as part of the RSS feed for file galleries",
// "Latest files uploaded to the file galleries" => "Latest files uploaded to the file galleries",
// "Individual file galleries RSS description" => "Individual file galleries RSS description",
// "Description to be published as part of the RSS feeds for individual file galleries" => "Description to be published as part of the RSS feeds for individual file galleries",
// "Latest files uploaded to this file gallery" => "Latest files uploaded to this file gallery",
// "Wiki pages RSS description" => "Wiki pages RSS description",
// "Description to be published as part of the RSS feed for wiki pages pages" => "Description to be published as part of the RSS feed for wiki pages pages",
// "Latest wiki page changes" => "Latest wiki page changes",
// "Forums RSS description" => "Forums RSS description",
// "Description to be published as part of the RSS feed for forums" => "Description to be published as part of the RSS feed for forums",
// "Latest forum topics" => "Latest forum topics",
// "Individual forums RSS description" => "Individual forums RSS description",
// "Description to be published as part of the RSS feeds for individual forums" => "Description to be published as part of the RSS feeds for individual forums",
// "Latest posts to this form" => "Latest posts to this form",
// "Individual trackers RSS description" => "Individual trackers RSS description",
// "Description to be published as part of the RSS feed for individual trackers" => "Description to be published as part of the RSS feed for individual trackers",
// "Latest additions to this tracker" => "Latest additions to this tracker",
// "Calendar events RSS description" => "Calendar events RSS description",
// "Description to be published as part of the RSS feed for calendar events" => "Description to be published as part of the RSS feed for calendar events",
"Upcoming Events" => "近期事件",
// "Directories RSS description" => "Directories RSS description",
// "Description to be published as part of the RSS feed for directories" => "Description to be published as part of the RSS feed for directories",
// "Latest sites" => "Latest sites",
// "Shoutbox RSS description" => "Shoutbox RSS description",
// "Description to be published as part of the RSS feed for shoutbox messages" => "Description to be published as part of the RSS feed for shoutbox messages",
// "Latest shoutbox messages" => "Latest shoutbox messages",
// "Tracker labels" => "Tracker labels",
// "Include tracker field labels in the RSS output" => "Include tracker field labels in the RSS output",
"Page" => "頁面",
// "Finder view" => "Finder view",
// "Show as a column" => "Show as a column",
// "Show in popup box" => "Show in popup box",
// "Both" => "Both",
// "Podcast directory" => "Podcast directory",
// "File system directory for storing podcast files" => "File system directory for storing podcast files",
// "The server must be able to read/write the directory" => "The server must be able to read/write the directory",
// "Required for podcasts" => "Required for podcasts",
// "To enable and use directory batch loading, set up a web-readable directory (preferably outside the web space). Then upload files to that directory, such as with SCP, FTP, etc" => "To enable and use directory batch loading, set up a web-readable directory (preferably outside the web space). Then upload files to that directory, such as with SCP, FTP, etc",
// "The server must be able to read the directory" => "The server must be able to read the directory",
// "The directory can be outside the web space" => "The directory can be outside the web space",
// "Prevent download if score becomes negative" => "Prevent download if score becomes negative",
// "If using Tiki Score system, users with a negative score cannot download files" => "If using Tiki Score system, users with a negative score cannot download files",
// "Allow download limit per file" => "Allow download limit per file",
// "Allow file duplicates" => "Allow file duplicates",
// "Allow the same file to be uploaded more than once" => "Allow the same file to be uploaded more than once",
// "Yes, even in the same gallery" => "Yes, even in the same gallery",
// "Only in different galleries" => "Only in different galleries",
// "Display ZIP option in gallery" => "Display ZIP option in gallery",
// "Users can upload a .zip (archive file). Tiki will automatically un-zip the archive and add each file to the gallery." => "Users can upload a .zip (archive file). Tiki will automatically un-zip the archive and add each file to the gallery.",
// "Must match" => "Must match",
// "A regular expression that must be matched to accept the file example A-Za-z* (filename can only have a-z letters) \nFor example, if you want to require that uploads must have a wordprocessing file extension, you could enter .*.(odt|sxw|doc|dot|rtf|wpt|frm|wpd|txt|ODT|SXW|DOC|DOT|RTF|WPT|FRM|WPD|TXT)" => "A regular expression that must be matched to accept the file example A-Za-z* (filename can only have a-z letters) \nFor example, if you want to require that uploads must have a wordprocessing file extension, you could enter .*.(odt|sxw|doc|dot|rtf|wpt|frm|wpd|txt|ODT|SXW|DOC|DOT|RTF|WPT|FRM|WPD|TXT)",
// "Cannot match" => "Cannot match",
// "A regular expression that, if matched, causes the file to be rejected. For example, .gif rejects gif images. Note that the period must be escaped since a regular expression is being used. If you don’t know anything about regular expressions just leave the fields blank and all the files will be accepted" => "A regular expression that, if matched, causes the file to be rejected. For example, .gif rejects gif images. Note that the period must be escaped since a regular expression is being used. If you don’t know anything about regular expressions just leave the fields blank and all the files will be accepted",
// "Quota for all files and archives" => "Quota for all files and archives",
// "The total size of files uploaded to all the file galleries or to a specific file gallery can be limited. The quota for a file gallery applies to that file gallery and all the file galleries under it. \nWhen the limit is reached, no more files can be uploaded. The user will see an explanatory error message. An email can be sent via the Mail notifications feature.)" => "The total size of files uploaded to all the file galleries or to a specific file gallery can be limited. The quota for a file gallery applies to that file gallery and all the file galleries under it. \nWhen the limit is reached, no more files can be uploaded. The user will see an explanatory error message. An email can be sent via the Mail notifications feature.)",
// "0 for unlimited" => "0 for unlimited",
// "megabytes" => "megabytes",
// "Quota for each file gallery" => "Quota for each file gallery",
// "A different quota can be defined for each file gallery" => "A different quota can be defined for each file gallery",
// "Default quota for each new gallery" => "Default quota for each new gallery",
// "Show quota bar in the list page" => "Show quota bar in the list page",
// "Yes, display bar and detail text" => "Yes, display bar and detail text",
// "Yes, display only bar" => "Yes, display only bar",
// "Yes, display only text" => "Yes, display only text",
// "Storage" => "Storage",
// "Specify if uploaded files should be stored in the database or file directory" => "Specify if uploaded files should be stored in the database or file directory",
// "Store in database" => "Store in database",
// "Store in directory" => "Store in directory",
// "Path to the directory to store file gallery files" => "Path to the directory to store file gallery files",
// "Searchable file gallery content" => "Searchable file gallery content",
// "Include the search form on the current gallery page just after \"Find\"" => "Include the search form on the current gallery page just after \"Find\"",
// "Include a search form in file galleries" => "Include a search form in file galleries",
// "Display hits ratio to maximum" => "Display hits ratio to maximum",
// "Display hits with a ratio of hits to maximum hits" => "Display hits with a ratio of hits to maximum hits",
// "Display properties in the context menu" => "Display properties in the context menu",
// "Display \"Replace\" in the context menu" => "Display \"Replace\" in the context menu",
// "Automatic deletion of old files" => "Automatic deletion of old files",
// "The user will have an option when uploading a file to specify the time after which the file is deleted" => "The user will have an option when uploading a file to specify the time after which the file is deleted",
// "A cron job must be set up in order to delete the files" => "A cron job must be set up in order to delete the files",
// "Allow action on multiple files or galleries" => "Allow action on multiple files or galleries",
// "Include \"Remove\" as an option for the checkbox action in file galleries" => "Include \"Remove\" as an option for the checkbox action in file galleries",
// "Deletion emails notification" => "Deletion emails notification",
// "Email addresses (comma-separated) to receive a copy of each deleted file" => "Email addresses (comma-separated) to receive a copy of each deleted file",
// "Keep the same fileId for the latest version of a file" => "Keep the same fileId for the latest version of a file",
// "If the checkbox is checked, the file ID of the latest version of a file stays the same. A link to the file will always link to the latest version. If not checked, each version of the file is assigned its own file ID, so a link to the file will be to a specific version of the file" => "If the checkbox is checked, the file ID of the latest version of a file stays the same. A link to the file will always link to the latest version. If not checked, each version of the file is assigned its own file ID, so a link to the file will be to a specific version of the file",
// "Show thumbnail actions" => "Show thumbnail actions",
// "Show the checkbox and wrench icon for file actions menu when not displaying details" => "Show the checkbox and wrench icon for file actions menu when not displaying details",
// "Maximum thumbnail size" => "Maximum thumbnail size",
// "Maximum width or height for image thumbnails" => "Maximum width or height for image thumbnails",
// "Automatic indexing of file content" => "Automatic indexing of file content",
// "Uses command line tools to extract the information from the files based on their MIME types" => "Uses command line tools to extract the information from the files based on their MIME types",
// "Asynchronous indexing" => "Asynchronous indexing",
// "Upload files from remote source" => "Upload files from remote source",
// "Enable copying files to file galleries from a URL that will be polled for new revisions" => "Enable copying files to file galleries from a URL that will be polled for new revisions",
// "Remote source refresh frequency limit" => "Remote source refresh frequency limit",
// "Minimum number of seconds to elapse between remote source checks to prevent flooding the server with requests" => "Minimum number of seconds to elapse between remote source checks to prevent flooding the server with requests",
// "Set to zero to disable refresh" => "Set to zero to disable refresh",
// "Display controls to attempt a file refresh" => "Display controls to attempt a file refresh",
// "Let users trigger a refresh attempt from the remote host" => "Let users trigger a refresh attempt from the remote host",
// "Allow searching for existing files in the tracker files field" => "Allow searching for existing files in the tracker files field",
// "Search files using the search index" => "Search files using the search index",
// "Set MIME type based on file suffix" => "Set MIME type based on file suffix",
// "Sets the MIME type of an image file according to the file suffix when it is incorrectly detected as application/octet-stream" => "Sets the MIME type of an image file according to the file suffix when it is incorrectly detected as application/octet-stream",
// "Clean XML Always" => "Clean XML Always",
// "Sanitize XML based files such as SVG for all users" => "Sanitize XML based files such as SVG for all users",
// "Allow SVG file upload" => "Allow SVG file upload",
// "Because SVG files may contain malicious code and compromise system security, specifically grant permission to upload SVG files." => "Because SVG files may contain malicious code and compromise system security, specifically grant permission to upload SVG files.",
// "Maximum name length" => "Maximum name length",
// "Length to which to truncate file names in browse view" => "Length to which to truncate file names in browse view",
// "Maximum width of images" => "Maximum width of images",
// "Default maximum width of images in galleries" => "Default maximum width of images in galleries",
// "Maximum height of images" => "Maximum height of images",
// "Default maximum height of images in galleries" => "Default maximum height of images in galleries",
// "Use elFinder UI" => "Use elFinder UI",
// "Alternative file manager with drag and drop capability" => "Alternative file manager with drag and drop capability",
// "Use Viewer JS" => "Use Viewer JS",
// "Uses ViewerJS from http://viewerjs.org if available (needs a separate install due to licensing restrictions), and allows displaying ODF files (odt, ods, odp) as well as pdf in web pages" => "Uses ViewerJS from http://viewerjs.org if available (needs a separate install due to licensing restrictions), and allows displaying ODF files (odt, ods, odp) as well as pdf in web pages",
// "Viewer JS URI" => "Viewer JS URI",
// "Where ViewerJS is installed" => "Where ViewerJS is installed",
// "Use PDF.js" => "Use PDF.js",
// "Uses PDF.js to display PDF files in web pages" => "Uses PDF.js to display PDF files in web pages",
// "Default view" => "Default view",
// "Default sort field" => "Default sort field",
"Last modification date" => "上次修改日期",
"Owner" => "Owner",
// "Default sort direction" => "Default sort direction",
// "Descending" => "Descending",
// "Ascending" => "Ascending",
// "Enter the ID of any file in any gallery to be used as the icon for this gallery in browse view" => "Enter the ID of any file in any gallery to be used as the icon for this gallery in browse view",
// "Show explorer" => "Show explorer",
// "Show path" => "Show path",
// "Show slideshow" => "Show slideshow",
"Name-filename" => "名稱-檔名",
"Filename only" => "僅檔名",
// "Created / Uploaded" => "Created / Uploaded",
// "Show icon in column" => "Show icon in column",
// "OCR Files" => "OCR Files",
// "Extract and index text from supported file types" => "Extract and index text from supported file types",
// "OCR Every File" => "OCR Every File",
// "Attempt to OCR every supported file" => "Attempt to OCR every supported file",
// "View or export office documents as PDF" => "View or export office documents as PDF",
// "If enabled allows to view documents without download or to export documents as PDF files" => "If enabled allows to view documents without download or to export documents as PDF files",
// "Maximum width of file preview in pixels" => "Maximum width of file preview in pixels",
// "The maximum value of width in pixels for the files preview in the popover" => "The maximum value of width in pixels for the files preview in the popover",
// "Export diagram image on save" => "Export diagram image on save",
// "If enabled, diagrams will be cached in PNG format when saved or edited" => "If enabled, diagrams will be cached in PNG format when saved or edited",
// "Use draw.io public services to export images" => "Use draw.io public services to export images",
// "When exporting PDFs, if this setting is enabled, diagram images will be fetched using Drawio's services if not in cache. This basically works like a fallback" => "When exporting PDFs, if this setting is enabled, diagram images will be fetched using Drawio's services if not in cache. This basically works like a fallback",
// "Specify a directory on this server, for example: /var/www/  It's recommended that this directory not be web-accessible. PHP must be able to read/write to the directory" => "Specify a directory on this server, for example: /var/www/  It's recommended that this directory not be web-accessible. PHP must be able to read/write to the directory",
// "Use jQuery upload" => "Use jQuery upload",
// "Use the improved Tiki 15+ upload page" => "Use the improved Tiki 15+ upload page",
// "Redirect to file gallery" => "Redirect to file gallery",
// "If enabled, redirect all requests to images that were migrated from the image gallery to the corresponding file in the file gallery" => "If enabled, redirect all requests to images that were migrated from the image gallery to the corresponding file in the file gallery",
// "Revision approval" => "Revision approval",
// "Uses flagged revisions to hide unapproved wiki page revisions from users without necessary privileges" => "Uses flagged revisions to hide unapproved wiki page revisions from users without necessary privileges",
// "Revision approval categories" => "Revision approval categories",
// "List of category IDs for which revision approval is required" => "List of category IDs for which revision approval is required",
// "Footer shadow div start" => "Footer shadow div start",
// "Footer shadow div end" => "Footer shadow div end",
// "Forum image file gallery" => "Forum image file gallery",
// "File gallery used to store images for forums" => "File gallery used to store images for forums",
"Uploaded filenames must match regex" => "上傳檔案名稱必須符合正規表示式",
// "Manage thread defaults per-forum" => "Manage thread defaults per-forum",
// "Display thread configuration bar" => "Display thread configuration bar",
// "Allows users to override the defaults" => "Allows users to override the defaults",
// "Display the thread configuration bar only when the number of posts exceeds" => "Display the thread configuration bar only when the number of posts exceeds",
"posts" => "佈告數",
// "Keep settings for all forums during the user session" => "Keep settings for all forums during the user session",
// "Default style" => "Default style",
// "Threaded" => "Threaded",
// "Headers only" => "Headers only",
// "Default sort mode" => "Default sort mode",
"Title (desc)" => "標題 (降冪)",
"Title (asc)" => "標題 (升冪)",
"Topics" => "主題",
"Posts per day" => "每日發表數",
"Last post" => "最新發表",
// "Description length" => "Description length",
// "Require reply to have a title" => "Require reply to have a title",
// "Present an empty title input form and require it to be filled in before the forum post is submitted" => "Present an empty title input form and require it to be filled in before the forum post is submitted",
// "Prevent Nesting of Quote wikiplugins when replying" => "Prevent Nesting of Quote wikiplugins when replying",
// "Strips quote plugin in reply in order to prevent nesting of quote plugins" => "Strips quote plugin in reply in order to prevent nesting of quote plugins",
// "Forum post categories" => "Forum post categories",
// "Categories available in the category picker for forum posts" => "Categories available in the category picker for forum posts",
// "Include category selector in forum list" => "Include category selector in forum list",
// "Allow inbound email posts from anyone" => "Allow inbound email posts from anyone",
// "Allow posts from non-users in forums using inbound posts from a specified email address" => "Allow posts from non-users in forums using inbound posts from a specified email address",
// "Parse HTML in inbound email posts" => "Parse HTML in inbound email posts",
// "Attempt to keep the formatting of HTML \"rich text\" emails if using WYSIWYG" => "Attempt to keep the formatting of HTML \"rich text\" emails if using WYSIWYG",
// "Experimental" => "Experimental",
// "Has problems with some HTML emails, especially those with table-based layouts" => "Has problems with some HTML emails, especially those with table-based layouts",
// "Strip wiki markup from outgoing forum emails" => "Strip wiki markup from outgoing forum emails",
// "Convert outgoing emails from forum posts to plain text" => "Convert outgoing emails from forum posts to plain text",
// "Send moderation email" => "Send moderation email",
// "Send email to forum moderators when post is queued" => "Send email to forum moderators when post is queued",
// "Approve link in moderation email" => "Approve link in moderation email",
// "Include a link for forum moderators to approve queue from email" => "Include a link for forum moderators to approve queue from email",
// "Do not start messages titles with 'Re:'" => "Do not start messages titles with 'Re:'",
// "Don't display forum thread titles" => "Don't display forum thread titles",
// "Titles of posts usually don't change because they are a direct reply to the parent post. This feature turns off the display of titles in edit forms and forum display" => "Titles of posts usually don't change because they are a direct reply to the parent post. This feature turns off the display of titles in edit forms and forum display",
// "Include a dropdown selector in the forum list to choose a category for the post" => "Include a dropdown selector in the forum list to choose a category for the post",
// "Creation date (asc)" => "Creation date (asc)",
"Topics (desc)" => "主題 (降冪)",
"Threads (desc)" => "討論串 (降冪)",
"Latest post (desc)" => "最近發表佈告 (降冪)",
"Name (desc)" => "名稱 (降冪)",
"Name (asc)" => "名稱 (升冪)",
// "Href" => "Href",
// "Object ID" => "Object ID",
// "Comments locked" => "Comments locked",
// "Multilingual tags" => "Multilingual tags",
// "Permits translation management of tags" => "Permits translation management of tags",
// "Ordering of tagged objects" => "Ordering of tagged objects",
// "Default sort mode for tagged items" => "Default sort mode for tagged items",
// "Show tag cloud" => "Show tag cloud",
// "Show the full tag cloud in the list-tags screen" => "Show the full tag cloud in the list-tags screen",
// "Maximum number of tags in cloud" => "Maximum number of tags in cloud",
// "tags" => "tags",
// "Show tags in middle column" => "Show tags in middle column",
// "On pages that have content tagged, this option enables the display of the tags at the top of those pages. Tags can be set, among other places, in the properties tab when editing a wiki page." => "On pages that have content tagged, this option enables the display of the tags at the top of those pages. Tags can be set, among other places, in the properties tab when editing a wiki page.",
// "Preload random tag" => "Preload random tag",
// "A random tag will be selected on the tag search page (if no tag is pre-selected)." => "A random tag will be selected on the tag search page (if no tag is pre-selected).",
// "Tag Suggestions" => "Tag Suggestions",
// "Number of tags to show in tag suggestions" => "Number of tags to show in tag suggestions",
// "Valid characters pattern" => "Valid characters pattern",
// "Click on the links below to set or clear a pattern to limit characters accepted in tags. " => "Click on the links below to set or clear a pattern to limit characters accepted in tags. ",
// "Lowercase tags only" => "Lowercase tags only",
// "Convert uppercase characters in tags to lowercase, if this is a preferred style for making tags more user-friendly." => "Convert uppercase characters in tags to lowercase, if this is a preferred style for making tags more user-friendly.",
// "GD %0 detected" => "GD %0 detected",
// "GD not detected" => "GD not detected",
// "Imagick %0 detected" => "Imagick %0 detected",
// "Imagick 0 not detected" => "Imagick 0 not detected",
// "Batch loading directory" => "Batch loading directory",
// "Needs to be a web-readable directory" => "Needs to be a web-readable directory",
// "Display image information in a mouseover box" => "Display image information in a mouseover box",
// "Yes, and don't display that information under the image" => "Yes, and don't display that information under the image",
"Parent" => "父系",
"Uploaded image names must match regex" => "上傳影像名稱必須符合正規表示式",
"Uploaded image names cannot match regex" => "上傳影像名稱不得符合正規表示式",
"Directory path" => "資料夾路徑",
// "If you change this directory, move any images to the new directory either manually or using the 'Mover' below" => "If you change this directory, move any images to the new directory either manually or using the 'Mover' below",
// "Image processing library" => "Image processing library",
// "Imagick" => "Imagick",
// "Generate password" => "Generate password",
// "Display a button on the registration form to automatically generate a very secure password for the user" => "Display a button on the registration form to automatically generate a very secure password for the user",
// "The generated password may not include any restrictions (such as minimum/maximum length" => "The generated password may not include any restrictions (such as minimum/maximum length",
// "Maps & Location Enabled" => "Maps & Location Enabled",
// "Provide controls to load map and location libraries" => "Provide controls to load map and location libraries",
// "Geolocate wiki pages" => "Geolocate wiki pages",
// "Provide controls to indicate a geographic location of wiki pages in the edit form" => "Provide controls to indicate a geographic location of wiki pages in the edit form",
// "Geolocate articles" => "Geolocate articles",
// "Provide controls to indicate a geographic location in the article edit form" => "Provide controls to indicate a geographic location in the article edit form",
// "Geolocate blog posts" => "Geolocate blog posts",
// "Provide controls to indicate a geographic location in the blog post edit form" => "Provide controls to indicate a geographic location in the blog post edit form",
// "Available tile layers on maps" => "Available tile layers on maps",
// "Enables replacement of the default OpenStreetMap tiles with tiles from other mapping services, such as Google or Bing" => "Enables replacement of the default OpenStreetMap tiles with tiles from other mapping services, such as Google or Bing",
// "Valid options for OpenLayers 2 are: %0 and for OpenLayers 3+ are: %1" => "Valid options for OpenLayers 2 are: %0 and for OpenLayers 3+ are: %1",
// "Google Street View" => "Google Street View",
// "Open Google Street View in a new window to see the visible coordinates" => "Open Google Street View in a new window to see the visible coordinates",
// "Google Street View overlay" => "Google Street View overlay",
// "This is not guaranteed to work" => "This is not guaranteed to work",
// "Always load OpenLayers" => "Always load OpenLayers",
// "Load the OpenLayers library even if no map is explicitly included in the page" => "Load the OpenLayers library even if no map is explicitly included in the page",
// "Zoom level for the found location" => "Zoom level for the found location",
// "Zoom level when a searched-for location is found" => "Zoom level when a searched-for location is found",
// "Street" => "Street",
// "Town" => "Town",
// "Region" => "Region",
// "Continent" => "Continent",
// "OpenLayers version" => "OpenLayers version",
// "OpenLayers 2.x (for use up to at least 15.x)" => "OpenLayers 2.x (for use up to at least 15.x)",
// "OpenLayers 3+ (experimental)" => "OpenLayers 3+ (experimental)",
// "Bing Maps API Key" => "Bing Maps API Key",
// "Needed for Bing Map Layers" => "Needed for Bing Map Layers",
// "Nextzen Maps API Key" => "Nextzen Maps API Key",
// "Needed for Nextzen Map Layers" => "Needed for Nextzen Map Layers",
"Browser title" => "瀏覽器標題",
// "Visible label in the browser's title bar on all pages. Also appears in search engine results" => "Visible label in the browser's title bar on all pages. Also appears in search engine results",
// "Fallback for tiki base URL" => "Fallback for tiki base URL",
// "The full URL to the Tiki base URL including protocol, domain and path (example: https://example.com/tiki/), used when the current URL can not be determined, example, when executing from the command line" => "The full URL to the Tiki base URL including protocol, domain and path (example: https://example.com/tiki/), used when the current URL can not be determined, example, when executing from the command line",
// "Validate new user registrations by email" => "Validate new user registrations by email",
// "Tiki will send an email message to the user. The message contains a link that must be clicked to validate the registration. After clicking the link, the user will be validated. You can use this option to limit false registrations or fake email addresses" => "Tiki will send an email message to the user. The message contains a link that must be clicked to validate the registration. After clicking the link, the user will be validated. You can use this option to limit false registrations or fake email addresses",
// "Wiki homepage" => "Wiki homepage",
// "The default home page of the wiki when no other page is specified. The page will be created if it does not already exist" => "The default home page of the wiki when no other page is specified. The page will be created if it does not already exist",
// "Use group homepages" => "Use group homepages",
// "Users can be directed to different pages upon logging in, depending on their default group" => "Users can be directed to different pages upon logging in, depending on their default group",
// "Go to the group homepage only if logging in from the default homepage" => "Go to the group homepage only if logging in from the default homepage",
// "Cache external pages" => "Cache external pages",
// "Cache external images" => "Cache external images",
"Temporary directory" => "暫存目錄",
// "Directory on your server, relative to your Tiki installation, for storing temporary files. Tiki must have full read and write access to this directory" => "Directory on your server, relative to your Tiki installation, for storing temporary files. Tiki must have full read and write access to this directory",
// "Help URL" => "Help URL",
// "The default help system may not be complete. You can contribute to the Tiki documentation, which is a community-edited wiki" => "The default help system may not be complete. You can contribute to the Tiki documentation, which is a community-edited wiki",
"Open external links in new window" => "於新視窗開啟外部連結",
// "Open links to external sites in a new browser tab or window" => "Open links to external sites in a new browser tab or window",
// "Allow image lazy loading" => "Allow image lazy loading",
// "Allow that images are loaded in a lazy way" => "Allow that images are loaded in a lazy way",
// "License page" => "License page",
// "The wiki page where the license information is written" => "The wiki page where the license information is written",
// "Submit notice" => "Submit notice",
// "Text to appear when content is being submitted" => "Text to appear when content is being submitted",
// "Full path to gdaltindex" => "Full path to gdaltindex",
// "Full path to ogr2ogr" => "Full path to ogr2ogr",
// "Map Zone" => "Map Zone",
"Always display modules to all groups" => "所有的群組都顯示模組",
// "Any setting for the Groups parameter will be ignored and the module will be displayed to all users" => "Any setting for the Groups parameter will be ignored and the module will be displayed to all users",
// "Hide anonymous-only modules from registered users" => "Hide anonymous-only modules from registered users",
// "If an individual module is assigned to the Anonymous group, the module will be displayed only to anonymous visitors. Registered users will not see the module" => "If an individual module is assigned to the Anonymous group, the module will be displayed only to anonymous visitors. Registered users will not see the module",
// "Hide anonymous-only modules from Admins" => "Hide anonymous-only modules from Admins",
// "Maximum number of articles on the articles homepage" => "Maximum number of articles on the articles homepage",
// "The number of articles to show on each page of the Articles homepage" => "The number of articles to show on each page of the Articles homepage",
// "articles" => "articles",
// "Site Ads and Banners Content" => "Site Ads and Banners Content",
// "Test" => "Test",
// "URL to go to when clicking on a username" => "URL to go to when clicking on a username",
// "Default" => "Default",
// "Use %user% for login name and %userId% for userId)" => "Use %user% for login name and %userId% for userId)",
// "Forgot password" => "Forgot password",
// "Users can request a password reset. They will receive a link by email" => "Users can request a password reset. They will receive a link by email",
// "Group theme" => "Group theme",
// "Enable groups to each have their own visual theme" => "Enable groups to each have their own visual theme",
// "The displayed title of the website" => "The displayed title of the website",
// "Subtitle" => "Subtitle",
// "A short phrase that, for example, describes the site" => "A short phrase that, for example, describes the site",
"Maximum number of records in listings" => "列表中版本最大數目",
// "records" => "records",
// "Maximum number of versions" => "Maximum number of versions",
// "versions" => "versions",
"Users can register" => "允許使用者註冊",
// "Allow site visitors to register, using the registration form. The log-in module will include a \"Register\" link. If this is not activated, new users will have to be added manually by the admin on the Admin-Users page" => "Allow site visitors to register, using the registration form. The log-in module will include a \"Register\" link. If this is not activated, new users will have to be added manually by the admin on the Admin-Users page",
// "Tiki will attempt to validate the user’s email address by examining the syntax of the email address. It must be a string of letters, or digits or _ or . or - follows by a @ follows by a string of letters, or digits or _ or . or -. Tiki will perform a DNS lookup and attempt to open a SMTP session to validate the email server" => "Tiki will attempt to validate the user’s email address by examining the syntax of the email address. It must be a string of letters, or digits or _ or . or - follows by a @ follows by a string of letters, or digits or _ or . or -. Tiki will perform a DNS lookup and attempt to open a SMTP session to validate the email server",
// "Some web servers may disable this functionality, thereby disabling this feature. If you are not in in a high security site or if you are on an open users site, do not use this option" => "Some web servers may disable this functionality, thereby disabling this feature. If you are not in in a high security site or if you are on an open users site, do not use this option",
// "Yes, with \"deep MX\" search" => "Yes, with \"deep MX\" search",
// "Require validation by Admin" => "Require validation by Admin",
// "The administrator will receive an email for each new user registration, and must validate the user before the user can log in" => "The administrator will receive an email for each new user registration, and must validate the user before the user can log in",
// "Require passcode to register" => "Require passcode to register",
// "Users must enter an alphanumeric code to register.  The site administrator must inform users of this code. This is to restrict registration to invited users" => "Users must enter an alphanumeric code to register.  The site administrator must inform users of this code. This is to restrict registration to invited users",
// "Passcode" => "Passcode",
// "Alphanumeric code required to complete the registration" => "Alphanumeric code required to complete the registration",
// "Show passcode on registration form" => "Show passcode on registration form",
// "Registration page key" => "Registration page key",
// "Key required to be on included the URL to access the registration page (if not empty)" => "Key required to be on included the URL to access the registration page (if not empty)",
// "To register, users need to go to, for example: tiki-register.php?key=yourregistrationkeyvalue" => "To register, users need to go to, for example: tiki-register.php?key=yourregistrationkeyvalue",
// "Use a tracker to collect more user information" => "Use a tracker to collect more user information",
// "Display a tracker form for the user to complete as part of the registration process. This tracker will receive and store additional information about each user" => "Display a tracker form for the user to complete as part of the registration process. This tracker will receive and store additional information about each user",
// "Go to [tiki-admingroups.php|Admin Groups] to select which tracker and fields to display" => "Go to [tiki-admingroups.php|Admin Groups] to select which tracker and fields to display",
// "Use tracker to collect more group information" => "Use tracker to collect more group information",
// "Create a new group for each user" => "Create a new group for each user",
// "Automatically create a group for each user in order to, for example, assign permissions on the individual-user level" => "Automatically create a group for each user in order to, for example, assign permissions on the individual-user level",
// "Synchronize Tiki groups with a directory" => "Synchronize Tiki groups with a directory",
// "Define the directory within the \"LDAP\" tab" => "Define the directory within the \"LDAP\" tab",
// "Synchronize Tiki users with a directory" => "Synchronize Tiki users with a directory",
"Remember me" => "記住我的身份",
"Duration" => "期間",
// "The length of time before the user will need to log in again" => "The length of time before the user will need to log in again",
"day" => "日",
"week" => "週",
"month" => "月",
// "year" => "year",
// "Homepage Browser title" => "Homepage Browser title",
// "Customize Browser title for the custom homepage" => "Customize Browser title for the custom homepage",
// "Use custom homepage" => "Use custom homepage",
// "Use the top page of a Tiki feature or another homepage" => "Use the top page of a Tiki feature or another homepage",
// "This option will override the Use Tiki feature as homepage setting" => "This option will override the Use Tiki feature as homepage setting",
// "Use the top page of a Tiki feature as the homepage" => "Use the top page of a Tiki feature as the homepage",
// "Select the Tiki feature to provide the site homepage. Only enabled features are listed" => "Select the Tiki feature to provide the site homepage. Only enabled features are listed",
// "Disable JavaScript" => "Disable JavaScript",
// "Disable JavaScript for the purpose of testing even if enabled in the browser" => "Disable JavaScript for the purpose of testing even if enabled in the browser",
// "Use only for testing or troubleshooting. When enabled, many Tiki features will not operate correctly" => "Use only for testing or troubleshooting. When enabled, many Tiki features will not operate correctly",
// "Maximum rows per page" => "Maximum rows per page",
"Images per row" => "每列影像數",
// "images" => "images",
// "Thumbnail width" => "Thumbnail width",
// "Thumbnail height" => "Thumbnail height",
// "Default scale size" => "Default scale size",
// "Set blogs homepage first" => "Set blogs homepage first",
// "Set Image gal homepage first" => "Set Image gal homepage first",
// "Set Forum homepage first" => "Set Forum homepage first",
// "Since passwords are encrypted, it's not possible to tell the user what the password is. It's only possible to change it" => "Since passwords are encrypted, it's not possible to tell the user what the password is. It's only possible to change it",
// "Validate user's email server" => "Validate user's email server",
// "Displays the required passcode on the registration form. This is helpful for legitimate users who want to register while making it difficult for automated robots because the passcode is unique for each site and because it is displayed in JavaScript" => "Displays the required passcode on the registration form. This is helpful for legitimate users who want to register while making it difficult for automated robots because the passcode is unique for each site and because it is displayed in JavaScript",
// "The group name will be the same as the user's username" => "The group name will be the same as the user's username",
// "After logging in, users will automatically be logged in again when they leave and return to the site" => "After logging in, users will automatically be logged in again when they leave and return to the site",
// "User's choice" => "User's choice",
// "Google Maps API Key" => "Google Maps API Key",
// "Needed for Street View or other advanced features" => "Needed for Street View or other advanced features",
// "Default x for map center" => "Default x for map center",
// "Default y for map center" => "Default y for map center",
// "Default zoom level" => "Default zoom level",
// "whole earth" => "whole earth",
// "country size" => "country size",
// "city size" => "city size",
// "max zoom" => "max zoom",
// "Show map mode buttons in articles list" => "Show map mode buttons in articles list",
// "Show map mode buttons in page list" => "Show map mode buttons in page list",
// "Goal, recognition and rewards" => "Goal, recognition and rewards",
// "A tool to set motivational goals to increase engagement on the site" => "A tool to set motivational goals to increase engagement on the site",
// "Reward badge tracker" => "Reward badge tracker",
// "Tracker ID containing the list of badges to be awarded on goal completion. Each badge can be awarded only once per user" => "Tracker ID containing the list of badges to be awarded on goal completion. Each badge can be awarded only once per user",
// "0 to disable" => "0 to disable",
// "Groups not eligible for goals" => "Groups not eligible for goals",
// "Groups that will not be on the eligible group list" => "Groups that will not be on the eligible group list",
// "H5P support" => "H5P support",
// "Handle H5P package files on upload. H5P enables the creation, sharing and reusing of interactive HTML5 content" => "Handle H5P package files on upload. H5P enables the creation, sharing and reusing of interactive HTML5 content",
// "Whitelist" => "Whitelist",
// "Allowed filetypes" => "Allowed filetypes",
// "H5P Tracker User" => "H5P Tracker User",
// "Store H5P results" => "Store H5P results",
// "H5P Developer Mode" => "H5P Developer Mode",
// "Use \"patched\" libraries" => "Use \"patched\" libraries",
// "Default Gallery" => "Default Gallery",
// "File gallery to create new H5P content in by default" => "File gallery to create new H5P content in by default",
// "Store user state" => "Store user state",
// "Allows users to resume at the point they last got to" => "Allows users to resume at the point they last got to",
// "Save Frequency" => "Save Frequency",
// "How often to update user data" => "How often to update user data",
// "Allows users to export H5P content" => "Allows users to export H5P content",
// "Hub Is Enabled" => "Hub Is Enabled",
// "Updates libraries from h5p.org" => "Updates libraries from h5p.org",
// "Site Key" => "Site Key",
// "H5P Site Key" => "H5P Site Key",
// "H5P UUID" => "H5P UUID",
// "H5P Unique ID" => "H5P Unique ID",
// "Content Type Updated" => "Content Type Updated",
"Last update" => "最近更新",
// "Check Requirements" => "Check Requirements",
// "Unused so far" => "Unused so far",
// "Send Usage Statistics" => "Send Usage Statistics",
// "Request User Consent" => "Request User Consent",
// "LRS Content Types" => "LRS Content Types",
// "Reporting (?)" => "Reporting (?)",
// "HHeader shadow div start" => "HHeader shadow div start",
// "Header shadow div end" => "Header shadow div end",
// "Custom CSS" => "Custom CSS",
// "Additional CSS rules can be entered here and will apply to all pages, or the CSS ID of a page can be used to limit the scope of the rule (check the HTML source of the particular page to find its body ID tag.)\n\n" => "Additional CSS rules can be entered here and will apply to all pages, or the CSS ID of a page can be used to limit the scope of the rule (check the HTML source of the particular page to find its body ID tag.)\n\n",
// "Custom JavaScript" => "Custom JavaScript",
// "Includes a block of inline JavaScript after the inclusion of jQuery and other JavaScript libs in all pages" => "Includes a block of inline JavaScript after the inclusion of jQuery and other JavaScript libs in all pages",
// "Use [https://doc.tiki.org/PluginJS|PluginJS] to include Javascript on a single wiki page" => "Use [https://doc.tiki.org/PluginJS|PluginJS] to include Javascript on a single wiki page",
// "Do not include the < script > tags" => "Do not include the < script > tags",
// "Custom Less" => "Custom Less",
// "Compiles a new version of the currently selected theme and option using definitions declared here" => "Compiles a new version of the currently selected theme and option using definitions declared here",
// "Custom Less (CSS precompiler) - no longer used" => "Custom Less (CSS precompiler) - no longer used",
// "CSS Less is no longer used in Tiki 19+. Custom SCSS feature coming soon.." => "CSS Less is no longer used in Tiki 19+. Custom SCSS feature coming soon..",
// "Highlight group" => "Highlight group",
"Home blog (main blog)" => "首頁 Blog (主要 blog)",
"Home forum (main forum)" => "首頁論壇 (主論壇)",
// "Home file gallery (main file gallery)" => "Home file gallery (main file gallery)",
// "Select the default file gallery" => "Select the default file gallery",
"Home gallery (main gallery)" => "首頁圖庫 (主圖庫)",
// "No image gallery available (create one first)" => "No image gallery available (create one first)",
// "No file gallery available (create one first)" => "No file gallery available (create one first)",
// "No blog available (create one first)" => "No blog available (create one first)",
"HTTP port" => "HTTP 埠",
// "The port used to access this server; if not specified, port 80 will be used" => "The port used to access this server; if not specified, port 80 will be used",
// "If not specified, port 80 will be used" => "If not specified, port 80 will be used",
// "HTTP lookup: skip framesets" => "HTTP lookup: skip framesets",
// "When performing an HTTP request to an external source, verify if the result is a frameset and use heuristic to provide the real content" => "When performing an HTTP request to an external source, verify if the result is a frameset and use heuristic to provide the real content",
// "Registration referrer check" => "Registration referrer check",
// "Use the HTTP referrer to check registration POST is sent from same host. (May not work on some setups.)" => "Use the HTTP referrer to check registration POST is sent from same host. (May not work on some setups.)",
// "HTTP header x-frame options" => "HTTP header x-frame options",
// "The x-frame-options HTTP response header can be used to indicate whether or not a browser should be allowed to render a page in a &lt;frame&gt;, &lt;iframe&gt; or &lt;object&gt" => "The x-frame-options HTTP response header can be used to indicate whether or not a browser should be allowed to render a page in a &lt;frame&gt;, &lt;iframe&gt; or &lt;object&gt",
// "Header value" => "Header value",
// "DENY" => "DENY",
// "SAMEORIGIN" => "SAMEORIGIN",
// "HTTP header x-xss-protection" => "HTTP header x-xss-protection",
// "The x-xss-protection header is designed to enable the cross-site scripting (XSS) filter built into modern web browsers" => "The x-xss-protection header is designed to enable the cross-site scripting (XSS) filter built into modern web browsers",
// "0" => "0",
// "1;mode=block" => "1;mode=block",
// "HTTP header x-content-type-options" => "HTTP header x-content-type-options",
// "The x-content-type-options header is a marker used by the server to indicate that the MIME types advertised in the Content-Type headers should not be changed and be followed" => "The x-content-type-options header is a marker used by the server to indicate that the MIME types advertised in the Content-Type headers should not be changed and be followed",
// "HTTP header content-security-policy" => "HTTP header content-security-policy",
// "The Content-Security-Policy header allows web site administrators to control resources the user agent is allowed to load for a given page" => "The Content-Security-Policy header allows web site administrators to control resources the user agent is allowed to load for a given page",
// "HTTP header strict-transport-security" => "HTTP header strict-transport-security",
// "The Strict-Transport-Security header (often abbreviated as HSTS) is a security feature that lets a web site tell browsers that it should only be communicated with using HTTPS, instead of using HTTP" => "The Strict-Transport-Security header (often abbreviated as HSTS) is a security feature that lets a web site tell browsers that it should only be communicated with using HTTPS, instead of using HTTP",
// "HTTP header public-key-pins" => "HTTP header public-key-pins",
// "The public-key-pins header associates a specific cryptographic public key with a certain web server to decrease the risk of MITM attacks with forged certificates. If one or several keys are pinned and none of them are used by the server, the browser will not accept the response as legitimate, and will not display it" => "The public-key-pins header associates a specific cryptographic public key with a certain web server to decrease the risk of MITM attacks with forged certificates. If one or several keys are pinned and none of them are used by the server, the browser will not accept the response as legitimate, and will not display it",
// "HTTPS for user-specific links" => "HTTPS for user-specific links",
// "When building notification emails, RSS feeds, the canonical URL or other externally available links, use HTTPS when the content applies to a specific user. HTTPS must be configured on the server" => "When building notification emails, RSS feeds, the canonical URL or other externally available links, use HTTPS when the content applies to a specific user. HTTPS must be configured on the server",
"HTTPS port" => "HTTPS 埠",
// "the HTTPS port for this server" => "the HTTPS port for this server",
// "Use HTTPS login" => "Use HTTPS login",
// "Increase security by allowing to transmit authentication credentials over SSL. Certificates must be configured on the server" => "Increase security by allowing to transmit authentication credentials over SSL. Certificates must be configured on the server",
"Allow secure (HTTPS) login" => "允許安全 (https) 登入",
// "Encourage secure (HTTPS) login" => "Encourage secure (HTTPS) login",
// "Consider we are always in HTTPS, but do not check" => "Consider we are always in HTTPS, but do not check",
"Require secure (HTTPS) login" => "需要安全 (https) 登入",
// "Do not require HTTPS until the connection has been set up and tested; otherwise, the website will be inaccessible" => "Do not require HTTPS until the connection has been set up and tested; otherwise, the website will be inaccessible",
// "Enable intrusion detection system" => "Enable intrusion detection system",
// "An intrusion detection system (IDS) is a device or software application that monitors a network or systems for malicious activity or policy violations" => "An intrusion detection system (IDS) is a device or software application that monitors a network or systems for malicious activity or policy violations",
// "Intrusion detection system mode" => "Intrusion detection system mode",
// "Define IDS operation mode, log only, or log and block with impact over a given threshold" => "Define IDS operation mode, log only, or log and block with impact over a given threshold",
// "Log only" => "Log only",
// "Log and block requests" => "Log and block requests",
// "Intrusion detection system threshold" => "Intrusion detection system threshold",
// "Define IDS threshold, when configured in \"Log and block requests\" more" => "Define IDS threshold, when configured in \"Log and block requests\" more",
// "Custom rules file" => "Custom rules file",
// "Log to file" => "Log to file",
// "Log to database" => "Log to database",
// "Default for img-fluid class used in the IMG plugin" => "Default for img-fluid class used in the IMG plugin",
// "Default option for whether an image produced with the IMG plugin has the img-fluid class - a plugin parameter allows this to be overridden" => "Default option for whether an image produced with the IMG plugin has the img-fluid class - a plugin parameter allows this to be overridden",
// "Errors log file" => "Errors log file",
// "location, from your tiki root dir, where you want the error log file stored" => "location, from your tiki root dir, where you want the error log file stored",
// "Access log file" => "Access log file",
// "location, from your tiki root dir, where you want the access log file stored" => "location, from your tiki root dir, where you want the access log file stored",
// "IP can be checked" => "IP can be checked",
// "Check anonymous votes by user's IP" => "Check anonymous votes by user's IP",
// "Use CDN for JavaScript" => "Use CDN for JavaScript",
// "Obtain jQuery and jQuery UI libraries through a content delivery network (CDN)" => "Obtain jQuery and jQuery UI libraries through a content delivery network (CDN)",
// "Google" => "Google",
// "jQuery" => "jQuery",
// "Assume JavaScript is enabled even if not supported" => "Assume JavaScript is enabled even if not supported",
// "Assume JavaScript is enabled even if not supported, could be useful for load testing using tools like JMeter" => "Assume JavaScript is enabled even if not supported, could be useful for load testing using tools like JMeter",
// "Slide" => "Slide",
// "Fade" => "Fade",
// "Blind (UI)" => "Blind (UI)",
// "Clip (UI)" => "Clip (UI)",
// "Drop (UI)" => "Drop (UI)",
// "Explode (UI)" => "Explode (UI)",
// "Fold (UI)" => "Fold (UI)",
// "Puff (UI)" => "Puff (UI)",
// "Slide (UI)" => "Slide (UI)",
// "Effect for modules" => "Effect for modules",
// "Effect for tabs" => "Effect for tabs",
// "Speed" => "Speed",
// "Fast" => "Fast",
"Normal" => "正常",
// "Slow" => "Slow",
// "Direction" => "Direction",
// "Vertical" => "Vertical",
// "Horizontal" => "Horizontal",
"Left" => "左",
"Right" => "右",
"Up" => "上",
"Down" => "下",
// "jQuery-UI Chosen Select Boxes" => "jQuery-UI Chosen Select Boxes",
// "Styled replacement for dropdown select lists and multiple-select inputs" => "Styled replacement for dropdown select lists and multiple-select inputs",
// "Sortable Chosen Multi-selects" => "Sortable Chosen Multi-selects",
// "Enable drag and drop re-ordering of Chosen multi-select options" => "Enable drag and drop re-ordering of Chosen multi-select options",
// "Visual style of Colorbox (a.k.a. \"Shadowbox\")" => "Visual style of Colorbox (a.k.a. \"Shadowbox\")",
// "One" => "One",
// "Two" => "Two",
// "Three" => "Three",
// "Four" => "Four",
// "Five" => "Five",
// "FitVids.js" => "FitVids.js",
// "jQuery plugin for fluid-width (responsive) embedded videos" => "jQuery plugin for fluid-width (responsive) embedded videos",
// "jQuery Timeago" => "jQuery Timeago",
// "jQuery plugin for fuzzy timestamps" => "jQuery plugin for fuzzy timestamps",
// "SmartMenus" => "SmartMenus",
// "Add \"SmartMenus\" to Bootstrap menus. See smartmenus.org for more" => "Add \"SmartMenus\" to Bootstrap menus. See smartmenus.org for more",
// "SmartMenus Mode" => "SmartMenus Mode",
// "Blue" => "Blue",
// "Clean" => "Clean",
// "Mint" => "Mint",
// "Simple" => "Simple",
// "Draggable Modals" => "Draggable Modals",
// "Modal popups can be moved around" => "Modal popups can be moved around",
// "Resizable Modals" => "Resizable Modals",
// "Modal popups can be resized" => "Modal popups can be resized",
// "jQuery Double Scroll" => "jQuery Double Scroll",
// "jQuery plugin which adds an extra horizontal scroll bar at the top" => "jQuery plugin which adds an extra horizontal scroll bar at the top",
// "Partner ID" => "Partner ID",
// "Kaltura Partner ID" => "Kaltura Partner ID",
// "User secret" => "User secret",
// "Kaltura partner-setting user secret" => "Kaltura partner-setting user secret",
// "Admin secret" => "Admin secret",
// "Kaltura partner-setting admin secret" => "Kaltura partner-setting admin secret",
// "Kaltura video player ID" => "Kaltura video player ID",
// "Kaltura Dynamic Player (KDP) user interface configuration ID" => "Kaltura Dynamic Player (KDP) user interface configuration ID",
// "Kaltura video player ID (in entry edit mode)" => "Kaltura video player ID (in entry edit mode)",
// "Kaltura Dynamic Player (KDP) user interface configuration ID for use when editing. You can use a player which also has an option to select a frame as video thumbnail" => "Kaltura Dynamic Player (KDP) user interface configuration ID for use when editing. You can use a player which also has an option to select a frame as video thumbnail",
// "KCW UI configuration ID" => "KCW UI configuration ID",
// "Kaltura Configuration Wizard (KCW) user interface configuration ID" => "Kaltura Configuration Wizard (KCW) user interface configuration ID",
// "Kaltura service URL" => "Kaltura service URL",
// "for example, https://www.kaltura.com/" => "for example, https://www.kaltura.com/",
// "Show remixes from old versions of Kaltura" => "Show remixes from old versions of Kaltura",
// "Show remixes from old versions of Kaltura (remixing is no longer supported)" => "Show remixes from old versions of Kaltura (remixing is no longer supported)",
// "Keep versions for" => "Keep versions for",
// "Do not delete versions younger than this number of days" => "Do not delete versions younger than this number of days",
"Use database for translation" => "使用資料庫存放翻譯",
// "Use the database to store the translated strings and allow using interactive translation" => "Use the database to store the translated strings and allow using interactive translation",
// "Edit, export and import languages" => "Edit, export and import languages",
// "Manage contribution of translated strings" => "Manage contribution of translated strings",
// "Offers to set whether each translated string should be contributed to the Tiki community or kept locally" => "Offers to set whether each translated string should be contributed to the Tiki community or kept locally",
// "Machine translation implementation" => "Machine translation implementation",
// "Select between alternate impementations for machine translation. Depending on the implementation, different API keys may be required" => "Select between alternate impementations for machine translation. Depending on the implementation, different API keys may be required",
// "Google Translate" => "Google Translate",
// "Bing Translate" => "Bing Translate",
// "Enable machine translation of wiki pages" => "Enable machine translation of wiki pages",
// "Makes additional languages available to the list of languages on the page" => "Makes additional languages available to the list of languages on the page",
// "Google Translate API Key" => "Google Translate API Key",
// "The key must be generated from the Google console. Choose to create a server key" => "The key must be generated from the Google console. Choose to create a server key",
// "Bing Translate Client ID" => "Bing Translate Client ID",
// "The application must be registered" => "The application must be registered",
// "Bing Translate Client Secret" => "Bing Translate Client Secret",
// "Display available translations as dropdown" => "Display available translations as dropdown",
// "Instead of a simple icon to list available languages or translation options, show a more visible drop-down list" => "Instead of a simple icon to list available languages or translation options, show a more visible drop-down list",
// "Default language" => "Default language",
// "The site language is used when no other language is specified by the user" => "The site language is used when no other language is specified by the user",
// "Default admin language" => "Default admin language",
// "The site language is used in admin section when no other language is specified by the user" => "The site language is used in admin section when no other language is specified by the user",
// "Language inclusion threshold" => "Language inclusion threshold",
// "When the number of languages is restricted on the site, and is below this number, all languages will be added to the preferred language list, even if unspecified by the user. However, priority will be given to the specified languages" => "When the number of languages is restricted on the site, and is below this number, all languages will be added to the preferred language list, even if unspecified by the user. However, priority will be given to the specified languages",
// "languages" => "languages",
// "Layout width" => "Layout width",
// "The width of the content area of the site, centered in the browser window" => "The width of the content area of the site, centered in the browser window",
// "for example, 960px" => "for example, 960px",
// "Tabs optional" => "Tabs optional",
// "Users can choose not to have tabs. A <b>no tabs</b> button will be displayed" => "Users can choose not to have tabs. A <b>no tabs</b> button will be displayed",
// "Add group CSS info" => "Add group CSS info",
// "Add CSS classes to the page BODY tag based on the user's group membership" => "Add CSS classes to the page BODY tag based on the user's group membership",
// "Either grp_Anonymous or grp_Registered and possibly grp_Admins as well" => "Either grp_Anonymous or grp_Registered and possibly grp_Admins as well",
// "If this option is disabled, this user wouldn’t be able to log in" => "If this option is disabled, this user wouldn’t be able to log in",
// "Create the user" => "Create the user",
// "Deny access" => "Deny access",
// "Create user if not in LDAP" => "Create user if not in LDAP",
// "If a user was authenticated by Tiki’s user database, but not found on the LDAP server, Tiki will create an LDAP entry for this user" => "If a user was authenticated by Tiki’s user database, but not found on the LDAP server, Tiki will create an LDAP entry for this user",
// "If this option is set, the user “admin” will be authenticated by only using Tiki’s user database and not via LDAP. This option has no effect on users other than “admin”" => "If this option is set, the user “admin” will be authenticated by only using Tiki’s user database and not via LDAP. This option has no effect on users other than “admin”",
// "Maximum average server load threshold in the last minute" => "Maximum average server load threshold in the last minute",
// "Lock Content Templates" => "Lock Content Templates",
// "Enable users to lock content templates and so prevent others from editing them" => "Enable users to lock content templates and so prevent others from editing them",
// "Lock Wiki Structures" => "Lock Wiki Structures",
// "Enable users to lock wiki structures and so prevent others from editing them" => "Enable users to lock wiki structures and so prevent others from editing them",
// "Log mail in Tiki logs" => "Log mail in Tiki logs",
// "A line of type mail will be included in the System Log with the destination address and subject of each email sent" => "A line of type mail will be included in the System Log with the destination address and subject of each email sent",
// "Smarty template usage indicator" => "Smarty template usage indicator",
// "Add HTML comment at start and end of each Smarty template (.tpl file)" => "Add HTML comment at start and end of each Smarty template (.tpl file)",
// "Use only for development, not in production at a live site, because these warnings are added to emails as well, and are visible to users in the page source" => "Use only for development, not in production at a live site, because these warnings are added to emails as well, and are visible to users in the page source",
// "You need to clear your Tiki template cache for this change to take effect" => "You need to clear your Tiki template cache for this change to take effect",
// "Log SQL" => "Log SQL",
// "All SQL queries will be registered in the database in the adodb_logsql table. " => "All SQL queries will be registered in the database in the adodb_logsql table. ",
// "Do not enable this feature all the time. It can be very resource intensive and will impact performance" => "Do not enable this feature all the time. It can be very resource intensive and will impact performance",
// "Log queries using more than" => "Log queries using more than",
// "Use to log only queries that exceed a specific amount of time" => "Use to log only queries that exceed a specific amount of time",
// "Use email as username" => "Use email as username",
// "Instead of creating new usernames, use the user's email address for authentication. On the registration form, there will be no Username field" => "Instead of creating new usernames, use the user's email address for authentication. On the registration form, there will be no Username field",
// "Obscure email when using email as username" => "Obscure email when using email as username",
// "This will attempt as much as possible to hide the email address, showing the real name or the truncated email address instead" => "This will attempt as much as possible to hide the email address, showing the real name or the truncated email address instead",
// "Coverage will not be complete" => "Coverage will not be complete",
// "User can login via username or email" => "User can login via username or email",
// "This will allow users to login using their email (as well as their username)" => "This will allow users to login using their email (as well as their username)",
// "Auto-generate 6-digit username on registration" => "Auto-generate 6-digit username on registration",
// "This will auto-generate a 6-digit username for users who sign up (they will normally log in with emails only)" => "This will auto-generate a 6-digit username for users who sign up (they will normally log in with emails only)",
// "HTTP Basic Authentication" => "HTTP Basic Authentication",
// "Check credentials from HTTP Basic Authentication, which is useful to allow webservices to use credentials" => "Check credentials from HTTP Basic Authentication, which is useful to allow webservices to use credentials",
// "SSL Only (Recommended)" => "SSL Only (Recommended)",
// "Prevent multiple log-ins by the same user" => "Prevent multiple log-ins by the same user",
// "Users (other than admin) cannot log in simultaneously with multiple browsers" => "Users (other than admin) cannot log in simultaneously with multiple browsers",
// "Grab session if already logged in" => "Grab session if already logged in",
// "If users are blocked from logging in simultaneously, grab the session. Will force existing user to be logged out" => "If users are blocked from logging in simultaneously, grab the session. Will force existing user to be logged out",
// "Enable autologin from remote Tiki" => "Enable autologin from remote Tiki",
// "Used with autologin_remotetiki in the redirect plugin" => "Used with autologin_remotetiki in the redirect plugin",
// "System username to use to initiate autologin from remote Tiki" => "System username to use to initiate autologin from remote Tiki",
// "Specified user must exist and be configured in Settings...Tools...DSN/Content Authentication on remote Tiki. Used with autologin_remotetiki in the redirect plugin" => "Specified user must exist and be configured in Settings...Tools...DSN/Content Authentication on remote Tiki. Used with autologin_remotetiki in the redirect plugin",
// "System groupname to use for auto login token" => "System groupname to use for auto login token",
// "For security, please create a group that has no users and no permissions and specify its name here" => "For security, please create a group that has no users and no permissions and specify its name here",
// "Create a new user account if the user that is trying to autologin does not exist on this Tiki" => "Create a new user account if the user that is trying to autologin does not exist on this Tiki",
// "Allowed groups from remote Tiki to autologin" => "Allowed groups from remote Tiki to autologin",
// "Comma-separated list of groups to allow autologin from remote Tiki. If empty, will allow everyone" => "Comma-separated list of groups to allow autologin from remote Tiki. If empty, will allow everyone",
// "Sync these groups from remote Tiki on autologin" => "Sync these groups from remote Tiki on autologin",
// "Comma-separated list of groups to sync from remote Tiki on autologin. Group membership will be added or removed accordingly" => "Comma-separated list of groups to sync from remote Tiki on autologin. Group membership will be added or removed accordingly",
// "Automatically logout remote Tiki after logout" => "Automatically logout remote Tiki after logout",
// "When the user logs out of this Tiki, redirect the user to logout of the other Tiki as well" => "When the user logs out of this Tiki, redirect the user to logout of the other Tiki as well",
// "Redirect direct logins to this site to remote Tiki" => "Redirect direct logins to this site to remote Tiki",
// "URL of autologin page on remote Tiki to redirect user to login" => "URL of autologin page on remote Tiki to redirect user to login",
// "URL of autologin page on remote Tiki to redirect user to login, e.g. https://www.remotetiki.com/PageWithRedirectPlugin" => "URL of autologin page on remote Tiki to redirect user to login, e.g. https://www.remotetiki.com/PageWithRedirectPlugin",
"Long date format" => "長日期格式",
// "Specify how Tiki displays the date (longer version)" => "Specify how Tiki displays the date (longer version)",
"Long time format" => "長時間格式",
// "Specify how Tiki displays the time (longer version)" => "Specify how Tiki displays the time (longer version)",
// "%A %d of %B, %Y" => "%A %d of %B, %Y",
// "%H:%M:%S %Z" => "%H:%M:%S %Z",
// "%A %d of %B, %Y %H:%M:%S %Z" => "%A %d of %B, %Y %H:%M:%S %Z",
// "Force lowercase" => "Force lowercase",
// "Automatically convert all alphabetic characters in the username to lowercase letters. For example <b>JohnDoe</b> becomes <b>johndoe</b>" => "Automatically convert all alphabetic characters in the username to lowercase letters. For example <b>JohnDoe</b> becomes <b>johndoe</b>",
// "Email newline character(s)" => "Email newline character(s)",
// "End-of-line (EOL) character used in outgoing emails" => "End-of-line (EOL) character used in outgoing emails",
// "CRLF (standard)" => "CRLF (standard)",
// "LF (some Unix MTA)" => "LF (some Unix MTA)",
// "Text string used to customise mail templates" => "Text string used to customise mail templates",
// "Text string used to customise mail templates and added as a pref reference in the appropriate mail tpl files" => "Text string used to customise mail templates and added as a pref reference in the appropriate mail tpl files",
// "Main shadow start" => "Main shadow start",
// "Main shadow end" => "Main shadow end",
// "Maximum length" => "Maximum length",
// "The greatest number of characters for a valid username" => "The greatest number of characters for a valid username",
// "Memcache" => "Memcache",
// "Enable connection to memcached servers to store temporary information" => "Enable connection to memcached servers to store temporary information",
// "Requires the PHP memcache extension" => "Requires the PHP memcache extension",
// "Memcache servers" => "Memcache servers",
// "Server list which may be accessed. For each server, the address, port and weight must be specified" => "Server list which may be accessed. For each server, the address, port and weight must be specified",
// "One per line, with format of __address:port (weight)__; for example, \"localhost:11211 (1)\"" => "One per line, with format of __address:port (weight)__; for example, \"localhost:11211 (1)\"",
// "Memcache key prefix" => "Memcache key prefix",
// "When the memcache cluster is used by multiple applications, using unique prefixes for each of them helps avoid conflicts" => "When the memcache cluster is used by multiple applications, using unique prefixes for each of them helps avoid conflicts",
// "Memcache expiration" => "Memcache expiration",
// "Duration for which the data will be kept" => "Duration for which the data will be kept",
// "Cache wiki data in memcache" => "Cache wiki data in memcache",
// "Cache wiki output in memcache" => "Cache wiki output in memcache",
// "Cache forum output in memcache" => "Cache forum output in memcache",
// "Menu icons" => "Menu icons",
// "Allows icons to be defined for menu entries" => "Allows icons to be defined for menu entries",
// "Default path for the icons" => "Default path for the icons",
// "Edit menu icon" => "Edit menu icon",
// "Adds an icon on the navbar to edit menu entries" => "Adds an icon on the navbar to edit menu entries",
// "Maximum mailbox size" => "Maximum mailbox size",
// "Maximum number of messages allowed in the mailbox" => "Maximum number of messages allowed in the mailbox",
// "messages" => "messages",
// "Maximum mail archive size" => "Maximum mail archive size",
// "Maximum number of archive messages allowed" => "Maximum number of archive messages allowed",
// "Maximum sent box size" => "Maximum sent box size",
// "Maximum number of sent messages allowed in the mailbox" => "Maximum number of sent messages allowed in the mailbox",
// "Truncate internal message notification" => "Truncate internal message notification",
// "Number of characters to show in the message notification sent through email, with a link to read the full internal message" => "Number of characters to show in the message notification sent through email, with a link to read the full internal message",
// "Keywords" => "Keywords",
// "A list of keywords (separated by commas) that describe this website" => "A list of keywords (separated by commas) that describe this website",
// "Include tags" => "Include tags",
// "If the Tags feature is enabled, the tags for each page with tags set will be used as meta keywords. This allows individual pages at the site to have different meta tags" => "If the Tags feature is enabled, the tags for each page with tags set will be used as meta keywords. This allows individual pages at the site to have different meta tags",
// "Use thread title instead" => "Use thread title instead",
// "Use the forum thread title in the meta title tag" => "Use the forum thread title in the meta title tag",
// "Use the image title instead" => "Use the image title instead",
// "Use the image title in the meta title tag" => "Use the image title in the meta title tag",
// "A short description of the website. Some search engines display this information with the website's listing" => "A short description of the website. Some search engines display this information with the website's listing",
// "Page description" => "Page description",
// "Use each page description as a meta tag for that page" => "Use each page description as a meta tag for that page",
"Author" => "作者",
// "The author of this website. Typically this is the Admin or Webmaster" => "The author of this website. Typically this is the Admin or Webmaster",
// "geo.position" => "geo.position",
// "The latitude and longitude of the physical location of the site. For example \"38.898748, -77.037684\"" => "The latitude and longitude of the physical location of the site. For example \"38.898748, -77.037684\"",
// "geo.region" => "geo.region",
// "The ISO-3166 country and region codes for your location. For example, \"US-NY\"" => "The ISO-3166 country and region codes for your location. For example, \"US-NY\"",
// "geo.placename" => "geo.placename",
// "A free-text description of your location" => "A free-text description of your location",
// "Meta robots" => "Meta robots",
// "Specify how search engines robots should index your site. Will override page defaults. Valid values include: noindex, nofollow, none, all, noimageindex, noarchive, nocache, nosnippet, notranslate, unavailable_after and noyaca" => "Specify how search engines robots should index your site. Will override page defaults. Valid values include: noindex, nofollow, none, all, noimageindex, noarchive, nocache, nosnippet, notranslate, unavailable_after and noyaca",
// "Should be comma separated eg. noimageindex, nocache" => "Should be comma separated eg. noimageindex, nocache",
// "Revisit after" => "Revisit after",
// "Specify how often (in days) Web robots should visit your site" => "Specify how often (in days) Web robots should visit your site",
// "Middle shadow div start" => "Middle shadow div start",
// "Middle shadow div end" => "Middle shadow div end",
// "Minimum length" => "Minimum length",
// "The least possible number of characters for a valid username" => "The least possible number of characters for a valid username",
// "The least possible number of characters for a valid password" => "The least possible number of characters for a valid password",
// "Mobile access" => "Mobile access",
// "Allow automatic switching of the perspective according to the mobile_perspectives preference (behavior since Tiki 14)" => "Allow automatic switching of the perspective according to the mobile_perspectives preference (behavior since Tiki 14)",
// "This feature will be removed after Tiki18 and before Tiki19 (It is no longer under development following the integration of the Bootstrap CSS framework)" => "This feature will be removed after Tiki18 and before Tiki19 (It is no longer under development following the integration of the Bootstrap CSS framework)",
// "Mobile Perspectives" => "Mobile Perspectives",
// "Top module zone" => "Top module zone",
// "Activate zone for modules such as site logo, log-in form, etc. (page header)" => "Activate zone for modules such as site logo, log-in form, etc. (page header)",
// "Topbar module zone" => "Topbar module zone",
// "Activate zone for modules such as horizontal menu (navbar), search form, page-wide content, etc" => "Activate zone for modules such as horizontal menu (navbar), search form, page-wide content, etc",
// "topbar" => "topbar",
// "Page top module zone" => "Page top module zone",
// "Activate zone for modules such as breadcrumbs, banners, share icons, etc" => "Activate zone for modules such as breadcrumbs, banners, share icons, etc",
// "Bottom module zone" => "Bottom module zone",
// "Activate zone for modules such as \"powered by\" and \"rss list\" (page footer)" => "Activate zone for modules such as \"powered by\" and \"rss list\" (page footer)",
// "Page bottom module zone" => "Page bottom module zone",
// "Activate zone for modules at the bottom of the main column of each page" => "Activate zone for modules at the bottom of the main column of each page",
// "Module file" => "Module file",
// "Use a static module definition file instead of relying on the dynamic values generated by Tiki. Useful for custom themes. The file must be in YAML format, following the format used in profiles" => "Use a static module definition file instead of relying on the dynamic values generated by Tiki. Useful for custom themes. The file must be in YAML format, following the format used in profiles",
// "Extra module zones available" => "Extra module zones available",
// "Extra module zones to be managed through the module administration interface. Useful if a custom theme or layout requires a special zone other than the predefined ones" => "Extra module zones to be managed through the module administration interface. Useful if a custom theme or layout requires a special zone other than the predefined ones",
// "Comma-separated list, maximum of 20 characters per entry" => "Comma-separated list, maximum of 20 characters per entry",
// "Allow users to control the notifications they receive based on content changes" => "Allow users to control the notifications they receive based on content changes",
// "Notification digests" => "Notification digests",
// "Enable digest notifications (requires a cron job)" => "Enable digest notifications (requires a cron job)",
// "Clear individual notifications" => "Clear individual notifications",
// "Allow users to selectively clear notifications instead of simply having a clear-all button" => "Allow users to selectively clear notifications instead of simply having a clear-all button",
// "Notification count refresh interval" => "Notification count refresh interval",
// "Show unread notification count and refresh every [x] seconds" => "Show unread notification count and refresh every [x] seconds",
// "0 to disable, every refresh causes a hit on the server, try to leave this above 60 seconds" => "0 to disable, every refresh causes a hit on the server, try to leave this above 60 seconds",
// "Notification reply-to email pattern" => "Notification reply-to email pattern",
// "Email model to use for the notification email reply-to address" => "Email model to use for the notification email reply-to address",
// "noreply+PLACEHOLDER@example.com" => "noreply+PLACEHOLDER@example.com",
// "\"More Like This\" algorithm" => "\"More Like This\" algorithm",
// "enables tagged material to offer a find potentially related content. Basic will present content where a minimum number of tags match the item or page being viewed. Weighted is the same, but items are presented in Weighted (highest value first) sort order" => "enables tagged material to offer a find potentially related content. Basic will present content where a minimum number of tags match the item or page being viewed. Weighted is the same, but items are presented in Weighted (highest value first) sort order",
// "Minimum number of tags in common" => "Minimum number of tags in common",
// "The minimum number of matching tags required for an item to be presented in the \"More Like This\" feature" => "The minimum number of matching tags required for an item to be presented in the \"More Like This\" feature",
// "Multi-domain" => "Multi-domain",
// "Enable domain names to be mapped to perspectives and simulate multiple domains hosted with the same Tiki installation" => "Enable domain names to be mapped to perspectives and simulate multiple domains hosted with the same Tiki installation",
// "Multi-domain Configuration" => "Multi-domain Configuration",
// "Comma-separated values mapping the domain name to the perspective ID" => "Comma-separated values mapping the domain name to the perspective ID",
// "One domain per line with a comma separating it from the perspective ID. For example: tiki.org,1" => "One domain per line with a comma separating it from the perspective ID. For example: tiki.org,1",
// "Switch domain when switching perspective" => "Switch domain when switching perspective",
// "Important: Different domains have different login sessions and, even in the case of subdomains, an understanding of session cookies is needed to make it work" => "Important: Different domains have different login sessions and, even in the case of subdomains, an understanding of session cookies is needed to make it work",
// "Must read" => "Must read",
// "Allow assignment of mandatory readings and track progress" => "Allow assignment of mandatory readings and track progress",
// "Must read tracker" => "Must read tracker",
// "Tracker containing the individual read requests" => "Tracker containing the individual read requests",
// "Namespace" => "Namespace",
// "Enable namespaces feature for wiki pages" => "Enable namespaces feature for wiki pages",
// "Namespace separator" => "Namespace separator",
// "Select the character, symbol, or text to use as the namespace separator" => "Select the character, symbol, or text to use as the namespace separator",
// "Default namespace" => "Default namespace",
// "Namespace to use when creating wiki pages. Should be defined within perspectives" => "Namespace to use when creating wiki pages. Should be defined within perspectives",
// "Hide namespace indicator in structure path" => "Hide namespace indicator in structure path",
// "Hide namespace indicator in page title" => "Hide namespace indicator in page title",
// "Force all non-namespace page links to the same namespace" => "Force all non-namespace page links to the same namespace",
// "If the current page is in a namespace, all links without a namespace will have it added automatically" => "If the current page is in a namespace, all links without a namespace will have it added automatically",
// "Throttle newsletter send rate" => "Throttle newsletter send rate",
// "Pause for a given amount of seconds before each batch to avoid overloading the mail server" => "Pause for a given amount of seconds before each batch to avoid overloading the mail server",
// "Newsletter pause length" => "Newsletter pause length",
// "Number of seconds delay before each batch" => "Number of seconds delay before each batch",
// "Newsletter batch size" => "Newsletter batch size",
// "Number of emails to send in each batch" => "Number of emails to send in each batch",
// "emails" => "emails",
// "Allow sending newsletters through external clients" => "Allow sending newsletters through external clients",
// "Generate mailto links using the recipients as the BCC list" => "Generate mailto links using the recipients as the BCC list",
// "This will expose the list if email addresses to all users allowed to send newsletters" => "This will expose the list if email addresses to all users allowed to send newsletters",
// "Use relative (next / previous) pagination links" => "Use relative (next / previous) pagination links",
// "Encryption key for OAuthServer" => "Encryption key for OAuthServer",
// "A key used to encrypt/decrypt authorization codes" => "A key used to encrypt/decrypt authorization codes",
// "PGP/MIME encrypted email messaging" => "PGP/MIME encrypted email messaging",
// "Use OpenPGP PGP/MIME-compliant encrypted email messaging. All email messaging, notifications, and newsletters are sent as PGP/MIME-encrypted messages, signed with the signer key, and are completely opaque to outsiders. All user accounts need to be properly configured in a gnupg keyring with public keys associated with their tiki-account-related email addresses" => "Use OpenPGP PGP/MIME-compliant encrypted email messaging. All email messaging, notifications, and newsletters are sent as PGP/MIME-encrypted messages, signed with the signer key, and are completely opaque to outsiders. All user accounts need to be properly configured in a gnupg keyring with public keys associated with their tiki-account-related email addresses",
// "Enable only if gpg, keyring, and tikiaccounts are properly configured for PGP/MIME functionality. NOTE: Requires that all accounts have their public-keys configured into gnupg-keyring, so do not allow non-administred registrations (or e.g. non-configured emails for newsletters etc) to site if this feature turned on" => "Enable only if gpg, keyring, and tikiaccounts are properly configured for PGP/MIME functionality. NOTE: Requires that all accounts have their public-keys configured into gnupg-keyring, so do not allow non-administred registrations (or e.g. non-configured emails for newsletters etc) to site if this feature turned on",
// "Path to gnupg keyring" => "Path to gnupg keyring",
// "Full directory path to gnupg keyring (default /home/www/.gnupg/ ). The directory, related subdirectories (e.g., a subdirectory 'signer\\" => "Full directory path to gnupg keyring (default /home/www/.gnupg/ ). The directory, related subdirectories (e.g., a subdirectory 'signer\\",
// "Path to gpg executable" => "Path to gpg executable",
// "Full path to gpg executable" => "Full path to gpg executable",
// "Read signer pass phrase from prefs or from a file" => "Read signer pass phrase from prefs or from a file",
// "Read GnuPG signer pass phrase from preferences or from a file (default is 'file\\" => "Read GnuPG signer pass phrase from preferences or from a file (default is 'file\\",
// "preferences" => "preferences",
// "file" => "file",
// "Signer pass phrase" => "Signer pass phrase",
// "GnuPG signer private-key passphrase. Define pass phrase either here or in a signer pass phrase file" => "GnuPG signer private-key passphrase. Define pass phrase either here or in a signer pass phrase file",
// "leave empty if read from file" => "leave empty if read from file",
// "Path to signer pass phrase filename" => "Path to signer pass phrase filename",
// "Full path including the filename of the file containing the GnuPG signer private-key pass phrase. The directory and file must have proper permissions for tiki to access/read the signer pass phrase file" => "Full path including the filename of the file containing the GnuPG signer private-key pass phrase. The directory and file must have proper permissions for tiki to access/read the signer pass phrase file",
// "Wiki buttons" => "Wiki buttons",
// "Specify the location  of the wiki-specific options (such as Backlinks, Page Description, and so on)" => "Specify the location  of the wiki-specific options (such as Backlinks, Page Description, and so on)",
// "Top " => "Top ",
// "Bottom" => "Bottom",
// "Neither" => "Neither",
// "Pages can reoccur in structure" => "Pages can reoccur in structure",
// "A page can be listed multiple times in a structure" => "A page can be listed multiple times in a structure",
// "Fetch page content from incoming feeds" => "Fetch page content from incoming feeds",
// "Page content from the source will be fetched before sending the content to the generators" => "Page content from the source will be fetched before sending the content to the generators",
// "if set, will display 'first' and 'last' links on pages" => "if set, will display 'first' and 'last' links on pages",
// "Display \"fast-forward\" links" => "Display \"fast-forward\" links",
// "Display \"fast-forward\" links (to advance 10 percent of the total number of pages) " => "Display \"fast-forward\" links (to advance 10 percent of the total number of pages) ",
// "Hide pagination when there is only one page" => "Hide pagination when there is only one page",
// "Don't display pagination on single pages" => "Don't display pagination on single pages",
// "Use Icons" => "Use Icons",
// "Display 'First' and 'Last' links" => "Display 'First' and 'Last' links",
// "Require characters and numerals" => "Require characters and numerals",
// "For improved security, require users to include a mix of alphabetical characters and numerals in passwords" => "For improved security, require users to include a mix of alphabetical characters and numerals in passwords",
// "Password file used" => "Password file used",
// "The automatically selected file is recommended unless you generate your own blacklist file" => "The automatically selected file is recommended unless you generate your own blacklist file",
// "Prevent common passwords" => "Prevent common passwords",
// "For improved security, prevent users from creating blacklisted passwords. Use default blacklist or create custom blacklists through Control Panel -> Log in -> Password Blacklist" => "For improved security, prevent users from creating blacklisted passwords. Use default blacklist or create custom blacklists through Control Panel -> Log in -> Password Blacklist",
// "Password expires after" => "Password expires after",
// "The number of days after which a password will expire. Days are counted starting with the user’s first login. When the password expires, users will be required to select a new password when logging in" => "The number of days after which a password will expire. Days are counted starting with the user’s first login. When the password expires, users will be required to select a new password when logging in",
// "Require alphabetical characters in lower and upper case" => "Require alphabetical characters in lower and upper case",
// "Password must contain at least one lowercase alphabetical character like \"a\" and one uppercase character like \"A\". Use this option to require users to select stronger passwords" => "Password must contain at least one lowercase alphabetical character like \"a\" and one uppercase character like \"A\". Use this option to require users to select stronger passwords",
// "Require special characters" => "Require special characters",
// "Password must contain at least one special character in lower case like <b>\" / \$ % ? & * ( ) _ + .</b> Use this option to require users to select stronger passwords" => "Password must contain at least one special character in lower case like <b>\" / \$ % ? & * ( ) _ + .</b> Use this option to require users to select stronger passwords",
// "Require no consecutive repetition of the same character" => "Require no consecutive repetition of the same character",
// "Password must not contain a consecutive repetition of the same character such as \"111\" or \"aab\"" => "Password must not contain a consecutive repetition of the same character such as \"111\" or \"aab\"",
// "The password must be different from the user's log-in name" => "The password must be different from the user's log-in name",
// "Payment" => "Payment",
// "Feature for tracking and managing payment requests" => "Feature for tracking and managing payment requests",
// "Payment system" => "Payment system",
// "Currently a choice between PayPal, and Cclite (in development), or Tiki User Credits" => "Currently a choice between PayPal, and Cclite (in development), or Tiki User Credits",
// "PayPal: see PayPal.com - Cclite: Community currency" => "PayPal: see PayPal.com - Cclite: Community currency",
// "PayPal" => "PayPal",
// "Israel Post Payment Module" => "Israel Post Payment Module",
// "Cclite" => "Cclite",
// "Tiki User Credits" => "Tiki User Credits",
// "PayPal ID" => "PayPal ID",
// "Enable payments through PayPal. This account can be either Personal, Business Standard, or Business Pro. A Personal account allows the receiving of small payments from shopping carts. A Business Standard account allows also the receiving of periodic payments through Plugin GroupMembership or receiving bigger amounts. And a Business Pro account allows further customization. See paypal.com for more information and exact fees depending on your country and business type" => "Enable payments through PayPal. This account can be either Personal, Business Standard, or Business Pro. A Personal account allows the receiving of small payments from shopping carts. A Business Standard account allows also the receiving of periodic payments through Plugin GroupMembership or receiving bigger amounts. And a Business Pro account allows further customization. See paypal.com for more information and exact fees depending on your country and business type",
// "Primary email of your PayPal account (Personal or Business)" => "Primary email of your PayPal account (Personal or Business)",
// "PayPal business password" => "PayPal business password",
// "The PayPal password associated with your PayPal Pro business account. This is NOT needed for PayPal Personal or PayPal Standard Business accounts" => "The PayPal password associated with your PayPal Pro business account. This is NOT needed for PayPal Personal or PayPal Standard Business accounts",
// "Primary password of your PayPal Pro business account - OPTIONAL" => "Primary password of your PayPal Pro business account - OPTIONAL",
// "Paypal business signature" => "Paypal business signature",
// "Your API signature associated with your PayPal Pro business account. This is NOT needed for Paypal Personal or Paypal Standard Business accounts" => "Your API signature associated with your PayPal Pro business account. This is NOT needed for Paypal Personal or Paypal Standard Business accounts",
// "Your API signature associated with your PayPal Pro business account - OPTIONAL" => "Your API signature associated with your PayPal Pro business account - OPTIONAL",
// "PayPal environment" => "PayPal environment",
// "Used to switch between the PayPal sandbox, used for testing and development and the live environment" => "Used to switch between the PayPal sandbox, used for testing and development and the live environment",
// "Production" => "Production",
// "PayPal instant payment notification (IPN)" => "PayPal instant payment notification (IPN)",
// "Enable IPN for automatic payment completion. PayPal will ping back the site when a payment is confirmed. The payment will then be entered automatically. This may not be possible if the site is not on a public server" => "Enable IPN for automatic payment completion. PayPal will ping back the site when a payment is confirmed. The payment will then be entered automatically. This may not be possible if the site is not on a public server",
// "Payment data transfer (PDT)" => "Payment data transfer (PDT)",
// "Enable PDT for automatic payment completion. PayPal will include information that allow to validate the payment when redirecting the user back to your website without waiting for PayPal to ping back the website like IPN. The payment will then be entered automatically" => "Enable PDT for automatic payment completion. PayPal will include information that allow to validate the payment when redirecting the user back to your website without waiting for PayPal to ping back the website like IPN. The payment will then be entered automatically",
// "Payment data transfer (PDT) token" => "Payment data transfer (PDT) token",
// " Payment data transfer token to validate PDT messages, which should be available in the PayPal admin interface where you enable PDT" => " Payment data transfer token to validate PDT messages, which should be available in the PayPal admin interface where you enable PDT",
// "Redirect after PDT payment" => "Redirect after PDT payment",
// "Optionally, after receiving a successful payment, the user will be redirected to this page" => "Optionally, after receiving a successful payment, the user will be redirected to this page",
// "Currency used when entering payments" => "Currency used when entering payments",
// "Default acceptable payment delay" => "Default acceptable payment delay",
// "Number of days before a payment request becomes overdue. This can be changed per payment request" => "Number of days before a payment request becomes overdue. This can be changed per payment request",
// "Cclite registries" => "Cclite registries",
// "Registries in Cclite" => "Registries in Cclite",
// "Registry names in Cclite" => "Registry names in Cclite",
// "Cclite registry currencies" => "Cclite registry currencies",
// "Currencies in Cclite" => "Currencies in Cclite",
// "Each registry in Cclite can have its own currency. There must be one currency per registry (case sensitive)" => "Each registry in Cclite can have its own currency. There must be one currency per registry (case sensitive)",
// "Cclite server URL" => "Cclite server URL",
// "Full URL of the repository" => "Full URL of the repository",
// "for example, https://cclite.yourdomain.org/cclite/" => "for example, https://cclite.yourdomain.org/cclite/",
// "Cclite merchant key" => "Cclite merchant key",
// "Corresponds with merchant key setting in Cclite" => "Corresponds with merchant key setting in Cclite",
// "Cclite merchant user" => "Cclite merchant user",
// "Username in Cclite representing \"the management\"" => "Username in Cclite representing \"the management\"",
// "Cclite enable payments" => "Cclite enable payments",
// "Select Cclite test or live operation" => "Select Cclite test or live operation",
// "Live" => "Live",
// "Hashing algorithm" => "Hashing algorithm",
// "Encryption type" => "Encryption type",
// "SHA1" => "SHA1",
// "SHA256" => "SHA256",
// "SHA512" => "SHA512",
// "Cclite payment notification" => "Cclite payment notification",
// "To do" => "To do",
// "Wiki page with manual payment instructions" => "Wiki page with manual payment instructions",
// "Enter wiki page name" => "Enter wiki page name",
// "Invoice prefix" => "Invoice prefix",
// "The prefix must be set and unique if the same PayPal account is used for different Tiki sites, because PayPal checks that the invoice is not paid twice" => "The prefix must be set and unique if the same PayPal account is used for different Tiki sites, because PayPal checks that the invoice is not paid twice",
// "Types of credit to use" => "Types of credit to use",
// "This is a list of the types of Tiki user credits that are acceptable for payment" => "This is a list of the types of Tiki user credits that are acceptable for payment",
// "Exchange rate for types of credit to use" => "Exchange rate for types of credit to use",
// "This is a corresponding list of the number of credits equivalent to 1 unit of the payment currency" => "This is a corresponding list of the number of credits equivalent to 1 unit of the payment currency",
// "User can only see own outstanding payments" => "User can only see own outstanding payments",
// "Unless the user has administer-payment permissions, a user can only see his or her own outstanding payments" => "Unless the user has administer-payment permissions, a user can only see his or her own outstanding payments",
// "User can only see own past or cancelled payments" => "User can only see own past or cancelled payments",
// "Unless the user has administer-payment permissions, the user can only see his or her own past or cancelled payments" => "Unless the user has administer-payment permissions, the user can only see his or her own past or cancelled payments",
// "Anonymous users can pay outstanding invoices" => "Anonymous users can pay outstanding invoices",
// "Anonymous users can see outstanding invoices to pay them through a simple shopping cart (without the need to set up the advanced cart)" => "Anonymous users can see outstanding invoices to pay them through a simple shopping cart (without the need to set up the advanced cart)",
// "Manage product inventory" => "Manage product inventory",
// "Activate product inventory feature. This requires a products tracker to be set up properly, and the item ID must be the product code" => "Activate product inventory feature. This requires a products tracker to be set up properly, and the item ID must be the product code",
// "Products tracker ID" => "Products tracker ID",
// "ID of the tracker that is the products tracker, which is needed for advanced cart features; the item ID will be the product code" => "ID of the tracker that is the products tracker, which is needed for advanced cart features; the item ID will be the product code",
// "Products tracker name" => "Products tracker name",
// "Name of tracker that is the products tracker, needed for advanced cart features; the item ID will be the product code" => "Name of tracker that is the products tracker, needed for advanced cart features; the item ID will be the product code",
// "Inventory type field ID" => "Inventory type field ID",
// "In the products tracker, the ID of the field to store the inventory type; the value of the field must be \"none\" or \"internal\"" => "In the products tracker, the ID of the field to store the inventory type; the value of the field must be \"none\" or \"internal\"",
// "Inventory total field ID" => "Inventory total field ID",
// "In the products tracker, the ID of the field to store the total inventory of products" => "In the products tracker, the ID of the field to store the total inventory of products",
// "Inventory total less hold field ID" => "Inventory total less hold field ID",
// "In the products tracker, the ID of the field to store the total inventory of products less the amount on hold because they are currently in carts" => "In the products tracker, the ID of the field to store the total inventory of products less the amount on hold because they are currently in carts",
// "Inventory hold timeout" => "Inventory hold timeout",
// "Minutes to hold inventory before making it available again when there is no user cart action" => "Minutes to hold inventory before making it available again when there is no user cart action",
// "Bundled products feature for cart" => "Bundled products feature for cart",
// "Activate the bundled products feature. This requires a products tracker to be set up properly, and the item ID must be the product code" => "Activate the bundled products feature. This requires a products tracker to be set up properly, and the item ID must be the product code",
// "Product name field name" => "Product name field name",
// "In the products tracker, the name of the field for the product name that will be used as the label of the product, for example in a bundle" => "In the products tracker, the name of the field for the product name that will be used as the label of the product, for example in a bundle",
// "Items in bundle field name" => "Items in bundle field name",
// "In the products tracker, the name of the field for a comma-separated list of product IDs of products in the bundle (that is, if the field contains anything, then this product is a bundle). You can also specify the number of the sub-products; for example, 23:(\"colon\")2,24 means item 23 (x2) + item 24 (x1)" => "In the products tracker, the name of the field for a comma-separated list of product IDs of products in the bundle (that is, if the field contains anything, then this product is a bundle). You can also specify the number of the sub-products; for example, 23:(\"colon\")2,24 means item 23 (x2) + item 24 (x1)",
// "Product price field name" => "Product price field name",
// "In the products tracker, the name of the field for the product price" => "In the products tracker, the name of the field for the product price",
// "Associated event ID field name" => "Associated event ID field name",
// "In the products tracker, the field name for the associated event ID. This is needed for the associated events cart feature, and requires an events tracker to be set up in which the item ID there is the event ID to be associated with" => "In the products tracker, the field name for the associated event ID. This is needed for the associated events cart feature, and requires an events tracker to be set up in which the item ID there is the event ID to be associated with",
// "Product class ID field name" => "Product class ID field name",
// "In the products tracker, the name of the field for the product class ID, needed for the gift certificates cart feature" => "In the products tracker, the name of the field for the product class ID, needed for the gift certificates cart feature",
// "Gift certificate template field name" => "Gift certificate template field name",
// "In the products tracker, the name of the field for the gift certificate template, needed for the gift certificates cart feature" => "In the products tracker, the name of the field for the gift certificate template, needed for the gift certificates cart feature",
// "Record cart orders in trackers" => "Record cart orders in trackers",
// "This feature is available for registered users and requires two trackers to be created and configured, an orders tracker and an orders item tracker. Profiles also need to be configured, to do the recording" => "This feature is available for registered users and requires two trackers to be created and configured, an orders tracker and an orders item tracker. Profiles also need to be configured, to do the recording",
// "Orders profile" => "Orders profile",
// "Wiki page containing the profile for creating orders (page name must not have spaces)" => "Wiki page containing the profile for creating orders (page name must not have spaces)",
// "Order item profile" => "Order item profile",
// "Wiki page containing the profile for creating order items (page name must not have spaces)" => "Wiki page containing the profile for creating order items (page name must not have spaces)",
// "Allow anonymous shopping" => "Allow anonymous shopping",
// "Allow shopping by anonymous users and record the orders in trackers" => "Allow shopping by anonymous users and record the orders in trackers",
// "Anonymous orders profile" => "Anonymous orders profile",
// "Wiki page containing the profile for creating orders for anonymous users (page name must not have spaces)" => "Wiki page containing the profile for creating orders for anonymous users (page name must not have spaces)",
// "Anonymous order item profile" => "Anonymous order item profile",
// "Wiki page containing the profile for creating order items for anonymous users (page name must not have spaces)" => "Wiki page containing the profile for creating order items for anonymous users (page name must not have spaces)",
// "Anonymous shopper info profile" => "Anonymous shopper info profile",
// "Anonymous users order review page" => "Anonymous users order review page",
// "Wiki page where anonymous users can review their orders" => "Wiki page where anonymous users can review their orders",
// "Temporary shopper group" => "Temporary shopper group",
// "Group name of group with permission to access review page via a token" => "Group name of group with permission to access review page via a token",
// "Enable association of product orders" => "Enable association of product orders",
// "Enable association of products with events (or projects, etc.)" => "Enable association of products with events (or projects, etc.)",
// "Events tracker ID" => "Events tracker ID",
// "Tracker ID of tracker that is the events tracker" => "Tracker ID of tracker that is the events tracker",
// "Events tracker name" => "Events tracker name",
// "Name of tracker that is the events tracker" => "Name of tracker that is the events tracker",
// "Event start field name" => "Event start field name",
// "Field name in events tracker of start date/time" => "Field name in events tracker of start date/time",
// "Event end field name" => "Event end field name",
// "Field name in events tracker of end date/time" => "Field name in events tracker of end date/time",
// "Allow exchange of products" => "Allow exchange of products",
// "Order items tracker ID" => "Order items tracker ID",
// "Tracker ID of tracker that is the order items tracker" => "Tracker ID of tracker that is the order items tracker",
// "Gift certificates" => "Gift certificates",
// "Gift certificate tracker ID" => "Gift certificate tracker ID",
// "ID of tracker that is the gift certificate tracker" => "ID of tracker that is the gift certificate tracker",
// "Gift certificate tracker name" => "Gift certificate tracker name",
// "Name of tracker that is the gift certificate tracker" => "Name of tracker that is the gift certificate tracker",
// "Orders tracker name" => "Orders tracker name",
// "Name of tracker that is the orders tracker" => "Name of tracker that is the orders tracker",
// "Order items tracker name" => "Order items tracker name",
// "Name of tracker that is the order items tracker" => "Name of tracker that is the order items tracker",
// "Product classes tracker name" => "Product classes tracker name",
// "Name of tracker that is the product classes tracker" => "Name of tracker that is the product classes tracker",
// "Payment heading" => "Payment heading",
// "Heading displayed on payment form" => "Heading displayed on payment form",
// "Israel Post payment environment" => "Israel Post payment environment",
// "Switch between test transactions and real transactions" => "Switch between test transactions and real transactions",
// "Israel Post use pre-authorization" => "Israel Post use pre-authorization",
// "Use the pre-authorization mechanism prior to processing the real transaction. Must match the account configuration at Israel Post" => "Use the pre-authorization mechanism prior to processing the real transaction. Must match the account configuration at Israel Post",
// "Israel Post business ID" => "Israel Post business ID",
// "Provided by Israel Post, usually the business name" => "Provided by Israel Post, usually the business name",
// "Israel Post API password" => "Israel Post API password",
// "Provided by Israel Post" => "Provided by Israel Post",
// "Send to URL" => "Send to URL",
// "URL to redirect to on \"permission denied\"" => "URL to redirect to on \"permission denied\"",
// "On permission denied, display login module" => "On permission denied, display login module",
// "If an anonymous visitor attempts to access a page for which permission is not granted, Tiki will automatically display the Log-in module. \nAlternatively, use the Send to URL field to display a specific page (relative to your Tiki installation) instead" => "If an anonymous visitor attempts to access a page for which permission is not granted, Tiki will automatically display the Log-in module. \nAlternatively, use the Send to URL field to display a specific page (relative to your Tiki installation) instead",
// "PHP libxml extension" => "PHP libxml extension",
// "This extension requires the libxml PHP extension.\n\t\t\t\tThis means that passing in --enable-libxml is also required, although this is\n\t\t\t\timplicitly accomplished because libxml is enabled by default" => "This extension requires the libxml PHP extension.\n\t\t\t\tThis means that passing in --enable-libxml is also required, although this is\n\t\t\t\timplicitly accomplished because libxml is enabled by default",
// "PHP DateTime" => "PHP DateTime",
// "DateTime class (and related functions) are enabled\n\t\t\t\tby default since PHP 5.2.0" => "DateTime class (and related functions) are enabled\n\t\t\t\tby default since PHP 5.2.0",
// "Number of comments to show on poll pages" => "Number of comments to show on poll pages",
// "The order in which order polls are displayed" => "The order in which order polls are displayed",
// "Show categories" => "Show categories",
// "For polls that are categorized, the category is displayed" => "For polls that are categorized, the category is displayed",
// "Show objects" => "Show objects",
// "List wiki pages or other site objects that the poll is attached to" => "List wiki pages or other site objects that the poll is attached to",
// "Multiple polls per object" => "Multiple polls per object",
// "When used with the rating features, allow multiple polls to be attached to a single object" => "When used with the rating features, allow multiple polls to be attached to a single object",
// "Disable textarea toolbar" => "Disable textarea toolbar",
// "Don't display the toolbar on text inputs in surveys" => "Don't display the toolbar on text inputs in surveys",
// "Precision of survey results calculation" => "Precision of survey results calculation",
// "Number of decimal places in the percentage figures" => "Number of decimal places in the percentage figures",
// "decimal places" => "decimal places",
// "Set display settings for all galleries" => "Set display settings for all galleries",
// "PDF from URL" => "PDF from URL",
// "Using external tools, generate PDF documents from URLs" => "Using external tools, generate PDF documents from URLs",
// "WebKit (wkhtmltopdf)" => "WebKit (wkhtmltopdf)",
// "WeasyPrint" => "WeasyPrint",
// "mPDF" => "mPDF",
// "Webservice URL" => "Webservice URL",
// "URL to a service that takes a URL as the query string and returns a PDF document" => "URL to a service that takes a URL as the query string and returns a PDF document",
// "WebKit path" => "WebKit path",
// "Full path to the wkhtmltopdf executable to generate the PDF document with" => "Full path to the wkhtmltopdf executable to generate the PDF document with",
// "WeasyPrint path" => "WeasyPrint path",
// "Full path to the weasyprint executable to generate the PDF document with" => "Full path to the weasyprint executable to generate the PDF document with",
// "Print Friendly PDF" => "Print Friendly PDF",
// "Useful for dark themes, enabling this option will change the theme background color to white and the color of text to black. If not activated, theme colors will be retained in the pdf file" => "Useful for dark themes, enabling this option will change the theme background color to white and the color of text to black. If not activated, theme colors will be retained in the pdf file",
// "PDF Orientation" => "PDF Orientation",
// "Landscape or portrait" => "Landscape or portrait",
// "Portrait" => "Portrait",
// "Landscape" => "Landscape",
// "PDF page size" => "PDF page size",
// "ISO Standard sizes: A0, A1, A2, A3, A4, A5 or North American paper sizes: Letter, Legal, Tabloid/Ledger (for ledger, select landscape orientation)" => "ISO Standard sizes: A0, A1, A2, A3, A4, A5 or North American paper sizes: Letter, Legal, Tabloid/Ledger (for ledger, select landscape orientation)",
// "Legal" => "Legal",
// "Tabloid/Ledger" => "Tabloid/Ledger",
// "A0" => "A0",
// "A1" => "A1",
// "A2" => "A2",
// "A3" => "A3",
// "A4" => "A4",
// "A5" => "A5",
// "A6" => "A6",
// "Generate auto table of contents with PDF" => "Generate auto table of contents with PDF",
// "Link TOC with content" => "Link TOC with content",
// "Link table of contents headings with content in the PDF" => "Link table of contents headings with content in the PDF",
// "TOC heading" => "TOC heading",
// "Heading to be displayed above the table of contents" => "Heading to be displayed above the table of contents",
// "PDF TOC levels" => "PDF TOC levels",
// "These will be automatically created from the content; the default will be heading 1, heading 2 and heading 3 - for example, H1|H2|H3" => "These will be automatically created from the content; the default will be heading 1, heading 2 and heading 3 - for example, H1|H2|H3",
// "Show Page title" => "Show Page title",
// "Print wiki page title with pdf" => "Print wiki page title with pdf",
// "PDF header text" => "PDF header text",
// "Possible values, Plain text, HTML, Wiki syntax, {PAGENO},{PAGETITLE},{DATE j-m-Y}, Page {PAGENO} of {NB}, {include page=\"wiki_page_name\"}" => "Possible values, Plain text, HTML, Wiki syntax, {PAGENO},{PAGETITLE},{DATE j-m-Y}, Page {PAGENO} of {NB}, {include page=\"wiki_page_name\"}",
// "HTML / Wiki Syntax / " => "HTML / Wiki Syntax / ",
// "Left text" => "Left text",
// "Center Text" => "Center Text",
// "Right Text" => "Right Text",
// "PDF footer text" => "PDF footer text",
// "HTML, Wiki Syntax, plain text, {PAGENO}, {DATE j-m-Y}, Page {PAGENO} of {NB}" => "HTML, Wiki Syntax, plain text, {PAGENO}, {DATE j-m-Y}, Page {PAGENO} of {NB}",
// "Left margin" => "Left margin",
// "Numeric value.For example 10" => "Numeric value.For example 10",
// "Right margin" => "Right margin",
// "Numeric value, no need to add px. For example 10" => "Numeric value, no need to add px. For example 10",
// "Top margin" => "Top margin",
// "Bottom margin" => "Bottom margin",
// "Header margin from top of document" => "Header margin from top of document",
// "Only applicable if the header is set. Specify a numeric value, and there is no need to add \"px\". For example, 10" => "Only applicable if the header is set. Specify a numeric value, and there is no need to add \"px\". For example, 10",
// "Warning: Header can overlap text if top margin is not set properly" => "Warning: Header can overlap text if top margin is not set properly",
// "Footer margin from bottom of document" => "Footer margin from bottom of document",
// "Only applicable if the footer is set. Specify a numeric value, and there is no need to add \"px\". For example, 10" => "Only applicable if the footer is set. Specify a numeric value, and there is no need to add \"px\". For example, 10",
// "Warning: Footer can overlap text if bottom margin is not set properly" => "Warning: Footer can overlap text if bottom margin is not set properly",
// "Hyperlink behaviour in PDF" => "Hyperlink behaviour in PDF",
// "Off (Links will be removed)" => "Off (Links will be removed)",
// "Add as footnote (Links will be listed at end of document" => "Add as footnote (Links will be listed at end of document",
// "PDF Bookmarks" => "PDF Bookmarks",
// "Automatically generate bookmarks" => "Automatically generate bookmarks",
// "H1-H6, separated by |.For example: H1|H2|H3" => "H1-H6, separated by |.For example: H1|H2|H3",
// "Number of columns" => "Number of columns",
// "Default - 1 Column" => "Default - 1 Column",
// "2 Columns" => "2 Columns",
// "3 Columns" => "3 Columns",
// "4 Columns" => "4 Columns",
// "PDF password for viewing" => "PDF password for viewing",
// "Password-protect the generated PDF" => "Password-protect the generated PDF",
// "Watermark text" => "Watermark text",
// "PDF watermark text, if any" => "PDF watermark text, if any",
// "Watermark Image URL" => "Watermark Image URL",
// "The watermark image will appear under the text. Enter the complete image URL" => "The watermark image will appear under the text. Enter the complete image URL",
// "PDF page background color" => "PDF page background color",
// "Enter a valid CSS color code" => "Enter a valid CSS color code",
// "PDF page background image" => "PDF page background image",
// "Enter the full URL" => "Enter the full URL",
// "CoverPage text settings" => "CoverPage text settings",
// "Heading|Subheading|Alignment|Background color|Text color|Page border|Border color. Enter settings separated by |. Leave blank to use default settings" => "Heading|Subheading|Alignment|Background color|Text color|Page border|Border color. Enter settings separated by |. Leave blank to use default settings",
// "Coverpage image URL" => "Coverpage image URL",
// "Print wiki authors" => "Print wiki authors",
// "Include wiki page authors and date in print versions of wiki pages" => "Include wiki page authors and date in print versions of wiki pages",
// "Print original wiki URL" => "Print original wiki URL",
// "Include original wiki page URL in print versions of wiki pages" => "Include original wiki page URL in print versions of wiki pages",
// "Print original tracker item URL" => "Print original tracker item URL",
// "Print original forum post URL" => "Print original forum post URL",
// "Include original forum post URL in print version of forum posts" => "Include original forum post URL in print version of forum posts",
// "Repository URLs" => "Repository URLs",
// "List of URLs for the profile repositories that will be used" => "List of URLs for the profile repositories that will be used",
// "Enter multiple repository URLs, one per line" => "Enter multiple repository URLs, one per line",
// "Data channels" => "Data channels",
// "Data channels are templates that can be applied from a post request. They can be used to automate work on more complex installations" => "Data channels are templates that can be applied from a post request. They can be used to automate work on more complex installations",
// "Data channels create a named pipe to run profiles from user space. One channel per line. Each line is comma delimited and contains __channel name, domain, profile, allowed groups, (optional) \$profilerequest:input\$ matches to groups__" => "Data channels create a named pipe to run profiles from user space. One channel per line. Each line is comma delimited and contains __channel name, domain, profile, allowed groups, (optional) \$profilerequest:input\$ matches to groups__",
// "There are security considerations related to using data channels. Make sure the profile page is controlled by administrators only" => "There are security considerations related to using data channels. Make sure the profile page is controlled by administrators only",
// "Developer mode" => "Developer mode",
// "For profiles under an approval workflow, always use the latest version, even if not approved" => "For profiles under an approval workflow, always use the latest version, even if not approved",
// "Make sure you review the profiles you install" => "Make sure you review the profiles you install",
// "Automatically approve wiki-plugins on pages installed by profiles" => "Automatically approve wiki-plugins on pages installed by profiles",
// "Some wiki-plugins require admin approval before they are executable. If turned on, then all wiki-plugins that are on wiki pages created via profiles are automatically approved" => "Some wiki-plugins require admin approval before they are executable. If turned on, then all wiki-plugins that are on wiki pages created via profiles are automatically approved",
// "Make sure your profiles are not executable or editable by untrusted users" => "Make sure your profiles are not executable or editable by untrusted users",
// "Proxy host name" => "Proxy host name",
// "Proxy host - without http:// or similar, just the host name" => "Proxy host - without http:// or similar, just the host name",
// "Proxy port" => "Proxy port",
// "Proxy username" => "Proxy username",
// "Proxy password" => "Proxy password",
// "Quantify change size" => "Quantify change size",
// "In addition to tracking the changes, track the change size and display approximately how up-to-date the page is" => "In addition to tracking the changes, track the change size and display approximately how up-to-date the page is",
// "Advanced Rating" => "Advanced Rating",
// "In an advanced rating system, the options and calculation method can be configured" => "In an advanced rating system, the options and calculation method can be configured",
// "Rating recalculation mode" => "Rating recalculation mode",
// "Determines when and how rating aggregates are recalculated. Depending on the site load, some options may be preferred to others. On large-volume sites, it should be done as a cron job. On vote recalculation, there may be inaccuracies if rating calculation is time-dependent" => "Determines when and how rating aggregates are recalculated. Depending on the site load, some options may be preferred to others. On large-volume sites, it should be done as a cron job. On vote recalculation, there may be inaccuracies if rating calculation is time-dependent",
// "Recalculate on vote" => "Recalculate on vote",
// "Randomly recalculate oldest ratings (on load)" => "Randomly recalculate oldest ratings (on load)",
// "Randomly recalculate oldest ratings (on vote)" => "Randomly recalculate oldest ratings (on vote)",
// "Cron job (must be set manually)" => "Cron job (must be set manually)",
// "Before any attempt to re-index the object" => "Before any attempt to re-index the object",
// "Recalculation odds (1 in X)" => "Recalculation odds (1 in X)",
// "Dice roll performed on every request. When successful, will recalculate a certain number of votes" => "Dice roll performed on every request. When successful, will recalculate a certain number of votes",
"votes" => "票",
// "Recalculation count" => "Recalculation count",
// "How many ratings should be recalculated when odds strike" => "How many ratings should be recalculated when odds strike",
// "ratings" => "ratings",
// "Smiley Ratings" => "Smiley Ratings",
// "Displays smiley faces or emojis in a simple ratings system with an easy-to-use interface. Works with 0-11 only, depending on the configuration" => "Displays smiley faces or emojis in a simple ratings system with an easy-to-use interface. Works with 0-11 only, depending on the configuration",
// "Enabled" => "Enabled",
// "Detailed rating results" => "Detailed rating results",
// "Displays a table with the result count and percentage per rating option" => "Displays a table with the result count and percentage per rating option",
// "Reversed Rating Options" => "Reversed Rating Options",
// "Displays the ratings options in reverse" => "Displays the ratings options in reverse",
// "Include percentages in the detailed rating results" => "Include percentages in the detailed rating results",
// "Include percentages in the detailed rating results. Otherwise, only count numbers and bars are shown" => "Include percentages in the detailed rating results. Otherwise, only count numbers and bars are shown",
// "Default rating options" => "Default rating options",
// "List of options available" => "List of options available",
// "Multiple votes per user" => "Multiple votes per user",
// "Allow users to vote multiple times in the same poll" => "Allow users to vote multiple times in the same poll",
// "Use reCAPTCHA" => "Use reCAPTCHA",
// "Use reCAPTCHA, a specialized captcha service, instead of default CAPTCHA" => "Use reCAPTCHA, a specialized captcha service, instead of default CAPTCHA",
// "You will need to register at [http://www.google.com/recaptcha]" => "You will need to register at [http://www.google.com/recaptcha]",
// "Site key" => "Site key",
// "reCAPTCHA public key obtained after registering" => "reCAPTCHA public key obtained after registering",
// "Secret key" => "Secret key",
// "reCAPTCHA private key obtained after registering" => "reCAPTCHA private key obtained after registering",
// "reCAPTCHA theme" => "reCAPTCHA theme",
// "Choose a theme for the reCAPTCHA widget" => "Choose a theme for the reCAPTCHA widget",
// "Black Glass" => "Black Glass",
// "Red" => "Red",
// "White" => "White",
// "reCAPTCHA version" => "reCAPTCHA version",
// "1.0" => "1.0",
// "2.0" => "2.0",
// "3.0" => "3.0",
"Record untranslated strings" => "記錄未翻譯項目",
// "Keep track of the unsuccessful attemps to translate strings" => "Keep track of the unsuccessful attemps to translate strings",
// "Redis" => "Redis",
// "Enable connection to Redis to store cache" => "Enable connection to Redis to store cache",
// "Requires PHP Redis" => "Requires PHP Redis",
// "Redis Host" => "Redis Host",
// "IP address or domain name for Redis server" => "IP address or domain name for Redis server",
// "Redis Port" => "Redis Port",
// "Port for Redis server" => "Port for Redis server",
// "Redis connection timeout" => "Redis connection timeout",
// "Seconds to wait before timeout when trying to connect to Redis. 0 means unlimited" => "Seconds to wait before timeout when trying to connect to Redis. 0 means unlimited",
// "Redis Prefix" => "Redis Prefix",
// "When the Redis cluster is used by multiple applications, using unique prefixes for each of them helps avoid conflicts. Leave blank for none" => "When the Redis cluster is used by multiple applications, using unique prefixes for each of them helps avoid conflicts. Leave blank for none",
// "Redis cache expiry" => "Redis cache expiry",
// "Duration for which the cache will be kept. 0 means unlimited" => "Duration for which the cache will be kept. 0 means unlimited",
// "Redis is single threaded, which means that when clearing cache which could take a while especially if the total Redis db is large, it could hold up the Redis server for other applications as well. Use separate instances instead of prefixing if that is a concern" => "Redis is single threaded, which means that when clearing cache which could take a while especially if the total Redis db is large, it could hold up the Redis server for other applications as well. Use separate instances instead of prefixing if that is a concern",
// "Restrict supported languages" => "Restrict supported languages",
// "Limit the languages made available on the site" => "Limit the languages made available on the site",
// "Use Ctrl+Click to select multiple languages" => "Use Ctrl+Click to select multiple languages",
// "Enable SAML Auth" => "Enable SAML Auth",
// "IdP Entity Id" => "IdP Entity Id",
// "Identifier of the IdP entity (\"Issuer\")" => "Identifier of the IdP entity (\"Issuer\")",
// "Single sign-on service URL" => "Single sign-on service URL",
// "SSO endpoint info of the IdP, the URL target of the IdP where the SP will send the Authentication Request (\"SAML 2.0 Endpoint (HTTP)\")" => "SSO endpoint info of the IdP, the URL target of the IdP where the SP will send the Authentication Request (\"SAML 2.0 Endpoint (HTTP)\")",
// "Single log-out service URL" => "Single log-out service URL",
// "SLO endpoint info of the IdP, the URL target of the IdP where the SP will send the SLO Request (\"SLO Endpoint (HTTP)\")" => "SLO endpoint info of the IdP, the URL target of the IdP where the SP will send the SLO Request (\"SLO Endpoint (HTTP)\")",
// "X.509 certificate" => "X.509 certificate",
// "Public x509 certificate of the IdP.  (\"X.509 certificate\")" => "Public x509 certificate of the IdP.  (\"X.509 certificate\")",
// "Auto-provisioning - if the user doesn't exist, Tiki will create a new user with the data provided by the IdP.<br>Review the Mapping section" => "Auto-provisioning - if the user doesn't exist, Tiki will create a new user with the data provided by the IdP.<br>Review the Mapping section",
// "Sync user group with IdP data" => "Sync user group with IdP data",
// "This should be enabled to sync groups with the IdP" => "This should be enabled to sync groups with the IdP",
// "Enable Single Logout Service" => "Enable Single Logout Service",
// "The \"logout\" function logs out the user from the Tiki site, the identity provider and all connected service providers" => "The \"logout\" function logs out the user from the Tiki site, the identity provider and all connected service providers",
// "Default group" => "Default group",
// "When provisioning a new user and not group found, assign that group" => "When provisioning a new user and not group found, assign that group",
// "Account matcher" => "Account matcher",
// "Select the field to be used to find the user account. If the \"email\" field is selected, keep in mind that if users change their email address, then the link with the IdP account will be lost" => "Select the field to be used to find the user account. If the \"email\" field is selected, keep in mind that if users change their email address, then the link with the IdP account will be lost",
// "Log-in link text" => "Log-in link text",
// "The text that appears on the log-in page" => "The text that appears on the log-in page",
// "SAML attribute that will be mapped to the Tiki username" => "SAML attribute that will be mapped to the Tiki username",
// "The SAML attribute that will be mapped to the Tiki username" => "The SAML attribute that will be mapped to the Tiki username",
// "SAML attribute that will be mapped to the Tiki email" => "SAML attribute that will be mapped to the Tiki email",
// "The SAML attribute that will be mapped to the Tiki email" => "The SAML attribute that will be mapped to the Tiki email",
// "SAML attribute that will be mapped to the Tiki group" => "SAML attribute that will be mapped to the Tiki group",
// "The SAML attribute that will be mapped to the Tiki email. For example the eduPersonAffiliation" => "The SAML attribute that will be mapped to the Tiki email. For example the eduPersonAffiliation",
// "Admins" => "Admins",
// "Set here the values of the IdP related to the user group info that will be matched with the Admins group" => "Set here the values of the IdP related to the user group info that will be matched with the Admins group",
// "Registered" => "Registered",
// "Set here the values of the IdP related to the user group info that will be matched with the Registered group" => "Set here the values of the IdP related to the user group info that will be matched with the Registered group",
// "Debug Mode" => "Debug Mode",
// "Enable debug mode when your are debugging the SAML workflow. Errors and warnings will be showed." => "Enable debug mode when your are debugging the SAML workflow. Errors and warnings will be showed.",
// "Strict Mode" => "Strict Mode",
// "Always enable strict mode on production websites. When strict mode is enabled, then Tiki will reject unsigned or unencrypted messages if it expects them to be signed or encrypted.\n\t\t\t   Also Tiki will reject messages that do not strictly follow the SAML standard: Destination, NameId, Conditions . . . are also validated" => "Always enable strict mode on production websites. When strict mode is enabled, then Tiki will reject unsigned or unencrypted messages if it expects them to be signed or encrypted.\n\t\t\t   Also Tiki will reject messages that do not strictly follow the SAML standard: Destination, NameId, Conditions . . . are also validated",
// "Service Provider Entity ID" => "Service Provider Entity ID",
// "Set the Entity ID for the service provider. It is recommended to set as the SP Entity ID the URL where the metadata of the service provider is published. If not provided, the toolkit will use \"php-saml\" as the SP entityID" => "Set the Entity ID for the service provider. It is recommended to set as the SP Entity ID the URL where the metadata of the service provider is published. If not provided, the toolkit will use \"php-saml\" as the SP entityID",
// "Requested NameIDFormat" => "Requested NameIDFormat",
// "Specifies constraints on the name identifier to be used to represent the requested subject" => "Specifies constraints on the name identifier to be used to represent the requested subject",
// "urn:oasis:names:tc:SAML:1.1:nameid-format:unspecified" => "urn:oasis:names:tc:SAML:1.1:nameid-format:unspecified",
// "urn:oasis:names:tc:SAML:1.1:nameid-format:emailAddress" => "urn:oasis:names:tc:SAML:1.1:nameid-format:emailAddress",
// "urn:oasis:names:tc:SAML:1.1:nameid-format:X509SubjectName" => "urn:oasis:names:tc:SAML:1.1:nameid-format:X509SubjectName",
// "urn:oasis:names:tc:SAML:2.0:nameid-format:entity" => "urn:oasis:names:tc:SAML:2.0:nameid-format:entity",
// "urn:oasis:names:tc:SAML:2.0:nameid-format:transient" => "urn:oasis:names:tc:SAML:2.0:nameid-format:transient",
// "urn:oasis:names:tc:SAML:2.0:nameid-format:persistent" => "urn:oasis:names:tc:SAML:2.0:nameid-format:persistent",
// "urn:oasis:names:tc:SAML:2.0:nameid-format:encrypted" => "urn:oasis:names:tc:SAML:2.0:nameid-format:encrypted",
// "urn:oasis:names:tc:SAML:2.0:nameid-format:kerberos" => "urn:oasis:names:tc:SAML:2.0:nameid-format:kerberos",
// "Requested AuthnContext" => "Requested AuthnContext",
// "Authentication context: unselect all to accept any type, otherwise select the valid contexts" => "Authentication context: unselect all to accept any type, otherwise select the valid contexts",
// "urn:oasis:names:tc:SAML:2.0:ac:classes:unspecified" => "urn:oasis:names:tc:SAML:2.0:ac:classes:unspecified",
// "urn:oasis:names:tc:SAML:2.0:ac:classes:Password" => "urn:oasis:names:tc:SAML:2.0:ac:classes:Password",
// "urn:oasis:names:tc:SAML:2.0:ac:classes:PasswordProtectedTransport" => "urn:oasis:names:tc:SAML:2.0:ac:classes:PasswordProtectedTransport",
// "urn:oasis:names:tc:SAML:2.0:ac:classes:X509" => "urn:oasis:names:tc:SAML:2.0:ac:classes:X509",
// "urn:oasis:names:tc:SAML:2.0:ac:classes:Smartcard" => "urn:oasis:names:tc:SAML:2.0:ac:classes:Smartcard",
// "urn:oasis:names:tc:SAML:2.0:ac:classes:Kerberos" => "urn:oasis:names:tc:SAML:2.0:ac:classes:Kerberos",
// "urn:federation:authentication:windows" => "urn:federation:authentication:windows",
// "Enable Lowercase URL encoding" => "Enable Lowercase URL encoding",
// "Some IdPs such as ADFS can use lowercase URL encoding, but the plugin expects uppercase URL encoding, so enable it to fix incompatibility issues." => "Some IdPs such as ADFS can use lowercase URL encoding, but the plugin expects uppercase URL encoding, so enable it to fix incompatibility issues.",
// "Encrypt nameID" => "Encrypt nameID",
// "Sign AuthnRequest" => "Sign AuthnRequest",
// "The samlp:AuthnRequest messages sent by this SP will be signed" => "The samlp:AuthnRequest messages sent by this SP will be signed",
// "Sign LogoutRequest" => "Sign LogoutRequest",
// "The samlp:logoutRequest messages sent by this SP will be signed" => "The samlp:logoutRequest messages sent by this SP will be signed",
// "Sign LogoutResponse" => "Sign LogoutResponse",
// "The samlp:logoutResponse messages sent by this SP will be signed" => "The samlp:logoutResponse messages sent by this SP will be signed",
// "Sign Metadata" => "Sign Metadata",
// "The Metadata published by this SP will be signed" => "The Metadata published by this SP will be signed",
// "Reject Unsigned Messages" => "Reject Unsigned Messages",
// "Reject unsigned samlp:Response, samlp:LogoutRequest and samlp:LogoutResponse received" => "Reject unsigned samlp:Response, samlp:LogoutRequest and samlp:LogoutResponse received",
// "Reject Unsigned Assertions" => "Reject Unsigned Assertions",
// "Reject unsigned saml:Assertion received" => "Reject unsigned saml:Assertion received",
// "Reject Unencrypted Assertions" => "Reject Unencrypted Assertions",
// "Reject unencrypted saml:Assertion received" => "Reject unencrypted saml:Assertion received",
// "Retrieve Parameters From Server" => "Retrieve Parameters From Server",
// "Sometimes when the app is behind a firewall or proxy, the query parameters can be modified an this affects the signature validation process on HTTP-Redirect binding. Active this when you noticed signature validation failures, the plugin will try to extract the original query parameters" => "Sometimes when the app is behind a firewall or proxy, the query parameters can be modified an this affects the signature validation process on HTTP-Redirect binding. Active this when you noticed signature validation failures, the plugin will try to extract the original query parameters",
// "Service Provider X.509 certificate" => "Service Provider X.509 certificate",
// "Public x509 certificate of the SP" => "Public x509 certificate of the SP",
// "Service Provider Private Key" => "Service Provider Private Key",
// "Private key of the SP" => "Private key of the SP",
// "Signature Algorithm" => "Signature Algorithm",
// "Algorithm that the toolkit will use on the signing process" => "Algorithm that the toolkit will use on the signing process",
// "http://www.w3.org/2000/09/xmldsig#rsa-sha1" => "http://www.w3.org/2000/09/xmldsig#rsa-sha1",
// "http://www.w3.org/2001/04/xmldsig-more#rsa-sha256" => "http://www.w3.org/2001/04/xmldsig-more#rsa-sha256",
// "http://www.w3.org/2001/04/xmldsig-more#rsa-sha384" => "http://www.w3.org/2001/04/xmldsig-more#rsa-sha384",
// "http://www.w3.org/2001/04/xmldsig-more#rsa-sha512" => "http://www.w3.org/2001/04/xmldsig-more#rsa-sha512",
// "http://www.w3.org/2000/09/xmldsig#dsa-sha1" => "http://www.w3.org/2000/09/xmldsig#dsa-sha1",
// "Scheduler stalled after (minutes)" => "Scheduler stalled after (minutes)",
// "Set a scheduler to stall if the running time is long. Set 0 to disable stall detection" => "Set a scheduler to stall if the running time is long. Set 0 to disable stall detection",
// "Notify on stalled schedulers" => "Notify on stalled schedulers",
// "Send an email notification when a stalled scheduler is detected" => "Send an email notification when a stalled scheduler is detected",
// "Users to notify on stalled task" => "Users to notify on stalled task",
// "List of users/emails separated by comma to be notified when a scheduler task is set to stalled.</br><code>Ex: admin,operations@example.com</code></br><strong>If empty, the email will be sent to all administrators.</strong>" => "List of users/emails separated by comma to be notified when a scheduler task is set to stalled.</br><code>Ex: admin,operations@example.com</code></br><strong>If empty, the email will be sent to all administrators.</strong>",
// "Self healing after (minutes)" => "Self healing after (minutes)",
// "Self healing resets a stalled scheduler automatically after the timeout set. 0 disables self healing" => "Self healing resets a stalled scheduler automatically after the timeout set. 0 disables self healing",
// "Notify on healed schedulers" => "Notify on healed schedulers",
// "Send an email notification when a stalled scheduler is healed" => "Send an email notification when a stalled scheduler is healed",
// "Users to notify on healed task" => "Users to notify on healed task",
// "List of users/emails separated by comma to be notified when a scheduler task is set to healed.</br><code>Ex: admin,operations@example.com</code></br><strong>If empty, the email will be sent to all administrators.</strong>" => "List of users/emails separated by comma to be notified when a scheduler task is set to healed.</br><code>Ex: admin,operations@example.com</code></br><strong>If empty, the email will be sent to all administrators.</strong>",
// "Number of logs to keep" => "Number of logs to keep",
// "0 will keep all logs" => "0 will keep all logs",
// "SCORM support" => "SCORM support",
// "Handle SCORM package files on upload. SCORM is a standard used in learning management systems" => "Handle SCORM package files on upload. SCORM is a standard used in learning management systems",
// "SCORM Tracker" => "SCORM Tracker",
// "The ID number of the tracker used to store SCORM metadata" => "The ID number of the tracker used to store SCORM metadata",
// "Parse search results" => "Parse search results",
// "When enabled search results are parsed so content formatting is visible in the search results" => "When enabled search results are parsed so content formatting is visible in the search results",
// "Default where" => "Default where",
// "When object filter is not on, limit to search one type of object" => "When object filter is not on, limit to search one type of object",
"Entire site" => "整個網站",
"Wiki Pages" => "Wiki 頁面",
// "Wiki pages" => "Wiki pages",
// "Blog posts" => "Blog posts",
// "Tracker items" => "Tracker items",
// "Spreadsheets" => "Spreadsheets",
// "Restrict search language by default" => "Restrict search language by default",
// "Only search content that is in the interface language, otherwise show the language menu" => "Only search content that is in the interface language, otherwise show the language menu",
// "Autocomplete page names" => "Autocomplete page names",
// "Automatically complete page names as the user starts typing. For example the user types the start of the wiki page name “Sear” and Tiki returns “Search”, “Search General Settings”, etc" => "Automatically complete page names as the user starts typing. For example the user types the start of the wiki page name “Sear” and Tiki returns “Search”, “Search General Settings”, etc",
// "deprecated" => "deprecated",
// "Category filter" => "Category filter",
// "Tag filter" => "Tag filter",
// "Use facets for default search interface" => "Use facets for default search interface",
// "Facets are dynamic filters generated by the search engine to refine the search results. The feature may not be supported for all search engines" => "Facets are dynamic filters generated by the search engine to refine the search results. The feature may not be supported for all search engines",
// "Facet result count" => "Facet result count",
// "Default number of facet results to obtain" => "Default number of facet results to obtain",
// "facet results" => "facet results",
// "Search index outdated" => "Search index outdated",
// "Number of days to consider the search index outdated" => "Number of days to consider the search index outdated",
// "Show error on missing field" => "Show error on missing field",
// "When using List plugin to specify certain fields, especially tracker fields, this check helps ensure their names were entered correctly" => "When using List plugin to specify certain fields, especially tracker fields, this check helps ensure their names were entered correctly",
// "File thumbnail preview" => "File thumbnail preview",
// "Have a preview of attachments in search results" => "Have a preview of attachments in search results",
// "Use date histogram aggregations" => "Use date histogram aggregations",
// "Use date histogram aggregations (facets) when indexing, requires Elasticsearch" => "Use date histogram aggregations (facets) when indexing, requires Elasticsearch",
// "Date histogram aggregations interval" => "Date histogram aggregations interval",
// "Default interval for date histogram aggregations" => "Default interval for date histogram aggregations",
// "Use \"year, quarter, month, week, day, hour, minute, second\" or Elasticsearch Time units as descibed here %0" => "Use \"year, quarter, month, week, day, hour, minute, second\" or Elasticsearch Time units as descibed here %0",
// "Date range aggregations ranges" => "Date range aggregations ranges",
// "Default ranges for date range aggregations" => "Default ranges for date range aggregations",
// "Comma separated ranges, one per line using Elasticsearch Time date math as descibed here %0" => "Comma separated ranges, one per line using Elasticsearch Time date math as descibed here %0",
// "Excluded facets" => "Excluded facets",
// "List of facets (a.k.a. aggregations) to exclude from the default search results" => "List of facets (a.k.a. aggregations) to exclude from the default search results",
// "Avoid Duplicated Facets" => "Avoid Duplicated Facets",
// "Avoid Facets appearing with the same name, usually by appending the Tracker name" => "Avoid Facets appearing with the same name, usually by appending the Tracker name",
// "Parse wiki syntax in comments" => "Parse wiki syntax in comments",
// "Parse wiki syntax in comments in all sections apart from Forums" => "Parse wiki syntax in comments in all sections apart from Forums",
// "Use \"Accept wiki syntax\" for forums in admin forums page" => "Use \"Accept wiki syntax\" for forums in admin forums page",
// "Short URL" => "Short URL",
// "Provides the ability to create a short url, easy to share" => "Provides the ability to create a short url, easy to share",
// "Short URL base URL" => "Short URL base URL",
// "The base URL that is used when generating short URLs, including the HTTP prefix, example: \"http://www.example.com\". By default will use the URL of the current website" => "The base URL that is used when generating short URLs, including the HTTP prefix, example: \"http://www.example.com\". By default will use the URL of the current website",
// "Sender email" => "Sender email",
// "Email address that will be used as the sender for outgoing emails" => "Email address that will be used as the sender for outgoing emails",
// "Sender full name" => "Sender full name",
// "Real name that will be used as the sender for outgoing emails" => "Real name that will be used as the sender for outgoing emails",
// "Time zone" => "Time zone",
// "Indicates the default time zone to use for the server" => "Indicates the default time zone to use for the server",
// "Session storage location" => "Session storage location",
// "Select where the session information should be stored. Memcache sessions require memcache to be configured" => "Select where the session information should be stored. Memcache sessions require memcache to be configured",
// "Default (from php.ini)" => "Default (from php.ini)",
"Database" => "資料庫",
// "Session lifetime" => "Session lifetime",
// "Expressed as minutes. This is the minimum time logged in. To be the exact time, adjustments must be made in .htaccess session.gc_probability and session.gc_divisor to 1. Be careful - changing the probability may affect server performance" => "Expressed as minutes. This is the minimum time logged in. To be the exact time, adjustments must be made in .htaccess session.gc_probability and session.gc_divisor to 1. Be careful - changing the probability may affect server performance",
// "Silent session" => "Silent session",
// "Do not automatically start sessions" => "Do not automatically start sessions",
// "Users will only have a session if they log in. Anonymous users will not have features like Switch Language or Switch Theme (which require a session)" => "Users will only have a session if they log in. Anonymous users will not have features like Switch Language or Switch Theme (which require a session)",
// "Can cause problems when combined with cookie consent and JavaScript-disabled browsers" => "Can cause problems when combined with cookie consent and JavaScript-disabled browsers",
// "Session cookie name" => "Session cookie name",
// "Session cookie name used instead of the PHP default configuration" => "Session cookie name used instead of the PHP default configuration",
// "Protect all sessions with HTTPS" => "Protect all sessions with HTTPS",
// "Always redirect to HTTPS to prevent a session hijack through network sniffing" => "Always redirect to HTTPS to prevent a session hijack through network sniffing",
// "Warning: activate only if SSL is already configured; otherwise, all users including admin will be locked out of the site" => "Warning: activate only if SSL is already configured; otherwise, all users including admin will be locked out of the site",
// "Display links on the share page" => "Display links on the share page",
// "Token notification" => "Token notification",
// "Users can subscribe to the notifications of consultation of the token" => "Users can subscribe to the notifications of consultation of the token",
// "Add contact" => "Add contact",
// "If not already in the list, recipients are added to the list of contacts" => "If not already in the list, recipients are added to the list of contacts",
// "Display name and email" => "Display name and email",
// "If the user is connected, the name and email will display in the page" => "If the user is connected, the name and email will display in the page",
// "Number of times accessed" => "Number of times accessed",
// "User can choose how many times the share page can be consulted" => "User can choose how many times the share page can be consulted",
// "Maximum number of times accessed" => "Maximum number of times accessed",
// "Maximum number of times that the shared page can be consulted" => "Maximum number of times that the shared page can be consulted",
// "page hits" => "page hits",
// "The name of the default group" => "The name of the default group",
// "Create with default group" => "Create with default group",
// "Valid affiliations" => "Valid affiliations",
// "A list of affiliations which will allow users to log in to this wiki" => "A list of affiliations which will allow users to log in to this wiki",
// "Separate multiple affiliations with commas" => "Separate multiple affiliations with commas",
// "Shipping service" => "Shipping service",
// "Expose a JSON shipping rate estimation service. Accounts from providers may be required (FedEx, UPS, ...)" => "Expose a JSON shipping rate estimation service. Accounts from providers may be required (FedEx, UPS, ...)",
// "FedEx API" => "FedEx API",
// "Enable shipping rate calculation through FedEx APIs" => "Enable shipping rate calculation through FedEx APIs",
// "FedEx key" => "FedEx key",
// "Developer key" => "Developer key",
// "FedEx password" => "FedEx password",
// "FedEx meter number" => "FedEx meter number",
// "FedEx account number" => "FedEx account number",
// "UPS API" => "UPS API",
// "Enable shipping rate calculation using the UPS carrier" => "Enable shipping rate calculation using the UPS carrier",
// "UPS username" => "UPS username",
// "UPS credentials" => "UPS credentials",
// "UPS password" => "UPS password",
// "UPS access key" => "UPS access key",
// "Custom shipping provider" => "Custom shipping provider",
"Short date format" => "短日期格式",
// "Specify how Tiki displays the date (shorter version)" => "Specify how Tiki displays the date (shorter version)",
"Short time format" => "短時間格式",
// "Specify how Tiki displays the time (shorter version)" => "Specify how Tiki displays the time (shorter version)",
// "Short JavaScript date format" => "Short JavaScript date format",
// "Used in jQuery-UI date picker fields" => "Used in jQuery-UI date picker fields",
// "Short JavaScript time format" => "Short JavaScript time format",
// "Used in jQuery-UI datetime picker fields" => "Used in jQuery-UI datetime picker fields",
// "%Y-%m-%d" => "%Y-%m-%d",
// "%H:%M" => "%H:%M",
// "yy-mm-dd" => "yy-mm-dd",
// "HH:mm" => "HH:mm",
// "%Y-%m-%d %H:%M" => "%Y-%m-%d %H:%M",
// "Display available translations" => "Display available translations",
// "Display list of available languages and offer to switch languages or translate. This appears on wiki pages and articles action buttons" => "Display list of available languages and offer to switch languages or translate. This appears on wiki pages and articles action buttons",
// "Close site" => "Close site",
// "Use this setting to \\\"close\\\" the Tiki site (such as for maintenance). Users attempting to access the site will see only a log-in form. Only users with specific permission will be allowed to log in.\n\t\t\tUse the Message to display to specify the message that visitors will see when attempting to access your site" => "Use this setting to \\\"close\\\" the Tiki site (such as for maintenance). Users attempting to access the site will see only a log-in form. Only users with specific permission will be allowed to log in.\n\t\t\tUse the Message to display to specify the message that visitors will see when attempting to access your site",
// "Coming soon" => "Coming soon",
"Message" => "訊息",
// "Site is closed for maintenance; please come back later" => "Site is closed for maintenance; please come back later",
// "Server is currently too busy; please come back later" => "Server is currently too busy; please come back later",
// "Locations (breadcrumbs)" => "Locations (breadcrumbs)",
// "Examples:  » / >  : -> →" => "Examples:  » / >  : -> →",
// "Choices" => "Choices",
// "Examples: | / ¦  " => "Examples: | / ¦  ",
// "Browser title position" => "Browser title position",
// "Position of the browser title in the full browser bar relative to the current page's descriptor" => "Position of the browser title in the full browser bar relative to the current page's descriptor",
// "After current page's descriptor" => "After current page's descriptor",
// "Before current page's descriptor" => "Before current page's descriptor",
// "No browser title, only current page's descriptor" => "No browser title, only current page's descriptor",
// "Only browser title, no current page's descriptor" => "Only browser title, no current page's descriptor",
// "Browser title display mode" => "Browser title display mode",
// "When breadcrumbs are used, method to display the browser title" => "When breadcrumbs are used, method to display the browser title",
// "Most-specific first" => "Most-specific first",
// "Least-specific first (site)" => "Least-specific first (site)",
// "Current only" => "Current only",
// "Favicons" => "Favicons",
// "Custom favicon image files can be put in the /themes/(themename)/favicons directory, or the default Tiki favicons can be used" => "Custom favicon image files can be put in the /themes/(themename)/favicons directory, or the default Tiki favicons can be used",
// "Site terminal" => "Site terminal",
// "Allows users to be directed to a specific perspective depending on the origin IP address. Can be used inside intranets to use different configurations for users depending on their departements or discriminate people in web contexts. Unspecified IPs will fall back to default behavior, including multi-domain handling. Manually selected perspectives take precedence over this" => "Allows users to be directed to a specific perspective depending on the origin IP address. Can be used inside intranets to use different configurations for users depending on their departements or discriminate people in web contexts. Unspecified IPs will fall back to default behavior, including multi-domain handling. Manually selected perspectives take precedence over this",
// "Site terminal configuration" => "Site terminal configuration",
// "Provides the mapping from subnets to perspective" => "Provides the mapping from subnets to perspective",
// "One per line. Network prefix in CIDR notation (address/mask size), separated by comma with the perspective ID" => "One per line. Network prefix in CIDR notation (address/mask size), separated by comma with the perspective ID",
// "Google Analytics account number" => "Google Analytics account number",
// "The account number for the site. The account number from Google is something like UA-XXXXXXX-YY" => "The account number for the site. The account number from Google is something like UA-XXXXXXX-YY",
// "Google Analytics Groups Option" => "Google Analytics Groups Option",
// "Define option for Google Analytics groups" => "Define option for Google Analytics groups",
// "Included" => "Included",
// "Excluded" => "Excluded",
// "Google Analytics Available Groups" => "Google Analytics Available Groups",
// "User groups for which Google Analytics will be available" => "User groups for which Google Analytics will be available",
// "Google Global Site Tag Mode" => "Google Global Site Tag Mode",
// "Use the newer Google Global Site Tag (gtag.js) as opposed to the previous ga.js" => "Use the newer Google Global Site Tag (gtag.js) as opposed to the previous ga.js",
// "Google authentication credentials file" => "Google authentication credentials file",
// "Path to the Google Service Account credentials JSON file" => "Path to the Google Service Account credentials JSON file",
// "Site layout" => "Site layout",
// "Changes the template for the overall site layout" => "Changes the template for the overall site layout",
// "Admin layout" => "Admin layout",
// "Specify which layout template to use for admin pages" => "Specify which layout template to use for admin pages",
// "Enable layout per page, etc" => "Enable layout per page, etc",
// "Specify an alternate layout for a particular wiki page, etc" => "Specify an alternate layout for a particular wiki page, etc",
// "Piwik server URL" => "Piwik server URL",
// "The URL to the Piwik server of this site" => "The URL to the Piwik server of this site",
// "In Piwik, the selected site (Site Id) must have view permission set for anonymous, or a token authentication parameter can be inserted in the Piwik server URL" => "In Piwik, the selected site (Site Id) must have view permission set for anonymous, or a token authentication parameter can be inserted in the Piwik server URL",
// "Site Id" => "Site Id",
// "The ID of this website in Piwik" => "The ID of this website in Piwik",
// "Piwik JavaScript tracking code" => "Piwik JavaScript tracking code",
// "Piwik Groups Option" => "Piwik Groups Option",
// "Define option for Piwik groups" => "Define option for Piwik groups",
// "Piwik Available Groups" => "Piwik Available Groups",
// "User groups for which piwik will be available" => "User groups for which piwik will be available",
// "Security timeout" => "Security timeout",
// "Sets the expiration of CSRF tickets and related forms. The %0session_lifetime%1 \n\t\t\t\tpreference is used for the default, if set, otherwise the %0session.gc_maxlifetime%1 %0php.ini%1 setting \n\t\t\t\tis used, subject to a default maximum of four hours in any case" => "Sets the expiration of CSRF tickets and related forms. The %0session_lifetime%1 \n\t\t\t\tpreference is used for the default, if set, otherwise the %0session.gc_maxlifetime%1 %0php.ini%1 setting \n\t\t\t\tis used, subject to a default maximum of four hours in any case",
// "Minimum value is 30 seconds to avoid blocking everyone from being able to make any changes, including to this setting" => "Minimum value is 30 seconds to avoid blocking everyone from being able to make any changes, including to this setting",
// "Code to be placed on every page of this website just before the </body> tag" => "Code to be placed on every page of this website just before the </body> tag",
"Publish" => "發表",
// "Make the banner visible to all site visitors" => "Make the banner visible to all site visitors",
// "Activate must be turned on for Publish to take effect" => "Activate must be turned on for Publish to take effect",
// "Logo source (image path)" => "Logo source (image path)",
// "Logo background color" => "Logo background color",
// "A legacy option to add a background color to the div that contains the logo image" => "A legacy option to add a background color to the div that contains the logo image",
// "Examples" => "Examples",
// "Logo title (on mouseover)" => "Logo title (on mouseover)",
// "This appears as tool tip text. The site logo is also a link to the site index (top page)" => "This appears as tool tip text. The site logo is also a link to the site index (top page)",
// "HTML \"alt\" tag description" => "HTML \"alt\" tag description",
// "Normally a description of the image, such as \"Example.com logo\"" => "Normally a description of the image, such as \"Example.com logo\"",
// "Used by text browsers, screen readers, etc" => "Used by text browsers, screen readers, etc",
// "Site icon" => "Site icon",
// "This is used in narrow (top to bottom) page headers. In some layouts, the image is scaled down to fit in the available space" => "This is used in narrow (top to bottom) page headers. In some layouts, the image is scaled down to fit in the available space",
// "Recommended image height: 32 pixel" => "Recommended image height: 32 pixel",
// "Sitemap protocol" => "Sitemap protocol",
// "Allows generating site maps based on the Sitemap protocol, in the form of XML documents. Mostly used to facilitate indexation of a site by web search engines" => "Allows generating site maps based on the Sitemap protocol, in the form of XML documents. Mostly used to facilitate indexation of a site by web search engines",
// "Include Smarty notices in the PHP error report" => "Include Smarty notices in the PHP error report",
// "In most cases, Smarty notices can be safely ignored. However, they may be useful in the development process when unexpected issues occur" => "In most cases, Smarty notices can be safely ignored. However, they may be useful in the development process when unexpected issues occur",
// "Tiki will display <a href=\"https://www.smarty.net\">Smarty</a> notices with the PHP error messages" => "Tiki will display <a href=\"https://www.smarty.net\">Smarty</a> notices with the PHP error messages",
// "Smarty security" => "Smarty security",
// "Do not allow PHP code in Smarty templates" => "Do not allow PHP code in Smarty templates",
// "You should leave this on unless you know what you are doing" => "You should leave this on unless you know what you are doing",
// "Extra Smarty modifiers" => "Extra Smarty modifiers",
// "Make additional PHP functions available as Smarty modifiers. This may be needed for custom templates" => "Make additional PHP functions available as Smarty modifiers. This may be needed for custom templates",
// "There may be security implications. Make sure you know what you are doing" => "There may be security implications. Make sure you know what you are doing",
// "Extra Smarty functions" => "Extra Smarty functions",
// "Make additional PHP functions available as Smarty functions. This may be needed for custom templates" => "Make additional PHP functions available as Smarty functions. This may be needed for custom templates",
// "Extra Smarty directories" => "Extra Smarty directories",
// "Make additional directories available as Smarty directories. This may be needed for custom icons (clear temp/cache after changing)" => "Make additional directories available as Smarty directories. This may be needed for custom icons (clear temp/cache after changing)",
// "Smarty compilation" => "Smarty compilation",
// "Indicates when the template cache should be refreshed" => "Indicates when the template cache should be refreshed",
"Modified" => "已變更",
// "Never check (performance)" => "Never check (performance)",
// "Always (development, slow)" => "Always (development, slow)",
// "Smarty cache permissions" => "Smarty cache permissions",
// "Permissions that enable Smarty to write to the templates_c directory" => "Permissions that enable Smarty to write to the templates_c directory",
// "User writable (0644)" => "User writable (0644)",
// "User & group writable (0664)" => "User & group writable (0664)",
// "Social network type" => "Social network type",
// "Select how the friendship relations within the social network should be treated" => "Select how the friendship relations within the social network should be treated",
// "Follow (as in Twitter)" => "Follow (as in Twitter)",
// "Friend (as in Facebook)" => "Friend (as in Facebook)",
// "Followers need approval" => "Followers need approval",
// "Consumer key" => "Consumer key",
// "Consumer key generated by registering this Tiki site as an application at Twitter" => "Consumer key generated by registering this Tiki site as an application at Twitter",
// "Consumer secret" => "Consumer secret",
// "Consumer secret generated by registering this Tiki site as an application at Twitter" => "Consumer secret generated by registering this Tiki site as an application at Twitter",
// "Twitter site name" => "Twitter site name",
// "The default website name that will be used by Twitter (twitter:site) for every web page. This parameter will be used instead of the browser title" => "The default website name that will be used by Twitter (twitter:site) for every web page. This parameter will be used instead of the browser title",
// "Twitter site image" => "Twitter site image",
// "The default image (logo, picture, etc) that will be used by Twitter (twitter:image) for every web page. The image must be specified as a URL" => "The default image (logo, picture, etc) that will be used by Twitter (twitter:image) for every web page. The image must be specified as a URL",
// "Application secret" => "Application secret",
// "Application secret generated by registering this Tiki site as an application at Facebook" => "Application secret generated by registering this Tiki site as an application at Facebook",
// "Application ID" => "Application ID",
// "Application ID generated by registering this Tiki site as an application at Facebook" => "Application ID generated by registering this Tiki site as an application at Facebook",
// "Facebook site name" => "Facebook site name",
// "The default website name that will be used by Facebook (og:site_name) for every webpage. This parameter will be used instead of the browser title" => "The default website name that will be used by Facebook (og:site_name) for every webpage. This parameter will be used instead of the browser title",
// "Facebook site image" => "Facebook site image",
// "The default image (logo, picture, etc.) that will be used by Facebook (og:image) for every webpage. It must be specified as a URL. The minimum valid image size is 200x200px. However, Facebook recommends 1200x630px or larger for the best display on high resolution devices" => "The default image (logo, picture, etc.) that will be used by Facebook (og:image) for every webpage. It must be specified as a URL. The minimum valid image size is 200x200px. However, Facebook recommends 1200x630px or larger for the best display on high resolution devices",
// "Login using Facebook" => "Login using Facebook",
// "Allow users to log in using Facebook" => "Allow users to log in using Facebook",
// "Auto-create Tiki user" => "Auto-create Tiki user",
// "Automatically create a Tiki user by the username of fb_xxxxxxxx for users logging in using Facebook if they do not yet have a Tiki account. If not, they will be asked to link or register a Tiki account" => "Automatically create a Tiki user by the username of fb_xxxxxxxx for users logging in using Facebook if they do not yet have a Tiki account. If not, they will be asked to link or register a Tiki account",
// "Require Facebook users to enter local account info on creation" => "Require Facebook users to enter local account info on creation",
// "Require Facebook users to enter local account info, specifically email and local log-in name" => "Require Facebook users to enter local account info, specifically email and local log-in name",
// "Tiki can post to the Facebook wall" => "Tiki can post to the Facebook wall",
// "Tiki may post status messages, notes, photos, and videos to the Facebook Wall" => "Tiki may post status messages, notes, photos, and videos to the Facebook Wall",
// "Tiki can manage events" => "Tiki can manage events",
// "Tiki may create and RSVP to Facebook events" => "Tiki may create and RSVP to Facebook events",
// "Tiki can manage pages" => "Tiki can manage pages",
// "Tiki can manage user pages" => "Tiki can manage user pages",
// "Tiki can SMS" => "Tiki can SMS",
// "Tiki can use SMS functions via Facebook" => "Tiki can use SMS functions via Facebook",
// "Set user email from Facebook on creation" => "Set user email from Facebook on creation",
// "Create a user tracker item on registration" => "Create a user tracker item on registration",
// "First and last name tracker field IDs to set on creation" => "First and last name tracker field IDs to set on creation",
// "bit.ly login" => "bit.ly login",
// "Site-wide log-in name (username) for bit.ly" => "Site-wide log-in name (username) for bit.ly",
// "bit.ly key" => "bit.ly key",
// "Site-wide API key for bit.ly" => "Site-wide API key for bit.ly",
// "Use site-wide account" => "Use site-wide account",
// "When set to \"yes\", only the site-wide account will be used for all users" => "When set to \"yes\", only the site-wide account will be used for all users",
// "Client ID" => "Client ID",
// "Client ID generated by registering this site as an application at LinkedIn" => "Client ID generated by registering this site as an application at LinkedIn",
// "Client secret" => "Client secret",
// "Client Secret generated by registering this site as an application at LinkedIn" => "Client Secret generated by registering this site as an application at LinkedIn",
// "Log in using LinkedIn" => "Log in using LinkedIn",
// "Allow users to log in using LinkedIn" => "Allow users to log in using LinkedIn",
// "Auto-create Tiki user from LinkedIn" => "Auto-create Tiki user from LinkedIn",
// "Automatically create a Tiki user by the username of li_xxxxxxxx for users logging in using LinkedIn if they do not yet have a Tiki account. If not, they will be asked to link or register a Tiki account" => "Automatically create a Tiki user by the username of li_xxxxxxxx for users logging in using LinkedIn if they do not yet have a Tiki account. If not, they will be asked to link or register a Tiki account",
// "Set user email from LinkedIn on creation" => "Set user email from LinkedIn on creation",
// "Tiki will set the user's email from Facebook on creation" => "Tiki will set the user's email from Facebook on creation",
// "Sets whether a tracker item should be created for the user upon registration" => "Sets whether a tracker item should be created for the user upon registration",
// "Comma-separated, with first name field followed by last name field; for example, '2,3'" => "Comma-separated, with first name field followed by last name field; for example, '2,3'",
// "Tiki will set the user's email from LinkedIn on creation" => "Tiki will set the user's email from LinkedIn on creation",
// "Stored searches" => "Stored searches",
// "Allow users to store search queries" => "Allow users to store search queries",
// "Expose Jitsi provision URL" => "Expose Jitsi provision URL",
// "Provide connection configuration information for Jitsi users to connect to a community/organization instant messaging server" => "Provide connection configuration information for Jitsi users to connect to a community/organization instant messaging server",
// "Jitsi configuration" => "Jitsi configuration",
// "Content of a Jitsi-format Java properties file" => "Content of a Jitsi-format Java properties file",
// "Location where tracker attachment files are stored" => "Location where tracker attachment files are stored",
// "Filesystem" => "Filesystem",
// "Path of a directory on Tiki's host, such as /var/www/. For confidentiality, this directory should not be web accessible. PHP must be able to read/write to the directory" => "Path of a directory on Tiki's host, such as /var/www/. For confidentiality, this directory should not be web accessible. PHP must be able to read/write to the directory",
// "Site theme" => "Site theme",
// "Icons of the displayed theme" => "Icons of the displayed theme",
// "The default theme for the site. Themes are bootstrap.css variants, including original Tiki themes as well as implementations of themes from Bootswatch.com. For more information about Bootstrap, see getbootstrap.com" => "The default theme for the site. Themes are bootstrap.css variants, including original Tiki themes as well as implementations of themes from Bootswatch.com. For more information about Bootstrap, see getbootstrap.com",
// "Site theme option" => "Site theme option",
// "Supplemental style sheet for the selected theme" => "Supplemental style sheet for the selected theme",
// "theme option, theme-option, style option, options, css" => "theme option, theme-option, style option, options, css",
// "Custom theme URL" => "Custom theme URL",
// "Local or external URL of the custom Bootstrap-compatible CSS file to use" => "Local or external URL of the custom Bootstrap-compatible CSS file to use",
// "Admin theme" => "Admin theme",
// "Theme for the settings panels and other administration pages" => "Theme for the settings panels and other administration pages",
// "Admin theme option" => "Admin theme option",
// "Option theme includes main theme CSS" => "Option theme includes main theme CSS",
// "Don't include the main theme stylesheet because its contents are included in the option stylesheet" => "Don't include the main theme stylesheet because its contents are included in the option stylesheet",
// "Navbar background color" => "Navbar background color",
// "Dark" => "Dark",
// "Light" => "Light",
// "Select a dark or light navbar (containing horizontal menu, etc.), as styled by the theme" => "Select a dark or light navbar (containing horizontal menu, etc.), as styled by the theme",
// "Fixed topbar offset" => "Fixed topbar offset",
// "The offset value of the top padding should be the same height as the navbar in the fixed top position to prevent the navbar from obscuring the page content" => "The offset value of the top padding should be the same height as the navbar in the fixed top position to prevent the navbar from obscuring the page content",
// "topbar offset, top offset, fixed topbar, top padding, offset" => "topbar offset, top offset, fixed topbar, top padding, offset",
// "Icons" => "Icons",
// "Icon set used by the site" => "Icon set used by the site",
// "Theme Customizer tool" => "Theme Customizer tool",
// "Activate the theme customizer tool to enable easy theme customization" => "Activate the theme customizer tool to enable easy theme customization",
// "Check frequency" => "Check frequency",
// "How often Tiki should check for updates. This field applies only if \"Check for updates automatically\" is enabled. " => "How often Tiki should check for updates. This field applies only if \"Check for updates automatically\" is enabled. ",
// "Click \"Check for Updates Now\" to perform an update check" => "Click \"Check for Updates Now\" to perform an update check",
// "Each day" => "Each day",
// "Each week" => "Each week",
// "Each month" => "Each month",
// "Upgrade cycle" => "Upgrade cycle",
// "Tiki upgrade frequency for this site to check against" => "Tiki upgrade frequency for this site to check against",
// "Regular (8 months)" => "Regular (8 months)",
// "Long-Term Support" => "Long-Term Support",
// "Minify JavaScript" => "Minify JavaScript",
// "Compress JavaScript files used in the page into a single file to be distributed statically. Changes to JavaScript files will require cache to be cleared. Uses http://code.google.com/p/minify/" => "Compress JavaScript files used in the page into a single file to be distributed statically. Changes to JavaScript files will require cache to be cleared. Uses http://code.google.com/p/minify/",
// "Minify late JavaScript" => "Minify late JavaScript",
// "Compress extra JavaScript files used in the page after tiki-setup into a separate file which may vary from page to page" => "Compress extra JavaScript files used in the page after tiki-setup into a separate file which may vary from page to page",
// "Minify CSS" => "Minify CSS",
// "Compress CSS files (notably by removing white space). Changes to CSS files will require cache to be cleared" => "Compress CSS files (notably by removing white space). Changes to CSS files will require cache to be cleared",
// "Uses http://code.google.com/p/minify/" => "Uses http://code.google.com/p/minify/",
// "Minify CSS into a single file" => "Minify CSS into a single file",
// "In addition to reducing the size of the CSS files, reduce the number of files by consolidating them" => "In addition to reducing the size of the CSS files, reduce the number of files by consolidating them",
// "This setting may not work out of the box for all styles. Import needs to use @import url(\"...\") and not @import \"...\"" => "This setting may not work out of the box for all styles. Import needs to use @import url(\"...\") and not @import \"...\"",
// "Prefix CSS" => "Prefix CSS",
// "Use -prefix-free JavaScript library to add vendor specific css prefixes" => "Use -prefix-free JavaScript library to add vendor specific css prefixes",
// "May be replaced by a server-side option soon" => "May be replaced by a server-side option soon",
// "Skip date for same day" => "Skip date for same day",
// "When displaying short date and time, skip date for today. Only time will be displayed" => "When displaying short date and time, skip date for today. Only time will be displayed",
// "Cache-control header" => "Cache-control header",
// "Custom HTTP header to use when a session is active" => "Custom HTTP header to use when a session is active",
// "Example: no-cache, pre-check=0, post-check=0" => "Example: no-cache, pre-check=0, post-check=0",
// "Cache-control header (no session)" => "Cache-control header (no session)",
// "Custom HTTP header to use when no session is active" => "Custom HTTP header to use when no session is active",
// "Content delivery networks" => "Content delivery networks",
// "Use alternate domains to serve static files from this Tiki site to avoid sending cookies, improve local caching and generally improve user-experience performance" => "Use alternate domains to serve static files from this Tiki site to avoid sending cookies, improve local caching and generally improve user-experience performance",
// "List of URI prefixes to include before static files (one per line), for example: http://cdn1.example.com" => "List of URI prefixes to include before static files (one per line), for example: http://cdn1.example.com",
// "Content delivery networks in SSL" => "Content delivery networks in SSL",
// "Use alternate domains to serve static files from this Tiki site to avoid sending cookies, improve local caching and generally improve user-experience performance. Leave empty to disable CDN in SSL mode" => "Use alternate domains to serve static files from this Tiki site to avoid sending cookies, improve local caching and generally improve user-experience performance. Leave empty to disable CDN in SSL mode",
// "List of URI prefixes to include before static files (one per line), for example: https://sslcdn1.example.com" => "List of URI prefixes to include before static files (one per line), for example: https://sslcdn1.example.com",
// "Check CDN files exists" => "Check CDN files exists",
// "Check that minified JS and CSS files exist before including them in the page" => "Check that minified JS and CSS files exist before including them in the page",
// "Domain prefix handling" => "Domain prefix handling",
// "Strip or automatically add the \"www.\" prefix on domain names to standardize URLs" => "Strip or automatically add the \"www.\" prefix on domain names to standardize URLs",
// "Leave as-is" => "Leave as-is",
// "Remove the www" => "Remove the www",
// "Add the www" => "Add the www",
// "Domain redirects" => "Domain redirects",
// "When the site is accessed through specific domain names, redirect to an alternate domain preserving the URL. Useful for domain name transitions, like tikiwiki.org to tiki.org" => "When the site is accessed through specific domain names, redirect to an alternate domain preserving the URL. Useful for domain name transitions, like tikiwiki.org to tiki.org",
// "One entry per line, with each entry a comma-separated list: old domain, new domain" => "One entry per line, with each entry a comma-separated list: old domain, new domain",
// "Validate uploaded file content" => "Validate uploaded file content",
// "Do not trust user input and open the files to verify their content" => "Do not trust user input and open the files to verify their content",
// "Allow the tiki_p_trust_input permission" => "Allow the tiki_p_trust_input permission",
// "Bypass user input filtering" => "Bypass user input filtering",
// "Note: all permissions are granted to the Admins group including this one, so if you enable this you may expose your site to XSS (Cross Site Scripting) attacks for admin users" => "Note: all permissions are granted to the Admins group including this one, so if you enable this you may expose your site to XSS (Cross Site Scripting) attacks for admin users",
// "Object selector threshold" => "Object selector threshold",
// "Number of records after which the object selectors will request searching instead of selecting from a list" => "Number of records after which the object selectors will request searching instead of selecting from a list",
// "Object selector search field" => "Object selector search field",
// "Field or (comma separated) fields to search when filtering in an object selector. e.g. \"%0\" (default \"%1\")" => "Field or (comma separated) fields to search when filtering in an object selector. e.g. \"%0\" (default \"%1\")",
// "Client key for this site" => "Client key for this site",
// "This must match the shared key entered in the Master’s key field" => "This must match the shared key entered in the Master’s key field",
// "Synchronize remote tracker" => "Synchronize remote tracker",
// "Enable a tracker to be cloned on a remote host, and synchronize the data locally on demand" => "Enable a tracker to be cloned on a remote host, and synchronize the data locally on demand",
// "Refresh item link items when the master is modified" => "Refresh item link items when the master is modified",
// "To be used when item link is used in trackers so that the index remains in good shape when data on the master that is indexed with the detail is modified and used to search on" => "To be used when item link is used in trackers so that the index remains in good shape when data on the master that is indexed with the detail is modified and used to search on",
// "Refresh items list items when related items are created or modified" => "Refresh items list items when related items are created or modified",
// "Use this to enable the ItemsList fields to refresh their content in the search index when related tracker items are created or modified" => "Use this to enable the ItemsList fields to refresh their content in the search index when related tracker items are created or modified",
// "Clone tracker items" => "Clone tracker items",
// "Allow copying tracker item information to a new tracker item" => "Allow copying tracker item information to a new tracker item",
// "Trackers available for insertion from wiki pages" => "Trackers available for insertion from wiki pages",
// "List of tracker IDs made available when attempting to insert" => "List of tracker IDs made available when attempting to insert",
// "Change field types" => "Change field types",
// "Allow field type to be changed after creation" => "Allow field type to be changed after creation",
// "Use with care" => "Use with care",
// "Show comments below items" => "Show comments below items",
// "Show comments for a tracker item below the item itself as in other trackers, instead of enclosed in a tab" => "Show comments for a tracker item below the item itself as in other trackers, instead of enclosed in a tab",
// "Use legacy tracker insertion screen" => "Use legacy tracker insertion screen",
// "Use the legacy tracker insertion screen (a tab) instead of a popup dialog" => "Use the legacy tracker insertion screen (a tab) instead of a popup dialog",
// "Useful for older trackers using deprecated fields such as Image and File or when more insertion space is useful" => "Useful for older trackers using deprecated fields such as Image and File or when more insertion space is useful",
// "Show tracker status in objectlink" => "Show tracker status in objectlink",
// "Show the status when doing an objectlink. This can be used to show the status in tracker screens but not in outputs" => "Show the status when doing an objectlink. This can be used to show the status in tracker screens but not in outputs",
// "Sync wiki page name to linked tracker field" => "Sync wiki page name to linked tracker field",
// "When the wiki page is renamed or when the value of the tracker field that is linked to the wiki page is changed, make the corresponding change as well to the other linked via tiki.wiki.linkedfield relation" => "When the wiki page is renamed or when the value of the tracker field that is linked to the wiki page is changed, make the corresponding change as well to the other linked via tiki.wiki.linkedfield relation",
// "Redirect page views to the linked tracker item" => "Redirect page views to the linked tracker item",
// "Redirect the user to the tracker item when trying to view a wiki page that has a linked tracker item via tiki.wiki.linkeditem relation. Can be bypassed by adding &admin (?admin in sefurl) to the URL" => "Redirect the user to the tracker item when trying to view a wiki page that has a linked tracker item via tiki.wiki.linkeditem relation. Can be bypassed by adding &admin (?admin in sefurl) to the URL",
// "To get to the wiki page after activation, you can add &admin (?admin in sefurl) to the URL" => "To get to the wiki page after activation, you can add &admin (?admin in sefurl) to the URL",
// "Tracker for articles" => "Tracker for articles",
// "Have a tracker to supplement article information" => "Have a tracker to supplement article information",
// "Tracker ID of tracker for articles" => "Tracker ID of tracker for articles",
// "A tracker for articles must contain an \"Articles\" field" => "A tracker for articles must contain an \"Articles\" field",
// "Sets whether the article info should be indexed in the tracker item. This automatically sets the article field to read-only and sets up categorization synchronization between articles and tracker items" => "Sets whether the article info should be indexed in the tracker item. This automatically sets the article field to read-only and sets up categorization synchronization between articles and tracker items",
// "Tracker tabular" => "Tracker tabular",
// "Allows management of import/export tracker profiles and management of custom list formats" => "Allows management of import/export tracker profiles and management of custom list formats",
// "Always notify watchers" => "Always notify watchers",
// "Send item updated notifications to watchers even if nothing has changed" => "Send item updated notifications to watchers even if nothing has changed",
// "Require users to fill in tracker information" => "Require users to fill in tracker information",
// "Tracker ID of tracker required to be filled in" => "Tracker ID of tracker required to be filled in",
// "Mandatory tracker field to check for required filling in" => "Mandatory tracker field to check for required filling in",
// "The permname of field that is checked to see if user has completed the form. If field is empty, user has not completed it" => "The permname of field that is checked to see if user has completed the form. If field is empty, user has not completed it",
// "Fields that are asked for in the modal for force-filling" => "Fields that are asked for in the modal for force-filling",
// "Comma-separated permanent names of fields that are requested in the modal for required filling in. If empty, all fields are requested" => "Comma-separated permanent names of fields that are requested in the modal for required filling in. If empty, all fields are requested",
// "Tracker item links use prefix alias" => "Tracker item links use prefix alias",
// "Links for tracker items will use the prefix alias automatically everywhere" => "Links for tracker items will use the prefix alias automatically everywhere",
// "Tracker report resize button" => "Tracker report resize button",
// "Add a button to resize long tracker reports" => "Add a button to resize long tracker reports",
// "Tracker list order" => "Tracker list order",
// "Default order for the main tracker list" => "Default order for the main tracker list",
// "Id Ascending" => "Id Ascending",
// "Id Descending" => "Id Descending",
// "Created Ascending" => "Created Ascending",
// "Created Descending" => "Created Descending",
// "Name Ascending" => "Name Ascending",
// "Name Descending" => "Name Descending",
// "Last Modified Ascending" => "Last Modified Ascending",
// "Last Modified Descending" => "Last Modified Descending",
// "Number of Items Ascending" => "Number of Items Ascending",
// "Number of Items Descending" => "Number of Items Descending",
// "Tracker History Diff Style" => "Tracker History Diff Style",
// "Default style for tracker history" => "Default style for tracker history",
"Original" => "原始",
// "Index article info in tracker item" => "Index article info in tracker item",
// "Require users to fill in a tracker form if not done already by prompting them with a modal dialog" => "Require users to fill in a tracker form if not done already by prompting them with a modal dialog",
// "Storage settings when file galleries are not used" => "Storage settings when file galleries are not used",
// "Unified search engine" => "Unified search engine",
// "Search engine used to index the content of this Tiki site. Some engines are more suitable for larger sites, but require additional software on the server" => "Search engine used to index the content of this Tiki site. Some engines are more suitable for larger sites, but require additional software on the server",
// "Lucene (PHP implementation) - Deprecated" => "Lucene (PHP implementation) - Deprecated",
// "Elasticsearch" => "Elasticsearch",
// "Lucene index location" => "Lucene index location",
// "Path to the location of the Lucene search index. The index must be on a local filesystem with enough space to contain the volume of the database" => "Path to the location of the Lucene search index. The index must be on a local filesystem with enough space to contain the volume of the database",
// "Highlight results snippets" => "Highlight results snippets",
// "Highlight the result snippet based on the search query to improve user experience" => "Highlight the result snippet based on the search query to improve user experience",
// "Lucene maximum results" => "Lucene maximum results",
// "Maximum number of results to produce. Results beyond these will need a more refined query to be reached" => "Maximum number of results to produce. Results beyond these will need a more refined query to be reached",
// "results" => "results",
// "Lucene maximum result-set limit" => "Lucene maximum result-set limit",
// "Maximum size of result set to consider" => "Maximum size of result set to consider",
// "This is used when calculating result scores and sort order which can lead to \"out of memory\" errors on large data sets. The default of 1000 is safe with the PHP memory_limit set to 128M" => "This is used when calculating result scores and sort order which can lead to \"out of memory\" errors on large data sets. The default of 1000 is safe with the PHP memory_limit set to 128M",
// "result sets" => "result sets",
// "Lucene terms per query limit" => "Lucene terms per query limit",
// "Maximum number of terms to be generated. This value may need to be increased in the case of \"Terms per query limit is reached\" espescially with wildcard, range and fuzzy searches" => "Maximum number of terms to be generated. This value may need to be increased in the case of \"Terms per query limit is reached\" espescially with wildcard, range and fuzzy searches",
// "terms" => "terms",
// "Lucene maximum number of buffered documents" => "Lucene maximum number of buffered documents",
// "Number of documents required before the buffered in-memory documents are written into a new segment" => "Number of documents required before the buffered in-memory documents are written into a new segment",
// "documents" => "documents",
// "Lucene maximum number of merge documents" => "Lucene maximum number of merge documents",
// "Largest number of documents merged by addDocument(). Small values (for example, less than 10,000) are best for interactive indexing, as this limits the length of pauses while indexing to a few seconds. Larger values are best for batched indexing and speedier searches" => "Largest number of documents merged by addDocument(). Small values (for example, less than 10,000) are best for interactive indexing, as this limits the length of pauses while indexing to a few seconds. Larger values are best for batched indexing and speedier searches",
// "Small values (for example, less than 10,000) are best for interactive indexing. Use 0 for the Lucene default, which is practically infinite" => "Small values (for example, less than 10,000) are best for interactive indexing. Use 0 for the Lucene default, which is practically infinite",
// "merge documents" => "merge documents",
// "Default Boolean Operator" => "Default Boolean Operator",
// "Use OR or AND as the default search operator" => "Use OR or AND as the default search operator",
// "AND" => "AND",
// "OR" => "OR",
// "Lucene merge factor" => "Lucene merge factor",
// "How often segment indices are merged by addDocument(). With smaller values, less RAM is used while indexing, and searches on unoptimized indices are faster, but indexing speed is slower. With larger values, more RAM is used during indexing, and while searches on unoptimized indices are slower, indexing is faster" => "How often segment indices are merged by addDocument(). With smaller values, less RAM is used while indexing, and searches on unoptimized indices are faster, but indexing speed is slower. With larger values, more RAM is used during indexing, and while searches on unoptimized indices are slower, indexing is faster",
// "Large values (greater than 10) are best for batch index creation, and smaller values (less than 10) for indices that are interactively maintained" => "Large values (greater than 10) are best for batch index creation, and smaller values (less than 10) for indices that are interactively maintained",
// "Incremental Index Update" => "Incremental Index Update",
// "Update the index incrementally as the site content is modified" => "Update the index incrementally as the site content is modified",
// "This may lead to lower performance and accuracy than processing the index on a periodic basis" => "This may lead to lower performance and accuracy than processing the index on a periodic basis",
// "Field weights" => "Field weights",
// "Allow the field weights to be set that apply when ranking pages in the search results. The weight is applied only when the field is in the query. To nullify the value of a field, use an insignificant amount, but not 0, which may lead to unexpected behaviors such as stripping of results" => "Allow the field weights to be set that apply when ranking pages in the search results. The weight is applied only when the field is in the query. To nullify the value of a field, use an insignificant amount, but not 0, which may lead to unexpected behaviors such as stripping of results",
// "Add these fields to the \"Default content fields\" preference below for it to have an effect in a global \"content\" search" => "Add these fields to the \"Default content fields\" preference below for it to have an effect in a global \"content\" search",
// "One field per line, field_name__:__5.3" => "One field per line, field_name__:__5.3",
// "Default content fields" => "Default content fields",
// "All of the content is aggregated in the contents field. For custom weighting to apply, the fields must be included in the query. This option allows other fields to be included in the default content search" => "All of the content is aggregated in the contents field. For custom weighting to apply, the fields must be included in the query. This option allows other fields to be included in the default content search",
// "Tokenize version numbers" => "Tokenize version numbers",
// "Tokenize version number strings so that major versions are found when sub-versions are mentioned. For example, searching for 2.7 would return documents containing 2.7.4, but not 1.2.7" => "Tokenize version number strings so that major versions are found when sub-versions are mentioned. For example, searching for 2.7 would return documents containing 2.7.4, but not 1.2.7",
// "Cache per user and query for Tiki built-in search" => "Cache per user and query for Tiki built-in search",
// "Time in minutes a user has a same query cached applied to Tiki built-in search interface only" => "Time in minutes a user has a same query cached applied to Tiki built-in search interface only",
// "Index forum replies together with initial post" => "Index forum replies together with initial post",
// "Forum replies will be indexed together with the initial post as a single document instead of being indexed separately" => "Forum replies will be indexed together with the initial post as a single document instead of being indexed separately",
// "Relation types to index within object" => "Relation types to index within object",
// "Comma-separated relation types for which objects should be indexed in their related objects" => "Comma-separated relation types for which objects should be indexed in their related objects",
// "Elasticsearch needed" => "Elasticsearch needed",
// "Cache individual search formatters" => "Cache individual search formatters",
// "List of search formatters whose output will be cached. This is separate to the result-specific formatted results cache" => "List of search formatters whose output will be cached. This is separate to the result-specific formatted results cache",
// "Format to use for tracker field keys" => "Format to use for tracker field keys",
// "Choose between field IDs and permanent names for the tracker indexing" => "Choose between field IDs and permanent names for the tracker indexing",
// "Permanent name" => "Permanent name",
// "Field ID (backward compatibility mode with Tiki 7 and 8)" => "Field ID (backward compatibility mode with Tiki 7 and 8)",
// "Index Tracker Category names" => "Index Tracker Category names",
// "Index the names and paths of category field values" => "Index the names and paths of category field values",
// "Requires reindexing" => "Requires reindexing",
// "Cache result-specific formatted results" => "Cache result-specific formatted results",
// "Formatted search results such as the ones used in the List plugin will be cached to prevent process-intensive reformatting on each page load. The cache is result-specific" => "Formatted search results such as the ones used in the List plugin will be cached to prevent process-intensive reformatting on each page load. The cache is result-specific",
// "Every different result will generate a separate cache. This could quickly build up a large cache directory. It is recommended to clear Tiki caches often (e.g. once per week) via an automated job if you use this feature" => "Every different result will generate a separate cache. This could quickly build up a large cache directory. It is recommended to clear Tiki caches often (e.g. once per week) via an automated job if you use this feature",
// "Excluded categories" => "Excluded categories",
// "List of category IDs to exclude from the search index" => "List of category IDs to exclude from the search index",
// "Excluded plugins" => "Excluded plugins",
// "List of plugin names to exclude while indexing" => "List of plugin names to exclude while indexing",
// "Exclude all plugins" => "Exclude all plugins",
// "Indexing will exclude all plugins" => "Indexing will exclude all plugins",
// "Except included plugins" => "Except included plugins",
// "List of plugin names that are required to be included while indexing, when excluding all" => "List of plugin names that are required to be included while indexing, when excluding all",
// "Example: fancytable,list,trackerlist,trackerfilter" => "Example: fancytable,list,trackerlist,trackerfilter",
// "Elasticsearch URL" => "Elasticsearch URL",
// "URL of any node in the cluster" => "URL of any node in the cluster",
// "Elasticsearch index prefix" => "Elasticsearch index prefix",
// "The prefix that is used for all indexes for this installation in Elasticsearch" => "The prefix that is used for all indexes for this installation in Elasticsearch",
// "Elasticsearch current index" => "Elasticsearch current index",
// "A new index is created upon rebuilding, and the old one is then destroyed. This setting enables seeing the currently active index" => "A new index is created upon rebuilding, and the old one is then destroyed. This setting enables seeing the currently active index",
// "Do not change this value unless you know what you are doing" => "Do not change this value unless you know what you are doing",
// "Tokenize CamelCase words" => "Tokenize CamelCase words",
// "Consider the components of camel-case words as separate tokens, allowing them to be searched individually" => "Consider the components of camel-case words as separate tokens, allowing them to be searched individually",
// "Conflicts with Tokenize Version Numbers" => "Conflicts with Tokenize Version Numbers",
// "Elasticsearch field limit per index" => "Elasticsearch field limit per index",
// "fields" => "fields",
// "The maximum number of fields per search index in Elasticsearch version 5.x and above" => "The maximum number of fields per search index in Elasticsearch version 5.x and above",
// "Use MySQL Full-Text Search (fallback)" => "Use MySQL Full-Text Search (fallback)",
// "In case of Elasticsearch is active and unavailable, use MySQL Full-Text Search as fallback" => "In case of Elasticsearch is active and unavailable, use MySQL Full-Text Search as fallback",
// "MySQL full-text search current index" => "MySQL full-text search current index",
// "Unified index identifier fields (Internal)" => "Unified index identifier fields (Internal)",
// "Used to store the fields to be considered as identifiers. This is overwritten after each index rebuilding" => "Used to store the fields to be considered as identifiers. This is overwritten after each index rebuilding",
// "Use unified search in category admin" => "Use unified search in category admin",
// "Use unified search to find objects to add to categories. This limits the types of objects available to those included in the unified index" => "Use unified search to find objects to add to categories. This limits the types of objects available to those included in the unified index",
// "Stop Word List" => "Stop Word List",
// "Words excluded from the search index, because they can be too frequent and produce unwanted results" => "Words excluded from the search index, because they can be too frequent and produce unwanted results",
// "MySQL full-text search has its own list of stop words configured in the server" => "MySQL full-text search has its own list of stop words configured in the server",
// "Automatically trim Elasticsearch results on date-sorted query" => "Automatically trim Elasticsearch results on date-sorted query",
// "Automatically trim Elasticsearch results in unified search if the query is sorted by modification or creation date" => "Automatically trim Elasticsearch results in unified search if the query is sorted by modification or creation date",
// "Highlight results pages" => "Highlight results pages",
// "Highlight words on the result pages based on the search query" => "Highlight words on the result pages based on the search query",
// "Plugins tab of the textarea control panel loads with an empty list" => "Plugins tab of the textarea control panel loads with an empty list",
// "Improve the performance of the textarea control panel by avoiding the loading of all plugins initially" => "Improve the performance of the textarea control panel by avoiding the loading of all plugins initially",
// "Some plugins may not appear. When using the MySQL engine, can have problems with short plugin names (for MyISAM, those under \"ft_min_word_len\")" => "Some plugins may not appear. When using the MySQL engine, can have problems with short plugin names (for MyISAM, those under \"ft_min_word_len\")",
// "Possessive Stemmer" => "Possessive Stemmer",
// "LIST plugin cache default on" => "LIST plugin cache default on",
// "If selected, LIST plugins will be cached by default unless turned off at plugin level" => "If selected, LIST plugins will be cached by default unless turned off at plugin level",
// "LIST plugin cache default expiry" => "LIST plugin cache default expiry",
// "Default number of minutes for LIST plugin cache expiry" => "Default number of minutes for LIST plugin cache expiry",
// "The possessive stemmer removes possessives (trailing \"'s\\" => "The possessive stemmer removes possessives (trailing \"'s\\",
// "Re-validate user by email after" => "Re-validate user by email after",
// "unsuccessful login attempts" => "unsuccessful login attempts",
// "After a certain number of consecutive unsuccessful log-in attempts, the user will receive an email with instruction to validate his or her account. However, the user can still log in with the old password" => "After a certain number of consecutive unsuccessful log-in attempts, the user will receive an email with instruction to validate his or her account. However, the user can still log in with the old password",
// "brute force, brute-force, login failure, login-failure, failed logins" => "brute force, brute-force, login failure, login-failure, failed logins",
// "Suspend account after" => "Suspend account after",
// "After a certain number of consecutive unsuccessful login attempts, the account is suspended. An admin must revalidate the account before the user can use it again" => "After a certain number of consecutive unsuccessful login attempts, the account is suspended. An admin must revalidate the account before the user can use it again",
// "URL the user is redirected to after account validation" => "URL the user is redirected to after account validation",
// "The default page a Registered user sees after account validation is \"tiki-information.php?msg=Account validated successfully\"" => "The default page a Registered user sees after account validation is \"tiki-information.php?msg=Account validated successfully\"",
// "Account validated successfully" => "Account validated successfully",
// "The URL that the anonymous user is redirected to when a page is not found" => "The URL that the anonymous user is redirected to when a page is not found",
// "Use Only ASCII in SEFURLs" => "Use Only ASCII in SEFURLs",
// "Do not use accented characters in short (search engine friendly) URLs" => "Do not use accented characters in short (search engine friendly) URLs",
// "Close site when server load is above the threshold" => "Close site when server load is above the threshold",
// "Use this option to \"close\" the Tiki site when the server load exceeds a specific threshold. Only users with specific permission will be allowed to log in. Use \"Maximum average server load threshold in the last minute\" to define the maximum server load. Use the \"Message to display\" to specify the message that visitors will see when attempting to access the site" => "Use this option to \"close\" the Tiki site when the server load exceeds a specific threshold. Only users with specific permission will be allowed to log in. Use \"Maximum average server load threshold in the last minute\" to define the maximum server load. Use the \"Message to display\" to specify the message that visitors will see when attempting to access the site",
// "Use proxy" => "Use proxy",
// "Specify if this Tiki site requires a proxy to access the internet. If enabled, the proxy Host name (either with or without the http:// prefix), Port settings, Username, and Password can be specified" => "Specify if this Tiki site requires a proxy to access the internet. If enabled, the proxy Host name (either with or without the http:// prefix), Port settings, Username, and Password can be specified",
// "Use context menus for actions (icons)" => "Use context menus for actions (icons)",
// "Currently used in File Galleries only" => "Currently used in File Galleries only",
// "Use context menus for actions (text)" => "Use context menus for actions (text)",
// "Show user's real name" => "Show user's real name",
// "Show the user's real name instead of username (log-in name), when possible" => "Show the user's real name instead of username (log-in name), when possible",
// "User emails must be unique" => "User emails must be unique",
// "The email address of each user must be unique" => "The email address of each user must be unique",
// "Display user tracker information on the user information page" => "Display user tracker information on the user information page",
// "Input the user tracker ID then field IDs to be shown, all separated by commas. Example: 1,1,2,3,4 (user tracker ID 1 followed by field IDs 1-4)" => "Input the user tracker ID then field IDs to be shown, all separated by commas. Example: 1,1,2,3,4 (user tracker ID 1 followed by field IDs 1-4)",
"Users can configure modules" => "允許使用者設定模組",
// "Modules aren't reflected in the screen until they are configured on MyAccount->Modules, including for the admin user" => "Modules aren't reflected in the screen until they are configured on MyAccount->Modules, including for the admin user",
// "Users can open and close the modules" => "Users can open and close the modules",
// "Allows users to open and close modules using the icon in the module header" => "Allows users to open and close modules using the icon in the module header",
// "Module decides" => "Module decides",
// "Store full-size copy of profile picture in file gallery" => "Store full-size copy of profile picture in file gallery",
// "Size of the small profile picture stored for users" => "Size of the small profile picture stored for users",
// "Crop the profile picture thumbnail to a square" => "Crop the profile picture thumbnail to a square",
// "File gallery in which to store full-size profile picture" => "File gallery in which to store full-size profile picture",
// "Enter the gallery ID here. Create a dedicated gallery that is admin-only for security, or make sure gallery permissions are set so that only admins can edit" => "Enter the gallery ID here. Create a dedicated gallery that is admin-only for security, or make sure gallery permissions are set so that only admins can edit",
// "File ID of default profile picture" => "File ID of default profile picture",
// "File ID of image to use in file gallery as the profile picture if user has no profile picture in file galleries" => "File ID of image to use in file gallery as the profile picture if user has no profile picture in file galleries",
// "Display who has viewed \"my items\" on the user information page" => "Display who has viewed \"my items\" on the user information page",
// "This requires activation of tracking of views for various items in the action log" => "This requires activation of tracking of views for various items in the action log",
// "Length of \"who viewed my items\" history" => "Length of \"who viewed my items\" history",
// "Number of days before the current day to consider when displaying \"who viewed my items\"" => "Number of days before the current day to consider when displaying \"who viewed my items\"",
// "Show to others \"who viewed my items\" on the user information page" => "Show to others \"who viewed my items\" on the user information page",
// "Show to others \"who viewed my items\" on the user information page. Admins can always see this information" => "Show to others \"who viewed my items\" on the user information page. Admins can always see this information",
// "Use pretty trackers for registration form" => "Use pretty trackers for registration form",
// "Registration pretty tracker template" => "Registration pretty tracker template",
// "Use a wiki page name or Smarty template file with a .tpl extension" => "Use a wiki page name or Smarty template file with a .tpl extension",
// "Hide Mandatory" => "Hide Mandatory",
// "Hide mandatory fields indication with an asterisk (shown by default)" => "Hide mandatory fields indication with an asterisk (shown by default)",
// "Output the registration results" => "Output the registration results",
// "Use a wiki page as template to output the registration results to" => "Use a wiki page as template to output the registration results to",
// "Output registration pretty tracker template" => "Output registration pretty tracker template",
// "Wiki page only" => "Wiki page only",
// "Page name field ID" => "Page name field ID",
// "User tracker IDs to sync prefs from" => "User tracker IDs to sync prefs from",
// "Select one or more trackers to sync user preferences from" => "Select one or more trackers to sync user preferences from",
// "Tracker field IDs to sync the \"real name\" pref from" => "Tracker field IDs to sync the \"real name\" pref from",
// "Enter the comma-separated IDs in order of priority to be chosen; each item can concatenate multiple fields using \"+\", for example \"2+3,4\"" => "Enter the comma-separated IDs in order of priority to be chosen; each item can concatenate multiple fields using \"+\", for example \"2+3,4\"",
// "Tracker field IDs to sync user groups" => "Tracker field IDs to sync user groups",
// "Enter the comma-separated IDs of all fields that contain group names to which to sync user groups" => "Enter the comma-separated IDs of all fields that contain group names to which to sync user groups",
// "Synchronize long/lat/zoom to location field" => "Synchronize long/lat/zoom to location field",
// "Synchronize user geolocation preferences with the main location field" => "Synchronize user geolocation preferences with the main location field",
// "Change user system language when changing user tracker item language" => "Change user system language when changing user tracker item language",
// "Assign a user tracker item when registering if email equals this field" => "Assign a user tracker item when registering if email equals this field",
// "Maximum users in drop-down lists" => "Maximum users in drop-down lists",
// "Use jQuery autocomplete text input to prevent out-of-memory errors and performance issues when the user list is very large" => "Use jQuery autocomplete text input to prevent out-of-memory errors and performance issues when the user list is very large",
"users" => "使用者",
// "Use the user's real name instead of log-in name in the autocomplete selector in trackers" => "Use the user's real name instead of log-in name in the autocomplete selector in trackers",
// "Use the user's real name instead of log-in name in the autocomplete selector in the messaging feature" => "Use the user's real name instead of log-in name in the autocomplete selector in the messaging feature",
// "User favorites" => "User favorites",
// "Enable users to flag content as their favorite" => "Enable users to flag content as their favorite",
// "User likes" => "User likes",
// "Enable users to \"like\" content" => "Enable users to \"like\" content",
// "Users must choose a group at registration" => "Users must choose a group at registration",
// "Users cannot register without choosing one of the groups indicated above" => "Users cannot register without choosing one of the groups indicated above",
// "Users available in search results" => "Users available in search results",
// "Users available within search results. Content related to the user will be included in the index" => "Users available within search results. Content related to the user will be included in the index",
"Public" => "公開",
// "Use Gravatar for user profile pictures" => "Use Gravatar for user profile pictures",
// "Always request the Gravatar image for the user profile picture" => "Always request the Gravatar image for the user profile picture",
// "Configuration for multilike" => "Configuration for multilike",
// "Separate configurations by a blank line; for example, relation_prefix=tiki.multilike ids=1,2,3 values=1,3,5 labels=Good,Great,Excellent)" => "Separate configurations by a blank line; for example, relation_prefix=tiki.multilike ids=1,2,3 values=1,3,5 labels=Good,Great,Excellent)",
// "Force users to upload an avatar" => "Force users to upload an avatar",
// "Score ascending" => "Score ascending",
// "Score descending" => "Score descending",
// "Name ascending" => "Name ascending",
// "Name descending" => "Name descending",
// "Login ascending" => "Login ascending",
// "Login descending" => "Login descending",
// "User the tracker's field ID whose value is used as the output page name" => "User the tracker's field ID whose value is used as the output page name",
// "Require the user to upload a profile picture if they haven't done so already by prompting them with a modal popup" => "Require the user to upload a profile picture if they haven't done so already by prompting them with a modal popup",
// "Quota" => "Quota",
"Private" => "私人",
// "Users cannot see each other's files or galleries" => "Users cannot see each other's files or galleries",
// "Users can see each other's files, but don't see the galleries in listings" => "Users can see each other's files, but don't see the galleries in listings",
// "Username pattern" => "Username pattern",
// "This regex pattern requires or forbids the use of certain characters for username. For example, to add Hebrew, use: /&#94;&#91; '\\-_a-zA-Z0-9@\\.א-ת]*\$/ or, for Chinese, use: /&#94;&#91; '\\-_a-zA-Z0-9@\\.\\x00-\\xff]*\$/" => "This regex pattern requires or forbids the use of certain characters for username. For example, to add Hebrew, use: /&#94;&#91; '\\-_a-zA-Z0-9@\\.א-ת]*\$/ or, for Chinese, use: /&#94;&#91; '\\-_a-zA-Z0-9@\\.\\x00-\\xff]*\$/",
// "Serve profile pictures statically" => "Serve profile pictures statically",
// "When enabled, feature checks and permission checks will be skipped" => "When enabled, feature checks and permission checks will be skipped",
"Displayed time zone" => "顯示時區",
// "Use time zone set from user preferences, or the automatically detected time zone for anonymous (if browser allows). Site default is used as fallback" => "Use time zone set from user preferences, or the automatically detected time zone for anonymous (if browser allows). Site default is used as fallback",
// "Always the site default time zone" => "Always the site default time zone",
"Number of visited pages to remember" => "拜訪過頁面保留筆數",
// "visited pages" => "visited pages",
"User information" => "使用者資訊",
// "Specify if the user's information is public or private" => "Specify if the user's information is public or private",
// "Use 12-hour clock for time selectors" => "Use 12-hour clock for time selectors",
// "Use the 12-hour clock (with AM and PM) in some edit screens to set the time for publishing new or edited blog posts, articles, etc" => "Use the 12-hour clock (with AM and PM) in some edit screens to set the time for publishing new or edited blog posts, articles, etc",
// "Use interface that shows differences in any versions" => "Use interface that shows differences in any versions",
"Tasks per page" => "每頁工作數",
// "tasks" => "tasks",
// "20" => "20",
// "40" => "40",
// "50" => "50",
"Messages per page" => "每頁訊息數",
"Allow messages from other users" => "允許其他使用者的訊息",
// "Notify sender when reading mail" => "Notify sender when reading mail",
"Send me an email for messages with priority equal to or greater than" => "發送 email 通知, 當訊息重要性大於等於",
// "priority" => "priority",
// "Auto-archive read messages after" => "Auto-archive read messages after",
// "The number of days after which Tiki will archive the messages that have been read by the user" => "The number of days after which Tiki will archive the messages that have been read by the user",
// "60" => "60",
"My pages" => "我的頁面",
// "List all wiki pages edited by the user" => "List all wiki pages edited by the user",
"My blogs" => "我的 blogs",
// "List all blogs and blog posts edited by the user" => "List all blogs and blog posts edited by the user",
"My galleries" => "我的圖庫",
// "List all galleries edited by the user" => "List all galleries edited by the user",
"My messages" => "我的訊息",
// "List all messages and replies by the user" => "List all messages and replies by the user",
"My tasks" => "我的工作",
// "List all tasks by the user" => "List all tasks by the user",
// "My forum topics" => "My forum topics",
// "List all forum topics by the user" => "List all forum topics by the user",
// "My forum replies" => "My forum replies",
// "List all forum replies by the user" => "List all forum replies by the user",
"My items" => "我的事項",
// "List all tracker items by the user" => "List all tracker items by the user",
// "Character set for mail" => "Character set for mail",
// "Keep closed remarksbox hidden" => "Keep closed remarksbox hidden",
// "XMPP account JID or username" => "XMPP account JID or username",
// "XMPP account password" => "XMPP account password",
// "XMPP http-bind URL" => "XMPP http-bind URL",
// "Full URL to the http-bind" => "Full URL to the http-bind",
// "https://xmpp.example.org/http-bind/" => "https://xmpp.example.org/http-bind/",
// "Pre-set show user's info on mouseover" => "Pre-set show user's info on mouseover",
// "Set new users' info to display in a popup when their name is hovered over" => "Set new users' info to display in a popup when their name is hovered over",
// "Remember the alert boxes that users have closed and don't display them again" => "Remember the alert boxes that users have closed and don't display them again",
// "Validator emails (separated by comma) if different than the sender email" => "Validator emails (separated by comma) if different than the sender email",
// "Vimeo upload" => "Vimeo upload",
// "Enables video upload to the Vimeo service. API keys are required and approval must be granted by Vimeo for the upload API" => "Enables video upload to the Vimeo service. API keys are required and approval must be granted by Vimeo for the upload API",
// "Vimeo delete" => "Vimeo delete",
// "Causes videos uploaded to the Vimeo service via Tiki file galleries to be deleted when the Tiki file is deleted" => "Causes videos uploaded to the Vimeo service via Tiki file galleries to be deleted when the Tiki file is deleted",
// "Permanently removes videos from the registered vimeo.com account" => "Permanently removes videos from the registered vimeo.com account",
// "Vimeo consumer key" => "Vimeo consumer key",
// "API consumer key" => "API consumer key",
// "Vimeo consumer secret" => "Vimeo consumer secret",
// "API consumer secret" => "API consumer secret",
// "Vimeo access token" => "Vimeo access token",
// "The access token that is automatically generated by Vimeo when API keys are requested" => "The access token that is automatically generated by Vimeo when API keys are requested",
// "Vimeo access token secret" => "Vimeo access token secret",
// "The access token secret automatically generated by Vimeo when API keys are requested" => "The access token secret automatically generated by Vimeo when API keys are requested",
// "Vimeo Default Gallery" => "Vimeo Default Gallery",
// "The The ID of the default file gallery in which to store the Vimeo reference" => "The The ID of the default file gallery in which to store the Vimeo reference",
// "Display by default" => "Display by default",
// "Path (if stored in directory)" => "Path (if stored in directory)",
// "Edit idle timeout" => "Edit idle timeout",
// "Select the amount of time (in minutes) after which a user's edit session will expire. If the user does not save or preview their work, it will be lost. Tiki will display a \"countdown time\" in the user's browser and display an alert when only a minute remains" => "Select the amount of time (in minutes) after which a user's edit session will expire. If the user does not save or preview their work, it will be lost. Tiki will display a \"countdown time\" in the user's browser and display an alert when only a minute remains",
// "Cron jobs can be triggered from a URL or with JavaScript. A token is required to run the cron job manually" => "Cron jobs can be triggered from a URL or with JavaScript. A token is required to run the cron job manually",
// "How to trigger Web Cron" => "How to trigger Web Cron",
// "Calling the Web Cron URL" => "Calling the Web Cron URL",
// "Adding JavaScript that calls Web Cron" => "Adding JavaScript that calls Web Cron",
// "URL and JavaScript" => "URL and JavaScript",
// "Run interval" => "Run interval",
// "The amount of time of each run" => "The amount of time of each run",
// "Token" => "Token",
// "The token to use when running the cron manually" => "The token to use when running the cron manually",
// "Default cache" => "Default cache",
// "Cache time in seconds to use if the webservice does not supply \"max-age\" or \"no-cache\" in the response" => "Cache time in seconds to use if the webservice does not supply \"max-age\" or \"no-cache\" in the response",
// "Last Modified" => "Last Modified",
// "Last editor" => "Last editor",
// "Wiki link format" => "Wiki link format",
// "Level of special characters acceptable in wiki links for page names. For example: ((Page &eacute;&agrave;&icirc;))" => "Level of special characters acceptable in wiki links for page names. For example: ((Page &eacute;&agrave;&icirc;))",
// "\"Strict\" includes only basic characters such as a-z and 0-9. A site that uses accented or special characters in page names should not use \"strict\"" => "\"Strict\" includes only basic characters such as a-z and 0-9. A site that uses accented or special characters in page names should not use \"strict\"",
"Complete" => "Complete",
// "Relaxed" => "Relaxed",
// "Strict" => "Strict",
// "Wiki URL scheme" => "Wiki URL scheme",
// "Alter the SEFURL pattern for page names" => "Alter the SEFURL pattern for page names",
// "Use the \"View\" action to regenerate your URLs after changing this setting" => "Use the \"View\" action to regenerate your URLs after changing this setting",
// "Show the page version" => "Show the page version",
// "Display the page version information when viewing the page" => "Display the page version information when viewing the page",
// "Display the page name above the page area" => "Display the page name above the page area",
// "Display the page name in small text at the top of each page (above the page's content)" => "Display the page name in small text at the top of each page (above the page's content)",
// "Display the page name inside the page content" => "Display the page name inside the page content",
// "Page name display stripper" => "Page name display stripper",
// "The character(s) to use as a delimiter in the page name. The portion of the name after the character(s) will not be displayed. If the page name display stripper conflicts with the namespace separator, the namespace is used and the page name display is not stripped" => "The character(s) to use as a delimiter in the page name. The portion of the name after the character(s) will not be displayed. If the page name display stripper conflicts with the namespace separator, the namespace is used and the page name display is not stripped",
// "Wiki author list style" => "Wiki author list style",
// "Change the list format that is used to display the authors of the page" => "Change the list format that is used to display the authors of the page",
// "Creator and Author" => "Creator and Author",
// "Business style" => "Business style",
// "Collaborative style" => "Collaborative style",
// "Page last modified on" => "Page last modified on",
// "none (disabled)" => "none (disabled)",
// "Specify wiki author list style per page" => "Specify wiki author list style per page",
// "Enable the style in which the author list is displayed to be modified on a per-page basis" => "Enable the style in which the author list is displayed to be modified on a per-page basis",
// "Wiki page edit buttons location" => "Wiki page edit buttons location",
// "Specify the location of the Save, Preview, and Cancel buttons on the wiki edit page" => "Specify the location of the Save, Preview, and Cancel buttons on the wiki edit page",
// "Wiki navigation bar location" => "Wiki navigation bar location",
// "When using the ...page... page break wiki syntax" => "When using the ...page... page break wiki syntax",
// "Wiki top line location" => "Wiki top line location",
// "Page description, page actions, icons, backlinks..." => "Page description, page actions, icons, backlinks...",
// "Display ShareThis icon prominently" => "Display ShareThis icon prominently",
// "Encourage sharing by displaying the ShareThis icon (the default is placing the icon in a drop-down list that requires a click to view)" => "Encourage sharing by displaying the ShareThis icon (the default is placing the icon in a drop-down list that requires a click to view)",
// "Cache wiki pages (global)" => "Cache wiki pages (global)",
// "Enable page cache globally for wiki pages" => "Enable page cache globally for wiki pages",
"no cache" => "無快取",
// "Allow comments per wiki page" => "Allow comments per wiki page",
// "Enable control of comments on wiki pages on a per-page basis" => "Enable control of comments on wiki pages on a per-page basis",
// "Enable (default On)" => "Enable (default On)",
// "Enable (default Off)" => "Enable (default Off)",
// "Wiki copyright" => "Wiki copyright",
// "Prevent special characters in page names" => "Prevent special characters in page names",
// "Some characters in a wiki page name may prevent the page from being easily accessible via the URL or wiki links. This option prevents the creation of page names with such characters" => "Some characters in a wiki page name may prevent the page from being easily accessible via the URL or wiki links. This option prevents the creation of page names with such characters",
// "Page ranking reload probability" => "Page ranking reload probability",
// "Calculation of page rankings is a resource-intensive task that cannot be performed at every page load. It will be calculated at random page loads based on a dice roll. This option indicates the number of faces on the dice. Larger numbers lead to reduced resource use, but less-accurate ranking" => "Calculation of page rankings is a resource-intensive task that cannot be performed at every page load. It will be calculated at random page loads based on a dice roll. This option indicates the number of faces on the dice. Larger numbers lead to reduced resource use, but less-accurate ranking",
// "Encourage contribution to wiki pages by anonymous" => "Encourage contribution to wiki pages by anonymous",
// "When a page is not editable because the user is anonymous, display the edit buttons anyway. The visitor will be prompted with a log-in screen and will be encouraged to register in order to be able to edit the page" => "When a page is not editable because the user is anonymous, display the edit buttons anyway. The visitor will be prompted with a log-in screen and will be encouraged to register in order to be able to edit the page",
// "Warn before page lock timeout" => "Warn before page lock timeout",
// "Provide a JavaScript alert before the user's lock on a page times out" => "Provide a JavaScript alert before the user's lock on a page times out",
// "Dynamic variables" => "Dynamic variables",
// "Global snippets of text that can be included in wiki pages and edited in place" => "Global snippets of text that can be included in wiki pages and edited in place",
// "Single (%varname%)" => "Single (%varname%)",
// "Double (%%varname%%)" => "Double (%%varname%%)",
// "Multilingual dynamic variables" => "Multilingual dynamic variables",
// "Make dynamic variable content language-specific" => "Make dynamic variable content language-specific",
// "Allow plugin-specific edits" => "Allow plugin-specific edits",
// "Add an icon next to each plugin usage to enable editing the plugin in a popup form, without needing to edit the whole page" => "Add an icon next to each plugin usage to enable editing the plugin in a popup form, without needing to edit the whole page",
// "This feature is unavailable outside wiki pages, whether or not this preference is enabled" => "This feature is unavailable outside wiki pages, whether or not this preference is enabled",
// "Allow section-specific edits" => "Allow section-specific edits",
// "Add an edit icon at the top of each heading-demarcated wiki page section (up to a configurable maximum level) to ease the editing of a single section" => "Add an edit icon at the top of each heading-demarcated wiki page section (up to a configurable maximum level) to ease the editing of a single section",
// "Section-specific edits maximum level" => "Section-specific edits maximum level",
// "Prevent a proliferation of edit icons for low-level sections. For example, when set to 2, no edit icons will show for third-level (HTML h3) sections" => "Prevent a proliferation of edit icons for low-level sections. For example, when set to 2, no edit icons will show for third-level (HTML h3) sections",
// "Only display focused edit icons (for sections and/or plugins) on request" => "Only display focused edit icons (for sections and/or plugins) on request",
// "Focused edit icons will only display after a per-session \"Edit icons\" preference is enabled. This preference is defined directly from any wiki page" => "Focused edit icons will only display after a per-session \"Edit icons\" preference is enabled. This preference is defined directly from any wiki page",
// "Allow minor edits of wiki pages" => "Allow minor edits of wiki pages",
// "Minor edits don't flag new content for translation and don't cause watch notifications to be sent (unless \"Watch minor edits\" is enabled)" => "Minor edits don't flag new content for translation and don't cause watch notifications to be sent (unless \"Watch minor edits\" is enabled)",
// "Display comment list by default" => "Display comment list by default",
// "Display Post new comment form by default" => "Display Post new comment form by default",
// "Simple wiki comment ratings" => "Simple wiki comment ratings",
// "Enable users to rate comments based on a simple numeric scale" => "Enable users to rate comments based on a simple numeric scale",
// "Wiki rating options" => "Wiki rating options",
// "List of options available for the rating of wiki comments" => "List of options available for the rating of wiki comments",
// "Add a slideshow button on wiki pages" => "Add a slideshow button on wiki pages",
"Page creators are administrators of their pages" => "頁面建立者也是頁面管理者",
// "Create watch for author on page creation" => "Create watch for author on page creation",
"Enable watches on comments" => "啟動對評論的監視",
// "Watch minor edits" => "Watch minor edits",
// "Page ID" => "Page ID",
// "Page name maximum displayed length" => "Page name maximum displayed length",
// "Comment of the latest edit" => "Comment of the latest edit",
// "Description maximum displayed length" => "Description maximum displayed length",
"Versions" => "版本",
// "Categories path" => "Categories path",
// "Default sort order" => "Default sort order",
// "Sort Direction" => "Sort Direction",
// "Visibility of discussion" => "Visibility of discussion",
// "Just a button among others (default), or special section" => "Just a button among others (default), or special section",
// "In the button bar (default)" => "In the button bar (default)",
// "Special section above button bar" => "Special section above button bar",
// "Forum for discussion" => "Forum for discussion",
// "Allow management of keywords on a per-page basis" => "Allow management of keywords on a per-page basis",
// "Similar pages only listed in same language" => "Similar pages only listed in same language",
// "When listing similar pages, such as on a \"page not found\" page, only display pages in the same language as the request page" => "When listing similar pages, such as on a \"page not found\" page, only display pages in the same language as the request page",
// "Mandatory wiki page edit summary" => "Mandatory wiki page edit summary",
// "Reject save attempts that do not include an edit summary describing the changes made" => "Reject save attempts that do not include an edit summary describing the changes made",
// "Position of tags selection" => "Position of tags selection",
// "Place the tags selection more prominently than under the \"Properties\" tab" => "Place the tags selection more prominently than under the \"Properties\" tab",
// "Properties tab" => "Properties tab",
// "Edit tab" => "Edit tab",
// "Tags tab" => "Tags tab",
// "Structure navigation bar location" => "Structure navigation bar location",
// "Display Next and Back buttons, breadcrumbs, and a form to add a new page" => "Display Next and Back buttons, breadcrumbs, and a form to add a new page",
// "Backlink page names maximum displayed length" => "Backlink page names maximum displayed length",
// "Show blog posts" => "Show blog posts",
// "Blog posts linking to a wiki page are shown as backlinks" => "Blog posts linking to a wiki page are shown as backlinks",
// "Show forum posts" => "Show forum posts",
// "Forum posts linking to a wiki page are shown as backlinks" => "Forum posts linking to a wiki page are shown as backlinks",
// "Show comments" => "Show comments",
// "Comments linking to a wiki page are shown as backlinks" => "Comments linking to a wiki page are shown as backlinks",
// "Show articles" => "Show articles",
// "Articles linking to a wiki page are shown as backlinks" => "Articles linking to a wiki page are shown as backlinks",
// "Show tracker items" => "Show tracker items",
// "Tracker items linking to a wiki page are shown as backlinks" => "Tracker items linking to a wiki page are shown as backlinks",
// "Show trackers" => "Show trackers",
// "Trackers with a description linking to a wiki page are shown as backlinks" => "Trackers with a description linking to a wiki page are shown as backlinks",
// "Show tracker fields" => "Show tracker fields",
// "Tracker fields with a description linking to a wiki page are shown as backlinks" => "Tracker fields with a description linking to a wiki page are shown as backlinks",
// "Show calendar events" => "Show calendar events",
// "Calendar events with a description linking to a wiki page are shown as backlinks." => "Calendar events with a description linking to a wiki page are shown as backlinks.",
// "Simple wiki ratings" => "Simple wiki ratings",
// "Enable users to rate wiki pages based on a simple numeric scale" => "Enable users to rate wiki pages based on a simple numeric scale",
// "List of options available for the rating of wiki pages" => "List of options available for the rating of wiki pages",
// "Semantic link types to use as page alias markers" => "Semantic link types to use as page alias markers",
// "Comma-separated list of semantic links to identify a page as an alias of another" => "Comma-separated list of semantic links to identify a page as an alias of another",
// "Redirect pages using these prefix-alias semantic links" => "Redirect pages using these prefix-alias semantic links",
// "Comma-separated list of page name prefixes for pages that will be redirected to other pages with a semantic link" => "Comma-separated list of page name prefixes for pages that will be redirected to other pages with a semantic link",
// "Wiki page pagination" => "Wiki page pagination",
// "Enable the separation of a wiki page's content into a set of two or more paginated pages" => "Enable the separation of a wiki page's content into a set of two or more paginated pages",
// "Wiki page separator" => "Wiki page separator",
// "The separator to use in wiki page content to mark the end of each page section" => "The separator to use in wiki page content to mark the end of each page section",
// "Wiki auto-toc" => "Wiki auto-toc",
// "Automatic table of contents generation for wiki pages. The generated table of contents will display as a fixed-position aside next to the page contents. This setting can be toggled per page, in the page properties" => "Automatic table of contents generation for wiki pages. The generated table of contents will display as a fixed-position aside next to the page contents. This setting can be toggled per page, in the page properties",
// "Inline auto-toc" => "Inline auto-toc",
// "Change the display of the table of contents for wiki pages to inline" => "Change the display of the table of contents for wiki pages to inline",
// "Table of contents position" => "Table of contents position",
// "Position of the table of contents, either top, left, right (right is the default)" => "Position of the table of contents, either top, left, right (right is the default)",
// "Table of contents offset" => "Table of contents offset",
// "Offset for table of contents. Useful when there is a fixed navigation bar. If used with inline TOC, will behave as a top margin" => "Offset for table of contents. Useful when there is a fixed navigation bar. If used with inline TOC, will behave as a top margin",
// "Table of contents default" => "Table of contents default",
// "Set the default for the table of contents (default \"on\" and can be toggled per page)" => "Set the default for the table of contents (default \"on\" and can be toggled per page)",
// "On" => "On",
// "Off" => "Off",
// "Add an option to hide the page title per wiki page" => "Add an option to hide the page title per wiki page",
// "Enable the page title to not be displayed, on a per-page basis" => "Enable the page title to not be displayed, on a per-page basis",
// "Multilevel style numbering for ordered lists" => "Multilevel style numbering for ordered lists",
// "Make ordered list items display unique numbers for all levels of their sub-items; for example: 1.1, 1.2, 1.2.1, 1.2.2, etc" => "Make ordered list items display unique numbers for all levels of their sub-items; for example: 1.1, 1.2, 1.2.1, 1.2.2, etc",
// "Force link to included page" => "Force link to included page",
// "When only a portion of page is included, create a \"See full page\" link to the included page. It has the same effect of setting \"linkoriginal=y\" parameter every time Plugin Include is used" => "When only a portion of page is included, create a \"See full page\" link to the included page. It has the same effect of setting \"linkoriginal=y\" parameter every time Plugin Include is used",
// "Date Field" => "Date Field",
// "The field indexed as the global \"date\" field" => "The field indexed as the global \"date\" field",
// "You will need to rebuild the search index after changing this" => "You will need to rebuild the search index after changing this",
// "Wiki cache reduces server load but can cause some empty pages and other issues when using wiki plugins. Use only if necessary; it may be better to use an individual wiki cache for only the pages that require it" => "Wiki cache reduces server load but can cause some empty pages and other issues when using wiki plugins. Use only if necessary; it may be better to use an individual wiki cache for only the pages that require it",
// "Maximum displayed length of the latest edit's comment" => "Maximum displayed length of the latest edit's comment",
// "Plugin %0" => "Plugin %0",
// "Global cache time for the plugin snarf" => "Global cache time for the plugin snarf",
// "Default cache time for the plugin snarf" => "Default cache time for the plugin snarf",
// "0 for no cache" => "0 for no cache",
// "GUI for the list plugin" => "GUI for the list plugin",
// "Experimental GUI for the list plugin in popup plugin edit forms" => "Experimental GUI for the list plugin in popup plugin edit forms",
// "(listgui)" => "(listgui)",
// "Plugin trackerlist converter" => "Plugin trackerlist converter",
// "Button on trackerlist and trackerfilter plugins edit form to convert them to use the list plugin instead" => "Button on trackerlist and trackerfilter plugins edit form to convert them to use the list plugin instead",
// "Maximum plugin parsing passes" => "Maximum plugin parsing passes",
// "Affects the number of wiki plugins that can be used. The default of 500 allows for 1 plugin nested seven times, or 44 plugins nested once. A value of 1200 is required for 1 eighth level plugin" => "Affects the number of wiki plugins that can be used. The default of 500 allows for 1 plugin nested seven times, or 44 plugins nested once. A value of 1200 is required for 1 eighth level plugin",
// "passes" => "passes",
// "Setting this to a higher value than the default of 500 may have performance implications" => "Setting this to a higher value than the default of 500 may have performance implications",
// "Inline plugin %0" => "Inline plugin %0",
// "Plugin pending approval notification" => "Plugin pending approval notification",
// "Send an email alert to users with permission to approve plugins when a plugin approval is pending" => "Send an email alert to users with permission to approve plugins when a plugin approval is pending",
// "Hide admin wizard on log-in when an admin user logs in" => "Hide admin wizard on log-in when an admin user logs in",
// "Workspace UI" => "Workspace UI",
// "Combines multiple site features to create a workspace experience for workgroups" => "Combines multiple site features to create a workspace experience for workgroups",
// "Workspace root category" => "Workspace root category",
// "ID of the root category containing all workspaces" => "ID of the root category containing all workspaces",
// "This value is automatically managed and should not need to be modified manually" => "This value is automatically managed and should not need to be modified manually",
// "Full WYSIWYG editor is optional" => "Full WYSIWYG editor is optional",
// "If WYSIWYG is optional, the wiki text editor is also available. Otherwise only the WYSIWYG editor is used" => "If WYSIWYG is optional, the wiki text editor is also available. Otherwise only the WYSIWYG editor is used",
// "Switching between HTML and wiki formats can cause problems for some pages" => "Switching between HTML and wiki formats can cause problems for some pages",
// "Full WYSIWYG editor is displayed by default" => "Full WYSIWYG editor is displayed by default",
// "If both the WYSIWYG editor and the text editor are available, the WYSIWYG editor is used by default, for example, when creating new pages" => "If both the WYSIWYG editor and the text editor are available, the WYSIWYG editor is used by default, for example, when creating new pages",
// "Reopen with the same editor" => "Reopen with the same editor",
// "Ensures the editor last used to edit a page or item is used for the next edit as the default" => "Ensures the editor last used to edit a page or item is used for the next edit as the default",
// "This allows a mixture of wiki syntax and HTML in the code of wiki pages where HTML is allowed" => "This allows a mixture of wiki syntax and HTML in the code of wiki pages where HTML is allowed",
// "Use Wiki syntax in WYSIWYG" => "Use Wiki syntax in WYSIWYG",
// "Causes parsed text areas based on wiki syntax when not in WYSIWYG mode to keep using Tiki syntax, instead of HTML as the WYSIWYG editor uses by default. Sometimes referred to as a \"visual wiki\"" => "Causes parsed text areas based on wiki syntax when not in WYSIWYG mode to keep using Tiki syntax, instead of HTML as the WYSIWYG editor uses by default. Sometimes referred to as a \"visual wiki\"",
// "Using wiki syntax in WYSIWYG mode will limit toolbar to wiki tools" => "Using wiki syntax in WYSIWYG mode will limit toolbar to wiki tools",
// "Existing wiki pages remain in HTML, unless they are converted to non-WYSIWYG and back to WYSIWYG (one by one)" => "Existing wiki pages remain in HTML, unless they are converted to non-WYSIWYG and back to WYSIWYG (one by one)",
// "CKeditor offers possibilities which may not be expressible in Tiki syntax" => "CKeditor offers possibilities which may not be expressible in Tiki syntax",
// "Full WYSIWYG editor skin" => "Full WYSIWYG editor skin",
// "Moono (Default)" => "Moono (Default)",
// "Kama" => "Kama",
// "Bootstrap CK" => "Bootstrap CK",
// "Minimalist" => "Minimalist",
// "Office 2013" => "Office 2013",
// "Typefaces" => "Typefaces",
// "List of font names separated by semi-colons (\";\")" => "List of font names separated by semi-colons (\";\")",
// "Inline WYSIWYG editor" => "Inline WYSIWYG editor",
// "Seamless inline editing. Uses CKEditor 4. Inline editing enables editing pages without a context switch. The editor is embedded in the wiki page. When used on pages in wiki format, a conversion from HTML to wiki format is required" => "Seamless inline editing. Uses CKEditor 4. Inline editing enables editing pages without a context switch. The editor is embedded in the wiki page. When used on pages in wiki format, a conversion from HTML to wiki format is required",
// "Extra plugins" => "Extra plugins",
// "List of plugin names (separated by,)" => "List of plugin names (separated by,)",
// "In Tiki, CKEditor uses the \"standard\" package in which some plugins are disabled by default that are available in the \"full\" package.<br>See http://ckeditor.com/presets for a comparison of which plugins are enabled as standard" => "In Tiki, CKEditor uses the \"standard\" package in which some plugins are disabled by default that are available in the \"full\" package.<br>See http://ckeditor.com/presets for a comparison of which plugins are enabled as standard",
// "Support Tiki's \"wiki syntax\" in HTML pages" => "Support Tiki's \"wiki syntax\" in HTML pages",
// "XMPP client (ConverseJS)" => "XMPP client (ConverseJS)",
// "Integration with Converse.js XMPP client" => "Integration with Converse.js XMPP client",
// "XMPP server domain" => "XMPP server domain",
// "example.org" => "example.org",
// "XMPP MUC Domain" => "XMPP MUC Domain",
// "Required for auto-joining rooms" => "Required for auto-joining rooms",
// "conference.example.org" => "conference.example.org",
// "The authentication method to be used by XMPP client" => "The authentication method to be used by XMPP client",
// "OAuth (uses Tiki as provider)" => "OAuth (uses Tiki as provider)",
// "Openfire TikiToken" => "Openfire TikiToken",
// "Allow anonymous" => "Allow anonymous",
// "Allow anonymous users on Chat" => "Allow anonymous users on Chat",
// "Openfire REST API endpoint" => "Openfire REST API endpoint",
// "Full URL to API endpoint" => "Full URL to API endpoint",
// "https://xmpp.example.org:9091/plugins/restapi/v1/" => "https://xmpp.example.org:9091/plugins/restapi/v1/",
// "Rest API username" => "Rest API username",
// "Username to allow Openfire API usage" => "Username to allow Openfire API usage",
// "Rest API password" => "Rest API password",
// "Password to allow Openfire API usage" => "Password to allow Openfire API usage",
// "ConverseJS Debug Mode" => "ConverseJS Debug Mode",
// "Enables more logging, e.g. XML stanzas and error tracebacks to the JavaScript Console" => "Enables more logging, e.g. XML stanzas and error tracebacks to the JavaScript Console",
// "ConverseJS Extra Settings" => "ConverseJS Extra Settings",
// "JSON format object defining extra optional settings to initialize ConverseJS" => "JSON format object defining extra optional settings to initialize ConverseJS",
"SMTP server" => "SMTP 伺服器",
// "Security" => "Security",
// "SSL" => "SSL",
// "TLS" => "TLS",
// "Mail sender" => "Mail sender",
// "Specify if Tiki should use Sendmail(the PHP mail() function), SMTP or File (Debug) (to debug email sending by means of storing emails as files on disk at ./temp/Mail_yyyymmddhhmmss_randomstring.tmp ) to send mail notifications" => "Specify if Tiki should use Sendmail(the PHP mail() function), SMTP or File (Debug) (to debug email sending by means of storing emails as files on disk at ./temp/Mail_yyyymmddhhmmss_randomstring.tmp ) to send mail notifications",
// "Sendmail" => "Sendmail",
// "SMTP" => "SMTP",
// "File (debug)" => "File (debug)",
// "Authentication" => "Authentication",
// "Mail server authentication" => "Mail server authentication",
// "LOGIN" => "LOGIN",
// "PLAIN" => "PLAIN",
// "CRAM-MD5" => "CRAM-MD5",
// "Local server name" => "Local server name",
// "Name of the local server. Will be reported to SMTP relay on the HELO/EHLO line" => "Name of the local server. Will be reported to SMTP relay on the HELO/EHLO line",
// "Mail delivery" => "Mail delivery",
// "When set to Queue, messages will be stored in the database. Requires using the shell script %0 to be run for actual delivery. Only works with SMTP mail" => "When set to Queue, messages will be stored in the database. Requires using the shell script %0 to be run for actual delivery. Only works with SMTP mail",
// "Send immediately" => "Send immediately",
// "Queue" => "Queue",
// "Verify HTTPS certificates of remote servers" => "Verify HTTPS certificates of remote servers",
// "When set to enforce, the server will fail to connect over HTTPS to a remote server that do not have a SSL certificate that is valid and can be verified against the local list of Certificate Authority (CA)" => "When set to enforce, the server will fail to connect over HTTPS to a remote server that do not have a SSL certificate that is valid and can be verified against the local list of Certificate Authority (CA)",
// "Do not enforce verification" => "Do not enforce verification",
// "Enforce verification" => "Enforce verification",
// "Use CURL for HTTP connections" => "Use CURL for HTTP connections",
// "Use CURL instead of sockets for server to server HTTP connections, when sockets are not available" => "Use CURL instead of sockets for server to server HTTP connections, when sockets are not available",
// "Zotero bibliography" => "Zotero bibliography",
// "Connect Tiki to the <a href=\"https://www.zotero.org\">Zotero</a> online bibliography management system" => "Connect Tiki to the <a href=\"https://www.zotero.org\">Zotero</a> online bibliography management system",
// "You must supply the following items: Zotero Client Key, Zotero Client Secret, Zotero Group, and Zotero Reference Style" => "You must supply the following items: Zotero Client Key, Zotero Client Secret, Zotero Group, and Zotero Reference Style",
// "Zotero client key" => "Zotero client key",
// "Required identification key. Registration required" => "Required identification key. Registration required",
// "Zotero client secret" => "Zotero client secret",
// "Zotero group ID" => "Zotero group ID",
// "Numeric ID of the group, can be found in the URL" => "Numeric ID of the group, can be found in the URL",
// "Zotero reference style" => "Zotero reference style",
// "Use an alternate Zotero reference style when formatting the references. The reference formats must be installed on the Zotero server" => "Use an alternate Zotero reference style when formatting the references. The reference formats must be installed on the Zotero server",
// "Unmatched system requirement. Missing PHP extension among %0" => "Unmatched system requirement. Missing PHP extension among %0",
// "Unmatched system requirement. The database you are using does not support this feature" => "Unmatched system requirement. The database you are using does not support this feature",
// "Missing default for preference \"%0\"" => "Missing default for preference \"%0\"",
// "Configuration forced by host" => "Configuration forced by host",
// "Disabled by host" => "Disabled by host",
"Settings" => "設定",
"Permissions" => "權限",
"View" => "觀看",
"Modules" => "模組",
// "Plugins" => "Plugins",
// "Like" => "Like",
// "Missing preference \"%0\" for \"%1\"" => "Missing preference \"%0\" for \"%1\"",
// "%0 set to minimum of %1 instead of submitted value of %2" => "%0 set to minimum of %1 instead of submitted value of %2",
// "%0 set to maximum of %1 instead of submitted value of %2" => "%0 set to maximum of %1 instead of submitted value of %2",
// "Don't like" => "Don't like",
"Wiki top pages" => "Wiki 首頁",
"Most-relevant pages" => "最相關頁面",
"Wiki last pages" => "Wiki 末頁",
// "Forums last topics" => "Forums last topics",
"Topic date" => "主題日期",
// "Forums last posts" => "Forums last posts",
"Forums most-read topics" => "論壇最熱門話題",
"Forums best topics" => "論壇最佳話題",
"Most-visited forums" => "最熱門論壇",
"Forums with most posts" => "最多文章論壇",
"Wiki top galleries" => "Wiki 最熱門圖庫",
"Wiki top file galleries" => "Wiki 最熱門檔案庫",
"Wiki top images" => "Wiki 最熱門影像",
"Wiki top files" => "Wiki 最熱門檔案",
"Downloads" => "下傳數",
"Wiki most-recent images" => "Wiki 最新影像",
"Upload date" => "上傳日期",
"Wiki most-recent files" => "Wiki 最新檔案",
"Top Articles" => "最熱門文章",
"Most-visited blogs" => "最常被瀏覽 blogs",
"Most-active blogs" => "最活躍 blog",
"Blogs last posts" => "Blogs 最新文章",
"Post date" => "發表日期",
"Wiki top authors" => "Wiki 最佳作者",
"Pages" => "頁面",
"Top article authors" => "文章最多作者",
// "Expecting three arguments for article-info" => "Expecting three arguments for article-info",
// "Unsupported property. Supported properties are: " => "Unsupported property. Supported properties are: ",
// "The Articles feature is not activated" => "The Articles feature is not activated",
// "Object must be provided and contain two arguments: type and object" => "Object must be provided and contain two arguments: type and object",
// "Invalid property" => "Invalid property",
// "Item must be provided and contain one argument: type, object-id" => "Item must be provided and contain one argument: type, object-id",
// "List must be provided and contain at least one argument: category IDs" => "List must be provided and contain at least one argument: category IDs",
// "Invalid range" => "Invalid range",
// "Invalid revote period" => "Invalid revote period",
// "Expecting \"keep\" to be \"latest\" or \"oldest\"" => "Expecting \"keep\" to be \"latest\" or \"oldest\"",
// "Qualifier must be provided and contain one argument: type" => "Qualifier must be provided and contain one argument: type",
// "From must be provided and contain two arguments: type, object-id" => "From must be provided and contain two arguments: type, object-id",
// "To must be provided and contain two arguments: type, object-id" => "To must be provided and contain two arguments: type, object-id",
// "Field must be provided and contain one argument: field permanent name" => "Field must be provided and contain one argument: field permanent name",
// "Unknown variables referenced: %0" => "Unknown variables referenced: %0",
// "Username is required" => "Username is required",
"Password is required" => "需要密碼",
"User already exists" => "使用者已經存在",
"Invalid username" => "不合法的使用者名稱",
"Username is too long" => "使用者名稱過長",
// "Username cannot contain uppercase letters" => "Username cannot contain uppercase letters",
"Wrong passcode. You need to know the passcode to register at this site" => "passcode 錯誤, 你必須有 passcode 才能在本站註冊",
// "You must choose a group" => "You must choose a group",
// "Email not valid. Should be in the format \"mailbox@example.com\"" => "Email not valid. Should be in the format \"mailbox@example.com\"",
// "One of these groups is required" => "One of these groups is required",
// "This field is required" => "This field is required",
"The passwords don't match" => "密碼錯誤",
// "Username must be at least %0 characters long" => "Username must be at least %0 characters long",
// "Username cannot contain more than %0 characters" => "Username cannot contain more than %0 characters",
// "This invitation does not exist or is deprecated or wrong email" => "This invitation does not exist or is deprecated or wrong email",
// "The title and description must be entered, to generate a feed" => "The title and description must be entered, to generate a feed",
// "To fix this error go to Admin -> Feeds" => "To fix this error go to Admin -> Feeds",
// "Please contact the site administrator and request this error to be corrected" => "Please contact the site administrator and request this error to be corrected",
// "If you set feed author email or URL, you must set feed author name" => "If you set feed author email or URL, you must set feed author name",
// "Feed logo" => "Feed logo",
// "Unspecified" => "Unspecified",
"Log In" => "登入",
// "See other users' profiles" => "See other users' profiles",
// "Have your profile seen" => "Have your profile seen",
// "Make friends" => "Make friends",
// "Receive a message" => "Receive a message",
"Send a message" => "發送訊息",
// "Read an article" => "Read an article",
// "Publish an article" => "Publish an article",
// "Have your article read" => "Have your article read",
// "Create new file gallery" => "Create new file gallery",
// "Upload a new file to a gallery" => "Upload a new file to a gallery",
// "Download another user's file" => "Download another user's file",
// "Have your file downloaded" => "Have your file downloaded",
// "Create a new image gallery" => "Create a new image gallery",
// "Upload a new image to a gallery" => "Upload a new image to a gallery",
// "View another user's gallery" => "View another user's gallery",
// "View another user's images" => "View another user's images",
// "Have your gallery viewed by another user" => "Have your gallery viewed by another user",
// "Have your image viewed" => "Have your image viewed",
// "Create a new blog" => "Create a new blog",
// "Post in a blog" => "Post in a blog",
// "Read another user's blog" => "Read another user's blog",
// "Have your blog read" => "Have your blog read",
// "Create a new wiki page" => "Create a new wiki page",
// "Edit an existing page" => "Edit an existing page",
"Attach a file" => "附加檔案",
// "Create a new forum topic" => "Create a new forum topic",
// "Reply to a forum topic" => "Reply to a forum topic",
// "Read a forum post" => "Read a forum post",
// "Have your forum post read" => "Have your forum post read",
// "Create a new tracker item" => "Create a new tracker item",
// "Edit a tracker item" => "Edit a tracker item",
// "View a tracker item" => "View a tracker item",
// "Have your tracker item viewed" => "Have your tracker item viewed",
// "Tracker field content added" => "Tracker field content added",
// "Favorite an item" => "Favorite an item",
// "Have your item favorited" => "Have your item favorited",
// "Have your item rated (per rating)" => "Have your item rated (per rating)",
// "Have your item unrated (per rating)" => "Have your item unrated (per rating)",
// "Add a profile photo" => "Add a profile photo",
// "Try rebuilding or optimizing the index on the search admin page" => "Try rebuilding or optimizing the index on the search admin page",
// "Invalid table name" => "Invalid table name",
// "Invalid column name" => "Invalid column name",
// "Wiki Comment" => "Wiki Comment",
// "Calendar item" => "Calendar item",
"Gallery" => "圖庫",
"Blog post" => "Blog 佈告",
// "Tracker item" => "Tracker item",
// "The search index could not be updated. The site is misconfigured. Contact an administrator" => "The search index could not be updated. The site is misconfigured. Contact an administrator",
// "Rebuild in progress" => "Rebuild in progress",
// "The search index could not be rebuilt" => "The search index could not be rebuilt",
// "The active index could not be removed, probably due to a file permission issue" => "The active index could not be removed, probably due to a file permission issue",
// "The new index could not be made active, probably due to a file permission issue" => "The new index could not be made active, probably due to a file permission issue",
// "Failed to delete the old index" => "Failed to delete the old index",
// "blog post" => "blog post",
// "forum post" => "forum post",
// "tracker item" => "tracker item",
// "tracker field" => "tracker field",
// "sheet" => "sheet",
"comment" => "評論",
// "category" => "category",
// "webservice" => "webservice",
// "activity" => "activity",
// "calendar item" => "calendar item",
// "Unable to connect to the main search index, MySQL full-text search used, the search results might not be accurate" => "Unable to connect to the main search index, MySQL full-text search used, the search results might not be accurate",
// "Contact the site administrator. The index needs rebuilding" => "Contact the site administrator. The index needs rebuilding",
// "Client Node" => "Client Node",
// "Elasticsearch Version" => "Elasticsearch Version",
// "Lucene Version" => "Lucene Version",
// "Cluster Name" => "Cluster Name",
// "Cluster Status" => "Cluster Status",
// "Cluster Node Count" => "Cluster Node Count",
// "Index %0" => "Index %0",
// "%0 documents, totaling %1" => "%0 documents, totaling %1",
// "Node %0" => "Node %0",
// "Using %0, since %1" => "Using %0, since %1",
// "%0 documents, totaling %1 bytes" => "%0 documents, totaling %1 bytes",
// "Using %0 bytes, since %1" => "Using %0 bytes, since %1",
// "Field Count Tried on Last Rebuild" => "Field Count Tried on Last Rebuild",
// "Field limit setting is lower than Tiki needs to store in the index" => "Field limit setting is lower than Tiki needs to store in the index",
// "Information Missing" => "Information Missing",
// "Object Type" => "Object Type",
// "date_histogram" => "date_histogram",
// "Date Histogram" => "Date Histogram",
// "date_range" => "date_range",
// "Date Range" => "Date Range",
// "Local Search" => "Local Search",
// "Federated Search" => "Federated Search",
// "Index not found" => "Index not found",
// "Rebuild search index" => "Rebuild search index",
// "Click here to rebuild index" => "Click here to rebuild index",
// "On Demand" => "On Demand",
// "You can revisit the results of this saved search on demand" => "You can revisit the results of this saved search on demand",
// "Mobile mode: Permission denied, please log in" => "Mobile mode: Permission denied, please log in",
// " has accessed your temporary shared content" => " has accessed your temporary shared content",
// "has accessed the following shared content" => "has accessed the following shared content",
// "Your access to this page has expired" => "Your access to this page has expired",
// "Handling actions of plugin \"%s\" failed" => "Handling actions of plugin \"%s\" failed",
// "You must choose an option" => "You must choose an option",
// "For you to vote, cookies must be allowed" => "For you to vote, cookies must be allowed",
// "This poll is closed" => "This poll is closed",
// "Preference %0 failed to unserialize. Value was \"%1\"" => "Preference %0 failed to unserialize. Value was \"%1\"",
// "A tracker with id \"%0\" is required to be filled in, but it was deleted" => "A tracker with id \"%0\" is required to be filled in, but it was deleted",
// "Update the preference \"<b>%0</b>\" on admin panel" => "Update the preference \"<b>%0</b>\" on admin panel",
// "Congratulations" => "Congratulations",
// "This is the default homepage for your Tiki. If you are seeing this page, your installation was successful" => "This is the default homepage for your Tiki. If you are seeing this page, your installation was successful",
// "You can change this page after logging in. Please review the [http://doc.tiki.org/wiki+syntax|wiki syntax] for editing details" => "You can change this page after logging in. Please review the [http://doc.tiki.org/wiki+syntax|wiki syntax] for editing details",
// "Get started" => "Get started",
// "To begin configuring your site" => "To begin configuring your site",
// "1) Log in with your newly created password" => "1) Log in with your newly created password",
// "2) Manually [tiki-admin.php?page=features|Enable specific Tiki features] that you didn't enable with the Admin wizard" => "2) Manually [tiki-admin.php?page=features|Enable specific Tiki features] that you didn't enable with the Admin wizard",
// "3) Run [tiki-admin.php?page=profiles|Tiki Profiles] to quickly get up and running" => "3) Run [tiki-admin.php?page=profiles|Tiki Profiles] to quickly get up and running",
// "Need help" => "Need help",
// "For more information" => "For more information",
// "[https://tiki.org/Introduction|Learn more about Tiki]" => "[https://tiki.org/Introduction|Learn more about Tiki]",
// "[https://tiki.org/|Get help], including the [http://doc.tiki.org|official documentation] and [http://tiki.org/forums|support forums]" => "[https://tiki.org/|Get help], including the [http://doc.tiki.org|official documentation] and [http://tiki.org/forums|support forums]",
// "[https://tiki.org/Join|Join the Tiki community]" => "[https://tiki.org/Join|Join the Tiki community]",
"new" => "增加",
// "Saved" => "Saved",
// "Save failed" => "Save failed",
// "Standard Shipping" => "Standard Shipping",
// "3 to 5 working days" => "3 to 5 working days",
// "Express Shipping" => "Express Shipping",
// "Next day delivery" => "Next day delivery",
// "Custom Shipping Example" => "Custom Shipping Example",
// "UPS_CODE_%0" => "UPS_CODE_%0",
// "Problem reading custom shipping provider \"%0\"" => "Problem reading custom shipping provider \"%0\"",
// "Modified date" => "Modified date",
// "<!-- jq smarty plugin inactive: feature_jquery off -->" => "<!-- jq smarty plugin inactive: feature_jquery off -->",
// "No records to display" => "No records to display",
// "Please specify the name of the package and the view" => "Please specify the name of the package and the view",
// "Error: Unable to locate view file for the package" => "Error: Unable to locate view file for the package",
// "Error: Unable to locate function name for the view" => "Error: Unable to locate function name for the view",
"Previous" => "先前排名",
"current" => "目前",
"Next" => "下一個",
// "More results may be available. Refine criteria to access the estimated %0 results" => "More results may be available. Refine criteria to access the estimated %0 results",
// "Tab View" => "Tab View",
// "No Tabs" => "No Tabs",
// "This edit session will expire in" => "This edit session will expire in",
// "There is an autosaved draft of your recent edits, to use it instead " => "There is an autosaved draft of your recent edits, to use it instead ",
// "If you want the original instead of the autosaved draft of your edits" => "If you want the original instead of the autosaved draft of your edits",
"click here" => "點擊此處",
// "AutoSave" => "AutoSave",
// "Your edit session has expired" => "Your edit session has expired",
// "Your edit session will expire in" => "Your edit session will expire in",
// "You must PREVIEW or SAVE your work now, to avoid losing your edits" => "You must PREVIEW or SAVE your work now, to avoid losing your edits",
// "You are about to leave this page. Changes since your last save may be lost. Are you sure you want to exit this page" => "You are about to leave this page. Changes since your last save may be lost. Are you sure you want to exit this page",
// "Help page" => "Help page",
// "View or edit tpl" => "View or edit tpl",
// "View tpl" => "View tpl",
// "itemId required" => "itemId required",
// "Plugin name not specified" => "Plugin name not specified",
// "Delete file" => "Delete file",
// "File (ID %0) removed" => "File (ID %0) removed",
// "File (ID %0) not removed" => "File (ID %0) not removed",
// "File uploaded" => "File uploaded",
// "File not uploaded" => "File not uploaded",
// "Missing _id or _type params" => "Missing _id or _type params",
// "Wrong attachments gallery" => "Wrong attachments gallery",
// "You are attempting to display a gallery that is not a valid attachment gallery" => "You are attempting to display a gallery that is not a valid attachment gallery",
// "Missing 'to' or 'from' parameter" => "Missing 'to' or 'from' parameter",
"at" => "於",
"to" => "到",
// "Favorite" => "Favorite",
// "Hour" => "Hour",
// "Minute" => "Minute",
// "a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z" => "a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z",
// "Click here to go to Edit Languages" => "Click here to go to Edit Languages",
// "The text is" => "The text is",
// "character(s) too long - please edit it" => "character(s) too long - please edit it",
// "Jun" => "Jun",
// "Jul" => "Jul",
// "Clear filter" => "Clear filter",
// "Type not specified" => "Type not specified",
// "lock perm not found" => "lock perm not found",
// "admin perm not found" => "admin perm not found",
// "Missing parameter" => "Missing parameter",
// "Multivalue configuration not found" => "Multivalue configuration not found",
"No records found" => "查無記錄",
// "No object information provided" => "No object information provided",
// "No title specified" => "No title specified",
// "Relation not found" => "Relation not found",
// "tags disabled" => "tags disabled",
// "Comma-separated list of field IDs" => "Comma-separated list of field IDs",
// "%0 list separated with \"%1\"" => "%0 list separated with \"%1\"",
// "Object selector requires Unified Index to be enabled" => "Object selector requires Unified Index to be enabled",
// "Currency in payment (%0) does not match the currency for that registry (%1)" => "Currency in payment (%0) does not match the currency for that registry (%1)",
// "Payment error" => "Payment error",
// "This invoice does not exist or access to it is restricted" => "This invoice does not exist or access to it is restricted",
"You do not have the permission that is needed to use this feature" => "權限不足, 無法使用本功能",
// "(not found in an admin panel)" => "(not found in an admin panel)",
// "Preference %0 is not defined" => "Preference %0 is not defined",
// "Drag this out of the perspective and resave the perspective" => "Drag this out of the perspective and resave the perspective",
// "No object information provided for rating" => "No object information provided for rating",
// "An error occurred" => "An error occurred",
// "Configure Ratings" => "Configure Ratings",
// "Unavailable" => "Unavailable",
// "Invalid fields provided" => "Invalid fields provided",
// "Missing or invalid tracker reference" => "Missing or invalid tracker reference",
// "Configured" => "Configured",
"General" => "一般",
// "Tracker rendering error (section=\"%0\" mode=\"%1\")" => "Tracker rendering error (section=\"%0\" mode=\"%1\")",
// "No rows found" => "No rows found",
// "Toggle sections" => "Toggle sections",
// "Show only selected" => "Show only selected",
// "You might want to also set the tiki_p_modify_object_categories permission under the tiki section" => "You might want to also set the tiki_p_modify_object_categories permission under the tiki section",
// "You are logged in" => "You are logged in",
// "Request not from this host" => "Request not from this host",
// "Please enter a valid %s.  No spaces, more than %d characters and contain %s" => "Please enter a valid %s.  No spaces, more than %d characters and contain %s",
"username" => "使用者名稱",
"password" => "密碼",
// "Cookies must be enabled to log in to this site" => "Cookies must be enabled to log in to this site",
// "wikidiff: error - no object_id specified" => "wikidiff: error - no object_id specified",
// "wikidiff: error - no old version specified" => "wikidiff: error - no old version specified",
// "wikidiff: error - page \"%0\" not found" => "wikidiff: error - page \"%0\" not found",
// "wikidiff: Error - only wiki pages supported currently" => "wikidiff: Error - only wiki pages supported currently",
"second" => "秒",
// "months" => "months",
// "weeks" => "weeks",
"done" => "完成",
// "Text cut here" => "Text cut here",
// "Task" => "Task",
"Priority" => "重要性",
"Start date" => "開始日期",
// "End date" => "End date",
// "in %s days, the %s" => "in %s days, the %s",
// "in %s day, the %s" => "in %s day, the %s",
"Today" => "今天",
// "%0 and %1" => "%0 and %1",
// "Permission denied: the specified wiki page cannot be used as Smarty template resource" => "Permission denied: the specified wiki page cannot be used as Smarty template resource",
// "No WSDL found" => "No WSDL found",
// "Facebook feed data not retrieved" => "Facebook feed data not retrieved",
// "Facebook profile information not retrieved" => "Facebook profile information not retrieved",
// "You need to link your local account to Facebook before you can login using it" => "You need to link your local account to Facebook before you can login using it",
// "We were unable to create a new user with your Facebook account. Please contact the administrator" => "We were unable to create a new user with your Facebook account. Please contact the administrator",
// "We were unable to connect to your LinkedIn account. Please contact the administrator" => "We were unable to connect to your LinkedIn account. Please contact the administrator",
// "We were unable to log you in using your LinkedIn account. Please contact the administrator" => "We were unable to log you in using your LinkedIn account. Please contact the administrator",
// "You need to link your local account to LinkedIn before you can login using it" => "You need to link your local account to LinkedIn before you can login using it",
"pvs" => "pvs",
// "Days with the most pageviews" => "Days with the most pageviews",
// "Day with the most pageviews" => "Day with the most pageviews",
// "Days with the fewest pageviews" => "Days with the fewest pageviews",
// "Day with the fewest pageviews" => "Day with the fewest pageviews",
// "No pageviews yet" => "No pageviews yet",
// "Use this tree to copy the structure" => "Use this tree to copy the structure",
// "system" => "system",
// "created from structure" => "created from structure",
// "%d choice(s) must be made for the question" => "%d choice(s) must be made for the question",
// "At least %d choice(s) must be made for the question" => "At least %d choice(s) must be made for the question",
// "Fewer than %d choice(s) must be made for the question" => "Fewer than %d choice(s) must be made for the question",
"One choice" => "單一選擇",
"Multiple choices" => "多重選擇",
// "Thumbnails" => "Thumbnails",
"Short text" => "簡短文字",
// "Wiki textarea" => "Wiki textarea",
"Rate (1 to 5)" => "評比 (1..5)",
"Rate (1 to 10)" => "評比 (1..10)",
"Heading" => "標題",
// "Icon not found: %0" => "Icon not found: %0",
// "Icon set: Class not defined for icon %0" => "Icon set: Class not defined for icon %0",
// "Custom theme by specifying URL" => "Custom theme by specifying URL",
// "Required features: <b>%0</b>. If you do not have permission to activate these features, ask the site administrator" => "Required features: <b>%0</b>. If you do not have permission to activate these features, ask the site administrator",
// "CSRF check not performed" => "CSRF check not performed",
// "Required headers are missing" => "Required headers are missing",
// "Requesting site could not be identified because %0 and %1 were empty" => "Requesting site could not be identified because %0 and %1 were empty",
// "Request needs to originate from this site" => "Request needs to originate from this site",
// "The %0 host (%1) does not match this server (%2)" => "The %0 host (%1) does not match this server (%2)",
// "Ticket has expired. Reload the page" => "Ticket has expired. Reload the page",
// "Ticket matches but is expired" => "Ticket matches but is expired",
// "Reloading the page may help" => "Reloading the page may help",
// "Ticket does not match or is missing" => "Ticket does not match or is missing",
// "Potential cross-site request forgery (CSRF) detected. Operation blocked" => "Potential cross-site request forgery (CSRF) detected. Operation blocked",
// "Request to %0 failed CSRF check" => "Request to %0 failed CSRF check",
// "Confirm action" => "Confirm action",
// "Please confirm action" => "Please confirm action",
// "unknown error" => "unknown error",
"You are not logged in" => "你尚未登入",
"You do not have permission to view this section" => "權限不足, 你無法觀看這個區段",
// "For the security of your password, direct access to the feed is only available via HTTPS" => "For the security of your password, direct access to the feed is only available via HTTPS",
// "Help link" => "Help link",
"You are banned from" => "你被禁止使用",
"wiki" => "wiki",
// "img-g" => "img-g",
// "file-g" => "file-g",
"quizzes" => "測驗",
// "arts" => "arts",
"blogs" => "blogs",
"forums" => "論壇",
// "Tiki links converted to relative links" => "Tiki links converted to relative links",
// "TikiLib::create_page: Cannot create page \"%0\", it already exists.)" => "TikiLib::create_page: Cannot create page \"%0\", it already exists.)",
// "The file was successfully uploaded" => "The file was successfully uploaded",
// "The file was only partially uploaded" => "The file was only partially uploaded",
// "No file was uploaded. Was a file selected " => "No file was uploaded. Was a file selected ",
// "A temporary folder is missing" => "A temporary folder is missing",
// "Alias <b>%0</b> link already present in %1 page(s)" => "Alias <b>%0</b> link already present in %1 page(s)",
// "%d points" => "%d points",
// "Removed" => "Removed",
// "Plugin %0 pending approval" => "Plugin %0 pending approval",
// "Possible cross-site request forgery (CSRF, or \"sea surfing\") detected. Operation blocked" => "Possible cross-site request forgery (CSRF, or \"sea surfing\") detected. Operation blocked",
// "Bold" => "Bold",
// "img/icons/text_bold.png" => "img/icons/text_bold.png",
// "Italic" => "Italic",
// "img/icons/text_italic.png" => "img/icons/text_italic.png",
// "Underline" => "Underline",
// "img/icons/text_underline.png" => "img/icons/text_underline.png",
// "Strikethrough" => "Strikethrough",
// "img/icons/text_strikethrough.png" => "img/icons/text_strikethrough.png",
"Code" => "碼",
// "img/icons/page_white_code.png" => "img/icons/page_white_code.png",
// "Non-parsed (wiki syntax does not apply)" => "Non-parsed (wiki syntax does not apply)",
// "img/icons/noparse.png" => "img/icons/noparse.png",
// "Align Center" => "Align Center",
// "Horizontal Bar" => "Horizontal Bar",
// "Page Break" => "Page Break",
// "Box" => "Box",
"Title bar" => "標題列",
// "Bullet List" => "Bullet List",
// "Numbered List" => "Numbered List",
// "Special Characters" => "Special Characters",
// "Foreground color" => "Foreground color",
// "Background Color" => "Background Color",
// "Wiki Link" => "Wiki Link",
// "img/icons/page_link.png" => "img/icons/page_link.png",
// "Object Link" => "Object Link",
// "External Link" => "External Link",
// "img/icons/world_link.png" => "img/icons/world_link.png",
// "img/icons/table.png" => "img/icons/table.png",
// "Table Builder" => "Table Builder",
// "img/icons/find.png" => "img/icons/find.png",
// "Find Text" => "Find Text",
// "img/icons/text_replace.png" => "img/icons/text_replace.png",
// "Text Replace" => "Text Replace",
// "Full-screen edit" => "Full-screen edit",
"Wiki Help" => "wiki 說明",
// "Choose or upload images" => "Choose or upload images",
// "img/icons/pictures.png" => "img/icons/pictures.png",
// "Choose or upload files" => "Choose or upload files",
// "Switch Editor (wiki or WYSIWYG)" => "Switch Editor (wiki or WYSIWYG)",
// "img/icons/pencil_go.png" => "img/icons/pencil_go.png",
// "Admin Toolbars" => "Admin Toolbars",
// "img/icons/wrench.png" => "img/icons/wrench.png",
// "Save Sheet" => "Save Sheet",
// "Add row after selection or to the end if no selection" => "Add row after selection or to the end if no selection",
// "img/icons/sheet_row_add.png" => "img/icons/sheet_row_add.png",
// "Add multiple rows after selection or to the end if no selection" => "Add multiple rows after selection or to the end if no selection",
// "img/icons/sheet_row_add_multi.png" => "img/icons/sheet_row_add_multi.png",
// "Add row before selection or to end if no selection" => "Add row before selection or to end if no selection",
// "Delete selected row" => "Delete selected row",
// "img/icons/sheet_row_delete.png" => "img/icons/sheet_row_delete.png",
// "Add column after selection or to the end if no selection" => "Add column after selection or to the end if no selection",
// "img/icons/sheet_col_add.png" => "img/icons/sheet_col_add.png",
// "Delete selected column" => "Delete selected column",
// "img/icons/sheet_col_delete.png" => "img/icons/sheet_col_delete.png",
// "Add multiple columns after selection or to the end if no selection" => "Add multiple columns after selection or to the end if no selection",
// "img/icons/sheet_col_add_multi.png" => "img/icons/sheet_col_add_multi.png",
// "Add column before selection or to the end if no selection" => "Add column before selection or to the end if no selection",
// "Get Cell Range" => "Get Cell Range",
// "img/icons/sheet_get_range.png" => "img/icons/sheet_get_range.png",
"Find" => "尋找",
// "Refresh calculations" => "Refresh calculations",
// "Finish editing" => "Finish editing",
// "Reset Colors" => "Reset Colors",
// "Reset" => "Reset",
// "Show this text" => "Show this text",
// "Link to this page" => "Link to this page",
// "Anchor" => "Anchor",
// "Semantic relation" => "Semantic relation",
"Cancel" => "取消",
// "Insert" => "Insert",
// "Types of object" => "Types of object",
// "Link to this object" => "Link to this object",
// "link to this URL" => "link to this URL",
// "No cache" => "No cache",
// "Case Insensitivity" => "Case Insensitivity",
// "Note: Uses regular expressions" => "Note: Uses regular expressions",
"Close" => "關閉",
// "Replace" => "Replace",
// "Replace All" => "Replace All",
// "Flat" => "Flat",
// "Tabs" => "Tabs",
// "No template available for %0 - %1" => "No template available for %0 - %1",
// "Tracker %0 not found for Field %1" => "Tracker %0 not found for Field %1",
// "*** ERROR: Tracker ID not set ***" => "*** ERROR: Tracker ID not set ***",
// "*** ERROR: Field ID not set ***" => "*** ERROR: Field ID not set ***",
// "*** ERROR: Tracker %0 not found ***" => "*** ERROR: Tracker %0 not found ***",
// "TrackerLib::get_all_items: No item for itemId %0" => "TrackerLib::get_all_items: No item for itemId %0",
// "Tracker list_items ran out of memory after %0 items" => "Tracker list_items ran out of memory after %0 items",
// "No fields found in header, not a comma-separated values file" => "No fields found in header, not a comma-separated values file",
// "Problem inserting tracker item: trackerId=%0, created=%1, lastModif=%2, status=%3" => "Problem inserting tracker item: trackerId=%0, created=%1, lastModif=%2, status=%3",
// "Problem converting tracker item link field: trackerId=%0, fieldId=%1, itemId=%2" => "Problem converting tracker item link field: trackerId=%0, fieldId=%1, itemId=%2",
// "Problem converting tracker relation field: trackerId=%0, fieldId=%1, itemId=%2 from value \"%3\"" => "Problem converting tracker relation field: trackerId=%0, fieldId=%1, itemId=%2 from value \"%3\"",
// "Field is not numeric" => "Field is not numeric",
// "Function" => "Function",
// "Pending" => "Pending",
// "Tracker field setup error - display field not found: " => "Tracker field setup error - display field not found: ",
// "Item Creation" => "Item Creation",
// "Item Modification" => "Item Modification",
"Item" => "項目",
"Subject" => "主題",
// "Tracker was modified at %0 by %1" => "Tracker was modified at %0 by %1",
// "View the tracker item at" => "View the tracker item at",
// "Missing wiki email template page \"%0\"" => "Missing wiki email template page \"%0\"",
// "Tracker field not enabled: fieldId=%0 type=%1" => "Tracker field not enabled: fieldId=%0 type=%1",
// "Field not specified" => "Field not specified",
// "No extra information for that attached file. " => "No extra information for that attached file. ",
// "There is no passwords that fit your criteria. You will need a more extensive word list to generate a password list" => "There is no passwords that fit your criteria. You will need a more extensive word list to generate a password list",
// "Could not create /storage/pass_blacklists directory" => "Could not create /storage/pass_blacklists directory",
// "Existing password blacklist file was overwritten" => "Existing password blacklist file was overwritten",
// "Existing password blacklist file could not be overwritten" => "Existing password blacklist file could not be overwritten",
// "File Error. Password file not created" => "File Error. Password file not created",
// "File Error. Password file generation interrupted" => "File Error. Password file generation interrupted",
// "Password blacklist file generated" => "Password blacklist file generated",
// "Unable to Populate Blacklist: File dose not exist or is not readable" => "Unable to Populate Blacklist: File dose not exist or is not readable",
// "Critical" => "Critical",
// "Immediate notification by email" => "Immediate notification by email",
"High" => "高",
// "Will be sent to you with the next periodic digest" => "Will be sent to you with the next periodic digest",
"Low" => "低",
// "Included in your personalized recent changes feed" => "Included in your personalized recent changes feed",
// "Anywhere" => "Anywhere",
// "translations of %0" => "translations of %0",
// "%0 in %1" => "%0 in %1",
// "%0 for %1" => "%0 for %1",
// "Any activity" => "Any activity",
// "Page modified" => "Page modified",
// "Page created" => "Page created",
// "Any forum activity" => "Any forum activity",
// "New topics" => "New topics",
// "Any item activity" => "Any item activity",
// "New items" => "New items",
// "Action Required" => "Action Required",
// "Recommendation Received" => "Recommendation Received",
// "%0 (%1 level up, entire structure)" => "%0 (%1 level up, entire structure)",
// "%0 (%1 level up)" => "%0 (%1 level up)",
// "%0 (current subtree)" => "%0 (current subtree)",
// "%0 Reply Handler" => "%0 Reply Handler",
// "The user [ %0 ] is not registered with this wiki and autocreate is disabled" => "The user [ %0 ] is not registered with this wiki and autocreate is disabled",
// "The user [ %0|%1 ] is not registered with this wiki and the creation process failed" => "The user [ %0|%1 ] is not registered with this wiki and the creation process failed",
// "unverified" => "unverified",
// "Your Information" => "Your Information",
"User Information" => "使用者資訊",
// "Can create/close a book" => "Can create/close a book",
// "Can create/edit/lock accounts" => "Can create/edit/lock accounts",
// "Create a new transaction" => "Create a new transaction",
// "Permission to view the journal" => "Permission to view the journal",
// "Can book into the stack where statements can be changed" => "Can book into the stack where statements can be changed",
// "Can import statements from external accounts" => "Can import statements from external accounts",
// "Can manage templates for recurring transactions" => "Can manage templates for recurring transactions",
// "Can admin the articles" => "Can admin the articles",
// "Can approve submissions" => "Can approve submissions",
// "Can admin article topics" => "Can admin article topics",
// "Can admin article types" => "Can admin article types",
// "Can read article headings" => "Can read article headings",
// "Submitted articles are automatically approved" => "Submitted articles are automatically approved",
// "Can edit articles" => "Can edit articles",
// "Can edit the user (owner) of articles" => "Can edit the user (owner) of articles",
// "Can edit submissions" => "Can edit submissions",
// "Can read articles (applies to article or topic level)" => "Can read articles (applies to article or topic level)",
// "Can remove articles" => "Can remove articles",
// "Can remove submissions" => "Can remove submissions",
// "Can submit articles" => "Can submit articles",
// "Can rate articles" => "Can rate articles",
// "Can view recordings from past meetings" => "Can view recordings from past meetings",
// "Can join a meeting" => "Can join a meeting",
// "Can moderate a meeting" => "Can moderate a meeting",
// "Can create a meeting" => "Can create a meeting",
// "Can use XMPP chat" => "Can use XMPP chat",
// "Can admin blogs" => "Can admin blogs",
// "Can assign perms to blog" => "Can assign perms to blog",
// "Can post to a blog" => "Can post to a blog",
// "Can create a blog" => "Can create a blog",
// "Can read blogs" => "Can read blogs",
// "Can view in module and feed the blog posts" => "Can view in module and feed the blog posts",
// "Can view in module and feed the blog" => "Can view in module and feed the blog",
// "Can create/admin calendars" => "Can create/admin calendars",
// "Can add events in the calendar" => "Can add events in the calendar",
// "Can edit events in the calendar" => "Can edit events in the calendar",
// "Can browse the calendar" => "Can browse the calendar",
// "Can view event details" => "Can view event details",
// "Can add himself or herself to the participants" => "Can add himself or herself to the participants",
// "Can add guest to the participants" => "Can add guest to the participants",
// "Can view Tiki tools calendar" => "Can view Tiki tools calendar",
// "Can admin categories" => "Can admin categories",
// "Can see the category in a listing" => "Can see the category in a listing",
// "Can add objects to the category (tiki_p_modify_object_categories permission required)" => "Can add objects to the category (tiki_p_modify_object_categories permission required)",
// "Can remove objects from the category (tiki_p_modify_object_categories permission required)" => "Can remove objects from the category (tiki_p_modify_object_categories permission required)",
// "Can assign perms to category" => "Can assign perms to category",
// "Administrator can create channels, remove channels, etc" => "Administrator can create channels, remove channels, etc",
// "Can use the chat system" => "Can use the chat system",
// "Can admin received articles" => "Can admin received articles",
// "Can admin received pages" => "Can admin received pages",
// "Can send articles to other sites" => "Can send articles to other sites",
// "Can send articles to this site" => "Can send articles to this site",
// "Can send pages to this site" => "Can send pages to this site",
// "Can send pages to other sites" => "Can send pages to other sites",
// "Can post new comments" => "Can post new comments",
// "Can read comments" => "Can read comments",
// "Can admin comments" => "Can admin comments",
// "Can edit all comments" => "Can edit all comments",
// "Can delete comments" => "Can delete comments",
// "Can vote on comments" => "Can vote on comments",
// "Can admin content templates" => "Can admin content templates",
// "Can edit content templates" => "Can edit content templates",
// "Can lock content templates" => "Can lock content templates",
// "Can use content templates" => "Can use content templates",
// "Can admin contributions" => "Can admin contributions",
// "Can admin the directory" => "Can admin the directory",
// "Can admin directory categories" => "Can admin directory categories",
// "Can admin directory sites" => "Can admin directory sites",
// "Submitted links are valid" => "Submitted links are valid",
// "Can submit sites to the directory" => "Can submit sites to the directory",
// "Can validate submitted links" => "Can validate submitted links",
// "Can use the directory" => "Can use the directory",
// "Can execute arbitrary queries on a given DSN" => "Can execute arbitrary queries on a given DSN",
// "Can admin FAQs" => "Can admin FAQs",
// "Can suggest FAQ questions" => "Can suggest FAQ questions",
// "Can view FAQs" => "Can view FAQs",
// "Can download files" => "Can download files",
// "Can upload files" => "Can upload files",
// "Can list file galleries" => "Can list file galleries",
// "Can view file galleries" => "Can view file galleries",
// "Can admin file galleries" => "Can admin file galleries",
// "Can assign permissions to file galleries" => "Can assign permissions to file galleries",
// "Can use Directory Batch Load" => "Can use Directory Batch Load",
// "Can upload .zip file packages" => "Can upload .zip file packages",
// "Can create file galleries" => "Can create file galleries",
// "Can edit a gallery file" => "Can edit a gallery file",
// "Can remove files" => "Can remove files",
// "Can view file galleries explorer" => "Can view file galleries explorer",
// "Can view file galleries path" => "Can view file galleries path",
// "Can upload files containing JavaScript" => "Can upload files containing JavaScript",
// "Can upload SVG files" => "Can upload SVG files",
// "Can admin forums" => "Can admin forums",
// "Can attach files to forum posts" => "Can attach files to forum posts",
// "Auto approve forum posts" => "Auto approve forum posts",
// "Can post in forums" => "Can post in forums",
// "Can start threads in forums" => "Can start threads in forums",
// "Can read forums" => "Can read forums",
// "Can report posts to moderator" => "Can report posts to moderator",
// "Can vote on comments in forums" => "Can vote on comments in forums",
// "Can browse tags" => "Can browse tags",
// "Can admin tags" => "Can admin tags",
// "Can tag objects" => "Can tag objects",
// "Can unassign tags from an object" => "Can unassign tags from an object",
// "Can subscribe to groups" => "Can subscribe to groups",
// "Can invite user to my groups" => "Can invite user to my groups",
// "Can view the group" => "Can view the group",
// "Can view the group members" => "Can view the group members",
// "Can add group members" => "Can add group members",
// "Can remove group members" => "Can remove group members",
// "Can join or leave the group" => "Can join or leave the group",
// "Can view H5P content" => "Can view H5P content",
// "Can edit H5P content" => "Can edit H5P content",
// "Can administer H5P content" => "Can administer H5P content",
// "Can edit HTML pages" => "Can edit HTML pages",
// "Can view HTML pages" => "Can view HTML pages",
// "Can admin Image Galleries" => "Can admin Image Galleries",
// "Can assign permissions to image galleries" => "Can assign permissions to image galleries",
// "Can upload .zip files of images" => "Can upload .zip files of images",
// "Can create image galleries" => "Can create image galleries",
// "Can list image galleries" => "Can list image galleries",
// "Can upload images" => "Can upload images",
// "Can view image galleries" => "Can view image galleries",
// "Can admin Kaltura video feature" => "Can admin Kaltura video feature",
// "Can upload video or record from webcam" => "Can upload video or record from webcam",
// "Can edit media information" => "Can edit media information",
// "Can delete media" => "Can delete media",
// "Can download media" => "Can download media",
// "Can list media" => "Can list media",
// "Can view media" => "Can view media",
// "Can broadcast messages to all users" => "Can broadcast messages to all users",
// "Can broadcast messages to groups" => "Can broadcast messages to groups",
// "Can use the messaging system" => "Can use the messaging system",
// "Can admin newsletters" => "Can admin newsletters",
// "Can subscribe multiple email addresses at once (requires tiki_p_subscribe email)" => "Can subscribe multiple email addresses at once (requires tiki_p_subscribe email)",
// "Can send newsletters" => "Can send newsletters",
// "Can subscribe any email address to newsletters" => "Can subscribe any email address to newsletters",
// "Can subscribe to newsletters" => "Can subscribe to newsletters",
// "Can view the archive of a newsletters" => "Can view the archive of a newsletters",
// "Can list newsletters" => "Can list newsletters",
// "Can administer payments" => "Can administer payments",
// "Can view payment requests and details" => "Can view payment requests and details",
// "Can enter manual payments" => "Can enter manual payments",
// "Can request a payment" => "Can request a payment",
// "Can view the perspective" => "Can view the perspective",
// "Can edit the perspective" => "Can edit the perspective",
// "Can create a perspective" => "Can create a perspective",
// "Can admin perspectives" => "Can admin perspectives",
// "Can admin polls" => "Can admin polls",
// "Can view poll results" => "Can view poll results",
// "Can view poll user choices" => "Can view poll user choices",
// "Can vote in polls" => "Can vote in polls",
// "Can view poll voters" => "Can view poll voters",
// "Can admin quizzes" => "Can admin quizzes",
// "Can take quizzes" => "Can take quizzes",
// "Can view quiz stats" => "Can view quiz stats",
// "Can view user quiz results" => "Can view user quiz results",
// "Can admin spreadsheets" => "Can admin spreadsheets",
// "Can create and edit spreadsheets" => "Can create and edit spreadsheets",
// "Can view spreadsheets" => "Can view spreadsheets",
// "Can view spreadsheets history" => "Can view spreadsheets history",
// "Can admin the shoutbox (edit/remove messages)" => "Can admin the shoutbox (edit/remove messages)",
// "Can post messages in the shoutbox" => "Can post messages in the shoutbox",
// "Can view the shoutbox" => "Can view the shoutbox",
// "Can use social network integration" => "Can use social network integration",
// "Can register this site with social networks" => "Can register this site with social networks",
// "Admin live support system" => "Admin live support system",
// "Can use live support system" => "Can use live support system",
// "Can admin surveys" => "Can admin surveys",
// "Can take surveys" => "Can take surveys",
// "Can view survey stats" => "Can view survey stats",
// "Can admin TikiTests" => "Can admin TikiTests",
// "Can edit TikiTests" => "Can edit TikiTests",
// "Can replay TikiTests" => "Can replay TikiTests",
// "Can admin trackers" => "Can admin trackers",
// "Can attach files to tracker items" => "Can attach files to tracker items",
// "Can view tracker item attachments and download them" => "Can view tracker item attachments and download them",
// "Can post tracker item comments" => "Can post tracker item comments",
// "Can view tracker item comments" => "Can view tracker item comments",
// "Can create new tracker items" => "Can create new tracker items",
// "Can list trackers" => "Can list trackers",
// "Can change tracker items" => "Can change tracker items",
// "Can change pending tracker items" => "Can change pending tracker items",
// "Can change closed tracker items" => "Can change closed tracker items",
// "Can remove tracker items" => "Can remove tracker items",
// "Can remove pending tracker items" => "Can remove pending tracker items",
// "Can remove closed tracker items" => "Can remove closed tracker items",
// "Can view rating result for tracker items" => "Can view rating result for tracker items",
// "Can rate tracker items" => "Can rate tracker items",
// "Can re-rate tracker items" => "Can re-rate tracker items",
// "Can view trackers" => "Can view trackers",
// "Can view closed trackers items" => "Can view closed trackers items",
// "Can view pending trackers items" => "Can view pending trackers items",
// "Can watch a tracker" => "Can watch a tracker",
// "Can export tracker items" => "Can export tracker items",
// "Can save a CSV backup of all trackers" => "Can save a CSV backup of all trackers",
// "Manage tracker views" => "Manage tracker views",
// "View list view of tracker tabular data. Tracker item permissions apply" => "View list view of tracker tabular data. Tracker item permissions apply",
// "Export a tracker tabular view to CSV. Tracker permissions may not apply" => "Export a tracker tabular view to CSV. Tracker permissions may not apply",
// "Import a CSV file into a tabular tracker. Tracker permissions may not apply" => "Import a CSV file into a tabular tracker. Tracker permissions may not apply",
// "Can trigger the transition between two states" => "Can trigger the transition between two states",
// "Can admin users" => "Can admin users",
// "Can cache user bookmarks" => "Can cache user bookmarks",
// "Can configure modules" => "Can configure modules",
// "Can create user bookmarks" => "Can create user bookmarks",
// "Can use the mini event calendar" => "Can use the mini event calendar",
// "Can use the notepad" => "Can use the notepad",
// "Can admin public tasks" => "Can admin public tasks",
// "Can use tasks" => "Can use tasks",
// "Can receive tasks from other users" => "Can receive tasks from other users",
// "Can send tasks to other users" => "Can send tasks to other users",
// "Can upload personal files" => "Can upload personal files",
// "Can create items in personal menu" => "Can create items in personal menu",
// "Can list registered users" => "Can list registered users",
// "Can invite users by email, and include them in groups" => "Can invite users by email, and include them in groups",
// "Can delete his/her own account" => "Can delete his/her own account",
// "Can use webmail" => "Can use webmail",
// "Can use group webmail" => "Can use group webmail",
// "Can admin group webmail accounts" => "Can admin group webmail accounts",
// "Can use personal webmail accounts" => "Can use personal webmail accounts",
// "Can admin personal webmail accounts" => "Can admin personal webmail accounts",
// "Can view page/pages" => "Can view page/pages",
// "Can edit pages" => "Can edit pages",
// "Can inline-edit pages" => "Can inline-edit pages",
// "Can view wiki history" => "Can view wiki history",
// "Can admin the wiki" => "Can admin the wiki",
// "Can assign permissions to wiki pages" => "Can assign permissions to wiki pages",
// "Can edit copyright notices" => "Can edit copyright notices",
// "Can edit dynamic variables" => "Can edit dynamic variables",
// "Can export wiki pages using the export feature" => "Can export wiki pages using the export feature",
// "Can lock pages" => "Can lock pages",
// "Can save as a minor edit" => "Can save as a minor edit",
// "Can remove" => "Can remove",
// "Can rename pages" => "Can rename pages",
// "Can roll back pages" => "Can roll back pages",
// "Can upload pictures to wiki pages" => "Can upload pictures to wiki pages",
// "Can use the page as a template for a tracker or unified search" => "Can use the page as a template for a tracker or unified search",
// "Can view in module and feed the wiki pages reference" => "Can view in module and feed the wiki pages reference",
// "Can admin attachments on wiki pages" => "Can admin attachments on wiki pages",
// "Can add and change ratings on wiki pages" => "Can add and change ratings on wiki pages",
// "Can attach files to wiki pages" => "Can attach files to wiki pages",
// "Can view and download wiki page attachments" => "Can view and download wiki page attachments",
// "Can view wiki comments" => "Can view wiki comments",
// "Can view rating of wiki pages" => "Can view rating of wiki pages",
// "Can view source of wiki pages" => "Can view source of wiki pages",
// "Can participate in rating of wiki pages" => "Can participate in rating of wiki pages",
// "Can view similar wiki pages" => "Can view similar wiki pages",
// "View page backlinks" => "View page backlinks",
// "Can view unapproved revisions of pages" => "Can view unapproved revisions of pages",
// "Can approve revisions of pages" => "Can approve revisions of pages",
// "Can view contributions to a page" => "Can view contributions to a page",
// "Can use reference library items" => "Can use reference library items",
// "Can add to, edit and remove reference library items" => "Can add to, edit and remove reference library items",
// "Can administer structures" => "Can administer structures",
// "Can create and edit structures" => "Can create and edit structures",
// "Can lock structures" => "Can lock structures",
// "Can watch structures" => "Can watch structures",
// "Administrator can manage users, groups and permissions and all features" => "Administrator can manage users, groups and permissions and all features",
// "Can access site when closed" => "Can access site when closed",
// "Administrator can admin banners" => "Administrator can admin banners",
// "Can ban users or IP addresses" => "Can ban users or IP addresses",
// "Can admin the dynamic content system" => "Can admin the dynamic content system",
// "Can admin integrator repositories and rules" => "Can admin integrator repositories and rules",
// "Can send email to a mail-in accounts, and have the email integrated. Only applies when the mail-in setting \"anonymous\" = n" => "Can send email to a mail-in accounts, and have the email integrated. Only applies when the mail-in setting \"anonymous\" = n",
// "Can admin mail-in accounts" => "Can admin mail-in accounts",
// "Can edit object permissions" => "Can edit object permissions",
// "Can admin external feeds" => "Can admin external feeds",
// "Can clean cache" => "Can clean cache",
// "Can create a new CSS file (style sheet) appended with -user" => "Can create a new CSS file (style sheet) appended with -user",
// "Can remove the association between two pages in a translation set" => "Can remove the association between two pages in a translation set",
// "Can admin cookies" => "Can admin cookies",
// "Can edit translations and create new languages" => "Can edit translations and create new languages",
// "Can edit menus" => "Can edit menus",
// "Can edit menu options" => "Can edit menu options",
// "Can edit site templates" => "Can edit site templates",
// "Can search" => "Can search",
// "Can report a link to the webmaster" => "Can report a link to the webmaster",
// "Can send a link to a friend" => "Can send a link to a friend",
// "Can share a page (email, Twitter, Facebook, message, forums)" => "Can share a page (email, Twitter, Facebook, message, forums)",
// "Can use HTML in pages" => "Can use HTML in pages",
// "Can view action log" => "Can view action log",
// "Can view the action log for users of his or her groups" => "Can view the action log for users of his or her groups",
// "Can view integrated repositories" => "Can view integrated repositories",
// "Can view results from user ratings" => "Can view results from user ratings",
// "Can view referrer stats" => "Can view referrer stats",
// "Can view site stats" => "Can view site stats",
// "Can view site templates" => "Can view site templates",
// "Can view results from webservice requests" => "Can view results from webservice requests",
// "Can administer webservices" => "Can administer webservices",
// "Can admin toolbars" => "Can admin toolbars",
// "Trust all user inputs including plugins (no security checks)" => "Trust all user inputs including plugins (no security checks)",
// "Can view unapproved plugin details" => "Can view unapproved plugin details",
// "Can execute unapproved plugin registered" => "Can execute unapproved plugin registered",
// "Can approve plugin execution" => "Can approve plugin execution",
// "Can admin mail notifications" => "Can admin mail notifications",
// "Can use the importer" => "Can use the importer",
// "Can change the categories of an object" => "Can change the categories of an object",
// "User can administer modules" => "User can administer modules",
// "Can switch between wiki and WYSIWYG modes while editing" => "Can switch between wiki and WYSIWYG modes while editing",
// "Can create a new workspace for a given template" => "Can create a new workspace for a given template",
// "Can manage all aspects of a goal" => "Can manage all aspects of a goal",
// "Can manage who is eligible for a goal" => "Can manage who is eligible for a goal",
// "Cannot add user %0 to nonexistent group %1" => "Cannot add user %0 to nonexistent group %1",
// "Cannot add nonexistent user %0 to group %1" => "Cannot add nonexistent user %0 to group %1",
// "User \"%0\" is banned from the group \"%1\"" => "User \"%0\" is banned from the group \"%1\"",
// "Do you want to unban them and continue" => "Do you want to unban them and continue",
// "Email cannot be set because this email is already in use by another user" => "Email cannot be set because this email is already in use by another user",
// "Password should be at least %0 characters long" => "Password should be at least %0 characters long",
// "Password must contain at least one lowercase alphabetical character like \"a\" and one uppercase character like \"A\"" => "Password must contain at least one lowercase alphabetical character like \"a\" and one uppercase character like \"A\"",
"Password must contain both letters and numbers" => "密碼必須含有字母及數字",
// "Password must contain at least one special character in lower case like \" / \$ % ? & * ( ) _ + .." => "Password must contain at least one special character in lower case like \" / \$ % ? & * ( ) _ + ..",
// "The password is blacklisted because it is too common" => "The password is blacklisted because it is too common",
// "No user tracker found with id #%0" => "No user tracker found with id #%0",
// "The administrator has not yet validated your account. Please wait" => "The administrator has not yet validated your account. Please wait",
// "You must validate your account first. An email has been sent to you" => "You must validate your account first. An email has been sent to you",
// "Email address is required" => "Email address is required",
// "Invalid email address \"%0\"" => "Invalid email address \"%0\"",
// "Unable to send mail to invite \"%0\"" => "Unable to send mail to invite \"%0\"",
// "The email could not be retrieved from the IdP and is required" => "The email could not be retrieved from the IdP and is required",
// "The username could not be retrieved from the IdP and is required" => "The username could not be retrieved from the IdP and is required",
// "SAML Login failed. User not authenticated" => "SAML Login failed. User not authenticated",
// "Can edit one's own forum posts" => "Can edit one's own forum posts",
// "The registration mail can't be sent. Contact the administrator" => "The registration mail can't be sent. Contact the administrator",
// "The registration mail can't be sent because there is no server email address set, and this feature is disabled" => "The registration mail can't be sent because there is no server email address set, and this feature is disabled",
// "The user email confirmation can't be sent. Contact the administrator" => "The user email confirmation can't be sent. Contact the administrator",
// "Edit field: (Parameter needs to be 'trackerId=XX&fieldId=YY&itemId=ZZ' or be empty to use the current field)" => "Edit field: (Parameter needs to be 'trackerId=XX&fieldId=YY&itemId=ZZ' or be empty to use the current field)",
// "Edit field: (Incorrect validation parameter)" => "Edit field: (Incorrect validation parameter)",
"Page already exists" => "頁面已存在",
// "Page does not exist" => "Page does not exist",
// "Email already in use" => "Email already in use",
// "Invalid email" => "Invalid email",
// "Invalid character combination for username" => "Invalid character combination for username",
// "Username must be all lower case" => "Username must be all lower case",
// "Personal Phone" => "Personal Phone",
// "Personal Mobile" => "Personal Mobile",
// "Personal Fax" => "Personal Fax",
// "Work Phone" => "Work Phone",
// "Work Mobile" => "Work Mobile",
// "Work Fax" => "Work Fax",
// "Company" => "Company",
// "Organization" => "Organization",
// "Department" => "Department",
// "Division" => "Division",
// "Job Title" => "Job Title",
// "Street Address" => "Street Address",
// "City" => "City",
// "State" => "State",
// "Postal Code" => "Postal Code",
// "Mail to: User not found" => "Mail to: User not found",
"(AT)" => "(AT)",
"(DOT)" => "(DOT)",
// "Webservice error on %0 request \"%1\"" => "Webservice error on %0 request \"%1\"",
// "You will need to rebuild the search index to see these changes" => "You will need to rebuild the search index to see these changes",
// "Parse To Wiki %0: preg_replace error #%1" => "Parse To Wiki %0: preg_replace error #%1",
// "Cannot create aliased page" => "Cannot create aliased page",
// "You attempted to create the following page" => "You attempted to create the following page",
// "That page is an alias for the following pages" => "That page is an alias for the following pages",
// "If you want to create the page, you must first edit each of the pages above to remove the alias link they may contain. This link should look something like this" => "If you want to create the page, you must first edit each of the pages above to remove the alias link they may contain. This link should look something like this",
// "Can't parse HTML data - no grammar file" => "Can't parse HTML data - no grammar file",
// "Rollback by %0 to version %1" => "Rollback by %0 to version %1",
// "Removed version \$version" => "Removed version \$version",
// "Changed actual version to \$version" => "Changed actual version to \$version",
"No version indicated" => "未指定版本",
// "Plugin " => "Plugin ",
// "failed" => "failed",
// "Required parameters are in</em> <b>bold</b>" => "Required parameters are in</em> <b>bold</b>",
// "Parameter Info" => "Parameter Info",
// "There are no approved versions of this page" => "There are no approved versions of this page",
// "Semantic token already exists" => "Semantic token already exists",
// "Invalid semantic token name" => "Invalid semantic token name",
// "Semantic token not found" => "Semantic token not found",
// "Page locked" => "Page locked",
// "Page unlocked" => "Page unlocked",
// "Initial content copied from version %0 of page %1" => "Initial content copied from version %0 of page %1",
// "You don't have permission to use category '%0'" => "You don't have permission to use category '%0'",
// "You don't have permission to edit categories" => "You don't have permission to edit categories",
// "You don't have permission to edit tags" => "You don't have permission to edit tags",
// "Removed last version" => "Removed last version",
// "Activity Stream" => "Activity Stream",
// "Create a social network activity stream" => "Create a social network activity stream",
// "List configuration information" => "List configuration information",
// "Auto-Scroll" => "Auto-Scroll",
// "Automatically load next page of results when scrolling down" => "Automatically load next page of results when scrolling down",
// "Add Tag" => "Add Tag",
// "Provide an input field for adding a tag to an object" => "Provide an input field for adding a tag to an object",
// "Object type and id, as in %0type:id%1, if unset, will use current object" => "Object type and id, as in %0type:id%1, if unset, will use current object",
// "Add Reference" => "Add Reference",
// "Add a bibliography reference" => "Add a bibliography reference",
// "Biblio Code" => "Biblio Code",
// "The code to be added as reference" => "The code to be added as reference",
// "missing bibliography definition" => "missing bibliography definition",
// "Add Relation" => "Add Relation",
// "Provide a button to toggle a pre-specified relation" => "Provide a button to toggle a pre-specified relation",
// "Qualifier" => "Qualifier",
// "Relation qualifier. Usually a three-part string separated by two periods" => "Relation qualifier. Usually a three-part string separated by two periods",
// "Source Object" => "Source Object",
// "Object identifier as %0type:itemId%1 to start the relation from, will use the current\n\t\t\t\t\tobject if left blank" => "Object identifier as %0type:itemId%1 to start the relation from, will use the current\n\t\t\t\t\tobject if left blank",
// "Target Object" => "Target Object",
// "Object identifier as %0type:itemId%1 to end the relation to, will use the current\n\t\t\t\t\tobject if left blank" => "Object identifier as %0type:itemId%1 to end the relation to, will use the current\n\t\t\t\t\tobject if left blank",
// "Button Text for Add" => "Button Text for Add",
// "Text to show on the button to add relation" => "Text to show on the button to add relation",
// "Button Text for Already Added State" => "Button Text for Already Added State",
// "Text to show on the button when relation is already added" => "Text to show on the button when relation is already added",
// "Relation Added" => "Relation Added",
// "Mouseover Button Text for Remove" => "Mouseover Button Text for Remove",
// "Text to show on the button to remove relation" => "Text to show on the button to remove relation",
// "Remove Relation" => "Remove Relation",
// "Button ID" => "Button ID",
// "A unique ID to distinguish the button from others on the page if there is more than one" => "A unique ID to distinguish the button from others on the page if there is more than one",
// "Set Button Class" => "Set Button Class",
// "Class or classes for the Button" => "Class or classes for the Button",
// "Source and target object cannot be the same" => "Source and target object cannot be the same",
// "Add to cart" => "Add to cart",
// "PluginAddToCart" => "PluginAddToCart",
// "Add a product to the shopping cart" => "Add a product to the shopping cart",
// "Product code" => "Product code",
// "Unique identifier for the product. Two products with the same code will be the same and the information used will be the one of the first in" => "Unique identifier for the product. Two products with the same code will be the same and the information used will be the one of the first in",
// "Label for the product in the cart" => "Label for the product in the cart",
// "Product Type" => "Product Type",
// "The product type that is being sold, which will affect fulfillment, for example, standard product, gift certificate, event ticket" => "The product type that is being sold, which will affect fulfillment, for example, standard product, gift certificate, event ticket",
// "Product Class" => "Product Class",
// "The class the product belongs to. Can be used to limit how gift cards are used" => "The class the product belongs to. Can be used to limit how gift cards are used",
// "Product Bundle" => "Product Bundle",
// "The bundle the product belongs to. Can be used to limit how gift cards are used, will automatically add other products in the same class to the cart" => "The bundle the product belongs to. Can be used to limit how gift cards are used, will automatically add other products in the same class to the cart",
// "Bundle Class" => "Bundle Class",
// "The class the bundle belongs to. Can be used to limit how gift cards are used" => "The class the bundle belongs to. Can be used to limit how gift cards are used",
// "Price" => "Price",
// "The price to charge for the item" => "The price to charge for the item",
// "URL of the product's information. The URL may be relative or absolute (begin\n\t\t\t\t\twith %0http://%1)" => "URL of the product's information. The URL may be relative or absolute (begin\n\t\t\t\t\twith %0http://%1)",
// "Button label" => "Button label",
// "Text for the submit button. default" => "Text for the submit button. default",
// "Associated event code" => "Associated event code",
// "Unique identifier for the event that is associated to the product" => "Unique identifier for the event that is associated to the product",
// "Automatically check out" => "Automatically check out",
// "Automatically check out for purchase and send the user to pay (this is disabled when there is already something in the cart)" => "Automatically check out for purchase and send the user to pay (this is disabled when there is already something in the cart)",
// "Hide Quantity" => "Hide Quantity",
// "Hide the quantity field so you can create buy now button for a single item, quantity = 1 (not available with the exchange feature)" => "Hide the quantity field so you can create buy now button for a single item, quantity = 1 (not available with the exchange feature)",
// "Buy on behalf of" => "Buy on behalf of",
// "Allows the selection of user to make purchase on behalf of" => "Allows the selection of user to make purchase on behalf of",
// "Shop as anonymous always" => "Shop as anonymous always",
// "Add to cart as anonymous shopper even if logged in" => "Add to cart as anonymous shopper even if logged in",
// "Forward to this URL after free purchase" => "Forward to this URL after free purchase",
// "Gift certificate" => "Gift certificate",
// "Allows user to add gift certificate from the product view" => "Allows user to add gift certificate from the product view",
// "Order Item ID to exchange product" => "Order Item ID to exchange product",
// "Used in conjunction with exchange feature" => "Used in conjunction with exchange feature",
// "Product ID to exchange to" => "Product ID to exchange to",
// "Amount of new product to exchange for" => "Amount of new product to exchange for",
// "Should normally be set to the amount of products in the order being exchanged" => "Should normally be set to the amount of products in the order being exchanged",
// "Ajax add to cart feature" => "Ajax add to cart feature",
// "Attempts to turn on Ajax for the cart" => "Attempts to turn on Ajax for the cart",
// "Weight" => "Weight",
// "The weight of the item" => "The weight of the item",
// "The order was recorded and is now awaiting payment. Reference number is %0" => "The order was recorded and is now awaiting payment. Reference number is %0",
// "Your free order of %0 (%1) has been processed. An email has been sent to you for your records" => "Your free order of %0 (%1) has been processed. An email has been sent to you for your records",
// "Your free order of %0 (%1) has been processed" => "Your free order of %0 (%1) has been processed",
// "%0 (%1) was added to your cart" => "%0 (%1) was added to your cart",
// "Add to Google Calendar" => "Add to Google Calendar",
// "Add a calendar item to a Google calendar" => "Add a calendar item to a Google calendar",
// "Calendar item ID" => "Calendar item ID",
// "The item ID of the calendar to add to Google calendar" => "The item ID of the calendar to add to Google calendar",
// "A calendar item ID number" => "A calendar item ID number",
// "Icon Style" => "Icon Style",
// "Choose the icon style" => "Choose the icon style",
// "Either 1, 2 or 3" => "Either 1, 2 or 3",
// "Adjust Inventory" => "Adjust Inventory",
// "PluginAdjustInventory" => "PluginAdjustInventory",
// "Adjust the inventory level of a product" => "Adjust the inventory level of a product",
// "Product ID" => "Product ID",
// "Product ID of item in the cart tracker" => "Product ID of item in the cart tracker",
// "Show Add" => "Show Add",
// "Show option to add to inventory" => "Show option to add to inventory",
// "Show Subtract" => "Show Subtract",
// "Show option to subtract from inventory" => "Show option to subtract from inventory",
// "Inventory was adjusted by %0" => "Inventory was adjusted by %0",
// "User Agent Info" => "User Agent Info",
// "Show the user's browser and server information" => "Show the user's browser and server information",
// "Info" => "Info",
// "Display's the visitor's IP address (IP or default), browser information (BROWSER), or server software (SVRSW)" => "Display's the visitor's IP address (IP or default), browser information (BROWSER), or server software (SVRSW)",
// "IP address" => "IP address",
// "Server software" => "Server software",
// "Browser" => "Browser",
// "Ajax Load" => "Ajax Load",
// "Load data into an HTML div using Ajax or in an iframe" => "Load data into an HTML div using Ajax or in an iframe",
// "JavaScript to run when the data is loaded, the incoming HTML is in a variable called data. You can modify that variable's contents to customise the HTML" => "JavaScript to run when the data is loaded, the incoming HTML is in a variable called data. You can modify that variable's contents to customise the HTML",
// "Address of the data to load, for example, %0tiki-index_raw.php?page=Page+Name%1" => "Address of the data to load, for example, %0tiki-index_raw.php?page=Page+Name%1",
// "Selector" => "Selector",
// "jQuery selector to retrieve part of the page when using Ajax, for example,\n\t\t\t\t\t%0#page-data%1" => "jQuery selector to retrieve part of the page when using Ajax, for example,\n\t\t\t\t\t%0#page-data%1",
// "Target" => "Target",
// "Where to load the Ajax data into (will create own DIV if not supplied. When using\n\t\t\t\t\tiframe if JavaScript is disabled it will appear where the plugin is in the page" => "Where to load the Ajax data into (will create own DIV if not supplied. When using\n\t\t\t\t\tiframe if JavaScript is disabled it will appear where the plugin is in the page",
// "HTML id for the div or iframe" => "HTML id for the div or iframe",
// "Class for the div or iframe" => "Class for the div or iframe",
// "In pixels or percentage. Default value is %0" => "In pixels or percentage. Default value is %0",
// "Make Links Absolute" => "Make Links Absolute",
// "Convert relative links in the incoming data to be absolute. Default value is \"All\"" => "Convert relative links in the incoming data to be absolute. Default value is \"All\"",
// "Images Only" => "Images Only",
// "Links Only" => "Links Only",
// "Parameter URL missing" => "Parameter URL missing",
// "Anchor Link" => "Anchor Link",
// "Create a link to an anchor" => "Create a link to an anchor",
// "Anchor link label" => "Anchor link label",
// "Anchor Name" => "Anchor Name",
// "The anchor name as defined in the Aname plugin" => "The anchor name as defined in the Aname plugin",
// "The name of the wiki page containing the anchor. If empty, the anchor name will be searched for on the wiki page where the plugin is used" => "The name of the wiki page containing the anchor. If empty, the anchor name will be searched for on the wiki page where the plugin is used",
// "Create an anchor that can be linked to" => "Create an anchor that can be linked to",
// "The name of the anchor" => "The name of the anchor",
// "Image Annotation" => "Image Annotation",
// "Annotate an image" => "Annotate an image",
// "Autogenerated content. Leave blank initially" => "Autogenerated content. Leave blank initially",
// "Absolute URL to the image, relative path from Tiki site root or an image from the file gallery %0" => "Absolute URL to the image, relative path from Tiki site root or an image from the file gallery %0",
// "Absolute URL to the image or relative path from Tiki site root" => "Absolute URL to the image or relative path from Tiki site root",
// "Image width in pixels" => "Image width in pixels",
// "Image height in pixels" => "Image height in pixels",
// "Alignment" => "Alignment",
// "Image alignment" => "Image alignment",
"Center" => "置中",
// "CSS Class" => "CSS Class",
// "Class of the containing DIV element" => "Class of the containing DIV element",
// "Show List" => "Show List",
// "Show the list of annotations below the image" => "Show the list of annotations below the image",
// "(y/n)" => "(y/n)",
// "Show Link" => "Show Link",
// "Show the link below the label in the popups" => "Show the link below the label in the popups",
// "Save changes to annotations" => "Save changes to annotations",
// "Image annotations changed" => "Image annotations changed",
// "Editable" => "Editable",
// "Label" => "Label",
// "Application Frame" => "Application Frame",
// "Create a frame in which to assemble custom applications" => "Create a frame in which to assemble custom applications",
// "Application layout" => "Application layout",
// "Minimum height" => "Minimum height",
// "Prevent the frame from becoming any shorter than the specified size" => "Prevent the frame from becoming any shorter than the specified size",
// "Maximum height" => "Maximum height",
// "Prevent the frame from becoming any higher than the specified size" => "Prevent the frame from becoming any higher than the specified size",
// "Hide left column" => "Hide left column",
// "Hide the left column when the application frame is in use to provide more space to the application" => "Hide the left column when the application frame is in use to provide more space to the application",
// "Hide right column" => "Hide right column",
// "Hide the right column when the application frame is in use to provide more space to the application" => "Hide the right column when the application frame is in use to provide more space to the application",
// "Full page" => "Full page",
// "Completely fill the content area of the page" => "Completely fill the content area of the page",
// "Absolute Position" => "Absolute Position",
// "Use all available space for the application frame (by means of CSS absolute positioning)" => "Use all available space for the application frame (by means of CSS absolute positioning)",
// "When using absolute mode, leave some space for the header at the top" => "When using absolute mode, leave some space for the header at the top",
// "Fill the complete page" => "Fill the complete page",
// "Template file not found: %0" => "Template file not found: %0",
// "Pan/Zoom" => "Pan/Zoom",
"Select" => "選擇",
// "Select/Modify" => "Select/Modify",
// "Draw Polygon" => "Draw Polygon",
// "Draw Path" => "Draw Path",
// "Reset Zoom" => "Reset Zoom",
// "Archive Builder" => "Archive Builder",
// "Define an archive that can be downloaded" => "Define an archive that can be downloaded",
// "Description of the archive content. Multiple handlers are available for content types. One per line. Ex: page-as-pdf:some-folder/foo.pdf:HomePage , tracker-attachments:target-folder/:3435" => "Description of the archive content. Multiple handlers are available for content types. One per line. Ex: page-as-pdf:some-folder/foo.pdf:HomePage , tracker-attachments:target-folder/:3435",
// "Archive Name" => "Archive Name",
// "Upon download, the name of the file that will be provided" => "Upon download, the name of the file that will be provided",
// "Missing \".zip\" file name extension" => "Missing \".zip\" file name extension",
// "Incorrect parameter" => "Incorrect parameter",
// "Download archive" => "Download archive",
// "Display a field of an article" => "Display a field of an article",
// "The article field (component) to display. The default field is \"Heading\"" => "The article field (component) to display. The default field is \"Heading\"",
// "Article ID" => "Article ID",
// "The article to display. If no value is provided, the most recent article will be used" => "The article to display. If no value is provided, the most recent article will be used",
// "Article List" => "Article List",
// "Display multiple articles" => "Display multiple articles",
// "Use Pagination" => "Use Pagination",
// "Activate pagination when the articles list is long. Default is %0" => "Activate pagination when the articles list is long. Default is %0",
// "Maximum Displayed" => "Maximum Displayed",
// "The number of articles to display in the list (use %0 to show all)" => "The number of articles to display in the list (use %0 to show all)",
// "Topic Name Filter" => "Topic Name Filter",
// "Filter the list of articles by topic. Example: " => "Filter the list of articles by topic. Example: ",
// "Topic ID Filter" => "Topic ID Filter",
// "Filter the list of articles by topic ID. Example: " => "Filter the list of articles by topic ID. Example: ",
// "Valid topic IDs" => "Valid topic IDs",
// "Type Filter" => "Type Filter",
// "Filter the list of articles by types. Example: " => "Filter the list of articles by types. Example: ",
// "Valid article types" => "Valid article types",
// "Category ID" => "Category ID",
// "List of category IDs, separated by \"%0\". Only articles in all these categories are\n\t\t\t\t\tlisted" => "List of category IDs, separated by \"%0\". Only articles in all these categories are\n\t\t\t\t\tlisted",
// "List only articles in this language" => "List only articles in this language",
// "The column and order of the sort in %0columnName_asc%1 or %0columnName_desc%1 format.\n\t\t\t\t\tDefaults to %0publishDate_desc%1 (other column examples are %0title%1, %0lang%1, %0articleId%1,\n\t\t\t\t\t%0authorName%1 & %0topicName%1). Use \"random\" to have random items" => "The column and order of the sort in %0columnName_asc%1 or %0columnName_desc%1 format.\n\t\t\t\t\tDefaults to %0publishDate_desc%1 (other column examples are %0title%1, %0lang%1, %0articleId%1,\n\t\t\t\t\t%0authorName%1 & %0topicName%1). Use \"random\" to have random items",
// "random or column names to add _asc _desc to: " => "random or column names to add _asc _desc to: ",
// "Specific order" => "Specific order",
// "List of ArticleId that must appear in this order if present" => "List of ArticleId that must appear in this order if present",
// "Only these articles" => "Only these articles",
// "List of article IDs to display, separated by \"%0\"" => "List of article IDs to display, separated by \"%0\"",
// "Not these articles" => "Not these articles",
// "List of article IDs to not display, separated by \"%0\"" => "List of article IDs to not display, separated by \"%0\"",
// "Quiet" => "Quiet",
// "Whether to not report when there are no articles (no reporting by default)" => "Whether to not report when there are no articles (no reporting by default)",
// "Title Only" => "Title Only",
// "Whether to only show the title of the articles (not set to title only by default)" => "Whether to only show the title of the articles (not set to title only by default)",
// "Show Article Body" => "Show Article Body",
// "Whether to show the body of the articles instead of the heading (not set by default)" => "Whether to show the body of the articles instead of the heading (not set by default)",
// "Starting Article" => "Starting Article",
// "The article number that the list should start with (starts with first article by\n\t\t\t\t\tdefault)" => "The article number that the list should start with (starts with first article by\n\t\t\t\t\tdefault)",
// "This will not work if Pagination is used" => "This will not work if Pagination is used",
// "Start Date" => "Start Date",
// "Earliest date to select articles from" => "Earliest date to select articles from",
// " (%0YYYY-MM-DD%1)" => " (%0YYYY-MM-DD%1)",
// "Latest date to select articles from" => "Latest date to select articles from",
// "Period quantity" => "Period quantity",
// "Numeric value to display only last articles published within a user defined\n\t\t\t\t\ttime-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how\n\t\t\t\t\tmany of those units are to be considered to define the time frame. If this parameter is set,\n\t\t\t\t\t\"Start Date\" and \"End Date\" are ignored" => "Numeric value to display only last articles published within a user defined\n\t\t\t\t\ttime-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how\n\t\t\t\t\tmany of those units are to be considered to define the time frame. If this parameter is set,\n\t\t\t\t\t\"Start Date\" and \"End Date\" are ignored",
// "Period unit" => "Period unit",
// "Time unit used with \"Period quantity\"" => "Time unit used with \"Period quantity\"",
// "Override Dates" => "Override Dates",
// "Whether to comply with the article type's \"show before publish\" and \"show after expiration\" settings (not complied with by default)" => "Whether to comply with the article type's \"show before publish\" and \"show after expiration\" settings (not complied with by default)",
// "Containing class" => "Containing class",
// "CSS class to add to the containing \"div.article\" (default: \"%0\")" => "CSS class to add to the containing \"div.article\" (default: \"%0\")",
// "Valid CSS class" => "Valid CSS class",
// "Large First Image" => "Large First Image",
// "If set to %0 (Yes), the first image will be displayed with the dimension used to\n\t\t\t\t\tview of the article" => "If set to %0 (Yes), the first image will be displayed with the dimension used to\n\t\t\t\t\tview of the article",
// "Additional URL parameter for the link to read the article" => "Additional URL parameter for the link to read the article",
// "Show actions (buttons and links)" => "Show actions (buttons and links)",
// "Whether to show the buttons and links to do actions on each article (for the\n\t\t\t\t\tactions you have permission to do" => "Whether to show the buttons and links to do actions on each article (for the\n\t\t\t\t\tactions you have permission to do",
// "No translation" => "No translation",
// "User- or pipe-separated list of two-letter language codes for additional languages\n\t\t\t\t\tto display. List pages with no language or with a missing translation in one of the language" => "User- or pipe-separated list of two-letter language codes for additional languages\n\t\t\t\t\tto display. List pages with no language or with a missing translation in one of the language",
// "Use Source URL" => "Use Source URL",
// "Use the external source URL as link for articles" => "Use the external source URL as link for articles",
// "Display an attachment or a list of them" => "Display an attachment or a list of them",
// "File name of the attached file to link to. Either name, file, id or num can be\n\t\t\t\t\tused to identify a single attachment" => "File name of the attached file to link to. Either name, file, id or num can be\n\t\t\t\t\tused to identify a single attachment",
"File" => "檔案",
// "Same as name" => "Same as name",
// "Name of the wiki page the file is attached to. If left empty when the plugin is\n\t\t\t\t\tused on a wiki page, this defaults to that wiki page" => "Name of the wiki page the file is attached to. If left empty when the plugin is\n\t\t\t\t\tused on a wiki page, this defaults to that wiki page",
// "Show Description" => "Show Description",
// "Shows the description as the link text instead of the file name (not used by default)" => "Shows the description as the link text instead of the file name (not used by default)",
// "Bullets" => "Bullets",
// "Makes the list of attachments a bulleted list (not set by default)" => "Makes the list of attachments a bulleted list (not set by default)",
// "Indicates that this file is an image, and should be displayed inline using the\n\t\t\t\t\t%0 tag (not set by default)" => "Indicates that this file is an image, and should be displayed inline using the\n\t\t\t\t\t%0 tag (not set by default)",
// "Custom Label" => "Custom Label",
// "Makes the text between the %0 tags the link text instead of the file name\n\t\t\t\t\tor description. Only the first attachment will be listed" => "Makes the text between the %0 tags the link text instead of the file name\n\t\t\t\t\tor description. Only the first attachment will be listed",
// "Lists links to all attachments for the entire tiki site together with pages they\n\t\t\t\t\tare attached to when set to %0 (Yes)" => "Lists links to all attachments for the entire tiki site together with pages they\n\t\t\t\t\tare attached to when set to %0 (Yes)",
// "Order Number" => "Order Number",
// "Identifies the attachment to link to by the order of the attachment in the list\n\t\t\t\t\tof attachments to a page instead of by file name or ID. Either name, file, id or num can be used to\n\t\t\t\t\tidentify a single attachment" => "Identifies the attachment to link to by the order of the attachment in the list\n\t\t\t\t\tof attachments to a page instead of by file name or ID. Either name, file, id or num can be used to\n\t\t\t\t\tidentify a single attachment",
// "Identifies the attachment to link to by id number instead of by file name or order\n\t\t\t\t\tnumber. Either name, file, id or num can be used to identify a single attachment" => "Identifies the attachment to link to by id number instead of by file name or order\n\t\t\t\t\tnumber. Either name, file, id or num can be used to identify a single attachment",
// "Attachment name, file, id or num" => "Attachment name, file, id or num",
// "The alt text that pops up on mouseover will include the number of downloads of the\n\t\t\t\t\tattachment at the end when set to %0 (Yes)" => "The alt text that pops up on mouseover will include the number of downloads of the\n\t\t\t\t\tattachment at the end when set to %0 (Yes)",
// "File Type Icon" => "File Type Icon",
// "A file type icon is displayed in front of the attachment link when this is set to\n\t\t\t\t\t%0 (Yes)" => "A file type icon is displayed in front of the attachment link when this is set to\n\t\t\t\t\t%0 (Yes)",
// "Page \"%0\" does not exist" => "Page \"%0\" does not exist",
// "No such attachment on this page" => "No such attachment on this page",
// "Attributes" => "Attributes",
// "Assign generic attributes to the current object" => "Assign generic attributes to the current object",
// "Add popups and color coding that identifies authors" => "Add popups and color coding that identifies authors",
// "Username of the author of the text" => "Username of the author of the text",
// "Deleted by User" => "Deleted by User",
// "Username of the person who deleted the text" => "Username of the person who deleted the text",
// "Make Visible" => "Make Visible",
// "Show popup with author/deleted by" => "Show popup with author/deleted by",
// "Generate a popup with names of author(s) (default: no)" => "Generate a popup with names of author(s) (default: no)",
// "deleted by" => "deleted by",
// "Should this author's contribution be visible (default: no)" => "Should this author's contribution be visible (default: no)",
// "Auto Query Args" => "Auto Query Args",
// "Automatically propagate arguments when clicking on links" => "Automatically propagate arguments when clicking on links",
// "Arguments for auto query" => "Arguments for auto query",
// "Colon-separated list of arguments, the values of which will be propagated through\n\t\t\t\t\tany link created below this plugin" => "Colon-separated list of arguments, the values of which will be propagated through\n\t\t\t\t\tany link created below this plugin",
"Profile picture" => "頭像",
// "Display a user's profile picture" => "Display a user's profile picture",
// "The wiki page the profile picture will link to. If empty and the user's\n\t\t\t\t\tinformation is public, then the profile picture will link automatically the that user's user\n\t\t\t\t\tinformation page" => "The wiki page the profile picture will link to. If empty and the user's\n\t\t\t\t\tinformation is public, then the profile picture will link automatically the that user's user\n\t\t\t\t\tinformation page",
// "Float" => "Float",
// "Align the profile picture on the page" => "Align the profile picture on the page",
// "Full Size" => "Full Size",
// "If full-size images are stored in the file gallery, show the full-size image" => "If full-size images are stored in the file gallery, show the full-size image",
"Back" => "返回",
// "Display a link that goes back one page in the browser history" => "Display a link that goes back one page in the browser history",
// "List all pages that link to a particular page" => "List all pages that link to a particular page",
// "The page links will point to. Default value is the current page" => "The page links will point to. Default value is the current page",
// "Displayed Information" => "Displayed Information",
// "Pipe separated list of fields to display. ex: hits|user" => "Pipe separated list of fields to display. ex: hits|user",
// "Excluded pages" => "Excluded pages",
// "Pipe-separated list of pages to be excluded from the listing, for example:\n\t\t\t\t\t%0HomePage|Sandbox%1" => "Pipe-separated list of pages to be excluded from the listing, for example:\n\t\t\t\t\t%0HomePage|Sandbox%1",
// "Include Self" => "Include Self",
// "With or without self-link (default is without)" => "With or without self-link (default is without)",
// "With or without header (default is with header)" => "With or without header (default is with header)",
// "With header" => "With header",
// "Without header" => "Without header",
// "No pages link to" => "No pages link to",
// "One page links to" => "One page links to",
// "pages link to" => "pages link to",
// "Add a banner" => "Add a banner",
"Zone" => "區域",
// "Name of the zone created in Admin > Banners" => "Name of the zone created in Admin > Banners",
// "Determines the browser behavior when the banner is clicked" => "Determines the browser behavior when the banner is clicked",
// "missing parameter" => "missing parameter",
// "Benchmark" => "Benchmark",
// "Performance-test wiki content (used by developers to optimize plugins)" => "Performance-test wiki content (used by developers to optimize plugins)",
// "Iteration Quantity" => "Iteration Quantity",
// "The number of iterations to process" => "The number of iterations to process",
// "Each Iteration Details" => "Each Iteration Details",
// "Provides time and memory of each iteration" => "Provides time and memory of each iteration",
// "BigBlueButton" => "BigBlueButton",
// "Hold a video/audio/chat/presentation session using the BigBlueButton web conferencing system" => "Hold a video/audio/chat/presentation session using the BigBlueButton web conferencing system",
// "Meeting" => "Meeting",
// "MeetingID for BigBlueButton. This is a 5 digit number, starting with a 7.\n\t\t\t\t\tEx.: %0 or %1" => "MeetingID for BigBlueButton. This is a 5 digit number, starting with a 7.\n\t\t\t\t\tEx.: %0 or %1",
// "Anonymous Prefix" => "Anonymous Prefix",
// "Unregistered users will get this token prepended to their name" => "Unregistered users will get this token prepended to their name",
// "Welcome Message" => "Welcome Message",
// "A message to be provided when someone enters the room" => "A message to be provided when someone enters the room",
// "Dial Number" => "Dial Number",
// "The phone-in support number to join from traditional phones" => "The phone-in support number to join from traditional phones",
// "Voice Bridge" => "Voice Bridge",
// "Code to enter for phone attendees to join the room. Typically, the same 5 digits\n\t\t\t\t\tof the MeetingID" => "Code to enter for phone attendees to join the room. Typically, the same 5 digits\n\t\t\t\t\tof the MeetingID",
// "Log-out URL" => "Log-out URL",
// "URL to which the user will be redirected after logging out of BigBlueButton" => "URL to which the user will be redirected after logging out of BigBlueButton",
// "Record" => "Record",
// "The recording starts when the first person enters the room, and ends when the last\n\t\t\t\t\tperson leaves. After a period of processing (which depends on the length of the meeting), the\n\t\t\t\t\trecording will be added to the list of all recordings for this room. Requires BBB >= 0.8" => "The recording starts when the first person enters the room, and ends when the last\n\t\t\t\t\tperson leaves. After a period of processing (which depends on the length of the meeting), the\n\t\t\t\t\trecording will be added to the list of all recordings for this room. Requires BBB >= 0.8",
// "Display Recordings" => "Display Recordings",
// "Enable or Disable the display of video recordings" => "Enable or Disable the display of video recordings",
// "Display Attendees" => "Display Attendees",
// "Enable or Disable the display of attendees list" => "Enable or Disable the display of attendees list",
// "BigBlueButton is misconfigured or inaccessible" => "BigBlueButton is misconfigured or inaccessible",
// "Blog List" => "Blog List",
// "Display posts from a site blog" => "Display posts from a site blog",
// "Blog ID" => "Blog ID",
// "The ID number of the blog on the site to list posts from. More than one blog can be provided, separated by colon. Example: 1:5. Limitation: if more than one blog is provided, the private posts (drafts) are not shown" => "The ID number of the blog on the site to list posts from. More than one blog can be provided, separated by colon. Example: 1:5. Limitation: if more than one blog is provided, the private posts (drafts) are not shown",
// "Maximum Items" => "Maximum Items",
// "Maximum number of entries to list (no maximum set by default)" => "Maximum number of entries to list (no maximum set by default)",
// "Only display posts created by this user (all posts listed by default)" => "Only display posts created by this user (all posts listed by default)",
// "Simple List" => "Simple List",
// "Show simple list of date, title and author (default) or formatted list of blog\n\t\t\t\t\tposts" => "Show simple list of date, title and author (default) or formatted list of blog\n\t\t\t\t\tposts",
// "Character Count" => "Character Count",
// "Number of characters to display if not a simple list (defaults to all)" => "Number of characters to display if not a simple list (defaults to all)",
// "Word Boundary" => "Word Boundary",
// "If not a simple list and Character Count is non-zero, then marking this as yes will\n\t\t\t\t\tbreak on word boundaries only" => "If not a simple list and Character Count is non-zero, then marking this as yes will\n\t\t\t\t\tbreak on word boundaries only",
// "Ellipsis" => "Ellipsis",
// "If not a simple list and Character Count is non-zero, then marking this as yes will\n\t\t\t\t\tput ellipsis (...) at end of text (default)" => "If not a simple list and Character Count is non-zero, then marking this as yes will\n\t\t\t\t\tput ellipsis (...) at end of text (default)",
// "More" => "More",
// "If not a simple list and Character Count is non-zero, then marking this as yes\n\t\t\t\t\twill put a \"More\" link to the full entry (default)" => "If not a simple list and Character Count is non-zero, then marking this as yes\n\t\t\t\t\twill put a \"More\" link to the full entry (default)",
// "Show Icons" => "Show Icons",
// "If not a simple list, marking this as no will prevent the \"edit\" and \"print\" type\n\t\t\t\t\ticons from displaying (default is to show the icons)" => "If not a simple list, marking this as no will prevent the \"edit\" and \"print\" type\n\t\t\t\t\ticons from displaying (default is to show the icons)",
// "Use Excerpt" => "Use Excerpt",
// "If the blog has \"Use post excerpt\" enabled then use excerpts where available (default)" => "If the blog has \"Use post excerpt\" enabled then use excerpts where available (default)",
// "Earliest date to select posts from" => "Earliest date to select posts from",
// "End Date" => "End Date",
// "Latest date to select posts from" => "Latest date to select posts from",
// "Container Class" => "Container Class",
// "CSS Class to add to the container %0DIV.article%1. (Default=%0wikiplugin_bloglist%1)" => "CSS Class to add to the container %0DIV.article%1. (Default=%0wikiplugin_bloglist%1)",
// "Missing blog ID for Bloglist plugin" => "Missing blog ID for Bloglist plugin",
// "Create a formatted box with a title bar" => "Create a formatted box with a title bar",
// "Box Title" => "Box Title",
// "Displayed above the content" => "Displayed above the content",
// "As defined by CSS, name, or color hex code" => "As defined by CSS, name, or color hex code",
// "Valid CSS color name or code" => "Valid CSS color name or code",
// "Box Width" => "Box Width",
// "Text Alignment" => "Text Alignment",
// "Aligns the text within the box (left-aligned by default)" => "Aligns the text within the box (left-aligned by default)",
// "Float Position" => "Float Position",
// "Set the alignment for the entire box. For elements with a width of less than 100%, other elements\n\t\t\t\t\twill wrap around it unless the %0 parameter is appropriately set.)" => "Set the alignment for the entire box. For elements with a width of less than 100%, other elements\n\t\t\t\t\twill wrap around it unless the %0 parameter is appropriately set.)",
"Clear" => "清除",
// "Text, etc. is not allowed to wrap around the box if this parameter is set to %0 (Yes)" => "Text, etc. is not allowed to wrap around the box if this parameter is set to %0 (Yes)",
// "Apply custom CSS class to the box" => "Apply custom CSS class to the box",
// "CSS Style" => "CSS Style",
// "Enter CSS styling tags for the div type used e.g. padding: 5px" => "Enter CSS styling tags for the div type used e.g. padding: 5px",
// "Button" => "Button",
// "Add a link formatted as a button" => "Add a link formatted as a button",
// "Label for the button (ignored if the text is defined)" => "Label for the button (ignored if the text is defined)",
// "Url" => "Url",
// "URL to be produced by the button. You can use wiki argument variables like\n\t\t\t\t\t%0 in it" => "URL to be produced by the button. You can use wiki argument variables like\n\t\t\t\t\t%0 in it",
// "Label for the button" => "Label for the button",
// "Icon Name" => "Icon Name",
// "Enter an iconset name to show an icon in the button" => "Enter an iconset name to show an icon in the button",
// "Button Type" => "Button Type",
// "Use a type to style the button. By default btn-primary will be applied" => "Use a type to style the button. By default btn-primary will be applied",
// "Danger" => "Danger",
// "Primary" => "Primary",
// "Button width" => "Button width",
// "In pixels or percentage. (e.g. 200px or 100%)" => "In pixels or percentage. (e.g. 200px or 100%)",
// "Button height" => "Button height",
// "CSS class for the button. Note that the btn class is always applied by default" => "CSS class for the button. Note that the btn class is always applied by default",
// "CSS style attributes" => "CSS style attributes",
// "Link Relation" => "Link Relation",
// "Enter %0 for colorbox effect (like shadowbox and lightbox) or appropriate\n\t\t\t\t\tsyntax for link relation" => "Enter %0 for colorbox effect (like shadowbox and lightbox) or appropriate\n\t\t\t\t\tsyntax for link relation",
// "Auto Arguments" => "Auto Arguments",
// "Comma-separated list of URL arguments that will be kept from %0 (like\n\t\t\t\t\t%1) in addition to those you can specify in the href parameter" => "Comma-separated list of URL arguments that will be kept from %0 (like\n\t\t\t\t\t%1) in addition to those you can specify in the href parameter",
// "You can also use %0 to specify that every arguments listed in the\n\t\t\t\t\tglobal var \$auto_query_args has to be kept from URL" => "You can also use %0 to specify that every arguments listed in the\n\t\t\t\t\tglobal var \$auto_query_args has to be kept from URL",
// "Flip Id" => "Flip Id",
// "HTML id attribute of the element to show/hide content" => "HTML id attribute of the element to show/hide content",
// "Flip Hide Text" => "Flip Hide Text",
// "If set to No (%0), will not display a \"(Hide)\" suffix after the button label\n\t\t\t\t\twhen the content is shown" => "If set to No (%0), will not display a \"(Hide)\" suffix after the button label\n\t\t\t\t\twhen the content is shown",
// "Flip Default Open" => "Flip Default Open",
// "If set to %0, the flip is open by default (if no cookie jar)" => "If set to %0, the flip is open by default (if no cookie jar)",
// "Escape Apostrophes" => "Escape Apostrophes",
// "If set to %0, will escape the apostrophes in onclick" => "If set to %0, will escape the apostrophes in onclick",
// "Disable Button" => "Disable Button",
// "Set to %0 to disable the button" => "Set to %0 to disable the button",
// "lib/smarty_tiki/function.button.php is missing or unreadable" => "lib/smarty_tiki/function.button.php is missing or unreadable",
// "Display a calendar and its events" => "Display a calendar and its events",
// "Calendar IDs" => "Calendar IDs",
// "Comma-separated list of calendar Ids to restrict the events to specified calendars" => "Comma-separated list of calendar Ids to restrict the events to specified calendars",
// "Example values" => "Example values",
// "Not set by default" => "Not set by default",
// "View Type" => "View Type",
// "Determines how events" => "Determines how events",
// "%0 (default) shows events in a calendar" => "%0 (default) shows events in a calendar",
// "View Time Span" => "View Time Span",
// "If in calendar (%0) View Type, determines the time span displayed by the\n\t\t\t\t\tcalendar" => "If in calendar (%0) View Type, determines the time span displayed by the\n\t\t\t\t\tcalendar",
// "Default is month" => "Default is month",
// "Navigation Bar" => "Navigation Bar",
// "Show or hide the navigation bar (not shown by default)" => "Show or hide the navigation bar (not shown by default)",
// "Carousel" => "Carousel",
// "Display images in a self-advancing carousel" => "Display images in a self-advancing carousel",
// "Images Source" => "Images Source",
// "Choose where to get your images from" => "Choose where to get your images from",
// "Select an option" => "Select an option",
// "All the images in a file gallery" => "All the images in a file gallery",
// "A list of file IDs" => "A list of file IDs",
// "File Gallery ID" => "File Gallery ID",
// "ID number of the file gallery that contains the images to be displayed" => "ID number of the file gallery that contains the images to be displayed",
// "File IDs" => "File IDs",
// "List of IDs of images from the File Galleries separated by commas" => "List of IDs of images from the File Galleries separated by commas",
// "Sort Mode" => "Sort Mode",
// "Sort by database table field name, ascending or descending. Examples:\n\t\t\t\t\t%0 or %1" => "Sort by database table field name, ascending or descending. Examples:\n\t\t\t\t\t%0 or %1",
// "%0 or %1 with actual database field name in place of\n\t\t\t\t\t%2" => "%0 or %1 with actual database field name in place of\n\t\t\t\t\t%2",
// "Transition Time" => "Transition Time",
// "The time (in milliseconds) for the transition between two images" => "The time (in milliseconds) for the transition between two images",
// "number" => "number",
// "Display Time" => "Display Time",
// "The time (in milliseconds) to display each image" => "The time (in milliseconds) to display each image",
// "Caption Height" => "Caption Height",
// "The height of the caption. This is a fraction of the height of the images" => "The height of the caption. This is a fraction of the height of the images",
// "real between 0 and 1" => "real between 0 and 1",
// "Display Progress Bar" => "Display Progress Bar",
// "Display Thumbnails" => "Display Thumbnails",
// "Display thumbnails, number, count etc" => "Display thumbnails, number, count etc",
// "Buttons" => "Buttons",
// "Numbers" => "Numbers",
// "Thumbnail Box Width" => "Thumbnail Box Width",
// "Width of thumbnail box in CSS units (default %0)" => "Width of thumbnail box in CSS units (default %0)",
// "Thumbnail Box Height" => "Thumbnail Box Height",
// "Height of thumbnail box in CSS units (default %0)" => "Height of thumbnail box in CSS units (default %0)",
// "Start Automatically" => "Start Automatically",
// "Start the carousel automatically when the page loads (default: Yes)" => "Start the carousel automatically when the page loads (default: Yes)",
// "Legacy v2 param" => "Legacy v2 param",
// "Display thumbnails" => "Display thumbnails",
// "Thumbnail Numbers" => "Thumbnail Numbers",
// "Display place numbers in the thumbnail boxes" => "Display place numbers in the thumbnail boxes",
// "Thumbnail Background" => "Thumbnail Background",
// "Use corresponding image as background for a thumbnail box" => "Use corresponding image as background for a thumbnail box",
// "Thumbnail Font Size" => "Thumbnail Font Size",
// "Font size of thumbnail box in CSS units\n\t\t\t\t\t(default %0)" => "Font size of thumbnail box in CSS units\n\t\t\t\t\t(default %0)",
// "CSS units" => "CSS units",
// "Image Size" => "Image Size",
// "Scale image between 0 and 1 to reduce it, or set a maximum size in pixels" => "Scale image between 0 and 1 to reduce it, or set a maximum size in pixels",
// "Real between 0 and 1, or integer over 10" => "Real between 0 and 1, or integer over 10",
// "Makes images clickable" => "Makes images clickable",
// "In case there are URLs in the image description, the image is made clickable and links to the first URL found" => "In case there are URLs in the image description, the image is made clickable and links to the first URL found",
// "Cart Missing User Info" => "Cart Missing User Info",
// "PluginCartMissingUserInfo" => "PluginCartMissingUserInfo",
// "Check completeness of user input for a shopping cart transaction" => "Check completeness of user input for a shopping cart transaction",
// "Information Type" => "Information Type",
// "Post Purchase" => "Post Purchase",
// "Required before purchase" => "Required before purchase",
// "Product Class ID" => "Product Class ID",
// "CasperJS" => "CasperJS",
// "Enable running CasperJS scripts from this Tiki site" => "Enable running CasperJS scripts from this Tiki site",
// "CasperJS not available" => "CasperJS not available",
// "Execute CasperJS script" => "Execute CasperJS script",
// "List categories and objects assigned to them" => "List categories and objects assigned to them",
// "Category IDs" => "Category IDs",
// "List of category IDs separated by \"+\", for example, %0. Default will use category\n\t\t\t\t\tof the current page" => "List of category IDs separated by \"+\", for example, %0. Default will use category\n\t\t\t\t\tof the current page",
// "Types" => "Types",
// "List of object types to include in the list, separated by \"+\", for example, " => "List of object types to include in the list, separated by \"+\", for example, ",
// "Sort ascending or descending based on various attributes (sorted ascending by\n\t\t\t\t\tname by default)" => "Sort ascending or descending based on various attributes (sorted ascending by\n\t\t\t\t\tname by default)",
// "Hits Ascending" => "Hits Ascending",
// "Hits Descending" => "Hits Descending",
// "Item ID Ascending" => "Item ID Ascending",
// "Item ID Descending" => "Item ID Descending",
// "Type Ascending" => "Type Ascending",
// "Type Descending" => "Type Descending",
// "Random" => "Random",
// "Split" => "Split",
// "Whether multiple categories will be listed on different lines (default is to split them)" => "Whether multiple categories will be listed on different lines (default is to split them)",
// "And" => "And",
// "If set to %0 (Yes), only objects in all of the categories will be shown (default\n\t\t\t\t\tis to show objects in any of the categories)" => "If set to %0 (Yes), only objects in all of the categories will be shown (default\n\t\t\t\t\tis to show objects in any of the categories)",
// "Sub-categories" => "Sub-categories",
// "Also list objects in sub-categories of the categories given (default is to list\n\t\t\t\t\tsub-category objects)" => "Also list objects in sub-categories of the categories given (default is to list\n\t\t\t\t\tsub-category objects)",
// "Show descriptions (not shown by default)" => "Show descriptions (not shown by default)",
// "Show object names (shown by default)" => "Show object names (shown by default)",
// "Show type (shown by default)" => "Show type (shown by default)",
// "One Per Line" => "One Per Line",
// "Show one object per line (multiple per line shown by default)" => "Show one object per line (multiple per line shown by default)",
// "Child Links" => "Child Links",
// "Show children category links (shown by default)" => "Show children category links (shown by default)",
// "Top Link" => "Top Link",
// "Show top category link (shown by default)" => "Show top category link (shown by default)",
// "Maximum Records" => "Maximum Records",
// "Maximum number of objects to list (default is %0)" => "Maximum number of objects to list (default is %0)",
// "Show title text above category object lists (shown by default)" => "Show title text above category object lists (shown by default)",
// "List only objects in this language" => "List only objects in this language",
// "Only apply if %0" => "Only apply if %0",
"Categories are disabled" => "類別功能已關閉",
// "PluginCategoryTransition" => "PluginCategoryTransition",
// "Display controls to trigger category transitions for any object" => "Display controls to trigger category transitions for any object",
// "Redirect URL" => "Redirect URL",
// "URL the user is sent to after transition is done" => "URL the user is sent to after transition is done",
// "Category Orphans" => "Category Orphans",
// "List objects that are not categorized" => "List objects that are not categorized",
// "Determine which type of objects are shown (default is %0)" => "Determine which type of objects are shown (default is %0)",
// "Calendars" => "Calendars",
// "Max" => "Max",
// "Maximum number of items. Use %0 for unlimited. Default is the site admin setting\n\t\t\t\t\tfor maximum records" => "Maximum number of items. Use %0 for unlimited. Default is the site admin setting\n\t\t\t\t\tfor maximum records",
// "Result Offset" => "Result Offset",
// "Result number at which the listing should start (default is no offset)" => "Result number at which the listing should start (default is no offset)",
// "Category Path" => "Category Path",
// "Show the full category path for a wiki page" => "Show the full category path for a wiki page",
// "Separator" => "Separator",
// "String used to separate the categories in the path. Default character is %0" => "String used to separate the categories in the path. Default character is %0",
// "Display Top Category" => "Display Top Category",
// "Show the top category as part of the path name (not shown by default)" => "Show the top category as part of the path name (not shown by default)",
// "Access and use a cclite social credit and alternative currency account" => "Access and use a cclite social credit and alternative currency account",
// "Mode of operation - summary or recent. Default: %0" => "Mode of operation - summary or recent. Default: %0",
// "Account summary" => "Account summary",
// "Recent transactions" => "Recent transactions",
// "Registry" => "Registry",
// "Registry to query. Default: site preference (or first in list when more than one)" => "Registry to query. Default: site preference (or first in list when more than one)",
// "You need to be logged in to view this information" => "You need to be logged in to view this information",
// "Center text" => "Center text",
"Chart" => "排行榜",
// "Display a chart from TikiSheet" => "Display a chart from TikiSheet",
// "Chart caption" => "Chart caption",
// "Spreadsheet ID" => "Spreadsheet ID",
// "Data sheet ID" => "Data sheet ID",
// "Chart Type" => "Chart Type",
// "Specify a valid chart type" => "Specify a valid chart type",
// "Chart Width" => "Chart Width",
// "Width in pixels" => "Width in pixels",
// "Chart Height" => "Chart Height",
// "Height in pixels" => "Height in pixels",
// "Value series" => "Value series",
// "Required for pie charts" => "Required for pie charts",
// "Independent series" => "Independent series",
// "Required for types other than pie chart" => "Required for types other than pie chart",
// "Dependent series" => "Dependent series",
// "Description needed" => "Description needed",
// "Colors" => "Colors",
// "List of colors to use" => "List of colors to use",
// "Styles" => "Styles",
// "List of styles to use" => "List of styles to use",
// "Labels for the series or values in the legend" => "Labels for the series or values in the legend",
// "Chart as PDF" => "Chart as PDF",
// "Chart as PostScript" => "Chart as PostScript",
// "Chart JS" => "Chart JS",
// "Create a JS Chart" => "Create a JS Chart",
// "JSON encoded array for data and options" => "JSON encoded array for data and options",
// "Chart Id" => "Chart Id",
// "A custom ID for the chart" => "A custom ID for the chart",
// "The type of chart. Currently works with pie, bar and doughnut" => "The type of chart. Currently works with pie, bar and doughnut",
// "The height of the chart in px" => "The height of the chart in px",
// "The width of the chart in px" => "The width of the chart in px",
// "Chart data values" => "Chart data values",
// "Colon-separated values for the chart (required if not using JSON encoded data in the plugin body)" => "Colon-separated values for the chart (required if not using JSON encoded data in the plugin body)",
// "Chart data labels" => "Chart data labels",
// "Colon-separated labels for the datasets in the chart. Max 10, if left empty" => "Colon-separated labels for the datasets in the chart. Max 10, if left empty",
// "Chart colors" => "Chart colors",
// "Colon-separated colors for the datasets in the chart. Max 10, if left empty" => "Colon-separated colors for the datasets in the chart. Max 10, if left empty",
// "Chart highlight" => "Chart highlight",
// "Colon-separated color of chart section when highlighted" => "Colon-separated color of chart section when highlighted",
// "Uses the non-minified version of the chart.js library for easier debugging" => "Uses the non-minified version of the chart.js library for easier debugging",
// "Values must be set for chart" => "Values must be set for chart",
// "Check Referer" => "Check Referer",
// "Display content based on the address that originated the request for the current page" => "Display content based on the address that originated the request for the current page",
// "Wiki text to display if conditions are met. The body may contain %0. Text after the marker\n\t\t\twill be displayed if conditions are not met" => "Wiki text to display if conditions are met. The body may contain %0. Text after the marker\n\t\t\twill be displayed if conditions are not met",
// "Referer List" => "Referer List",
// "Comma-separated list of domains to check" => "Comma-separated list of domains to check",
// "Display code with syntax highlighting and line numbering" => "Display code with syntax highlighting and line numbering",
// "Code to be displayed" => "Code to be displayed",
// "Caption" => "Caption",
// "Code snippet label" => "Code snippet label",
// "Line Wrapping" => "Line Wrapping",
// "Wrap lines of code which do not fit in the display box's width. Enabling avoids overflow or hidden line ends" => "Wrap lines of code which do not fit in the display box's width. Enabling avoids overflow or hidden line ends",
// "Any supported language listed at http://codemirror.net/mode/" => "Any supported language listed at http://codemirror.net/mode/",
// "Line Numbers" => "Line Numbers",
// "Show line numbers for each line of code" => "Show line numbers for each line of code",
// "Right to Left" => "Right to Left",
// "Switch the text display from left to right, to right to left (left to right by default)" => "Switch the text display from left to right, to right to left (left to right by default)",
// "Code Tag" => "Code Tag",
// "Encloses the code in an HTML code tag, for example: &lt;code&gt;user input&lt;code&gt" => "Encloses the code in an HTML code tag, for example: &lt;code&gt;user input&lt;code&gt",
// "Any supported theme listed at https://codemirror.net/demo/theme.html" => "Any supported theme listed at https://codemirror.net/demo/theme.html",
// "Colorbox" => "Colorbox",
// "Display a gallery of images in a popup slideshow" => "Display a gallery of images in a popup slideshow",
// "Image Gallery ID" => "Image Gallery ID",
// "ID number of the image gallery that contains the images to be displayed" => "ID number of the image gallery that contains the images to be displayed",
// "File ID Filter" => "File ID Filter",
// "Colon-separated list of fileIds in a file gallery to show" => "Colon-separated list of fileIds in a file gallery to show",
// "Thumb" => "Thumb",
// "Display as a thumbnail or full size" => "Display as a thumbnail or full size",
// "Show File Title" => "Show File Title",
// "Show file title" => "Show file title",
// "Show File Name" => "Show File Name",
// "Show file name" => "Show file name",
// "Show All Thumbs" => "Show All Thumbs",
// "Show thumbnails of all the images in the gallery" => "Show thumbnails of all the images in the gallery",
// "Parse Descriptions" => "Parse Descriptions",
// "Parse the file descriptions as wiki syntax" => "Parse the file descriptions as wiki syntax",
"This feature is disabled" => "這個功能已經關閉",
// "Display a comment area for a specified object" => "Display a comment area for a specified object",
// "Object type the comment is associated with" => "Object type the comment is associated with",
// "Tracker Item" => "Tracker Item",
// "Submission" => "Submission",
// "Blog Post" => "Blog Post",
// "The current wiki page to which you have added the plugin" => "The current wiki page to which you have added the plugin",
"Dynamic Content" => "動態內容",
// "Display content from dynamic content repository" => "Display content from dynamic content repository",
// "Content ID" => "Content ID",
// "Dynamic content ID. The value can be obtained in the listing" => "Dynamic content ID. The value can be obtained in the listing",
// "Content Label" => "Content Label",
// "Label of the dynamic content to display" => "Label of the dynamic content to display",
// "Contributions Dashboard" => "Contributions Dashboard",
// "List users' contributions to a page" => "List users' contributions to a page",
// "Notice" => "Notice",
// "Default Beginning Date" => "Default Beginning Date",
// "Default Ending Date" => "Default Ending Date",
// "Dashboard Types" => "Dashboard Types",
// "The types of charts that will be rendered, separated by commas" => "The types of charts that will be rendered, separated by commas",
"Update" => "更新",
// "Convene" => "Convene",
// "Suggest meeting dates and times and vote to select one" => "Suggest meeting dates and times and vote to select one",
// "Convene data generated from user input" => "Convene data generated from user input",
// "Title for the event" => "Title for the event",
// "Calendar ID" => "Calendar ID",
// "ID number of the site calendar in which to store the date for the events with the most votes" => "ID number of the site calendar in which to store the date for the events with the most votes",
// "Minimum Votes" => "Minimum Votes",
// "Minimum number of votes needed to show Add-to-Calendar icon, so that new users do\n\t\t\t\t\tnot see a potentially confusing icon before the convene has enough information on it" => "Minimum number of votes needed to show Add-to-Calendar icon, so that new users do\n\t\t\t\t\tnot see a potentially confusing icon before the convene has enough information on it",
// "Date-Time Format" => "Date-Time Format",
// "Display date and time in short or long format, according to the site wide setting" => "Display date and time in short or long format, according to the site wide setting",
// "Short" => "Short",
// "Long" => "Long",
// "Observe Admin Permissions" => "Observe Admin Permissions",
// "Show user profile pictures" => "Show user profile pictures",
// "Delete Date" => "Delete Date",
// "UTC date time: %0" => "UTC date time: %0",
// "Add Date" => "Add Date",
// "Not OK" => "Not OK",
// "Unconfirmed" => "Unconfirmed",
// "Add User" => "Add User",
// "Not ok" => "Not ok",
// "Ok" => "Ok",
// "Only admins can edit or delete other users' votes and dates. N.B. This is a guide only as if a user can edit the page they can change this setting, it is intended to make the plugin easier to use for most users" => "Only admins can edit or delete other users' votes and dates. N.B. This is a guide only as if a user can edit the page they can change this setting, it is intended to make the plugin easier to use for most users",
// "Show user's profile pictures next to their names" => "Show user's profile pictures next to their names",
// "Edit User/Save changes" => "Edit User/Save changes",
// "Delete User" => "Delete User",
// "Username.." => "Username..",
// "Selected Date" => "Selected Date",
// "Add as Calendar Event" => "Add as Calendar Event",
// "This page is being edited by another user. Please reload the page and try again later" => "This page is being edited by another user. Please reload the page and try again later",
// "Delete this date" => "Delete this date",
// "Are you sure you want to remove this user's votes" => "Are you sure you want to remove this user's votes",
// "There is no undo" => "There is no undo",
"Cookie" => "Cookie",
// "Display a random tagline or \"cookie\" (in the \"fortune cookie\" sense)" => "Display a random tagline or \"cookie\" (in the \"fortune cookie\" sense)",
// "Display content based on whether cookie consent has been granted by the user" => "Display content based on whether cookie consent has been granted by the user",
// "Wiki syntax containing the content that can be hidden or shown" => "Wiki syntax containing the content that can be hidden or shown",
// "No Cookie Message" => "No Cookie Message",
// "Message displayed if user has not consented to accepting cookies" => "Message displayed if user has not consented to accepting cookies",
// "Containing Element" => "Containing Element",
// "DOM element to contain everything (div, span, etc). The default is %0,\n\t\t\t\t\tset to %1 for no container" => "DOM element to contain everything (div, span, etc). The default is %0,\n\t\t\t\t\tset to %1 for no container",
// "Element CSS Class" => "Element CSS Class",
// "CSS class for above" => "CSS class for above",
// "No Consent CSS Class" => "No Consent CSS Class",
// "CSS class for no consent message. Default: %0" => "CSS class for no consent message. Default: %0",
"Insert copyright notices" => "插入版權宣告",
// "Pattern for display of the copyright information. May contain %0~title~%1, %0~year~%1, %0~authors~%1 and %0~holder~%1" => "Pattern for display of the copyright information. May contain %0~title~%1, %0~year~%1, %0~authors~%1 and %0~holder~%1",
// "Countdown" => "Countdown",
// "Display the time until or after a date and time" => "Display the time until or after a date and time",
// "Text to append to the countdown" => "Text to append to the countdown",
// "Target date and time. Multiple formats accepted" => "Target date and time. Multiple formats accepted",
// "Items to Show" => "Items to Show",
// "Select: %0y%1=years, %0o%1=months, %0d%1=days, %0h%1=hours, %0m%1=minutes, %0s%1=seconds.\n\t\t\t\t\tEnter multiple values as: %0yodhms%1. Must be in the order of descending length, and a time unit should not be skipped.\n\t\t\t\t\tIf blank, the time is shown down to the hour if not zero" => "Select: %0y%1=years, %0o%1=months, %0d%1=days, %0h%1=hours, %0m%1=minutes, %0s%1=seconds.\n\t\t\t\t\tEnter multiple values as: %0yodhms%1. Must be in the order of descending length, and a time unit should not be skipped.\n\t\t\t\t\tIf blank, the time is shown down to the hour if not zero",
// "Years" => "Years",
// "Years, Months" => "Years, Months",
// "Years, Months, Days" => "Years, Months, Days",
// "Years, Months, Days, Hours" => "Years, Months, Days, Hours",
// "Years, Months, Days, Hours, Minutes" => "Years, Months, Days, Hours, Minutes",
// "Years, Months, Days, Hours, Minutes & Seconds" => "Years, Months, Days, Hours, Minutes & Seconds",
// "Months" => "Months",
// "Months, Days" => "Months, Days",
// "Months, Days, Hours" => "Months, Days, Hours",
// "Months, Days, Hours, Minutes" => "Months, Days, Hours, Minutes",
// "Months, Days, Hours, Minutes & Seconds" => "Months, Days, Hours, Minutes & Seconds",
"Days" => "數日",
// "Days & Hours" => "Days & Hours",
// "Days, Hours & Minutes" => "Days, Hours & Minutes",
// "Days, Hours, Minutes & Seconds" => "Days, Hours, Minutes & Seconds",
"Hours" => "小時",
// "Hours & Minutes" => "Hours & Minutes",
// "Hours, Minutes & Seconds" => "Hours, Minutes & Seconds",
// "Minutes" => "Minutes",
// "Minutes & Seconds" => "Minutes & Seconds",
// "Seconds" => "Seconds",
// "Calendar Days" => "Calendar Days",
// "Will use calendar day difference when set to Yes (%0y%1) and time units are not shown.\n\t\t\t\t\tResult is that tomorrow, for example, is always shown as a one day away even if less than 24 hours\n\t\t\t\t\tfrom now. No (%0n%1) is the default" => "Will use calendar day difference when set to Yes (%0y%1) and time units are not shown.\n\t\t\t\t\tResult is that tomorrow, for example, is always shown as a one day away even if less than 24 hours\n\t\t\t\t\tfrom now. No (%0n%1) is the default",
// "Handle Past Events" => "Handle Past Events",
// "If Yes (%0y%1), will display amount of time since the event (default).\n\t\t\t\t\tIf No (%0n%1) and if there is body text, will display \"is over\" or custom text set in text parameter\n\t\t\t\t\tafter body text" => "If Yes (%0y%1), will display amount of time since the event (default).\n\t\t\t\t\tIf No (%0n%1) and if there is body text, will display \"is over\" or custom text set in text parameter\n\t\t\t\t\tafter body text",
"Text" => "文字",
// "Text that will show with the countdown and body text.\n\t\t\t\t\tSet to %0default%1 or leave empty to show \"xxx days until/since [body text]\", except that if\n\t\t\t\t\t the since parameter is set to No (%0n%1), \"[body text] is over\" will show after the end date has passed.\n\t\t\t\t\tAlso, if no time is shown because of the time units being displayed (for example, only years are shown and it's\n\t\t\t\t\tless than a year before/after the end date) then \"[body text] will happen in less than a year/happened in the last year\" will show.\n\t\t\t\t\tOr set pipe-separated custom text as follows: %0before date|before date by less than shortest time unit shown|after date\n\t\t\t\t\t|after date by less than shortest time unit shown|after date and since set to No (n)%1.\n\t\t\t\t\tSet to %0silent%1 for no text" => "Text that will show with the countdown and body text.\n\t\t\t\t\tSet to %0default%1 or leave empty to show \"xxx days until/since [body text]\", except that if\n\t\t\t\t\t the since parameter is set to No (%0n%1), \"[body text] is over\" will show after the end date has passed.\n\t\t\t\t\tAlso, if no time is shown because of the time units being displayed (for example, only years are shown and it's\n\t\t\t\t\tless than a year before/after the end date) then \"[body text] will happen in less than a year/happened in the last year\" will show.\n\t\t\t\t\tOr set pipe-separated custom text as follows: %0before date|before date by less than shortest time unit shown|after date\n\t\t\t\t\t|after date by less than shortest time unit shown|after date and since set to No (n)%1.\n\t\t\t\t\tSet to %0silent%1 for no text",
// "default, silent, custom: before event|after event|after event when time not shown" => "default, silent, custom: before event|after event|after event when time not shown",
// "Thousands separator" => "Thousands separator",
// "Set the thousands separator for results of 1,000 or more.\n\t\t\t\t\tChoices are comma (%0c%1), decimal (%0d%1), space (%0s%1), or leave blank for no separator" => "Set the thousands separator for results of 1,000 or more.\n\t\t\t\t\tChoices are comma (%0c%1), decimal (%0d%1), space (%0s%1), or leave blank for no separator",
// "Comma" => "Comma",
// "Period" => "Period",
// "Space" => "Space",
// "Countdown: Missing \"enddate\" parameter for plugin" => "Countdown: Missing \"enddate\" parameter for plugin",
// "will happen in less than a year" => "will happen in less than a year",
// "will happen in less than a month" => "will happen in less than a month",
// "will happen in less than a day" => "will happen in less than a day",
// "will happen in less than an hour" => "will happen in less than an hour",
// "will happen in less than a minute" => "will happen in less than a minute",
// "is happening this second" => "is happening this second",
// "happened in the last year" => "happened in the last year",
// "happened in the last month" => "happened in the last month",
// "happened in the last day" => "happened in the last day",
// "happened in the last hour" => "happened in the last hour",
// "happened in the last minute" => "happened in the last minute",
// "until" => "until",
"since" => "自",
// "is over" => "is over",
// "Custom Search" => "Custom Search",
// "Create a custom search form for searching or listing items on the site" => "Create a custom search form for searching or listing items on the site",
// "LIST plugin configuration information" => "LIST plugin configuration information",
// "Template wiki page" => "Template wiki page",
// "Wiki page where search user interface template is found" => "Wiki page where search user interface template is found",
// "Template file" => "Template file",
// "Smarty template (.tpl) file where search user interface template is found" => "Smarty template (.tpl) file where search user interface template is found",
// "Search Id" => "Search Id",
// "A unique identifier to distinguish custom searches for storing of previous search\n\t\t\t\t\tcriteria entered by users" => "A unique identifier to distinguish custom searches for storing of previous search\n\t\t\t\t\tcriteria entered by users",
// "Search Delay" => "Search Delay",
// "Delay in milliseconds before automatically triggering search after change\n\t\t\t\t\t(%00%1 disables and is the default)" => "Delay in milliseconds before automatically triggering search after change\n\t\t\t\t\t(%00%1 disables and is the default)",
// "Fade DIV Id" => "Fade DIV Id",
// "The specific ID of the specific div to fade out when AJAX search is in progress,\n\t\t\t\t\tif not set will attempt to fade the whole area or if failing simply show the spinner" => "The specific ID of the specific div to fade out when AJAX search is in progress,\n\t\t\t\t\tif not set will attempt to fade the whole area or if failing simply show the spinner",
// "Recall Last Search" => "Recall Last Search",
// "In the same session, return users to same search parameters on coming back to the\n\t\t\t\t\tsearch page after leaving" => "In the same session, return users to same search parameters on coming back to the\n\t\t\t\t\tsearch page after leaving",
// "Custom JavaScript Page" => "Custom JavaScript Page",
// "The wiki page on which custom JavaScript is to be executed on return of Ajax results" => "The wiki page on which custom JavaScript is to be executed on return of Ajax results",
// "Destination Div" => "Destination Div",
// "The id of an existing div to contain the search results" => "The id of an existing div to contain the search results",
// "Search On Load" => "Search On Load",
// "Execute the search when the page loads (default: Yes)" => "Execute the search when the page loads (default: Yes)",
// "Require Input" => "Require Input",
// "Require first input field to be filled for search to trigger" => "Require first input field to be filled for search to trigger",
// "Force Sort" => "Force Sort",
// "Force the use of specified sort mode in place of search relevance even when there is a text search query" => "Force the use of specified sort mode in place of search relevance even when there is a text search query",
// "Trim Linefeeds" => "Trim Linefeeds",
// "Remove the linefeeds added after each input which casues the wiki parser to add extra paragraphs" => "Remove the linefeeds added after each input which casues the wiki parser to add extra paragraphs",
// "Searchable Only Results" => "Searchable Only Results",
// "Only include results marked as searchable in the index" => "Only include results marked as searchable in the index",
// "Use custom search JavaScript file" => "Use custom search JavaScript file",
// "Mainly keeps the search state on the URL hash, but also adds some helper functions like easier sorting and page size" => "Mainly keeps the search state on the URL hash, but also adds some helper functions like easier sorting and page size",
// "JavaScript disabled" => "JavaScript disabled",
// "JavaScript is required for this search feature" => "JavaScript is required for this search feature",
// "Template is not specified" => "Template is not specified",
// "Template page not found" => "Template page not found",
// "Please enter a search query" => "Please enter a search query",
// "_from parameter not valid: \"%0\"" => "_from parameter not valid: \"%0\"",
// "_to parameter not valid: \"%0\"" => "_to parameter not valid: \"%0\"",
// "_gap parameter not valid: \"%0\"" => "_gap parameter not valid: \"%0\"",
// "_group is needed to be set if _style is checkbox or radio" => "_group is needed to be set if _style is checkbox or radio",
// "Cypht webmail" => "Cypht webmail",
// "Embed Cypht webmail and news reader" => "Embed Cypht webmail and news reader",
// "Mailbox name" => "Mailbox name",
// "IMAP server" => "IMAP server",
// "IMAP port" => "IMAP port",
// "IMAP use TLS" => "IMAP use TLS",
// "Use secure connection to IMAP server" => "Use secure connection to IMAP server",
// "IMAP username" => "IMAP username",
// "Account mailbox username" => "Account mailbox username",
// "IMAP password" => "IMAP password",
// "Account mailbox password" => "Account mailbox password",
// "SMTP connection name" => "SMTP connection name",
// "SMTP port" => "SMTP port",
// "SMTP use TLS" => "SMTP use TLS",
// "Use secure TLS/SSL connection to SMTP server" => "Use secure TLS/SSL connection to SMTP server",
// "SMTP no authentication" => "SMTP no authentication",
// "Disable SMTP authentication if your server does not support it" => "Disable SMTP authentication if your server does not support it",
// "Use global settings" => "Use global settings",
// "Use global Cypht settings available at Tiki Webmail page. Choosing \"No\" will make this instance of Cypht use its own settings. Useful if this is a Groupmail box or you don't want to mix mailbox server and/or site settings from other pages" => "Use global Cypht settings available at Tiki Webmail page. Choosing \"No\" will make this instance of Cypht use its own settings. Useful if this is a Groupmail box or you don't want to mix mailbox server and/or site settings from other pages",
// "Groupmail use" => "Groupmail use",
// "Share this mailbox for Groupmail usage or keep it private" => "Share this mailbox for Groupmail usage or keep it private",
// "GroupMail: Group (e.g. \"Help Team\")" => "GroupMail: Group (e.g. \"Help Team\")",
// "GroupMail: Tracker ID (to store GroupMail activity)" => "GroupMail: Tracker ID (to store GroupMail activity)",
// "From Field ID" => "From Field ID",
// "GroupMail: From Field (Id of field in tracker to store email From header)" => "GroupMail: From Field (Id of field in tracker to store email From header)",
// "Subject Field ID" => "Subject Field ID",
// "GroupMail: Subject Field (Id of field in tracker to store email Subject header)" => "GroupMail: Subject Field (Id of field in tracker to store email Subject header)",
// "Message Field ID" => "Message Field ID",
// "GroupMail: Message Field (Id of field in tracker to store email message identifier)" => "GroupMail: Message Field (Id of field in tracker to store email message identifier)",
// "Content Field ID" => "Content Field ID",
// "GroupMail: Content Field (Id of field in tracker to store email message body content)" => "GroupMail: Content Field (Id of field in tracker to store email message body content)",
// "Account Field ID" => "Account Field ID",
// "GroupMail: Account Field (Id of field in tracker to store Webmail account name)" => "GroupMail: Account Field (Id of field in tracker to store Webmail account name)",
// "DateTime Field Id" => "DateTime Field Id",
// "GroupMail: Date Time Field (Id of field in tracker to store email sent timestamp)" => "GroupMail: Date Time Field (Id of field in tracker to store email sent timestamp)",
// "Operator Field ID" => "Operator Field ID",
// "GroupMail: Operator Field (Id of field in tracker to store operator name (username))" => "GroupMail: Operator Field (Id of field in tracker to store operator name (username))",
// "UI display presentational purposes only" => "UI display presentational purposes only",
// "E.g. imap.your-domain.com" => "E.g. imap.your-domain.com",
// "Default is 993" => "Default is 993",
// "E.g. smtp.your-domain.com" => "E.g. smtp.your-domain.com",
// "Default is 587" => "Default is 587",
// "Only one cypht plugin per page can be used" => "Only one cypht plugin per page can be used",
// "Data Channel" => "Data Channel",
// "Display a form to access data channels" => "Display a form to access data channels",
// "List of fields to display. One field per line. Comma delimited: %0" => "List of fields to display. One field per line. Comma delimited: %0",
// "To use values from other forms on the same page as parameters for the data-channel\n\t\t\tuse %0 or %1 can be used where a value is simply listed on the same page where each value has the %2\n\t\t\tas an html id tag" => "To use values from other forms on the same page as parameters for the data-channel\n\t\t\tuse %0 or %1 can be used where a value is simply listed on the same page where each value has the %2\n\t\t\tas an html id tag",
// "Where %0 is\n\t\t\tthe id (important) of the external input to use, and %1 is the name of the parameter in the\n\t\t\tdata-channel" => "Where %0 is\n\t\t\tthe id (important) of the external input to use, and %1 is the name of the parameter in the\n\t\t\tdata-channel",
// "To use fixed hidden preset\n\t\t\tvalues use %0" => "To use fixed hidden preset\n\t\t\tvalues use %0",
// "Channel Name" => "Channel Name",
// "Name of the channel as registered by the administrator" => "Name of the channel as registered by the administrator",
// "Return URL" => "Return URL",
// "URL to go to after data channel has run. Defaults to current page. Can contain\n\t\t\t\t\tplaceholders %0 or %1, where reference matches a profile object ref,\n\t\t\t\t\tallowing to redirect conditionally to a freshly created object" => "URL to go to after data channel has run. Defaults to current page. Can contain\n\t\t\t\t\tplaceholders %0 or %1, where reference matches a profile object ref,\n\t\t\t\t\tallowing to redirect conditionally to a freshly created object",
// "Return URL on error" => "Return URL on error",
// "URL to go to after data channel has run and failed. If not specified, use the success URL" => "URL to go to after data channel has run and failed. If not specified, use the success URL",
// "Do not use returnURI but instead return true quietly" => "Do not use returnURI but instead return true quietly",
// "If set to %0, will return quietly after data channel has run which would be needed\n\t\t\t\t\tif plugin is used in non-wiki page context" => "If set to %0, will return quietly after data channel has run which would be needed\n\t\t\t\t\tif plugin is used in non-wiki page context",
// "Button Label" => "Button Label",
// "Label for the submit button. Default: \"Go\"" => "Label for the submit button. Default: \"Go\"",
// "CSS class for this form" => "CSS class for this form",
"Template" => "模板",
// "Template to be used to render the form, instead of the default template" => "Template to be used to render the form, instead of the default template",
// "Empty Caches" => "Empty Caches",
// "Which caches to empty. Default \"Clear all Tiki caches\"" => "Which caches to empty. Default \"Clear all Tiki caches\"",
// "Clear all Tiki caches" => "Clear all Tiki caches",
// "All user prefs sessions" => "All user prefs sessions",
// "Price to execute the data channel (%0)" => "Price to execute the data channel (%0)",
// "Payment Label" => "Payment Label",
// "Debug" => "Debug",
// "Be careful, if debug is on, the page will not be refreshed and previous modules\n\t\t\t\t\tcan be obsolete (not on by default)" => "Be careful, if debug is on, the page will not be refreshed and previous modules\n\t\t\t\t\tcan be obsolete (not on by default)",
// "Multiple Values" => "Multiple Values",
// "Accept arrays of multiple values in the POST. e.g. %0 etc.\n\t\t\t\t\t(multiple values not accepted by default)" => "Accept arrays of multiple values in the POST. e.g. %0 etc.\n\t\t\t\t\t(multiple values not accepted by default)",
// "Data channel" => "Data channel",
// "DB Report" => "DB Report",
// "Query an ADOdb database and display results (does not work with PDO)" => "Query an ADOdb database and display results (does not work with PDO)",
// "report definition" => "report definition",
// "Full DSN" => "Full DSN",
// "A full DSN (Data Source Name) connection string. Example: " => "A full DSN (Data Source Name) connection string. Example: ",
// "Wiki DSN Name" => "Wiki DSN Name",
// "The name of a DSN connection defined by the Wiki administrator" => "The name of a DSN connection defined by the Wiki administrator",
// "Wiki Syntax" => "Wiki Syntax",
// "Parse wiki syntax within the report (not parsed by default)" => "Parse wiki syntax within the report (not parsed by default)",
// "Display the parsed report definition (not displayed by default)" => "Display the parsed report definition (not displayed by default)",
// "Missing db or dsn parameter" => "Missing db or dsn parameter",
// "AdoDb not found" => "AdoDb not found",
// "No DSN connection string found" => "No DSN connection string found",
// "Run a database report" => "Run a database report",
// "Diagram" => "Diagram",
// "Display mxGraph/Draw.io diagrams" => "Display mxGraph/Draw.io diagrams",
// "fileId" => "fileId",
// "Id of the file in the file gallery. A xml file containing the graph model. Leave empty for more options" => "Id of the file in the file gallery. A xml file containing the graph model. Leave empty for more options",
"page" => "頁面",
// "Page of the diagram that should be displayed" => "Page of the diagram that should be displayed",
// "annotate" => "annotate",
// "Id of the file in the file gallery. A image file to include in the diagram" => "Id of the file in the file gallery. A image file to include in the diagram",
// "Image alignment when exporting a PDF" => "Image alignment when exporting a PDF",
// "Alignment of the diagrams during PDF export. Accepted values: \"left\", \"right\" and \"center\"" => "Alignment of the diagrams during PDF export. Accepted values: \"left\", \"right\" and \"center\"",
// "Previous xorti/mxgraph-editor package has been deprecated.<br/>" => "Previous xorti/mxgraph-editor package has been deprecated.<br/>",
// "To view diagrams Tiki needs the tikiwiki/diagram package. If you do not have permission to install this package, ask the site administrator" => "To view diagrams Tiki needs the tikiwiki/diagram package. If you do not have permission to install this package, ask the site administrator",
// "Create New Diagram" => "Create New Diagram",
// "Page (inline)" => "Page (inline)",
// "Tiki wasn't able to find the file with id %0" => "Tiki wasn't able to find the file with id %0",
// "Tiki wasn't able to parse the Diagram. Please check the diagram XML data and structure" => "Tiki wasn't able to parse the Diagram. Please check the diagram XML data and structure",
// " in " => " in ",
// "Selected file to annotate must be an image" => "Selected file to annotate must be an image",
// "Can not retrieve size from file %0" => "Can not retrieve size from file %0",
// "Create a custom popup dialog box" => "Create a custom popup dialog box",
// "Button labels separated by commas" => "Button labels separated by commas",
// "Button Actions" => "Button Actions",
// "JavaScript to perform on first button click" => "JavaScript to perform on first button click",
// "Dialog Width" => "Dialog Width",
// "In pixels" => "In pixels",
// "HTML ID" => "HTML ID",
// "Automatically generated if left empty in the form %0 (must be unique\n\t\t\t\t\tper page)" => "Automatically generated if left empty in the form %0 (must be unique\n\t\t\t\t\tper page)",
// "Show Animation" => "Show Animation",
// "Hide Animation" => "Hide Animation",
// "Auto Open" => "Auto Open",
// "Open dialog automatically" => "Open dialog automatically",
// "Modal" => "Modal",
// "Use modal form" => "Use modal form",
// "Wiki page to use as dialog body" => "Wiki page to use as dialog body",
// "Open Action" => "Open Action",
// "JavaScript to execute when dialog opens" => "JavaScript to execute when dialog opens",
// "Div" => "Div",
// "Define and format sections of a page or text" => "Define and format sections of a page or text",
// "Indicate the type of HTML tag to use (default is %0)" => "Indicate the type of HTML tag to use (default is %0)",
// "Span" => "Span",
"Pre" => "pre",
// "Teletype" => "Teletype",
// "Paragraph" => "Paragraph",
// "Block quote" => "Block quote",
// "H1" => "H1",
// "H2" => "H2",
// "H3" => "H3",
// "H4" => "H4",
// "H5" => "H5",
// "H6" => "H6",
// "Valid CSS color name or hex code" => "Valid CSS color name or hex code",
// "Box width" => "Box width",
// "In pixels or percentage. Default is original size" => "In pixels or percentage. Default is original size",
// "Aligns the text within the element" => "Aligns the text within the element",
// "Justify" => "Justify",
// "Set the alignment for the entire element. For elements with a width of less than\n\t\t\t\t100%, other elements will wrap around it unless the %0 parameter is appropriately set" => "Set the alignment for the entire element. For elements with a width of less than\n\t\t\t\t100%, other elements will wrap around it unless the %0 parameter is appropriately set",
// "Content cannot wrap around this object because of what the parameter is set to" => "Content cannot wrap around this object because of what the parameter is set to",
// "Apply custom CSS class to the div" => "Apply custom CSS class to the div",
// "Title attribute" => "Title attribute",
// "Title for the div, usually displayed as a tooltip" => "Title for the div, usually displayed as a tooltip",
// "onClick attribute" => "onClick attribute",
// "Enter on onclick event" => "Enter on onclick event",
// "Style attribute" => "Style attribute",
// "Enter CSS styling tags for the div type used" => "Enter CSS styling tags for the div type used",
// "Data attributes" => "Data attributes",
// "URL encoded list or attributes and values" => "URL encoded list or attributes and values",
// "ARIA attributes" => "ARIA attributes",
// "URL encoded list or attributes and values, e.g. label, expanded etc" => "URL encoded list or attributes and values, e.g. label, expanded etc",
// "Role attribute" => "Role attribute",
// "e.g. button, heading, search etc" => "e.g. button, heading, search etc",
// "Sets the id attribute of the div, as defined by HTML" => "Sets the id attribute of the div, as defined by HTML",
// "Definition List" => "Definition List",
// "Create a definition list" => "Create a definition list",
// "One entry per line. Each line is in %0Term: Definition%1 format" => "One entry per line. Each line is in %0Term: Definition%1 format",
// "List Type" => "List Type",
// "Type of definition list (left-aligned or horizontal)" => "Type of definition list (left-aligned or horizontal)",
// "Standard (left-aligned)" => "Standard (left-aligned)",
// "Horizontal (inline) " => "Horizontal (inline) ",
// "Draw" => "Draw",
// "Embed a drawing in a page" => "Embed a drawing in a page",
// "Drawing ID" => "Drawing ID",
// "Internal ID of the file ID" => "Internal ID of the file ID",
// "Width in pixels or percentage. Default value is page width, for example, %0 or %1" => "Width in pixels or percentage. Default value is page width, for example, %0 or %1",
// "Height in pixels or percentage. Default value is complete drawing height" => "Height in pixels or percentage. Default value is complete drawing height",
// "Force Display Archive" => "Force Display Archive",
// "The latest revision of file is automatically shown, by setting archive to Yes (%0),\n\t\t\t\tit bypasses this check and shows the archive rather than the latest revision" => "The latest revision of file is automatically shown, by setting archive to Yes (%0),\n\t\t\t\tit bypasses this check and shows the archive rather than the latest revision",
// "Draw New SVG Image" => "Draw New SVG Image",
// "Edit SVG Image" => "Edit SVG Image",
// "List of dynamic variables" => "List of dynamic variables",
// "Show dynamic variables and their values" => "Show dynamic variables and their values",
// "Layout" => "Layout",
// "Set to table to show results in a table (not shown in a table by default)" => "Set to table to show results in a table (not shown in a table by default)",
// "String to use between elements of the list if table layout is not used" => "String to use between elements of the list if table layout is not used",
// "Parsed result" => "Parsed result",
"Syntax" => "語法",
// "Value per database" => "Value per database",
// "Equation" => "Equation",
// "Render an equation written in LaTeX syntax as an image" => "Render an equation written in LaTeX syntax as an image",
// "equation" => "equation",
// "To view equations Tiki needs the mathjax/mathjax package. If you do not have permission to install this package, ask the site administrator" => "To view equations Tiki needs the mathjax/mathjax package. If you do not have permission to install this package, ask the site administrator",
// "Display events from calendars" => "Display events from calendars",
// "ID numbers for the site calendars whose events are to be displayed, separated by\n\t\t\t\t\tvertical bars (%0)" => "ID numbers for the site calendars whose events are to be displayed, separated by\n\t\t\t\t\tvertical bars (%0)",
// "Maximum Days" => "Maximum Days",
// "Events occurring within this number of days in the future from today will be\n\t\t\t\t\tincluded in the list (unless limited by other parameter settings). Default is %0" => "Events occurring within this number of days in the future from today will be\n\t\t\t\t\tincluded in the list (unless limited by other parameter settings). Default is %0",
// "Maximum Events" => "Maximum Events",
// "Maximum number of events to display. Default is %0. Set to %1 to display all\n\t\t\t\t\t(unless limited by other parameter settings)" => "Maximum number of events to display. Default is %0. Set to %1 to display all\n\t\t\t\t\t(unless limited by other parameter settings)",
// "Show Time" => "Show Time",
// "Show the time along with the date (shown by default)" => "Show the time along with the date (shown by default)",
// "Show the description of the event (shown by default)" => "Show the description of the event (shown by default)",
// "Time Span" => "Time Span",
// "Specify the time span" => "Specify the time span",
// "Past" => "Past",
// "Future" => "Future",
// "Activate pagination when Events listing are long. Default is %0" => "Activate pagination when Events listing are long. Default is %0",
// "Exercise" => "Exercise",
// "PluginExercise" => "PluginExercise",
// "Create an exercise/test with questions and grade" => "Create an exercise/test with questions and grade",
"Answer" => "回答",
// "Used inline to specify the right answer to the question and propose an input field" => "Used inline to specify the right answer to the question and propose an input field",
// "Incorrect" => "Incorrect",
// "Incorrect answer to suggest. Several incorrect answers can be suggested (separated by \"+\")" => "Incorrect answer to suggest. Several incorrect answers can be suggested (separated by \"+\")",
// "Check your score" => "Check your score",
// "You scored %0 out of %1" => "You scored %0 out of %1",
// "Good" => "Good",
// "Extend Cart Inventory Hold" => "Extend Cart Inventory Hold",
// "PluginExtendCartHold" => "PluginExtendCartHold",
// "Extend the time that items are held in a shopping cart" => "Extend the time that items are held in a shopping cart",
// "Create a link that shows/hides initially hidden content" => "Create a link that shows/hides initially hidden content",
// "Content of the hideable zone (in Wiki syntax)" => "Content of the hideable zone (in Wiki syntax)",
// "Label for link that shows and hides the content when clicked" => "Label for link that shows and hides the content when clicked",
// "Unspecified label" => "Unspecified label",
// "Arrow icon showing that content can be hidden or shown" => "Arrow icon showing that content can be hidden or shown",
// "Show Speed" => "Show Speed",
// "Speed of animation in milliseconds when showing content (%0200%1 is fast and\n\t\t\t\t\t%0600%1 is slow. %01000%1 equals 1 second)" => "Speed of animation in milliseconds when showing content (%0200%1 is fast and\n\t\t\t\t\t%0600%1 is slow. %01000%1 equals 1 second)",
// "Integer greater than 0 and less than or equal to 1000, or %0 or %1" => "Integer greater than 0 and less than or equal to 1000, or %0 or %1",
// "Hide Speed" => "Hide Speed",
// "Speed of animation in milliseconds when hiding content (%0200%1 is fast and\n\t\t\t\t\t%0600%1 is slow. %01000%1 equals 1 second)" => "Speed of animation in milliseconds when hiding content (%0200%1 is fast and\n\t\t\t\t\t%0600%1 is slow. %01000%1 equals 1 second)",
// "Use Bootstrap" => "Use Bootstrap",
// "Use Bootstrap collapsible box" => "Use Bootstrap collapsible box",
// "Apply custom CSS class" => "Apply custom CSS class",
// "Fancy List" => "Fancy List",
// "Create a formatted numbered list" => "Create a formatted numbered list",
// "One item per line starting with anything followed by \")\"" => "One item per line starting with anything followed by \")\"",
// "Use Div" => "Use Div",
// "Use the HTML div tag instead of the HTML ordered list tag (ol)" => "Use the HTML div tag instead of the HTML ordered list tag (ol)",
// "CSS class for the fancylist" => "CSS class for the fancylist",
// "Heading Row" => "Heading Row",
// "Header rows of the table. Use %0 to separate multiple rows" => "Header rows of the table. Use %0 to separate multiple rows",
// "Heading CSS Class" => "Heading CSS Class",
// "CSS class to apply to the heading row" => "CSS class to apply to the heading row",
// "Header Horizontal Alignment" => "Header Horizontal Alignment",
// "Horizontal alignments for header cells, separated by %0. Choices: %1" => "Horizontal alignments for header cells, separated by %0. Choices: %1",
// "Header Vertical Alignment" => "Header Vertical Alignment",
// "Vertical alignments for header cells, separated by %0\". Choices: %1" => "Vertical alignments for header cells, separated by %0\". Choices: %1",
// "Column Widths" => "Column Widths",
// "Column widths followed by \"px\" for pixels or \"%\" for percentages. Each column\n\t\t\t\t    separated by %0" => "Column widths followed by \"px\" for pixels or \"%\" for percentages. Each column\n\t\t\t\t    separated by %0",
// "Cell Horizontal Align" => "Cell Horizontal Align",
// "Table body column horizontal alignments, separated by %0. Choices: %1" => "Table body column horizontal alignments, separated by %0. Choices: %1",
// "Cell Vertical Align" => "Cell Vertical Align",
// "Table body column vertical alignments, separated by %0. Choices: %1" => "Table body column vertical alignments, separated by %0. Choices: %1",
// "Fancy Table" => "Fancy Table",
// "Create a formatted table that can be filtered and sorted" => "Create a formatted table that can be filtered and sorted",
// "Rows separated by %0 in the header; for the table body, one row per line. Cells separated by %1 (since Tiki4) or %2 in both cases" => "Rows separated by %0 in the header; for the table body, one row per line. Cells separated by %1 (since Tiki4) or %2 in both cases",
// "The jQuery Sortable Tables feature must be activated for the sort feature to work" => "The jQuery Sortable Tables feature must be activated for the sort feature to work",
// "JavaScript must be enabled for the sort feature to work" => "JavaScript must be enabled for the sort feature to work",
// "Unable to load the jQuery Sortable Tables feature" => "Unable to load the jQuery Sortable Tables feature",
// "Display a button for a user to click to make an object a favorite" => "Display a button for a user to click to make an object a favorite",
// "Indicate type of object" => "Indicate type of object",
// "Enter the ID of the object" => "Enter the ID of the object",
// "Link to a file that's attached or in a gallery or archive" => "Link to a file that's attached or in a gallery or archive",
// "Label for the link to the file (ignored if the file is a wiki attachment)" => "Label for the link to the file (ignored if the file is a wiki attachment)",
// "Indicate whether the file is in a file gallery or is a wiki page attachment" => "Indicate whether the file is in a file gallery or is a wiki page attachment",
// "Identify an attachment by entering its file name, which will show as a link to the\n\t\t\t\t\tfile. If the page parameter is empty, it must be a file name of an attachment to the page where the\n\t\t\t\t\tplugin is used" => "Identify an attachment by entering its file name, which will show as a link to the\n\t\t\t\t\tfile. If the page parameter is empty, it must be a file name of an attachment to the page where the\n\t\t\t\t\tplugin is used",
// "Custom Description" => "Custom Description",
// "Custom text that will be used for the link instead of the file name or file description" => "Custom text that will be used for the link instead of the file name or file description",
// "Name of the wiki page the file is attached to. Defaults to the wiki page where the\n\t\t\t\t\tplugin is used if empty" => "Name of the wiki page the file is attached to. Defaults to the wiki page where the\n\t\t\t\t\tplugin is used if empty",
// "Attachment Description" => "Attachment Description",
// "Show the attachment description as the link label instead of the attachment file name" => "Show the attachment description as the link label instead of the attachment file name",
// "Indicates that this attachment is an image, and should be displayed inline using the img tag" => "Indicates that this attachment is an image, and should be displayed inline using the img tag",
// "File ID" => "File ID",
// "File ID of a file in a file gallery or an archive" => "File ID of a file in a file gallery or an archive",
// "Example value" => "Example value",
"Date" => "日期",
// "For an archive file, the archive created just before this date will be linked to.\n\t\t\t\t\tSpecial values : %0 and %1" => "For an archive file, the archive created just before this date will be linked to.\n\t\t\t\t\tSpecial values : %0 and %1",
// "Show Icon" => "Show Icon",
// "Show an icon version of the file or file type with the link to the file" => "Show an icon version of the file or file type with the link to the file",
// "Browser Display" => "Browser Display",
// "Display in different browser window or tab instead of downloading" => "Display in different browser window or tab instead of downloading",
// "File Gallery File/Archive" => "File Gallery File/Archive",
// "Wiki Page Attachment" => "Wiki Page Attachment",
// "The date has not been set" => "The date has not been set",
// "Incorrect date format" => "Incorrect date format",
// "No such file" => "No such file",
// "Wiki attachments are disabled" => "Wiki attachments are disabled",
// "List files by ID, gallery or category, or show a slideshow of image files" => "List files by ID, gallery or category, or show a slideshow of image files",
// "Title for the file listing, or the link text when %0" => "Title for the file listing, or the link text when %0",
// "File Galleries IDs" => "File Galleries IDs",
// "To list only files contained in these file galleries (multiple IDs separated by\n\t\t\t\t\tcolon)" => "To list only files contained in these file galleries (multiple IDs separated by\n\t\t\t\t\tcolon)",
// "Or enter a username\n\t\t\t\t\tfor user files (hint: enter %0 for current logged-in user)" => "Or enter a username\n\t\t\t\t\tfor user files (hint: enter %0 for current logged-in user)",
// "To restrict files listed to those belonging to one or more categories. Enter a\n\t\t\t\t\tsingle category or ID or list of them separated by colon" => "To restrict files listed to those belonging to one or more categories. Enter a\n\t\t\t\t\tsingle category or ID or list of them separated by colon",
// "Valid category IDs separated by colons" => "Valid category IDs separated by colons",
// "To list only specified files, enter their file IDs separated by colon. If File\n\t\t\t\t\tIDs are specified here then the Gallery ID field above should be empty" => "To list only specified files, enter their file IDs separated by colon. If File\n\t\t\t\t\tIDs are specified here then the Gallery ID field above should be empty",
// "Valid file IDs separated by colons" => "Valid file IDs separated by colons",
// "Order ascending (_asc), descending (_desc) or random based on any field in the\n\t\t\t\t\tfile gallery table. Default is %0" => "Order ascending (_asc), descending (_desc) or random based on any field in the\n\t\t\t\t\tfile gallery table. Default is %0",
// "Last modified Ascending" => "Last modified Ascending",
// "Last modified Descending" => "Last modified Descending",
// "File Name Ascending" => "File Name Ascending",
// "File Name Descending" => "File Name Descending",
// "File Size Ascending" => "File Size Ascending",
// "File Size Descending" => "File Size Descending",
// "File Type Ascending" => "File Type Ascending",
// "File Type Descending" => "File Type Descending",
// "Last Download Ascending" => "Last Download Ascending",
// "Last Download Descending" => "Last Download Descending",
// "Show Action" => "Show Action",
// "Show a column with icons for the various actions the user can take with each file\n\t\t\t\t\t(shown by default)" => "Show a column with icons for the various actions the user can take with each file\n\t\t\t\t\t(shown by default)",
// "Show Find" => "Show Find",
// "Show a search box above the list (not shown by default)" => "Show a search box above the list (not shown by default)",
// "Show Find is recursive" => "Show Find is recursive",
// "The search box digs recursively in sub-galleries (by default)" => "The search box digs recursively in sub-galleries (by default)",
// "Show Title" => "Show Title",
// "Show the title of the file gallery (shown by default). Also shown on slide show\n\t\t\t\t\tpop up window if a single galleryId is used" => "Show the title of the file gallery (shown by default). Also shown on slide show\n\t\t\t\t\tpop up window if a single galleryId is used",
// "Show ID" => "Show ID",
// "Show the ID number of each file (shown by default)" => "Show the ID number of each file (shown by default)",
// "Show the file-type icon for each file" => "Show the file-type icon for each file",
// "Show Name" => "Show Name",
// "Show the name given to the file upon upload into the file gallery (shown by\n\t\t\t\t\tdefault). Set to Yes (%0) to show as a caption in a slide show" => "Show the name given to the file upon upload into the file gallery (shown by\n\t\t\t\t\tdefault). Set to Yes (%0) to show as a caption in a slide show",
// "Show Filename" => "Show Filename",
// "Show each file's filename (shown by default except in slide show). Set to Yes\n\t\t\t\t\t(%0) to show as a caption in a slide show" => "Show each file's filename (shown by default except in slide show). Set to Yes\n\t\t\t\t\t(%0) to show as a caption in a slide show",
// "Show Size" => "Show Size",
// "Show the size of each file in kilobytes (shown by default except in slide show)" => "Show the size of each file in kilobytes (shown by default except in slide show)",
// "Show the description of the file given upon upload into the file gallery (shown\n\t\t\t\t\tby default except in slide show). Set to Yes (%0) to show as a caption in a slide show" => "Show the description of the file given upon upload into the file gallery (shown\n\t\t\t\t\tby default except in slide show). Set to Yes (%0) to show as a caption in a slide show",
// "Show Creation Date" => "Show Creation Date",
// "Show the date each file was created (not shown by default)" => "Show the date each file was created (not shown by default)",
// "Show Last Modification Date" => "Show Last Modification Date",
// "Show the date each file was last modified (shown by default)" => "Show the date each file was last modified (shown by default)",
// "Show Last Modification Time as well as Date" => "Show Last Modification Time as well as Date",
// "if showmodified is set to y then this will show both the date and time that each file was last modified (not shown by default)" => "if showmodified is set to y then this will show both the date and time that each file was last modified (not shown by default)",
// "Show Hits" => "Show Hits",
// "Show the number of hits each file has received (not shown by default)" => "Show the number of hits each file has received (not shown by default)",
// "Show Locked By" => "Show Locked By",
// "For locked files, show the username of the user who locked it (not shown by default)" => "For locked files, show the username of the user who locked it (not shown by default)",
// "Show the username of the user who is the author of the file (not shown by default)" => "Show the username of the user who is the author of the file (not shown by default)",
// "Show Creator" => "Show Creator",
// "Show the username of the user who is the creator of the file (not shown by default)" => "Show the username of the user who is the creator of the file (not shown by default)",
// "Show Parent Gallery Name" => "Show Parent Gallery Name",
// "Show the name of the parent gallery" => "Show the name of the parent gallery",
// "Show File Count" => "Show File Count",
// "For galleries included in the list (where the file gallery includes other\n\t\t\t\t\tgalleries), show the number of files in each of those galleries (not shown by default)" => "For galleries included in the list (where the file gallery includes other\n\t\t\t\t\tgalleries), show the number of files in each of those galleries (not shown by default)",
// "Show Source" => "Show Source",
// "Show the source (shown by default)" => "Show the source (shown by default)",
// "Show Slideshow" => "Show Slideshow",
// "Show a link that produces a popup slideshow when clicked (not set by default)" => "Show a link that produces a popup slideshow when clicked (not set by default)",
// "Slideshow Width" => "Slideshow Width",
// "Set width of slideshow popup" => "Set width of slideshow popup",
// "Slideshow Height" => "Slideshow Height",
// "Set height of slideshow popup" => "Set height of slideshow popup",
// "Show Comments" => "Show Comments",
// "Show comments for each file (not shown by default)" => "Show comments for each file (not shown by default)",
// "Show Last Editor" => "Show Last Editor",
// "Show the username of the user who last modified the file (shown by default)" => "Show the username of the user who last modified the file (shown by default)",
// "Show image thumbnail" => "Show image thumbnail",
// "Show Image thumb" => "Show Image thumb",
// "Show only files created by this user" => "Show only files created by this user",
// "Show Upload" => "Show Upload",
// "Show a simple form to upload files to the gallery (not shown by default)" => "Show a simple form to upload files to the gallery (not shown by default)",
// "Number of rows (default: -1 = all)" => "Number of rows (default: -1 = all)",
// "Recursive" => "Recursive",
// "With subgalleries" => "With subgalleries",
// "Fitnesse Test Suite" => "Fitnesse Test Suite",
// "Create test suites for applications built using Tiki" => "Create test suites for applications built using Tiki",
// "Test execution scenario" => "Test execution scenario",
// "Fixture not found: %0" => "Fixture not found: %0",
// "Tracker Math for [%0|%1]" => "Tracker Math for [%0|%1]",
// "Tracker Field not found: %0" => "Tracker Field not found: %0",
// "Field is not a math field: %0" => "Field is not a math field: %0",
// "Tracker Data for [%0|%1]" => "Tracker Data for [%0|%1]",
// "Table must contain at least one field named itemId" => "Table must contain at least one field named itemId",
// "%0 (expect: %1)" => "%0 (expect: %1)",
// "Flash Video" => "Flash Video",
// "Embed a video or audio file" => "Embed a video or audio file",
// "Flash Type" => "Flash Type",
// "Whether you want to insert a Flash from a URL, a fileId from a podcast file\n\t\t\t\t\tgallery or a link to a specific service like Youtube or Vimeo" => "Whether you want to insert a Flash from a URL, a fileId from a podcast file\n\t\t\t\t\tgallery or a link to a specific service like Youtube or Vimeo",
// "Blip.tv" => "Blip.tv",
// "File Gallery Podcast" => "File Gallery Podcast",
// "Movie URL" => "Movie URL",
// "Youtube" => "Youtube",
// "URL to the movie to include, for example, %0" => "URL to the movie to include, for example, %0",
// "File Gallery Podcast ID" => "File Gallery Podcast ID",
// "ID of a file from a podcast gallery - will work only with podcast gallery" => "ID of a file from a podcast gallery - will work only with podcast gallery",
// "YouTube URL" => "YouTube URL",
// "Complete URL to the YouTube video" => "Complete URL to the YouTube video",
// "Vimeo URL" => "Vimeo URL",
// "Complete URL to the Vimeo video" => "Complete URL to the Vimeo video",
// "Width of movie in pixels (default is %0)" => "Width of movie in pixels (default is %0)",
// "Height of movie in pixels (default is %0)" => "Height of movie in pixels (default is %0)",
// "Quality" => "Quality",
// "Flash video quality. Default value: %0" => "Flash video quality. Default value: %0",
// "Medium" => "Medium",
// "Alternative image URL" => "Alternative image URL",
// "Image to display if Flash is not available" => "Image to display if Flash is not available",
// "Invalid URL" => "Invalid URL",
// "Missing parameter movie to the plugin flash" => "Missing parameter movie to the plugin flash",
// "Fluid Grid" => "Fluid Grid",
// "Arrange content into rows and columns using a Bootstrap fluid grid" => "Arrange content into rows and columns using a Bootstrap fluid grid",
// "Text to display in a grid. Use \"---\" to separate the columns and \"@@@\" to separate rows" => "Text to display in a grid. Use \"---\" to separate the columns and \"@@@\" to separate rows",
// "Join Columns" => "Join Columns",
// "Merge empty cells into the cell to their left" => "Merge empty cells into the cell to their left",
// "Device size" => "Device size",
// "Specify the device size below which the cells will be stacked vertically" => "Specify the device size below which the cells will be stacked vertically",
// "Small" => "Small",
// "Large" => "Large",
// "Extra Large" => "Extra Large",
// "Column Sizes" => "Column Sizes",
// "Specify all column widths in units which add up to 12" => "Specify all column widths in units which add up to 12",
"First" => "第一個",
// "Cells specified are ordered first left to right across rows (default) or top to bottom down columns" => "Cells specified are ordered first left to right across rows (default) or top to bottom down columns",
"Column" => "行",
// "Custom Class" => "Custom Class",
// "Add a class to customize the design" => "Add a class to customize the design",
"Font" => "字型",
// "Format the font type and size of text" => "Format the font type and size of text",
"Content" => "內容",
// "Font Family" => "Font Family",
// "Select the font family to display the content" => "Select the font family to display the content",
// "Font Size" => "Font Size",
// "Define the size of the font in pixels (enter %0 to get a font of 12px)" => "Define the size of the font in pixels (enter %0 to get a font of 12px)",
// "Footnote" => "Footnote",
// "Create automatically numbered footnotes (together with PluginFootnoteArea)" => "Create automatically numbered footnotes (together with PluginFootnoteArea)",
// "The footnote" => "The footnote",
// "Tag" => "Tag",
// "Tag footnote with unique identifier" => "Tag footnote with unique identifier",
// "One word made of alphanumeric characters" => "One word made of alphanumeric characters",
// "Same as Tag" => "Same as Tag",
// "Tag to existing footnote by its Tag" => "Tag to existing footnote by its Tag",
// "Same as" => "Same as",
// "Tag to existing footnote number" => "Tag to existing footnote number",
// "tag name (since 17) or footnote number" => "tag name (since 17) or footnote number",
// "Add class to footnotearea" => "Add class to footnotearea",
// "Scheme" => "Scheme",
// "Segregate footnotes by class in footnotearea. Apply different numbering style (optional)" => "Segregate footnotes by class in footnotearea. Apply different numbering style (optional)",
// "Scheme strings (ClassName:((Number Style|numStyle))). Multiples may be separated by | (roman-upper:className|decimal)" => "Scheme strings (ClassName:((Number Style|numStyle))). Multiples may be separated by | (roman-upper:className|decimal)",
// "Error: Tag not found in any previous footnote" => "Error: Tag not found in any previous footnote",
// "Footnote Area" => "Footnote Area",
// "Create automatically numbered footnotes (together with PluginFootnote)" => "Create automatically numbered footnotes (together with PluginFootnote)",
// "Filter footnotearea by footnote class" => "Filter footnotearea by footnote class",
// "SameAs Style" => "SameAs Style",
// "Numbering style for sameas referencing" => "Numbering style for sameas referencing",
// "Valid Tiki ((Number Style))" => "Valid Tiki ((Number Style))",
// "Tagged" => "Tagged",
// "List similarly tagged objects" => "List similarly tagged objects",
// "Tags to find similar to" => "Tags to find similar to",
// "Leave blank to use the object's own tags" => "Leave blank to use the object's own tags",
// "Type of objects to extract. Set to All to find all types" => "Type of objects to extract. Set to All to find all types",
// "Same" => "Same",
"Blog Posts" => "Blog 佈告",
// "Faqs" => "Faqs",
// "Offset" => "Offset",
// "Start record" => "Start record",
// "Default -1 (all)" => "Default -1 (all)",
// "Determine sort order based on various fields (Default: %0)" => "Determine sort order based on various fields (Default: %0)",
// "Comments locked Ascending" => "Comments locked Ascending",
// "Comments locked Descending" => "Comments locked Descending",
// "Description Ascending" => "Description Ascending",
// "Description Descending" => "Description Descending",
// "Href Ascending" => "Href Ascending",
// "Href Descending" => "Href Descending",
// "Object ID Ascending" => "Object ID Ascending",
// "Object ID Descending" => "Object ID Descending",
// "Show objects with names or descriptions similar to the text entered here" => "Show objects with names or descriptions similar to the text entered here",
// "Choose whether to broaden" => "Choose whether to broaden",
// "n|y" => "n|y",
// "Choose the header level for formatting. Default is %0 (for header level h3). Set\n\t\t\t\t\tto %1 for no header tags" => "Choose the header level for formatting. Default is %0 (for header level h3). Set\n\t\t\t\t\tto %1 for no header tags",
// "Show Titles Only" => "Show Titles Only",
// "Choose whether to show titles only (not shown by default)" => "Choose whether to show titles only (not shown by default)",
// "Max Image Size" => "Max Image Size",
// "Height or width in pixels. Default: %0 (no maximum)" => "Height or width in pixels. Default: %0 (no maximum)",
// "Show a 'more' link that links to the full list of tagged objects (not shown by default)" => "Show a 'more' link that links to the full list of tagged objects (not shown by default)",
// "More URL" => "More URL",
// "Alternate \"more\" link pointing to specified URL instead of default full list of tagged objects" => "Alternate \"more\" link pointing to specified URL instead of default full list of tagged objects",
// "More label" => "More label",
// "Alternate text to display on the \"more\" link (default is \"more\")" => "Alternate text to display on the \"more\" link (default is \"more\")",
// "Friend and unfriend other users" => "Friend and unfriend other users",
// "Add or Remove Friend Button" => "Add or Remove Friend Button",
// "Other User" => "Other User",
// "Button Text" => "Button Text",
// "The user you wish to change relations with" => "The user you wish to change relations with",
// "Button text that's displayed when friending a user" => "Button text that's displayed when friending a user",
// "Button text that's displayed when un-friending a user" => "Button text that's displayed when un-friending a user",
// "Add to Friend Network" => "Add to Friend Network",
// "Remove from Friend Network" => "Remove from Friend Network",
// "FTP" => "FTP",
// "Create a button for downloading a file from an FTP server" => "Create a button for downloading a file from an FTP server",
// "File name on the server" => "File name on the server",
// "Server Name" => "Server Name",
// "Name of the server for the FTP account. Example: " => "Name of the server for the FTP account. Example: ",
// "Username for the FTP account" => "Username for the FTP account",
// "Password for the FTP account" => "Password for the FTP account",
// "Download Button Label" => "Download Button Label",
// "Label for the FTP download button" => "Label for the FTP download button",
// "missing parameters" => "missing parameters",
// "Connection failed" => "Connection failed",
// "Set a Full-Width Page Title" => "Set a Full-Width Page Title",
// "Display the page title the full width of the site content container. " => "Display the page title the full width of the site content container. ",
// "PluginFullWidthTitle" => "PluginFullWidthTitle",
// "Page title" => "Page title",
// "If you need to include tpl files" => "If you need to include tpl files",
// "Icon Source" => "Icon Source",
// "Source path of the icon" => "Source path of the icon",
// "Galleriffic" => "Galleriffic",
// "Display a slideshow of images on a page using the Galleriffic script" => "Display a slideshow of images on a page using the Galleriffic script",
// "Sort by database table field name, ascending (_asc) or descending (_desc). Examples:\n\t\t\t\t\t%0 or %1" => "Sort by database table field name, ascending (_asc) or descending (_desc). Examples:\n\t\t\t\t\t%0 or %1",
// "%0 or %1 with actual table field name in place of %2" => "%0 or %1 with actual table field name in place of %2",
// "Thumbs Width" => "Thumbs Width",
// "Width in pixels or percentage. (e.g. %0 or %1)" => "Width in pixels or percentage. (e.g. %0 or %1)",
// "Image Slideshow Width" => "Image Slideshow Width",
// "Width in pixels or percentage of the largest image. (e.g. %0 or %1)" => "Width in pixels or percentage of the largest image. (e.g. %0 or %1)",
// "Image Slideshow Height" => "Image Slideshow Height",
// "Height in pixels or percentage of the largest images. (e.g. %0 or %1)" => "Height in pixels or percentage of the largest images. (e.g. %0 or %1)",
// "Start Slideshow" => "Start Slideshow",
// "Automatically start the slideshow" => "Automatically start the slideshow",
// "Delay" => "Delay",
// "Delay in milliseconds between each transition" => "Delay in milliseconds between each transition",
// "Number of thumbnails" => "Number of thumbnails",
// "The number of thumbnails to show per page" => "The number of thumbnails to show per page",
// "Show Top Pager" => "Show Top Pager",
// "Display thumbnail pager at top" => "Display thumbnail pager at top",
// "Show Bottom Pager" => "Show Bottom Pager",
// "Display thumbnail pager at bottom" => "Display thumbnail pager at bottom",
// "Play Slideshow" => "Play Slideshow",
// "Pause Slideshow" => "Pause Slideshow",
// "Previous Photo" => "Previous Photo",
// "Next Photo" => "Next Photo",
"Prev" => "前一個",
// "Gantt Chart" => "Gantt Chart",
// "Create and display a gantt graphic using tracker data" => "Create and display a gantt graphic using tracker data",
// "Tracker to search from" => "Tracker to search from",
// "Order Field" => "Order Field",
// "Permanent name of the field to use for row number order" => "Permanent name of the field to use for row number order",
// "Level Field" => "Level Field",
// "Permanent name of the field to use for row level" => "Permanent name of the field to use for row level",
// "Status Field" => "Status Field",
// "Permanent name of the field to use for row status" => "Permanent name of the field to use for row status",
// "Dependency Field" => "Dependency Field",
// "Permanent name of the field to use for row dependency" => "Permanent name of the field to use for row dependency",
// "Progress Field" => "Progress Field",
// "Permanent name of the field to use for row progress, values between 0-100" => "Permanent name of the field to use for row progress, values between 0-100",
// "Name Field" => "Name Field",
// "Permanent name of the field to use for row name" => "Permanent name of the field to use for row name",
// "Description Field" => "Description Field",
// "Permanent name of the field to use for row description" => "Permanent name of the field to use for row description",
// "Code Field" => "Code Field",
// "Permanent name of the field to use for row code" => "Permanent name of the field to use for row code",
// "Begin Date Field" => "Begin Date Field",
// "Permanent name of the field to use for event beginning" => "Permanent name of the field to use for event beginning",
// "End Date Field" => "End Date Field",
// "Permanent name of the field to use for event ending" => "Permanent name of the field to use for event ending",
// "Resources Field" => "Resources Field",
// "Permanent name of the field to use for resources ending" => "Permanent name of the field to use for resources ending",
// "Roles Field" => "Roles Field",
// "Permanent name of the field to use for roles ending" => "Permanent name of the field to use for roles ending",
// "Effort Field" => "Effort Field",
// "Permanent name of the field to use for effort ending, values in milliseconds" => "Permanent name of the field to use for effort ending, values in milliseconds",
// "Start Is Milestone" => "Start Is Milestone",
// "Flag field to start is milestone" => "Flag field to start is milestone",
// "End Is Milestone" => "End Is Milestone",
// "Flag field to end is milestone" => "Flag field to end is milestone",
// "Writable" => "Writable",
// "Flag field to write or not in tasks" => "Flag field to write or not in tasks",
// "Deletable" => "Deletable",
// "Flag field that permit to delete or not tasks" => "Flag field that permit to delete or not tasks",
// "Parent Writable" => "Parent Writable",
// "Flag field to write or not in parent tasks" => "Flag field to write or not in parent tasks",
// "Missing required files, please make sure plugin files are installed at vendor_bundled/vendor/robicch/jquery-gantt. <br/><br /> To install, please run composer" => "Missing required files, please make sure plugin files are installed at vendor_bundled/vendor/robicch/jquery-gantt. <br/><br /> To install, please run composer",
// "Tracker data source not found" => "Tracker data source not found",
// "Order tracker field parameter is mandatory" => "Order tracker field parameter is mandatory",
// "Level tracker field parameter is mandatory" => "Level tracker field parameter is mandatory",
// "Depends tracker field parameter is mandatory" => "Depends tracker field parameter is mandatory",
// "You are trying to update a tracker that is not used by this gantt chart" => "You are trying to update a tracker that is not used by this gantt chart",
// "Gantt chart updated" => "Gantt chart updated",
// "Gauge" => "Gauge",
// "Display a horizontal bar gauge" => "Display a horizontal bar gauge",
"description" => "描述",
// "Current value to be represented by the gauge" => "Current value to be represented by the gauge",
// "Maximum Value" => "Maximum Value",
// "Maximum possible value. Default: %0" => "Maximum possible value. Default: %0",
// "Label displayed on the left side of the gauge" => "Label displayed on the left side of the gauge",
// "Color" => "Color",
// "Main color of the gauge. Use HTML color codes or names" => "Main color of the gauge. Use HTML color codes or names",
// "Background color of the gauge. Use HTML color codes or names" => "Background color of the gauge. Use HTML color codes or names",
// "Bar width in pixels" => "Bar width in pixels",
// "Label Width" => "Label Width",
// "Label width, in pixels" => "Label width, in pixels",
// "Display Percentage" => "Display Percentage",
// "Set to %0 (Yes) to display a percentage of the maximum" => "Set to %0 (Yes) to display a percentage of the maximum",
// "Display Value" => "Display Value",
// "Set to %1 (No) to hide the numeric value (shown by default)" => "Set to %1 (No) to hide the numeric value (shown by default)",
// "Bar height in pixels" => "Bar height in pixels",
// "GDGraph" => "GDGraph",
// "Create a simple graph from supplied data" => "Create a simple graph from supplied data",
// "Comma-separated data (x,y) to be graphed. A useful option is to generate this data from a LIST\n\t\t\tor CUSTOMSEARCH using a .tpl template or trackerlist plugin placed in the body" => "Comma-separated data (x,y) to be graphed. A useful option is to generate this data from a LIST\n\t\t\tor CUSTOMSEARCH using a .tpl template or trackerlist plugin placed in the body",
// "14, backported to 12.4" => "14, backported to 12.4",
// "Graph Type" => "Graph Type",
// "Defines what ype of graph or chart is to be generated" => "Defines what ype of graph or chart is to be generated",
// "Vertical Bar" => "Vertical Bar",
// "Graph Title" => "Graph Title",
// "Displayed above the graph" => "Displayed above the graph",
// "Alt Tag" => "Alt Tag",
// "Text for image alt tag" => "Text for image alt tag",
// "Graph Image Width" => "Graph Image Width",
// "Overall width in pixels. Default value is %0" => "Overall width in pixels. Default value is %0",
// "Graph Image Height" => "Graph Image Height",
// "Sets the total height in pixels of the image generated to display the entire graph\n\t\t\t\t\t- if not set and %0 is %1 then the image height will be calculated from the number of x,y pairs,\n\t\t\t\t\twhich is useful if the number of x,y pairs is not known eg they are generated using (say) a LIST,\n\t\t\t\t\tCUSTOMSEARCH or trackerlist plugin. The auto height option only works properly if the title is not\n\t\t\t\t\tshown" => "Sets the total height in pixels of the image generated to display the entire graph\n\t\t\t\t\t- if not set and %0 is %1 then the image height will be calculated from the number of x,y pairs,\n\t\t\t\t\twhich is useful if the number of x,y pairs is not known eg they are generated using (say) a LIST,\n\t\t\t\t\tCUSTOMSEARCH or trackerlist plugin. The auto height option only works properly if the title is not\n\t\t\t\t\tshown",
// "Get Security Token" => "Get Security Token",
// "PluginGetAccessToken" => "PluginGetAccessToken",
// "Display a link on a secure page using an access token" => "Display a link on a secure page using an access token",
// "Entry Patg" => "Entry Patg",
// "The path or part of the path that the token is for" => "The path or part of the path that the token is for",
// "Query Keys" => "Query Keys",
// "Query string parameter keys that the token is for, separated by a colon (:)" => "Query string parameter keys that the token is for, separated by a colon (:)",
// "Query Values" => "Query Values",
// "Query string parameter values that the token is for, separated by a colon (:)" => "Query string parameter values that the token is for, separated by a colon (:)",
// "Google Analytics" => "Google Analytics",
// "Add the tracking code for Google Analytics" => "Add the tracking code for Google Analytics",
// "Account Number" => "Account Number",
// "The account number for the site. Your account number from Google looks like\n\t\t\t\t\t%0. All you need to enter is %1" => "The account number for the site. Your account number from Google looks like\n\t\t\t\t\t%0. All you need to enter is %1",
// "Groups Option" => "Groups Option",
// "Define option for Google Analytics groups, include or exclude" => "Define option for Google Analytics groups, include or exclude",
// "Available Groups" => "Available Groups",
// "Google Analytics Chart" => "Google Analytics Chart",
// "Draw charts from Google Analytics data" => "Draw charts from Google Analytics data",
// "JSON File" => "JSON File",
// "Location of the (service account) credentials JSON file. Must be kept private and not web accessible. (Only needed on the first plugin on each page)" => "Location of the (service account) credentials JSON file. Must be kept private and not web accessible. (Only needed on the first plugin on each page)",
// "Profle IDs" => "Profle IDs",
// "In the format ga:XXXXXXX where XXXXXXX the URL of the analytics admin" => "In the format ga:XXXXXXX where XXXXXXX the URL of the analytics admin",
// "Query String" => "Query String",
// "Can be used instead of the parameters below. E.g. \"metrics=ga:users&dimensions=ga:country\", query can be generated here: %0" => "Can be used instead of the parameters below. E.g. \"metrics=ga:users&dimensions=ga:country\", query can be generated here: %0",
// "Metrics" => "Metrics",
// "e.g. \"ga:pageviews\", default \"ga:sessions,ga:users\"" => "e.g. \"ga:pageviews\", default \"ga:sessions,ga:users\"",
// "default \"30daysAgo\"" => "default \"30daysAgo\"",
// "default \"yesterday\"" => "default \"yesterday\"",
// "Dimensions" => "Dimensions",
// "default \"ga:date\"" => "default \"ga:date\"",
// "Segment" => "Segment",
// "default \"\"" => "default \"\"",
// "Max Results" => "Max Results",
// "default 50" => "default 50",
"Sort" => "排序",
// "One of the metrics usually, e.g. \"-ga:sessions\" default \"\"" => "One of the metrics usually, e.g. \"-ga:sessions\" default \"\"",
// "Container" => "Container",
// "ID of a DIV to contain the chart (optional)" => "ID of a DIV to contain the chart (optional)",
// "Type of chart, e.g. LINE, PIE etc" => "Type of chart, e.g. LINE, PIE etc",
// "Bar" => "Bar",
// "Pie" => "Pie",
// "Geo" => "Geo",
// "To draw charts from Google Analytics, Tiki needs the google/apiclient package. If you do not have permission to install this package, ask the site administrator" => "To draw charts from Google Analytics, Tiki needs the google/apiclient package. If you do not have permission to install this package, ask the site administrator",
// "googlechart: No credentials file" => "googlechart: No credentials file",
// "googlechart: No query_ids supplied" => "googlechart: No query_ids supplied",
// "googlechart exception: %0" => "googlechart exception: %0",
// "Google Doc" => "Google Doc",
// "Display a Google document" => "Display a Google document",
// "Leave this empty" => "Leave this empty",
// "Type of Google document" => "Type of Google document",
// "Document" => "Document",
// "Slides" => "Slides",
// "Forms" => "Forms",
// "Key" => "Key",
// "Google doc key - for example" => "Google doc key - for example",
// "Name of iframe. Default is \"Frame\" + the key" => "Name of iframe. Default is \"Frame\" + the key",
// "Size of frame. Use instead of width and height. The sizes will fit the Google\n\t\t\t\t\tpresentations sizes exactly" => "Size of frame. Use instead of width and height. The sizes will fit the Google\n\t\t\t\t\tpresentations sizes exactly",
// "Width in pixels or %" => "Width in pixels or %",
// "Height in pixels or %" => "Height in pixels or %",
// "Position of frame on page" => "Position of frame on page",
// "Middle" => "Middle",
// "Frame Border" => "Frame Border",
// "Choose whether to show a border around the iframe" => "Choose whether to show a border around the iframe",
// "Margin Height" => "Margin Height",
// "Margin height in pixels" => "Margin height in pixels",
// "Margin Width" => "Margin Width",
// "Margin width in pixels" => "Margin width in pixels",
// "Scrolling" => "Scrolling",
// "Choose whether to add a scroll bar" => "Choose whether to add a scroll bar",
// "Auto" => "Auto",
// "Edit Link" => "Edit Link",
// "Choose whether to show an edit link and set its location" => "Choose whether to show an edit link and set its location",
// "Required parameter \"type\" missing" => "Required parameter \"type\" missing",
// "Required parameter \"key\" missing" => "Required parameter \"key\" missing",
// "Display content based on the user's groups or friends" => "Display content based on the user's groups or friends",
// "Wiki text to display if conditions are met. The body may contain %0. Text after the marker\n\t\t\twill be displayed to users not matching the conditions" => "Wiki text to display if conditions are met. The body may contain %0. Text after the marker\n\t\t\twill be displayed to users not matching the conditions",
// "Allowed User Friends" => "Allowed User Friends",
// "Pipe separated list of users whose friends are allowed to view the block.\n\t\t\t\t\tExample" => "Pipe separated list of users whose friends are allowed to view the block.\n\t\t\t\t\tExample",
// "Allowed Groups" => "Allowed Groups",
// "Pipe separated list of groups allowed to view the block.\n\t\t\t\t\tExample" => "Pipe separated list of groups allowed to view the block.\n\t\t\t\t\tExample",
// "Denied Groups" => "Denied Groups",
// "Pipe-separated list of groups not allowed to view the block" => "Pipe-separated list of groups not allowed to view the block",
// "Allowed Groups Pending Membership" => "Allowed Groups Pending Membership",
// "User allowed to view block if membership payment to join group (or pipe-separated\n\t\t\t\t\tlist of groups) is outstanding" => "User allowed to view block if membership payment to join group (or pipe-separated\n\t\t\t\t\tlist of groups) is outstanding",
// "Allowed Groups Full Membership" => "Allowed Groups Full Membership",
// "User allowed to view block if membership in the group (or pipe-separated list of\n\t\t\t\t\tgroups) is not pending" => "User allowed to view block if membership in the group (or pipe-separated list of\n\t\t\t\t\tgroups) is not pending",
// "Group Expiration" => "Group Expiration",
// "Show the expiration date of a group the user belongs to" => "Show the expiration date of a group the user belongs to",
// "The name of an existing group on the site" => "The name of an existing group on the site",
// "not in group" => "not in group",
// "never expires" => "never expires",
// "Group List" => "Group List",
// "Create a complete or filtered list of groups" => "Create a complete or filtered list of groups",
// "If empty, all groups will be listed. Entering a group name will cause only groups\n\t\t\t\t\tthat include this group to be listed" => "If empty, all groups will be listed. Entering a group name will cause only groups\n\t\t\t\t\tthat include this group to be listed",
// "Group Homepage" => "Group Homepage",
// "Link the group name to the group homepage, if there is one (not linked to by default)" => "Link the group name to the group homepage, if there is one (not linked to by default)",
// "Recursively List Groups" => "Recursively List Groups",
// "Recursively list the included groups (the default is to not list them repeatedly)" => "Recursively list the included groups (the default is to not list them repeatedly)",
// "List only your own" => "List only your own",
// "Filter the list of groups to include only the groups from the user viewing the\n                    page (default is not to filter)" => "Filter the list of groups to include only the groups from the user viewing the\n                    page (default is not to filter)",
// "GroupMail Core" => "GroupMail Core",
// "Display GroupMail functions on a page" => "Display GroupMail functions on a page",
// "From Email" => "From Email",
// "Email address to report" => "Email address to report",
// "ID of GroupMail Logs tracker (set up in alias by profile)" => "ID of GroupMail Logs tracker (set up in alias by profile)",
// "ID of GroupMail Logs tracker field (usually set up in alias by profile)" => "ID of GroupMail Logs tracker field (usually set up in alias by profile)",
// "Datetime Field ID" => "Datetime Field ID",
// "Group Stats" => "Group Stats",
// "Show the distribution of users among groups" => "Show the distribution of users among groups",
"Groups" => "群組",
// "Groups, separated by \":\". If empty, all groups will be listed" => "Groups, separated by \":\". If empty, all groups will be listed",
// "Percentage of" => "Percentage of",
// "Show percentage out of all users in site, or just those specified in the groups\n\t\t\t\t\tparameter" => "Show percentage out of all users in site, or just those specified in the groups\n\t\t\t\t\tparameter",
// "Users in groups" => "Users in groups",
// "Site users" => "Site users",
// "Show Percentage" => "Show Percentage",
// "Show the percentage of total users that are members of each group (percentages\n\t\t\t\t\tare shown by default)" => "Show the percentage of total users that are members of each group (percentages\n\t\t\t\t\tare shown by default)",
// "Show Bar" => "Show Bar",
// "Represent the percentage of total users that are members of each group in a bar\n\t\t\t\t\tgraph (default is not to show the bar graph)" => "Represent the percentage of total users that are members of each group in a bar\n\t\t\t\t\tgraph (default is not to show the bar graph)",
// "H5P" => "H5P",
// "Enable the creation, sharing and reuse of interactive HTML5 content" => "Enable the creation, sharing and reuse of interactive HTML5 content",
// "The H5P file in a file gallery" => "The H5P file in a file gallery",
// "H5P is not compatible with the Inline comments (annotations) feature" => "H5P is not compatible with the Inline comments (annotations) feature",
// "Has Bought" => "Has Bought",
// "Check whether a user has bought an item or added it to the shopping cart" => "Check whether a user has bought an item or added it to the shopping cart",
// "PluginHasBought" => "PluginHasBought",
// "Key Name" => "Key Name",
// "Key name of passcode to be checked" => "Key name of passcode to be checked",
// "Key Labels" => "Key Labels",
// "Label of the key name of passcode to be checked" => "Label of the key name of passcode to be checked",
// "Tracker from which to get passcode to check against" => "Tracker from which to get passcode to check against",
// "Field ID from which to get passcode to check against" => "Field ID from which to get passcode to check against",
// "Item ID from which to get passcode to check against" => "Item ID from which to get passcode to check against",
// "Please fill in all fields" => "Please fill in all fields",
// "HTML" => "HTML",
// "Add HTML to a page" => "Add HTML to a page",
"HTML code" => "HTML碼",
// "Move to HTML head" => "Move to HTML head",
// "Insert the code in the HTML head section rather than in the body" => "Insert the code in the HTML head section rather than in the body",
// "Parse wiki syntax within the HTML code" => "Parse wiki syntax within the HTML code",
// "HTML Feed" => "HTML Feed",
// "Add an item to HTML Feed" => "Add an item to HTML Feed",
// "Name of this feed" => "Name of this feed",
// "HTML Feed Link" => "HTML Feed Link",
// "Receive and display content from another site sent using PluginHTMLFeed" => "Receive and display content from another site sent using PluginHTMLFeed",
// "Initial Value" => "Initial Value",
// "Feed Location" => "Feed Location",
// "Content Name" => "Content Name",
// "Content Style" => "Content Style",
// "Highlight" => "Highlight",
// "Asterisk" => "Asterisk",
// "HTML Feed Link Type" => "HTML Feed Link Type",
// "Backlink" => "Backlink",
// "Popup" => "Popup",
// "Hover" => "Hover",
// "Moderated" => "Moderated",
// "Date of last accepted HTML item, not used if not moderated" => "Date of last accepted HTML item, not used if not moderated",
// "Display an icon" => "Display an icon",
// "Name of the icon" => "Name of the icon",
// "Valid icon name" => "Valid icon name",
// "Size of the icon (greater than 0 and less than 10)" => "Size of the icon (greater than 0 and less than 10)",
// "greater than 0 and less than 10" => "greater than 0 and less than 10",
// "Rotate" => "Rotate",
// "Rotate the icon (90, 180 or 270 degrees) or flip it (horizontal or vertical)" => "Rotate the icon (90, 180 or 270 degrees) or flip it (horizontal or vertical)",
// "90, 180, 270, horizontal, vertical" => "90, 180, 270, horizontal, vertical",
// "Style supported by the current icon set" => "Style supported by the current icon set",
// "Iframe" => "Iframe",
// "Include the body of another web page in a scrollable frame within a page" => "Include the body of another web page in a scrollable frame within a page",
// "Frame title" => "Frame title",
// "Pixels or %" => "Pixels or %",
// "Align the iframe on the page" => "Align the iframe on the page",
// "Responsive" => "Responsive",
// "Make the display responsive so that browsers determine dimensions based on the width of their containing block by creating an intrinsic ratio that will properly scale on any device" => "Make the display responsive so that browsers determine dimensions based on the width of their containing block by creating an intrinsic ratio that will properly scale on any device",
// "16 by 9" => "16 by 9",
// "4 by 3" => "4 by 3",
"no" => "否",
// "Display one or more custom-formatted images" => "Display one or more custom-formatted images",
// "Image Source" => "Image Source",
// "Choose where to get the image from" => "Choose where to get the image from",
// "An image in the file galleries" => "An image in the file galleries",
// "An image attached to a wiki page" => "An image attached to a wiki page",
// "An image anywhere on the Internet" => "An image anywhere on the Internet",
// "One random image from a file gallery" => "One random image from a file gallery",
// "Numeric ID of an image in a file gallery (or a comma- or %0-separated list of IDs)" => "Numeric ID of an image in a file gallery (or a comma- or %0-separated list of IDs)",
// "Valid file IDs separated by commas or |" => "Valid file IDs separated by commas or |",
"Image ID" => "影像 ID",
// "Numeric ID of an image in an image gallery (or a comma- or %0-separated list of IDs)" => "Numeric ID of an image in an image gallery (or a comma- or %0-separated list of IDs)",
// "Valid image IDs separated by commas or |" => "Valid image IDs separated by commas or |",
// "Full URL to the image to display" => "Full URL to the image to display",
// "Numeric ID of a file gallery. Displays a random image from that gallery" => "Numeric ID of a file gallery. Displays a random image from that gallery",
// "Numeric ID of a file gallery. Displays all images from that gallery" => "Numeric ID of a file gallery. Displays all images from that gallery",
// "Attachment ID" => "Attachment ID",
// "Numeric ID of an image attached to a wiki page (or a comma- or %0-separated list)" => "Numeric ID of an image attached to a wiki page (or a comma- or %0-separated list)",
// "Valid attachment IDs separated by commas or |" => "Valid attachment IDs separated by commas or |",
"Thumbnail" => "縮圖",
// "Makes the image a thumbnail with various options" => "Makes the image a thumbnail with various options",
// "Simple - links to full size image on a new page" => "Simple - links to full size image on a new page",
// "\"Lightbox\" - enlarges in an overlay box when clicked" => "\"Lightbox\" - enlarges in an overlay box when clicked",
// "Mouseover - enlarges in a popup when moused over" => "Mouseover - enlarges in a popup when moused over",
// "Mouseover (sticky)" => "Mouseover (sticky)",
// "Popup - enlarges in a separate window" => "Popup - enlarges in a separate window",
// "Causes the image to be a link to this address. Overrides %0thumb%1 unless %0thumb%1 is\n\t\t\t\t\tset to %0mouseover%1 or %0mousesticky%1" => "Causes the image to be a link to this address. Overrides %0thumb%1 unless %0thumb%1 is\n\t\t\t\t\tset to %0mouseover%1 or %0mousesticky%1",
// "Image Height" => "Image Height",
// "Height in pixels or percent. Syntax: %0100%1 or %0100px%1 means 100 pixels;\n\t\t\t\t\t%050%%1 means 50 percent. Percent applies when Image Source is set to file galleries images only" => "Height in pixels or percent. Syntax: %0100%1 or %0100px%1 means 100 pixels;\n\t\t\t\t\t%050%%1 means 50 percent. Percent applies when Image Source is set to file galleries images only",
// "Image Width" => "Image Width",
// "Width in pixels or percent. Syntax: %0100%1 or %0100px%1 means 100 pixels;\n\t\t\t\t\t%050%%1 means 50 percent. Percent applies when Image Source is set to file galleries images only" => "Width in pixels or percent. Syntax: %0100%1 or %0100px%1 means 100 pixels;\n\t\t\t\t\t%050%%1 means 50 percent. Percent applies when Image Source is set to file galleries images only",
// "Serve retina images" => "Serve retina images",
// "Serves up retina images to high density screen displays. Width must be set to use this" => "Serves up retina images to high density screen displays. Width must be set to use this",
// "Responsive Image Widths" => "Responsive Image Widths",
// "Comma-separated widths at which we may want the browser to request the image. Requires \"sizes\"" => "Comma-separated widths at which we may want the browser to request the image. Requires \"sizes\"",
// "Sizes" => "Sizes",
// "Comma-separated sizes (in vw, em, px) for the image in xs, sm, md, and lg layouts. Must be 4 parameters" => "Comma-separated sizes (in vw, em, px) for the image in xs, sm, md, and lg layouts. Must be 4 parameters",
// "Maximum Size" => "Maximum Size",
// "Maximum height or width in pixels (largest dimension is scaled). Overrides height\n\t\t\t\t\tand width settings" => "Maximum height or width in pixels (largest dimension is scaled). Overrides height\n\t\t\t\t\tand width settings",
// "Image caption. Use %0name%1 or %0desc%1 or %0namedesc%1 for Tiki name and\n\t\t\t\t\tdescription properties, %0idesc%1 or %0ititle%1 for metadata from the image itself, otherwise\n\t\t\t\t\tenter your own description" => "Image caption. Use %0name%1 or %0desc%1 or %0namedesc%1 for Tiki name and\n\t\t\t\t\tdescription properties, %0idesc%1 or %0ititle%1 for metadata from the image itself, otherwise\n\t\t\t\t\tenter your own description",
// "Alternate Text" => "Alternate Text",
// "Alternate text that displays when image does not load. Set to \"Image\" by default" => "Alternate text that displays when image does not load. Set to \"Image\" by default",
// "Responsive Image" => "Responsive Image",
// "Default set by the admin using a preference and determines whether the image has the %0img-fluid%1 class" => "Default set by the admin using a preference and determines whether the image has the %0img-fluid%1 class",
// "Featured Image" => "Featured Image",
// "Set the image to be used for a thumbnail on referencing social network sites or for other special purpose" => "Set the image to be used for a thumbnail on referencing social network sites or for other special purpose",
// "Comment Ascending" => "Comment Ascending",
// "Comment Descending" => "Comment Descending",
// "Max Hits Ascending" => "Max Hits Ascending",
// "Max Hits Descending" => "Max Hits Descending",
// "User Ascending" => "User Ascending",
// "User Descending" => "User Descending",
// "Author Ascending" => "Author Ascending",
// "Author Descending" => "Author Descending",
// "Locked By Ascending" => "Locked By Ascending",
// "Locked By Descending" => "Locked By Descending",
// "Last modified User Ascending" => "Last modified User Ascending",
// "Last modified User Descending" => "Last modified User Descending",
// "Last modified Date Ascending" => "Last modified Date Ascending",
// "Last modified Date Descending" => "Last modified Date Descending",
// "Delete After Ascending" => "Delete After Ascending",
// "Delete After Descending" => "Delete After Descending",
// "Votes Ascending" => "Votes Ascending",
// "Votes Descending" => "Votes Descending",
// "Points Ascending" => "Points Ascending",
// "Points Descending" => "Points Descending",
// "Archive ID Ascending" => "Archive ID Ascending",
// "Archive ID Descending" => "Archive ID Descending",
// "Enlarge Button" => "Enlarge Button",
// "Adds an enlarge button (magnifying glass icon) below the image for use together\n\t\t\t\t\twith %0thumb%1. Follows %0thumb%1 settings unless %0thumb%1 is set to %0mouseover%1 or %0mousesticky%1\n\t\t\t\t\t(or overridden by %0link%1), otherwise button settings are followed, operating as described above\n\t\t\t\t\tfor %0thumb%1" => "Adds an enlarge button (magnifying glass icon) below the image for use together\n\t\t\t\t\twith %0thumb%1. Follows %0thumb%1 settings unless %0thumb%1 is set to %0mouseover%1 or %0mousesticky%1\n\t\t\t\t\t(or overridden by %0link%1), otherwise button settings are followed, operating as described above\n\t\t\t\t\tfor %0thumb%1",
// "Browse Popup" => "Browse Popup",
// "Specifies the relationship between the link image and the target. Enter %0 to\n\t\t\t\t\tcause the image to enlarge in a popup when clicked" => "Specifies the relationship between the link image and the target. Enter %0 to\n\t\t\t\t\tcause the image to enlarge in a popup when clicked",
// "Image Map" => "Image Map",
// "Name of the image map to use for the image" => "Name of the image map to use for the image",
// "Horizontal spacing" => "Horizontal spacing",
// "Horizontal spacing, in pixels, applied to both sides of the image. It may be necessary to use this legacy type of styling if the legacyalign parameter needs to be used for cases where float does not work eg newsletters viewed as an email" => "Horizontal spacing, in pixels, applied to both sides of the image. It may be necessary to use this legacy type of styling if the legacyalign parameter needs to be used for cases where float does not work eg newsletters viewed as an email",
// "Vertical spacing" => "Vertical spacing",
// "Vertical spacing, in pixels, applied to top and bottom of the image. It may be necessary to use this legacy type of styling if the legacyalign parameter needs to be used for cases where float does not work eg newsletters viewed as an email" => "Vertical spacing, in pixels, applied to top and bottom of the image. It may be necessary to use this legacy type of styling if the legacyalign parameter needs to be used for cases where float does not work eg newsletters viewed as an email",
// "Align image using legacy align tag" => "Align image using legacy align tag",
// "Aligns the image itself using the legacy align tag for cases where float does not work eg newsletters viewed as an email. Can be used in addition to the imalign parameter for cases where web pages are viewed by modern browsers and are used by the Newsletter function to send a web page as an email" => "Aligns the image itself using the legacy align tag for cases where float does not work eg newsletters viewed as an email. Can be used in addition to the imalign parameter for cases where web pages are viewed by modern browsers and are used by the Newsletter function to send a web page as an email",
// "Align Image" => "Align Image",
// "Aligns the image itself. Overridden by any alignment settings in %0styleimage%1.\n\t\t\t\t\tIf %0stylebox%1 or %0desc%1 are also set, then image only aligns inside the box - use %0stylebox%1\n\t\t\t\t\tin this case to align the box on the page" => "Aligns the image itself. Overridden by any alignment settings in %0styleimage%1.\n\t\t\t\t\tIf %0stylebox%1 or %0desc%1 are also set, then image only aligns inside the box - use %0stylebox%1\n\t\t\t\t\tin this case to align the box on the page",
// "Image Style" => "Image Style",
// "Enter %0border%1 to place a dark gray border around the image. Otherwise enter\n\t\t\t\t\tCSS styling syntax for other style effects" => "Enter %0border%1 to place a dark gray border around the image. Otherwise enter\n\t\t\t\t\tCSS styling syntax for other style effects",
// "Align Image Block" => "Align Image Block",
// "Aligns a block around the image (including the image). Image is no longer inline\n\t\t\t\t\twhen this setting is used. Can be overridden by any alignment settings in %0stylebox%1" => "Aligns a block around the image (including the image). Image is no longer inline\n\t\t\t\t\twhen this setting is used. Can be overridden by any alignment settings in %0stylebox%1",
// "Image Block Style" => "Image Block Style",
// "Description Style" => "Description Style",
// "Enter %0right%1 or %0left%1 to align text accordingly. Otherwise enter CSS styling\n\t\t\t\t\tsyntax for other style effects" => "Enter %0right%1 or %0left%1 to align text accordingly. Otherwise enter CSS styling\n\t\t\t\t\tsyntax for other style effects",
// "Wrapping" => "Wrapping",
// "Control how other items wrap around the image" => "Control how other items wrap around the image",
// "CSS class to apply to the image. %0class=\"fixedSize\"%1 prevents the image from being\n\t\t\t\t\tautomatically resized and relocated in Tiki SlideShows" => "CSS class to apply to the image. %0class=\"fixedSize\"%1 prevents the image from being\n\t\t\t\t\tautomatically resized and relocated in Tiki SlideShows",
// "Link Title" => "Link Title",
// "This text will appear in a tool tip when the image is moused over. If this is\n\t\t\t\t\tnot set, the %0desc%1 setting will be used. Use %0name%1 or %0desc%1 or %0namedesc%1 for Tiki name\n\t\t\t\t\tand description properties" => "This text will appear in a tool tip when the image is moused over. If this is\n\t\t\t\t\tnot set, the %0desc%1 setting will be used. Use %0name%1 or %0desc%1 or %0namedesc%1 for Tiki name\n\t\t\t\t\tand description properties",
// "Metadata" => "Metadata",
// "Display the image metadata (IPTC, EXIF and XMP information)" => "Display the image metadata (IPTC, EXIF and XMP information)",
// "Compression Quality" => "Compression Quality",
// "0 to 100 (default is 75)" => "0 to 100 (default is 75)",
// "Default Settings" => "Default Settings",
// "Default configuration settings (usually set by admin in the source code or\n\t\t\t\t\tthrough Plugin Alias)" => "Default configuration settings (usually set by admin in the source code or\n\t\t\t\t\tthrough Plugin Alias)",
// "Mandatory Setting" => "Mandatory Setting",
// "Mandatory configuration settings (usually set by admin in the source code or\n\t\t\t\t\tthrough Plugin Alias)" => "Mandatory configuration settings (usually set by admin in the source code or\n\t\t\t\t\tthrough Plugin Alias)",
// "Image Gallery Image" => "Image Gallery Image",
// "Image gallery browse window for the image will open when the thumbnail is clicked if the image is in a Tiki image gallery" => "Image gallery browse window for the image will open when the thumbnail is clicked if the image is in a Tiki image gallery",
// "Same as \"browse\" except that the page opens in a new window or tab" => "Same as \"browse\" except that the page opens in a new window or tab",
// "Makes the image a thumbnail that enlarges to full size when clicked or moused over (unless \"link\" is set to another target). \"browse\" and \"browsepopup\" only work with image gallery and \"download\" only works with file gallery or attachments" => "Makes the image a thumbnail that enlarges to full size when clicked or moused over (unless \"link\" is set to another target). \"browse\" and \"browsepopup\" only work with image gallery and \"download\" only works with file gallery or attachments",
// "Hide Draw Icon" => "Hide Draw Icon",
// "Do not show draw/edit icon button under image" => "Do not show draw/edit icon button under image",
// "Overlay with zoom" => "Overlay with zoom",
// "Full size image appears with zoom option in a \"Colorbox\" overlay when thumbnail is clicked" => "Full size image appears with zoom option in a \"Colorbox\" overlay when thumbnail is clicked",
// "Zoom" => "Zoom",
// "Adds a magnifying glass icon and zooms the image when hovered over" => "Adds a magnifying glass icon and zooms the image when hovered over",
// "PluginImg: User lacks permission to view image" => "PluginImg: User lacks permission to view image",
// "File is not an image" => "File is not an image",
// "Server does not support image manipulation" => "Server does not support image manipulation",
// "Image lazy loading is enabled but Tiki requires package npm-asset/lozad. If you do not have permission to install this package, ask the site administrator" => "Image lazy loading is enabled but Tiki requires package npm-asset/lozad. If you do not have permission to install this package, ask the site administrator",
// "SVG Image replace error \"%0\"" => "SVG Image replace error \"%0\"",
// "Enlarge" => "Enlarge",
// "''No image specified. One of the following parameters must be set: fileId, randomGalleryId, fgalId, attId, id, or src.''" => "''No image specified. One of the following parameters must be set: fileId, randomGalleryId, fgalId, attId, id, or src.''",
// "''Use one and only one of the following parameters: fileId, randomGalleryId, fgalId, attId, id, or src.''" => "''Use one and only one of the following parameters: fileId, randomGalleryId, fgalId, attId, id, or src.''",
// "Draw on the Image" => "Draw on the Image",
"Include" => "包含",
// "Include a portion of another wiki page" => "Include a portion of another wiki page",
// "Name of the source wiki page (which contains the included portion)" => "Name of the source wiki page (which contains the included portion)",
// "When only a portion of the page should be included, full text of the line after which\n\t\t\t\t\tinclusion should start" => "When only a portion of the page should be included, full text of the line after which\n\t\t\t\t\tinclusion should start",
"Stop" => "stop",
// "When only a portion of the page should be included, full text of the line before which\n\t\t\t\t\tinclusion should end" => "When only a portion of the page should be included, full text of the line before which\n\t\t\t\t\tinclusion should end",
// "Read more button" => "Read more button",
// "Add a \"Read more\" link at the end of included content, linking to the original page. (shows \"Read More\" by default)" => "Add a \"Read more\" link at the end of included content, linking to the original page. (shows \"Read More\" by default)",
// "Read more button label" => "Read more button label",
// "Label of the button linking to the source page (if it is displayed)" => "Label of the button linking to the source page (if it is displayed)",
// "Text to show when the page selected to be included is not found anymore" => "Text to show when the page selected to be included is not found anymore",
// "Permission denied message" => "Permission denied message",
// "Text to show when the page exists but the user has insufficient permissions to see it" => "Text to show when the page exists but the user has insufficient permissions to see it",
// "No version approved error message" => "No version approved error message",
// "Text to show when the page exists but no version is approved" => "Text to show when the page exists but no version is approved",
// "Edit Icon" => "Edit Icon",
// "Option to show the edit icon for the included page (shown by default). Depends on the \"edit icons\" settings" => "Option to show the edit icon for the included page (shown by default). Depends on the \"edit icons\" settings",
// "Max inclusions" => "Max inclusions",
// "Maximum amount of times the same page can be included. Defaults to 5" => "Maximum amount of times the same page can be included. Defaults to 5",
// "Parse Included Page" => "Parse Included Page",
// "Parse the page to be included before adding it to the parent page. This will help if html pages are included in wiki pages or vice versa, but will cause issues with the wiki table of contents" => "Parse the page to be included before adding it to the parent page. This will help if html pages are included in wiki pages or vice versa, but will cause issues with the wiki table of contents",
// "Max characters included" => "Max characters included",
// "Limit the length of the included text" => "Limit the length of the included text",
// "Read more" => "Read more",
// "The text above comes from page \"%s\". Click to go to that page" => "The text above comes from page \"%s\". Click to go to that page",
// "Include Plugin" => "Include Plugin",
// "Edit the included page" => "Edit the included page",
// "Include Template File" => "Include Template File",
// "Include a Smarty template (.tpl) file in a page" => "Include a Smarty template (.tpl) file in a page",
// "TPL file name" => "TPL file name",
// "If you need to include Smarty template files" => "If you need to include Smarty template files",
// "Values passed to the TPL" => "Values passed to the TPL",
// "Values to be passed to tpl file, for example %0, which can then be accessed in the Smarty template file as %1" => "Values to be passed to tpl file, for example %0, which can then be accessed in the Smarty template file as %1",
// "Include URL" => "Include URL",
// "Include the body content from a URL" => "Include the body content from a URL",
// "URL to external file to include" => "URL to external file to include",
// "Missing parameter url for plugin %0" => "Missing parameter url for plugin %0",
// "Insert Tracker Item" => "Insert Tracker Item",
// "Create a tracker item when the plugin is inserted in the page. The plugin code is removed and replaced by a link to the newly created item" => "Create a tracker item when the plugin is inserted in the page. The plugin code is removed and replaced by a link to the newly created item",
// "Item not inserted" => "Item not inserted",
// "Invite" => "Invite",
// "Invite a user to join your groups" => "Invite a user to join your groups",
// "Confirmation message after posting form" => "Confirmation message after posting form",
// "Including Group" => "Including Group",
// "Will list only the groups that include this group" => "Will list only the groups that include this group",
// "Default Group" => "Default Group",
// "Dropdown list will show this group by default" => "Dropdown list will show this group by default",
// "Dropdown list will show the group related to this item ID (in group selector or\n\t\t\t\t\tcreator field) by default" => "Dropdown list will show the group related to this item ID (in group selector or\n\t\t\t\t\tcreator field) by default",
// "The following mandatory fields are missing" => "The following mandatory fields are missing",
// "Email address" => "Email address",
// "Add jQuery JavaScript code" => "Add jQuery JavaScript code",
// "JavaScript code" => "JavaScript code",
// "Not On Ready" => "Not On Ready",
// "Do not execute on document ready (execute inline)" => "Do not execute on document ready (execute inline)",
// "No JavaScript" => "No JavaScript",
// "Optional markup for when JavaScript is off" => "Optional markup for when JavaScript is off",
// "Language to apply JQuery to" => "Language to apply JQuery to",
// "<!-- jq plugin inactive: JavaScript off -->" => "<!-- jq plugin inactive: JavaScript off -->",
// "JavaScript" => "JavaScript",
// "Add JavaScript code or files" => "Add JavaScript code or files",
// "JavaScript filename" => "JavaScript filename",
// "Late Load" => "Late Load",
// "Late load, use headerlib" => "Late load, use headerlib",
// "Display a video created through the Kaltura feature" => "Display a video created through the Kaltura feature",
// "Kaltura Entry ID" => "Kaltura Entry ID",
// "Kaltura ID of the video to be displayed, or leave empty to show a button to allow\n\t\t\t\t\tusers to add a new one" => "Kaltura ID of the video to be displayed, or leave empty to show a button to allow\n\t\t\t\t\tusers to add a new one",
// "Kaltura Video Player ID" => "Kaltura Video Player ID",
// "Width of the player in pixels or percent" => "Width of the player in pixels or percent",
// "Height of the player in pixels or percent" => "Height of the player in pixels or percent",
// "Align" => "Align",
// "Alignment of the player" => "Alignment of the player",
// "Not set" => "Not set",
// "Centre" => "Centre",
// "Alignment of the player using CSS float" => "Alignment of the player using CSS float",
// "Add Media Button Label" => "Add Media Button Label",
// "Text to display on button for adding new media" => "Text to display on button for adding new media",
// "Add media" => "Add media",
// "Player Type" => "Player Type",
// "Set player type" => "Set player type",
// "KDP" => "KDP",
// "HTML5" => "HTML5",
// "Upload Media" => "Upload Media",
// "Media ID or permission to upload video is required" => "Media ID or permission to upload video is required",
// "Log in to upload video" => "Log in to upload video",
// "Player not found" => "Player not found",
// "Kaltura player: unsupported type" => "Kaltura player: unsupported type",
// "Show alternative content based on the page language" => "Show alternative content based on the page language",
// "Content to show" => "Content to show",
// "List of languages for which the block is displayed. Languages use the two letter\n\t\t\t\t\tlanguage codes (ex: en, fr, es, ...). Use %0 to separate multiple languages" => "List of languages for which the block is displayed. Languages use the two letter\n\t\t\t\t\tlanguage codes (ex: en, fr, es, ...). Use %0 to separate multiple languages",
// "Not Language" => "Not Language",
// "List of languages for which the block is not displayed. Languages use the two\n\t\t\t\t\tletter language codes (ex: en, fr, es, ...). Use %0 to separate multiple languages" => "List of languages for which the block is not displayed. Languages use the two\n\t\t\t\t\tletter language codes (ex: en, fr, es, ...). Use %0 to separate multiple languages",
// "Show the last modification date for a page" => "Show the last modification date for a page",
// "Page name to display information of. Default value is current page" => "Page name to display information of. Default value is current page",
// "Date format" => "Date format",
// "Set date and time format according to site settings" => "Set date and time format according to site settings",
// "Long date" => "Long date",
// "Short date" => "Short date",
// "Long datetime" => "Long datetime",
// "Short datetime" => "Short datetime",
// "ISO" => "ISO",
// "Plugin to control width/background/header and footer of individual page, helpful in creating landing pages for projects" => "Plugin to control width/background/header and footer of individual page, helpful in creating landing pages for projects",
// "Display page header" => "Display page header",
// "Set to No, to hide header on the page" => "Set to No, to hide header on the page",
// "Display Page Footer" => "Display Page Footer",
// "Display Page Left Bar" => "Display Page Left Bar",
// "Set to No, to hide left on the page" => "Set to No, to hide left on the page",
// "Display Page Right Bar" => "Display Page Right Bar",
// "Set to No, to hide right on the page" => "Set to No, to hide right on the page",
// "Page Full Width" => "Page Full Width",
// "100% Page width" => "100% Page width",
// "Page Content Width" => "Page Content Width",
// "Enter page content width in px or % for example 1000px, leave blank for same width as page body.)" => "Enter page content width in px or % for example 1000px, leave blank for same width as page body.)",
// "Page Background Image URL" => "Page Background Image URL",
// "Enter image url, in case of single image" => "Enter image url, in case of single image",
// "Background Repear" => "Background Repear",
// "Cover,Repeat,no-repeat" => "Cover,Repeat,no-repeat",
// "Page Background Sliding Images" => "Page Background Sliding Images",
// "Enter file gallery id for fading background" => "Enter file gallery id for fading background",
// "Page Content Top Margin" => "Page Content Top Margin",
// "Enter value in % or px for example 30%, 300px, default will be 0" => "Enter value in % or px for example 30%, 300px, default will be 0",
// "Page Header Width" => "Page Header Width",
// "Enter page header width in px or %, leave blank for same width as page body.)" => "Enter page header width in px or %, leave blank for same width as page body.)",
// "Page Footer Width" => "Page Footer Width",
// "Enter page footer width in px or %, leave blank for same width as page body.)" => "Enter page footer width in px or %, leave blank for same width as page body.)",
// "Page Background Color" => "Page Background Color",
// "Enter a valid CSS color code, or an rgba value if opacity is desired; for example: #000 or rgba(00, 00, 00, 0.5)" => "Enter a valid CSS color code, or an rgba value if opacity is desired; for example: #000 or rgba(00, 00, 00, 0.5)",
// "Content Background Color" => "Content Background Color",
// "Content Text Color" => "Content Text Color",
// "Enter a valid CSS color code, for example #000,#fff,#ccc" => "Enter a valid CSS color code, for example #000,#fff,#ccc",
// "Content Border Radius" => "Content Border Radius",
// "To make content div round cornered, for example 10px" => "To make content div round cornered, for example 10px",
// "Content Border Shadow" => "Content Border Shadow",
// "For shadow around content box, for example: 10px 10px 5px grey, 1px 2px 4px rgba(0, 0, 0, .5), 0 4px 8px 0 rgba(0, 0, 0, 0.2)" => "For shadow around content box, for example: 10px 10px 5px grey, 1px 2px 4px rgba(0, 0, 0, .5), 0 4px 8px 0 rgba(0, 0, 0, 0.2)",
// "Transition Delay" => "Transition Delay",
// "Time interval to pause before moving to next slide in seconds" => "Time interval to pause before moving to next slide in seconds",
// "Display Page Action Buttons" => "Display Page Action Buttons",
// "Set to No, to hide page action buttons, with and under content" => "Set to No, to hide page action buttons, with and under content",
// "Display top bar(under header)" => "Display top bar(under header)",
// "Set to No, to hide topbar on the page" => "Set to No, to hide topbar on the page",
// "Display page top bar(above page content)" => "Display page top bar(above page content)",
// "Set to No, to hide page topbar module zone" => "Set to No, to hide page topbar module zone",
// "Display page bottom bar(under page content)" => "Display page bottom bar(under page content)",
// "Set to No, to hide page bottom bar module zone" => "Set to No, to hide page bottom bar module zone",
// "Create a \"Like\" button" => "Create a \"Like\" button",
// "Count only" => "Count only",
// "Sets whether to only show the count of likes rather than give the option to vote" => "Sets whether to only show the count of likes rather than give the option to vote",
// "Search for, list, and filter all types of items and display custom-formatted results" => "Search for, list, and filter all types of items and display custom-formatted results",
// "Use List GUI" => "Use List GUI",
// "Use the graphical user interface for editing this list plugin" => "Use the graphical user interface for editing this list plugin",
// "Cache Output" => "Cache Output",
// "Cache output of this list plugin" => "Cache output of this list plugin",
// "Cache Expiry Time" => "Cache Expiry Time",
// "Time before cache is expired in minutes" => "Time before cache is expired in minutes",
// "Cache Purge Rules" => "Cache Purge Rules",
// "Purge the cache when the type:id objects are updated. Set id=0 for any of that type. Or set type:withparam:x. Examples: trackeritem:20, trackeritem:trackerId:3, file:galleryId:5, forum post:forum_id:7, forum post:parent_id:8. Note that rule changes affect future caching, not past caches" => "Purge the cache when the type:id objects are updated. Set id=0 for any of that type. Or set type:withparam:x. Examples: trackeritem:20, trackeritem:trackerId:3, file:galleryId:5, forum post:forum_id:7, forum post:parent_id:8. Note that rule changes affect future caching, not past caches",
// "This is for much better performance by doing one search for multiple LIST plugins together. Render results from previous {MULTISEARCH(id-x)}...{MULTISEARCH} block by providing the ID used in that block" => "This is for much better performance by doing one search for multiple LIST plugins together. Render results from previous {MULTISEARCH(id-x)}...{MULTISEARCH} block by providing the ID used in that block",
// "Error: {MULTISEARCH(id=x)} requires use of Elasticsearch as the engine" => "Error: {MULTISEARCH(id=x)} requires use of Elasticsearch as the engine",
// "Error: {MULTISEARCH(id=x)} needs an ID to be specified" => "Error: {MULTISEARCH(id=x)} needs an ID to be specified",
// "List Execute" => "List Execute",
// "Set custom actions that can be executed on a filtered list of objects" => "Set custom actions that can be executed on a filtered list of objects",
// "Invalid action: %0" => "Invalid action: %0",
// "There are too many search result items to apply %0 action to" => "There are too many search result items to apply %0 action to",
// "Unknown error executing action %0 on item %1" => "Unknown error executing action %0 on item %1",
// "Error executing action %0 on item %1" => "Error executing action %0 on item %1",
// "Action %0 executed successfully on %1 item(s)" => "Action %0 executed successfully on %1 item(s)",
"List Pages" => "列出頁面",
// "List pages based on various criteria" => "List pages based on various criteria",
// "Result number at which the listing should start" => "Result number at which the listing should start",
// "Limit number of items displayed in the list. Default is to display all" => "Limit number of items displayed in the list. Default is to display all",
// "Initial" => "Initial",
// "Initial page to show" => "Initial page to show",
// "Show Name Only" => "Show Name Only",
// "Show only the page names" => "Show only the page names",
// "Category Filter" => "Category Filter",
// "Filter categories by Id numbers. Use different separators to filter as follows" => "Filter categories by Id numbers. Use different separators to filter as follows",
// "Page is in any of the specified categories. Example" => "Page is in any of the specified categories. Example",
// "Page must be in all of the specified categories. Example" => "Page must be in all of the specified categories. Example",
// "Page is in the first specified category and not in any of the others. Example" => "Page is in the first specified category and not in any of the others. Example",
// "Valid category ID or list separated by :, + or -" => "Valid category ID or list separated by :, + or -",
// "Structure Head" => "Structure Head",
// "Filter by structure head" => "Filter by structure head",
// "Show Page Alias" => "Show Page Alias",
// "Show page alias in the list" => "Show page alias in the list",
// "Include Tag" => "Include Tag",
// "Only pages with specific tag (separate tags using %0)" => "Only pages with specific tag (separate tags using %0)",
// "Exclude Tag" => "Exclude Tag",
// "Only pages with specific tag excluded (separate tags using %0)" => "Only pages with specific tag excluded (separate tags using %0)",
// "Show Number of Pages" => "Show Number of Pages",
// "Show the number of pages matching criteria" => "Show the number of pages matching criteria",
// "Only pages with names similar to the text entered for this parameter will be listed" => "Only pages with names similar to the text entered for this parameter will be listed",
// "Two-letter language code to filter pages listed" => "Two-letter language code to filter pages listed",
// "Orphan Language" => "Orphan Language",
// "Two-letter language code to filter pages listed. Only pages not available in the\n\t\t\t\t\tprovided language will be listed" => "Two-letter language code to filter pages listed. Only pages not available in the\n\t\t\t\t\tprovided language will be listed",
// "Load Translations" => "Load Translations",
// "User- or pipe-separated list of two-letter language codes for additional languages\n\t\t\t\t\tto display. If the language parameter is not defined, the first element of this list will be used\n\t\t\t\t\tas the primary filter" => "User- or pipe-separated list of two-letter language codes for additional languages\n\t\t\t\t\tto display. If the language parameter is not defined, the first element of this list will be used\n\t\t\t\t\tas the primary filter",
// "Page name and text entered for the filter parameter must match exactly to be listed" => "Page name and text entered for the filter parameter must match exactly to be listed",
// "Only Orphan Pages" => "Only Orphan Pages",
// "Only list orphan pages" => "Only list orphan pages",
// "For List Pages" => "For List Pages",
// "Sort ascending or descending on any field in the tiki_pages table. Syntax is\n\t\t\t\t\tfield name followed by _asc or _desc. Two examples" => "Sort ascending or descending on any field in the tiki_pages table. Syntax is\n\t\t\t\t\tfield name followed by _asc or _desc. Two examples",
// "When only a portion of the page should be included, specify the marker from which\n\t\t\t\t\tinclusion should start" => "When only a portion of the page should be included, specify the marker from which\n\t\t\t\t\tinclusion should start",
// "When only a portion of the page should be included, specify the marker at which\n\t\t\t\t\tinclusion should end" => "When only a portion of the page should be included, specify the marker at which\n\t\t\t\t\tinclusion should end",
// "Length" => "Length",
// "Number of characters to display" => "Number of characters to display",
// "Checkboxes" => "Checkboxes",
// "Offset Argument" => "Offset Argument",
// "Pagination" => "Pagination",
// "Exclude Page(s)" => "Exclude Page(s)",
// "Wiki page names to be excluded from list" => "Wiki page names to be excluded from list",
// "Local Files" => "Local Files",
// "Show a link to local or shared files and directories" => "Show a link to local or shared files and directories",
// "Local file or directory path" => "Local file or directory path",
// "List Directory" => "List Directory",
// "If the path above is a directory then list the contents" => "If the path above is a directory then list the contents",
// "Show MIME file-type icons" => "Show MIME file-type icons",
// "List files in a directory" => "List files in a directory",
// "Full path to the server-local directory. Default is the document root" => "Full path to the server-local directory. Default is the document root",
// "URL Prefix" => "URL Prefix",
// "Make the file name a link to the file by adding the URL path preceding the file\n\t\t\t\t\tname. Example" => "Make the file name a link to the file by adding the URL path preceding the file\n\t\t\t\t\tname. Example",
// "Set the sort order of the file list" => "Set the sort order of the file list",
// "File Name" => "File Name",
// "File Size" => "File Size",
// "Last Access" => "Last Access",
// "Last Metadata Change" => "Last Metadata Change",
// "Only list files with file names that contain this filter. Example" => "Only list files with file names that contain this filter. Example",
// "Limit" => "Limit",
// "Maximum amount of files to display. Default is no limit" => "Maximum amount of files to display. Default is no limit",
// "could not be opened because it doesn't exist or permission was denied" => "could not be opened because it doesn't exist or permission was denied",
// "Mail" => "Mail",
// "Mail other users or groups" => "Mail other users or groups",
// "Limit the list of groups to the groups including each group" => "Limit the list of groups to the groups including each group",
// "Group Dropdown" => "Group Dropdown",
// "Show a dropdown list of groups (not shown by default)" => "Show a dropdown list of groups (not shown by default)",
// "Recurse Groups" => "Recurse Groups",
// "Show each group and each group included in this group" => "Show each group and each group included in this group",
// "Recurse Group Users" => "Recurse Group Users",
// "Indicate how many times to recurse to collect the users of a selected group and\n\t\t\t\t\tthe users of each included groups. If %00%1 do not recurse, if %01%1, recurse one time, %02%1 for\n\t\t\t\t\ttwo times..." => "Indicate how many times to recurse to collect the users of a selected group and\n\t\t\t\t\tthe users of each included groups. If %00%1 do not recurse, if %01%1, recurse one time, %02%1 for\n\t\t\t\t\ttwo times...",
// "User Dropdown" => "User Dropdown",
// "Show a dropdown list of users (not shown by default)" => "Show a dropdown list of users (not shown by default)",
// "User Emails" => "User Emails",
// "Show a box for user to enter email addresses" => "Show a box for user to enter email addresses",
// "Real Name Dropdown" => "Real Name Dropdown",
// "Show a dropdown list of user real names (not shown by default)" => "Show a dropdown list of user real names (not shown by default)",
// "Show in popup instead of inline" => "Show in popup instead of inline",
// "Text to show on the button to send emails (default: %0Send mail%1)" => "Text to show on the button to send emails (default: %0Send mail%1)",
// "Send mail" => "Send mail",
// "Email Subject" => "Email Subject",
// "Present Email subject content" => "Present Email subject content",
// "Bypass Preview" => "Bypass Preview",
// "Send emails without first previewing" => "Send emails without first previewing",
// "Debug mode (admins only)" => "Debug mode (admins only)",
// "Show list of emails that are sent (admins only)" => "Show list of emails that are sent (admins only)",
// "Mail send was unsuccessful" => "Mail send was unsuccessful",
"Map" => "地圖",
// "Display a map" => "Display a map",
// "Instructions to load content" => "Instructions to load content",
// "Scope" => "Scope",
// "Display the geolocated items represented in the page (%0all%1, %0center%1, or\n\t\t\t\t\t%0custom%1 as a CSS selector). Default: %0center%1" => "Display the geolocated items represented in the page (%0all%1, %0center%1, or\n\t\t\t\t\t%0custom%1 as a CSS selector). Default: %0center%1",
// "Controls" => "Controls",
// "Comma-separated list of map controls will be displayed on the map and around it" => "Comma-separated list of map controls will be displayed on the map and around it",
// "Width of the map in pixels" => "Width of the map in pixels",
// "Height of the map in pixels" => "Height of the map in pixels",
// "Format: %0x,y,zoom%1 where %0x%1 is the longitude, and %0y%1 is the latitude.\n\t\t\t\t\t%0zoom%1 is between %00%1 (view Earth) and %019%1" => "Format: %0x,y,zoom%1 where %0x%1 is the longitude, and %0y%1 is the latitude.\n\t\t\t\t\t%0zoom%1 is between %00%1 (view Earth) and %019%1",
// "Popup Style" => "Popup Style",
// "Alter the way the information is displayed when objects are loaded on the map" => "Alter the way the information is displayed when objects are loaded on the map",
// "Bubble" => "Bubble",
// "MapServer File" => "MapServer File",
// "MapServer file identifier. Only fill this in if you are using MapServer" => "MapServer file identifier. Only fill this in if you are using MapServer",
// "Extents" => "Extents",
// "Size of the map" => "Size of the map",
// "Show item name in a tooltip on hover" => "Show item name in a tooltip on hover",
// "Open Layers Version" => "Open Layers Version",
// "OL2 or OL3+ so far (default ol2)" => "OL2 or OL3+ so far (default ol2)",
// "OpenLayers 2.x" => "OpenLayers 2.x",
// "Tileset layers" => "Tileset layers",
// "Tilesets to use for background layers, comma separated. Tileset groups can be added separated by a tilde character (requires Open Layers v3+, default is the geo_tilesets preference)" => "Tilesets to use for background layers, comma separated. Tileset groups can be added separated by a tilde character (requires Open Layers v3+, default is the geo_tilesets preference)",
// "Cluster Distance" => "Cluster Distance",
// "Distance between features before they are \"clustered\", 0 (off) to 100. (requires Open Layers v3+, default is 0)" => "Distance between features before they are \"clustered\", 0 (off) to 100. (requires Open Layers v3+, default is 0)",
// "Cluster Hover Behavior" => "Cluster Hover Behavior",
// "Appearance of clusters on mouse over. (requires Open Layers v3+, default is features)" => "Appearance of clusters on mouse over. (requires Open Layers v3+, default is features)",
// "Show Features" => "Show Features",
// "Cluster Fill Color" => "Cluster Fill Color",
// "Cluster fill color in RGB. (requires Open Layers v3+, default is 86, 134, 200)" => "Cluster fill color in RGB. (requires Open Layers v3+, default is 86, 134, 200)",
// "Cluster Text Color" => "Cluster Text Color",
// "Cluster text and outline color in RGB. (requires Open Layers v3+, default is 255, 255, 255)" => "Cluster text and outline color in RGB. (requires Open Layers v3+, default is 255, 255, 255)",
// "Color Picker" => "Color Picker",
// "Markdown" => "Markdown",
// "Parse the body of the plugin using a Markdown parser" => "Parse the body of the plugin using a Markdown parser",
// "Markdown syntax to be parsed" => "Markdown syntax to be parsed",
// "Mayan Calendars" => "Mayan Calendars",
// "Convert a Gregorian date to a Mayan calendar date" => "Convert a Gregorian date to a Mayan calendar date",
// "You must use the variable substitution" => "You must use the variable substitution",
// "LongCount: " => "LongCount: ",
// "Tzolkin: " => "Tzolkin: ",
// "Haab: " => "Haab: ",
// "Misc: " => "Misc: ",
// "Example: template " => "Example: template ",
// "for %022.05.2009%1 will return 12.19.16.6.11, 8 CHUEN, 9 SIP" => "for %022.05.2009%1 will return 12.19.16.6.11, 8 CHUEN, 9 SIP",
// "Default template: " => "Default template: ",
// "Gregorian date" => "Gregorian date",
// "Gregorian date for convert. Format: %0DD.MM.YYYY%1. Default: Today's date" => "Gregorian date for convert. Format: %0DD.MM.YYYY%1. Default: Today's date",
// " is not a valid date format. should be dd.mm.yyyy" => " is not a valid date format. should be dd.mm.yyyy",
// "Media Player" => "Media Player",
// "Add a media player to a page" => "Add a media player to a page",
// "Allow full-screen" => "Allow full-screen",
// "Allow full-screen mode" => "Allow full-screen mode",
// "MP3 URL" => "MP3 URL",
// "FLV URL" => "FLV URL",
// "File type for source URL, e.g. %0mp4%1, %0pdf%1 or %0odp%1. Specify one of the supported file types when\n\t\t\t\t\tthe URL of the file is missing the file extension. This is the case for File Gallery files which\n\t\t\t\t\thave a URL such as %0tiki-download_file.php?fileId=4&display%1 or %0display4%1 if you have Clean URLs\n\t\t\t\t\tenabled" => "File type for source URL, e.g. %0mp4%1, %0pdf%1 or %0odp%1. Specify one of the supported file types when\n\t\t\t\t\tthe URL of the file is missing the file extension. This is the case for File Gallery files which\n\t\t\t\t\thave a URL such as %0tiki-download_file.php?fileId=4&display%1 or %0display4%1 if you have Clean URLs\n\t\t\t\t\tenabled",
// "Player width in px or %" => "Player width in px or %",
// "Player height in px or %" => "Player height in px or %",
// "Set the style" => "Set the style",
// "Media Type" => "Media Type",
// "Media type for HTML5" => "Media type for HTML5",
// "Audio" => "Audio",
// "Video" => "Video",
// "Flash Window Mode" => "Flash Window Mode",
// "Sets the Window Mode property of the Flash movie. Transparent lets what's behind\n\t\t\t\t\tthe movie show through and allows the movie to be covered Opaque hides what's behind the movie and\n\t\t\t\t\tWindow plays the movie in its own window. Default value: " => "Sets the Window Mode property of the Flash movie. Transparent lets what's behind\n\t\t\t\t\tthe movie show through and allows the movie to be covered Opaque hides what's behind the movie and\n\t\t\t\t\tWindow plays the movie in its own window. Default value: ",
// "Transparent" => "Transparent",
// "Opaque" => "Opaque",
// "Window" => "Window",
// "Complete URL to the MP3 to include. Examples: %0http://example.org/example.mp3%1\n\t\t\t\t\tfor an external file, or for a video file in the site's File Gallery:\n\t\t\t\t\t%0tiki-download_file.php?fileId=2%1 (No need for %0http://%1 in this case)" => "Complete URL to the MP3 to include. Examples: %0http://example.org/example.mp3%1\n\t\t\t\t\tfor an external file, or for a video file in the site's File Gallery:\n\t\t\t\t\t%0tiki-download_file.php?fileId=2%1 (No need for %0http://%1 in this case)",
// "Complete URL to the FLV to include. Examples: %0http://example.org/example.flv%1\n\t\t\t\t\tfor an external file, or for a video file in the site's File Gallery:\n\t\t\t\t\t%0tiki-download_file.php?fileId=2%1 (the missing %0//%1 is intentional as this is a valid internal\n\t\t\t\t\tlink)" => "Complete URL to the FLV to include. Examples: %0http://example.org/example.flv%1\n\t\t\t\t\tfor an external file, or for a video file in the site's File Gallery:\n\t\t\t\t\t%0tiki-download_file.php?fileId=2%1 (the missing %0//%1 is intentional as this is a valid internal\n\t\t\t\t\tlink)",
// "Complete URL to the media to include, which has the appropriate extension.\n\t\t\t\t\tIf your URL doesn't have an extension, use the File type parameter below" => "Complete URL to the media to include, which has the appropriate extension.\n\t\t\t\t\tIf your URL doesn't have an extension, use the File type parameter below",
// "Download file" => "Download file",
// "Member List" => "Member List",
// "List and allow editing of group members" => "List and allow editing of group members",
// "List of groups to handle through the interface (use %0*%1 for all). Semi-colon\n\t\t\t\t\tseparated" => "List of groups to handle through the interface (use %0*%1 for all). Semi-colon\n\t\t\t\t\tseparated",
// "Descriptions" => "Descriptions",
// "Display group descriptions below list name" => "Display group descriptions below list name",
// "How to show the member lists" => "How to show the member lists",
// "Maximum" => "Maximum",
// "Maximum number of users to list in each group (default %0100%1)" => "Maximum number of users to list in each group (default %0100%1)",
// "Members Only" => "Members Only",
// "Show only groups containing a certain user. Enter %0%user%%1 to show groups for\n\t\t\t\t\tthe current logged-in user" => "Show only groups containing a certain user. Enter %0%user%%1 to show groups for\n\t\t\t\t\tthe current logged-in user",
// "Sort mode" => "Sort mode",
// "Sort mode for member listing" => "Sort mode for member listing",
// "Read only mode. All ability to modify membership is hidden" => "Read only mode. All ability to modify membership is hidden",
// "Set as Default Group" => "Set as Default Group",
// "Adds possibility to set group as default group. This automatically adds the user\n\t\t\t\t\tto the group. \"Required\" option will not propose simple addition in group" => "Adds possibility to set group as default group. This automatically adds the user\n\t\t\t\t\tto the group. \"Required\" option will not propose simple addition in group",
// "Not suggested" => "Not suggested",
// "Suggested" => "Suggested",
"Required" => "必須",
// "Only groups including the group that you specify will be listed" => "Only groups including the group that you specify will be listed",
// "Notify Added User" => "Notify Added User",
// "Notify Removed User" => "Notify Removed User",
// "Email notification to removed user" => "Email notification to removed user",
// "Need Approval" => "Need Approval",
// "Add approve/reject user buttons for private addon groups" => "Add approve/reject user buttons for private addon groups",
// "Member Payment" => "Member Payment",
// "Receive payment from a member to extend membership to a group" => "Receive payment from a member to extend membership to a group",
// "Name of the group for which the subscription should be added or extended" => "Name of the group for which the subscription should be added or extended",
// "Price per period (%0)" => "Price per period (%0)",
// "Current User Member" => "Current User Member",
// "Membership only for the current user" => "Membership only for the current user",
// "Input Title" => "Input Title",
// "Title of the initial input form" => "Title of the initial input form",
// "Use %0 for the group name, %1 for\n\t\t\t\t\tthe price, %2 for the currency, %4 for the number of days and %5 for the number of years" => "Use %0 for the group name, %1 for\n\t\t\t\t\tthe price, %2 for the currency, %4 for the number of days and %5 for the number of years",
// "Supports wiki syntax" => "Supports wiki syntax",
// "Input Title Only" => "Input Title Only",
// "Select Yes (%0y%1) to just show the title of the input form and not the period and\n\t\t\t\t\tcost information. Input Title must be set as well" => "Select Yes (%0y%1) to just show the title of the input form and not the period and\n\t\t\t\t\tcost information. Input Title must be set as well",
// "Initial Payment Form Title" => "Initial Payment Form Title",
// "Add a title to the payment form when initially shown after clicking \"Continue\"" => "Add a title to the payment form when initially shown after clicking \"Continue\"",
// "Use %0 for the group name, %1 for the price, %2 for the currency, %4 for the number\n\t\t\t\t\tof days and %5 for the number of years" => "Use %0 for the group name, %1 for the price, %2 for the currency, %4 for the number\n\t\t\t\t\tof days and %5 for the number of years",
// "Payment Form Title Only" => "Payment Form Title Only",
// "Select Yes (%0y%1) to just show the title of the payment form. Initial Payment Form\n\t\t\t\t\tTitle must be set as well" => "Select Yes (%0y%1) to just show the title of the payment form. Initial Payment Form\n\t\t\t\t\tTitle must be set as well",
// "Subsequent Payment Form Title" => "Subsequent Payment Form Title",
// "Title of the payment form after the initial showing" => "Title of the payment form after the initial showing",
// "Use %0 for the group name, %1 for the price, %2 for the currency, %4 for the number of days\n\t\t\t\t\t\tand %5 for the number of years" => "Use %0 for the group name, %1 for the price, %2 for the currency, %4 for the number of days\n\t\t\t\t\t\tand %5 for the number of years",
// "Subsequent Payment Form Title Only" => "Subsequent Payment Form Title Only",
// "Select Yes (%0y%1) to just show the title of the payment form that shows after the\n\t\t\t\t\tinitial viewing. Subsequent Payment Form Title must be set as well" => "Select Yes (%0y%1) to just show the title of the payment form that shows after the\n\t\t\t\t\tinitial viewing. Subsequent Payment Form Title must be set as well",
// "Prevent Double Request" => "Prevent Double Request",
// "Prevent user from extended if there is already a pending request" => "Prevent user from extended if there is already a pending request",
// "Free Periods" => "Free Periods",
// "Give specified numbers of free periods, the first one could be prorated, in\n\t\t\t\t\taddition to those bought" => "Give specified numbers of free periods, the first one could be prorated, in\n\t\t\t\t\taddition to those bought",
// "Hide Period" => "Hide Period",
// "Do not allow user to set period - use default of 1" => "Do not allow user to set period - use default of 1",
// "Periods Label" => "Periods Label",
// "Customize the label for the periods input. No effect if Hide Period is set to\n\t\t\t\t\tYes (%0y%1)" => "Customize the label for the periods input. No effect if Hide Period is set to\n\t\t\t\t\tYes (%0y%1)",
// "Page that payment service returns to after processing" => "Page that payment service returns to after processing",
// "Annual, commencing %0 %1 each year" => "Annual, commencing %0 %1 each year",
// "Monthly, commencing on day %0 each month" => "Monthly, commencing on day %0 each month",
// "The user " => "The user ",
// " already has a pending extension request payment invoice " => " already has a pending extension request payment invoice ",
// "%0 to %1 %2 for %3" => "%0 to %1 %2 for %3",
// "periods" => "periods",
// "period" => "period",
// "Membership to %0 for %1 users for %2 %3" => "Membership to %0 for %1 users for %2 %3",
// "The group " => "The group ",
// " does not have a membership term" => " does not have a membership term",
// " Go to " => " Go to ",
// "Admin > Groups" => "Admin > Groups",
// " to specify a term for this group by automatically unassigning users after a certain number of days" => " to specify a term for this group by automatically unassigning users after a certain number of days",
// " does not exist" => " does not exist",
// "MetaTag" => "MetaTag",
// "Add custom meta tags to the HTML head section of the page where the plugin is used" => "Add custom meta tags to the HTML head section of the page where the plugin is used",
// "Meta tags attributes for the HTML head where each meta goes on one line and name of the meta tag and the content is separated by a pipe (%0) character. Or just copy paste the raw HTML tags here" => "Meta tags attributes for the HTML head where each meta goes on one line and name of the meta tag and the content is separated by a pipe (%0) character. Or just copy paste the raw HTML tags here",
// "Name attribute of the meta tag" => "Name attribute of the meta tag",
// "Content attribute of the meta tag" => "Content attribute of the meta tag",
// "Mini Quiz" => "Mini Quiz",
// "Create a quiz using a tracker" => "Create a quiz using a tracker",
// "Instructions::Feedback" => "Instructions::Feedback",
// "Numeric value representing the miniquiz tracker ID" => "Numeric value representing the miniquiz tracker ID",
"Module" => "模組",
// "Display a module" => "Display a module",
"Module Name" => "模組名稱",
// "Module name as known in Tiki" => "Module name as known in Tiki",
// "Select Yes (%0y%1) to hide the title (default is to show the title)" => "Select Yes (%0y%1) to hide the title (default is to show the title)",
// "Title to display at the top of the box, assuming No Title is not set to Yes (%0y%1)" => "Title to display at the top of the box, assuming No Title is not set to Yes (%0y%1)",
// "Align the module to the left or right on the page allowing other elements to align against it" => "Align the module to the left or right on the page allowing other elements to align against it",
// "Number of rows (default: %010%1)" => "Number of rows (default: %010%1)",
// "Parse" => "Parse",
// "Parse wiki syntax" => "Parse wiki syntax",
// "Show only the content with no title or borders, etc. around the content" => "Show only the content with no title or borders, etc. around the content",
// "Title, background, etc" => "Title, background, etc",
// "Show module title (heading) background, etc. (default is to show them)" => "Show module title (heading) background, etc. (default is to show them)",
// "Add ability to show/hide the content of the module (default is the site admin\n\t\t\t\t\tsetting for modules)" => "Add ability to show/hide the content of the module (default is the site admin\n\t\t\t\t\tsetting for modules)",
// "Title Background" => "Title Background",
// "Override the background color for the title (if the title is shown). The value\n\t\t\t\t\tcan be a color name (ex: %0bgcolor=\"blue\"%1) or a hexadecimal value (ex: %0bgcolor=\"#FFEBCD\"%1)" => "Override the background color for the title (if the title is shown). The value\n\t\t\t\t\tcan be a color name (ex: %0bgcolor=\"blue\"%1) or a hexadecimal value (ex: %0bgcolor=\"#FFEBCD\"%1)",
// "Module Style" => "Module Style",
// "Inline CSS for the containing div element, for example, %0max-width:80%%1" => "Inline CSS for the containing div element, for example, %0max-width:80%%1",
// "Valid CSS styling" => "Valid CSS styling",
// "CSS styling for the module data itself" => "CSS styling for the module data itself",
// "Custom CSS class" => "Custom CSS class",
// "Module displayed depending on category. Multiple category ids or names can be\n\t\t\t\t\tseparated by semi-colons" => "Module displayed depending on category. Multiple category ids or names can be\n\t\t\t\t\tseparated by semi-colons",
// "Module hidden depending on category. Multiple category ids or names can be\n\t\t\t\t\tseparated by semi-colons. This takes precedence over the category parameter above" => "Module hidden depending on category. Multiple category ids or names can be\n\t\t\t\t\tseparated by semi-colons. This takes precedence over the category parameter above",
// "Only display the module if in one of the listed perspective IDs. Semi-colon\n\t\t\t\t\tseparated" => "Only display the module if in one of the listed perspective IDs. Semi-colon\n\t\t\t\t\tseparated",
// "Module only applicable for the specified languages. Languages are defined as two\n\t\t\t\t\tcharacter language codes. Multiple values can be separated by semi-colons" => "Module only applicable for the specified languages. Languages are defined as two\n\t\t\t\t\tcharacter language codes. Multiple values can be separated by semi-colons",
// "Module only applicable for the specified sections. Multiple values can be\n\t\t\t\t\tseparated by semi-colons" => "Module only applicable for the specified sections. Multiple values can be\n\t\t\t\t\tseparated by semi-colons",
// "Module only applicable on the specified page names. Multiple values can be\n\t\t\t\t\tseparated by semi-colons" => "Module only applicable on the specified page names. Multiple values can be\n\t\t\t\t\tseparated by semi-colons",
// "Module not applicable on the specified page names. Multiple values can be\n\t\t\t\t\tseparated by semi-colons" => "Module not applicable on the specified page names. Multiple values can be\n\t\t\t\t\tseparated by semi-colons",
// "Module enabled or disabled depending on the theme file name (e.g.\n\t\t\t\t\t%0thenews.css%1). Specified themes can be either included or excluded. Theme names prefixed by %0!%1\n\t\t\t\t\tare in the exclusion list. Multiple values can be separated by semi-colons" => "Module enabled or disabled depending on the theme file name (e.g.\n\t\t\t\t\t%0thenews.css%1). Specified themes can be either included or excluded. Theme names prefixed by %0!%1\n\t\t\t\t\tare in the exclusion list. Multiple values can be separated by semi-colons",
// "Module only available based on the relationship of the user with the wiki page.\n\t\t\t\t\tEither only creators (%0y%1) or only non-creators (%0n%1) will see the module" => "Module only available based on the relationship of the user with the wiki page.\n\t\t\t\t\tEither only creators (%0y%1) or only non-creators (%0n%1) will see the module",
// "Module only available based on the relationship of the user with the wiki page.\n\t\t\t\t\tEither only contributors (%0y%1) or only non-contributors (%0n%1) will see the module" => "Module only available based on the relationship of the user with the wiki page.\n\t\t\t\t\tEither only contributors (%0y%1) or only non-contributors (%0n%1) will see the module",
"Please choose a module" => "請選擇模組",
"to be used as argument" => "用為參數",
"Sorry, no such module" => "抱歉, 沒有這個模組",
// "Module List" => "Module List",
// "Display the modules assigned to a zone" => "Display the modules assigned to a zone",
// "Zone Name" => "Zone Name",
// "The name of the module zone to include. Can be a custom zone name" => "The name of the module zone to include. Can be a custom zone name",
// "Top bar" => "Top bar",
// "Page top" => "Page top",
// "Page bottom" => "Page bottom",
// "Monospace" => "Monospace",
// "Display text in a monospace font" => "Display text in a monospace font",
// "Text that the font will be applied to" => "Text that the font will be applied to",
// "Font name as recognized by browsers" => "Font name as recognized by browsers",
// "Mouseover" => "Mouseover",
// "Display hidden content by mousing over text" => "Display hidden content by mousing over text",
// "Hidden content, unless the label parameter is undefined, in which case this is the label" => "Hidden content, unless the label parameter is undefined, in which case this is the label",
// "Text displayed on the page. The body is the hidden content" => "Text displayed on the page. The body is the hidden content",
// "Destination link when mouseover text is clicked. Use http:// for external links" => "Destination link when mouseover text is clicked. Use http:// for external links",
// "DEPRECATED" => "DEPRECATED",
// "Hidden content. The body contains the label" => "Hidden content. The body contains the label",
// "Mouseover box width. Default: %0400px%1" => "Mouseover box width. Default: %0400px%1",
// "Mouseover box height. Default: %0200px%1" => "Mouseover box height. Default: %0200px%1",
// "Offset X" => "Offset X",
// "Shifts the overlay to the right by the specified number of pixels relative to\n\t\t\t\t\tthe cursor. Default: %05%1" => "Shifts the overlay to the right by the specified number of pixels relative to\n\t\t\t\t\tthe cursor. Default: %05%1",
// "Offset Y" => "Offset Y",
// "Shifts the overlay lower by the specified number of pixels relative to the\n\t\t\t\t\tcursor. Default: %00%1" => "Shifts the overlay lower by the specified number of pixels relative to the\n\t\t\t\t\tcursor. Default: %00%1",
// "Parse Body" => "Parse Body",
// "Parse the body of the plugin as wiki content (parsed by default)" => "Parse the body of the plugin as wiki content (parsed by default)",
// "Parse Label" => "Parse Label",
// "Parse the label as wiki content (parsed by default)" => "Parse the label as wiki content (parsed by default)",
// "CSS class to apply" => "CSS class to apply",
// "Background color to apply to the popup" => "Background color to apply to the popup",
// "Text Color" => "Text Color",
// "Color to apply to the text in the popup" => "Color to apply to the text in the popup",
"Sticky" => "置頂",
// "When enabled, popup stays visible until it is clicked" => "When enabled, popup stays visible until it is clicked",
// "Padding" => "Padding",
// "Padding size in pixels" => "Padding size in pixels",
// "Effect" => "Effect",
// "Set the type of show/hide animation that will be used" => "Set the type of show/hide animation that will be used",
// "Effect Speed" => "Effect Speed",
// "Set the speed of the animation" => "Set the speed of the animation",
// "Close Delay" => "Close Delay",
// "Number of seconds before popup closes" => "Number of seconds before popup closes",
// "HTML tag to use for the label. Default %0a%1" => "HTML tag to use for the label. Default %0a%1",
// "No label specified" => "No label specified",
// "MediaWiki Table" => "MediaWiki Table",
// "Display a table using MediaWiki syntax" => "Display a table using MediaWiki syntax",
// "Fancy" => "Fancy",
// "Set to true to apply additional formatting to the table (header style, odd/even\n\t\t\t\t\trows, etc.). Takes precedence over the %0wiki_classes%1 parameter" => "Set to true to apply additional formatting to the table (header style, odd/even\n\t\t\t\t\trows, etc.). Takes precedence over the %0wiki_classes%1 parameter",
// "True" => "True",
// "False" => "False",
// "Wiki Classes" => "Wiki Classes",
// "Determines whether wiki style classes will be used for the table and cells\n\t\t\t\t\t(used by default)" => "Determines whether wiki style classes will be used for the table and cells\n\t\t\t\t\t(used by default)",
// "MySpace" => "MySpace",
// "Display a MySpace Flash mp3 playlist" => "Display a MySpace Flash mp3 playlist",
// "MySpace Page" => "MySpace Page",
// "MySpace page name" => "MySpace page name",
// "Network condition" => "Network condition",
// "Display content based on the user's IP address" => "Display content based on the user's IP address",
// "Content to display conditionally" => "Content to display conditionally",
// "IPv4 List" => "IPv4 List",
// "Comma-separated list of IPv4 addresses to match against the visitor's address" => "Comma-separated list of IPv4 addresses to match against the visitor's address",
// "Now" => "Now",
// "Show the current date and time" => "Show the current date and time",
// "Time format using the PHP format described here: %0" => "Time format using the PHP format described here: %0",
// "Based site long date and time setting" => "Based site long date and time setting",
// "Date to display" => "Date to display",
// "Date time as specified in text using strtotime, i.e. \"next month\" - documentation here: %0" => "Date time as specified in text using strtotime, i.e. \"next month\" - documentation here: %0",
// "Allow Invalid Dates" => "Allow Invalid Dates",
// "Allow return values that are not a valid date, such as the day of the month" => "Allow return values that are not a valid date, such as the day of the month",
// "Plugin now when parameter not valid. %0" => "Plugin now when parameter not valid. %0",
// "Object Hits" => "Object Hits",
// "Display the number of hits for certain objects" => "Display the number of hits for certain objects",
// "For a wiki page, the page name, for other object types: ID number + ? +\n\t\t\t\t\tobject title" => "For a wiki page, the page name, for other object types: ID number + ? +\n\t\t\t\t\tobject title",
// "Object type, such as wiki, file gallery, file, article, etc. Default is\n\t\t\t\t\t%0wiki%1" => "Object type, such as wiki, file gallery, file, article, etc. Default is\n\t\t\t\t\t%0wiki%1",
// "Show the number of hits over the past number of days indicated. Default is to\n\t\t\t\t\tshow all hits" => "Show the number of hits over the past number of days indicated. Default is to\n\t\t\t\t\tshow all hits",
// "Since a date" => "Since a date",
// "Date since the hits are collected in a format supported by strtotime" => "Date since the hits are collected in a format supported by strtotime",
// "Display a link to an object" => "Display a link to an object",
// "The object type" => "The object type",
// "The item to display" => "The item to display",
// "Tiki Package View" => "Tiki Package View",
// "Display the output of a Tiki Package View" => "Display the output of a Tiki Package View",
// "Package Name" => "Package Name",
// "Name of package in the form %0vendor/name%1" => "Name of package in the form %0vendor/name%1",
// "Name of the view" => "Name of the view",
// "Name of the view file without the %0.php%1" => "Name of the view file without the %0.php%1",
// "Page Tabs" => "Page Tabs",
// "PluginPageTabs" => "PluginPageTabs",
// "Display the content of a wiki page in a set of tabs" => "Display the content of a wiki page in a set of tabs",
// "Wiki page names" => "Wiki page names",
// "The wiki pages you would like to use in this plugin, optional, separate with\n\t\t\t\t\tpipe %0|%1. Or a table with the class of \"pagetabs\" on the main page. On child pages use as a way\n\t\t\t\t\tto redirect to the parent" => "The wiki pages you would like to use in this plugin, optional, separate with\n\t\t\t\t\tpipe %0|%1. Or a table with the class of \"pagetabs\" on the main page. On child pages use as a way\n\t\t\t\t\tto redirect to the parent",
// "Parameter" => "Parameter",
// "Display content based on URL parameters" => "Display content based on URL parameters",
// "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the\n\t\t\tmarker will be displayed if conditions are not met" => "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the\n\t\t\tmarker will be displayed if conditions are not met",
// "Names of parameters required to display text, separated by %0|%1" => "Names of parameters required to display text, separated by %0|%1",
// "Source where the parameter is checked" => "Source where the parameter is checked",
// "REQUEST" => "REQUEST",
// "GET" => "GET",
// "POST" => "POST",
// "COOKIE" => "COOKIE",
// "Value to test for. If empty then just tests if the named params are set and not\n\t\t\t\t\t\"empty\"" => "Value to test for. If empty then just tests if the named params are set and not\n\t\t\t\t\t\"empty\"",
// "Show the details of a payment request or invoice" => "Show the details of a payment request or invoice",
// "Payment Request Number" => "Payment Request Number",
// "Unique identifier of the payment request" => "Unique identifier of the payment request",
// "Payment List" => "Payment List",
// "Show details of payments. The payments considered may be restrained by user or date" => "Show details of payments. The payments considered may be restrained by user or date",
// "Payment type" => "Payment type",
// "Outstanding" => "Outstanding",
// "Overdue" => "Overdue",
// "Authorized" => "Authorized",
// "Output format" => "Output format",
"Total" => "全部",
// "JSON (for advanced custom usage)" => "JSON (for advanced custom usage)",
// "Payments by a particular user" => "Payments by a particular user",
// "Payer email" => "Payer email",
// "Date range start, accepts most date formats" => "Date range start, accepts most date formats",
// "Date range end" => "Date range end",
// "Advanced filter" => "Advanced filter",
// "URL encoded string for advanced searching (e.g. description=Club+Membership&details=info@example.com)" => "URL encoded string for advanced searching (e.g. description=Club+Membership&details=info@example.com)",
// "List offset" => "List offset",
// "For pagination" => "For pagination",
// "Payments per page" => "Payments per page",
// "Automatic (newest first)" => "Automatic (newest first)",
// "User A to Z" => "User A to Z",
// "User Z to A" => "User Z to A",
// "Amount low to high" => "Amount low to high",
// "Amount high to low" => "Amount high to low",
// "Payment: oldest first" => "Payment: oldest first",
// "Payment: newest first" => "Payment: newest first",
// "Request: oldest first" => "Request: oldest first",
// "Request: newest first" => "Request: newest first",
// "Note, the paymentlist \"payer\" parameter cannot be used when search for \"details\" in an advance filter" => "Note, the paymentlist \"payer\" parameter cannot be used when search for \"details\" in an advance filter",
// "Plugin paymentlist: Unrecognised type \"%0\"" => "Plugin paymentlist: Unrecognised type \"%0\"",
// "No payments found" => "No payments found",
// "Payments by anonymous where the payer's email is recorded" => "Payments by anonymous where the payer's email is recorded",
// "PayPal Button" => "PayPal Button",
// "Embed a PayPal button" => "Embed a PayPal button",
// "Type of PayPal button" => "Type of PayPal button",
// "Shopping cart" => "Shopping cart",
// "Buy Now" => "Buy Now",
// "Donations" => "Donations",
// "Cart Action" => "Cart Action",
// "Action if Shopping Cart selected for type" => "Action if Shopping Cart selected for type",
// "Add to Cart" => "Add to Cart",
// "View Cart" => "View Cart",
// "Item Name" => "Item Name",
// "Item name or description. Required for Shopping cart" => "Item name or description. Required for Shopping cart",
// "Item price" => "Item price",
// "Button appearance" => "Button appearance",
"Smaller" => "縮小",
// "Custom" => "Custom",
// "Custom Button" => "Custom Button",
// "Custom button image URL" => "Custom button image URL",
// "Optional item identifier, often a tracker itemId" => "Optional item identifier, often a tracker itemId",
// "Number of items, empty or 0 to have an input the user can fill in" => "Number of items, empty or 0 to have an input the user can fill in",
// "Shipping Cost" => "Shipping Cost",
// "The cost of shipping this item" => "The cost of shipping this item",
// "Additional Shipping Cost" => "Additional Shipping Cost",
// "The cost of shipping each additional unit of this item" => "The cost of shipping each additional unit of this item",
// "Weight of item" => "Weight of item",
// "Weight Unit" => "Weight Unit",
// "The unit of measure if weight is specified" => "The unit of measure if weight is specified",
// "Kilos" => "Kilos",
// "Pounds" => "Pounds",
// "Business ID" => "Business ID",
// "PayPal business name/ID" => "PayPal business name/ID",
// "(Uses value in admin/payment if not set here)" => "(Uses value in admin/payment if not set here)",
// "Use MiniCart" => "Use MiniCart",
// "See https://github.com/jeffharrell/MiniCart" => "See https://github.com/jeffharrell/MiniCart",
// "Shipping Address Prompt" => "Shipping Address Prompt",
// "Indicate whether to prompt for and require an address" => "Indicate whether to prompt for and require an address",
// "Prompt for address" => "Prompt for address",
// "Do not prompt for address" => "Do not prompt for address",
// "Prompt for and require address" => "Prompt for and require address",
// "Completed payment return URL" => "Completed payment return URL",
// "Empty for current page, %0n%1 to disable" => "Empty for current page, %0n%1 to disable",
// "Continue Shopping URL" => "Continue Shopping URL",
// "Cancel payment URL" => "Cancel payment URL",
// "Form title" => "Form title",
// "Tooltip for the form and alt attribute for the image" => "Tooltip for the form and alt attribute for the image",
// "PayPal — The safer, easier way to pay online" => "PayPal — The safer, easier way to pay online",
// "Button text" => "Button text",
// "The checkout button text" => "The checkout button text",
// "Subtotal text" => "Subtotal text",
// "The subtotal text" => "The subtotal text",
// "Discount text" => "Discount text",
// "The discount text" => "The discount text",
// "Shipping text" => "Shipping text",
// "The shipping text" => "The shipping text",
// "Processing text" => "Processing text",
// "The processing text" => "The processing text",
// "PayPal button" => "PayPal button",
// "Item name (item_name) required" => "Item name (item_name) required",
// "Price (amount) required" => "Price (amount) required",
// "For customized PDF generation, to override global PDF settings" => "For customized PDF generation, to override global PDF settings",
// "Print friendly option will change theme background color to white and text /headings color to black. If set to 'n\\" => "Print friendly option will change theme background color to white and text /headings color to black. If set to 'n\\",
// "Generate table of contents" => "Generate table of contents",
// "Set if table of contents will be autogenerated before PDF content" => "Set if table of contents will be autogenerated before PDF content",
// "Link TOC headings with content on PDF document" => "Link TOC headings with content on PDF document",
// "Heading to be appeared before table of content is printed" => "Heading to be appeared before table of content is printed",
// "TOC levels" => "TOC levels",
// "Will be autopicked from content of document, for example:<code>H1|H2|H3</code>" => "Will be autopicked from content of document, for example:<code>H1|H2|H3</code>",
// "Enter Wiki Syntax / HTML code / Plain text. <br /> Possible values: <code>Custom HTML / Wiki Syntax / text </code>, <code>{PAGENO}</code>, <code>{DATE j-m-Y}</code>, <code> Page {PAGENO} of {NB}, Left text| Center Text | Right Text</code>. <br />Set header value as <code>off</code>, to turn off header from page" => "Enter Wiki Syntax / HTML code / Plain text. <br /> Possible values: <code>Custom HTML / Wiki Syntax / text </code>, <code>{PAGENO}</code>, <code>{DATE j-m-Y}</code>, <code> Page {PAGENO} of {NB}, Left text| Center Text | Right Text</code>. <br />Set header value as <code>off</code>, to turn off header from page",
// "Possible values: <code>HTML / Wiki Syntax / Plain text</code>,  <code>{include page=\"wiki_page_name\"}</code> <code>{PAGENO}</code>, <code>{DATE j-m-Y}</code>. <br/> For example: <code>{PAGETITLE}|Center Text|{PAGENO}</code>, <code> Page {PAGENO} of {NB}</code>, <code>{include page=\"wiki_page_name\"}</code>. <br /> Set footer value as <code>off</code>, to remove footer from page" => "Possible values: <code>HTML / Wiki Syntax / Plain text</code>,  <code>{include page=\"wiki_page_name\"}</code> <code>{PAGENO}</code>, <code>{DATE j-m-Y}</code>. <br/> For example: <code>{PAGETITLE}|Center Text|{PAGENO}</code>, <code> Page {PAGENO} of {NB}</code>, <code>{include page=\"wiki_page_name\"}</code>. <br /> Set footer value as <code>off</code>, to remove footer from page",
// "Only applicable if header is set. Numeric value only, no need to add px.Warning: Header can overlap text if top margin is not set properly" => "Only applicable if header is set. Numeric value only, no need to add px.Warning: Header can overlap text if top margin is not set properly",
// "Only applicable if footer is set.Numeric value only, no need to add px. Warning: Footer can overlap text if bottom margin is not set properly" => "Only applicable if footer is set.Numeric value only, no need to add px. Warning: Footer can overlap text if bottom margin is not set properly",
// "Generate PDF Bookmarks" => "Generate PDF Bookmarks",
// "Values H1-H6,separated by | <code>For example H1|H2|H3</code>" => "Values H1-H6,separated by | <code>For example H1|H2|H3</code>",
// "Secure confidential PDF with password, leave blank if password protected is not needed" => "Secure confidential PDF with password, leave blank if password protected is not needed",
// "Watermark text value, for example: Confidential, Draft etc. " => "Watermark text value, for example: Confidential, Draft etc. ",
// "Watermark image, enter full URL" => "Watermark image, enter full URL",
// "Full URL of watermark image" => "Full URL of watermark image",
// "Page background color" => "Page background color",
// "Page background image" => "Page background image",
// "<code>Heading|Subheading|Text Alignment|Background color|Text color|Page border|Border color</code>. Enter settings separated by <code>|</code>,sequence is important,leave blank for default. For example <code>{PAGETITLE}|Tikiwiki|Center|#fff|#000|1|#ccc</code>" => "<code>Heading|Subheading|Text Alignment|Background color|Text color|Page border|Border color</code>. Enter settings separated by <code>|</code>,sequence is important,leave blank for default. For example <code>{PAGETITLE}|Tikiwiki|Center|#fff|#000|1|#ccc</code>",
// "For pluginPDF, please select mpdf as default PDF engine from Print Settings" => "For pluginPDF, please select mpdf as default PDF engine from Print Settings",
// "Manual bookmark entry for a PDF file" => "Manual bookmark entry for a PDF file",
// "Bookmark Label" => "Bookmark Label",
// "Bookmark level" => "Bookmark level",
// "Insert page with new settings in PDF" => "Insert page with new settings in PDF",
// "Page Content" => "Page Content",
// "PDF page header text" => "PDF page header text",
// "PDF page footer text" => "PDF page footer text",
// "Watermark text for this page. Set value as \"off\", to turn off watermark of the page" => "Watermark text for this page. Set value as \"off\", to turn off watermark of the page",
// "Watermark text value, for example: Confidential, Draft etc" => "Watermark text value, for example: Confidential, Draft etc",
// "Watermark image, enter full url" => "Watermark image, enter full url",
// "To turn off watermark image on the page, set value as <code>off</code>" => "To turn off watermark image on the page, set value as <code>off</code>",
// "PluginPDF Page Break" => "PluginPDF Page Break",
// "Helpful to format PDF files created, plugin adds page break in PDF file generated" => "Helpful to format PDF files created, plugin adds page break in PDF file generated",
// "Display content based on permission settings" => "Display content based on permission settings",
// "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the\n\t\t\tmarker will be displayed to users not matching the conditions" => "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the\n\t\t\tmarker will be displayed to users not matching the conditions",
// "Possible Permissions" => "Possible Permissions",
// "Pipe-separated list of permissions, one of which is needed to view the default\n\t\t\t\t\ttext" => "Pipe-separated list of permissions, one of which is needed to view the default\n\t\t\t\t\ttext",
// "Forbidden Permissions" => "Forbidden Permissions",
// "Pipe-separated list of permissions, any of which will cause the default text\n\t\t\t\t\tnot to show" => "Pipe-separated list of permissions, any of which will cause the default text\n\t\t\t\t\tnot to show",
// "Global" => "Global",
// "Indicate whether the permissions are global or local to the object" => "Indicate whether the permissions are global or local to the object",
// "Display content based on the user's current perspective" => "Display content based on the user's current perspective",
// "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the\n\t\t\tmarker will be displayed to users not matching the condition" => "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the\n\t\t\tmarker will be displayed to users not matching the condition",
// "Allowed Perspectives" => "Allowed Perspectives",
// "Pipe-separated list of identifiers of perspectives in which the block is shown" => "Pipe-separated list of identifiers of perspectives in which the block is shown",
// "Denied Perspectives" => "Denied Perspectives",
// "Pipe-separated list of identifiers of perspectives in which the block is not\n\t\t\t\t\tshown" => "Pipe-separated list of identifiers of perspectives in which the block is not\n\t\t\t\t\tshown",
// "Pivot table" => "Pivot table",
// "Create and display data in pivot table for reporting" => "Create and display data in pivot table for reporting",
// "Leave one space in the box below to allow easier editing of current values with the plugin popup helper later on" => "Leave one space in the box below to allow easier editing of current values with the plugin popup helper later on",
// "Data source" => "Data source",
// "Override item permissions" => "Override item permissions",
// "Return all tracker items ignoring permissions to view the corresponding items" => "Return all tracker items ignoring permissions to view the corresponding items",
// "Width of pivot table. Units: % or px" => "Width of pivot table. Units: % or px",
// "Height of pivot table. Units: px" => "Height of pivot table. Units: px",
// "Pivot table Rows" => "Pivot table Rows",
// "Which field or fields to use as table rows. Leaving blank will remove grouping by table rows. " => "Which field or fields to use as table rows. Leaving blank will remove grouping by table rows. ",
// "Use permanentNames in case of tracker fields" => "Use permanentNames in case of tracker fields",
// "Separated by colon (:) if more than one" => "Separated by colon (:) if more than one",
// "Pivot table Columns" => "Pivot table Columns",
// "Which field or fields to use as table columns. Leaving blank will use the first available field" => "Which field or fields to use as table columns. Leaving blank will use the first available field",
// "Values used to decide what heatmapColors to use" => "Values used to decide what heatmapColors to use",
// "Color for each heatmapDomain value" => "Color for each heatmapDomain value",
// "Renderer Name" => "Renderer Name",
// "Display format of data" => "Display format of data",
// "Table Barchart" => "Table Barchart",
// "Heatmap" => "Heatmap",
// "Row Heatmap" => "Row Heatmap",
// "Col Heatmap" => "Col Heatmap",
// "Line Chart" => "Line Chart",
// "Bar Chart" => "Bar Chart",
// "Overlay Bar Chart" => "Overlay Bar Chart",
// "Stacked Bar Chart" => "Stacked Bar Chart",
// "Relative Bar Chart" => "Relative Bar Chart",
// "Boxplot Chart" => "Boxplot Chart",
// "Horizontal Boxplot Chart" => "Horizontal Boxplot Chart",
// "Area Chart" => "Area Chart",
// "Histogram" => "Histogram",
// "Density Histogram" => "Density Histogram",
// "Percent Histogram" => "Percent Histogram",
// "Probability Histogram" => "Probability Histogram",
// "Density Histogram Horizontal" => "Density Histogram Horizontal",
// "Percent Histogram Horizontal" => "Percent Histogram Horizontal",
// "Probability Histogram Horizontal" => "Probability Histogram Horizontal",
// "Horizontal Histogram" => "Horizontal Histogram",
// "Histogram2D" => "Histogram2D",
// "Density Histogram2D" => "Density Histogram2D",
// "Percent Histogram2D" => "Percent Histogram2D",
// "Probability Histogram2D" => "Probability Histogram2D",
// "Density Histogram2D Horizontal" => "Density Histogram2D Horizontal",
// "Percent Histogram2D Horizontal" => "Percent Histogram2D Horizontal",
// "Probability Histogram2D Horizontal" => "Probability Histogram2D Horizontal",
// "Horizontal Histogram2D" => "Horizontal Histogram2D",
// "Scatter Chart" => "Scatter Chart",
// "Treemap" => "Treemap",
// "Aggregator Name" => "Aggregator Name",
// "Function to apply on the numeric values from the variables selected" => "Function to apply on the numeric values from the variables selected",
// "Count Unique Values" => "Count Unique Values",
// "List Unique Values" => "List Unique Values",
// "Sum" => "Sum",
// "Integer Sum" => "Integer Sum",
// "Minimum" => "Minimum",
// "Sum over Sum" => "Sum over Sum",
// "80% Upper Bound" => "80% Upper Bound",
// "80% Lower Bound" => "80% Lower Bound",
// "Sum as Fraction of Total" => "Sum as Fraction of Total",
// "Sum as Fraction of Rows" => "Sum as Fraction of Rows",
// "Sum as Fraction of Columns" => "Sum as Fraction of Columns",
// "Count as Fraction of Total" => "Count as Fraction of Total",
// "Count as Fraction of Rows" => "Count as Fraction of Rows",
// "Count as Fraction of Columns" => "Count as Fraction of Columns",
// "Values" => "Values",
// "Variable with numeric values or tracker field permNames, on which the formula from the aggregator is applied. It can be left empty if aggregator is related to Counts" => "Variable with numeric values or tracker field permNames, on which the formula from the aggregator is applied. It can be left empty if aggregator is related to Counts",
// "Use permanentNames in case of tracker fields, separated by : in case of multiple fields function" => "Use permanentNames in case of tracker fields, separated by : in case of multiple fields function",
// "Inclusions" => "Inclusions",
// "Filter values for fields in rows or columns. Contains JSON encoded object of arrays of strings" => "Filter values for fields in rows or columns. Contains JSON encoded object of arrays of strings",
// "Filter list limit" => "Filter list limit",
// "Pivottable menuLimit option override - number of entries to consider the menu list too big when filtering on a particular column or row" => "Pivottable menuLimit option override - number of entries to consider the menu list too big when filtering on a particular column or row",
// "Aggregate details" => "Aggregate details",
// "When enabled, clicking a table cell will popup all items that were aggregated into that cell. Specify the name of the field or fields to use to display the details separated by colon. Enabled by default. To disable, set contents to an empty string" => "When enabled, clicking a table cell will popup all items that were aggregated into that cell. Specify the name of the field or fields to use to display the details separated by colon. Enabled by default. To disable, set contents to an empty string",
// "Highlight my items" => "Highlight my items",
// "Highlight owned items' values in Charts" => "Highlight owned items' values in Charts",
// "Highlight my group items" => "Highlight my group items",
// "Highlight items' values belonging to one of my groups in Charts" => "Highlight items' values belonging to one of my groups in Charts",
// "Color for each highlighted group items" => "Color for each highlighted group items",
// "xAxis label" => "xAxis label",
// "Override label of horizontal axis when using Chart renderers" => "Override label of horizontal axis when using Chart renderers",
// "yAxis label" => "yAxis label",
// "Override label of vertical axis when using Chart renderers" => "Override label of vertical axis when using Chart renderers",
// "Chart title" => "Chart title",
// "Override title when using Chart renderers" => "Override title when using Chart renderers",
// "Chart hover bar" => "Chart hover bar",
// "Display the Chart hover bar or not" => "Display the Chart hover bar or not",
// "Translate displayed data" => "Translate displayed data",
// "Use translated data values for calculations and display" => "Use translated data values for calculations and display",
// "Default value: No" => "Default value: No",
// "Missing required files, please make sure plugin files are installed at vendor_bundled/vendor/nicolaskruchten/pivottable. <br/><br /> To install, please run composer or download from following url:<a href=\"https://github.com/nicolaskruchten/pivottable/archive/master.zip\" target=\"_blank\">https://github.com/nicolaskruchten/pivottable/archive/master.zip</a>" => "Missing required files, please make sure plugin files are installed at vendor_bundled/vendor/nicolaskruchten/pivottable. <br/><br /> To install, please run composer or download from following url:<a href=\"https://github.com/nicolaskruchten/pivottable/archive/master.zip\" target=\"_blank\">https://github.com/nicolaskruchten/pivottable/archive/master.zip</a>",
// "Missing data parameter with format: source:ID, e.g. tracker:1" => "Missing data parameter with format: source:ID, e.g. tracker:1",
// "Error data parameter" => "Error data parameter",
// "You do not have rights to view tracker data" => "You do not have rights to view tracker data",
// "Unified search index not found" => "Unified search index not found",
// "Split wiki modifier should specify a field" => "Split wiki modifier should specify a field",
// "For example 'tracker:1' or 'activitystream'" => "For example 'tracker:1' or 'activitystream'",
// "Piwik" => "Piwik",
// "Embed a Piwik preformatted report (widget module) - Piwik Analytics is required.\n                            To use this plugin you have to grant in your Piwik view permission to anonymous for the selected \"Site Id\" or to add a token authentification parameter" => "Embed a Piwik preformatted report (widget module) - Piwik Analytics is required.\n                            To use this plugin you have to grant in your Piwik view permission to anonymous for the selected \"Site Id\" or to add a token authentification parameter",
// "Piwik server url" => "Piwik server url",
// "The url to your Piwik Server, where data for the report are collected and available" => "The url to your Piwik Server, where data for the report are collected and available",
// "Important : token_auth is visible in the html code and must be used in private page accessible to trusted users" => "Important : token_auth is visible in the html code and must be used in private page accessible to trusted users",
// "The ID of this website in Piwik To be improved" => "The ID of this website in Piwik To be improved",
// "Module and Action To Widgetize" => "Module and Action To Widgetize",
// "Piwik widget module to be used (as described in the widget section of your Piwik server) followed by the actionToWidgetize parameter separated by a comma" => "Piwik widget module to be used (as described in the widget section of your Piwik server) followed by the actionToWidgetize parameter separated by a comma",
// "Actions - Pages" => "Actions - Pages",
// "Actions - Entry pages" => "Actions - Entry pages",
// "Actions - Exit pages" => "Actions - Exit pages",
// "Actions - Outlinks" => "Actions - Outlinks",
// "Dashboard" => "Dashboard",
// "Live - Visitor in real time" => "Live - Visitor in real time",
// "Live - Simple Last Visit Count" => "Live - Simple Last Visit Count",
// "Live - Visitor Profile Popup" => "Live - Visitor Profile Popup",
// "Referrers - All referrers" => "Referrers - All referrers",
// "Referrers - Search engines" => "Referrers - Search engines",
// "Resolution - Screen Resolution" => "Resolution - Screen Resolution",
// "SEO - SEO Ranking (slow)" => "SEO - SEO Ranking (slow)",
// "User Country Map - RealTime Map" => "User Country Map - RealTime Map",
// "User Country Map - Visitor Map" => "User Country Map - Visitor Map",
// "User Country Map - Country" => "User Country Map - Country",
// "User Country Map - Continent" => "User Country Map - Continent",
// "User Language - Language" => "User Language - Language",
// "User Language - Language Code" => "User Language - Language Code",
// "Visits Time - By day of the week" => "Visits Time - By day of the week",
// "Visits Time - Visit Information Per Local Time" => "Visits Time - Visit Information Per Local Time",
// "Visits Time - Visit Information Per Server Time" => "Visits Time - Visit Information Per Server Time",
// "Visits Summary - by day of the week" => "Visits Summary - by day of the week",
// "Visits Summary - over time" => "Visits Summary - over time",
// "Visits Summary - overview with graph" => "Visits Summary - overview with graph",
// "Visitors - Visitor map" => "Visitors - Visitor map",
// "Visitors - Pages per visit" => "Visitors - Pages per visit",
// "Visitors - Frequency overview" => "Visitors - Frequency overview",
// "Visitors - Returning visits over time" => "Visitors - Returning visits over time",
// "Visitor Devices - Device type" => "Visitor Devices - Device type",
// "Visitor Devices - browser" => "Visitor Devices - browser",
// "Visitor Devices - Browser Versions" => "Visitor Devices - Browser Versions",
// "Visitor Devices - OS Families" => "Visitor Devices - OS Families",
// "Visitor Devices - OS Versions" => "Visitor Devices - OS Versions",
// "Visitor Interest - Number Of Visits Per Visit Duration" => "Visitor Interest - Number Of Visits Per Visit Duration",
// "Visitor Interest - Number Of Visits Per Page" => "Visitor Interest - Number Of Visits Per Page",
// "Visitor Interest - Number Of Visits By Visit Count" => "Visitor Interest - Number Of Visits By Visit Count",
// "Visitor Interest - Number Of Visits By Days Since Last" => "Visitor Interest - Number Of Visits By Days Since Last",
// "Visitor Setting - Screen resolution" => "Visitor Setting - Screen resolution",
// "Statistics period" => "Statistics period",
// "Data display duration. If range is selected you must enter the start and end the date" => "Data display duration. If range is selected you must enter the start and end the date",
// "Range" => "Range",
// "Date or Start date" => "Date or Start date",
// "Enter date or start date for the data to be displayed (yesterday by default). Possible values are: today, yesterday, and yyyy-mm-dd" => "Enter date or start date for the data to be displayed (yesterday by default). Possible values are: today, yesterday, and yyyy-mm-dd",
// "Enter end date (format yyyy-mm-dd) for the data to be displayed (only if range period is selected)" => "Enter end date (format yyyy-mm-dd) for the data to be displayed (only if range period is selected)",
// "Module width" => "Module width",
// "Optional, width of the module in px or % (100% by default)" => "Optional, width of the module in px or % (100% by default)",
// "Module height" => "Module height",
// "Optional, height of the module in px" => "Optional, height of the module in px",
// "Iframe Scrolling" => "Iframe Scrolling",
// "Optional, scrolling of the iframe that contain the module (no by default)" => "Optional, scrolling of the iframe that contain the module (no by default)",
// "Piwik javascript code" => "Piwik javascript code",
// "Define option for Piwik groups, include or exclude" => "Define option for Piwik groups, include or exclude",
// "Plugin Piwik error" => "Plugin Piwik error",
// "Piwik server url is required" => "Piwik server url is required",
// "Site Id is required" => "Site Id is required",
// "moduleToWidgetize is required" => "moduleToWidgetize is required",
// "Period set to range but no end date provided" => "Period set to range but no end date provided",
// "PlayScorm" => "PlayScorm",
// "Play a SCORM learning object in an iframe using Moodle" => "Play a SCORM learning object in an iframe using Moodle",
// "Numeric ID of a SCORM zip file in a File Gallery" => "Numeric ID of a SCORM zip file in a File Gallery",
// "Moodle URL" => "Moodle URL",
// "Web address of the Moodle instance" => "Web address of the Moodle instance",
// "Moodle Course ID" => "Moodle Course ID",
// "Course ID in Moodle to upload SCORM objects to" => "Course ID in Moodle to upload SCORM objects to",
// "Frame Width" => "Frame Width",
// "Frame Height" => "Frame Height",
// "Numeric ID" => "Numeric ID",
// "Numeric ID to distinguish multiple plugins of there is more than one" => "Numeric ID to distinguish multiple plugins of there is more than one",
// "Either the module or plugin parameter must be set, but not both" => "Either the module or plugin parameter must be set, but not both",
// "Plugin Manager error: %0%1 not found" => "Plugin Manager error: %0%1 not found",
// "Plugin Manager error: %0%1%2%3%4 not found" => "Plugin Manager error: %0%1%2%3%4 not found",
// "Plugin Manager error:  %0%1 not found" => "Plugin Manager error:  %0%1 not found",
"Options" => "選項",
// "Accepted Values" => "Accepted Values",
// "(body of plugin)" => "(body of plugin)",
// "%0separator:%1 " => "%0separator:%1 ",
// "(blank)" => "(blank)",
// "any string except for HTML and PHP tags" => "any string except for HTML and PHP tags",
// "Since" => "Since",
// "no parameters" => "no parameters",
// "Preferences required" => "Preferences required",
// "Introduced in %0" => "Introduced in %0",
// "Required parameters are in%0 %1bold%2" => "Required parameters are in%0 %1bold%2",
// "Plugin Manager" => "Plugin Manager",
// "List wiki plugin or module information for the site" => "List wiki plugin or module information for the site",
// "Information" => "Information",
// "Determines what information is shown. Values separated with %0|%1.\n\t\t\t\t\tIgnored when %0singletitle%1 is set to %0top%1 or %0none%1" => "Determines what information is shown. Values separated with %0|%1.\n\t\t\t\t\tIgnored when %0singletitle%1 is set to %0top%1 or %0none%1",
// "One or more of: description | parameters | paraminfo" => "One or more of: description | parameters | paraminfo",
// "Description and Parameters" => "Description and Parameters",
// "Description & Parameter Info" => "Description & Parameter Info",
// "Parameters & Parameter Info" => "Parameters & Parameter Info",
// "Plugin" => "Plugin",
// "Name of a plugin (e.g., backlinks), or list separated by %0|%1, or range separated\n\t\t\t\t\t by %0-%1. Single plugin can be used with %0limit%1 parameter" => "Name of a plugin (e.g., backlinks), or list separated by %0|%1, or range separated\n\t\t\t\t\t by %0-%1. Single plugin can be used with %0limit%1 parameter",
// "Name of a module (e.g., calendar_new), or list separated by %0|%1, or range separated\n\t\t\t\t\tby %0-%1. Single module can be used with %0limit%1 parameter" => "Name of a module (e.g., calendar_new), or list separated by %0|%1, or range separated\n\t\t\t\t\tby %0-%1. Single module can be used with %0limit%1 parameter",
// "Single Title" => "Single Title",
// "Set placement of plugin name and description when displaying information for only one plugin" => "Set placement of plugin name and description when displaying information for only one plugin",
// "Title Heading" => "Title Heading",
// "Sets the heading size for the title, e.g., %0h2%1" => "Sets the heading size for the title, e.g., %0h2%1",
// "Start with this plugin record number (must be an integer 1 or greater)" => "Start with this plugin record number (must be an integer 1 or greater)",
// "Number of plugins to show. Can be used either with start or plugin as the starting\n\t\t\t\t\tpoint. Must be an integer 1 or greater" => "Number of plugins to show. Can be used either with start or plugin as the starting\n\t\t\t\t\tpoint. Must be an integer 1 or greater",
// "Parameter Type" => "Parameter Type",
// "Only list parameters with this %0doctype%1 setting. Set to %0none%1 to show only\n\t\t\t\t\tparameters without a type setting and the body instructions" => "Only list parameters with this %0doctype%1 setting. Set to %0none%1 to show only\n\t\t\t\t\tparameters without a type setting and the body instructions",
// "Show Parameter Type" => "Show Parameter Type",
// "Show the parameter %0doctype%1 value" => "Show the parameter %0doctype%1 value",
// "Show Top Info" => "Show Top Info",
// "Show information above the table regarding preferences required and the first\n\t\t\t\t\tversion when the plugin became available. Shown by default" => "Show information above the table regarding preferences required and the first\n\t\t\t\t\tversion when the plugin became available. Shown by default",
"Poll" => "投票",
// "Embed a poll" => "Embed a poll",
// "Title of the poll" => "Title of the poll",
// "Numeric value representing the poll ID" => "Numeric value representing the poll ID",
// "Show poll title (shown by default)" => "Show poll title (shown by default)",
// "Show result" => "Show result",
// "Set how results of the poll will be shown (default is %0link%1)" => "Set how results of the poll will be shown (default is %0link%1)",
// "Voted" => "Voted",
// "Show total votes" => "Show total votes",
// "Set to No (%0n%1) to not show votes. Default is Yes (%0y%1)" => "Set to No (%0n%1) to not show votes. Default is Yes (%0y%1)",
// "Preference" => "Preference",
// "Display content based on global preference settings" => "Display content based on global preference settings",
// "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the marker\n\t\t\twill be displayed if not matching the conditions" => "Wiki text to display if conditions are met. The body may contain %0{ELSE}%1. Text after the marker\n\t\t\twill be displayed if not matching the conditions",
// "Document Preferences" => "Document Preferences",
// "Generate documentation for Tiki preference tabs, mostly for use on the Tiki documentation website (doc.tiki.org)" => "Generate documentation for Tiki preference tabs, mostly for use on the Tiki documentation website (doc.tiki.org)",
// "Preference-Tab" => "Preference-Tab",
// "The name of the preference tab to display, or a list of available tabs upon invalid" => "The name of the preference tab to display, or a list of available tabs upon invalid",
// "Show images at the top of each version of Tiki. Format: TikiVersion:FileGalleryID. Multiple images my be separated like so: TikiVersion1:FileGalleryID1|TikiVersion2:FileGalleryID2" => "Show images at the top of each version of Tiki. Format: TikiVersion:FileGalleryID. Multiple images my be separated like so: TikiVersion1:FileGalleryID1|TikiVersion2:FileGalleryID2",
// "Pretty Tracker View Tracking" => "Pretty Tracker View Tracking",
// "PluginPrettyTrackerViews" => "PluginPrettyTrackerViews",
// "Store tiki.tracker.pretty.views attribute for a trackeritem" => "Store tiki.tracker.pretty.views attribute for a trackeritem",
// "Set to %0y%1 to record view each time this is loaded" => "Set to %0y%1 to record view each time this is loaded",
// "Set to %0n%1 to hide showing of attribute" => "Set to %0n%1 to hide showing of attribute",
// "Set to ID of tracker item" => "Set to ID of tracker item",
// "Preview Files" => "Preview Files",
// "Enabled to generate preview of images or video files" => "Enabled to generate preview of images or video files",
// "Id of the file in the file gallery" => "Id of the file in the file gallery",
// "Animation" => "Animation",
// "Output should be a static image (<code>0</code>) or an animation (<code>1</code>)" => "Output should be a static image (<code>0</code>) or an animation (<code>1</code>)",
// "Width of the result in pixels" => "Width of the result in pixels",
// "Height of the result in pixels" => "Height of the result in pixels",
// "Show download link to the original file" => "Show download link to the original file",
// "Profile Application" => "Profile Application",
// "Add a button for applying a profile" => "Add a button for applying a profile",
// "Profile repository domain. Default value is %0profiles.tiki.org%1" => "Profile repository domain. Default value is %0profiles.tiki.org%1",
// "Profile Name" => "Profile Name",
// "Name of the profile to be applied" => "Name of the profile to be applied",
// "Profile plugin only available to administrators" => "Profile plugin only available to administrators",
// "Profile %0/%1 not found" => "Profile %0/%1 not found",
// "Profile Symbol Value" => "Profile Symbol Value",
// "Display the profile symbol related with profile and a reference and optionally with domain or package" => "Display the profile symbol related with profile and a reference and optionally with domain or package",
// "Reference key" => "Reference key",
// "Reference name" => "Reference name",
// "Package" => "Package",
// "Package extension name" => "Package extension name",
// "Proposal" => "Proposal",
// "Allow users to vote on a proposal and view the results" => "Allow users to vote on a proposal and view the results",
// "The list of votes cast. One vote per line. Either 0, +1 or -1 followed by a username" => "The list of votes cast. One vote per line. Either 0, +1 or -1 followed by a username",
// "Short description of the proposal to vote on. Will be displayed above the result\n\t\t\t\t\ttable" => "Short description of the proposal to vote on. Will be displayed above the result\n\t\t\t\t\ttable",
// "Weights" => "Weights",
// "Comma-separated list of groups and their associated weight. Default is\n\t\t\t\t\t%0Registered(1)%1 Example" => "Comma-separated list of groups and their associated weight. Default is\n\t\t\t\t\t%0Registered(1)%1 Example",
// "Accept proposal" => "Accept proposal",
// "Still undecided" => "Still undecided",
// "Reject proposal" => "Reject proposal",
// "Quote" => "Quote",
// "Format text as a quote" => "Format text as a quote",
// "Quoted text" => "Quoted text",
// "Reply To" => "Reply To",
// "Name of the quoted person" => "Name of the quoted person",
// "Thread Id for Forum replies" => "Thread Id for Forum replies",
// "The thread Id of the comment being replied to in forums. Overwrites replyto" => "The thread Id of the comment being replied to in forums. Overwrites replyto",
// "Source URL" => "Source URL",
// "The URL to the source quoted" => "The URL to the source quoted",
// "Date when the statement quoted was made" => "Date when the statement quoted was made",
// "YYYY-MM-DD" => "YYYY-MM-DD",
// "R syntax" => "R syntax",
// "Parse R syntax and show the output either from the code introduced between the plugin tags or from the file attached to a tracker item sent through PluginTracker. It can also be combined with Pretty Trackers to edit parameters from the script through web forms" => "Parse R syntax and show the output either from the code introduced between the plugin tags or from the file attached to a tracker item sent through PluginTracker. It can also be combined with Pretty Trackers to edit parameters from the script through web forms",
// "Random Include" => "Random Include",
// "Include a random page's content" => "Include a random page's content",
// "Random Dynamic Content" => "Random Dynamic Content",
// "Display pre-programmed changing content" => "Display pre-programmed changing content",
// "Numeric value representing the content ID" => "Numeric value representing the content ID",
// "User List with Real Names" => "User List with Real Names",
// "Show user real names for members of a group" => "Show user real names for members of a group",
// "Group name - only users belonging to a group or groups with group names containing this text\n\t\t\twill be included in the list. If empty all site users will be included" => "Group name - only users belonging to a group or groups with group names containing this text\n\t\t\twill be included in the list. If empty all site users will be included",
// "Result limit" => "Result limit",
// "Set to sort in ascending or descending order (unsorted by default" => "Set to sort in ascending or descending order (unsorted by default",
// "Make the listed names links to various types of user information" => "Make the listed names links to various types of user information",
// "User Page" => "User Page",
"User Preferences" => "使用者偏好",
// "Exclude" => "Exclude",
// "Exclude certain test or admin names from the list" => "Exclude certain test or admin names from the list",
"admin" => "管理者",
// "admin-test" => "admin-test",
// "test" => "test",
// "test-admin" => "test-admin",
"Preferences" => "使用偏好",
// "Redirect" => "Redirect",
// "Redirect to another page" => "Redirect to another page",
// "Wiki page name to redirect to" => "Wiki page name to redirect to",
// "Complete URL, internal or external" => "Complete URL, internal or external",
// "The ID of a perspective to switch to (requires feature_perspective)" => "The ID of a perspective to switch to (requires feature_perspective)",
// "Auto login remote Tiki and redirect to page there" => "Auto login remote Tiki and redirect to page there",
// "Base URL where remote Tiki is located, to auto login to prior to redirection to page there, e.g. https://othertiki.com" => "Base URL where remote Tiki is located, to auto login to prior to redirection to page there, e.g. https://othertiki.com",
// "perspective " => "perspective ",
// "nowhere" => "nowhere",
// "Remote system error" => "Remote system error",
// "REDIRECT plugin: The redirection to '%s' is disabled just after saving the page" => "REDIRECT plugin: The redirection to '%s' is disabled just after saving the page",
// "REDIRECT plugin: The redirection to '%s' is disabled in preview mode. " => "REDIRECT plugin: The redirection to '%s' is disabled in preview mode. ",
// "REDIRECT plugin: redirect loop detected" => "REDIRECT plugin: redirect loop detected",
// "Regular Expression" => "Regular Expression",
// "Perform a regular expression search and replace" => "Perform a regular expression search and replace",
// "Each line of content is evaluated separately" => "Each line of content is evaluated separately",
// "Name of page containing search and replace expressions separated by two colons.\n\t\t\t\t\tExample of syntax on that page" => "Name of page containing search and replace expressions separated by two colons.\n\t\t\t\t\tExample of syntax on that page",
// "Register Member Payment" => "Register Member Payment",
// "Register and make a member payment at the same time" => "Register and make a member payment at the same time",
// "NA" => "NA",
// "Fixed Periods" => "Fixed Periods",
// "Give specific periods that can be chosen with a dropdown list.\n\t\t\t\t\t\tExample" => "Give specific periods that can be chosen with a dropdown list.\n\t\t\t\t\t\tExample",
// "Insufficient Privileges" => "Insufficient Privileges",
"Submit" => "送出",
// "You will be redirected in 5 seconds" => "You will be redirected in 5 seconds",
// "Display the relation of an object to the rest of the site" => "Display the relation of an object to the rest of the site",
// "Qualifiers" => "Qualifiers",
// "Comma-separated list of relation qualifiers" => "Comma-separated list of relation qualifiers",
// "Object identifier as %0type:itemId%1" => "Object identifier as %0type:itemId%1",
// "Single List" => "Single List",
// "Render all qualifiers into a single list without displaying the qualifier name" => "Render all qualifiers into a single list without displaying the qualifier name",
// "Empty Message" => "Empty Message",
// "Message to give if result is empty and no relations are found" => "Message to give if result is empty and no relations are found",
// "Remarks Box" => "Remarks Box",
// "Display a comment, tip, note or warning box" => "Display a comment, tip, note or warning box",
// "remarks text" => "remarks text",
// "Select type of remarksbox, which determines what icon and style will be displayed" => "Select type of remarksbox, which determines what icon and style will be displayed",
// "Confirm" => "Confirm",
// "Tip" => "Tip",
// "Label displayed above the remark" => "Label displayed above the remark",
// "Use the highlight class for formatting (not used by default)" => "Use the highlight class for formatting (not used by default)",
// "Custom Icon" => "Custom Icon",
// "Enter a custom icon name (from tiki available icon at https://doc.tiki.org/PluginIcon)" => "Enter a custom icon name (from tiki available icon at https://doc.tiki.org/PluginIcon)",
// "Show a close button (not shown by default)" => "Show a close button (not shown by default)",
// "Width (e.g. %0100%%1 or %0250px%1 - default \"\")" => "Width (e.g. %0100%%1 or %0250px%1 - default \"\")",
// "Remember Dismiss" => "Remember Dismiss",
// "Set whether to remember if the alert is dismissed (not remembered by default).\n\t\t\t\t\tRequires %0id%1 and %0version%1 parameters to be set" => "Set whether to remember if the alert is dismissed (not remembered by default).\n\t\t\t\t\tRequires %0id%1 and %0version%1 parameters to be set",
// "Sets an HTML id for the account" => "Sets an HTML id for the account",
// "Sets a version for the alert. If new version, the alert should show up again even\n\t\t\t\t\tif it was previously dismissed using the %0store_cookie%1 parameter" => "Sets a version for the alert. If new version, the alert should show up again even\n\t\t\t\t\tif it was previously dismissed using the %0store_cookie%1 parameter",
// "RR (R syntax also)" => "RR (R syntax also)",
// "Same as PluginR, but allowing the execution of potentially dangerous commands once the admin has validated the plugin call" => "Same as PluginR, but allowing the execution of potentially dangerous commands once the admin has validated the plugin call",
// "R Code" => "R Code",
// "echo" => "echo",
// "Show a code block with the R commands to be run before running them (similarly to the echo command)" => "Show a code block with the R commands to be run before running them (similarly to the echo command)",
// "echo debug" => "echo debug",
// "Show a code block with the R commands to be run even if the R program fails to execute" => "Show a code block with the R commands to be run even if the R program fails to execute",
// "Word Wrap" => "Word Wrap",
// "Enable word wrapping on the code to avoid breaking the layout" => "Enable word wrapping on the code to avoid breaking the layout",
// "Syntax highlighting with colors. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, rsplus.." => "Syntax highlighting with colors. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, rsplus..",
// "wikisyntax" => "wikisyntax",
// "Choose whether the output should be parsed as wiki syntax (Optional). Options: 0 (no parsing, default), 1 (parsing)" => "Choose whether the output should be parsed as wiki syntax (Optional). Options: 0 (no parsing, default), 1 (parsing)",
// "width" => "width",
// "Width of the graph (Optional). Options: an integer number in pixels (default) or in units specified. If ommitted but height is set, width will be proportional to keep aspect ratio" => "Width of the graph (Optional). Options: an integer number in pixels (default) or in units specified. If ommitted but height is set, width will be proportional to keep aspect ratio",
// "height" => "height",
// "Height of the graph (Optional). Options: an integer number in pixels (default) or in units specified. If ommitted but width is set, height will be proportional to keep aspect ratio" => "Height of the graph (Optional). Options: an integer number in pixels (default) or in units specified. If ommitted but width is set, height will be proportional to keep aspect ratio",
// "units" => "units",
// "Choose units for the width and/or height parameters (Optional). Options: px (default) for pixels, in (inches), cm or mm" => "Choose units for the width and/or height parameters (Optional). Options: px (default) for pixels, in (inches), cm or mm",
// "pointsize" => "pointsize",
// "The default pointsize of plotted text, interpreted as big points (1/72 inch) at res dpi (optional). Options: interger number such as 12 or bigger" => "The default pointsize of plotted text, interpreted as big points (1/72 inch) at res dpi (optional). Options: interger number such as 12 or bigger",
// "bg" => "bg",
// "The initial background colour (optional). Options: white, yellow, grey, ... and transparent" => "The initial background colour (optional). Options: white, yellow, grey, ... and transparent",
// "parse_body" => "parse_body",
// "parses the body content to allow data to be generated from other plugins" => "parses the body content to allow data to be generated from other plugins",
// "res" => "res",
// "The nominal resolution in dpi which will be recorded in the bitmap file (if any). Also used for units other than the default, and to convert points to pixels (Optional). Options: a positive integer (default: 72 dpi). Values higher than 150 usually seem to be too much" => "The nominal resolution in dpi which will be recorded in the bitmap file (if any). Also used for units other than the default, and to convert points to pixels (Optional). Options: a positive integer (default: 72 dpi). Values higher than 150 usually seem to be too much",
// "svg" => "svg",
// "Show link for the creation of the SVG version of the plot. Options: 0 (do not create it, default), 1 (create it). Requires R Cairo pakage, which can be checked with the following command in the R console: capabilities()" => "Show link for the creation of the SVG version of the plot. Options: 0 (do not create it, default), 1 (create it). Requires R Cairo pakage, which can be checked with the following command in the R console: capabilities()",
// "pdf" => "pdf",
// "Show link for the creation of the PDF version of the plot. Options: 0 (do not create it, default), 1 (create it). Requires R Cairo pakage, which can be checked with the following command in the R console: capabilities()" => "Show link for the creation of the PDF version of the plot. Options: 0 (do not create it, default), 1 (create it). Requires R Cairo pakage, which can be checked with the following command in the R console: capabilities()",
// "onefile" => "onefile",
// "Should all plots appear in one file? This is the default value (1); but if you answer no, they will attempt to appear in separate files in the server, even if you currently will not be able to fetch them easily through the internet browser. This param can be used with figure types svg and pdf; however, not many svg viewers support several plots in one svg file" => "Should all plots appear in one file? This is the default value (1); but if you answer no, they will attempt to appear in separate files in the server, even if you currently will not be able to fetch them easily through the internet browser. This param can be used with figure types svg and pdf; however, not many svg viewers support several plots in one svg file",
// "LoadAndSave" => "LoadAndSave",
// "Load a previous R session (.RData, if any) for the same wiki page so that R object will be used while you work within the same page. For pretty trackers are used (wiki pages with itemId), the R session data (.RData) will be shared for the same itemId across wiki pages" => "Load a previous R session (.RData, if any) for the same wiki page so that R object will be used while you work within the same page. For pretty trackers are used (wiki pages with itemId), the R session data (.RData) will be shared for the same itemId across wiki pages",
// "Caching strategy" => "Caching strategy",
// "Define caching strategy, including LoadAndSave session. Default: One cache and one LoadAndSave session per plugin" => "Define caching strategy, including LoadAndSave session. Default: One cache and one LoadAndSave session per plugin",
// "Limit cache duration" => "Limit cache duration",
// "Force cache recalculation after time limit. Default: No limit" => "Force cache recalculation after time limit. Default: No limit",
// "CacheBy" => "CacheBy",
// "Write cached files inside a folder containing the Page id (pageid; default option) or the Page name (pagename)" => "Write cached files inside a folder containing the Page id (pageid; default option) or the Page name (pagename)",
// "Page Name (pagename)" => "Page Name (pagename)",
// "Page Id (pageid)" => "Page Id (pageid)",
// "Cache age" => "Cache age",
// "Display cache last modification date below the graph (default option: do not display)" => "Display cache last modification date below the graph (default option: do not display)",
// "attId" => "attId",
// "AttId from a tracker Item attachment. ex: 1. (Optional)" => "AttId from a tracker Item attachment. ex: 1. (Optional)",
// "Choose the source file type in the appropriate mimetype syntax (Optional). Options: csv|xml. ex: csv. (default). For xml, see documentation for more details on the additional R packages required" => "Choose the source file type in the appropriate mimetype syntax (Optional). Options: csv|xml. ex: csv. (default). For xml, see documentation for more details on the additional R packages required",
// "csv" => "csv",
// "xml" => "xml",
// "x11" => "x11",
// "Choose whether the server can use X11 to produce graphs in R, or alternatively use dev2bitmap instead (Optional). Options: 1 (R has support for X11, default), 0 (no support for X11 thus using dev2bitmap). These capabilities can be checked in the server with the command in the R console: capabilities()" => "Choose whether the server can use X11 to produce graphs in R, or alternatively use dev2bitmap instead (Optional). Options: 1 (R has support for X11, default), 0 (no support for X11 thus using dev2bitmap). These capabilities can be checked in the server with the command in the R console: capabilities()",
// "removen" => "removen",
// "Remove the extra \\n tags generated by some R packages out of the user control (such as with charts generated through GoogleVis R package). Options: 0 (do not remove \\n tags, default), 1 (remove them all)" => "Remove the extra \\n tags generated by some R packages out of the user control (such as with charts generated through GoogleVis R package). Options: 0 (do not remove \\n tags, default), 1 (remove them all)",
// "Custom output" => "Custom output",
// "Write your custom png creation R command. Use tikiRRfilename for value of output. RR does not produce an output file" => "Write your custom png creation R command. Use tikiRRfilename for value of output. RR does not produce an output file",
// "security" => "security",
// "Set the security level for the R commands allowed by the plugin. ex: 1. (default in R), 0 for no security checking (default in RR)" => "Set the security level for the R commands allowed by the plugin. ex: 1. (default in R), 0 for no security checking (default in RR)",
// "Cache was last modified: %0" => "Cache was last modified: %0",
// "One cache per plugin" => "One cache per plugin",
// "One cache per plugin per user" => "One cache per plugin per user",
// "No caching: Ignore and replace existing cache, if any" => "No caching: Ignore and replace existing cache, if any",
// "No limit" => "No limit",
// "1 hour" => "1 hour",
// "1 day" => "1 day",
// "7 days" => "7 days",
// "30 days" => "30 days",
// "365 days" => "365 days",
// "Don't display cache creation date" => "Don't display cache creation date",
// "Display cache creation date" => "Display cache creation date",
// "Blocked commands found: " => "Blocked commands found: ",
// "Use Plugin RR instead and validate your plugin call, or contact a site admin to have the plugin call validated for you" => "Use Plugin RR instead and validate your plugin call, or contact a site admin to have the plugin call validated for you",
// "command unavailable" => "command unavailable",
// "The __R__ package needs to be installed on the server" => "The __R__ package needs to be installed on the server",
// "See requirements on [https://doc.tiki.org/PluginR]" => "See requirements on [https://doc.tiki.org/PluginR]",
// "The path to the __R__ command could not be found on your system" => "The path to the __R__ command could not be found on your system",
// "Maybe this file is inaccessible due to safe mode restrictions" => "Maybe this file is inaccessible due to safe mode restrictions",
// "The path to the __convert__ command could not be found on your system" => "The path to the __convert__ command could not be found on your system",
// "You need to ensure that you have __imagemagick__ installed successfully on the server" => "You need to ensure that you have __imagemagick__ installed successfully on the server",
// "Cached R output from %0. If you click, you will re-run all R scripts in this page" => "Cached R output from %0. If you click, you will re-run all R scripts in this page",
// "Save Image as SVG" => "Save Image as SVG",
// "Save Image as PDF" => "Save Image as PDF",
// "plot" => "plot",
// "RSS Feed" => "RSS Feed",
// "Display items from one or more RSS feeds" => "Display items from one or more RSS feeds",
// "IDs" => "IDs",
// "List of feed IDs separated by colons. ex: %0" => "List of feed IDs separated by colons. ex: %0",
// "Result Count" => "Result Count",
// "Number of results displayed" => "Number of results displayed",
// "Show date of each item (not shown by default)" => "Show date of each item (not shown by default)",
// "Show feed descriptions (not shown by default)" => "Show feed descriptions (not shown by default)",
// "Show authors (not shown by default)" => "Show authors (not shown by default)",
// "URL to a favicon to put before each entry" => "URL to a favicon to put before each entry",
// "Show the title of the feed (shown by default)" => "Show the title of the feed (shown by default)",
// "Ticker" => "Ticker",
// "Turn static feed display into ticker news like" => "Turn static feed display into ticker news like",
// "Description Length" => "Description Length",
// "Max characters/length, truncates text to fit design" => "Max characters/length, truncates text to fit design",
// "Scroll" => "Scroll",
// "Show animated text that scrolls up or down" => "Show animated text that scrolls up or down",
// "Width in pixels. Example: %0" => "Width in pixels. Example: %0",
// "Number of pixels followed by \"px\"" => "Number of pixels followed by \"px\"",
// "Height in pixels. Example: %0" => "Height in pixels. Example: %0",
// "Scroll speed in number of seconds (default is %0)" => "Scroll speed in number of seconds (default is %0)",
// "SourceForge" => "SourceForge",
// "Creates a link to SourceForge tracker items" => "Creates a link to SourceForge tracker items",
// "Group ID" => "Group ID",
// "SourceForge project ID (shows as group_id in the URL of a tracker item" => "SourceForge project ID (shows as group_id in the URL of a tracker item",
// "SourceForge tracker ID (shows as atid in the URL of a tracker item" => "SourceForge tracker ID (shows as atid in the URL of a tracker item",
// "SourceForge item ID (shows as aid in the URL of a tracker item" => "SourceForge item ID (shows as aid in the URL of a tracker item",
// "Link title" => "Link title",
// "First part of link tooltip identifying the type of tracker item (bug, feature\n\t\t\t\t\trequest, patch or support request)" => "First part of link tooltip identifying the type of tracker item (bug, feature\n\t\t\t\t\trequest, patch or support request)",
// "ShareThis" => "ShareThis",
// "Add a ShareThis button" => "Add a ShareThis button",
// "Send Services" => "Send Services",
// "By default, %0email%1, %0aim%1 and %0sms%1 are available. Input one or two of the\n\t\t\t\t\tservices separated by a %0|%1 to limit the choice of send services" => "By default, %0email%1, %0aim%1 and %0sms%1 are available. Input one or two of the\n\t\t\t\t\tservices separated by a %0|%1 to limit the choice of send services",
// "AIM" => "AIM",
// "AIM and Email" => "AIM and Email",
// "AIM and SMS" => "AIM and SMS",
// "Email and SMS" => "Email and SMS",
// "Button Style" => "Button Style",
// "Set button style" => "Set button style",
// "Rotate Image" => "Rotate Image",
// "A value of %0y%1 (Yes) will cause the button icon to rotate every 3 seconds between\n\t\t\t\t\ta few icons, cycling through twice before stopping" => "A value of %0y%1 (Yes) will cause the button icon to rotate every 3 seconds between\n\t\t\t\t\ta few icons, cycling through twice before stopping",
// "Multiple Icons" => "Multiple Icons",
// "Enter pipe-separated list of services, e.g., %0" => "Enter pipe-separated list of services, e.g., %0",
// "First Services Shown" => "First Services Shown",
// "Input a list of post services (like %0Facebook|Myspace|Digg%1, etc.) separated by a\n\t\t\t\t\t%0|%1 to customize the services that are shown in the opening panel of the widget" => "Input a list of post services (like %0Facebook|Myspace|Digg%1, etc.) separated by a\n\t\t\t\t\t%0|%1 to customize the services that are shown in the opening panel of the widget",
// "Custom link text for the button" => "Custom link text for the button",
// "Header Title" => "Header Title",
// "Optional header title text for the widget" => "Optional header title text for the widget",
// "Header Background" => "Header Background",
// "HTML color code (not color name) for the background color for the header if an\n\t\t\t\t\toptional header title is used" => "HTML color code (not color name) for the background color for the header if an\n\t\t\t\t\toptional header title is used",
// "Header Text Color" => "Header Text Color",
// "HTML color code (not color name) for the header text if an optional header title is used" => "HTML color code (not color name) for the header text if an optional header title is used",
// "Link text color for services" => "Link text color for services",
// "HTML color code (not color name) for the link text for all send and post services shown in the widget" => "HTML color code (not color name) for the link text for all send and post services shown in the widget",
// "Set whether the widget will show in a popup window" => "Set whether the widget will show in a popup window",
// "Embedded Elements" => "Embedded Elements",
// "Allow embedded elements (like flash) to be seen while iframe is loading" => "Allow embedded elements (like flash) to be seen while iframe is loading",
// "Sheet" => "Sheet",
// "Display data from a TikiSheet" => "Display data from a TikiSheet",
// "Spreadsheet Heading" => "Spreadsheet Heading",
// "Internal ID of the TikiSheet. Either %0id%1 or %0url%1 is required" => "Internal ID of the TikiSheet. Either %0id%1 or %0url%1 is required",
// "Sheet Url Location" => "Sheet Url Location",
// "Internal URL of the Table to use as a spreadsheet. Either %0id%1 or %0url%1 is\n\t\t\t\t\trequired" => "Internal URL of the Table to use as a spreadsheet. Either %0id%1 or %0url%1 is\n\t\t\t\t\trequired",
// "Show a simple table view (Default: %0 = jquery.sheet view if feature enabled)" => "Show a simple table view (Default: %0 = jquery.sheet view if feature enabled)",
// "Width in pixels or percentage. Default value is page width, for example, %0200px%1 or\n\t\t\t\t\t%0100%%1" => "Width in pixels or percentage. Default value is page width, for example, %0200px%1 or\n\t\t\t\t\t%0100%%1",
// "Height in pixels or percentage. Default value is complete spreadsheet height" => "Height in pixels or percentage. Default value is complete spreadsheet height",
// "Show edit button. Default is to show depending on user's permissions" => "Show edit button. Default is to show depending on user's permissions",
// "Show subsheets" => "Show subsheets",
// "Show multi-sheets (default is to show)" => "Show multi-sheets (default is to show)",
// "Show a range of cells (or single cell). Default shows all. e.g. %0D1:F3%1 or\n\t\t\t\t\t%0e14:e14%1" => "Show a range of cells (or single cell). Default shows all. e.g. %0D1:F3%1 or\n\t\t\t\t\t%0e14:e14%1",
// "Apply custom CSS class to the containing div" => "Apply custom CSS class to the containing div",
// "New sheet in page: " => "New sheet in page: ",
// "Create New Sheet" => "Create New Sheet",
// "Error loading spreadsheet" => "Error loading spreadsheet",
// "Edit Sheet" => "Edit Sheet",
// "Collect Anonymous Shopper Info" => "Collect Anonymous Shopper Info",
// "PluginShopperinfo" => "PluginShopperinfo",
// "Collect shopper information for the shopping cart" => "Collect shopper information for the shopping cart",
// "Values to be collected" => "Values to be collected",
// "Names of values to be collected separated by : as defined in shopper profile" => "Names of values to be collected separated by : as defined in shopper profile",
// "Labels for the values to be collected" => "Labels for the values to be collected",
// "Labels of the values to be collected separated by a colon" => "Labels of the values to be collected separated by a colon",
// "Show even if logged in" => "Show even if logged in",
// "Normally this is used for anonymous users but sometimes may be used when logged in also" => "Normally this is used for anonymous users but sometimes may be used when logged in also",
// "Shorten" => "Shorten",
// "Show/hide a portion of text" => "Show/hide a portion of text",
// "Char length of always visible portion of text" => "Char length of always visible portion of text",
// "More text" => "More text",
// "A label indicating the text is expandable" => "A label indicating the text is expandable",
// "Less text" => "Less text",
// "A label for collapse text action" => "A label for collapse text action",
// "Show Pages" => "Show Pages",
// "Find pages by searching within page names" => "Find pages by searching within page names",
// "Search criteria" => "Search criteria",
// "Maximum amount of results displayed" => "Maximum amount of results displayed",
// "Display page name and/or description. Both displayed by default" => "Display page name and/or description. Both displayed by default",
// "Name & Description" => "Name & Description",
// "Show Preference" => "Show Preference",
// "Display the value of public global preferences" => "Display the value of public global preferences",
// "Name of preference to be displayed" => "Name of preference to be displayed",
// "Add Bibliography" => "Add Bibliography",
// "Add bibliography listing in the footer of a wiki page" => "Add bibliography listing in the footer of a wiki page",
// "Title to be displayed in the bibliography listing. Default is %0Bibliography%1" => "Title to be displayed in the bibliography listing. Default is %0Bibliography%1",
// "Show bibliography title. Title is shown by default" => "Show bibliography title. Title is shown by default",
// "Header Tag" => "Header Tag",
// "The HTML header tag level of the title. Default: %01%1" => "The HTML header tag level of the title. Default: %01%1",
// "Remove the lines around the list of references" => "Remove the lines around the list of references",
// "Remove the horizontal lines displayed above and below the list of references" => "Remove the horizontal lines displayed above and below the list of references",
// "Page identifier" => "Page identifier",
// "Provide the page id" => "Provide the page id",
// "Bibliography" => "Bibliography",
// "Signature" => "Signature",
// "Sign and date your contribution to a page" => "Sign and date your contribution to a page",
// "Auto-generated, the username" => "Auto-generated, the username",
// "Date and time" => "Date and time",
// "Auto-generated, the timestamp" => "Auto-generated, the timestamp",
// "Skype" => "Skype",
// "Add a link for calling or chating with a Skype user" => "Add a link for calling or chating with a Skype user",
// "Name or number to call or chat with" => "Name or number to call or chat with",
// "Set whether to call or chat. Default is chat" => "Set whether to call or chat. Default is chat",
// "Call" => "Call",
"Chat" => "閒談",
// "Show status" => "Show status",
// "Show a status icon or not i.e. if online/offline/etc. Default is to not show status" => "Show a status icon or not i.e. if online/offline/etc. Default is to not show status",
"yes" => "是",
// "do not forget to check the tools / options/\n\t\t\tprivacy / allow my status to be show on the web" => "do not forget to check the tools / options/\n\t\t\tprivacy / allow my status to be show on the web",
// "click to" => "click to",
// "Slider" => "Slider",
// "Embed a mini-slideshow of content on a page" => "Embed a mini-slideshow of content on a page",
// "Content separated by \"/////\"" => "Content separated by \"/////\"",
// "Slider Titles" => "Slider Titles",
// "Pipe-separated list of slider titles. Example" => "Pipe-separated list of slider titles. Example",
// "Height in pixels or percentage. Default value is complete slider height.\n\t\t\t\t\tIf the %0 parameter set to Yes (%1), then don't use percent only use pixels" => "Height in pixels or percentage. Default value is complete slider height.\n\t\t\t\t\tIf the %0 parameter set to Yes (%1), then don't use percent only use pixels",
// "The theme to use in slider" => "The theme to use in slider",
// "Expand" => "Expand",
// "Set whether the entire slider expands to fit the parent element. The %0 parameter\n\t\t\t\t\tneeds to also be set" => "Set whether the entire slider expands to fit the parent element. The %0 parameter\n\t\t\t\t\tneeds to also be set",
// "Resize" => "Resize",
// "Set whether solitary images/objects in the panel will be expanded to fit the viewport" => "Set whether solitary images/objects in the panel will be expanded to fit the viewport",
// "Show Multiple" => "Show Multiple",
// "Set this value to a number and it will show that many slides at once" => "Set this value to a number and it will show that many slides at once",
// "Arrows" => "Arrows",
// "Set whether to show forward and backward buttons" => "Set whether to show forward and backward buttons",
// "Navigation" => "Navigation",
// "Set whether to show a list of anchor links to link to each panel" => "Set whether to show a list of anchor links to link to each panel",
// "Start / Stop" => "Start / Stop",
// "Set whether to show a start/stop button and add slideshow functionality" => "Set whether to show a start/stop button and add slideshow functionality",
// "Toggle Arrows" => "Toggle Arrows",
// "Set whether side navigation arrows slide out on hovering and hide at other times" => "Set whether side navigation arrows slide out on hovering and hide at other times",
// "Toggle Controls" => "Toggle Controls",
// "Set whether slide in controls (navigation + play/stop button) on hover and slide\n\t\t\t\t\tchange, hide at other times" => "Set whether slide in controls (navigation + play/stop button) on hover and slide\n\t\t\t\t\tchange, hide at other times",
// "Enable Arrows" => "Enable Arrows",
// "Set whether arrows are clickable" => "Set whether arrows are clickable",
// "Enable Navigation" => "Enable Navigation",
// "Set whether navigation links are clickable" => "Set whether navigation links are clickable",
// "Enable Start Stop" => "Enable Start Stop",
// "Set whether the play/stop button is clickable. Previously %0" => "Set whether the play/stop button is clickable. Previously %0",
// "Enable Keyboard" => "Enable Keyboard",
// "Set whether keyboard arrow keys will work for this slider" => "Set whether keyboard arrow keys will work for this slider",
// "Auto Play" => "Auto Play",
// "Set whether the slideshow will start running automatically; replaces %0 option" => "Set whether the slideshow will start running automatically; replaces %0 option",
// "Auto Play Locked" => "Auto Play Locked",
// "Keep playing the slideshow even if the user changes slides" => "Keep playing the slideshow even if the user changes slides",
// "Auto Play Delayed" => "Auto Play Delayed",
// "Set whether there will be a delay in advancing slides" => "Set whether there will be a delay in advancing slides",
// "Pause On Hover" => "Pause On Hover",
// "Set whether the slideshow will pause on hover while the slideshow is active" => "Set whether the slideshow will pause on hover while the slideshow is active",
// "Stop At End" => "Stop At End",
// "Set whether the slideshow stops on the last page" => "Set whether the slideshow stops on the last page",
// "Delay between slides" => "Delay between slides",
// "Time in milliseconds between slideshow transitions (in AutoPlay mode)" => "Time in milliseconds between slideshow transitions (in AutoPlay mode)",
// "Right To Left" => "Right To Left",
// "Set whether the slideshow moves right-to-left" => "Set whether the slideshow moves right-to-left",
// "Resume On Video End" => "Resume On Video End",
// "Set whether auto play stops until the video is complete (for supported video types)" => "Set whether auto play stops until the video is complete (for supported video types)",
// "Animation Time" => "Animation Time",
// "Milliseconds between slides" => "Milliseconds between slides",
// "Panel Hashtags" => "Panel Hashtags",
// "Set whether to include a hashtag in the page URL, allowing links to specific panels" => "Set whether to include a hashtag in the page URL, allowing links to specific panels",
// "Create a slideshow from the content of a wiki page" => "Create a slideshow from the content of a wiki page",
// "The theme you want to use for the slideshow, default will be what you choose from\n\t\t\t\t\tthe admin panel under Look and Feel for jQuery UI" => "The theme you want to use for the slideshow, default will be what you choose from\n\t\t\t\t\tthe admin panel under Look and Feel for jQuery UI",
// "Parallax Background Image" => "Parallax Background Image",
// "URL of the background image to use in your slideshow, overrides %0" => "URL of the background image to use in your slideshow, overrides %0",
// "Valid URL" => "Valid URL",
// "Parallax Background Size" => "Parallax Background Size",
// "syntax, e.g. \"2100px 900px\" - currently only pixels are supported (don't use % or auto)" => "syntax, e.g. \"2100px 900px\" - currently only pixels are supported (don't use % or auto)",
// "Parallax Background Horizontal" => "Parallax Background Horizontal",
// "Number of pixels to move the parallax background per slide, Calculated automatically unless specified. Set to 0 to disable movement along an axis" => "Number of pixels to move the parallax background per slide, Calculated automatically unless specified. Set to 0 to disable movement along an axis",
// "Parallax Background Vertical" => "Parallax Background Vertical",
// "Transition" => "Transition",
// " Transition style" => " Transition style",
// "Transition Speed" => "Transition Speed",
// "Background Transition" => "Background Transition",
// "Transition style for full page slide backgrounds" => "Transition style for full page slide backgrounds",
// "Display presentation control arrows" => "Display presentation control arrows",
// "Controls Layout" => "Controls Layout",
// "Determines where controls appear, \"edges\" or \"bottom-right\"" => "Determines where controls appear, \"edges\" or \"bottom-right\"",
// "Controls Back Arrows" => "Controls Back Arrows",
// "Visibility rule for backwards navigation arrows; \"faded\", \"hidden\" or \"visible\"" => "Visibility rule for backwards navigation arrows; \"faded\", \"hidden\" or \"visible\"",
// "Progress" => "Progress",
// "Display a presentation progress bar" => "Display a presentation progress bar",
// "Slide Number" => "Slide Number",
// "Display the page number of the current slide" => "Display the page number of the current slide",
// "Fragments" => "Fragments",
// "Turns fragments on and off globally" => "Turns fragments on and off globally",
// "Fragment Effects" => "Fragment Effects",
// "Fragment Highlight Color" => "Fragment Highlight Color",
// "Auto Slide" => "Auto Slide",
// "Number of milliseconds between automatically proceeding to the next slide, disabled when set to 0, this value can be overwritten by using a data-autoslide attribute on your slides" => "Number of milliseconds between automatically proceeding to the next slide, disabled when set to 0, this value can be overwritten by using a data-autoslide attribute on your slides",
// "Auto Slide Stoppable" => "Auto Slide Stoppable",
// "Stop auto-sliding after user input" => "Stop auto-sliding after user input",
// "Auto-align Images" => "Auto-align Images",
// "Automatically move images to left hand side of slide text, will only align images greater than 200px in width" => "Automatically move images to left hand side of slide text, will only align images greater than 200px in width",
// "Start Slideshow Presentation" => "Start Slideshow Presentation",
// "SlideshowSlide" => "SlideshowSlide",
// "Advance plugin to add slide in slideshow with different background colors, background video, transition and other settings" => "Advance plugin to add slide in slideshow with different background colors, background video, transition and other settings",
// "Enter content of slide" => "Enter content of slide",
// "Slide Background color" => "Slide Background color",
// "Set background color for slide" => "Set background color for slide",
// "Slide Text color" => "Slide Text color",
// "Set Text color for slide" => "Set Text color for slide",
// "Background Video URL" => "Background Video URL",
// "Automatically plays a full size video behind the slide" => "Automatically plays a full size video behind the slide",
// "Mute Background Video" => "Mute Background Video",
// "Flags if the audio should be muted for background video" => "Flags if the audio should be muted for background video",
// "Loop Background Video" => "Loop Background Video",
// "Flags if the background video played in loop" => "Flags if the background video played in loop",
// "Transition In" => "Transition In",
// "Select entry transition effect for slide" => "Select entry transition effect for slide",
// "Transition Out" => "Transition Out",
// "Select exit transition effect for slide" => "Select exit transition effect for slide",
// "Smarty function" => "Smarty function",
// "Insert a Smarty function or variable" => "Insert a Smarty function or variable",
// "The name of the Smarty function that the plugin will activate. Available functions can be found at %0 and %1" => "The name of the Smarty function that the plugin will activate. Available functions can be found at %0 and %1",
// "Snarf" => "Snarf",
// "Display the contents of another web page" => "Display the contents of another web page",
// "Full URL to the page to include" => "Full URL to the page to include",
// "Regular Expression Pattern" => "Regular Expression Pattern",
// "PCRE-compliant regular expression pattern to find the parts you want changed" => "PCRE-compliant regular expression pattern to find the parts you want changed",
// "Regular Expression Replacement" => "Regular Expression Replacement",
// "PCRE-compliant regular expression replacement syntax showing what the content should be changed to" => "PCRE-compliant regular expression replacement syntax showing what the content should be changed to",
// "Enable/disable word wrapping of snippets of code (enabled by default)" => "Enable/disable word wrapping of snippets of code (enabled by default)",
// "Syntax highlighting to use for code snippets (Plugin Code is used for this)" => "Syntax highlighting to use for code snippets (Plugin Code is used for this)",
// "Set to Yes (%0) to add line numbers to code snippets (not shown by default)" => "Set to Yes (%0) to add line numbers to code snippets (not shown by default)",
// "Parse wiki syntax within the code snippet (not parsed by default)" => "Parse wiki syntax within the code snippet (not parsed by default)",
// "Switch the text display from left to right to right to left" => "Switch the text display from left to right to right to left",
// "HTML Content" => "HTML Content",
// "Set to Yes (%0) to display the content as is instead of escaping HTML special\n\t\t\t\t\tcharacters (not set by default)" => "Set to Yes (%0) to display the content as is instead of escaping HTML special\n\t\t\t\t\tcharacters (not set by default)",
// "Cache URL" => "Cache URL",
// "Cache time in minutes. Default is to use site preference, Set to %0 for no cache" => "Cache time in minutes. Default is to use site preference, Set to %0 for no cache",
// "Text to click on to fetch the URL via Ajax" => "Text to click on to fetch the URL via Ajax",
// "Sort lines of text" => "Sort lines of text",
// "Data to sort, one entry per line" => "Data to sort, one entry per line",
"Order" => "順序",
// "Set the sort order of lines of content (default is ascending)" => "Set the sort order of lines of content (default is ascending)",
// "Reverse" => "Reverse",
// "Shuffle" => "Shuffle",
// "Arrange content on a page into rows and columns" => "Arrange content on a page into rows and columns",
// "Text to display in a table. Use \"---\" to separate the columns and \"@@@\" to separate rows" => "Text to display in a table. Use \"---\" to separate the columns and \"@@@\" to separate rows",
// "Generate the colspan attribute if columns are missing" => "Generate the colspan attribute if columns are missing",
// "Fixed Size" => "Fixed Size",
// "Generate the width attribute for the columns" => "Generate the width attribute for the columns",
// "Specify all column widths in number of pixels or percent, separating each width\n\t\t\t\t\tby a pipe (%0)" => "Specify all column widths in number of pixels or percent, separating each width\n\t\t\t\t\tby a pipe (%0)",
// "Cells specified are ordered first left to right across rows (default) or top to\n\t\t\t\t\tbottom down columns" => "Cells specified are ordered first left to right across rows (default) or top to\n\t\t\t\t\tbottom down columns",
// "Display edit icon for each section. Works when used on a wiki page and the %0\n\t\t\t\t\tparameter is set to %1" => "Display edit icon for each section. Works when used on a wiki page and the %0\n\t\t\t\t\tparameter is set to %1",
// "SQL" => "SQL",
// "Query a MySQL database and display the results" => "Query a MySQL database and display the results",
// "The SQL query goes in the body. Example: " => "The SQL query goes in the body. Example: ",
// "DSN Name" => "DSN Name",
// "DSN name of the database being queried. The DSN name needs to first be defined at\n\t\t\t\t\t%0" => "DSN name of the database being queried. The DSN name needs to first be defined at\n\t\t\t\t\t%0",
// "Raw return" => "Raw return",
// "Return with table formatting (default) or raw data with no table formatting" => "Return with table formatting (default) or raw data with no table formatting",
// "Raw" => "Raw",
// "Delim" => "Delim",
// "The delimiter to be used between data elements (sets %0)" => "The delimiter to be used between data elements (sets %0)",
// "Turn wiki parsing of select results on and off (default is on)" => "Turn wiki parsing of select results on and off (default is on)",
"Missing db param" => "缺少資料庫參數",
// "Could not obtain valid DSN connection" => "Could not obtain valid DSN connection",
// "Stat" => "Stat",
// "Show various statistics for an object" => "Show various statistics for an object",
// "Colon-separated list of object type to show stats for" => "Colon-separated list of object type to show stats for",
// "Article & Tracker Item" => "Article & Tracker Item",
// "Article & Tracker Item & Wiki" => "Article & Tracker Item & Wiki",
// "Article & Wiki" => "Article & Wiki",
// "Article & Wiki & Tracker Item" => "Article & Wiki & Tracker Item",
// "Tracker Item & Article" => "Tracker Item & Article",
// "Tracker Item & Article & Wiki" => "Tracker Item & Article & Wiki",
// "Tracker Item & Wiki" => "Tracker Item & Wiki",
// "Tracker Item & Wiki & Article" => "Tracker Item & Wiki & Article",
// "Wiki & Article" => "Wiki & Article",
// "Wiki & Article & Tracker Item" => "Wiki & Article & Tracker Item",
// "Wiki & Tracker Item" => "Wiki & Tracker Item",
// "Wiki & Tracker Item & Article" => "Wiki & Tracker Item & Article",
// "Parent ID" => "Parent ID",
// "Enter a tracker ID to restrict stats to that tracker (for use with trackeritems only)" => "Enter a tracker ID to restrict stats to that tracker (for use with trackeritems only)",
// "Last 24 Hours" => "Last 24 Hours",
// "Added and/or viewed in the last 24 hours (only added items shown for tracker\n\t\t\t\t\titems whether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed in the last 24 hours (only added items shown for tracker\n\t\t\t\t\titems whether %0a%1 (added) or %0v%1 (viewed) or both is set)",
// "a or v or both separated by a colon. Example: \"a:v\" or \"v:a\"" => "a or v or both separated by a colon. Example: \"a:v\" or \"v:a\"",
"Added" => "增加",
// "Added and Viewed" => "Added and Viewed",
// "Viewed" => "Viewed",
// "Viewed & Added" => "Viewed & Added",
// "Added and/or viewed since the beginning of the day (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed since the beginning of the day (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)",
// "Last 7 Days" => "Last 7 Days",
// "Added and/or viewed in the last 7 days (only added items shown for tracker items\n\t\t\t\t\twhether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed in the last 7 days (only added items shown for tracker items\n\t\t\t\t\twhether %0a%1 (added) or %0v%1 (viewed) or both is set)",
// "This Week" => "This Week",
// "Added and/or viewed since the beginning of the week (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed since the beginning of the week (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)",
// "Last Month" => "Last Month",
// "Added and/or viewed last month (only added items shown for tracker items\n\t\t\t\t\twhether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed last month (only added items shown for tracker items\n\t\t\t\t\twhether %0a%1 (added) or %0v%1 (viewed) or both is set)",
// "This Month" => "This Month",
// "Added and/or viewed since the beginning of the month (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed since the beginning of the month (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)",
// "Last Year" => "Last Year",
// "Added and/or viewed in the last 365 days (only added items shown for tracker\n\t\t\t\t\titems whether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed in the last 365 days (only added items shown for tracker\n\t\t\t\t\titems whether %0a%1 (added) or %0v%1 (viewed) or both is set)",
// "This Year" => "This Year",
// "Added and/or viewed since the beginning of the year (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)" => "Added and/or viewed since the beginning of the year (only added items shown for\n\t\t\t\t\ttracker items whether %0a%1 (added) or %0v%1 (viewed) or both is set)",
// "Incorrect parameter: " => "Incorrect parameter: ",
// "Subscript" => "Subscript",
// "Apply subscript font to text" => "Apply subscript font to text",
// "Subscribe Group" => "Subscribe Group",
// "Allow users to subscribe to a group" => "Allow users to subscribe to a group",
// "text displayed before the button" => "text displayed before the button",
// "Group name to subscribe to or unsubscribe from" => "Group name to subscribe to or unsubscribe from",
// "Subscribe Text" => "Subscribe Text",
// "Subscribe text, containing %0 as the placeholder for the group name" => "Subscribe text, containing %0 as the placeholder for the group name",
"Subscribe" => "訂閱",
// "Unsubscribe Text" => "Unsubscribe Text",
// "Unsubscribe text, containing %0 as the placeholder for the group name" => "Unsubscribe text, containing %0 as the placeholder for the group name",
// "Unsubscribe" => "Unsubscribe",
// "Subscribe Action" => "Subscribe Action",
// "Subscribe button label, containing %0 as the placeholder for the group name" => "Subscribe button label, containing %0 as the placeholder for the group name",
// "Unsubscribe Action" => "Unsubscribe Action",
// "Unsubscribe button label, containing %0 as the placeholder for the group name" => "Unsubscribe button label, containing %0 as the placeholder for the group name",
// "Post-subscribe URL" => "Post-subscribe URL",
// "URL to send the user to after subscribing, if required" => "URL to send the user to after subscribing, if required",
// "Post-unsubscribe URL" => "Post-unsubscribe URL",
// "URL to send the user to after unsubscribing, if required" => "URL to send the user to after unsubscribing, if required",
// "Make this the default group text, containing %0 as the placeholder for the group name" => "Make this the default group text, containing %0 as the placeholder for the group name",
// "Not Default Group" => "Not Default Group",
// "Stop this being default group text, containing %0 as the placeholder for the group name" => "Stop this being default group text, containing %0 as the placeholder for the group name",
// "Default Group Action" => "Default Group Action",
// "Default group button label. Will subscribe to the group first if not already a member" => "Default group button label. Will subscribe to the group first if not already a member",
// "Not Default Group Action" => "Not Default Group Action",
// "Stop this being default group button label. Does not unsubscribe from the group" => "Stop this being default group button label. Does not unsubscribe from the group",
// "Second Default" => "Second Default",
// "Group name to set as default when user stops this group being it" => "Group name to set as default when user stops this group being it",
// "Redirect to new home page after default group change. (default is to redirect)" => "Redirect to new home page after default group change. (default is to redirect)",
// "Can Always Leave" => "Can Always Leave",
// "Always allow leaving a group even if the group settings do not allow user choice" => "Always allow leaving a group even if the group settings do not allow user choice",
// "Subscribe Groups" => "Subscribe Groups",
// "Allow users to subscribe to a list of groups" => "Allow users to subscribe to a list of groups",
// "Text shown in the dropdown box. Default: %0Subscribe to a group%1" => "Text shown in the dropdown box. Default: %0Subscribe to a group%1",
// "Show Subscribe Box" => "Show Subscribe Box",
// "Show the subscribe box (shown by default). Will not show if there are no other\n\t\t\t\t\tgroups the user may register for" => "Show the subscribe box (shown by default). Will not show if there are no other\n\t\t\t\t\tgroups the user may register for",
// "Subscribe Box Style" => "Subscribe Box Style",
// "Style to show the subscribe box" => "Style to show the subscribe box",
// "Show Default" => "Show Default",
// "Shows which group is the user's default group (if any) and allows the user to\n\t\t\t\t\tchange his or her default group" => "Shows which group is the user's default group (if any) and allows the user to\n\t\t\t\t\tchange his or her default group",
// "Group Description" => "Group Description",
// "Show the description of the group (not shown by default)" => "Show the description of the group (not shown by default)",
// "Colon-separated list of groups. By default the list of groups available to the user" => "Colon-separated list of groups. By default the list of groups available to the user",
// "Only list groups that include the group being specified here" => "Only list groups that include the group being specified here",
// "Default URL" => "Default URL",
// "Page user will be directed to after clicking on icon to change default group" => "Page user will be directed to after clicking on icon to change default group",
// "Leader Group Name" => "Leader Group Name",
// "Name of group for leaders of the group, where %0 will be substituted by\n\t\t\t\t\tthe group name" => "Name of group for leaders of the group, where %0 will be substituted by\n\t\t\t\t\tthe group name",
// "Pending Users Group Name" => "Pending Users Group Name",
// "Name of group for users that are waiting for approval to enter the group, where\n\t\t\t\t\t%0 will be substituted by the group name" => "Name of group for users that are waiting for approval to enter the group, where\n\t\t\t\t\t%0 will be substituted by the group name",
// "Group Management Page Name" => "Group Management Page Name",
// "Name of wiki page for group management by leaders, where %0 will be\n\t\t\t\t\tsubstituted by the group name" => "Name of wiki page for group management by leaders, where %0 will be\n\t\t\t\t\tsubstituted by the group name",
// "Hide link for groups including" => "Hide link for groups including",
// "Hide link to group home page for groups that include the group being specified here" => "Hide link to group home page for groups that include the group being specified here",
// "Always allow leaving group" => "Always allow leaving group",
// "Always allow leaving group even if the group settings do not allow user choice" => "Always allow leaving group even if the group settings do not allow user choice",
// "You do not have permission to subscribe to groups" => "You do not have permission to subscribe to groups",
// "Subscribe to newsletter" => "Subscribe to newsletter",
// "Allow users to subscribe to a newsletter" => "Allow users to subscribe to a newsletter",
// "Invitation message" => "Invitation message",
// "Newsletter ID" => "Newsletter ID",
// "Identification number of the Newsletter that you want to allow the users to subscribe to" => "Identification number of the Newsletter that you want to allow the users to subscribe to",
// "Confirmation Message" => "Confirmation Message",
// "Confirmation message after posting form. The plugin body is then the button label" => "Confirmation message after posting form. The plugin body is then the button label",
// "Button label. The plugin body is then the confirmation message" => "Button label. The plugin body is then the confirmation message",
// "Choose whether the output should be parsed as wiki syntax" => "Choose whether the output should be parsed as wiki syntax",
// "In Module" => "In Module",
// "Display the newsletter subscription form in module view (if included in a Tiki module)" => "Display the newsletter subscription form in module view (if included in a Tiki module)",
// "Already subscribed" => "Already subscribed",
// "Superscript" => "Superscript",
// "Apply superscript font to text" => "Apply superscript font to text",
// "Embed a survey" => "Embed a survey",
// "Id of the survey set up by the administrator" => "Id of the survey set up by the administrator",
// "Wiki Page to redirect the user after his vote" => "Wiki Page to redirect the user after his vote",
// "Language for the survey" => "Language for the survey",
// "Swiper" => "Swiper",
// "Embed swiper in content, support file galleries, files id and custom content" => "Embed swiper in content, support file galleries, files id and custom content",
// "Enter custom slides data separated by \"|\". Wiki Syntax / HTML supported in slide text, to include wiki page in slide text use pluginInclude.<code>title:Slide 1 title;text:HTML/Wiki Syntax Supported Slide 1 text;image:Slide Image URL;bgcolor:#colorcode;color: #color code for text | title:Slide 2 title;text:Slide 2 text;image:Slide Image URL;bgcolor:#colorcode</code> " => "Enter custom slides data separated by \"|\". Wiki Syntax / HTML supported in slide text, to include wiki page in slide text use pluginInclude.<code>title:Slide 1 title;text:HTML/Wiki Syntax Supported Slide 1 text;image:Slide Image URL;bgcolor:#colorcode;color: #color code for text | title:Slide 2 title;text:Slide 2 text;image:Slide Image URL;bgcolor:#colorcode</code> ",
// "Enter file gallery id for slider" => "Enter file gallery id for slider",
// "Transition Effect" => "Transition Effect",
// "Tranisition effect. Could be \"slide\", \"fade\", \"cube\", \"coverflow\" or \"flip\"" => "Tranisition effect. Could be \"slide\", \"fade\", \"cube\", \"coverflow\" or \"flip\"",
// "Slider Placement on Page" => "Slider Placement on Page",
// "Placement of slider, above topbar, below topbar, above menus and content or inside content" => "Placement of slider, above topbar, below topbar, above menus and content or inside content",
// "Inside Content" => "Inside Content",
// "Above top bar / Top of page" => "Above top bar / Top of page",
// "Above Content/Under top bar" => "Above Content/Under top bar",
// "Slider pagination, default bullets" => "Slider pagination, default bullets",
// "Fraction" => "Fraction",
// "Progress bar" => "Progress bar",
// "Display navigation arrows" => "Display navigation arrows",
// "Slider Background Color" => "Slider Background Color",
// "Slider background color, enter color code for example #000" => "Slider background color, enter color code for example #000",
// "Slider Parallax Background Image" => "Slider Parallax Background Image",
// "Enter image url for parallax background behind swiper" => "Enter image url for parallax background behind swiper",
// "Enter width of slider in px, default 100%" => "Enter width of slider in px, default 100%",
// "Enter height of slider in px, default min height 100px, max height will adjust with content" => "Enter height of slider in px, default min height 100px, max height will adjust with content",
// "Slide title color" => "Slide title color",
// "Enter text color code of slide title, for example #ccc" => "Enter text color code of slide title, for example #ccc",
// "Title font size" => "Title font size",
// "For example 42px, default 32 px" => "For example 42px, default 32 px",
// "Slide description color" => "Slide description color",
// "Enter text color code of slide description, for example #ccc" => "Enter text color code of slide description, for example #ccc",
// "Description font size" => "Description font size",
// "For example 24px, default 16 px" => "For example 24px, default 16 px",
// "Slide content background" => "Slide content background",
// "Slide content position" => "Slide content position",
// "Enter position for example top:20%;left:20% or bottom:20%;right:10%" => "Enter position for example top:20%;left:20% or bottom:20%;right:10%",
// "Autoplay slider, on by default" => "Autoplay slider, on by default",
// "Auto Play Delay" => "Auto Play Delay",
// "Show thumbnails under main slider" => "Show thumbnails under main slider",
// "Duration of transition between slides (in seconds)" => "Duration of transition between slides (in seconds)",
// "Auto Height" => "Auto Height",
// "Set to true and slider wrapper will adopt its height to the height of the currently active slide" => "Set to true and slider wrapper will adopt its height to the height of the currently active slide",
// "Space Between" => "Space Between",
// "Distance between slides in px" => "Distance between slides in px",
// "Slides Per View" => "Slides Per View",
// "Slides visible at the same time on slider's container. Coverflow transition works best with 3 slides per view" => "Slides visible at the same time on slider's container. Coverflow transition works best with 3 slides per view",
// "Slides Per View Mobile Screen" => "Slides Per View Mobile Screen",
// "Slides visible at the same time on small screens" => "Slides visible at the same time on small screens",
// "Slides Per View Tablet" => "Slides Per View Tablet",
// "Slides visible at the same time on low resolution tablets" => "Slides visible at the same time on low resolution tablets",
// "Slides Per Column" => "Slides Per Column",
// "Number of slides per column, for multirow layout" => "Number of slides per column, for multirow layout",
// "Slides Per Column Fill" => "Slides Per Column Fill",
// "Could be 'column' or 'row'. Defines how slides should fill rows, by column or by row" => "Could be 'column' or 'row'. Defines how slides should fill rows, by column or by row",
// "Centered Slides" => "Centered Slides",
// "If true, then active slide will be centered, not always on the left side" => "If true, then active slide will be centered, not always on the left side",
// "Slides Offset Before" => "Slides Offset Before",
// "Add (in px) additional slide offset in the beginning of the container (before all slides)" => "Add (in px) additional slide offset in the beginning of the container (before all slides)",
// "Slides Offset After" => "Slides Offset After",
// "Add (in px) additional slide offset in the end of the container (after all slides)" => "Add (in px) additional slide offset in the end of the container (after all slides)",
// "Slide To Clicked Slide" => "Slide To Clicked Slide",
// "Set to true and click on any slide will produce transition to this slide" => "Set to true and click on any slide will produce transition to this slide",
// "Free Mode" => "Free Mode",
// "If true then slides will not have fixed positions" => "If true then slides will not have fixed positions",
// "Preload Images" => "Preload Images",
// "When enabled Swiper will force to load all images" => "When enabled Swiper will force to load all images",
// "Update On Images Ready" => "Update On Images Ready",
// "When enabled Swiper will be reinitialized after all inner images (<img> tags) are loaded. Required preloadimages: true" => "When enabled Swiper will be reinitialized after all inner images (<img> tags) are loaded. Required preloadimages: true",
// "Loop Slider" => "Loop Slider",
// "Set to true to enable continuous loop mode (If you use it along with slidesperView: 'auto' then you need to specify loopedslides parameter with amount of slides to loop (duplicate))" => "Set to true to enable continuous loop mode (If you use it along with slidesperView: 'auto' then you need to specify loopedslides parameter with amount of slides to loop (duplicate))",
// " Please update composer to install required files" => " Please update composer to install required files",
// "Paramaters missing: Please either select file gallery, give file ids or custom slide code in body" => "Paramaters missing: Please either select file gallery, give file ids or custom slide code in body",
// "Arrange content in tabs" => "Arrange content in tabs",
// "Tabs content, separated by \"/////\"" => "Tabs content, separated by \"/////\"",
// "Tabset Name" => "Tabset Name",
// "Unique tabset name (if you want the last state to be remembered). Example" => "Unique tabset name (if you want the last state to be remembered). Example",
// "Tab Titles" => "Tab Titles",
// "Pipe-separated list of tab titles. Example" => "Pipe-separated list of tab titles. Example",
// "Toggle Tabs" => "Toggle Tabs",
// "Allow toggling between tabs and no-tabs view" => "Allow toggling between tabs and no-tabs view",
// "Inside Pretty Tracker" => "Inside Pretty Tracker",
// "Parse pretty tracker variables within tabs" => "Parse pretty tracker variables within tabs",
// "No tab title specified. At least one must be specified in order for the tabs to appear" => "No tab title specified. At least one must be specified in order for the tabs to appear",
// "Apply an HTML tag to content" => "Apply an HTML tag to content",
"Tag Name" => "標籤名稱",
// "Any valid HTML tag, 0% by default" => "Any valid HTML tag, 0% by default",
// "Equivalent to the style attribute of an HTML tag" => "Equivalent to the style attribute of an HTML tag",
// "Timeline" => "Timeline",
// "Display a timeline" => "Display a timeline",
// "Display the event list items represented in the page. (%0all%1, %0center%1, or\n\t\t\t\t\ta custom CSS selector)" => "Display the event list items represented in the page. (%0all%1, %0center%1, or\n\t\t\t\t\ta custom CSS selector)",
// "Width of the timeline as CSS units (default: %0)" => "Width of the timeline as CSS units (default: %0)",
// "Height of the timeline as CSS units (default: %0)" => "Height of the timeline as CSS units (default: %0)",
// "Primary Scale Unit" => "Primary Scale Unit",
// "Unit of time to use for the primary scale (default is Month)" => "Unit of time to use for the primary scale (default is Month)",
// "Decade" => "Decade",
// "Century" => "Century",
// "Secondary Scale Unit" => "Secondary Scale Unit",
// "Unit of time to use for the secondary scale" => "Unit of time to use for the secondary scale",
// "TimeSheet" => "TimeSheet",
// "Embed a timesheet into a page" => "Embed a timesheet into a page",
// "Title Search" => "Title Search",
// "Search page titles" => "Search page titles",
// "Search Criteria" => "Search Criteria",
// "Portion of a page name" => "Portion of a page name",
// "Also show page hits or user" => "Also show page hits or user",
// "Hits and user" => "Hits and user",
// "User and hits" => "User and hits",
// "Pipe-separated list of page names to exclude from results" => "Pipe-separated list of page names to exclude from results",
// "No Header" => "No Header",
// "Set to Yes (%0) to have no header for the search results" => "Set to Yes (%0) to have no header for the search results",
// "No pages found for title search" => "No pages found for title search",
// "One page found for title search" => "One page found for title search",
// "pages found for title search" => "pages found for title search",
// "Table of Contents (Structure)" => "Table of Contents (Structure)",
// "Display a table of contents of pages in a structure" => "Display a table of contents of pages in a structure",
// "Structure ID" => "Structure ID",
// "By default, structure for the current page will be displayed. Alternate\n\t\t\t\t\tstructure may be provided" => "By default, structure for the current page will be displayed. Alternate\n\t\t\t\t\tstructure may be provided",
// "By default, the table of contents for the current page will be displayed.\n\t\t\t\t\tAlternate page may be provided" => "By default, the table of contents for the current page will be displayed.\n\t\t\t\t\tAlternate page may be provided",
// "Order items in ascending or descending order (default is ascending)" => "Order items in ascending or descending order (default is ascending)",
// "Sort Order" => "Sort Order",
// "Order for the first Level of pages that will be displayed. Order by structure is the default" => "Order for the first Level of pages that will be displayed. Order by structure is the default",
// "Structure Order" => "Structure Order",
// "Alphabetic Order" => "Alphabetic Order",
// "Display the page description in front of the page name" => "Display the page description in front of the page name",
// "Show Numbering" => "Show Numbering",
// "Display the section numbers or not" => "Display the section numbers or not",
// "Style to apply" => "Style to apply",
"Admin" => "管理",
// "Start Level" => "Start Level",
// "Set the level starting from which page names are displayed. %0 or %1 (the default) means from level 1. Starting from %0 (and not 1)" => "Set the level starting from which page names are displayed. %0 or %1 (the default) means from level 1. Starting from %0 (and not 1)",
// "Maximum Level Depth" => "Maximum Level Depth",
// "Set the number of levels to display. %0 means only 1 level will be displayed and %1 mean no limit (and is the default)" => "Set the number of levels to display. %0 means only 1 level will be displayed and %1 mean no limit (and is the default)",
// "Together" => "Together",
// "Collaborate in real time" => "Collaborate in real time",
// "A service for collaborating on your website in real-time. TogetherJS lets users communicate,\n\t\t\tco-author, co-browse and guide each other. TogetherJS is implemented in JavaScript; no software or plugins\n\t\t\tto install, and it is friendly with existing web pages, while still letting developers customize the\n\t\t\texperience" => "A service for collaborating on your website in real-time. TogetherJS lets users communicate,\n\t\t\tco-author, co-browse and guide each other. TogetherJS is implemented in JavaScript; no software or plugins\n\t\t\tto install, and it is friendly with existing web pages, while still letting developers customize the\n\t\t\texperience",
// "Button Name" => "Button Name",
// "Set the button name. Default is CoWrite with TogetherJS" => "Set the button name. Default is CoWrite with TogetherJS",
// "CoWrite with TogetherJS" => "CoWrite with TogetherJS",
// "Note: TogetherJS is alpha-quality software. We do not recommend using it in\n\t\t\tproduction at this time" => "Note: TogetherJS is alpha-quality software. We do not recommend using it in\n\t\t\tproduction at this time",
// "Tour" => "Tour",
// "Quick and easy way to build your product tours with Bootstrap popovers" => "Quick and easy way to build your product tours with Bootstrap popovers",
// "Content of the step" => "Content of the step",
// "Element" => "Element",
// "Element to show the popup on; if empty, use the plugin location itself" => "Element to show the popup on; if empty, use the plugin location itself",
// "Title of the step" => "Title of the step",
// "Index of the step to show after this one, starting from 0, -1 for the last one" => "Index of the step to show after this one, starting from 0, -1 for the last one",
// "Index of the step to show before this one, starting from 0, -1 not to show" => "Index of the step to show before this one, starting from 0, -1 not to show",
// "Path to the page on which the step should be shown" => "Path to the page on which the step should be shown",
// "Start the tour on page load? If \"No\", then a start button can be made with \"Restart Button\", below" => "Start the tour on page load? If \"No\", then a start button can be made with \"Restart Button\", below",
// "Placement" => "Placement",
// "The placement of the popup" => "The placement of the popup",
// "Orphan" => "Orphan",
// "Setting to true removes the pointer on the popup and centers it on the page" => "Setting to true removes the pointer on the popup and centers it on the page",
// "Backdrop" => "Backdrop",
// "Show a dark backdrop behind the popover and its element, highlighting the current step" => "Show a dark backdrop behind the popover and its element, highlighting the current step",
// "Only Show Once" => "Only Show Once",
// "Show automatically only once. tour_id should also be set if there are multiple tours" => "Show automatically only once. tour_id should also be set if there are multiple tours",
// "Show Until Dismissed" => "Show Until Dismissed",
// "Show automatically only until dismissed. tour_id should also be set if there are multiple tours" => "Show automatically only until dismissed. tour_id should also be set if there are multiple tours",
// "Tour ID" => "Tour ID",
// "Set a tour ID to be able to only show the tour once" => "Set a tour ID to be able to only show the tour once",
// "Restart Button" => "Restart Button",
// "Display a button to restart the tour. Enter the text to appear on the button" => "Display a button to restart the tour. Enter the text to appear on the button",
"Translate" => "翻譯",
// "Translate text to the user language" => "Translate text to the user language",
// "Embed a form to populate a tracker" => "Embed a form to populate a tracker",
// "Numeric value representing the tracker ID" => "Numeric value representing the tracker ID",
"Fields" => "欄位",
// "Colon-separated list of field IDs to be displayed in the form as input fields.\n\t\t\t\t\tIf empty, all fields will be shown. Example: %0" => "Colon-separated list of field IDs to be displayed in the form as input fields.\n\t\t\t\t\tIf empty, all fields will be shown. Example: %0",
// "Colon-separated list of default values corresponding to the %0fields%1 parameter.\n\t\t\t\tFirst value corresponds to first field, second value to second field, etc. Default values can be\n\t\t\t\tset by using %0autosavefields%1 and %0autosavevalues%1 as URL parameters" => "Colon-separated list of default values corresponding to the %0fields%1 parameter.\n\t\t\t\tFirst value corresponds to first field, second value to second field, etc. Default values can be\n\t\t\t\tset by using %0autosavefields%1 and %0autosavevalues%1 as URL parameters",
// "Colon-separated labels for form submit buttons. Default is %0Save%1. When set to\n\t\t\t\t\t%0NONE%1, the save button will not appear and values will be saved dynamically" => "Colon-separated labels for form submit buttons. Default is %0Save%1. When set to\n\t\t\t\t\t%0NONE%1, the save button will not appear and values will be saved dynamically",
// "Action Style" => "Action Style",
// "Sets button style classes for action buttons. If multiple buttons have been set\n\t\t\t\t\tin the %0 parameter, the same number of colon-separated styles must be set here. Example" => "Sets button style classes for action buttons. If multiple buttons have been set\n\t\t\t\t\tin the %0 parameter, the same number of colon-separated styles must be set here. Example",
// "Display the title of the tracker at the top of the form (not shown by default)" => "Display the title of the tracker at the top of the form (not shown by default)",
// "Show the tracker's description (not shown by default)" => "Show the tracker's description (not shown by default)",
// "Show Fields Descriptions" => "Show Fields Descriptions",
// "Show the tracker's field descriptions (shown by default)" => "Show the tracker's field descriptions (shown by default)",
// "Mark Mandatory" => "Mark Mandatory",
// "Indicate mandatory fields with an asterisk (shown by default)" => "Indicate mandatory fields with an asterisk (shown by default)",
// "Show Status" => "Show Status",
// "Show the status of the items (not shown by default)" => "Show the status of the items (not shown by default)",
// "Embedded" => "Embedded",
// "To send an email once the tracker item has been created. Format: %0from" => "To send an email once the tracker item has been created. Format: %0from",
// "template%0" => "template%0",
// "For %0from%1 and %0to%1, use an email address\n\t\t\t\t\t\t(separate multiple addresses with a comma), a username, a fieldId of a field containing either an email address or a username,\n\t\t\t\t\t\ta fieldId of a UserSelector or GroupSelector field, or \"createdBy\" or \"lastModifBy\" for the item creator or modifier.\n\t\t\t\t\t\tWhen username is being used, the email will be sent to the email address of the user on file.\n\t\t\t\t\t\tWhen sending to several emails using different template, provide the template name for the message body for each email;\n\t\t\t\t\t\tI.e., the first template will be used for the first to, the second template if exists will be used\n\t\t\t\t\t\tfor the second from (otherwise the last given template will be used). Each template needs two files, one for the subject one for the body. The subject will be named\n\t\t\t\t\t\ttemplate_subject.tpl. All the templates must be in the %0templates/mail%1 directory. Example:\n\t\t\t\t\t\t%0webmaster@my.com|a@my.com,b@my.com|templatea.tpl,templateb.tpl%1 (%0templates/mail/tracker_changed_notification.tpl%1\n\t\t\t\t\t\tis the default from which you can get inspiration)" => "For %0from%1 and %0to%1, use an email address\n\t\t\t\t\t\t(separate multiple addresses with a comma), a username, a fieldId of a field containing either an email address or a username,\n\t\t\t\t\t\ta fieldId of a UserSelector or GroupSelector field, or \"createdBy\" or \"lastModifBy\" for the item creator or modifier.\n\t\t\t\t\t\tWhen username is being used, the email will be sent to the email address of the user on file.\n\t\t\t\t\t\tWhen sending to several emails using different template, provide the template name for the message body for each email;\n\t\t\t\t\t\tI.e., the first template will be used for the first to, the second template if exists will be used\n\t\t\t\t\t\tfor the second from (otherwise the last given template will be used). Each template needs two files, one for the subject one for the body. The subject will be named\n\t\t\t\t\t\ttemplate_subject.tpl. All the templates must be in the %0templates/mail%1 directory. Example:\n\t\t\t\t\t\t%0webmaster@my.com|a@my.com,b@my.com|templatea.tpl,templateb.tpl%1 (%0templates/mail/tracker_changed_notification.tpl%1\n\t\t\t\t\t\tis the default from which you can get inspiration)",
// "Choose between values text or html, depending on the syntax in the template file\n\t\t\t\t\tthat will be used" => "Choose between values text or html, depending on the syntax in the template file\n\t\t\t\t\tthat will be used",
// "URL the user is sent to after the form is submitted. The string %0itemId%1 will\n\t\t\t\t\tbe replaced with %0itemId=xx%1 where %0xx%1 is the new (or current) itemId. This parameter can be used in combination with the TABS plugin using %0?cookietab=1&itemId%1 (change the cookietab parameter's value depending on the tab you want the user to be sent to)" => "URL the user is sent to after the form is submitted. The string %0itemId%1 will\n\t\t\t\t\tbe replaced with %0itemId=xx%1 where %0xx%1 is the new (or current) itemId. This parameter can be used in combination with the TABS plugin using %0?cookietab=1&itemId%1 (change the cookietab parameter's value depending on the tab you want the user to be sent to)",
// "Keep params in URL" => "Keep params in URL",
// "Input form parameters (or field IDs) separated by a colon (%0:%1) to pass them in the URL after the form is submitted and redirected to the URL specified in the %0url%1 param. Example: %0urlparams=\"1:2:3:trackit\"%1. Enter %0*%1 to keep all the submitted parameters in the URL" => "Input form parameters (or field IDs) separated by a colon (%0:%1) to pass them in the URL after the form is submitted and redirected to the URL specified in the %0url%1 param. Example: %0urlparams=\"1:2:3:trackit\"%1. Enter %0*%1 to keep all the submitted parameters in the URL",
// "URL Target" => "URL Target",
// "Set the target parameter for the url (determines whether target will open in a\n\t\t\t\t\tnew page, etc.)" => "Set the target parameter for the url (determines whether target will open in a\n\t\t\t\t\tnew page, etc.)",
// "Self" => "Self",
"Overwrite" => "覆蓋",
// "Overwrite current field values of the item with the input values. Does not\n\t\t\t\t\toverwrite wiki pages and does not work when the %0discarditem%1 parameter is set to Yes (%0y%1)" => "Overwrite current field values of the item with the input values. Does not\n\t\t\t\t\toverwrite wiki pages and does not work when the %0discarditem%1 parameter is set to Yes (%0y%1)",
// "Display columns in the order listed in the fields parameter instead of by\n\t\t\t\t\tfield ID (field ID order is used by default)" => "Display columns in the order listed in the fields parameter instead of by\n\t\t\t\t\tfield ID (field ID order is used by default)",
// "To add a preview button with the label set by this parameter. Default:\n\t\t\t\t\t%0Preview%1. Useful to preview the computed fields of an item" => "To add a preview button with the label set by this parameter. Default:\n\t\t\t\t\t%0Preview%1. Useful to preview the computed fields of an item",
// "Label for the reset button, to return all fields to their default values" => "Label for the reset button, to return all fields to their default values",
"reset" => "重新設定",
// "Determine which items will be affected byt the form. If set to %0user%1 and\n\t\t\t\t\t%0trackerId%1 is not set, then the user tracker associated with the default group will be affected.\n\t\t\t\t\tIf %0trackerId%1 is set, then the item associated with the user in that tracker will be affected.\n\t\t\t\t\t If set to %0page%1, the item associated with that page will be affected (%0trackerId%1 must be\n\t\t\t\t\t set in this case)" => "Determine which items will be affected byt the form. If set to %0user%1 and\n\t\t\t\t\t%0trackerId%1 is not set, then the user tracker associated with the default group will be affected.\n\t\t\t\t\tIf %0trackerId%1 is set, then the item associated with the user in that tracker will be affected.\n\t\t\t\t\t If set to %0page%1, the item associated with that page will be affected (%0trackerId%1 must be\n\t\t\t\t\t set in this case)",
// "User&field" => "User&field",
// "User field to filter" => "User field to filter",
// "User field to filter user tracker items to" => "User field to filter user tracker items to",
// "Field to filter" => "Field to filter",
// "Field to filter user tracker items to" => "Field to filter user tracker items to",
// "Field to filter Value" => "Field to filter Value",
// "Value to filter user tracker items to" => "Value to filter user tracker items to",
// "Criteria" => "Criteria",
// "If more than one item found, will choose under this criteria. Used in combination with" => "If more than one item found, will choose under this criteria. Used in combination with",
// "creationDate - Ascending" => "creationDate - Ascending",
// "creationDate - Descending" => "creationDate - Descending",
// "Status of the item used in combination with" => "Status of the item used in combination with",
"or" => "或",
// "Transaction name" => "Transaction name",
// "The transaction identifier. This identifier connects the various trackers into a\n\t\t\t\t\tsingle transaction. Must be unique per transaction. The multiple steps in a single transaction\n\t\t\t\t\tmust share the same transaction name" => "The transaction identifier. This identifier connects the various trackers into a\n\t\t\t\t\tsingle transaction. Must be unique per transaction. The multiple steps in a single transaction\n\t\t\t\t\tmust share the same transaction name",
// "Transaction Step" => "Transaction Step",
// "Transaction step number specifying the order of the transaction steps. The first\n\t\t\t\t\tstep must be %0" => "Transaction step number specifying the order of the transaction steps. The first\n\t\t\t\t\tstep must be %0",
// "Final Transaction Step" => "Final Transaction Step",
// "Indicate whether this is the final transaction step" => "Indicate whether this is the final transaction step",
// "Transaction previous URL" => "Transaction previous URL",
// "The page to go back to when the \"previous\" button is clicked" => "The page to go back to when the \"previous\" button is clicked",
// "Transaction previous button label" => "Transaction previous button label",
// "Text for the \"previous\" button label" => "Text for the \"previous\" button label",
// "ItemId" => "ItemId",
// "ItemId identifying the item to be edited" => "ItemId identifying the item to be edited",
// "Ignore ItemId" => "Ignore ItemId",
// "Do not filter on the parameter %0itemId%1 if in the url (default is to filter)" => "Do not filter on the parameter %0itemId%1 if in the url (default is to filter)",
// "Template File" => "Template File",
// "Name of the template used to display the tracker items.  In the template, the\n\t\t\t\t\tsmarty variable %0{\$f_id}%1 will be replaced with the appropriate input tag, with %0id%1 representing\n\t\t\t\t\tthe field ID. The form tag and the submit button are generated by Tiki outside the template" => "Name of the template used to display the tracker items.  In the template, the\n\t\t\t\t\tsmarty variable %0{\$f_id}%1 will be replaced with the appropriate input tag, with %0id%1 representing\n\t\t\t\t\tthe field ID. The form tag and the submit button are generated by Tiki outside the template",
// "Name of the wiki page containing the template to display the tracker items. This\n\t\t\t\t\tpage must have the permission %0tiki_p_use_as_template%1 assigned to the Anonymous group to be used\n\t\t\t\t\tas a template" => "Name of the wiki page containing the template to display the tracker items. This\n\t\t\t\t\tpage must have the permission %0tiki_p_use_as_template%1 assigned to the Anonymous group to be used\n\t\t\t\t\tas a template",
// "New Status" => "New Status",
// "Default status applied to newly created or saved items" => "Default status applied to newly created or saved items",
// "Specify the width in pixels or percentage of the first column (the labels) in the\n\t\t\t\t\ttracker form" => "Specify the width in pixels or percentage of the first column (the labels) in the\n\t\t\t\t\ttracker form",
// "Autosave Fields" => "Autosave Fields",
// "Colon-separated list of field IDs to be automatically filled with values upon\n\t\t\t\t\tsave" => "Colon-separated list of field IDs to be automatically filled with values upon\n\t\t\t\t\tsave",
// "Autosave Values" => "Autosave Values",
// "Colon-separated values corresponding to %0. Special syntax cases" => "Colon-separated values corresponding to %0. Special syntax cases",
// "selects the first child category under a category with ID\n\t\t\t\t\t\t%0x%1 for use in a category field" => "selects the first child category under a category with ID\n\t\t\t\t\t\t%0x%1 for use in a category field",
// "inserts the value of the preference with %0x%1 being the\n\t\t\t\t\t\tpreference name" => "inserts the value of the preference with %0x%1 being the\n\t\t\t\t\t\tpreference name",
// "Increase-only Fields" => "Increase-only Fields",
// "Used with the %0  and %1 parameters. Colon-separated list of field IDs being\n\t\t\t\t\tauto-saved where the specified auto-save value will not take effect if it is less than or equal to\n\t\t\t\t\tthe current value of the field" => "Used with the %0  and %1 parameters. Colon-separated list of field IDs being\n\t\t\t\t\tauto-saved where the specified auto-save value will not take effect if it is less than or equal to\n\t\t\t\t\tthe current value of the field",
// "Registration Fields" => "Registration Fields",
// "Add registration fields such as Username and Password for use in registration\n\t\t\t\t\ttrackers" => "Add registration fields such as Username and Password for use in registration\n\t\t\t\t\ttrackers",
// "Register to group" => "Register to group",
// "The user enters this group via the registration (only a single group name\n\t\t\t\t\tis supported)" => "The user enters this group via the registration (only a single group name\n\t\t\t\t\tis supported)",
// "Validate users" => "Validate users",
// "Here one can overrule the default validate users by e-mail preference" => "Here one can overrule the default validate users by e-mail preference",
// "Output To Wiki" => "Output To Wiki",
// "Output result to a new wiki page with the name taken from the input for the\n\t\t\t\t\tspecified fieldId" => "Output result to a new wiki page with the name taken from the input for the\n\t\t\t\t\tspecified fieldId",
// "Discard After Output" => "Discard After Output",
// "Used with %0 - whether to discard the tracker item itself\n\t\t\t\t\tonce the wiki page is created, so that, in effect, the tracker is just a vehicle to create form\n\t\t\t\t\tfields to facilitate creating wiki pages" => "Used with %0 - whether to discard the tracker item itself\n\t\t\t\t\tonce the wiki page is created, so that, in effect, the tracker is just a vehicle to create form\n\t\t\t\t\tfields to facilitate creating wiki pages",
// "Template Page" => "Template Page",
// "Name of the wiki page containing the template to format the output to wiki page.\n\t\t\t\t\tMust be set for %0 to work. The template can contain variables to represent fields, for example\n\t\t\t\t\t%1 would result in the value of fieldId 6. Also %2 can be used for the itemId and if you have set\n\t\t\t\t\t%3 to yes, you can use %4 and %5" => "Name of the wiki page containing the template to format the output to wiki page.\n\t\t\t\t\tMust be set for %0 to work. The template can contain variables to represent fields, for example\n\t\t\t\t\t%1 would result in the value of fieldId 6. Also %2 can be used for the itemId and if you have set\n\t\t\t\t\t%3 to yes, you can use %4 and %5",
// "Output Wiki Namespace" => "Output Wiki Namespace",
// "Name of namespace that is used for the wiki page that is created when outputting\n\t\t\t\t\tto a wiki page" => "Name of namespace that is used for the wiki page that is created when outputting\n\t\t\t\t\tto a wiki page",
// "Store Relation" => "Store Relation",
// "Store %0 and %1 relation from the created\n\t\t\t\t\twiki page when outputting to a wiki page. Optionally, (separate feature to be turned on in admin\n\t\t\t\t\tpanel) these relations are used to sync page renames with the field specified in %2,\n\t\t\t\t\tand also optionally to redirect page viewing to the tracker item instead (where you can then\n\t\t\t\t\tinclude the page if needed)" => "Store %0 and %1 relation from the created\n\t\t\t\t\twiki page when outputting to a wiki page. Optionally, (separate feature to be turned on in admin\n\t\t\t\t\tpanel) these relations are used to sync page renames with the field specified in %2,\n\t\t\t\t\tand also optionally to redirect page viewing to the tracker item instead (where you can then\n\t\t\t\t\tinclude the page if needed)",
// "Multiple Fill Fields" => "Multiple Fill Fields",
// "Colon-separated list of field IDs to be filled with multiple values, to create\n\t\t\t\t\tmultiple items in one save. If empty, only one item will be created. Only for\n\t\t\t\t\titem creation. Example: %0" => "Colon-separated list of field IDs to be filled with multiple values, to create\n\t\t\t\t\tmultiple items in one save. If empty, only one item will be created. Only for\n\t\t\t\t\titem creation. Example: %0",
// "Fill Fields Separator" => "Fill Fields Separator",
// "Choose separator between fields in each line of the Multiple Fill text area.\n\t\t\t\t\tDefault is pipe (%0|%1)" => "Choose separator between fields in each line of the Multiple Fill text area.\n\t\t\t\t\tDefault is pipe (%0|%1)",
// "Fill Fields Defaults" => "Fill Fields Defaults",
// "Colon-separated list of default values for Multiple Fill Fields" => "Colon-separated list of default values for Multiple Fill Fields",
// "Embed the tracker in a form tag" => "Embed the tracker in a form tag",
// "If set to Yes (%0), the tracker is contained in a <form> tag and has action buttons" => "If set to Yes (%0), the tracker is contained in a <form> tag and has action buttons",
// "Use ajax to create/update tracker items" => "Use ajax to create/update tracker items",
// "Use ajax to create and update tracker items instead of form submission via request variables" => "Use ajax to create and update tracker items instead of form submission via request variables",
// "Transactions" => "Transactions",
// "You need to define both transaction name and transaction step, or none of the two" => "You need to define both transaction name and transaction step, or none of the two",
// "You need to choose transactionFinalStep (y/n)" => "You need to choose transactionFinalStep (y/n)",
// "Both transactionPreviousURL and transactionPreviousLabel are needed for a \"previous\" button" => "Both transactionPreviousURL and transactionPreviousLabel are needed for a \"previous\" button",
// "Tracker: Field #%0 not found in fields parameter or template" => "Tracker: Field #%0 not found in fields parameter or template",
// "The page to output the results to already exists. Try another name" => "The page to output the results to already exists. Try another name",
// "Tracker Transaction: Field #%0 not found in fields parameter or template" => "Tracker Transaction: Field #%0 not found in fields parameter or template",
"Tracker was modified at " => "追蹤修改於 ",
// "Form saved successfully" => "Form saved successfully",
// "Incorrect fieldId" => "Incorrect fieldId",
// "Following fields are incorrect" => "Following fields are incorrect",
// "Error: Read only field \"%0\"" => "Error: Read only field \"%0\"",
// "This field is mandatory" => "This field is mandatory",
// "Missing wiki template page \"%0\"" => "Missing wiki template page \"%0\"",
// "Each line is a list of %d field values separated with: %s" => "Each line is a list of %d field values separated with: %s",
// "You do not have permission to insert an item" => "You do not have permission to insert an item",
// "Incorrect item" => "Incorrect item",
// "You do not have permission to modify an item" => "You do not have permission to modify an item",
// "The page to output the results to contains the following prohibited characters: %0. Try another name" => "The page to output the results to contains the following prohibited characters: %0. Try another name",
// "Please ensure you are using the correct field ID and that it is properly included in the template, if any" => "Please ensure you are using the correct field ID and that it is properly included in the template, if any",
// "Passwords do not match" => "Passwords do not match",
// "Insert one item per line" => "Insert one item per line",
// "Fields marked with an * are mandatory" => "Fields marked with an * are mandatory",
// "Tracker Calendar" => "Tracker Calendar",
// "Create and display a calendar using tracker data" => "Create and display a calendar using tracker data",
// "Resource Descriptor Field" => "Resource Descriptor Field",
// "Permanent name of the field to use as the resource indicator" => "Permanent name of the field to use as the resource indicator",
// "Coloring Discriminator Field" => "Coloring Discriminator Field",
// "Permanent name of the field to use to segment the information into color schemes" => "Permanent name of the field to use to segment the information into color schemes",
// "Follow external link when event item is clicked. Useful for supporting links to\n\t\t\t\t\tpretty tracker supported pages" => "Follow external link when event item is clicked. Useful for supporting links to\n\t\t\t\t\tpretty tracker supported pages",
// "If Yes (%0y%1) the item id will be passed as %0itemId%1, which can be used\n\t\t\t\t\tby Tracker plugins. Will be passed as %0itemid%1 if No (%0n%1)" => "If Yes (%0y%1) the item id will be passed as %0itemId%1, which can be used\n\t\t\t\t\tby Tracker plugins. Will be passed as %0itemid%1 if No (%0n%1)",
// "Add All Fields" => "Add All Fields",
// "If Yes (%0y%1)  all fields in the tracker will be added to the URL, not just the\n\t\t\t\t\titemId" => "If Yes (%0y%1)  all fields in the tracker will be added to the URL, not just the\n\t\t\t\t\titemId",
// "Use Session Storage" => "Use Session Storage",
// "If Yes (%0y%1) copy all the field values into window.sessionStorage so it can be\n\t\t\t\t\taccessed via JavaScript" => "If Yes (%0y%1) copy all the field values into window.sessionStorage so it can be\n\t\t\t\t\taccessed via JavaScript",
// "Agenda by Months" => "Agenda by Months",
// "Display the option to change the view to agenda by months" => "Display the option to change the view to agenda by months",
// "Agenda by Weeks" => "Agenda by Weeks",
// "Display the option to change the view to agenda by weeks" => "Display the option to change the view to agenda by weeks",
// "Agenda by Days" => "Agenda by Days",
// "Display the option to change the view to agenda by days" => "Display the option to change the view to agenda by days",
// "List by Years" => "List by Years",
// "Display the option to change the view to list by years" => "Display the option to change the view to list by years",
// "List by Months" => "List by Months",
// "Display the option to change the view to list by months" => "Display the option to change the view to list by months",
// "List by Weeks" => "List by Weeks",
// "Display the option to change the view to list by weeks" => "Display the option to change the view to list by weeks",
// "List by Days" => "List by Days",
// "Display the option to change the view to list by days" => "Display the option to change the view to list by days",
// "Resources by Years" => "Resources by Years",
// "Display the option to change the view to resources by years" => "Display the option to change the view to resources by years",
// "Resources by Months" => "Resources by Months",
// "Display the option to change the view to resources by months" => "Display the option to change the view to resources by months",
// "Resources by Weeks" => "Resources by Weeks",
// "Display the option to change the view to resources by weeks" => "Display the option to change the view to resources by weeks",
// "Resources by Days" => "Resources by Days",
// "Display the option to change the view to resources by days" => "Display the option to change the view to resources by days",
// "Default View" => "Default View",
// "Choose the default view for the Tracker Calendar" => "Choose the default view for the Tracker Calendar",
// "Default Year" => "Default Year",
// "Choose the default year (yyyy) to use for the display" => "Choose the default year (yyyy) to use for the display",
// "Default Month" => "Default Month",
// "Choose the default month (mm, as numeric value) to use for the display. Numeric\n\t\t\t\t\tvalues here are 1-based, meaning January=1, February=2, etc" => "Choose the default month (mm, as numeric value) to use for the display. Numeric\n\t\t\t\t\tvalues here are 1-based, meaning January=1, February=2, etc",
// "Default Day" => "Default Day",
// "Choose the default day (dd) to use for the display" => "Choose the default day (dd) to use for the display",
// "Colormap for coloring" => "Colormap for coloring",
// "Colormap to be used when segmenting the information using the coloring field.\n\t\t\t\t\tEach map is composed of value and color separated with a comma, use pipes to separate multiple colormaps: %0" => "Colormap to be used when segmenting the information using the coloring field.\n\t\t\t\t\tEach map is composed of value and color separated with a comma, use pipes to separate multiple colormaps: %0",
// "First day of the Week" => "First day of the Week",
// "Choose the day that each week begins with, for the tracker calendar display.\n\t\t\t\t\tThe value must be a number that represents the day of the week: Sunday=0, Monday=1, Tuesday=2,\n\t\t\t\t\tetc. Default: %0 (Sunday)" => "Choose the day that each week begins with, for the tracker calendar display.\n\t\t\t\t\tThe value must be a number that represents the day of the week: Sunday=0, Monday=1, Tuesday=2,\n\t\t\t\t\tetc. Default: %0 (Sunday)",
// "Show Weekends" => "Show Weekends",
// "Display Saturdays and Sundays (shown by default)" => "Display Saturdays and Sundays (shown by default)",
// "Day Start" => "Day Start",
// "First time slot that will be displayed for each day, e.g. %0" => "First time slot that will be displayed for each day, e.g. %0",
// "Day End" => "Day End",
// "Last time slot that will be displayed for each day, e.g. %0" => "Last time slot that will be displayed for each day, e.g. %0",
// "Slot Duration" => "Slot Duration",
// "Frequency for displayting time slots, e.g. %0 (defaults to the calendar_timespan preference)" => "Frequency for displayting time slots, e.g. %0 (defaults to the calendar_timespan preference)",
// "Overlapping allowed" => "Overlapping allowed",
// "Allow resources to overlap in time" => "Allow resources to overlap in time",
// "To view Tracker Calendar Tiki needs the fullcalendar/fullcalendar-scheduler package. If you do not have permission to install this package, ask the site administrator" => "To view Tracker Calendar Tiki needs the fullcalendar/fullcalendar-scheduler package. If you do not have permission to install this package, ask the site administrator",
// "Fields not found" => "Fields not found",
// "Tracker Comments" => "Tracker Comments",
// "Display the number of comments for a tracker" => "Display the number of comments for a tracker",
// "Item Count" => "Item Count",
// "Determines whether the number of items will be shown (not shown by default)" => "Determines whether the number of items will be shown (not shown by default)",
// "Enter a username to select the items of the current user" => "Enter a username to select the items of the current user",
// "a user name" => "a user name",
// "Comments found" => "Comments found",
"Filters" => "過濾器",
// "The list of fields that can be used as filters along with their formats.\n\t\t\t\t\tThe field number and format are separated by a %0/%1 and multiple fields are separated by %0:%1" => "The list of fields that can be used as filters along with their formats.\n\t\t\t\t\tThe field number and format are separated by a %0/%1 and multiple fields are separated by %0:%1",
// "Format choices are" => "Format choices are",
// "dropdown" => "dropdown",
// "radio buttons" => "radio buttons",
// "multiple choice dropdown" => "multiple choice dropdown",
// "checkbox" => "checkbox",
// "text with wild characters" => "text with wild characters",
// "exact text match" => "exact text match",
// "initials" => "initials",
// "advanced search" => "advanced search",
// "range search (from/to)" => "range search (from/to)",
// "greater\n\t\t\t\t\t\tthan, less than, greater than or equal, less than or equal" => "greater\n\t\t\t\t\t\tthan, less than, greater than or equal, less than or equal",
// "Label on the submit button. Default: %0Filter%1. Use a space character to omit the\n\t\t\t\t\tbutton (for use in datachannels etc)" => "Label on the submit button. Default: %0Filter%1. Use a space character to omit the\n\t\t\t\t\tbutton (for use in datachannels etc)",
// "Display List" => "Display List",
// "Show the full list (before filtering) initially (filtered list shown by default)" => "Show the full list (before filtering) initially (filtered list shown by default)",
// "Displays all the filters on the same line (not shown on same line by default)" => "Displays all the filters on the same line (not shown on same line by default)",
// "Yes with field label in dropdown" => "Yes with field label in dropdown",
// "No Toggle" => "No Toggle",
// "The toggle button to show/hide filters will not be shown if set to Yes (%0y%1).\n\t\t\t\t\tDefault is not to show the toggle (default changed from \"n\" to \"y\" in Tiki 20.0)" => "The toggle button to show/hide filters will not be shown if set to Yes (%0y%1).\n\t\t\t\t\tDefault is not to show the toggle (default changed from \"n\" to \"y\" in Tiki 20.0)",
// "Export CSV" => "Export CSV",
// "Label for an export button. Leave blank to show the usual \"Filter\" button instead" => "Label for an export button. Leave blank to show the usual \"Filter\" button instead",
// "Export Status Field" => "Export Status Field",
// "Export the status field if the Export CSV option is used" => "Export the status field if the Export CSV option is used",
// "Export Created Date Field" => "Export Created Date Field",
// "Export the created date field if the Export CSV option is used" => "Export the created date field if the Export CSV option is used",
// "Export Modified Date Field" => "Export Modified Date Field",
// "Export the modified date field if the Export CSV option is used" => "Export the modified date field if the Export CSV option is used",
// "Export Character Set" => "Export Character Set",
// "Character set to be used if the Export CSV option is used" => "Character set to be used if the Export CSV option is used",
// "Map View Buttons" => "Map View Buttons",
// "Display Mapview and Listview buttons" => "Display Mapview and Listview buttons",
// " - was %0 until 12.0" => " - was %0 until 12.0",
// "Tracker Filter" => "Tracker Filter",
// "Create a form to filter tracker fields" => "Create a form to filter tracker fields",
// "notice" => "notice",
// "TrackerFilter: Wrong parameter specified - filterfield exists but exactvalue or filtervalue not set" => "TrackerFilter: Wrong parameter specified - filterfield exists but exactvalue or filtervalue not set",
// "TrackerFields: Unknown tracker field used in the parameter \"filters\"" => "TrackerFields: Unknown tracker field used in the parameter \"filters\"",
// "tracker field type not processed yet" => "tracker field type not processed yet",
// "Tracker If" => "Tracker If",
// "Display content based on results of a tracker field test" => "Display content based on results of a tracker field test",
// "Ignore" => "Ignore",
// "Ignore test in edit mode" => "Ignore test in edit mode",
// "Copy Tracker Item" => "Copy Tracker Item",
// "PluginTrackerItemCopy" => "PluginTrackerItemCopy",
// "Copy a tracker item" => "Copy a tracker item",
// "Tracker from which to copy item, joined tracker ids separated by %0:%1" => "Tracker from which to copy item, joined tracker ids separated by %0:%1",
// "Link Field IDs" => "Link Field IDs",
// "Fields links that are related to this tracker that you would like to join on,\n\t\t\t\t\tseparated by %0:%1" => "Fields links that are related to this tracker that you would like to join on,\n\t\t\t\t\tseparated by %0:%1",
// "Copy Field IDs" => "Copy Field IDs",
// "Field IDs to copy old value of, separated by %0:%1, joined fields separated by\n\t\t\t\t\t%0|%1" => "Field IDs to copy old value of, separated by %0:%1, joined fields separated by\n\t\t\t\t\t%0|%1",
// "Update Field IDs" => "Update Field IDs",
// "Field IDs to update with new values specified, separated by %0:%1, joined fields\n\t\t\t\t\tseparated by %0|%1" => "Field IDs to update with new values specified, separated by %0:%1, joined fields\n\t\t\t\t\tseparated by %0|%1",
// "New Values" => "New Values",
// "New values to replace for the field IDs specified, separated by %0:%1, joined\n\t\t\t\t\tfields separated by %0|%1. %0randomstring%1 will generate random string; and %0f_xx%1 to use value of\n\t\t\t\t\tfield xx of itemId" => "New values to replace for the field IDs specified, separated by %0:%1, joined\n\t\t\t\t\tfields separated by %0|%1. %0randomstring%1 will generate random string; and %0f_xx%1 to use value of\n\t\t\t\t\tfield xx of itemId",
// "ID of item to make copy of, otherwise input is asked for" => "ID of item to make copy of, otherwise input is asked for",
// "Make this number of copies on load" => "Make this number of copies on load",
// "Set the number of copies to make on load of plugin automatically" => "Set the number of copies to make on load of plugin automatically",
// "Returns array non-interactively" => "Returns array non-interactively",
// "If Yes (%0y%1), returns array of new information instead of displaying results\n\t\t\t\t\tto screen, used in non-interactive mode" => "If Yes (%0y%1), returns array of new information instead of displaying results\n\t\t\t\t\tto screen, used in non-interactive mode",
// "Missing mandatory parameters" => "Missing mandatory parameters",
// "Number of update fields do not match new values" => "Number of update fields do not match new values",
// "Tracker Item Field" => "Tracker Item Field",
// "Display or test the value of a tracker item field" => "Display or test the value of a tracker item field",
// "Wiki text containing an %0{ELSE}%1 marker" => "Wiki text containing an %0{ELSE}%1 marker",
// "Numeric value representing the item ID. Default is the user tracker item for the\n\t\t\t\t\tcurrent user" => "Numeric value representing the item ID. Default is the user tracker item for the\n\t\t\t\t\tcurrent user",
// "Numeric value representing the field ID displayed or tested" => "Numeric value representing the field ID displayed or tested",
// "Colon-separated list of field IDs. Default is all fields" => "Colon-separated list of field IDs. Default is all fields",
// "Status of the tracker item" => "Status of the tracker item",
// "Open & Pending" => "Open & Pending",
// "Open & Closed" => "Open & Closed",
// "Pending & Closed" => "Pending & Closed",
// "Open, Pending & Closed" => "Open, Pending & Closed",
// "Set to Yes (%01%1) to test whether a field is empty (if value parameter is empty)\n\t\t\t\t\tor has a value the same as the value parameter" => "Set to Yes (%01%1) to test whether a field is empty (if value parameter is empty)\n\t\t\t\t\tor has a value the same as the value parameter",
// "Value to compare against" => "Value to compare against",
// "You are not allowed to view this item" => "You are not allowed to view this item",
// "You don't have permission to view this field" => "You don't have permission to view this field",
// "Colon-separated list of field IDs for the fields to be displayed.\n\t\t\t\t\tExample: %02:4:5%1. The field order specified here determines the column order if the %0sort%1\n\t\t\t\t\tparameter is set to %0y%1" => "Colon-separated list of field IDs for the fields to be displayed.\n\t\t\t\t\tExample: %02:4:5%1. The field order specified here determines the column order if the %0sort%1\n\t\t\t\t\tparameter is set to %0y%1",
// "Display columns in the order listed in the %0fields%1 parameter instead of by\n\t\t\t\t\tfield ID (field ID order is used by default" => "Display columns in the order listed in the %0fields%1 parameter instead of by\n\t\t\t\t\tfield ID (field ID order is used by default",
// "Colon-separated list of fields which will display in a tooltip on mouse over.\n\t\t\t\t\tExample: %06:7%1. Setting this parameter implies %0y%1 value for %0sort%1 param" => "Colon-separated list of fields which will display in a tooltip on mouse over.\n\t\t\t\t\tExample: %06:7%1. Setting this parameter implies %0y%1 value for %0sort%1 param",
// "Sticky Popup" => "Sticky Popup",
// "Choose whether the popup tooltip will stay displayed on mouse out (does not stay open by default)" => "Choose whether the popup tooltip will stay displayed on mouse out (does not stay open by default)",
// "Display the title of the tracker (not shown by default)" => "Display the title of the tracker (not shown by default)",
// "Show Links" => "Show Links",
// "Show links to each tracker item (not shown by default). At least one field needs\n\t\t\t\t\tto be set as Public in order for this to work" => "Show links to each tracker item (not shown by default). At least one field needs\n\t\t\t\t\tto be set as Public in order for this to work",
// "Row" => "Row",
// "Show Item Count" => "Show Item Count",
// "Show the number of items found (not shown by default)" => "Show the number of items found (not shown by default)",
// "Show Initials" => "Show Initials",
// "Show an alphabetical index by first letter to assist in navigation (not shown\n\t\t\t\t\tby default)" => "Show an alphabetical index by first letter to assist in navigation (not shown\n\t\t\t\t\tby default)",
// "Creation date display is based on tracker settings unless overridden here" => "Creation date display is based on tracker settings unless overridden here",
// "Last Modification Date" => "Last Modification Date",
// "Last modification date display is based on tracker settings unless overridden here" => "Last modification date display is based on tracker settings unless overridden here",
// "Last modified by user display is based on tracker settings unless overridden here" => "Last modified by user display is based on tracker settings unless overridden here",
// "Show Field Name" => "Show Field Name",
// "Use the field names as column titles (used by default)" => "Use the field names as column titles (used by default)",
// "Show Item Rank" => "Show Item Rank",
// "Show item ranks (not shown by default)" => "Show item ranks (not shown by default)",
// "Show comments count or last comment date and user depending on tracker preferences" => "Show comments count or last comment date and user depending on tracker preferences",
// "Only show items matching certain status filters (only items with open status shown by default)" => "Only show items matching certain status filters (only items with open status shown by default)",
// "Sort rows in ascending (_asc) or descending (_desc) order based on field ID,\n\t\t\t\t\tdate created or date last modified" => "Sort rows in ascending (_asc) or descending (_desc) order based on field ID,\n\t\t\t\t\tdate created or date last modified",
// "(replacing %0fieldId%1 with the field ID number, e.g. %0f_3_asc%1)" => "(replacing %0fieldId%1 with the field ID number, e.g. %0f_3_asc%1)",
// "Sort Choice" => "Sort Choice",
// "Add a dropdown of sorting choices. Separate each choice with a %0:%1. For each\n\t\t\t\t\tchoice, use the format %0value|label%1. See %0sort_mode%1 for value choices. Example with two\n\t\t\t\t\tsorting choices: %0sortchoice=\"created_desc|Newest first:lastModif_desc|Last modified first\"%1" => "Add a dropdown of sorting choices. Separate each choice with a %0:%1. For each\n\t\t\t\t\tchoice, use the format %0value|label%1. See %0sort_mode%1 for value choices. Example with two\n\t\t\t\t\tsorting choices: %0sortchoice=\"created_desc|Newest first:lastModif_desc|Last modified first\"%1",
// "Maximum number of items to display or -1 for all items. Defaults to max records\n\t\t\t\t\tpreference, if set. Pagination will not show if all items are shown by setting to -1" => "Maximum number of items to display or -1 for all items. Defaults to max records\n\t\t\t\t\tpreference, if set. Pagination will not show if all items are shown by setting to -1",
// "Offset of first item. Default is no offset" => "Offset of first item. Default is no offset",
// "Fix offset always (no pagination)" => "Fix offset always (no pagination)",
// "Fix offset to that specified. This will disallow pagination" => "Fix offset to that specified. This will disallow pagination",
// "Show Pagination" => "Show Pagination",
// "Determines whether pagination will be shown (shown by default)" => "Determines whether pagination will be shown (shown by default)",
// "Show button to make entire width of tables visible" => "Show button to make entire width of tables visible",
// "Show a toggle button to allow wide tables to overflow to the right of the content area rather than be scrollable in a limited-width area (not by default)" => "Show a toggle button to allow wide tables to overflow to the right of the content area rather than be scrollable in a limited-width area (not by default)",
// "Filter Field" => "Filter Field",
// "Colon-separated list of fields to allow filtering on" => "Colon-separated list of fields to allow filtering on",
// "Filter Value" => "Filter Value",
// "Filter value (or multiple values) that correspond to %0filterfield%1. For better performance, use %0exactvalue%1\n\t\t\t\t\tinstead. %2Special search values to match" => "Filter value (or multiple values) that correspond to %0filterfield%1. For better performance, use %0exactvalue%1\n\t\t\t\t\tinstead. %2Special search values to match",
// "text that ends in \"value\"" => "text that ends in \"value\"",
// "text that begins with \"value\"" => "text that begins with \"value\"",
// "the current user's login name" => "the current user's login name",
// "the current user's default group" => "the current user's default group",
// "To filter by empty/non-empty values, use parameter %0exactvalue%1 instead" => "To filter by empty/non-empty values, use parameter %0exactvalue%1 instead",
// "any text" => "any text",
// "Exact Value" => "Exact Value",
// "Exact value (or multiple values) that correspond to %0filterfield%1. %2Special\n\t\t\t\t\tsearch values to filter by" => "Exact value (or multiple values) that correspond to %0filterfield%1. %2Special\n\t\t\t\t\tsearch values to filter by",
// "tracker item is in category with ID x or one its descendants" => "tracker item is in category with ID x or one its descendants",
// "tracker item is not in category with ID x or one of its descendants" => "tracker item is not in category with ID x or one of its descendants",
// "match against the value of a Tiki preference" => "match against the value of a Tiki preference",
// "match if value does not equal a Tiki preference value" => "match if value does not equal a Tiki preference value",
// "match if the field does not equal \"value\"" => "match if the field does not equal \"value\"",
// "match for non empty values (opposite with %0exactvalue%1=\"\")" => "match for non empty values (opposite with %0exactvalue%1=\"\")",
// "match if the field equals \"value1\" or \"value2\" (can list more than 2 alternative values)" => "match if the field equals \"value1\" or \"value2\" (can list more than 2 alternative values)",
// "match field with ID x in item with ID itemid.\n\t\t\t\t\t\t%0field(x)%1 can be used if the %0itemId%1 URL parameter is set" => "match field with ID x in item with ID itemid.\n\t\t\t\t\t\t%0field(x)%1 can be used if the %0itemId%1 URL parameter is set",
// "match if not equal to field with ID x in item with ID itemid\n\t\t\t\t\t\t%0field(x)%1 can be used if the %0itemId%1 URL parameter is set" => "match if not equal to field with ID x in item with ID itemid\n\t\t\t\t\t\t%0field(x)%1 can be used if the %0itemId%1 URL parameter is set",
// "The following comparisons can also be applied to date fields by using date phrases that PHP recognizes\n\t\t\t\t\t\t(see http://us.php.net/manual/en/function.strtotime.php )" => "The following comparisons can also be applied to date fields by using date phrases that PHP recognizes\n\t\t\t\t\t\t(see http://us.php.net/manual/en/function.strtotime.php )",
// "match if less than \"value\"" => "match if less than \"value\"",
// "match if greater than \"value\"" => "match if greater than \"value\"",
// "match if less than or equal to \"value\"" => "match if less than or equal to \"value\"",
// "match if greater than or equal to \"value\"" => "match if greater than or equal to \"value\"",
// "Adds a checkbox on each line to perform an action. Required elements are separated\n\t\t\t\t\tby %0/%1. Those elements are" => "Adds a checkbox on each line to perform an action. Required elements are separated\n\t\t\t\t\tby %0/%1. Those elements are",
// "the value of this field will be posted to the action" => "the value of this field will be posted to the action",
// "the name of the post" => "the name of the post",
// "the title of the submit button" => "the title of the submit button",
// "the name of the submit button" => "the name of the submit button",
// "the file that will be called upon submit" => "the file that will be called upon submit",
// "optional template inserted before the submit button and returned" => "optional template inserted before the submit button and returned",
// "Leave empty for multiple select, or use %0dropdown%1 or\n\t\t\t\t\t\t%0radio%1" => "Leave empty for multiple select, or use %0dropdown%1 or\n\t\t\t\t\t\t%0radio%1",
// "Set to %0y%1 if the trackerlist table is embedded inside an existing form.\n\t\t\t\t\t\tActionUrl is ignored in this case" => "Set to %0y%1 if the trackerlist table is embedded inside an existing form.\n\t\t\t\t\t\tActionUrl is ignored in this case",
// "comma-separated list of pre-checked items" => "comma-separated list of pre-checked items",
// "Format: %0checkbox=\"FieldId/PostName/Title/Submit/ActionUrl/Tpl/SelectType/Embed/Checked\"%1" => "Format: %0checkbox=\"FieldId/PostName/Title/Submit/ActionUrl/Tpl/SelectType/Embed/Checked\"%1",
// "Example: %0checkbox=\"6/to/Email to selected/submit/messu-compose.php//dropdown//1,2,3\"%1" => "Example: %0checkbox=\"6/to/Email to selected/submit/messu-compose.php//dropdown//1,2,3\"%1",
// "goIfOne" => "goIfOne",
// "Display the item rather than list if only one item is found" => "Display the item rather than list if only one item is found",
// "Show a 'more' button that links to the tracker item (not shown by default)" => "Show a 'more' button that links to the tracker item (not shown by default)",
// "More link pointing to specified URL instead of default tracker item link" => "More link pointing to specified URL instead of default tracker item link",
// "Display only the items of the following" => "Display only the items of the following",
// "the current user" => "the current user",
// "the current page name" => "the current page name",
// "the current IP address" => "the current IP address",
// "Use content of the specified tpl file as template to display the item.\n\t\t\t\t\tUse %0{\$f_fieldId}%1 to display a field with ID %0fieldId%1" => "Use content of the specified tpl file as template to display the item.\n\t\t\t\t\tUse %0{\$f_fieldId}%1 to display a field with ID %0fieldId%1",
// "Use content of the wiki page as template to display the item. The page should\n\t\t\t\t\thave the permission %0tiki_p_use_as_template%1 set, and should only be editable by trusted users\n\t\t\t\t\tsuch as other site admins" => "Use content of the wiki page as template to display the item. The page should\n\t\t\t\t\thave the permission %0tiki_p_use_as_template%1 set, and should only be editable by trusted users\n\t\t\t\t\tsuch as other site admins",
// "Template Wiki Page" => "Template Wiki Page",
// "Use content of the wiki page as template to display the item but with as little\n\t\t\t\t\tparsing on the content as with a tpl on disk. The page should have the permission\n\t\t\t\t\t%0tiki_p_use_as_template%1 set, and should only be editable by trusted users such as other site\n\t\t\t\t\tadmins" => "Use content of the wiki page as template to display the item but with as little\n\t\t\t\t\tparsing on the content as with a tpl on disk. The page should have the permission\n\t\t\t\t\t%0tiki_p_use_as_template%1 set, and should only be editable by trusted users such as other site\n\t\t\t\t\tadmins",
// "View User" => "View User",
// "Will display the items of the specified user" => "Will display the items of the specified user",
// "Colon-separated list of item IDs to restrict the listing to" => "Colon-separated list of item IDs to restrict the listing to",
// "Ignore the itemId url parameter when filtering list (not ignored by default)" => "Ignore the itemId url parameter when filtering list (not ignored by default)",
// "The link that will be on each main field when %0showlinks=\"y\"%1. Special values" => "The link that will be on each main field when %0showlinks=\"y\"%1. Special values",
// "will link to the item based on its item ID" => "will link to the item based on its item ID",
// "will link to the item based on its offset value" => "will link to the item based on its offset value",
// "will link to the item using %0itemX%1 (where X is the item ID) for when SEFURL is being\n\t\t\t\t\t\tused" => "will link to the item using %0itemX%1 (where X is the item ID) for when SEFURL is being\n\t\t\t\t\t\tused",
// "use to show the item without admin buttons and with a back button\n\t\t\t\t\t\twhen using a template (Display > Section Format must be set to \"Configured\" in the tracker\n\t\t\t\t\t\tproperties). Example" => "use to show the item without admin buttons and with a back button\n\t\t\t\t\t\twhen using a template (Display > Section Format must be set to \"Configured\" in the tracker\n\t\t\t\t\t\tproperties). Example",
// "similar to %0vi_tpl%1 except that admin buttons are shown for users\n\t\t\t\t\t\twith proper permissions when \"Restrict non admins to wiki page access only\" is set in the\n\t\t\t\t\t\ttracker properties" => "similar to %0vi_tpl%1 except that admin buttons are shown for users\n\t\t\t\t\t\twith proper permissions when \"Restrict non admins to wiki page access only\" is set in the\n\t\t\t\t\t\ttracker properties",
// "2.0, 3.0 for %0itemId%1, 11.0 for %0tr_offset%1, 14.0 for %0sefurl%1 and %0vi_tpl%1" => "2.0, 3.0 for %0itemId%1, 11.0 for %0tr_offset%1, 14.0 for %0sefurl%1 and %0vi_tpl%1",
// "Left Delimiter" => "Left Delimiter",
// "Smarty left delimiter for Latex generation. Example" => "Smarty left delimiter for Latex generation. Example",
// "Right Delimiter" => "Right Delimiter",
// "Smarty right delimiter for Latex generation Example" => "Smarty right delimiter for Latex generation Example",
// "List Mode" => "List Mode",
// "Set output format. Yes (y) displays tracker list view with truncated values\n\t\t\t\t\t(default); No (n) displays in tracker item view; Comma Separated Values (csv) outputs without any\n\t\t\t\t\tHTML formatting" => "Set output format. Yes (y) displays tracker list view with truncated values\n\t\t\t\t\t(default); No (n) displays in tracker item view; Comma Separated Values (csv) outputs without any\n\t\t\t\t\tHTML formatting",
// "Comma Separated Values" => "Comma Separated Values",
// "Export Button" => "Export Button",
// "Show an export button (not shown by default)" => "Show an export button (not shown by default)",
// "Compute" => "Compute",
// "Sum or average all the values of a field and displays it at the bottom of the\n\t\t\t\t\ttable" => "Sum or average all the values of a field and displays it at the bottom of the\n\t\t\t\t\ttable",
// "fieldId" => "fieldId",
// "%0, separated by %1" => "%0, separated by %1",
// "Silent" => "Silent",
// "Show nothing if no items found (the table header and a 'No records found'\n\t\t\t\t    message is shown by default)" => "Show nothing if no items found (the table header and a 'No records found'\n\t\t\t\t    message is shown by default)",
// "Show Delete" => "Show Delete",
// "Show a delete icon for each item (not shown by default)" => "Show a delete icon for each item (not shown by default)",
// "Url to redirect to after delete" => "Url to redirect to after delete",
// "Show Open Item" => "Show Open Item",
// "Show an open item  option (not shown by default)" => "Show an open item  option (not shown by default)",
// "Show Close Item" => "Show Close Item",
// "Show a close item option (not shown by default)" => "Show a close item option (not shown by default)",
// "Show Pending Item" => "Show Pending Item",
// "Show a pending item option (not shown by default)" => "Show a pending item option (not shown by default)",
// "Show Watch Button" => "Show Watch Button",
// "Show a watch button (not shown by default)" => "Show a watch button (not shown by default)",
// "Show Feed Button" => "Show Feed Button",
// "Show an RSS feed button (not shown by default)" => "Show an RSS feed button (not shown by default)",
// "Show Results Map" => "Show Results Map",
// "Show Map of results (not shown by default)" => "Show Map of results (not shown by default)",
// "Calendar Field IDs" => "Calendar Field IDs",
// "Used to display items in a calendar view. One fieldId if one date, or 2 fieldIds\n\t\t\t\t\tseparated with %0:%1 for %0start:end%1" => "Used to display items in a calendar view. One fieldId if one date, or 2 fieldIds\n\t\t\t\t\tseparated with %0:%1 for %0start:end%1",
// "Calendar View Mode" => "Calendar View Mode",
// "Calendar view type time span (default is month)" => "Calendar view type time span (default is month)",
// "Two months" => "Two months",
// "Trimester" => "Trimester",
// "Calendar Popup" => "Calendar Popup",
// "Calendar items will popup, overrides the %0stickypopup%1 parameter if turned off\n\t\t\t\t\t(default is to pop up)" => "Calendar items will popup, overrides the %0stickypopup%1 parameter if turned off\n\t\t\t\t\t(default is to pop up)",
// "Calendar item popups will stay open if set to y (Yes). Not sticky by default" => "Calendar item popups will stay open if set to y (Yes). Not sticky by default",
// "Beginning of Month" => "Beginning of Month",
// "Set whether calendar will begin at the beginning of the month (does by default)" => "Set whether calendar will begin at the beginning of the month (does by default)",
// "Show calendar navigation bar (shown by default)" => "Show calendar navigation bar (shown by default)",
// "Partial" => "Partial",
// "Calendar Title" => "Calendar Title",
// "Enter a title to display a calendar title (not set by default)" => "Enter a title to display a calendar title (not set by default)",
// "Calendar Delta" => "Calendar Delta",
// "Set the calendar delta that will be shown (not set by default)" => "Set the calendar delta that will be shown (not set by default)",
// "Plus Month" => "Plus Month",
// "Minus Month" => "Minus Month",
// "Plus Two months" => "Plus Two months",
// "Minus Two months" => "Minus Two months",
// "Display Spreadsheet" => "Display Spreadsheet",
// "Display tracker as a spreadsheet (not used by default)" => "Display tracker as a spreadsheet (not used by default)",
// "Force Compile" => "Force Compile",
// "Force Smarty to recompile the templates for each tracker item when using a\n\t\t\t\t    wiki page as a template. Default=n (best performance)" => "Force Smarty to recompile the templates for each tracker item when using a\n\t\t\t\t    wiki page as a template. Default=n (best performance)",
// "Numeric value to display only last tracker items created within a user defined\n\t\t\t\t    time-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how\n\t\t\t\t    many of those units are to be considered to define the time frame. Use in conjunction with\n\t\t\t\t    %0max=-\"1\"%1 to list all items (by default %0max%1 is set to %010%1)" => "Numeric value to display only last tracker items created within a user defined\n\t\t\t\t    time-frame. Used in conjunction with the next parameter \"Period unit\", this parameter indicates how\n\t\t\t\t    many of those units are to be considered to define the time frame. Use in conjunction with\n\t\t\t\t    %0max=-\"1\"%1 to list all items (by default %0max%1 is set to %010%1)",
// "Period type" => "Period type",
// "Time period after creation or after modification" => "Time period after creation or after modification",
// "Creation" => "Creation",
// "Modification" => "Modification",
// "Inline edit" => "Inline edit",
// "Colon-separated list of fields for which inline editing will be enabled" => "Colon-separated list of fields for which inline editing will be enabled",
// "Inline edit All" => "Inline edit All",
// "Allow all displayed fields to be editable" => "Allow all displayed fields to be editable",
// "Compile Each Item" => "Compile Each Item",
// "Compile each item separately instead of compiling the entire template" => "Compile each item separately instead of compiling the entire template",
// "Tracker List" => "Tracker List",
// "List, filter and sort the items in a tracker" => "List, filter and sort the items in a tracker",
// "Additional information when using tablesorter and the %0 parameter (Server Side Processing) is set to y" => "Additional information when using tablesorter and the %0 parameter (Server Side Processing) is set to y",
// "Filtering and sorting on some field types (e.g., items list), may behave unexpectedly" => "Filtering and sorting on some field types (e.g., items list), may behave unexpectedly",
// "For best results the date filter should only be applied to date field types" => "For best results the date filter should only be applied to date field types",
// "To filter the category field type, the exact category name or id needs to be entered" => "To filter the category field type, the exact category name or id needs to be entered",
// "incorrect filterfield" => "incorrect filterfield",
// "You have attempted to view data of a tracker field which is not public. You need to ask the admin to change the setting to public for this field" => "You have attempted to view data of a tracker field which is not public. You need to ask the admin to change the setting to public for this field",
// "Error in tracker ID" => "Error in tracker ID",
// "No field indicated" => "No field indicated",
// "Check Tracker Passcodes" => "Check Tracker Passcodes",
// "PluginTrackerpasscode" => "PluginTrackerpasscode",
// "Verify a tracker passcode" => "Verify a tracker passcode",
// "Session Key Names" => "Session Key Names",
// "Tracker Prefill" => "Tracker Prefill",
// "Create a button to prefill tracker fields" => "Create a button to prefill tracker fields",
// "Tracker page name" => "Tracker page name",
// "URL Parameters" => "URL Parameters",
// "Parameters to pass in the URL, for example, %0&my_parameter1=123&my_parameter2=q%1" => "Parameters to pass in the URL, for example, %0&my_parameter1=123&my_parameter2=q%1",
// "Field 1" => "Field 1",
// "Field ID for the first field" => "Field ID for the first field",
// "Value 1" => "Value 1",
// "Content that should be used to prefill the field" => "Content that should be used to prefill the field",
// "Field 2" => "Field 2",
// "Field ID for the second field" => "Field ID for the second field",
// "Value 2" => "Value 2",
// "Field 3" => "Field 3",
// "Field ID for the third field" => "Field ID for the third field",
// "Value 3" => "Value 3",
// "Field 4" => "Field 4",
// "Field ID for the fourth field" => "Field ID for the fourth field",
// "Value 4" => "Value 4",
// "Field 5" => "Field 5",
// "Field ID for the fifth field" => "Field ID for the fifth field",
// "Value 5" => "Value 5",
// "Field 6" => "Field 6",
// "Field ID for the sixth field" => "Field ID for the sixth field",
// "Value 6" => "Value 6",
// "Field 7" => "Field 7",
// "Field ID for the seventh field" => "Field ID for the seventh field",
// "Value 7" => "Value 7",
// "Field 8" => "Field 8",
// "Field ID for the eighth field" => "Field ID for the eighth field",
// "Value 8" => "Value 8",
// "Tracker Query Template" => "Tracker Query Template",
// "Generate a form from tracker data" => "Generate a form from tracker data",
// "Wiki Syntax, with variables from tracker query" => "Wiki Syntax, with variables from tracker query",
// "The name of the tracker to be queried, or if %0, the tracker ID" => "The name of the tracker to be queried, or if %0, the tracker ID",
// "Turn tracker query debug on (off by default)" => "Turn tracker query debug on (off by default)",
// "Use the tracker name instead of tracker ID in the %0 parameter. Also use the field\n\t\t\t\t\tname instead of field ID in the filter parameters. Set to Yes (%1) to use names (default) or\n\t\t\t\t\tNo (%2) to use IDs" => "Use the tracker name instead of tracker ID in the %0 parameter. Also use the field\n\t\t\t\t\tname instead of field ID in the filter parameters. Set to Yes (%1) to use names (default) or\n\t\t\t\t\tNo (%2) to use IDs",
// "Render" => "Render",
// "Render as needed for trackers (default)" => "Render as needed for trackers (default)",
// "Item id of tracker item" => "Item id of tracker item",
// "Tracker Item Ids" => "Tracker Item Ids",
// "Item id of tracker items, separated with comma" => "Item id of tracker items, separated with comma",
// "Like Filters" => "Like Filters",
// "Apply \"like\" filters to fields. Format: %0field:value;field:value;field:value%1,\n\t\t\t\t\twhere %0field%1 may be the field name or ID depending on the setting for the %0byname%1 parameter" => "Apply \"like\" filters to fields. Format: %0field:value;field:value;field:value%1,\n\t\t\t\t\twhere %0field%1 may be the field name or ID depending on the setting for the %0byname%1 parameter",
// "And Filters" => "And Filters",
// "Apply \"and\" filters to fields. Format: %0field:value;field:value;field:value%1,\n\t\t\t\t\twhere %0field%1 may be the field name or ID depending on the setting for the %0byname%1 parameter" => "Apply \"and\" filters to fields. Format: %0field:value;field:value;field:value%1,\n\t\t\t\t\twhere %0field%1 may be the field name or ID depending on the setting for the %0byname%1 parameter",
// "Or Filters" => "Or Filters",
// "Apply \"or\" filters to fields. Format: %0field:value;field:value;field:value%1,\n\t\t\t\t\twhere %0field%1 may be the field name or ID depending on the setting for the %0byname%1 parameter" => "Apply \"or\" filters to fields. Format: %0field:value;field:value;field:value%1,\n\t\t\t\t\twhere %0field%1 may be the field name or ID depending on the setting for the %0byname%1 parameter",
// "Get Last" => "Get Last",
// "Retrieve only the last item from the tracker" => "Retrieve only the last item from the tracker",
// "Tracker Stats" => "Tracker Stats",
// "Display statistics about a tracker" => "Display statistics about a tracker",
// "Colon-separated list of field IDs to be displayed. Example" => "Colon-separated list of field IDs to be displayed. Example",
// ". " => ". ",
// "Leave it empty to display all fields from this tracker" => "Leave it empty to display all fields from this tracker",
// "Show Count" => "Show Count",
// "Choose whether to show the count of votes each option received (shown by default)" => "Choose whether to show the count of votes each option received (shown by default)",
// "Choose whether to show the percentage of the vote each option received (not shown\n\t\t\t\t\tby default)" => "Choose whether to show the percentage of the vote each option received (not shown\n\t\t\t\t\tby default)",
// "Choose whether to show a bar representing the number of votes each option received\n\t\t\t\t\t(not shown by default)" => "Choose whether to show a bar representing the number of votes each option received\n\t\t\t\t\t(not shown by default)",
// "Only show items matching certain status filters" => "Only show items matching certain status filters",
// "Add a link to the tracker" => "Add a link to the tracker",
// "Show last modification date of a tracker. Set to Yes (%0) to use site setting for\n\t\t\t\t\tthe short date format or use PHP's format (www.php.net/strftime). Example" => "Show last modification date of a tracker. Set to Yes (%0) to use site setting for\n\t\t\t\t\tthe short date format or use PHP's format (www.php.net/strftime). Example",
// "invalid status" => "invalid status",
// "incorrect fieldId" => "incorrect fieldId",
// "Tracker Timeline" => "Tracker Timeline",
// "Show a timeline view of a tracker" => "Show a timeline view of a tracker",
// "Title Field" => "Title Field",
// "Tracker Field ID containing the item title" => "Tracker Field ID containing the item title",
// "Summary Field" => "Summary Field",
// "Tracker Field ID containing the summary of the item. The summary will be displayed\n\t\t\t\t\ton the timeline when the item is focused" => "Tracker Field ID containing the summary of the item. The summary will be displayed\n\t\t\t\t\ton the timeline when the item is focused",
// "Tracker Field ID containing the element start date. The field must be a\n\t\t\t\t\tdatetime/jscalendar field" => "Tracker Field ID containing the element start date. The field must be a\n\t\t\t\t\tdatetime/jscalendar field",
// "Tracker Field ID containing the element end date. The field must be a\n\t\t\t\t\tdatetime/jscalendar field" => "Tracker Field ID containing the element end date. The field must be a\n\t\t\t\t\tdatetime/jscalendar field",
// "Element Group" => "Element Group",
// "Tracker Field ID containing the element's group. Elements of a same group are\n\t\t\t\t\tdisplayed on the same row" => "Tracker Field ID containing the element's group. Elements of a same group are\n\t\t\t\t\tdisplayed on the same row",
// "Lower Bound" => "Lower Bound",
// "Date from which element should be displayed. Date must be provided in\n\t\t\t\t\t%0YYYY-MM-DD HH:mm:ss%1 format" => "Date from which element should be displayed. Date must be provided in\n\t\t\t\t\t%0YYYY-MM-DD HH:mm:ss%1 format",
// "Upper Bound" => "Upper Bound",
// "Date until which element should be displayed. Date must be provided in\n\t\t\t\t\t%0YYYY-MM-DD HH:mm:ss%1 format" => "Date until which element should be displayed. Date must be provided in\n\t\t\t\t\t%0YYYY-MM-DD HH:mm:ss%1 format",
// "Unit of time to use for the primary scale (default to hour - * SIMILE only)" => "Unit of time to use for the primary scale (default to hour - * SIMILE only)",
// "Decade *" => "Decade *",
// "Century *" => "Century *",
// "Unit of time to use for the secondary scale (default to empty - * SIMILE only)" => "Unit of time to use for the secondary scale (default to empty - * SIMILE only)",
// "Timeline height" => "Timeline height",
// "Height of the timeline band as a CSS unit (default: %0 -  - * SIMILE only)" => "Height of the timeline band as a CSS unit (default: %0 -  - * SIMILE only)",
// "Lower band height" => "Lower band height",
// "Height of the lower timeline band as a percentage (default: %0 -  - * SIMILE only)" => "Height of the lower timeline band as a percentage (default: %0 -  - * SIMILE only)",
// "Link Group Name" => "Link Group Name",
// "Convert the group name to a link" => "Convert the group name to a link",
// "Page Link Field" => "Page Link Field",
// "Tracker Field ID containing the page name for item details" => "Tracker Field ID containing the page name for item details",
// "SIMILE Timeline" => "SIMILE Timeline",
// "Use the SIMILE Timeline Widget" => "Use the SIMILE Timeline Widget",
// "Image Field" => "Image Field",
// "Tracker Field ID containing in image" => "Tracker Field ID containing in image",
// "Missing parameter: %0" => "Missing parameter: %0",
// "Start date after end date" => "Start date after end date",
// "Tracker Toggle" => "Tracker Toggle",
// "Numeric value representing the field ID tested" => "Numeric value representing the field ID tested",
// "Element Visibility" => "Element Visibility",
// "Set whether visible when the field has the value" => "Set whether visible when the field has the value",
// "HTML id of the element that is toggled" => "HTML id of the element that is toggled",
// "Use the field of specific item. The URL param itemId is used if this parameter\n\t\t\t\t\tis not set" => "Use the field of specific item. The URL param itemId is used if this parameter\n\t\t\t\t\tis not set",
// "trackertoggle: Param fieldId is required" => "trackertoggle: Param fieldId is required",
// "trackertoggle: Param fieldId field %0 does not exsist" => "trackertoggle: Param fieldId field %0 does not exsist",
// "trackertoggle: Param value is required" => "trackertoggle: Param value is required",
// "trackertoggle: Param id is required" => "trackertoggle: Param id is required",
// "Adjust the visibility of content based on a tracker field's value, possibly dynamically" => "Adjust the visibility of content based on a tracker field's value, possibly dynamically",
// "Trade" => "Trade",
// "Send payments between members using cclite" => "Send payments between members using cclite",
// "Currency depends on the selected registry" => "Currency depends on the selected registry",
// "Registry to trade in. Default: site preference (or first in list when more than one)" => "Registry to trade in. Default: site preference (or first in list when more than one)",
// "Currency to trade in. Default: Cclite currency preference for registry set above" => "Currency to trade in. Default: Cclite currency preference for registry set above",
// "Name of the user to receive or send the payment" => "Name of the user to receive or send the payment",
// "Leave empty to display an input box" => "Leave empty to display an input box",
// "Offered or wanted item" => "Offered or wanted item",
// "%0Offered%1" => "%0Offered%1",
// "Offered" => "Offered",
// "Wanted" => "Wanted",
// "%0Continue%1" => "%0Continue%1",
// "Title of the input form" => "Title of the input form",
// "Use %0 for the amount, %1 for currency,\n\t\t\t\t\t %2 for your user name, %3 for the other user" => "Use %0 for the amount, %1 for currency,\n\t\t\t\t\t %2 for your user name, %3 for the other user",
// "\"Payment of %0 %1 from user %2 to %3\" for offered items, \"Request payment of %0 %1 to user\n\t\t\t\t\t%2 from %3\" for wanted" => "\"Payment of %0 %1 from user %2 to %3\" for offered items, \"Request payment of %0 %1 to user\n\t\t\t\t\t%2 from %3\" for wanted",
// "Please log in" => "Please log in",
// " needs to validate their account" => " needs to validate their account",
// "Transclude" => "Transclude",
// "PluginTransclude" => "PluginTransclude",
// "Include the content of another page with certain changes" => "Include the content of another page with certain changes",
// "Name of the wiki page to use as a template for the values" => "Name of the wiki page to use as a template for the values",
// "Attempt to include a page that cannot be viewed" => "Attempt to include a page that cannot be viewed",
// "Page named \"%0\" does not exist at this time" => "Page named \"%0\" does not exist at this time",
// "Translated" => "Translated",
// "Create multilingual links" => "Create multilingual links",
// "[url] or ((wikiname)) or ((inter:interwiki)) (use wiki syntax)" => "[url] or ((wikiname)) or ((inter:interwiki)) (use wiki syntax)",
// "Two letter language code of the language, example" => "Two letter language code of the language, example",
"Flag" => "國旗",
// "Country name, example" => "Country name, example",
// "Translate a link from one language to another" => "Translate a link from one language to another",
// "TranslationOf" => "TranslationOf",
// "Original Page" => "Original Page",
// "Name of the page from which this link will be translated" => "Name of the page from which this link will be translated",
// "Translation Language" => "Translation Language",
// "Two letter language code of the language in which you want to translate this\n                    link. Example" => "Two letter language code of the language in which you want to translate this\n                    link. Example",
// "Translation Name" => "Translation Name",
// "Name of the page that will become the translation of the \"Original Page\"" => "Name of the page that will become the translation of the \"Original Page\"",
// "Translate this link" => "Translate this link",
// "Twitter" => "Twitter",
// "Display the activity for a twitter account" => "Display the activity for a twitter account",
// "Twitter Path" => "Twitter Path",
// "Depends on the type of timeline (Users, Collections, Favorites or Lists). For a\n\t\t\t\t\t User, it is the Account Name (like %0twitterdev%1), for Favorites, something like\n\t\t\t\t\t %0twitterdev/favorites%1. For lists, something like %0twitterdev/lists/listname%1, etc. " => "Depends on the type of timeline (Users, Collections, Favorites or Lists). For a\n\t\t\t\t\t User, it is the Account Name (like %0twitterdev%1), for Favorites, something like\n\t\t\t\t\t %0twitterdev/favorites%1. For lists, something like %0twitterdev/lists/listname%1, etc. ",
// "Widget Id" => "Widget Id",
// "Numeric identifier of the widget" => "Numeric identifier of the widget",
// "Embedded timelines are available in light and dark themes for customization.\n\t\t\t\t\tThe light theme is for pages that use a light colored background, while the dark theme is for pages\n\t\t\t\t\tthat use a dark colored background. Default is %0light%1" => "Embedded timelines are available in light and dark themes for customization.\n\t\t\t\t\tThe light theme is for pages that use a light colored background, while the dark theme is for pages\n\t\t\t\t\tthat use a dark colored background. Default is %0light%1",
// "light" => "light",
// "dark" => "dark",
// "Link Color" => "Link Color",
// "Text color for individual tweets. Default is theme default" => "Text color for individual tweets. Default is theme default",
// "Valid HTML color codes (with beginning #) or names" => "Valid HTML color codes (with beginning #) or names",
// "Border Color" => "Border Color",
// "Change the border color used by the widget. Default is theme default" => "Change the border color used by the widget. Default is theme default",
// "Height of widget in pixels. Default is %0" => "Height of widget in pixels. Default is %0",
// "Width of widget in pixels or 'auto' to fit to width of page. Default is %0" => "Width of widget in pixels or 'auto' to fit to width of page. Default is %0",
// "Number of pixels or the word 'auto'" => "Number of pixels or the word 'auto'",
// "Default is with Header" => "Default is with Header",
// "No Footer" => "No Footer",
// "Default is with Footer" => "Default is with Footer",
// "Footer" => "Footer",
// "Layout Option: No Borders" => "Layout Option: No Borders",
// "Default is with Borders" => "Default is with Borders",
// "Borders" => "Borders",
// "No Borders" => "No Borders",
// "No Scrollbar" => "No Scrollbar",
// "Default is with Scrollbar" => "Default is with Scrollbar",
// "Scrollbar" => "Scrollbar",
// "Transparent Background" => "Transparent Background",
// "Transparent Shell Background. Default is theme default" => "Transparent Shell Background. Default is theme default",
// "Theme default" => "Theme default",
// "User Count" => "User Count",
// "Display number of users for a site or one or more groups" => "Display number of users for a site or one or more groups",
// "Group name. If left blank, the total number of users for the site will be shown" => "Group name. If left blank, the total number of users for the site will be shown",
// "List of colon separated groups where a consolidated user count for multiple\n\t\t\t\t\tgroups is needed. Users in multiple groups are counted only once. If left blank then the behaviour\n\t\t\t\t\tis defined by the body parameter settings" => "List of colon separated groups where a consolidated user count for multiple\n\t\t\t\t\tgroups is needed. Users in multiple groups are counted only once. If left blank then the behaviour\n\t\t\t\t\tis defined by the body parameter settings",
// "UserInGroup" => "UserInGroup",
// "checks if an individual user is in a particular Group and simply return a string set to either true or false" => "checks if an individual user is in a particular Group and simply return a string set to either true or false",
// "userId" => "userId",
// "the userId to be checked" => "the userId to be checked",
// "test group" => "test group",
// "the Group that the userId check is made against" => "the Group that the userId check is made against",
// "text for true result" => "text for true result",
// "The text that is displayed if the test result is true" => "The text that is displayed if the test result is true",
// "text for false result" => "text for false result",
// "The text that is displayed if the test result is false" => "The text that is displayed if the test result is false",
// "Last Login information" => "Last Login information",
// "PluginUserLastLogged" => "PluginUserLastLogged",
// "Show the last login information for a given or current user" => "Show the last login information for a given or current user",
// "Username to display last login information for. Current user information shown\n\t\t\t\t\tif left blank" => "Username to display last login information for. Current user information shown\n\t\t\t\t\tif left blank",
// "DateFormat" => "DateFormat",
// "Date format setting. Short_datetime used by default" => "Date format setting. Short_datetime used by default",
// "User Link" => "User Link",
// "Display a link to a user's information page" => "Display a link to a user's information page",
// "User account name (which can be an email address)" => "User account name (which can be an email address)",
// "User List" => "User List",
// "Display a list of registered users" => "Display a list of registered users",
// "Login Filter" => "Login Filter",
// "Separator to use between users in the list. Default: comma" => "Separator to use between users in the list. Default: comma",
// "Set to sort in ascending or descending order" => "Set to sort in ascending or descending order",
// "Set to table to display results in a table" => "Set to table to display results in a table",
// "Make the user names listed links to different types of user information" => "Make the user names listed links to different types of user information",
// "User info" => "User info",
// "User page" => "User page",
// "User pref" => "User pref",
"Real Name" => "真實姓名",
// "Display the user's real name (when available) instead of login name" => "Display the user's real name (when available) instead of login name",
// "Filter on a group" => "Filter on a group",
// "Display contents based on user preference settings" => "Display contents based on user preference settings",
// "Create tabs for showing alternate versions of content" => "Create tabs for showing alternate versions of content",
// "Block of text separated by ---(version x)--- markers. Text before the first marker is used by\n\t\t\tdefault" => "Block of text separated by ---(version x)--- markers. Text before the first marker is used by\n\t\t\tdefault",
// "Display a navigation box that allows users to select a specific version to display" => "Display a navigation box that allows users to select a specific version to display",
// "Display the current version name as the title. No title shows when %0nav=\"y\"%1;\n\t\t\t\t\totherwise shows by default" => "Display the current version name as the title. No title shows when %0nav=\"y\"%1;\n\t\t\t\t\totherwise shows by default",
// "Default Label" => "Default Label",
// "Specifies version label to show when displaying the page for the first time.\n\t\t\t\t\tDefault label is 'Default'" => "Specifies version label to show when displaying the page for the first time.\n\t\t\t\t\tDefault label is 'Default'",
// "Embed a Vimeo video" => "Embed a Vimeo video",
// "Complete URL to the Vimeo video. Example" => "Complete URL to the Vimeo video. Example",
// "or leave blank to upload one" => "or leave blank to upload one",
// "Quality of the video" => "Quality of the video",
// "Expand to full screen" => "Expand to full screen",
// "Numeric ID of a Vimeo file in a File Gallery (or list separated by commas or %0)" => "Numeric ID of a Vimeo file in a File Gallery (or list separated by commas or %0)",
// "Numeric ID of a Tracker Files field, using Vimeo displayMode" => "Numeric ID of a Tracker Files field, using Vimeo displayMode",
// "Numeric ID of a Tracker item, using Vimeo displayMode" => "Numeric ID of a Tracker item, using Vimeo displayMode",
// "Gallery ID to upload to" => "Gallery ID to upload to",
// "Froogaloop API" => "Froogaloop API",
// "Use Vimeo Froogaloop API" => "Use Vimeo Froogaloop API",
// "Show the Video Title" => "Show the Video Title",
// "(default is to show)" => "(default is to show)",
// "Show Byline" => "Show Byline",
// "Show Portrait" => "Show Portrait",
// "Vimeo video not found for file #%0" => "Vimeo video not found for file #%0",
// "Feature required" => "Feature required",
// "Feature \"vimeo_upload\" is required to be able to add videos here" => "Feature \"vimeo_upload\" is required to be able to add videos here",
// "You do not have permsission to add files here" => "You do not have permsission to add files here",
// "You do not have permsission modify this tracker item" => "You do not have permsission modify this tracker item",
// "You do not have permsission modify this page" => "You do not have permsission modify this page",
// "Show the creator's byline" => "Show the creator's byline",
// "Show the creator's profile picture" => "Show the creator's profile picture",
"Vote" => "投票",
// "Create a tracker for voting" => "Create a tracker for voting",
// "Colon-separated list of field IDs to be displayed. If not set all the fields that\n\t\t\t\t\tcan be used (except IP, user, system, private fields) are used. Example" => "Colon-separated list of field IDs to be displayed. If not set all the fields that\n\t\t\t\t\tcan be used (except IP, user, system, private fields) are used. Example",
// "Choose whether to show the percentage of the vote each option received (not\n\t\t\t\t\tshown by default)" => "Choose whether to show the percentage of the vote each option received (not\n\t\t\t\t\tshown by default)",
// "Choose whether to show a bar representing the number of votes each option\n\t\t\t\t\treceived (not shown by default)" => "Choose whether to show a bar representing the number of votes each option\n\t\t\t\t\treceived (not shown by default)",
// "Show Stats" => "Show Stats",
// "Choose whether to show the voting results (shown by default)" => "Choose whether to show the voting results (shown by default)",
// "Show Stats After" => "Show Stats After",
// "Choose whether to show the voting results only after the date given in the\n\t\t\t\t\ttracker configuration (not set by default)" => "Choose whether to show the voting results only after the date given in the\n\t\t\t\t\ttracker configuration (not set by default)",
// "Choose whether to display the user name of the creator of the voting tracker (not\n\t\t\t\t\tshown by default)" => "Choose whether to display the user name of the creator of the voting tracker (not\n\t\t\t\t\tshown by default)",
// "Align the plugin on the page, allowing other elements to wrap around it (not set\n\t\t\t\t\tby default)" => "Align the plugin on the page, allowing other elements to wrap around it (not set\n\t\t\t\t\tby default)",
// "Show Toggle" => "Show Toggle",
// "Show toggle or not to display the form and the results" => "Show toggle or not to display the form and the results",
// "Votings" => "Votings",
// "Saves voting information in Smarty variables for display" => "Saves voting information in Smarty variables for display",
// "Object Key" => "Object Key",
// "Object key that is used to record votes" => "Object key that is used to record votes",
// "Return value" => "Return value",
// "Value to display as output of plugin" => "Value to display as output of plugin",
// "Wanted Pages" => "Wanted Pages",
// "Show location of links to pages not yet created" => "Show location of links to pages not yet created",
// "Custom level regex. A custom filter for wanted pages to be listed (only used when %0). Possible\n\t\t\tvalues: a valid regex-expression (PCRE)" => "Custom level regex. A custom filter for wanted pages to be listed (only used when %0). Possible\n\t\t\tvalues: a valid regex-expression (PCRE)",
// "A wildcard pattern of originating pages to be ignored. (refer to PHP function\n\t\t\t\t\tfnmatch() for details)" => "A wildcard pattern of originating pages to be ignored. (refer to PHP function\n\t\t\t\t\tfnmatch() for details)",
// "a valid regex-expression (PCRE)" => "a valid regex-expression (PCRE)",
// "Split By" => "Split By",
// "The character by which ignored patterns are separated" => "The character by which ignored patterns are separated",
// "Skip Alias" => "Skip Alias",
// "Whether to skip wanted pages that have a defined alias (not skipped by default)" => "Whether to skip wanted pages that have a defined alias (not skipped by default)",
// "Skip Extension" => "Skip Extension",
// "Whether to include external wikis in the list (not included by default)" => "Whether to include external wikis in the list (not included by default)",
// "Collect" => "Collect",
// "Collect either originating (from) or wanted pages (to) in a cell and display them\n\t\t\t\t\tin the second column" => "Collect either originating (from) or wanted pages (to) in a cell and display them\n\t\t\t\t\tin the second column",
"From" => "由",
// "Switch on debug output with details about the items (debug not on by default)" => "Switch on debug output with details about the items (debug not on by default)",
// "Memory Saver" => "Memory Saver",
// "Multiple collected items are separated in distinct table rows (default), or by\n\t\t\t\t\tcomma or line break in one cell" => "Multiple collected items are separated in distinct table rows (default), or by\n\t\t\t\t\tcomma or line break in one cell",
// "Line break" => "Line break",
// "Separate Row" => "Separate Row",
// "Level" => "Level",
// "Filter the list of wanted pages according to page_regex or custom filter. The\n\t\t\t\t\tdefault value is the site's __current__ page_regex" => "Filter the list of wanted pages according to page_regex or custom filter. The\n\t\t\t\t\tdefault value is the site's __current__ page_regex",
// "Full" => "Full",
// "non-valid custom regex" => "non-valid custom regex",
// ", " => ", ",
// "ignored" => "ignored",
// "External Wiki" => "External Wiki",
// "dash-WikiWord" => "dash-WikiWord",
// "WikiWord" => "WikiWord",
// "not in level" => "not in level",
"valid" => "確認",
// "End of debug output" => "End of debug output",
// "Wanted Page" => "Wanted Page",
// "Referenced By Page" => "Referenced By Page",
// "Web Document Viewer" => "Web Document Viewer",
// "View a document in a page" => "View a document in a page",
// "File Id" => "File Id",
// "The FileId of a file in a File Gallery of the file you wish to embed in the viewer" => "The FileId of a file in a File Gallery of the file you wish to embed in the viewer",
// "The URL of the file you wish to embed in the viewer. If the file is stored in\n\t\t\t\t\tFile Galleries, please use the %0 parameter" => "The URL of the file you wish to embed in the viewer. If the file is stored in\n\t\t\t\t\tFile Galleries, please use the %0 parameter",
// "No FileId or URL has been set" => "No FileId or URL has been set",
// "Web Service" => "Web Service",
// "Display remote information exposed in JSON or YAML or SOAP XML" => "Display remote information exposed in JSON or YAML or SOAP XML",
// "Template to apply to the data provided. Template format uses smarty templating engine using\n\t\t\tdouble brackets as delimiter. Output must provide wiki syntax. Body can be sent to a parameter instead by\n\t\t\tusing the %0 parameter" => "Template to apply to the data provided. Template format uses smarty templating engine using\n\t\t\tdouble brackets as delimiter. Output must provide wiki syntax. Body can be sent to a parameter instead by\n\t\t\tusing the %0 parameter",
// "Complete service URL" => "Complete service URL",
// "Registered service name" => "Registered service name",
// "For use with registered services, name of the template to be used to display the\n\t\t\t\t\tservice output. This parameter will be ignored if a body is provided" => "For use with registered services, name of the template to be used to display the\n\t\t\t\t\tservice output. This parameter will be ignored if a body is provided",
// "Body as Parameter" => "Body as Parameter",
// "Name of the argument to send the body as for services with complex input.\n\t\t\t\t\tNamed service required for this to be useful" => "Name of the argument to send the body as for services with complex input.\n\t\t\t\t\tNamed service required for this to be useful",
// "Parameters formatted like a query" => "Parameters formatted like a query",
// "Unknown Template" => "Unknown Template",
// "Unknown Service" => "Unknown Service",
// "Wiki Diff" => "Wiki Diff",
// "Display the differences between two wiki objects" => "Display the differences between two wiki objects",
// "Object Id" => "Object Id",
// "Object to do a diff on (page name for wiki pages)" => "Object to do a diff on (page name for wiki pages)",
// "Object type (wiki pages only)" => "Object type (wiki pages only)",
// "Old version" => "Old version",
// "Integer for old version number, or date" => "Integer for old version number, or date",
// "New version" => "New version",
// "Leave empty for current version" => "Leave empty for current version",
// "Diff Style" => "Diff Style",
// "Defaults to \"diff style\" preference if empty" => "Defaults to \"diff style\" preference if empty",
// "Show version info" => "Show version info",
// "Show the heading \"Comparing version X with version Y\"" => "Show the heading \"Comparing version X with version Y\"",
// "Use a WYSIWYG editor to edit a section of content" => "Use a WYSIWYG editor to edit a section of content",
// "Minimum width for DIV. Default" => "Minimum width for DIV. Default",
// "Minimum height for DIV. Default" => "Minimum height for DIV. Default",
"Use HTML" => "使用 HTML",
// "By default, the body (content) of calls to the WYSIWYG plugin is interpreted according to the \"Use Wiki syntax in WYSIWYG\" (%0wysiwyg_htmltowiki%1) preference. By default, \"Use HTML\" is considered enabled if \"Use Wiki syntax in WYSIWYG\" is disabled, and vice versa.\n\t\t\t\t This parameter allows overriding that preference if needed" => "By default, the body (content) of calls to the WYSIWYG plugin is interpreted according to the \"Use Wiki syntax in WYSIWYG\" (%0wysiwyg_htmltowiki%1) preference. By default, \"Use HTML\" is considered enabled if \"Use Wiki syntax in WYSIWYG\" is disabled, and vice versa.\n\t\t\t\t This parameter allows overriding that preference if needed",
// "XMLupdate" => "XMLupdate",
// "Allows multiple elements of an XML file stored in a File Gallery to be updated - the File Gallery (at present) is assumed to store all files in a Directory" => "Allows multiple elements of an XML file stored in a File Gallery to be updated - the File Gallery (at present) is assumed to store all files in a Directory",
// "list (one per line) of the XML element (node) names irrespective of their path and must (at present) be unique in the file " => "list (one per line) of the XML element (node) names irrespective of their path and must (at present) be unique in the file ",
// "File Id of the XML file stored in a File Gallery which is assumed to store its data in a directory" => "File Id of the XML file stored in a File Gallery which is assumed to store its data in a directory",
// "XML node attribute name" => "XML node attribute name",
// "optional use of an attribute for the XML nodes - used as a label in the input form. If used then all nodes in the XML file should have the attribute text set even if it is a blank/space" => "optional use of an attribute for the XML nodes - used as a label in the input form. If used then all nodes in the XML file should have the attribute text set even if it is a blank/space",
// "XML node listed in output" => "XML node listed in output",
// "yes/no option to include the XML node name in the plugin output - default is yes - and should always be yes if the attribute parameter is not used or not all the nodes have their attribute text set" => "yes/no option to include the XML node name in the plugin output - default is yes - and should always be yes if the attribute parameter is not used or not all the nodes have their attribute text set",
// "Xmpp" => "Xmpp",
// "Chat using Xmpp" => "Chat using Xmpp",
// "Room Name" => "Room Name",
// "Room to auto-join" => "Room to auto-join",
// "View Mode" => "View Mode",
// "Fullscreen" => "Fullscreen",
// "Overlayed" => "Overlayed",
// "Chat room width in CSS units" => "Chat room width in CSS units",
// "Chat room height in CSS units" => "Chat room height in CSS units",
// "Visibility" => "Visibility",
// "This room is visible to anyone or only for members" => "This room is visible to anyone or only for members",
// "Members only" => "Members only",
// "Show Real JIDs of Occupants to" => "Show Real JIDs of Occupants to",
// "If just moderator or anyone else can fetch information about an occupant" => "If just moderator or anyone else can fetch information about an occupant",
// "If just \"moderator\", anonymous user will not be able to change their nicknames" => "If just \"moderator\", anonymous user will not be able to change their nicknames",
// "Anyone" => "Anyone",
// "Moderator" => "Moderator",
// "Show controlbox on load" => "Show controlbox on load",
// "If controlbox should be shown after page load" => "If controlbox should be shown after page load",
// "This preference only works when view mode is overlayed" => "This preference only works when view mode is overlayed",
// "Show occupants" => "Show occupants",
// "If occupants window should be visible by default" => "If occupants window should be visible by default",
// "This preference only works when view mode is embedded" => "This preference only works when view mode is embedded",
// "Groups (comma-separated)" => "Groups (comma-separated)",
// "Allowed groups to use this resource" => "Allowed groups to use this resource",
// "Is secret" => "Is secret",
// "If the room will be listed on public chat room list" => "If the room will be listed on public chat room list",
// "Archiving" => "Archiving",
// "If room messages will be stored" => "If room messages will be stored",
// "Persistent" => "Persistent",
// "If room will continue to exist after last user leaves" => "If room will continue to exist after last user leaves",
// "If room is moderated" => "If room is moderated",
// "PluginXMPP Error: No room specified" => "PluginXMPP Error: No room specified",
// "Add a group to room" => "Add a group to room",
// "Add users to room" => "Add users to room",
// "YouTube" => "YouTube",
// "Embed a YouTube video in a page" => "Embed a YouTube video in a page",
// "Movie" => "Movie",
// "Complete URL to the YouTube video or last part (after %0www.youtube.com/v/%1 and\n\t\t\t\t\tbefore the first question mark)" => "Complete URL to the YouTube video or last part (after %0www.youtube.com/v/%1 and\n\t\t\t\t\tbefore the first question mark)",
// "Privacy-Enhanced" => "Privacy-Enhanced",
// "Enable privacy-enhanced mode" => "Enable privacy-enhanced mode",
// "Start time" => "Start time",
// "Start time offset in seconds" => "Start time offset in seconds",
// "Quality of the video. Default is %0high%1" => "Quality of the video. Default is %0high%1",
// "Enlarge video to full screen size" => "Enlarge video to full screen size",
"Related" => "相關",
// "Show related videos (shown by default)" => "Show related videos (shown by default)",
// "Background" => "Background",
// "Toolbar background color. Use an HTML color code" => "Toolbar background color. Use an HTML color code",
// "HTML color code, e.g. ffffff" => "HTML color code, e.g. ffffff",
// "Toolbar border colors. Use an HTML color code" => "Toolbar border colors. Use an HTML color code",
// "Plugin YouTube error: the movie parameter is empty" => "Plugin YouTube error: the movie parameter is empty",
// "Invalid YouTube URL provided" => "Invalid YouTube URL provided",
// "Zotero Citation" => "Zotero Citation",
// "Retrieves and includes a Zotero reference in the page" => "Retrieves and includes a Zotero reference in the page",
// "Reference Key" => "Reference Key",
// "Unique reference for the group associated to the site. Can be retrieved from the\n\t\t\t\t\tZotero Bibliography module" => "Unique reference for the group associated to the site. Can be retrieved from the\n\t\t\t\t\tZotero Bibliography module",
// "Reference Tag" => "Reference Tag",
// "Uses the first result using the specified tag. Useful when the tag mechanism is\n\t\t\t\t\tcoerced into creating unique human memorizable keys" => "Uses the first result using the specified tag. Useful when the tag mechanism is\n\t\t\t\t\tcoerced into creating unique human memorizable keys",
// "Append a note to the reference for additional information, like page numbers or\n\t\t\t\t\tother sub-references" => "Append a note to the reference for additional information, like page numbers or\n\t\t\t\t\tother sub-references",
// "Zotero Reference List" => "Zotero Reference List",
// "Display the complete reference list from a Zotero server" => "Display the complete reference list from a Zotero server",
// "Provide the list of references with a given tag" => "Provide the list of references with a given tag",
// "No results obtained. The Zotero citation server may be down" => "No results obtained. The Zotero citation server may be down",
// "Set up some advanced options" => "Set up some advanced options",
// "Set up Auto TOC" => "Set up Auto TOC",
// "Define Categories" => "Define Categories",
// "Set up User & Community features" => "Set up User & Community features",
// "Set up Date and Time" => "Set up Date and Time",
// "Select Editor type" => "Select Editor type",
// "Set up Main features" => "Set up Main features",
// "Set up File Gallery & Attachments" => "Set up File Gallery & Attachments",
// "Set up File storage" => "Set up File storage",
// "Set up Language" => "Set up Language",
// "Set up Login" => "Set up Login",
// "Set up Look & Feel" => "Set up Look & Feel",
// "Set up Namespace" => "Set up Namespace",
// "Set up Search" => "Set up Search",
// "Set up Structures" => "Set up Structures",
// "Set up Text Area" => "Set up Text Area",
// "Set up Wiki environment" => "Set up Wiki environment",
// "Tiki Setup" => "Tiki Setup",
// "Configuration Wizard Completed" => "Configuration Wizard Completed",
// "Set up Wysiwyg editor" => "Set up Wysiwyg editor",
// "Related doc.tiki.org pages" => "Related doc.tiki.org pages",
// "New in Tiki 13" => "New in Tiki 13",
// "New in Tiki 14" => "New in Tiki 14",
// "New in Tiki 15 (LTS)" => "New in Tiki 15 (LTS)",
// "New in Tiki 16" => "New in Tiki 16",
// "New in Tiki 17" => "New in Tiki 17",
// "New in Tiki 18 (LTS)" => "New in Tiki 18 (LTS)",
// "New in Tiki 19" => "New in Tiki 19",
// "New in Tiki 20" => "New in Tiki 20",
// "Novice Admin Assistance" => "Novice Admin Assistance",
// "Other features and settings" => "Other features and settings",
// "Permissions & Logs" => "Permissions & Logs",
// "Send feedback & Connect" => "Send feedback & Connect",
// "User Interface" => "User Interface",
// "Changes Wizard Completed" => "Changes Wizard Completed",
// "Configuration Profiles Wizard Completed" => "Configuration Profiles Wizard Completed",
// "Demo of Cases in Project Management" => "Demo of Cases in Project Management",
// "Demo of Commonly Used Configurations" => "Demo of Commonly Used Configurations",
// "Demo of Highly Specialized Configurations" => "Demo of Highly Specialized Configurations",
// "Demo of Interesting Use Cases" => "Demo of Interesting Use Cases",
// "Demo of More Advanced Configurations" => "Demo of More Advanced Configurations",
// "Demo of Other Interesting Use Cases" => "Demo of Other Interesting Use Cases",
// "Featured Site Configurations" => "Featured Site Configurations",
// "Useful Administration Configurations" => "Useful Administration Configurations",
// "Useful Changes in Display Mode" => "Useful Changes in Display Mode",
// "Useful Micro Configurations" => "Useful Micro Configurations",
// "Useful New Technology Configurations" => "Useful New Technology Configurations",
// "Personal Information" => "Personal Information",
"User Watches" => "使用者監視",
// "Notification Preferences" => "Notification Preferences",
// "unicode" => "unicode",
// "Report Preferences" => "Report Preferences",
// "User Details" => "User Details",
// "You cannot access this page directly" => "You cannot access this page directly",
// "Welcome to the User Wizard" => "Welcome to the User Wizard",
// "User Wizard Completed" => "User Wizard Completed",
// "Invalid wizard stepNr specified" => "Invalid wizard stepNr specified",
"Articles Home" => "文章首頁",
// "Delete selected messages" => "Delete selected messages",
// "%0 archived message was deleted" => "%0 archived message was deleted",
// "%0 archived messages were deleted" => "%0 archived messages were deleted",
// "No messages were deleted" => "No messages were deleted",
// "No messages were selected to delete" => "No messages were selected to delete",
// "The message must have either a subject or a body" => "The message must have either a subject or a body",
// "User %s does not have the permission" => "User %s does not have the permission",
// "The message has been sent to" => "The message has been sent to",
// "The message will be sent to" => "The message will be sent to",
// "See below for how the broadcast message will be handled upon confirmation" => "See below for how the broadcast message will be handled upon confirmation",
// "No valid users to send the message to" => "No valid users to send the message to",
// "User %s does not want to receive messages" => "User %s does not want to receive messages",
// "Sent box is full. Archive or delete some sent messages first if you want to send more messages" => "Sent box is full. Archive or delete some sent messages first if you want to send more messages",
// "See below for how message will be handled upon confirmation" => "See below for how message will be handled upon confirmation",
// "You have to be able to receive messages in order to send them. Goto your user preferences and enable 'Allow messages from other users'" => "You have to be able to receive messages in order to send them. Goto your user preferences and enable 'Allow messages from other users'",
// "User %s can not receive messages, mailbox is full" => "User %s can not receive messages, mailbox is full",
// "User %s can not receive messages" => "User %s can not receive messages",
// "Invalid user: %s" => "Invalid user: %s",
// "%0 message was marked" => "%0 message was marked",
// "%0 messages were marked" => "%0 messages were marked",
// "No messages were marked" => "No messages were marked",
// "No messages were selected to mark" => "No messages were selected to mark",
// "%0 message was deleted" => "%0 message was deleted",
// "%0 messages were deleted" => "%0 messages were deleted",
// "%0 message was archived" => "%0 message was archived",
// "%0 messages were archived" => "%0 messages were archived",
// "No messages were archived" => "No messages were archived",
// "No messages were selected to archive" => "No messages were selected to archive",
// "Archive is full. Delete some messages from archive first" => "Archive is full. Delete some messages from archive first",
// "Delete message" => "Delete message",
// "Message deleted" => "Message deleted",
// "Message not deleted" => "Message not deleted",
"No more messages" => "沒有訊息了",
// "Delete archive message" => "Delete archive message",
// "Archive message deleted" => "Archive message deleted",
// "Archive message not deleted" => "Archive message not deleted",
// "Delete sent message" => "Delete sent message",
// "Sent message deleted" => "Sent message deleted",
// "Sent message not deleted" => "Sent message not deleted",
// "%0 sent message was deleted" => "%0 sent message was deleted",
// "%0 sent messages were deleted" => "%0 sent messages were deleted",
// "Action Calendar" => "Action Calendar",
// "Item types filter" => "Item types filter",
// "If set to a list of item types, restricts the items displayed to those of one of these types. Each set is a comma-separated list of item type codes" => "If set to a list of item types, restricts the items displayed to those of one of these types. Each set is a comma-separated list of item type codes",
// "Possible item type values" => "Possible item type values",
// "Similar Content" => "Similar Content",
// "Find similar content based on tags" => "Find similar content based on tags",
// "Similar Content Filter" => "Similar Content Filter",
// "Display only similar content of type specified" => "Display only similar content of type specified",
// "Default: \"All Content Type\"" => "Default: \"All Content Type\"",
// "Options: \"article, wiki page, blog post\"" => "Options: \"article, wiki page, blog post\"",
// "Broaden FreeTag Search" => "Broaden FreeTag Search",
// "Find similar content that contains one of the Tags or All of the Tags" => "Find similar content that contains one of the Tags or All of the Tags",
// "Default: \"n - needs to contain all of the Tags\"" => "Default: \"n - needs to contain all of the Tags\"",
// "Options: \"n - Needs to contain All Tags / y - Needs to contain one of the Tags\"" => "Options: \"n - Needs to contain All Tags / y - Needs to contain one of the Tags\"",
// "Quick Admin Bar" => "Quick Admin Bar",
// "Consolidated admin bar with an easy access to quick admin links, recent changes, and important admin features" => "Consolidated admin bar with an easy access to quick admin links, recent changes, and important admin features",
// "Display mode: module or header. Leave empty for module mode" => "Display mode: module or header. Leave empty for module mode",
// "Google AdSense" => "Google AdSense",
// "Displays a text/image Google AdSense advertisement. This module should be updated to support new Google code" => "Displays a text/image Google AdSense advertisement. This module should be updated to support new Google code",
// "ad_channel" => "ad_channel",
// "Advertisement channel, as optionally provided by Google" => "Advertisement channel, as optionally provided by Google",
// "client" => "client",
// "As provided by Google. Format: \"pub-xxxxxxxxxxxxxxxx\"" => "As provided by Google. Format: \"pub-xxxxxxxxxxxxxxxx\"",
// "display" => "display",
// "Global banner format as provided by Google. For example: \"display=468*60_as\"" => "Global banner format as provided by Google. For example: \"display=468*60_as\"",
// "color_bg" => "color_bg",
// "Background color, as optionally provided by Google" => "Background color, as optionally provided by Google",
// "color_border" => "color_border",
// "Border color, as optionally provided by Google" => "Border color, as optionally provided by Google",
// "color_link" => "color_link",
// "Link color, as optionally provided by Google" => "Link color, as optionally provided by Google",
// "color_text" => "color_text",
// "Text color, as optionally provided by Google" => "Text color, as optionally provided by Google",
// "color_url" => "color_url",
// "URL color, as optionally provided by Google" => "URL color, as optionally provided by Google",
// "Article Archives" => "Article Archives",
// "Shows links to the published articles for each month" => "Shows links to the published articles for each month",
// "If set to \"y\", displays a button labelled \"More...\" that links to a paginated view of the selected articles" => "If set to \"y\", displays a button labelled \"More...\" that links to a paginated view of the selected articles",
// "Default: \"n\"" => "Default: \"n\"",
// "If set to a category identifier, only consider the articles in the specified category" => "If set to a category identifier, only consider the articles in the specified category",
// "Example value: 13" => "Example value: 13",
// "Topic filter (by names)" => "Topic filter (by names)",
// "If set to a list of article topic names separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered" => "If set to a list of article topic names separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered",
// "Topic filter (by identifiers)" => "Topic filter (by identifiers)",
// "If set to a list of article topic identifiers separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered" => "If set to a list of article topic identifiers separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered",
// "Example values: 13, !13, 1+3, !1+5+7" => "Example values: 13, !13, 1+3, !1+5+7",
// "Types filter" => "Types filter",
// "If set to a list of article type names separated by plus signs, only consider the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not considered" => "If set to a list of article type names separated by plus signs, only consider the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not considered",
// "Example values: Event, !Event, Event+Review, !Event+Classified+Article" => "Example values: Event, !Event, Event+Review, !Event+Classified+Article",
// "Language filter" => "Language filter",
// "If set to a language code, only consider the articles in the specified language" => "If set to a language code, only consider the articles in the specified language",
// "Article Topics" => "Article Topics",
// "Lists all article topics with links to their articles" => "Lists all article topics with links to their articles",
// "Lists the specified number of published articles in the specified order" => "Lists the specified number of published articles in the specified order",
// "Show publication time" => "Show publication time",
// "If set to \"y\", article publication times are shown" => "If set to \"y\", article publication times are shown",
// "Show creation time" => "Show creation time",
// "If set to \"y\", article creation times are shown" => "If set to \"y\", article creation times are shown",
// "Show rating selector" => "Show rating selector",
// "If set to \"y\", offers the user to filter articles based on a minimum and a maximum rating" => "If set to \"y\", offers the user to filter articles based on a minimum and a maximum rating",
// "Image width" => "Image width",
// "If set, displays an image for each article if one applies, with the given width (in pixels). The article's own image is used, with a fallback to the article's topic image" => "If set, displays an image for each article if one applies, with the given width (in pixels). The article's own image is used, with a fallback to the article's topic image",
// "If set to a category identifier, only lists the articles in the specified category" => "If set to a category identifier, only lists the articles in the specified category",
// "If set to a list of article topic names separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed" => "If set to a list of article topic names separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed",
// "If set to a list of article topic identifiers separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed" => "If set to a list of article topic identifiers separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed",
// "If set to a list of article type names separated by plus signs, only lists the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not listed" => "If set to a list of article type names separated by plus signs, only lists the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not listed",
// "If set to a language code, only lists the articles in the specified language" => "If set to a language code, only lists the articles in the specified language",
// "Specifies how the articles should be sorted" => "Specifies how the articles should be sorted",
// "Possible values include created and created_asc (equivalent), created_desc, author, rating, topicId, lang and title. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on article creation date" => "Possible values include created and created_asc (equivalent), created_desc, author, rating, topicId, lang and title. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on article creation date",
// "If set to an integer, offsets the articles list by the given number. For example, if the module was otherwise set to list the 10 articles most recently published, setting the offset to 10 would make the module list the 11th to 20th articles in descending order of publication time instead" => "If set to an integer, offsets the articles list by the given number. For example, if the module was otherwise set to list the 10 articles most recently published, setting the offset to 10 would make the module list the 11th to 20th articles in descending order of publication time instead",
// "If set to \"y\", displays a button labelled \"More\" that links to a paginated view of the selected articles" => "If set to \"y\", displays a button labelled \"More\" that links to a paginated view of the selected articles",
// "Absolute URL" => "Absolute URL",
// "If set to \"y\", some of the links use an absolute URL instead of a relative one. This can avoid broken links if the module is to be sent in a newsletter, for example" => "If set to \"y\", some of the links use an absolute URL instead of a relative one. This can avoid broken links if the module is to be sent in a newsletter, for example",
// "If set to 0, will take the topicId of the article if in an article" => "If set to 0, will take the topicId of the article if in an article",
// "Tiki Assistant" => "Tiki Assistant",
// "Display an assistant to guide new Tiki admins" => "Display an assistant to guide new Tiki admins",
// "Newest Blog Post Comments" => "Newest Blog Post Comments",
// "Displays the specified number of the blog post comments most recently added" => "Displays the specified number of the blog post comments most recently added",
// "No date" => "No date",
// "If set to \"y\", the date of comments is not displayed in the module box" => "If set to \"y\", the date of comments is not displayed in the module box",
// "Verbose tooltips" => "Verbose tooltips",
// "If set to \"y\", blog post title is only visible as a tooltip and not displayed" => "If set to \"y\", blog post title is only visible as a tooltip and not displayed",
// "Options: \"y,n\"" => "Options: \"y,n\"",
// "Last-Visited Pages" => "Last-Visited Pages",
// "Displays the last Wiki pages visited by the user" => "Displays the last Wiki pages visited by the user",
// "Maximum number of characters in page names allowed before truncating" => "Maximum number of characters in page names allowed before truncating",
// "Show Namespace" => "Show Namespace",
// "Show namespace prefix in page names" => "Show namespace prefix in page names",
// "A hierarchy of where you are. Ex.: Home > Section1 > Subsection C" => "A hierarchy of where you are. Ex.: Home > Section1 > Subsection C",
// "Label preceding the crumbs" => "Label preceding the crumbs",
// "Menu Id" => "Menu Id",
// "Menu to take the crumb trail from" => "Menu to take the crumb trail from",
// "Menu Start Level" => "Menu Start Level",
// "Lowest level of the menu to display" => "Lowest level of the menu to display",
// "Menu Stop Level" => "Menu Stop Level",
// "Highest level of the menu to display" => "Highest level of the menu to display",
// "Show Site Crumb" => "Show Site Crumb",
// "Display the first crumb, usually the site, when using menu crumbs" => "Display the first crumb, usually the site, when using menu crumbs",
// "Show Page Crumb" => "Show Page Crumb",
// "Display the last crumb, usually the page, when using menu crumbs" => "Display the last crumb, usually the page, when using menu crumbs",
// "Show Crumb Links" => "Show Crumb Links",
// "Display links on the crumbs" => "Display links on the crumbs",
// "Includes a calendar or a list of calendar events" => "Includes a calendar or a list of calendar events",
// "Calendars filter" => "Calendars filter",
// "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\"). Example values: \"13\", \"4,7\", \"31:49\". Not set by default" => "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\"). Example values: \"13\", \"4,7\", \"31:49\". Not set by default",
// "Displayed month (relative)" => "Displayed month (relative)",
// "Distance in month to the month to display. A distance of -1 would display the previous month. Setting this option implies a calendar view type with a month time span. Example values: 2, 0, -2, -12" => "Distance in month to the month to display. A distance of -1 would display the previous month. Setting this option implies a calendar view type with a month time span. Example values: 2, 0, -2, -12",
// "View type" => "View type",
// "Determines how to show events. Possible values: %0, %1" => "Determines how to show events. Possible values: %0, %1",
// "Calendar view type time span" => "Calendar view type time span",
// "If in calendar (or \"table\") view type, determines the time span displayed by the calendar. Possible values: %0, %1, %2, %3 ,%4, %5. A user changing this time span in the calendar can change the time span the module displays for him" => "If in calendar (or \"table\") view type, determines the time span displayed by the calendar. Possible values: %0, %1, %2, %3 ,%4, %5. A user changing this time span in the calendar can change the time span the module displays for him",
// "Show action" => "Show action",
// "Viewmode when clicking on a day" => "Viewmode when clicking on a day",
// "Put a link on all the days , not only those with event" => "Put a link on all the days , not only those with event",
// "View navigation bar" => "View navigation bar",
// "Cart" => "Cart",
// "Displays the content of the cart, allows quantities to be modified and proceeds to payment" => "Displays the content of the cart, allows quantities to be modified and proceeds to payment",
// "Use AJAX" => "Use AJAX",
// "Use AJAX services for managing the cart" => "Use AJAX services for managing the cart",
// "Show Items" => "Show Items",
// "Shows the items in the cart as they are added" => "Shows the items in the cart as they are added",
// "Shows the number of items in the cart" => "Shows the number of items in the cart",
// "Checkout URL" => "Checkout URL",
// "Where to go to when the \"Check-out\" button is clicked but before the payment invoice is generated" => "Where to go to when the \"Check-out\" button is clicked but before the payment invoice is generated",
// "(Default empty: Goes to tiki-payment.php)" => "(Default empty: Goes to tiki-payment.php)",
// "Post-Payment URL" => "Post-Payment URL",
// "Where to go to once the payment has been generated, will append \"?invoice=xx\" parameter on the URL for use in pretty trackers etc" => "Where to go to once the payment has been generated, will append \"?invoice=xx\" parameter on the URL for use in pretty trackers etc",
// "Show Total Weight" => "Show Total Weight",
// "Shows the weight of the items in the cart" => "Shows the weight of the items in the cart",
// "Shown after the weight" => "Shown after the weight",
// "Show Item Buttons" => "Show Item Buttons",
// "Shows add, remove and delete buttons on items" => "Shows add, remove and delete buttons on items",
// "The quantities in your cart were updated" => "The quantities in your cart were updated",
// "Gift card added" => "Gift card added",
// "Gift card not found" => "Gift card not found",
// "Gift card removed" => "Gift card removed",
// "Displays links to categories as a tree" => "Displays links to categories as a tree",
// "Object type filter" => "Object type filter",
// "Object type filter to apply when accessing a linked category. Example values" => "Object type filter to apply when accessing a linked category. Example values",
// "Deep" => "Deep",
// "Show subcategories objects when accessing a linked category. Possible values: on (default), off" => "Show subcategories objects when accessing a linked category. Possible values: on (default), off",
// "Limits displayed categories to a subtree of categories starting with the category with the given ID. Example value: 11. Default: 0 (don't limit display)" => "Limits displayed categories to a subtree of categories starting with the category with the given ID. Example value: 11. Default: 0 (don't limit display)",
// "Show these categories and their children" => "Show these categories and their children",
// "Show only these categories and the immediate child categories of these in the order the parameter specifies. Example values: 3,5,6" => "Show only these categories and the immediate child categories of these in the order the parameter specifies. Example values: 3,5,6",
// "Category links to a page named as the category" => "Category links to a page named as the category",
// "If y, category links to a page named as the category" => "If y, category links to a page named as the category",
// "Hide Empty" => "Hide Empty",
// "If y, only categories with child objects will be shown" => "If y, only categories with child objects will be shown",
// "Only Children" => "Only Children",
// "If y, only direct child categories will be shown. Default: n" => "If y, only direct child categories will be shown. Default: n",
// "Custom URL" => "Custom URL",
// "Custom URL for link to send you. Use %catId% as placeholder for catId or %name% for name. E.g. \"ProductBrowse?categ=%catId%\" " => "Custom URL for link to send you. Use %catId% as placeholder for catId or %name% for name. E.g. \"ProductBrowse?categ=%catId%\" ",
// "Category Transitions" => "Category Transitions",
// "Displays controls to trigger category transitions and change the page's state according to predefined rules" => "Displays controls to trigger category transitions and change the page's state according to predefined rules",
// "Example Transition" => "Example Transition",
// "Change Category" => "Change Category",
// "Enables to categorize an object" => "Enables to categorize an object",
// "Some combinations of Multiple categories, Detailed, Unassign and Assign may challenge intuition or be simply broken" => "Some combinations of Multiple categories, Detailed, Unassign and Assign may challenge intuition or be simply broken",
// "Category identifier" => "Category identifier",
// "Changes the root of the displayed categories from default \"TOP\" to the category with the given identifier" => "Changes the root of the displayed categories from default \"TOP\" to the category with the given identifier",
// "Note that the root category is not displayed" => "Note that the root category is not displayed",
// "Defaults to 0 (root)" => "Defaults to 0 (root)",
// "No top" => "No top",
// "In non-detailed view, disallow uncategorizing. Example value: 1" => "In non-detailed view, disallow uncategorizing. Example value: 1",
// "Display path" => "Display path",
// "Unless set to \"n\", display relative category paths in the category tree rather than category names" => "Unless set to \"n\", display relative category paths in the category tree rather than category names",
// "Paths are relative to the root category, which is not displayed" => "Paths are relative to the root category, which is not displayed",
// "Multiple categories" => "Multiple categories",
// "If set to \"n\", only allows categorizing in one category (from those displayed)" => "If set to \"n\", only allows categorizing in one category (from those displayed)",
// "Categorize" => "Categorize",
// "String to display on the button to submit new categories, when multiple categories is enabled. Default value: Categorize" => "String to display on the button to submit new categories, when multiple categories is enabled. Default value: Categorize",
// "Shy" => "Shy",
// "If set to \"y\", the module is not shown on pages which are not already categorized" => "If set to \"y\", the module is not shown on pages which are not already categorized",
// "Detailed" => "Detailed",
// "If set to \"y\", shows a list of categories in which the object is. If deletion is not disabled, it is done with the list" => "If set to \"y\", shows a list of categories in which the object is. If deletion is not disabled, it is done with the list",
// "If set to \"n\", the detailed list of categories will not offer to unassign a category" => "If set to \"n\", the detailed list of categories will not offer to unassign a category",
// "If set to \"y\", allow to assign new categories" => "If set to \"y\", allow to assign new categories",
// "Example values: y, n" => "Example values: y, n",
// "Default value: y" => "Default value: y",
// "Group filter" => "Group filter",
// "Very particular filter option. If set to \"y\", only categories with a name matching one of the user's groups are shown, and descendants of these matching categories" => "Very particular filter option. If set to \"y\", only categories with a name matching one of the user's groups are shown, and descendants of these matching categories",
// "Default value: n" => "Default value: n",
// "Image URL not in category" => "Image URL not in category",
// "Very particular parameter. If both this and \"Image URL in category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is not in the category" => "Very particular parameter. If both this and \"Image URL in category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is not in the category",
// "Image URL in category" => "Image URL in category",
// "Very particular parameter. If both this and \"Image URL not in category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is in the category" => "Very particular parameter. If both this and \"Image URL not in category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is in the category",
// "Categorize %s" => "Categorize %s",
// "Categorize %s in %s" => "Categorize %s in %s",
// "Collapse Button" => "Collapse Button",
// "Bootstrap collapse button" => "Bootstrap collapse button",
// "CSS selector defining which objects get collapsed" => "CSS selector defining which objects get collapsed",
// "CSS class for containing DIV element" => "CSS class for containing DIV element",
// "CSS selector defining the collapsing objects' container" => "CSS selector defining the collapsing objects' container",
"Received Objects" => "接收的物件",
// "Displays the number of pages received (via Communications)" => "Displays the number of pages received (via Communications)",
// "Contributors" => "Contributors",
// "Lists the contributors to the wiki page being viewed and some information on them" => "Lists the contributors to the wiki page being viewed and some information on them",
// "Shows the credits a user has" => "Shows the credits a user has",
// "Newest Directory Sites" => "Newest Directory Sites",
// "Displays the specified number of the directory sites most recently added" => "Displays the specified number of the directory sites most recently added",
// "Directory category identifier" => "Directory category identifier",
// "If set to a directory category identifier, only displays the sites in the specified directory category" => "If set to a directory category identifier, only displays the sites in the specified directory category",
// "If set to \"y\", displays a button labelled \"More\" that links to the directory" => "If set to \"y\", displays a button labelled \"More\" that links to the directory",
"Show description" => "顯示描述",
// "If set to \"y\", the description of the directory site appears" => "If set to \"y\", the description of the directory site appears",
// "Maximum length of description" => "Maximum length of description",
// "If desc = \"y\", use maxdesc to set the maximum length of the directory site (in characters). Leave blank to set no maximum (show the entire description)" => "If desc = \"y\", use maxdesc to set the maximum length of the directory site (in characters). Leave blank to set no maximum (show the entire description)",
// "Default: blank" => "Default: blank",
// "Directory Statistics" => "Directory Statistics",
// "Displays statistics about the directory, including the number of sites validated and to validate, the number of categories, of searches and of visited links" => "Displays statistics about the directory, including the number of sites validated and to validate, the number of categories, of searches and of visited links",
// "Top Directory Sites" => "Top Directory Sites",
// "Displays the specified number of the directory sites from most visited to least visited" => "Displays the specified number of the directory sites from most visited to least visited",
// "Domain Password" => "Domain Password",
// "Store personal passwords for other domains securely in Tiki" => "Store personal passwords for other domains securely in Tiki",
// "System the credentials apply for. The name must match a defined Password Domain" => "System the credentials apply for. The name must match a defined Password Domain",
// "Use current user" => "Use current user",
// "Use the currently logged-in user. The username is not editable. (y/n) Default: y" => "Use the currently logged-in user. The username is not editable. (y/n) Default: y",
// "Can Update" => "Can Update",
// "If \"y\" the user can update the values, otherwise the display is read-only (y/n). Default: n" => "If \"y\" the user can update the values, otherwise the display is read-only (y/n). Default: n",
// "Show domain prompt" => "Show domain prompt",
// "If \"y\" the word \"domain\" is shown before the domain. Otherwise the domain name takes the full row (y/n). Default: y" => "If \"y\" the word \"domain\" is shown before the domain. Otherwise the domain name takes the full row (y/n). Default: y",
// "No Password Domains found" => "No Password Domains found",
// "Domain is not valid" => "Domain is not valid",
// "No domain specified" => "No domain specified",
// "No user defined" => "No user defined",
// "No password saved" => "No password saved",
// "Read error" => "Read error",
// "No password specified" => "No password specified",
// "No username specified" => "No username specified",
// "Failed to save password" => "Failed to save password",
// "Failed to save user" => "Failed to save user",
// "Saved OK" => "Saved OK",
// "Facebook" => "Facebook",
// "Shows the Wall of a user" => "Shows the Wall of a user",
// "Tiki user to show Facebook wall of" => "Tiki user to show Facebook wall of",
// "Show username in timeline. y|n" => "Show username in timeline. y|n",
// "user not registered with facebook" => "user not registered with facebook",
// "No username given" => "No username given",
"Featured Links" => "主打連結",
// "Displays the site's first featured links" => "Displays the site's first featured links",
// "Displays links to file galleries" => "Displays links to file galleries",
// "Top-Rated Topics" => "Top-Rated Topics",
// "Displays the specified number of the forum topics with the best ratings" => "Displays the specified number of the forum topics with the best ratings",
// "Newest Forum Posts" => "Newest Forum Posts",
// "Displays the latest forum posts" => "Displays the latest forum posts",
"Topics only" => "僅主題",
// "If set to \"y\", only displays topics" => "If set to \"y\", only displays topics",
// "List of forum identifiers" => "List of forum identifiers",
// "If set to a list of forum identifiers, restricts the posts to those in the identified forums. Identifiers are separated by colons (\":\")" => "If set to a list of forum identifiers, restricts the posts to those in the identified forums. Identifiers are separated by colons (\":\")",
// "Show date" => "Show date",
// "If set to \"y\", show post date directly instead of as tooltip" => "If set to \"y\", show post date directly instead of as tooltip",
// "Show time" => "Show time",
// "Show times after dates" => "Show times after dates",
// "If set to \"y\", show post author directly instead of as tooltip" => "If set to \"y\", show post author directly instead of as tooltip",
"Most Commented Forums" => "最多評論論壇",
// "Display the specified number of the forums with the most comments" => "Display the specified number of the forums with the most comments",
// "Top Visited Forum Topics" => "Top Visited Forum Topics",
// "Display the specified number of the forum topics with the most reads" => "Display the specified number of the forum topics with the most reads",
// "Top Visited Forums" => "Top Visited Forums",
// "Display the specified number of the forums with the most visits" => "Display the specified number of the forums with the most visits",
// "Tags Editor" => "Tags Editor",
// "Shows current tags and enables adding and removing some if permissions allow" => "Shows current tags and enables adding and removing some if permissions allow",
// "Wiki Page Tags" => "Wiki Page Tags",
// "Displays current tags on wiki pages and enables adding tags if permissions allow" => "Displays current tags on wiki pages and enables adding tags if permissions allow",
// "Similar-Tag Items" => "Similar-Tag Items",
// "Shows content with multiple tags in common" => "Shows content with multiple tags in common",
// "Type of objects to extract" => "Type of objects to extract",
// "Most Popular Tags" => "Most Popular Tags",
// "Shows the most popular tags. More popularity is indicated by a larger font" => "Shows the most popular tags. More popularity is indicated by a larger font",
// "Display type" => "Display type",
// "If set to \"cloud\", links are displayed as a cloud" => "If set to \"cloud\", links are displayed as a cloud",
// "Default: \"list\"" => "Default: \"list\"",
// "Maximum elements" => "Maximum elements",
// "If set to a number, limits the number of tags displayed" => "If set to a number, limits the number of tags displayed",
// "BlogId" => "BlogId",
// "Blog Id if only blog posts selected. More than one blog can be provided, separated by colon. Example: 1:5" => "Blog Id if only blog posts selected. More than one blog can be provided, separated by colon. Example: 1:5",
// "My Preferred Tags" => "My Preferred Tags",
// "Displays to registered users the tags they prefer, based on the number of objects they tagged. Greater preference is indicated by a larger text size" => "Displays to registered users the tags they prefer, based on the number of objects they tagged. Greater preference is indicated by a larger text size",
// "My preferred tags" => "My preferred tags",
// "Displays a list of friends" => "Displays a list of friends",
// "GIT detail" => "GIT detail",
// "GIT commit and last update information" => "GIT commit and last update information",
"Google Search" => "Google 搜尋",
// "Displays a simple form to search on Google. By default, search results are limited to those on the Tiki site" => "Displays a simple form to search on Google. By default, search results are limited to those on the Tiki site",
// "Groups Emulation" => "Groups Emulation",
// "Enables temporarily changing one's group memberships to see how users in fewer groups experience the site" => "Enables temporarily changing one's group memberships to see how users in fewer groups experience the site",
// "Show All Groups" => "Show All Groups",
// "If set to \"n\", the list is not shown" => "If set to \"n\", the list is not shown",
// "Show Your Groups" => "Show Your Groups",
// "Emulate Groups" => "Emulate Groups",
// "Last Actions" => "Last Actions",
// "Displays the specified number of last actions" => "Displays the specified number of last actions",
// "Show user" => "Show user",
// "If set to \"y\", user names are displayed in the module box" => "If set to \"y\", user names are displayed in the module box",
// "If set to \"y\", action dates are displayed in the module box" => "If set to \"y\", action dates are displayed in the module box",
// "Maximum number of characters in action descriptions before truncating" => "Maximum number of characters in action descriptions before truncating",
"Newest Blog Posts" => "最新 blog 佈告",
// "Lists the specified number of blogs posts from newest to oldest" => "Lists the specified number of blogs posts from newest to oldest",
// "If set to \"y\", the date of posts is not displayed in the module box" => "If set to \"y\", the date of posts is not displayed in the module box",
// "Blog identifier" => "Blog identifier",
// "If set to a blog identifier, restricts the blog posts to those in the identified blog" => "If set to a blog identifier, restricts the blog posts to those in the identified blog",
// "Newest Category Items" => "Newest Category Items",
// "Lists the specified number of objects of the given type in the given category, starting from the most recently created" => "Lists the specified number of objects of the given type in the given category, starting from the most recently created",
// "Identifier of the category from which objects are listed. Objects merely in child categories will not be displayed" => "Identifier of the category from which objects are listed. Objects merely in child categories will not be displayed",
// "Maximum number of characters in object names allowed before truncating" => "Maximum number of characters in object names allowed before truncating",
// "Type of the objects to list. Example values" => "Type of the objects to list. Example values",
// "no object here yet" => "no object here yet",
"Newest Blogs" => "最近建立 blogs",
// "Displays the specified number of blogs from newest to oldest" => "Displays the specified number of blogs from newest to oldest",
"Newest FAQs" => "最近建立 FAQS",
// "Displays the specified number of FAQs from newest to oldest" => "Displays the specified number of FAQs from newest to oldest",
"Newest Quizzes" => "最近建立的測驗",
// "Displays the specified number of quizzes from newest to oldest" => "Displays the specified number of quizzes from newest to oldest",
// "Last-Modified File Galleries" => "Last-Modified File Galleries",
// "Display the specified number of file galleries, starting from the most recently modified" => "Display the specified number of file galleries, starting from the most recently modified",
"Newest Files" => "最近檔案",
// "List the specified number of files, starting from the most recently added" => "List the specified number of files, starting from the most recently added",
// "Gallery identifiers" => "Gallery identifiers",
// "If set to a set of file gallery identifiers, restricts the files to those in the identified galleries. The value is a colon-separated sequence of integers" => "If set to a set of file gallery identifiers, restricts the files to those in the identified galleries. The value is a colon-separated sequence of integers",
// "Example value: 13, 2:13, 1:2:3:5:6" => "Example value: 13, 2:13, 1:2:3:5:6",
// "Last-Modified Image Galleries" => "Last-Modified Image Galleries",
// "Displays the specified number of image galleries, starting from the most recently modified" => "Displays the specified number of image galleries, starting from the most recently modified",
// "Newest Images" => "Newest Images",
// "List the specified number of images, starting from the most recently added" => "List the specified number of images, starting from the most recently added",
// "Gallery identifier" => "Gallery identifier",
// "If set to an image gallery identifier, restricts the images to those in the identified gallery" => "If set to an image gallery identifier, restricts the images to those in the identified gallery",
// "Link content" => "Link content",
// "Display the links as image names or thumbnails" => "Display the links as image names or thumbnails",
// "Possible values: \"names\" or \"thumbnails\". Default value: \"names\"" => "Possible values: \"names\" or \"thumbnails\". Default value: \"names\"",
// "Last-Modified Events" => "Last-Modified Events",
// "Display the specified number of calendar events, starting from the most recently modified" => "Display the specified number of calendar events, starting from the most recently modified",
// "Calendar Identifier" => "Calendar Identifier",
// "If set to a calendar identifier, restricts the events to those in the identified calendar" => "If set to a calendar identifier, restricts the events to those in the identified calendar",
// "Maximum number of characters in event names allowed before truncating" => "Maximum number of characters in event names allowed before truncating",
// "Hide Date" => "Hide Date",
// "If set to \"y\", it will hide date" => "If set to \"y\", it will hide date",
"Latest Changes" => "最近變動",
// "List the specified number of pages, starting from the most recently modified" => "List the specified number of pages, starting from the most recently modified",
// "Link Target" => "Link Target",
// "Target URL of the \"...more\" link at the bottom of the module" => "Target URL of the \"...more\" link at the bottom of the module",
"Last-Modified Blogs" => "最近修改 blogs",
// "Displays the specified number of blogs, starting from the most recently modified" => "Displays the specified number of blogs, starting from the most recently modified",
// "Newest Podcasts" => "Newest Podcasts",
// "Displays Podcasts" => "Displays Podcasts",
// "File galleries IDs" => "File galleries IDs",
// "List of IDs of file galleries of type \"Podcast (Audio)\". Identifiers are separated by a colon (\":\"). If none, all file galleries will be scanned" => "List of IDs of file galleries of type \"Podcast (Audio)\". Identifiers are separated by a colon (\":\"). If none, all file galleries will be scanned",
// "Width of mediaplayer in pixels" => "Width of mediaplayer in pixels",
// "Height of mediaplayer in pixels" => "Height of mediaplayer in pixels",
// "Path to mp3 player. For instance media/player_mp3_maxi.swf if you downloaded player_mp3_maxi.swf from http://flash-mp3-player.net/players/maxi/download/ to directory media/ (directory needs to be created or you can chose another place)" => "Path to mp3 player. For instance media/player_mp3_maxi.swf if you downloaded player_mp3_maxi.swf from http://flash-mp3-player.net/players/maxi/download/ to directory media/ (directory needs to be created or you can chose another place)",
// "Bottom Link URL" => "Bottom Link URL",
// "URL for a link at bottom of module" => "URL for a link at bottom of module",
// "Bottom Link URL Text" => "Bottom Link URL Text",
// "Text for link if Bottom Link URL is set" => "Text for link if Bottom Link URL is set",
// "More Podcasts" => "More Podcasts",
// "Verbose" => "Verbose",
// "Display description of podcast below player if \"y\", and on title mouseover if \"n\"" => "Display description of podcast below player if \"y\", and on title mouseover if \"n\"",
"Newest Article Submissions" => "最近送交文章",
// "Lists the specified number of article submissions from newest to oldest" => "Lists the specified number of article submissions from newest to oldest",
// "Newest Tracker Comments" => "Newest Tracker Comments",
// "Lists the specified number of tracker comments (optionally restricting to those in a specific tracker or tracker item) starting from the most recently posted" => "Lists the specified number of tracker comments (optionally restricting to those in a specific tracker or tracker item) starting from the most recently posted",
// "Tracker identifier" => "Tracker identifier",
// "If set to a tracker identifier, only displays the comments on the given tracker" => "If set to a tracker identifier, only displays the comments on the given tracker",
// "Item identifier" => "Item identifier",
// "If set to an item identifier, only displays the comments on the given item" => "If set to an item identifier, only displays the comments on the given item",
// "Newest Tracker Items" => "Newest Tracker Items",
// "Displays the value of a field of the specified number of tracker items. If the specified tracker has no main field, either Field name or Field identifier is required" => "Displays the value of a field of the specified number of tracker items. If the specified tracker has no main field, either Field name or Field identifier is required",
// "Identifier of the tracker from which items are listed" => "Identifier of the tracker from which items are listed",
// "Field identifier" => "Field identifier",
// "Identifier of the field from which values are listed. If Field name is set, this parameter is ignored" => "Identifier of the field from which values are listed. If Field name is set, this parameter is ignored",
// "Field name" => "Field name",
// "Name of the field from which values are listed" => "Name of the field from which values are listed",
// "Example value: age" => "Example value: age",
// "Specifies how the items should be sorted" => "Specifies how the items should be sorted",
// "Possible values include created and created_asc (equivalent), created_desc, status, lastModif, createdBy and lastModifBy. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on item creation date. \"lastModif\" sorts on the last modification date of items. \"lastModif_desc\" sorts in descending order of last modification date" => "Possible values include created and created_asc (equivalent), created_desc, status, lastModif, createdBy and lastModifBy. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on item creation date. \"lastModif\" sorts on the last modification date of items. \"lastModif_desc\" sorts in descending order of last modification date",
// "Status filter" => "Status filter",
// "If set, limits the listed items to those with the given statuses. Values are combinations of \"o\" (open), \"p\" (pending) and \"c\" (closed). Possible values" => "If set, limits the listed items to those with the given statuses. Values are combinations of \"o\" (open), \"p\" (pending) and \"c\" (closed). Possible values",
// "Unable to determine which field to show. Tracker identifier may be invalid, or the tracker has no main field and neither Field identifier nor Field name were set" => "Unable to determine which field to show. Tracker identifier may be invalid, or the tracker has no main field and neither Field identifier nor Field name were set",
// "You do not have permission to view this tracker" => "You do not have permission to view this tracker",
"Last Items" => "上一個項目",
"Last modified Items" => "上一個修改項目",
// "Newest Validated FAQ Questions" => "Newest Validated FAQ Questions",
// "Displays the specified number of validated questions FAQs from newest to oldest" => "Displays the specified number of validated questions FAQs from newest to oldest",
// "FAQ identifier" => "FAQ identifier",
// "If set to a FAQ identifier, restricts the chosen questions to those in the identified FAQ" => "If set to a FAQ identifier, restricts the chosen questions to those in the identified FAQ",
// "Last Visitors" => "Last Visitors",
// "Displays information about the specified number of users in decreasing order of last login time" => "Displays information about the specified number of users in decreasing order of last login time",
// "Show profile pictures" => "Show profile pictures",
// "If set to \"y\", show user profile pictures" => "If set to \"y\", show user profile pictures",
// "Maximum number of characters in user names allowed before truncating" => "Maximum number of characters in user names allowed before truncating",
// "Don't show date" => "Don't show date",
// "YouTube Playlist" => "YouTube Playlist",
// "Display a YouTube playlist" => "Display a YouTube playlist",
// "Playlist ID" => "Playlist ID",
// "ID of the YouTube playlist to display (not the complete URL). Example: id=4DE69387D46DA2F6" => "ID of the YouTube playlist to display (not the complete URL). Example: id=4DE69387D46DA2F6",
// "Google YouTube API Key" => "Google YouTube API Key",
// "Width of each video in pixels" => "Width of each video in pixels",
// "Height of each video in pixels" => "Height of each video in pixels",
// "Allow FullScreen" => "Allow FullScreen",
// "Bottom Link" => "Bottom Link",
// "Url for a link at bottom of module. Example: link_url=http://www.youtube.com/CouncilofEurope#grid/user/E57D0D93BA3A56C8" => "Url for a link at bottom of module. Example: link_url=http://www.youtube.com/CouncilofEurope#grid/user/E57D0D93BA3A56C8",
// "Bottom Link Text" => "Bottom Link Text",
// "Text for link if link_url is set, otherwise 'More Videos'" => "Text for link if link_url is set, otherwise 'More Videos'",
// "Video Descriptions" => "Video Descriptions",
// "Display description of video on title mouseover if 'y'. Default is 'y'" => "Display description of video on title mouseover if 'y'. Default is 'y'",
// "Order by" => "Order by",
// "Criteria to order by the videos in the list. Default is 'position'" => "Criteria to order by the videos in the list. Default is 'position'",
// "position" => "position",
// "commentCount" => "commentCount",
"duration" => "期間",
// "published" => "published",
// "reversedPosition" => "reversedPosition",
// "title" => "title",
// "viewCount" => "viewCount",
// "To display a YouTube playlist, Tiki needs the google/apiclient package. If you do not have permission to install this package, ask the site administrator" => "To display a YouTube playlist, Tiki needs the google/apiclient package. If you do not have permission to install this package, ask the site administrator",
// "No Playlist found" => "No Playlist found",
// "No Playlist ID was provided" => "No Playlist ID was provided",
"Live Support" => "線上支援",
// "Tells users whether a live support operator is present and allows them to request support if possible. If the user is an operator, links to the operator console" => "Tells users whether a live support operator is present and allows them to request support if possible. If the user is an operator, links to the operator console",
// "Server Load" => "Server Load",
// "Report of server resources used" => "Report of server resources used",
// "Locator" => "Locator",
// "Presents a map with the geolocated content within the page" => "Presents a map with the geolocated content within the page",
// "Preference \"%0\" is disabled" => "Preference \"%0\" is disabled",
// "Log-in box" => "Log-in box",
// "Input size" => "Input size",
// "Number of characters for username and password input fields" => "Number of characters for username and password input fields",
// "Display mode: module, header or popup. Leave empty for module mode" => "Display mode: module, header or popup. Leave empty for module mode",
// "Show Register" => "Show Register",
// "Show the register link" => "Show the register link",
// "Show I Forgot" => "Show I Forgot",
// "Show the \"I forgot my password\" link" => "Show the \"I forgot my password\" link",
// "Show Remember me" => "Show Remember me",
// "Show the \"Remember me\" checkbox" => "Show the \"Remember me\" checkbox",
// "Show user avatar" => "Show user avatar",
// "Show the user avatar when in popup mode" => "Show the user avatar when in popup mode",
// "Show user name" => "Show user name",
// "Show the user name when in popup mode" => "Show the user name when in popup mode",
// "Groups for switch user listing" => "Groups for switch user listing",
// "If this parameter is empty, all users are offered in the Switch user drop-down. If this parameter is set to a list of user groups, a user is only offered if it is member of at least one of these. A set of groups is specified with their identifiers (integers) separated by pipe characters (\"|\")" => "If this parameter is empty, all users are offered in the Switch user drop-down. If this parameter is set to a list of user groups, a user is only offered if it is member of at least one of these. A set of groups is specified with their identifiers (integers) separated by pipe characters (\"|\")",
// "Menu ID" => "Menu ID",
// "Menu to use as the dropdown in \"popup\" mode. Defaults to a built in menu with only \"My Account\" and \"Logout\"" => "Menu to use as the dropdown in \"popup\" mode. Defaults to a built in menu with only \"My Account\" and \"Logout\"",
// "Logo" => "Logo",
// "Site logo, title and subtitle" => "Site logo, title and subtitle",
// "Image URL" => "Image URL",
// "Image to use. Defaults to sitelogo_src preference" => "Image to use. Defaults to sitelogo_src preference",
// "CSS colour to use as background. Defaults to sitelogo_bgcolor preference" => "CSS colour to use as background. Defaults to sitelogo_bgcolor preference",
// "Image title attribute. Defaults to sitelogo_title preference" => "Image title attribute. Defaults to sitelogo_title preference",
// "Alt" => "Alt",
// "Image alt attribute. Defaults to sitelogo_alt preference" => "Image alt attribute. Defaults to sitelogo_alt preference",
// "URL for the image and titles link. Defaults to \"./\"" => "URL for the image and titles link. Defaults to \"./\"",
// "Logo Title" => "Logo Title",
// "Large text to go next to image. Defaults to sitetitle preference" => "Large text to go next to image. Defaults to sitetitle preference",
// "Logo Subtitle" => "Logo Subtitle",
// "Smaller text to go under the Logo Title. Defaults to sitesubtitle preference" => "Smaller text to go under the Logo Title. Defaults to sitesubtitle preference",
// "Logo Class" => "Logo Class",
// "CSS class for the image container div. Defaults to sitelogo" => "CSS class for the image container div. Defaults to sitelogo",
// "Title Class" => "Title Class",
// "CSS class title text container div. Defaults to sitetitles" => "CSS class title text container div. Defaults to sitetitles",
// "Map Feature Editor" => "Map Feature Editor",
// "Allows shapes to be drawn over the map" => "Allows shapes to be drawn over the map",
// "Tracker to store the feature in" => "Tracker to store the feature in",
// "Hidden Input" => "Hidden Input",
// "Hidden values to be sent over to the dialog. fieldName(value)" => "Hidden values to be sent over to the dialog. fieldName(value)",
// "Standard controls" => "Standard controls",
// "Dispay the standard draw controls" => "Dispay the standard draw controls",
// "Mode change on insert" => "Mode change on insert",
// "Target mode to enter after successfully inserting an item" => "Target mode to enter after successfully inserting an item",
// "Edit details" => "Edit details",
// "Edit the tracker item's details through a dialog after the initial item creation" => "Edit the tracker item's details through a dialog after the initial item creation",
// "Layer Selector" => "Layer Selector",
// "Include base layer" => "Include base layer",
// "Include the drop list for the base layers" => "Include the drop list for the base layers",
// "Include optional layers" => "Include optional layers",
// "Include the checkboxes for the optional layers" => "Include the checkboxes for the optional layers",
// "Replace the map's built-in layer controls" => "Replace the map's built-in layer controls",
// "Mode Selector" => "Mode Selector",
// "Toggle input modes for the map" => "Toggle input modes for the map",
// "Map location search" => "Map location search",
// "Simple search controls for the map" => "Simple search controls for the map",
"Menu" => "選單",
// "Displays a menu or a structure as a menu" => "Displays a menu or a structure as a menu",
// "Identifier of a menu (from tiki-admin_menus.php)" => "Identifier of a menu (from tiki-admin_menus.php)",
"Structure" => "結構",
// "Identifier of a structure of wiki pages (name or number from tiki-admin_structures.php)" => "Identifier of a structure of wiki pages (name or number from tiki-admin_structures.php)",
// "Direction for menu: horiz or vert (default vert)" => "Direction for menu: horiz or vert (default vert)",
// "CSS/Superfish" => "CSS/Superfish",
// "Use CSS Superfish menu (if bootstrap = n). y|n (default y)" => "Use CSS Superfish menu (if bootstrap = n). y|n (default y)",
// "Use Bootstrap menus" => "Use Bootstrap menus",
// "Show Navbar Toggle Button" => "Show Navbar Toggle Button",
// "Used in Bootstrap navbar menus when viewport is too narrow for menu items" => "Used in Bootstrap navbar menus when viewport is too narrow for menu items",
// "The URL of the navbar brand (logo)" => "The URL of the navbar brand (logo)",
// "Used in Bootstrap navbar menus, if there is a Brand logo to be attached to the menu" => "Used in Bootstrap navbar menus, if there is a Brand logo to be attached to the menu",
// "CSS class(es) for the menu nav element" => "CSS class(es) for the menu nav element",
// "Default specified is for Bootstrap menus. Replace \"navbar-light bg-light\" with \"navbar-dark bg-dark\" for a dark navbar" => "Default specified is for Bootstrap menus. Replace \"navbar-light bg-light\" with \"navbar-dark bg-dark\" for a dark navbar",
// "DOM #id" => "DOM #id",
// "Id of the menu in the DOM" => "Id of the menu in the DOM",
// "CSS class" => "CSS class",
// "Class of the menu container" => "Class of the menu container",
// "Limit low visibles levels" => "Limit low visibles levels",
// "All the submenus beginning at this level will be displayed if the url matches one of the option of this level or above or below" => "All the submenus beginning at this level will be displayed if the url matches one of the option of this level or above or below",
// "Limit top visible levels" => "Limit top visible levels",
// "Do not display options higher than this level" => "Do not display options higher than this level",
// "Link on Section" => "Link on Section",
// "Create links on menu sections" => "Create links on menu sections",
// "(y/n default y)" => "(y/n default y)",
// "Translate labels" => "Translate labels",
// "Menu Cookie" => "Menu Cookie",
// "Open the menu to show current option if possible" => "Open the menu to show current option if possible",
// "Set Selected" => "Set Selected",
// "Process all menu items to show currently selected item and other dynamic states. Useful when disabled on very large menus where performance becomes an issue" => "Process all menu items to show currently selected item and other dynamic states. Useful when disabled on very large menus where performance becomes an issue",
// "One of these parameters has to be set" => "One of these parameters has to be set",
// "Menu Page" => "Menu Page",
// "Displays a Wiki page" => "Displays a Wiki page",
// "Page to display in the menu. Example value: HomePage" => "Page to display in the menu. Example value: HomePage",
// "Use default namespace" => "Use default namespace",
// "Prepend the default namespace to the page name for localized menus per workspace (1/0)" => "Prepend the default namespace to the page name for localized menus per workspace (1/0)",
// "Menu style" => "Menu style",
// "Display the page as a menu (horiz / vert)" => "Display the page as a menu (horiz / vert)",
// "Wiki Structure Menu" => "Wiki Structure Menu",
// "Displays a structure" => "Displays a structure",
// "N.B. Deprecated, use the Menu module instead" => "N.B. Deprecated, use the Menu module instead",
// "Structure to display in the menu" => "Structure to display in the menu",
// "Unread Inter-User Messages" => "Unread Inter-User Messages",
// "Displays to users their number of new inter-user messages and a link to their message box" => "Displays to users their number of new inter-user messages and a link to their message box",
// "Show If Empty" => "Show If Empty",
// "Show the module when there are no messages waiting. y|n " => "Show the module when there are no messages waiting. y|n ",
// "Default=y" => "Default=y",
"Messages" => "訊息",
// "Small live chat box" => "Small live chat box",
// "Channels" => "Channels",
// "List of chat channels. Channel names are separated by a comma (\",\")" => "List of chat channels. Channel names are separated by a comma (\",\")",
// "By default, a single channel named \"default\" exists" => "By default, a single channel named \"default\" exists",
// "Mobile" => "Mobile",
// "Currently only shows switch to and from mobile mode" => "Currently only shows switch to and from mobile mode",
// "To Label" => "To Label",
// "Switch to normal site label" => "Switch to normal site label",
// "From Label" => "From Label",
// "Switch to mobile site label" => "Switch to mobile site label",
// "Switch Perspective" => "Switch Perspective",
// "Also switch perspective back to this one when leaving mobile mode" => "Also switch perspective back to this one when leaving mobile mode",
// "Stay" => "Stay",
// "Stay on same page" => "Stay on same page",
// "Switch to mobile site" => "Switch to mobile site",
// "Switch to normal site" => "Switch to normal site",
// "Months Links" => "Months Links",
// "Link to articles or blog posts for the current month and those preceding it" => "Link to articles or blog posts for the current month and those preceding it",
// "Type of objects to link to" => "Type of objects to link to",
// "Possible values" => "Possible values",
// "\"blogs\" for blog posts, \"cms\" for published articles" => "\"blogs\" for blog posts, \"cms\" for published articles",
// "Object Identifier" => "Object Identifier",
// "Identifier of an object with children to link to" => "Identifier of an object with children to link to",
// "This is required for the blog Object type" => "This is required for the blog Object type",
// "For example, an identifier of 3 and a blogs Object type will show links to the blog posts in the blog with identifier 3" => "For example, an identifier of 3 and a blogs Object type will show links to the blog posts in the blog with identifier 3",
// "List by month" => "List by month",
// "Most Commented" => "Most Commented",
// "Display the most commented objects of a certain type" => "Display the most commented objects of a certain type",
// "Type of objects to consider" => "Type of objects to consider",
// "Possible values: wiki (Wiki pages), blog (blog posts), article (articles)" => "Possible values: wiki (Wiki pages), blog (blog posts), article (articles)",
// "Language Filter" => "Language Filter",
// "If set to a RFC1766 language tag, restricts the objects considered to those in the specified language" => "If set to a RFC1766 language tag, restricts the objects considered to those in the specified language",
// "Request the creation of a mustread item based on the current object" => "Request the creation of a mustread item based on the current object",
// "Object Field" => "Object Field",
// "Permanent name of the field containing the object reference" => "Permanent name of the field containing the object reference",
// "Notifications Link" => "Notifications Link",
// "Shows an icon with the number of and a link to user notifications" => "Shows an icon with the number of and a link to user notifications",
"Pending Article Submissions" => "等待送交文章",
// "Displays the number of article submissions waiting examination and a link to the list" => "Displays the number of article submissions waiting examination and a link to the list",
"Old Articles" => "舊文章",
// "Displays the specified number of old articles (which do not show on articles home page anymore)" => "Displays the specified number of old articles (which do not show on articles home page anymore)",
// "Package Module" => "Package Module",
// "A module that shows content from a Tiki Package View" => "A module that shows content from a Tiki Package View",
// "Name of package (vendor/name)" => "Name of package (vendor/name)",
// "Name of package in the form vendor/name" => "Name of package in the form vendor/name",
// "Name of the view file without the .php" => "Name of the view file without the .php",
// "Other parameters" => "Other parameters",
// "URL encoded string of other parameters (will not replace standard parameters)" => "URL encoded string of other parameters (will not replace standard parameters)",
// "Payments Outstanding" => "Payments Outstanding",
// "Displays the payments outstanding for the current user" => "Displays the payments outstanding for the current user",
// "List of active permissions for current object" => "List of active permissions for current object",
// "Enables to change current perspective" => "Enables to change current perspective",
// "Powered By" => "Powered By",
// "Powered by Tiki, and others" => "Powered by Tiki, and others",
// "Shows \"Powered by Tiki Wiki CMS Groupware\" message" => "Shows \"Powered by Tiki Wiki CMS Groupware\" message",
// "Tiki version info" => "Tiki version info",
// "Shows theme credits (contents of credits.tpl)" => "Shows theme credits (contents of credits.tpl)",
// "Shows various \"powered by\" icons" => "Shows various \"powered by\" icons",
// "Quick Edit" => "Quick Edit",
// "Enables to quickly create or edit Wiki pages" => "Enables to quickly create or edit Wiki pages",
// "Deprecated - use the Search module instead" => "Deprecated - use the Search module instead",
// "Template identifier" => "Template identifier",
// "If set to a template identifier, the specified template is used for creating new Wiki pages" => "If set to a template identifier, the specified template is used for creating new Wiki pages",
// "If set, send the form to the given location (relative to Tiki's root) for processing" => "If set, send the form to the given location (relative to Tiki's root) for processing",
// "SUBMIT label" => "SUBMIT label",
// "The label on the button to submit the form" => "The label on the button to submit the form",
"Create/Edit" => "建立/編輯",
// "INPUT SIZE" => "INPUT SIZE",
// "Size attribute (horizontal, in characters) of the text input field for page names" => "Size attribute (horizontal, in characters) of the text input field for page names",
// "Optional heading to display at the top of the module's content" => "Optional heading to display at the top of the module's content",
// "Category to preselect" => "Category to preselect",
// "If set, pages created through the module have this category prechecked to be categorized in" => "If set, pages created through the module have this category prechecked to be categorized in",
// "Tip to be shown" => "Tip to be shown",
// "Custom text to be shown as a tip at the top of the edit page" => "Custom text to be shown as a tip at the top of the edit page",
// "Title of tip to be shown" => "Title of tip to be shown",
// "Custom title to be shown for the tip at the top of the edit page" => "Custom title to be shown for the tip at the top of the edit page",
// "Custom header template" => "Custom header template",
// "Wiki page to be used as a template to show content on top of edit page" => "Wiki page to be used as a template to show content on top of edit page",
"Quick Edit a Wiki Page" => "快速編輯 Wiki 頁面",
// "Quick Search" => "Quick Search",
// "Performs a search query and persists the results in the module for quick navigation access" => "Performs a search query and persists the results in the module for quick navigation access",
// "Filter object type" => "Filter object type",
// "Limit search results to a specific object type. Enter an object type to use a static filter or write \"selector\" to provide an input" => "Limit search results to a specific object type. Enter an object type to use a static filter or write \"selector\" to provide an input",
// "Filter category" => "Filter category",
// "Limit search results to a specific category. Enter the comma-separated list of category IDs to include in the selector. Single category will display no controls" => "Limit search results to a specific category. Enter the comma-separated list of category IDs to include in the selector. Single category will display no controls",
// "Quick Administration" => "Quick Administration",
// "Some helpful tools for administrators" => "Some helpful tools for administrators",
"Random Image" => "隨機影像",
// "Displays a random image" => "Displays a random image",
// "If set to an image gallery identifier, restricts the chosen images to those in the identified gallery" => "If set to an image gallery identifier, restricts the chosen images to those in the identified gallery",
// "Show link" => "Show link",
// "If set to \"n\", the image thumbnail does not link to the image" => "If set to \"n\", the image thumbnail does not link to the image",
// "Default: \"y\"" => "Default: \"y\"",
// "Show name" => "Show name",
// "If set to \"y\", the name of the image is displayed" => "If set to \"y\", the name of the image is displayed",
// "If set to \"y\", the description of the image is displayed" => "If set to \"y\", the description of the image is displayed",
"Random Pages" => "隨機頁面",
// "Displays the specified number of random wiki pages" => "Displays the specified number of random wiki pages",
// "New User Registration" => "New User Registration",
// "Permit anonymous visitors to create an account on the site" => "Permit anonymous visitors to create an account on the site",
// "News Feeds" => "News Feeds",
// "List of feeds available on this site" => "List of feeds available on this site",
// "Multi-purpose search module (go or edit page by name and/or search site)" => "Multi-purpose search module (go or edit page by name and/or search site)",
// "Legacy Mode" => "Legacy Mode",
// "Setting to emulate previous behaviour" => "Setting to emulate previous behaviour",
// "If set to \"y\" the search performed is a \"Tiki search\"" => "If set to \"y\" the search performed is a \"Tiki search\"",
// " (full text search)" => " (full text search)",
// "Show Object Type Filter" => "Show Object Type Filter",
// "If set to \"y\" shows a dropdown of sections to search" => "If set to \"y\" shows a dropdown of sections to search",
// " (no object filter)" => " (no object filter)",
// "Use autocomplete" => "Use autocomplete",
// "If set to \"y\" input uses autocomplete for pagenames if applicable" => "If set to \"y\" input uses autocomplete for pagenames if applicable",
// " (use autocomplete)" => " (use autocomplete)",
// "Advanced search" => "Advanced search",
// "Use advanced (boolean) search (full text search only)" => "Use advanced (boolean) search (full text search only)",
// " (use advanced search)" => " (use advanced search)",
// "Advanced search checkbox" => "Advanced search checkbox",
// "Show advanced search checkbox (full text search only)" => "Show advanced search checkbox (full text search only)",
// " (advanced search checkbox off)" => " (advanced search checkbox off)",
// "Advanced search help" => "Advanced search help",
// "Show advanced search help icon (full text search only)" => "Show advanced search help icon (full text search only)",
// " (advanced search help off)" => " (advanced search help off)",
// "Show Search Button" => "Show Search Button",
// "Show search button" => "Show search button",
// " (do show search button)" => " (do show search button)",
// "Show Go Button" => "Show Go Button",
// "Show go to page button" => "Show go to page button",
// " (do show go button)" => " (do show go button)",
// "Show Edit Button" => "Show Edit Button",
// "Show edit button" => "Show edit button",
// " (do show edit button)" => " (do show edit button)",
// "Default Button" => "Default Button",
// "Action to perform on entering <return>" => "Action to perform on entering <return>",
// " (search|go|edit)" => " (search|go|edit)",
// "Search Form Action" => "Search Form Action",
// " tiki-searchresults.php or tiki-searchindex.php (for Tiki search)" => " tiki-searchresults.php or tiki-searchindex.php (for Tiki search)",
// "Search Submit Label" => "Search Submit Label",
// "Go Form Action" => "Go Form Action",
// "Go Submit Label" => "Go Submit Label",
"Go" => "衝",
// "Edit Form Action" => "Edit Form Action",
// "Edit Submit Label" => "Edit Submit Label",
// "Input field width" => "Input field width",
// "Width of the text input field (in characters)" => "Width of the text input field (in characters)",
// " 0 (leave automatic width)" => " 0 (leave automatic width)",
// "Select size" => "Select size",
// "Size of the Search Filter dropdown list" => "Size of the Search Filter dropdown list",
// "Edit Template identifier" => "Edit Template identifier",
// "If set to a category identifier, pages created through the module are automatically categorized in the specified category" => "If set to a category identifier, pages created through the module are automatically categorized in the specified category",
// "Compact mode" => "Compact mode",
// "Makes the three buttons only appear on mouse-over" => "Makes the three buttons only appear on mouse-over",
// "Additional filters" => "Additional filters",
// "Filters to be applied to the search results, as a URL-encoded string. Ex.: catgories=1+AND+2&prefix~title=Test" => "Filters to be applied to the search results, as a URL-encoded string. Ex.: catgories=1+AND+2&prefix~title=Test",
// "Search is disabled" => "Search is disabled",
// "Search for Wiki Page" => "Search for Wiki Page",
// "More Like This" => "More Like This",
// "Uses the unified search to provide similar documents" => "Uses the unified search to provide similar documents",
// "Object Type Filters" => "Object Type Filters",
// "Comma-separated types to allow" => "Comma-separated types to allow",
// "Text Search Filters" => "Text Search Filters",
// "Comma-separated text search filters to use. Use \"=\" to separate field and value" => "Comma-separated text search filters to use. Use \"=\" to separate field and value",
// "Object id of item you want to get similar items to" => "Object id of item you want to get similar items to",
// "The object id of the item. If none is provided, Tiki will attempt to resolve the current object" => "The object id of the item. If none is provided, Tiki will attempt to resolve the current object",
// "Object type of item you want to get similar items to" => "Object type of item you want to get similar items to",
// "The object type of the item (eg. \"trackeritem\"). If none is provided, Tiki will attempt to resolve the current object" => "The object type of the item (eg. \"trackeritem\"). If none is provided, Tiki will attempt to resolve the current object",
// "Search For a Wiki Page" => "Search For a Wiki Page",
// "Search for a wiki page by name" => "Search for a wiki page by name",
// "Exact match checkbox checked by default if set to \"y\"" => "Exact match checkbox checked by default if set to \"y\"",
// "Semantic Links" => "Semantic Links",
// "List the relationships known for the Wiki page displayed. For each relation type contained in the page, it lists all the pages it links to or gets linked from" => "List the relationships known for the Wiki page displayed. For each relation type contained in the page, it lists all the pages it links to or gets linked from",
// "Links for sharing, reporting etc" => "Links for sharing, reporting etc",
// "Report" => "Report",
// "Report to Webmaster" => "Report to Webmaster",
// "Share this page" => "Share this page",
// "Use icons for report, share and email links" => "Use icons for report, share and email links",
// "Show Facebook \"Like\" button on the current page" => "Show Facebook \"Like\" button on the current page",
// "Facebook: URL" => "Facebook: URL",
// "URL to \"Like\" (leave blank for current URL)" => "URL to \"Like\" (leave blank for current URL)",
// "Facebook: Send" => "Facebook: Send",
// "Show Facebook \"Send\" button" => "Show Facebook \"Send\" button",
// "Facebook: Layout" => "Facebook: Layout",
// "Size, layout and amount of social context" => "Size, layout and amount of social context",
// "Facebook: Width" => "Facebook: Width",
// "Facebook: Height" => "Facebook: Height",
// "Container height in CSS units (e.g. \"120px\" or \"2em\")" => "Container height in CSS units (e.g. \"120px\" or \"2em\")",
// "Facebook: Show Faces" => "Facebook: Show Faces",
// "Show pictures of others who like this" => "Show pictures of others who like this",
// "Facebook: Verb" => "Facebook: Verb",
// "Verb to display in button" => "Verb to display in button",
// "Facebook: Colors" => "Facebook: Colors",
// "Color scheme" => "Color scheme",
// "Facebook: Font" => "Facebook: Font",
// "Font to display" => "Font to display",
// "Facebook: Locale" => "Facebook: Locale",
// "Locale in the format ll_CC (default \"en_US\")" => "Locale in the format ll_CC (default \"en_US\")",
// "Facebook: Referrals" => "Facebook: Referrals",
// "Label for tracking referrals (optional)" => "Label for tracking referrals (optional)",
// "Facebook: App Id" => "Facebook: App Id",
// "ID of your Facebook app (optional)" => "ID of your Facebook app (optional)",
// "Show Twitter Follow Button on the current page" => "Show Twitter Follow Button on the current page",
// "Twitter: User Name" => "Twitter: User Name",
// "Twitter user name to quote as \"via\"" => "Twitter user name to quote as \"via\"",
// "Twitter: Label" => "Twitter: Label",
// "Text to display. Default \"Tweet\"" => "Text to display. Default \"Tweet\"",
// "Twitter: URL" => "Twitter: URL",
// "URL to \"Tweet\" (leave blank for current URL)" => "URL to \"Tweet\" (leave blank for current URL)",
// "Twitter: Show Count" => "Twitter: Show Count",
// "Position of Tweet count" => "Position of Tweet count",
// "Twitter: Language" => "Twitter: Language",
// "Two letter language code" => "Two letter language code",
// "Twitter: Width" => "Twitter: Width",
// "Width in pixels or percentage (e.g. 300px)" => "Width in pixels or percentage (e.g. 300px)",
// "Twitter: Height" => "Twitter: Height",
// "Twitter: Text" => "Twitter: Text",
// "Tweet text (leave empty to use page title" => "Tweet text (leave empty to use page title",
// "LinkedIn" => "LinkedIn",
// "Linked in share button" => "Linked in share button",
// "LinkedIn: URL" => "LinkedIn: URL",
// "URL to share (leave blank for current URL)" => "URL to share (leave blank for current URL)",
// "LinkedIn: Count Mode" => "LinkedIn: Count Mode",
// "Position of count" => "Position of count",
// "Google +1" => "Google +1",
// "Google +1 button" => "Google +1 button",
// "Google: Size" => "Google: Size",
// "Google button size" => "Google button size",
// "Google: Annotation" => "Google: Annotation",
// "Google annotation" => "Google annotation",
// "Google: Language" => "Google: Language",
// "Google language" => "Google language",
// "Google: URL" => "Google: URL",
// "Creates or shows a short url for the visiting page" => "Creates or shows a short url for the visiting page",
// "The shoutbox is a quick messaging tool. Messages reload each time the page changes. Anyone with the right permission can see all messages. Another permission allows messages to be sent." => "The shoutbox is a quick messaging tool. Messages reload each time the page changes. Anyone with the right permission can see all messages. Another permission allows messages to be sent.",
// "If set to \"1\", displays message post dates and times as tooltips instead of showing directly in the module content" => "If set to \"1\", displays message post dates and times as tooltips instead of showing directly in the module content",
// "Label on the button to post a message" => "Label on the button to post a message",
// "Wait label" => "Wait label",
// "Label on the button to post a message when the message is being posted if AJAX is enabled" => "Label on the button to post a message when the message is being posted if AJAX is enabled",
// "Please wait.." => "Please wait..",
// "Maximum messages shown" => "Maximum messages shown",
// "Number of messages to display" => "Number of messages to display",
// "Tweet" => "Tweet",
// "If set to \"1\" and the user has authorized us to tweet messages with Twitter, the user can decide, if he wants to shout via Twitter" => "If set to \"1\" and the user has authorized us to tweet messages with Twitter, the user can decide, if he wants to shout via Twitter",
// "If set to \"1\" and the user has authorized us with Facebook, the user can decide, if he wants to add the shout to his Facebook wall" => "If set to \"1\" and the user has authorized us with Facebook, the user can decide, if he wants to add the shout to his Facebook wall",
// "Since Last Visit (Simple)" => "Since Last Visit (Simple)",
// "Displays to logged-in users the number of new or updated objects since their last login date and time" => "Displays to logged-in users the number of new or updated objects since their last login date and time",
"Since your last visit" => "自從你上次拜訪",
// "Since Last Visit" => "Since Last Visit",
// "Displays to logged-in users new or updated objects since a point in time, by default their last login date and time" => "Displays to logged-in users new or updated objects since a point in time, by default their last login date and time",
// "Show users" => "Show users",
// "If set to \"n\", do not show new users" => "If set to \"n\", do not show new users",
// "If set to \"n\", do not show tracker changes" => "If set to \"n\", do not show tracker changes",
// "Calendar focus" => "Calendar focus",
// "Unless set to \"ignore\", the module changes the reference point in time from the user's last login date and time to a day where users browse to using the calendar" => "Unless set to \"ignore\", the module changes the reference point in time from the user's last login date and time to a day where users browse to using the calendar",
// "Show date as a calendar link" => "Show date as a calendar link",
// "If set to \"n\", do not add a link to tiki calendar on the date in the header (even if feature calendar is set)" => "If set to \"n\", do not add a link to tiki calendar on the date in the header (even if feature calendar is set)",
// "Fold sections by default" => "Fold sections by default",
// "If set to \"y\", fold automatically sections and show only the title (user has to click on each section in order to see the details of modifications)" => "If set to \"y\", fold automatically sections and show only the title (user has to click on each section in order to see the details of modifications)",
// "Use tabbed presentation" => "Use tabbed presentation",
// "If set to \"y\", use Bootstrap tabs to show the result" => "If set to \"y\", use Bootstrap tabs to show the result",
// "Minimum timespan" => "Minimum timespan",
// "Instead of the last login time, go back this minimum time, specified in days, in case the last login time is more recent" => "Instead of the last login time, go back this minimum time, specified in days, in case the last login time is more recent",
// "Maximum comment length" => "Maximum comment length",
// "Changes since" => "Changes since",
// "Since your last visit.." => "Since your last visit..",
// "In the last %0 days.." => "In the last %0 days..",
"new comments" => "新評論",
// " (archived)" => " (archived)",
// "new posts" => "new posts",
"wiki pages changed" => "wiki 頁面已變動",
// "new articles" => "new articles",
// "new FAQs" => "new FAQs",
// "new blogs" => "new blogs",
// "new blog posts" => "new blog posts",
// "new image galleries" => "new image galleries",
"new images" => "新影像",
// "new file galleries" => "new file galleries",
"new files" => "新檔案",
// "new polls" => "new polls",
"new users" => "新使用者",
// "new tracker items" => "new tracker items",
// "updated tracker items" => "updated tracker items",
// "new calendars" => "new calendars",
// "new events" => "new events",
// "starting on" => "starting on",
// "If comments don't use titles this sets the maximum length for the comment snippet" => "If comments don't use titles this sets the maximum length for the comment snippet",
// "SVN Up Info" => "SVN Up Info",
// "SVN Version and last update information" => "SVN Version and last update information",
// "Switch Language" => "Switch Language",
// "Displays a language picker to change the language of the site" => "Displays a language picker to change the language of the site",
// "Display mode" => "Display mode",
// "Changes how the list of languages is displayed. Possible values are droplist, flags and words. Defaults to droplist" => "Changes how the list of languages is displayed. Possible values are droplist, flags and words. Defaults to droplist",
// "Switch Admin Language" => "Switch Admin Language",
// "Displays a language picker to change the language of admin site" => "Displays a language picker to change the language of admin site",
// "Switch Theme" => "Switch Theme",
// "Enables to quickly change the theme for the user" => "Enables to quickly change the theme for the user",
// "Not allowed here" => "Not allowed here",
// "Displayed theme" => "Displayed theme",
// "Admin Theme" => "Admin Theme",
// "Terminology" => "Terminology",
// "Support for multilingual terminology" => "Support for multilingual terminology",
// "Root category" => "Root category",
// "All terms will automatically be put in that category. " => "All terms will automatically be put in that category. ",
// "Note that the category must already exist. " => "Note that the category must already exist. ",
// "Defaults to 'Term'" => "Defaults to 'Term'",
// "Tiki Tests" => "Tiki Tests",
// "Tiki test suite helper" => "Tiki test suite helper",
"Most Active blogs" => "最活躍 blogs",
// "Displays the specified number of blogs with links to them, from the most active one to the least" => "Displays the specified number of blogs with links to them, from the most active one to the least",
// "Blog activity measurement can be more or less accurate" => "Blog activity measurement can be more or less accurate",
// "Lists the specified number of articles with links to them, from the most visited one to the least" => "Lists the specified number of articles with links to them, from the most visited one to the least",
// "Top Blog Posters" => "Top Blog Posters",
// "Displays the specified number of users who posted to blogs, starting with the one having most posts" => "Displays the specified number of users who posted to blogs, starting with the one having most posts",
// "Limit to a blog" => "Limit to a blog",
"Top File Galleries" => "最熱門檔案庫",
// "Displays the specified number of file galleries with links to them, starting with the one with most hits" => "Displays the specified number of file galleries with links to them, starting with the one with most hits",
// "Top Files" => "Top Files",
// "Displays the specified number of files with links to them, starting with the one with most hits" => "Displays the specified number of files with links to them, starting with the one with most hits",
// "Top Forum Posters" => "Top Forum Posters",
// "Displays the specified number of users who posted to forums, starting with the one having most posts" => "Displays the specified number of users who posted to forums, starting with the one having most posts",
// "Top Image Galleries" => "Top Image Galleries",
// "Displays the specified number of image galleries with links to them, starting with the one with most hits" => "Displays the specified number of image galleries with links to them, starting with the one with most hits",
"Top Images" => "最熱門影像",
// "Displays the specified number of images with links to them, from the most visited one to the least" => "Displays the specified number of images with links to them, from the most visited one to the least",
// "Top Objects" => "Top Objects",
// "Displays the specified number of objects, starting with the one having the most hits" => "Displays the specified number of objects, starting with the one having the most hits",
"Top Pages" => "最熱門頁面",
// "Displays the specified number of wiki pages with links to them, starting with the one having the most hits" => "Displays the specified number of wiki pages with links to them, starting with the one having the most hits",
"Top Quizzes" => "最熱門測驗",
// "Displays the specified number of quizzes with links to them, starting with the one having the most hits" => "Displays the specified number of quizzes with links to them, starting with the one having the most hits",
"Top Visited Blogs" => "最常被瀏覽 blogs",
// "Display the specified number of blogs with links to them, from the most visited one to the least" => "Display the specified number of blogs with links to them, from the most visited one to the least",
// "Show Last Post" => "Show Last Post",
// "Top Visited FAQs" => "Top Visited FAQs",
// "Display the specified number of FAQs with links to them, from the most visited one to the least" => "Display the specified number of FAQs with links to them, from the most visited one to the least",
// "Tracker Input" => "Tracker Input",
// "Allows a dialog to be opened to create new tracker items" => "Allows a dialog to be opened to create new tracker items",
// "Tracker ID to render" => "Tracker ID to render",
// "Text Input" => "Text Input",
// "Multiple text fields to display as part of the main form along with the label. Field names map to the permanent names in the tracker field definitions. ex: groupName(Group Name) relatedTask(Task)" => "Multiple text fields to display as part of the main form along with the label. Field names map to the permanent names in the tracker field definitions. ex: groupName(Group Name) relatedTask(Task)",
// "Location Field" => "Location Field",
// "Obtain the coordinates from a nearby map and send them to the location field. In addition to the field name, :marker or :viewport can be used as the suffix. Default is :marker" => "Obtain the coordinates from a nearby map and send them to the location field. In addition to the field name, :marker or :viewport can be used as the suffix. Default is :marker",
// "Capture StreetView" => "Capture StreetView",
// "Include a button on the StreetView interface to create tracker items from the location. Requires upload image from URL and location parameter" => "Include a button on the StreetView interface to create tracker items from the location. Requires upload image from URL and location parameter",
// "Alter the submit button label" => "Alter the submit button label",
// "Operation to perform on success" => "Operation to perform on success",
// "Operation to perform in the following format: operationName(argument). Current operations are redirect with the URL template as the argument. @valueName@ will be replaced by the appropriate value where valueName is itemId, status or a permanent name" => "Operation to perform in the following format: operationName(argument). Current operations are redirect with the URL template as the argument. @valueName@ will be replaced by the appropriate value where valueName is itemId, status or a permanent name",
// "Mode change on complete" => "Mode change on complete",
// "Target mode to enter after dialog closes" => "Target mode to enter after dialog closes",
// "Tracker Help" => "Tracker Help",
// "Display the fields of a tracker (name and identifier)" => "Display the fields of a tracker (name and identifier)",
// "Text field height" => "Text field height",
// "Number of lines" => "Number of lines",
// "Text field width" => "Text field width",
// "Number of characters" => "Number of characters",
// "Translate Updates" => "Translate Updates",
// "Links to versions of the wiki page being viewed in other languages, distinguishing between better, equivalent or worse translations. Optionally displays the up-to-dateness of the translation being viewed" => "Links to versions of the wiki page being viewed in other languages, distinguishing between better, equivalent or worse translations. Optionally displays the up-to-dateness of the translation being viewed",
// "Reference language" => "Reference language",
// "If set to a language code, restricts the localized pages shown to the reference page, unless that page is being displayed" => "If set to a language code, restricts the localized pages shown to the reference page, unless that page is being displayed",
// "Show language" => "Show language",
// "If \"y\" the page language will be shown instead of the page name" => "If \"y\" the page language will be shown instead of the page name",
// "Default = \"y\"" => "Default = \"y\"",
// "Tweets" => "Tweets",
// "Shows the tweets from the Twitter timeline of a user" => "Shows the tweets from the Twitter timeline of a user",
// "Tiki user to show Twitter timeline of" => "Tiki user to show Twitter timeline of",
// "Show public|friends timeline. " => "Show public|friends timeline. ",
// "Search string" => "Search string",
// "user not registered with twitter" => "user not registered with twitter",
// "Lists the specified number of calendar events, ordered by their start date" => "Lists the specified number of calendar events, ordered by their start date",
// "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\")" => "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\")",
// "Maximum days in the future" => "Maximum days in the future",
// "Maximum distance to event start dates in days (looking forward)" => "Maximum distance to event start dates in days (looking forward)",
// "Maximum days in the past" => "Maximum days in the past",
// "Maximum distance to event end dates in days (looking backward)" => "Maximum distance to event end dates in days (looking backward)",
// "cellpadding" => "cellpadding",
// "If set to an integer, apply this cellpadding to the HTML table generated" => "If set to an integer, apply this cellpadding to the HTML table generated",
// "cellspacing" => "cellspacing",
// "If set to an integer, apply this cellspacing to the HTML table generated" => "If set to an integer, apply this cellspacing to the HTML table generated",
// "If set to \"y\", event descriptions are displayed" => "If set to \"y\", event descriptions are displayed",
// "Show end date and time" => "Show end date and time",
// "If set to \"y\", event end dates and times are displayed, when appropriate" => "If set to \"y\", event end dates and times are displayed, when appropriate",
// "Use custom calendar background colors" => "Use custom calendar background colors",
// "If set to \"y\", events are displayed with their calendar's custom background color (if one is set)" => "If set to \"y\", events are displayed with their calendar's custom background color (if one is set)",
// "Show information in tooltips" => "Show information in tooltips",
// "If set to \"n\", event tooltips will not display event information" => "If set to \"n\", event tooltips will not display event information",
// "Format to use for most dates. See <a href=\"http://www.php.net/manual/en/function.strftime.php\">strftime() documentation</a>" => "Format to use for most dates. See <a href=\"http://www.php.net/manual/en/function.strftime.php\">strftime() documentation</a>",
// "site preference for short date format followed by site preference for short time format" => "site preference for short date format followed by site preference for short time format",
// "If set to an integer, event names are allowed that number of characters as a maximum before being truncated" => "If set to an integer, event names are allowed that number of characters as a maximum before being truncated",
// "My Blogs" => "My Blogs",
// "Displays to registered users their blogs" => "Displays to registered users their blogs",
"My Bookmarks" => "使用者書籤",
// "Lightweight interface to user bookmarks, enabling to view them concisely, do some manipulations and bookmark the page being viewed" => "Lightweight interface to user bookmarks, enabling to view them concisely, do some manipulations and bookmark the page being viewed",
// "My Image Galleries" => "My Image Galleries",
// "Displays to registered users their image galleries" => "Displays to registered users their image galleries",
"User Pages" => "使用者頁面",
// "Displays to registered users the specified number of wiki pages which they were the last to edit" => "Displays to registered users the specified number of wiki pages which they were the last to edit",
"My Pages" => "我的頁面",
"My Tasks" => "使用者任務",
// "Lightweight interface to user tasks, enabling to view them concisely and do some manipulations" => "Lightweight interface to user tasks, enabling to view them concisely and do some manipulations",
// "The task title must have at least 3 characters" => "The task title must have at least 3 characters",
// "Public Tasks" => "Public Tasks",
// "Lists the public user tasks of a chosen group, with links to tasks" => "Lists the public user tasks of a chosen group, with links to tasks",
// "User-Group Tracker" => "User-Group Tracker",
// "User and Group tracker links" => "User and Group tracker links",
// "Users List" => "Users List",
// "Display a list of users with optional extra information from each" => "Display a list of users with optional extra information from each",
// "Login" => "Login",
// "Show the user name" => "Show the user name",
// "y|n" => "y|n",
// "Show the user real name" => "Show the user real name",
// "Last Login" => "Last Login",
// "Show the last login date" => "Show the last login date",
// "Show the direct and included groups a user belongs to" => "Show the direct and included groups a user belongs to",
// "Show the user profile picture" => "Show the user profile picture",
// "Show a link to the userPage" => "Show a link to the userPage",
// "Log" => "Log",
// "Show a link to the user logs(feature actionlog must be activated)" => "Show a link to the user logs(feature actionlog must be activated)",
// "Show only the users of the group" => "Show only the users of the group",
// "Groupname" => "Groupname",
// "Included Groups" => "Included Groups",
// "Show only the users of the group group and of a group including group" => "Show only the users of the group group and of a group including group",
// "initial" => "initial",
// "Show only the users whose name begins with the letter" => "Show only the users whose name begins with the letter",
// "a letter" => "a letter",
// "heading" => "heading",
// "Show the table heading" => "Show the table heading",
// "Sort users in ascending or descending order using these values: " => "Sort users in ascending or descending order using these values: ",
// "My Score" => "My Score",
// "Display the logged user's rank and score" => "Display the logged user's rank and score",
// "Most Active Users" => "Most Active Users",
// "Display the specified number of users and their score, starting from the one with the highest score" => "Display the specified number of users and their score, starting from the one with the highest score",
// "websearch" => "websearch",
// "Displays a simple form to perform a web search with choice on multiple search engines" => "Displays a simple form to perform a web search with choice on multiple search engines",
// "Related Items" => "Related Items",
// "Lists objects which share a category with the viewed object" => "Lists objects which share a category with the viewed object",
// "Online Users" => "Online Users",
// "Display information about users currently logged in" => "Display information about users currently logged in",
// "Display the number of users logged in, the list of users logged in, or both" => "Display the number of users logged in, the list of users logged in, or both",
// "Possible values: \"count\", \"list\" or \"both\". Default value: \"both\"" => "Possible values: \"count\", \"list\" or \"both\". Default value: \"both\"",
// "Cluster Mode" => "Cluster Mode",
// "If set to \"1\", separate users based on which host/server they logged on" => "If set to \"1\", separate users based on which host/server they logged on",
// "Silent Mode" => "Silent Mode",
// "If set to \"1\" hides the module, which allows another \"who is there\" module to include users that should not see it" => "If set to \"1\" hides the module, which allows another \"who is there\" module to include users that should not see it",
// "Newest Comments" => "Newest Comments",
// "Lists the specified number of comments starting from the most recently posted" => "Lists the specified number of comments starting from the most recently posted",
// "More in tooltips" => "More in tooltips",
// "If set to \"y\", the name of the object on which a comment is made is not displayed in the module box, but instead moved in the item's tooltip" => "If set to \"y\", the name of the object on which a comment is made is not displayed in the module box, but instead moved in the item's tooltip",
// "Type of the objects from which comments will be listed. Possible values" => "Type of the objects from which comments will be listed. Possible values",
// "Display user profile pictures instead of numbers" => "Display user profile pictures instead of numbers",
// "Comments about objects in this language only" => "Comments about objects in this language only",
// "Last article comments" => "Last article comments",
// "Last wiki comments" => "Last wiki comments",
// "Hold a chat session using XMPP (uses the ConverseJS client)" => "Hold a chat session using XMPP (uses the ConverseJS client)",
// "XMPP" => "XMPP",
// "Displays YouTube videos and/or a link to a YouTube user's page" => "Displays YouTube videos and/or a link to a YouTube user's page",
// "Video identifiers" => "Video identifiers",
// "List of YouTube videos identifiers to display. Identifiers are separated by a comma (\",\")" => "List of YouTube videos identifiers to display. Identifiers are separated by a comma (\",\")",
// "YouTube user identifier" => "YouTube user identifier",
// "If set to a YouTube user identifier, display a link to the videos of this user" => "If set to a YouTube user identifier, display a link to the videos of this user",
// "Videos on YouTube" => "Videos on YouTube",
// "Module Zone" => "Module Zone",
// "Can contain other modules so can be used as a Bootstrap navbar object, for example" => "Can contain other modules so can be used as a Bootstrap navbar object, for example",
// "Must be unique; the zone becomes an \"extra module zone\" and will appear in the admin modules panel" => "Must be unique; the zone becomes an \"extra module zone\" and will appear in the admin modules panel",
// "Example for a Bootstrap \"social\" navbar" => "Example for a Bootstrap \"social\" navbar",
// "Bibliography Search" => "Bibliography Search",
// "Search the group's Zotero library for entries with the specified tags" => "Search the group's Zotero library for entries with the specified tags",
// "failure" => "failure",
// "You do not have sufficient permissions to perform this action" => "You do not have sufficient permissions to perform this action",
// "Please enter Biblio Code" => "Please enter Biblio Code",
// "Biblio code must not exceed 50 characters" => "Biblio code must not exceed 50 characters",
// "success" => "success",
// "Page not found. Please save the page first" => "Page not found. Please save the page first",
// "This reference already exists in the library" => "This reference already exists in the library",
// "Reference added to library" => "Reference added to library",
// "This biblio code already exists" => "This biblio code already exists",
// "Bibliography saved" => "Bibliography saved",
// "Reference already exists" => "Reference already exists",
// "Reference added" => "Reference added",
// "Invalid server key" => "Invalid server key",
"Invalid username or password" => "使用者名稱或密碼錯誤",
// "Cookie not found" => "Cookie not found",
// "This user is your friend" => "This user is your friend",
// "You share the following groups with this user" => "You share the following groups with this user",
// "Unlike" => "Unlike",
// "There is no activity to display in this stream" => "There is no activity to display in this stream",
// "%0 %1" => "%0 %1",
// "%0 posted a comment to" => "%0 posted a comment to",
// "%0 started a new discussion" => "%0 started a new discussion",
// "Join the discussion" => "Join the discussion",
// "%0 replied to a thread" => "%0 replied to a thread",
// "%0 corrected a message" => "%0 corrected a message",
// "%0 requested an action from you" => "%0 requested an action from you",
// "%0 triggered your %1 priority saved filter" => "%0 triggered your %1 priority saved filter",
// "Critical Priority" => "Critical Priority",
// "See your saved filter" => "See your saved filter",
// "High Priority" => "High Priority",
// "Low Priority" => "Low Priority",
// "Recommended Reading" => "Recommended Reading",
// "Based on your previous activity, we believe you might find this useful" => "Based on your previous activity, we believe you might find this useful",
// "Was this useful" => "Was this useful",
// "Help us improve" => "Help us improve",
// "%0 created a tracker" => "%0 created a tracker",
// "%0 created a tracker item" => "%0 created a tracker item",
// "%0 modified a tracker item" => "%0 modified a tracker item",
// "%0 has added %1 to his stream" => "%0 has added %1 to his stream",
// "%0 is now followed by %1" => "%0 is now followed by %1",
// "%0 and %1 became friends" => "%0 and %1 became friends",
// "%0 created a page" => "%0 created a page",
// "%0 modified a page" => "%0 modified a page",
// "View changes" => "View changes",
// "history" => "history",
// "Show More" => "Show More",
// "Saving.." => "Saving..",
// "Adding.." => "Adding..",
// "References Available" => "References Available",
// "Add to library" => "Add to library",
// "Library References" => "Library References",
"Use" => "使用",
// "Edit Library References" => "Edit Library References",
// "Part" => "Part",
// "URI" => "URI",
// "Publisher" => "Publisher",
// "Enter the CSS class name to be added in the 'li' tag for listing this reference" => "Enter the CSS class name to be added in the 'li' tag for listing this reference",
// "Enter template format in which you want to display the reference details in the bibliography listing. For example" => "Enter template format in which you want to display the reference details in the bibliography listing. For example",
// "All the codes must be in lower case letters separated with spaces" => "All the codes must be in lower case letters separated with spaces",
// "Please save the page before creating the bibliography" => "Please save the page before creating the bibliography",
// "Preference Filters" => "Preference Filters",
// "basic" => "basic",
// "Set as my default" => "Set as my default",
// "Provide Feedback" => "Provide Feedback",
// "Once selected, some icon/s will be shown next to all features so that you can provide some on-site feedback about them" => "Once selected, some icon/s will be shown next to all features so that you can provide some on-site feedback about them",
// "Icon for 'Like'" => "Icon for 'Like'",
// "Icon for 'Fix me'" => "Icon for 'Fix me'",
// "Icon for 'What is this for?'" => "Icon for 'What is this for?'",
// "Your votes will be sent when you connect with mother.tiki.org (currently only by clicking the 'Connect > <strong>Send Info</strong>' button)" => "Your votes will be sent when you connect with mother.tiki.org (currently only by clicking the 'Connect > <strong>Send Info</strong>' button)",
// "Click to read more" => "Click to read more",
// "Rebuild Admin Index" => "Rebuild Admin Index",
// "Control Panels" => "Control Panels",
// "Search preferences" => "Search preferences",
// "Configuration search" => "Configuration search",
// "Note: The search index needs rebuilding, this will take a few minutes" => "Note: The search index needs rebuilding, this will take a few minutes",
// "Preference Search Results" => "Preference Search Results",
// "Apply Changes" => "Apply Changes",
// "Apply" => "Apply",
// "No results" => "No results",
// "No preferences were found for your search query" => "No preferences were found for your search query",
// "Not what you expected? Try %0rebuilding%1 the preferences search index" => "Not what you expected? Try %0rebuilding%1 the preferences search index",
// "Access" => "Access",
"Users" => "使用者",
// "Banning" => "Banning",
// "Directories" => "Directories",
// "External Feeds" => "External Feeds",
"HTML Pages" => "HTML 頁面",
// "Wiki Structures" => "Wiki Structures",
// "System" => "System",
// "Activity Rules" => "Activity Rules",
// "Content Templates" => "Content Templates",
// "Languages" => "Languages",
"Mail Notifications" => "郵件通知",
"Menus" => "選單",
// "User Credits" => "User Credits",
// "Transitions" => "Transitions",
// "Plugin Approval" => "Plugin Approval",
// "Mods" => "Mods",
// "Tools" => "Tools",
// "Action Log" => "Action Log",
"Cookies" => "Cookies",
// "DSN/Content Authentication" => "DSN/Content Authentication",
// "Edit TPL" => "Edit TPL",
// "External Pages Cache" => "External Pages Cache",
// "External Wikis" => "External Wikis",
// "Importer" => "Importer",
// "PhpInfo" => "PhpInfo",
// "Referer Statistics" => "Referer Statistics",
// "Search Statistics" => "Search Statistics",
// "Security Admin" => "Security Admin",
// "Server Check" => "Server Check",
// "Synchronize Dev" => "Synchronize Dev",
// "System Cache" => "System Cache",
// "System Logs" => "System Logs",
// "Sitemap" => "Sitemap",
// "Wizards" => "Wizards",
"Cancel Edit" => "取消編輯",
// "Banners listing" => "Banners listing",
// "Activate the feature" => "Activate the feature",
// "Site ads and banners" => "Site ads and banners",
// "Apply changes" => "Apply changes",
// "Look under \"<a href=\"tiki-admin_rssmodules.php\" target=\"_blank\" class=\"alert-link\">External Feeds</a>\" on the application menu if you are searching for the <a href=\"https://doc.tiki.org/Article+generator\" target=\"_blank\" class=\"alert-link\">\"Article Generator\" on RSS feeds</a>" => "Look under \"<a href=\"tiki-admin_rssmodules.php\" target=\"_blank\" class=\"alert-link\">External Feeds</a>\" on the application menu if you are searching for the <a href=\"https://doc.tiki.org/Article+generator\" target=\"_blank\" class=\"alert-link\">\"Article Generator\" on RSS feeds</a>",
// "List of articles" => "List of articles",
// "List of article types" => "List of article types",
// "Article Types" => "Article Types",
// "List of article topics" => "List of article topics",
"General Settings" => "一般設定",
"Features" => "功能",
// "Custom (Article Own) images setting" => "Custom (Article Own) images setting",
// "Sharing on social networks" => "Sharing on social networks",
"Import CSV file" => "匯入 CSV 檔案",
"Batch upload (CSV file)" => "批次上傳 (CSV 檔案)",
// "File format: title,authorName,heading,body,lang,user" => "File format: title,authorName,heading,body,lang,user",
// "Articles Listing and View" => "Articles Listing and View",
"List articles" => "列出文章",
// "Article view" => "Article view",
// "Blogs listing" => "Blogs listing",
// "Blogs Listings" => "Blogs Listings",
// "Items to display" => "Items to display",
// "Calendars listing" => "Calendars listing",
// "General settings" => "General settings",
// "Categories listing" => "Categories listing",
// "Browse Categories" => "Browse Categories",
// "Administer Categories" => "Administer Categories",
// "Organize objects" => "Organize objects",
// "Organize Objects" => "Organize Objects",
// "Category objects" => "Category objects",
// "Re-apply last saved category defaults to wiki pages" => "Re-apply last saved category defaults to wiki pages",
// "Performance" => "Performance",
// "Comments listing" => "Comments listing",
// "Site-wide features" => "Site-wide features",
// "Display options" => "Display options",
// "Annotations" => "Annotations",
// "Using comments in various features" => "Using comments in various features",
// "Group Administration" => "Group Administration",
// "User Administration" => "User Administration",
// "Community Features" => "Community Features",
// "Community" => "Community",
// "Additional options" => "Additional options",
// "Social Interaction" => "Social Interaction",
// "Friendship and followers" => "Friendship and followers",
// "Select which items to display when listing users" => "Select which items to display when listing users",
// "Activity stream" => "Activity stream",
// "Tiki Connect" => "Tiki Connect",
// "Join the community" => "Join the community",
// "Tiki Wiki CMS Groupware is Free and Open Source Software (FOSS). It is a community-driven project which exists and improves thanks to the participation of people just like YOU" => "Tiki Wiki CMS Groupware is Free and Open Source Software (FOSS). It is a community-driven project which exists and improves thanks to the participation of people just like YOU",
// "Join the Community" => "Join the Community",
// "Tiki news" => "Tiki news",
// "Embedded RSS feed from info.tiki.org TODO, meanwhile" => "Embedded RSS feed from info.tiki.org TODO, meanwhile",
// "Tiki Newsletter" => "Tiki Newsletter",
// "Promote your site" => "Promote your site",
// "Add your site to the Tiki directory" => "Add your site to the Tiki directory",
// "Submit your site" => "Submit your site",
// "Spread the word" => "Spread the word",
// "Add the \"Powered by\" module to your site. " => "Add the \"Powered by\" module to your site. ",
// "Manage Modules" => "Manage Modules",
// "Help improve Tiki" => "Help improve Tiki",
// "Submit a feature request or bug report" => "Submit a feature request or bug report",
// "Visit Tiki development site" => "Visit Tiki development site",
// "Make a financial contribution to the Tiki Association" => "Make a financial contribution to the Tiki Association",
// "Contribute to Tiki" => "Contribute to Tiki",
// "New Feature" => "New Feature",
// "Please note: Experimental - work in progress" => "Please note: Experimental - work in progress",
// "Tiki Connect is a way to let the Tiki project know how it is being used, and which parts people like or would like fixing (or explaining)" => "Tiki Connect is a way to let the Tiki project know how it is being used, and which parts people like or would like fixing (or explaining)",
// "Once enabled, when you click the '<strong>Send Info</strong>' button below you will be connected with <em>mother.tiki.org</em>, which is where the data will be collected" => "Once enabled, when you click the '<strong>Send Info</strong>' button below you will be connected with <em>mother.tiki.org</em>, which is where the data will be collected",
// "You can also send feedback about Tiki by checking the 'Feedback' checkbox(once Tiki Connect is enabled, next to the 'Preference Filters' bar above)" => "You can also send feedback about Tiki by checking the 'Feedback' checkbox(once Tiki Connect is enabled, next to the 'Preference Filters' bar above)",
// "Icons will appear next to all the preferences where you can 'like', request a 'fix' or ask 'what is this for?'" => "Icons will appear next to all the preferences where you can 'like', request a 'fix' or ask 'what is this for?'",
// "Your votes are sent when you connect with mother.tiki.org (currently only by clicking the '<strong>Send Info</strong>' button)" => "Your votes are sent when you connect with mother.tiki.org (currently only by clicking the '<strong>Send Info</strong>' button)",
// "Send Info" => "Send Info",
// "Send the data" => "Send the data",
// "Preview info" => "Preview info",
// "See what is going to be sent" => "See what is going to be sent",
// "Fill form" => "Fill form",
// "Fill this form in based on other preferences" => "Fill this form in based on other preferences",
// "Advanced settings" => "Advanced settings",
// "Exposed to assist testing and development" => "Exposed to assist testing and development",
// "Connections Received" => "Connections Received",
// "Rebuild received connections index" => "Rebuild received connections index",
// "<strong>Server stats:</strong> %0 reports received from %1 Tikis" => "<strong>Server stats:</strong> %0 reports received from %1 Tikis",
// "Jitsi" => "Jitsi",
// "Provision URL" => "Provision URL",
// "Allows a copyright to be determined for various objects" => "Allows a copyright to be determined for various objects",
// "Directories listing" => "Directories listing",
// "Extention package error" => "Extention package error",
// "Cannot show page because the extension package is not installed or activated" => "Cannot show page because the extension package is not installed or activated",
// "Extension package admin template page is missing" => "Extension package admin template page is missing",
// "FAQ listing" => "FAQ listing",
// "Please see the <a class='alert-link' target='tikihelp' href='http://doc.tiki.org/Features'>evaluation of each feature</a> on Tiki's developer site" => "Please see the <a class='alert-link' target='tikihelp' href='http://doc.tiki.org/Features'>evaluation of each feature</a> on Tiki's developer site",
// "Global features" => "Global features",
// "Main features" => "Main features",
// "Secondary features" => "Secondary features",
// "Administrative features" => "Administrative features",
"Watches" => "監視",
// "Additional features" => "Additional features",
// "Payment and Accounting" => "Payment and Accounting",
// "Mail and Sharing" => "Mail and Sharing",
// "Interaction with online services or other software" => "Interaction with online services or other software",
// "Configuration completed" => "Configuration completed",
// "Authenticate with Zotero" => "Authenticate with Zotero",
// "Interface" => "Interface",
// "jQuery plugins and add-ons" => "jQuery plugins and add-ons",
// "Programmer" => "Programmer",
// "Logging and Reporting" => "Logging and Reporting",
// "Visible to admin only" => "Visible to admin only",
// "Include Smarty notices" => "Include Smarty notices",
// "Custom Code" => "Custom Code",
// "To create or remove file galleries, select" => "To create or remove file galleries, select",
// "from the application menu" => "from the application menu",
// "If you decide to store files in a directory you must ensure that the user cannot access directly to the directory" => "If you decide to store files in a directory you must ensure that the user cannot access directly to the directory",
// "You have two options to accomplish this:<br><ul><li>Use a directory outside your document root, make sure your php script can read and write to that directory</li><li>Use a directory inside the document root and use .htaccess to prevent the user from listing the directory contents</li></ul>" => "You have two options to accomplish this:<br><ul><li>Use a directory outside your document root, make sure your php script can read and write to that directory</li><li>Use a directory inside the document root and use .htaccess to prevent the user from listing the directory contents</li></ul>",
// "To configure the directory path use UNIX like paths for example files/ or c:/foo/files or /www/files/" => "To configure the directory path use UNIX like paths for example files/ or c:/foo/files or /www/files/",
// "File galleries listing" => "File galleries listing",
// "Move files from database to directory" => "Move files from database to directory",
// "Move files from directory to database" => "Move files from directory to database",
// "Manage comment settings" => "Manage comment settings",
// "Update mime of all non archived octet-stream files" => "Update mime of all non archived octet-stream files",
// "Upload Regex" => "Upload Regex",
// "Settings for Media Alchemyst" => "Settings for Media Alchemyst",
// "Settings for Diagrams" => "Settings for Diagrams",
// "Listings" => "Listings",
// "Configuration for gallery listings" => "Configuration for gallery listings",
// "Changing these settings will <em>not</em> affect existing file galleries. These changes will apply <em>only</em> to new file galleries" => "Changing these settings will <em>not</em> affect existing file galleries. These changes will apply <em>only</em> to new file galleries",
// "Admin Listings" => "Admin Listings",
// "Configuration for gallery administration listings" => "Configuration for gallery administration listings",
// "Search Indexing" => "Search Indexing",
// "Handlers" => "Handlers",
// "Add custom handlers to make your files &quot;searchable&quot; content" => "Add custom handlers to make your files &quot;searchable&quot; content",
// "Use <strong>%1</strong> as the internal file name. For example, use <strong>strings %1</strong> to convert the document to text, using the Unix <strong>strings</strong> command" => "Use <strong>%1</strong> as the internal file name. For example, use <strong>strings %1</strong> to convert the document to text, using the Unix <strong>strings</strong> command",
// "To delete a handler, leave the <strong>System Command</strong> field blank" => "To delete a handler, leave the <strong>System Command</strong> field blank",
// "Tiki is pre-configured to handle many common types. If any of those are listed here, it is because the command line tool is unavailable" => "Tiki is pre-configured to handle many common types. If any of those are listed here, it is because the command line tool is unavailable",
// "Missing Handlers" => "Missing Handlers",
// "Mime Types" => "Mime Types",
// "Previous versions of Tiki may have assigned alternative mime-types to Microsoft Office files, such as \"application/vnd.ms-word\" and these need to be changed to be \"application/msword\" for the default file indexing to function properly" => "Previous versions of Tiki may have assigned alternative mime-types to Microsoft Office files, such as \"application/vnd.ms-word\" and these need to be changed to be \"application/msword\" for the default file indexing to function properly",
// "Fix vnd.ms-* mime type files" => "Fix vnd.ms-* mime type files",
// "MIME Type" => "MIME Type",
// "System Command" => "System Command",
// "Reindex all files for search" => "Reindex all files for search",
// "Enhancements" => "Enhancements",
// "H5P Info" => "H5P Info",
// "Service URL to purge unused libraries can be found here. Can be used in a cron task" => "Service URL to purge unused libraries can be found here. Can be used in a cron task",
// "SCORM" => "SCORM",
// "OCR Indexing" => "OCR Indexing",
// "Forums listing" => "Forums listing",
// "WYSIWYG is enabled but needs to be in \"wiki syntax\" mode to work correctly in forums" => "WYSIWYG is enabled but needs to be in \"wiki syntax\" mode to work correctly in forums",
// "Threads" => "Threads",
"Searches" => "搜尋",
// "Forum Listing" => "Forum Listing",
// "Tags listing" => "Tags listing",
// "Browse Tags" => "Browse Tags",
// "Translate tags" => "Translate tags",
// "Translate Tags" => "Translate Tags",
// "Remove tags not applied to any objects" => "Remove tags not applied to any objects",
// "Clean Up Unused Tags" => "Clean Up Unused Tags",
// "Random tag cloud colors" => "Random tag cloud colors",
// "Separate colors with a comma (,)" => "Separate colors with a comma (,)",
// "Alphanumeric ASCII characters only" => "Alphanumeric ASCII characters only",
// "No accents or special characters" => "No accents or special characters",
// "Accept all characters" => "Accept all characters",
// "Tag search page" => "Tag search page",
// "When arriving on <a href=\"tiki-browse_freetags.php\">tag search page</a>" => "When arriving on <a href=\"tiki-browse_freetags.php\">tag search page</a>",
// "To add/remove image galleries, go to \"Image Galleries\" on the application menu, or" => "To add/remove image galleries, go to \"Image Galleries\" on the application menu, or",
"Click Here" => "點擊此處",
// "You can upload images of a size of " => "You can upload images of a size of ",
// "Alter the php.ini variables file_uploads, upload_max_filesize, post_max_size and database variables (max_allowed_packet for mysql) to change this value" => "Alter the php.ini variables file_uploads, upload_max_filesize, post_max_size and database variables (max_allowed_packet for mysql) to change this value",
"Galleries features" => "圖庫功能",
"Gallery listing configuration" => "圖庫列表設定",
// "Comments settings" => "Comments settings",
// "Manage images" => "Manage images",
// "Remove unused images" => "Remove unused images",
// "Remove unused images in the system gallery" => "Remove unused images in the system gallery",
// "Remove images not being used in wiki pages, articles or blog posts" => "Remove images not being used in wiki pages, articles or blog posts",
// "Move images from database storage to filesystem storage" => "Move images from database storage to filesystem storage",
// "Move images from filesystem storage to database storage" => "Move images from filesystem storage to database storage",
// "Move images" => "Move images",
"All galleries" => "所有的圖庫",
"System Gallery" => "系統圖庫",
// "Reset or upgrade your database" => "Reset or upgrade your database",
// "Create and edit menus" => "Create and edit menus",
// "Server Fitness" => "Server Fitness",
// "Check if your server meets the requirements for running Tiki" => "Check if your server meets the requirements for running Tiki",
// "Check for Updates Now" => "Check for Updates Now",
// "Check if a new Tiki version is available" => "Check if a new Tiki version is available",
"General Preferences" => "一般偏好",
// "Release check" => "Release check",
// "Last update from SVN" => "Last update from SVN",
// "Site identity" => "Site identity",
// "Themes" => "Themes",
// "Go to the <a href=\"tiki-admin.php?page=look\" class=\"alert-link\">Look & Feel</a> section for additional site customization preferences" => "Go to the <a href=\"tiki-admin.php?page=look\" class=\"alert-link\">Look & Feel</a> section for additional site customization preferences",
// "These values will be stored in plain text in the database" => "These values will be stored in plain text in the database",
// "Email to send a test mail" => "Email to send a test mail",
// "Logging and reporting" => "Logging and reporting",
// "Web Cron" => "Web Cron",
// "Call Web Cron URL" => "Call Web Cron URL",
// "Scheduler Settings" => "Scheduler Settings",
// "Sessions" => "Sessions",
// "Advanced configuration" => "Advanced configuration",
// "Note that storing session data in the database is an advanced systems administration option, and is for admins who have comprehensive access and understanding of the database, in order to deal with any unexpected effects" => "Note that storing session data in the database is an advanced systems administration option, and is for admins who have comprehensive access and understanding of the database, in order to deal with any unexpected effects",
// "Changing this feature will immediately log you out when you save this preference" => "Changing this feature will immediately log you out when you save this preference",
// "Enable now" => "Enable now",
"Contact" => "聯絡",
// "Terms and conditions" => "Terms and conditions",
// "Home page" => "Home page",
// "Redirects" => "Redirects",
// "Site access" => "Site access",
// "Test site closed message" => "Test site closed message",
// "The namespace separator should not" => "The namespace separator should not",
// "contain any of the characters not allowed in wiki page names, typically" => "contain any of the characters not allowed in wiki page names, typically",
// "conflict with wiki syntax tagging" => "conflict with wiki syntax tagging",
// "To use :: as a separator, you should also use ::: as the wiki center tag syntax" => "To use :: as a separator, you should also use ::: as the wiki center tag syntax",
// "Note: a conversion of :: to ::: for existing pages must be done manually" => "Note: a conversion of :: to ::: for existing pages must be done manually",
// "If the page name display stripper conflicts with the namespace separator, the namespace is used and the page name display is not stripped" => "If the page name display stripper conflicts with the namespace separator, the namespace is used and the page name display is not stripped",
// "php.net" => "php.net",
"Date and Time Format Help" => "日期與時間格式說明",
// "Time zone and format" => "Time zone and format",
// "Date/time selectors" => "Date/time selectors",
// "Manage customized local string translations" => "Manage customized local string translations",
// "Upload a file with translations for the selected language" => "Upload a file with translations for the selected language",
"Edit languages" => "編輯語言",
// "Intertiki Client" => "Intertiki Client",
// "Set up this Tiki site as the Intertiki client" => "Set up this Tiki site as the Intertiki client",
// "Client server settings" => "Client server settings",
// "Currently linked master server" => "Currently linked master server",
// "Add an available master server" => "Add an available master server",
// "The InterTiki Server fields are for defining for every master server you want to have access to from this client" => "The InterTiki Server fields are for defining for every master server you want to have access to from this client",
// "Server name" => "Server name",
// "Set the name of your target server as defined in the server name field of the master. Use a distinct, but easily understood value" => "Set the name of your target server as defined in the server name field of the master. Use a distinct, but easily understood value",
// "Server host" => "Server host",
// "The full URL of the master servers primary Tiki (ex: https://tiki.org). Even if your Tiki is not at the top level of your web directory, you will still use the site\\'s URL per the ex. above" => "The full URL of the master servers primary Tiki (ex: https://tiki.org). Even if your Tiki is not at the top level of your web directory, you will still use the site\\'s URL per the ex. above",
// "Server port" => "Server port",
// "The port number the master tiki responds to HTTP on (usually 80)" => "The port number the master tiki responds to HTTP on (usually 80)",
// "Server path" => "Server path",
// "The full path (from the URL root) to the PHP file containing the XMLRPC handler on the server. EX 1: If the master tiki resides at the root of the site, you would enter \"/remote.php\". EX 2: Say the master tiki is found at http://www.mydomain.com/tiki/mytiki, you would enter \"/tiki/mytiki/remote.php\" in this field" => "The full path (from the URL root) to the PHP file containing the XMLRPC handler on the server. EX 1: If the master tiki resides at the root of the site, you would enter \"/remote.php\". EX 2: Say the master tiki is found at http://www.mydomain.com/tiki/mytiki, you would enter \"/tiki/mytiki/remote.php\" in this field",
// "Server groups" => "Server groups",
// "Groups on the master to authenticate to (only auth users in the groups defined, case-sensitive)" => "Groups on the master to authenticate to (only auth users in the groups defined, case-sensitive)",
// "Available master Tiki servers" => "Available master Tiki servers",
// "Delete master server" => "Delete master server",
// "Intertiki Master Server" => "Intertiki Master Server",
// "Set up this Tiki site as the InterTiki master server" => "Set up this Tiki site as the InterTiki master server",
// "Master server settings" => "Master server settings",
// "Allowed client servers" => "Allowed client servers",
// "Arbitrary name used to uniquely identify this configuration (does not effect operation). Recommend use of a name that indicates the client server (ex: doc.tw.o)" => "Arbitrary name used to uniquely identify this configuration (does not effect operation). Recommend use of a name that indicates the client server (ex: doc.tw.o)",
// "This is the shared key you define. It has to match the client configuration for your server. It can be as short or as long as you like. It is recommended you follow the same kind of password policies your organization would have for something like a wireless WEP key" => "This is the shared key you define. It has to match the client configuration for your server. It can be as short or as long as you like. It is recommended you follow the same kind of password policies your organization would have for something like a wireless WEP key",
// "IP" => "IP",
// "The physical IP address the client machine will be making requests to the server from. If the client is on the same machine, you should be able to use 127.0.0.1" => "The physical IP address the client machine will be making requests to the server from. If the client is on the same machine, you should be able to use 127.0.0.1",
// "Username of primary contact on client machine. Useful for adminstration" => "Username of primary contact on client machine. Useful for adminstration",
// "Can register" => "Can register",
// "To change the host key you need to remove and add it as a new one" => "To change the host key you need to remove and add it as a new one",
"New" => "增加",
// "Enable/disable Tiki features in " => "Enable/disable Tiki features in ",
// ", but configure them elsewhere" => ", but configure them elsewhere",
// "See <strong>more options</strong> after you enable more <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Preference+Filters'>Preference Filters</a> above ({icon name=\"filter\"})" => "See <strong>more options</strong> after you enable more <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Preference+Filters'>Preference Filters</a> above ({icon name=\"filter\"})",
// "Tiki detected system configuration files with <strong>.ini</strong> extension, under the root folder of Tiki. It is recommended to change it to <strong>.ini.php</strong>.<br/>Check <strong><a href=\"https://doc.tiki.org/System-Configuration\">https://doc.tiki.org/System-Configuration</a></strong> for examples" => "Tiki detected system configuration files with <strong>.ini</strong> extension, under the root folder of Tiki. It is recommended to change it to <strong>.ini.php</strong>.<br/>Check <strong><a href=\"https://doc.tiki.org/System-Configuration\">https://doc.tiki.org/System-Configuration</a></strong> for examples",
// "Registration" => "Registration",
// "Log in" => "Log in",
// "Generate a passcode" => "Generate a passcode",
// "Requires PHP GD library" => "Requires PHP GD library",
// "Group and tracker login settings" => "Group and tracker login settings",
// "Users can select a group to join at registration" => "Users can select a group to join at registration",
// "By default, new users automatically join the Registered group" => "By default, new users automatically join the Registered group",
// "Other login settings" => "Other login settings",
// "Cookie consent" => "Cookie consent",
// "Assign users to groups by matching email patterns" => "Assign users to groups by matching email patterns",
// "An email pattern must be defined in the settings for at least one group for this to produce any results" => "An email pattern must be defined in the settings for at least one group for this to produce any results",
// "Remote Tiki Autologin" => "Remote Tiki Autologin",
// "You must install PHP extension LDAP" => "You must install PHP extension LDAP",
// "You must change the Authentication Method to LDAP for these changes to take effect" => "You must change the Authentication Method to LDAP for these changes to take effect",
// "LDAP bind settings" => "LDAP bind settings",
// "LDAP user" => "LDAP user",
// "LDAP admin" => "LDAP admin",
// "LDAP external groups" => "LDAP external groups",
// "LDAP group" => "LDAP group",
// "LDAP group member - if group membership can be found in group attributes" => "LDAP group member - if group membership can be found in group attributes",
// "LDAP user group - if group membership can be found in user attributes" => "LDAP user group - if group membership can be found in user attributes",
// "PAM" => "PAM",
// "You must change the Authentication Method to PAM for these changes to take effect" => "You must change the Authentication Method to PAM for these changes to take effect",
// "Shibboleth Authentication " => "Shibboleth Authentication ",
// "You must change the Authentication Method to Shibboleth for these changes to take effect" => "You must change the Authentication Method to Shibboleth for these changes to take effect",
// "SAML2" => "SAML2",
// "based on Onelogin's php-saml " => "based on Onelogin's php-saml ",
// "You must change the Authentication Method to SAML for these changes to take effect" => "You must change the Authentication Method to SAML for these changes to take effect",
// "Identity provider settings" => "Identity provider settings",
// "Attribute mapping" => "Attribute mapping",
// "Group mapping" => "Group mapping",
// "CAS" => "CAS",
// "CAS (central authentication service)" => "CAS (central authentication service)",
// "You must change the Authentication Method to CAS for these changes to take effect" => "You must change the Authentication Method to CAS for these changes to take effect",
// "CAS server" => "CAS server",
// "CAS Server Name" => "CAS Server Name",
// "CAS Server Port" => "CAS Server Port",
// "CAS Server Path" => "CAS Server Path",
// "phpBB User Database Authentication " => "phpBB User Database Authentication ",
// "You must change the Authentication Method to phpBB for these changes to take effect" => "You must change the Authentication Method to phpBB for these changes to take effect",
// "You must turn Users can register off for phpBB Authentication to function properly" => "You must turn Users can register off for phpBB Authentication to function properly",
// "MySql only (for now)" => "MySql only (for now)",
// "Web server" => "Web server",
// "Web Server Authentication " => "Web Server Authentication ",
// "You must change the Authentication Method to Web Server for these changes to take effect" => "You must change the Authentication Method to Web Server for these changes to take effect",
// "Password Blacklist" => "Password Blacklist",
// "Password blacklist tools" => "Password blacklist tools",
// "Upload Word List for Processing" => "Upload Word List for Processing",
// "Words currently indexed" => "Words currently indexed",
// "You may create custom blacklists to better fit your needs. Start by uploading a word list.\n\t\t\t\t\t\tThen reduce that list to something that applies to your specific configuration and needs with the tools that appear below" => "You may create custom blacklists to better fit your needs. Start by uploading a word list.\n\t\t\t\t\t\tThen reduce that list to something that applies to your specific configuration and needs with the tools that appear below",
// "Raw password files can be obtained from <a href=\"https://github.com/danielmiessler/SecLists/tree/master/Passwords\" target=\"_blank\">Daniel Miessler's Collection</a>.\n\t\t\t\t\t\tTiki's defaut password blacklist files were generated from Missler's top 1 million password file" => "Raw password files can be obtained from <a href=\"https://github.com/danielmiessler/SecLists/tree/master/Passwords\" target=\"_blank\">Daniel Miessler's Collection</a>.\n\t\t\t\t\t\tTiki's defaut password blacklist files were generated from Missler's top 1 million password file",
// "Use 'LOAD DATA INFILE'" => "Use 'LOAD DATA INFILE'",
// "Allows much larger files to be uploaded, but requires MySQL on localhost with extra permissions" => "Allows much larger files to be uploaded, but requires MySQL on localhost with extra permissions",
// "Create or Replace Word Index" => "Create or Replace Word Index",
// "Text files with one word per line accepted.\n\t\t\t\t\t\t\tThe word list will be converted to all lowe case. Duplicate entries will be removed.\n\t\t\t\t\t\t\tTypically passwords lists should be arranged with the most commonly used passwords first" => "Text files with one word per line accepted.\n\t\t\t\t\t\t\tThe word list will be converted to all lowe case. Duplicate entries will be removed.\n\t\t\t\t\t\t\tTypically passwords lists should be arranged with the most commonly used passwords first",
// "Delete Temporary Index" => "Delete Temporary Index",
// "It is recommended that you delete indexed passwords from your database after your done generating your password lists.\n\t\t\t\t\t\t\tThey can take up quite a lot of space and serve no pourpose after processing is complete" => "It is recommended that you delete indexed passwords from your database after your done generating your password lists.\n\t\t\t\t\t\t\tThey can take up quite a lot of space and serve no pourpose after processing is complete",
// "Blacklist Currently Using" => "Blacklist Currently Using",
// "Saving places a text file with the generated passwords in your storage/pass_blacklists folder and enables it\n\t\t\t\t\t\t\tas an option for use. Fields default to the password standards set in tiki. You should not have to change these, unless you plan on changing your password\n\t\t\t\t\t\t\trequirements in the future" => "Saving places a text file with the generated passwords in your storage/pass_blacklists folder and enables it\n\t\t\t\t\t\t\tas an option for use. Fields default to the password standards set in tiki. You should not have to change these, unless you plan on changing your password\n\t\t\t\t\t\t\trequirements in the future",
// "Number of passwords (limit)" => "Number of passwords (limit)",
// "This sets the number of passwords that your blacklist will use. The words from the begining of of the file will be selected over the lower,\n\t\t\t\t\t\t\t\t\t\tso if you have a list of words arranged with the most common at the top, it will select only the most common works to blacklist.\n\t\t\t\t\t\t\t\t\t\tTypical usage ranges between 1,000 & 10,000, although many more could be used. Twitter blacklists 396" => "This sets the number of passwords that your blacklist will use. The words from the begining of of the file will be selected over the lower,\n\t\t\t\t\t\t\t\t\t\tso if you have a list of words arranged with the most common at the top, it will select only the most common works to blacklist.\n\t\t\t\t\t\t\t\t\t\tTypical usage ranges between 1,000 & 10,000, although many more could be used. Twitter blacklists 396",
// "Minimum Password Length" => "Minimum Password Length",
// "The minimum password length for your password. This will filter out any password that has an illegal length" => "The minimum password length for your password. This will filter out any password that has an illegal length",
// "Require Numbers &amp; Letters" => "Require Numbers &amp; Letters",
// "If checked, will filter out any password that does not have both upper and lower case letters" => "If checked, will filter out any password that does not have both upper and lower case letters",
// "Require Special Characters" => "Require Special Characters",
// "If checked, will filter out any passwords that do not have special characters" => "If checked, will filter out any passwords that do not have special characters",
// "Save & Set as Default" => "Save & Set as Default",
// "View Password List" => "View Password List",
// "OAuth Server Settings" => "OAuth Server Settings",
// "Main theme" => "Main theme",
// "Theme Screenshot" => "Theme Screenshot",
// "Theme Preferences" => "Theme Preferences",
// "{{\$theme|escape|ucfirst}}" => "{{\$theme|escape|ucfirst}}",
// "No theme preferences found" => "No theme preferences found",
// "General layout" => "General layout",
// "Admin pages layout" => "Admin pages layout",
// "Admin theme must be selected first" => "Admin theme must be selected first",
// "Fixed vs full width layout" => "Fixed vs full width layout",
// "Logo and Title" => "Logo and Title",
// "Module zone visibility" => "Module zone visibility",
// "Site report bar" => "Site report bar",
// "Limits" => "Limits",
// "UI Effects" => "UI Effects",
// "Standard UI effects" => "Standard UI effects",
// "Tab UI effects" => "Tab UI effects",
// "Customization" => "Customization",
// "Custom codes" => "Custom codes",
// "Editing" => "Editing",
// "View Templates" => "View Templates",
"Edit Templates" => "編輯模板",
// "Miscellaneous" => "Miscellaneous",
// "Responsive images" => "Responsive images",
// "Context menus" => "Context menus",
// "currently used in file galleries only" => "currently used in file galleries only",
// "Separators" => "Separators",
// "Smarty templates (TPL files)" => "Smarty templates (TPL files)",
// "Defaults" => "Defaults",
// "See also" => "See also",
// "Search Engine Friendly URLs" => "Search Engine Friendly URLs",
// "Also" => "Also",
// "here" => "here",
// "for more information on geo tagging" => "for more information on geo tagging",
// "Meta tags" => "Meta tags",
// "Geo Metatags" => "Geo Metatags",
// "Robots" => "Robots",
// "&quot;Modules&quot; are the items of content at the top &amp; bottom and in the right &amp; left columns of the site" => "&quot;Modules&quot; are the items of content at the top &amp; bottom and in the right &amp; left columns of the site",
// "Admin &gt; Modules" => "Admin &gt; Modules",
// "from the menu to create and edit modules" => "from the menu to create and edit modules",
// "{\$crumbs[\$crumb]->description}" => "{\$crumbs[\$crumb]->description}",
// "Hint" => "Hint",
// "If you lose your login module, use tiki-login_scr.php to be able to login" => "If you lose your login module, use tiki-login_scr.php to be able to login",
// "Composer not found" => "Composer not found",
// "Composer could not be executed, so the automated check on the packages cannot be performed" => "Composer could not be executed, so the automated check on the packages cannot be performed",
// "In <a href=\"javascript:void(0)\" class=\"install-composer alert-link\">Diagnose</a> tab you can install composer" => "In <a href=\"javascript:void(0)\" class=\"install-composer alert-link\">Diagnose</a> tab you can install composer",
// "Result of executing the changes to the packages" => "Result of executing the changes to the packages",
// "Composer errors" => "Composer errors",
// "Composer returned some errors" => "Composer returned some errors",
// "Issues with composer environment" => "Issues with composer environment",
// "Run %0 from a shell to try to fix this, see %1 for more info" => "Run %0 from a shell to try to fix this, see %1 for more info",
// "Packages" => "Packages",
// "Packages check could not be performed at the moment due to missing" => "Packages check could not be performed at the moment due to missing",
// "You can try to install composer from the <a href=\"javascript:void(0)\" class=\"install-composer alert-link\">Diagnose</a> tab or look at the manual instructions bellow" => "You can try to install composer from the <a href=\"javascript:void(0)\" class=\"install-composer alert-link\">Diagnose</a> tab or look at the manual instructions bellow",
// "Installed Packages" => "Installed Packages",
// "Status of the packages registered in the composer.json file" => "Status of the packages registered in the composer.json file",
// "Version Required" => "Version Required",
// "Version Installed" => "Version Installed",
// "Installed" => "Installed",
// "Missing" => "Missing",
// "Enable extension" => "Enable extension",
// "Update extension" => "Update extension",
// "Disable extension" => "Disable extension",
// "Removal not available" => "Removal not available",
// "This package is not managed by Tiki and likely was installed manually" => "This package is not managed by Tiki and likely was installed manually",
// "One or more packages appear to be missing" => "One or more packages appear to be missing",
// "In the list above, some packages could not be found. They are defined in the composer.json file, but do not seem to be installed" => "In the list above, some packages could not be found. They are defined in the composer.json file, but do not seem to be installed",
// "Could not validate the status of one or more packages" => "Could not validate the status of one or more packages",
// "In the list above, some packages status could not be validated, since composer was not found, you can try to install composer and try again or install the packages manually" => "In the list above, some packages status could not be validated, since composer was not found, you can try to install composer and try again or install the packages manually",
// "Install packages from the administrator interface" => "Install packages from the administrator interface",
// "The administrator interface can be used to install the packages marked as missing in the list above" => "The administrator interface can be used to install the packages marked as missing in the list above",
// "Click the \"Fix Missing Packages\" button below, and Tiki will try to install them" => "Click the \"Fix Missing Packages\" button below, and Tiki will try to install them",
// "Fix Missing Packages" => "Fix Missing Packages",
// "Install packages manually" => "Install packages manually",
// "Make sure <code>composer</code> is installed" => "Make sure <code>composer</code> is installed",
// "Composer can be installed manually, in the host machine, by following the instructions from the" => "Composer can be installed manually, in the host machine, by following the instructions from the",
// "website" => "website",
// "The script <code>setup.sh</code> that is included in the Tiki distribution can be run to make sure composer is installed and the file permissions are correctly applied. In this case, composer will be installed as <code>temp/composer.phar</code>" => "The script <code>setup.sh</code> that is included in the Tiki distribution can be run to make sure composer is installed and the file permissions are correctly applied. In this case, composer will be installed as <code>temp/composer.phar</code>",
// "Below is an example of how to do this in a Linux-like operating system" => "Below is an example of how to do this in a Linux-like operating system",
// "Install the missing packages" => "Install the missing packages",
// "You can install the missing packages by issuing the command" => "You can install the missing packages by issuing the command",
// "Available Packages" => "Available Packages",
// "These packages have been identified as required by one or more features" => "These packages have been identified as required by one or more features",
// "Licence" => "Licence",
// "Required by" => "Required by",
// "Not Available" => "Not Available",
// "Install" => "Install",
// "There appear to be some optional packages that can be installed" => "There appear to be some optional packages that can be installed",
// "In the list above, there are optional packages that may be installed in order to use the Tiki features that require the package" => "In the list above, there are optional packages that may be installed in order to use the Tiki features that require the package",
// "The administrator interface can be used to install the optional packages in the list above" => "The administrator interface can be used to install the optional packages in the list above",
// "Click the \"Install Package\" button, and Tiki will try to install them" => "Click the \"Install Package\" button, and Tiki will try to install them",
// "Make sure there is a <code>composer.json</code> file in the root of the website" => "Make sure there is a <code>composer.json</code> file in the root of the website",
// "If there is not already a <code>composer.json</code> file, then create one" => "If there is not already a <code>composer.json</code> file, then create one",
// "The sample <code>composer.json.dist</code> that comes with Tiki can be used as a starting point" => "The sample <code>composer.json.dist</code> that comes with Tiki can be used as a starting point",
// "Install the package" => "Install the package",
// "Packages can be installed by issuing a command" => "Packages can be installed by issuing a command",
// "for each package that is to be installed" => "for each package that is to be installed",
// "Packages Custom" => "Packages Custom",
// "There are no manual managed packages installed in the folder vendor_custom" => "There are no manual managed packages installed in the folder vendor_custom",
// "Please check <a href=\"https://packages.tiki.org/\">Tiki Packages</a> website for information on how to download and use these manual packages" => "Please check <a href=\"https://packages.tiki.org/\">Tiki Packages</a> website for information on how to download and use these manual packages",
// "Note that this in place for when you can not use composer to manage your packages, example when there is restricted access to internet and composer will not be able to download the packages, for most users the most convenient way is to install directly from the \"Packages\" tab" => "Note that this in place for when you can not use composer to manage your packages, example when there is restricted access to internet and composer will not be able to download the packages, for most users the most convenient way is to install directly from the \"Packages\" tab",
// "Composer Packages Custom <small>Status of the packages registered in the vendor_custom folder</small>" => "Composer Packages Custom <small>Status of the packages registered in the vendor_custom folder</small>",
// "For information only" => "For information only",
// "These packages are managed manually and displayed here for informational purposes" => "These packages are managed manually and displayed here for informational purposes",
// "Packages Bundled" => "Packages Bundled",
// "These packages are bundled with Tiki, and displayed here for informational purposes" => "These packages are bundled with Tiki, and displayed here for informational purposes",
// "Composer Packages Bundled" => "Composer Packages Bundled",
// "status of the packages registered in the vendor_bundled/composer.json file" => "status of the packages registered in the vendor_bundled/composer.json file",
// "Diagnose" => "Diagnose",
// "Diagnose Composer Installation" => "Diagnose Composer Installation",
// "Use the button below to test your composer installation" => "Use the button below to test your composer installation",
// "Diagnose Composer" => "Diagnose Composer",
// "Composer management" => "Composer management",
// "Install Composer" => "Install Composer",
// "Update Composer" => "Update Composer",
// "Remove composer.lock" => "Remove composer.lock",
// "Clean vendor folder" => "Clean vendor folder",
// "{\$diagnostic_composer_location}" => "{\$diagnostic_composer_location}",
// "Extensions Preferences" => "Extensions Preferences",
// "Activate Extension Package" => "Activate Extension Package",
// "Extension Package Groups API" => "Extension Package Groups API",
// "Payments" => "Payments",
// "Choose payment system" => "Choose payment system",
// "You can use only one payment method: PayPal or Cclite or Tiki User Credits" => "You can use only one payment method: PayPal or Cclite or Tiki User Credits",
// "PayPal is working at the moment. See PayPal.com" => "PayPal is working at the moment. See PayPal.com",
// "Cclite: Community currency accounting for local exchange trading systems (LETS). See " => "Cclite: Community currency accounting for local exchange trading systems (LETS). See ",
// "sourceforge.net" => "sourceforge.net",
// "Tiki User Credits: Requires this other feature to be configured" => "Tiki User Credits: Requires this other feature to be configured",
// "Israel Post payment module" => "Israel Post payment module",
// "Cclite is for creating and managing alternative or complementary trading currencies and groups" => "Cclite is for creating and managing alternative or complementary trading currencies and groups",
// "Work in progress since Tiki 6" => "Work in progress since Tiki 6",
// "Advanced Shopping Cart" => "Advanced Shopping Cart",
// "Cart settings" => "Cart settings",
// "Advanced cart tracker names setup" => "Advanced cart tracker names setup",
// "Products tracker setup" => "Products tracker setup",
// "Depending on which feature you are using, you may need some or all of the following fields to be setup" => "Depending on which feature you are using, you may need some or all of the following fields to be setup",
// "Shipping" => "Shipping",
// "Please see the <a class='alert-link' target='tikihelp' href='http://dev.tiki.org/Performance'>Performance page</a> on Tiki's developer site" => "Please see the <a class='alert-link' target='tikihelp' href='http://dev.tiki.org/Performance'>Performance page</a> on Tiki's developer site",
// "Output compression is active" => "Output compression is active",
// "Compression is handled by" => "Compression is handled by",
// "PHP settings" => "PHP settings",
// "Some PHP.INI settings that can increase performance" => "Some PHP.INI settings that can increase performance",
// "'realpath_cache_size setting': %0" => "'realpath_cache_size setting': %0",
// "(percentage used %0 %" => "(percentage used %0 %",
// "Determines the size of the realpath cache to be used by PHP" => "Determines the size of the realpath cache to be used by PHP",
// "'realpath_cache_ttl setting': %0 seconds" => "'realpath_cache_ttl setting': %0 seconds",
// "Duration of time (in seconds) for which to cache realpath information for a given file or directory" => "Duration of time (in seconds) for which to cache realpath information for a given file or directory",
// "Bytecode Cache" => "Bytecode Cache",
// "Using <strong>%0</strong>. These stats affect all PHP applications running on the server" => "Using <strong>%0</strong>. These stats affect all PHP applications running on the server",
// "Configuration setting <em>xcache.admin.enable_auth</em> prevents from accessing statistics. This will also prevent the cache from being cleared when clearing template cache" => "Configuration setting <em>xcache.admin.enable_auth</em> prevents from accessing statistics. This will also prevent the cache from being cleared when clearing template cache",
// "Memory Used" => "Memory Used",
// "Cache Hits" => "Cache Hits",
// "Misses" => "Misses",
// "Few hits recorded. Statistics may not be representative" => "Few hits recorded. Statistics may not be representative",
// "Low hit ratio. %0 may be misconfigured and not used" => "Low hit ratio. %0 may be misconfigured and not used",
// "Little memory available. Thrashing likely to occur" => "Little memory available. Thrashing likely to occur",
// "The values to increase are apc.shm_size (for APC), xcache.size (for XCache) or opcache.memory_consumption (for OPcache)" => "The values to increase are apc.shm_size (for APC), xcache.size (for XCache) or opcache.memory_consumption (for OPcache)",
// "Small amount of memory allocated to %0. Verify the configuration" => "Small amount of memory allocated to %0. Verify the configuration",
// "Configuration <em>%0</em> is enabled. Disabling modification checks can improve performance, but will require manual clear on file updates" => "Configuration <em>%0</em> is enabled. Disabling modification checks can improve performance, but will require manual clear on file updates",
// "<em>%0</em> should not be disabled due to authentication on XCache" => "<em>%0</em> should not be disabled due to authentication on XCache",
// "Clear all APC caches" => "Clear all APC caches",
// "Clear APC caches" => "Clear APC caches",
// "Clear Caches" => "Clear Caches",
// "Bytecode cache is not used. Using a bytecode cache (OPcache, APC, XCache, WinCache) is highly recommended for production environments" => "Bytecode cache is not used. Using a bytecode cache (OPcache, APC, XCache, WinCache) is highly recommended for production environments",
// "Major Slowdown" => "Major Slowdown",
// "Major slowdown" => "Major slowdown",
// "These are reported to slow down Tiki. If you have a high-volume site, you may want to deactivate them" => "These are reported to slow down Tiki. If you have a high-volume site, you may want to deactivate them",
// "Many search options impact performance. Please see <a href=\"tiki-admin.php?page=search\" class=\"alert-link\">Search admin panel</a>" => "Many search options impact performance. Please see <a href=\"tiki-admin.php?page=search\" class=\"alert-link\">Search admin panel</a>",
// "Time and Memory Limits" => "Time and Memory Limits",
// "PDF settings" => "PDF settings",
// "Wiki print version" => "Wiki print version",
// "Other features" => "Other features",
// "Tiki Configuration Profiles" => "Tiki Configuration Profiles",
// "Some of your Profiles Repositories are not connecting. This may prevent you from applying certain profiles" => "Some of your Profiles Repositories are not connecting. This may prevent you from applying certain profiles",
// "Find profiles" => "Find profiles",
// "Search by name, types and repository" => "Search by name, types and repository",
// "Profile types" => "Profile types",
// "Profile repository" => "Profile repository",
// "Suggested Profiles" => "Suggested Profiles",
// "Featured Site Profiles" => "Featured Site Profiles",
// "Featured Site Profiles is a list of applications that are maintained by the Tiki community and are a great way to get started" => "Featured Site Profiles is a list of applications that are maintained by the Tiki community and are a great way to get started",
// "Full Profiles" => "Full Profiles",
// "Full Profiles are full featured out of the box solutions" => "Full Profiles are full featured out of the box solutions",
// "Mini Profiles" => "Mini Profiles",
// "Mini Profiles will configure specific features and are a great way to add more functionality to an existing configuration" => "Mini Profiles will configure specific features and are a great way to add more functionality to an existing configuration",
// "Learning Profiles" => "Learning Profiles",
// "Learning Profiles will allow you to quickly evaluate specific features in Tiki" => "Learning Profiles will allow you to quickly evaluate specific features in Tiki",
// "Select and apply profile <small>Click on a configuration profile name below to review it and apply it on your site</small>" => "Select and apply profile <small>Click on a configuration profile name below to review it and apply it on your site</small>",
// "Repository" => "Repository",
// "Profile type" => "Profile type",
// "See profile info below (may take a few seconds to load)" => "See profile info below (may take a few seconds to load)",
// "applied" => "applied",
// "JavaScript must be turned <strong>ON</strong> in order to apply Profiles. Please enable your JavaScript and try again" => "JavaScript must be turned <strong>ON</strong> in order to apply Profiles. Please enable your JavaScript and try again",
// "Export YAML" => "Export YAML",
// "Export modified preferences as YAML" => "Export modified preferences as YAML",
// "Toggle Visible" => "Toggle Visible",
// "Show added preferences" => "Show added preferences",
// "no default" => "no default",
// "Repository status" => "Repository status",
// "status of the registered profile repositories" => "status of the registered profile repositories",
"Refresh" => "重新整理",
// "Profile tester" => "Profile tester",
// "Paste or type wiki markup and YAML (with or without the {literal}{CODE}{/literal} tags) into the text area below" => "Paste or type wiki markup and YAML (with or without the {literal}{CODE}{/literal} tags) into the text area below",
// "This will run the profile and make potentially unrecoverable changes in your database" => "This will run the profile and make potentially unrecoverable changes in your database",
// "Test profile name" => "Test profile name",
// "Permission added" => "Permission added",
// "User added" => "User added",
// "User modified" => "User modified",
// "Group added" => "Group added",
// "old value" => "old value",
// "Installer added" => "Installer added",
// "Profile without changes" => "Profile without changes",
// "Global configuration" => "Global configuration",
// "This preference needs to be disabled" => "This preference needs to be disabled",
// "Enabling ratings for forums" => "Enabling ratings for forums",
// "You need to" => "You need to",
// "Create or edit a forum and enable" => "Create or edit a forum and enable",
// "Posts can be rated" => "Posts can be rated",
// "While editing the forum, choose whether to show the \"User information display > <strong>Topic Rating</strong>\" by each user" => "While editing the forum, choose whether to show the \"User information display > <strong>Topic Rating</strong>\" by each user",
// "Set the rating options at" => "Set the rating options at",
// "Ratings" => "Ratings",
// "see above" => "see above",
// "Permissions involved" => "Permissions involved",
// "tiki" => "tiki",
// "Default Options" => "Default Options",
// "Cache duration" => "Cache duration",
"Create new" => "建立新的",
// "Use this page to configure the feeds generated by Tiki. To syndicate feeds from other sites, use <a class=\"alert-link\" href=\"tiki-admin_rssmodules.php\" title=\"{tr}External Feeds" => "Use this page to configure the feeds generated by Tiki. To syndicate feeds from other sites, use <a class=\"alert-link\" href=\"tiki-admin_rssmodules.php\" title=\"{tr}External Feeds",
// "Feeds" => "Feeds",
// "Feed for articles" => "Feed for articles",
// "Feed for blogs" => "Feed for blogs",
// "Feed for individual blogs" => "Feed for individual blogs",
// "Feed for image galleries" => "Feed for image galleries",
// "Feed for individual image galleries" => "Feed for individual image galleries",
// "Feed for file galleries" => "Feed for file galleries",
// "Feed for individual file galleries" => "Feed for individual file galleries",
// "Feed for wiki pages (with diff)" => "Feed for wiki pages (with diff)",
// "with diff" => "with diff",
// "Feed for wiki pages (no diff)" => "Feed for wiki pages (no diff)",
// "no diff" => "no diff",
// "Feed for forums" => "Feed for forums",
// "Feed for individual forums" => "Feed for individual forums",
// "Feed for trackers" => "Feed for trackers",
// "Feed for calendars" => "Feed for calendars",
// "Feed for directories" => "Feed for directories",
// "Feed for shoutbox" => "Feed for shoutbox",
// "Incoming Feeds" => "Incoming Feeds",
// "You can see users rank by score in the module users_rank, for that go to" => "You can see users rank by score in the module users_rank, for that go to",
// "Admin modules" => "Admin modules",
// "Cause scores older than a certain number of days to expire" => "Cause scores older than a certain number of days to expire",
// "Scoring rules" => "Scoring rules",
// "Unique rule ID" => "Unique rule ID",
// "Rule" => "Rule",
// "A label or ID to help identify which event was triggered to get points" => "A label or ID to help identify which event was triggered to get points",
// "Pts recipient type" => "Pts recipient type",
// "Recipient Type" => "Recipient Type",
// "The object type of the point recipient. Usually 'user' but can also be article, trackeritem, etc. Can also use '(eval type)' to get the type of the object being triggered by the event" => "The object type of the point recipient. Usually 'user' but can also be article, trackeritem, etc. Can also use '(eval type)' to get the type of the object being triggered by the event",
// "Pts recipient" => "Pts recipient",
// "The ID of the points recipient" => "The ID of the points recipient",
// "This is the value for the ID of the recipient. It is retrieved by evaluating the event parameters. Using 'user' for example, would retrieve the user triggering the event. 'object' would retrieve the ID of the object on which the event is being triggered" => "This is the value for the ID of the recipient. It is retrieved by evaluating the event parameters. Using 'user' for example, would retrieve the user triggering the event. 'object' would retrieve the ID of the object on which the event is being triggered",
// "Points Given" => "Points Given",
// "This is the numerical value of the points being given" => "This is the numerical value of the points being given",
// "Triggering event" => "Triggering event",
// "Reversal event" => "Reversal event",
// "Valid Triggering Object IDs" => "Valid Triggering Object IDs",
// "Valid Object Ids" => "Valid Object Ids",
// "This is a comma-separated list of object ids for which the event is valid" => "This is a comma-separated list of object ids for which the event is valid",
// "Min. Time Between Scoring" => "Min. Time Between Scoring",
// "Time between scoring" => "Time between scoring",
// "This is the amount of time in seconds that a user must wait before again being able to get points for this event" => "This is the amount of time in seconds that a user must wait before again being able to get points for this event",
// "can be seen on page" => "can be seen on page",
// "in Admin menu" => "in Admin menu",
// "Also see the Search Indexing tab" => "Also see the Search Indexing tab",
// "File Gallery admin panel" => "File Gallery admin panel",
// "About the Unified Index" => "About the Unified Index",
// "The Unified Index provides many underlying features for Tiki, including object selectors for translations amongst other things" => "The Unified Index provides many underlying features for Tiki, including object selectors for translations amongst other things",
// "Disabling this will cause some parts of Tiki to be unavailable" => "Disabling this will cause some parts of Tiki to be unavailable",
// "Find out more about it here" => "Find out more about it here",
// "Search engine settings" => "Search engine settings",
// "About Unified search engines" => "About Unified search engines",
// "Advantages" => "Advantages",
// "Fast performance. Works out of the box with Tiki and even on most basic server setups" => "Fast performance. Works out of the box with Tiki and even on most basic server setups",
// "Disadvantages" => "Disadvantages",
// "Many common words (such as \"first\", \"second\", and \"third\" are not searchable unless MySQL configuration is modified). Only the first 65,535 characters (about 8000 words) of long pieces of content are searchable" => "Many common words (such as \"first\", \"second\", and \"third\" are not searchable unless MySQL configuration is modified). Only the first 65,535 characters (about 8000 words) of long pieces of content are searchable",
// "link" => "link",
// " for full list) " => " for full list) ",
// "Lucene (PHP implementation)" => "Lucene (PHP implementation)",
// "Overcomes limitations of MySQL search mentioned above. Comes built in with Tiki" => "Overcomes limitations of MySQL search mentioned above. Comes built in with Tiki",
// "Slower performance. May not work well with the most basic server setups and because the index is stored on disk it is more prone to file permissions problems and other server configuration issues" => "Slower performance. May not work well with the most basic server setups and because the index is stored on disk it is more prone to file permissions problems and other server configuration issues",
// "Most advanced, fast and scalable search engine. Enables some very advanced/new features of Tiki" => "Most advanced, fast and scalable search engine. Enables some very advanced/new features of Tiki",
// "Needs to be separately installed from Tiki and requires more configuration" => "Needs to be separately installed from Tiki and requires more configuration",
// "for more information) " => "for more information) ",
// "About Use MySQL Full-Text Search as fallback" => "About Use MySQL Full-Text Search as fallback",
// "Elasticsearch is a tiki external service. You should set at least a daily full index rebuild to keep the MySQL index updated in case of Elastic unavailability" => "Elasticsearch is a tiki external service. You should set at least a daily full index rebuild to keep the MySQL index updated in case of Elastic unavailability",
// "Elastic search only" => "Elastic search only",
// "Experiment with LIST plugin syntax" => "Experiment with LIST plugin syntax",
// "After you have found the correct contents, you may copy-paste them in a LIST plugin" => "After you have found the correct contents, you may copy-paste them in a LIST plugin",
// "Legacy search" => "Legacy search",
// "Forum searches" => "Forum searches",
// "Search Results" => "Search Results",
// "Items to display in search results" => "Items to display in search results",
// "Information to display for each result" => "Information to display for each result",
// "Stored Search" => "Stored Search",
// "Configuration" => "Configuration",
// "ManifoldCF Configuration Checker" => "ManifoldCF Configuration Checker",
// "Occurrences of string in database" => "Occurrences of string in database",
// "Set default table" => "Set default table",
// "Text to search" => "Text to search",
// "Results for " => "Results for ",
// "in {if isset(\$tableFilter)}table <b>{\$tableFilter|escape}</b>{else}all tables{/if}" => "in {if isset(\$tableFilter)}table <b>{\$tableFilter|escape}</b>{else}all tables{/if}",
// "Occurrences" => "Occurrences",
// "View occurrences" => "View occurrences",
// "in table " => "in table ",
// "column" => "column",
// "Page preview" => "Page preview",
"View page" => "觀看頁面",
// "View blog post" => "View blog post",
// "View file" => "View file",
// "View gallery" => "View gallery",
// "View category" => "View category",
// "View article" => "View article",
// "View forum" => "View forum",
// "View calendar" => "View calendar",
// "View calendar item" => "View calendar item",
// "View tracker" => "View tracker",
// "View tracker item" => "View tracker item",
// "View forum comment" => "View forum comment",
// "Back to first level results" => "Back to first level results",
"Admin groups" => "管理者群組",
// "Admin Groups" => "Admin Groups",
"Admin users" => "管理者",
// "Admin Users" => "Admin Users",
// "Manage permissions" => "Manage permissions",
// "Please see the <a class='alert-link' target='tikihelp' href='http://dev.tiki.org/Security'>Security page</a> on Tiki's developer site" => "Please see the <a class='alert-link' target='tikihelp' href='http://dev.tiki.org/Security'>Security page</a> on Tiki's developer site",
// "See <a class=\"alert-link\" href=\"tiki-admin_security.php\" title=\"Security\"><strong>Security Admin</strong></a> for additional security settings" => "See <a class=\"alert-link\" href=\"tiki-admin_security.php\" title=\"Security\"><strong>Security Admin</strong></a> for additional security settings",
// "General Security" => "General Security",
// "MySQL SSL connection" => "MySQL SSL connection",
// "MySQL SSL connection is active" => "MySQL SSL connection is active",
// "MySQL connection is not encrypted" => "MySQL connection is not encrypted",
// "To activate SSL, copy the keyfiles (.pem) til db/cert folder. The filenames must end with \"-key.pem\", \"-cert.pem\", \"-ca.pem\"" => "To activate SSL, copy the keyfiles (.pem) til db/cert folder. The filenames must end with \"-key.pem\", \"-cert.pem\", \"-ca.pem\"",
// "MySQL Server does not have SSL activated" => "MySQL Server does not have SSL activated",
// "Smarty and Features Security" => "Smarty and Features Security",
// "Please also see" => "Please also see",
// "HTTPS (SSL) and other login preferences" => "HTTPS (SSL) and other login preferences",
// "User Encryption" => "User Encryption",
// "Requires the OpenSSL PHP extension for encryption" => "Requires the OpenSSL PHP extension for encryption",
// "You have OpenSSL installed" => "You have OpenSSL installed",
// "OpenSSL is not loaded" => "OpenSSL is not loaded",
// "User Encryption requires the PHP extension OpenSSL for encryption.\n\t\t\t\t\t\t\tYou should activate OpenSSL before activating User Encryption" => "User Encryption requires the PHP extension OpenSSL for encryption.\n\t\t\t\t\t\t\tYou should activate OpenSSL before activating User Encryption",
// "You may also want to add the Domain Password module somewhere" => "You may also want to add the Domain Password module somewhere",
// "Comma-separated list of password domains, e.g.: Company ABC,Company XYZ" => "Comma-separated list of password domains, e.g.: Company ABC,Company XYZ",
// "The user can add passwords for a registered password domain" => "The user can add passwords for a registered password domain",
// "Statistics for existing data" => "Statistics for existing data",
// "When no data which was encoded by MCrypt in Tiki versions prior to 18 is present, User Encryption does not need the MCrypt PHP extension" => "When no data which was encoded by MCrypt in Tiki versions prior to 18 is present, User Encryption does not need the MCrypt PHP extension",
// "CSRF security" => "CSRF security",
// "Use these options to protect against cross-site request forgeries (CSRF)" => "Use these options to protect against cross-site request forgeries (CSRF)",
// "HTTP Headers" => "HTTP Headers",
// "Use these options to add options related with security to the HTTP Headers" => "Use these options to add options related with security to the HTTP Headers",
// "Spam Protection" => "Spam Protection",
// "You can additionally protect from spam enabling the \"<a href=\"http://doc.tiki.org/Forum+Admin#Forum_moderation\" target=\"_blank\" class=\"alert-link\">moderation queue on forums</a>\", or through <strong>banning</strong> multiple ip's from the \"<a href=\"tiki-admin_actionlog.php\" target=\"_blank\" class=\"alert-link\">Action log</a>\", from \"<a href=\"tiki-adminusers.php\" target=\"_blank\" class=\"alert-link\">Users registration</a>\", or from the \"<a href=\"tiki-list_comments.php\" target=\"_blank\" class=\"alert-link\">Comments moderation queue</a>\" itself" => "You can additionally protect from spam enabling the \"<a href=\"http://doc.tiki.org/Forum+Admin#Forum_moderation\" target=\"_blank\" class=\"alert-link\">moderation queue on forums</a>\", or through <strong>banning</strong> multiple ip's from the \"<a href=\"tiki-admin_actionlog.php\" target=\"_blank\" class=\"alert-link\">Action log</a>\", from \"<a href=\"tiki-adminusers.php\" target=\"_blank\" class=\"alert-link\">Users registration</a>\", or from the \"<a href=\"tiki-list_comments.php\" target=\"_blank\" class=\"alert-link\">Comments moderation queue</a>\" itself",
"Search results" => "搜尋結果",
// "Site Access" => "Site Access",
// "Admin IDS custom rules" => "Admin IDS custom rules",
// "Tokens" => "Tokens",
// "To manage tokens go to <a href=\"tiki-admin_tokens.php\" class=\"alert-link\">Admin Tokens</a> page. Tokens are also used for the Temporary Users feature (see <a href=\"tiki-adminusers.php\" class=\"alert-link\">Admin Users</a>)" => "To manage tokens go to <a href=\"tiki-admin_tokens.php\" class=\"alert-link\">Admin Tokens</a> page. Tokens are also used for the Temporary Users feature (see <a href=\"tiki-adminusers.php\" class=\"alert-link\">Admin Users</a>)",
// "OpenPGP" => "OpenPGP",
// "OpenPGP functionality for PGP/MIME encrypted email messaging" => "OpenPGP functionality for PGP/MIME encrypted email messaging",
// "Experimental OpenPGP fuctionality for PGP/MIME encrypted email messaging" => "Experimental OpenPGP fuctionality for PGP/MIME encrypted email messaging",
// "All email-messaging/notifications/newsletters are sent as PGP/MIME-encrypted messages, signed with the signer-key, and are completely 100% opaque to outsiders. All user accounts need to be properly configured into gnupg keyring with public-keys related to their tiki-account-related email-addresses" => "All email-messaging/notifications/newsletters are sent as PGP/MIME-encrypted messages, signed with the signer-key, and are completely 100% opaque to outsiders. All user accounts need to be properly configured into gnupg keyring with public-keys related to their tiki-account-related email-addresses",
// "If you use preferences option for the signer passphrase, clear the file option just for security" => "If you use preferences option for the signer passphrase, clear the file option just for security",
// "If you use file for the signer passphrase, clear the preferences option just for security" => "If you use file for the signer passphrase, clear the preferences option just for security",
// "The email of preference <a href=\"tiki-admin.php?page=general&alt=General\" class=\"alert-link\">'sender_email'</a> is used as signer key ID, and it must have both private and public key in the gnupg keyring" => "The email of preference <a href=\"tiki-admin.php?page=general&alt=General\" class=\"alert-link\">'sender_email'</a> is used as signer key ID, and it must have both private and public key in the gnupg keyring",
// "SEFURL requires the <strong>URL Rewrite module</strong> for IIS. You do not seem to have this module installed" => "SEFURL requires the <strong>URL Rewrite module</strong> for IIS. You do not seem to have this module installed",
// "Please see <a class=\"alert-link\" href=\"http://doc.tiki.org/Windows+Server+Install\">Windows Server Install</a> on tiki.org for more information" => "Please see <a class=\"alert-link\" href=\"http://doc.tiki.org/Windows+Server+Install\">Windows Server Install</a> on tiki.org for more information",
// "SEFURL will not work unless Tiki specific directives are deployed to the %0 file" => "SEFURL will not work unless Tiki specific directives are deployed to the %0 file",
// "To enable this file, simply copy the %0 file (located in the main directory of your Tiki installation) to %1" => "To enable this file, simply copy the %0 file (located in the main directory of your Tiki installation) to %1",
// "If you need to keep an existing (non Tiki) %0 file, just add Tiki directives to it" => "If you need to keep an existing (non Tiki) %0 file, just add Tiki directives to it",
// "When you upgrade Tiki (e.g. from version 7 to version 8), make sure to make use of the new URL rewriting configuration file" => "When you upgrade Tiki (e.g. from version 7 to version 8), make sure to make use of the new URL rewriting configuration file",
// "%0 file is missing" => "%0 file is missing",
// "Unable to verify that your URL rewriting configuration is up to date" => "Unable to verify that your URL rewriting configuration is up to date",
// "SEFURL may not work completely or correctly if Tiki URL rewriting configuration is not current" => "SEFURL may not work completely or correctly if Tiki URL rewriting configuration is not current",
// "%0 is not in the expected format" => "%0 is not in the expected format",
// "%0 may simply be outdated" => "%0 may simply be outdated",
// "To update this file, if it was not customized, copy the %0 file (located in the main directory of your Tiki installation) to %1, overwriting the latter" => "To update this file, if it was not customized, copy the %0 file (located in the main directory of your Tiki installation) to %1, overwriting the latter",
// "%0 file is out of date" => "%0 file is out of date",
// "The RewriteBase directive seems not to be set up correctly. This is required for sefurl to function correctly" => "The RewriteBase directive seems not to be set up correctly. This is required for sefurl to function correctly",
// "The current value in %0 is %1 but the base url for this site is %2" => "The current value in %0 is %1 but the base url for this site is %2",
// "For example, if the field is left blank, the canonical URL domain is" => "For example, if the field is left blank, the canonical URL domain is",
// "URL parameters" => "URL parameters",
// "List of Url Parameters that should go in the path" => "List of Url Parameters that should go in the path",
// "Known types" => "Known types",
// "Invert" => "Invert",
// "Show Usage" => "Show Usage",
// "Delete &amp; Unreference" => "Delete &amp; Unreference",
// "Invert Relation" => "Invert Relation",
// "New types" => "New types",
// "Fix" => "Fix",
// "No occurences found" => "No occurences found",
// "If you don't want to limit it, an input box will be displayed; otherwise, it will be checkbox" => "If you don't want to limit it, an input box will be displayed; otherwise, it will be checkbox",
// "Social network integration" => "Social network integration",
// "To use Twitter integration, you must register this site as an application at" => "To use Twitter integration, you must register this site as an application at",
// "and allow write access for the application" => "and allow write access for the application",
// "Enter &lt;your site URL&gt;tiki-socialnetworks.php as callback URL" => "Enter &lt;your site URL&gt;tiki-socialnetworks.php as callback URL",
// "To use Facebook integration, you must register this site as an application at" => "To use Facebook integration, you must register this site as an application at",
// "and allow extended access for the application" => "and allow extended access for the application",
// "Enter &lt;your site URL&gt;tiki-socialnetworks.php?request_facebook as Site URL and &lt;your site&gt; as Site Domain" => "Enter &lt;your site URL&gt;tiki-socialnetworks.php?request_facebook as Site URL and &lt;your site&gt; as Site Domain",
// "The following preferences affect what permissions the user is asked to allow Tiki to do by Facebook when authorizing it" => "The following preferences affect what permissions the user is asked to allow Tiki to do by Facebook when authorizing it",
// "bit.ly" => "bit.ly",
// "There is no need to set up a site-wide bit.ly account; every user can have his or her own, but this allows for site-wide statistics" => "There is no need to set up a site-wide bit.ly account; every user can have his or her own, but this allows for site-wide statistics",
// "Go to" => "Go to",
// "to sign up for an account" => "to sign up for an account",
// "to retrieve the API key" => "to retrieve the API key",
// "To use LinkedIn integration, you must register this site as an application at" => "To use LinkedIn integration, you must register this site as an application at",
// "and allow necessary permissions for the application" => "and allow necessary permissions for the application",
// "Enter &lt;your site URL&gt;tiki-socialnetworks_linkedin.php as Authorized OAuth Redirect URLs" => "Enter &lt;your site URL&gt;tiki-socialnetworks_linkedin.php as Authorized OAuth Redirect URLs",
// "Share This" => "Share This",
// "This is a new control panel on Tiki and work is still in progress" => "This is a new control panel on Tiki and work is still in progress",
// "Tiki Statistics" => "Tiki Statistics",
// "Piwik Analytics" => "Piwik Analytics",
// "Text area (that apply throughout many features)" => "Text area (that apply throughout many features)",
// "Wiki syntax" => "Wiki syntax",
// "Typography" => "Typography",
// "Default size" => "Default size",
// "External links and images" => "External links and images",
// "External links will be identified with" => "External links will be identified with",
// "About plugins" => "About plugins",
// "Tiki plugins add functionality to wiki pages, articles, blogs, and so on. You can enable and disable them below" => "Tiki plugins add functionality to wiki pages, articles, blogs, and so on. You can enable and disable them below",
// "You can approve plugin use at <a href=\"tiki-plugins.php\" class=\"alert-link\">tiki-plugins.php</a>" => "You can approve plugin use at <a href=\"tiki-plugins.php\" class=\"alert-link\">tiki-plugins.php</a>",
// "The edit-plugin icon is an easy way for users to edit the parameters of each plugin in wiki pages. It can be disabled for individual plugins below" => "The edit-plugin icon is an easy way for users to edit the parameters of each plugin in wiki pages. It can be disabled for individual plugins below",
// "Check disabled plugins used in wiki pages" => "Check disabled plugins used in wiki pages",
// "Disabled used plugins" => "Disabled used plugins",
// "Plugin preferences" => "Plugin preferences",
// "Edit plugin icons" => "Edit plugin icons",
// "Plugin List" => "Plugin List",
// "Use the filter input above to find plugins, or enter return to see the whole list" => "Use the filter input above to find plugins, or enter return to see the whole list",
// "Search Help" => "Search Help",
// "Disable edit plugin icon (make plugin inline)" => "Disable edit plugin icon (make plugin inline)",
// "Plugin Aliases" => "Plugin Aliases",
// "About plugin aliases" => "About plugin aliases",
// "Tiki plugin aliases allow you to define your own custom configurations of existing plugins" => "Tiki plugin aliases allow you to define your own custom configurations of existing plugins",
// "Find out more here" => "Find out more here",
// "This page is designed to work with JavaScript" => "This page is designed to work with JavaScript",
// "Available alias" => "Available alias",
// "Plugin Alias" => "Plugin Alias",
// "Enable Checked Plugins" => "Enable Checked Plugins",
// "General information" => "General information",
// "Plugin name" => "Plugin name",
// "Base plugin" => "Base plugin",
// "Body label" => "Body label",
// "Dependencies" => "Dependencies",
// "Inline (no plugin edit UI)" => "Inline (no plugin edit UI)",
// "Simple plugin arguments" => "Simple plugin arguments",
// "Add parameter" => "Add parameter",
// "Argument" => "Argument",
// "Delete this parameter" => "Delete this parameter",
// "Default Value" => "Default Value",
// "Plugin parameter documentation" => "Plugin parameter documentation",
// "Add parameter documentation" => "Add parameter documentation",
// "Delete this parameter's documentation" => "Delete this parameter's documentation",
// "Safe" => "Safe",
// "Plugin body" => "Plugin body",
// "Ignore user input" => "Ignore user input",
// "Default content" => "Default content",
// "Body Parameters" => "Body Parameters",
// "Add body parameter" => "Add body parameter",
// "Delete this body parameter" => "Delete this body parameter",
// "Encoding" => "Encoding",
// "Argument source (if different)" => "Argument source (if different)",
// "Composed plugin arguments" => "Composed plugin arguments",
// "Add composed parameter" => "Add composed parameter",
// "Delete this composed argument" => "Delete this composed argument",
// "Pattern" => "Pattern",
// "Composed parameters" => "Composed parameters",
// "Delete this composed parameter" => "Delete this composed parameter",
// "Tracker settings" => "Tracker settings",
// "Field settings" => "Field settings",
// "Linked wiki pages" => "Linked wiki pages",
// "Wiki pages are linked to tracker items, and their page names to tracker fields, via the tiki.wiki.linkeditem and tiki.wiki.linkedfield relations. You need to be familiar with the Relations tracker field or use the outputwiki option in the TRACKER plugin to make use of these features" => "Wiki pages are linked to tracker items, and their page names to tracker fields, via the tiki.wiki.linkeditem and tiki.wiki.linkedfield relations. You need to be familiar with the Relations tracker field or use the outputwiki option in the TRACKER plugin to make use of these features",
// "Tracker attachment preferences" => "Tracker attachment preferences",
// "Tracker force-fill feature" => "Tracker force-fill feature",
// "Field Types" => "Field Types",
// "Field types" => "Field types",
// "Tracker attachments" => "Tracker attachments",
"dls" => "下傳數",
// "Switch storage" => "Switch storage",
// "Change all to db" => "Change all to db",
// "Change all to file" => "Change all to file",
// "User Settings" => "User Settings",
// "Default user preferences" => "Default user preferences",
// "Users Default Preferences" => "Users Default Preferences",
// "My Account Items" => "My Account Items",
// "User Features" => "User Features",
// "User Account Features" => "User Account Features",
// "User Info and Picture" => "User Info and Picture",
"User information display" => "顯示使用者資料",
// "Messaging and Notifications" => "Messaging and Notifications",
// "User notifications" => "User notifications",
// "For the digest emails to be sent out, you will need to set-up a cron job" => "For the digest emails to be sent out, you will need to set-up a cron job",
// "Adjust the command parameters for your digest frequency. Default frequency is 7 days" => "Adjust the command parameters for your digest frequency. Default frequency is 7 days",
// "Sample command" => "Sample command",
"User Files" => "使用者檔案",
// "Kaltura" => "Kaltura",
// "Kaltura Registration" => "Kaltura Registration",
// "To get a Kaltura Partner ID" => "To get a Kaltura Partner ID",
// "Setup your own instance of Kaltura Community Edition (CE)" => "Setup your own instance of Kaltura Community Edition (CE)",
// "get an account via Kaltura.com" => "get an account via Kaltura.com",
// "List Media" => "List Media",
// "List Remix Entries" => "List Remix Entries",
// "Add New Media" => "Add New Media",
// "Plugin to embed in pages" => "Plugin to embed in pages",
// "Enable related tracker field types" => "Enable related tracker field types",
// "Kaltura / Tiki config" => "Kaltura / Tiki config",
// "Kaltura partner settings" => "Kaltura partner settings",
// "Kaltura dynamic player" => "Kaltura dynamic player",
// "Kaltura contribution wizard" => "Kaltura contribution wizard",
// "You can manually edit these values in lib/videogals/standardTikiKcw.xml" => "You can manually edit these values in lib/videogals/standardTikiKcw.xml",
// "Recreate KCW \"uiConf\"" => "Recreate KCW \"uiConf\"",
// "Legacy support" => "Legacy support",
// "Webservices" => "Webservices",
// "Use the 'Quick Edit' module to easily create or edit wiki pages" => "Use the 'Quick Edit' module to easily create or edit wiki pages",
// "List wiki pages" => "List wiki pages",
// "List structures" => "List structures",
// "Page display" => "Page display",
// "Automatic table of contents" => "Automatic table of contents",
// "General features" => "General features",
"Export Wiki Pages" => "匯出 Wiki 頁面",
// "Redirect and Similar" => "Redirect and Similar",
// "Wikiwords Features" => "Wikiwords Features",
// "If you change storage, it is better to move all the files for easy backup.." => "If you change storage, it is better to move all the files for easy backup..",
// "Move all attachments to database" => "Move all attachments to database",
// "Move all attachments to file system" => "Move all attachments to file system",
"Remove unused pictures" => "移除未使用的圖片",
// "Move images from wiki_up to the home file gallery" => "Move images from wiki_up to the home file gallery",
// "Move images to home gallery" => "Move images to home gallery",
// "If you use these buttons please make sure to have a backup of the database and the directory wiki_up" => "If you use these buttons please make sure to have a backup of the database and the directory wiki_up",
// "Wiki watch" => "Wiki watch",
// "Namespaces" => "Namespaces",
// "Settings that may be affected by the namespace separator" => "Settings that may be affected by the namespace separator",
// "Flagged Revision" => "Flagged Revision",
// "Page Listings" => "Page Listings",
// "Select which items to display when listing pages" => "Select which items to display when listing pages",
// "Database dumps and restores" => "Database dumps and restores",
// "Name for dump" => "Name for dump",
// "Create Database Dump" => "Create Database Dump",
// "Wiki database" => "Wiki database",
// "Restore" => "Restore",
// "Dump files" => "Dump files",
// "Dump files archive wiki pages for various usages such as off-line browsing or distribution on optical disks" => "Dump files archive wiki pages for various usages such as off-line browsing or distribution on optical disks",
// "The HTML files generated may refer to files not included in the dump" => "The HTML files generated may refer to files not included in the dump",
// "Dumps do not include files attached to wiki pages" => "Dumps do not include files attached to wiki pages",
// "Dumping will overwrite the preexisting dump" => "Dumping will overwrite the preexisting dump",
// "Create Dump File" => "Create Dump File",
// "Download Dump File" => "Download Dump File",
// "Remove Dump File" => "Remove Dump File",
// "Mass replace and page permissions report" => "Mass replace and page permissions report",
// "Mass search and replace" => "Mass search and replace",
// "Report wiki pages with direct object permissions" => "Report wiki pages with direct object permissions",
"Wiki attachments" => "Wiki 附件",
// "Move attachment to database" => "Move attachment to database",
// "Move to database" => "Move to database",
// "Move attachment to file system" => "Move attachment to file system",
// "Move to file system" => "Move to file system",
// "Exclusive" => "Exclusive",
// "Share Common" => "Share Common",
// "Edit perspective" => "Edit perspective",
// "No areas found. Click \"Update Areas\" to populate this list" => "No areas found. Click \"Update Areas\" to populate this list",
// "This tab shows you an overview of categories affected by the areas feature. <br> More help here: <a href=\"http://doc.tiki.org/Areas\" target=\"tikihelp\" class=\"alert-link\">doc.tiki.org/Areas</a> " => "This tab shows you an overview of categories affected by the areas feature. <br> More help here: <a href=\"http://doc.tiki.org/Areas\" target=\"tikihelp\" class=\"alert-link\">doc.tiki.org/Areas</a> ",
// "Update areas" => "Update areas",
// "WYSIWYG means What You See Is What You Get, and is handled in Tiki by <a class=\"alert-link\" href=\"http://ckeditor.com/\">CKEditor</a>" => "WYSIWYG means What You See Is What You Get, and is handled in Tiki by <a class=\"alert-link\" href=\"http://ckeditor.com/\">CKEditor</a>",
// "Page links" => "Page links",
// "Note that if the SEFURL feature is on, page links created using wysiwyg might not be automatically updated when pages are renamed. This is addressed through the \"Use Wiki syntax in WYSIWYG\" feature" => "Note that if the SEFURL feature is on, page links created using wysiwyg might not be automatically updated when pages are renamed. This is addressed through the \"Use Wiki syntax in WYSIWYG\" feature",
// "WYSIWYG editor features" => "WYSIWYG editor features",
// "Related features" => "Related features",
// "{\$sect|capitalize}" => "{\$sect|capitalize}",
"Position" => "位置",
"Cache Time" => "快取時間",
"secs" => "秒",
// "Use Ctrl+Click to select multiple options" => "Use Ctrl+Click to select multiple options",
// "The" => "The",
// "Display Modules to All Groups" => "Display Modules to All Groups",
// "setting will override your selection of specific groups" => "setting will override your selection of specific groups",
// "Displayed now for all eligible users even with personal assigned modules" => "Displayed now for all eligible users even with personal assigned modules",
// "Displayed for the eligible users with no personal assigned modules" => "Displayed for the eligible users with no personal assigned modules",
// "Displayed now, can't be unassigned" => "Displayed now, can't be unassigned",
// "Not displayed until a user chooses it" => "Not displayed until a user chooses it",
// "Because <a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">Users can Configure Modules</a>, select either" => "Because <a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">Users can Configure Modules</a>, select either",
// "to make sure users will notice any newly assigned modules" => "to make sure users will notice any newly assigned modules",
// "required" => "required",
// "Params: specific params to the module and/or general params ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme', 'notitle', 'nopage'). Separator between params:'&amp;'. E.g. maxlen=15&amp;nonums=y" => "Params: specific params to the module and/or general params ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme', 'notitle', 'nopage'). Separator between params:'&amp;'. E.g. maxlen=15&amp;nonums=y",
// "Enter the parameters in URL format, e.g. 'nobox=y&class=rbox-data'" => "Enter the parameters in URL format, e.g. 'nobox=y&class=rbox-data'",
// "Edit custom module" => "Edit custom module",
// "Enter the code below" => "Enter the code below",
// "Anti-Bot verification code image" => "Anti-Bot verification code image",
// "Try another code" => "Try another code",
// "Your article has been added" => "Your article has been added",
// "Create Article" => "Create Article",
// "Expires" => "Expires",
// "Users rating: " => "Users rating: ",
// "{\$topicName}" => "{\$topicName}",
// "List all articles of the same topic" => "List all articles of the same topic",
// "{\$topicName|escape}" => "{\$topicName|escape}",
// "{\$topics[\$topicId].name|escape}" => "{\$topics[\$topicId].name|escape}",
// "You do not have permission to read complete articles" => "You do not have permission to read complete articles",
"First page" => "首頁",
"Previous page" => "前一頁",
"Next page" => "後一頁",
"Last page" => "末頁",
// "Related content" => "Related content",
"bytes" => "位元組",
// "Article actions" => "Article actions",
// "Send a link" => "Send a link",
// "Get a short URL" => "Get a short URL",
// "Attached files" => "Attached files",
"Upload file" => "上傳檔案",
// "File upload comment" => "File upload comment",
"Attach" => "附檔",
"Attach a file to this item" => "夾帶一個檔案至此項目",
// "{\$attfields[ix]}" => "{\$attfields[ix]}",
// "more info" => "more info",
"No attachments for this item" => "此項目無附件",
// "Blog actions" => "Blog actions",
// "Blog Actions" => "Blog Actions",
"Monitor" => "監控",
// "Stop monitoring" => "Stop monitoring",
// "Group Monitor" => "Group Monitor",
"RSS" => "RSS",
// "Watched by categories" => "Watched by categories",
// "Blog post actions" => "Blog post actions",
"Save to notepad" => "儲存到筆記本",
// "Published By" => "Published By",
"Publish Date" => "發表日期",
// "Previous post" => "Previous post",
// "Next post" => "Next post",
// "More.." => "More..",
"pages" => "頁面",
"Last" => "最近",
"private" => "私人",
"permanent link" => "固定連結",
// "Leave a comment" => "Leave a comment",
// "%0 comment" => "%0 comment",
// "%0 comments" => "%0 comments",
// "{\$item.name}" => "{\$item.name}",
// "{\$sub.name}" => "{\$sub.name}",
// "Parent Gallery" => "Parent Gallery",
// "Select Categories" => "Select Categories",
// "Admin Categories" => "Admin Categories",
// "Select/deselect all categories" => "Select/deselect all categories",
"No categories defined" => "尚未定義類別",
// "Browse Category" => "Browse Category",
// "Are you sure you want to archive this comment" => "Are you sure you want to archive this comment",
// "Are you sure you want to unarchive this comment" => "Are you sure you want to unarchive this comment",
// "Edit Comment" => "Edit Comment",
// "Comments unlocked" => "Comments unlocked",
"Post new comment" => "發表新評論",
// "There are no comments at this time" => "There are no comments at this time",
"Add Comment" => "增加評論",
// "Reply" => "Reply",
// "Archived" => "Archived",
// "Unarchive" => "Unarchive",
// "Archive" => "Archive",
// "Rejected" => "Rejected",
"Approve" => "同意",
"Reject" => "駁回",
// "Are you sure you want to lock comments on this object" => "Are you sure you want to lock comments on this object",
// "Are you sure you want to approve this comment" => "Are you sure you want to approve this comment",
// "Are you sure you want to reject this comment" => "Are you sure you want to reject this comment",
// "Go back to" => "Go back to",
// "You are currently registered on this site. This section is optional. By filling it, you will not link this post to your account and preserve your anonymity" => "You are currently registered on this site. This section is optional. By filling it, you will not link this post to your account and preserve your anonymity",
// "Website" => "Website",
// "Send me an email when someone replies" => "Send me an email when someone replies",
// "Are you sure you want to delete this comment" => "Are you sure you want to delete this comment",
// "Are you sure you want to unlock comments on this object" => "Are you sure you want to unlock comments on this object",
// "Posted by" => "Posted by",
// "Private message" => "Private message",
"private message" => "私人訊息",
// "Send eMail to user" => "Send eMail to user",
// "User online" => "User online",
// "User offline" => "User offline",
// "Download attachment" => "Download attachment",
// "Remove attachment" => "Remove attachment",
// "Deliberation Items" => "Deliberation Items",
// "top of page" => "top of page",
// "Notification" => "Notification",
// "Delete post" => "Delete post",
// "Report this post" => "Report this post",
// "Group monitor" => "Group monitor",
// "Moderator actions for selected topics" => "Moderator actions for selected topics",
// "Reported messages" => "Reported messages",
// "Reported" => "Reported",
// "Queued messages" => "Queued messages",
// "Queued" => "Queued",
"Threshold" => "起算點",
"Replies" => "回覆數",
// "below your current threshold" => "below your current threshold",
// "New Reply" => "New Reply",
// "Editing reply" => "Editing reply",
// "Reply to the selected post" => "Reply to the selected post",
// "Post new message" => "Post new message",
// "If you would like to be notified when someone replies to this topic<br>please tell us your e-mail address" => "If you would like to be notified when someone replies to this topic<br>please tell us your e-mail address",
// "Maximum size" => "Maximum size",
// "Reply to parent post" => "Reply to parent post",
// "Post new reply" => "Post new reply",
// "Post as Anonymous" => "Post as Anonymous",
// "Please note that the preview does not keep the attached file which you will have to choose before posting" => "Please note that the preview does not keep the attached file which you will have to choose before posting",
// "Posting replies" => "Posting replies",
// "Please enter a title" => "Please enter a title",
"1 comment" => "1 篇評論",
"Go back" => "回上頁",
"Return to home page" => "返回首頁",
// "Type of contribution" => "Type of contribution",
// "No contribution records found" => "No contribution records found",
// "{\$prefs.cookie_consent_description}" => "{\$prefs.cookie_consent_description}",
// "{\$prefs.cookie_consent_question}" => "{\$prefs.cookie_consent_question}",
// "{\$prefs.cookie_consent_button}" => "{\$prefs.cookie_consent_button}",
"Copyrights" => "版權所有",
// "Authors" => "Authors",
// "Copyright Holder" => "Copyright Holder",
// "Do you really want to remove the %0 route" => "Do you really want to remove the %0 route",
// "Back to tracker list" => "Back to tracker list",
// "System error" => "System error",
// "The following error message was returned" => "The following error message was returned",
// "Database is not currently up to date! Visit <a href=\"tiki-install.php\">Tiki Installer</a> to resolve this issue" => "Database is not currently up to date! Visit <a href=\"tiki-install.php\">Tiki Installer</a> to resolve this issue",
// "If you have shell (SSH) access, you can also use the following, on the command line, from the root of your Tiki installation" => "If you have shell (SSH) access, you can also use the following, on the command line, from the root of your Tiki installation",
// "The query was" => "The query was",
// "The built query was likely" => "The built query was likely",
// "Stacktrace" => "Stacktrace",
// "Tiki is unable to connect to the database" => "Tiki is unable to connect to the database",
// "An error occurred while performing the request" => "An error occurred while performing the request",
"Current URL" => "目前的 URL",
"Command" => "命令",
"exec" => "執行",
"Type <code>help</code> to get list of available commands" => "輸入 <code>help</code> 可取得完整指令列表",
"Page generation debugging log" => "頁面生成除錯用紀錄",
"Features state" => "功能狀態",
"features matched" => "符合的功能",
"Watchlist" => "監視列表",
// "Page discussion" => "Page discussion",
// "This page has been discussed once" => "This page has been discussed once",
// "Access discussion" => "Access discussion",
// "This page has been discussed %0 times" => "This page has been discussed %0 times",
// "Access discussion (%0 replies)" => "Access discussion (%0 replies)",
// "There are no discussions currently on this page" => "There are no discussions currently on this page",
// "Start discussion" => "Start discussion",
// "Duplicate File Gallery" => "Duplicate File Gallery",
// "Duplicate categories" => "Duplicate categories",
// "Duplicate permissions" => "Duplicate permissions",
// "Duplicate" => "Duplicate",
"There are individual permissions set for this file gallery" => "這個檔案庫有獨立的權限設定",
// "Manage Permissions" => "Manage Permissions",
"Properties" => "Properties",
// "{\$gal_info.name}" => "{\$gal_info.name}",
// "Other (%0)" => "Other (%0)",
// "Any file" => "Any file",
// "Podcast (audio)" => "Podcast (audio)",
// "Podcast (video)" => "Podcast (video)",
// "Gallery is visible to non-admin users" => "Gallery is visible to non-admin users",
// "Gallery is unlocked" => "Gallery is unlocked",
// "Users with upload permission can add files to the gallery (not just the gallery owner)" => "Users with upload permission can add files to the gallery (not just the gallery owner)",
// "Respect permissions for backlinks to view a file" => "Respect permissions for backlinks to view a file",
// "Files can be locked at download" => "Files can be locked at download",
// "Maximum number of archives for each file" => "Maximum number of archives for each file",
// "unlimited" => "unlimited",
// "Parent gallery" => "Parent gallery",
// "Owner of the gallery" => "Owner of the gallery",
"Mb" => "Mb",
// "Min" => "Min",
// "Group of users alerted when file gallery is modified" => "Group of users alerted when file gallery is modified",
// "Allows each user to be selected for small groups" => "Allows each user to be selected for small groups",
// "Maximum width of images in gallery" => "Maximum width of images in gallery",
// "If an image is wider than this, it will be resized" => "If an image is wider than this, it will be resized",
// "Attention: In this case, the original image will be lost" => "Attention: In this case, the original image will be lost",
// "Maximum height of images in gallery" => "Maximum height of images in gallery",
// "If an image is higher than this, it will be resized" => "If an image is higher than this, it will be resized",
// "Wiki markup to enter when image selected from \"file gallery manager\"" => "Wiki markup to enter when image selected from \"file gallery manager\"",
// "The default is " => "The default is ",
// "Field names will be replaced when enclosed in % chars. e.g. %fileId%, %name%, %filename%, %description%" => "Field names will be replaced when enclosed in % chars. e.g. %fileId%, %name%, %filename%, %description%",
// "Attributes will be replaced when enclosed in % chars. e.g. %tiki.content.url% for remote file URLs" => "Attributes will be replaced when enclosed in % chars. e.g. %tiki.content.url% for remote file URLs",
// "Display Settings" => "Display Settings",
// "Finder View" => "Finder View",
// "Select which items to display when listing galleries" => "Select which items to display when listing galleries",
"Max description display size" => "最大描述顯示大小",
// "Max rows per page" => "Max rows per page",
// "View inserted gallery after save" => "View inserted gallery after save",
// "File error" => "File error",
// "Perhaps you are looking for" => "Perhaps you are looking for",
// "There are no wiki pages similar to '{\$page|escape}'" => "There are no wiki pages similar to '{\$page|escape}'",
// "Token Error" => "Token Error",
// "Go to Log in Page" => "Go to Log in Page",
// "Create this page" => "Create this page",
// "(page will be orphaned)" => "(page will be orphaned)",
// "Close Window" => "Close Window",
// "Redirecting in %0 seconds" => "Redirecting in %0 seconds",
// "Permission successfully changed" => "Permission successfully changed",
// "Global permission" => "Global permission",
// "</em>\" _2=\$info.objid}Object permission for the %0 %1 (ID %2)" => "</em>\" _2=\$info.objid}Object permission for the %0 %1 (ID %2)",
// "</em>\"}Object permission for the %0 %1" => "</em>\"}Object permission for the %0 %1",
// "Permissions successfully changed" => "Permissions successfully changed",
// "Global permissions" => "Global permissions",
// "</em>\" _2=\$info.objid}Object permissions for the %0 %1 (ID %2)" => "</em>\" _2=\$info.objid}Object permissions for the %0 %1 (ID %2)",
// "</em>\"}Object permissions for the %0 %1" => "</em>\"}Object permissions for the %0 %1",
// "" => "",
// "No permissions were changed" => "No permissions were changed",
// "The following change has been applied" => "The following change has been applied",
// "The following changes have been applied" => "The following changes have been applied",
// "{\$item.mes[0]|stringfix}" => "{\$item.mes[0]|stringfix}",
// "Preference name" => "Preference name",
"Upload" => "上傳",
// "Open as WebFolder" => "Open as WebFolder",
// "Delete gallery" => "Delete gallery",
// "Edit: " => "Edit: ",
// "Display as PDF" => "Display as PDF",
// "Download current version" => "Download current version",
// "Browser display" => "Browser display",
// "Archives" => "Archives",
// "Upload new version" => "Upload new version",
// "Replace draft" => "Replace draft",
// "Upload draft" => "Upload draft",
// "Validate draft" => "Validate draft",
// "Validate your draft" => "Validate your draft",
// "Delete draft" => "Delete draft",
// "Delete your draft" => "Delete your draft",
// "Edit properties" => "Edit properties",
// "Refresh metadata" => "Refresh metadata",
// "Page view" => "Page view",
// "File already locked by %0" => "File already locked by %0",
// "Lock file" => "Lock file",
// "Download and lock" => "Download and lock",
// "Open your draft in WebDAV" => "Open your draft in WebDAV",
// "Open in WebDAV" => "Open in WebDAV",
// "Share a link to this file" => "Share a link to this file",
// "Email a link to this file" => "Email a link to this file",
// "Click here to use the file" => "Click here to use the file",
// "The checkbox is disabled because this preference is disabled globally" => "The checkbox is disabled because this preference is disabled globally",
// "Please enable the preference globally first" => "Please enable the preference globally first",
// "Site administrators can enable the preference" => "Site administrators can enable the preference",
// "Show an icon in a column" => "Show an icon in a column",
// "Search.." => "Search..",
// "Select files" => "Select files",
// "Too many files selected. De-select some files before adding more" => "Too many files selected. De-select some files before adding more",
// "Current Selection" => "Current Selection",
// "Click to remove" => "Click to remove",
// "Upload Files" => "Upload Files",
// "Drop files or " => "Drop files or ",
// "Choose files" => "Choose files",
// "Automatic upload" => "Automatic upload",
// "Last modification: %0" => "Last modification: %0",
// "No files found" => "No files found",
// "Upload from URL" => "Upload from URL",
// "File added" => "File added",
// "Images will be resized to {if \$image_max_size_x} {\$image_max_size_x}px in width{/if}{if \$image_max_size_y} and {\$image_max_size_y}px in height{/if} " => "Images will be resized to {if \$image_max_size_x} {\$image_max_size_x}px in width{/if}{if \$image_max_size_y} and {\$image_max_size_y}px in height{/if} ",
// "Images will not be resized, for resizing edit this tracker field and set image max width and height in \"Options for files\" section" => "Images will not be resized, for resizing edit this tracker field and set image max width and height in \"Options for files\" section",
"Upload File" => "上傳檔案",
// "Or drop files here from your file manager" => "Or drop files here from your file manager",
// "Or drop file here from your file manager" => "Or drop file here from your file manager",
// "Export PDF" => "Export PDF",
// "Start the Slideshow" => "Start the Slideshow",
// "Pause the Slideshow" => "Pause the Slideshow",
// "There are no images to display" => "There are no images to display",
// "Select Files (%0)" => "Select Files (%0)",
// "Sort By" => "Sort By",
// "Sort direction" => "Sort direction",
// "Any" => "Any",
// "Lookup" => "Lookup",
// "Deep search" => "Deep search",
// "Select Tags" => "Select Tags",
// "Include objects without a specified language" => "Include objects without a specified language",
// "View Saved Searches" => "View Saved Searches",
// "Add to filter" => "Add to filter",
// "{\$whatlabel}" => "{\$whatlabel}",
// "Clear Filter" => "Clear Filter",
// "any type" => "any type",
// "Article Topic" => "Article Topic",
// "any topic" => "any topic",
// "any language" => "any language",
// "not in" => "not in",
// "Date From" => "Date From",
// "Date To" => "Date To",
// "any category" => "any category",
// "Multiple select" => "Multiple select",
// "{\$value}" => "{\$value}",
// "{\$duration.label}" => "{\$duration.label}",
// "Orphans" => "Orphans",
// "{\$find_other}" => "{\$find_other}",
// "Displayed rows" => "Displayed rows",
// "Hide Map" => "Hide Map",
// "Show Map" => "Show Map",
// "Module errors" => "Module errors",
// "The following modules could not be loaded" => "The following modules could not be loaded",
"Change" => "更改",
// "Show PHP error messages" => "Show PHP error messages",
// "Put tags separated by spaces. For tags with more than one word, use no spaces and put words together or enclose them with double quotes" => "Put tags separated by spaces. For tags with more than one word, use no spaces and put words together or enclose them with double quotes",
// "Untag" => "Untag",
// "Goal" => "Goal",
// "Eligible Groups" => "Eligible Groups",
// "No eligible groups" => "No eligible groups",
// "No goals configured yet" => "No goals configured yet",
// "Goal Administration" => "Goal Administration",
// "%0 was removed" => "%0 was removed",
// "Are you sure you want to delete %0" => "Are you sure you want to delete %0",
// "View Goal" => "View Goal",
// "Eligibility" => "Eligibility",
// "Goal Attribution" => "Goal Attribution",
// "Individual Goal" => "Individual Goal",
// "Group Goal" => "Group Goal",
// "Range Type" => "Range Type",
// "Rolling" => "Rolling",
// "Fixed" => "Fixed",
// "Time span" => "Time span",
// "In days" => "In days",
// "YYYY-MM-DD HH:MM:SS" => "YYYY-MM-DD HH:MM:SS",
// "Rewards are given to individuals achieving the goal or group members for group goals" => "Rewards are given to individuals achieving the goal or group members for group goals",
// "Changes will not be saved" => "Changes will not be saved",
// "Your changes to conditions are not saved until you save the goal" => "Your changes to conditions are not saved until you save the goal",
"Operator" => "服務員",
// "At Least" => "At Least",
// "At Most" => "At Most",
// "Metric" => "Metric",
// "Event Type" => "Event Type",
// "Badge" => "Badge",
// "Hide condition from users" => "Hide condition from users",
// "Members of" => "Members of",
// "Your changes to rewards are not saved until you save the goal" => "Your changes to rewards are not saved until you save the goal",
// "Credit Type" => "Credit Type",
// "Credit Quantity" => "Credit Quantity",
// "Hide reward from users" => "Hide reward from users",
// "No conditions yet" => "No conditions yet",
// "Add Condition" => "Add Condition",
// "No rewards yet" => "No rewards yet",
// "Add Reward" => "Add Reward",
// "Modify Eligibility" => "Modify Eligibility",
// "No groups are eligible to this goal" => "No groups are eligible to this goal",
// "Major Version" => "Major Version",
// "Minor Version" => "Minor Version",
// "Tutorial URL" => "Tutorial URL",
// "Restricted" => "Restricted",
// "Return to list" => "Return to list",
// "Images Galleries" => "Images Galleries",
"Edit this page" => "編輯此頁面",
// "RSS Wiki" => "RSS Wiki",
// "RSS Blogs" => "RSS Blogs",
// "RSS Articles" => "RSS Articles",
// "RSS Image Galleries" => "RSS Image Galleries",
// "RSS File Galleries" => "RSS File Galleries",
// "RSS Forums" => "RSS Forums",
// "RSS Directories" => "RSS Directories",
// "RSS Calendars" => "RSS Calendars",
// "RSS Tracker" => "RSS Tracker",
// "Use Selected Icon" => "Use Selected Icon",
// "Do you really want to remove the custom IDS rule with Id %0" => "Do you really want to remove the custom IDS rule with Id %0",
// "Back to IDS Rules list" => "Back to IDS Rules list",
// "Toggle interactive translation" => "Toggle interactive translation",
// "Once checked, click on any string to translate it" => "Once checked, click on any string to translate it",
// "Turn off interactive translation" => "Turn off interactive translation",
// "Interactive Translation" => "Interactive Translation",
"Translation" => "翻譯",
// "Couldn't find any translatable string" => "Couldn't find any translatable string",
// "Save translations" => "Save translations",
// "Changes will be applied on next page load only" => "Changes will be applied on next page load only",
// "Upload Successful" => "Upload Successful",
// "custom.php" => "custom.php",
// "Download custom.php file for the selected language" => "Download custom.php file for the selected language",
// "custom.json" => "custom.json",
// "Download custom.json file for the selected language" => "Download custom.json file for the selected language",
// "Custom translation file does not exist. Save a custom translation to create the file" => "Custom translation file does not exist. Save a custom translation to create the file",
// "Translations" => "Translations",
// "Translation text" => "Translation text",
// "Add a new row" => "Add a new row",
// "Add row" => "Add row",
// "Customized String Translations" => "Customized String Translations",
// "Manage custom translations" => "Manage custom translations",
// "Process Type" => "Process Type",
// "Select how the uploaded translations should be processed" => "Select how the uploaded translations should be processed",
// "No translations in the database available to export" => "No translations in the database available to export",
// "Translations in the database" => "Translations in the database",
// "Merge all translations, whether or not they are marked as general (for contribution)" => "Merge all translations, whether or not they are marked as general (for contribution)",
// "The translations in the database will be merged with the other translations in language.php. After writing translations to language.php the translations are removed from the database" => "The translations in the database will be merged with the other translations in language.php. After writing translations to language.php the translations are removed from the database",
// "To be able to write your translations back to language.php make sure that the web server has write permission in the lang/ directory" => "To be able to write your translations back to language.php make sure that the web server has write permission in the lang/ directory",
// "Cancel Fullscreen" => "Cancel Fullscreen",
// "Toggle right modules" => "Toggle right modules",
// "Toggle left modules" => "Toggle left modules",
// "Toggle module contents" => "Toggle module contents",
// "Toggle" => "Toggle",
// "Move up" => "Move up",
// "Move down" => "Move down",
// "Move to opposite side" => "Move to opposite side",
// "{\$count_label}" => "{\$count_label}",
// "Show Tree" => "Show Tree",
// "Hide Tree" => "Hide Tree",
// "Select action to perform with checked.." => "Select action to perform with checked..",
// "Assign permissions to file galleries" => "Assign permissions to file galleries",
// "Delete selected items" => "Delete selected items",
// "Download zip version" => "Download zip version",
// "Reset to default list view settings" => "Reset to default list view settings",
// "Move selected file or gallery" => "Move selected file or gallery",
"Move to" => "移動至",
// "Assign file gallery permissions to groups" => "Assign file gallery permissions to groups",
// "No Additional Sort" => "No Additional Sort",
// "Other Sorts" => "Other Sorts",
// "Locked by-" => "Locked by-",
// "No information" => "No information",
// "{\$topic|escape}" => "{\$topic|escape}",
// "{\$type|escape}" => "{\$type|escape}",
// "The leader of " => "The leader of ",
// "has added you. To visit it, logon and go to the home page " => "has added you. To visit it, logon and go to the home page ",
// "You have been added" => "You have been added",
// "This is to inform you that your request to join" => "This is to inform you that your request to join",
// " has been accepted" => " has been accepted",
// "To visit it, go to the home page" => "To visit it, go to the home page",
// "Leader approved your request" => "Leader approved your request",
// "has been denied.\nif you feel that this could be a mistake, or have any questions or concerns, please contact the" => "has been denied.\nif you feel that this could be a mistake, or have any questions or concerns, please contact the",
// "Leader rejected your request" => "Leader rejected your request",
// "This is to inform you that you have been removed from " => "This is to inform you that you have been removed from ",
// " If you did not request this removal, or have any questions or concerns, please contact" => " If you did not request this removal, or have any questions or concerns, please contact",
// "You have been removed from it" => "You have been removed from it",
// "Upgrade Available" => "Upgrade Available",
// "Upgrades Available" => "Upgrades Available",
// "{\$subject}" => "{\$subject}",
// "Hi {\$mail_user|username} has sent you this {\$prefs.mail_template_custom_text}link" => "Hi {\$mail_user|username} has sent you this {\$prefs.mail_template_custom_text}link",
"Blog post:" => "Blog 佈告:",
"at:" => "於:",
// "Gift Certificate Information" => "Gift Certificate Information",
"Description:" => "描述:",
// "Percentage Discount" => "Percentage Discount",
// "Value of Gift Certificate" => "Value of Gift Certificate",
// "Redeem Code" => "Redeem Code",
// "Your {\$prefs.mail_template_custom_text}Gift Certificate Purchase" => "Your {\$prefs.mail_template_custom_text}Gift Certificate Purchase",
// "Your {\$prefs.mail_template_custom_text}cart order has been received. Please note that orders are not finalized until payment has been made" => "Your {\$prefs.mail_template_custom_text}cart order has been received. Please note that orders are not finalized until payment has been made",
// "You can review your order at" => "You can review your order at",
// "Your {\$prefs.mail_template_custom_text}cart order" => "Your {\$prefs.mail_template_custom_text}cart order",
// "Someone tried to subscribe this email address at our {\$prefs.mail_template_custom_text}site" => "Someone tried to subscribe this email address at our {\$prefs.mail_template_custom_text}site",
"To the newsletter:" => "訂閱的電子報:",
// "Please access the following URL to confirm your subscription" => "Please access the following URL to confirm your subscription",
// "To validate your account and login to the {\$prefs.mail_template_custom_text}site, please click on the following link" => "To validate your account and login to the {\$prefs.mail_template_custom_text}site, please click on the following link",
// "The administrator approved your account" => "The administrator approved your account",
// "Confirm your {\$prefs.mail_template_custom_text}email at %s" => "Confirm your {\$prefs.mail_template_custom_text}email at %s",
// "Remove {\$prefs.mail_template_custom_text}file" => "Remove {\$prefs.mail_template_custom_text}file",
// "GalleryId" => "GalleryId",
// "Identifier" => "Identifier",
// "{\$prefs.mail_template_custom_text}File Gallery quota exceeded" => "{\$prefs.mail_template_custom_text}File Gallery quota exceeded",
"User:" => "使用者:",
// "A new message was posted to {\$prefs.mail_template_custom_text}forum" => "A new message was posted to {\$prefs.mail_template_custom_text}forum",
// "New topic" => "New topic",
// "An anonymous {\$prefs.mail_template_custom_text}user" => "An anonymous {\$prefs.mail_template_custom_text}user",
"Title:" => "標題:",
// "An anonymous user" => "An anonymous user",
// "has posted a reply to a thread you're watching.\nYou can view the thread and reply at the following URL" => "has posted a reply to a thread you're watching.\nYou can view the thread and reply at the following URL",
// "Note that this is an edited post" => "Note that this is an edited post",
// "has posted a reply to a thread that requires moderation.\nYou can approve or reject the post at the following URL" => "has posted a reply to a thread that requires moderation.\nYou can approve or reject the post at the following URL",
// "To instantly approve this post without logging in, use the following URL" => "To instantly approve this post without logging in, use the following URL",
// "You have been invited to access %0 by %1" => "You have been invited to access %0 by %1",
// "Your token for accessing the {\$prefs.mail_template_custom_text}site is %0" => "Your token for accessing the {\$prefs.mail_template_custom_text}site is %0",
// "Your access is valid until %0" => "Your access is valid until %0",
// "Your {\$prefs.mail_template_custom_text}temporary access to %0" => "Your {\$prefs.mail_template_custom_text}temporary access to %0",
// "You are invited by" => "You are invited by",
// "You join this group" => "You join this group",
// "Join me on %s" => "Join me on %s",
// "Tiki mail-in auto-reply" => "Tiki mail-in auto-reply",
// "{\$prefs.mail_template_custom_text}page not found" => "{\$prefs.mail_template_custom_text}page not found",
// "%0 mentioned you in %1" => "%0 mentioned you in %1",
// "You've been mentioned on %0" => "You've been mentioned on %0",
// "A new {\$prefs.mail_template_custom_text}message was posted to you" => "A new {\$prefs.mail_template_custom_text}message was posted to you",
// "Click here to read the full message and / or reply" => "Click here to read the full message and / or reply",
// "New {\$prefs.mail_template_custom_text}message arrived from %s" => "New {\$prefs.mail_template_custom_text}message arrived from %s",
"Hi" => "Hi",
// "Your {\$prefs.mail_template_custom_text}account registration request for {\$mail_site} was validated by the site admin and your account is active now" => "Your {\$prefs.mail_template_custom_text}account registration request for {\$mail_site} was validated by the site admin and your account is active now",
// "To login with your username and password, please follow this link" => "To login with your username and password, please follow this link",
"Enjoy the site!" => "好好享受本站的資源!",
// "User Account Activated" => "User Account Activated",
// "{\$mail_user} <{\$mail_email}> has requested a new password on {\$mail_site}, but you need to validate his {\$prefs.mail_template_custom_text}account first" => "{\$mail_user} <{\$mail_email}> has requested a new password on {\$mail_site}, but you need to validate his {\$prefs.mail_template_custom_text}account first",
// "has requested an account on" => "has requested an account on",
// "User Tracker" => "User Tracker",
// "To validate that {\$prefs.mail_template_custom_text}account, please follow the link" => "To validate that {\$prefs.mail_template_custom_text}account, please follow the link",
// "Assign to a group" => "Assign to a group",
// "View user's data" => "View user's data",
// "Best regards" => "Best regards",
// "User Registration Request" => "User Registration Request",
// "Go to your friendship network to accept or refuse this {\$prefs.mail_template_custom_text}request" => "Go to your friendship network to accept or refuse this {\$prefs.mail_template_custom_text}request",
// "You're invited to join my {\$prefs.mail_template_custom_text}network of friends" => "You're invited to join my {\$prefs.mail_template_custom_text}network of friends",
"The user" => "使用者",
// "registered at your {\$prefs.mail_template_custom_text}site" => "registered at your {\$prefs.mail_template_custom_text}site",
// "New {\$prefs.mail_template_custom_text}user registration" => "New {\$prefs.mail_template_custom_text}user registration",
// "Start of article" => "Start of article",
"Published" => "發表",
"By:" => "By:",
"Bye bye!" => "Bye bye!",
// "This email address has been removed from the list of subscribers of: " => "This email address has been removed from the list of subscribers of: ",
"Newsletter:" => "電子報:",
// "Bye bye from %s at %s" => "Bye bye from %s at %s",
// "You can unsubscribe from this {\$prefs.mail_template_custom_text}newsletter by following this link" => "You can unsubscribe from this {\$prefs.mail_template_custom_text}newsletter by following this link",
"Welcome to our newsletter!" => "歡迎加入我們的電子報!",
// "This email address has been added to the list of subscribers of: " => "This email address has been added to the list of subscribers of: ",
"You can always cancel your subscription using:" => "你可以這樣取消你的訂閱:",
// "Welcome to %s at %s" => "Welcome to %s at %s",
// "Reply Notification: " => "Reply Notification: ",
// "{\$prefs.mail_template_custom_text}Email Notification" => "{\$prefs.mail_template_custom_text}Email Notification",
// "Someone requested a password reset for your %0account" => "Someone requested a password reset for your %0account",
// "Please click on the following link to confirm you wish to reset your password and go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else" => "Please click on the following link to confirm you wish to reset your password and go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else",
// "Important: Username & password are CaSe SenSitiVe" => "Important: Username & password are CaSe SenSitiVe",
// "Important: The old password remains active if you don't click the link above" => "Important: The old password remains active if you don't click the link above",
// "Your account information for %s" => "Your account information for %s",
// "}Plugin %0 is pending approval on %1" => "}Plugin %0 is pending approval on %1",
// "tiki-plugins.php\"}See all the {\$prefs.mail_template_custom_text}pending plugins in the <a href='%0'>plugin approval page</a>" => "tiki-plugins.php\"}See all the {\$prefs.mail_template_custom_text}pending plugins in the <a href='%0'>plugin approval page</a>",
// "Plugin arguments" => "Plugin arguments",
// "Report on %0 for %1" => "Report on %0 for %1",
// "Last {\$prefs.mail_template_custom_text}Report sent on %0" => "Last {\$prefs.mail_template_custom_text}Report sent on %0",
// "Changes in detail" => "Changes in detail",
// "You are receiving notification emails grouped in a periodic digest. To receive them individually when posted instead, change your preferences at %0" => "You are receiving notification emails grouped in a periodic digest. To receive them individually when posted instead, change your preferences at %0",
// "A new {\$prefs.mail_template_custom_text}source category was detected by the RSS article creator at" => "A new {\$prefs.mail_template_custom_text}source category was detected by the RSS article creator at",
// "Feed" => "Feed",
// "New categories" => "New categories",
// "Configure settings for the new category at" => "Configure settings for the new category at",
// "New {\$prefs.mail_template_custom_text}source category in RSS feed" => "New {\$prefs.mail_template_custom_text}source category in RSS feed",
// "Scheduler \"%0\" is now marked as healed, since its running time is over %1 minutes" => "Scheduler \"%0\" is now marked as healed, since its running time is over %1 minutes",
// "Details" => "Details",
"Site" => "網站",
// "[%0] Scheduler \"%1\" was healed" => "[%0] Scheduler \"%1\" was healed",
// "Scheduler \"%0\" is now marked as stalled, since its running time is over %1 minutes" => "Scheduler \"%0\" is now marked as stalled, since its running time is over %1 minutes",
// "[%0] Scheduler \"%1\" is stalled" => "[%0] Scheduler \"%1\" is stalled",
// "Look at this {\$prefs.mail_template_custom_text}link" => "Look at this {\$prefs.mail_template_custom_text}link",
// "A friend sends you a {\$prefs.mail_template_custom_text}link from: " => "A friend sends you a {\$prefs.mail_template_custom_text}link from: ",
// "A new {\$prefs.mail_template_custom_text}article was submitted by {\$mail_user|username} to {\$mail_site} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "A new {\$prefs.mail_template_custom_text}article was submitted by {\$mail_user|username} to {\$mail_site} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
"You can edit the submission following this link:" => "你可以使用此連結修改送出的資料:",
"Heading:" => "標題:",
"Body:" => "本文:",
// "New {\$prefs.mail_template_custom_text}article submitted at %s" => "New {\$prefs.mail_template_custom_text}article submitted at %s",
// "Tracker item {\$mail_itemId} was deleted in the tracker {tr}{\$mail_trackerName}" => "Tracker item {\$mail_itemId} was deleted in the tracker {tr}{\$mail_trackerName}",
// "{\$mail_user|username}" => "{\$mail_user|username}",
// "{\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "{\$mail_date|tiki_short_datetime:\"\":\"n\"}",
// "New status for ItemID {\$mail_itemId} {\$mail_item_desc} for the {\$prefs.mail_template_custom_text}tracker {tr}{\$mail_trackerName}" => "New status for ItemID {\$mail_itemId} {\$mail_item_desc} for the {\$prefs.mail_template_custom_text}tracker {tr}{\$mail_trackerName}",
// "View the {\$prefs.mail_template_custom_text}tracker item at" => "View the {\$prefs.mail_template_custom_text}tracker item at",
// "The last content before deletion was as follows" => "The last content before deletion was as follows",
// "Download the file at" => "Download the file at",
// "{\$mail_trackerName}" => "{\$mail_trackerName}",
"item" => "項目",
// "was deleted at" => "was deleted at",
// "was modified at" => "was modified at",
// "Please visit this {\$prefs.mail_template_custom_text}link before logging in again" => "Please visit this {\$prefs.mail_template_custom_text}link before logging in again",
// "Last attempt" => "Last attempt",
// "Confirm your {\$prefs.mail_template_custom_text}account at %s" => "Confirm your {\$prefs.mail_template_custom_text}account at %s",
// "{\$prefs.mail_template_custom_text}Site" => "{\$prefs.mail_template_custom_text}Site",
// "{\$prefs.mail_template_custom_text}Account suspended" => "{\$prefs.mail_template_custom_text}Account suspended",
// "An administrator of the {\$prefs.mail_template_custom_text}site below has added you as a new user" => "An administrator of the {\$prefs.mail_template_custom_text}site below has added you as a new user",
// "If you want to confirm your membership in this site, click on the following link to login for the first time" => "If you want to confirm your membership in this site, click on the following link to login for the first time",
// "Welcome to the site" => "Welcome to the site",
// "Your personal access to" => "Your personal access to",
// "joined" => "joined",
// "User joined" => "User joined",
// "You are getting this email because you are a leader of" => "You are getting this email because you are a leader of",
// "Click here to manage members" => "Click here to manage members",
// "You are getting this email because you are a leader" => "You are getting this email because you are a leader",
// "The user needs to be approved before he is admitted" => "The user needs to be approved before he is admitted",
// "user joined" => "user joined",
// "You are getting this email because you are a group leader" => "You are getting this email because you are a group leader",
// "left" => "left",
// "user left" => "user left",
"You or someone registered this email address at" => "你或是某位註冊此 email 地址的人",
// "If you want to be a registered user in this %0site you will have to use the following link to login for the first time" => "If you want to be a registered user in this %0site you will have to use the following link to login for the first time",
// "Your {\$prefs.mail_template_custom_text}registration confirmation" => "Your {\$prefs.mail_template_custom_text}registration confirmation",
// "You will receive an email with the information needed to log into this site the first time" => "You will receive an email with the information needed to log into this site the first time",
// "Your account request has been stored and will be activated by the admin as soon as possible" => "Your account request has been stored and will be activated by the admin as soon as possible",
// "You'll receive email notification once your account is activated" => "You'll receive email notification once your account is activated",
// "Please do not attempt to login until you receive the email notification" => "Please do not attempt to login until you receive the email notification",
// "New {\$prefs.mail_template_custom_text}article post" => "New {\$prefs.mail_template_custom_text}article post",
// "Edit {\$prefs.mail_template_custom_text}article post" => "Edit {\$prefs.mail_template_custom_text}article post",
// "Delete {\$prefs.mail_template_custom_text}article post" => "Delete {\$prefs.mail_template_custom_text}article post",
// "{\$mail_title} by {\$mail_user|username} at" => "{\$mail_title} by {\$mail_user|username} at",
// "View the article at" => "View the article at",
// "Expiration Date" => "Expiration Date",
"If you don't want to receive these notifications follow this link:" => "如果你不想再收到這些通知請使用此連結:",
// "The old article follows" => "The old article follows",
// "New {\$prefs.mail_template_custom_text}article post at" => "New {\$prefs.mail_template_custom_text}article post at",
// "Edited {\$prefs.mail_template_custom_text}article post at" => "Edited {\$prefs.mail_template_custom_text}article post at",
// "Deleted {\$prefs.mail_template_custom_text}article post at" => "Deleted {\$prefs.mail_template_custom_text}article post at",
// "New {\$prefs.mail_template_custom_text}blog post: {\$mail_title}, \"{\$mail_post_title}\", by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "New {\$prefs.mail_template_custom_text}blog post: {\$mail_title}, \"{\$mail_post_title}\", by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
"View the blog at:" => "檢視此 blog 於:",
// "New {\$prefs.mail_template_custom_text}blog post at %s" => "New {\$prefs.mail_template_custom_text}blog post at %s",
// "View item calendar at" => "View item calendar at",
// "Modified {\$prefs.mail_template_custom_text}calendar item" => "Modified {\$prefs.mail_template_custom_text}calendar item",
// "New {\$prefs.mail_template_custom_text}calendar item" => "New {\$prefs.mail_template_custom_text}calendar item",
"changed" => "更改",
// "A new {\$prefs.mail_template_custom_text}category was created in" => "A new {\$prefs.mail_template_custom_text}category was created in",
"Created by" => "產生自 ",
"created" => "建立",
// "A {\$prefs.mail_template_custom_text}category was removed in" => "A {\$prefs.mail_template_custom_text}category was removed in",
// "Removed by" => "Removed by",
// "removed" => "removed",
// "A {\$prefs.mail_template_custom_text}category was updated" => "A {\$prefs.mail_template_custom_text}category was updated",
// "Updated by" => "Updated by",
// "Old" => "Old",
// "updated" => "updated",
// "The {\$prefs.mail_template_custom_text}Wiki page \"{\$mail_objectname}\" was commented on by" => "The {\$prefs.mail_template_custom_text}Wiki page \"{\$mail_objectname}\" was commented on by",
// "an anonymous user" => "an anonymous user",
// "The {\$prefs.mail_template_custom_text}Blog post \"{\$mail_objectname}\" was commented on by" => "The {\$prefs.mail_template_custom_text}Blog post \"{\$mail_objectname}\" was commented on by",
// "The {\$prefs.mail_template_custom_text}article \"{\$mail_objectname}\" was commented on by" => "The {\$prefs.mail_template_custom_text}article \"{\$mail_objectname}\" was commented on by",
// "The {\$prefs.mail_template_custom_text}tracker item \"{\$mail_item_title}\" of tracker \"{\$mail_objectname}\" was commented on by" => "The {\$prefs.mail_template_custom_text}tracker item \"{\$mail_item_title}\" of tracker \"{\$mail_objectname}\" was commented on by",
// "You can view the comment by following this link" => "You can view the comment by following this link",
"Comment:" => "評論:",
// "File Gallery %s changed" => "File Gallery %s changed",
// "A file was removed from the {\$prefs.mail_template_custom_text}file gallery" => "A file was removed from the {\$prefs.mail_template_custom_text}file gallery",
// "A new file was posted to {\$prefs.mail_template_custom_text}file gallery" => "A new file was posted to {\$prefs.mail_template_custom_text}file gallery",
"File Description" => "檔案描述",
// "You can download the new file at" => "You can download the new file at",
// "The new file ID is %0 and it is in gallery ID %1" => "The new file ID is %0 and it is in gallery ID %1",
// "New {\$prefs.mail_template_custom_text}forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username} <{\$mail_author|escape}>" => "New {\$prefs.mail_template_custom_text}forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username} <{\$mail_author|escape}>",
// "New {\$prefs.mail_template_custom_text}forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username} <{\$mail_author|escape}>" => "New {\$prefs.mail_template_custom_text}forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username} <{\$mail_author|escape}>",
// "New {\$prefs.mail_template_custom_text}forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}" => "New {\$prefs.mail_template_custom_text}forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}",
// "New {\$prefs.mail_template_custom_text}forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}" => "New {\$prefs.mail_template_custom_text}forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author|username}",
// "Image Gallery {\$galleryName} changed" => "Image Gallery {\$galleryName} changed",
// "A new file was posted to {\$prefs.mail_template_custom_text}image gallery" => "A new file was posted to {\$prefs.mail_template_custom_text}image gallery",
// "The {\$prefs.mail_template_custom_text}map {\$mail_page} was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "The {\$prefs.mail_template_custom_text}map {\$mail_page} was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
// "You can view the updated map following this link" => "You can view the updated map following this link",
// "You can edit the map following this link" => "You can edit the map following this link",
// "An object was added to {\$prefs.mail_template_custom_text}category" => "An object was added to {\$prefs.mail_template_custom_text}category",
// "Added by" => "Added by",
// "An object was removed from {\$prefs.mail_template_custom_text}category" => "An object was removed from {\$prefs.mail_template_custom_text}category",
// "A page has been added to your watched {\$prefs.mail_template_custom_text}sub-structure" => "A page has been added to your watched {\$prefs.mail_template_custom_text}sub-structure",
// "A page has been removed from your watched {\$prefs.mail_template_custom_text}sub-structure" => "A page has been removed from your watched {\$prefs.mail_template_custom_text}sub-structure",
// "A page has been promoted in your watched {\$prefs.mail_template_custom_text}sub-structure" => "A page has been promoted in your watched {\$prefs.mail_template_custom_text}sub-structure",
// "A page has been demoted in your watched {\$prefs.mail_template_custom_text}structure" => "A page has been demoted in your watched {\$prefs.mail_template_custom_text}structure",
// "Structure modified" => "Structure modified",
// "has consulted your" => "has consulted your",
// "Go to the File Gallery" => "Go to the File Gallery",
// "Download the file" => "Download the file",
// "A new file has been attached to {\$prefs.mail_template_custom_text}page" => "A new file has been attached to {\$prefs.mail_template_custom_text}page",
// "File name" => "File name",
// "New {\$prefs.mail_template_custom_text}attachment on %s, page" => "New {\$prefs.mail_template_custom_text}attachment on %s, page",
// "The {\$prefs.mail_template_custom_text}page \"{\$mail_page}\" was created by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "The {\$prefs.mail_template_custom_text}page \"{\$mail_page}\" was created by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
// "The {\$prefs.mail_template_custom_text}page \"{\$mail_page}\" was deleted by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "The {\$prefs.mail_template_custom_text}page \"{\$mail_page}\" was deleted by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
// "A file was attached to {\$prefs.mail_template_custom_text}\"{\$mail_page}\"" => "A file was attached to {\$prefs.mail_template_custom_text}\"{\$mail_page}\"",
// "The {\$prefs.mail_template_custom_text}page \"{\$mail_page}\" was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}" => "The {\$prefs.mail_template_custom_text}page \"{\$mail_page}\" was changed by {\$mail_user|username} at {\$mail_date|tiki_short_datetime:\"\":\"n\"}",
// "The page {\$prefs.mail_template_custom_text}\"{\$mail_page}\" was deleted but used to be here" => "The page {\$prefs.mail_template_custom_text}\"{\$mail_page}\" was deleted but used to be here",
// "You can view the page by following this link" => "You can view the page by following this link",
// "You can view a diff back to the previous version by following this link" => "You can view a diff back to the previous version by following this link",
// "The changes in this version follow below, followed after by the current full page text" => "The changes in this version follow below, followed after by the current full page text",
// "-Lines: {\$oldd} changed to +Lines: {\$newd}" => "-Lines: {\$oldd} changed to +Lines: {\$newd}",
// "The old page content follows below" => "The old page content follows below",
// "The new page content follows below" => "The new page content follows below",
// "{\$prefs.mail_template_custom_text}wiki page \"%s\" created by {\$mail_user|username}" => "{\$prefs.mail_template_custom_text}wiki page \"%s\" created by {\$mail_user|username}",
// "{\$prefs.mail_template_custom_text}wiki page \"%s\" deleted by {\$mail_user|username}" => "{\$prefs.mail_template_custom_text}wiki page \"%s\" deleted by {\$mail_user|username}",
// "A file was attached to {\$prefs.mail_template_custom_text}\"%s\"" => "A file was attached to {\$prefs.mail_template_custom_text}\"%s\"",
// "{\$prefs.mail_template_custom_text}wiki page \"%s\" changed by {\$mail_user|username}" => "{\$prefs.mail_template_custom_text}wiki page \"%s\" changed by {\$mail_user|username}",
// "Wiki page renamed" => "Wiki page renamed",
// "Old name" => "Old name",
"New name" => "新名稱",
// "Your %0account ID" => "Your %0account ID",
// "has been generated" => "has been generated",
// "Thank you for your %0registration" => "Thank you for your %0registration",
"You may log in now." => "你現在可以登入了.",
// "Operation Completed" => "Operation Completed",
// "Return to Query List" => "Return to Query List",
// "Do you really want to remove the %0 account" => "Do you really want to remove the %0 account",
// "Delete Account" => "Delete Account",
"Active" => "啟動",
"Account name" => "帳號名稱",
// "Wiki (multiple action) allows to prefix the subject with GET:, PREPEND: or APPEND" => "Wiki (multiple action) allows to prefix the subject with GET:, PREPEND: or APPEND",
// "Reply handler requires notifications to be enabled and the reply email pattern to be configured" => "Reply handler requires notifications to be enabled and the reply email pattern to be configured",
"POP server" => "POP 伺服器",
// "POP" => "POP",
// "IMAP" => "IMAP",
"Admin Topics" => "管理主題",
// "Admin Types" => "Admin Types",
// "Allow anonymous access" => "Allow anonymous access",
// "Warning: Enabling anonymous access will disable all permission checking for mailed-in content" => "Warning: Enabling anonymous access will disable all permission checking for mailed-in content",
// "Allow admin access" => "Allow admin access",
// "Administrators have full access to the system. Disabling admin mail-in is the safest option" => "Administrators have full access to the system. Disabling admin mail-in is the safest option",
// "Allow attachments" => "Allow attachments",
// "Allow routing" => "Allow routing",
// "Allow per user routing of incoming email to structures" => "Allow per user routing of incoming email to structures",
// "Show inline images" => "Show inline images",
// "For HTML email, attempt to create a WYSIWYG wiki-page" => "For HTML email, attempt to create a WYSIWYG wiki-page",
// "Keep HTML format" => "Keep HTML format",
// "Always save Email in HTML format as a wiki page in HTML format, regardless of editor availability or selection" => "Always save Email in HTML format as a wiki page in HTML format, regardless of editor availability or selection",
// "Discard to the end from" => "Discard to the end from",
// "Auto-assign category" => "Auto-assign category",
// "Only affects wiki-put, when creating a new wiki page" => "Only affects wiki-put, when creating a new wiki page",
// "Auto-assign namespace" => "Auto-assign namespace",
// "Email response when no access" => "Email response when no access",
// "Leave email on server on error" => "Leave email on server on error",
// "Leave the email on the mail server, when an error occurs and the content has not been integrated into Tiki" => "Leave the email on the mail server, when an error occurs and the content has not been integrated into Tiki",
// "Add Account" => "Add Account",
// "Operation not reversible" => "Operation not reversible",
// "This action is currently of a basic type. Using the advanced editor will prevent the simple editor to be used" => "This action is currently of a basic type. Using the advanced editor will prevent the simple editor to be used",
"Event" => "事件",
// "Disable rule" => "Disable rule",
// "Enable rule" => "Enable rule",
// "Unknown status" => "Unknown status",
// "Current Type" => "Current Type",
// "New Type" => "New Type",
// "The rule has been removed" => "The rule has been removed",
// "Are you sure you want to delete this rule" => "Are you sure you want to delete this rule",
// "Are you certain you want to delete this activity? It will be removed permanently from the database and will affect any statistics that depend on it" => "Are you certain you want to delete this activity? It will be removed permanently from the database and will affect any statistics that depend on it",
// "Sample Rule" => "Sample Rule",
// "Basic Rule (Record Event)" => "Basic Rule (Record Event)",
// "Tracker Rule" => "Tracker Rule",
// "Advanced Rule" => "Advanced Rule",
// "Community Control Panel" => "Community Control Panel",
// "Event Chain Diagram" => "Event Chain Diagram",
// "Rule Type" => "Rule Type",
// "Allow Notifications" => "Allow Notifications",
// "Recipient" => "Recipient",
// "Cached sample data helps to view available variables for event types" => "Cached sample data helps to view available variables for event types",
// "Sample available" => "Sample available",
// "Sample currently not available" => "Sample currently not available",
// "Source Event" => "Source Event",
// "Target Event" => "Target Event",
// "All event names are required to have at least 3 components" => "All event names are required to have at least 3 components",
// "%0 Copy" => "%0 Copy",
// "Clone of Menu Id" => "Clone of Menu Id",
// "Symbol Information" => "Symbol Information",
// "Profile Source" => "Profile Source",
// "Clone" => "Clone",
"dynamic collapsed" => "動態展開",
"dynamic extended" => "動態延伸",
"fixed" => "固定",
// "Labels of all options will be wiki parsed" => "Labels of all options will be wiki parsed",
// "Folder Icon" => "Folder Icon",
// "Path and filename of closed folder icon" => "Path and filename of closed folder icon",
// "Configure icons for menu entries" => "Configure icons for menu entries",
// "For wiki page, use ((PageName))" => "For wiki page, use ((PageName))",
// "Selecting 2 groups means that the option will be seen if the user belongs to the 2 groups. If you want the 2 groups to see the option, create 2 options with one group each" => "Selecting 2 groups means that the option will be seen if the user belongs to the 2 groups. If you want the 2 groups to see the option, create 2 options with one group each",
// "If the url is ((PageName)), you do not need to put the groups, the option will be displayed only if the page can be displayed" => "If the url is ((PageName)), you do not need to put the groups, the option will be displayed only if the page can be displayed",
"Sections" => "區段",
// "Separate multiple feature/preferences with a comma ( , ) for an AND or a vertical bar ( | ) for an OR" => "Separate multiple feature/preferences with a comma ( , ) for an AND or a vertical bar ( | ) for an OR",
// "Separate multiple permissions with a comma ( , ) for an AND or a vertical bar ( | ) for an OR" => "Separate multiple permissions with a comma ( , ) for an AND or a vertical bar ( | ) for an OR",
// "Input an HTML class value for the menu option. Separate with a space for multiple classes" => "Input an HTML class value for the menu option. Separate with a space for multiple classes",
// "Tips" => "Tips",
// "To add new options to the menu set the optionId field to 0. To remove an option set the remove field to 'y'" => "To add new options to the menu set the optionId field to 0. To remove an option set the remove field to 'y'",
// "Duplicate options will be ignored" => "Duplicate options will be ignored",
// "Show Quick URLs" => "Show Quick URLs",
"Some useful URLs" => "一些有用的 URL 們",
// "Hide Quick URLs" => "Hide Quick URLs",
"Home" => "首頁",
// "Choose" => "Choose",
"Home Page" => "首頁",
"Home Blog" => "主 Blog",
"Home Image Gal" => "主影像圖庫",
"Home Image Gallery" => "主影像圖庫",
"Home File Gal" => "主檔案庫",
"Home File Gallery" => "主檔案庫",
"User preferences" => "使用者偏好",
"User prefs" => "使用者偏好",
"Wiki Home" => "Wiki 首頁",
"List galleries" => "列出檔案庫",
"List image galleries" => "列出圖庫",
"Upload image" => "上傳影像",
"Gallery Rankings" => "圖庫排名",
"Browse a gallery" => "瀏覽圖庫",
"Articles home" => "文章首頁",
"All articles" => "所有文章",
"List Blogs" => "列出 Blogs",
// "Create Blog" => "Create Blog",
"View a forum" => "進入論壇",
"View a thread" => "檢視討論串",
"View a FAQ" => "觀看 FAQ",
"Take a quiz" => "參加測驗",
"Quiz stats" => "測驗統計",
"Stats for a Quiz" => "測驗統計",
// "Message Archive" => "Message Archive",
// "Archive is full" => "Archive is full",
"Unread" => "未閱讀",
"Flagged" => "標記",
"Unflagged" => "已解除標記",
"Containing" => "包含",
"Sender" => "寄件者",
"No messages to display" => "沒有訊息可顯示",
"Broadcast message" => "廣播訊息",
"All users" => "所有使用者",
"Lowest" => "最低",
"Very High" => "非常高",
"Body" => "內容",
"Send" => "發送",
"Compose message" => "撰寫訊息",
// "If you want people to be able to reply to you, enable <a href='tiki-user_preferences.php'>Allow messages from other users</a> in your preferences" => "If you want people to be able to reply to you, enable <a href='tiki-user_preferences.php'>Allow messages from other users</a> in your preferences",
// "To: Multiple addresses can be separated with a semicolon (';') or comma (',')" => "To: Multiple addresses can be separated with a semicolon (';') or comma (',')",
"CC" => "CC",
// "CC: Multiple addresses can be separated with a semicolon (';') or comma (',')" => "CC: Multiple addresses can be separated with a semicolon (';') or comma (',')",
"BCC" => "BCC",
// "BCC: Multiple addresses can be separated with a semicolon (';') or comma (',')" => "BCC: Multiple addresses can be separated with a semicolon (';') or comma (',')",
// "Reply-to my email" => "Reply-to my email",
// "The user will be able to reply to you directly via email" => "The user will be able to reply to you directly via email",
// "Send me a copy" => "Send me a copy",
// "You will be sent a copy of this email" => "You will be sent a copy of this email",
// "No messages to download" => "No messages to download",
// "full" => "full",
// "Mailbox is full! Delete or archive some messages if you want to receive more messages" => "Mailbox is full! Delete or archive some messages if you want to receive more messages",
// "is reply to" => "is reply to",
// "Find replied message" => "Find replied message",
// "Perform action with checked" => "Perform action with checked",
"Mark as read" => "設為閱讀",
"Mark as unread" => "設為未讀",
"Mark as flagged" => "設為已標記",
"Mark as unflagged" => "設為未標記",
"Mark" => "標計",
"Mailbox" => "信件匣",
"Compose" => "編寫",
"Broadcast" => "廣播",
// "Auto-archive age for read messages" => "Auto-archive age for read messages",
"Read message" => "閱讀訊息",
// "Flagged:Click to unflag" => "Flagged:Click to unflag",
// "Not flagged:Click to flag" => "Not flagged:Click to flag",
"replyall" => "回覆全部",
// "Reply All" => "Reply All",
"From:" => "自:",
"Cc" => "Cc",
// "<i class=\"fas fa-arrow-left\" aria-hidden=\"true\"></i>" => "<i class=\"fas fa-arrow-left\" aria-hidden=\"true\"></i>",
// "<i class=\"fas fa-arrow-right\" aria-hidden=\"true\"></i>" => "<i class=\"fas fa-arrow-right\" aria-hidden=\"true\"></i>",
// "Sent Messages" => "Sent Messages",
// "Replied" => "Replied",
// "Not replied" => "Not replied",
// "Move to archive" => "Move to archive",
// "Image Metadata for" => "Image Metadata for",
// "<em>Note: only basic metadata processed for this file type</em>" => "<em>Note: only basic metadata processed for this file type</em>",
// "{\$subtypes@key|escape}" => "{\$subtypes@key|escape}",
// "{\$fields@key|lower|capitalize|escape}" => "{\$fields@key|lower|capitalize|escape}",
// "{\$fieldarray.label|escape}" => "{\$fieldarray.label|escape}",
// "{\$fieldarray@key|escape}" => "{\$fieldarray@key|escape}",
// "{\$fieldarray.suffix|escape}" => "{\$fieldarray.suffix|escape}",
// "No metadata found" => "No metadata found",
// "Read-only metadata extracted from the file" => "Read-only metadata extracted from the file",
// "<em>Only basic metadata processed for this file type.</em>" => "<em>Only basic metadata processed for this file type.</em>",
// "Control panels" => "Control panels",
// "Turn on interactive translation" => "Turn on interactive translation",
// "Comment moderation" => "Comment moderation",
// "Clear all caches" => "Clear all caches",
// "Plugin approval" => "Plugin approval",
// "Logs" => "Logs",
// "Smarty debug window" => "Smarty debug window",
// "Display type unknown, you have to enter the banner type" => "Display type unknown, you have to enter the banner type",
// "You forgot your Google ad_client number " => "You forgot your Google ad_client number ",
// "Thank you for installing Tiki" => "Thank you for installing Tiki",
// "To configure your Tiki" => "To configure your Tiki",
// "from the menu" => "from the menu",
// "Read the <a class=\"link\" href=\"http://doc.tiki.org/Configuration\" title=\"Tiki Documentation\" target=\"_blank\">configuration documentation</a>" => "Read the <a class=\"link\" href=\"http://doc.tiki.org/Configuration\" title=\"Tiki Documentation\" target=\"_blank\">configuration documentation</a>",
// "Watch the <a class=\"link\" href=\"http://tiki.org/TikiMovies\" title=\"Demos\" target=\"_blank\">demo movies" => "Watch the <a class=\"link\" href=\"http://tiki.org/TikiMovies\" title=\"Demos\" target=\"_blank\">demo movies",
// "To remove this module" => "To remove this module",
"Admin Modules" => "管理模組",
// "and remove the assistant module" => "and remove the assistant module",
// "You can also add other modules" => "You can also add other modules",
// "To customize the menu" => "To customize the menu",
"Admin Menus" => "管理選單",
// "and edit menu ID 42" => "and edit menu ID 42",
// "Or, create your own menu and add it to a module" => "Or, create your own menu and add it to a module",
// "To begin configuring Tiki, please" => "To begin configuring Tiki, please",
"login" => "登入",
// "as admin" => "as admin",
// "The Tiki Community" => "The Tiki Community",
// "To learn more, visit: <a href=\"http://tiki.org\" title=\"The Tiki Community\" target=\"_blank\">http://tiki.org</a>" => "To learn more, visit: <a href=\"http://tiki.org\" title=\"The Tiki Community\" target=\"_blank\">http://tiki.org</a>",
// "Tiki Documentation" => "Tiki Documentation",
// "For help, visit <a href=\"http://doc.tiki.org\" title=\"Tiki Documentation\" target=\"_blank\">http://doc.tiki.org</a>" => "For help, visit <a href=\"http://doc.tiki.org\" title=\"Tiki Documentation\" target=\"_blank\">http://doc.tiki.org</a>",
"on" => "on",
// "Published on" => "Published on",
// "on blogpost" => "on blogpost",
// "Untitled" => "Untitled",
// "{\$module_params.label|escape:\"html\"}" => "{\$module_params.label|escape:\"html\"}",
// "{\$crumbs[0]->description}" => "{\$crumbs[0]->description}",
// "Add Event" => "Add Event",
// "Unit cost" => "Unit cost",
// "Qty" => "Qty",
// "Cart contains <span>%0</span> items" => "Cart contains <span>%0</span> items",
// "Total weight %0 %1" => "Total weight %0 %1",
// "Gift Certificate" => "Gift Certificate",
// "Remove Gift Certificate" => "Remove Gift Certificate",
// "Add Gift Certificate" => "Add Gift Certificate",
// "Check-out" => "Check-out",
// "Your cart is empty" => "Your cart is empty",
// "Missing %0 of the following categories" => "Missing %0 of the following categories",
// "%0 extra of the following categories" => "%0 extra of the following categories",
// "Unknown comparison" => "Unknown comparison",
// "Impossible condition, %0 of" => "Impossible condition, %0 of",
// "Assign into category" => "Assign into category",
// "{\$modcatlist[\$k].name|escape}" => "{\$modcatlist[\$k].name|escape}",
// "Unassign category" => "Unassign category",
// "{\$module_params.categorize}" => "{\$module_params.categorize}",
"Pages:" => "頁面:",
// "{\$contributor.country|stringfix}" => "{\$contributor.country|stringfix}",
// "Homepage" => "Homepage",
// "1 more contributor" => "1 more contributor",
// "{\$hiddenContributors} more contributors" => "{\$hiddenContributors} more contributors",
// "low" => "low",
"Sites" => "站臺",
"Sites to validate" => "待確認的站臺",
"Visited links" => "已拜訪連結",
"Pass" => "密碼",
// "By" => "By",
// "Add tags" => "Add tags",
// "No tags yet" => "No tags yet",
// "List everything tagged" => "List everything tagged",
"Last updated" => "最近修改",
// "All Groups" => "All Groups",
// "Your Groups" => "Your Groups",
// "Emulated Groups" => "Emulated Groups",
// "Switch to Groups" => "Switch to Groups",
// "Simulate" => "Simulate",
// "Add Post" => "Add Post",
// "insert original" => "insert original",
// "insert thumbnail" => "insert thumbnail",
// "more" => "more",
// "Last %0 Podcasts" => "Last %0 Podcasts",
// "This is likely not a podcast file" => "This is likely not a podcast file",
// "The path to a podcast player is required" => "The path to a podcast player is required",
// "{\$link_text}" => "{\$link_text}",
// "No profile picture" => "No profile picture",
// "You" => "You",
// "Never logged in" => "Never logged in",
// "{\$data.info.title|escape:\"html\"}" => "{\$data.info.title|escape:\"html\"}",
"Open operator console" => "開啟服務員介面",
// "Execution time" => "Execution time",
// "Memory usage" => "Memory usage",
// "Queries" => "Queries",
// "Server load" => "Server load",
// "Logged in as" => "Logged in as",
"Log out" => "登出",
// "Return to Main User" => "Return to Main User",
// "Return to main user" => "Return to main user",
"Switch" => "轉換",
// "Switch User" => "Switch User",
"Email:" => "Email:",
// "Email address or " => "Email address or ",
// "User account ID" => "User account ID",
// "Enter a username and click 'Switch'.<br>Useful for testing permissions" => "Enter a username and click 'Switch'.<br>Useful for testing permissions",
// "Switch user" => "Switch user",
// "Toggle Dropdown" => "Toggle Dropdown",
"My Account" => "我的Tiki",
// "{\$user|username|escape|replace:'&amp;':'&'}" => "{\$user|username|escape|replace:'&amp;':'&'}",
// "Log in through CAS" => "Log in through CAS",
// "Log in as admin" => "Log in as admin",
// "Log in through Shibboleth" => "Log in through Shibboleth",
// "\n\t\t{if \$prefs.saml_option_login_link_text eq ''}\n\t\t\tLog in through SAML2 IdP\n\t\t{else}\n\t\t\t{\$prefs.saml_option_login_link_text}\n\t\t{/if}\n\t\t" => "\n\t\t{if \$prefs.saml_option_login_link_text eq ''}\n\t\t\tLog in through SAML2 IdP\n\t\t{else}\n\t\t\t{\$prefs.saml_option_login_link_text}\n\t\t{/if}\n\t\t",
// "CapsLock is on" => "CapsLock is on",
// "Click here if you've forgotten your password" => "Click here if you've forgotten your password",
"I forgot my password" => "忘記密碼",
// "Click here to register" => "Click here to register",
// "Click here to log in using the default security protocol" => "Click here to log in using the default security protocol",
"Standard" => "標準",
// "Click here to log in using a secure protocol" => "Click here to log in using a secure protocol",
"Secure" => "安全",
"Stay in SSL mode" => "保留在 ssl 模式",
// "local account" => "local account",
// "Log in via Facebook" => "Log in via Facebook",
// "Log in via LinkedIn" => "Log in via LinkedIn",
// "OpenID Log in" => "OpenID Log in",
// "OpenID Login" => "OpenID Login",
// "What is OpenID" => "What is OpenID",
// "Change the logo" => "Change the logo",
// "Click to change or upload new logo" => "Click to change or upload new logo",
// "{\$module_params.sitetitle|escape}" => "{\$module_params.sitetitle|escape}",
// "{\$module_params.sitesubtitle|escape}" => "{\$module_params.sitesubtitle|escape}",
// "No acceptable field to store the feature was found in the specified tracker" => "No acceptable field to store the feature was found in the specified tracker",
// "Edit this menu" => "Edit this menu",
"You have" => "你有",
"new messages" => "新訊息",
"new message" => "件新訊息",
"You have 0 new messages" => "你有 0 封新訊息",
// "No article found" => "No article found",
// "No blog post found" => "No blog post found",
"We have" => "我們有",
"submissions waiting to be examined" => "等待檢查的文章",
// "Permissions applied from" => "Permissions applied from",
// "No permissions to display" => "No permissions to display",
// "Stay on this page" => "Stay on this page",
// "Edit perspectives" => "Edit perspectives",
// "Within %0" => "Within %0",
// "Search Terms" => "Search Terms",
// "Any type" => "Any type",
// "Recent Preferences" => "Recent Preferences",
// "Wiki feed" => "Wiki feed",
// "Blogs feed" => "Blogs feed",
// "Articles feed" => "Articles feed",
// "Image Galleries feed" => "Image Galleries feed",
"Image Galleries" => "影像圖庫",
// "File Galleries feed" => "File Galleries feed",
// "Forums feed" => "Forums feed",
// "Directory feed" => "Directory feed",
// "Calendar feed" => "Calendar feed",
// "{\$tracker.name}" => "{\$tracker.name}",
"Entire Site" => "整個網站",
"Image Gals" => "影像圖庫",
// "Search for text throughout the site" => "Search for text throughout the site",
// "Go directly to a page, or search in page titles if exact match is not found" => "Go directly to a page, or search in page titles if exact match is not found",
// "Edit existing page or create a new one" => "Edit existing page or create a new one",
// "External" => "External",
// "Exact match" => "Exact match",
// "Page Relations" => "Page Relations",
// "Get short url" => "Get short url",
// "Copy" => "Copy",
// "Copied" => "Copied",
// "Tweet with Twitter" => "Tweet with Twitter",
// "Post on my Facebook wall" => "Post on my Facebook wall",
// "Shout date" => "Shout date",
// "Delete this shout" => "Delete this shout",
// "Edit this shout" => "Edit this shout",
"Read More" => "繼續閱讀",
"Since your last visit on" => "自從你上次拜訪由",
"New Images" => "新影像",
"Wiki Pages Changed" => "wiki 頁面已變動",
"New Files" => "新檔案",
"New Comments" => "新評論",
// "New Tracker Items" => "New Tracker Items",
// "New Calendar Events" => "New Calendar Events",
"New Users" => "新使用者",
"click to edit" => "點擊可編輯",
// "Nothing has changed" => "Nothing has changed",
"Tracker Items" => "追蹤項目",
// "Updated" => "Updated",
// "Multiple" => "Multiple",
// "including" => "including",
// "No Subversion checkout or unable to determine last update" => "No Subversion checkout or unable to determine last update",
// "Find term" => "Find term",
// "{\$user_languages[ix].name}" => "{\$user_languages[ix].name}",
// "If not found, you will be given a chance to create it" => "If not found, you will be given a chance to create it",
// "TikiTests Menu" => "TikiTests Menu",
// "List Tests" => "List Tests",
// "Create Test" => "Create Test",
"Top galleries" => "最熱門圖庫",
// "Posted to" => "Posted to",
// "(Read More)" => "(Read More)",
// "Missing values" => "Missing values",
// "Add Marker" => "Add Marker",
// "Tracker name" => "Tracker name",
// "Insert fields in wiki textarea" => "Insert fields in wiki textarea",
// "There are no translations of this page" => "There are no translations of this page",
// "Up-to-date-ness" => "Up-to-date-ness",
// "Incoming" => "Incoming",
// "To <strong>continue translating</strong>, select the language to translate from" => "To <strong>continue translating</strong>, select the language to translate from",
// "update from it" => "update from it",
// "None match your" => "None match your",
// "Set your preferred languages" => "Set your preferred languages",
// "preferred languages" => "preferred languages",
// "Outgoing" => "Outgoing",
// "update it" => "update it",
// "click to view" => "click to view",
"Bookmarks" => "書籤",
"Cache" => "快取",
// "Create Bookmark" => "Create Bookmark",
// "New Folder" => "New Folder",
"Done" => "完成",
"Del" => "清除",
// "select" => "select",
// "{\$user_groups[ix].groupName|escape}" => "{\$user_groups[ix].groupName|escape}",
// "Group information" => "Group information",
// "You need to activate user and/or group trackers" => "You need to activate user and/or group trackers",
"view" => "觀看",
// "%0 out of %1 users" => "%0 out of %1 users",
"online users" => "線上使用者",
"online user" => "線上使用者",
// "on host" => "on host",
// "User does not accept messages" => "User does not accept messages",
"Send a message to" => "發送訊息至",
// "More Videos" => "More Videos",
// "No results were found. Are you sure you searched for a tag" => "No results were found. Are you sure you searched for a tag",
// "We are not autorized to access the group at this time. If you have access to the Zotero group, you can grant this site read access" => "We are not autorized to access the group at this time. If you have access to the Zotero group, you can grant this site read access",
// "Mark all as read" => "Mark all as read",
// "You receive this notification because you requested it" => "You receive this notification because you requested it",
// "If you did not request these emails or did so in an error, please use the following link" => "If you did not request these emails or did so in an error, please use the following link",
// "Manage your notifications" => "Manage your notifications",
// "Notification Digest" => "Notification Digest",
// "No notifications available" => "No notifications available",
// "Priorities" => "Priorities",
// "No unread notifications" => "No unread notifications",
// "<span class=\"add-count\">0</span> have been added. <span class=\"skip-count\">0</span> were skipped" => "<span class=\"add-count\">0</span> have been added. <span class=\"skip-count\">0</span> were skipped",
// "Required Action" => "Required Action",
// "Add all members" => "Add all members",
// "OR Select individuals.." => "OR Select individuals..",
// "Add selected members" => "Add selected members",
// "Detail" => "Detail",
// "Respond" => "Respond",
// "Opened" => "Opened",
// "Logged In" => "Logged In",
// "Unopened" => "Unopened",
// "People" => "People",
// "Empty list" => "Empty list",
// "Responses" => "Responses",
// "Entry" => "Entry",
// "Request Date" => "Request Date",
// "Action Req'd" => "Action Req'd",
// "None (Owner)" => "None (Owner)",
// "Nothing to do" => "Nothing to do",
// "Add Item" => "Add Item",
// "On this document" => "On this document",
// "Saving" => "Saving",
// "This window will close automatically in 3 seconds.." => "This window will close automatically in 3 seconds..",
// "An error occurred, please try again" => "An error occurred, please try again",
// "Consent screen" => "Consent screen",
// "Do you really want to proceed" => "Do you really want to proceed",
// "No individual permissions, category permissions apply" => "No individual permissions, category permissions apply",
// "There are individual permissions set for this object" => "There are individual permissions set for this object",
"No individual permissions. Global permissions apply." => "不採用單獨的權限設定,採用全體權限設定",
// "Search and select what you are looking for from the options that appear" => "Search and select what you are looking for from the options that appear",
// "No matching results" => "No matching results",
// "Search and select what you are looking for from the options that appear." => "Search and select what you are looking for from the options that appear.",
// "Comparing version {\$old.version} with version {\$new.version}" => "Comparing version {\$old.version} with version {\$new.version}",
"Current" => "目前",
// "Session" => "Session",
// "Old Session" => "Old Session",
// "Old Version" => "Old Version",
// "New Session" => "New Session",
// "New Version" => "New Version",
"Versions are identical" => "版本相同",
// "Example wikidiff plugin syntax" => "Example wikidiff plugin syntax",
// "Minimum %0 characters long" => "Minimum %0 characters long",
// "Password must contain at least one special character like \" / \$ % ? & * ( ) _ + .." => "Password must contain at least one special character like \" / \$ % ? & * ( ) _ + ..",
// "Password is too common" => "Password is too common",
// "Individual permissions" => "Individual permissions",
// "Select image" => "Select image",
// "Pick a file" => "Pick a file",
// "Upload or record media" => "Upload or record media",
// "Convert to List" => "Convert to List",
// "{\$info.title|escape}" => "{\$info.title|escape}",
// "{\$info.description|default:''|escape}" => "{\$info.description|default:''|escape}",
// "Auto generate Biblio Code" => "Auto generate Biblio Code",
// "New reference created" => "New reference created",
// "Problems while creating the reference" => "Problems while creating the reference",
// "[-]" => "[-]",
"vote" => "投票",
// "Use &quot;%0&quot; to separate values" => "Use &quot;%0&quot; to separate values",
// "Reset to default value" => "Reset to default value",
// "Restore current value" => "Restore current value",
// "Change your preference filter settings in order to view advanced preferences by default" => "Change your preference filter settings in order to view advanced preferences by default",
// "advanced" => "advanced",
// "Change your preference filter settings in order to view experimental preferences by default" => "Change your preference filter settings in order to view experimental preferences by default",
// "experimental" => "experimental",
// "Requires" => "Requires",
// "You need apply profile" => "You need apply profile",
// "You need to set" => "You need to set",
// "Requires package" => "Requires package",
// "Missing tiki package" => "Missing tiki package",
// "User rating" => "User rating",
// "Rate" => "Rate",
// "User rating on thread topic" => "User rating on thread topic",
// "Debug Information" => "Debug Information",
// "Engine does not provide any debug information" => "Engine does not provide any debug information",
// "A valid email is mandatory to register" => "A valid email is mandatory to register",
// "{\$customfields[ir].label}" => "{\$customfields[ir].label}",
// "{\$gr.groupDesc|escape}" => "{\$gr.groupDesc|escape}",
// "Use your email address as your log-in name" => "Use your email address as your log-in name",
// "Lowercase only" => "Lowercase only",
// "New Password" => "New Password",
"Confirm password" => "再次輸入密碼",
// "Passwords match" => "Passwords match",
"Generate a password" => "產生一個密碼",
// "Passcode to register" => "Passcode to register",
// "Not your password" => "Not your password",
// "To request a passcode, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\t\t\t\t\tcontact the system administrator{if \$prefs.feature_contact eq 'y'}</a>{/if}" => "To request a passcode, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\t\t\t\t\tcontact the system administrator{if \$prefs.feature_contact eq 'y'}</a>{/if}",
// "The passcode (to block robots from registration) is" => "The passcode (to block robots from registration) is",
// "{\$remarksbox_title|escape}" => "{\$remarksbox_title|escape}",
// "Do you really want to remove the %0 scheduler" => "Do you really want to remove the %0 scheduler",
// "Reset the scheduler, will mark this run as failed, allowing it to be executed again" => "Reset the scheduler, will mark this run as failed, allowing it to be executed again",
// "Back to schedulers list" => "Back to schedulers list",
// "Reversal Event" => "Reversal Event",
// "Unique Name" => "Unique Name",
// "Type (e.g. user)" => "Type (e.g. user)",
// "Field value (e.g. user)" => "Field value (e.g. user)",
// "Pt. value" => "Pt. value",
// "The documents are returned sorted on relevance depending on order, proximity, frequency of terms. " => "The documents are returned sorted on relevance depending on order, proximity, frequency of terms. ",
// "Default search behavior" => "Default search behavior",
// "By default, all search terms are <em>optional</em>" => "By default, all search terms are <em>optional</em>",
// "It behaves like an OR logic" => "It behaves like an OR logic",
// "Objects that contain the more terms are rated higher in the results and will appear first" => "Objects that contain the more terms are rated higher in the results and will appear first",
// "For example, <strong>wiki forum</strong> will find" => "For example, <strong>wiki forum</strong> will find",
// "objects that include both tokenized terms" => "objects that include both tokenized terms",
// "objects that include the term <strong>wiki</strong>" => "objects that include the term <strong>wiki</strong>",
// "objects that include the term <strong>forum</strong>" => "objects that include the term <strong>forum</strong>",
// "Boolean operators" => "Boolean operators",
// "You can use AND or OR or NOT also to do a boolean search" => "You can use AND or OR or NOT also to do a boolean search",
// "Example: <strong>wiki and forum</strong> will find objects with both terms" => "Example: <strong>wiki and forum</strong> will find objects with both terms",
// "Example: <strong>wiki or forum</strong> will find objects with one of the term" => "Example: <strong>wiki or forum</strong> will find objects with one of the term",
// "Grouping terms" => "Grouping terms",
// "Use parenthesis ( ) to group terms into subexpressions" => "Use parenthesis ( ) to group terms into subexpressions",
// "Example: <strong>wiki and (forum blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or that contain <strong>wiki</strong> and <strong>blog</strong> in any order" => "Example: <strong>wiki and (forum blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or that contain <strong>wiki</strong> and <strong>blog</strong> in any order",
// "Finding phrases" => "Finding phrases",
// "Use double quotes ( <kbd>\" \"</kbd> ) around a phrase to find terms in the exact order, next to each other" => "Use double quotes ( <kbd>\" \"</kbd> ) around a phrase to find terms in the exact order, next to each other",
// "Example: <kbd>\"Alex Bell\"</kbd> will not find <strong>Bell Alex</strong> or <strong>Alex G. Bell</strong> but <strong>Alex Bells</strong>. " => "Example: <kbd>\"Alex Bell\"</kbd> will not find <strong>Bell Alex</strong> or <strong>Alex G. Bell</strong> but <strong>Alex Bells</strong>. ",
// "Only full word matches shown by default: Use wildcards (*) to get partial matches also. E.g. searching for 'foo' will miss foobar in the results, but 'foo*' will include it" => "Only full word matches shown by default: Use wildcards (*) to get partial matches also. E.g. searching for 'foo' will miss foobar in the results, but 'foo*' will include it",
// "media image" => "media image",
// "Expand table" => "Expand table",
// "Restore layout" => "Restore layout",
// "Items found" => "Items found",
// "Indexed" => "Indexed",
// "Queue size" => "Queue size",
// "Batch Size" => "Batch Size",
// "Process %0" => "Process %0",
// "Process Batch" => "Process Batch",
// "Your index was last fully rebuilt on %0" => "Your index was last fully rebuilt on %0",
"version" => "版本",
// "Fallback search engine" => "Fallback search engine",
// "Fallback search index was rebuild" => "Fallback search index was rebuild",
// "Fallback search index was not rebuilt" => "Fallback search index was not rebuilt",
// "Execution Statistics" => "Execution Statistics",
// "Current Memory usage" => "Current Memory usage",
// "Memory peak usage before indexing" => "Memory peak usage before indexing",
// "Memory peak usage after indexing" => "Memory peak usage after indexing",
// "Number of queries" => "Number of queries",
// "Rebuilding index.." => "Rebuilding index..",
// "Enable logging" => "Enable logging",
// "Log file is saved as %0" => "Log file is saved as %0",
// "Rebuild" => "Rebuild",
// "Process Queue" => "Process Queue",
// "Indexing Problems" => "Indexing Problems",
// "If the indexing does not complete, check the log file to see where it ended" => "If the indexing does not complete, check the log file to see where it ended",
// "Last line of log file (web)" => "Last line of log file (web)",
// "Last line of log file (console)" => "Last line of log file (console)",
// "Not enough memory" => "Not enough memory",
// "Time limit too short" => "Time limit too short",
// "High resource usage" => "High resource usage",
// "Command Line Utilities" => "Command Line Utilities",
// "Cache Expired" => "Cache Expired",
// "Unfortunately, the search cache has expired. Please <a href=\"{\$url}\" class=\"alert-link\">reload the page</a> to start over" => "Unfortunately, the search cache has expired. Please <a href=\"{\$url}\" class=\"alert-link\">reload the page</a> to start over",
// "Index" => "Index",
// "Defined" => "Defined",
"Valid" => "Valid",
// "May not work or corrupt data" => "May not work or corrupt data",
// "Alter" => "Alter",
// "No instances configured" => "No instances configured",
// "If you want this index to be on a different cluster, connected as a tribe node, you need to enter the primary cluster location here. Indices cannot be created on tribe nodes" => "If you want this index to be on a different cluster, connected as a tribe node, you need to enter the primary cluster location here. Indices cannot be created on tribe nodes",
// "Create Index" => "Create Index",
// "Return to List of Saved Searches" => "Return to List of Saved Searches",
// "Do you really want to remove the %0 saved search" => "Do you really want to remove the %0 saved search",
// "Other Queries" => "Other Queries",
// "No stored queries" => "No stored queries",
"Create New" => "建立新的",
// "This will help you recognize your stored queries if ever you want to modify or remove them" => "This will help you recognize your stored queries if ever you want to modify or remove them",
// "Use Existing" => "Use Existing",
// "{\$result.object_type|escape}" => "{\$result.object_type|escape}",
// "Last modification" => "Last modification",
// "No pages matched the search criteria test" => "No pages matched the search criteria test",
// "Download Log File" => "Download Log File",
// "Resend newsletter" => "Resend newsletter",
// "Send Newsletter" => "Send Newsletter",
// "Send newsletter" => "Send newsletter",
// "This content is licensed under the terms of the" => "This content is licensed under the terms of the",
"To edit the copyright notices" => "要編輯版權宣告",
// "Know the username" => "Know the username",
// "%0 has been accepted" => "%0 has been accepted",
// "Do you really want to approve %0" => "Do you really want to approve %0",
// "Do you really want to remove %0" => "Do you really want to remove %0",
// "No friends have been added" => "No friends have been added",
// "Incoming requests" => "Incoming requests",
// "Accept and add" => "Accept and add",
// "Still waiting for approval" => "Still waiting for approval",
// "Do you really want to cancel request for %0" => "Do you really want to cancel request for %0",
// "%0 has been removed from your friends" => "%0 has been removed from your friends",
// "Page alias.." => "Page alias..",
// "Monitor the Sub-Structure" => "Monitor the Sub-Structure",
// "Stop Monitoring the Sub-Structure" => "Stop Monitoring the Sub-Structure",
// "locked by %0" => "locked by %0",
"Locked" => "鎖定",
// "Edit page" => "Edit page",
// "Add new child page" => "Add new child page",
// "About &amp; News" => "About &amp; News",
// "Information and introduction portal" => "Information and introduction portal",
// "Documentation" => "Documentation",
// "How to use Tiki" => "How to use Tiki",
// "Development" => "Development",
// "How make Tiki" => "How make Tiki",
// "Forums and general community information" => "Forums and general community information",
// "How make Tiki look pretty" => "How make Tiki look pretty",
// "Manage" => "Manage",
// "Initializite this format with the current tracker fields" => "Initializite this format with the current tracker fields",
// "Tracker Name" => "Tracker Name",
// "File Delimiter" => "File Delimiter",
// "Comma (,)" => "Comma (,)",
// "Semicolon (;)" => "Semicolon (;)",
// "<strong>Error:</strong> Selected file has <span id=\"file-size\"></span> bytes. The max file size upload is %0 bytes" => "<strong>Error:</strong> Selected file has <span id=\"file-size\"></span> bytes. The max file size upload is %0 bytes",
// "Field Type" => "Field Type",
// "Primary Key" => "Primary Key",
// "PK" => "PK",
// "Unique Key" => "Unique Key",
// "UK" => "UK",
// "Read-Only" => "Read-Only",
// "RO" => "RO",
// "Export-Only" => "Export-Only",
// "EO" => "EO",
// "Required to import data. Can be any field as long as it is unique" => "Required to import data. Can be any field as long as it is unique",
// "Impose unique value requirement for the target column. This only works with Transactional Import feature" => "Impose unique value requirement for the target column. This only works with Transactional Import feature",
// "When importing a file, read-only fields will be skipped, preventing them from being modified, but also speeding-up the process" => "When importing a file, read-only fields will be skipped, preventing them from being modified, but also speeding-up the process",
// "When two fields affecting the same value are included in the format, such as the ID and the text value for an Item Link field, one of the two fields must be marked as read-only to prevent a conflict" => "When two fields affecting the same value are included in the format, such as the ID and the text value for an Item Link field, one of the two fields must be marked as read-only to prevent a conflict",
// "Simple headers" => "Simple headers",
// "Allow using field labels only as a header row when importing rather than the full &quot;Field [permName:type]&quot; format" => "Allow using field labels only as a header row when importing rather than the full &quot;Field [permName:type]&quot; format",
// "Import updates" => "Import updates",
// "Import update" => "Import update",
// "Allow updating existing entries matched by PK when importing. If this is disabled, only new items will be imported" => "Allow updating existing entries matched by PK when importing. If this is disabled, only new items will be imported",
// "Ignore blanks" => "Ignore blanks",
// "Ignore blank values when import is updating existing items. Only non-blank values will be updated this way" => "Ignore blank values when import is updating existing items. Only non-blank values will be updated this way",
// "Transactional import" => "Transactional import",
// "Import transaction" => "Import transaction",
// "Import in a single transaction. If any of the items fails validation, the whole import is rejected and nothing is saved" => "Import in a single transaction. If any of the items fails validation, the whole import is rejected and nothing is saved",
// "Bulk import" => "Bulk import",
// "Bulk Import" => "Bulk Import",
// "Import in 'bulk' mode so the search index is not updated for each item and no notifications should be sent" => "Import in 'bulk' mode so the search index is not updated for each item and no notifications should be sent",
// "Are you sure you want to delete this item" => "Are you sure you want to delete this item",
// "Delete item" => "Delete item",
// "Select a field.." => "Select a field..",
// "Select Mode" => "Select Mode",
// "No primary key" => "No primary key",
// "Side" => "Side",
// "Filters will be available in partial export menus" => "Filters will be available in partial export menus",
// "Skip Unmodified" => "Skip Unmodified",
// "Will not re-import items that have not changed" => "Will not re-import items that have not changed",
// "Import Completed" => "Import Completed",
// "Your import was completed succesfully" => "Your import was completed succesfully",
// "CSV File" => "CSV File",
// "Applied filters" => "Applied filters",
// "Create Tracker from File" => "Create Tracker from File",
// "Export Full" => "Export Full",
// "Export Partial" => "Export Partial",
// "Export Custom" => "Export Custom",
// "No tabular formats defined" => "No tabular formats defined",
// "Modes" => "Modes",
// "This book" => "This book",
// "before" => "before",
// "after" => "after",
// "don't display" => "don't display",
// "Decimals" => "Decimals",
// "Decimal Point" => "Decimal Point",
// "Auto Tax" => "Auto Tax",
"Tasks" => "任務",
// "Book new entries" => "Book new entries",
// "Confirm stack entries" => "Confirm stack entries",
// "Book into Stack" => "Book into Stack",
// "Accounts" => "Accounts",
// "Journal" => "Journal",
// "Fetch all" => "Fetch all",
// "Create new account" => "Create new account",
// "Edit Account" => "Edit Account",
// "Account number" => "Account number",
"Notes" => "備忘錄",
// "Budget" => "Budget",
// "Create account" => "Create account",
// "Modify account" => "Modify account",
// "\" _1=\"{\$book.bookName|escape:'attr'}\"}Delete account %0 from book %1" => "\" _1=\"{\$book.bookName|escape:'attr'}\"}Delete account %0 from book %1",
// "Delete this account" => "Delete this account",
// "Back to book page" => "Back to book page",
// "Account" => "Account",
// "Debit" => "Debit",
// "Credit" => "Credit",
// "Tax" => "Tax",
// "Unlock account" => "Unlock account",
// "Lock account" => "Lock account",
// "Remove account" => "Remove account",
// "Create a new account" => "Create a new account",
// "printable version" => "printable version",
// "export table" => "export table",
// "View account" => "View account",
// "Edit this account" => "Edit this account",
// "My books" => "My books",
// "Tax automation" => "Tax automation",
// "hide" => "hide",
// "behind" => "behind",
// "Close book" => "Close book",
// "Close book? (This action cannot be undone)" => "Close book? (This action cannot be undone)",
// "Create a book" => "Create a book",
// "Book properties" => "Book properties",
// "Name of the book" => "Name of the book",
// "First date in journal" => "First date in journal",
// "Last date in journal" => "Last date in journal",
// "Currency settings" => "Currency settings",
// "Currency (up to 3 letters) " => "Currency (up to 3 letters) ",
// "Position of the currency " => "Position of the currency ",
// "Show no currency" => "Show no currency",
// "Show currency in front of numbers" => "Show currency in front of numbers",
// "Show currency behind numbers" => "Show currency behind numbers",
// "Decimal point" => "Decimal point",
// "Decimal" => "Decimal",
// "Quote strings with" => "Quote strings with",
// "End of Line" => "End of Line",
// "Carriage return" => "Carriage return",
// "Line feed" => "Line feed",
// "Carriage Return/Line feed" => "Carriage Return/Line feed",
// "Automatic Tax Calculation" => "Automatic Tax Calculation",
// "Allow automatic tax calculation" => "Allow automatic tax calculation",
// "Create a new book" => "Create a new book",
// "Canceled Journal" => "Canceled Journal",
// "Booking Date" => "Booking Date",
// "Amount" => "Amount",
// "Book a transaction" => "Book a transaction",
// "\"}Delete account %0" => "\"}Delete account %0",
// "Add entry" => "Add entry",
// "Book" => "Book",
// "\"}Record entry in book %0" => "\"}Record entry in book %0",
// "Export {\$what}" => "Export {\$what}",
// "Export CSV settings" => "Export CSV settings",
// "Separator between fields" => "Separator between fields",
// "Quote character for text" => "Quote character for text",
// "Export as CSV" => "Export as CSV",
// "\" _1=\"{\$book.bookName|escape:'attr'}\"}Cancel transaction ID %0 in book %1" => "\" _1=\"{\$book.bookName|escape:'attr'}\"}Cancel transaction ID %0 in book %1",
// "Cancel transaction" => "Cancel transaction",
// "Balance" => "Balance",
// "Deleted" => "Deleted",
// "Debit Account" => "Debit Account",
// "Debit Amount" => "Debit Amount",
// "Debit Text" => "Debit Text",
// "Credit Account" => "Credit Account",
// "Credit Amount" => "Credit Amount",
// "Credit Text" => "Credit Text",
// "Book a transaction into the stack" => "Book a transaction into the stack",
// "\"}Record stack entry in book %0" => "\"}Record stack entry in book %0",
// "\"}Modify stack entry in book %0" => "\"}Modify stack entry in book %0",
// "\" _1=\"{\$book.bookName|escape:'attr'}\"}Delete stack %0 from book %1" => "\" _1=\"{\$book.bookName|escape:'attr'}\"}Delete stack %0 from book %1",
// "Remove transaction" => "Remove transaction",
// "\" _1=\"{\$book.bookName|escape:'attr'}\"}Confirm stack %0 for book %1" => "\" _1=\"{\$book.bookName|escape:'attr'}\"}Confirm stack %0 for book %1",
// "Confirm transaction" => "Confirm transaction",
// "Do not group by item" => "Do not group by item",
// "Group by item" => "Group by item",
// "Calendar View" => "Calendar View",
// "Tiki Action Calendar" => "Tiki Action Calendar",
"Tools Calendars" => "工具行事曆",
"Check / Uncheck All" => "全選/全取消",
// "Your sender email is not set. You can set it <a href=\"%0\" class=\"alert-link\">in the general admin panel.</a>" => "Your sender email is not set. You can set it <a href=\"%0\" class=\"alert-link\">in the general admin panel.</a>",
// "Database Version Problem" => "Database Version Problem",
// "Your database requires an update to match the current Tiki version. Please proceed to <a class=\"alert-link\" href=\"tiki-install.php\">the installer</a>. Using Tiki with an incorrect database version usually provokes errors" => "Your database requires an update to match the current Tiki version. Please proceed to <a class=\"alert-link\" href=\"tiki-install.php\">the installer</a>. Using Tiki with an incorrect database version usually provokes errors",
// "Vendor folder issues" => "Vendor folder issues",
// "Your vendor folder contains multiple packages that were normally bundled with Tiki. Since version 17 those libraries were migrated from the folder <strong>vendor</strong> to the folder <strong>vendor_bundled</strong>" => "Your vendor folder contains multiple packages that were normally bundled with Tiki. Since version 17 those libraries were migrated from the folder <strong>vendor</strong> to the folder <strong>vendor_bundled</strong>",
// "To avoid issues your <strong>vendor/autoload.php</strong> was not loaded" => "To avoid issues your <strong>vendor/autoload.php</strong> was not loaded",
// "We recommend that you remove/clean the <strong>vendor/</strong> folder content unless you really want to load these libraries, that are not bundled with tiki, and in such case add a file called <strong>vendor/do_not_clean.txt</strong> to force the load of these libraries" => "We recommend that you remove/clean the <strong>vendor/</strong> folder content unless you really want to load these libraries, that are not bundled with tiki, and in such case add a file called <strong>vendor/do_not_clean.txt</strong> to force the load of these libraries",
// "To avoid issues your <strong>vendor/autoload.php</strong> was renamed to <strong>vendor/autoload-disabled.php</strong>" => "To avoid issues your <strong>vendor/autoload.php</strong> was renamed to <strong>vendor/autoload-disabled.php</strong>",
// "For more information check <strong>vendor/autoload-disabled-README.txt</strong> file" => "For more information check <strong>vendor/autoload-disabled-README.txt</strong> file",
// "Installer not locked" => "Installer not locked",
// " The installer allows a user to change or destroy the site's database through the browser so it is very important to keep it locked. " => " The installer allows a user to change or destroy the site's database through the browser so it is very important to keep it locked. ",
// "<br />You can re-run the installer (tiki-install.php), skip to the last step and select <strong>LOCK THE INSTALLER</strong>. Alternatively, you can simply <strong>add a lock file</strong> (file without any extension) in your db/ folder" => "<br />You can re-run the installer (tiki-install.php), skip to the last step and select <strong>LOCK THE INSTALLER</strong>. Alternatively, you can simply <strong>add a lock file</strong> (file without any extension) in your db/ folder",
// "You can also use the following, on the command line, from the root of your Tiki installation" => "You can also use the following, on the command line, from the root of your Tiki installation",
// "Search Index outdated" => "Search Index outdated",
// "The search index might be outdated. It is recommended to rebuild the search index" => "The search index might be outdated. It is recommended to rebuild the search index",
// "File gallery directory web accessable" => "File gallery directory web accessable",
// "This is a potential security risk" => "This is a potential security risk",
// "You may deny access to this directory with server access rules, move your gallery directory into a space outside of your web root, or transfer file gallery storage into the database" => "You may deny access to this directory with server access rules, move your gallery directory into a space outside of your web root, or transfer file gallery storage into the database",
// "}The <strong>%0</strong> parameter has an invalid value: <strong>%1</strong>" => "}The <strong>%0</strong> parameter has an invalid value: <strong>%1</strong>",
// "Please select some actions to be reported" => "Please select some actions to be reported",
"End" => "結束",
// "Users and Groups" => "Users and Groups",
"Misc" => "其它",
// "Units" => "Units",
// "kb" => "kb",
// "Contribution Time" => "Contribution Time",
// "Graph Contributions" => "Graph Contributions",
// "Group Bar Plot" => "Group Bar Plot",
// "Accumulated Bar Plot" => "Accumulated Bar Plot",
// "Background color" => "Background color",
// "{\$color}" => "{\$color}",
// "Legend background color" => "Legend background color",
// "Save graphs to image gallery" => "Save graphs to image gallery",
// "Records" => "Records",
// "See Statistics" => "See Statistics",
// "contribution" => "contribution",
// "contributor" => "contributor",
// "{\$actionlog.action|escape}" => "{\$actionlog.action|escape}",
// "{\$actionlog.objectType}" => "{\$actionlog.objectType}",
// "{\$actionlog.ip}" => "{\$actionlog.ip}",
// "Delete action from log" => "Delete action from log",
// "Select action to perform with checked" => "Select action to perform with checked",
// "Delete selected actions from log" => "Delete selected actions from log",
// "Edit Action" => "Edit Action",
// "Save Action" => "Save Action",
"Statistics" => "統計",
// "Volumes are equally distributed on each contributors/author" => "Volumes are equally distributed on each contributors/author",
// "connection time" => "connection time",
// "connection seconds" => "connection seconds",
// "mns" => "mns",
// "Volume per category" => "Volume per category",
// "Volume per category and per user" => "Volume per category and per user",
// "Number of actions per user" => "Number of actions per user",
// "Total number of users" => "Total number of users",
// "Number of actions per object" => "Number of actions per object",
// "Total number of objects" => "Total number of objects",
// "Bigbluebutton" => "Bigbluebutton",
// "Time in bigbluebutton (in minutes)" => "Time in bigbluebutton (in minutes)",
// "Number of actions per category" => "Number of actions per category",
// "Number of actions per category and per user" => "Number of actions per category and per user",
// "Volume per the users' group and per contribution" => "Volume per the users' group and per contribution",
// "Volume per group and per contribution" => "Volume per group and per contribution",
// "Volume per user and per contribution" => "Volume per user and per contribution",
// "Volume per users' contribution and time" => "Volume per users' contribution and time",
// "Volume per contribution and time" => "Volume per contribution and time",
"Weeks" => "數週",
// "How" => "How",
// "You need to check out the recorded box for each action type we may be interested to have some report later. To see a report of some action types, select the reported checkboxes of these action types, goto the Report tab and select additional filters. The report will only contains the actions that occurred since the action type has been set to recorded" => "You need to check out the recorded box for each action type we may be interested to have some report later. To see a report of some action types, select the reported checkboxes of these action types, goto the Report tab and select additional filters. The report will only contains the actions that occurred since the action type has been set to recorded",
// "Wiki page actions except viewed will always be recorded but can be not reported" => "Wiki page actions except viewed will always be recorded but can be not reported",
// "Recorded" => "Recorded",
// "{\$actionlog.action}" => "{\$actionlog.action}",
// "Import as CSV" => "Import as CSV",
// "Banning rules have been updated" => "Banning rules have been updated",
// "Add or edit rules" => "Add or edit rules",
"Rule title" => "規則名稱",
"Username regex matching" => "使用者名稱符合正規表示式",
// "Multiple IP regex matching" => "Multiple IP regex matching",
"IP regex matching" => "IP 符合正規表示式",
"Banned from sections" => "禁用下列區段",
// "{\$sec}" => "{\$sec}",
"Rule activated by dates" => "規則依日期啟用",
"Rule active from" => "規則起始日期",
"Rule active until" => "規則結束日期",
"Custom message to the user" => "給使用者的自訂訊息",
// "Import rules as CSV" => "Import rules as CSV",
// "Column names on the first line" => "Column names on the first line",
// "Sections format" => "Sections format",
// "section names are splitted by pipes (vertical bars). To see an example and use it as template, add one rule by hand, and export it as csv" => "section names are splitted by pipes (vertical bars). To see an example and use it as template, add one rule by hand, and export it as csv",
// "See" => "See",
// "Import as new rules" => "Import as new rules",
"Find:" => "尋找:",
// "Current rules" => "Current rules",
"x" => "x",
// "Delete selected banning rules" => "Delete selected banning rules",
"User/IP" => "使用者/IP",
// "Delete banning rule" => "Delete banning rule",
// "No rules found" => "No rules found",
"Admin Calendars" => "管理行事曆",
// "Create Calendar" => "Create Calendar",
// "View Calendars" => "View Calendars",
// "Calendar name" => "Calendar name",
"Participants" => "參與者",
// "Personal" => "Personal",
// "Field will show in popup" => "Field will show in popup",
"Custom location" => "自訂位置",
// "Custom participants" => "Custom participants",
// "Custom languages" => "Custom languages",
// "Add event" => "Add event",
// "Delete calendar" => "Delete calendar",
// "Edit Calendar" => "Edit Calendar",
// "Custom classification" => "Custom classification",
"Custom language" => "自訂語系",
// "Custom subscription list" => "Custom subscription list",
"Custom priority" => "自訂重要性",
// "Personal Calendar" => "Personal Calendar",
// "Start of day" => "Start of day",
// "End of day" => "End of day",
// "Days to display" => "Days to display",
// "Standard color" => "Standard color",
// "Green" => "Green",
// "Purple" => "Purple",
// "Orange" => "Orange",
// "Yellow" => "Yellow",
// "Custom foreground color" => "Custom foreground color",
// "Custom background color" => "Custom background color",
// "Default event status" => "Default event status",
// "Show in popup view" => "Show in popup view",
// "Show in calendar view" => "Show in calendar view",
// "Group of users alerted when calendar event is modified" => "Group of users alerted when calendar event is modified",
// "Default length of events is all day" => "Default length of events is all day",
// "Event name on each day in calendar view" => "Event name on each day in calendar view",
// "Delete events older than" => "Delete events older than",
// "Delete old events" => "Delete old events",
// "Browse the category system" => "Browse the category system",
// "Create category" => "Create category",
// "Edit category" => "Edit category",
"Edit this category:" => "編輯此類別:",
"Add new category" => "加入新類別",
// "Apply parent category permissions" => "Apply parent category permissions",
"Objects in category" => "分類中的物件",
// "Remove from this category" => "Remove from this category",
// "Remove object from category" => "Remove object from category",
// "{\$objects[ix].type}" => "{\$objects[ix].type}",
// "Remove checked" => "Remove checked",
// "Remove objects from category" => "Remove objects from category",
// "Moving objects" => "Moving objects",
// "Moving objects between categories" => "Moving objects between categories",
"Current category" => "目前分類",
// "Perform an action on all objects in the current category" => "Perform an action on all objects in the current category",
// "Unassign objects from category" => "Unassign objects from category",
// "Move to selected category" => "Move to selected category",
// "Choose destination category" => "Choose destination category",
// "Copy to selected category" => "Copy to selected category",
// "Add objects" => "Add objects",
"Add objects to category" => "增加物件到分類中",
"Objects" => "物件",
"Quiz" => "測驗",
"Batch upload" => "批次上傳",
// "Sample file content" => "Sample file content",
// "Content templates" => "Content templates",
"Templates" => "模板",
// "Visible in no sections" => "Visible in no sections",
// "Remove section" => "Remove section",
// "Uncategorized" => "Uncategorized",
// "{\$catName}" => "{\$catName}",
// "Remove template" => "Remove template",
// "Edit template" => "Edit template",
// "Create template" => "Create template",
// "Use the Administration page of each enabled feature to allow the use of content templates" => "Use the Administration page of each enabled feature to allow the use of content templates",
// "Name field is mandatory" => "Name field is mandatory",
// "No features are configured to use templates" => "No features are configured to use templates",
// "Template Type" => "Template Type",
// "Text area" => "Text area",
// "Admin Contributions" => "Admin Contributions",
// "Edit the contribution" => "Edit the contribution",
// "Contributions are mandatory in wiki pages" => "Contributions are mandatory in wiki pages",
// "Contributions are mandatory in forums" => "Contributions are mandatory in forums",
// "Contributions are mandatory in comments" => "Contributions are mandatory in comments",
// "Contributions are mandatory in blogs" => "Contributions are mandatory in blogs",
// "Contributions are displayed in the comment/post" => "Contributions are displayed in the comment/post",
// "Create a new contribution" => "Create a new contribution",
// "List of contributions" => "List of contributions",
// "Remove contribution" => "Remove contribution",
"Admin cookies" => "管理 cookies",
// "To use cookie in a text area (Wiki page, etc), a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{cookie}{/literal}" => "To use cookie in a text area (Wiki page, etc), a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{cookie}{/literal}",
"Create/edit cookies" => "建立/編輯 cookies",
"Upload Cookies from textfile" => "由文字檔上傳 Cookies",
// "Upload from disk" => "Upload from disk",
"Remove all cookies" => "移除所有cookies",
"cookie" => "cookie",
// "Remove cookie" => "Remove cookie",
// "Manage Credits" => "Manage Credits",
// "(YYYY-MM-DD HH:MM:SS)" => "(YYYY-MM-DD HH:MM:SS)",
// "(level credits always 0)" => "(level credits always 0)",
// "Delete Checked" => "Delete Checked",
// "User Credits Expiry Summary (Plans)" => "User Credits Expiry Summary (Plans)",
// "User Plan" => "User Plan",
// "Start of Latest Plan" => "Start of Latest Plan",
// "Start of Next Plan" => "Start of Next Plan",
// "Expiry" => "Expiry",
// "Use User Credits" => "Use User Credits",
// "Restore User Level Credits" => "Restore User Level Credits",
// "Historical Usage Report" => "Historical Usage Report",
// "all types" => "all types",
"filter" => "過濾器",
// "Usage Date" => "Usage Date",
// "Amount Used" => "Amount Used",
// "No such user" => "No such user",
// "Manage Credit Types" => "Manage Credit Types",
// "Display Text" => "Display Text",
// "Unit Text" => "Unit Text",
// "Is Static Level Credit" => "Is Static Level Credit",
// "Display Bar Length Scaling Divisor" => "Display Bar Length Scaling Divisor",
// "Purge Expired and Used Credits (All Users)" => "Purge Expired and Used Credits (All Users)",
// "Purge" => "Purge",
// "Admin Content Sources" => "Admin Content Sources",
// "Use Admin DSN to define the database to be used by the SQL plugin" => "Use Admin DSN to define the database to be used by the SQL plugin",
// "Create/edit DSN" => "Create/edit DSN",
// "Local (Tiki database)" => "Local (Tiki database)",
// "See db/local.php" => "See db/local.php",
// "Remove DSN" => "Remove DSN",
// "Content Authentication" => "Content Authentication",
// "Identification" => "Identification",
// "HTTP Basic" => "HTTP Basic",
// "HTTP Session / Login" => "HTTP Session / Login",
// "HTTP Session / Visit" => "HTTP Session / Visit",
// "Admin External Wikis" => "Admin External Wikis",
// "Create/Edit External Wiki" => "Create/Edit External Wiki",
"URL (use \$page to be replaced by the page name in the URL example: http://www.example.com/tiki-index.php?page=\$page)" => "URL (在URL中使用 \$page 來取代 page, 例如: http://www.example.com/tiki-index.php?page=\$page)",
// "<em>[prefix]</em>main, such as tiki_main" => "<em>[prefix]</em>main, such as tiki_main",
// "Search as" => "Search as",
// "Leave blank to search using currently active groups" => "Leave blank to search using currently active groups",
"ExtWiki" => "外部wiki",
// "Search As" => "Search As",
// "Remove external wiki" => "Remove external wiki",
"Admin Forums" => "管理論壇",
// "Create Forum" => "Create Forum",
"Age" => "年齡",
"PPD" => "每日發表數",
// "Create/Edit Forums" => "Create/Edit Forums",
"Edit this Forum:" => "編輯此論壇:",
"Create New Forum" => "建立新論壇",
// "Main details" => "Main details",
// "Image symbolizing the forum" => "Image symbolizing the forum",
// "Only allow replies to the first message (flat forum)" => "Only allow replies to the first message (flat forum)",
"Moderator user" => "管理者帳號",
"Moderator group" => "管理者群組",
"Password protected" => "受密碼保護",
"Forum password" => "論壇密碼",
"Prevent flooding" => "防止灌水",
"Minimum time between posts" => "發表佈告的最小間隔時間",
"Send the posts of this forum to this email address" => "寄送此論壇文章到這個電子郵件",
"Prune unreplied-to messages after" => "刪去未回覆的訊息於",
"Prune old messages after" => "刪去舊訊息於",
// "Forum-mailing list synchronization" => "Forum-mailing list synchronization",
// "Forward messages to this forum to this email address, in a format that can be used for sending back to the inbound forum email address" => "Forward messages to this forum to this email address, in a format that can be used for sending back to the inbound forum email address",
// "Send emails even when the post is generated by an inbound email" => "Send emails even when the post is generated by an inbound email",
// "Append a reply link to outbound mails" => "Append a reply link to outbound mails",
// "Originating email address for emails from this forum" => "Originating email address for emails from this forum",
"Add messages from this email to the forum" => "將來自此 email 的訊息增加至論壇",
"POP3 server" => "POP3 伺服器",
// "Forums list" => "Forums list",
// "Display last post titles" => "Display last post titles",
// "Forum topics (threads) list" => "Forum topics (threads) list",
"Default order of topics" => "預設主題排列順序",
"Topics per page" => "每頁主題數",
"Topic list configuration" => "主題列表設定",
// "Last post title" => "Last post title",
// "Last post profile picture" => "Last post profile picture",
// "Author profile picture" => "Author profile picture",
"Use topic smileys" => "主題可使用表情符號",
"Show topic summary" => "顯示主題統計",
// "Forum threads" => "Forum threads",
// "Default ordering of threads" => "Default ordering of threads",
// "Default style of threads" => "Default style of threads",
"Approval type" => "核可方式",
// "Topic Rating" => "Topic Rating",
"User Level" => "使用者等級",
"eMail" => "電子郵件",
"Online" => "線上",
"Permission" => "權限",
// "Store attachments in" => "Store attachments in",
// "File system" => "File system",
"Max attachment size (bytes)" => "最大附件大小 (bytes)",
// "Shows number of attachments of the all thread in forum list" => "Shows number of attachments of the all thread in forum list",
// "Duplicate Forum" => "Duplicate Forum",
"Admin Hotwords" => "管理熱門單字",
"Add Hotword" => "加入熱門字眼",
"Word" => "單字",
// "Delete hotword" => "Delete hotword",
// "Admin HTML Page Dynamic Zones" => "Admin HTML Page Dynamic Zones",
"Admin HTML pages" => "管理 HTML 頁面",
"Edit zone" => "編輯區域",
"Dynamic zones" => "動態區域",
"zone" => "區域",
"content" => "內容",
"Mass update" => "大量更新",
// "Use {literal}{ed id=name}{/literal} or {literal}{ted id=name}{/literal} to insert dynamic zones" => "Use {literal}{ed id=name}{/literal} or {literal}{ted id=name}{/literal} to insert dynamic zones",
"Create new HTML page" => "建立新 HTML 頁面",
"Edit this HTML page:" => "編輯此 HTML 頁面:",
"Apply template" => "套用模板",
// "{\$templates[ix].name}" => "{\$templates[ix].name}",
"Dynamic" => "動態",
"Static" => "靜態",
// "Refresh rate (if dynamic)" => "Refresh rate (if dynamic)",
"Last Modif" => "最近修改",
// "Admin dynamic zones" => "Admin dynamic zones",
// "Remove HTML page" => "Remove HTML page",
// "IDS Rules" => "IDS Rules",
// "Add a new Rule" => "Add a new Rule",
// "Rule ID" => "Rule ID",
// "Impact" => "Impact",
// "Edit rule settings" => "Edit rule settings",
// "Edit Rule" => "Edit Rule",
// "Add a new rule" => "Add a new rule",
// "Rule Id" => "Rule Id",
// "Rule Id must be numeric" => "Rule Id must be numeric",
// "Rule Regex" => "Rule Regex",
// "An easier way to integrate content from another site into Tiki is via iframed links using Tiki's <a class=\"alert-link\" href=\"tiki-admin_links.php\">featured links</a> feature" => "An easier way to integrate content from another site into Tiki is via iframed links using Tiki's <a class=\"alert-link\" href=\"tiki-admin_links.php\">featured links</a> feature",
// "Edit Repository" => "Edit Repository",
// "Create New Repository" => "Create New Repository",
// "Human-readable repository name" => "Human-readable repository name",
// "Path to repository (local filesystem: relative/absolute web root, remote: prefixed with 'http://')" => "Path to repository (local filesystem: relative/absolute web root, remote: prefixed with 'http://')",
// "File name of start page" => "File name of start page",
// "Start page" => "Start page",
// "CSS file to load when browse this repository" => "CSS file to load when browse this repository",
// "CSS File" => "CSS File",
// "Is repository visible to users" => "Is repository visible to users",
// "Can files from repository be cached" => "Can files from repository be cached",
// "Cacheable" => "Cacheable",
// "Clear all cached pages of this repository" => "Clear all cached pages of this repository",
// "Clear cache" => "Clear cache",
// "Seconds count 'till cached page will be expired" => "Seconds count 'till cached page will be expired",
// "Cache expiration" => "Cache expiration",
// "Human-readable text description of repository" => "Human-readable text description of repository",
// "Available Repositories" => "Available Repositories",
// "Edit rules" => "Edit rules",
// "Edit Rules for Repository" => "Edit Rules for Repository",
// "Configure Repositories" => "Configure Repositories",
// "List Repositories" => "List Repositories",
// "Configure this Repository" => "Configure this Repository",
// "View this Repository" => "View this Repository",
// "New Rule" => "New Rule",
// "Copy Rules" => "Copy Rules",
// "view/hide copy rules dialog" => "view/hide copy rules dialog",
// "Source repository" => "Source repository",
// "Rules will be applied in this order ('0' or empty = auto)" => "Rules will be applied in this order ('0' or empty = auto)",
// "Rule order" => "Rule order",
// "Text to search for" => "Text to search for",
// "Text to replace" => "Text to replace",
// "Is this regular expression or simple search/replacer" => "Is this regular expression or simple search/replacer",
// "Regex" => "Regex",
// "Is case sensitive (for simple replacer)" => "Is case sensitive (for simple replacer)",
// "Case sensitive" => "Case sensitive",
// "subset of chars: imsxeADSXUu, which are regex modifiers" => "subset of chars: imsxeADSXUu, which are regex modifiers",
// "Regex modifiers" => "Regex modifiers",
// "Human-readable text description of rule" => "Human-readable text description of rule",
// "Check to enable this rule" => "Check to enable this rule",
// "Preview options" => "Preview options",
// "Apply all rules or just this to generate preview" => "Apply all rules or just this to generate preview",
// "Apply all rules" => "Apply all rules",
// "View source code after rules applied" => "View source code after rules applied",
// "Code preview" => "Code preview",
// "Generate HTML preview" => "Generate HTML preview",
// "HTML preview" => "HTML preview",
// "Test file from repository to generate preview for (empty = configured start page)" => "Test file from repository to generate preview for (empty = configured start page)",
// "Preview Results" => "Preview Results",
// "Rules List" => "Rules List",
// "Case" => "Case",
// "Admin Invoices" => "Admin Invoices",
// "Admin keywords" => "Admin keywords",
// "Edit page keywords" => "Edit page keywords",
// "Current Page Keywords" => "Current Page Keywords",
// "Search by page" => "Search by page",
// "results found" => "results found",
// "Remove keywords for this page" => "Remove keywords for this page",
"No pages found" => "找不到頁面",
// "To use these links, you must assign the featured_links <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a>" => "To use these links, you must assign the featured_links <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a>",
"Generate positions by hits" => "由點擊數產生位置",
"List of featured links" => "列出主打連結",
// "Remove featured link" => "Remove featured link",
"Add Featured Link" => "加入主打連結",
"Edit this Featured Link:" => "編輯此主打連結:",
"Create new Featured Link" => "建立新主打連結",
"disables the link" => "關閉此連結",
"Link type" => "連結類型",
"replace current page" => "取代目前頁面",
"framed" => "頁框",
"open new window" => "開啟新視窗",
// "Mail-in accounts" => "Mail-in accounts",
// "Allow" => "Allow",
// "Leave" => "Leave",
// "Auto-category" => "Auto-category",
// "Auto-namespace" => "Auto-namespace",
// "Administrator" => "Administrator",
// "Admin Mail-in Routes" => "Admin Mail-in Routes",
// "Check Mail-in accounts" => "Check Mail-in accounts",
// "Check automatically" => "Check automatically",
"Frequency" => "頻率",
// "Check Manually Now" => "Check Manually Now",
// "Admin Mail-in routes" => "Admin Mail-in routes",
// "Structure Routing" => "Structure Routing",
// "Wiki structures feature is not enabled" => "Wiki structures feature is not enabled",
// "List Menus" => "List Menus",
// "Create menu option" => "Create menu option",
// "Edit This Menu" => "Edit This Menu",
// "Export menu options" => "Export menu options",
// "Import menu options" => "Import menu options",
// "Manage menu" => "Manage menu",
"Menu options" => "選單項目",
// "Save Options" => "Save Options",
// "New option" => "New option",
// "Check this if the option is an alternative to the previous one" => "Check this if the option is an alternative to the previous one",
// "Drag this on to the menu area below" => "Drag this on to the menu area below",
// "URL or ((page name))" => "URL or ((page name))",
// "Test URL" => "Test URL",
// "Remove Option" => "Remove Option",
"Preview menu" => "預覽選單",
// "Deploy" => "Deploy",
// "Menu Options" => "Menu Options",
// "RESET" => "RESET",
"Clear Cache" => "清除快取",
// "Show hidden modules" => "Show hidden modules",
// "Hide hidden modules" => "Hide hidden modules",
// "Exit Modules" => "Exit Modules",
// "Modules Parameters" => "Modules Parameters",
// "The following required parameters are missing" => "The following required parameters are missing",
// "Drag the modules around to re-order then click save when ready" => "Drag the modules around to re-order then click save when ready",
// "Double click them to edit" => "Double click them to edit",
// "Modules with \"position: absolute\" in their style can be dragged in to position" => "Modules with \"position: absolute\" in their style can be dragged in to position",
// "New modules can be dragged from the \"All Modules\" tab" => "New modules can be dragged from the \"All Modules\" tab",
// "Links and buttons in modules, apart from the Application Menu, have been deliberately disabled on this page to make drag and drop more reliable. Click here to return <a href=\"./\" class=\"alert-link\">HOME</a>" => "Links and buttons in modules, apart from the Application Menu, have been deliberately disabled on this page to make drag and drop more reliable. Click here to return <a href=\"./\" class=\"alert-link\">HOME</a>",
// "More info here" => "More info here",
// "Assigned modules" => "Assigned modules",
// "Assign/Edit modules" => "Assign/Edit modules",
"Assigned Modules" => "指定模組",
// "Add module" => "Add module",
// "You will need to go" => "You will need to go",
// "to reorder or move modules in the left or right columns since you have created a custom order for these" => "to reorder or move modules in the left or right columns since you have created a custom order for these",
// "Use the table below to assign previously unassigned modules, or reorder and move modules where there is no custom order created by the user" => "Use the table below to assign previously unassigned modules, or reorder and move modules where there is no custom order created by the user",
// "Edit module" => "Edit module",
"Assign new module" => "指定新模組",
"Edit this assigned module:" => "編輯指定的模組:",
// "Module Options" => "Module Options",
// "Custom Modules" => "Custom Modules",
// "Delete custom module" => "Delete custom module",
// "Create new custom module" => "Create new custom module",
// "Edit this custom module" => "Edit this custom module",
// "Create your new custom module below. Make sure to preview first and make sure all is OK before <a href=\"#assign\" class=\"alert-link\">assigning it</a>. Using HTML, you will be fine. However, if you improperly use wiki syntax or Smarty code, you could lock yourself out of the site" => "Create your new custom module below. Make sure to preview first and make sure all is OK before <a href=\"#assign\" class=\"alert-link\">assigning it</a>. Using HTML, you will be fine. However, if you improperly use wiki syntax or Smarty code, you could lock yourself out of the site",
// "Parse using" => "Parse using",
// "Wiki Markup" => "Wiki Markup",
"Objects that can be included" => "允許包含的物件",
"Available polls" => "現有的投票",
// "Random active poll" => "Random active poll",
// "Random current poll" => "Random current poll",
// "Use gallery" => "Use gallery",
"Random image from" => "隨機影像 由",
"Dynamic content blocks" => "動態內容區塊",
// "Use dynamic content" => "Use dynamic content",
// "External feeds" => "External feeds",
// "Use RSS module" => "Use RSS module",
"Banner zones" => "大標題區域",
// "Use banner zone" => "Use banner zone",
// "Use wiki structure" => "Use wiki structure",
// "To use a <a target=\"tikihelp\" href=\"http://users.tpg.com.au/j_birch/plugins/superfish/\" class=\"alert-link\">CSS (Superfish) menu</a>, use one of these syntaxes" => "To use a <a target=\"tikihelp\" href=\"http://users.tpg.com.au/j_birch/plugins/superfish/\" class=\"alert-link\">CSS (Superfish) menu</a>, use one of these syntaxes",
// "To use a default Tiki menu" => "To use a default Tiki menu",
// "All Modules" => "All Modules",
// "Show all modules" => "Show all modules",
"Admin newsletter subscriptions" => "管理電子報訂閱",
"Subscriptions" => "訂閱",
// "Groups included through inheritance" => "Groups included through inheritance",
// "Remove subscription" => "Remove subscription",
// "Wiki Page Name" => "Wiki Page Name",
// "Validate Addresses" => "Validate Addresses",
// "Add To List" => "Add To List",
"Subscribed" => "訂閱",
// "Mark subscription as valid" => "Mark subscription as valid",
// "Unsubscribed" => "Unsubscribed",
// "Remove selected subscriptions" => "Remove selected subscriptions",
// "Add subscribers" => "Add subscribers",
// "You can add several email addresses by separating them with commas" => "You can add several email addresses by separating them with commas",
// "Add email" => "Add email",
// "Add user" => "Add user",
// "Users from group" => "Users from group",
// "Group subscription also subscribes included groups" => "Group subscription also subscribes included groups",
// "Don't send confirmation email" => "Don't send confirmation email",
// "The user email will be refreshed at each newsletter sending" => "The user email will be refreshed at each newsletter sending",
// "Import emails from file" => "Import emails from file",
// ".txt file, one email per line" => ".txt file, one email per line",
// "Don't send confirmation emails" => "Don't send confirmation emails",
// "Import emails from wiki page" => "Import emails from wiki page",
// "Wiki page, one email per line" => "Wiki page, one email per line",
// "Import emails from tracker" => "Import emails from tracker",
// "Subscribe group" => "Subscribe group",
// "Including group inheritance" => "Including group inheritance",
// "Including group, group users and emails will be refreshed at each newsletter sending" => "Including group, group users and emails will be refreshed at each newsletter sending",
// "Use subscribers of another newsletter" => "Use subscribers of another newsletter",
// "Use emails from wiki page" => "Use emails from wiki page",
"Wiki page" => "Wiki 頁面",
// "Emails on a wiki page which will be added at each newsletter sending, one email per line" => "Emails on a wiki page which will be added at each newsletter sending, one email per line",
// "Don't subscribe emails" => "Don't subscribe emails",
// "Export Subscriber Emails" => "Export Subscriber Emails",
"Admin newsletters" => "管理電子報",
"List Newsletters" => "列出電子報",
"Send Newsletters" => "送出電子報",
"Editions" => "版本",
// "Drafts" => "Drafts",
"Last Sent" => "上次寄出",
// "Remove newsletter" => "Remove newsletter",
"Create/Edit Newsletters" => "建立/編輯電子報",
"There are individual permissions set for this newsletter" => "此電子報有獨立的權限設定",
// "Users can subscribe/unsubscribe to this list" => "Users can subscribe/unsubscribe to this list",
// "Users can subscribe any email address" => "Users can subscribe any email address",
// "Add unsubscribe instructions to each newsletter" => "Add unsubscribe instructions to each newsletter",
// "Validate email addresses" => "Validate email addresses",
// "Allow customized text message to be sent with the HTML version" => "Allow customized text message to be sent with the HTML version",
// "Allow clipping of articles into newsletter" => "Allow clipping of articles into newsletter",
// "Automatically clip articles into newsletter" => "Automatically clip articles into newsletter",
// "Do not send newsletter if clip is empty" => "Do not send newsletter if clip is empty",
// "Clip articles published in the past number of days" => "Clip articles published in the past number of days",
// "Article types to clip" => "Article types to clip",
// "Mail notifications" => "Mail notifications",
// "You need to set <a class=\"alert-link\" href=\"tiki-admin.php?page=general\">Sender Email</a> before creating email notifications" => "You need to set <a class=\"alert-link\" href=\"tiki-admin.php?page=general\">Sender Email</a> before creating email notifications",
"Add notification" => "增加通知",
// "Destination" => "Destination",
// "Myself" => "Myself",
// "Note that a user is not notified for his or her own action" => "Note that a user is not notified for his or her own action",
// "User / Group" => "User / Group",
// "Delete mail notification event" => "Delete mail notification event",
// "Delete selected notification events" => "Delete selected notification events",
// "Trackers Outbound Emails" => "Trackers Outbound Emails",
// "Forums Outbound Emails" => "Forums Outbound Emails",
// "OAuth Server" => "OAuth Server",
// "List of clients" => "List of clients",
// "Client_id" => "Client_id",
// "Client_secret" => "Client_secret",
// "Redirect_uri" => "Redirect_uri",
"Admin Polls" => "管理投票",
"Preview poll" => "閱覽這個投票",
// "Add poll option" => "Add poll option",
// "Edit poll option" => "Edit poll option",
"Poll options" => "投票選項",
"Votes" => "投票",
"Set last poll as current" => "設定最後一個投票為目前的投票",
"Close all polls but last" => "關閉所有投票除了最後一個",
"Activate all polls" => "啟動所有投票",
// "Create poll" => "Create poll",
// "Edit poll" => "Edit poll",
"active" => "啟動",
"object" => "物件",
// "Toggle Quick Options" => "Toggle Quick Options",
// "Add Option" => "Add Option",
// "Leave box empty to delete an option" => "Leave box empty to delete an option",
// "Votes older than x days are not considered" => "Votes older than x days are not considered",
// "0 for no limit" => "0 for no limit",
"Results" => "結果",
// "Add poll to pages" => "Add poll to pages",
// "{\$channels[ix].title}" => "{\$channels[ix].title}",
// "This menu shows only Polls with 'status': \"template\"" => "This menu shows only Polls with 'status': \"template\"",
// "{\$listPages[ix].pageName|escape}" => "{\$listPages[ix].pageName|escape}",
// "Lock the pages" => "Lock the pages",
// "Custom Route" => "Custom Route",
// "Add a new Custom Route" => "Add a new Custom Route",
// "Edit route settings" => "Edit route settings",
// "Edit route" => "Edit route",
// "Add a new route" => "Add a new route",
// "If you select router type \"To tracker item by field value\", you must use a regular expression in the From field value" => "If you select router type \"To tracker item by field value\", you must use a regular expression in the From field value",
// "The users will get redirected to the tracker item that has a field that matches the value found in the URL" => "The users will get redirected to the tracker item that has a field that matches the value found in the URL",
// "|^page(\\d+)\$| will redirect /page10 to the tracker item where the selected value is 10" => "|^page(\\d+)\$| will redirect /page10 to the tracker item where the selected value is 10",
// "Router Type" => "Router Type",
// "Check this option to set route as a Short URL" => "Check this option to set route as a Short URL",
// "This page is to configure settings of external feeds read/imported by Tiki. To generate/export feeds, look for \"Feeds\" on the admin panel, or" => "This page is to configure settings of external feeds read/imported by Tiki. To generate/export feeds, look for \"Feeds\" on the admin panel, or",
// "To use feeds in a text area (Wiki page, etc), a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the feed" => "To use feeds in a text area (Wiki page, etc), a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the feed",
// "To use them to generate articles, use the <a class=\"alert-link\" href=\"https://doc.tiki.org/Article+generator\" target=\"_blank\">Article generator <img src=\"img/icons/newspaper_go.png\"></a> for that specific feed" => "To use them to generate articles, use the <a class=\"alert-link\" href=\"https://doc.tiki.org/Article+generator\" target=\"_blank\">Article generator <img src=\"img/icons/newspaper_go.png\"></a> for that specific feed",
"Content for the feed" => "Feed 的內容",
// "Refresh All feeds" => "Refresh All feeds",
// "Show Date" => "Show Date",
"Refresh rate" => "更新率",
// "Article generator" => "Article generator",
// "Edit Feed" => "Edit Feed",
// "Create Feed" => "Create Feed",
// "Create new external feed" => "Create new external feed",
// "Show feed title" => "Show feed title",
// "Show publish date" => "Show publish date",
// "Article Generator" => "Article Generator",
// "Article Generator for %0" => "Article Generator for %0",
// "Once you have defined the settings below, each new item in this rss feed will generate a new article" => "Once you have defined the settings below, each new item in this rss feed will generate a new article",
// "From the point when you defined the settings onwards, new items in the feed become articles each time the feed is refreshed. But only new ones" => "From the point when you defined the settings onwards, new items in the feed become articles each time the feed is refreshed. But only new ones",
// "You can enable <strong>Show source</strong> for the <a href=\"tiki-article_types.php\" class=\"alert-link\" target=\"_blank\">article type</a> (hidden by default), to allow users to read the full content" => "You can enable <strong>Show source</strong> for the <a href=\"tiki-article_types.php\" class=\"alert-link\" target=\"_blank\">article type</a> (hidden by default), to allow users to read the full content",
// "Use Article Submission System" => "Use Article Submission System",
// "Expiration" => "Expiration",
// "Publish in the future" => "Publish in the future",
// "-1 to use original publishing date from the feed" => "-1 to use original publishing date from the feed",
// "Custom Settings for Source Categories" => "Custom Settings for Source Categories",
// "No source categories detected for this feed" => "No source categories detected for this feed",
// "Source Category" => "Source Category",
// "Priority (10 is highest)" => "Priority (10 is highest)",
// "Categorize Created Articles" => "Categorize Created Articles",
// "Configure" => "Configure",
// "Add a new Scheduler" => "Add a new Scheduler",
// "Schedulers" => "Schedulers",
// "Run Time" => "Run Time",
// "Re-Run" => "Re-Run",
// "Edit scheduler settings" => "Edit scheduler settings",
// "Stalled" => "Stalled",
// "Run now" => "Run now",
// "Edit scheduler" => "Edit scheduler",
// "Add a new scheduler" => "Add a new scheduler",
// "Use CRON format to enter the values in \"Run Time\":\n\t\t\t\t<br>\n\t\t\t\tMinute, Hour, Day of Month, Month, Day of Week\n\t\t\t\t<br>\n\t\t\t\tEg. every 5 minutes: */5 * * * *" => "Use CRON format to enter the values in \"Run Time\":\n\t\t\t\t<br>\n\t\t\t\tMinute, Hour, Day of Month, Month, Day of Week\n\t\t\t\t<br>\n\t\t\t\tEg. every 5 minutes: */5 * * * *",
// "Run if missed" => "Run if missed",
// "Scheduler logs" => "Scheduler logs",
// "Last {\$numOfLogs} Logs" => "Last {\$numOfLogs} Logs",
// "Running" => "Running",
// "Failed" => "Failed",
// "To <a class=\"alert-link\" target=\"tikihelp\" href=\"http://security.tiki.org/tiki-contact.php\">report any security issues</a>" => "To <a class=\"alert-link\" target=\"tikihelp\" href=\"http://security.tiki.org/tiki-contact.php\">report any security issues</a>",
// "For additional security checks, please visit <a href=\"tiki-check.php\" class=\"alert-link\">Tiki Server Compatibility Check</a>" => "For additional security checks, please visit <a href=\"tiki-check.php\" class=\"alert-link\">Tiki Server Compatibility Check</a>",
// "Tiki settings" => "Tiki settings",
// "Tiki variable" => "Tiki variable",
// "Setting" => "Setting",
// "Risk Factor" => "Risk Factor",
// "Explanation" => "Explanation",
// "About WikiPlugins and security: Make sure to only grant the \"tiki_p_plugin_approve\" permission to trusted editors" => "About WikiPlugins and security: Make sure to only grant the \"tiki_p_plugin_approve\" permission to trusted editors",
// "You can deactivate risky plugins at (<a href=\"tiki-admin.php?page=textarea\">tiki-admin.php?page=textarea</a>)" => "You can deactivate risky plugins at (<a href=\"tiki-admin.php?page=textarea\">tiki-admin.php?page=textarea</a>)",
// "You can approve plugin use at <a href=\"tiki-plugins.php\">tiki-plugins.php</a>" => "You can approve plugin use at <a href=\"tiki-plugins.php\">tiki-plugins.php</a>",
// "Security checks" => "Security checks",
// "Check all tiki files" => "Check all tiki files",
// "Note, that this can take a very long time. You should check your max_execution_time setting in php.ini" => "Note, that this can take a very long time. You should check your max_execution_time setting in php.ini",
// "File checks" => "File checks",
// "Check file permissions" => "Check file permissions",
// "This check tries to find files with problematic file permissions. Some file permissions that are shown here as problematic may be unproblematic or unavoidable in some environments" => "This check tries to find files with problematic file permissions. Some file permissions that are shown here as problematic may be unproblematic or unavoidable in some environments",
// "See end of table for detailed explanations" => "See end of table for detailed explanations",
// "owner" => "owner",
// "special" => "special",
// "other" => "other",
// "uid" => "uid",
// "gid" => "gid",
// "suid" => "suid",
// "sgid" => "sgid",
"sticky" => "置頂",
// "r" => "r",
// "w" => "w",
// "Set User ID (suid) files" => "Set User ID (suid) files",
// "World writable files or directories" => "World writable files or directories",
// "Files or directories the Webserver can write to" => "Files or directories the Webserver can write to",
// "Strange Inodes (not file, not link, not directory)" => "Strange Inodes (not file, not link, not directory)",
// "Executable files" => "Executable files",
// "What to do with these check results" => "What to do with these check results",
// "Suid files are not part of tiki and there is no need for suid files in a webspace. Sometimes intruders that gain elevated privileges leave suid files to \"keep the door open\"" => "Suid files are not part of tiki and there is no need for suid files in a webspace. Sometimes intruders that gain elevated privileges leave suid files to \"keep the door open\"",
// "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content" => "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content",
// "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"temp\". Review the tiki install guide for further information" => "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"temp\". Review the tiki install guide for further information",
// "Inodes that are not files or directories are not part of tiki. Review these Inodes" => "Inodes that are not files or directories are not part of tiki. Review these Inodes",
// "Setting the executable bit can be dangerous if the webserver is configured to execute cgi scripts from that directories. If you use the usual php module (for apache) then php scripts and other files in tiki do not need to have the executable bit. You can safely remove the executable bit with chmod" => "Setting the executable bit can be dangerous if the webserver is configured to execute cgi scripts from that directories. If you use the usual php module (for apache) then php scripts and other files in tiki do not need to have the executable bit. You can safely remove the executable bit with chmod",
// "Admin Shoutbox Words" => "Admin Shoutbox Words",
// "Add Banned Word" => "Add Banned Word",
// "Are you sure you want to delete this word" => "Are you sure you want to delete this word",
// "Rebuild sitemap" => "Rebuild sitemap",
// "Submit the Sitemap" => "Submit the Sitemap",
// "You can submit the sitemap for processing in all major search engines using the following URL" => "You can submit the sitemap for processing in all major search engines using the following URL",
// "The URL that you will need to use for submitting the sitemap will be available after you rebuild the sitemap" => "The URL that you will need to use for submitting the sitemap will be available after you rebuild the sitemap",
// "Automate Sitemap generation" => "Automate Sitemap generation",
// "You can automate the sitemap generation by using the scheduler functionality:\n\t\t\t<a href=\"https://doc.tiki.org/Scheduler\" class=\"alert-link\">https://doc.tiki.org/Scheduler</a>\n\t\t" => "You can automate the sitemap generation by using the scheduler functionality:\n\t\t\t<a href=\"https://doc.tiki.org/Scheduler\" class=\"alert-link\">https://doc.tiki.org/Scheduler</a>\n\t\t",
// "Or you can use directly the command line" => "Or you can use directly the command line",
// "XML Zip Import" => "XML Zip Import",
// "Feedback" => "Feedback",
// "Structure created" => "Structure created",
// "View Page" => "View Page",
// "Please Confirm" => "Please Confirm",
// "You will remove structure" => "You will remove structure",
"Destroy the structure leaving the wiki pages" => "刪除結構, 保留 wiki 頁面",
"Destroy the structure and remove the pages" => "刪除結構與頁面",
// "Note that the following pages are also part of another structure. Make sure that access permissions (if any) do not conflict" => "Note that the following pages are also part of another structure. Make sure that access permissions (if any) do not conflict",
// "The following pages have automatically been categorized with the same categories as the structure" => "The following pages have automatically been categorized with the same categories as the structure",
// "The following pages have categories but the structure has none. You may wish to uncategorize them to be consistent" => "The following pages have categories but the structure has none. You may wish to uncategorize them to be consistent",
// "The following pages are in categories that the structure is not in. You may wish to recategorize them in order to be consistent" => "The following pages are in categories that the structure is not in. You may wish to recategorize them in order to be consistent",
// "Existing Structures" => "Existing Structures",
// "View Structure" => "View Structure",
// "View structure" => "View structure",
// "Export pages" => "Export pages",
// "Dump tree" => "Dump tree",
// "Create WebHelp" => "Create WebHelp",
// "View WebHelp" => "View WebHelp",
// "XML Zip" => "XML Zip",
// "Perform action with selected" => "Perform action with selected",
// ".." => "..",
// "Delete with the pages" => "Delete with the pages",
// "Create Structure" => "Create Structure",
// "Alias" => "Alias",
"Tree" => "樹系",
"Use single spaces to indent structure levels" => "使用單一空格縮排結構層級",
// "Create New Structure" => "Create New Structure",
"Edit survey questions" => "編輯調查問題",
// "Add a New Question" => "Add a New Question",
"List Surveys" => "列出調查",
"Survey Stats" => "調查結果",
// "This survey stats" => "This survey stats",
"Edit this Survey" => "編輯這個調查",
"Admin Surveys" => "管理調查",
"Questions" => "問題",
"Question" => "問題",
// "Answer is mandatory" => "Answer is mandatory",
// "Required answers" => "Required answers",
// "Single choice using radio buttons" => "Single choice using radio buttons",
// "Example: \"one, two, many, lots\"" => "Example: \"one, two, many, lots\"",
// "(Use \"\\,\" to include a comma" => "(Use \"\\,\" to include a comma",
// "Multiple choice using checkboxes" => "Multiple choice using checkboxes",
// "For a rate, you can give the maximum value" => "For a rate, you can give the maximum value",
// "Multiple choices of thumbnail from a file gallery, options contains Gallery ID" => "Multiple choices of thumbnail from a file gallery, options contains Gallery ID",
// "Example: 4" => "Example: 4",
// "Options are: rows,columns,toolbars" => "Options are: rows,columns,toolbars",
// "Example: 10,60,n (toolbar can be \"y\", \"n\" or \"c\" for comments toolbar)" => "Example: 10,60,n (toolbar can be \"y\", \"n\" or \"c\" for comments toolbar)",
// "For the 'short text' type, options are: columns" => "For the 'short text' type, options are: columns",
// "Example: 60" => "Example: 60",
// "A heading to go between questions. Options are newpage,tag" => "A heading to go between questions. Options are newpage,tag",
// "Example: y,h4" => "Example: y,h4",
"Options (if apply)" => "選項 (如果有)",
"Admin surveys" => "管理調查",
// "Create/Edit Surveys" => "Create/Edit Surveys",
"Edit this Survey:" => "編輯此調查:",
// "Create New Survey" => "Create New Survey",
"There are individual permissions set for this survey" => "此調查有獨立的權限設定",
// "Synchronize Dev/Prod Servers" => "Synchronize Dev/Prod Servers",
// "Use this tool if you have at least two different Tiki instances serving as development, staging or production instances. You can compare differences between Tiki configuration, wiki pages and their contents as well as tracker and field configurations. Especially useful when changes from a development server needs to be applied to production one. This tool will only show differences between instances, you will still have to manually apply the changes to the production one" => "Use this tool if you have at least two different Tiki instances serving as development, staging or production instances. You can compare differences between Tiki configuration, wiki pages and their contents as well as tracker and field configurations. Especially useful when changes from a development server needs to be applied to production one. This tool will only show differences between instances, you will still have to manually apply the changes to the production one",
// "Remote Server Address" => "Remote Server Address",
// "Show diff" => "Show diff",
"Local" => "本地",
// "Remote" => "Remote",
// "System Administration" => "System Administration",
// "If your Tiki is acting weird, first thing to try is to clear your cache below. Also very important is to clear your cache after an upgrade (by FTP/SSH when needed)" => "If your Tiki is acting weird, first thing to try is to clear your cache below. Also very important is to clear your cache after an upgrade (by FTP/SSH when needed)",
// "Also see \"Rebuild Index\" in the <a class=\"alert-link\" href=\"tiki-admin.php?page=search\">Search Control Panel</a>" => "Also see \"Rebuild Index\" in the <a class=\"alert-link\" href=\"tiki-admin.php?page=search\">Search Control Panel</a>",
// "Clear cached content" => "Clear cached content",
// "Empty" => "Empty",
// "All user preference sessions" => "All user preference sessions",
// "Save directories" => "Save directories",
// "Directories to save" => "Directories to save",
// "Directory is not writeable" => "Directory is not writeable",
// "Full Path to the Zip File" => "Full Path to the Zip File",
// "ZIP" => "ZIP",
// "Generate zip" => "Generate zip",
// "A zip has been written to %0" => "A zip has been written to %0",
// "Groups still used in the database but no more defined" => "Groups still used in the database but no more defined",
// "Admin Tokens" => "Admin Tokens",
// "List tokens" => "List tokens",
// "Timeout" => "Timeout",
// "Hits left" => "Hits left",
// "Max hits" => "Max hits",
// "Create Temp User" => "Create Temp User",
// "Temp User Prefix" => "Temp User Prefix",
// "Add new token" => "Add new token",
// "Token successfully created" => "Token successfully created",
// "Full URL" => "Full URL",
// "Timeout in seconds (-1 for unlimited)" => "Timeout in seconds (-1 for unlimited)",
// "Maximum number of hits (-1 for unlimited)" => "Maximum number of hits (-1 for unlimited)",
// "Groups (separated by comma)" => "Groups (separated by comma)",
// "View mode" => "View mode",
// "Wiki and WYSIWYG" => "Wiki and WYSIWYG",
// "Wiki only" => "Wiki only",
// "WYSIWYG (HTML mode)" => "WYSIWYG (HTML mode)",
// "WYSIWYG (wiki mode)" => "WYSIWYG (wiki mode)",
// "Reset to Global" => "Reset to Global",
// "Reset to defaults" => "Reset to defaults",
// "Formatting Tools" => "Formatting Tools",
// "Plugin Tools" => "Plugin Tools",
// "Edit tool" => "Edit tool",
// "Wysiwyg Token" => "Wysiwyg Token",
// "Custom Tools" => "Custom Tools",
// "Add a new custom tool" => "Add a new custom tool",
// "To configure the toolbars on the various text editing areas select the section, and optionally check the comments checkbox, you want to edit and drag the icons from the left hand box to the toolbars on the right.<br>\nDrag icons back from the toolbar rows onto the full list to remove them.<br>\nIcons with <strong>bold</strong> labels are for wiki text areas, those that are <em>italic</em> are for WYSIWYG mode, and those that are <strong><em>bold and italic</em></strong> are for both.<br>\nTo save the current set use the dropdown (and optionally check the comments checkbox) at the bottom of the page to set where you want these toolbars to appear, and click Save" => "To configure the toolbars on the various text editing areas select the section, and optionally check the comments checkbox, you want to edit and drag the icons from the left hand box to the toolbars on the right.<br>\nDrag icons back from the toolbar rows onto the full list to remove them.<br>\nIcons with <strong>bold</strong> labels are for wiki text areas, those that are <em>italic</em> are for WYSIWYG mode, and those that are <strong><em>bold and italic</em></strong> are for both.<br>\nTo save the current set use the dropdown (and optionally check the comments checkbox) at the bottom of the page to set where you want these toolbars to appear, and click Save",
// "If you are experiencing problems with this page after upgrading from Tiki 4 please use this link to delete all your customised tools" => "If you are experiencing problems with this page after upgrading from Tiki 4 please use this link to delete all your customised tools",
// "Delete all custom tools" => "Delete all custom tools",
// "Warning: There is no undo" => "Warning: There is no undo",
"List Articles" => "列出文章",
// "Add topic" => "Add topic",
// "Notification Email" => "Notification Email",
// "You will be able to add a notification email per article topic when you edit the topic after its creation" => "You will be able to add a notification email per article topic when you edit the topic after its creation",
"topic image" => "主題影像",
"Activate" => "啟動",
// "De-activate" => "De-activate",
// "Remove with articles" => "Remove with articles",
// "Tracker Fields" => "Tracker Fields",
"Admin Tracker" => "管理追蹤",
// "Import Fields" => "Import Fields",
// "Mandatory" => "Mandatory",
// "Save All" => "Save All",
// "Remove Selected" => "Remove Selected",
// "Export Selected" => "Export Selected",
// "Subset Selection" => "Subset Selection",
// "Category Selection" => "Category Selection",
// "Group Selection" => "Group Selection",
// "Add Group" => "Add Group",
// "Press Enter for each group" => "Press Enter for each group",
// "At least two elements are required to create transitions. Additional tabs appear once the selection is completed" => "At least two elements are required to create transitions. Additional tabs appear once the selection is completed",
// "Draw Transition Diagram" => "Draw Transition Diagram",
// "Guards" => "Guards",
// "preserved" => "preserved",
// "No transitions" => "No transitions",
// "New / Edit" => "New / Edit",
// "Edit <em>%0</em>" => "Edit <em>%0</em>",
// "New transition" => "New transition",
// "Upon trigger, preserve the initial state" => "Upon trigger, preserve the initial state",
// "Members" => "Members",
// "No guards on this transition" => "No guards on this transition",
// "New Guard" => "New Guard",
// "Exactly" => "Exactly",
// "States" => "States",
// "Body of POST request" => "Body of POST request",
// "Enter the URL of a web services returning either JSON or YAML. Parameters can be specified by enclosing a name between percentage signs. For example: %name%. %service% and %template% are reserved keywords and cannot be used" => "Enter the URL of a web services returning either JSON or YAML. Parameters can be specified by enclosing a name between percentage signs. For example: %name%. %service% and %template% are reserved keywords and cannot be used",
// "Parameters (%name%)" => "Parameters (%name%)",
"Operation" => "Operation",
// "%0 requires no parameter" => "%0 requires no parameter",
// "Test Input" => "Test Input",
// "Bypass cache" => "Bypass cache",
// "Response Information" => "Response Information",
// "OIntegrate Version" => "OIntegrate Version",
// "Not supported" => "Not supported",
// "Schema Version" => "Schema Version",
// "Schema Documentation" => "Schema Documentation",
// "Not specified, default used" => "Not specified, default used",
// "Content Type" => "Content Type",
// "Not specified" => "Not specified",
// "Returned Data" => "Returned Data",
// "tuncated at approx. 1MB" => "tuncated at approx. 1MB",
// "Proposed Templates" => "Proposed Templates",
// "Register this web service. It will be possible to register the templates afterwards. Service name must only contain letters" => "Register this web service. It will be possible to register the templates afterwards. Service name must only contain letters",
// "Register Service" => "Register Service",
// "Registered Templates" => "Registered Templates",
// "Engine" => "Engine",
// "Output" => "Output",
// "Toggle template source" => "Toggle template source",
// "Register Template" => "Register Template",
// "Add New Group" => "Add New Group",
// "Invitation List" => "Invitation List",
"List of existing groups" => "現存群組列表",
// "Inherits Permissions from" => "Inherits Permissions from",
// "User Choice" => "User Choice",
// "Edit group" => "Edit group",
// "{\$users[user].groupDesc|escape|nl2br}" => "{\$users[user].groupDesc|escape|nl2br}",
// "{\$users[user].groupHome}" => "{\$users[user].groupHome}",
// "{\$users[user].userChoice}" => "{\$users[user].userChoice}",
// "Create group" => "Create group",
// "Group is NOT being monitored. Click icon to START monitoring" => "Group is NOT being monitored. Click icon to START monitoring",
// "Group IS being monitored. Click icon to STOP monitoring" => "Group IS being monitored. Click icon to STOP monitoring",
// "Inheritance" => "Inheritance",
// "Permissions will be inherited from these groups" => "Permissions will be inherited from these groups",
// "Indirectly included groups" => "Indirectly included groups",
// "Group Home" => "Group Home",
// "Use wiki page name or full URL" => "Use wiki page name or full URL",
// "For other Tiki features, use links relative to the Tiki root (such as <em>/tiki-forums.php</em>)" => "For other Tiki features, use links relative to the Tiki root (such as <em>/tiki-forums.php</em>)",
// "Default Category" => "Default Category",
// "Default category assigned to uncategorized objects edited by a user with this default group" => "Default category assigned to uncategorized objects edited by a user with this default group",
// "Use site default" => "Use site default",
// "Group color" => "Group color",
// "Default color to use when plotting values for this group in charts. Use HEX notation, e.g. #FF0000 for red color" => "Default color to use when plotting values for this group in charts. Use HEX notation, e.g. #FF0000 for red color",
// "Group Information Tracker" => "Group Information Tracker",
// "choose a group tracker .." => "choose a group tracker ..",
// "Choose a group tracker which can be used to add user registration fields or allow group permissions on a tracker. The tracker must have one user selector field that is set to auto-assign" => "Choose a group tracker which can be used to add user registration fields or allow group permissions on a tracker. The tracker must have one user selector field that is set to auto-assign",
// "choose a field .." => "choose a field ..",
// "Select the user selector field from the above tracker" => "Select the user selector field from the above tracker",
// "Go to trackers list" => "Go to trackers list",
// "User Registration Tracker" => "User Registration Tracker",
// "choose a user tracker .." => "choose a user tracker ..",
// "Choose a user tracker to provide fields for a new user to complete upon registration. The tracker must have one user selector field that is set to auto-assign" => "Choose a user tracker to provide fields for a new user to complete upon registration. The tracker must have one user selector field that is set to auto-assign",
// "Select user field" => "Select user field",
// "Choose a field .." => "Choose a field ..",
// "No fields in tracker .." => "No fields in tracker ..",
// "Select the user selector field from the above tracker to link a tracker item to the user upon registration" => "Select the user selector field from the above tracker to link a tracker item to the user upon registration",
// "No fields in this tracker" => "No fields in this tracker",
// "Go to tracker list" => "Go to tracker list",
// "User Wizard Fields" => "User Wizard Fields",
// "By default, the same fields as in registration are used" => "By default, the same fields as in registration are used",
// "You can choose in the <a href=\"%0\">Login admin panel</a> to show different fields in User Wizard than the ones asked at Registration Time" => "You can choose in the <a href=\"%0\">Login admin panel</a> to show different fields in User Wizard than the ones asked at Registration Time",
// "Group or User Tracker Registration Fields" => "Group or User Tracker Registration Fields",
// "If either a group information tracker or user registration tracker has been selected above, enter colon-separated field ID numbers for the tracker fields in the above tracker to include on the registration form for a new user to complete" => "If either a group information tracker or user registration tracker has been selected above, enter colon-separated field ID numbers for the tracker fields in the above tracker to include on the registration form for a new user to complete",
// "User can assign himself or herself to the group" => "User can assign himself or herself to the group",
// "Membership expiry" => "Membership expiry",
// "Anniversary" => "Anniversary",
// "Use MMDD to specify an annual date as of which all users will be unassigned from the group, or DD to specify a monthly date" => "Use MMDD to specify an annual date as of which all users will be unassigned from the group, or DD to specify a monthly date",
// "Or" => "Or",
// "Number of Days" => "Number of Days",
// "Number of days after which all users will be unassigned from the group" => "Number of days after which all users will be unassigned from the group",
// "Pro-Rate Membership" => "Pro-Rate Membership",
// "Payment for membership extension is prorated at a minimum interval" => "Payment for membership extension is prorated at a minimum interval",
// "Users are automatically assigned at registration in the group if their emails match the pattern" => "Users are automatically assigned at registration in the group if their emails match the pattern",
// "Assign group <em>management</em> permissions" => "Assign group <em>management</em> permissions",
// "Assign Permissions" => "Assign Permissions",
// "Group tracker item : {\$groupitemid}" => "Group tracker item : {\$groupitemid}",
"Edit Item" => "編輯項目",
// "Group tracker item not found" => "Group tracker item not found",
// "</i>\"}%0 members" => "</i>\"}%0 members",
// "Assigned" => "Assigned",
// "Edit user" => "Edit user",
// "Remove from group" => "Remove from group",
// "No members" => "No members",
// "Add or ban users" => "Add or ban users",
// "Add to group" => "Add to group",
// "Ban from group" => "Ban from group",
// "</i>\"}Users banned from %0" => "</i>\"}Users banned from %0",
// "Banned members" => "Banned members",
// "Unban user" => "Unban user",
// "Unban user %0 from group %1" => "Unban user %0 from group %1",
// "No banned members" => "No banned members",
// "</i>\"}%0 import/export" => "</i>\"}%0 import/export",
// "Export group users (CSV file)" => "Export group users (CSV file)",
// "Charset encoding" => "Charset encoding",
// "UTF-8" => "UTF-8",
// "ISO-8859-1" => "ISO-8859-1",
// "Import users to group (CSV file)" => "Import users to group (CSV file)",
// "Imported users must already exist. To create users and assign them to groups, go to <a href=\"tiki-adminusers.php\">admin->users</a>" => "Imported users must already exist. To create users and assign them to groups, go to <a href=\"tiki-adminusers.php\">admin->users</a>",
"Add a New User" => "增加使用者",
// "Since this Tiki site is in slave mode and imports groups, the master groups will be automatically reimported at each login" => "Since this Tiki site is in slave mode and imports groups, the master groups will be automatically reimported at each login",
// "Since this Tiki site is in slave mode and imports preferences, the master user preferences will be automatically reimported at each login" => "Since this Tiki site is in slave mode and imports preferences, the master user preferences will be automatically reimported at each login",
"Number of displayed rows" => "顯示的列數",
// "More Criteria" => "More Criteria",
// "Group (direct)" => "Group (direct)",
// "Email not confirmed" => "Email not confirmed",
// "User not validated" => "User not validated",
// "OpenID" => "OpenID",
// "Edit account settings" => "Edit account settings",
// "N" => "N",
// "Registered %0 ago" => "Registered %0 ago",
// "Need to validate email" => "Need to validate email",
// "Edit this included group" => "Edit this included group",
// "Add or remove from a group" => "Add or remove from a group",
// "Edit group expiry" => "Edit group expiry",
// "Change user preferences" => "Change user preferences",
// "Switch to this user" => "Switch to this user",
// "Validate user" => "Validate user",
// "Invalidate user" => "Invalidate user",
// "Remove link with OpenID for this user" => "Remove link with OpenID for this user",
// "Remove link with OpenID account" => "Remove link with OpenID account",
// "Remove users.." => "Remove users..",
// "Ban IPs" => "Ban IPs",
// "Change group assignments" => "Change group assignments",
// "Set default groups" => "Set default groups",
// "Send wiki page content by email" => "Send wiki page content by email",
// "Warning: User Encryption is Active" => "Warning: User Encryption is Active",
// "The feature User Encryption stores encrypted user information, such as password used to connect to externalsystems.\n\t\t\t\t\tIf the password is changed, it will destroy the user's decryption key, and make the data unreadable.\n\t\t\t\t\tThe user will be forced to re-enter the passwords and other data that may be encrypted" => "The feature User Encryption stores encrypted user information, such as password used to connect to externalsystems.\n\t\t\t\t\tIf the password is changed, it will destroy the user's decryption key, and make the data unreadable.\n\t\t\t\t\tThe user will be forced to re-enter the passwords and other data that may be encrypted",
// "Assign user to Groups" => "Assign user to Groups",
// "Intertiki Enabled" => "Intertiki Enabled",
// "This Tiki is an Intertiki Client so user information must be edited on the Intertiki Master \"%0\"" => "This Tiki is an Intertiki Client so user information must be edited on the Intertiki Master \"%0\"",
// "Use the email as username" => "Use the email as username",
// "The username will be an autogenerated number based on the user ID if no actual username is provided when the user is created. Do not change these numeric usernames" => "The username will be an autogenerated number based on the user ID if no actual username is provided when the user is created. Do not change these numeric usernames",
// "Changing username is disabled for Intertiki sites" => "Changing username is disabled for Intertiki sites",
// "No password is required" => "No password is required",
// "Tiki is configured to delegate the password managment to LDAP" => "Tiki is configured to delegate the password managment to LDAP",
"New password" => "新密碼",
// "Confirm new password" => "Confirm new password",
// "User must change password at next login" => "User must change password at next login",
// "Send an email to the user to enable him or her to validate their account" => "Send an email to the user to enable him or her to validate their account",
// "You need to set <a href=\"tiki-admin.php?page=general\" class=\"alert-link\">Sender Email</a>" => "You need to set <a href=\"tiki-admin.php?page=general\" class=\"alert-link\">Sender Email</a>",
// "Add a user tracker item for this user" => "Add a user tracker item for this user",
// "User tracker" => "User tracker",
// "View item" => "View item",
// "Modify this user\\'s data" => "Modify this user\\'s data",
// "Pass confirmed" => "Pass confirmed",
// "Email confirmed" => "Email confirmed",
// "%0 days ago" => "%0 days ago",
// "Current Login" => "Current Login",
// "You do not have permission to edit this user" => "You do not have permission to edit this user",
// "Your file should contain in the first row (first entry) the following fields" => "Your file should contain in the first row (first entry) the following fields",
// "user1,pass1,email1,group1,group1" => "user1,pass1,email1,group1,group1",
// "user2,pass2,email2,\"group1,group2\",group1" => "user2,pass2,email2,\"group1,group2\",group1",
// "Only login, password, email are mandatory. Use an empty password for automatic password generation. Use same login and email if the login use email. Groups are separated by comma. With group name with comma, double the comma" => "Only login, password, email are mandatory. Use an empty password for automatic password generation. Use same login and email if the login use email. Groups are separated by comma. With group name with comma, double the comma",
// "On most server with default setting importing 250 users should be fine. If you have a long list you can split it or change the server settings to allow longer execution time" => "On most server with default setting importing 250 users should be fine. If you have a long list you can split it or change the server settings to allow longer execution time",
// "Please also note that the data should match your Tiki setting. IE: if special characters or space are not permit for the username of your Tiki then your data in the CSV file for username should not contain any" => "Please also note that the data should match your Tiki setting. IE: if special characters or space are not permit for the username of your Tiki then your data in the CSV file for username should not contain any",
// "Existing Users" => "Existing Users",
// "Don't overwrite" => "Don't overwrite",
// "Overwrite groups" => "Overwrite groups",
// "Create groups" => "Create groups",
// "The user must change his or her password the first time they log in" => "The user must change his or her password the first time they log in",
// "You can export users of a group by clicking on that group at <a href=\"tiki-admingroups.php\" class=\"alert-link\">admin->groups</a>" => "You can export users of a group by clicking on that group at <a href=\"tiki-admingroups.php\" class=\"alert-link\">admin->groups</a>",
// "Temporary Users" => "Temporary Users",
// "Token Access Feature Dependency" => "Token Access Feature Dependency",
// "The token access feature is needed for Temporary Users to login" => "The token access feature is needed for Temporary Users to login",
// "Turn it on here" => "Turn it on here",
// "Feature Conflict" => "Feature Conflict",
// "This feature currently is incompatible with the \"Use email as username\" feature" => "This feature currently is incompatible with the \"Use email as username\" feature",
// "Turn it off here" => "Turn it off here",
// "This feature currently is incompatible with the \"The email address of each user must be unique.\" feature" => "This feature currently is incompatible with the \"The email address of each user must be unique.\" feature",
// "Temporary users cannot login the usual way but instead do so via an autologin URL that is associated with a token" => "Temporary users cannot login the usual way but instead do so via an autologin URL that is associated with a token",
// "An email will be sent out to invited users containing this URL. You will receive a copy of the email yourself" => "An email will be sent out to invited users containing this URL. You will receive a copy of the email yourself",
// "These temporary users will be deleted (but can be set to be preserved in Admin Tokens) once the validity period is over. Normally, these users should have read-only access. Nevertheless, if you are allowing these users to submit information, e.g. fill in a tracker form, make sure to ask for their information again in those forms" => "These temporary users will be deleted (but can be set to be preserved in Admin Tokens) once the validity period is over. Normally, these users should have read-only access. Nevertheless, if you are allowing these users to submit information, e.g. fill in a tracker form, make sure to ask for their information again in those forms",
// "Please do not assign temporary users to Groups that can access any security sensitive information, since access to these accounts is relatively easy to obtain, for example by intercepting or otherwise getting access to these emails" => "Please do not assign temporary users to Groups that can access any security sensitive information, since access to these accounts is relatively easy to obtain, for example by intercepting or otherwise getting access to these emails",
// "To revoke access before validity expires or to review who has access, please see" => "To revoke access before validity expires or to review who has access, please see",
// "Email addresses (comma-separated)" => "Email addresses (comma-separated)",
// "Valid for days (use -1 for forever)" => "Valid for days (use -1 for forever)",
// "Username prefix" => "Username prefix",
// "Autologin (non-SEFURL) path" => "Autologin (non-SEFURL) path",
// "More languages are available. To view them, update languages you can read from <a href=\"tiki-user_preferences.php\" class=\"alert-link\">user preferences</a> or your browser's preferences" => "More languages are available. To view them, update languages you can read from <a href=\"tiki-user_preferences.php\" class=\"alert-link\">user preferences</a> or your browser's preferences",
// "Add Type" => "Add Type",
// "Add article type" => "Add article type",
// "{\$types[user].type|escape}" => "{\$types[user].type|escape}",
// "View articles with this type" => "View articles with this type",
// "Show before publish date" => "Show before publish date",
// "Show after expire date" => "Show after expire date",
// "Heading only" => "Heading only",
// "Comment can rate article" => "Comment can rate article",
// "Show image" => "Show image",
// "Show profile picture" => "Show profile picture",
// "Show expire date" => "Show expire date",
// "Show reads" => "Show reads",
// "Show size" => "Show size",
// "Show topline" => "Show topline",
// "Show subtitle" => "Show subtitle",
// "Show source" => "Show source",
// "Show image caption" => "Show image caption",
// "Creator can edit" => "Creator can edit",
// "Custom attribute" => "Custom attribute",
// "Assign User %0 to Groups" => "Assign User %0 to Groups",
// "{\$users[user].groupDesc|escape}" => "{\$users[user].groupDesc|escape}",
"backlinks to" => "反向連結至",
"No backlinks to this page" => "此頁面並無反向連結",
// "Directory batch upload" => "Directory batch upload",
"Browse Gallery" => "瀏覽圖庫",
"Upload From Disk" => "由磁碟上傳",
// "available images" => "available images",
"Filesize" => "檔案大小",
// "Filetype" => "Filetype",
// "Remove File Extension from Image Name" => "Remove File Extension from Image Name",
// "eg. from \"digicam0001.jpg\" then name digicam0001 will be used for the name field" => "eg. from \"digicam0001.jpg\" then name digicam0001 will be used for the name field",
// "Convert the last sub directory to a sub gallery" => "Convert the last sub directory to a sub gallery",
// "eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named \"screenshots\" will be created" => "eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named \"screenshots\" will be created",
// "Use the last sub directory name as description" => "Use the last sub directory name as description",
// "eg. from \"misc/screenshots/digicam0001.jpg\" a description \"screenshots\" will be created" => "eg. from \"misc/screenshots/digicam0001.jpg\" a description \"screenshots\" will be created",
// "Select a Gallery" => "Select a Gallery",
"Process" => "程序",
// "Browse File Gallery" => "Browse File Gallery",
// "Please do not use this feature to upload data into the database" => "Please do not use this feature to upload data into the database",
// "Available Files" => "Available Files",
// "File Permissions" => "File Permissions",
// "File is writable" => "File is writable",
// "File is not writable" => "File is not writable",
// "Total: %0" => "Total: %0",
// "Select a File Gallery" => "Select a File Gallery",
// "Root" => "Root",
// "Upload into galleries according to sub-directories" => "Upload into galleries according to sub-directories",
// "eg. for \"misc/screenshots/digicam0001.jpg\" the file will be uploaded into a gallery called \"screenshots\" in the called \"misc\" inside the chosen gallery if it exists" => "eg. for \"misc/screenshots/digicam0001.jpg\" the file will be uploaded into a gallery called \"screenshots\" in the called \"misc\" inside the chosen gallery if it exists",
// "Create sub-galleries" => "Create sub-galleries",
// "Sub-galleries will be automatically created if they don't exist and the user has permission. Note that these galleries will have the global file gallery permissions set" => "Sub-galleries will be automatically created if they don't exist and the user has permission. Note that these galleries will have the global file gallery permissions set",
// "Upload into galleries according sub-directory as galleryId" => "Upload into galleries according sub-directory as galleryId",
// "eg. for \"42/digicam0001.jpg\" the file will be uploaded into a gallery with the Id \"42\" if it exists" => "eg. for \"42/digicam0001.jpg\" the file will be uploaded into a gallery with the Id \"42\" if it exists",
// "Process files" => "Process files",
"Edit Post" => "編輯文章",
// "New Post" => "New Post",
// "View post" => "View post",
"View Blog" => "觀看 blog",
// "Note: Remember that this is only a preview, and has not yet been saved" => "Note: Remember that this is only a preview, and has not yet been saved",
// "Excerpt" => "Excerpt",
// "Admin the Category System" => "Admin the Category System",
// "Browse in" => "Browse in",
// "or in" => "or in",
"Image galleries" => "圖庫",
// "Trackers Items" => "Trackers Items",
// "Sheets" => "Sheets",
// "Find in" => "Find in",
// " in the current category and its subcategories" => " in the current category and its subcategories",
// "Hide subcategories objects" => "Hide subcategories objects",
// "Show subcategories objects" => "Show subcategories objects",
// "Up one level" => "Up one level",
// "{\$objects[ix].type|replace:\"wiki page\":\"wiki\"|replace:\"trackeritem\":\"tracker item\"}" => "{\$objects[ix].type|replace:\"wiki page\":\"wiki\"|replace:\"trackeritem\":\"tracker item\"}",
// "Clear tags" => "Clear tags",
// "With all selected tags" => "With all selected tags",
// "With one selected tag" => "With one selected tag",
// "With last selected tag" => "With last selected tag",
// "More Popular Tags" => "More Popular Tags",
// "Alphabetically" => "Alphabetically",
// "By Size" => "By Size",
// "Cloud" => "Cloud",
// "{\$feature_label}" => "{\$feature_label}",
// "Filter in" => "Filter in",
// "All blogs" => "All blogs",
// "{\$objects[ix].type|replace:\"wiki page\":\"Wiki\"|replace:\"article\":\"Article\"|regex_replace:\"/tracker [0-9]*/\":\"tracker item\"}" => "{\$objects[ix].type|replace:\"wiki page\":\"Wiki\"|replace:\"article\":\"Article\"|regex_replace:\"/tracker [0-9]*/\":\"tracker item\"}",
// "Delete Tag" => "Delete Tag",
"Browsing Gallery" => "瀏覽圖庫",
// "Gallery actions" => "Gallery actions",
// "List Galleries" => "List Galleries",
"Edit Gallery" => "編輯圖庫",
"Upload Image" => "上傳影像",
// "Directory Batch" => "Directory Batch",
"List Gallery" => "列出圖庫",
// "All Images" => "All Images",
"Rebuild Thumbnails" => "重建縮圖",
// "{\$advice}" => "{\$advice}",
"Sort Images by" => "排列影像順序",
// "subgallery" => "subgallery",
// "Subgallery" => "Subgallery",
// "Original size" => "Original size",
"rotate right" => "向右旋轉",
// "You can view this gallery's configured image (first, random, etc.) in your browser using" => "You can view this gallery's configured image (first, random, etc.) in your browser using",
// "You can include the gallery's image in an HTML page using" => "You can include the gallery's image in an HTML page using",
// "You can include the image in a tiki page using" => "You can include the image in a tiki page using",
"Browsing Image" => "瀏覽影像",
"Return to Gallery" => "返回圖庫",
"Edit Image" => "編輯影像",
"Bigger" => "放大",
// "Slideshow forward" => "Slideshow forward",
// "Repeat" => "Repeat",
// "Click to zoom" => "Click to zoom",
"Image Name" => "影像名稱",
"Image size" => "影像大小",
"Image Scale" => "影像比率",
"Original Size" => "原始大小",
"Move image" => "移動影像",
// "Include the image in a tiki page using the following syntax" => "Include the image in a tiki page using the following syntax",
// "To include the image in an HTML page" => "To include the image in an HTML page",
// "To link to this page from another tiki page" => "To link to this page from another tiki page",
// "Monitoring" => "Monitoring",
// "Visible Calendars" => "Visible Calendars",
"Group Calendars" => "群組行事曆",
// "Export calendars" => "Export calendars",
// "advanced parameters" => "advanced parameters",
// "Export as iCal" => "Export as iCal",
"January" => "一月",
"February" => "二月",
"March" => "三月",
"April" => "四月",
"May" => "五月",
"June" => "六月",
"July" => "七月",
"August" => "八月",
"September" => "九月",
"October" => "十月",
"November" => "十一月",
"December" => "十二月",
// "Jan" => "Jan",
// "Feb" => "Feb",
// "Mar" => "Mar",
// "Apr" => "Apr",
// "Aug" => "Aug",
// "Sep" => "Sep",
// "Oct" => "Oct",
// "Nov" => "Nov",
// "Dec" => "Dec",
"Sun" => "日",
"Mon" => "一",
"Tue" => "二",
"Wed" => "三",
"Thu" => "四",
"Fri" => "五",
"Sat" => "六",
"today" => "今日",
// "semester" => "semester",
// "quarter" => "quarter",
// "all-day" => "all-day",
"Organized by" => "組織方式",
// "Classification" => "Classification",
// "View this Week" => "View this Week",
// "Change Focus" => "Change Focus",
// "View this Day" => "View this Day",
// "Calendar event : " => "Calendar event : ",
// "New event" => "New event",
// "View event" => "View event",
// "Edit/Delete event" => "Edit/Delete event",
// "Export Event as iCal" => "Export Event as iCal",
"Edit Calendar Item" => "編輯行事曆項目",
// "New Calendar Item" => "New Calendar Item",
// "Recurrence" => "Recurrence",
// "This event depends on a recurrence rule" => "This event depends on a recurrence rule",
// "ending by" => "ending by",
// "ending after" => "ending after",
// "events" => "events",
// "(%0 events have been manually modified)" => "(%0 events have been manually modified)",
// "(%0 event has been manually modified)" => "(%0 event has been manually modified)",
// "This event is not recurrent" => "This event is not recurrent",
// "On a weekly basis" => "On a weekly basis",
// "Each" => "Each",
// "of the week" => "of the week",
// "On a monthly basis" => "On a monthly basis",
// "of the month" => "of the month",
// "On a yearly basis" => "On a yearly basis",
"of" => "of",
// "Starting on" => "Starting on",
// "Start period" => "Start period",
// "End Period" => "End Period",
// "End after" => "End after",
// "occurrences" => "occurrences",
// "occurrence" => "occurrence",
// "End before" => "End before",
// "Event occurs once on" => "Event occurs once on",
// "Event is repeated" => "Event is repeated",
"times" => "次",
// "{\$daysnames[\$recurrence.weekday]}s" => "{\$daysnames[\$recurrence.weekday]}s",
// "of every month" => "of every month",
// "on each" => "on each",
// "{\$monthnames[\$recurrence.dateOfYear_month]}" => "{\$monthnames[\$recurrence.dateOfYear_month]}",
// "starting" => "starting",
// "ending" => "ending",
// "Show duration" => "Show duration",
// "Events cannot end before they start" => "Events cannot end before they start",
// "No description" => "No description",
// "or new" => "or new",
// "Choose users to alert" => "Choose users to alert",
// "Withdraw me from the list of participants" => "Withdraw me from the list of participants",
// "Add me to the list of participants" => "Add me to the list of participants",
"Roles" => "Roles",
// "chair" => "chair",
// "default role" => "default role",
// "required participant" => "required participant",
// "optional participant" => "optional participant",
// "non-participant" => "non-participant",
// "Input list of participants, separated by commas. Roles must be indicated by a prefix separated by a colon as in" => "Input list of participants, separated by commas. Roles must be indicated by a prefix separated by a colon as in",
// "role:login_or_email,login_or_email" => "role:login_or_email,login_or_email",
// "If no role is provided, default role will be \"Chair participant\"" => "If no role is provided, default role will be \"Chair participant\"",
// "Update this event only" => "Update this event only",
// "Update every unchanged event in this recurrence series" => "Update every unchanged event in this recurrence series",
// "Update every event in this recurrence series" => "Update every event in this recurrence series",
// "Delete event" => "Delete event",
// "Delete recurrent events" => "Delete recurrent events",
// "Calendar import" => "Calendar import",
// "Calendar has been updated" => "Calendar has been updated",
// "%0 column name can be used instead of %1" => "%0 column name can be used instead of %1",
"import" => "匯入",
// "Previous {\$viewmode|escape}" => "Previous {\$viewmode|escape}",
// "D" => "D",
// "W" => "W",
// "M" => "M",
// "Next {\$viewmode|escape}" => "Next {\$viewmode|escape}",
// "%d/%m" => "%d/%m",
// "%m/%d" => "%m/%d",
// "Advanced parameters for iCal export" => "Advanced parameters for iCal export",
// "Calendars to be exported" => "Calendars to be exported",
// "Export calendars iCal" => "Export calendars iCal",
// "Export calendars CSV" => "Export calendars CSV",
// "Your account has been validated" => "Your account has been validated",
// "You have to choose a password to use this account" => "You have to choose a password to use this account",
// "Change password" => "Change password",
// "Set password" => "Set password",
// "Old Password" => "Old Password",
// "Repeat Password" => "Repeat Password",
// "MySQL or MariaDB Database Properties" => "MySQL or MariaDB Database Properties",
// "Acknowledge (OK)" => "Acknowledge (OK)",
// "Property" => "Property",
// "Tiki Fitness" => "Tiki Fitness",
// "Acknowledge" => "Acknowledge",
// "New database engine" => "New database engine",
// "Your website is using a 18.x or higher version of tiki wiki and your database tables are not using the InnoDB database engine, you should consider migrate to InnoDB, that is now the default database engine for Tiki" => "Your website is using a 18.x or higher version of tiki wiki and your database tables are not using the InnoDB database engine, you should consider migrate to InnoDB, that is now the default database engine for Tiki",
// "MySQL crashed Tables" => "MySQL crashed Tables",
// "Be careful" => "Be careful",
// "The following list is just a very quick look at SHOW TABLE STATUS that tells you, if tables have been marked as crashed. If you are experiencing database problems you should still run CHECK TABLE or myisamchk to make sure" => "The following list is just a very quick look at SHOW TABLE STATUS that tells you, if tables have been marked as crashed. If you are experiencing database problems you should still run CHECK TABLE or myisamchk to make sure",
// "Test sending emails" => "Test sending emails",
// "To test if your installation is capable of sending emails please visit the <a href=\"tiki-install.php\">Tiki Installer</a>" => "To test if your installation is capable of sending emails please visit the <a href=\"tiki-install.php\">Tiki Installer</a>",
// "Server Information" => "Server Information",
// "Server Properties" => "Server Properties",
// "Special directories" => "Special directories",
// "To backup these directories go to <a href=\"tiki-admin_system.php\">Admin->Tiki Cache/SysAdmin</a>" => "To backup these directories go to <a href=\"tiki-admin_system.php\">Admin->Tiki Cache/SysAdmin</a>",
// "Fitness" => "Fitness",
// "Directory is writeable" => "Directory is writeable",
// "Apache properties" => "Apache properties",
// "IIS properties" => "IIS properties",
// "PHP scripting language properties" => "PHP scripting language properties",
// "Change PHP configuration values" => "Change PHP configuration values",
// "{\$php_sapi_info.message}" => "{\$php_sapi_info.message}",
// "<a href=\"{\$php_sapi_info.link}\" class=\"alert-link\">{\$php_sapi_info.link}</a>" => "<a href=\"{\$php_sapi_info.link}\" class=\"alert-link\">{\$php_sapi_info.link}</a>",
// "You can check the full documentation on how to change the configurations values in <a href=\"http://www.php.net/manual/en/configuration.php\" class=\"alert-link\">http://www.php.net/manual/en/configuration.php</a>" => "You can check the full documentation on how to change the configurations values in <a href=\"http://www.php.net/manual/en/configuration.php\" class=\"alert-link\">http://www.php.net/manual/en/configuration.php</a>",
// "PHP Security properties" => "PHP Security properties",
// "To check the file integrity of your Tiki installation, go to <a href=\"tiki-admin_security.php\">Admin->Security</a>" => "To check the file integrity of your Tiki installation, go to <a href=\"tiki-admin_security.php\">Admin->Security</a>",
// "Tiki Security" => "Tiki Security",
// "Sensitive Data Exposure" => "Sensitive Data Exposure",
// "Tiki detected that there are temporary files in the db folder which may expose credentials or other sensitive information" => "Tiki detected that there are temporary files in the db folder which may expose credentials or other sensitive information",
// "Tiki did not detect temporary files in the db folder which may expose credentials or other sensitive information" => "Tiki did not detect temporary files in the db folder which may expose credentials or other sensitive information",
// "Print configurations" => "Print configurations",
// "mPDF Information" => "mPDF Information",
// "mPDF is selected as Print option, however the class can't be loaded, please check \"Print Settings\" in /tiki-admin.php?page=print" => "mPDF is selected as Print option, however the class can't be loaded, please check \"Print Settings\" in /tiki-admin.php?page=print",
// "File Gallery Search Indexing" => "File Gallery Search Indexing",
// "More information %0 here %1" => "More information %0 here %1",
// "Command Missing" => "Command Missing",
// "The command \"shell_exec\" is required for file gallery search indexing" => "The command \"shell_exec\" is required for file gallery search indexing",
// "Mimetype" => "Mimetype",
// "Go to the %0 File Gallery Control Panel %1 (with advanced preferences showing) to enable" => "Go to the %0 File Gallery Control Panel %1 (with advanced preferences showing) to enable",
// "MySQL Variable Information" => "MySQL Variable Information",
// "PHP Info" => "PHP Info",
// "For more detailed information about your PHP installation see <a href=\"tiki-phpinfo.php\">Admin->phpinfo</a>" => "For more detailed information about your PHP installation see <a href=\"tiki-phpinfo.php\">Admin->phpinfo</a>",
// "Benchmark PHP/MySQL" => "Benchmark PHP/MySQL",
// "Check" => "Check",
// "BOM Detected Files" => "BOM Detected Files",
// "Scanned files" => "Scanned files",
// "BOM files detected" => "BOM files detected",
// "No BOM files detected" => "No BOM files detected",
// "TRIM" => "TRIM",
// "For more detailed information about Tiki Remote Instance Manager please check <a href=\"https://doc.tiki.org/TRIM\">doc.tiki.org</a>" => "For more detailed information about Tiki Remote Instance Manager please check <a href=\"https://doc.tiki.org/TRIM\">doc.tiki.org</a>",
// "Requirements" => "Requirements",
// "OS not supported" => "OS not supported",
// "Apparently tiki is running on a Windows based server. This feature is not supported natively" => "Apparently tiki is running on a Windows based server. This feature is not supported natively",
// "User Data Encryption" => "User Data Encryption",
// "MCrypt encryption found in users data preferences" => "MCrypt encryption found in users data preferences",
// "Found %0 user(s) with data preferences encrypted with MCrypt" => "Found %0 user(s) with data preferences encrypted with MCrypt",
// "No user preferences were found with data encrypted with MCrypt" => "No user preferences were found with data encrypted with MCrypt",
// "Tiki Packages" => "Tiki Packages",
// "OCR Status" => "OCR Status",
// "Please choose the language for this page" => "Please choose the language for this page",
// "Choose language" => "Choose language",
"Contact Us" => "連絡我們",
"Send a message to us" => "發送訊息給我們",
// "Your email" => "Your email",
"Contact us by email" => "使用email與我們聯絡",
// "Click here to send us an email" => "Click here to send us an email",
// "Send another message" => "Send another message",
"Contacts" => "通訊錄",
// "Group View" => "Group View",
"Create/edit contacts" => "建立/編輯 通訊錄",
"First Name" => "名",
"Last Name" => "姓",
"Nickname" => "暱稱",
// "Publish this contact to groups" => "Publish this contact to groups",
// "Extra Fields" => "Extra Fields",
// "Copy page" => "Copy page",
// "Invalid page name" => "Invalid page name",
// "The page name specified contains unallowed characters. It will not be possible to save the page until those are removed: <strong>%0</strong>" => "The page name specified contains unallowed characters. It will not be possible to save the page until those are removed: <strong>%0</strong>",
// "The page name specified contains characters that may render the page hard to access. You may want to consider removing those: <strong>%0</strong>" => "The page name specified contains characters that may render the page hard to access. You may want to consider removing those: <strong>%0</strong>",
// "Use this name anyway" => "Use this name anyway",
// "Duplicate tags" => "Duplicate tags",
// "Quick Create Multilanguage Pages" => "Quick Create Multilanguage Pages",
// "Following pages were created, as translations of each other" => "Following pages were created, as translations of each other",
// "Following pages were not created" => "Following pages were not created",
// "page already exists" => "page already exists",
// "Enter the names of a new page page in various languages" => "Enter the names of a new page page in various languages",
// "Preferred languages" => "Preferred languages",
// "Other languages" => "Other languages",
// "Create pages" => "Create pages",
// "View generated WebHelp" => "View generated WebHelp",
// "No structure" => "No structure",
// "Top page" => "Top page",
"Add a new site" => "增加新的站臺",
// "You cannot add sites until Directory Categories are setup" => "You cannot add sites until Directory Categories are setup",
// "Please contact the Site Administrator" => "Please contact the Site Administrator",
// "<a href=\"tiki-directory_admin_categories.php\">Add a directory category now</a>" => "<a href=\"tiki-directory_admin_categories.php\">Add a directory category now</a>",
"Site added" => "增加的站臺",
// "The following site was added, but may require validation by the admin before appearing on the lists" => "The following site was added, but may require validation by the admin before appearing on the lists",
// "Edit a site" => "Edit a site",
"Add a site" => "增加一個站臺",
// "Directory Categories" => "Directory Categories",
// "{\$countries[ux]}" => "{\$countries[ux]}",
"Admin Directory" => "管理目錄",
"There are" => "有",
"invalid sites" => "不正確的站臺",
"valid sites" => "正確的站臺",
"Users have visited" => "使用者已拜訪",
"sites from the directory" => "個站臺由這個目錄",
"Users have searched" => "使用者已搜尋",
"times from the directory" => "次由這個目錄",
"Validate" => "確認",
"Admin directory categories" => "管理目錄分類",
// "Parent directory category" => "Parent directory category",
"Add a directory category" => "增加目錄類別",
"Edit this directory category" => "編輯目錄類別",
// "Add a Directory Category" => "Add a Directory Category",
"Child type" => "子型別",
// "Most visited directory sub-categories" => "Most visited directory sub-categories",
// "Directory category description" => "Directory category description",
// "Random directory sub-categories" => "Random directory sub-categories",
"Maximum number of child directory categories to show" => "最大展示的分類數目",
// "Allow sites in this directory category" => "Allow sites in this directory category",
// "Show number of sites in this directory category" => "Show number of sites in this directory category",
"Editor group" => "編輯者群組",
// "Directory Subcategories" => "Directory Subcategories",
"cType" => "cType",
"allow" => "允許",
"count" => "次",
"editor" => "編輯",
// "Relate" => "Relate",
// "Admin related directory categories" => "Admin related directory categories",
// "Add a related directory category" => "Add a related directory category",
// "Directory Category" => "Directory Category",
"Mutual" => "共同",
// "Related directory categories" => "Related directory categories",
"Admin sites" => "管理站臺",
"Is valid" => "是正確的",
"New Sites" => "新站臺",
"Popular Sites" => "酷站臺",
"any" => "任何",
"in entire directory" => "在整個目錄中",
// "in current directory category" => "in current directory category",
"Sort by" => "排序依據",
// "Hits (desc)" => "Hits (desc)",
// "Hits (asc)" => "Hits (asc)",
// "Last updated (desc)" => "Last updated (desc)",
// "Last updated (asc)" => "Last updated (asc)",
"sort" => "排序",
// "No records" => "No records",
// "Total directory categories" => "Total directory categories",
"Total links" => "全部連結",
"Links to validate" => "待確認連結",
"Searches performed" => "搜尋已執行",
"Total links visited" => "全部被拜訪連結",
"Directory ranking" => "目錄排名",
"Validate sites" => "確認站臺",
"country" => "國家",
// "Discounts" => "Discounts",
// "{\$prefs.payment_currency|escape}" => "{\$prefs.payment_currency|escape}",
// " or " => " or ",
// "Maximum time the discount can be used in the first phase of payment" => "Maximum time the discount can be used in the first phase of payment",
// "-1 for unlimited" => "-1 for unlimited",
// "Translation of this page is incomplete" => "Translation of this page is incomplete",
// "To add <strong>new content</strong> to the page" => "To add <strong>new content</strong> to the page",
// "use the editor" => "use the editor",
"Edit article" => "編輯文章",
"View Articles" => "顯示文章",
// "Allow full HTML" => "Allow full HTML",
// "Keep any HTML tag" => "Keep any HTML tag",
// "If not enabled, Tiki will retain some HTML tags (a, p, pre, img, hr, b, i)" => "If not enabled, Tiki will retain some HTML tags (a, p, pre, img, hr, b, i)",
// "To translate, do not change the language and the content. Instead, <a class=\"alert-link\" href=\"%0\">create a new translation</a> in the new language" => "To translate, do not change the language and the content. Instead, <a class=\"alert-link\" href=\"%0\">create a new translation</a> in the new language",
// "{\$typei|escape}" => "{\$typei|escape}",
// "Click \"Preview\" after selecting article type to have appropriate edit form fields" => "Click \"Preview\" after selecting article type to have appropriate edit form fields",
// "Publication" => "Publication",
// "If checked, the article is published" => "If checked, the article is published",
// "User (article owner)" => "User (article owner)",
"Time" => "時間",
"Own Image" => "Own Image",
// "If not the topic image" => "If not the topic image",
// "Max file size : {\$prefs.article_image_file_size_max/1000} KB" => "Max file size : {\$prefs.article_image_file_size_max/1000} KB",
"Current Image" => "目前影像",
"Article image" => "文章圖片",
// "Image caption" => "Image caption",
// "Default will use the topic name" => "Default will use the topic name",
"Use own image" => "Use own image",
"Float text around image" => "文繞圖",
// "Read Article" => "Read Article",
// "Maximum dimensions of custom image in view mode" => "Maximum dimensions of custom image in view mode",
// "Maximum dimensions of custom image in list mode" => "Maximum dimensions of custom image in list mode",
// "Attach existing article ID as translation" => "Attach existing article ID as translation",
// "Topline" => "Topline",
// "http://.." => "http://..",
// "Test your link: " => "Test your link: ",
// "Apply content template" => "Apply content template",
// "{\$template.name|escape}" => "{\$template.name|escape}",
// "Email addresses to be sent notifications (comma-separated)" => "Email addresses to be sent notifications (comma-separated)",
// "Cancel the edit (changes will be lost)" => "Cancel the edit (changes will be lost)",
// "Create or edit banners" => "Create or edit banners",
"List banners" => "列出大標題",
"URL to link the banner" => "連結此標題的 URL",
"Client" => "用戶",
"Maximum impressions" => "最大次數",
// "Maximum number of impressions for a user" => "Maximum number of impressions for a user",
// "Maximum clicks" => "Maximum clicks",
// "URIs where the banner appears only" => "URIs where the banner appears only",
// "Type each URI enclosed with the # character. Exemple:#/this_page#/tiki-index.php?page=this_page#" => "Type each URI enclosed with the # character. Exemple:#/this_page#/tiki-index.php?page=this_page#",
// "URIs where the banner will not appear" => "URIs where the banner will not appear",
// "Or, create a new zone" => "Or, create a new zone",
// "New Zone" => "New Zone",
"Show the banner only between these dates" => "只在這些日期顯示大標題",
"From date" => "開始日期",
"To date" => "結束日期",
"Use dates" => "使用日期",
// "Show the banner only in these hours" => "Show the banner only in these hours",
"Show the banner only on" => "顯示大標題的日子",
"Select ONE method for the banner" => "選擇大標題的方式",
"Use Image" => "使用影像",
// "Use Image from URL" => "Use Image from URL",
// "(the image will be requested at the URL for each impression)" => "(the image will be requested at the URL for each impression)",
// "Use Flash" => "Use Flash",
// "Movie Size" => "Movie Size",
// "width in pixels" => "width in pixels",
// "Pixels" => "Pixels",
// "height in pixels" => "height in pixels",
// "FlashPlugin min version" => "FlashPlugin min version",
// "ex" => "ex",
// "Use Text" => "Use Text",
"Save the Banner" => "儲存大標題",
// "Remove zones (info entered for any banner in the zones will be lost)" => "Remove zones (info entered for any banner in the zones will be lost)",
"Edit Blog" => "編輯 Blog",
// "A category is mandatory" => "A category is mandatory",
"Individual permissions are set for this blog" => "這個 blog 有獨立的權限設定",
// "Allow other users to post in this blog" => "Allow other users to post in this blog",
// "Even if others post to the blog, the author is always its administrator" => "Even if others post to the blog, the author is always its administrator",
"Allow search" => "允許搜尋",
"Allow comments" => "允許評論",
// "Use post excerpt" => "Use post excerpt",
// "Display Options" => "Display Options",
// "Displayed posts" => "Displayed posts",
// "Number of posts to show per page" => "Number of posts to show per page",
// "Display the blog title on the posts list page" => "Display the blog title on the posts list page",
// "Display the blog title on the post page" => "Display the blog title on the post page",
// "Display the blog description" => "Display the blog description",
// "Display breadcrumbs" => "Display breadcrumbs",
// "Display the author in blog posts" => "Display the author in blog posts",
// "Display the publish date in blog posts" => "Display the publish date in blog posts",
// "Show user profile picture" => "Show user profile picture",
// "Show the post's related content" => "Show the post's related content",
// "The checkbox is disabled because the tags feature is disabled globally" => "The checkbox is disabled because the tags feature is disabled globally",
// "Related posts" => "Related posts",
// "Maximum number of related posts to display" => "Maximum number of related posts to display",
"Blog heading" => "Blog 標題",
// "Heading preview" => "Heading preview",
// "Blog post heading" => "Blog post heading",
// "Organizer" => "Organizer",
// "Move objects between categories" => "Move objects between categories",
// "Click on the category name to display the list of objects in that category" => "Click on the category name to display the list of objects in that category",
// "Select the objects to affect. Controls will appear in the category browser" => "Select the objects to affect. Controls will appear in the category browser",
// "Use the plus and minus signs to add or remove the categories on selected objects" => "Use the plus and minus signs to add or remove the categories on selected objects",
// "Object list result" => "Object list result",
// "Select objects to change categorization" => "Select objects to change categorization",
// "More results are available. Please refine the search criteria" => "More results are available. Please refine the search criteria",
// "Select all" => "Select all",
// "Unselect all" => "Unselect all",
// "The file will be saved in" => "The file will be saved in",
// "Currently trying" => "Currently trying",
"Try" => "測試",
// "Missing Package" => "Missing Package",
// "To view/edit ODT documents Tiki needs bower-asset/wodo.texteditor package" => "To view/edit ODT documents Tiki needs bower-asset/wodo.texteditor package",
// "Please contact the Administrator to install it" => "Please contact the Administrator to install it",
// "Tiki Docs" => "Tiki Docs",
// "Save file" => "Save file",
// "Cancel editing file" => "Cancel editing file",
// "Editing file" => "Editing file",
// "Save and Back" => "Save and Back",
"Rename" => "更名",
// "Toggle Fullscreen" => "Toggle Fullscreen",
// "More information" => "More information",
// "Wiki Page Editor" => "Wiki Page Editor",
// "More help on editing wiki pages" => "More help on editing wiki pages",
// "The syntax system used for creating pages in Tiki" => "The syntax system used for creating pages in Tiki",
// "Bold text" => "Bold text",
// "Italic text" => "Italic text",
// "single quotes" => "single quotes",
// "Underlined text" => "Underlined text",
"Colored text" => "著色文字",
// "Will display using the indicated HTML color or color name. Color name can contain two colors separated by a comma. In this case, the first color would be the foreground and the second one the background" => "Will display using the indicated HTML color or color name. Color name can contain two colors separated by a comma. In this case, the first color would be the foreground and the second one the background",
// "Deleted text" => "Deleted text",
// "2 dashes" => "2 dashes",
// "Headings" => "Headings",
// "show/hide heading section. + (shown) or - (hidden) by default" => "show/hide heading section. + (shown) or - (hidden) by default",
// "Autonumbered Headings" => "Autonumbered Headings",
// "{literal}{toc}{/literal}, {literal}{maketoc}{/literal} prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)" => "{literal}{toc}{/literal}, {literal}{maketoc}{/literal} prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)",
// "Common optional parameters for maketoc are: title|maxdepth|levels|nums, and for toc are: order|showdesc|shownum|structId|maxdepth|pagename" => "Common optional parameters for maketoc are: title|maxdepth|levels|nums, and for toc are: order|showdesc|shownum|structId|maxdepth|pagename",
// "Horizontal rule" => "Horizontal rule",
// "Text box" => "Text box",
"Box content" => "方塊內容",
// "Centered text" => "Centered text",
// "Inserts an editable variable" => "Inserts an editable variable",
"External links" => "外部連結",
// "use square brackets for an external link: [URL], [URL|link_description],[URL|link_description|relation] or [URL|description|relation|nocache] (that last prevents the local Wiki from caching the linked page; relation can be used to insert rel attribute for the link - useful e.g. for shadowbox)" => "use square brackets for an external link: [URL], [URL|link_description],[URL|link_description|relation] or [URL|description|relation|nocache] (that last prevents the local Wiki from caching the linked page; relation can be used to insert rel attribute for the link - useful e.g. for shadowbox)",
// "For an external Wiki, use ExternalWikiName:PageName or ((External Wiki Name: Page Name))" => "For an external Wiki, use ExternalWikiName:PageName or ((External Wiki Name: Page Name))",
// "Square Brackets" => "Square Brackets",
// "Use [[foo] to show [foo]" => "Use [[foo] to show [foo]",
"JoinCapitalizedWords or use" => "連在一起的大寫字或使用",
"page|description" => "頁面|描述",
"for wiki references" => "表示 wiki 參考",
// "page|#anchor" => "page|#anchor",
// "page|#anchor|desc" => "page|#anchor|desc",
// "for wiki heading/anchor references" => "for wiki heading/anchor references",
"SomeName" => "某個名稱",
"prevents referencing" => "表示不參考",
"Lists" => "項目",
"for bullet lists" => "表示無序列表",
"for numbered lists" => "表示有序列表",
"definition" => "定義",
"for definiton lists" => "表示定義列表",
// "Indentation" => "Indentation",
// "Creates an indentation for each plus (useful in list to continue at the same level)" => "Creates an indentation for each plus (useful in list to continue at the same level)",
"Tables" => "表格",
// "row" => "row",
"col" => "col",
// "Monospace font" => "Monospace font",
// "Code sample" => "Code sample",
// "(very useful especially in tables)" => "(very useful especially in tables)",
"Multi-page pages" => "多頁式頁面",
// "to separate pages" => "to separate pages",
"Non-parsed sections" => "不分析的區段",
"data" => "資料",
// "Prevents wiki parsing of the enclosed data" => "Prevents wiki parsing of the enclosed data",
// "Preformated sections" => "Preformated sections",
// "~pp~ data ~/pp~ Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done). ~pre~ data ~/pre~ also displayes preformatted text with fixed spacing, but wiki processing still occurs on the text" => "~pp~ data ~/pp~ Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done). ~pre~ data ~/pre~ also displayes preformatted text with fixed spacing, but wiki processing still occurs on the text",
// "~tc~ Tiki Comment ~/tc~ makes a Tiki comment. It will be completely removed from the display, but saved in the file for future reference. ~hc~ HTML Comment ~/hc~ makes an HTML comment. It will be inserted as a comment in the output HTML; these are not normally displayed in browsers, but can be seen using \"View Source\" or similar" => "~tc~ Tiki Comment ~/tc~ makes a Tiki comment. It will be completely removed from the display, but saved in the file for future reference. ~hc~ HTML Comment ~/hc~ makes an HTML comment. It will be inserted as a comment in the output HTML; these are not normally displayed in browsers, but can be seen using \"View Source\" or similar",
// "Block Preformatting" => "Block Preformatting",
// "Indent text with any number of spaces to change it to a monospaced block that still follows other Wiki formatting instructions. It will be indented with the same number of spaces that are used. Note that this mode does not preserve exact spacing and line breaks; use ~pp~...~/pp~ for that" => "Indent text with any number of spaces to change it to a monospaced block that still follows other Wiki formatting instructions. It will be indented with the same number of spaces that are used. Note that this mode does not preserve exact spacing and line breaks; use ~pp~...~/pp~ for that",
// "Insert with respect to right-to-left and left-to-right text direction DIV (up to end of text) and markers for langages as Arabic and Hebrew" => "Insert with respect to right-to-left and left-to-right text direction DIV (up to end of text) and markers for langages as Arabic and Hebrew",
// "Special characters" => "Special characters",
// "hard space" => "hard space",
// "numeric between ~ for HTML numeric characters entity" => "numeric between ~ for HTML numeric characters entity",
// "Because the wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs. Lines can be of any length, and will be wrapped together with the next line. Paragraphs are separated by blank lines" => "Because the wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs. Lines can be of any length, and will be wrapped together with the next line. Paragraphs are separated by blank lines",
// "Because the Wiki paragraph formatting feature is off, each line will be presented as you write it. This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line" => "Because the Wiki paragraph formatting feature is off, each line will be presented as you write it. This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line",
// "Note that plugin arguments can be enclosed with double quotes (&quot;); this allows them to contain , or = or &gt" => "Note that plugin arguments can be enclosed with double quotes (&quot;); this allows them to contain , or = or &gt",
// "More help here" => "More help here",
// "Wiki plugins extend the function of wiki syntax with more specialized commands" => "Wiki plugins extend the function of wiki syntax with more specialized commands",
// "Activate/deactivate plugins" => "Activate/deactivate plugins",
"No description available" => "沒有描述",
// "For more information, please see" => "For more information, please see",
// "WYSIWYG Editor" => "WYSIWYG Editor",
// "More help on WYSIWYG editing" => "More help on WYSIWYG editing",
// "The WYSIWYG editor in Tiki is <a href=\"http://ckeditor.com\">CKEditor</a>" => "The WYSIWYG editor in Tiki is <a href=\"http://ckeditor.com\">CKEditor</a>",
// "To switch modes between WYSIWYG and Wiki edit modes click the {icon name=\"pencil_go\"} button on the toolbar" => "To switch modes between WYSIWYG and Wiki edit modes click the {icon name=\"pencil_go\"} button on the toolbar",
// "<strong>Note: </strong>Using this button converts the page source from wiki to HTML, or vice versa.\n\tThe conversion process is not entirely transparent, meaning that you may notice differences between the look of a page in different modes.\n\tThis will improve in future updates but as the two systems have significant differences in what they can do it is unlikely to ever be totally transparent" => "<strong>Note: </strong>Using this button converts the page source from wiki to HTML, or vice versa.\n\tThe conversion process is not entirely transparent, meaning that you may notice differences between the look of a page in different modes.\n\tThis will improve in future updates but as the two systems have significant differences in what they can do it is unlikely to ever be totally transparent",
// "<strong>Note: </strong>Using this button changes the editor between WYSIWYG and the usual wiki editor, but leaves the page source in wiki syntax" => "<strong>Note: </strong>Using this button changes the editor between WYSIWYG and the usual wiki editor, but leaves the page source in wiki syntax",
// "Wiki plugins can be used and edited in WYSIWYG mode, double click the plugin to bring up the plugin edit popup form.<br>\n\tHere is an example of the {ldelim}BOX{rdelim} plugin" => "Wiki plugins can be used and edited in WYSIWYG mode, double click the plugin to bring up the plugin edit popup form.<br>\n\tHere is an example of the {ldelim}BOX{rdelim} plugin",
// "This is text in a box which is justified. The box has a cream background, takes 80% of the window width and is centered" => "This is text in a box which is justified. The box has a cream background, takes 80% of the window width and is centered",
// "<strong>Caution:</strong> There are still limitations regarding use of plugins in the WYSIWYG editor.<br>\n\tIf you intend to use plugins extensively in a page consider editing that page in wiki mode only.<br>\n\tCurrently, cutting and pasting, or drag and drop of plugins in WYSIWYG will cause problems. Use source mode or the plain wiki editor if you need to move plugins around" => "<strong>Caution:</strong> There are still limitations regarding use of plugins in the WYSIWYG editor.<br>\n\tIf you intend to use plugins extensively in a page consider editing that page in wiki mode only.<br>\n\tCurrently, cutting and pasting, or drag and drop of plugins in WYSIWYG will cause problems. Use source mode or the plain wiki editor if you need to move plugins around",
// "<strong>Admins:</strong><br>\n\t\t<em>This new implementation is designed to work best with some site preferences set in a certain way.\n\t\tThese can all be found on the <a href=\"tiki-admin.php?page=wysiwyg\">WYSIWYG admin page</a>.\n\t\tA profile to set these up correctly can be found on <a href=\"http://profiles.tiki.org/WYSIWYG_6x\">profiles.tiki.org</a>\n\t\twhich can be applied using the <a href=\"tiki-admin.php?page=profiles\">profiles admin page</a>.</em>" => "<strong>Admins:</strong><br>\n\t\t<em>This new implementation is designed to work best with some site preferences set in a certain way.\n\t\tThese can all be found on the <a href=\"tiki-admin.php?page=wysiwyg\">WYSIWYG admin page</a>.\n\t\tA profile to set these up correctly can be found on <a href=\"http://profiles.tiki.org/WYSIWYG_6x\">profiles.tiki.org</a>\n\t\twhich can be applied using the <a href=\"tiki-admin.php?page=profiles\">profiles admin page</a>.</em>",
// "Browse Images" => "Browse Images",
"Edit successful!" => "編輯成功!",
"The following image was successfully edited" => "下列影像已成功編輯",
"Image Description" => "影像描述",
// "Upload from disk to change the image" => "Upload from disk to change the image",
// "Save and Go Next" => "Save and Go Next",
// "Edit Invoice" => "Edit Invoice",
// "Invoice Number" => "Invoice Number",
// "Date Issued" => "Date Issued",
// "Work Description" => "Work Description",
// "Taxable" => "Taxable",
// "New Item" => "New Item",
// "Invoice Note" => "Invoice Note",
// "Save Invoice" => "Save Invoice",
// "Customized String Translation" => "Customized String Translation",
// "Manage local translations in a custom.php file" => "Manage local translations in a custom.php file",
// "Download language.php file for the selected language" => "Download language.php file for the selected language",
// "Download Database Translations" => "Download Database Translations",
// "Download a file with all the translations in the database for the selected language" => "Download a file with all the translations in the database for the selected language",
// "Translations in the database will be merged with the other translations in language.php for the selected language" => "Translations in the database will be merged with the other translations in language.php for the selected language",
"Add a translation" => "增加一個翻譯",
// "Untranslated strings" => "Untranslated strings",
// "Show only database stored untranslated strings" => "Show only database stored untranslated strings",
"Edit translations" => "編輯一個翻譯",
// "Show only database stored translations" => "Show only database stored translations",
// "Original string" => "Original string",
// "Last changed by %0 on %1" => "Last changed by %0 on %1",
// "Contribute" => "Contribute",
// "Undecided" => "Undecided",
// "Save translation in the database" => "Save translation in the database",
// "Delete translation from the database" => "Delete translation from the database",
"Compare" => "比較",
// "Compare the original translation with the database translation" => "Compare the original translation with the database translation",
// "For translations specific to this Tiki instance, select No. If this translation can be contributed to the Tiki community, select Yes" => "For translations specific to this Tiki instance, select No. If this translation can be contributed to the Tiki community, select Yes",
// "Translate all" => "Translate all",
// "Delete all" => "Delete all",
// "Are you sure you want to delete all untranslated strings from database" => "Are you sure you want to delete all untranslated strings from database",
// "Are you sure you want to delete all translations from database" => "Are you sure you want to delete all translations from database",
// "Return to the default perspective" => "Return to the default perspective",
// "Switch to" => "Switch to",
// "Preference List" => "Preference List",
// "Search preferences below and drag them into the preference list above" => "Search preferences below and drag them into the preference list above",
"Program dynamic content for block" => "設計區塊的動態內容",
"Create New Block" => "建立新區塊",
"Return to block listing" => "返回區塊列表",
"Block description: " => "區塊描述: ",
"You are editing block:" => "你正在編輯區塊:",
// "Publising Date" => "Publising Date",
"Publishing Date" => "發表日期",
"Edit question options" => "編輯問題選項",
"List Quizzes" => "列出測驗",
"Quiz Stats" => "測驗統計",
"This Quiz Stats" => "這個測驗的統計",
"Edit this Quiz" => "編輯這個測驗",
"Admin Quizzes" => "管理測驗",
"Create/edit options for question" => "建立/編輯 問題的選項",
"points" => "分",
"Quiz can be repeated" => "可以重覆參加測驗",
// "Time Limit" => "Time Limit",
"Create/edit quizzes" => "增加/編輯 測驗",
"There are individual permissions set for this quiz" => "這個測驗有單獨權限設定",
"Store quiz results" => "儲存測驗結果",
"Quiz is time-limited" => "測驗有時間限制",
"Maximum time" => "最大時間",
// "Passing Percentage" => "Passing Percentage",
// "%" => "%",
"Edit quiz questions" => "編輯測驗問題",
"Create/edit questions for quiz" => "建立/編輯 測驗的選項",
// "Question Type" => "Question Type",
// "Import questions from text" => "Import questions from text",
// "Instructions: Type, or paste your multiple choice questions below. Provide one line for the question, then provide as many answers on want on subsequent lines. Separate questions with a blank line. To indicate correct answers, you may initiate an answer with \"*\" (without the quotes). None, any or all the answers are possible to be marked as correct" => "Instructions: Type, or paste your multiple choice questions below. Provide one line for the question, then provide as many answers on want on subsequent lines. Separate questions with a blank line. To indicate correct answers, you may initiate an answer with \"*\" (without the quotes). None, any or all the answers are possible to be marked as correct",
// "Input" => "Input",
"Maximum score" => "最高分數",
// "Edit quiz results" => "Edit quiz results",
"From Points" => "從分數",
"To Points" => "至分數",
// "Reports" => "Reports",
// "Report Builder" => "Report Builder",
// "Report Type" => "Report Type",
// "Select Report Type" => "Select Report Type",
// "Wiki Data" => "Wiki Data",
// "Export As CSV" => "Export As CSV",
"You will remove" => "將會移除",
"and its subpages from the structure, now you have two options:" => "以及結構中的子頁面, 你有兩個選擇:",
// "and its subpages from the structure" => "and its subpages from the structure",
// "Remove from structure" => "Remove from structure",
// "Remove from structure and remove page too" => "Remove from structure and remove page too",
// "The page already exists. The page that has been added to the structure is the existing one" => "The page already exists. The page that has been added to the structure is the existing one",
// "The following pages added have automatically been categorized with the same categories as the structure" => "The following pages added have automatically been categorized with the same categories as the structure",
// "Structure Layout" => "Structure Layout",
// "Monitor the structure" => "Monitor the structure",
// "Stop Monitoring the structure" => "Stop Monitoring the structure",
// "Add pages" => "Add pages",
// "Use an existing page by dragging it into the structure above" => "Use an existing page by dragging it into the structure above",
// "{\$catix.categpath}" => "{\$catix.categpath}",
// "Categorize all pages in structure together" => "Categorize all pages in structure together",
// "Remove existing categories from ALL pages before recategorizing" => "Remove existing categories from ALL pages before recategorizing",
// "Move to another structure" => "Move to another structure",
// "at the beginning" => "at the beginning",
// "at the end" => "at the end",
"Submit article" => "傳送文章",
"List submissions" => "列出submission",
"Use ...page... to separate pages in a multi-page post" => "使用 ...頁面... 將頁面分隔為多重頁面",
// "Fields with <b>*</b> are optional" => "Fields with <b>*</b> are optional",
// "<b>Topline</b>=small line above Title" => "<b>Topline</b>=small line above Title",
// "<b>Subtitle</b>=small line below Title" => "<b>Subtitle</b>=small line below Title",
// "<b>Source</b>=URL to article source" => "<b>Source</b>=URL to article source",
"Author Name" => "作者",
"Own image size x" => "Own image size x",
"Own image size y" => "Own image size y",
// "Auto-Approve Article" => "Auto-Approve Article",
// "View template" => "View template",
"Template listing" => "Template列表",
"Available templates" => "現有模板",
"Important" => "重要",
// "You should only modify default header.tpl and other important files via a text code editor, through console,\n\t\t\t\t\tor SSH, or FTP edit commands--and only if you know what you are doing! ;-)" => "You should only modify default header.tpl and other important files via a text code editor, through console,\n\t\t\t\t\tor SSH, or FTP edit commands--and only if you know what you are doing! ;-)",
// "Extensive customizations can be made safely through the <a href=\"tiki-admin.php?page=look\" class=\"tips alert-link\"\n\t\t\t\t\ttitle=\"Look & Feel\">Look & Feel</a> admin panel custom code or general layout areas" => "Extensive customizations can be made safely through the <a href=\"tiki-admin.php?page=look\" class=\"tips alert-link\"\n\t\t\t\t\ttitle=\"Look & Feel\">Look & Feel</a> admin panel custom code or general layout areas",
// "To be safe and to make upgrades easier, it is recommended that you create a custom theme before modifying tpl files.\n\t\t\t\t\tSee <a href=\"http://doc.tiki.org/Customizing+Themes\" class=\"tips alert-link\" title=\"Customizing Themes help page\">\n\t\t\t\t\tdoc.tiki.org/Customizing+Themes</a> for how to do that" => "To be safe and to make upgrades easier, it is recommended that you create a custom theme before modifying tpl files.\n\t\t\t\t\tSee <a href=\"http://doc.tiki.org/Customizing+Themes\" class=\"tips alert-link\" title=\"Customizing Themes help page\">\n\t\t\t\t\tdoc.tiki.org/Customizing+Themes</a> for how to do that",
// "Save Only in the Theme" => "Save Only in the Theme",
// "Delete the copy in the theme" => "Delete the copy in the theme",
// "Admin Article Topics" => "Admin Article Topics",
// "Edit article topic" => "Edit article topic",
// "Admin notifications" => "Admin notifications",
// "Enter email addresses " => "Enter email addresses ",
// "View Article" => "View Article",
// "Attach or detach existing translations of this page" => "Attach or detach existing translations of this page",
// "Manage Translations" => "Manage Translations",
// "You must specify the object language" => "You must specify the object language",
// "The object doesn't exist" => "The object doesn't exist",
// "The object doesn't have a language" => "The object doesn't have a language",
// "The object already has a translation for this language" => "The object already has a translation for this language",
// "The object is already in the set of translations" => "The object is already in the set of translations",
// "Translate this page to a new language" => "Translate this page to a new language",
// "Select language to translate to" => "Select language to translate to",
// "Enter the page title" => "Enter the page title",
// "Assign categories to this new translation (Note: they should probably be the same as the categories of the page being translate)" => "Assign categories to this new translation (Note: they should probably be the same as the categories of the page being translate)",
// "Create translation" => "Create translation",
// "Change language for this page" => "Change language for this page",
// "Change Language" => "Change Language",
// "You forgot to specify the language of the translation. Please choose a language in the picklist" => "You forgot to specify the language of the translation. Please choose a language in the picklist",
// "The page already exists. It was selected in the list below" => "The page already exists. It was selected in the list below",
// "No language is assigned to this page" => "No language is assigned to this page",
// "Please select a language before translating" => "Please select a language before translating",
// "Set Page Language" => "Set Page Language",
// "Edit %0" => "Edit %0",
// "Update '{\$page}'" => "Update '{\$page}'",
// "{\$customTip|escape}" => "{\$customTip|escape}",
// "Preview your changes" => "Preview your changes",
// "Draft written on" => "Draft written on",
// "Warning: new versions of this page have been made after this draft" => "Warning: new versions of this page have been made after this draft",
// "The Sandbox is a page where you can practice editing, etc. and use the preview feature to check the appearance of the page. No versions are stored for this page" => "The Sandbox is a page where you can practice editing, etc. and use the preview feature to check the appearance of the page. No versions are stored for this page",
// "The following item(s) include this one with Plugin Include and might be affected by these changes. Renaming sections can break related item(s)" => "The following item(s) include this one with Plugin Include and might be affected by these changes. Renaming sections can break related item(s)",
// "An edit summary is mandatory" => "An edit summary is mandatory",
// "Translate from" => "Translate from",
// "Changes that need to be translated are highlighted below" => "Changes that need to be translated are highlighted below",
// "No comment" => "No comment",
// "All Versions" => "All Versions",
// "Edit wiki page" => "Edit wiki page",
// "Select the style used to display differences to be translated" => "Select the style used to display differences to be translated",
// "text full" => "text full",
// "Change the style used to display differences to be translated" => "Change the style used to display differences to be translated",
// "Change diff styles" => "Change diff styles",
// "Translate to" => "Translate to",
// "Reproduce the changes highlighted on the left using the editor below" => "Reproduce the changes highlighted on the left using the editor below",
// "Describe the change you made" => "Describe the change you made",
// "Edit comment: Enter some text to describe the changes you are currently making" => "Edit comment: Enter some text to describe the changes you are currently making",
// "Monitor this page" => "Monitor this page",
"Upload picture" => "上傳圖片",
// "Add another image" => "Add another image",
// "Categorization has been preset for this edit" => "Categorization has been preset for this edit",
// "Categories will be inherited from the structure top page" => "Categories will be inherited from the structure top page",
// "Leave page and go to..." => "Leave page and go to...",
// "Wiki Preferences" => "Wiki Preferences",
// "Copyright notices" => "Copyright notices",
// "Copyright page" => "Copyright page",
// "{\$templates[ix].name|escape}" => "{\$templates[ix].name|escape}",
// "Lock this page" => "Lock this page",
// "Allow comments on this page" => "Allow comments on this page",
// "HTML tags are used to create elements of the wiki page, instead of being displayed as code" => "HTML tags are used to create elements of the wiki page, instead of being displayed as code",
// "Try to convert HTML to wiki" => "Try to convert HTML to wiki",
"Import page" => "匯入頁面 ",
// "Export page" => "Export page",
// "Export all versions" => "Export all versions",
// "Attach file" => "Attach file",
// "Only cache a page if it should look the same to all groups authorized to see it" => "Only cache a page if it should look the same to all groups authorized to see it",
// "{\$prefs.wikiSubmitNotice}" => "{\$prefs.wikiSubmitNotice}",
// "Site default" => "Site default",
// "as Creator &amp; Last Editor" => "as Creator &amp; Last Editor",
// "no (disabled)" => "no (disabled)",
// "Description (used for metatags)" => "Description (used for metatags)",
// "My Footnotes" => "My Footnotes",
// "{\$template.title|escape}" => "{\$template.title|escape}",
// "There is no available poll template" => "There is no available poll template",
// "Please ask an administrator to create one" => "Please ask an administrator to create one",
// "\"}To translate, do not change the language and the content. Instead, <a class=\"alert-link\" href=\"%0\">create a new translation</a> in the new language" => "\"}To translate, do not change the language and the content. Instead, <a class=\"alert-link\" href=\"%0\">create a new translation</a> in the new language",
// "Translation request" => "Translation request",
// "Send urgent translation request" => "Send urgent translation request",
// "Geolocation" => "Geolocation",
// "Show page title" => "Show page title",
// "Explicit Namespace" => "Explicit Namespace",
// "The namespace for a page is guessed automatically from the page name. However, some exceptions may arise. This option allows to override the namespace" => "The namespace for a page is guessed automatically from the page name. However, some exceptions may arise. This option allows to override the namespace",
// "Page layout" => "Page layout",
// "Site Default" => "Site Default",
// "{\$title}" => "{\$title}",
// "List Sheets" => "List Sheets",
// "Graph" => "Graph",
// "Export to file" => "Export to file",
// "Autodetect" => "Autodetect",
"Admin FAQ" => "管理 FAQ",
"List FAQs" => "列出 FAQs",
"View FAQ" => "觀看 FAQ",
"Edit this FAQ" => "編輯這個 FAQ",
"New Question" => "新問題",
// "Edit FAQ question" => "Edit FAQ question",
// "Add FAQ question" => "Add FAQ question",
"Use a question from another FAQ" => "使用來自其它 FAQ 的問題",
"FAQ questions" => "FAQ 問題",
"Suggested questions" => "建議問題",
"No suggested questions" => "無建議的問題",
// "File Archive" => "File Archive",
// "Size (width x height)" => "Size (width x height)",
// "Content waiting for approval" => "Content waiting for approval",
// "You are currently viewing the latest version of the page" => "You are currently viewing the latest version of the page",
// "You can also view the {self_link}latest approved version{/self_link}" => "You can also view the {self_link}latest approved version{/self_link}",
// "You can approve this revision and make it available to a wider audience. Make sure you review all the changes before approving" => "You can approve this revision and make it available to a wider audience. Make sure you review all the changes before approving",
// "Show changes since last approved revision" => "Show changes since last approved revision",
// "This page has no prior approved revision. <strong>All of the content must be reviewed.</strong>" => "This page has no prior approved revision. <strong>All of the content must be reviewed.</strong>",
// "Approve current revision" => "Approve current revision",
// "Reject current revision" => "Reject current revision",
// "You are currently viewing the approved version of the page" => "You are currently viewing the approved version of the page",
// "You can also view the {self_link latest=1}latest version{/self_link}" => "You can also view the {self_link latest=1}latest version{/self_link}",
// "View the {self_link latest=1}latest version{/self_link}" => "View the {self_link latest=1}latest version{/self_link}",
// "Forum Importer" => "Forum Importer",
// "Import from a Local SQL File" => "Import from a Local SQL File",
// "Forum Type" => "Forum Type",
// "DB Prefix" => "DB Prefix",
// "Local SQL Filename on Server (path will be stripped)" => "Local SQL Filename on Server (path will be stripped)",
// "Must be in tikiroot/{\$tmpdir} or tikiroot/img/wiki_up" => "Must be in tikiroot/{\$tmpdir} or tikiroot/img/wiki_up",
// "Get Forum List" => "Get Forum List",
// "Verification" => "Verification",
// "File must be an SQL file and exist in either <i>\$tikiroot/temp</i> or <i>\$tikiroot/img/wiki_up</i>" => "File must be an SQL file and exist in either <i>\$tikiroot/temp</i> or <i>\$tikiroot/img/wiki_up</i>",
// "File was not specified, or could not be found in either location. Please put the file in either directory and Go Back. If the file exists in both locations, the \$tikiroot/{\$filecheck} location will be preferred" => "File was not specified, or could not be found in either location. Please put the file in either directory and Go Back. If the file exists in both locations, the \$tikiroot/{\$filecheck} location will be preferred",
// "Proceed" => "Proceed",
// "Go Back" => "Go Back",
// "Select a Forum You Wish to Move (ONE at a time!)" => "Select a Forum You Wish to Move (ONE at a time!)",
// "Which Forum Do You Wish to Import this Into" => "Which Forum Do You Wish to Import this Into",
// "Refresh list" => "Refresh list",
"Edit queued message" => "編輯佇列中訊息",
// "Make this a thread of" => "Make this a thread of",
"None, this is a thread message" => "不, 這不是討論串",
"summary" => "總結",
"Announce" => "公佈",
"Hot" => "熱門",
"no feeling" => "沒感覺",
"frown" => "皺眉",
"exclaim" => "驚叫",
"idea" => "點子",
"mad" => "瘋狂",
"neutral" => "中立",
"question" => "問題",
"sad" => "難過",
"happy" => "快樂",
"wink" => "眨眼",
"Save and Approve" => "儲存並核可",
// "Convert to topic" => "Convert to topic",
"New Topic" => "新主題",
"no summary" => "無總結",
"No messages queued yet" => "尚無訊息佇列",
// "Search by name" => "Search by name",
// "Search in content" => "Search in content",
"Last Post" => "最近發表佈告",
// "{\$section|escape}" => "{\$section|escape}",
// "No forums found" => "No forums found",
// "Loading" => "Loading",
"Reported by" => "回報自",
// "Perfom action with checked" => "Perfom action with checked",
// "Un-report" => "Un-report",
// "Tag translation" => "Tag translation",
// "Tags that were created on pages with no language set will remain universal (i.e. is the same tag in all languages) until a language has been set for the tag. Until then, they cannot be translated" => "Tags that were created on pages with no language set will remain universal (i.e. is the same tag in all languages) until a language has been set for the tag. Until then, they cannot be translated",
// "Show checkboxes" => "Show checkboxes",
// "There are no tags on this page in your preferred languages" => "There are no tags on this page in your preferred languages",
// "Set language" => "Set language",
// "Universal" => "Universal",
// "Displayed languages" => "Displayed languages",
// "Friendship Network" => "Friendship Network",
"Galleries" => "圖庫",
"Create New Gallery" => "建立新圖庫",
// "Migrate Images to File Gallery" => "Migrate Images to File Gallery",
"Create a gallery" => "建立圖庫",
"Edit this gallery:" => "編輯此圖庫:",
"There are individual permissions set for this gallery" => "這個圖庫有獨立的權限設定",
"Gallery is visible to non-admin users?" => "允許非管理者用戶看到?",
"Max Rows per page" => "每頁最大列數",
"Thumbnails size X" => "縮圖大小 X",
"Thumbnails size Y" => "縮圖大小 Y",
// "Fields to show during browsing the gallery" => "Fields to show during browsing the gallery",
// "XY-Size" => "XY-Size",
// "Gallery Image" => "Gallery Image",
"Available scales" => "現有的比率",
// "Global default" => "Global default",
// "Bounding box" => "Bounding box",
// "default scale" => "default scale",
// "Default scale" => "Default scale",
"No scales available" => "沒有可用的比率",
// "Original image is default scale" => "Original image is default scale",
// "Add scaled images with bounding box of square size" => "Add scaled images with bounding box of square size",
"Other users can upload images to this gallery" => "允許其它使用者上傳影像至此圖庫",
"You can access the gallery using the following URL" => "你可以經由下列的URL進入此圖庫",
"Available Galleries" => "目前所有的圖庫",
// "Choose a filter" => "Choose a filter",
"Imgs" => "影像",
// "Make map" => "Make map",
// "Select Graphic Type" => "Select Graphic Type",
// "Pie Chart" => "Pie Chart",
// "Multiline" => "Multiline",
// "Multibar" => "Multibar",
// "Bar Stack" => "Bar Stack",
// "Independant Scale" => "Independant Scale",
// "Horizontal Scale" => "Horizontal Scale",
// "Vertical Scale" => "Vertical Scale",
// "Series" => "Series",
// "Edit Spreadsheet" => "Edit Spreadsheet",
// "List Spreadsheets" => "List Spreadsheets",
// "Wiki plug-in" => "Wiki plug-in",
// "Spreadsheet History" => "Spreadsheet History",
"Roll back" => "回復",
// "Toggle Full Screen" => "Toggle Full Screen",
// "Date Selection" => "Date Selection",
// "Edit Date" => "Edit Date",
// "View Spreadsheet" => "View Spreadsheet",
// "Clone Spreadsheet" => "Clone Spreadsheet",
// "Roll back spreadsheet" => "Roll back spreadsheet",
// "Import From File" => "Import From File",
// "File to import" => "File to import",
// "Grab Wiki Tables" => "Grab Wiki Tables",
// "Import pages from a Structured Text Dump" => "Import pages from a Structured Text Dump",
// "Name of the dump file (it has to be in dump/)" => "Name of the dump file (it has to be in dump/)",
"Overwrite existing pages if the name is the same" => "當名稱一樣時覆寫已存在的頁面",
// "Remove previously existing page versions" => "Remove previously existing page versions",
"excerpt" => "引用",
"Result" => "結果",
// "body" => "body",
// "Name of the zip file on the server" => "Name of the zip file on the server",
// "Tiki Importer" => "Tiki Importer",
// "If you are NOT running a new Tiki installation, make a backup of your database before using this importer" => "If you are NOT running a new Tiki installation, make a backup of your database before using this importer",
// "If your pages contain XML code, the HTML purifier will delete it. Deactivate this feature" => "If your pages contain XML code, the HTML purifier will delete it. Deactivate this feature",
// "Your PHP is running with safe mode enabled. This might cause problems to the import process as safe mode limits the possibility to change in run time some PHP settings (like max_execution_time). It is recommended to run this script without safe mode" => "Your PHP is running with safe mode enabled. This might cause problems to the import process as safe mode limits the possibility to change in run time some PHP settings (like max_execution_time). It is recommended to run this script without safe mode",
// "Depending on the size of the file from the source software, the import process may take a while to complete. This might be a problem according to your PHP and web server settings. This script tries to change the relevant settings but there are some settings that the script cannot change. So, if you are having problems with the script, please try to increase the value of the following PHP settings: max_input_time, max_execution_time (this setting is limited by the web server setting, if you are running Apache also change its Timeout setting), post_max_size, upload_max_filesize, memory_limit. It is recommended that you run this script on a server where you can change the values of those settings (if needed)" => "Depending on the size of the file from the source software, the import process may take a while to complete. This might be a problem according to your PHP and web server settings. This script tries to change the relevant settings but there are some settings that the script cannot change. So, if you are having problems with the script, please try to increase the value of the following PHP settings: max_input_time, max_execution_time (this setting is limited by the web server setting, if you are running Apache also change its Timeout setting), post_max_size, upload_max_filesize, memory_limit. It is recommended that you run this script on a server where you can change the values of those settings (if needed)",
// "Select the software to import from" => "Select the software to import from",
// "Select.." => "Select..",
// "WARNING: make sure to have a backup before running the script. If you do not have a backup this is the last chance to cancel the importer by clicking on the cancel button" => "WARNING: make sure to have a backup before running the script. If you do not have a backup this is the last chance to cancel the importer by clicking on the cancel button",
// "Congratulations! You have successful imported your data to Tiki" => "Congratulations! You have successful imported your data to Tiki",
// "%0 pages imported from a total of %1" => "%0 pages imported from a total of %1",
// "%0 pages imported" => "%0 pages imported",
// "(you can see the list of wiki pages in your site <a href=\"tiki-listpages.php\">here</a>)" => "(you can see the list of wiki pages in your site <a href=\"tiki-listpages.php\">here</a>)",
// "%0 posts imported" => "%0 posts imported",
// "%0 tags imported" => "%0 tags imported",
// "%0 categories imported" => "%0 categories imported",
// "Importer log" => "Importer log",
// "Suggested .htaccess rules" => "Suggested .htaccess rules",
// "Tiki Wiki CMS Groupware" => "Tiki Wiki CMS Groupware",
// "Installation" => "Installation",
// "Tiki Icon" => "Tiki Icon",
// "Tiki Project Web Site" => "Tiki Project Web Site",
// "Support Forums" => "Support Forums",
// "Welcome" => "Welcome",
// "Welcome to the <strong>Tiki %0</strong> installer" => "Welcome to the <strong>Tiki %0</strong> installer",
// "Use this script to install a new database or upgrade your existing database" => "Use this script to install a new database or upgrade your existing database",
// "For the latest information about this release, please read the" => "For the latest information about this release, please read the",
// "Release Notes" => "Release Notes",
// "For complete documentation, please visit" => "For complete documentation, please visit",
// "For more information about Tiki, please visit" => "For more information about Tiki, please visit",
// "Select your language" => "Select your language",
// "License" => "License",
// "Tiki is software distributed under the LGPL license" => "Tiki is software distributed under the LGPL license",
// "Review the System Requirements" => "Review the System Requirements",
// "Before installing Tiki, <a href=\"https://doc.tiki.org/Requirements\" target=\"_blank\" class=\"alert-link\">review the documentation</a> and confirm that your system meets the minimum requirements" => "Before installing Tiki, <a href=\"https://doc.tiki.org/Requirements\" target=\"_blank\" class=\"alert-link\">review the documentation</a> and confirm that your system meets the minimum requirements",
// "This installer will perform some basic checks automatically" => "This installer will perform some basic checks automatically",
// "Please see: " => "Please see: ",
// "a detailed report about your server" => "a detailed report about your server",
// "Memory" => "Memory",
// "Tiki has not detected your PHP memory_limit" => "Tiki has not detected your PHP memory_limit",
// "This probably means you have no set limit (all is well)" => "This probably means you have no set limit (all is well)",
// "Tiki has detected your PHP memory limit at" => "Tiki has detected your PHP memory limit at",
// "Tiki requires <strong>at least</strong> 128MB of PHP memory for script execution" => "Tiki requires <strong>at least</strong> 128MB of PHP memory for script execution",
// "Allocating too little memory will cause Tiki to display blank pages" => "Allocating too little memory will cause Tiki to display blank pages",
// "To change the memory limit, use the <strong>memory_limit</strong> key in your <strong>php.ini </strong> file (for example: memory_limit = 128M) and restart your webserver" => "To change the memory limit, use the <strong>memory_limit</strong> key in your <strong>php.ini </strong> file (for example: memory_limit = 128M) and restart your webserver",
// "Tiki has detected your PHP memory_limit at" => "Tiki has detected your PHP memory_limit at",
// "Tiki uses the PHP <strong>mail</strong> function to send email notifications and messages" => "Tiki uses the PHP <strong>mail</strong> function to send email notifications and messages",
// "To test your system configuration, Tiki will attempt to send a test message to you" => "To test your system configuration, Tiki will attempt to send a test message to you",
// "Test email" => "Test email",
// "tiki@example.com" => "tiki@example.com",
// "Email address to send test to" => "Email address to send test to",
// "Copy test mail to " => "Copy test mail to ",
// "Send Test Message" => "Send Test Message",
// "Tiki was able to send a test message to" => "Tiki was able to send a test message to",
// "Tiki was not able to send a test message" => "Tiki was not able to send a test message",
// "Review your mail log for details" => "Review your mail log for details",
// "Review the mail settings in your <strong>php.ini</strong> file (for example: confirm that the <strong>sendmail_path</strong> is correct)" => "Review the mail settings in your <strong>php.ini</strong> file (for example: confirm that the <strong>sendmail_path</strong> is correct)",
// "If your host requires SMTP authentication, additional configuration may be necessary" => "If your host requires SMTP authentication, additional configuration may be necessary",
// "Image Processing" => "Image Processing",
// "Tiki detected" => "Tiki detected",
// "Tiki can create images" => "Tiki can create images",
// "Tiki was not able to create a sample image. Please check your GD library configuration" => "Tiki was not able to create a sample image. Please check your GD library configuration",
// "Tiki was not able to detect the GD library" => "Tiki was not able to detect the GD library",
// "Tiki uses the GD library to process images for the Image Gallery and CAPTCHA support" => "Tiki uses the GD library to process images for the Image Gallery and CAPTCHA support",
// "Set the Database Connection" => "Set the Database Connection",
// "Tiki requires an active database connection" => "Tiki requires an active database connection",
// "You must create the database and user <strong>before</strong> completing this page, unless your database user has also permissions to create new databases and not just use them" => "You must create the database and user <strong>before</strong> completing this page, unless your database user has also permissions to create new databases and not just use them",
// "Tiki cannot find a database connection" => "Tiki cannot find a database connection",
// "This is normal for a new installation" => "This is normal for a new installation",
// "Tiki found an existing database connection in your local.php file" => "Tiki found an existing database connection in your local.php file",
// "Database name: %0" => "Database name: %0",
// "Tiki found an automatic database connection for your environment" => "Tiki found an automatic database connection for your environment",
// "Use Existing Connection" => "Use Existing Connection",
// "Modify database connection" => "Modify database connection",
// "Use this page to create a new database connection, or use the <a href=\"https://doc.tiki.org/Manual+Installation\" target=\"_blank\" title=\"manual installation\">manual installation process</a>" => "Use this page to create a new database connection, or use the <a href=\"https://doc.tiki.org/Manual+Installation\" target=\"_blank\" title=\"manual installation\">manual installation process</a>",
// "Database information" => "Database information",
// "Enter your database connection information" => "Enter your database connection information",
// "DBMS driver" => "DBMS driver",
// "Select the database driver to use with Tiki" => "Select the database driver to use with Tiki",
// "Only drivers supported by your PHP installation are listed here. If your driver is not in the list, try to install the appropriate PHP extension" => "Only drivers supported by your PHP installation are listed here. If your driver is not in the list, try to install the appropriate PHP extension",
// "Host name" => "Host name",
// "Enter the host name or IP for your database" => "Enter the host name or IP for your database",
// "Use <strong>localhost</strong> if the database is running on the same machine as Tiki" => "Use <strong>localhost</strong> if the database is running on the same machine as Tiki",
// "For non-default port number use <strong>example.com;port=3307</strong>" => "For non-default port number use <strong>example.com;port=3307</strong>",
// "Database name" => "Database name",
// "Name of the database to be used. This database will be created if it does not exist and permissions allow creation" => "Name of the database to be used. This database will be created if it does not exist and permissions allow creation",
// "You can create the database using Adminer, MySQL Workbench, phpMyAdmin, cPanel, or ask your hosting provider. If the database doesn't exist and the supplied username has permissions, it will be created" => "You can create the database using Adminer, MySQL Workbench, phpMyAdmin, cPanel, or ask your hosting provider. If the database doesn't exist and the supplied username has permissions, it will be created",
// "If you are using a database which is already being used for something else (not recommended), check db/tiki.sql to make sure the table names used by Tiki are not already used" => "If you are using a database which is already being used for something else (not recommended), check db/tiki.sql to make sure the table names used by Tiki are not already used",
// "Database user" => "Database user",
// "Enter a database user with administrator permission for the Tiki database" => "Enter a database user with administrator permission for the Tiki database",
// "User name" => "User name",
// "Database username" => "Database username",
// "Create the above database user just for this Tiki database" => "Create the above database user just for this Tiki database",
// "Administrative database user" => "Administrative database user",
// "Enter database administrator user name and password" => "Enter database administrator user name and password",
// "This is a DB admin user which has permission to create new databases and new users" => "This is a DB admin user which has permission to create new databases and new users",
// "DB admin user name" => "DB admin user name",
// "DB admin password" => "DB admin password",
// "Character set" => "Character set",
// "Highly recommended for new installations. However, if you are upgrading or migrating a previous tiki database, you are recommended to uncheck this box" => "Highly recommended for new installations. However, if you are upgrading or migrating a previous tiki database, you are recommended to uncheck this box",
// "Always force connection to use UTF-8" => "Always force connection to use UTF-8",
// "Install & Upgrade" => "Install & Upgrade",
// "Failed to set max_execution_time for PHP. You may experience problems when creating/upgrading the database using this installer on a slow system. This can manifest itself by a blank page" => "Failed to set max_execution_time for PHP. You may experience problems when creating/upgrading the database using this installer on a slow system. This can manifest itself by a blank page",
// "This install will populate (or upgrade) the database" => "This install will populate (or upgrade) the database",
// "If you want to upgrade from a previous Tiki release, ensure that you have read and understood the <a href=\"https://doc.tiki.org/Upgrade\" target=\"_blank\" class=\"alert-link\">Upgrade instructions</a>" => "If you want to upgrade from a previous Tiki release, ensure that you have read and understood the <a href=\"https://doc.tiki.org/Upgrade\" target=\"_blank\" class=\"alert-link\">Upgrade instructions</a>",
// "A new install will populate the database" => "A new install will populate the database",
// "Encoding Issue" => "Encoding Issue",
// "<p>Your database encoding is <strong>not</strong> in UTF-8mb4.</p><p>Current encoding is <em>%0</em>. The languages that will be available for content on the site will be limited. If you plan on using languages not covered by the character set, you should re-create or alter the database so the default encoding is <em>utf8mb4</em>.</p>" => "<p>Your database encoding is <strong>not</strong> in UTF-8mb4.</p><p>Current encoding is <em>%0</em>. The languages that will be available for content on the site will be limited. If you plan on using languages not covered by the character set, you should re-create or alter the database so the default encoding is <em>utf8mb4</em>.</p>",
// "Character Set Conversion" => "Character Set Conversion",
// "Use at your own risk. If the data in the database currently contains improperly converted data, this may make matters worse. Suitable for new installations. Requires ALTER privilege on the database" => "Use at your own risk. If the data in the database currently contains improperly converted data, this may make matters worse. Suitable for new installations. Requires ALTER privilege on the database",
// "Convert database and tables to UTF-8" => "Convert database and tables to UTF-8",
// "This will destroy your current database: %0" => "This will destroy your current database: %0",
// "Reinstall the database" => "Reinstall the database",
// "Select database engine" => "Select database engine",
// "MyISAM" => "MyISAM",
// "InnoDB" => "InnoDB",
// "Reinstall" => "Reinstall",
// "Upgrade" => "Upgrade",
// "Warning: Category Permissions Will Not Be Upgraded" => "Warning: Category Permissions Will Not Be Upgraded",
// "Category permissions have been revamped since version 3. If you have been using category permissions, note that they may not work properly after upgrading to version 4 onwards, and it will be necessary to reconfigure them" => "Category permissions have been revamped since version 3. If you have been using category permissions, note that they may not work properly after upgrading to version 4 onwards, and it will be necessary to reconfigure them",
// "Automatically upgrade your existing database to version" => "Automatically upgrade your existing database to version",
// "This site has an admin account configured" => "This site has an admin account configured",
// "Please log in with your admin password to continue" => "Please log in with your admin password to continue",
// "Review the Upgrade" => "Review the Upgrade",
// "Review the Installation" => "Review the Installation",
// "Upgrade complete" => "Upgrade complete",
// "Installation complete" => "Installation complete",
// "Your database has been configured and Tiki is ready to run" => "Your database has been configured and Tiki is ready to run",
// "If this is your first install, your admin password is <strong>admin</strong>" => "If this is your first install, your admin password is <strong>admin</strong>",
// "You can now log in into Tiki as user <strong>admin</strong> and start configuring the application" => "You can now log in into Tiki as user <strong>admin</strong> and start configuring the application",
// "Upgrade operations executed successfully" => "Upgrade operations executed successfully",
// "Installation operations executed successfully" => "Installation operations executed successfully",
// "SQL queries" => "SQL queries",
// "Database was left unchanged" => "Database was left unchanged",
// "Operations failed" => "Operations failed",
// "Display details" => "Display details",
// "During an upgrade, it is normal to have SQL failures resulting with <strong>Table already exists</strong> messages" => "During an upgrade, it is normal to have SQL failures resulting with <strong>Table already exists</strong> messages",
// "Check all errors" => "Check all errors",
"Configure General Settings" => "一般設定",
// "Complete these fields to configure common, general settings for your site" => "Complete these fields to configure common, general settings for your site",
// "The information you enter here can be changed later" => "The information you enter here can be changed later",
// "Refer to the <a href=\"https://doc.tiki.org/Admin+home\" target=\"_blank\" class=\"alert-link\">documentation</a> for complete information on these, and other, settings" => "Refer to the <a href=\"https://doc.tiki.org/Admin+home\" target=\"_blank\" class=\"alert-link\">documentation</a> for complete information on these, and other, settings",
// "My Tiki" => "My Tiki",
// "This will appear in the browser title bar" => "This will appear in the browser title bar",
// "Email sent by your site will use this address" => "Email sent by your site will use this address",
// "Network Proxy" => "Network Proxy",
// "Toggle section display" => "Toggle section display",
// "Secure Log in" => "Secure Log in",
// "It is recommended to choose the \"Require secure (HTTPS) login\" option for better security. A security certificate and dedicated IP address are required to implement a secure login" => "It is recommended to choose the \"Require secure (HTTPS) login\" option for better security. A security certificate and dedicated IP address are required to implement a secure login",
// "HTTPS login" => "HTTPS login",
// "PHP error reporting level" => "PHP error reporting level",
// "Report all errors except notices" => "Report all errors except notices",
// "Visible to Admin only" => "Visible to Admin only",
// "Admin email" => "Admin email",
// "admin@example.com" => "admin@example.com",
// "This is the email address for your administrator account" => "This is the email address for your administrator account",
// "Set up htaccess file" => "Set up htaccess file",
"Method" => "方法",
// "Select how to set up your htaccess file" => "Select how to set up your htaccess file",
// "Upgrade fix" => "Upgrade fix",
// "Experiencing problems with the upgrade? Your administrator account lost its privileges? This may occur if you upgraded from a very old version of Tiki.</p>\n                                    <p>We can fix it! Doing so will" => "Experiencing problems with the upgrade? Your administrator account lost its privileges? This may occur if you upgraded from a very old version of Tiki.</p>\n                                    <p>We can fix it! Doing so will",
// "Create the <em>Admins</em> group, if missing" => "Create the <em>Admins</em> group, if missing",
// "Grant <em>tiki_p_admin</em> to the group, if missing" => "Grant <em>tiki_p_admin</em> to the group, if missing",
// "Add the administrator account to the group, if missing" => "Add the administrator account to the group, if missing",
// "To do so enter the name of the main admin account in the field below" => "To do so enter the name of the main admin account in the field below",
// "Administrator account (optional):</label><div class=\"col-sm-4\"> <input type=\"text\" name=\"admin_account\" class=\"form-control\"></div><div class=\"col-sm-4\"><em>The default account is <strong>admin</strong></em>" => "Administrator account (optional):</label><div class=\"col-sm-4\"> <input type=\"text\" name=\"admin_account\" class=\"form-control\"></div><div class=\"col-sm-4\"><em>The default account is <strong>admin</strong></em>",
// "Check this box if you have a lot of disabled accounts after an upgrade to tiki4" => "Check this box if you have a lot of disabled accounts after an upgrade to tiki4",
// "List of accounts that will be enabled" => "List of accounts that will be enabled",
// "Last Notes" => "Last Notes",
// "Read the following information to ensure that your website data stays protected, your site healthy and you don't unnecessarily loose time or data while setting up your Tiki site now or while maintaining it in the future" => "Read the following information to ensure that your website data stays protected, your site healthy and you don't unnecessarily loose time or data while setting up your Tiki site now or while maintaining it in the future",
// "Subscribe to Tiki Releases newsletter" => "Subscribe to Tiki Releases newsletter",
// "Critical & Security update" => "Critical & Security update",
// "It is highly recommended that you subscribe to the Tiki Releases newsletter, so that you receive important notices about new releases and critical security updates" => "It is highly recommended that you subscribe to the Tiki Releases newsletter, so that you receive important notices about new releases and critical security updates",
// "We don't share subscribed emails and we send very few of these newsletters per year" => "We don't share subscribed emails and we send very few of these newsletters per year",
// "Please use the following link and subscribe" => "Please use the following link and subscribe",
// "Tiki Releases newsletter" => "Tiki Releases newsletter",
// "First Wizards, then Control Panels with Preference Filter" => "First Wizards, then Control Panels with Preference Filter",
// "Tiki contains thousands of options and parameters (what we call \"preferences\"), which can be overwhelming for a new site administrator" => "Tiki contains thousands of options and parameters (what we call \"preferences\"), which can be overwhelming for a new site administrator",
// "That's why we suggest you to start by using our <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Wizards'>Wizards</a> ({icon name='magic'})" => "That's why we suggest you to start by using our <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Wizards'>Wizards</a> ({icon name='magic'})",
// "Once basic parameters will be set, you will always be able to gain full control of the options using the Control Panels. Note: basic preferences will be displayed by default after a new install" => "Once basic parameters will be set, you will always be able to gain full control of the options using the Control Panels. Note: basic preferences will be displayed by default after a new install",
// "You can modify the default filter choice at your own convenience to also display Advanced, Experimental or Unavailable preferences in Control Panels" => "You can modify the default filter choice at your own convenience to also display Advanced, Experimental or Unavailable preferences in Control Panels",
// "You'll find the <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Preference+Filters'>Preference Filter</a> at the top of the Navigation Bar in the <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Control+Panels'>Control Panels</a> by clicking on the funnel icon ({icon name='filter'}) or use the search box provided" => "You'll find the <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Preference+Filters'>Preference Filter</a> at the top of the Navigation Bar in the <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Control+Panels'>Control Panels</a> by clicking on the funnel icon ({icon name='filter'}) or use the search box provided",
// "Storing your uploaded files" => "Storing your uploaded files",
// "To ease the install process and first access, Tiki saves your uploaded files (office documents, images, pdf, etc. attached to wiki pages, forum posts, tracker items, file galleries, ...) by default in its database" => "To ease the install process and first access, Tiki saves your uploaded files (office documents, images, pdf, etc. attached to wiki pages, forum posts, tracker items, file galleries, ...) by default in its database",
// "This works perfectly in most cases but it is not the recommended setup if you need to save many thousands of files or more" => "This works perfectly in most cases but it is not the recommended setup if you need to save many thousands of files or more",
// "In that case, consider switching from \"<strong>Store to database</strong>\" to \"<strong>Store to directory</strong>\", which you will find in the <em>Configuration Wizard - Set up File Gallery & Attachments</em> or in the <em>Control Panels - File Galleries</em> where you will be able to migrate your currently uploaded files from one to the other" => "In that case, consider switching from \"<strong>Store to database</strong>\" to \"<strong>Store to directory</strong>\", which you will find in the <em>Configuration Wizard - Set up File Gallery & Attachments</em> or in the <em>Control Panels - File Galleries</em> where you will be able to migrate your currently uploaded files from one to the other",
// "Tiki Community" => "Tiki Community",
// "The Tiki Community is a global network of developers, site operators, <a href='https://tiki.org/Consultants' target='_blank'>consultants</a> and end users" => "The Tiki Community is a global network of developers, site operators, <a href='https://tiki.org/Consultants' target='_blank'>consultants</a> and end users",
// "Get Help with Tiki" => "Get Help with Tiki",
// "Hire a Tiki Service Provider" => "Hire a Tiki Service Provider",
// "Help to improve the <a href='https://dev.tiki.org/' target='_blank'>Code</a> and the <a href='https://doc.tiki.org/' target='_blank'>Documentation</a>" => "Help to improve the <a href='https://dev.tiki.org/' target='_blank'>Code</a> and the <a href='https://doc.tiki.org/' target='_blank'>Documentation</a>",
// "Enter Your Tiki" => "Enter Your Tiki",
// "Ready to run" => "Ready to run",
// "The installation is complete" => "The installation is complete",
// ".htaccess File" => ".htaccess File",
// "We recommend enabling the <strong>.htaccess</strong> file for your Tiki" => "We recommend enabling the <strong>.htaccess</strong> file for your Tiki",
// "This will enable you to use SEFURLs (search engine friendly URLs) and help improve site security" => "This will enable you to use SEFURLs (search engine friendly URLs) and help improve site security",
// "Your .htaccess file has been set up (%0)" => "Your .htaccess file has been set up (%0)",
// "If this is an upgrade, clean the Tiki caches manually (the <strong>temp/templates_c</strong> directory) or by using the <strong>Admin &gt; System</strong> option from the Admin menu" => "If this is an upgrade, clean the Tiki caches manually (the <strong>temp/templates_c</strong> directory) or by using the <strong>Admin &gt; System</strong> option from the Admin menu",
// "Enter Tiki and Lock Installer" => "Enter Tiki and Lock Installer",
// "Recommended" => "Recommended",
// "Enter Tiki Without Locking Installer" => "Enter Tiki Without Locking Installer",
// "Not recommended due to security risk" => "Not recommended due to security risk",
// "You can now access the site normally. Report back any issues that you might find (if any) to the Tiki forums or bug tracker" => "You can now access the site normally. Report back any issues that you might find (if any) to the Tiki forums or bug tracker",
// "Are you sure you want to attempt to fix the encoding of your entire database" => "Are you sure you want to attempt to fix the encoding of your entire database",
// "Upgrading and running into encoding issues" => "Upgrading and running into encoding issues",
// "We can try to fix it, but <strong>make sure you have backups, and can restore them</strong>" => "We can try to fix it, but <strong>make sure you have backups, and can restore them</strong>",
// "Previous table encoding" => "Previous table encoding",
// "Please select" => "Please select",
// "Click to fix double encoding (dangerous)" => "Click to fix double encoding (dangerous)",
// "Oops. You need to make sure client charset is forced to UTF-8. Reset the database connection to continue" => "Oops. You need to make sure client charset is forced to UTF-8. Reset the database connection to continue",
// "MultiTiki Setup" => "MultiTiki Setup",
// "Default Installation" => "Default Installation",
// "DB OK" => "DB OK",
// "No DB" => "No DB",
// "Adding a new host" => "Adding a new host",
// "To add a new virtual host run the setup.sh with the domain name of the new host as a last parameter" => "To add a new virtual host run the setup.sh with the domain name of the new host as a last parameter",
// "MultiTiki" => "MultiTiki",
// "Are you upgrading an existing Tiki site" => "Are you upgrading an existing Tiki site",
// "Go directly to the <strong>Install/Upgrade</strong> step" => "Go directly to the <strong>Install/Upgrade</strong> step",
// "Install/Upgrade" => "Install/Upgrade",
// "Powered by" => "Powered by",
// "Powered by Tiki Wiki CMS Groupware" => "Powered by Tiki Wiki CMS Groupware",
// "Clear cached version and refresh cache" => "Clear cached version and refresh cache",
// "configure rules" => "configure rules",
// "Invitation" => "Invitation",
// "Invitations list" => "Invitations list",
// "The mail has been sent to: " => "The mail has been sent to: ",
// "You are about to send an invitation to theses people, please confirm" => "You are about to send an invitation to theses people, please confirm",
// "Fill this box with the list of emails you want to invite " => "Fill this box with the list of emails you want to invite ",
// "Format of the list above " => "Format of the list above ",
// "CSV Style: One line per invitation, with the format: lastname,firstname,email" => "CSV Style: One line per invitation, with the format: lastname,firstname,email",
// "Everything that appear as an email in the text will be detected and used (in that case, {literal}{firstname} and {lastname}{/literal} will be ignored in the email content)" => "Everything that appear as an email in the text will be detected and used (in that case, {literal}{firstname} and {lastname}{/literal} will be ignored in the email content)",
// "Type here the email subject you'll want to be sent to them " => "Type here the email subject you'll want to be sent to them ",
// "Type here the email content you'll want to be sent to them (and let the {literal}{link}{/literal} word, it will be replaced with the good link for registering) " => "Type here the email content you'll want to be sent to them (and let the {literal}{link}{/literal} word, it will be replaced with the good link for registering) ",
// "Type here the content that the user will see when he'll click on the link from the mail " => "Type here the content that the user will see when he'll click on the link from the mail ",
// "Choose one or more groups that you want these subscriptions to be in. Don't choose any if you don't want anything special " => "Choose one or more groups that you want these subscriptions to be in. Don't choose any if you don't want anything special ",
// "Invoices" => "Invoices",
// "New Invoice" => "New Invoice",
// "Clients" => "Clients",
// "New Client" => "New Client",
// "Invoice Reports" => "Invoice Reports",
// "Add more media" => "Add more media",
// "Change Details" => "Change Details",
// "Video Title" => "Video Title",
// "Editor" => "Editor",
// "Embed code" => "Embed code",
// "Plays" => "Plays",
// "No action specified" => "No action specified",
// "This file is not expected to be called directly" => "This file is not expected to be called directly",
"Last Changes" => "最新變動",
// "Last 2 days" => "Last 2 days",
// "Last 3 days" => "Last 3 days",
// "Last 5 days" => "Last 5 days",
// "Last week" => "Last week",
// "Last 2 weeks" => "Last 2 weeks",
// "Last month" => "Last month",
"Search by Date" => "以日期搜尋",
"Found" => "找到",
"LastChanges" => "最近變動",
"Ip" => "Ip",
// "{\$lastchanges[changes].action|escape}" => "{\$lastchanges[changes].action|escape}",
// "v" => "v",
"Diff" => "比對差異",
"Pages like" => "相似頁面",
// "New Article" => "New Article",
// "New Submission" => "New Submission",
"View Submissions" => "檢視意見",
// "Expiry Date" => "Expiry Date",
// "{\$listpages[changes].type|escape}" => "{\$listpages[changes].type|escape}",
// "{\$listpages[changes].disp_article}" => "{\$listpages[changes].disp_article}",
// "{\$listpages[changes].lang}" => "{\$listpages[changes].lang}",
// "{\$listpages[changes].hasImage}" => "{\$listpages[changes].hasImage}",
// "{\$listpages[changes].useImage}" => "{\$listpages[changes].useImage}",
// "Select Duplicates" => "Select Duplicates",
// "To use a banner in a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{banner zone=ABC}{/literal}, where ABC is the name of the zone" => "To use a banner in a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{banner zone=ABC}{/literal}, where ABC is the name of the zone",
"Create banner" => "建立大標題",
"Use Dates?" => "使用日期?",
"Max Impressions" => "最大次數",
"Impressions" => "次數",
// "Max Clicks" => "Max Clicks",
"Clicks" => "點擊",
// "List Posts" => "List Posts",
// "The cache is used by" => "The cache is used by",
// "{\$headerName}" => "{\$headerName}",
// "Approval" => "Approval",
// "Delete comment" => "Delete comment",
// "(no title)" => "(no title)",
// "{\$val|ucwords}" => "{\$val|ucwords}",
// "Approved" => "Approved",
// "More Information" => "More Information",
// "Delete selected comments" => "Delete selected comments",
// "Delete and ban selected comments" => "Delete and ban selected comments",
// "Delete and ban" => "Delete and ban",
"Dynamic Content System" => "動態內容系統",
// "To use content blocks in a text area (Wiki page, etc), a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{content id=x}{/literal}, where x is the ID of the content block" => "To use content blocks in a text area (Wiki page, etc), a <a class=\"alert-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{content id=x}{/literal}, where x is the ID of the content block",
// "You can also use {literal}{content label=x}{/literal}, where x is the label of the content block" => "You can also use {literal}{content label=x}{/literal}, where x is the label of the content block",
"Available content blocks" => "現有的內容區塊",
// "Current Value" => "Current Value",
"Current ver" => "目前版本",
"Next ver" => "下一個版本",
// "Future vers" => "Future vers",
"Program" => "方案",
// "Create/Edit content block" => "Create/Edit content block",
// "Edit content block" => "Edit content block",
// "Create content block" => "Create content block",
"Available FAQs" => "現有的 FAQs",
// "Questions / Suggested" => "Questions / Suggested",
"Edit/Create" => "編輯/產生",
"Edit this FAQ:" => "編輯此 FAQ:",
// "Create new FAQ" => "Create new FAQ",
"Create New FAQ:" => "建立新 FAQ:",
"Users can suggest questions" => "允許使用者建議問題",
"Create a File Gallery" => "建立檔案庫",
// "{\$name}" => "{\$name}",
// "Finder" => "Finder",
"RSS feed" => "RSS feed",
// "Hide file information from list view" => "Hide file information from list view",
// "Hide list view information" => "Hide list view information",
// "Show file information from list view" => "Show file information from list view",
// "Show list view information" => "Show list view information",
// "Create Diagram" => "Create Diagram",
// "Batch" => "Batch",
// "SlideShow" => "SlideShow",
// "Create H5P" => "Create H5P",
// "Be careful to set the right permissions on the files you link to" => "Be careful to set the right permissions on the files you link to",
// "Keep gallery window open" => "Keep gallery window open",
// "optional" => "optional",
// "Modifications" => "Modifications",
// "Property <b>{\$fgp_name}</b> Changed" => "Property <b>{\$fgp_name}</b> Changed",
// "Search for text within files in all galleries" => "Search for text within files in all galleries",
// "Search by identifier" => "Search by identifier",
// "Search for the file with this number, in all galleries" => "Search for the file with this number, in all galleries",
// "Maximum width" => "Maximum width",
"You can access the file gallery using the following URL" => "你可以由下列URL進入這個檔案庫",
"Gallery Images" => "圖庫影像",
// "Inviter" => "Inviter",
// "Only successful invitations" => "Only successful invitations",
// "Only pending invitations" => "Only pending invitations",
// "Number of invitations" => "Number of invitations",
// "Invoice Clients" => "Invoice Clients",
// "Tax Status" => "Tax Status",
// "New Contact" => "New Contact",
// "Client Name" => "Client Name",
// "Remix Entries" => "Remix Entries",
// "Browse Media" => "Browse Media",
// "Browse Remixes" => "Browse Remixes",
// "Please select some media entries to use" => "Please select some media entries to use",
// "Media Id" => "Media Id",
// "Wiki plugin code" => "Wiki plugin code",
// "No entries" => "No entries",
// "No media entries found" => "No media entries found",
// "to upload" => "to upload",
// "Modified By" => "Modified By",
// "No mix entries found" => "No mix entries found",
// "Object Permissions List" => "Object Permissions List",
// "Object Permissions" => "Object Permissions",
// "Object permissions" => "Object permissions",
// "Category permissions" => "Category permissions",
// "Perform action with selected permissions" => "Perform action with selected permissions",
// "Assign to this group" => "Assign to this group",
// "Only default global permissions are being used" => "Only default global permissions are being used",
"Reason" => "原因",
// "No object permissions apply" => "No object permissions apply",
// "{\$special.reason|escape}" => "{\$special.reason|escape}",
// "No category permissions apply" => "No category permissions apply",
// "Blog: %0" => "Blog: %0",
// "New Blog Post" => "New Blog Post",
// "Post Title" => "Post Title",
"Blog Title" => "Blog 標題",
// "(bytes)" => "(bytes)",
// "Delete Expired Submissions" => "Delete Expired Submissions",
// "Deletes expired submissions 1000 at a time to avoid timeouts" => "Deletes expired submissions 1000 at a time to avoid timeouts",
"Survey stats" => "調查結果",
// "Take survey" => "Take survey",
// "Import Structure" => "Import Structure",
// "Import From Profile/YAML" => "Import From Profile/YAML",
// "Manage Tabular Formats" => "Manage Tabular Formats",
// "Clone remote" => "Clone remote",
"Items" => "項目",
// "{\$tracker.name|escape}" => "{\$tracker.name|escape}",
// "Do you really remove this tracker" => "Do you really remove this tracker",
// "Do you really want to clear all the items from this tracker? (N.B. there is no undo and notifications will not be sent)" => "Do you really want to clear all the items from this tracker? (N.B. there is no undo and notifications will not be sent)",
// "users registered" => "users registered",
"like" => "如同",
// "Distance (km)" => "Distance (km)",
// "{\$listuserscountry[changes]}" => "{\$listuserscountry[changes]}",
// "List Wiki Pages" => "List Wiki Pages",
// "Page aliases found" => "Page aliases found",
// "Create a Wiki Page" => "Create a Wiki Page",
// "Insert name of the page you wish to create" => "Insert name of the page you wish to create",
// "Create page within %0" => "Create page within %0",
// "Page creator" => "Page creator",
"Last author" => "最近作者",
"Last version" => "最近版本",
// "Status of the page" => "Status of the page",
// "Links to other items in page" => "Links to other items in page",
// "Links to this page in other pages" => "Links to this page in other pages",
// "Backl" => "Backl",
// "Page size" => "Page size",
"Lang" => "語系",
// "No page" => "No page",
// "No pages found with" => "No pages found with",
// "Download PDF" => "Download PDF",
// "Download zipped file" => "Download zipped file",
// "Add page name as page header" => "Add page name as page header",
"Open client window" => "開啟客戶端視窗",
"Generate HTML" => "產生 HTML",
"Transcripts" => "紀錄",
"Online operators" => "線上服務員",
"Accepted requests" => "已接受要求",
// "{\$online_operators[ix].status}" => "{\$online_operators[ix].status}",
"transcripts" => "紀錄",
// "offline" => "offline",
"Offline operators" => "離線服務員",
// "{\$offline_operators[ix].status}" => "{\$offline_operators[ix].status}",
"Add an operator to the system" => "增加系統服務員",
"Operators must be tiki users" => "服務員必須是 tiki 使用者",
"Set as Operator" => "設為服務員",
"Chat started" => "對談已開始",
"Operator:" => "服務員:",
"Live support:User window" => "線上支援:使用者視窗",
"Request live support" => "要求線上支援",
"Request support" => "要求支援",
"Your request is being processed" => "你的要求正在處理",
"cancel request and exit" => "取消要求並離開",
"cancel request and leave a message" => "取消要求並留言",
"Live support:Console" => "線上支援:操作臺",
// "{\$status}" => "{\$status}",
"be online" => "正在線上",
"be offline" => "正離線中",
// "You are not an operator" => "You are not an operator",
"Support requests" => "支援要求",
"Requested" => "已要求",
"Accept" => "接受",
"Join" => "加入",
// "No support requests" => "No support requests",
"Support chat transcripts" => "支援交談紀錄",
// "Back to admin" => "Back to admin",
// "operator" => "operator",
"started" => "已開始",
"reason" => "原因",
"msgs" => "訊息",
"Transcript" => "紀錄",
// "For security purposes we must periodically validate your email address to allow continued access to this site" => "For security purposes we must periodically validate your email address to allow continued access to this site",
// "A validation email has been sent to you. Please open that email and follow the instructions to once again gain access to the site" => "A validation email has been sent to you. Please open that email and follow the instructions to once again gain access to the site",
// "Thank you" => "Thank you",
// "Mail-in feature" => "Mail-in feature",
// "Click here to go to mailin admin" => "Click here to go to mailin admin",
// "Missing dependency. Obtain <a href=\"http://tiki.org/tiki-download_file.php?fileId=50\">visorFreemind.swf</a> and upload it in files/" => "Missing dependency. Obtain <a href=\"http://tiki.org/tiki-download_file.php?fileId=50\">visorFreemind.swf</a> and upload it in files/",
"Mini Calendar" => "迷你月曆",
"Prefs" => "個人偏好",
"Daily" => "每日",
"Weekly" => "每週",
"Remove old events" => "移除舊事件",
"h" => "h",
"mins" => "分",
// "Edit Event" => "Edit Event",
"Mini Calendar: Preferences" => "迷你月曆: 個人偏好",
"Calendar Interval in daily view" => "每日檢視中的行事曆週期",
"Start hour for days" => "每天開始時間",
"End hour for days" => "每天結束時間",
"Reminders" => "提醒",
"no reminders" => "沒有提醒",
"min" => "分",
"Or enter path or URL" => "或 輸入路徑 或 URL",
"Add Topic" => "增加主題",
// "Tiki Mods" => "Tiki Mods",
// "Tiki \"Mods\" are obsolete as of Tiki 19" => "Tiki \"Mods\" are obsolete as of Tiki 19",
// "Tiki now uses \"Packages\" instead" => "Tiki now uses \"Packages\" instead",
// "Please visit <a href=\"https://doc.tiki.org/Packages\" class=\"alert-link\" target=\"_blank\">https://doc.tiki.org/Packages</a> to find out more.</em>" => "Please visit <a href=\"https://doc.tiki.org/Packages\" class=\"alert-link\" target=\"_blank\">https://doc.tiki.org/Packages</a> to find out more.</em>",
// "y" => "y",
"User Galleries" => "使用者列表",
// "My Articles" => "My Articles",
// "User Articles" => "User Articles",
// "My User Items" => "My User Items",
// "User Items" => "User Items",
"Unread Messages" => "未讀訊息",
// "User forum topics" => "User forum topics",
// "Forum topic" => "Forum topic",
// "Date of post" => "Date of post",
// "User forum replies" => "User forum replies",
"User Blogs" => "使用者 Blogs",
// "My blog Posts" => "My blog Posts",
// "User Blog Posts" => "User Blog Posts",
// "To display the objects you created or contributed to" => "To display the objects you created or contributed to",
// "My Items" => "My Items",
// "My Info" => "My Info",
"My Watches" => "我的監視",
// "Contacts Preferences" => "Contacts Preferences",
"Notepad" => "筆記本",
"MyFiles" => "我的檔案",
"Sent editions" => "送出版本",
"Admin Newsletters" => "管理電子報",
// "HTML version" => "HTML version",
// "Text version" => "Text version",
"The newsletter was sent to {\$sent} email addresses" => "電子報已發送至 {\$sent} email 地址",
// "Delete errors" => "Delete errors",
// "Not sent" => "Not sent",
"Subscribe to Newsletter" => "訂閱電子報",
"Subscribe to this Newsletter" => "訂閱",
// "Available Newsletters" => "Available Newsletters",
"Write a note" => "寫個備忘錄",
"quota" => "配額",
"No notes yet" => "尚無記事",
"Merge selected notes into" => "合併選擇的記事至",
"Reading note:" => "閱讀備忘錄:",
"List notes" => "列出備忘錄",
"Write note" => "寫備忘錄",
"Wiki Create" => "wiki 建立",
"Wiki Overwrite" => "wiki 覆寫",
// "Object Watches" => "Object Watches",
// "Groups watching" => "Groups watching",
// "Changes to groups watching" => "Changes to groups watching",
// "These changes to group watches" => "These changes to group watches",
// "were made to these descendants" => "were made to these descendants",
// "This Category" => "This Category",
// "All Descendants" => "All Descendants",
// "Assign global permissions" => "Assign global permissions",
"Assign permissions to " => "指定權限給",
// "Edit Permissions" => "Edit Permissions",
// "Currently editing Global permissions" => "Currently editing Global permissions",
// "This object's direct permissions override any global permissions or category permissions affecting this object" => "This object's direct permissions override any global permissions or category permissions affecting this object",
// "This category's direct permissions override any global permissions affecting objects in it" => "This category's direct permissions override any global permissions affecting objects in it",
// "To edit global permissions" => "To edit global permissions",
// "No permissions yet applied to this object but category permissions affect this object and are displayed below" => "No permissions yet applied to this object but category permissions affect this object and are displayed below",
// "To edit category permissions" => "To edit category permissions",
// "No permissions yet applied to this object but parent object's permissions affect this object and are displayed below" => "No permissions yet applied to this object but parent object's permissions affect this object and are displayed below",
// "To edit parent object's permissions" => "To edit parent object's permissions",
// "No direct permissions yet applied to this object. Global permissions apply" => "No direct permissions yet applied to this object. Global permissions apply",
// "Currently inherited permissions displayed" => "Currently inherited permissions displayed",
// "Show permissions for disabled features" => "Show permissions for disabled features",
// "Assign permissions to this category" => "Assign permissions to this category",
"Assign permissions to this object" => "指定此物件的權限",
// "Delete category permissions" => "Delete category permissions",
// "Delete object permissions" => "Delete object permissions",
// "Reset Perms" => "Reset Perms",
// "This will remove all the settings here and permissions will be reset to inherit any category permissions that are set, or the global sitewide permissions" => "This will remove all the settings here and permissions will be reset to inherit any category permissions that are set, or the global sitewide permissions",
// "This will remove all the settings here and permissions will be reset to inherit the global sitewide permissions" => "This will remove all the settings here and permissions will be reset to inherit the global sitewide permissions",
// "Permissions Clipboard" => "Permissions Clipboard",
// "Copy the permissions set here" => "Copy the permissions set here",
// "Paste" => "Paste",
// "Paste copied permissions from " => "Paste copied permissions from ",
// "Assign or remove permissions on <em>all</em> child categories" => "Assign or remove permissions on <em>all</em> child categories",
// "Are you sure you want to affect all child categories?\\nThere is no undo" => "Are you sure you want to affect all child categories?\\nThere is no undo",
// "Assign or remove permissions on all pages of the sub-structure" => "Assign or remove permissions on all pages of the sub-structure",
// "Are you sure you want to affect all pages in this sub-structure?\\nThere is no undo" => "Are you sure you want to affect all pages in this sub-structure?\\nThere is no undo",
// "You must select at least one feature" => "You must select at least one feature",
// "View Differences" => "View Differences",
// "Permissions added" => "Permissions added",
// "Permissions removed" => "Permissions removed",
// "Select groups" => "Select groups",
// "Some of your groups have been automatically hidden.<br> Select the groups below to assign permissions for" => "Some of your groups have been automatically hidden.<br> Select the groups below to assign permissions for",
// "These groups are not the groups that have permissions on the object. It is only the groups you can see in the columns of the first tab" => "These groups are not the groups that have permissions on the object. It is only the groups you can see in the columns of the first tab",
// "Select only groups that have a perm with the object" => "Select only groups that have a perm with the object",
// "Group name" => "Group name",
// "Select features" => "Select features",
// "Some of your features have been automatically hidden.<br> Select the features below to assign permissions for" => "Some of your features have been automatically hidden.<br> Select the features below to assign permissions for",
// "Feature name" => "Feature name",
// "Quick Permissions" => "Quick Permissions",
// "Assign Quick-Permissions to this object" => "Assign Quick-Permissions to this object",
// "Individual permissions are currently assigned (See tab Assign Permissions)" => "Individual permissions are currently assigned (See tab Assign Permissions)",
// "<em>Quick permissions</em> should be considered as an experimental feature" => "<em>Quick permissions</em> should be considered as an experimental feature",
// "Although permissions will be set as expected using this form, it doesn't necessarily show the current permissions reliably" => "Although permissions will be set as expected using this form, it doesn't necessarily show the current permissions reliably",
// "There is also no undo - <strong>Use with care!</strong>" => "There is also no undo - <strong>Use with care!</strong>",
// "Your OpenID identity is valid" => "Your OpenID identity is valid",
// "Your identity gives you access to multiple user accounts" => "Your identity gives you access to multiple user accounts",
// "Select account" => "Select account",
"Orphan Pages" => "孤兒頁面",
"Browser not supported" => "瀏覽器不支援",
// "Contributions by author" => "Contributions by author",
"Similar" => "相似",
// "Make Structure" => "Make Structure",
"Discuss" => "討論",
// "Bookmark" => "Bookmark",
// "View latest version before editing" => "View latest version before editing",
// "Contributions to" => "Contributions to",
// "current version" => "current version",
// "Words" => "Words",
// "Whitespaces" => "Whitespaces",
// "Characters" => "Characters",
// "Printable characters" => "Printable characters",
// "Page changes" => "Page changes",
// "Original wiki text" => "Original wiki text",
// "Parsed Text (HTML)" => "Parsed Text (HTML)",
// "Output text only (No HTML tags)" => "Output text only (No HTML tags)",
// "Show statistics" => "Show statistics",
// "Visualize page changes" => "Visualize page changes",
// "Show popups" => "Show popups",
// "Escape HTML / Wiki syntax in page changes" => "Escape HTML / Wiki syntax in page changes",
// "Show contributions" => "Show contributions",
// "Collapse Into Edit Sessions" => "Collapse Into Edit Sessions",
// "Show All Versions" => "Show All Versions",
// "Preview of version" => "Preview of version",
// "(current)" => "(current)",
// "Roll back to this version" => "Roll back to this version",
// "Content Approval" => "Content Approval",
// "This revision is currently marked as approved" => "This revision is currently marked as approved",
// "Remove Approval" => "Remove Approval",
// "This revision has not been approved" => "This revision has not been approved",
// "Approve Revision" => "Approve Revision",
// "History view" => "History view",
// "This revision may not be the latest approved revision" => "This revision may not be the latest approved revision",
// "This revision has been rejected" => "This revision has been rejected",
// "Source of version" => "Source of version",
// "Update Translation" => "Update Translation",
// "Hide translation history" => "Hide translation history",
// "Show translation history" => "Show translation history",
// "Enable pagination" => "Enable pagination",
// "rows per page" => "rows per page",
// "HTML allowed" => "HTML allowed",
// "HTML syntax is allowed either by page setting or use of the WYSIWIG editor" => "HTML syntax is allowed either by page setting or use of the WYSIWIG editor",
// "from %0" => "from %0",
// "approved" => "approved",
// "Updated from" => "Updated from",
// "Used to update" => "Used to update",
// "rejected" => "rejected",
// "Difference" => "Difference",
// "Older Version" => "Older Version",
// "Israel Post" => "Israel Post",
// "Order ID" => "Order ID",
// "Payment authorized (not captured)" => "Payment authorized (not captured)",
// "Payment authorized (captured)" => "Payment authorized (captured)",
// "Unknown state" => "Unknown state",
// "Date Paid" => "Date Paid",
// "Payer" => "Payer",
// "Payer email from %0" => "Payer email from %0",
// "View payment info" => "View payment info",
// "Cancel this payment request" => "Cancel this payment request",
// "View payment request" => "View payment request",
// "Paypal" => "Paypal",
// "Transaction ID" => "Transaction ID",
// "Payment made by <em>%0, %1</em> (%2)" => "Payment made by <em>%0, %1</em> (%2)",
// "Payment Request" => "Payment Request",
// "{\$wp_member_title}" => "{\$wp_member_title}",
// "For each user: " => "For each user: ",
// "per full period" => "per full period",
// "applicable prorated pricing provided" => "applicable prorated pricing provided",
// "free periods provided" => "free periods provided",
// "full free" => "full free",
// "prorated free" => "prorated free",
// "Payment Status" => "Payment Status",
// "{\$payment_info.state|capitalize|escape}" => "{\$payment_info.state|capitalize|escape}",
// "Capture Payment" => "Capture Payment",
// "Paid amount" => "Paid amount",
// "Initial amount" => "Initial amount",
// "Amount remaining" => "Amount remaining",
// "Payment request initiated" => "Payment request initiated",
// "Payment request due" => "Payment request due",
// "Pay with PayPal" => "Pay with PayPal",
// "Pay with Paypal" => "Pay with Paypal",
// "Proceed to Israel Post" => "Proceed to Israel Post",
// "Pay With Cclite" => "Pay With Cclite",
// "Refresh page" => "Refresh page",
// "Payment info" => "Payment info",
// "Trade with Cclite" => "Trade with Cclite",
// "Payment problem" => "Payment problem",
// "Pay With Tiki Credits" => "Pay With Tiki Credits",
// "Pay with Tiki User Credits" => "Pay with Tiki User Credits",
// "Credit type" => "Credit type",
// "Credits left" => "Credits left",
// "Amount to pay" => "Amount to pay",
// "Pay using" => "Pay using",
// "Payment Details" => "Payment Details",
// "Enter a Manual Payment" => "Enter a Manual Payment",
// "Enter payment" => "Enter payment",
// "using" => "using",
// "Payment information" => "Payment information",
// "No outstanding payments found" => "No outstanding payments found",
// "No paid payments found" => "No paid payments found",
// "<em>No cancelled payments found</em>" => "<em>No cancelled payments found</em>",
// "Request" => "Request",
// "Payable within" => "Payable within",
"Pick your profile picture" => "選擇你的頭像",
"Your current profile picture" => "你目前的頭像",
// "Full size" => "Full size",
// "no profile picture" => "no profile picture",
// "Pick user profile picture from the library" => "Pick user profile picture from the library",
"Pick user profile picture" => "選擇使用者的頭像",
"Hide all" => "隱藏全部",
// "icons" => "icons",
"Show all" => "顯示全部",
"random" => "隨機",
"Upload your own profile picture" => "上傳你自己的頭像",
// "Select your profile picture" => "Select your profile picture",
// "File (only .gif, .jpg and .png images approximately 45px × 45px)" => "File (only .gif, .jpg and .png images approximately 45px × 45px)",
// "File (only .gif, .jpg and .png images)" => "File (only .gif, .jpg and .png images)",
// "Plugin execution was denied" => "Plugin execution was denied",
// "After argument validation by an editor, the execution of this plugin was denied. This plugin will eventually be removed or corrected" => "After argument validation by an editor, the execution of this plugin was denied. This plugin will eventually be removed or corrected",
// "This plugin was recently added or modified. Until an editor of the site validates the parameters, execution will not be possible" => "This plugin was recently added or modified. Until an editor of the site validates the parameters, execution will not be possible",
// "You are allowed to" => "You are allowed to",
// "View arguments" => "View arguments",
// "Execute the plugin in preview mode (may be dangerous)" => "Execute the plugin in preview mode (may be dangerous)",
// "Approve the plugin for public execution" => "Approve the plugin for public execution",
// "View Details" => "View Details",
// "This plugin does not contain any arguments" => "This plugin does not contain any arguments",
// "This plugin's body is empty" => "This plugin's body is empty",
// "Experiment with plugin LIST" => "Experiment with plugin LIST",
// "Test Plugin LIST" => "Test Plugin LIST",
// "For security, grant the <strong>tiki_p_plugin_approve</strong> permission only to trusted user groups" => "For security, grant the <strong>tiki_p_plugin_approve</strong> permission only to trusted user groups",
// "Use the <a href=\"tiki-admin.php?page=textarea\" class=\"alert-link\">Admin: Text Area page</a> to deactivate potentially risky plugins" => "Use the <a href=\"tiki-admin.php?page=textarea\" class=\"alert-link\">Admin: Text Area page</a> to deactivate potentially risky plugins",
// "This page lists the plugins that require validation, the first time they are encountered" => "This page lists the plugins that require validation, the first time they are encountered",
// "Each plugin contains a unique <em>signature</em> that is preserved" => "Each plugin contains a unique <em>signature</em> that is preserved",
// "When you upgrade from an old version, you may need to reparse all the pages" => "When you upgrade from an old version, you may need to reparse all the pages",
// "If a plugin is no longer in use (for example, it has been removed from the wiki page), use <strong>Clear</strong> to remove it from this list" => "If a plugin is no longer in use (for example, it has been removed from the wiki page), use <strong>Clear</strong> to remove it from this list",
// "The plugin will automatically be added if it is encountered" => "The plugin will automatically be added if it is encountered",
// "Plugins can be individually previewed, approved, or rejected from the particular location that contains the plugin" => "Plugins can be individually previewed, approved, or rejected from the particular location that contains the plugin",
// "For security, you should review each plugin to ensure it is safe to approve" => "For security, you should review each plugin to ensure it is safe to approve",
// "Added By" => "Added By",
// "Wiki page: <a href=\"%0#%2\" title=\"View this page.\">%1</a>" => "Wiki page: <a href=\"%0#%2\" title=\"View this page.\">%1</a>",
// "View this page" => "View this page",
// "Approve all pending plugins" => "Approve all pending plugins",
// "Using <strong>Approve</strong> or <strong>Approve All</strong> will approve and activate the pending plugins" => "Using <strong>Approve</strong> or <strong>Approve All</strong> will approve and activate the pending plugins",
// "Use this feature <strong>only</strong> if you have verified that all the pending plugins are safe" => "Use this feature <strong>only</strong> if you have verified that all the pending plugins are safe",
// "No plugins pending approval" => "No plugins pending approval",
// "{\$channels[ix].title|escape}" => "{\$channels[ix].title|escape}",
// "View Results" => "View Results",
// "Sorry" => "Sorry",
"Other Polls" => "其他投票",
// "Poll Results" => "Poll Results",
// "All Polls" => "All Polls",
// "Top-Voted Polls" => "Top-Voted Polls",
// "Edit Poll" => "Edit Poll",
// "Find the poll" => "Find the poll",
// "{\$what}" => "{\$what}",
// "Number of top voted polls to show" => "Number of top voted polls to show",
// "Show results in this range" => "Show results in this range",
// "Show all results with no time span consideration" => "Show all results with no time span consideration",
// "Show all results with time span consideration" => "Show all results with time span consideration",
// "Show all results" => "Show all results",
// "Find results" => "Find results",
// "Show detailed results of this poll" => "Show detailed results of this poll",
// "List Votes" => "List Votes",
// "Preference translation" => "Preference translation",
// "Popup preview" => "Popup preview",
// "Close preview" => "Close preview",
// "Permalink" => "Permalink",
"The original document is available at" => "原始文件位於",
"Print multiple pages" => "列印多重頁面",
// "Selected Structures" => "Selected Structures",
// "Add Structure" => "Add Structure",
// "No structures" => "No structures",
// "Available Pages" => "Available Pages",
// "No pages" => "No pages",
// "All pages selected" => "All pages selected",
"Add Page" => "增加頁面",
"Remove Page" => "移除頁面",
// "Selected Pages" => "Selected Pages",
// "No pages selected" => "No pages selected",
// "Add Pages from Structures" => "Add Pages from Structures",
// "Edit quiz" => "Edit quiz",
// "Current Version" => "Current Version",
// "General Options" => "General Options",
// "Publication Date" => "Publication Date",
// "at " => "at ",
// "Use " => "Use ",
// "randomly selected questions" => "randomly selected questions",
// "Test-time Options" => "Test-time Options",
// "Shuffle questions" => "Shuffle questions",
// "Shuffle answers" => "Shuffle answers",
// "Limit questions displayed per page to " => "Limit questions displayed per page to ",
// "question(s)" => "question(s)",
// "Impose a time limit of " => "Impose a time limit of ",
// "Allow students to store partial results and return to quiz" => "Allow students to store partial results and return to quiz",
// "Allow students to retake this quiz " => "Allow students to retake this quiz ",
// "Grading and Feedback" => "Grading and Feedback",
// "Grading method " => "Grading method ",
// "Show students their score " => "Show students their score ",
// "Show students the correct answers" => "Show students the correct answers",
// "Publish statistics " => "Publish statistics ",
// "Extra Options" => "Extra Options",
// "Solicit additional questions from students" => "Solicit additional questions from students",
// "Link quiz to forum named: " => "Link quiz to forum named: ",
// "Prologue" => "Prologue",
// "Epilogue" => "Epilogue",
"Quiz result stats" => "測驗結果統計",
"User answers" => "使用者答案",
"Stats for quizzes" => "測驗統計",
"taken" => "參加過",
"Av score" => "平均分數",
"Av time" => "平均時間",
"Stats for quiz" => "測驗統計",
"Clear Stats" => "清除統計",
// "time taken" => "time taken",
// "Pass/Fail" => "Pass/Fail",
// "Passed" => "Passed",
"Stats for this quiz Questions " => "此測驗問題統計資料 ",
"Top 10" => "前 10",
"Top 20" => "前 20",
"Top 50" => "前 50",
"Top 100" => "前 100",
// "Rank" => "Rank",
// "Not Published" => "Not Published",
// "This article is currently unpublished and visible only to editors" => "This article is currently unpublished and visible only to editors",
"Received articles" => "已接收文章",
"Topic image" => "主題影像",
"Edit received article" => "編輯接收的文章",
"Image x size" => "影像 x 大小",
"Image y size" => "影像 y 大小",
"Image name" => "影像名稱",
"Image:" => "影像:",
"Publishing date" => "發表日期",
"Accept Article" => "接受文章",
// "Received Pages" => "Received Pages",
// "Edit Received Page" => "Edit Received Page",
// "The highlight pages already exist" => "The highlight pages already exist",
// "Please, change the name if you want the page to be uploaded" => "Please, change the name if you want the page to be uploaded",
// "Received Structures" => "Received Structures",
// "Prefix the checked: " => "Prefix the checked: ",
// " Postfix the checked: " => " Postfix the checked: ",
// "References" => "References",
// "Add a new library reference" => "Add a new library reference",
// "Edit reference settings" => "Edit reference settings",
// "Reference usage" => "Reference usage",
// "Delete reference" => "Delete reference",
// "Edit reference" => "Edit reference",
// "If you change the value of Biblio Code, you might loose the link between references" => "If you change the value of Biblio Code, you might loose the link between references",
// "Pages using reference %0" => "Pages using reference %0",
"Referer stats" => "參照頁面統計",
"Register as a new user" => "註冊新使用者",
// "Tiki site registered" => "Tiki site registered",
"The following site was added and validation by admin may be needed before appearing on the lists" => "已加入以下站臺, 需等待管理者確認後才會顯示在列表上",
// "You don't have permission to use this feature" => "You don't have permission to use this feature",
// "Please register" => "Please register",
// "Register this site at Tiki.org" => "Register this site at Tiki.org",
// "Read this first" => "Read this first",
// "On this page you can make your tiki site known to Tiki.org. It will get shown there in a list of known tiki sites" => "On this page you can make your tiki site known to Tiki.org. It will get shown there in a list of known tiki sites",
// "Registering is voluntary" => "Registering is voluntary",
// "Registering does not give you any benefits except one more link to your site" => "Registering does not give you any benefits except one more link to your site",
// "You don't get any emails, we don't sell the data about your site" => "You don't get any emails, we don't sell the data about your site",
// "Registering is just for us to get an overview of Tiki's usage" => "Registering is just for us to get an overview of Tiki's usage",
// "If your site is private or inside your intranet, you should not register" => "If your site is private or inside your intranet, you should not register",
// "tiki.org" => "tiki.org",
// "Information about your site" => "Information about your site",
// "Enter your username or email" => "Enter your username or email",
// "Enter your email" => "Enter your email",
// "Request Password Reset" => "Request Password Reset",
"Rename page" => "頁面更名",
// "Redirect original page" => "Redirect original page",
// "301 Redirect - \\\"moved permanently\\\" HTTP response status code" => "301 Redirect - \\\"moved permanently\\\" HTTP response status code",
// "Create an SEO-friendly, automatic redirect from old page name to new page name (ex.: for search engines or users that may have bookmarked the page)" => "Create an SEO-friendly, automatic redirect from old page name to new page name (ex.: for search engines or users that may have bookmarked the page)",
// "Roll back page %0 to version %1" => "Roll back page %0 to version %1",
// "Describe the reason for roll back" => "Describe the reason for roll back",
// "Enter some text to describe the reason for rolling back" => "Enter some text to describe the reason for rolling back",
// "This feature currently searches and replaces within wiki pages only" => "This feature currently searches and replaces within wiki pages only",
// "Max number of pages at a time" => "Max number of pages at a time",
// "Number of surrounding chars to preview" => "Number of surrounding chars to preview",
// "Replace selected" => "Replace selected",
"Searched" => "搜尋",
// "Search Query" => "Search Query",
"Search in" => "搜尋於",
// "Date Search" => "Date Search",
// "All dates" => "All dates",
// "{\$languages[ix].name}" => "{\$languages[ix].name}",
// "Calendar Items" => "Calendar Items",
// "{\$where|escape}" => "{\$where|escape}",
// "{\$where_label|escape}\"" => "{\$where_label|escape}\"",
// "{\$results[search].type|escape}" => "{\$results[search].type|escape}",
// "Simple search" => "Simple search",
"No pages matched the search criteria" => "找不到符合條件的頁面",
// "You can also send newsletters using an external client" => "You can also send newsletters using an external client",
"This newsletter will be sent to {\$subscribers} email addresses." => "電子報已發送至 {\$subscribers} email 地址.",
// "Sending will be throttled with a batch size of {\$prefs.newsletter_batch_size} and a pause period of {\$prefs.newsletter_pause_length} seconds" => "Sending will be throttled with a batch size of {\$prefs.newsletter_batch_size} and a pause period of {\$prefs.newsletter_pause_length} seconds",
// "Reply to" => "Reply to",
// "Send from" => "Send from",
// "Recipients" => "Recipients",
// "Validated" => "Validated",
// "Is user" => "Is user",
// "Sending Newsletter" => "Sending Newsletter",
// "sending to {\$subscribers} addresses" => "sending to {\$subscribers} addresses",
// "with the 'Reply To' email set to: {\$replyto}" => "with the 'Reply To' email set to: {\$replyto}",
// "with the 'Send From' email set to: {\$sendfrom}" => "with the 'Send From' email set to: {\$sendfrom}",
"Prepare a newsletter to be sent" => "準備將要送出的電子報",
"Admin templates" => "管理模板",
// "Data HTML" => "Data HTML",
// "Must be wiki parsed" => "Must be wiki parsed",
// "Wiki Parsed" => "Wiki Parsed",
// "Is HTML" => "Is HTML",
// "Data Txt" => "Data Txt",
// "Article Clip (read only)" => "Article Clip (read only)",
// "Clip Now" => "Clip Now",
// "Clip Articles" => "Clip Articles",
// "To include the article clipping into your newsletter, cut and paste it into the contents" => "To include the article clipping into your newsletter, cut and paste it into the contents",
// "If autoclipping is enabled, you can also enter \"~~~articleclip~~~\" which will be replaced with the latest\tclip when sending" => "If autoclipping is enabled, you can also enter \"~~~articleclip~~~\" which will be replaced with the latest\tclip when sending",
// "Be careful not to paste articles that must not be seen by the recipients" => "Be careful not to paste articles that must not be seen by the recipients",
// "Attached Files" => "Attached Files",
"remove" => "移除",
// "octets" => "octets",
// "To add a file, click here" => "To add a file, click here",
// "Reply To Email" => "Reply To Email",
// "if not" => "if not",
// "Sender email not set" => "Sender email not set",
// "Send From Email" => "Send From Email",
// "Save as Draft" => "Save as Draft",
// "Save your changes" => "Save your changes",
// "Save any changes and send to all subscribers" => "Save any changes and send to all subscribers",
// "Drafts (%0)" => "Drafts (%0)",
// "Sent Editions (%0)" => "Sent Editions (%0)",
"Send objects" => "發送物件",
"Transmission results" => "傳送結果",
"Send Wiki Pages" => "發送 Wiki 頁面",
// "Send a structure" => "Send a structure",
"Send Articles" => "發送文章",
"Add Article" => "加入文章",
"Send objects to this site" => "發送物件到這個網站",
// "Ex: http://tiki.org or localhost" => "Ex: http://tiki.org or localhost",
// "Use /commxmlrpc.php if your Tiki site is installed at the root, otherwise adapt /tiki to your need" => "Use /commxmlrpc.php if your Tiki site is installed at the root, otherwise adapt /tiki to your need",
// "Report this page" => "Report this page",
// "Page shared" => "Page shared",
// "The link was sent via email to the following addresses" => "The link was sent via email to the following addresses",
// "The link was sent via Twitter" => "The link was sent via Twitter",
// "The link was posted on your Facebook wall" => "The link was posted on your Facebook wall",
// "The link was sent as message to" => "The link was sent as message to",
// "The link was published in a" => "The link was published in a",
// "Have a look at this page" => "Have a look at this page",
// "Access rights are granted for the page" => "Access rights are granted for the page",
// "Short link" => "Short link",
// "Send email" => "Send email",
// "Recipient(s)" => "Recipient(s)",
// "Separate multiple email addresses with a comma and a space" => "Separate multiple email addresses with a comma and a space",
// "Separate multiple email addresses with a comma" => "Separate multiple email addresses with a comma",
// "Your name" => "Your name",
// "Recipients can subscribe to token notifications" => "Recipients can subscribe to token notifications",
// "Token Access Limit" => "Token Access Limit",
// "How many times recipients can access this page" => "How many times recipients can access this page",
// "Tweet via Twitter" => "Tweet via Twitter",
// "Authorize with Twitter first" => "Authorize with Twitter first",
// "Have a look at " => "Have a look at ",
// "Put on my Facebook wall" => "Put on my Facebook wall",
// "Authorize with Facebook first" => "Authorize with Facebook first",
// "Link text" => "Link text",
// "This will be the title for the URL" => "This will be the title for the URL",
// "Like this post" => "Like this post",
// "You do not have the permission to send messages or you did not allow other users to send you messages" => "You do not have the permission to send messages or you did not allow other users to send you messages",
// "User(s)" => "User(s)",
// "Separate multiple recipients with a semicolon" => "Separate multiple recipients with a semicolon",
// "Post on forum" => "Post on forum",
// "There is no forum where you can post a message" => "There is no forum where you can post a message",
// "password-protected" => "password-protected",
// "Share access rights" => "Share access rights",
// "Return to previous page" => "Return to previous page",
// "Create sheet" => "Create sheet",
// "Configure sheet" => "Configure sheet",
// "There are individual permissions set for this sheet" => "There are individual permissions set for this sheet",
// "Class Name" => "Class Name",
// "Header Rows" => "Header Rows",
// "Footer Rows" => "Footer Rows",
// "Wiki Parse Values" => "Wiki Parse Values",
// "Parent Spreadsheet" => "Parent Spreadsheet",
// "Makes this sheet a \"child\" sheet of a multi-sheet set" => "Makes this sheet a \"child\" sheet of a multi-sheet set",
// "You can access the sheet using the following URL" => "You can access the sheet using the following URL",
// "Banned Words" => "Banned Words",
// "Change shoutbox general settings" => "Change shoutbox general settings",
// "auto-link urls" => "auto-link urls",
"Post or edit a message" => "發表或編輯訊息",
// "Location : " => "Location : ",
// "Content may be out of date" => "Content may be out of date",
// "An urgent request for translation has been sent. Until this page is updated, you can see a corrected version in the following pages" => "An urgent request for translation has been sent. Until this page is updated, you can see a corrected version in the following pages",
// "Update from it" => "Update from it",
// "page: %0/%1" => "page: %0/%1",
// "This text was automatically translated by Google Translate from the following page: " => "This text was automatically translated by Google Translate from the following page: ",
// "Rate this page" => "Rate this page",
// "Last edited by" => "Last edited by",
// "based on work by" => "based on work by",
// "Contributors to this page" => "Contributors to this page",
// "To use Twitter integration, the site admin must register this site as an application at <a href=\"http://twitter.com/oauth_clients/\" class=\"alert-link\" target=\"_blank\">http://twitter.com/oauth_clients/</a> and allow write access for the application" => "To use Twitter integration, the site admin must register this site as an application at <a href=\"http://twitter.com/oauth_clients/\" class=\"alert-link\" target=\"_blank\">http://twitter.com/oauth_clients/</a> and allow write access for the application",
// "Twitter authorisation" => "Twitter authorisation",
// "to manage your authorisations at Twitter" => "to manage your authorisations at Twitter",
// "this site with twitter.com to use Twitter integration of this site" => "this site with twitter.com to use Twitter integration of this site",
// "To use Facebook integration, the site admin must register this site as an application at <a href=\"http://developers.facebook.com/setup/\" class=\"alert-link\" target=\"_blank\">http://developers.facebook.com/setup/</a> first" => "To use Facebook integration, the site admin must register this site as an application at <a href=\"http://developers.facebook.com/setup/\" class=\"alert-link\" target=\"_blank\">http://developers.facebook.com/setup/</a> first",
// "Facebook authorisation" => "Facebook authorisation",
// "to manage your authorizations at Facebook" => "to manage your authorizations at Facebook",
// "this site within facebook.com to use Facebook integration with this site" => "this site within facebook.com to use Facebook integration with this site",
// "To use LinkedIn integration, the site admin must register this site as an application at <a href=\"https://www.linkedin.com/secure/developer\" class=\"alert-link\" target=\"_blank\">https://www.linkedin.com/secure/developer</a> first" => "To use LinkedIn integration, the site admin must register this site as an application at <a href=\"https://www.linkedin.com/secure/developer\" class=\"alert-link\" target=\"_blank\">https://www.linkedin.com/secure/developer</a> first",
// "LinkedIn authorisation" => "LinkedIn authorisation",
// "this site to link your user to your LinkedIn account" => "this site to link your user to your LinkedIn account",
// "The site admin has set up a global account which will be used for this site" => "The site admin has set up a global account which will be used for this site",
// "bit.ly Login" => "bit.ly Login",
// "bit.ly Key" => "bit.ly Key",
// "Save changes" => "Save changes",
// "You will be redirected to the home page shortly" => "You will be redirected to the home page shortly",
// "to go to the home page immediately" => "to go to the home page immediately",
// "Please provide local account information" => "Please provide local account information",
// "Do you already have a local account for this site" => "Do you already have a local account for this site",
// "Login to link to it using the following form instead" => "Login to link to it using the following form instead",
// "Link to Existing Account" => "Link to Existing Account",
// "You will not see the latest queries" => "You will not see the latest queries",
// "Query" => "Query",
// "Params" => "Params",
// "Most viewed objects" => "Most viewed objects",
// "Most viewed objects in the last 7 days" => "Most viewed objects in the last 7 days",
"Site Stats" => "網站統計",
// "Date of first pageview" => "Date of first pageview",
// "Days since first pageview" => "Days since first pageview",
"Total pageviews" => "全部頁面瀏覽數",
"Average pageviews per day" => "每天平均頁面瀏覽數",
"Wiki Stats" => "Wiki 統計",
"Size of Wiki Pages" => "Wiki 頁面大小",
"Average page length" => "平均頁面長度",
"Average versions per page" => "平均每頁版本數",
"Visits to wiki pages" => "wiki 頁面拜訪數",
"Average links per page" => "平均每頁連結數",
"Image galleries Stats" => "影像圖庫統計",
"Average images per gallery" => "平均圖庫影像數",
"Total size of images" => "所有影像大小",
"Average image size" => "平均影像大小",
"Visits to image galleries" => "影像庫拜訪數",
"File galleries Stats" => "檔案庫統計",
"Average files per gallery" => "檔案庫平均檔案數",
"Total size of files" => "全部檔案的總大小",
"Average file size" => "平均檔案大小",
"Visits to file galleries" => "檔案庫拜訪數",
// "Articles Stats" => "Articles Stats",
"Total reads" => "全部閱讀數",
"Average reads per article" => "文章平均閱讀數",
"Total articles size" => "全部文章大小",
"Average article size" => "平均文章大小",
"Forum Stats" => "論壇統計",
"Total topics" => "全部主題",
"Average topics per forums" => "論壇平均主題數",
// "Total replies" => "Total replies",
// "Average number of replies per topic" => "Average number of replies per topic",
"Visits to forums" => "論壇拜訪數",
"Blog Stats" => "Blog 統計",
"Weblogs" => "Weblogs",
"Total posts" => "總發表佈告數",
"Average posts per weblog" => "weblog 平均發表數",
"Total size of blog posts" => "blog 佈告的總大小",
"Average posts size" => "平均佈告大小",
"Visits to weblogs" => "weblogs 拜訪數",
"Poll Stats" => "投票統計",
"Total votes" => "總票數",
"Average votes per poll" => "投票平均票數",
// "FAQ Stats" => "FAQ Stats",
"Total questions" => "全部問題數",
"Average questions per FAQ" => "FAQ 平均問題數",
"User Stats" => "使用者統計",
"Average bookmarks per user" => "使用者平均書籤數",
"Average questions per quiz" => "每測驗平均問題數",
"Quizzes taken" => "已參加過的測驗",
"Average quiz score" => "平均測驗分數",
"Average time per quiz" => "每測驗平均回答時間",
// "Most viewed objects in period" => "Most viewed objects in period",
// "{\$best_objects_stats_between[i]->type}" => "{\$best_objects_stats_between[i]->type}",
// "{\$best_objects_stats_lastweek[i]->type}" => "{\$best_objects_stats_lastweek[i]->type}",
"Usage chart" => "使用排行榜",
"Usage chart image" => "使用紀錄圖表",
// "Daily Usage" => "Daily Usage",
// "Piwik Analytics Dashboard" => "Piwik Analytics Dashboard",
// "Defaul dashboard is set to Piwik default dashboard. You can customize the modules to be displayed using the Dashboard setting; Create new dashboard" => "Defaul dashboard is set to Piwik default dashboard. You can customize the modules to be displayed using the Dashboard setting; Create new dashboard",
"Stats for surveys" => "調查結果",
"Last taken" => "最近參加的調查",
"Stats for survey" => "調查結果",
// "Select a user to preview its answer (marked as" => "Select a user to preview its answer (marked as",
// "User voted" => "User voted",
// "Select User" => "Select User",
// "no answer" => "no answer",
// "Tiki Logs" => "Tiki Logs",
// "Export through Action Log" => "Export through Action Log",
// "Clean logs older than" => "Clean logs older than",
// "Are you sure you want to revert" => "Are you sure you want to revert",
// "Revert" => "Revert",
"Time Left" => "剩餘時間",
"Send Answers" => "送出答案",
// "Thank you for your submission" => "Thank you for your submission",
// "Send a link to a friend" => "Send a link to a friend",
"Your email was sent" => "email 已寄出",
// "The link was sent to the following addresses" => "The link was sent to the following addresses",
// "Friend's email" => "Friend's email",
// "Your comment" => "Your comment",
// "I found an interesting page that I thought you would like" => "I found an interesting page that I thought you would like",
// "TikiTests Edit" => "TikiTests Edit",
// "Summary mode" => "Summary mode",
// "Show Page Differences" => "Show Page Differences",
// "Show Tidy Errors and Warnings" => "Show Tidy Errors and Warnings",
// "Show POST Data" => "Show POST Data",
// "Use Current Session/Log out" => "Use Current Session/Log out",
// "Recorded Links" => "Recorded Links",
// "Element to compare (Xpath expression)" => "Element to compare (Xpath expression)",
// "Test Xpath Expression" => "Test Xpath Expression",
// "Post Variables" => "Post Variables",
// "Tidy Results" => "Tidy Results",
// "Delete this link" => "Delete this link",
// "TikiTests List" => "TikiTests List",
// "Config" => "Config",
// "Replay" => "Replay",
// "Tidy extension not present" => "Tidy extension not present",
// "PECL HTTP extension present" => "PECL HTTP extension present",
// "cURL extension present" => "cURL extension present",
// "PECL HTTP and cURL extension not present. Replay of the TikiTest will not be possible" => "PECL HTTP and cURL extension not present. Replay of the TikiTest will not be possible",
// "List TikiTests" => "List TikiTests",
// "Create a TikiTest" => "Create a TikiTest",
// "Replay the TikiTest" => "Replay the TikiTest",
// "Edit the TikiTest" => "Edit the TikiTest",
// "TikiTests Record Configuration" => "TikiTests Record Configuration",
// "Start Recording Test" => "Start Recording Test",
// "TikiTests Replay Configuration" => "TikiTests Replay Configuration",
// "Failure" => "Failure",
// "Reference" => "Reference",
// "The pages are different" => "The pages are different",
// "The pages are identical" => "The pages are identical",
// "Recording to pause press the pause button" => "Recording to pause press the pause button",
// "Pause the recording" => "Pause the recording",
// "Paused to resume press the play button" => "Paused to resume press the play button",
// "Resume the recording" => "Resume the recording",
// "Stop the recording" => "Stop the recording",
// "Control by Objects" => "Control by Objects",
"Control by Sections" => "由區塊控制",
"Assign themes to categories" => "指定分類的佈景主題",
"Assigned categories" => "已指定的分類",
// "Delete selected" => "Delete selected",
"Control by Categories" => "由分類控制",
"Assign themes to objects" => "指定物件的佈景主題",
"Assigned objects" => "指定物件",
"Assign themes to sections" => "指定區塊的佈景主題",
"Assigned sections" => "指定區塊",
// "Timesheets" => "Timesheets",
// "Apply the following profile for enhancements: " => "Apply the following profile for enhancements: ",
// "Time Tracker" => "Time Tracker",
// "Local Cache (Not Committed)" => "Local Cache (Not Committed)",
// "Saved (Committed)" => "Saved (Committed)",
// "New task" => "New task",
// "Toggle completed" => "Toggle completed",
// "Toggle archived" => "Toggle archived",
// "Task name" => "Task name",
// "Estimate (in min.)" => "Estimate (in min.)",
// "Estimate" => "Estimate",
// "Task is completed" => "Task is completed",
// "Task is archived" => "Task is archived",
// "Created at" => "Created at",
// "Are you sure you want to delete all tasks" => "Are you sure you want to delete all tasks",
// "Commit Time Sheet Items" => "Commit Time Sheet Items",
// "View All" => "View All",
// "View My Items" => "View My Items",
"Summary" => "總計",
// "Time Spent" => "Time Spent",
// "Done By" => "Done By",
// "Add Tracker" => "Add Tracker",
// "Add Tracker To Tracker Report" => "Add Tracker To Tracker Report",
// "View Tracker Report" => "View Tracker Report",
// "Pick tracker to join" => "Pick tracker to join",
// "Pick fields to join on" => "Pick fields to join on",
// "Join inner" => "Join inner",
// "Join outer" => "Join outer",
// "Tracker - Open" => "Tracker - Open",
// "Tracker - Pending" => "Tracker - Pending",
// "Tracker - Closed" => "Tracker - Closed",
// "Tracker Item History" => "Tracker Item History",
// "View Tracker Item" => "View Tracker Item",
// "Not logging" => "Not logging",
// "Tracker changes are not being logged: Go to <a href=\"tiki-admin_actionlog.php?action_log_type=trackeritem&cookietab=2\" class=\"alert-link\">Action log admin</a> to enable" => "Tracker changes are not being logged: Go to <a href=\"tiki-admin_actionlog.php?action_log_type=trackeritem&cookietab=2\" class=\"alert-link\">Action log admin</a> to enable",
// "Edit File" => "Edit File",
// "Advanced mode" => "Advanced mode",
// "Simple mode" => "Simple mode",
// "Retry" => "Retry",
// "Additional Info" => "Additional Info",
// "Syntax Tips" => "Syntax Tips",
// "Download link using Tiki syntax" => "Download link using Tiki syntax",
// "Display an image using Tiki syntax" => "Display an image using Tiki syntax",
// "Use as a thumbnail with ShadowBox" => "Use as a thumbnail with ShadowBox",
// "Download link using HTML" => "Download link using HTML",
// "You locked the file" => "You locked the file",
// "The file has been locked by {\$fileInfo.lockedby}" => "The file has been locked by {\$fileInfo.lockedby}",
// "File title" => "File title",
// "required field for podcasts" => "required field for podcasts",
// "File description" => "File description",
// "Re-upload from disk" => "Re-upload from disk",
// "Use Gallery default resize settings for images <span id=\"imageResizeInfo\">{if \$gal_info[\"image_max_size_x\"]}({\$gal_info[\"image_max_size_x\"]}px X {\$gal_info[\"image_max_size_y\"]} px){else}(No resize){/if}</span>" => "Use Gallery default resize settings for images <span id=\"imageResizeInfo\">{if \$gal_info[\"image_max_size_x\"]}({\$gal_info[\"image_max_size_x\"]}px X {\$gal_info[\"image_max_size_y\"]} px){else}(No resize){/if}</span>",
// "If an image is wider than this, it will be resized. Attention: In this case, the original image will be lost. (0=unlimited)" => "If an image is wider than this, it will be resized. Attention: In this case, the original image will be lost. (0=unlimited)",
// "If an image is higher than this, it will be resized. Attention: In this case, the original image will be lost. (0=unlimited)" => "If an image is higher than this, it will be resized. Attention: In this case, the original image will be lost. (0=unlimited)",
// "Unzip zip files" => "Unzip zip files",
// "File can be deleted after" => "File can be deleted after",
// "OCR files if supported" => "OCR files if supported",
// "Creator of file, if different from the 'Uploaded by' user" => "Creator of file, if different from the 'Uploaded by' user",
// "File Type" => "File Type",
// "No type" => "No type",
// "Maximum number of downloads" => "Maximum number of downloads",
// "-1 for no limit" => "-1 for no limit",
// "Upload File(s)" => "Upload File(s)",
// "Add Another File" => "Add Another File",
// "Maximum file size is around" => "Maximum file size is around",
// "Note: You are running IIS" => "Note: You are running IIS",
// "maxAllowedContentLength also limits upload size" => "maxAllowedContentLength also limits upload size",
// "Please check web.config in the Tiki root folder" => "Please check web.config in the Tiki root folder",
// "Uploading file.." => "Uploading file..",
// "No File to Upload.." => "No File to Upload..",
// "Keeps a reference to the remote file" => "Keeps a reference to the remote file",
// "Video file uploaded" => "Video file uploaded",
// "Link to file from a Wiki page" => "Link to file from a Wiki page",
// "For image files" => "For image files",
// "Display full size" => "Display full size",
// "Display thumbnail that enlarges" => "Display thumbnail that enlarges",
"Batch Upload Results" => "批次上傳結果",
"Upload successful!" => "上傳成功!",
"The following image was successfully uploaded" => "下列影像已成功上傳",
"Image ID thumb" => "影像 ID 縮圖",
"You can view this image in your browser using" => "你可以觀看此影像在你的瀏覽器中使用",
// "You can include the image in an Wiki page using" => "You can include the image in an Wiki page using",
// "or use filename" => "or use filename",
"Now enter the image URL" => "輸入影像的 URL",
"or upload a local image from your disk" => "或從你的磁碟上傳影像",
"Batch Upload" => "批次上傳",
"Thumbnail (optional, overrides automatic thumbnail generation)" => "縮圖 (選擇性, 覆蓋自動縮圖產生)",
// "No gallery available" => "No gallery available",
"You have to create a gallery first!" => "你必須先建立圖庫!",
"User assigned modules" => "使用者指定模組",
// "to assign modules, which will make them available for creating a custom order on this page" => "to assign modules, which will make them available for creating a custom order on this page",
"Restore defaults" => "回復預設值",
// "The column is disabled" => "The column is disabled",
"#" => "#",
// "Move module up" => "Move module up",
// "Move module down" => "Move module down",
// "Move to right side" => "Move to right side",
// "Move to left side" => "Move to left side",
"Assign module" => "指定模組",
"top" => "top",
"Current folder" => "目標資料夾",
"Folders" => "資料夾",
"Folder in" => "資料夾於",
// "Refresh cache" => "Refresh cache",
"Admin folders and bookmarks" => "管理資料夾與書籤",
// "a folder" => "a folder",
// "a bookmark" => "a bookmark",
// "User Contacts Preferences" => "User Contacts Preferences",
"Change preferences" => "更改偏好",
// "Manage Fields" => "Manage Fields",
// "{\$ext.fieldname|escape}" => "{\$ext.fieldname|escape}",
// "{\$chdata.name}" => "{\$chdata.name}",
"Send me a message" => "發送訊息給我",
// "Basic Data" => "Basic Data",
// "Assign group" => "Assign group",
// "Assign Group" => "Assign Group",
// "User Icon" => "User Icon",
// "{\$gender}" => "{\$gender}",
// "(non public)" => "(non public)",
// "{\$country|stringfix}" => "{\$country|stringfix}",
// "User's homepage" => "User's homepage",
// "Personal Wiki Page" => "Personal Wiki Page",
// "Your relationship with other users" => "Your relationship with other users",
// "Relationship of this user to you" => "Relationship of this user to you",
// "The user has chosen to make his information private" => "The user has chosen to make his information private",
// "Additional Information" => "Additional Information",
// "Change user information" => "Change user information",
// "User Contribution" => "User Contribution",
// "has contributed to the following content" => "has contributed to the following content",
// "has not contributed to any content yet" => "has not contributed to any content yet",
// "Blogs Posts" => "Blogs Posts",
// "Forum comments" => "Forum comments",
// "Forum topics" => "Forum topics",
// "Who Looks at Items" => "Who Looks at Items",
// "Who Looks at Your Items" => "Who Looks at Your Items",
// "Who Looks at His or Her Items" => "Who Looks at His or Her Items",
// "Send Me A Message" => "Send Me A Message",
// "Send me a message " => "Send me a message ",
// "The following message will be sent to user" => "The following message will be sent to user",
// "Message Body" => "Message Body",
// "My Mail-in" => "My Mail-in",
// "Are you sure you want to delete the routing rule" => "Are you sure you want to delete the routing rule",
// "Configure how your mailed-in wiki pages are to be linked / organized" => "Configure how your mailed-in wiki pages are to be linked / organized",
// "Structure routing will link mailed-in pages as a child to the specified structure node. Only email matching the filters are linked" => "Structure routing will link mailed-in pages as a child to the specified structure node. Only email matching the filters are linked",
// "Only newly created pages, using the mail-in wiki-put function, are affected" => "Only newly created pages, using the mail-in wiki-put function, are affected",
// "Go to wiki structure setting" => "Go to wiki structure setting",
// "Toggle options" => "Toggle options",
// "Male" => "Male",
// "Female" => "Female",
// "Your Personal Wiki Page" => "Your Personal Wiki Page",
// "User's personal tracker information" => "User's personal tracker information",
// "View extra information" => "View extra information",
// "Your personal tracker information" => "Your personal tracker information",
// "Is email public" => "Is email public",
// "Unavailable - please set your email below" => "Unavailable - please set your email below",
// "Preferred perspective" => "Preferred perspective",
// "Email character set" => "Email character set",
// "Admin Language" => "Admin Language",
// "Can you read more languages" => "Can you read more languages",
// "Other languages you can read" => "Other languages you can read",
// "Select language.." => "Select language..",
// "Select from the dropdown to add automatically to the list below" => "Select from the dropdown to add automatically to the list below",
// "Displayed timezone" => "Displayed timezone",
// "Detect user time zone if browser allows, otherwise site default" => "Detect user time zone if browser allows, otherwise site default",
// "Site time zone <strong>%0</strong> is enforced and overrides user preferences" => "Site time zone <strong>%0</strong> is enforced and overrides user preferences",
// "Use 12-hour clock in time selectors" => "Use 12-hour clock in time selectors",
// "Display info tooltip on mouseover for every user who allows his/her information to be public" => "Display info tooltip on mouseover for every user who allows his/her information to be public",
"User Messages" => "使用者訊息",
// "Notify sender when reading his mail" => "Notify sender when reading his mail",
// "Message priority notification" => "Message priority notification",
// "Read message auto-archiving" => "Read message auto-archiving",
// "never" => "never",
// "Auto-archive read messages after selected days" => "Auto-archive read messages after selected days",
"User Tasks" => "使用者工作",
// "XMPP account JID" => "XMPP account JID",
// "If empty, Tiki will provide default value" => "If empty, Tiki will provide default value",
// "You have to provide this when using custom XMPP server" => "You have to provide this when using custom XMPP server",
// "My user items" => "My user items",
// "My articles" => "My articles",
// "My level" => "My level",
// "Remember which remarksbox (alert box) you have closed and don't show them again" => "Remember which remarksbox (alert box) you have closed and don't show them again",
// "Reset remark boxes visibility" => "Reset remark boxes visibility",
// "This will reset the visibility of all the tips, notices and warning remarks boxes you have closed" => "This will reset the visibility of all the tips, notices and warning remarks boxes you have closed",
// "Account Information" => "Account Information",
// "Leave \"New password\" and \"Confirm new password\" fields blank to keep current password" => "Leave \"New password\" and \"Confirm new password\" fields blank to keep current password",
// "Current password (required)" => "Current password (required)",
// "Account Deletion" => "Account Deletion",
// "Are you really sure you want to delete the account %0" => "Are you really sure you want to delete the account %0",
// "Check this box if you really want to delete the account" => "Check this box if you really want to delete the account",
// "Delete the account" => "Delete the account",
// "Delete my account" => "Delete my account",
// "Task list" => "Task list",
// "Admin mode off" => "Admin mode off",
// "Admin mode on" => "Admin mode on",
// "Task help" => "Task help",
// "Empty Trash" => "Empty Trash",
// "Task received" => "Task received",
// "You received this task" => "You received this task",
// "Task sent" => "Task sent",
// "You sent this task to another user" => "You sent this task to another user",
// "Task shared by a group" => "Task shared by a group",
// "Task is shared by a group" => "Task is shared by a group",
// "Accepted by task user and creator" => "Accepted by task user and creator",
// "Task has been accepted by user and creator" => "Task has been accepted by user and creator",
// "Rejected by a user" => "Rejected by a user",
// "Task has been rejected by a user" => "Task has been rejected by a user",
// "Waiting for me" => "Waiting for me",
// "Task has not yet been accepted or rejected by you" => "Task has not yet been accepted or rejected by you",
// "Waiting for other user" => "Waiting for other user",
// "Task has not yet been accepted or rejected by another user" => "Task has not yet been accepted or rejected by another user",
// "Admin Mode" => "Admin Mode",
// "Edit Task" => "Edit Task",
// "NOT accept" => "NOT accept",
// "Remove from Trash" => "Remove from Trash",
// "Move to trash" => "Move to trash",
// "Move to Trash" => "Move to Trash",
// "Task saved" => "Task saved",
// "View Task" => "View Task",
// "Open a new task" => "Open a new task",
// "Last Version" => "Last Version",
// "taskId" => "taskId",
// "Task user" => "Task user",
// "Only the creator can delete this task" => "Only the creator can delete this task",
// "Use start date and time" => "Use start date and time",
// "Use end date and time" => "Use end date and time",
// "Open / In Process" => "Open / In Process",
// "Waiting / Not Started" => "Waiting / Not Started",
"Percentage completed" => "完成百分比",
// "Waiting" => "Waiting",
// "Shared for Group" => "Shared for Group",
// "Accepted by User" => "Accepted by User",
// "No / Rejected" => "No / Rejected",
// "Accepted by Creator" => "Accepted by Creator",
// "This message will be send to users if you are makeing changes of assigned tasks" => "This message will be send to users if you are makeing changes of assigned tasks",
// "Send a message with changes" => "Send a message with changes",
// "Modified by" => "Modified by",
// "Marked as deleted" => "Marked as deleted",
// "Inform task user by email" => "Inform task user by email",
// "Reload" => "Reload",
// "You can only view this task" => "You can only view this task",
// "In the trash" => "In the trash",
// "Not Accepted by One User" => "Not Accepted by One User",
// "Not Accepted User" => "Not Accepted User",
"No tasks entered" => "尚未輸入工作",
// "Select One" => "Select One",
"Trash" => "垃圾桶",
// "Undo Trash" => "Undo Trash",
// "Received" => "Received",
// "Submitted" => "Submitted",
// "Shared" => "Shared",
// "All Shared Tasks" => "All Shared Tasks",
// "Previous version" => "Previous version",
// "Next version" => "Next version",
// "completed (100%)" => "completed (100%)",
// "Public for group" => "Public for group",
// "Wikis" => "Wikis",
// "Forum Threads" => "Forum Threads",
// "{\$userinfo['user_country']|stringfix}" => "{\$userinfo['user_country']|stringfix}",
// "{\$userinfo['user_gender']}" => "{\$userinfo['user_gender']}",
// "This user has contributed to the following wiki pages" => "This user has contributed to the following wiki pages",
// "This user has not contributed to any wiki pages yet" => "This user has not contributed to any wiki pages yet",
// "This user has not contributed any blog posts yet" => "This user has not contributed any blog posts yet",
// "This user has contributed to the following tracker items" => "This user has contributed to the following tracker items",
// "This user has not contributed to any tracker items yet" => "This user has not contributed to any tracker items yet",
// "This user has contributed to the following articles" => "This user has contributed to the following articles",
// "This user has not contributed to any articles yet" => "This user has not contributed to any articles yet",
// "This user has started to the following forum threads" => "This user has started to the following forum threads",
// "This user has not contributed to any forums yet" => "This user has not contributed to any forums yet",
// "Add to Network" => "Add to Network",
// "Remove from Network" => "Remove from Network",
// "User Watches and preferences" => "User Watches and preferences",
// "You need to set your email to receive email notifications" => "You need to set your email to receive email notifications",
// "Use reports to summarise notifications about objects you are watching" => "Use reports to summarise notifications about objects you are watching",
// "Use reports" => "Use reports",
// "Reporting interval" => "Reporting interval",
// "Every minute" => "Every minute",
// "Hourly" => "Hourly",
"Monthly" => "每月",
// "Report length" => "Report length",
// "Short report" => "Short report",
// "Detailed report" => "Detailed report",
// "Report format" => "Report format",
// "Send report even if no activity" => "Send report even if no activity",
// "My watches" => "My watches",
// "Use \"watches\" to monitor wiki pages or other objects" => "Use \"watches\" to monitor wiki pages or other objects",
// "Watch new items by clicking the {icon name='watch'} button on specific pages" => "Watch new items by clicking the {icon name='watch'} button on specific pages",
// "Add Watch" => "Add Watch",
// "Select event type" => "Select event type",
// "All watched events" => "All watched events",
// "A user submits a blog post" => "A user submits a blog post",
// "A user posts a forum thread" => "A user posts a forum thread",
// "A user posts a forum topic" => "A user posts a forum topic",
// "A user edited or commented on a wiki page" => "A user edited or commented on a wiki page",
// "A user edited a wiki page" => "A user edited a wiki page",
// "{\$w.type}" => "{\$w.type}",
// "Use this form to control notifications about objects you are watching" => "Use this form to control notifications about objects you are watching",
// "Send notification when I am the editor" => "Send notification when I am the editor",
// "Used space" => "Used space",
// "up to" => "up to",
// "no limit for admin" => "no limit for admin",
"User Menu" => "使用者選單",
"May need to refresh twice to see changes" => "可能需要更新兩次才看得到變動",
"Add top level bookmarks to menu" => "增加最高一層的書籤至選單",
"Add or edit an item" => "增加或編輯一個項目",
"New Window" => "新的視窗",
"replace window" => "取代視窗",
"Delete Selected" => "刪除選擇項目",
"Pos" => "Pos",
"User_versions_for" => "User_versions_for",
// "Monitor articles" => "Monitor articles",
// "Stop monitoring articles" => "Stop monitoring articles",
// "{\$listpages[ix].topicName}" => "{\$listpages[ix].topicName}",
// "\"}Actions for %0" => "\"}Actions for %0",
// "No articles yet" => "No articles yet",
// "New article" => "New article",
"Banner stats" => "大標題統計",
"Create new banner" => "建立新標題",
"Banner Information" => "大標題資訊",
"Click ratio" => "點擊率",
"Weekdays" => "工作日",
"mon" => "一",
"tue" => "二",
"wed" => "三",
"thu" => "四",
"fri" => "五",
"sat" => "六",
"sun" => "日",
"Banner raw data" => "大標題原始資料",
"Cached" => "已快取",
"This is a cached version of the page." => "這是本頁面的快取版本",
"Click here to view the Google cache of the page instead." => "點擊這裡瀏覽 Google 頁面存檔.",
// "{\$faq_info.title}" => "{\$faq_info.title}",
// "There are no questions in this FAQ" => "There are no questions in this FAQ",
// "Answers" => "Answers",
// "Add Suggestion" => "Add Suggestion",
"Edit Forum" => "編輯論壇",
"Forum List" => "論壇列表",
// "Forum actions" => "Forum actions",
// "Monitor topics" => "Monitor topics",
// "Stop monitoring topics" => "Stop monitoring topics",
// "Monitor topics and threads" => "Monitor topics and threads",
// "Stop monitoring topics and threads" => "Stop monitoring topics and threads",
// "Group monitor topics" => "Group monitor topics",
// "Group monitor topics and threads" => "Group monitor topics and threads",
// "Post New" => "Post New",
// "Deliberation" => "Deliberation",
// "Add Deliberation Item" => "Add Deliberation Item",
// "Watch for replies" => "Watch for replies",
// "Send me an email when someone replies to my topic" => "Send me an email when someone replies to my topic",
// "Don't send me any emails" => "Don't send me any emails",
// "Enter your name" => "Enter your name",
// "Editing posts" => "Editing posts",
// "Use wiki syntax when editing the content of posts - HTML is not allowed. Please click on the following link for documentation on wiki syntax" => "Use wiki syntax when editing the content of posts - HTML is not allowed. Please click on the following link for documentation on wiki syntax",
// "Moderator actions on selected topics" => "Moderator actions on selected topics",
// "Emot" => "Emot",
// "Rating <br/>(avg/max)" => "Rating <br/>(avg/max)",
// "Detailed results <br/>(counts)" => "Detailed results <br/>(counts)",
// "Detailed results <br/>(counts/%)" => "Detailed results <br/>(counts/%)",
"pts" => "pts",
// "Topic locked" => "Topic locked",
// "Forum locked" => "Forum locked",
// "No topics found" => "No topics found",
// "posts in this forum" => "posts in this forum",
// "Filter Posts" => "Filter Posts",
// "Last post date" => "Last post date",
"All posts" => "全部文章",
"Last hour" => "前 1 小時",
"Last 24 hours" => "前 24 小時",
"Last 48 hours" => "前 48 小時",
// "Show archived posts" => "Show archived posts",
// "Containing posts by" => "Containing posts by",
// "Me" => "Me",
"normal" => "正常",
"announce" => "公佈",
"hot" => "熱門",
// "Posts with no replies" => "Posts with no replies",
// "Topic List" => "Topic List",
// "The post has been reported and will be reviewed by a moderator" => "The post has been reported and will be reviewed by a moderator",
// "Previous topic" => "Previous topic",
// "Next topic" => "Next topic",
// "You are viewing a reply to" => "You are viewing a reply to",
// "Thread actions" => "Thread actions",
// "Print this page" => "Print this page",
// "Print all pages" => "Print all pages",
"Show posts" => "顯示發表數",
"Jump to forum" => "跳躍至論壇",
// "View Invoice" => "View Invoice",
// "Invoice %0" => "Invoice %0",
// "Date Issued %0" => "Date Issued %0",
// "Amount: %0" => "Amount: %0",
// "Payment Terms: %0" => "Payment Terms: %0",
// "This sheet is already being edited by %0" => "This sheet is already being edited by %0",
// "Back to Page" => "Back to Page",
// "Tiki Sheet" => "Tiki Sheet",
// "Save current spreadsheet" => "Save current spreadsheet",
// "Cancel editing current spreadsheet" => "Cancel editing current spreadsheet",
// "No parse" => "No parse",
// "What would you like to add" => "What would you like to add",
// "New spreadsheet" => "New spreadsheet",
// "Existing spreadsheet" => "Existing spreadsheet",
// "Tracker as a spreadsheet" => "Tracker as a spreadsheet",
// "Spreadsheet from file gallery" => "Spreadsheet from file gallery",
// "Cell" => "Cell",
// "Set Reference" => "Set Reference",
// "Un-Merge" => "Un-Merge",
// "Adds an additional row to bottom of the spreadsheet" => "Adds an additional row to bottom of the spreadsheet",
// "Add Row" => "Add Row",
// "Adds an additional rows to bottom of the spreadsheet" => "Adds an additional rows to bottom of the spreadsheet",
// "Add Multi-Rows" => "Add Multi-Rows",
// "Delets the current row thats highlighted" => "Delets the current row thats highlighted",
// "Delete Row" => "Delete Row",
// "Inserts an additional row after currently selected row" => "Inserts an additional row after currently selected row",
// "Insert Row Before" => "Insert Row Before",
// "Insert Row After" => "Insert Row After",
// "Unhides all the hidden rows" => "Unhides all the hidden rows",
// "Show All" => "Show All",
// "Hides or shows the currently selected row" => "Hides or shows the currently selected row",
// "Toggle Hide Row" => "Toggle Hide Row",
// "Adds an additional column to the right of the spreadsheet" => "Adds an additional column to the right of the spreadsheet",
// "Add Column" => "Add Column",
// "Adds an additional columns to the right of the spreadsheet" => "Adds an additional columns to the right of the spreadsheet",
// "Add Multi-Columns" => "Add Multi-Columns",
// "Deletes the current column thats highlighted" => "Deletes the current column thats highlighted",
// "Delete Column" => "Delete Column",
// "Inserts an additional column after currently selected column" => "Inserts an additional column after currently selected column",
// "Insert Column Before" => "Insert Column Before",
// "Insert Column After" => "Insert Column After",
// "Fill down current cell value" => "Fill down current cell value",
// "Fill Down" => "Fill Down",
// "Fill up current cell value" => "Fill up current cell value",
// "Fill Up" => "Fill Up",
// "Unhides all the hidden columns" => "Unhides all the hidden columns",
// "Hides or shows the currently selected column" => "Hides or shows the currently selected column",
// "Toggle Hide Column" => "Toggle Hide Column",
// "Add new spreadsheet" => "Add new spreadsheet",
// "Add Spreadsheet" => "Add Spreadsheet",
// "Delete the current spreadsheet" => "Delete the current spreadsheet",
// "Delete Spreadsheet" => "Delete Spreadsheet",
// "Recompiles the current sheet" => "Recompiles the current sheet",
// "Change the title of the sheet" => "Change the title of the sheet",
// "Wrap Cell Range" => "Wrap Cell Range",
// "Wrap with SUM" => "Wrap with SUM",
// "Wrap with CEILING" => "Wrap with CEILING",
// "Wrap with COUNT" => "Wrap with COUNT",
// "Wrap with MAX" => "Wrap with MAX",
// "Wrap with MIN" => "Wrap with MIN",
// "Redo" => "Redo",
// "Toggle State" => "Toggle State",
// "Function Reference" => "Function Reference",
// "Usage Example: =SUM(SUM(A1:B1) + SUM(D7))" => "Usage Example: =SUM(SUM(A1:B1) + SUM(D7))",
// "=(TRUE(N(A1)) || FALSE(N(B1)))" => "=(TRUE(N(A1)) || FALSE(N(B1)))",
// "Returns the absolute value of a number" => "Returns the absolute value of a number",
// "Returns a rounded number" => "Returns a rounded number",
// "Returns a number rounded up based on a multiple of significance" => "Returns a number rounded up based on a multiple of significance",
// "Counts the number of cells that contain a value" => "Counts the number of cells that contain a value",
// "Counts full days from a specific date - format(YYYY,MM,DD)" => "Counts full days from a specific date - format(YYYY,MM,DD)",
// "Converts a number to text, using a currency format - options(number, decimals, symbol)" => "Converts a number to text, using a currency format - options(number, decimals, symbol)",
// "Returns a logical value of FALSE" => "Returns a logical value of FALSE",
// "Returns a text representation of a number rounded to a specified number of decimal places - options(number, decimals, useCommas)" => "Returns a text representation of a number rounded to a specified number of decimal places - options(number, decimals, useCommas)",
// "Returns a number rounded down based on a multiple of significance" => "Returns a number rounded down based on a multiple of significance",
// "Returns the integer portion of a number" => "Returns the integer portion of a number",
// "Returns the largest value from the numbers provided" => "Returns the largest value from the numbers provided",
// "Returns the smallest value from the numbers provided" => "Returns the smallest value from the numbers provided",
// "Converts a value to a number" => "Converts a value to a number",
// "Gets full date of today" => "Gets full date of today",
// "Returns the mathematical constant called pi, which is 3.14159265358979" => "Returns the mathematical constant called pi, which is 3.14159265358979",
// "Returns the result of a number raised to a given power" => "Returns the result of a number raised to a given power",
// "Returns a random number that is greater than or equal to 0 and less than 1" => "Returns a random number that is greater than or equal to 0 and less than 1",
// "Returns a number rounded to a specified number of digits" => "Returns a number rounded to a specified number of digits",
// "Returns all of the values in each of the specified cells and added together" => "Returns all of the values in each of the specified cells and added together",
// "Returns a logical value of TRUE" => "Returns a logical value of TRUE",
// "Converts a text value that represents a number to a number" => "Converts a text value that represents a number to a number",
// "Italics" => "Italics",
// "Uppercase" => "Uppercase",
// "Capitalize" => "Capitalize",
// "Lowercase" => "Lowercase",
// "Font Size +" => "Font Size +",
// "Font Size -" => "Font Size -",
// "{\$tracker_info.name}" => "{\$tracker_info.name}",
// "Tracker actions" => "Tracker actions",
// "Group Monitoring" => "Group Monitoring",
// "Stop Watching" => "Stop Watching",
// "atts" => "atts",
// "List Attachments" => "List Attachments",
// "View/Edit" => "View/Edit",
"Insert New Item" => "插入新項目",
// "View inserted item" => "View inserted item",
"Insert new item" => "插入新項目",
// "Synchronization" => "Synchronization",
// "This tracker is a remote copy of <a href=\"%0\">%0</a>" => "This tracker is a remote copy of <a href=\"%0\">%0</a>",
// "It was last updated on %0" => "It was last updated on %0",
// "Reload field definitions" => "Reload field definitions",
// "Items added locally" => "Items added locally",
// "Push new items" => "Push new items",
// "Safe modifications (no remote conflict)" => "Safe modifications (no remote conflict)",
// "Dangerous modifications (remote conflict)" => "Dangerous modifications (remote conflict)",
// "On push, local items will be removed until data reload" => "On push, local items will be removed until data reload",
// "Push local changes" => "Push local changes",
// "Local changes will be lost" => "Local changes will be lost",
// "When reloading the data from the source, all local changes will be lost" => "When reloading the data from the source, all local changes will be lost",
// "New items that must be preserved should be pushed using the above controls" => "New items that must be preserved should be pushed using the above controls",
// "Modifications that must be preserved should be replicated" => "Modifications that must be preserved should be replicated",
// "Without conflicts: Using the above controls" => "Without conflicts: Using the above controls",
// "With conflicts: Manually on the source" => "With conflicts: Manually on the source",
// "Using the above controls will cause information loss" => "Using the above controls will cause information loss",
// "Reload data from source" => "Reload data from source",
// "Tracker item actions" => "Tracker item actions",
// "Move to another tracker" => "Move to another tracker",
// "Save Returning to Item List" => "Save Returning to Item List",
// "Save and Comment" => "Save and Comment",
// "Special Operations" => "Special Operations",
// "close" => "close",
// "Open Tiki WebDAV (Wiki pages) as WebFolder" => "Open Tiki WebDAV (Wiki pages) as WebFolder",
// "Open Tiki WebDAV as WebFolder" => "Open Tiki WebDAV as WebFolder",
// "Parent page" => "Parent page",
// "Manage Stucture" => "Manage Stucture",
// "Child" => "Child",
// "page id" => "page id",
// "Please wait" => "Please wait",
// " The PDF is being prepared, please wait.." => " The PDF is being prepared, please wait..",
// "Show structure" => "Show structure",
// "Hide structure bar and any toc" => "Hide structure bar and any toc",
// "Hide structure" => "Hide structure",
// "Page actions" => "Page actions",
// " PDF" => " PDF",
// "Warning:mPDF Package Missing" => "Warning:mPDF Package Missing",
// "Click to toggle on/off" => "Click to toggle on/off",
// "Edit icons" => "Edit icons",
// "Wysiwyg" => "Wysiwyg",
// "Send link" => "Send link",
// "Monitor page" => "Monitor page",
// "Stop monitoring page" => "Stop monitoring page",
// "Monitor sub-structure" => "Monitor sub-structure",
// "Stop monitoring sub-structure" => "Stop monitoring sub-structure",
// "Group monitor structure" => "Group monitor structure",
// "Profiles Wizard" => "Profiles Wizard",
// "Changes Wizard" => "Changes Wizard",
// "Configuration Wizard" => "Configuration Wizard",
// "steps" => "steps",
// "User Wizard" => "User Wizard",
// "Wizard Steps" => "Wizard Steps",
// "Change Theme" => "Change Theme",
// "Change Transition" => "Change Transition",
// "Convex" => "Convex",
// "Concave" => "Concave",
// " Handouts" => " Handouts",
// "Exit Slideshow" => "Exit Slideshow",
// "More types available" => "More types available",
// "More field types may be enabled from the <a href=\"%0\" class=\"alert-link\">administration panel</a>" => "More field types may be enabled from the <a href=\"%0\" class=\"alert-link\">administration panel</a>",
// "Contact your administrator to see if they can be enabled. The complete field type list is available in the <a rel=\"external\" class=\"alert-link external\" href=\"%0\">documentation</a>" => "Contact your administrator to see if they can be enabled. The complete field type list is available in the <a rel=\"external\" class=\"alert-link external\" href=\"%0\">documentation</a>",
// "Description contains wiki syntax" => "Description contains wiki syntax",
// "Restrict visibility to administrators" => "Restrict visibility to administrators",
// "Useful if you are working on a live tracker" => "Useful if you are working on a live tracker",
// "Add Field &amp; Edit Advanced Options" => "Add Field &amp; Edit Advanced Options",
// "Do you really want to clear all the items from tracker \"%0\"? (Note: there is no undo and notifications will not be sent.)" => "Do you really want to clear all the items from tracker \"%0\"? (Note: there is no undo and notifications will not be sent.)",
// "Clear All" => "Clear All",
// "Options for %0" => "Options for %0",
// "Separate multiple with commas" => "Separate multiple with commas",
// "Separate multiple with &quot;{\$def.separator}&quot" => "Separate multiple with &quot;{\$def.separator}&quot",
// "Error Message" => "Error Message",
// "Visible by all" => "Visible by all",
// "Visible by all but not in RSS feeds" => "Visible by all but not in RSS feeds",
// "Visible after creation by administrators only" => "Visible after creation by administrators only",
// "Editable by administrators only" => "Editable by administrators only",
// "Editable after creation by administrators only" => "Editable after creation by administrators only",
// "Editable by administrators and creator only" => "Editable by administrators and creator only",
// "Immutable after creation" => "Immutable after creation",
// "Creator requires a user field with auto-assign to creator (1)" => "Creator requires a user field with auto-assign to creator (1)",
// "Visible by" => "Visible by",
// "List of Group names with permission to see this field" => "List of Group names with permission to see this field",
// "Separated by comma (,)" => "Separated by comma (,)",
// "Editable by" => "Editable by",
// "List of Group names with permission to edit this field" => "List of Group names with permission to edit this field",
// "Changing the permanent name may have consequences in integrated systems" => "Changing the permanent name may have consequences in integrated systems",
// "Changing the field type may cause irretrievable data loss - use with caution" => "Changing the field type may cause irretrievable data loss - use with caution",
// "Make sure you rebuild the search index if you change field type" => "Make sure you rebuild the search index if you change field type",
// "Deprecated" => "Deprecated",
// "To export tracker or tracker items please" => "To export tracker or tracker items please",
// "enable" => "enable",
// "and use" => "and use",
// "Tracker Tabular" => "Tracker Tabular",
// "It is easy to use, optimised and far more powerful" => "It is easy to use, optimised and far more powerful",
// "Export Tracker Items" => "Export Tracker Items",
// "ISO-8859-1 Latin" => "ISO-8859-1 Latin",
// "Delimitor (left)" => "Delimitor (left)",
// "Delimitor (right)" => "Delimitor (right)",
// "Carriage return inside field value" => "Carriage return inside field value",
// "Export dates as UNIX Timestamps to facilitate importing" => "Export dates as UNIX Timestamps to facilitate importing",
// "Export ItemLink type fields as the itemId of the linked item (to facilitate importing)" => "Export ItemLink type fields as the itemId of the linked item (to facilitate importing)",
// "Export country type fields as the system name of the country (to facilitate importing)" => "Export country type fields as the system name of the country (to facilitate importing)",
// "Parse as wiki text" => "Parse as wiki text",
// "Generic information" => "Generic information",
// "Number of records" => "Number of records",
// "First record" => "First record",
// "Quick Export" => "Quick Export",
// "Produce a CSV with basic formatting" => "Produce a CSV with basic formatting",
// "If you use field types such as 'User Preference', 'Relations' or 'Items list/Item link', please export your items through the next section below 'Export Tracker Items'" => "If you use field types such as 'User Preference', 'Relations' or 'Items list/Item link', please export your items through the next section below 'Export Tracker Items'",
// "Tracker Export" => "Tracker Export",
// "Copy the definition text above and paste into the Import Structure box for a new tracker" => "Copy the definition text above and paste into the Import Structure box for a new tracker",
// "Profile Export" => "Profile Export",
// "Produce YAML for a profile" => "Produce YAML for a profile",
// "Linked tracker and field IDs (such as those referenced in ItemLink, ItemsList field options, for instance) are not currently converted to profile object references, so will need manual replacement" => "Linked tracker and field IDs (such as those referenced in ItemLink, ItemsList field options, for instance) are not currently converted to profile object references, so will need manual replacement",
// "For example: \$profileobject:field_ref\$" => "For example: \$profileobject:field_ref\$",
// "Export Profile" => "Export Profile",
"Fields Export" => "匯出",
// "Copy the definition text above and paste into the Import Fields box on a tracker's fields page" => "Copy the definition text above and paste into the Import Fields box on a tracker's fields page",
// "YAML Export" => "YAML Export",
// "Profile for trackerId %0" => "Profile for trackerId %0",
// "Raw data" => "Raw data",
// "Preserve tracker ID" => "Preserve tracker ID",
// "Use \"Tracker -> Export -> Structure\" to produce this data" => "Use \"Tracker -> Export -> Structure\" to produce this data",
// "Tracker import completed" => "Tracker import completed",
// "Return to Trackers" => "Return to Trackers",
// "Import fields for this tracker" => "Import fields for this tracker",
// "Raw Fields" => "Raw Fields",
// "Preserve Field IDs" => "Preserve Field IDs",
// "Confirmation" => "Confirmation",
// "Imported file '%0'" => "Imported file '%0'",
// "Import completed with '%0'" => "Import completed with '%0'",
// "To import items into a tracker please" => "To import items into a tracker please",
// "The order of the fields does not matter, but you need to add a header with the field names" => "The order of the fields does not matter, but you need to add a header with the field names",
// "Add \" -- \" (with the spaces before and after) to the end of the fields in the header that you would like to import" => "Add \" -- \" (with the spaces before and after) to the end of the fields in the header that you would like to import",
// "Auto-incremented itemid fields shall be included with no matter what values" => "Auto-incremented itemid fields shall be included with no matter what values",
// "If you are having problems, try a different line ending for your csv file that matches the server operating system" => "If you are having problems, try a different line ending for your csv file that matches the server operating system",
// "UNIX Timestamp" => "UNIX Timestamp",
// "Character encoding" => "Character encoding",
// "Create as new items" => "Create as new items",
// "Update lastModif date if updating items (status and created are updated only if the fields are specified in the csv)" => "Update lastModif date if updating items (status and created are updated only if the fields are specified in the csv)",
// "Convert values of ItemLink and Relation type fields from the value in the CSV file to the itemId of the linked item. Requires the linked or related item to be correctly set up in advance" => "Convert values of ItemLink and Relation type fields from the value in the CSV file to the itemId of the linked item. Requires the linked or related item to be correctly set up in advance",
// "Please note: This is an experimental new feature - work in progress" => "Please note: This is an experimental new feature - work in progress",
// "YAML" => "YAML",
// "Create another" => "Create another",
// "Do you really want to remove the \"%0\" tracker" => "Do you really want to remove the \"%0\" tracker",
// "Please note" => "Please note",
// "This tracker, its fields and all of its %0 items will be permanently removed from your system" => "This tracker, its fields and all of its %0 items will be permanently removed from your system",
// "Are you sure you want to remove the fields? Data will be lost" => "Are you sure you want to remove the fields? Data will be lost",
// "Remove Fields" => "Remove Fields",
// "Return to field administration" => "Return to field administration",
// "Replacement" => "Replacement",
// "%0 other item(s) currently refer to the element you are trying to delete. They will be replaced by this one" => "%0 other item(s) currently refer to the element you are trying to delete. They will be replaced by this one",
// "Description is wiki-parsed" => "Description is wiki-parsed",
// "Field Prefix" => "Field Prefix",
// "Allow ratings (deprecated, use rating field)" => "Allow ratings (deprecated, use rating field)",
// "Rating options" => "Rating options",
// "Show ratings in listing" => "Show ratings in listing",
// "Show comments in listing" => "Show comments in listing",
// "Display last comment author and date" => "Display last comment author and date",
// "Allow attachments (deprecated, use files field)" => "Allow attachments (deprecated, use files field)",
// "Display attachments in listing" => "Display attachments in listing",
// "Attachment attributes (sortable)" => "Attachment attributes (sortable)",
// "Recommended size: 64x64px" => "Recommended size: 64x64px",
// "Show status to tracker administrator only" => "Show status to tracker administrator only",
// "Show creation date when listing items" => "Show creation date when listing items",
// "Creation date format" => "Creation date format",
// "Show item creator" => "Show item creator",
// "Show creation date when viewing items" => "Show creation date when viewing items",
// "Show last modification date when listing items" => "Show last modification date when listing items",
// "Show item last modifier" => "Show item last modifier",
// "Modification date format" => "Modification date format",
// "Show last modification date when viewing items" => "Show last modification date when viewing items",
// "Hide empty fields from item view" => "Hide empty fields from item view",
// "List detail popup" => "List detail popup",
// "Section Format" => "Section Format",
// "Section format" => "Section format",
// "Determines how headers will be rendered when using header fields as form section dividers" => "Determines how headers will be rendered when using header fields as form section dividers",
// "Set to <em>Configured</em> to use the four following fields" => "Set to <em>Configured</em> to use the four following fields",
// "Use Form Classes" => "Use Form Classes",
// "Input Form Classes" => "Input Form Classes",
// "Sets classes for form to be used in Tracker Plugin (e.g. form-horizontal or col-md-9)" => "Sets classes for form to be used in Tracker Plugin (e.g. form-horizontal or col-md-9)",
// "Template to display an item" => "Template to display an item",
// "wiki:pageName for a wiki page or tpl:tplName for a template" => "wiki:pageName for a wiki page or tpl:tplName for a template",
// "Template to edit an item" => "Template to edit an item",
// "New item status" => "New item status",
// "Modified item status" => "Modified item status",
// "No change" => "No change",
// "Default status displayed in list mode" => "Default status displayed in list mode",
// "Copy activity to email" => "Copy activity to email",
// "Use simplified email format" => "Use simplified email format",
// "The tracker will use the text field named Subject if any as subject and will use the user email or for anonymous the email field if any as sender" => "The tracker will use the text field named Subject if any as subject and will use the user email or for anonymous the email field if any as sender",
// "Publish RSS feed for this tracker" => "Publish RSS feed for this tracker",
// "Requires \"RSS per tracker\" to be set in Admin/RSS" => "Requires \"RSS per tracker\" to be set in Admin/RSS",
// "(Currently set)" => "(Currently set)",
// "(Currently not set)" => "(Currently not set)",
// "Group alerted on item modification" => "Group alerted on item modification",
// "Allow user selection for small groups" => "Allow user selection for small groups",
// "User can see his own items" => "User can see his own items",
// "The tracker needs a user field with the item-owner activated" => "The tracker needs a user field with the item-owner activated",
// "No extra permission is needed at the tracker permissions level to allow a user to see just his own items through Plugin TrackerList with the param view=user" => "No extra permission is needed at the tracker permissions level to allow a user to see just his own items through Plugin TrackerList with the param view=user",
// "Item creator can modify his items" => "Item creator can modify his items",
// "The tracker needs a user field with the auto-assign activated" => "The tracker needs a user field with the auto-assign activated",
// "Item creator can remove his items" => "Item creator can remove his items",
// "User can take ownership of item created by anonymous" => "User can take ownership of item created by anonymous",
// "Only one item per user or IP" => "Only one item per user or IP",
// "The tracker needs a user or IP address field with the auto-assign set to Creator" => "The tracker needs a user or IP address field with the auto-assign set to Creator",
// "Members of the creator group can modify items" => "Members of the creator group can modify items",
// "The tracker needs a group field with the auto-assign activated" => "The tracker needs a group field with the auto-assign activated",
// "Members of the creator group can remove items" => "Members of the creator group can remove items",
// "Restrict non admins to wiki page access only" => "Restrict non admins to wiki page access only",
// "Only users with admin tracker permission (tiki_p_admin_trackers) can use the built-in tracker interfaces (tiki-view_tracker.php and tiki-view_tracker_item.php). This is useful if you want the users of these trackers to only access them via wiki pages, where you can use the various tracker plugins to embed forms and reports" => "Only users with admin tracker permission (tiki_p_admin_trackers) can use the built-in tracker interfaces (tiki-view_tracker.php and tiki-view_tracker_item.php). This is useful if you want the users of these trackers to only access them via wiki pages, where you can use the various tracker plugins to embed forms and reports",
// "Creation date constraint" => "Creation date constraint",
// "The tracker will be <strong>open</strong> for non-admin users through wiki pages with PluginTracker <strong>only</strong> during the period 'After' the start date and/or 'Before' the end date set below" => "The tracker will be <strong>open</strong> for non-admin users through wiki pages with PluginTracker <strong>only</strong> during the period 'After' the start date and/or 'Before' the end date set below",
// "Before" => "Before",
// "Auto-create corresponding categories" => "Auto-create corresponding categories",
// "Create a group for each item" => "Create a group for each item",
// "Groups will include" => "Groups will include",
// "Creator is assigned to the group" => "Creator is assigned to the group",
// "Will become the creator's default group" => "Will become the creator's default group",
// "Will become the new item's group creator" => "Will become the new item's group creator",
// "Copy the default group in the field ID before updating the group" => "Copy the default group in the field ID before updating the group",
// "Non Advanced Search or Natural Search" => "Non Advanced Search or Natural Search",
// "Advanced Search or Boolean Search" => "Advanced Search or Boolean Search",
// "Objects that contain the more terms are rated higher in the results and will appear first in their type" => "Objects that contain the more terms are rated higher in the results and will appear first in their type",
// "objects that include both terms" => "objects that include both terms",
// "Requiring terms" => "Requiring terms",
// "Add a plus sign ( + ) before a term to indicate that the term <em>must</em> appear in results" => "Add a plus sign ( + ) before a term to indicate that the term <em>must</em> appear in results",
// "Example: <strong>+wiki forum</strong> will find objects containing at least <strong>wiki</strong>. Objects with both terms and many occurences of the terms will appear first" => "Example: <strong>+wiki forum</strong> will find objects containing at least <strong>wiki</strong>. Objects with both terms and many occurences of the terms will appear first",
// "Excluding terms" => "Excluding terms",
// "Add a minus sign ( - ) before a term to indicate that the term <em>must not</em> appear in the results" => "Add a minus sign ( - ) before a term to indicate that the term <em>must not</em> appear in the results",
// "To reduce a term's value without completely excluding it, <a href=\"#reducing\" title=\"Reducing a term's value\">use a tilde</a>" => "To reduce a term's value without completely excluding it, <a href=\"#reducing\" title=\"Reducing a term's value\">use a tilde</a>",
// "Example: <strong>-wiki forum</strong> will find objects that do not contain <strong>wiki</strong> but contain <strong>forum</strong>" => "Example: <strong>-wiki forum</strong> will find objects that do not contain <strong>wiki</strong> but contain <strong>forum</strong>",
// "Example: <strong>+wiki +(forum blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or that contain <strong>wiki</strong> and <strong>blog</strong> in any order" => "Example: <strong>+wiki +(forum blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or that contain <strong>wiki</strong> and <strong>blog</strong> in any order",
// "Use double quotes ( <kbd>\" \"</kbd> ) around a phrase to find terms in the exact order, exactly as typed" => "Use double quotes ( <kbd>\" \"</kbd> ) around a phrase to find terms in the exact order, exactly as typed",
// "Example: <kbd>\"Alex Bell\"</kbd> will not find <strong>Bell Alex</strong> or <strong>Alex G. Bell</strong>. " => "Example: <kbd>\"Alex Bell\"</kbd> will not find <strong>Bell Alex</strong> or <strong>Alex G. Bell</strong>. ",
// "Using wildcards" => "Using wildcards",
// "Add an asterisk ( * ) after a term to find objects that include the root word" => "Add an asterisk ( * ) after a term to find objects that include the root word",
// "For example, <strong>run*</strong> will find" => "For example, <strong>run*</strong> will find",
// "objects that include the term <strong>run</strong>" => "objects that include the term <strong>run</strong>",
// "objects that include the term <strong>runner</strong>" => "objects that include the term <strong>runner</strong>",
// "objects that include the term <strong>running</strong>" => "objects that include the term <strong>running</strong>",
// "Reducing a term's value" => "Reducing a term's value",
// "Add a tilde ( ~ ) before a term to reduce its value indicate to the ranking of the results" => "Add a tilde ( ~ ) before a term to reduce its value indicate to the ranking of the results",
// "Objects that contain the term will appear lower than other objects (unlike the <a href=\"#excluding\" title=\"Excluding terms\">minus sign</a>\twhich will completely exclude a term)" => "Objects that contain the term will appear lower than other objects (unlike the <a href=\"#excluding\" title=\"Excluding terms\">minus sign</a>\twhich will completely exclude a term)",
// "Example: <strong>+wiki ~forum</strong> will rate an object with only <strong>wiki</strong> higher that an object with <strong>wiki</strong> and <strong>forum</strong>" => "Example: <strong>+wiki ~forum</strong> will rate an object with only <strong>wiki</strong> higher that an object with <strong>wiki</strong> and <strong>forum</strong>",
// "Changing relevance value" => "Changing relevance value",
// "Add a less than ( &lt; ) or greater than ( &gt; ) sign before a term to change the term's contribution to the overall relevance value assigned to a object" => "Add a less than ( &lt; ) or greater than ( &gt; ) sign before a term to change the term's contribution to the overall relevance value assigned to a object",
// "Example: <strong>+wiki +(&gt;forum &lt; blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or <strong>wiki</strong> and <strong>blog</strong> in any order. <strong>wiki forum</strong> will be rated higher" => "Example: <strong>+wiki +(&gt;forum &lt; blog)</strong> will find objects that contain <strong>wiki</strong> and <strong>forum</strong> or <strong>wiki</strong> and <strong>blog</strong> in any order. <strong>wiki forum</strong> will be rated higher",
// "{\$confirmation_message}" => "{\$confirmation_message}",
// "\"}Are you sure you want to set this %0 to \"open\"" => "\"}Are you sure you want to set this %0 to \"open\"",
// "\"}Are you sure you want to set this %0 to \"pending\"" => "\"}Are you sure you want to set this %0 to \"pending\"",
// "\"}Are you sure you want to set this %0 to \"closed\"" => "\"}Are you sure you want to set this %0 to \"closed\"",
// "{\$field.name|truncate:65|escape}" => "{\$field.name|truncate:65|escape}",
// "Hold \"Ctrl\" in order to select multiple values" => "Hold \"Ctrl\" in order to select multiple values",
// "{\$field_name}" => "{\$field_name}",
// "{\$description}" => "{\$description}",
// "{\$sc.label|escape}" => "{\$sc.label|escape}",
// "Admin Fields" => "Admin Fields",
// "It is very likely that authentication will be required to access this data on the remote site. Configure the authentication source from Admin DSN" => "It is very likely that authentication will be required to access this data on the remote site. Configure the authentication source from Admin DSN",
// "Search for trackers to clone" => "Search for trackers to clone",
// "After" => "After",
// "Do you really want to remove the scheduled event" => "Do you really want to remove the scheduled event",
// "Remove event" => "Remove event",
// "No events registered" => "No events registered",
// "Reference date" => "Reference date",
// "After creation" => "After creation",
// "After last modification" => "After last modification",
// "Delay prior to status change" => "Delay prior to status change",
// "Mail subject text" => "Mail subject text",
// "Mail body ressource" => "Mail body ressource",
// "wiki:pageName for a wiki page or tplName.tpl for a template" => "wiki:pageName for a wiki page or tplName.tpl for a template",
// "Existing Article" => "Existing Article",
// "Article URL" => "Article URL",
// "(automatically generated after item creation)" => "(automatically generated after item creation)",
// "Change Event" => "Change Event",
// "Attached files limitation" => "Attached files limitation",
// "The amount of files that can be attached is limited to <strong>%0</strong>. The latest files will be preserved" => "The amount of files that can be attached is limited to <strong>%0</strong>. The latest files will be preserved",
// "Browse files" => "Browse files",
// "Browse Files" => "Browse Files",
// "Link to existing Vimeo URL" => "Link to existing Vimeo URL",
// "Type or paste the URL and press ENTER" => "Type or paste the URL and press ENTER",
// "You do not have permission to upload files to this gallery" => "You do not have permission to upload files to this gallery",
// "You do not have permission to add a member to a group" => "You do not have permission to add a member to a group",
// "Select Icon" => "Select Icon",
// "Remove image" => "Remove image",
// "Are you sure you want to delete this image" => "Are you sure you want to delete this image",
// "{\$field.options_map.addItems|escape}" => "{\$field.options_map.addItems|escape}",
// "Add Media" => "Add Media",
// "Format: x,y,zoom where x is the longitude, and y is the latitude. Zoom is between 0 (view Earth) and 19" => "Format: x,y,zoom where x is the longitude, and y is the latitude. Zoom is between 0 (view Earth) and 19",
// "This bug has been demonstrated on {\$field.options_map.domain|escape}" => "This bug has been demonstrated on {\$field.options_map.domain|escape}",
// "Please demonstrate your bug on {\$field.options_map.domain|escape}" => "Please demonstrate your bug on {\$field.options_map.domain|escape}",
// "Bug needs to be created first" => "Bug needs to be created first",
// "You will be able to demonstrate your bug on a {\$field.options_map.domain|escape} instance once it has been created" => "You will be able to demonstrate your bug on a {\$field.options_map.domain|escape} instance once it has been created",
// "Show.tiki.org snapshot creation is in progress" => "Show.tiki.org snapshot creation is in progress",
// "\\\" href=\\\"http://{\$field.snapshoturl|escape}\\\" target=\\\"_blank\\\">http://{\$field.snapshoturl|escape}</a>\"}Show.tiki.org snapshot creation is in progress... Please monitor %0 for progress" => "\\\" href=\\\"http://{\$field.snapshoturl|escape}\\\" target=\\\"_blank\\\">http://{\$field.snapshoturl|escape}</a>\"}Show.tiki.org snapshot creation is in progress... Please monitor %0 for progress",
// "Note that if you get a popup asking for a username/password, please just enter \"show\" and \"show\"" => "Note that if you get a popup asking for a username/password, please just enter \"show\" and \"show\"",
// "Password reset" => "Password reset",
// "Password reset was successful" => "Password reset was successful",
// "Password reset failed" => "Password reset failed",
// "Show.tiki.org instance destruction in progress" => "Show.tiki.org instance destruction in progress",
// "Show.tiki.org instance destruction is in progress... Please wait.." => "Show.tiki.org instance destruction is in progress... Please wait..",
// "Show.tiki.org is not configured properly" => "Show.tiki.org is not configured properly",
// "The public/private keys configured to connect to {\$field.options_map.domain|escape} were not accepted. Please make sure you are using RSA keys. Thanks" => "The public/private keys configured to connect to {\$field.options_map.domain|escape} were not accepted. Please make sure you are using RSA keys. Thanks",
// "Show.tiki.org is currently unavailable" => "Show.tiki.org is currently unavailable",
// "Unable to connect to {\$field.options_map.domain|escape}. Please let us know of the problem so that we can do something about it. Thanks" => "Unable to connect to {\$field.options_map.domain|escape}. Please let us know of the problem so that we can do something about it. Thanks",
// "Show.tiki.org is under maintenance" => "Show.tiki.org is under maintenance",
// "Show.tiki.org is currently under maintenance. Sorry for the inconvenience" => "Show.tiki.org is currently under maintenance. Sorry for the inconvenience",
// "Unable to get information from {\$field.options_map.domain|escape}" => "Unable to get information from {\$field.options_map.domain|escape}",
// "Unable to get information from {\$field.options_map.domain|escape}. Please let us know of the problem so that we can do something about it. Thanks" => "Unable to get information from {\$field.options_map.domain|escape}. Please let us know of the problem so that we can do something about it. Thanks",
// "Instance is being created" => "Instance is being created",
// "Show.tiki.org is in the progress of creating the new instance. Please continue waiting for a minute or two. If this continues on for more than 10 minutes, please let us know of the problem so that we can do something about it. Thanks" => "Show.tiki.org is in the progress of creating the new instance. Please continue waiting for a minute or two. If this continues on for more than 10 minutes, please let us know of the problem so that we can do something about it. Thanks",
// "About {\$field.options_map.domain|escape}" => "About {\$field.options_map.domain|escape}",
// "To help developers solve the bug, we kindly request that you demonstrate your bug on a {\$field.options_map.domain|escape} instance. To start, simply select a version and click on \"Create {\$field.options_map.domain|escape} instance\". Once the instance is ready (in a minute or two), as indicated in the status window below, you can then access that instance, login (the initial admin username/password is \"admin\") and configure the Tiki to demonstrate your bug. Priority will be given to bugs that have been demonstrated on {\$field.options_map.domain|escape}" => "To help developers solve the bug, we kindly request that you demonstrate your bug on a {\$field.options_map.domain|escape} instance. To start, simply select a version and click on \"Create {\$field.options_map.domain|escape} instance\". Once the instance is ready (in a minute or two), as indicated in the status window below, you can then access that instance, login (the initial admin username/password is \"admin\") and configure the Tiki to demonstrate your bug. Priority will be given to bugs that have been demonstrated on {\$field.options_map.domain|escape}",
// "Create {\$field.options_map.domain|escape} instance" => "Create {\$field.options_map.domain|escape} instance",
// "Accessing the Tiki instance that demonstrates this bug" => "Accessing the Tiki instance that demonstrates this bug",
// "\\\" href=\\\"http://{\$field.showurl|escape}\\\" target=\\\"_blank\\\">http://{\$field.showurl|escape}</a>\"}The URL for the {\$field.options_map.domain|escape} instance that demonstrates this bug is at: %0" => "\\\" href=\\\"http://{\$field.showurl|escape}\\\" target=\\\"_blank\\\">http://{\$field.showurl|escape}</a>\"}The URL for the {\$field.options_map.domain|escape} instance that demonstrates this bug is at: %0",
// "Note that if you get a popup asking for a username/password, please just enter \"show\" and \"show\". This is different from the initial login and password for a new Tiki which is \"admin\" and \"admin\"" => "Note that if you get a popup asking for a username/password, please just enter \"show\" and \"show\". This is different from the initial login and password for a new Tiki which is \"admin\" and \"admin\"",
// "\\\" href=\\\"http://{\$field.showlogurl|escape}\\\" target=\\\"_blank\\\">http://{\$field.showlogurl|escape}</a>\"}For the install log, see %0" => "\\\" href=\\\"http://{\$field.showlogurl|escape}\\\" target=\\\"_blank\\\">http://{\$field.showlogurl|escape}</a>\"}For the install log, see %0",
// "Note that if you see PHP errors or a Tiki claiming to be missing third party software, the instance creation is probably not finished. Please wait a couple minutes and reload" => "Note that if you see PHP errors or a Tiki claiming to be missing third party software, the instance creation is probably not finished. Please wait a couple minutes and reload",
// "Snapshots" => "Snapshots",
// "Snapshots are database dumps of the configuration that developers can download for debugging. Once you have reproduced your bug on the {\$field.options_map.domain|escape} instance, create a snapshot that can then be downloaded by developers for further investigation" => "Snapshots are database dumps of the configuration that developers can download for debugging. Once you have reproduced your bug on the {\$field.options_map.domain|escape} instance, create a snapshot that can then be downloaded by developers for further investigation",
// "\\\" href=\\\"http://{\$field.snapshoturl|escape}\\\" target=\\\"_blank\\\">http://{\$field.snapshoturl|escape}</a>\"}Snapshots can be accessed at: %0" => "\\\" href=\\\"http://{\$field.snapshoturl|escape}\\\" target=\\\"_blank\\\">http://{\$field.snapshoturl|escape}</a>\"}Snapshots can be accessed at: %0",
// "Create new snapshot" => "Create new snapshot",
// "Destroy this {\$field.options_map.domain|escape} instance" => "Destroy this {\$field.options_map.domain|escape} instance",
// "Reset password to 12345" => "Reset password to 12345",
// "SVN update" => "SVN update",
// "Debug Mode Information" => "Debug Mode Information",
// "Get instance information and refresh cache" => "Get instance information and refresh cache",
// "Filter by group" => "Filter by group",
// "Select user(s)" => "Select user(s)",
// "View stand alone wiki page" => "View stand alone wiki page",
// "Source of wiki page" => "Source of wiki page",
// "History of wiki page" => "History of wiki page",
// "No articles" => "No articles",
// "Administrator intervention required" => "Administrator intervention required",
// "Tags is not enabled" => "Tags is not enabled",
// "LastModif" => "LastModif",
// "You did not vote yet" => "You did not vote yet",
// "My rating" => "My rating",
// "{\$field.labels[i]}" => "{\$field.labels[i]}",
// "Click to vote for this value" => "Click to vote for this value",
// "Remove your rating" => "Remove your rating",
// "%0 element(s)" => "%0 element(s)",
// "Language: %0" => "Language: %0",
// "You have subscribed" => "You have subscribed",
// "You have not yet subscribed" => "You have not yet subscribed",
// "with" => "with",
// "friends" => "friends",
// "Translation.." => "Translation..",
// "No language assigned" => "No language assigned",
// "Set page language" => "Set page language",
// "Set article language" => "Set article language",
// "Current language" => "Current language",
// "Show all translations of this page on a single page" => "Show all translations of this page on a single page",
// "All languages" => "All languages",
// "Machine translations" => "Machine translations",
// "Translate page" => "Translate page",
// "Manage page translations" => "Manage page translations",
// "Translate article" => "Translate article",
// "Manage article translations" => "Manage article translations",
// "Are you sure you want to detach these translations" => "Are you sure you want to detach these translations",
// "Current translation set" => "Current translation set",
// "Detach translation" => "Detach translation",
// "Are you sure you want to detach the translation" => "Are you sure you want to detach the translation",
// "No translations available at this time" => "No translations available at this time",
// "Add a new object to the set" => "Add a new object to the set",
// "All possible translations exist" => "All possible translations exist",
// "Email this wiki page" => "Email this wiki page",
// "Enter page name.\n\t\t\t\t\t\tThe wiki page must have a page description, which is used as the subject of the email.\n\t\t\t\t\t\tEnable the page descriptions feature at Control Panels &gt; Wiki" => "Enter page name.\n\t\t\t\t\t\tThe wiki page must have a page description, which is used as the subject of the email.\n\t\t\t\t\t\tEnable the page descriptions feature at Control Panels &gt; Wiki",
// "Bcc" => "Bcc",
// "Enter a valid email to send a blind copy to (optional)" => "Enter a valid email to send a blind copy to (optional)",
// "%0 away" => "%0 away",
// "Shared groups" => "Shared groups",
// "Friendship" => "Friendship",
// "Add to or remove from" => "Add to or remove from",
// "Add to" => "Add to",
// "Remove from" => "Remove from",
// "These groups" => "These groups",
// "Use Ctrl+Click or Command+Click to select multiple options" => "Use Ctrl+Click or Command+Click to select multiple options",
// "Set default group" => "Set default group",
// "Remove users" => "Remove users",
// "Remove the users' pages" => "Remove the users' pages",
// "Remove the user pages belonging to these users" => "Remove the user pages belonging to these users",
// "Delete user items from these trackers" => "Delete user items from these trackers",
// "Warning: Experimental" => "Warning: Experimental",
// "Select trackers here to have items in them which are \"owned\" by these users deleted" => "Select trackers here to have items in them which are \"owned\" by these users deleted",
// "Important: If you set trackers to store user's information, \"User\" and \"Group\" tracker items related to this user will be deleted automatically" => "Important: If you set trackers to store user's information, \"User\" and \"Group\" tracker items related to this user will be deleted automatically",
// "Delete user files" => "Delete user files",
// "Delete the users' file galleries and all the files in them" => "Delete the users' file galleries and all the files in them",
// "Ban users" => "Ban users",
// "Checking this option and clicking OK will redirect you to a form where the selected users are marked for IP Banning" => "Checking this option and clicking OK will redirect you to a form where the selected users are marked for IP Banning",
// "To login to this site you must be %0 years old, which does not match the birthdate of %1 you provided" => "To login to this site you must be %0 years old, which does not match the birthdate of %1 you provided",
// "Cancel login process" => "Cancel login process",
// "You must be at least %0 years old to login into this site. Please provide your birthdate before proceed to login" => "You must be at least %0 years old to login into this site. Please provide your birthdate before proceed to login",
// "Birth date" => "Birth date",
// "Validate your age and proceed to login" => "Validate your age and proceed to login",
// "I approve the above terms and conditions" => "I approve the above terms and conditions",
// "I Decline, log out" => "I Decline, log out",
// "However, no account is associated to the OpenID identifier" => "However, no account is associated to the OpenID identifier",
// "If you use an email filter, be sure to add %0 to your accepted list" => "If you use an email filter, be sure to add %0 to your accepted list",
// "Associate OpenID with an existing Tiki account" => "Associate OpenID with an existing Tiki account",
// "Browse for video file to upload" => "Browse for video file to upload",
// "Upload Progress" => "Upload Progress",
// "Vimeo Setup Error" => "Vimeo Setup Error",
// "{\$errMsg}" => "{\$errMsg}",
// "Available space: %0 megabytes" => "Available space: %0 megabytes",
// "No standard definition uploads available currently" => "No standard definition uploads available currently",
// "No high definition uploads available currently" => "No high definition uploads available currently",
// "Re-generating the URLs may cause 404 errors for links coming from external sources, such as search engines" => "Re-generating the URLs may cause 404 errors for links coming from external sources, such as search engines",
// "You will also need to rebuild your caches and search index" => "You will also need to rebuild your caches and search index",
// "Re-generate URLs" => "Re-generate URLs",
// "The following item(s) include page(s) being deleted and will break" => "The following item(s) include page(s) being deleted and will break",
// "Remove {\$idesc}" => "Remove {\$idesc}",
// "Create redirect" => "Create redirect",
// "Create a 301 Redirect (\\\"moved permanently\\\") to specified page. An SEO-friendly, automatic redirect from the page being deleted to the designated new page (ex.: for search engines or users that may have bookmarked the page being deleted)" => "Create a 301 Redirect (\\\"moved permanently\\\") to specified page. An SEO-friendly, automatic redirect from the page being deleted to the designated new page (ex.: for search engines or users that may have bookmarked the page being deleted)",
// "Redirect to" => "Redirect to",
// "Use this thread to discuss the page" => "Use this thread to discuss the page",
// "Missing or incorrect trackerId parameter for the plugin" => "Missing or incorrect trackerId parameter for the plugin",
"List Trackers" => "列出追蹤項目",
// "resource day" => "resource day",
// "resource month" => "resource month",
// "resource year" => "resource year",
// "resource week" => "resource week",
// "list day" => "list day",
// "list month" => "list month",
// "list year" => "list year",
// "list week" => "list week",
// "list" => "list",
// "agenda month" => "agenda month",
// "agenda week" => "agenda week",
// "agenda day" => "agenda day",
// "{\$params.label|escape}" => "{\$params.label|escape}",
// "Subtract" => "Subtract",
// "Meeting ID" => "Meeting ID",
// "Current attendees" => "Current attendees",
// "No attendees at this time" => "No attendees at this time",
// "Last time we checked, the room you requested did not exist" => "Last time we checked, the room you requested did not exist",
// "Current recordings" => "Current recordings",
// "On %0 from %1 to %2" => "On %0 from %1 to %2",
// "This will permanently remove the recording" => "This will permanently remove the recording",
// "(including audio recording & chat log)" => "(including audio recording & chat log)",
// "{\$button_label}" => "{\$button_label}",
// "{\$moretext|escape}" => "{\$moretext|escape}",
// "{\$ftptitle}" => "{\$ftptitle}",
// "No permission to change the following task" => "No permission to change the following task",
// "Project update not possible as you lack rights for updating a parent project" => "Project update not possible as you lack rights for updating a parent project",
// "Start date is a milestone" => "Start date is a milestone",
// "End date is a milestone" => "End date is a milestone",
// "Task has constraints" => "Task has constraints",
// "Error: there is a dependency on an open task" => "Error: there is a dependency on an open task",
// "Error: due to a descendant of a closed task" => "Error: due to a descendant of a closed task",
// "This task has external dependencies" => "This task has external dependencies",
// "GANNT_ERROR_LOADING_DATA_TASK_REMOVED" => "GANNT_ERROR_LOADING_DATA_TASK_REMOVED",
// "Cannot depend on ancestors" => "Cannot depend on ancestors",
// "The data inserted are invalid for the field format" => "The data inserted are invalid for the field format",
// "An error has occurred while loading the data. A task has been trashed" => "An error has occurred while loading the data. A task has been trashed",
// "Cannot close a task with open issues" => "Cannot close a task with open issues",
// "You cannot exchange tasks of different depth" => "You cannot exchange tasks of different depth",
// "Sem" => "Sem",
// "Cannot move task" => "Cannot move task",
// "Please save your project" => "Please save your project",
// "Error: date settings" => "Error: date settings",
// "Cannot depend on descendants" => "Cannot depend on descendants",
// "code/short name" => "code/short name",
// "start" => "start",
// "dur" => "dur",
// "depe" => "depe",
// "assignees" => "assignees",
// "completed" => "completed",
// "suspended" => "suspended",
// "undefined" => "undefined",
// "Task editor" => "Task editor",
// "is milestone" => "is milestone",
// "status" => "status",
// "progress" => "progress",
// "Assignments" => "Assignments",
// "Role" => "Role",
// "est.wklg" => "est.wklg",
// "Number of Users" => "Number of Users",
// "Percentage of Total" => "Percentage of Total",
// "Email address of invitee" => "Email address of invitee",
// "Set in these groups" => "Set in these groups",
// "Number of result" => "Number of result",
"Message sent to" => "訊息發送至",
// "Email sent to" => "Email sent to",
// "recipients" => "recipients",
// "Message preview" => "Message preview",
// "Number of Recipients" => "Number of Recipients",
// "Send Mail" => "Send Mail",
// "Send to users" => "Send to users",
// "Send to" => "Send to",
// "Email address (if more than one, separated by \",\")" => "Email address (if more than one, separated by \",\")",
// "Send to groups" => "Send to groups",
// "Preview Mail" => "Preview Mail",
// "You will receive a copy of the email yourself. Please give it a few minutes" => "You will receive a copy of the email yourself. Please give it a few minutes",
// "Please wait while your email is being sent.." => "Please wait while your email is being sent..",
// "Previous npm-asset/pdfjs-dist package has been deprecated" => "Previous npm-asset/pdfjs-dist package has been deprecated",
// "To view pdf files Tiki needs npm-asset/pdfjs-dist-viewer-min package" => "To view pdf files Tiki needs npm-asset/pdfjs-dist-viewer-min package",
// "Check to remove" => "Check to remove",
// "Contents of email to be sent to user" => "Contents of email to be sent to user",
// "Append custom message" => "Append custom message",
// "Approve user" => "Approve user",
// "Reject user" => "Reject user",
// "Add in group" => "Add in group",
// "Set as default group for users" => "Set as default group for users",
// "Join myself" => "Join myself",
// "Leave myself" => "Leave myself",
// "Cost for one period" => "Cost for one period",
// "Free for the rest of the current period, a prorated value of" => "Free for the rest of the current period, a prorated value of",
// "Prorated cost for first period" => "Prorated cost for first period",
// "Special offer! Free additional periods" => "Special offer! Free additional periods",
// "Membership to %0 for %1 for %2 %3" => "Membership to %0 for %1 for %2 %3",
// "separated by |" => "separated by |",
// "{\$periodslabel}" => "{\$periodslabel}",
// "vs" => "vs",
// "Mine" => "Mine",
// "Save Changes" => "Save Changes",
// "Edit Pivot Table" => "Edit Pivot Table",
// "Click to view interactive SCORM learning object" => "Click to view interactive SCORM learning object",
// "Download original file" => "Download original file",
// "Re-Apply" => "Re-Apply",
// "wrote" => "wrote",
// "{\$wp_emptymsg}" => "{\$wp_emptymsg}",
// "{\$snarfParams.ajax|escape:html}" => "{\$snarfParams.ajax|escape:html}",
// "Last Day" => "Last Day",
// "Last Week" => "Last Week",
// "{\$action}" => "{\$action}",
// "Groups you are in" => "Groups you are in",
// "(This is an included group)" => "(This is an included group)",
// "(You are a leader)" => "(You are a leader)",
// "Your default group" => "Your default group",
// "Leave Group" => "Leave Group",
// "Manage Group" => "Manage Group",
// "Change default group" => "Change default group",
// "Subscribe to a group" => "Subscribe to a group",
// "Groups you can join" => "Groups you can join",
// "This group requires approval to join" => "This group requires approval to join",
// "Subscribe to groups" => "Subscribe to groups",
"Subscription confirmed!" => "訂閱已確認!",
// "Subscribe to the newsletter" => "Subscribe to the newsletter",
// "Mini TimeSheet" => "Mini TimeSheet",
// "Full View" => "Full View",
// "End tour" => "End tour",
// "-- Choose an option --" => "-- Choose an option --",
// "{\$export_action}" => "{\$export_action}",
// "Map View" => "Map View",
// "Field error" => "Field error",
// "Stop Monitor" => "Stop Monitor",
// "Tracker - " => "Tracker - ",
// "{\$checkbox.title}" => "{\$checkbox.title}",
// "Export Tracker" => "Export Tracker",
// "Close item" => "Close item",
// "Open item" => "Open item",
// "Pend item" => "Pend item",
// "{\$params.label}" => "{\$params.label}",
// "Please login first" => "Please login first",
// "Toggle display" => "Toggle display",
// "Page approved by %0 on %1" => "Page approved by %0 on %1",
// "Page last modified on %0 by %1" => "Page last modified on %0 by %1",
// "Created by %0" => "Created by %0",
// "Last Modification: %0 by %1" => "Last Modification: %0 by %1",
// "Save the page as a partial translation" => "Save the page as a partial translation",
// "Partial Translation" => "Partial Translation",
// "Save the page as a completed translation" => "Save the page as a completed translation",
// "Complete Translation" => "Complete Translation",
// "Save the page, but do not count it as new content to be translated" => "Save the page, but do not count it as new content to be translated",
// "Save the page, but do not send notifications and do not count it as new content to be translated" => "Save the page, but do not send notifications and do not count it as new content to be translated",
"Save Minor Edit" => "次要",
// "Save the page" => "Save the page",
// "If you are an experienced Tiki site administrator, consider whether the advanced features below would be useful for your use case. They are useful for creating a similar set of Tiki objects for different groups of users with like permissions" => "If you are an experienced Tiki site administrator, consider whether the advanced features below would be useful for your use case. They are useful for creating a similar set of Tiki objects for different groups of users with like permissions",
// "Workspaces UI in doc.tiki.org" => "Workspaces UI in doc.tiki.org",
// "Enable using the same wiki page name in different contexts" => "Enable using the same wiki page name in different contexts",
// "E.g. ns1:_:MyPage and ns2:_:MyPage" => "E.g. ns1:_:MyPage and ns2:_:MyPage",
// "Workspaces & Areas admin panel" => "Workspaces & Areas admin panel",
// "Automatic table of contents for a wiki page" => "Automatic table of contents for a wiki page",
// "Auto TOC options" => "Auto TOC options",
// "Auto TOC" => "Auto TOC",
// "Global content category system</h4>\n\t\tItems of different types (wiki pages, articles, tracker items, etc) can be added to one or more categories. Permissions set for a category will apply to all items in that category, allowing access to be restricted to certain groups, users, etc" => "Global content category system</h4>\n\t\tItems of different types (wiki pages, articles, tracker items, etc) can be added to one or more categories. Permissions set for a category will apply to all items in that category, allowing access to be restricted to certain groups, users, etc",
// "Categories are set up in the admin categories panel. Please see the Categories item in the Admin menu" => "Categories are set up in the admin categories panel. Please see the Categories item in the Admin menu",
// "Set up categories here" => "Set up categories here",
// "You have the feature '<strong>Revision Approval</strong>' enabled, but you haven't defined yet which content categories require revision approval for their wiki pages" => "You have the feature '<strong>Revision Approval</strong>' enabled, but you haven't defined yet which content categories require revision approval for their wiki pages",
// "Once you have <a href=\"tiki-admin_categories.php\" class=\"alert-link\" target=\"_blank\">some categories defined</a>, go back to the Configuration Wizard step '<strong>Set up Wiki environment</strong>' and define them there" => "Once you have <a href=\"tiki-admin_categories.php\" class=\"alert-link\" target=\"_blank\">some categories defined</a>, go back to the Configuration Wizard step '<strong>Set up Wiki environment</strong>' and define them there",
// "Configure general user & community features and settings related to sharing and social networks" => "Configure general user & community features and settings related to sharing and social networks",
// "Add a <b>User and Registration tracker</b>" => "Add a <b>User and Registration tracker</b>",
// "User and Registration tracker: You can use trackers to collect additional information for users during registration or even later once they are registered users" => "User and Registration tracker: You can use trackers to collect additional information for users during registration or even later once they are registered users",
// "Some uses of this type of tracker could be" => "Some uses of this type of tracker could be",
// "To collect user information (such as mailing address or phone number)" => "To collect user information (such as mailing address or phone number)",
// "To require the user to acknowledge a user agreement" => "To require the user to acknowledge a user agreement",
// "To prevent spammer registration, by asking new users to provide a reason why they want to join (the prompt should tell the user that his answer should indicate that he or she clearly understands what the site is about)" => "To prevent spammer registration, by asking new users to provide a reason why they want to join (the prompt should tell the user that his answer should indicate that he or she clearly understands what the site is about)",
// "The profile will enable the feature 'Trackers' for you and a few other settings required. Once the profile is applied, you will be provided with instructions about further steps that you need to perform manually" => "The profile will enable the feature 'Trackers' for you and a few other settings required. Once the profile is applied, you will be provided with instructions about further steps that you need to perform manually",
// "apply profile now" => "apply profile now",
// "new window" => "new window",
// "To set up the <strong>User Watches</strong> and their associated settings, visit the page to " => "To set up the <strong>User Watches</strong> and their associated settings, visit the page to ",
// "Community General Settings" => "Community General Settings",
// "admin panel" => "admin panel",
// "in doc.tiki.org" => "in doc.tiki.org",
// "Sharing & Networking" => "Sharing & Networking",
// "Social Network" => "Social Network",
// "Friendship and Followers" => "Friendship and Followers",
// "Set the site time zone and format for displaying dates and times" => "Set the site time zone and format for displaying dates and times",
// "Date and Time options" => "Date and Time options",
// "Date and Time admin panel" => "Date and Time admin panel",
// "Select editor type" => "Select editor type",
// "Only Plain Text Editor (Disable Wysiwyg)" => "Only Plain Text Editor (Disable Wysiwyg)",
// "Use only the plain text editor, which is the most stable editor mode and most compatible with Tiki functionality. The Full WYSIWYG Editor will be disabled, but you will still be able to insert wysiwyg sections through the Plain Text editor with <a href=\"https://doc.tiki.org/PluginWysiwyg\" alt=\"Link to Plugin Wysiwyg doc. page\" target=\"blank\">Plugin Wysiwyg</a>" => "Use only the plain text editor, which is the most stable editor mode and most compatible with Tiki functionality. The Full WYSIWYG Editor will be disabled, but you will still be able to insert wysiwyg sections through the Plain Text editor with <a href=\"https://doc.tiki.org/PluginWysiwyg\" alt=\"Link to Plugin Wysiwyg doc. page\" target=\"blank\">Plugin Wysiwyg</a>",
// "Use a What You See Is What You Get (Wysiwyg) editor, by default in all new pages or only in some when selected. Provides a visual interface preferred by many. You will be able to configure the Full WYSIWYG Editor options in a next wizard page" => "Use a What You See Is What You Get (Wysiwyg) editor, by default in all new pages or only in some when selected. Provides a visual interface preferred by many. You will be able to configure the Full WYSIWYG Editor options in a next wizard page",
// "It won’t change the editor on existing pages. If you just install your Tiki, note that the HomePage has already been created with the plain editor" => "It won’t change the editor on existing pages. If you just install your Tiki, note that the HomePage has already been created with the plain editor",
// "Set up the main Tiki features. The wiki and file gallery features are always enabled" => "Set up the main Tiki features. The wiki and file gallery features are always enabled",
// "Main Tiki features" => "Main Tiki features",
// "Tiki has many more features" => "Tiki has many more features",
// "Global Features" => "Global Features",
// "Enable email notifications to users when changes in the content of specific items (pages, posts, trackers, etc.) are made" => "Enable email notifications to users when changes in the content of specific items (pages, posts, trackers, etc.) are made",
// "Set up the file gallery and attachments" => "Set up the file gallery and attachments",
// "Choose to store them either in the database or in files on disk, among other options" => "Choose to store them either in the database or in files on disk, among other options",
// "This setting makes the feature available, go to next wizard page to apply elFinder to File Galleries.\n\t\t\t\t\t\tThis setting also activates jQuery, which is required for elFinder" => "This setting makes the feature available, go to next wizard page to apply elFinder to File Galleries.\n\t\t\t\t\t\tThis setting also activates jQuery, which is required for elFinder",
// "elFinder" => "elFinder",
// "Wiki admin panel" => "Wiki admin panel",
// "File storage" => "File storage",
// "Set elFinder as the default file gallery viewer" => "Set elFinder as the default file gallery viewer",
// "File Gallery storage" => "File Gallery storage",
// "Attachment storage" => "Attachment storage",
// "Select the site language" => "Select the site language",
// "Language options" => "Language options",
// "Configure the log-in, registration and validation preferences for the new accounts" => "Configure the log-in, registration and validation preferences for the new accounts",
// "Registration and log-in options" => "Registration and log-in options",
// "Login admin panel" => "Login admin panel",
// "Configure the Tiki theme and other look & feel preferences" => "Configure the Tiki theme and other look & feel preferences",
// "Look & Feel options" => "Look & Feel options",
// "Look & Feel admin panel" => "Look & Feel admin panel",
// "Namespace settings" => "Namespace settings",
// "There are two search systems in Tiki that use different search engines: <strong>Basic Search</strong> and <strong>Advanced Search</strong>" => "There are two search systems in Tiki that use different search engines: <strong>Basic Search</strong> and <strong>Advanced Search</strong>",
// "The Advanced Search generally provides better results, but is more demanding on the server (it creates a search index, updated either incrementally or based on a cron job configured elsewhere)" => "The Advanced Search generally provides better results, but is more demanding on the server (it creates a search index, updated either incrementally or based on a cron job configured elsewhere)",
// "Basic Search" => "Basic Search",
// "Uses MySQL full-text search" => "Uses MySQL full-text search",
// "If enabled, the search module and search feature in the main application menu will use it by default, even if 'Advanced Search' is also enabled below" => "If enabled, the search module and search feature in the main application menu will use it by default, even if 'Advanced Search' is also enabled below",
// "Advanced Search" => "Advanced Search",
// "Uses Unified Search Index with a specified search engine" => "Uses Unified Search Index with a specified search engine",
// "If you have issues with Advanced Search, simply revert to Basic Search" => "If you have issues with Advanced Search, simply revert to Basic Search",
// "Unified Search is required by a number of other features, e.g. the community friendship network" => "Unified Search is required by a number of other features, e.g. the community friendship network",
// "Other settings" => "Other settings",
// "Also see the Search Indexing tab here" => "Also see the Search Indexing tab here",
// "Search admin card" => "Search admin card",
// "Search in doc.tiki.org" => "Search in doc.tiki.org",
// "Hierarchical organization of wiki pages" => "Hierarchical organization of wiki pages",
// "Structures organize a group of wiki pages into a tree or book that can be easily navigated by users. Creating a structure is the fastest method for creating multiple pages at once. It's a great way to make a book, as well as to allow users to create new pages that will be automatically found in a common table of contents. New pages can inherit permissions from the structure homepage" => "Structures organize a group of wiki pages into a tree or book that can be easily navigated by users. Creating a structure is the fastest method for creating multiple pages at once. It's a great way to make a book, as well as to allow users to create new pages that will be automatically found in a common table of contents. New pages can inherit permissions from the structure homepage",
// "Structures options" => "Structures options",
// "Set up the text area environment (Editing and Plugins)" => "Set up the text area environment (Editing and Plugins)",
// "Editing and plugins admin panel" => "Editing and plugins admin panel",
// "Set up the Wiki environment" => "Set up the Wiki environment",
// "Wiki environment" => "Wiki environment",
// "Look for the <img src=\"img/icons/camera.png\" /> icon in the editor toolbar" => "Look for the <img src=\"img/icons/camera.png\" /> icon in the editor toolbar",
// "Requires Java" => "Requires Java",
// "Verify your Java installation" => "Verify your Java installation",
// "Once you have the feature '<strong>Categories</strong>' enabled, you will need to define some content categories, and indicate which ones require revision approval for their wiki pages" => "Once you have the feature '<strong>Categories</strong>' enabled, you will need to define some content categories, and indicate which ones require revision approval for their wiki pages",
// "You will be able to set the category ids here when you come back with Categories enabled, or at the corresponding <a href=\"tiki-admin.php?page=wiki&cookietab=3\" class=\"alert-link\" target=\"_blank\">Control Panel</a> with the '<em>Advanced</em>' features shown in the <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Preference+Filters'>Preference Filters</a>" => "You will be able to set the category ids here when you come back with Categories enabled, or at the corresponding <a href=\"tiki-admin.php?page=wiki&cookietab=3\" class=\"alert-link\" target=\"_blank\">Control Panel</a> with the '<em>Advanced</em>' features shown in the <a class='alert-link' target='tikihelp' href='https://doc.tiki.org/Preference+Filters'>Preference Filters</a>",
// "Get Started" => "Get Started",
// "Congratulations! You now have a working instance of Tiki %0" => "Congratulations! You now have a working instance of Tiki %0",
// "You may <a href=\"tiki-index.php\">start using it right away</a>, or you may configure it to better meet your needs, using one of the configuration helpers below" => "You may <a href=\"tiki-index.php\">start using it right away</a>, or you may configure it to better meet your needs, using one of the configuration helpers below",
// "Mouse over the icons to know more about the features and preferences that are new for you" => "Mouse over the icons to know more about the features and preferences that are new for you",
// "Example: " => "Example: ",
// "Help icon" => "Help icon",
// "You will get more information about the features and preferences whenever this icon is available and you pass your mouse over it" => "You will get more information about the features and preferences whenever this icon is available and you pass your mouse over it",
// "Moreover, if you click on it, you'll be directed in a new window to the corresponding documentation page for further information on that feature or topic" => "Moreover, if you click on it, you'll be directed in a new window to the corresponding documentation page for further information on that feature or topic",
// "Configuration Profiles Wizard" => "Configuration Profiles Wizard",
// "You may start by applying some of our configuration templates through the <b>Configuration Profiles Wizard</b>" => "You may start by applying some of our configuration templates through the <b>Configuration Profiles Wizard</b>",
// "They are like the <b>Macros</b> from many computer languages" => "They are like the <b>Macros</b> from many computer languages",
// "It is best to apply them from the start and you can always preview and reverse the process" => "It is best to apply them from the start and you can always preview and reverse the process",
// "Configuration Profiles" => "Configuration Profiles",
// "Each of these provides a shrink-wrapped solution that meets most of the needs of a particular kind of community or site (Personal Blog space, Company Intranet, ...) or that extends basic setup with extra features configured for you" => "Each of these provides a shrink-wrapped solution that meets most of the needs of a particular kind of community or site (Personal Blog space, Company Intranet, ...) or that extends basic setup with extra features configured for you",
// "If you are new to Tiki administration, we recommend that you start with this approach" => "If you are new to Tiki administration, we recommend that you start with this approach",
// "If the profile you selected does not quite meet your needs, you will still have the option of customizing it further with one of the approaches below" => "If the profile you selected does not quite meet your needs, you will still have the option of customizing it further with one of the approaches below",
// "Start Configuration Profiles Wizard (Macros)" => "Start Configuration Profiles Wizard (Macros)",
// "Configuration Walkthrough" => "Configuration Walkthrough",
// "Alternatively, you may use the <b>Configuration Wizard</b>" => "Alternatively, you may use the <b>Configuration Wizard</b>",
// "This will guide you through the most common preference settings in order to customize your site" => "This will guide you through the most common preference settings in order to customize your site",
// "You will easily be able to configure options like: languages, date and time, user login, theme, website title and logo, etc" => "You will easily be able to configure options like: languages, date and time, user login, theme, website title and logo, etc",
// "Use this wizard if none of the <b>Configuration Profiles</b> look like a good starting point, or if you need to customize your site further" => "Use this wizard if none of the <b>Configuration Profiles</b> look like a good starting point, or if you need to customize your site further",
// "Start Configuration Wizard" => "Start Configuration Wizard",
// "Or you may use the <b>Changes Wizard</b>" => "Or you may use the <b>Changes Wizard</b>",
// "This will guide you through the most common new settings and informations in order to upgrade your site" => "This will guide you through the most common new settings and informations in order to upgrade your site",
// "Use this wizard if you are upgrading from previous versions of Tiki, specially if you come from the previous Long-Term Support (LTS) version" => "Use this wizard if you are upgrading from previous versions of Tiki, specially if you come from the previous Long-Term Support (LTS) version",
// "Some of these settings are also available through the Configuration Wizard, and all of them are available through Control Panels" => "Some of these settings are also available through the Configuration Wizard, and all of them are available through Control Panels",
// "But this wizard will let you learn about them as well as enable/disable them easily according to your needs and interests for your site" => "But this wizard will let you learn about them as well as enable/disable them easily according to your needs and interests for your site",
// "Start Changes Wizard" => "Start Changes Wizard",
// "Use the <b>Control Panels</b> to manually browse through the full list of preferences" => "Use the <b>Control Panels</b> to manually browse through the full list of preferences",
// "From the main administration page you'll be able to configure your Tiki, to enable features not set on by default and to change settings" => "From the main administration page you'll be able to configure your Tiki, to enable features not set on by default and to change settings",
// "To Avoid Getting Overwhelmed by the impressive number of settings as a Startup Tiki Admin we set a preferences filters for Basic and Advanced features to start with" => "To Avoid Getting Overwhelmed by the impressive number of settings as a Startup Tiki Admin we set a preferences filters for Basic and Advanced features to start with",
// "Explore the control panels and configure your Tiki manually" => "Explore the control panels and configure your Tiki manually",
// "Go to the Control Panels" => "Go to the Control Panels",
// "You can check if your server meets the requirements for running Tiki version %0" => "You can check if your server meets the requirements for running Tiki version %0",
// "Using our home made standalone script for server environment settings diagnostics you can check that everything is ready to run your Tiki properly" => "Using our home made standalone script for server environment settings diagnostics you can check that everything is ready to run your Tiki properly",
// "It is very useful for any PHP app, as it checks over 50 different things and provides contextual feedback" => "It is very useful for any PHP app, as it checks over 50 different things and provides contextual feedback",
// "Check your server fitness" => "Check your server fitness",
// "Go to the Tiki Server Compatibility Check" => "Go to the Tiki Server Compatibility Check",
// "You are done with the admin wizard" => "You are done with the admin wizard",
// "Choose another <a href=\"%0\">Wizard</a> to continue configuring your site as admin" => "Choose another <a href=\"%0\">Wizard</a> to continue configuring your site as admin",
// "Visit the <a href=\"%0\">User Wizard</a> to set some of your user preferences as a user" => "Visit the <a href=\"%0\">User Wizard</a> to set some of your user preferences as a user",
// "Or click at the button <strong>Finish</strong> to end the admin wizard and go back to the where you were" => "Or click at the button <strong>Finish</strong> to end the admin wizard and go back to the where you were",
// "You can choose to use by default the 'Compatible' Wiki mode (content is saved in wiki syntax), or the HTML mode" => "You can choose to use by default the 'Compatible' Wiki mode (content is saved in wiki syntax), or the HTML mode",
// "Wysiwyg editor" => "Wysiwyg editor",
// "Select the Wysiwyg editor mode" => "Select the Wysiwyg editor mode",
// "Compatible Wiki mode" => "Compatible Wiki mode",
// "Use wiki syntax for saved pages" => "Use wiki syntax for saved pages",
// "This is the most compatible with Tiki functionality and the most stable editor mode" => "This is the most compatible with Tiki functionality and the most stable editor mode",
// "Tools and functions in the editor toolbar will be limited" => "Tools and functions in the editor toolbar will be limited",
// "HTML mode" => "HTML mode",
// "Use HTML syntax for saved pages" => "Use HTML syntax for saved pages",
// "Best compatibility with inline editing" => "Best compatibility with inline editing",
// "Loses some wiki related features, such as SlideShow, and has some problems with SEFURL" => "Loses some wiki related features, such as SlideShow, and has some problems with SEFURL",
// "Full editor toolbar" => "Full editor toolbar",
// "Wysiwyg admin panel" => "Wysiwyg admin panel",
// "Documentation site" => "Documentation site",
// "Related pages from the Official Documentation site <em>https://doc.tiki.org</em>" => "Related pages from the Official Documentation site <em>https://doc.tiki.org</em>",
// "To see it in full size out of this frame" => "To see it in full size out of this frame",
// "Main new features and settings in Tiki 13" => "Main new features and settings in Tiki 13",
// "Tiki13" => "Tiki13",
// "Tiki13 is a post-LTS version" => "Tiki13 is a post-LTS version",
// "It will be supported until 14.1 is released" => "It will be supported until 14.1 is released",
// "The requirements increased (IE9, PHP 5.5)" => "The requirements increased (IE9, PHP 5.5)",
// "Major changes have happened, including moving to Bootstrap" => "Major changes have happened, including moving to Bootstrap",
// "New Themes" => "New Themes",
// "Site layouts (based on 'Bootstrap')" => "Site layouts (based on 'Bootstrap')",
// "The changes in this area were refactored in Tiki 14" => "The changes in this area were refactored in Tiki 14",
// "Goal, Recognition and Rewards" => "Goal, Recognition and Rewards",
// "Main new features and settings in Tiki 14" => "Main new features and settings in Tiki 14",
// "Tiki14" => "Tiki14",
// "Tiki14 is a standard non-LTS version" => "Tiki14 is a standard non-LTS version",
// "It will be supported until 15.1 is released" => "It will be supported until 15.1 is released",
// "The requirements are the same as in the previous version (IE9, PHP 5.5)" => "The requirements are the same as in the previous version (IE9, PHP 5.5)",
// "Minor changes have happened, compared to post-LTS versions such as Tiki13" => "Minor changes have happened, compared to post-LTS versions such as Tiki13",
// "New modules" => "New modules",
// "A new module called <strong>Module zone</strong> was added" => "A new module called <strong>Module zone</strong> was added",
// "Module zone" => "Module zone",
// "New module meant to provide a horizontal 'navigation bar' for the website" => "New module meant to provide a horizontal 'navigation bar' for the website",
// "Tiki Addons" => "Tiki Addons",
// "Addons allow a way for developers to add an even broader range of functionality" => "Addons allow a way for developers to add an even broader range of functionality",
// "Addons" => "Addons",
// "Tiki is already one of the most feature-rich social business/web content management platforms that exist today, where hundreds of developers have contributed directly to its codebase" => "Tiki is already one of the most feature-rich social business/web content management platforms that exist today, where hundreds of developers have contributed directly to its codebase",
// "Nevertheless, in Tiki 14, the Tiki Addons feature was added to allow a way for developers to add an even broader range of functionality that can be used with Tiki" => "Nevertheless, in Tiki 14, the Tiki Addons feature was added to allow a way for developers to add an even broader range of functionality that can be used with Tiki",
// "Other new features" => "Other new features",
// "Improved and extended features" => "Improved and extended features",
// "See the full list of changes" => "See the full list of changes",
// "Main new features and settings in Tiki 15" => "Main new features and settings in Tiki 15",
// "Tiki15" => "Tiki15",
// "Tiki15 is an LTS version" => "Tiki15 is an LTS version",
// "As it is a Long-Term Support (LTS) version, it will be supported for 5 years" => "As it is a Long-Term Support (LTS) version, it will be supported for 5 years",
// "The requirements are the same as in the previous version (IE9, PHP 5.5), plus php5-curl and php5-intl are now recommended" => "The requirements are the same as in the previous version (IE9, PHP 5.5), plus php5-curl and php5-intl are now recommended",
// "In Tiki 14, the Tiki Addons feature was added to allow a way for developers <br/>to add an even broader range of functionality that can be used with Tiki" => "In Tiki 14, the Tiki Addons feature was added to allow a way for developers <br/>to add an even broader range of functionality that can be used with Tiki",
// "In Tiki 15, an addons repository was added" => "In Tiki 15, an addons repository was added",
// "New Wiki Plugins" => "New Wiki Plugins",
// "Social Networks with Linkedin" => "Social Networks with Linkedin",
// "Temporary User Accounts" => "Temporary User Accounts",
// "Display more information here" => "Display more information here",
// "You can use this feature through: " => "You can use this feature through: ",
// "Admin Users > Temporary Users (tab)" => "Admin Users > Temporary Users (tab)",
// "Statistics Control Panel" => "Statistics Control Panel",
// "You are highly recommended to use a file directory as the File Gallery storage, when using this feature" => "You are highly recommended to use a file directory as the File Gallery storage, when using this feature",
// "Console" => "Console",
// "There is a console.php command to set a scheduled batch upload cron task" => "There is a console.php command to set a scheduled batch upload cron task",
// "A couple of helper commands to manage multitikis.\nList the sites in a tiki instance and move a site from one tiki to another to help with upgrades etc (using local file access only)" => "A couple of helper commands to manage multitikis.\nList the sites in a tiki instance and move a site from one tiki to another to help with upgrades etc (using local file access only)",
// "Removed features" => "Removed features",
// "Synchronize categories of user tracker item to user groups" => "Synchronize categories of user tracker item to user groups",
// "Main new and improved features and settings in Tiki 16" => "Main new and improved features and settings in Tiki 16",
// "Tiki16" => "Tiki16",
// "Tiki16 is a standard non-LTS version" => "Tiki16 is a standard non-LTS version",
// "It will be supported until 17.1 is released" => "It will be supported until 17.1 is released",
// "New PHP minimum requirement for Tiki 16 is PHP 5.6" => "New PHP minimum requirement for Tiki 16 is PHP 5.6",
// "Many libraries have been upgraded; most notably, jQuery 3.0, Bootstrap Tour v0.11.0 among others" => "Many libraries have been upgraded; most notably, jQuery 3.0, Bootstrap Tour v0.11.0 among others",
// "Tracker Force-Fill Feature" => "Tracker Force-Fill Feature",
// "Improved Fields" => "Improved Fields",
// "Improved Plugins and extended features" => "Improved Plugins and extended features",
// "There are a few new console.php commands to set scheduled cron tasks" => "There are a few new console.php commands to set scheduled cron tasks",
// "Filtering to Index-based Plugins" => "Filtering to Index-based Plugins",
// "Filter UI added in any wiki plugin using unified search index" => "Filter UI added in any wiki plugin using unified search index",
// "PDF Settings (Control Panel > Print)" => "PDF Settings (Control Panel > Print)",
// "New method to create PDF: mPDF" => "New method to create PDF: mPDF",
// "New Profiles" => "New Profiles",
// "Bug_Tracker_16" => "Bug_Tracker_16",
// "Execute on list" => "Execute on list",
// "GeoCMS_Maps" => "GeoCMS_Maps",
// "Work_Custom_Pricing" => "Work_Custom_Pricing",
// "Main new and improved features and settings in Tiki 17" => "Main new and improved features and settings in Tiki 17",
// "Tiki17" => "Tiki17",
// "Tiki17 is a standard non-LTS version" => "Tiki17 is a standard non-LTS version",
// "It will be supported until 18.1 is released" => "It will be supported until 18.1 is released",
// "Many libraries have been upgraded" => "Many libraries have been upgraded",
// "Improved Plugins" => "Improved Plugins",
// "HTTP Header Options" => "HTTP Header Options",
// "Intrusion Detection System (IDS) with Expose" => "Intrusion Detection System (IDS) with Expose",
// "Other new or Extended Features" => "Other new or Extended Features",
// "Preferences can be set" => "Preferences can be set",
// "One system cron job can trigger all required actions at their specific scheduled times" => "One system cron job can trigger all required actions at their specific scheduled times",
// "Main new and improved features and settings in Tiki 18" => "Main new and improved features and settings in Tiki 18",
// "Tiki18" => "Tiki18",
// "This is an LTS version" => "This is an LTS version",
// "New Features" => "New Features",
// "Composer Web Install (<b>Packages</b>)" => "Composer Web Install (<b>Packages</b>)",
// "Style guide tool" => "Style guide tool",
// "Look and feel colors can be customized with a style guide tool" => "Look and feel colors can be customized with a style guide tool",
// "PDF from URL: mPDF new settings" => "PDF from URL: mPDF new settings",
// "Other Extended Features" => "Other Extended Features",
// "Real-time collaboration tools (<b>RTC</b>)" => "Real-time collaboration tools (<b>RTC</b>)",
// "New actions can be performed" => "New actions can be performed",
// "Drag and drop added to menu management" => "Drag and drop added to menu management",
// "Profiles" => "Profiles",
// "Dry-run/Preview and Selective Rollback were added, as well as new options to allow exporting files and tracker items" => "Dry-run/Preview and Selective Rollback were added, as well as new options to allow exporting files and tracker items",
// "Calendars and Calendar Items will now appear in search results of the unified search index" => "Calendars and Calendar Items will now appear in search results of the unified search index",
// "Certain tracker fields can be converted keeping options" => "Certain tracker fields can be converted keeping options",
// "New Fields" => "New Fields",
// "Activity_Stream" => "Activity_Stream",
// "Simple_Forum" => "Simple_Forum",
// "Timesheets_Tracker" => "Timesheets_Tracker",
// "User_Profile_Business" => "User_Profile_Business",
// "Main new and improved features and settings in Tiki 19" => "Main new and improved features and settings in Tiki 19",
// "Tiki19" => "Tiki19",
// "It is a Standard Term Support (STS) version" => "It is a Standard Term Support (STS) version",
// "It will be supported until Tiki 20.1 is released" => "It will be supported until Tiki 20.1 is released",
// "Some internal libraries and optional external packages have been upgraded or replaced by more updated ones" => "Some internal libraries and optional external packages have been upgraded or replaced by more updated ones",
// "Federation" => "Federation",
// "Other New Features" => "Other New Features",
// "Added a preview button in tracker field files to enable pdf view in new window without download document" => "Added a preview button in tracker field files to enable pdf view in new window without download document",
// "'Save and comment' can be enabled per tracker and permits to add a comment when saving an edit for a tracker item" => "'Save and comment' can be enabled per tracker and permits to add a comment when saving an edit for a tracker item",
// "Create tracker from File" => "Create tracker from File",
// "GanttChart" => "GanttChart",
// "Hide Fixed Top Nav Bar on Scroll 19" => "Hide Fixed Top Nav Bar on Scroll 19",
// "Scheduler_Presets" => "Scheduler_Presets",
// "And many more improvements" => "And many more improvements",
// "Main new and improved features and settings in Tiki 20" => "Main new and improved features and settings in Tiki 20",
// "Tiki20" => "Tiki20",
// "It will be supported until Tiki 21.1 is released" => "It will be supported until Tiki 21.1 is released",
// "Groupmail_20" => "Groupmail_20",
// "Improvements that can help novice admins to set up their tiki sites more easily and improve their usability" => "Improvements that can help novice admins to set up their tiki sites more easily and improve their usability",
// "Basic Information about Wizards" => "Basic Information about Wizards",
// "Starting in Tiki12, some wizards were added to Tiki in order to help in the initial setup based on configuration templates like \"Macros\" (<b>Profiles Wizard</b>), as well as further site configuration (<b>Configuration Wizard</b>), fine tunning the new features and preferences when upgrading (<b>Changes Wizard</b>), and to help you as site admin to collect more information from your users if you need it (<b>Users Wizard</b>)" => "Starting in Tiki12, some wizards were added to Tiki in order to help in the initial setup based on configuration templates like \"Macros\" (<b>Profiles Wizard</b>), as well as further site configuration (<b>Configuration Wizard</b>), fine tunning the new features and preferences when upgrading (<b>Changes Wizard</b>), and to help you as site admin to collect more information from your users if you need it (<b>Users Wizard</b>)",
// "Wizards oriented to help the site admin (Profiles, Configuration and Changes Wizards) come always enabled" => "Wizards oriented to help the site admin (Profiles, Configuration and Changes Wizards) come always enabled",
// "The User Wizard comes disabled by default, and you have the option to enable it and configure it for your site" => "The User Wizard comes disabled by default, and you have the option to enable it and configure it for your site",
// "Wizards settings" => "Wizards settings",
// "Here you can see listed other features and settings that were not included in the previous sections" => "Here you can see listed other features and settings that were not included in the previous sections",
// "Ratings in Forums" => "Ratings in Forums",
// "New option per forum: \"User information display > <strong>Topic Rating</strong>\" by each user" => "New option per forum: \"User information display > <strong>Topic Rating</strong>\" by each user",
// "Topic Rating by each user" => "Topic Rating by each user",
// "Since Tiki12.2, there is a new forum setting to allow the optional display of the Rating by each user to that forum thread topic in each reply" => "Since Tiki12.2, there is a new forum setting to allow the optional display of the Rating by each user to that forum thread topic in each reply",
// "This setting is useful to ease the task to reach consensus on deliberations (in forum threads) by identifying in a more clear way the position (topic rating) of each person on that topic at each moment on the discussion" => "This setting is useful to ease the task to reach consensus on deliberations (in forum threads) by identifying in a more clear way the position (topic rating) of each person on that topic at each moment on the discussion",
// "Sysadmin Tasks" => "Sysadmin Tasks",
// "Search Index" => "Search Index",
// "You can rebuild the unified search index (feature '<b>Advanced Search</b>') by visiting example.com/tiki-admin.php?page=search&rebuild=now or through setting a <b>cron job</b>" => "You can rebuild the unified search index (feature '<b>Advanced Search</b>') by visiting example.com/tiki-admin.php?page=search&rebuild=now or through setting a <b>cron job</b>",
// "Cron Job to Rebuild Search Index" => "Cron Job to Rebuild Search Index",
// "Starting in Tiki9, if you had a large site you should set up a Cron job to regularly rebuild the search index" => "Starting in Tiki9, if you had a large site you should set up a Cron job to regularly rebuild the search index",
// "Starting in Tiki11, the syntax to rebuild the search index changed" => "Starting in Tiki11, the syntax to rebuild the search index changed",
// "Starting in Tiki11, <b>console.php</b> script exists to help you administer your Tiki or <em>MultiTiki</em> instance via the command line" => "Starting in Tiki11, <b>console.php</b> script exists to help you administer your Tiki or <em>MultiTiki</em> instance via the command line",
// "Console (console.php script)" => "Console (console.php script)",
// "Example: Database update" => "Example: Database update",
// "In case of Tikis with domains <code>site1.example.com</code> & <code>site2.example.com</code>, in a <em>MultiTiki</em> setup, append an argument like <code> --site=sitename.example.com</code>" => "In case of Tikis with domains <code>site1.example.com</code> & <code>site2.example.com</code>, in a <em>MultiTiki</em> setup, append an argument like <code> --site=sitename.example.com</code>",
// "Mail Queue" => "Mail Queue",
// "Daily Reports for User Watches" => "Daily Reports for User Watches",
// "Starting in Tiki12.2, console.php also handles the feature <strong>Mail Queue</strong>, which has been also fixed, and it is a very useful feature in Tikis with heavy load of notification email sending" => "Starting in Tiki12.2, console.php also handles the feature <strong>Mail Queue</strong>, which has been also fixed, and it is a very useful feature in Tikis with heavy load of notification email sending",
// "When Tiki has many notification emails to send upon new changes in your site (e.g. a new calendar event), the site may seem unresponsive for some seconds until the whole mail delivery is finished" => "When Tiki has many notification emails to send upon new changes in your site (e.g. a new calendar event), the site may seem unresponsive for some seconds until the whole mail delivery is finished",
// "The more users or groups subscribed to receive notification emails for changes in that object, the longer that unresponsive time just after the user has clicked the submit button" => "The more users or groups subscribed to receive notification emails for changes in that object, the longer that unresponsive time just after the user has clicked the submit button",
// "You can prevent that unresponsive time by means of setting Tiki to store notification emails in an email queue (see <strong>Settings > Control Panels > General > General Preferences > Mail > Mail sender > STMP</strong>, and <strong>Mail Delivery > Queue</strong>), and request the server to process the email sending based on a cron job" => "You can prevent that unresponsive time by means of setting Tiki to store notification emails in an email queue (see <strong>Settings > Control Panels > General > General Preferences > Mail > Mail sender > STMP</strong>, and <strong>Mail Delivery > Queue</strong>), and request the server to process the email sending based on a cron job",
// "Example: Send the Mail Queue" => "Example: Send the Mail Queue",
// "And since Tiki12.3, console.php also handles <strong>Daily Reports for User Watches</strong>, which finally allows this feature to be used in '<em>MultiTiki</em>' setups" => "And since Tiki12.3, console.php also handles <strong>Daily Reports for User Watches</strong>, which finally allows this feature to be used in '<em>MultiTiki</em>' setups",
// "This feature which allows users to choose to received notification emails grouped in a periodic digest with the frequency they choose (daily, weekly, ...)" => "This feature which allows users to choose to received notification emails grouped in a periodic digest with the frequency they choose (daily, weekly, ...)",
// "Example: Send the Daily Report" => "Example: Send the Daily Report",
// "Other Features" => "Other Features",
// "New permissions and action log settings" => "New permissions and action log settings",
// "Wiki Inline Editing" => "Wiki Inline Editing",
// "Starting in Tiki12, Tiki offers the option to edit inline a wiki page in wysiwyg mode with a simplified editor, which is based on Ckeditor4" => "Starting in Tiki12, Tiki offers the option to edit inline a wiki page in wysiwyg mode with a simplified editor, which is based on Ckeditor4",
// "The editor can be quickly turned on/off. All processing is done client side" => "The editor can be quickly turned on/off. All processing is done client side",
// "Starting in Tiki12, Rating results can be selectively shown to just some user groups, as well as a few other new settings were introduced to fine tune the information shown" => "Starting in Tiki12, Rating results can be selectively shown to just some user groups, as well as a few other new settings were introduced to fine tune the information shown",
// "bigbluebutton" => "bigbluebutton",
// "New explicit permission tiki_p_bigbluebutton_view_rec needed to view recordings" => "New explicit permission tiki_p_bigbluebutton_view_rec needed to view recordings",
// "tiki_p_bigbluebutton_view_rec is no longer implicit if tiki_p_bigbluebutton_join is granted" => "tiki_p_bigbluebutton_view_rec is no longer implicit if tiki_p_bigbluebutton_join is granted",
// "Switch editor" => "Switch editor",
// "Starting in Tiki7, Tiki offers the option to allow users to switch the editor from plain text to wysiwyg and viceversa, provided that the user belongs to a group with this required permission granted" => "Starting in Tiki7, Tiki offers the option to allow users to switch the editor from plain text to wysiwyg and viceversa, provided that the user belongs to a group with this required permission granted",
// "Action log settings" => "Action log settings",
// "Joined Room" => "Joined Room",
// "Left Room" => "Left Room",
// "You are reaching the end of the <em>Changes Wizard</em>" => "You are reaching the end of the <em>Changes Wizard</em>",
// "Since you are upgrading, you probably had a previous installation of Tiki for a while, and you may already have some experience using a few Tiki features, at least" => "Since you are upgrading, you probably had a previous installation of Tiki for a while, and you may already have some experience using a few Tiki features, at least",
// "That's why we would like to <strong>ask you to send us some feedback about your usage of Tiki</strong>, while having the chance to connect in the future with other Tiki Admins near you in the Tiki Community" => "That's why we would like to <strong>ask you to send us some feedback about your usage of Tiki</strong>, while having the chance to connect in the future with other Tiki Admins near you in the Tiki Community",
// "Once '<em>Tiki Connect</em>' is enabled, when you click the '<strong>Send Info</strong>' button below you will be connected with <em>mother.tiki.org</em>, which is where the data will be collected" => "Once '<em>Tiki Connect</em>' is enabled, when you click the '<strong>Send Info</strong>' button below you will be connected with <em>mother.tiki.org</em>, which is where the data will be collected",
// "You can also send feedback about Tiki by checking the '<em>Provide Feedback</em>' checkbox (once <em>Tiki Connect</em> is enabled), next to the '<em>Show on admin login</em>' above" => "You can also send feedback about Tiki by checking the '<em>Provide Feedback</em>' checkbox (once <em>Tiki Connect</em> is enabled), next to the '<em>Show on admin login</em>' above",
// "Icons will appear next to all the preferences where you can 'like' {\$smarty.capture.likeicon|escape}" => "Icons will appear next to all the preferences where you can 'like' {\$smarty.capture.likeicon|escape}",
// "Connect" => "Connect",
// "Site title is required" => "Site title is required",
// "Here you can set up a few options and features related to Trackers which were added across several versions of Tiki" => "Here you can set up a few options and features related to Trackers which were added across several versions of Tiki",
// "You might have not specially noticed when they appeared but you should know about these enhancements since you might be interested in using some of them in your site" => "You might have not specially noticed when they appeared but you should know about these enhancements since you might be interested in using some of them in your site",
// "Tracker Field Types" => "Tracker Field Types",
// "Some field types may now come <b>pre-disabled</b>: <a href=\"tiki-admin.php?page=trackers&cookietab=3\" target=\"_blank\">re-check the list</a>" => "Some field types may now come <b>pre-disabled</b>: <a href=\"tiki-admin.php?page=trackers&cookietab=3\" target=\"_blank\">re-check the list</a>",
// "Former ways to manage ratings in trackers are <b>deprecated</b>" => "Former ways to manage ratings in trackers are <b>deprecated</b>",
// "Deprecated Rating Systems in Trackers" => "Deprecated Rating Systems in Trackers",
// "Tracker field types" => "Tracker field types",
// "edit Tracker" => "edit Tracker",
// "Other options to be set elsewhere" => "Other options to be set elsewhere",
// "Add a <em>User and Registration tracker</em>" => "Add a <em>User and Registration tracker</em>",
// "In lists of tracker items, through the interface of the tracker feature as well as through list in tracker related plugins" => "In lists of tracker items, through the interface of the tracker feature as well as through list in tracker related plugins",
// "You can set it in" => "You can set it in",
// "tracker edition" => "tracker edition",
// "Some User Interface (UI) improvements which usually come disabled in new Tiki installations" => "Some User Interface (UI) improvements which usually come disabled in new Tiki installations",
// "They are proven to be useful enhancements in some production environments" => "They are proven to be useful enhancements in some production environments",
// "The ones still tagged as <em>experimental</em> <img src=img/icons/error.png> might have failed to work under some environments, but they are very likely to work as-is in your environment also, so you might like to give them a try" => "The ones still tagged as <em>experimental</em> <img src=img/icons/error.png> might have failed to work under some environments, but they are very likely to work as-is in your environment also, so you might like to give them a try",
// "Icons and Profile Pictures" => "Icons and Profile Pictures",
// "Text Areas" => "Text Areas",
// "You are done with the Changes Wizard" => "You are done with the Changes Wizard",
// "You are done with the Configuration Profiles Wizard" => "You are done with the Configuration Profiles Wizard",
// "Visit the <a href=\"%0\">Configuration Wizard</a> to continue configuring your site" => "Visit the <a href=\"%0\">Configuration Wizard</a> to continue configuring your site",
// "Visit the <a href=\"%0\">User Wizard</a> to set some of your user preferences" => "Visit the <a href=\"%0\">User Wizard</a> to set some of your user preferences",
// "Some profiles were created for use cases of project management" => "Some profiles were created for use cases of project management",
// "This profile show cases the use of Gantt Charts in Tiki for Project Management. You can visually edit task details through the Gantt Chart UI and tracker items get updated accordingly" => "This profile show cases the use of Gantt Charts in Tiki for Project Management. You can visually edit task details through the Gantt Chart UI and tracker items get updated accordingly",
// "It creates" => "It creates",
// "a sample tracker that will hold the tasks" => "a sample tracker that will hold the tasks",
// "a sample wiki page linked to that tracker to display the tasks" => "a sample wiki page linked to that tracker to display the tasks",
// "Some demo data to help you get started" => "Some demo data to help you get started",
// "Click to expand" => "Click to expand",
// "Work custom pricing" => "Work custom pricing",
// "This profile is a showcase of how to setup trackers to allow defining work orders in one tracker, and linked them to billable tasks from another one" => "This profile is a showcase of how to setup trackers to allow defining work orders in one tracker, and linked them to billable tasks from another one",
// "Work Custom Pricing" => "Work Custom Pricing",
// "This allows to define a custom price aside of the guide and get some of the items selected summed in another field of tracker1. The tracker also demonstrates how item link field currently allows to create and link items in a second tracker on the fly and get them stored while adding the new item in the first tracker. Objects created by this profile" => "This allows to define a custom price aside of the guide and get some of the items selected summed in another field of tracker1. The tracker also demonstrates how item link field currently allows to create and link items in a second tracker on the fly and get them stored while adding the new item in the first tracker. Objects created by this profile",
// "Wildcard items" => "Wildcard items",
// "This profile adds a way to provide reusable items in a tracker coming from another one working as templates" => "This profile adds a way to provide reusable items in a tracker coming from another one working as templates",
// "This profile provides some tracker items to work as template items that you can include in other trackers when needed. Objects created are" => "This profile provides some tracker items to work as template items that you can include in other trackers when needed. Objects created are",
// "A couple of trackers. One for current items, and another one for the reusable items working ass templates" => "A couple of trackers. One for current items, and another one for the reusable items working ass templates",
// "A few wiki pages to list, view and edit items" => "A few wiki pages to list, view and edit items",
// "Some example items in both trackers to help you get started" => "Some example items in both trackers to help you get started",
// "Check out some commonly used configurations in Tiki sites" => "Check out some commonly used configurations in Tiki sites",
// "User & Registration Tracker" => "User & Registration Tracker",
// "This profile allows you to request more details in the registration process or in the User Wizard, as well as to provide more custom information to your users" => "This profile allows you to request more details in the registration process or in the User Wizard, as well as to provide more custom information to your users",
// "It includes" => "It includes",
// "A long list of predefined usual fields, to choose from" => "A long list of predefined usual fields, to choose from",
// "Some fields already prepared to display custom information from your specific site" => "Some fields already prepared to display custom information from your specific site",
// "The chance to easily customize it with the power of Trackers" => "The chance to easily customize it with the power of Trackers",
// "Custom Contact Form" => "Custom Contact Form",
// "This profile eases the task to create a custom contact form adapted to the specific case of that site" => "This profile eases the task to create a custom contact form adapted to the specific case of that site",
// "More details" => "More details",
// "Enables Trackers and sets up a few fields to create a basic 'contact us' form as a starting point" => "Enables Trackers and sets up a few fields to create a basic 'contact us' form as a starting point",
// "New fields can be added asking questions specific for the site" => "New fields can be added asking questions specific for the site",
// "You decide where and when to display the link to the contact us form in your Tiki menus and pages" => "You decide where and when to display the link to the contact us form in your Tiki menus and pages",
// "This profile creates two linked trackers. One that allow pre-selecting the items in a drop down list based on the items in a previous drop down field. And a second tracker that holds the options displayed in the drop down fields" => "This profile creates two linked trackers. One that allow pre-selecting the items in a drop down list based on the items in a previous drop down field. And a second tracker that holds the options displayed in the drop down fields",
// "Useful for Geographic data (State, Country/Province, ...)" => "Useful for Geographic data (State, Country/Province, ...)",
// "Useful for Types and Subtypes" => "Useful for Types and Subtypes",
// "Useful for Program Names and Versions" => "Useful for Program Names and Versions",
// "Easily manage the options in the second tracker without editing the dropdown in the first tracker" => "Easily manage the options in the second tracker without editing the dropdown in the first tracker",
// "Sortable Tables" => "Sortable Tables",
// "This profile creates a few examples of tables with data that can be sorted and filtered interactively in real time, using the JQuery Sortable Tables feature" => "This profile creates a few examples of tables with data that can be sorted and filtered interactively in real time, using the JQuery Sortable Tables feature",
// "Useful to sort and filter data in real time" => "Useful to sort and filter data in real time",
// "Same approach for FancyTable and TrackerList Plugins" => "Same approach for FancyTable and TrackerList Plugins",
// "Sorting can be server-side or client-side based " => "Sorting can be server-side or client-side based ",
// "Some profiles are highly customized for very specialized use cases, and they are listed in this special category" => "Some profiles are highly customized for very specialized use cases, and they are listed in this special category",
// "Demo Profiles" => "Demo Profiles",
// "They are initially intended for testing environments, so that, after you have played with the feature, you don't have to deal with removing the created objects, nor with restoring the potentially changed settings in your site" => "They are initially intended for testing environments, so that, after you have played with the feature, you don't have to deal with removing the created objects, nor with restoring the potentially changed settings in your site",
// "Once you know what they do, you can also apply them in your production site, in order to have working templates of the underlying features, that you can further adapt to your site later on" => "Once you know what they do, you can also apply them in your production site, in order to have working templates of the underlying features, that you can further adapt to your site later on",
// "These configuration profiles <strong>require extra software</strong> to be installed in your server to function as expected" => "These configuration profiles <strong>require extra software</strong> to be installed in your server to function as expected",
// "See details in the instructions page shown in your site once each profile is applied" => "See details in the instructions page shown in your site once each profile is applied",
// "CartoGraf" => "CartoGraf",
// "CartoGraf is an interactive web-based mapping application to enhance learning in history and geography classes in high schools" => "CartoGraf is an interactive web-based mapping application to enhance learning in history and geography classes in high schools",
// "CartoGraf is a great example of how to use profiles in a general purpose app (Tiki) to make a very specific application" => "CartoGraf is a great example of how to use profiles in a general purpose app (Tiki) to make a very specific application",
// "This profile is using Tiki as Framework, with these details" => "This profile is using Tiki as Framework, with these details",
// "It is mainly based on Maps, Drawings, PluginAppFrame and Trackers" => "It is mainly based on Maps, Drawings, PluginAppFrame and Trackers",
// "It uses its own Cartograf style (downloaded aside)" => "It uses its own Cartograf style (downloaded aside)",
// "It allows custom markers for maps (placed in a file gallery)" => "It allows custom markers for maps (placed in a file gallery)",
// "It is used in production at http://cartograf.recitus.qc.ca (in French)" => "It is used in production at http://cartograf.recitus.qc.ca (in French)",
// "R demo" => "R demo",
// "This profile demonstrates common uses of R language for statistics to produce advanced and/or interactive graphs and reports in web 2.0 pages" => "This profile demonstrates common uses of R language for statistics to produce advanced and/or interactive graphs and reports in web 2.0 pages",
// "It uses the R Project for Statistical Computing software & PluginR in Tiki (both of which are not bundled within a default Tiki installation and they need to be installed in the same server as Tiki)" => "It uses the R Project for Statistical Computing software & PluginR in Tiki (both of which are not bundled within a default Tiki installation and they need to be installed in the same server as Tiki)",
// "The profile creates many demo pages, which comprise" => "The profile creates many demo pages, which comprise",
// "Simple R syntax in wiki pages to produce interactive charts" => "Simple R syntax in wiki pages to produce interactive charts",
// "Advanced usage to create full GUI for an R application" => "Advanced usage to create full GUI for an R application",
// "Many other examples of nice charts and reports that you can produce with this system" => "Many other examples of nice charts and reports that you can produce with this system",
// "r.tiki.org site" => "r.tiki.org site",
// "r.tiki.org live site" => "r.tiki.org live site",
// "GeoCMS Maps" => "GeoCMS Maps",
// "This profile demonstrates common uses of geolocation of different tiki objects (wiki pages, blog posts, articles and tracker items) to produce separated or combined maps" => "This profile demonstrates common uses of geolocation of different tiki objects (wiki pages, blog posts, articles and tracker items) to produce separated or combined maps",
// "R Heatmaps" => "R Heatmaps",
// "This profile adds a web interface for an R package called EasyHeatMap (link to package provided in the instructions page once the profile is applied)" => "This profile adds a web interface for an R package called EasyHeatMap (link to package provided in the instructions page once the profile is applied)",
// "This R package allows the creation and edition of HeatMap graphics (as used in Bioinformatics)" => "This R package allows the creation and edition of HeatMap graphics (as used in Bioinformatics)",
// "This profile creates" => "This profile creates",
// "A single wiki page where the whole heatmap generation can be run, to allow debugging your server installation of the required system and R packages if anything fails for you" => "A single wiki page where the whole heatmap generation can be run, to allow debugging your server installation of the required system and R packages if anything fails for you",
// "A few wiki pages to list, view and edit analysis in R to produce HeatMaps for differential expression of gene sets" => "A few wiki pages to list, view and edit analysis in R to produce HeatMaps for differential expression of gene sets",
// "Example input files and default values provided as a happy path to produce your first Heatmaps" => "Example input files and default values provided as a happy path to produce your first Heatmaps",
// "Plugin R" => "Plugin R",
// "Plugin R in doc.tiki.org" => "Plugin R in doc.tiki.org",
// "Each of these profiles create a working instance of some features, such as trackers and wiki pages customized for specific purposes, for example" => "Each of these profiles create a working instance of some features, such as trackers and wiki pages customized for specific purposes, for example",
// "They are not to be initially applied in production environments since they cannot be easily reverted and changes and new objects in your site are created for real" => "They are not to be initially applied in production environments since they cannot be easily reverted and changes and new objects in your site are created for real",
// "Bug Tracker" => "Bug Tracker",
// "This profile allows you to see a tracker in action with some demo data, and a custom interface in a wiki page to add new items, as well as having them listed for you below" => "This profile allows you to see a tracker in action with some demo data, and a custom interface in a wiki page to add new items, as well as having them listed for you below",
// "Uses PluginTracker in a wiki page to add items" => "Uses PluginTracker in a wiki page to add items",
// "Create some custom feedback for message to the user after item insertion" => "Create some custom feedback for message to the user after item insertion",
// "Uses PluginTrackerList to display inserted items" => "Uses PluginTrackerList to display inserted items",
// "Timesheet" => "Timesheet",
// "This profile allows recording time spent on projects. It creates two trackers: one to hold the time spent, and the other with the project names" => "This profile allows recording time spent on projects. It creates two trackers: one to hold the time spent, and the other with the project names",
// "Allows to track your time spent on projects" => "Allows to track your time spent on projects",
// "Customize your project categories" => "Customize your project categories",
// "Add or edit your timesheet fields as desired" => "Add or edit your timesheet fields as desired",
// "Both trackers are linked, so that project names can be chosen when entering items to the timesheet tracker" => "Both trackers are linked, so that project names can be chosen when entering items to the timesheet tracker",
// "Plugin Timesheet" => "Plugin Timesheet",
// "Plugin Timesheet in doc.tiki.org" => "Plugin Timesheet in doc.tiki.org",
// "Tracker as Calendar" => "Tracker as Calendar",
// "This profile creates a tracker with some demo data and wiki interface that will be used to display and manage a Calendar of events in a fancy visual way" => "This profile creates a tracker with some demo data and wiki interface that will be used to display and manage a Calendar of events in a fancy visual way",
// "Advanced use of Plugin TrackerList" => "Advanced use of Plugin TrackerList",
// "Working example of Plugin TrackerCalendar" => "Working example of Plugin TrackerCalendar",
// "Drag & Drop to resize or move events" => "Drag & Drop to resize or move events",
// "Several display modes, useful for Project & Resource Management" => "Several display modes, useful for Project & Resource Management",
// "Voting System" => "Voting System",
// "This profile sets up a Voting system in which only members of a group will be able to vote. It creates a tracker, 2 groups of users, one user in each group and a custom wiki page as interface to vote" => "This profile sets up a Voting system in which only members of a group will be able to vote. It creates a tracker, 2 groups of users, one user in each group and a custom wiki page as interface to vote",
// "Group homepage set for the voting group" => "Group homepage set for the voting group",
// "Only one vote per member is allowed" => "Only one vote per member is allowed",
// "Results shown in real time (Plugin TrackerStat)" => "Results shown in real time (Plugin TrackerStat)",
// "Other candidates can be voted beyond the proposed" => "Other candidates can be voted beyond the proposed",
// "Check out these more advanced configurations that demonstrate some other Tiki Features that you might be interested in for your site" => "Check out these more advanced configurations that demonstrate some other Tiki Features that you might be interested in for your site",
// "Shopping Cart" => "Shopping Cart",
// "This profile provides a Shopping Cart and the corresponding basic payment system" => "This profile provides a Shopping Cart and the corresponding basic payment system",
// "It currently uses the PayPal shopping cart rather than the built in Tiki" => "It currently uses the PayPal shopping cart rather than the built in Tiki",
// "A tracker for products including price, weight, image and stock quantity" => "A tracker for products including price, weight, image and stock quantity",
// "Some sample items which are open, pending and closed items, with different permissions to view or edit them for different groups of users" => "Some sample items which are open, pending and closed items, with different permissions to view or edit them for different groups of users",
// "A small category subtree to classify products" => "A small category subtree to classify products",
// "Wiki pages to display the available products list, one product details page and a search form" => "Wiki pages to display the available products list, one product details page and a search form",
// "Easy GeoBlog" => "Easy GeoBlog",
// "This profile demonstrates the geolocation of Blog posts, in conjunction with other associated features" => "This profile demonstrates the geolocation of Blog posts, in conjunction with other associated features",
// "Single map with all geolocated blog posts" => "Single map with all geolocated blog posts",
// "Different home page once the user logs in" => "Different home page once the user logs in",
// "Random header image from files included in a file gallery" => "Random header image from files included in a file gallery",
// "WYSIWYG Editor (compatible mode with wiki syntax)" => "WYSIWYG Editor (compatible mode with wiki syntax)",
// "Wiki, Search, Menu & Tags" => "Wiki, Search, Menu & Tags",
// "Comments moderation & Banning (for anonymous comments to your site)" => "Comments moderation & Banning (for anonymous comments to your site)",
// "Profile Conditional_Display_in_Forms" => "Profile Conditional_Display_in_Forms",
// "This profile demonstrates the setup to conditionally hide or display some fields in a form" => "This profile demonstrates the setup to conditionally hide or display some fields in a form",
// "Conditional_Display_in_Forms" => "Conditional_Display_in_Forms",
// "Main features used" => "Main features used",
// "Plugin JQ (jQuery)" => "Plugin JQ (jQuery)",
// "Plugin TrackerIf" => "Plugin TrackerIf",
// "Profile Execute_on_list" => "Profile Execute_on_list",
// "This profile demonstrates how to perform actions on several items from a list using Plugin ListExecute" => "This profile demonstrates how to perform actions on several items from a list using Plugin ListExecute",
// "Plugin ListExecute" => "Plugin ListExecute",
// "Each of these profiles create a working instance of some features, such as wiki structures, forums, trackers and wiki pages, customized for specific purposes" => "Each of these profiles create a working instance of some features, such as wiki structures, forums, trackers and wiki pages, customized for specific purposes",
// "Structured Master Documents" => "Structured Master Documents",
// "This profile will get you started with Wiki Structures, containing multiple wiki pages with a hierarchical order, like master documents from office suites, and more" => "This profile will get you started with Wiki Structures, containing multiple wiki pages with a hierarchical order, like master documents from office suites, and more",
// "Many pages are pre-created to let you easily set up several wiki structures" => "Many pages are pre-created to let you easily set up several wiki structures",
// "A common navigation menu is created and shown at the top of pages in the structure" => "A common navigation menu is created and shown at the top of pages in the structure",
// "You can easily print (export) them all together in a single html" => "You can easily print (export) them all together in a single html",
// "Permissions or Monitoring can be applied in bulk to the whole structure or substructures" => "Permissions or Monitoring can be applied in bulk to the whole structure or substructures",
// "Consensus Forums" => "Consensus Forums",
// "This profile sets up the configuration needed to facilitate forums that help their users to seek consensus on the discussion topics held" => "This profile sets up the configuration needed to facilitate forums that help their users to seek consensus on the discussion topics held",
// "Users ratings in Forums" => "Users ratings in Forums",
// "Topics with less agreement can be easily identified from the topic list" => "Topics with less agreement can be easily identified from the topic list",
// "The current rating of each user to the thread topic is shown each time, so that further attention and explanations can be given where needed to help reaching a higher degree of consensus" => "The current rating of each user to the thread topic is shown each time, so that further attention and explanations can be given where needed to help reaching a higher degree of consensus",
// "Replies can also be rated, but without affecting the topic rating average" => "Replies can also be rated, but without affecting the topic rating average",
// "Profile instructions are translated to several languages. Therefore, some settings related to internationalization of wiki pages are enabled by the profile" => "Profile instructions are translated to several languages. Therefore, some settings related to internationalization of wiki pages are enabled by the profile",
// "Barter Market" => "Barter Market",
// "This profile creates three trackers with some demo data to showcase a basic setup for a barter market of linked offers and wants of goods, services and knowledge" => "This profile creates three trackers with some demo data to showcase a basic setup for a barter market of linked offers and wants of goods, services and knowledge",
// "minimal number of fields in these trackers, which can be extended" => "minimal number of fields in these trackers, which can be extended",
// "tracker items are categorized" => "tracker items are categorized",
// "a few modules added, including a wiki page menu" => "a few modules added, including a wiki page menu",
// "best display if using just one column (right, for instance)" => "best display if using just one column (right, for instance)",
// "Revision Approval (ISO9001)" => "Revision Approval (ISO9001)",
// "This profile sets up the configuration needed to facilitate the handling of document revision approval for quality certification systems (such as ISO9001)" => "This profile sets up the configuration needed to facilitate the handling of document revision approval for quality certification systems (such as ISO9001)",
// "Additions: 1 group, 2 users, 2 wiki pages, 3 categories" => "Additions: 1 group, 2 users, 2 wiki pages, 3 categories",
// "Revision approval is set for homepage and 'official document'" => "Revision approval is set for homepage and 'official document'",
// "Wiki Argument Variables are used in the 'official document'" => "Wiki Argument Variables are used in the 'official document'",
// "Initialize Tiki as an application, e.g. a blog., by means of applying one of the 4 featured configuration profiles" => "Initialize Tiki as an application, e.g. a blog., by means of applying one of the 4 featured configuration profiles",
// "Collaborative Community" => "Collaborative Community",
// "Setup to help subject experts and enthusiasts work together to build a Knowledge Base" => "Setup to help subject experts and enthusiasts work together to build a Knowledge Base",
// "Uses" => "Uses",
// "Wiki Editing" => "Wiki Editing",
// "Personal Member Spaces" => "Personal Member Spaces",
// "Company Intranet" => "Company Intranet",
// "Setup for a Corporate Intranet of a typical medium-sized business" => "Setup for a Corporate Intranet of a typical medium-sized business",
// "Company News Articles" => "Company News Articles",
// "Executive Blog" => "Executive Blog",
// "File Repository & Management" => "File Repository & Management",
// "Collaborative Wiki" => "Collaborative Wiki",
// "Personal Blog and Profile" => "Personal Blog and Profile",
// "Setup with many cool features to help you integrate the Social Web and establish a strong presence in the Blogosphere" => "Setup with many cool features to help you integrate the Social Web and establish a strong presence in the Blogosphere",
// "Blog (Full set of blog related features)" => "Blog (Full set of blog related features)",
// "RSS Integration" => "RSS Integration",
// "Video Log" => "Video Log",
// "Small Organization Web Presence" => "Small Organization Web Presence",
// "Setup for a Web Presence of a typical small business or non-profit" => "Setup for a Web Presence of a typical small business or non-profit",
// "Company News & Updates" => "Company News & Updates",
// "Highlight Company's Products and Services" => "Highlight Company's Products and Services",
// "File Gallery (great for Media Kit)" => "File Gallery (great for Media Kit)",
// "Contact Form" => "Contact Form",
// "Profiles admin card" => "Profiles admin card",
// "Check out some useful changes in the configuration for site administrators" => "Check out some useful changes in the configuration for site administrators",
// "Debug Mode Enabled" => "Debug Mode Enabled",
// "Debug Mode Disabled" => "Debug Mode Disabled",
// "Profile <i>Debug_Mode_Enabled</i> will help you detect potential errors and warnings which are hidden otherwise" => "Profile <i>Debug_Mode_Enabled</i> will help you detect potential errors and warnings which are hidden otherwise",
// "Once applied, you might like to apply the opposite profile: <i>Debug_Mode_Disabled</i>, if not changing the appropriate settings by hand" => "Once applied, you might like to apply the opposite profile: <i>Debug_Mode_Disabled</i>, if not changing the appropriate settings by hand",
// "Enables/Disables debugging tools" => "Enables/Disables debugging tools",
// "Enables/Disables logging tools" => "Enables/Disables logging tools",
// "Disables/Enables redirections to similar pages" => "Disables/Enables redirections to similar pages",
// "Enables/Disables error and warning display to all users, not only admins" => "Enables/Disables error and warning display to all users, not only admins",
// "This configuration profile enables the Scheduler feature and loads a preset of schedulers" => "This configuration profile enables the Scheduler feature and loads a preset of schedulers",
// "Each scheduler can replace a former cron job action in the server" => "Each scheduler can replace a former cron job action in the server",
// "You only need one cron job action in the server, the one that runs the tiki scheduler as frequently as you need" => "You only need one cron job action in the server, the one that runs the tiki scheduler as frequently as you need",
// "This configuration profile showcases the activity stream feature in Tiki" => "This configuration profile showcases the activity stream feature in Tiki",
// "Activity Stream data can also be reviewed through PluginPivotTable" => "Activity Stream data can also be reviewed through PluginPivotTable",
// "It is somewhat similar to the basic Action log feature in Tiki" => "It is somewhat similar to the basic Action log feature in Tiki",
// "Check out some useful profiles that involve changing the display mode of content in your site" => "Check out some useful profiles that involve changing the display mode of content in your site",
// "Slideshow demo" => "Slideshow demo",
// "This profile sets up a slideshow from a simple wiki page, which you can use to learn the basics of how easily the slideshow system in Tiki works" => "This profile sets up a slideshow from a simple wiki page, which you can use to learn the basics of how easily the slideshow system in Tiki works",
// "All content is in a wiki page, which can be printed to your audience in just a few sheets of paper" => "All content is in a wiki page, which can be printed to your audience in just a few sheets of paper",
// "Headers of different levels are used as markers of 'new slide' and used as titles" => "Headers of different levels are used as markers of 'new slide' and used as titles",
// "Many settings can be predefined as parameters of a call to PluginSlideshow" => "Many settings can be predefined as parameters of a call to PluginSlideshow",
// "Allows slide notes in a separate window for dual monitor setups, slide numbers in footer, timer, style with background images, navigation bar with all slides listed to jump to" => "Allows slide notes in a separate window for dual monitor setups, slide numbers in footer, timer, style with background images, navigation bar with all slides listed to jump to",
// "Hide Fixed Top Navigation Bar on scroll" => "Hide Fixed Top Navigation Bar on scroll",
// "This profile hides the fixed top navigation bar (in the top section of modules) on page scroll, while displaying the topbar module in a sticky position at the top afterwards" => "This profile hides the fixed top navigation bar (in the top section of modules) on page scroll, while displaying the topbar module in a sticky position at the top afterwards",
// "Hide Fixed Top Navi Bar on Scroll" => "Hide Fixed Top Navi Bar on Scroll",
// "Site layout (in Control Panels > Look and Feel > General layout) will be set to 'Classic Bootstrap (fixed top navbar)'" => "Site layout (in Control Panels > Look and Feel > General layout) will be set to 'Classic Bootstrap (fixed top navbar)'",
// "Preference Site logo (feature_sitelogo) will be disabled so that logos and site title are not shown twice" => "Preference Site logo (feature_sitelogo) will be disabled so that logos and site title are not shown twice",
// "After scrolling down a bit, the fixed top bar will disappear and the topbar zone (if any) will become sticky" => "After scrolling down a bit, the fixed top bar will disappear and the topbar zone (if any) will become sticky",
// "This profile is best demonstrated after applying the Collaborative Community profile which include site title and topbar module with menus" => "This profile is best demonstrated after applying the Collaborative Community profile which include site title and topbar module with menus",
// "Check out this set of potentially useful profiles for your site which involve small amount of changes in your site configuration" => "Check out this set of potentially useful profiles for your site which involve small amount of changes in your site configuration",
// "Menu on Wiki page" => "Menu on Wiki page",
// "This profile sets up a side module with a menu based on a wiki page in the right hand-side column" => "This profile sets up a side module with a menu based on a wiki page in the right hand-side column",
// "With this profile you can" => "With this profile you can",
// "use wiki syntax to edit it" => "use wiki syntax to edit it",
// "delegate its edition with wiki page permissions" => "delegate its edition with wiki page permissions",
// "use plugins to manage conditional display of sections" => "use plugins to manage conditional display of sections",
// "Random header images" => "Random header images",
// "This profile adds a module in the top zone that displays a random image from a File Gallery" => "This profile adds a module in the top zone that displays a random image from a File Gallery",
// "Some sample images to fit the default configuration are also provided as a starting point" => "Some sample images to fit the default configuration are also provided as a starting point",
// "default configuration uses images at 800x150px resized by the top module parameters to match the header default size" => "default configuration uses images at 800x150px resized by the top module parameters to match the header default size",
// "a different random image is shown at each page load" => "a different random image is shown at each page load",
// "elFinder modern file galery manager (with drag & drop capabilities!) is used by default" => "elFinder modern file galery manager (with drag & drop capabilities!) is used by default",
// "you can tweak the module and file gallery defaults as needed for your needs" => "you can tweak the module and file gallery defaults as needed for your needs",
// "Multilingual Wiki" => "Multilingual Wiki",
// "This profile allows Tiki content translation, and sets up modules to change language and to display links to page translations with their percentage of completion" => "This profile allows Tiki content translation, and sets up modules to change language and to display links to page translations with their percentage of completion",
// "The enabled features comprise" => "The enabled features comprise",
// "Multilingual freetags" => "Multilingual freetags",
// "Countries By Region" => "Countries By Region",
// "This profile will create a set of categories and subcategories in your site with the names of countries grouped by regions" => "This profile will create a set of categories and subcategories in your site with the names of countries grouped by regions",
// "The regions listed with their countries are" => "The regions listed with their countries are",
// "Saharan, Sub-Saharan Africa" => "Saharan, Sub-Saharan Africa",
// "Middle East, North Africa" => "Middle East, North Africa",
// "Asia" => "Asia",
// "North, Central America" => "North, Central America",
// "Oceania" => "Oceania",
// "South America" => "South America",
// "Check out this set of useful configurations that involve using some new technology for your site" => "Check out this set of useful configurations that involve using some new technology for your site",
// "Write Together" => "Write Together",
// "This profile adds a simple wiki page on a side module (using the Module menupage), showing the button to start co-writing with TogetherJS" => "This profile adds a simple wiki page on a side module (using the Module menupage), showing the button to start co-writing with TogetherJS",
// "Allows cowriting documents in real time" => "Allows cowriting documents in real time",
// "Allows voice communication in real time while editing" => "Allows voice communication in real time while editing",
// "Uses the TogetherJS Mozilla widget" => "Uses the TogetherJS Mozilla widget",
// "Post-it Sticky Note" => "Post-it Sticky Note",
// "This profile allows to display a sticky note (a \"post-it\") in your tiki site" => "This profile allows to display a sticky note (a \"post-it\") in your tiki site",
// "You can move it to another location" => "You can move it to another location",
// "You can customize the contents and which groups of users will see it (by default, only to Admins)" => "You can customize the contents and which groups of users will see it (by default, only to Admins)",
// "It will be shown for each user of that group until manually closed" => "It will be shown for each user of that group until manually closed",
// "Groupmail" => "Groupmail",
// "This profile allows to provide a way for a team (a Tiki group) to process email contact requests, save them in contact lists and act on them and record the process in wiki pages" => "This profile allows to provide a way for a team (a Tiki group) to process email contact requests, save them in contact lists and act on them and record the process in wiki pages",
// "A tracker for email messages received and store addresses in the Contacts feature" => "A tracker for email messages received and store addresses in the Contacts feature",
// "Webmail configuration to use an account for groupmail" => "Webmail configuration to use an account for groupmail",
// "A side module with markers to indicate who took which message" => "A side module with markers to indicate who took which message",
// "A system to review communication logs from that group mail account" => "A system to review communication logs from that group mail account",
// "Profile X" => "Profile X",
// "This profile allows to " => "This profile allows to ",
// "Feature_X in doc.tiki.org" => "Feature_X in doc.tiki.org",
// "User Dummy" => "User Dummy",
// "This is a dummy page" => "This is a dummy page",
// "Set up basic information as a user on this site" => "Set up basic information as a user on this site",
"Your personal Wiki Page" => "你的個人 Wiki 頁面",
// "The feature 'User Preferences' is currently disabled in this site" => "The feature 'User Preferences' is currently disabled in this site",
// "Enable the feature" => "Enable the feature",
// "Enable it" => "Enable it",
// "You might ask your site admin to enable it" => "You might ask your site admin to enable it",
// "Use 'watches' to monitor wiki pages or other objects" => "Use 'watches' to monitor wiki pages or other objects",
// "Set up below preferences related to receiving notifications by email about changes in the site" => "Set up below preferences related to receiving notifications by email about changes in the site",
// "The feature user watches is disabled in this site" => "The feature user watches is disabled in this site",
// "Set up the general settings for your account" => "Set up the general settings for your account",
// "User Params" => "User Params",
"Is email public? (uses scrambling to prevent spam)" => "公開 email? (使用擾亂法以避免spam)",
// "Does your email application need a special character set" => "Does your email application need a special character set",
// "Preferred language" => "Preferred language",
// "Site time zone is enforced and overrides user preferences" => "Site time zone is enforced and overrides user preferences",
// "The feature with the user preferences screen is disabled in this site" => "The feature with the user preferences screen is disabled in this site",
// "You are not allowed to remove this notification " => "You are not allowed to remove this notification ",
// "Interval in which you want to get the reports" => "Interval in which you want to get the reports",
// "HTML-Email" => "HTML-Email",
// "Send me an email also if nothing happened" => "Send me an email also if nothing happened",
// "The feature daily reports of user watches is disabled in this site" => "The feature daily reports of user watches is disabled in this site",
// "Use this form to fill in some extra information about you" => "Use this form to fill in some extra information about you",
// "Extra information about you" => "Extra information about you",
// "Tiki User Wizard" => "Tiki User Wizard",
// "This wizard will help you fill in data and main settings for your account on this website" => "This wizard will help you fill in data and main settings for your account on this website",
// "Depending on the features enabled by the site admin, you will be offered more or less options" => "Depending on the features enabled by the site admin, you will be offered more or less options",
// "If you can't set up your user preferences (Real name, keep your information public or private, time settings, ...), you can request the site admin to enable the user preferences feature" => "If you can't set up your user preferences (Real name, keep your information public or private, time settings, ...), you can request the site admin to enable the user preferences feature",
// "Click at the \"Start\" button above to launch it" => "Click at the \"Start\" button above to launch it",
// "To learn more about this Tiki release, go to <a href=\"https://doc.tiki.org/Tiki{\$tikiMajorVersion}\">Tiki {\$tikiMajorVersion}</a>" => "To learn more about this Tiki release, go to <a href=\"https://doc.tiki.org/Tiki{\$tikiMajorVersion}\">Tiki {\$tikiMajorVersion}</a>",
// "You are done with the user wizard" => "You are done with the user wizard",
// "Visit the Full <a href=\"%0\">User Preferences</a> page to set the rest of your user preferences" => "Visit the Full <a href=\"%0\">User Preferences</a> page to set the rest of your user preferences",
// "Or.." => "Or..",
// "Click at the button <strong>Finish</strong> to end the user wizard and go back to the where you were" => "Click at the button <strong>Finish</strong> to end the user wizard and go back to the where you were",
// "Show on admin log-in" => "Show on admin log-in",
// "Finish" => "Finish",
// "Start the Wizardry" => "Start the Wizardry",
// "Save and Continue" => "Save and Continue",
// "No turning back" => "No turning back",
// "Once you switch your template to advanced mode, there is no turning back. The simple interface will no longer be available" => "Once you switch your template to advanced mode, there is no turning back. The simple interface will no longer be available",
// "Return to simple interface" => "Return to simple interface",
// "Workspace Name" => "Workspace Name",
// "Wiki Page Source" => "Wiki Page Source",
// "Not enough options" => "Not enough options",
// "This is the simple edition interface offering a subset of the available features. You can switch to the advanced mode and get more power" => "This is the simple edition interface offering a subset of the available features. You can switch to the advanced mode and get more power",
// "Advanced Mode" => "Advanced Mode",
// "Bind area" => "Bind area",
// "Is managing group" => "Is managing group",
// "Workspace creator joins this group" => "Workspace creator joins this group",
// "Add group" => "Add group",
// "Select Permissions" => "Select Permissions",
// "Edit content template" => "Edit content template",
// "Add page" => "Add page",
// "Default (Font-awesome)" => "Default (Font-awesome)",
// "The default system icon set using Font-awesome fonts" => "The default system icon set using Font-awesome fonts",
// "Solid" => "Solid",
// "Outline" => "Outline",
// "Font Awesome Regular" => "Font Awesome Regular",
// "Font Awesome Pro Only" => "Font Awesome Pro Only",
// "Brands" => "Brands",
// "Legacy (pre Tiki14) icons" => "Legacy (pre Tiki14) icons",
// "Legacy (pre Tiki14) icons, mainly using famfamfam images" => "Legacy (pre Tiki14) icons, mainly using famfamfam images",
// "Custom icons" => "Custom icons",
// "Custom icons for the theme" => "Custom icons for the theme",
// "Theme icons" => "Theme icons",
// "Icons to be used for this theme" => "Icons to be used for this theme",
// "This field is manadatory" => "This field is manadatory",
// "Design by" => "Design by",
// "Missing book id" => "Missing book id",
// "You do not have the right view this page" => "You do not have the right view this page",
// "%0 account in book %1 modified" => "%0 account in book %1 modified",
// "%0 account created for book %1" => "%0 account created for book %1",
// "Account %0 in book %1 unlocked" => "Account %0 in book %1 unlocked",
// "Account %0 in book %1 not unlocked" => "Account %0 in book %1 not unlocked",
// "Account %0 in book %1 locked" => "Account %0 in book %1 locked",
// "Account %0 in book %1 not locked" => "Account %0 in book %1 not locked",
// "Delete account %0 from book %1" => "Delete account %0 from book %1",
// "%0 account deleted from book %1" => "%0 account deleted from book %1",
// "Missing account id" => "Missing account id",
// "You do not have the rights to view this account" => "You do not have the rights to view this account",
// "You do not have the rights to manage accounts" => "You do not have the rights to manage accounts",
// "You do not have permission to create a book" => "You do not have permission to create a book",
// "Book %0 successfully created" => "Book %0 successfully created",
// "You do not have permission to close this book" => "You do not have permission to close this book",
// "Close book (this action cannot be undone)" => "Close book (this action cannot be undone)",
// "Book successfully closed" => "Book successfully closed",
// "The attempt to close the book was unsuccessful" => "The attempt to close the book was unsuccessful",
// "Cancel journal %0 in book %1" => "Cancel journal %0 in book %1",
// "Journal shown below successfully canceled" => "Journal shown below successfully canceled",
// "Missing journal id" => "Missing journal id",
// "You do not have the right to cancel transactions" => "You do not have the right to cancel transactions",
// "Error retrieving data from journal" => "Error retrieving data from journal",
// "You do not have the right to book" => "You do not have the right to book",
// "Record entry in book %0" => "Record entry in book %0",
// "Journal %0 successfully recorded in book %1" => "Journal %0 successfully recorded in book %1",
// "Don't know what to export" => "Don't know what to export",
// "You do not have the right export/view this data" => "You do not have the right export/view this data",
// "You do not have the right to book into the stack" => "You do not have the right to book into the stack",
// "Record stack entry in book %0" => "Record stack entry in book %0",
// "Modify stack entry in book %0" => "Modify stack entry in book %0",
// "Delete stack %0 from book %1" => "Delete stack %0 from book %1",
// "Confirm stack %0 for book %0" => "Confirm stack %0 for book %0",
// "Stack %0 successfully modified in book %1" => "Stack %0 successfully modified in book %1",
// "Stack %0 successfully deleted from book %1" => "Stack %0 successfully deleted from book %1",
// "Stack %0 recorded in book %1" => "Stack %0 recorded in book %1",
// "Stack %0 deleted from book %1" => "Stack %0 deleted from book %1",
// "Stack %0 confirmed and recorded as entry in book %1" => "Stack %0 confirmed and recorded as entry in book %1",
// "Tiki Calendar" => "Tiki Calendar",
// "%0 enabled" => "%0 enabled",
// "%0 disabled" => "%0 disabled",
// "%0 set" => "%0 set",
// "%0 unset" => "%0 unset",
// "item added" => "item added",
// "items added" => "items added",
// "item deleted" => "item deleted",
// "items deleted" => "items deleted",
// "Help on Configuration Sections" => "Help on Configuration Sections",
// "Default preference filters set" => "Default preference filters set",
// "%0 reset" => "%0 reset",
// "Search error" => "Search error",
// "Global site configuration, date formats, etc" => "Global site configuration, date formats, etc",
// "Switches for major features" => "Switches for major features",
// "User registration, remember me cookie settings and authentication methods" => "User registration, remember me cookie settings and authentication methods",
// "User related preferences like info and picture, features, messages and notification, files, etc" => "User related preferences like info and picture, features, messages and notification, files, etc",
// "Repository configuration, browse and apply profiles" => "Repository configuration, browse and apply profiles",
// "Look & Feel" => "Look & Feel",
// "Theme selection, layout settings and UI effect controls" => "Theme selection, layout settings and UI effect controls",
// "Editing and Plugins" => "Editing and Plugins",
// "Text editing settings applicable to many areas. Plugin activation and plugin alias management" => "Text editing settings applicable to many areas. Plugin activation and plugin alias management",
// "Module appearance settings" => "Module appearance settings",
// "i18n" => "i18n",
// "Internationalization and localization - multilingual features" => "Internationalization and localization - multilingual features",
// "Meta Tags" => "Meta Tags",
// "Information to include in the header of each page" => "Information to include in the header of each page",
// "Maps" => "Maps",
// "Settings and features for maps" => "Settings and features for maps",
// "Server performance settings" => "Server performance settings",
// "Site security settings" => "Site security settings",
// "Outgoing RSS feed setup" => "Outgoing RSS feed setup",
// "Tiki Connect - join in" => "Tiki Connect - join in",
// "Rating settings" => "Rating settings",
// "Search configuration" => "Search configuration",
// "Wiki page settings and features" => "Wiki page settings and features",
// "Defaults and configuration for file galleries" => "Defaults and configuration for file galleries",
// "Settings for blogs" => "Settings for blogs",
// "Defaults and configuration for image galleries (will be phased out in favour of file galleries)" => "Defaults and configuration for image galleries (will be phased out in favour of file galleries)",
// "Settings and features for articles" => "Settings and features for articles",
// "Settings and features for forums" => "Settings and features for forums",
// "Settings and features for trackers" => "Settings and features for trackers",
// "Settings and features for polls" => "Settings and features for polls",
// "Settings and features for calendars" => "Settings and features for calendars",
// "Settings and features for categories" => "Settings and features for categories",
// "Configure workspace feature" => "Configure workspace feature",
// "Values of actions for users rank score" => "Values of actions for users rank score",
// "Settings and features for tags" => "Settings and features for tags",
// "Settings and features for FAQs" => "Settings and features for FAQs",
// "Settings and features for directory of links" => "Settings and features for directory of links",
// "Site-wide copyright information" => "Site-wide copyright information",
// "Message settings" => "Message settings",
// "Webmail settings" => "Webmail settings",
// "Options for WYSIWYG editor" => "Options for WYSIWYG editor",
// "Site advertisements and notices" => "Site advertisements and notices",
// "InterTiki" => "InterTiki",
// "Set up links between Tiki servers" => "Set up links between Tiki servers",
// "Manage semantic wiki links" => "Manage semantic wiki links",
// "Register and manage web services" => "Register and manage web services",
// "SEF URL" => "SEF URL",
// "Video integration configuration" => "Video integration configuration",
// "Payment settings" => "Payment settings",
// "Configure social networks integration" => "Configure social networks integration",
// "User specific features and settings" => "User specific features and settings",
// "Configure share feature" => "Configure share feature",
// "Configure statistics reporting for your site usage" => "Configure statistics reporting for your site usage",
// "Print Settings" => "Print Settings",
// "Settings and features for print versions and pdf generation" => "Settings and features for print versions and pdf generation",
// "External packages installation and management" => "External packages installation and management",
// "RTC" => "RTC",
// "Real-time collaboration tools" => "Real-time collaboration tools",
// "Help on %0 Config" => "Help on %0 Config",
// "Remove selected actions" => "Remove selected actions",
// "The selected action has been deleted from the log" => "The selected action has been deleted from the log",
// "%0 actions have been deleted from the log" => "%0 actions have been deleted from the log",
// "No actions were deleted from the log" => "No actions were deleted from the log",
// "Must specify actionId" => "Must specify actionId",
// "Users Contributions: Addition" => "Users Contributions: Addition",
// "%s Contributions: Addition" => "%s Contributions: Addition",
// "Users Contributions: Suppression" => "Users Contributions: Suppression",
// "%s Contributions: Suppression" => "%s Contributions: Suppression",
// "Total Contributions Addition per Day" => "Total Contributions Addition per Day",
// "Total Contributions Addition per Week" => "Total Contributions Addition per Week",
// "Total Contributions Suppression per Day" => "Total Contributions Suppression per Day",
// "Total Contributions Suppression per Week" => "Total Contributions Suppression per Week",
// "Total Contributions: Addition" => "Total Contributions: Addition",
// "Total Contributions: Suppression" => "Total Contributions: Suppression",
// "Groups Contributions: Addition" => "Groups Contributions: Addition",
// "Groups Contributions: Suppression" => "Groups Contributions: Suppression",
// "white" => "white",
// "gray" => "gray",
// "silver" => "silver",
// "ivory" => "ivory",
// "whitesmoke" => "whitesmoke",
// "beige" => "beige",
// "darkgrey" => "darkgrey",
// "No rule selected for deletion. No deletions were performed" => "No rule selected for deletion. No deletions were performed",
// "The selected banning rule has been deleted" => "The selected banning rule has been deleted",
// "%0 banning rules have been deleted" => "%0 banning rules have been deleted",
// "The following banning rule has been saved or replaced" => "The following banning rule has been saved or replaced",
// "The following %0 banning rules have been saved or replaced" => "The following %0 banning rules have been saved or replaced",
// "No changes were made to the following selected banning rules" => "No changes were made to the following selected banning rules",
// "Only %0 of the selected banning rules shown below were added or changed" => "Only %0 of the selected banning rules shown below were added or changed",
// "No banning rules were selected" => "No banning rules were selected",
// "Multiple IP Banning" => "Multiple IP Banning",
// "Access from your localization was forbidden due to excessive spamming" => "Access from your localization was forbidden due to excessive spamming",
// "Not saved" => "Not saved",
// "Username pattern empty" => "Username pattern empty",
// "Default IP pattern still set" => "Default IP pattern still set",
// "Calendar %0 deleted" => "Calendar %0 deleted",
// "Calendar %0 not deleted" => "Calendar %0 not deleted",
// "One calendar event deleted" => "One calendar event deleted",
// "No calendar events deleted" => "No calendar events deleted",
// "%0 calendar events deleted" => "%0 calendar events deleted",
// "No such category with parentID %0" => "No such category with parentID %0",
// "One object unassigned from category" => "One object unassigned from category",
// "%0 objects unassigned from category" => "%0 objects unassigned from category",
// "No objects unassigned" => "No objects unassigned",
// "Incorrect category ID %0 - objects not moved" => "Incorrect category ID %0 - objects not moved",
// "One object moved to selected category" => "One object moved to selected category",
// "%0 objects moved to selected category" => "%0 objects moved to selected category",
// "No objects moved" => "No objects moved",
// "Incorrect category ID %0 - objects not copied" => "Incorrect category ID %0 - objects not copied",
// "One object copied to selected category" => "One object copied to selected category",
// "%0 objects copied to selected category" => "%0 objects copied to selected category",
// "No objects copied" => "No objects copied",
// "One page added to category" => "One page added to category",
// "%0 pages added to category" => "%0 pages added to category",
// "No pages added to category" => "No pages added to category",
// "%0 %1 removed from category %2" => "%0 %1 removed from category %2",
// "%0 %1 not removed from category %2" => "%0 %1 not removed from category %2",
// "Delete category" => "Delete category",
// "Category ID %0 and descendants deleted" => "Category ID %0 and descendants deleted",
// "Category ID %0 not deleted" => "Category ID %0 not deleted",
// "Category cannot be parent of itself - no changes made" => "Category cannot be parent of itself - no changes made",
// "Category %0 updated" => "Category %0 updated",
// "Category %0 created" => "Category %0 created",
// "The file does not have the required header" => "The file does not have the required header",
// "Incorrect parameter %0" => "Incorrect parameter %0",
// "Categories imported" => "Categories imported",
// "Edit permissions for this category" => "Edit permissions for this category",
// "Assign permissions" => "Assign permissions",
// "Template removed" => "Template removed",
// "Template not removed" => "Template not removed",
// "Section removed" => "Section removed",
// "Section not removed" => "Section not removed",
// "Template %0 created or modified" => "Template %0 created or modified",
// "Template %0 not created or modified" => "Template %0 not created or modified",
// "Contribution settings saved" => "Contribution settings saved",
// "Contribution settings not saved" => "Contribution settings not saved",
// "Contribution added" => "Contribution added",
// "Contribution not added" => "Contribution not added",
// "Contribution modified" => "Contribution modified",
// "Contribution not modified" => "Contribution not modified",
// "Contribution removed" => "Contribution removed",
// "Contribution not removed" => "Contribution not removed",
// "Cookie removed" => "Cookie removed",
// "Cookie not removed" => "Cookie not removed",
// "All cookies removed" => "All cookies removed",
// "No cookies removed" => "No cookies removed",
// "File uploaded and one cookie created or replaced" => "File uploaded and one cookie created or replaced",
// "File uploaded and %0 cookies created or replaced" => "File uploaded and %0 cookies created or replaced",
// "Upload failed - no cookies created" => "Upload failed - no cookies created",
"Upload failed" => "上傳失敗",
// "Cookie saved" => "Cookie saved",
// "Cookie not saved" => "Cookie not saved",
// "Admin credits" => "Admin credits",
// "DSN removed" => "DSN removed",
// "DSN not removed" => "DSN not removed",
// "DSN created or modified" => "DSN created or modified",
// "DSN not created or modified" => "DSN not created or modified",
// "External wiki removed" => "External wiki removed",
// "External wiki not removed" => "External wiki not removed",
// "External wiki saved" => "External wiki saved",
// "External wiki not saved" => "External wiki not saved",
// "Forum saved" => "Forum saved",
// "Forum not saved" => "Forum not saved",
// "Forum duplicated" => "Forum duplicated",
// "Forum not duplicated" => "Forum not duplicated",
"All posted" => "所有文章",
"Queue anonymous posts" => "保留匿名文章",
"Queue all posts" => "保留所有文章",
"No attachments" => "禁止附件",
"Everybody can attach" => "允許任何人附件",
"Only users with attach permission" => "只允許有附件權限的使用者",
"Moderators and admin can attach" => "只允許板主與管理者",
// "No display" => "No display",
"Date (desc)" => "日期 (降冪)",
"Date (asc)" => "日期 (升冪)",
"Score (desc)" => "分數 (降冪)",
"Replies (desc)" => "回覆 (降冪)",
"Reads (desc)" => "閱讀 (降冪)",
// "You have to provide a hotword and a URL" => "You have to provide a hotword and a URL",
// "Hotword added" => "Hotword added",
// "Hotword not added" => "Hotword not added",
// "Hotword deleted" => "Hotword deleted",
// "Hotword not deleted" => "Hotword not deleted",
// "One dynamic zone updated" => "One dynamic zone updated",
// "%0 dynamic zones updated" => "%0 dynamic zones updated",
// "Dynamic zones not updated" => "Dynamic zones not updated",
// "Hotword saved" => "Hotword saved",
// "Hotword not saved" => "Hotword not saved",
// "HTML page removed" => "HTML page removed",
// "HTML page not removed" => "HTML page not removed",
// "HTML page saved" => "HTML page saved",
// "HTML page not saved" => "HTML page not saved",
// "A custom rule with the same ID already exists" => "A custom rule with the same ID already exists",
// "Tiki IDS is not enabled" => "Tiki IDS is not enabled",
// "Requested action is not supported on repository" => "Requested action is not supported on repository",
// "Repository name can't be an empty" => "Repository name can't be an empty",
// "No repository" => "No repository",
// "Search is mandatory field" => "Search is mandatory field",
// "File not found " => "File not found ",
// "Requested action in not supported on repository" => "Requested action in not supported on repository",
// "You need to apply the \"Invoice\" profile" => "You need to apply the \"Invoice\" profile",
// "Remove keywords" => "Remove keywords",
// "Keywords for page \"%0\" saved" => "Keywords for page \"%0\" saved",
// "Keywords for page \"%0\" removed" => "Keywords for page \"%0\" removed",
// "Keywords were not updated" => "Keywords were not updated",
// "Featured link saved" => "Featured link saved",
// "Featured link not saved" => "Featured link not saved",
// "Non-existent link" => "Non-existent link",
// "Featured link removed" => "Featured link removed",
// "Featured link not removed" => "Featured link not removed",
// "Frequency should be a positive integer" => "Frequency should be a positive integer",
// "Mail-in accounts set to be checked every %s minutes" => "Mail-in accounts set to be checked every %s minutes",
// "Automatic Mail-in accounts checking disabled" => "Automatic Mail-in accounts checking disabled",
"No menu indicated" => "未指定選單",
// "Delete menu ID %0" => "Delete menu ID %0",
// "Reset the Application Menu to the current system default" => "Reset the Application Menu to the current system default",
// "Module file in use. You need to edit %0 to configure your modules" => "Module file in use. You need to edit %0 to configure your modules",
// "%0 cache files cleared" => "%0 cache files cleared",
// "Module unassigned" => "Module unassigned",
// "Module not unassigned" => "Module not unassigned",
// "Displayed order may not change if other modules now have the same order rank" => "Displayed order may not change if other modules now have the same order rank",
// "Also, displayed order may not change for you since you have assigned a custom order for modules %0here%1" => "Also, displayed order may not change for you since you have assigned a custom order for modules %0here%1",
// "Standard module display order moved up" => "Standard module display order moved up",
// "Standard module display order not moved up" => "Standard module display order not moved up",
// "Standard module display order moved down" => "Standard module display order moved down",
// "Standard module display order not moved down" => "Standard module display order not moved down",
// "Standard display of modules reordered or moved" => "Standard display of modules reordered or moved",
// "Standard display of modules not reordered or moved" => "Standard display of modules not reordered or moved",
// "If you receive this error after attempting more than once to move a module, it may be because the standard display has already been changed but it is not visible to you because you have assigned a custom order for modules %0here%1" => "If you receive this error after attempting more than once to move a module, it may be because the standard display has already been changed but it is not visible to you because you have assigned a custom order for modules %0here%1",
// "Cannot create or update module: You need to specify a name for the module" => "Cannot create or update module: You need to specify a name for the module",
// "Cannot create or update module: You cannot leave the data field empty" => "Cannot create or update module: You cannot leave the data field empty",
// "A module with that \"name\" already exists, please choose another" => "A module with that \"name\" already exists, please choose another",
// "Custom module created" => "Custom module created",
// "Custom module modified" => "Custom module modified",
// "Custom not module created" => "Custom not module created",
// "Custom module not modified" => "Custom module not modified",
// "There is a problem with your custom module \"%0\": ' . '<br><br><em>' . \$e->getMessage()\n\t\t\t\t\t. '</em><br><br>' . '<span class=\"button\"><a href=\"tiki-admin_modules.php?um_edit='\n\t\t\t\t\t. \$_REQUEST['assign_name'] . '&cookietab=2#editcreate\">' . tr('Click here to edit the module" => "There is a problem with your custom module \"%0\": ' . '<br><br><em>' . \$e->getMessage()\n\t\t\t\t\t. '</em><br><br>' . '<span class=\"button\"><a href=\"tiki-admin_modules.php?um_edit='\n\t\t\t\t\t. \$_REQUEST['assign_name'] . '&cookietab=2#editcreate\">' . tr('Click here to edit the module",
// "Module assigned" => "Module assigned",
// "Module not assigned" => "Module not assigned",
// "Custom module deleted" => "Custom module deleted",
// "Custom module not deleted" => "Custom module not deleted",
// "Appearance" => "Appearance",
"No newsletter indicated" => "未指定電子報",
// "Newsletter does not exist" => "Newsletter does not exist",
// "subscription" => "subscription",
// "subscriptions" => "subscriptions",
// "No subscriptions removed" => "No subscriptions removed",
// "Subscription removed" => "Subscription removed",
// "Subscription not removed" => "Subscription not removed",
// "Subscription marked as valid" => "Subscription marked as valid",
// "Subscription not marked as valid" => "Subscription not marked as valid",
// "Errors encountered when attempting to add subscription" => "Errors encountered when attempting to add subscription",
// "Subscription added" => "Subscription added",
// "Error opening uploaded file" => "Error opening uploaded file",
// "Error importing from wiki page \"%0\"" => "Error importing from wiki page \"%0\"",
// "Wiki page \"%0\" imported" => "Wiki page \"%0\" imported",
// "Error importing from tracker ID %0" => "Error importing from tracker ID %0",
// "Tracker ID %0 imported" => "Tracker ID %0 imported",
// "Not all subscriptions created" => "Not all subscriptions created",
// "Subscriptions not created" => "Subscriptions not created",
// "Subscriptions created" => "Subscriptions created",
// "Group \"%0\" subscribed" => "Group \"%0\" subscribed",
// "Group \"%0\" not subscribed" => "Group \"%0\" not subscribed",
// "Subscribers added" => "Subscribers added",
// "Subscribers not added" => "Subscribers not added",
// "Emails from wiki page \"%0\" subscribed" => "Emails from wiki page \"%0\" subscribed",
// "Emails from wiki page \"%0\" not subscribed" => "Emails from wiki page \"%0\" not subscribed",
// "%0 \$word removed" => "%0 \$word removed",
// "Newsletter removed" => "Newsletter removed",
// "Newsletter not removed" => "Newsletter not removed",
// "Newsletter created or modified" => "Newsletter created or modified",
// "Newsletter not created or modified" => "Newsletter not created or modified",
// "You need to provide a username or an email" => "You need to provide a username or an email",
// "The user has no email set. No notifications will be sent" => "The user has no email set. No notifications will be sent",
// "Mail notification event added" => "Mail notification event added",
// "Mail notification event deleted" => "Mail notification event deleted",
// "One mail notification events deleted" => "One mail notification events deleted",
// "%0 mail notifications events deleted" => "%0 mail notifications events deleted",
"No poll indicated" => "未指定投票",
// "Name is required" => "Name is required",
// "Task is required" => "Task is required",
// "Run Time is required" => "Run Time is required",
// "Run Time format is invalid" => "Run Time format is invalid",
// "Status cannot be empty" => "Status cannot be empty",
// "Scheduler %s was updated" => "Scheduler %s was updated",
// "Scheduler %s was created" => "Scheduler %s was created",
// "Inactive" => "Inactive",
// "unsafe" => "unsafe",
// "The Path to store files in the filegallery should be outside the tiki root directory" => "The Path to store files in the filegallery should be outside the tiki root directory",
// "The Path to store files in the imagegallery should be outside the tiki root directory" => "The Path to store files in the imagegallery should be outside the tiki root directory",
// "The feature \"Edit Templates\" is switched on. Do not allow anyone you cannot trust to use this feature. It can easily be used to inject php code" => "The feature \"Edit Templates\" is switched on. Do not allow anyone you cannot trust to use this feature. It can easily be used to inject php code",
// "The \"Snarf Wikiplugin\" is activated. It can be used by wiki editors to include pages from the local network and via regex replacement create any HTML" => "The \"Snarf Wikiplugin\" is activated. It can be used by wiki editors to include pages from the local network and via regex replacement create any HTML",
// "The \"Regex Wikiplugin\" is activated. It can be used by wiki editors to create any HTML via regex replacement" => "The \"Regex Wikiplugin\" is activated. It can be used by wiki editors to create any HTML via regex replacement",
// "The \"Lsdir Wikiplugin\" is activated. It can be used by wiki editors to view the contents of any directory" => "The \"Lsdir Wikiplugin\" is activated. It can be used by wiki editors to view the contents of any directory",
// "The \"Bloglist Wikiplugin\" is activated. It can be used by wiki editors to disclose private blog posts" => "The \"Bloglist Wikiplugin\" is activated. It can be used by wiki editors to disclose private blog posts",
// "The \"iframe Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks" => "The \"iframe Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks",
// "The \"js Wikiplugin\" is activated. It can be used by wiki editors to use JavaScript, which can be used to do all kind of nasty things like cross site scripting attacks, etc" => "The \"js Wikiplugin\" is activated. It can be used by wiki editors to use JavaScript, which can be used to do all kind of nasty things like cross site scripting attacks, etc",
// "The \"JQ Wikiplugin\" is activated. It can be used by wiki editors to use JavaScript, which can be used to do all kind of nasty things like cross site scripting attacks, etc" => "The \"JQ Wikiplugin\" is activated. It can be used by wiki editors to use JavaScript, which can be used to do all kind of nasty things like cross site scripting attacks, etc",
// "The \"Redirect Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks" => "The \"Redirect Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks",
// "The \"Module Wikiplugin\" is activated. It can be used by wiki editors to add modules which permit to access information (see module list)" => "The \"Module Wikiplugin\" is activated. It can be used by wiki editors to add modules which permit to access information (see module list)",
// "The \"Userlist Wikiplugin\" is activated. It can be used by wiki editors to display the list of users" => "The \"Userlist Wikiplugin\" is activated. It can be used by wiki editors to display the list of users",
// "The \"Usercount Wikiplugin\" is activated. It can be used by wiki editors to display a count of the number of users" => "The \"Usercount Wikiplugin\" is activated. It can be used by wiki editors to display a count of the number of users",
// "The \"SQL Wikiplugin\" is activated. It can be used by wiki editors to execute SQL commands" => "The \"SQL Wikiplugin\" is activated. It can be used by wiki editors to execute SQL commands",
// "risky" => "risky",
// "To the extent secure logins are not required, data transmitted between the browser and server is not private" => "To the extent secure logins are not required, data transmitted between the browser and server is not private",
// "One or more mail-in accounts have enabled \"Allow anonymous access\", which disables all permission checking for incoming email. Check tiki-admin_mailin.php" => "One or more mail-in accounts have enabled \"Allow anonymous access\", which disables all permission checking for incoming email. Check tiki-admin_mailin.php",
// "One or more mail-in accounts have enabled \"Allow admin access\", which allows for incoming email from admins. Admins have all rights, and web pages can easily be overwitten / tampered with. Check tiki-admin_mailin.php" => "One or more mail-in accounts have enabled \"Allow admin access\", which allows for incoming email from admins. Admins have all rights, and web pages can easily be overwitten / tampered with. Check tiki-admin_mailin.php",
// "Unlocked" => "Unlocked",
// "The installer is not locked. The installer could be accessed, putting the database at risk of being altered or destroyed" => "The installer is not locked. The installer could be accessed, putting the database at risk of being altered or destroyed",
// "Path disclosure" => "Path disclosure",
// "Path disclosure through error message" => "Path disclosure through error message",
// "SQL injection" => "SQL injection",
// "SQL injection by authenticated user" => "SQL injection by authenticated user",
// "SQL injection by authenticated user with special privileges" => "SQL injection by authenticated user with special privileges",
// "SQL injection without authentication" => "SQL injection without authentication",
// "PHP command injection" => "PHP command injection",
// "PHP command injection by authenticated user" => "PHP command injection by authenticated user",
// "PHP command injection by authenticated user with special privileges" => "PHP command injection by authenticated user with special privileges",
// "PHP command injection without authentication" => "PHP command injection without authentication",
// "File upload" => "File upload",
// "File is not readable. Unable to check" => "File is not readable. Unable to check",
// "This Tiki file differs from the SVN repository version. Check if this file was uploaded and if it is dangerous" => "This Tiki file differs from the SVN repository version. Check if this file was uploaded and if it is dangerous",
// "This is not a Tiki file. Check if this file was uploaded and if it is dangerous" => "This is not a Tiki file. Check if this file was uploaded and if it is dangerous",
// "This is a modified File. Cannot check version. Check if it is dangerous" => "This is a modified File. Cannot check version. Check if it is dangerous",
// "This file is from another Tiki version: " => "This file is from another Tiki version: ",
// "Shoutbox Words" => "Shoutbox Words",
// "You have to provide a word" => "You have to provide a word",
"You do not have permission to view this page." => "權限不足, 你無法觀看此頁面",
"You do not have permission to edit this page." => "權限不足, 你無法編輯此頁面",
// "You must specify a page name, it will be created if it doesn't exist" => "You must specify a page name, it will be created if it doesn't exist",
"page not added (Exists)" => "未加入頁面 (已存在)",
"No survey indicated" => "未指定調查",
// "Tiki Cache/Sys Admin" => "Tiki Cache/Sys Admin",
// "WYSIWYG Plugin" => "WYSIWYG Plugin",
// "Are you sure you want to delete all your custom tools" => "Are you sure you want to delete all your custom tools",
// "Are you sure you want to delete this custom tool" => "Are you sure you want to delete this custom tool",
// "Are you sure you want to remove this topic" => "Are you sure you want to remove this topic",
// "Are you sure you want to remove this topic AND all the articles related" => "Are you sure you want to remove this topic AND all the articles related",
"No tracker indicated" => "未指定追蹤",
// "Tracker Fields %0" => "Tracker Fields %0",
// "Are you sure you want to delete the webservice \"%0\"" => "Are you sure you want to delete the webservice \"%0\"",
// "Are you sure you want to delete the template \"%0\"" => "Are you sure you want to delete the template \"%0\"",
// "Webservice error \"%0\" not saved (alpha characters only)" => "Webservice error \"%0\" not saved (alpha characters only)",
"User doesn't exist" => "使用者不存在",
"No records were found. Check the file please!" => "找不到紀錄, 請檢查檔案!",
// "User login or email is required" => "User login or email is required",
// "User does not exist on master" => "User does not exist on master",
"User login is required" => "需要使用者登入",
"Email is required" => "需要 email",
"User is duplicated" => "使用者重複",
// "Created account %s <%s>" => "Created account %s <%s>",
// "Assigned %s in group %s" => "Assigned %s in group %s",
// "Users added" => "Users added",
// "%0 users not added" => "%0 users not added",
// "Email validation requested but email address not set" => "Email validation requested but email address not set",
// "The passwords do not match" => "The passwords do not match",
// "Password not set" => "Password not set",
// "User %s already exists" => "User %s already exists",
// "User login contains invalid characters" => "User login contains invalid characters",
// "New user created with username %s" => "New user created with username %s",
// "Impossible to create new %s with %s %s" => "Impossible to create new %s with %s %s",
// "User account %0 has been invalidated by the admin" => "User account %0 has been invalidated by the admin",
// "An error occurred - the user account %0 has not been invalidated by the admin" => "An error occurred - the user account %0 has not been invalidated by the admin",
// "Link to OpenID for user %0 has been removed" => "Link to OpenID for user %0 has been removed",
// "An error occurred - the link to OpenID for user %0 has not been removed" => "An error occurred - the link to OpenID for user %0 has not been removed",
// "Modify this user's data" => "Modify this user's data",
// "%s changed from %s to %s" => "%s changed from %s to %s",
// "%s modified successfully" => "%s modified successfully",
// "%s modification failed" => "%s modification failed",
// "Impossible to change %s from %s to %s" => "Impossible to change %s from %s to %s",
"email" => "電子郵件",
// "Unable to change %s from %s to %s" => "Unable to change %s from %s to %s",
"Review" => "評論",
// "Classified" => "Classified",
// "Failed to add attribute" => "Failed to add attribute",
// "rss feed disabled" => "rss feed disabled",
// "Are you sure you want to add user %0 to group %1" => "Are you sure you want to add user %0 to group %1",
// "You have to indicate a group" => "You have to indicate a group",
// "This group is invalid" => "This group is invalid",
// "Remote system user needs to be configured" => "Remote system user needs to be configured",
// "Remote system group for autologin need to be configured" => "Remote system group for autologin need to be configured",
// "User name needs to be specified" => "User name needs to be specified",
// "Base URL not received from remote system" => "Base URL not received from remote system",
// "Email needs to be specified" => "Email needs to be specified",
"The page cannot be found" => "找不到頁面",
// "Image Galleries Configuration Panel" => "Image Galleries Configuration Panel",
// "Could not read image %s" => "Could not read image %s",
// "Image %s upload failed" => "Image %s upload failed",
// "Image %s uploaded successfully" => "Image %s uploaded successfully",
// "Image %s removed from Batch directory" => "Image %s removed from Batch directory",
// "Impossible to remove image %s from Batch directory" => "Impossible to remove image %s from Batch directory",
// "Incorrect directory chosen for batch upload of images" => "Incorrect directory chosen for batch upload of images",
// "Please setup that dir on " => "Please setup that dir on ",
// "Please contact the website administrator" => "Please contact the website administrator",
// "Directory batch" => "Directory batch",
// "File Galleries Configuration Panel" => "File Galleries Configuration Panel",
// "Incorrect directory chosen for batch upload of files" => "Incorrect directory chosen for batch upload of files",
// "It isn't possible to post in any blog" => "It isn't possible to post in any blog",
// "You may need to create a blog first" => "You may need to create a blog first",
"You do not have permission to edit this post" => "權限不足, 你無法編輯此佈告",
"Top visited blogs" => "最熱門 blog",
"Last posts" => "最新發表",
"Top active blogs" => "最活躍 blog",
// "No blogId specified" => "No blogId specified",
// "Stop watching all categories" => "Stop watching all categories",
// "Watch all categories" => "Watch all categories",
// "Group watches for all categories" => "Group watches for all categories",
// "Stop watching this category and its descendants" => "Stop watching this category and its descendants",
// "Watch this category and its descendants" => "Watch this category and its descendants",
// "Group watches for this category" => "Group watches for this category",
// "Stop watching this category" => "Stop watching this category",
// "Watch this category" => "Watch this category",
// "Nothing tagged yet" => "Nothing tagged yet",
// "You must clear your browser cache" => "You must clear your browser cache",
"You do not have permission to access this gallery" => "你沒有存取這個圖庫的權限",
"No gallery indicated" => "未指定圖庫",
"You do not have permission to remove images from this gallery" => "你沒有刪除本圖庫中影像的權限",
"You do not have permission to rebuild thumbnails in this gallery" => "權限不足, 你無法建立此圖庫的縮圖",
"You do not have permission to rotate images in this gallery" => "權限不足, 你無法旋轉此圖庫中的影像",
"No image indicated" => "未指定影像",
"picture not found" => "找不到圖片",
"You do not have permission to move images from this gallery" => "你沒有移動本圖庫中檔案的權限",
"You do not have permission to view the calendar" => "權限不足, 你無法使用行事曆",
// "You need to <a href=\"tiki-admin_calendars.php?cookietab=2\">create a calendar</a>" => "You need to <a href=\"tiki-admin_calendars.php?cookietab=2\">create a calendar</a>",
"event without name" => "無名事件",
// "You do not have permission to view this page" => "You do not have permission to view this page",
// "Invalid date format" => "Invalid date format",
// "Your PHP installation does not have calendar enabled" => "Your PHP installation does not have calendar enabled",
// "%H:%M %Z" => "%H:%M %Z",
// "Invalid username or activation code. Maybe this code has already been used" => "Invalid username or activation code. Maybe this code has already been used",
// "Your email could not be validated; make sure you email is correct" => "Your email could not be validated; make sure you email is correct",
"You can not use the same password again" => "請勿再使用相同的密碼",
"Invalid old password" => "舊密碼錯誤",
// "Invalid request. Expecting channels array" => "Invalid request. Expecting channels array",
// "Missing channel name" => "Missing channel name",
// "One of the requested channels cannot be requested. It does not exist or permission is denied" => "One of the requested channels cannot be requested. It does not exist or permission is denied",
// "One of the install profiles could not be obtained" => "One of the install profiles could not be obtained",
// "info" => "info",
// "Errors will be logged, since log_errors is enabled. Also, display_errors is disabled. This is good practice for a production site, to log the errors instead of displaying them" => "Errors will be logged, since log_errors is enabled. Also, display_errors is disabled. This is good practice for a production site, to log the errors instead of displaying them",
// "How to change this value" => "How to change this value",
// "Errors will be logged, since log_errors is enabled, but display_errors is also enabled. Good practice, especially for a production site, is to log all errors instead of displaying them" => "Errors will be logged, since log_errors is enabled, but display_errors is also enabled. Good practice, especially for a production site, is to log all errors instead of displaying them",
// "Errors will not be logged, since log_errors is not enabled. Good practice, especially for a production site, is to log all errors" => "Errors will not be logged, since log_errors is not enabled. Good practice, especially for a production site, is to log all errors",
// "Errors will not be reported, because error_reporting and display_errors are both turned off. This may be appropriate for a production site but, if any problems occur, enable these in php.ini to get more information" => "Errors will not be reported, because error_reporting and display_errors are both turned off. This may be appropriate for a production site but, if any problems occur, enable these in php.ini to get more information",
// "No errors will be reported, although display_errors is On, because the error_reporting level is set to 0. This may be appropriate for a production site but, in if any problems occur, raise the value in php.ini to get more information" => "No errors will be reported, although display_errors is On, because the error_reporting level is set to 0. This may be appropriate for a production site but, in if any problems occur, raise the value in php.ini to get more information",
// "No errors will be reported, because display_errors is turned off. This may be appropriate for a production site but, in any problems occur, enable it in php.ini to get more information. The error_reporting level is reasonable at ' . \$e . '" => "No errors will be reported, because display_errors is turned off. This may be appropriate for a production site but, in any problems occur, enable it in php.ini to get more information. The error_reporting level is reasonable at ' . \$e . '",
// "Not all errors will be reported as the error_reporting level is at ' . \$e . '. ' . 'This is not necessarily a bad thing (and it may be appropriate for a production site) as critical errors will be reported, but sometimes it may be useful to get more information. Check the error_reporting level in php.ini if any problems are occurring" => "Not all errors will be reported as the error_reporting level is at ' . \$e . '. ' . 'This is not necessarily a bad thing (and it may be appropriate for a production site) as critical errors will be reported, but sometimes it may be useful to get more information. Check the error_reporting level in php.ini if any problems are occurring",
// "No errors will be reported although the error_reporting level is all the way up at ' . \$e . " => "No errors will be reported although the error_reporting level is all the way up at ' . \$e . ",
// "All errors will be reported as the error_reporting level is all the way up at ' . \$e . ' and display_errors is on. This is good because, in case of problems, the error reports usually contain useful information" => "All errors will be reported as the error_reporting level is all the way up at ' . \$e . ' and display_errors is on. This is good because, in case of problems, the error reports usually contain useful information",
// "good" => "good",
// "ini_set is used in some places to accommodate special needs of some Tiki features" => "ini_set is used in some places to accommodate special needs of some Tiki features",
// "unsure" => "unsure",
// "ini_set is used in some places to accommodate special needs of some Tiki features. Check disable_functions in your php.ini" => "ini_set is used in some places to accommodate special needs of some Tiki features. Check disable_functions in your php.ini",
// "The PDO extension is the suggested database driver/abstraction layer" => "The PDO extension is the suggested database driver/abstraction layer",
// "The recommended PDO database driver/abstraction layer cannot be found. The MySQLi driver is available, though, so the database connection will fall back to the AdoDB abstraction layer that is bundled with Tiki" => "The recommended PDO database driver/abstraction layer cannot be found. The MySQLi driver is available, though, so the database connection will fall back to the AdoDB abstraction layer that is bundled with Tiki",
// "The recommended PDO database driver/abstraction layer cannot be found. The MySQL driver is available, though, so the database connection will fall back to the AdoDB abstraction layer that is bundled with Tiki" => "The recommended PDO database driver/abstraction layer cannot be found. The MySQL driver is available, though, so the database connection will fall back to the AdoDB abstraction layer that is bundled with Tiki",
// "bad" => "bad",
// "None of the supported database drivers (PDO/mysqli/mysql) is loaded. This prevents Tiki from functioning" => "None of the supported database drivers (PDO/mysqli/mysql) is loaded. This prevents Tiki from functioning",
// "N/A" => "N/A",
// "Unable to detect" => "Unable to detect",
// "Cannot determine the size of this disk drive" => "Cannot determine the size of this disk drive",
// "Less than 200MB of free disk space is available. Tiki will not fit in this amount of disk space" => "Less than 200MB of free disk space is available. Tiki will not fit in this amount of disk space",
// "Less than 250MB of free disk space is available. This would be quite tight for a Tiki installation. Tiki needs disk space for compiled templates and uploaded files" => "Less than 250MB of free disk space is available. This would be quite tight for a Tiki installation. Tiki needs disk space for compiled templates and uploaded files",
// "When the disk space is filled, users, including administrators, will not be able to log in to Tiki" => "When the disk space is filled, users, including administrators, will not be able to log in to Tiki",
// "This test cannot reliably check for quotas, so be warned that if this server makes use of them, there might be less disk space available than reported" => "This test cannot reliably check for quotas, so be warned that if this server makes use of them, there might be less disk space available than reported",
// "More than 251MB of free disk space is available. Tiki will run smoothly, but there may be issues when the site grows (because of file uploads, for example)" => "More than 251MB of free disk space is available. Tiki will run smoothly, but there may be issues when the site grows (because of file uploads, for example)",
// "The PHP function disk_free_space is not available on your server, so the amount of available disk space can't be checked for" => "The PHP function disk_free_space is not available on your server, so the amount of available disk space can't be checked for",
// "PHP is being run as CGI. Feel free to use a threaded Apache MPM to increase performance" => "PHP is being run as CGI. Feel free to use a threaded Apache MPM to increase performance",
// "Looks like you are running PHP as FPM/CGI/FastCGI, you may be able to override some of your PHP configurations by add them to .user.ini files, see" => "Looks like you are running PHP as FPM/CGI/FastCGI, you may be able to override some of your PHP configurations by add them to .user.ini files, see",
// "PHP is being run using FPM (Fastcgi Process Manager). Feel free to use a threaded Apache MPM to increase performance" => "PHP is being run using FPM (Fastcgi Process Manager). Feel free to use a threaded Apache MPM to increase performance",
// "Looks like you are running PHP as a module in Apache, you may be able to override some of your PHP configurations by add them to .htaccess files, see" => "Looks like you are running PHP as a module in Apache, you may be able to override some of your PHP configurations by add them to .htaccess files, see",
// "PHP is not being run as CGI. Be aware that PHP is not thread-safe and you should not use a threaded Apache MPM (like worker)" => "PHP is not being run as CGI. Be aware that PHP is not thread-safe and you should not use a threaded Apache MPM (like worker)",
// "APC is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details" => "APC is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details",
// "xCache is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details" => "xCache is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details",
// "OPcache is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details" => "OPcache is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details",
// "Some PHP versions may exhibit randomly issues with the OpCache leading to the server starting to fail to serve all PHP requests, your PHP version seems to\n\t\t be affected, despite the performance penalty, we would recommend disabling the OpCache if you experience random crashes" => "Some PHP versions may exhibit randomly issues with the OpCache leading to the server starting to fail to serve all PHP requests, your PHP version seems to\n\t\t be affected, despite the performance penalty, we would recommend disabling the OpCache if you experience random crashes",
// "WinCache is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details" => "WinCache is being used as the ByteCode Cache, which increases performance if correctly configured. See Admin->Performance in the Tiki for more details",
// "WinCache is being used as the ByteCode Cache, but the required CGI/FastCGI server API is apparently not being used" => "WinCache is being used as the ByteCode Cache, but the required CGI/FastCGI server API is apparently not being used",
// "WinCache version 2 or higher is being used as the FileCache. It does not support a ByteCode Cache" => "WinCache version 2 or higher is being used as the FileCache. It does not support a ByteCode Cache",
// "It is recommended to use Zend opcode cache as the ByteCode Cache" => "It is recommended to use Zend opcode cache as the ByteCode Cache",
// "WinCache version 2 or higher is being used as the FileCache, but the required CGI/FastCGI server API is apparently not being used" => "WinCache version 2 or higher is being used as the FileCache, but the required CGI/FastCGI server API is apparently not being used",
// "The memory_limit is at" => "The memory_limit is at",
// "This is known to support smooth functioning even for bigger sites" => "This is known to support smooth functioning even for bigger sites",
// "This will normally work, but the site might run into problems when it grows" => "This will normally work, but the site might run into problems when it grows",
// "Your memory_limit is at" => "Your memory_limit is at",
// "This is known to cause issues! Ther memory_limit should be increased to at least 128M, which is the PHP default" => "This is known to cause issues! Ther memory_limit should be increased to at least 128M, which is the PHP default",
// "The session.save_handler should be set to 'files'" => "The session.save_handler should be set to 'files'",
// "Well set! The default setting of 'files' is recommended for Tiki" => "Well set! The default setting of 'files' is recommended for Tiki",
// "The session.save_path must writable" => "The session.save_path must writable",
// "The session.save_path is writable" => "The session.save_path is writable",
// "If you would be using the recommended session.save_handler setting of 'files\\" => "If you would be using the recommended session.save_handler setting of 'files\\",
// "It doesn't matter though, since your session.save_handler is not set to 'files'" => "It doesn't matter though, since your session.save_handler is not set to 'files'",
// "In conjunction with gc_divisor is used to manage probability that the gc (garbage collection) routine is started" => "In conjunction with gc_divisor is used to manage probability that the gc (garbage collection) routine is started",
// "Coupled with session.gc_probability defines the probability that the gc (garbage collection) process is started on every session initialization. The probability is calculated by using gc_probability/gc_divisor, e.g. 1/100 means there is a 1% chance that the GC process starts on each request" => "Coupled with session.gc_probability defines the probability that the gc (garbage collection) process is started on every session initialization. The probability is calculated by using gc_probability/gc_divisor, e.g. 1/100 means there is a 1% chance that the GC process starts on each request",
// "Specifies the number of seconds after which data will be seen as 'garbage' and potentially cleaned up. Garbage collection may occur during session start" => "Specifies the number of seconds after which data will be seen as 'garbage' and potentially cleaned up. Garbage collection may occur during session start",
// "The session is empty. Try reloading the page and, if this message is displayed again, there may be a problem with the server setup" => "The session is empty. Try reloading the page and, if this message is displayed again, there may be a problem with the server setup",
// "This appears to work" => "This appears to work",
// "zlib output compression is turned on. This saves bandwidth. On the other hand, turning it off would reduce CPU usage. The appropriate choice can be made for this Tiki" => "zlib output compression is turned on. This saves bandwidth. On the other hand, turning it off would reduce CPU usage. The appropriate choice can be made for this Tiki",
// "zlib output compression is turned off. This reduces CPU usage. On the other hand, turning it on would save bandwidth. The appropriate choice can be made for this Tiki" => "zlib output compression is turned off. This reduces CPU usage. On the other hand, turning it on would save bandwidth. The appropriate choice can be made for this Tiki",
// "register_globals should be off by default. See the PHP manual for details" => "register_globals should be off by default. See the PHP manual for details",
// "Correctly set! And this is also future proof as register_globals is deprecated" => "Correctly set! And this is also future proof as register_globals is deprecated",
// "safe_mode is deprecated and should be off by default. See the <a href=\"http://www.php.net/manual/de/features.safe-mode.php\">PHP manual</a> for details" => "safe_mode is deprecated and should be off by default. See the <a href=\"http://www.php.net/manual/de/features.safe-mode.php\">PHP manual</a> for details",
// "Correctly set! And this is also future proof as safe_mode is deprecated" => "Correctly set! And this is also future proof as safe_mode is deprecated",
// "Some features like assigning permissions to a group whose name contains a quote will not work with this turned on. magic_quotes_gpc is also deprecated and should be off by default. See the PHP manual for details. Having this turned on may cause Tiki to show strange behavior" => "Some features like assigning permissions to a group whose name contains a quote will not work with this turned on. magic_quotes_gpc is also deprecated and should be off by default. See the PHP manual for details. Having this turned on may cause Tiki to show strange behavior",
// "Correctly set! Some features like assigning permissions to a group whose name contains a quote will not work with this turned on. And this is also future proof as magic_quotes_gpc is deprecated" => "Correctly set! Some features like assigning permissions to a group whose name contains a quote will not work with this turned on. And this is also future proof as magic_quotes_gpc is deprecated",
// "Correctly set! Tiki is fully UTF-8 and so should be this installation" => "Correctly set! Tiki is fully UTF-8 and so should be this installation",
// "default_charset should be UTF-8 as Tiki is fully UTF-8. Please check the php.ini file" => "default_charset should be UTF-8 as Tiki is fully UTF-8. Please check the php.ini file",
// "No time zone is set! While there are a number of fallbacks in PHP to determine the time zone, the only reliable solution is to set it explicitly in php.ini! Please check the value of date.timezone in php.ini" => "No time zone is set! While there are a number of fallbacks in PHP to determine the time zone, the only reliable solution is to set it explicitly in php.ini! Please check the value of date.timezone in php.ini",
// "Well done! Having a time zone set protects the site from related errors" => "Well done! Having a time zone set protects the site from related errors",
// "Files can be uploaded to Tiki" => "Files can be uploaded to Tiki",
// "Files cannot be uploaded to Tiki" => "Files cannot be uploaded to Tiki",
// "The max_execution_time is at" => "The max_execution_time is at",
// "This is a good value for production sites. If timeouts are experienced (such as when performing admin functions) this may need to be increased nevertheless" => "This is a good value for production sites. If timeouts are experienced (such as when performing admin functions) this may need to be increased nevertheless",
// "The max_execution_time is unlimited" => "The max_execution_time is unlimited",
// "This is not necessarily bad, but it's a good idea to limit this time on productions servers in order to eliminate unexpectedly long running scripts" => "This is not necessarily bad, but it's a good idea to limit this time on productions servers in order to eliminate unexpectedly long running scripts",
// "It is likely that some scripts, such as admin functions, will not finish in this time! The max_execution_time should be incresed to at least 30s" => "It is likely that some scripts, such as admin functions, will not finish in this time! The max_execution_time should be incresed to at least 30s",
// "The max_input_time is at" => "The max_input_time is at",
// "The max_input_time is unlimited" => "The max_input_time is unlimited",
// "It is likely that some scripts, such as admin functions, will not finish in this time! The max_input_time should be increased to at least 30 seconds" => "It is likely that some scripts, such as admin functions, will not finish in this time! The max_input_time should be increased to at least 30 seconds",
// "The max_file_uploads is at" => "The max_file_uploads is at",
// "This is the maximum number of files allowed to be uploaded simultaneously" => "This is the maximum number of files allowed to be uploaded simultaneously",
// "The maximum number of files allowed to be uploaded is not available" => "The maximum number of files allowed to be uploaded is not available",
// "The upload_max_filesize is at" => "The upload_max_filesize is at",
// "Quite large files can be uploaded, but keep in mind to set the script timeouts accordingly" => "Quite large files can be uploaded, but keep in mind to set the script timeouts accordingly",
// "Upload size is unlimited and this not advised. A user could mistakenly upload a very large file which could fill up the disk. This value should be set to accommodate the realistic needs of the site" => "Upload size is unlimited and this not advised. A user could mistakenly upload a very large file which could fill up the disk. This value should be set to accommodate the realistic needs of the site",
// "This is not a bad amount, but be sure the level is high enough to accommodate the needs of the site" => "This is not a bad amount, but be sure the level is high enough to accommodate the needs of the site",
// "The post_max_size is at" => "The post_max_size is at",
// "The GD extension is needed for manipulation of images and for CAPTCHA images" => "The GD extension is needed for manipulation of images and for CAPTCHA images",
// "The GD extension is loaded, and Tiki can create images, but the FreeType extension is needed for CAPTCHA text generation" => "The GD extension is loaded, and Tiki can create images, but the FreeType extension is needed for CAPTCHA text generation",
// "The GD extension is loaded, but Tiki is unable to create images. Please check your GD library configuration" => "The GD extension is loaded, but Tiki is unable to create images. Please check your GD library configuration",
// "ImageMagick is used as a fallback in case GD is not available" => "ImageMagick is used as a fallback in case GD is not available",
// "ImageMagick is available, but unable to create images. Please check your ImageMagick configuration" => "ImageMagick is available, but unable to create images. Please check your ImageMagick configuration",
// "mbstring extension is needed for an UTF-8 compatible lower case filter, in the admin search for example" => "mbstring extension is needed for an UTF-8 compatible lower case filter, in the admin search for example",
// "mbstring extension is loaded, but mbstring.func_overload = ' . ' ' . \$func_overload . '.' . ' ' . 'Tiki only works with mbstring.func_overload = 0. Please check the php.ini file" => "mbstring extension is loaded, but mbstring.func_overload = ' . ' ' . \$func_overload . '.' . ' ' . 'Tiki only works with mbstring.func_overload = 0. Please check the php.ini file",
// "mbstring extension is loaded, but missing important functions such as mb_split(). Reinstall it with --enable-mbregex or ask your a server administrator to do it" => "mbstring extension is loaded, but missing important functions such as mb_split(). Reinstall it with --enable-mbregex or ask your a server administrator to do it",
// "mbstring extension is needed for an UTF-8 compatible lower case filter" => "mbstring extension is needed for an UTF-8 compatible lower case filter",
// "calendar extension is needed by Tiki" => "calendar extension is needed by Tiki",
// "The calendar feature of Tiki will not function without this" => "The calendar feature of Tiki will not function without this",
// "ctype extension is needed by Tiki" => "ctype extension is needed by Tiki",
// "This extension is needed for the dom extension (see below)" => "This extension is needed for the dom extension (see below)",
// "This extension is needed by Tiki" => "This extension is needed by Tiki",
// "This extension is needed to connect Tiki to an LDAP server. More info at: http://doc.tiki.org/LDAP " => "This extension is needed to connect Tiki to an LDAP server. More info at: http://doc.tiki.org/LDAP ",
// "Tiki will not be able to connect to an LDAP server as the needed PHP extension is missing. More info at: http://doc.tiki.org/LDAP" => "Tiki will not be able to connect to an LDAP server as the needed PHP extension is missing. More info at: http://doc.tiki.org/LDAP",
// "This extension can be used to speed up Tiki by saving sessions as well as wiki and forum data on a memcached server" => "This extension can be used to speed up Tiki by saving sessions as well as wiki and forum data on a memcached server",
// "This extension can be used to speed up Tiki by saving wiki and forum data on a redis server" => "This extension can be used to speed up Tiki by saving wiki and forum data on a redis server",
// "This extension is needed for the show.tiki.org tracker field type, up to Tiki 17" => "This extension is needed for the show.tiki.org tracker field type, up to Tiki 17",
// "This extension is required for H5P" => "This extension is required for H5P",
// "This extension is required for many features in Tiki" => "This extension is required for many features in Tiki",
// "This extension is used to interpret SVN information for TortoiseSVN 1.7 or higher" => "This extension is used to interpret SVN information for TortoiseSVN 1.7 or higher",
// "Enable safe, encrypted storage of data such as passwords. Required for the User Encryption feature and improves encryption in other features, when available" => "Enable safe, encrypted storage of data such as passwords. Required for the User Encryption feature and improves encryption in other features, when available",
// "MCrypt is abandonware and is being phased out. Starting in version 18, Tiki uses OpenSSL where it previously used MCrypt, except perhaps via third-party libraries" => "MCrypt is abandonware and is being phased out. Starting in version 18, Tiki uses OpenSSL where it previously used MCrypt, except perhaps via third-party libraries",
// "Tiki still uses MCrypt to decrypt user data encrypted with MCrypt, when converting that data to OpenSSL" => "Tiki still uses MCrypt to decrypt user data encrypted with MCrypt, when converting that data to OpenSSL",
// "Please check the 'User Data Encryption' section to see if there is user data encrypted with MCrypt" => "Please check the 'User Data Encryption' section to see if there is user data encrypted with MCrypt",
// "Ability to generate random numbers, useful for example for CAPTCHA and other security features" => "Ability to generate random numbers, useful for example for CAPTCHA and other security features",
// "This extension is required and used frequently in validation functions invoked within Zend Framework" => "This extension is required and used frequently in validation functions invoked within Zend Framework",
// "The eval() function is required by the Smarty templating engine" => "The eval() function is required by the Smarty templating engine",
// "You will get \"Please contact support about\" messages instead of modules. eval() is most probably disabled via Suhosin" => "You will get \"Please contact support about\" messages instead of modules. eval() is most probably disabled via Suhosin",
// "The ZipArchive class is needed for features such as XML Wiki Import/Export and PluginArchiveBuilder" => "The ZipArchive class is needed for features such as XML Wiki Import/Export and PluginArchiveBuilder",
// "The DateTime class is needed for the WebDAV feature" => "The DateTime class is needed for the WebDAV feature",
// "Xdebug can be very handy for a development server, but it might be better to disable it when on a production server" => "Xdebug can be very handy for a development server, but it might be better to disable it when on a production server",
// "Tiki requires MySQL >= 5.x" => "Tiki requires MySQL >= 5.x",
// "The max_allowed_packet setting is at" => "The max_allowed_packet setting is at",
// "This limits the size of binary files that can be uploaded to Tiki, when storing files in the database. Please see: <a href=\"http://doc.tiki.org/File+Storage\">file storage</a>" => "This limits the size of binary files that can be uploaded to Tiki, when storing files in the database. Please see: <a href=\"http://doc.tiki.org/File+Storage\">file storage</a>",
// "Your database supports the utf8mb4 character set required in Tiki19 and above" => "Your database supports the utf8mb4 character set required in Tiki19 and above",
// "Your database does not support the utf8mb4 character set required in Tiki19 and above. You need to upgrade your mysql or mariadb installation" => "Your database does not support the utf8mb4 character set required in Tiki19 and above. You need to upgrade your mysql or mariadb installation",
// "Tiki is fully utf8mb4 and so should be every part of the stack" => "Tiki is fully utf8mb4 and so should be every part of the stack",
// "On a fresh install everything should be set to utf8mb4 to avoid unexpected results. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>" => "On a fresh install everything should be set to utf8mb4 to avoid unexpected results. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>",
// "Tiki is fully utf8mb4 but some database underlying variables are set to utf8 by the database engine and cannot be modified" => "Tiki is fully utf8mb4 but some database underlying variables are set to utf8 by the database engine and cannot be modified",
// "On a fresh install everything should be set to utf8mb4 or utf8 to avoid unexpected results. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>" => "On a fresh install everything should be set to utf8mb4 or utf8 to avoid unexpected results. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>",
// "Tiki is fully utf8mb4 and so should be every part of the stack. utf8mb4_unicode_ci is the default collation for Tiki" => "Tiki is fully utf8mb4 and so should be every part of the stack. utf8mb4_unicode_ci is the default collation for Tiki",
// "On a fresh install everything should be set to utf8mb4 to avoid unexpected results. utf8mb4_unicode_ci is the default collation for Tiki. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>" => "On a fresh install everything should be set to utf8mb4 to avoid unexpected results. utf8mb4_unicode_ci is the default collation for Tiki. For further information please see <a href=\"http://doc.tiki.org/Understanding+Encoding\">Understanding Encoding</a>",
// "MySQL doesn't log slow queries. If performance issues are noticed, this could be enabled, but keep in mind that the logging itself slows MySQL down" => "MySQL doesn't log slow queries. If performance issues are noticed, this could be enabled, but keep in mind that the logging itself slows MySQL down",
// "MySQL logs slow queries. If no performance issues are noticed, this should be disabled on a production site as it slows MySQL down" => "MySQL logs slow queries. If no performance issues are noticed, this should be disabled on a production site as it slows MySQL down",
// "ON" => "ON",
// "OFF" => "OFF",
// "Tiki needs this module for Search Engine Friendly URLs via .htaccess. However, it can't be checked if this web server respects configurations made in .htaccess. For further information go to Admin->SefURL in your Tiki" => "Tiki needs this module for Search Engine Friendly URLs via .htaccess. However, it can't be checked if this web server respects configurations made in .htaccess. For further information go to Admin->SefURL in your Tiki",
// "Tiki needs this module for Search Engine Friendly URLs. For further information go to Admin->SefURL in the Tiki" => "Tiki needs this module for Search Engine Friendly URLs. For further information go to Admin->SefURL in the Tiki",
// "RewriteBase is set correctly in .htaccess. Search Engine Friendly URLs should work. Be aware, though, that this test can't checked if Apache really loads .htaccess" => "RewriteBase is set correctly in .htaccess. Search Engine Friendly URLs should work. Be aware, though, that this test can't checked if Apache really loads .htaccess",
// "RewriteBase is not set correctly in .htaccess. Search Engine Friendly URLs are not going to work with this configuration. It should be set to \"" => "RewriteBase is not set correctly in .htaccess. Search Engine Friendly URLs are not going to work with this configuration. It should be set to \"",
// "The .htaccess file has not been activated, so this check cannot be  performed. To use Search Engine Friendly URLs, activate .htaccess by copying _htaccess into its place (or a symlink if supported by your Operating System). Then do this check again" => "The .htaccess file has not been activated, so this check cannot be  performed. To use Search Engine Friendly URLs, activate .htaccess by copying _htaccess into its place (or a symlink if supported by your Operating System). Then do this check again",
// "Not Working" => "Not Working",
// "The automated test could not run. The required files could not be created  on the server to run the test. That may only mean that there were no permissions, but the Apache configuration should be checked. For further information go to Admin->SefURL in the Tiki" => "The automated test could not run. The required files could not be created  on the server to run the test. That may only mean that there were no permissions, but the Apache configuration should be checked. For further information go to Admin->SefURL in the Tiki",
// "Working" => "Working",
// "An automated test was done, and the server appears to be configured correctly to handle Search Engine Friendly URLs" => "An automated test was done, and the server appears to be configured correctly to handle Search Engine Friendly URLs",
// "An automated test was done and, based on the results, the server does not appear to be configured correctly to handle Search Engine Friendly URLs. The server returned an unexpected HTTP code: \"%s\". This automated test may fail due to the infrastructure setup, but the Apache configuration should be checked. For further information go to Admin->SefURL in your Tiki" => "An automated test was done and, based on the results, the server does not appear to be configured correctly to handle Search Engine Friendly URLs. The server returned an unexpected HTTP code: \"%s\". This automated test may fail due to the infrastructure setup, but the Apache configuration should be checked. For further information go to Admin->SefURL in your Tiki",
// "An automated test was done and, based on the results, the server does not appear to be configured correctly to handle Search Engine Friendly URLs. This automated test may fail due to the infrastructure setup, but the Apache configuration should be checked. For further information go to Admin->SefURL in your Tiki" => "An automated test was done and, based on the results, the server does not appear to be configured correctly to handle Search Engine Friendly URLs. This automated test may fail due to the infrastructure setup, but the Apache configuration should be checked. For further information go to Admin->SefURL in your Tiki",
// "With this module, the HTTP Expires header can be set, which increases performance. It can't be checked, though, if mod_expires is configured correctly" => "With this module, the HTTP Expires header can be set, which increases performance. It can't be checked, though, if mod_expires is configured correctly",
// "With this module, the HTTP Expires header can be set, which increases performance. Once it is installed, it still needs to be configured correctly" => "With this module, the HTTP Expires header can be set, which increases performance. Once it is installed, it still needs to be configured correctly",
// "With this module, the data the webserver sends out can be compressed, which reduced data transfer amounts and increases performance. This test can't check, though, if mod_deflate is configured correctly" => "With this module, the data the webserver sends out can be compressed, which reduced data transfer amounts and increases performance. This test can't check, though, if mod_deflate is configured correctly",
// "With this module, the data the webserver sends out can be compressed, which reduces data transfer amounts and increases performance. Once it is installed, it still needs to be configured correctly" => "With this module, the data the webserver sends out can be compressed, which reduces data transfer amounts and increases performance. Once it is installed, it still needs to be configured correctly",
// "This module can increase security of Tiki and therefore the server, but be aware that it is very tricky to configure correctly. A misconfiguration can lead to failed page saves or other hard to trace bugs" => "This module can increase security of Tiki and therefore the server, but be aware that it is very tricky to configure correctly. A misconfiguration can lead to failed page saves or other hard to trace bugs",
// "The URL Rewrite Module is required to use SEFURL on IIS" => "The URL Rewrite Module is required to use SEFURL on IIS",
// "Not Installed" => "Not Installed",
// "Tesseract PHP package could not be found. Try installing through Packages" => "Tesseract PHP package could not be found. Try installing through Packages",
// "Tesseract PHP dependency installed" => "Tesseract PHP dependency installed",
// "The installed Tesseract version is lower than the required version" => "The installed Tesseract version is lower than the required version",
// "Tesseract package" => "Tesseract package",
// "languages installed" => "languages installed",
// "Not all languages installed. You may need to install additional languages for multilingual support" => "Not all languages installed. You may need to install additional languages for multilingual support",
// "Tesseract languages" => "Tesseract languages",
// "Tesseract could not be found" => "Tesseract could not be found",
// "Tesseract meets or exceeds the version requirements" => "Tesseract meets or exceeds the version requirements",
// "Tesseract binary" => "Tesseract binary",
// "Your path preference is not configured. It may work now but will likely fail with cron. Specify an absolute path" => "Your path preference is not configured. It may work now but will likely fail with cron. Specify an absolute path",
// "Path setup correctly" => "Path setup correctly",
// "Your path may not be configured correctly. It appears to be located at " => "Your path may not be configured correctly. It appears to be located at ",
// "Your path is configured, but we were unable to tell if it was configured properly or not" => "Your path is configured, but we were unable to tell if it was configured properly or not",
// "Tesseract path" => "Tesseract path",
// "Pdfimages path" => "Pdfimages path",
// "Scheduler has been successfully setup" => "Scheduler has been successfully setup",
// "Scheduler needs to have a console command of \"ocr:all\" set" => "Scheduler needs to have a console command of \"ocr:all\" set",
// "upload_tmp_dir is probably inside the Tiki directory. There is a risk that someone can upload any file to this directory and access it via web browser" => "upload_tmp_dir is probably inside the Tiki directory. There is a risk that someone can upload any file to this directory and access it via web browser",
// "It can't be reliably determined if the upload_tmp_dir is accessible via a web browser. To be sure, check the webserver configuration" => "It can't be reliably determined if the upload_tmp_dir is accessible via a web browser. To be sure, check the webserver configuration",
// "safe" => "safe",
// "WebKit is enabled" => "WebKit is enabled",
// "The Blogs feature is enabled" => "The Blogs feature is enabled",
// "Exec can potentially be used to execute arbitrary code on the server" => "Exec can potentially be used to execute arbitrary code on the server",
// "Tiki does not need it; perhaps it should be disabled" => "Tiki does not need it; perhaps it should be disabled",
// "However, the Plugins R/RR need it. If you use the Plugins R/RR and the other PHP software on the server can be trusted, this should be enabled" => "However, the Plugins R/RR need it. If you use the Plugins R/RR and the other PHP software on the server can be trusted, this should be enabled",
// "Exec can be potentially be used to execute arbitrary code on the server" => "Exec can be potentially be used to execute arbitrary code on the server",
// "Tiki needs it to run the Plugins R/RR" => "Tiki needs it to run the Plugins R/RR",
// "If this is needed and the other PHP software on the server can be trusted, this should be enabled" => "If this is needed and the other PHP software on the server can be trusted, this should be enabled",
// "Passthru is similar to exec" => "Passthru is similar to exec",
// "Tiki does not need it; perhaps it should be disabled. However, the Composer package manager used for installations in Subversion checkouts may need it" => "Tiki does not need it; perhaps it should be disabled. However, the Composer package manager used for installations in Subversion checkouts may need it",
// "Tiki does not need it; it is good that it is disabled. However, the Composer package manager used for installations in Subversion checkouts may need it" => "Tiki does not need it; it is good that it is disabled. However, the Composer package manager used for installations in Subversion checkouts may need it",
// "Shell_exec is similar to exec" => "Shell_exec is similar to exec",
// "Tiki needs it to run PDF from URL: WebKit (wkhtmltopdf). ' . \$pdf_webkit . 'If this is needed and the other PHP software on the server can be trusted, this should be enabled" => "Tiki needs it to run PDF from URL: WebKit (wkhtmltopdf). ' . \$pdf_webkit . 'If this is needed and the other PHP software on the server can be trusted, this should be enabled",
// "System is similar to exec" => "System is similar to exec",
// "Tiki does not need it; it is good that it is disabled" => "Tiki does not need it; it is good that it is disabled",
// "Proc_open is similar to exec" => "Proc_open is similar to exec",
// "Tiki does not need it; perhaps it should be disabled. However, the Composer package manager used for installations in Subversion checkouts or when using the package manager from the <a href=\"https://doc.tiki.org/Packages\" target=\"_blank\">admin interface</a> may need it" => "Tiki does not need it; perhaps it should be disabled. However, the Composer package manager used for installations in Subversion checkouts or when using the package manager from the <a href=\"https://doc.tiki.org/Packages\" target=\"_blank\">admin interface</a> may need it",
// "Tiki does not need it; it is good that it is disabled. However, the Composer package manager used for installations in Subversion checkouts or when using the package manager from the <a href=\"https://doc.tiki.org/Packages\" target=\"_blank\">admin interface</a> may need it" => "Tiki does not need it; it is good that it is disabled. However, the Composer package manager used for installations in Subversion checkouts or when using the package manager from the <a href=\"https://doc.tiki.org/Packages\" target=\"_blank\">admin interface</a> may need it",
// "popen is similar to exec" => "popen is similar to exec",
// "Tiki needs it for file search indexing in file galleries. If this is needed and other PHP software on the server can be trusted, this should be enabled" => "Tiki needs it for file search indexing in file galleries. If this is needed and other PHP software on the server can be trusted, this should be enabled",
// "Curl_exec can potentially be abused to write malicious code" => "Curl_exec can potentially be abused to write malicious code",
// "Tiki needs it to run features like Kaltura, CAS login, CClite and the myspace and sf wiki-plugins. If these are needed and other PHP software on the server can be trusted, this should be enabled" => "Tiki needs it to run features like Kaltura, CAS login, CClite and the myspace and sf wiki-plugins. If these are needed and other PHP software on the server can be trusted, this should be enabled",
// "Curl_multi_exec can potentially be abused to write malicious code" => "Curl_multi_exec can potentially be abused to write malicious code",
// "It is probably an urban myth that this is dangerous. Tiki team will reconsider this check, but be warned" => "It is probably an urban myth that this is dangerous. Tiki team will reconsider this check, but be warned",
// "It is required for the <a href=\"http://doc.tiki.org/System+Configuration\" target=\"_blank\">System Configuration</a> feature" => "It is required for the <a href=\"http://doc.tiki.org/System+Configuration\" target=\"_blank\">System Configuration</a> feature",
// "session.use_trans_sid should be off by default. See the PHP manual for details" => "session.use_trans_sid should be off by default. See the PHP manual for details",
// "Setting the xbithack option is unsafe. Depending on the file handling of the webserver and the Tiki settings, an attacker may be able to upload scripts to file gallery and execute them" => "Setting the xbithack option is unsafe. Depending on the file handling of the webserver and the Tiki settings, an attacker may be able to upload scripts to file gallery and execute them",
// "setting the xbithack option is unsafe. Depending on the file handling of the webserver and the Tiki settings,  an attacker may be able to upload scripts to file gallery and execute them" => "setting the xbithack option is unsafe. Depending on the file handling of the webserver and the Tiki settings,  an attacker may be able to upload scripts to file gallery and execute them",
// "allow_url_fopen may potentially be used to upload remote data or scripts. Also used by Composer to fetch dependencies. ' . \$feature_blogs . 'If this Tiki does not use the Blogs feature, this can be switched off" => "allow_url_fopen may potentially be used to upload remote data or scripts. Also used by Composer to fetch dependencies. ' . \$feature_blogs . 'If this Tiki does not use the Blogs feature, this can be switched off",
// "Tiki detected that there are temporary files in the db folder that may expose credentials or other sensitive information" => "Tiki detected that there are temporary files in the db folder that may expose credentials or other sensitive information",
// "Tiki did not detect temporary files in the db folder that may expose credentials or other sensitive information" => "Tiki did not detect temporary files in the db folder that may expose credentials or other sensitive information",
// "To manage this instance from a remote server you need SSH or FTP access to this server" => "To manage this instance from a remote server you need SSH or FTP access to this server",
// "Command found" => "Command found",
// "Command not found, check if it is installed and available in one of the paths above" => "Command not found, check if it is installed and available in one of the paths above",
// "Extension loaded in PHP" => "Extension loaded in PHP",
// "Extension not loaded in PHP" => "Extension not loaded in PHP",
// "Test mail from Tiki Server Compatibility Test" => "Test mail from Tiki Server Compatibility Test",
// "It was possible to send an e-mail. This only means that a mail server accepted the mail for delivery. This check can\\;t verify if that server actually delivered the mail. Please check the inbox of ' . htmlspecialchars(\$email) . ' to see if the mail was delivered" => "It was possible to send an e-mail. This only means that a mail server accepted the mail for delivery. This check can\\;t verify if that server actually delivered the mail. Please check the inbox of ' . htmlspecialchars(\$email) . ' to see if the mail was delivered",
// "It was not possible to send an e-mail. It may be that there is no mail server installed on this machine or that it is incorrectly configured. If the local mail server cannot be made to work, a regular mail account can be set up and its SMTP settings configured in tiki-admin.php" => "It was not possible to send an e-mail. It may be that there is no mail server installed on this machine or that it is incorrectly configured. If the local mail server cannot be made to work, a regular mail account can be set up and its SMTP settings configured in tiki-admin.php",
// "Neither APC, WinCache nor xCache is being used as the ByteCode Cache; if one of these were used and correctly configured, performance would be increased. See Admin->Performance in the Tiki for more details" => "Neither APC, WinCache nor xCache is being used as the ByteCode Cache; if one of these were used and correctly configured, performance would be increased. See Admin->Performance in the Tiki for more details",
// "Neither APC, xCache, nor OPcache is being used as the ByteCode Cache; if one of these were used and correctly configured, performance would be increased. See Admin->Performance in the Tiki for more details" => "Neither APC, xCache, nor OPcache is being used as the ByteCode Cache; if one of these were used and correctly configured, performance would be increased. See Admin->Performance in the Tiki for more details",
// "The memory_limit is unlimited. This is not necessarily bad, but it's a good idea to limit this on productions servers in order to eliminate unexpectedly greedy scripts" => "The memory_limit is unlimited. This is not necessarily bad, but it's a good idea to limit this on productions servers in order to eliminate unexpectedly greedy scripts",
// "The fileinfo extension is needed for the 'Validate uploaded file content' preference" => "The fileinfo extension is needed for the 'Validate uploaded file content' preference",
// "The intl extension is required for Tiki 15 and newer" => "The intl extension is required for Tiki 15 and newer",
// "intl extension is preferred for Tiki 15 and newer. Because is not available, the filters for text will not be able to detect the language and will use a generic range of characters as letters" => "intl extension is preferred for Tiki 15 and newer. Because is not available, the filters for text will not be able to detect the language and will use a generic range of characters as letters",
// "Congratulations!\n\nThis server can send emails.\n\n" => "Congratulations!\n\nThis server can send emails.\n\n",
// "The path '%0' on preference '%1' does not exist" => "The path '%0' on preference '%1' does not exist",
// "The lib '%0' on preference '%1', option '%2' does not exist" => "The lib '%0' on preference '%1', option '%2' does not exist",
// "The class '%0' needed for preference '%1', with option '%2' selected, does not exist" => "The class '%0' needed for preference '%1', with option '%2' selected, does not exist",
// "The extension '%0' on preference '%1', with option '%2' selected, is not loaded" => "The extension '%0' on preference '%1', with option '%2' selected, is not loaded",
"Top authors" => "最多產作者",
// "User %0 validated by the admin" => "User %0 validated by the admin",
// "Problem. Try to log in again to receive new confirmation instructions" => "Problem. Try to log in again to receive new confirmation instructions",
"Invalid" => "Invalid",
// "You must include a subject or a message" => "You must include a subject or a message",
// "You must make sure to have a valid email address in the From field" => "You must make sure to have a valid email address in the From field",
// "%0 sent you a message" => "%0 sent you a message",
// "last version" => "last version",
// "Cannot rename page because the new name begins with reserved prefix" => "Cannot rename page because the new name begins with reserved prefix",
// "Cannot copy page because maybe new page name already exists" => "Cannot copy page because maybe new page name already exists",
// "TikiHelp WebHelp generation engine. Generating WebHelp using" => "TikiHelp WebHelp generation engine. Generating WebHelp using",
// "Eliminating previous files" => "Eliminating previous files",
// "Index: <strong>%0</strong>" => "Index: <strong>%0</strong>",
// "Directory: <strong>%0</strong>" => "Directory: <strong>%0</strong>",
// "Unable to create directory Run <code>sh setup.sh</code> from the command line to fix" => "Unable to create directory Run <code>sh setup.sh</code> from the command line to fix",
// "You need to change chmod 'whelp' manually to 777" => "You need to change chmod 'whelp' manually to 777",
// "Creating directory structure in <strong>%0</strong>" => "Creating directory structure in <strong>%0</strong>",
// "Submit a new link" => "Submit a new link",
// "Must enter a name to add a site. " => "Must enter a name to add a site. ",
// "Must enter a url to add a site. " => "Must enter a url to add a site. ",
// "URL already added to the directory. Duplicate site? " => "URL already added to the directory. Duplicate site? ",
// "URL cannot be accessed wrong URL or site is offline and cannot be added to the directory. " => "URL cannot be accessed wrong URL or site is offline and cannot be added to the directory. ",
// "Must select a category. " => "Must select a category. ",
"Must enter a name to add a site" => "增加站臺時必須輸入名稱",
"Must enter a url to add a site" => "增加站臺時必須輸入 URL",
"URL already added to the directory. Duplicate site?" => "已經加入過此URL了. 是否為重複站臺?",
// "URL cannot be accessed: wrong URL or site is offline and cannot be added to the directory" => "URL cannot be accessed: wrong URL or site is offline and cannot be added to the directory",
"Must select a category" => "請選擇一個分類",
"Browse Directory" => "瀏覽目錄",
// "How to use Directory" => "How to use Directory",
"No site indicated" => "未指定站臺",
// "This feature is disabled: %0" => "This feature is disabled: %0",
// "No parent specified" => "No parent specified",
// "Latest sites of directory %0" => "Latest sites of directory %0",
// "Discount code already exists" => "Discount code already exists",
// "Invalid fileId. Please provide a valid fileId to preview a specific file" => "Invalid fileId. Please provide a valid fileId to preview a specific file",
// "Unable to display file" => "Unable to display file",
// "File has been deleted" => "File has been deleted",
// "You cannot download this file right now. Your score is low or file limit was reached" => "You cannot download this file right now. Your score is low or file limit was reached",
// "File locked" => "File locked",
// "File not locked" => "File not locked",
// "Error : The file %s doesn't exist" => "Error : The file %s doesn't exist",
"Article not found" => "找不到文章",
"You do not have permission to edit this article" => "你沒有權限編輯此文章",
// "The language can't be changed as its set of translations has already this language" => "The language can't be changed as its set of translations has already this language",
"Banner not found" => "找不到大標題",
"You do not have permission to edit this banner" => "權限不足, 你無法編輯此blog",
"You do not have permission to edit this blog" => "權限不足, 你無法編輯此 blog",
// "No filters applied" => "No filters applied",
// "You do not have permission to write the css file" => "You do not have permission to write the css file",
// "Wrong file type, expected one of %0" => "Wrong file type, expected one of %0",
// "You do not have permission to view/edit this file" => "You do not have permission to view/edit this file",
// " drawing" => " drawing",
// "Wrong file type, expected %0" => "Wrong file type, expected %0",
// "New Svg Image" => "New Svg Image",
"Invalid request to edit an image" => "不正確的編輯影像請求",
"You have permission to edit images but not in this gallery" => "權限不足, 你可以編輯影像, 但不得編輯此圖庫",
"Failed to edit the image" => "編輯影像失敗",
// "Edit or export languages" => "Edit or export languages",
// "Edit Perspectives" => "Edit Perspectives",
"No content id indicated" => "未指定內容編號",
"No question indicated" => "未指定問題",
"No quiz indicated" => "未指定測驗",
// "View this wiki page" => "View this wiki page",
"No structure indicated" => "未指定結構",
// "Invalid structure_id or page_ref_id" => "Invalid structure_id or page_ref_id",
"You do not have permission to edit submissions" => "權限不足, 你無法編輯意見",
"You have to create a topic first" => "你必須先建立主題",
// "Template directory %0 unknown" => "Template directory %0 unknown",
"You do not have permission to do that" => "你沒有權限",
"You do not have permission to write the template" => "權限不足, 你無法寫入模板",
"You do not have permission to read the template" => "權限不足, 你無法讀取模板",
// "No topic id specified" => "No topic id specified",
// "Invalid topic id specified" => "Invalid topic id specified",
// "No object indicated" => "No object indicated",
// "Only wiki pages are supported" => "Only wiki pages are supported",
// "Forbidden" => "Forbidden",
// "New diagram" => "New diagram",
// "Edit diagram" => "Edit diagram",
// "Override lock and carry on with edit" => "Override lock and carry on with edit",
// "Page is currently being edited" => "Page is currently being edited",
"page imported" => "匯入的頁面",
"created from import" => "從匯入建立",
// "To review the changes you have just made %0compare the versions%1 in history of this page" => "To review the changes you have just made %0compare the versions%1 in history of this page",
// "Page %0 saved (version %1)" => "Page %0 saved (version %1)",
// "This page is being edited by %0. Please check with the user before editing the page,\totherwise the changes will be stored as two separate versions in the history and you will have to manually merge them later" => "This page is being edited by %0. Please check with the user before editing the page,\totherwise the changes will be stored as two separate versions in the history and you will have to manually merge them later",
// "Can't import remote HTML page" => "Can't import remote HTML page",
"The Sandbox is disabled" => "沙池功能已關閉",
"The page cannot be edited because it is locked" => "無法編輯頁面, 它正被鎖定中",
// "That page already exists. Go back and choose a different name" => "That page already exists. Go back and choose a different name",
// "The page name is" => "The page name is",
// "The translation set already contains a page in this language" => "The translation set already contains a page in this language",
// "The file cannot be opened" => "The file cannot be opened",
// "Problem zip initialisation" => "Problem zip initialisation",
// "Problem zip" => "Problem zip",
// "Another user is currently exporting that tracker. Please try again later" => "Another user is currently exporting that tracker. Please try again later",
// "No questions group indicated" => "No questions group indicated",
// "Remove archive: " => "Remove archive: ",
// "Remove file gallery: " => "Remove file gallery: ",
"You do not have permission to edit this file" => "權限不足, 你無法編輯此檔案",
"Most-visited file galleries" => "最常被瀏覽圖庫",
"Most downloaded files" => "最多下傳檔案",
"Last files" => "最新檔案",
// "No gallery ID specified" => "No gallery ID specified",
// "Form error - no import method selected for some reason" => "Form error - no import method selected for some reason",
// "Form error - no server-side filename entered for selected import method" => "Form error - no server-side filename entered for selected import method",
"No forum indicated" => "未指定論壇",
"Last forum topics" => "最新論壇主題",
// "Last replied forum topics" => "Last replied forum topics",
"Most-Read Forum Topics" => "最多閱讀主題",
"Top topics" => "最熱門主題",
"Forum posts" => "論壇文章數",
"Most-Visited Forums" => "最多訪客論壇",
// "No forumId specified" => "No forumId specified",
// "List Forums" => "List Forums",
// "Not supported yet" => "Not supported yet",
// "All files copied" => "All files copied",
"id" => "編號",
// "first uploaded image" => "first uploaded image",
// "last uploaded image" => "last uploaded image",
"first image" => "第一張影像",
"last image" => "最末張影像",
// "random image" => "random image",
"You do not have permission to create galleries and so you cannot edit them" => "權限不足, 你無法建立和編輯檔案庫",
"You do not have permission to edit this gallery" => "權限不足, 你無法編輯此檔案庫",
"You do not have permission to remove this gallery" => "權限不足, 你無法移除此檔案庫",
"Top images" => "最熱門影像",
"Last images" => "最新影像",
// "No valid renderer found. GD or PDFLib required" => "No valid renderer found. GD or PDFLib required",
// "No sheet specified" => "No sheet specified",
// "Unknown Graphic" => "Unknown Graphic",
// "Unknown Renderer" => "Unknown Renderer",
// "You must select a renderer" => "You must select a renderer",
// "Invalid Series for current graphic" => "Invalid Series for current graphic",
"overwriting old page" => "覆寫舊頁面",
// "updated from structured text import" => "updated from structured text import",
"page created" => "頁面已建立",
// "created from structured text import" => "created from structured text import",
// "Unable to locate import file" => "Unable to locate import file",
// "Pages in zip file %0 successfully imported" => "Pages in zip file %0 successfully imported",
// "Invalid software name" => "Invalid software name",
// "No wiki page specified" => "No wiki page specified",
// "This version does not exist" => "This version does not exist",
// "There is more than one item in the tracker with this title" => "There is more than one item in the tracker with this title",
// "There are no items in the tracker with this title" => "There are no items in the tracker with this title",
// "Are you sure you want to undo the last change" => "Are you sure you want to undo the last change",
// "There is nothing to undo" => "There is nothing to undo",
// "You have requested that this page be machine translated" => "You have requested that this page be machine translated",
// "However, the Machine Translation feature is not enabled. Please enable this feature, or ask a site admin to do it" => "However, the Machine Translation feature is not enabled. Please enable this feature, or ask a site admin to do it",
// "No repository given" => "No repository given",
// "This invitation does not exist or is deprecated" => "This invitation does not exist or is deprecated",
// "Congratulations! You are now part of this invitation group(s)" => "Congratulations! You are now part of this invitation group(s)",
// "Communication error" => "Communication error",
// "Invalid response provided by the Kaltura server. Please retry" => "Invalid response provided by the Kaltura server. Please retry",
// "Are you sure you want to permanently remove the article with identifier %0" => "Are you sure you want to permanently remove the article with identifier %0",
// "Are you sure you want to permanently remove these %0 articles" => "Are you sure you want to permanently remove these %0 articles",
"You do not have permission to remove articles" => "你沒有權限刪除文章",
"You do not have permission to remove banners" => "權限不足, 你無法移除大標題",
// "List Blog Posts" => "List Blog Posts",
"You do not have permission to remove this blog" => "權限不足, 你無法移除此 blog",
// "You do not have permission to view the comments for this blog" => "You do not have permission to view the comments for this blog",
// "The following comment has been deleted" => "The following comment has been deleted",
// "The following comments have been deleted" => "The following comments have been deleted",
// "Delete selected comments and ban" => "Delete selected comments and ban",
// "Users have been pre-selected for banning in the highlighted section of the form below" => "Users have been pre-selected for banning in the highlighted section of the form below",
// "One comment approved" => "One comment approved",
// "%0 comments approved" => "%0 comments approved",
// "No comments approved" => "No comments approved",
// "One comment rejected" => "One comment rejected",
// "%0 comments rejected" => "%0 comments rejected",
// "No comments rejected" => "No comments rejected",
// "Comment archived" => "Comment archived",
// "%0 comments archived" => "%0 comments archived",
// "No comments archived" => "No comments archived",
// "Comment unarchived" => "Comment unarchived",
// "%0 comments unarchived" => "%0 comments unarchived",
// "No comments unarchived" => "No comments unarchived",
// "Action not performed since no comments were selected" => "Action not performed since no comments were selected",
// "Approved Status" => "Approved Status",
// "This blog has no posts" => "This blog has no posts",
// "Dynamic content" => "Dynamic content",
// "Admin FAQs" => "Admin FAQs",
// "Non-existent gallery" => "Non-existent gallery",
// "You do not have permission to view this gallery" => "You do not have permission to view this gallery",
// "One item moved" => "One item moved",
// "%0 items moved" => "%0 items moved",
// "No items moved" => "No items moved",
// "One item moved and one item failed to move" => "One item moved and one item failed to move",
// "One item moved and %0 items failed to move" => "One item moved and %0 items failed to move",
// "%0 items moved and one item failed to move" => "%0 items moved and one item failed to move",
// "%0 items moved and %0 items failed to move" => "%0 items moved and %0 items failed to move",
// "One item deleted" => "One item deleted",
// "%0 items deleted" => "%0 items deleted",
// "No items deleted" => "No items deleted",
// "One item deleted and one item failed to delete" => "One item deleted and one item failed to delete",
// "One item deleted and %0 items failed to delete" => "One item deleted and %0 items failed to delete",
// "%0 items deleted and one item failed to delete" => "%0 items deleted and one item failed to delete",
// "%0 items moved and %0 items failed to delete" => "%0 items moved and %0 items failed to delete",
// "List view settings reset for one gallery" => "List view settings reset for one gallery",
// "List view settings reset for %0 galleries" => "List view settings reset for %0 galleries",
// "List view settings not changed for the selected gallery" => "List view settings not changed for the selected gallery",
// "List view settings not changed for the %0 selected galleries" => "List view settings not changed for the %0 selected galleries",
// "List view settings reset for %0 galleries and not changed for one gallery" => "List view settings reset for %0 galleries and not changed for one gallery",
// "List view settings reset for %0 galleries and not changed for %0 galleries" => "List view settings reset for %0 galleries and not changed for %0 galleries",
// "No files selected" => "No files selected",
// "Metadata refreshed for one file" => "Metadata refreshed for one file",
// "Metadata refreshed for %0 files" => "Metadata refreshed for %0 files",
// "Metadata not refreshed" => "Metadata not refreshed",
// "Metadata refreshed for one file and not refreshed for one file" => "Metadata refreshed for one file and not refreshed for one file",
// "Metadata refreshed for one file and not refreshed for %0 files" => "Metadata refreshed for one file and not refreshed for %0 files",
// "Metadata refreshed for %0 files and not refreshed for one file" => "Metadata refreshed for %0 files and not refreshed for one file",
// "Metadata refreshed for %0 files and not refreshed for %0 files" => "Metadata refreshed for %0 files and not refreshed for %0 files",
// "Incorrect file ID" => "Incorrect file ID",
// "The file is already locked by %s" => "The file is already locked by %s",
// "File unlocked" => "File unlocked",
// "File not unlocked" => "File not unlocked",
// "Files in this gallery are not lockable" => "Files in this gallery are not lockable",
// "You don't have permission to validate files from this gallery" => "You don't have permission to validate files from this gallery",
// "Error retrieving file" => "Error retrieving file",
// "Draft validated" => "Draft validated",
// "Validation failed" => "Validation failed",
// "File deleted" => "File deleted",
// "File not deleted" => "File not deleted",
// "Metadata refreshed" => "Metadata refreshed",
// "You need upload permission to edit files" => "You need upload permission to edit files",
// "You need permission to create galleries to edit them" => "You need permission to create galleries to edit them",
// "File properties for %0 edited'. htmlspecialchars(\$_REQUEST['fname'])));\n\t\t} else {\n\t\t\tFeedback::error(tr('File properties for %0 not changed'. htmlspecialchars(\$_REQUEST['fname'])));\n\t\t}\n\t\t\$smarty->assign('edit_mode" => "File properties for %0 edited'. htmlspecialchars(\$_REQUEST['fname'])));\n\t\t} else {\n\t\t\tFeedback::error(tr('File properties for %0 not changed'. htmlspecialchars(\$_REQUEST['fname'])));\n\t\t}\n\t\t\$smarty->assign('edit_mode",
// "Quota too big" => "Quota too big",
// "Quota too small" => "Quota too small",
// "Gallery %0 created or modified" => "Gallery %0 created or modified",
// "Gallery %0 not created or modified" => "Gallery %0 not created or modified",
// "You do not have permission to duplicate this gallery" => "You do not have permission to duplicate this gallery",
// "Gallery duplicated" => "Gallery duplicated",
// "Gallery not duplicated" => "Gallery not duplicated",
// "Remove file gallery %0" => "Remove file gallery %0",
// "Incorrect gallery ID" => "Incorrect gallery ID",
// "Gallery %0 deleted" => "Gallery %0 deleted",
// "Gallery %0 not deleted" => "Gallery %0 not deleted",
// "Could not find the file requested" => "Could not find the file requested",
// "File %0 updated" => "File %0 updated",
// "File %0 not updated" => "File %0 not updated",
// "Invalid %0 parameter" => "Invalid %0 parameter",
// "File %0 not found" => "File %0 not found",
// "User watch added" => "User watch added",
// "User watch not added" => "User watch not added",
// "User watch removed" => "User watch removed",
// "User watch not removed" => "User watch not removed",
// "Not modified for" => "Not modified for",
// "Not downloaded for" => "Not downloaded for",
// "This gallery does not exist" => "This gallery does not exist",
// "Error importing" => "Error importing",
// "Error converting" => "Error converting",
// "Importing" => "Importing",
// "Processing" => "Processing",
// "Ready" => "Ready",
// "Pending moderation" => "Pending moderation",
// "Blocked" => "Blocked",
// "Invalid action" => "Invalid action",
// "Remove permission %0 from %1" => "Remove permission %0 from %1",
// "Assign permission %0 to %1" => "Assign permission %0 to %1",
// "Delete posts" => "Delete posts",
// "View submissions" => "View submissions",
// "Are you sure you want to permanently remove the submitted article with identifier %0" => "Are you sure you want to permanently remove the submitted article with identifier %0",
// "Are you sure you want to permanently remove these %0 submitted articles" => "Are you sure you want to permanently remove these %0 submitted articles",
// "Are you sure you want to approve these %0 submitted articles" => "Are you sure you want to approve these %0 submitted articles",
// "Are you sure you want to permanently remove all expired submitted articles" => "Are you sure you want to permanently remove all expired submitted articles",
// "Pages not in a structure" => "Pages not in a structure",
// "You are neither an administrator nor an operator of live support" => "You are neither an administrator nor an operator of live support",
// "Username field cannot be empty. Please go back and try again" => "Username field cannot be empty. Please go back and try again",
// "Unable to contact remote server" => "Unable to contact remote server",
// "XMLRPC Error: " => "XMLRPC Error: ",
// "Unable to create login" => "Unable to create login",
// "No groups set on Intertiki client" => "No groups set on Intertiki client",
// "%d or more unsuccessful login attempts have been made" => "%d or more unsuccessful login attempts have been made",
// "Your account has been suspended" => "Your account has been suspended",
// "Contact your site administrator to reactivate it" => "Contact your site administrator to reactivate it",
// "An email has been sent to you with the instructions to follow" => "An email has been sent to you with the instructions to follow",
// "Account requires administrator approval" => "Account requires administrator approval",
// "You did not validate your account" => "You did not validate your account",
// "Resend" => "Resend",
// "You should have received an email. Check your mailbox and your spam box. Otherwise click on the button to resend the email" => "You should have received an email. Check your mailbox and your spam box. Otherwise click on the button to resend the email",
// "You must use the right case for your username" => "You must use the right case for your username",
// "You are not yet validated" => "You are not yet validated",
// "You are already logged in" => "You are already logged in",
// "Authentication error" => "Authentication error",
// "The mail can't be sent. Contact the administrator" => "The mail can't be sent. Contact the administrator",
// "There is more than one user account with this email. Please contact the administrator" => "There is more than one user account with this email. Please contact the administrator",
// "Your default nickname is already in use. A new one has to be selected" => "Your default nickname is already in use. A new one has to be selected",
// "Verification cancelled" => "Verification cancelled",
// "The selected account is not associated with your identity" => "The selected account is not associated with your identity",
// "unknown action" => "unknown action",
// "Authentication method is not OpenID" => "Authentication method is not OpenID",
// "Authentication error; probably not a valid OpenID" => "Authentication error; probably not a valid OpenID",
// "Could not redirect to server: " => "Could not redirect to server: ",
// "OpenID authentication failed: " => "OpenID authentication failed: ",
// "You have already validated your account. Please log in" => "You have already validated your account. Please log in",
// "No page provided" => "No page provided",
// "User module unassigned" => "User module unassigned",
// "User module not unassigned" => "User module not unassigned",
// "User module moved up" => "User module moved up",
// "User module not moved up" => "User module not moved up",
// "User module moved down" => "User module moved down",
// "User module not moved down" => "User module not moved down",
// "User module moved to opposite side" => "User module moved to opposite side",
// "User module not moved to opposite side" => "User module not moved to opposite side",
// "You do not have permission to use this feature" => "You do not have permission to use this feature",
"You must log in to use this feature" => "你必須登入才能使用此功能",
// "\$tikiMonitorRestriction need to be an array" => "\$tikiMonitorRestriction need to be an array",
// "My Account Home" => "My Account Home",
"You do not have permission to view other users data" => "你沒有權限觀看其他使用者的資料",
// "Subscription confirmed for newsletter %0 (%1)" => "Subscription confirmed for newsletter %0 (%1)",
// "Subscription request failed" => "Subscription request failed",
// "You have been unsubscribed from newsletter %0" => "You have been unsubscribed from newsletter %0",
// "Your request to unsubscribe failed" => "Your request to unsubscribe failed",
"You must be logged in to subscribe to newsletters" => "你必須登入才能訂閱電子報",
// "You will receive an email soon to confirm your subscription. Click on the confirmation link in that email to begin receiving the newsletter" => "You will receive an email soon to confirm your subscription. Click on the confirmation link in that email to begin receiving the newsletter",
// "Newsletter not subscribed" => "Newsletter not subscribed",
"No note indicated" => "未指定備忘錄",
"merged note:" => "合併記事:",
"The file is too large" => "檔案過大",
"No item indicated" => "未指定項目",
// "Are you sure you want to delete this note" => "Are you sure you want to delete this note",
"created from notepad" => "由記事本建立",
// "Note not found" => "Note not found",
"No name indicated for wiki page" => "尚未指定 wiki 頁面名稱",
"Not enough information to display this page" => "沒有足夠資訊顯示此頁面",
// "You do not have permission to assign permissions for this object" => "You do not have permission to assign permissions for this object",
// "Are you sure you want to modify permissions" => "Are you sure you want to modify permissions",
// "%0 and all the children groups" => "%0 and all the children groups",
// "Are you sure you want to remove the direct permissions from this object" => "Are you sure you want to remove the direct permissions from this object",
// "Are you sure you want to paste the copied permissions into this object" => "Are you sure you want to paste the copied permissions into this object",
// "Error while processing payment: " => "Error while processing payment: ",
// "Payment has been confirmed" => "Payment has been confirmed",
// "Payment confirmation has not been received yet" => "Payment confirmation has not been received yet",
// "Manual payment entered" => "Manual payment entered",
// "You do not have permission to enter payment" => "You do not have permission to enter payment",
// "New payment requested" => "New payment requested",
// "Cancel payment %0" => "Cancel payment %0",
// "Payment canceled" => "Payment canceled",
// "You need permission to edit pages in order to experiment on plugin LIST" => "You need permission to edit pages in order to experiment on plugin LIST",
// "No preference given" => "No preference given",
// "This preference is not translatable" => "This preference is not translatable",
"No article indicated" => "未指定文章",
"Article is not published yet" => "文章尚未被發表",
"No post indicated" => "未指定佈告",
"Blog not found" => "找不到 Blog",
// "Missing object list type argument" => "Missing object list type argument",
// "Index (%0)" => "Index (%0)",
"No pages indicated" => "未指定頁面",
// "Multiple Print" => "Multiple Print",
// "Pageviews" => "Pageviews",
"No result indicated" => "未指定結果",
"Invalid or unknown username" => "使用者名稱錯誤",
// "Unable to send mail. User has not configured email" => "Unable to send mail. User has not configured email",
// "Invalid or unknown email address" => "Invalid or unknown email address",
// "Please provide a username or email address" => "Please provide a username or email address",
// "Please contact the Administrator if you do not get the email, or if there is an issue with resetting the password" => "Please contact the Administrator if you do not get the email, or if there is an issue with resetting the password",
// "An email with a link to reset your password has been sent " => "An email with a link to reset your password has been sent ",
// "to the email" => "to the email",
"to the registered email address for" => "至註冊的 email 地址:",
// "Rename wiki page" => "Rename wiki page",
// "Page renamed from %0 to %1. Semantic alias redirect created" => "Page renamed from %0 to %1. Semantic alias redirect created",
// "Are you sure you want to roll back \"%0\" to version #%1" => "Are you sure you want to roll back \"%0\" to version #%1",
// "Non-existent version" => "Non-existent version",
// "Tiki RSS Feed Error Message: %0" => "Tiki RSS Feed Error Message: %0",
// "This match was not case sensitive" => "This match was not case sensitive",
// "No items selected" => "No items selected",
// "Page cannot be found: " => "Page cannot be found: ",
// "Page has changed since preview: " => "Page has changed since preview: ",
// "Page not updated due to error in replacing: " => "Page not updated due to error in replacing: ",
// "Page updated: " => "Page updated: ",
// "Search Stats" => "Search Stats",
// "%0: Results for \"%1\"" => "%0: Results for \"%1\"",
// "Your query was stored" => "Your query was stored",
// "Searchindex" => "Searchindex",
// "A problem occurred during file uploading" => "A problem occurred during file uploading",
// "File causing trouble was at rank" => "File causing trouble was at rank",
// "The error was %0" => "The error was %0",
// "Error: You can't send the same newsletter by refreshing this frame content" => "Error: You can't send the same newsletter by refreshing this frame content",
// "No newsletters available" => "No newsletters available",
// "Cannot login to server maybe the server is down" => "Cannot login to server maybe the server is down",
"successfully sent" => "成功寄送",
"not sent" => "未寄送",
// "Error: " => "Error: ",
// "Send Pages" => "Send Pages",
// "Notice: this variable may not be empty" => "Notice: this variable may not be empty",
// "Notice: invalid variable value" => "Notice: invalid variable value",
// "Report to the webmaster" => "Report to the webmaster",
// "Token called" => "Token called",
// "Error sending tweet" => "Error sending tweet",
// "Your link was sent" => "Your link was sent",
// "One of the email addresses that was input is invalid" => "One of the email addresses that was input is invalid",
// "Your email is mandatory" => "Your email is mandatory",
// "Error sending mail to" => "Error sending mail to",
// "Share page" => "Share page",
// "No text given for tweet" => "No text given for tweet",
// "You don't have permission to post in this forum" => "You don't have permission to post in this forum",
// "Spreadsheet - " => "Spreadsheet - ",
// "Are you sure you want to delete this spreadsheet" => "Are you sure you want to delete this spreadsheet",
// "URL provided is empty or unsupported" => "URL provided is empty or unsupported",
// "Unable to generate a short url for the requested resource" => "Unable to generate a short url for the requested resource",
// "'%0' short url" => "'%0' short url",
// "You do not have permission to edit messages %0" => "You do not have permission to edit messages %0",
// "Sitemap file not available" => "Sitemap file not available",
// "Required features: sitemap_enable. If you do not have permission to activate these features, ask the site administrator" => "Required features: sitemap_enable. If you do not have permission to activate these features, ask the site administrator",
// "Exporting slideshow as PDF requires a working installation of mPDF" => "Exporting slideshow as PDF requires a working installation of mPDF",
// "Export to PDF error: %0" => "Export to PDF error: %0",
// "Permission denied. You cannot view this page" => "Permission denied. You cannot view this page",
// "Email is mandatory" => "Email is mandatory",
// "Username and email are mandatory" => "Username and email are mandatory",
// "The email address is invalid" => "The email address is invalid",
// "Clean the sql logs" => "Clean the sql logs",
// "Are you sure you want to clear all statistics and data for this survey" => "Are you sure you want to clear all statistics and data for this survey",
// "The following list of changes has been reverted" => "The following list of changes has been reverted",
// "Log already reverted" => "Log already reverted",
// "Invalid System Log ID" => "Invalid System Log ID",
"You cannot take this quiz twice" => "你不能重複參加這個測驗",
// "The quiz time limit was exceeded. The quiz score cannot be computed" => "The quiz time limit was exceeded. The quiz score cannot be computed",
"You cannot take this survey twice" => "你不能重複參加這個調查",
"Please create a category first" => "請先建立一個類別",
// "Committing.." => "Committing..",
// "Could not save" => "Could not save",
// "No trackerId specified" => "No trackerId specified",
// "Incorrect file gallery" => "Incorrect file gallery",
// "You must lock the file before editing it" => "You must lock the file before editing it",
"Error processing zipped image package" => "處理 zip 壓縮的影像包時發生錯誤",
"No permission to upload zipped image packages" => "沒有權限上傳 zip 壓縮的影像包",
// "The uploaded file is not recognized as a image" => "The uploaded file is not recognized as a image",
"You do not have permission to upload images" => "你沒有上傳影像的權限",
"You have permission to upload images but not to this gallery" => "你無法在此圖庫中上傳影像",
"Cannot get image from URL" => "無法由URL取得影像",
// "That is not an image (or you have php < 4.0.5)" => "That is not an image (or you have php < 4.0.5)",
// "Usage" => "Usage",
// "Default user modules restored" => "Default user modules restored",
// "Default user modules not restored" => "Default user modules not restored",
// "User module assigned" => "User module assigned",
// "User module not assigned" => "User module not assigned",
// "User module display order moved up. Displayed order may not change if other modules now have the same order rank" => "User module display order moved up. Displayed order may not change if other modules now have the same order rank",
// "User module display order not moved up" => "User module display order not moved up",
// "User module display order moved down. Displayed order may not change if other modules now have the same order rank" => "User module display order moved down. Displayed order may not change if other modules now have the same order rank",
// "User module display order not moved down" => "User module display order not moved down",
// "User module moved to left column" => "User module moved to left column",
// "User module not moved to left column" => "User module not moved to left column",
// "User module moved to right column" => "User module moved to right column",
// "User module not moved to right column" => "User module not moved to right column",
"TOP" => "TOP",
"No URL indicated" => "未指定url",
"ERROR: Either the subject or body must be non-empty" => "錯誤: 標題或內文不可以為空",
"Unknown user" => "不明使用者",
// "Added new structure route" => "Added new structure route",
// "Deleted structure route" => "Deleted structure route",
// "Updated structure route" => "Updated structure route",
// "Notification preferences set" => "Notification preferences set",
// "Errors were encountered when setting notification preferences" => "Errors were encountered when setting notification preferences",
// "Email is set to %s" => "Email is set to %s",
// "Password has been changed" => "Password has been changed",
// "Invalid password. Your current password is required to change administrative information" => "Invalid password. Your current password is required to change administrative information",
// "The passwords did not match" => "The passwords did not match",
// "If you really want to delete your account, you must check the checkbox" => "If you really want to delete your account, you must check the checkbox",
// "User report preferences saved" => "User report preferences saved",
// "User report preferences not saved" => "User report preferences not saved",
// "User reports disabled" => "User reports disabled",
// "User report not disabled" => "User report not disabled",
// "was moved to the trash" => "was moved to the trash",
// "was moved to the trash by" => "was moved to the trash by",
// "open / in process" => "open / in process",
// "Rights by creator" => "Rights by creator",
// "END" => "END",
// "Percentage" => "Percentage",
// "Task accepted by creator" => "Task accepted by creator",
// "Task accepted by task user" => "Task accepted by task user",
// "Task NOT accepted by creator" => "Task NOT accepted by creator",
// "Task NOT accepted by task user" => "Task NOT accepted by task user",
// "Sorry, this task does not exist or you don't have permission to view this task" => "Sorry, this task does not exist or you don't have permission to view this task",
// "Task entries" => "Task entries",
// "Changes" => "Changes",
// "Info message" => "Info message",
// "NEW Task" => "NEW Task",
// "Either you don't have permission to send tasks to other users, or the user doesn't have permission to receive tasks" => "Either you don't have permission to send tasks to other users, or the user doesn't have permission to receive tasks",
// "Changes on Task" => "Changes on Task",
// "You received a new task" => "You received a new task",
// "The priority is" => "The priority is",
// "very low" => "very low",
// "high" => "high",
// "very high" => "very high",
// "You must start your work at least on" => "You must start your work at least on",
// "You must finish your work on" => "You must finish your work on",
// "Log in and click the link below" => "Log in and click the link below",
// "Please read the task and work on it" => "Please read the task and work on it",
// "Sorry, there was an error while trying to write data into the database" => "Sorry, there was an error while trying to write data into the database",
// "Unsubscribe from user watch email notifications" => "Unsubscribe from user watch email notifications",
// "Unsubscribed from user watch email notification" => "Unsubscribed from user watch email notification",
// "Unsubscribe failed" => "Unsubscribe failed",
// "Unknown watch type" => "Unknown watch type",
// "Language watch" => "Language watch",
// "Category watch: %0, Language: %1" => "Category watch: %0, Language: %1",
// "User watch deleted" => "User watch deleted",
// "User watch not deleted" => "User watch not deleted",
"Cannot upload this file. The storage quota would be exceeded" => "無法上傳檔案, 磁碟配額不足",
"No user indicated" => "未指定使用者",
// "Non-existent user" => "Non-existent user",
"No banner indicated" => "未指定大標題",
"No blog indicated" => "未指定 blog",
// "Post not found" => "Post not found",
// "You do not have permission to view this blog post while it is marked as private" => "You do not have permission to view this blog post while it is marked as private",
"No cache information available" => "無快取資訊",
// "You must suggest a question; please try again" => "You must suggest a question; please try again",
"No FAQ indicated" => "未指定faq",
// "Are you sure you want to remove that attachment" => "Are you sure you want to remove that attachment",
// "Are you sure you want to remove that topic" => "Are you sure you want to remove that topic",
// "You do not have permission to remove someone else's post" => "You do not have permission to remove someone else's post",
// "Incorrect thread" => "Incorrect thread",
// "Thread %0 does not exist" => "Thread %0 does not exist",
"No thread indicated" => "未指定討論串",
// "Files are read only at this time" => "Files are read only at this time",
// "Are you sure you want to clone this spreadsheet" => "Are you sure you want to clone this spreadsheet",
// "Clone Error" => "Clone Error",
// "Are you sure you want to roll back this spreadsheet" => "Are you sure you want to roll back this spreadsheet",
// "Rollback Error" => "Rollback Error",
// "Tracker Added To Spreadsheet" => "Tracker Added To Spreadsheet",
// "Tracker Removed From Spreadsheet" => "Tracker Removed From Spreadsheet",
// "Spreadsheet added" => "Spreadsheet added",
// "Spreadsheet removed" => "Spreadsheet removed",
// "File removed" => "File removed",
// "Spreadsheet truncated" => "Spreadsheet truncated",
// "Create or view tracker" => "Create or view tracker",
// "Admin this tracker" => "Admin this tracker",
// "Are you sure you want to delete the selected items" => "Are you sure you want to delete the selected items",
// "Create tracker item" => "Create tracker item",
// "This tracker restricts access to the built-in tracker interfaces. You need admin tracker permission" => "This tracker restricts access to the built-in tracker interfaces. You need admin tracker permission",
// "Are you sure you want to permanently delete this item" => "Are you sure you want to permanently delete this item",
// "Are you sure you want to remove this attachment" => "Are you sure you want to remove this attachment",
// "Edit/Delete" => "Edit/Delete",
// "You don't have a personal tracker item yet. Click here to make one" => "You don't have a personal tracker item yet. Click here to make one",
// "That tracker does not use extras" => "That tracker does not use extras",
"Address book" => "通訊錄",
"Top pages" => "最熱門頁面",
"Last pages" => "最新頁面",
// "Note, deprecated file tiki-wikiplugin_edit.php, code moved to service plugin->replace" => "Note, deprecated file tiki-wikiplugin_edit.php, code moved to service plugin->replace",
);
